/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 101;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 69,
  Feature_HasRCPC_IMMOBit = 90,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 68,
  Feature_HasSHA3Bit = 67,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 32,
  Feature_HasLSEBit = 33,
  Feature_HasNoLSEBit = 100,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 87,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 81,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 47,
  Feature_HasSVEAESBit = 29,
  Feature_HasSVESM4Bit = 30,
  Feature_HasSVESHA3Bit = 98,
  Feature_HasSVEBitPermBit = 40,
  Feature_HasSMEandIsNonStreamingSafeBit = 60,
  Feature_HasSMEBit = 53,
  Feature_HasSMEF64F64Bit = 55,
  Feature_HasSMEF16F16Bit = 57,
  Feature_HasSMEI16I64Bit = 58,
  Feature_HasSME2andIsNonStreamingSafeBit = 64,
  Feature_HasSME2Bit = 62,
  Feature_HasSME2p1Bit = 66,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 50,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 44,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 51,
  Feature_HasLUTBit = 52,
  Feature_HasSME_LUTv2Bit = 65,
  Feature_HasSMEF8F16Bit = 56,
  Feature_HasSMEF8F32Bit = 54,
  Feature_HasSME_MOP4Bit = 59,
  Feature_HasSME_TMOPBit = 63,
  Feature_HasCMPBRBit = 88,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 34,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p1Bit = 97,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 41,
  Feature_HasNonStreamingSVE_or_SSVE_AESBit = 28,
  Feature_HasNonStreamingSVE_or_SSVE_BitPermBit = 39,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 43,
  Feature_HasSVE2_or_SMEBit = 36,
  Feature_HasNonStreamingSVE2_or_SME2Bit = 49,
  Feature_HasSVE2p1_or_SMEBit = 61,
  Feature_HasSVE2p1_or_SME2Bit = 46,
  Feature_HasSVE2p1_or_SME2p1Bit = 48,
  Feature_HasSVE2p1_or_StreamingSME2Bit = 31,
  Feature_HasSVE2p2_or_SME2p2Bit = 35,
  Feature_HasNonStreamingSVE2p2_or_SME2p2Bit = 42,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 99,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 77,
  Feature_HasRCPCBit = 89,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 96,
  Feature_HasMatMulFP64Bit = 45,
  Feature_HasLS64Bit = 84,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 85,
  Feature_HasGCSBit = 1,
  Feature_HasCPABit = 86,
  Feature_IsLEBit = 75,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 38,
  Feature_UseAlternateSExtLoadCVTF32Bit = 79,
  Feature_UseScalarIncVLBit = 37,
  Feature_NoUseScalarIncVLBit = 93,
  Feature_HasFastIncVLBit = 94,
  Feature_UseSVEFPLD1RBit = 92,
  Feature_UseLDAPURBit = 91,
  Feature_AllowMisalignedMemAccessesBit = 95,
  Feature_NotForCodeSizeBit = 78,
  Feature_UseSTRQroBit = 76,
  Feature_TailCallX16X17Bit = 71,
  Feature_TailCallX17Bit = 82,
  Feature_TailCallNotX16Bit = 83,
  Feature_TailCallAnyBit = 70,
  Feature_SLSBLRMitigationBit = 74,
  Feature_NoSLSBLRMitigationBit = 73,
  Feature_OptimizedGISelOrOtherSelectorBit = 72,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVESM4())
    Features.set(Feature_HasSVESM4Bit);
  if (Subtarget->hasSVESHA3())
    Features.set(Feature_HasSVESHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->isSVEorStreamingSVEAvailable())
    Features.set(Feature_HasSVE_or_SMEBit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p1Bit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_AESBit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_BitPermBit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2() || Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2()))
    Features.set(Feature_HasNonStreamingSVE2_or_SME2Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p1() || Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p1() || Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p1() || Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if ((Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSVE2p1()) ||(Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_StreamingSME2Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2p2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->hasCPA())
    Features.set(Feature_HasCPABit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCPA,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE2p2_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVESM4,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasNonStreamingSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE_or_SME2p1_HasSVESHA3,
  GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCPABit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE2p2_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVESM4Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNonStreamingSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasNonStreamingSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasNonStreamingSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE_or_SME2p1Bit, Feature_HasSVESHA3Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_or_disjoint,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_MO_Predicate_top16Zero = GICXXPred_Invalid + 1,
  GICXXPred_MO_Predicate_top32Zero,
  GICXXPred_MO_Predicate_topbitsallzero32,
  GICXXPred_MO_Predicate_topbitsallzero64,
};
bool AArch64InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  switch (PredicateID) {
  case GICXXPred_MO_Predicate_top16Zero: {
    
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 16)); 
  }
  case GICXXPred_MO_Predicate_top32Zero: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 32)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero32: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 31)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero64: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 63)); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(907), /*)*//*default:*//*Label 155*/ GIMT_Encode4(441991),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3426),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37033),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(51885),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(54650),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(54732), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(54814),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(62560),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(87675), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(99011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(106535), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(116617),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(117108),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(117599),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(117867),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(118017),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(118508), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(118541),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(127479),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(128529), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(131578), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(145104),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(146455),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(147447),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(148439),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(149931), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(151423),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(152415),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(153407),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(154399),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(155391),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(156383),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(157375), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(158080),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(158785),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(159490),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(160195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(160900), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(160951),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(266138), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(277654),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(277944), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    350 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(279381),
     /*    354 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(279501), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    366 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(279742),
     /*    370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(281640),
     /*    374 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(283294),
     /*    378 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(286073),
     /*    382 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(286898),
     /*    386 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(287442), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(288267),
     /*    398 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(288397), GIMT_Encode4(0),
     /*    406 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(288939), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    422 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(296716), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    466 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(297761),
     /*    470 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(298245),
     /*    474 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(298729),
     /*    478 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(299201),
     /*    482 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301577),
     /*    486 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(302049), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(303439),
     /*    534 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(305237),
     /*    538 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(305975),
     /*    542 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(310591), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(326864), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    598 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(327480),
     /*    602 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(330987),
     /*    606 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(331235),
     /*    610 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(331423),
     /*    614 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(332400),
     /*    618 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(333377),
     /*    622 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(338005),
     /*    626 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(342011),
     /*    630 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(342331),
     /*    634 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(342651), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    646 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(343508),
     /*    650 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(343790),
     /*    654 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(344168),
     /*    658 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(344546),
     /*    662 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(344896),
     /*    666 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(345246),
     /*    670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(345949), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    706 */ /*TargetOpcode::G_PTR_ADD*//*Label 81*/ GIMT_Encode4(346652), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_SMIN*//*Label 82*/ GIMT_Encode4(347152),
     /*    718 */ /*TargetOpcode::G_SMAX*//*Label 83*/ GIMT_Encode4(347556),
     /*    722 */ /*TargetOpcode::G_UMIN*//*Label 84*/ GIMT_Encode4(347960),
     /*    726 */ /*TargetOpcode::G_UMAX*//*Label 85*/ GIMT_Encode4(348364),
     /*    730 */ /*TargetOpcode::G_ABS*//*Label 86*/ GIMT_Encode4(348768),
     /*    734 */ /*TargetOpcode::G_LROUND*//*Label 87*/ GIMT_Encode4(349583),
     /*    738 */ /*TargetOpcode::G_LLROUND*//*Label 88*/ GIMT_Encode4(349749),
     /*    742 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(349848), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 90*/ GIMT_Encode4(349864),
     /*    762 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(355236),
     /*    766 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(388158), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 93*/ GIMT_Encode4(391076), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    786 */ /*TargetOpcode::G_CTTZ*//*Label 94*/ GIMT_Encode4(393396), GIMT_Encode4(0),
     /*    794 */ /*TargetOpcode::G_CTLZ*//*Label 95*/ GIMT_Encode4(393548), GIMT_Encode4(0),
     /*    802 */ /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(394222),
     /*    806 */ /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(394382),
     /*    810 */ /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(394696),
     /*    814 */ /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(394850), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    862 */ /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(395341),
     /*    866 */ /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(395641),
     /*    870 */ /*TargetOpcode::G_FRINT*//*Label 102*/ GIMT_Encode4(396132),
     /*    874 */ /*TargetOpcode::G_FNEARBYINT*//*Label 103*/ GIMT_Encode4(396623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FADD*//*Label 104*/ GIMT_Encode4(397114),
     /*    906 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 105*/ GIMT_Encode4(398240),
     /*    910 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 106*/ GIMT_Encode4(398856),
     /*    914 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 107*/ GIMT_Encode4(402578), GIMT_Encode4(0),
     /*    922 */ /*TargetOpcode::G_STRICT_FMA*//*Label 108*/ GIMT_Encode4(403194),
     /*    926 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 109*/ GIMT_Encode4(418801), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_TRAP*//*Label 110*/ GIMT_Encode4(419101),
     /*    966 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 111*/ GIMT_Encode4(419115),
     /*    970 */ /*TargetOpcode::G_UBSANTRAP*//*Label 112*/ GIMT_Encode4(419136), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 113*/ GIMT_Encode4(419161), GIMT_Encode4(0),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 114*/ GIMT_Encode4(419471),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 115*/ GIMT_Encode4(419642),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 116*/ GIMT_Encode4(419813),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 117*/ GIMT_Encode4(419984),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 118*/ GIMT_Encode4(420155), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 119*/ GIMT_Encode4(421284),
     /*   1030 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 120*/ GIMT_Encode4(421487),
     /*   1034 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 121*/ GIMT_Encode4(421690),
     /*   1038 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 122*/ GIMT_Encode4(421893), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3294 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 123*/ GIMT_Encode4(422096), GIMT_Encode4(0),
     /*   3302 */ /*AArch64::G_BSP*//*Label 124*/ GIMT_Encode4(422236),
     /*   3306 */ /*AArch64::G_DUP*//*Label 125*/ GIMT_Encode4(423224),
     /*   3310 */ /*AArch64::G_DUPLANE16*//*Label 126*/ GIMT_Encode4(425207),
     /*   3314 */ /*AArch64::G_DUPLANE32*//*Label 127*/ GIMT_Encode4(425462),
     /*   3318 */ /*AArch64::G_DUPLANE64*//*Label 128*/ GIMT_Encode4(425717),
     /*   3322 */ /*AArch64::G_DUPLANE8*//*Label 129*/ GIMT_Encode4(425863),
     /*   3326 */ /*AArch64::G_EXT*//*Label 130*/ GIMT_Encode4(426042),
     /*   3330 */ /*AArch64::G_FCMEQ*//*Label 131*/ GIMT_Encode4(427692),
     /*   3334 */ /*AArch64::G_FCMGE*//*Label 132*/ GIMT_Encode4(428251),
     /*   3338 */ /*AArch64::G_FCMGT*//*Label 133*/ GIMT_Encode4(429343),
     /*   3342 */ /*AArch64::G_REV16*//*Label 134*/ GIMT_Encode4(430435),
     /*   3346 */ /*AArch64::G_REV32*//*Label 135*/ GIMT_Encode4(430589),
     /*   3350 */ /*AArch64::G_REV64*//*Label 136*/ GIMT_Encode4(430765),
     /*   3354 */ /*AArch64::G_SADDLP*//*Label 137*/ GIMT_Encode4(431039),
     /*   3358 */ /*AArch64::G_SADDLV*//*Label 138*/ GIMT_Encode4(431245),
     /*   3362 */ /*AArch64::G_SDOT*//*Label 139*/ GIMT_Encode4(431644),
     /*   3366 */ /*AArch64::G_SITOF*//*Label 140*/ GIMT_Encode4(432014),
     /*   3370 */ /*AArch64::G_SMULL*//*Label 141*/ GIMT_Encode4(432131),
     /*   3374 */ /*AArch64::G_TRN1*//*Label 142*/ GIMT_Encode4(433364),
     /*   3378 */ /*AArch64::G_TRN2*//*Label 143*/ GIMT_Encode4(434144),
     /*   3382 */ /*AArch64::G_UADDLP*//*Label 144*/ GIMT_Encode4(434924),
     /*   3386 */ /*AArch64::G_UADDLV*//*Label 145*/ GIMT_Encode4(435130),
     /*   3390 */ /*AArch64::G_UDOT*//*Label 146*/ GIMT_Encode4(435997),
     /*   3394 */ /*AArch64::G_UITOF*//*Label 147*/ GIMT_Encode4(436367),
     /*   3398 */ /*AArch64::G_UMULL*//*Label 148*/ GIMT_Encode4(436484),
     /*   3402 */ /*AArch64::G_UZP1*//*Label 149*/ GIMT_Encode4(437717),
     /*   3406 */ /*AArch64::G_UZP2*//*Label 150*/ GIMT_Encode4(438497),
     /*   3410 */ /*AArch64::G_VASHR*//*Label 151*/ GIMT_Encode4(439277),
     /*   3414 */ /*AArch64::G_VLSHR*//*Label 152*/ GIMT_Encode4(439975),
     /*   3418 */ /*AArch64::G_ZIP1*//*Label 153*/ GIMT_Encode4(440431),
     /*   3422 */ /*AArch64::G_ZIP2*//*Label 154*/ GIMT_Encode4(441211),
     /*   3426 */ // Label 0: @3426
     /*   3426 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 169*/ GIMT_Encode4(37032),
     /*   3437 */ /*GILLT_s32*//*Label 156*/ GIMT_Encode4(3525),
     /*   3441 */ /*GILLT_s64*//*Label 157*/ GIMT_Encode4(6304), GIMT_Encode4(0),
     /*   3449 */ /*GILLT_v2s32*//*Label 158*/ GIMT_Encode4(12244),
     /*   3453 */ /*GILLT_v2s64*//*Label 159*/ GIMT_Encode4(15852),
     /*   3457 */ /*GILLT_v4s16*//*Label 160*/ GIMT_Encode4(21754),
     /*   3461 */ /*GILLT_v4s32*//*Label 161*/ GIMT_Encode4(25252),
     /*   3465 */ /*GILLT_v8s8*//*Label 162*/ GIMT_Encode4(31430),
     /*   3469 */ /*GILLT_v8s16*//*Label 163*/ GIMT_Encode4(32280),
     /*   3473 */ /*GILLT_v16s8*//*Label 164*/ GIMT_Encode4(35858), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3493 */ /*GILLT_nxv2s64*//*Label 165*/ GIMT_Encode4(36582), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv4s32*//*Label 166*/ GIMT_Encode4(36954), GIMT_Encode4(0),
     /*   3513 */ /*GILLT_nxv8s16*//*Label 167*/ GIMT_Encode4(36980), GIMT_Encode4(0),
     /*   3521 */ /*GILLT_nxv16s8*//*Label 168*/ GIMT_Encode4(37006),
     /*   3525 */ // Label 156: @3525
     /*   3525 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(6303),
     /*   3530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3536 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3569), // Rule ID 13455 //
     /*   3541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3556 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3567 */     GIR_RootConstrainSelectedInstOperands,
     /*   3568 */     // GIR_Coverage, 13455,
     /*   3568 */     GIR_EraseRootFromParent_Done,
     /*   3569 */   // Label 171: @3569
     /*   3569 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3721), // Rule ID 13894 //
     /*   3574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3601 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3604 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3609 */     // MIs[2] pattern
     /*   3609 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3612 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3623 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3626 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3630 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3649 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3652 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3656 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3720 */     // GIR_Coverage, 13894,
     /*   3720 */     GIR_EraseRootFromParent_Done,
     /*   3721 */   // Label 172: @3721
     /*   3721 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3873), // Rule ID 15756 //
     /*   3726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3753 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3756 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3761 */     // MIs[2] pattern
     /*   3761 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3764 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3775 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3801 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3808 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3855 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3872 */     // GIR_Coverage, 15756,
     /*   3872 */     GIR_EraseRootFromParent_Done,
     /*   3873 */   // Label 173: @3873
     /*   3873 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4025), // Rule ID 15768 //
     /*   3878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3905 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3908 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3913 */     // MIs[2] pattern
     /*   3913 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3916 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3927 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3941 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3944 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3948 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3953 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3956 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3960 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3968 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3973 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3990 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4024 */     // GIR_Coverage, 15768,
     /*   4024 */     GIR_EraseRootFromParent_Done,
     /*   4025 */   // Label 174: @4025
     /*   4025 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4177), // Rule ID 15780 //
     /*   4030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4057 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4060 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4065 */     // MIs[2] pattern
     /*   4065 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4068 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4079 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4079 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4082 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4086 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4105 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4108 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4112 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4176 */     // GIR_Coverage, 15780,
     /*   4176 */     GIR_EraseRootFromParent_Done,
     /*   4177 */   // Label 175: @4177
     /*   4177 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4210), // Rule ID 91 //
     /*   4182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4197 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4208 */     GIR_RootConstrainSelectedInstOperands,
     /*   4209 */     // GIR_Coverage, 91,
     /*   4209 */     GIR_EraseRootFromParent_Done,
     /*   4210 */   // Label 176: @4210
     /*   4210 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4362), // Rule ID 2656 //
     /*   4215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4246 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4249 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4254 */     // MIs[2] pattern
     /*   4254 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4257 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4264 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4264 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4267 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4271 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4290 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4293 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4297 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4344 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4361 */     // GIR_Coverage, 2656,
     /*   4361 */     GIR_EraseRootFromParent_Done,
     /*   4362 */   // Label 177: @4362
     /*   4362 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4514), // Rule ID 10068 //
     /*   4367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4398 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4401 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4406 */     // MIs[2] pattern
     /*   4406 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4409 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4416 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4416 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4419 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4423 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4442 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4449 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4479 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4486 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4496 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4513 */     // GIR_Coverage, 10068,
     /*   4513 */     GIR_EraseRootFromParent_Done,
     /*   4514 */   // Label 178: @4514
     /*   4514 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4666), // Rule ID 10080 //
     /*   4519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4550 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4553 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4558 */     // MIs[2] pattern
     /*   4558 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4561 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4568 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4568 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4571 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4575 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4594 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4597 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4601 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4614 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4631 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4648 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4665 */     // GIR_Coverage, 10080,
     /*   4665 */     GIR_EraseRootFromParent_Done,
     /*   4666 */   // Label 179: @4666
     /*   4666 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4818), // Rule ID 10092 //
     /*   4671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4702 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4705 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4710 */     // MIs[2] pattern
     /*   4710 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4713 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4720 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4720 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4723 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4727 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4746 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4817 */     // GIR_Coverage, 10092,
     /*   4817 */     GIR_EraseRootFromParent_Done,
     /*   4818 */   // Label 180: @4818
     /*   4818 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4975), // Rule ID 15799 //
     /*   4823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4850 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4853 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4869 */     // MIs[2] pred
     /*   4869 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4880 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4906 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4909 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4913 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4943 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4974 */     // GIR_Coverage, 15799,
     /*   4974 */     GIR_EraseRootFromParent_Done,
     /*   4975 */   // Label 181: @4975
     /*   4975 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5132), // Rule ID 15800 //
     /*   4980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5019 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5026 */     // MIs[2] pred
     /*   5026 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5037 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5037 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5040 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5044 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5063 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5070 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5114 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5131 */     // GIR_Coverage, 15800,
     /*   5131 */     GIR_EraseRootFromParent_Done,
     /*   5132 */   // Label 182: @5132
     /*   5132 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5289), // Rule ID 15801 //
     /*   5137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5164 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5167 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5183 */     // MIs[2] pred
     /*   5183 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5194 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5194 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5197 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5201 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5220 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5227 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5240 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5288 */     // GIR_Coverage, 15801,
     /*   5288 */     GIR_EraseRootFromParent_Done,
     /*   5289 */   // Label 183: @5289
     /*   5289 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5446), // Rule ID 15802 //
     /*   5294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5321 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5324 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5333 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5340 */     // MIs[2] pred
     /*   5340 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5351 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5351 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5354 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5358 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5365 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5368 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5372 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5377 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5380 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5384 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5428 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5445 */     // GIR_Coverage, 15802,
     /*   5445 */     GIR_EraseRootFromParent_Done,
     /*   5446 */   // Label 184: @5446
     /*   5446 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5603), // Rule ID 10184 //
     /*   5451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5482 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5485 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5501 */     // MIs[2] pred
     /*   5501 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5508 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5508 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5511 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5515 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5534 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5537 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5541 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5549 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5575 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5585 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5602 */     // GIR_Coverage, 10184,
     /*   5602 */     GIR_EraseRootFromParent_Done,
     /*   5603 */   // Label 185: @5603
     /*   5603 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5760), // Rule ID 10185 //
     /*   5608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5639 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5642 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5658 */     // MIs[2] pred
     /*   5658 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5665 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5665 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5668 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5672 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5691 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5698 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5759 */     // GIR_Coverage, 10185,
     /*   5759 */     GIR_EraseRootFromParent_Done,
     /*   5760 */   // Label 186: @5760
     /*   5760 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5917), // Rule ID 10186 //
     /*   5765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5796 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5799 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5808 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5815 */     // MIs[2] pred
     /*   5815 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5822 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5848 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5855 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5899 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5916 */     // GIR_Coverage, 10186,
     /*   5916 */     GIR_EraseRootFromParent_Done,
     /*   5917 */   // Label 187: @5917
     /*   5917 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6074), // Rule ID 10187 //
     /*   5922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5953 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5956 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5972 */     // MIs[2] pred
     /*   5972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5979 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5979 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5982 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5986 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   6000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6005 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   6008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   6012 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   6015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6073 */     // GIR_Coverage, 10187,
     /*   6073 */     GIR_EraseRootFromParent_Done,
     /*   6074 */   // Label 188: @6074
     /*   6074 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6107), // Rule ID 13459 //
     /*   6079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6094 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6105 */     GIR_RootConstrainSelectedInstOperands,
     /*   6106 */     // GIR_Coverage, 13459,
     /*   6106 */     GIR_EraseRootFromParent_Done,
     /*   6107 */   // Label 189: @6107
     /*   6107 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6143), // Rule ID 14039 //
     /*   6112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6127 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6141 */     GIR_RootConstrainSelectedInstOperands,
     /*   6142 */     // GIR_Coverage, 14039,
     /*   6142 */     GIR_EraseRootFromParent_Done,
     /*   6143 */   // Label 190: @6143
     /*   6143 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6176), // Rule ID 97 //
     /*   6148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6163 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6174 */     GIR_RootConstrainSelectedInstOperands,
     /*   6175 */     // GIR_Coverage, 97,
     /*   6175 */     GIR_EraseRootFromParent_Done,
     /*   6176 */   // Label 191: @6176
     /*   6176 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6212), // Rule ID 3954 //
     /*   6181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6196 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6210 */     GIR_RootConstrainSelectedInstOperands,
     /*   6211 */     // GIR_Coverage, 3954,
     /*   6211 */     GIR_EraseRootFromParent_Done,
     /*   6212 */   // Label 192: @6212
     /*   6212 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6245), // Rule ID 13457 //
     /*   6217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6232 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6243 */     GIR_RootConstrainSelectedInstOperands,
     /*   6244 */     // GIR_Coverage, 13457,
     /*   6244 */     GIR_EraseRootFromParent_Done,
     /*   6245 */   // Label 193: @6245
     /*   6245 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6278), // Rule ID 95 //
     /*   6250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6265 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6276 */     GIR_RootConstrainSelectedInstOperands,
     /*   6277 */     // GIR_Coverage, 95,
     /*   6277 */     GIR_EraseRootFromParent_Done,
     /*   6278 */   // Label 194: @6278
     /*   6278 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6302), // Rule ID 93 //
     /*   6283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6295 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6300 */     GIR_RootConstrainSelectedInstOperands,
     /*   6301 */     // GIR_Coverage, 93,
     /*   6301 */     GIR_Done,
     /*   6302 */   // Label 195: @6302
     /*   6302 */   GIM_Reject,
     /*   6303 */ // Label 170: @6303
     /*   6303 */ GIM_Reject,
     /*   6304 */ // Label 157: @6304
     /*   6304 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(12243),
     /*   6309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6315 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6451), // Rule ID 5425 //
     /*   6320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6353 */     // MIs[1] Operand 2
     /*   6353 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6380 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6384 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6388 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6393 */     // MIs[3] Operand 2
     /*   6393 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6406 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6433 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6450 */     // GIR_Coverage, 5425,
     /*   6450 */     GIR_EraseRootFromParent_Done,
     /*   6451 */   // Label 197: @6451
     /*   6451 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6587), // Rule ID 5424 //
     /*   6456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6489 */     // MIs[1] Operand 2
     /*   6489 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6516 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6520 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6524 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6529 */     // MIs[3] Operand 2
     /*   6529 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6542 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6586 */     // GIR_Coverage, 5424,
     /*   6586 */     GIR_EraseRootFromParent_Done,
     /*   6587 */   // Label 198: @6587
     /*   6587 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6723), // Rule ID 5434 //
     /*   6592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6625 */     // MIs[1] Operand 2
     /*   6625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6660 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6665 */     // MIs[3] Operand 2
     /*   6665 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6676 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6678 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6705 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6722 */     // GIR_Coverage, 5434,
     /*   6722 */     GIR_EraseRootFromParent_Done,
     /*   6723 */   // Label 199: @6723
     /*   6723 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6859), // Rule ID 5423 //
     /*   6728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6761 */     // MIs[1] Operand 2
     /*   6761 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6792 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6796 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6801 */     // MIs[3] Operand 2
     /*   6801 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6812 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6814 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6858 */     // GIR_Coverage, 5423,
     /*   6858 */     GIR_EraseRootFromParent_Done,
     /*   6859 */   // Label 200: @6859
     /*   6859 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6995), // Rule ID 5422 //
     /*   6864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6897 */     // MIs[1] Operand 2
     /*   6897 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6924 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6928 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6937 */     // MIs[3] Operand 2
     /*   6937 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6948 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6950 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6977 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6994 */     // GIR_Coverage, 5422,
     /*   6994 */     GIR_EraseRootFromParent_Done,
     /*   6995 */   // Label 201: @6995
     /*   6995 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7063), // Rule ID 6989 //
     /*   7000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7041 */     // MIs[2] Rn
     /*   7041 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7046 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7052 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7061 */     GIR_RootConstrainSelectedInstOperands,
     /*   7062 */     // GIR_Coverage, 6989,
     /*   7062 */     GIR_EraseRootFromParent_Done,
     /*   7063 */   // Label 202: @7063
     /*   7063 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7131), // Rule ID 14197 //
     /*   7068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7109 */     // MIs[2] Rn
     /*   7109 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7120 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7129 */     GIR_RootConstrainSelectedInstOperands,
     /*   7130 */     // GIR_Coverage, 14197,
     /*   7130 */     GIR_EraseRootFromParent_Done,
     /*   7131 */   // Label 203: @7131
     /*   7131 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7164), // Rule ID 13456 //
     /*   7136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7151 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7162 */     GIR_RootConstrainSelectedInstOperands,
     /*   7163 */     // GIR_Coverage, 13456,
     /*   7163 */     GIR_EraseRootFromParent_Done,
     /*   7164 */   // Label 204: @7164
     /*   7164 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7297), // Rule ID 4006 //
     /*   7169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7206 */     // MIs[2] Operand 2
     /*   7206 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7225 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7229 */     // MIs[3] Operand 1
     /*   7229 */     // No operand predicates
     /*   7229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7235 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7247 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7295 */     GIR_RootConstrainSelectedInstOperands,
     /*   7296 */     // GIR_Coverage, 4006,
     /*   7296 */     GIR_EraseRootFromParent_Done,
     /*   7297 */   // Label 205: @7297
     /*   7297 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7392), // Rule ID 4004 //
     /*   7302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7347 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7351 */     // MIs[3] Operand 1
     /*   7351 */     // No operand predicates
     /*   7351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7357 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7369 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7390 */     GIR_RootConstrainSelectedInstOperands,
     /*   7391 */     // GIR_Coverage, 4004,
     /*   7391 */     GIR_EraseRootFromParent_Done,
     /*   7392 */   // Label 206: @7392
     /*   7392 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7487), // Rule ID 4005 //
     /*   7397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7442 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7446 */     // MIs[3] Operand 1
     /*   7446 */     // No operand predicates
     /*   7446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7452 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7464 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7485 */     GIR_RootConstrainSelectedInstOperands,
     /*   7486 */     // GIR_Coverage, 4005,
     /*   7486 */     GIR_EraseRootFromParent_Done,
     /*   7487 */   // Label 207: @7487
     /*   7487 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7520), // Rule ID 92 //
     /*   7492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7507 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7518 */     GIR_RootConstrainSelectedInstOperands,
     /*   7519 */     // GIR_Coverage, 92,
     /*   7519 */     GIR_EraseRootFromParent_Done,
     /*   7520 */   // Label 208: @7520
     /*   7520 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7653), // Rule ID 14049 //
     /*   7525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7566 */     // MIs[2] Operand 2
     /*   7566 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7585 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7589 */     // MIs[3] Operand 1
     /*   7589 */     // No operand predicates
     /*   7589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7591 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7603 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7651 */     GIR_RootConstrainSelectedInstOperands,
     /*   7652 */     // GIR_Coverage, 14049,
     /*   7652 */     GIR_EraseRootFromParent_Done,
     /*   7653 */   // Label 209: @7653
     /*   7653 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7748), // Rule ID 14047 //
     /*   7658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7707 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7711 */     // MIs[3] Operand 1
     /*   7711 */     // No operand predicates
     /*   7711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7713 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7725 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7746 */     GIR_RootConstrainSelectedInstOperands,
     /*   7747 */     // GIR_Coverage, 14047,
     /*   7747 */     GIR_EraseRootFromParent_Done,
     /*   7748 */   // Label 210: @7748
     /*   7748 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7843), // Rule ID 14048 //
     /*   7753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7802 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7806 */     // MIs[3] Operand 1
     /*   7806 */     // No operand predicates
     /*   7806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7808 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7820 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7841 */     GIR_RootConstrainSelectedInstOperands,
     /*   7842 */     // GIR_Coverage, 14048,
     /*   7842 */     GIR_EraseRootFromParent_Done,
     /*   7843 */   // Label 211: @7843
     /*   7843 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7925), // Rule ID 13467 //
     /*   7848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7893 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7908 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7923 */     GIR_RootConstrainSelectedInstOperands,
     /*   7924 */     // GIR_Coverage, 13467,
     /*   7924 */     GIR_EraseRootFromParent_Done,
     /*   7925 */   // Label 212: @7925
     /*   7925 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8007), // Rule ID 13468 //
     /*   7930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7990 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8005 */     GIR_RootConstrainSelectedInstOperands,
     /*   8006 */     // GIR_Coverage, 13468,
     /*   8006 */     GIR_EraseRootFromParent_Done,
     /*   8007 */   // Label 213: @8007
     /*   8007 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8089), // Rule ID 123 //
     /*   8012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8065 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8072 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8087 */     GIR_RootConstrainSelectedInstOperands,
     /*   8088 */     // GIR_Coverage, 123,
     /*   8088 */     GIR_EraseRootFromParent_Done,
     /*   8089 */   // Label 214: @8089
     /*   8089 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8171), // Rule ID 125 //
     /*   8094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8147 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8154 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8169 */     GIR_RootConstrainSelectedInstOperands,
     /*   8170 */     // GIR_Coverage, 125,
     /*   8170 */     GIR_EraseRootFromParent_Done,
     /*   8171 */   // Label 215: @8171
     /*   8171 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8229), // Rule ID 13889 //
     /*   8176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8191 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8194 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8199 */     // MIs[1] pattern
     /*   8199 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8202 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8213 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8227 */     GIR_RootConstrainSelectedInstOperands,
     /*   8228 */     // GIR_Coverage, 13889,
     /*   8228 */     GIR_EraseRootFromParent_Done,
     /*   8229 */   // Label 216: @8229
     /*   8229 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8287), // Rule ID 15751 //
     /*   8234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8249 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8252 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8257 */     // MIs[1] pattern
     /*   8257 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8260 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8271 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8285 */     GIR_RootConstrainSelectedInstOperands,
     /*   8286 */     // GIR_Coverage, 15751,
     /*   8286 */     GIR_EraseRootFromParent_Done,
     /*   8287 */   // Label 217: @8287
     /*   8287 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8345), // Rule ID 15763 //
     /*   8292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8307 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8310 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8315 */     // MIs[1] pattern
     /*   8315 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8318 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8329 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8343 */     GIR_RootConstrainSelectedInstOperands,
     /*   8344 */     // GIR_Coverage, 15763,
     /*   8344 */     GIR_EraseRootFromParent_Done,
     /*   8345 */   // Label 218: @8345
     /*   8345 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8403), // Rule ID 15775 //
     /*   8350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8365 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8368 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8373 */     // MIs[1] pattern
     /*   8373 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8376 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8387 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8401 */     GIR_RootConstrainSelectedInstOperands,
     /*   8402 */     // GIR_Coverage, 15775,
     /*   8402 */     GIR_EraseRootFromParent_Done,
     /*   8403 */   // Label 219: @8403
     /*   8403 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8500), // Rule ID 4021 //
     /*   8408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8428 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8456 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8468 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8498 */     GIR_RootConstrainSelectedInstOperands,
     /*   8499 */     // GIR_Coverage, 4021,
     /*   8499 */     GIR_EraseRootFromParent_Done,
     /*   8500 */   // Label 220: @8500
     /*   8500 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8597), // Rule ID 14059 //
     /*   8505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8542 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8553 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8595 */     GIR_RootConstrainSelectedInstOperands,
     /*   8596 */     // GIR_Coverage, 14059,
     /*   8596 */     GIR_EraseRootFromParent_Done,
     /*   8597 */   // Label 221: @8597
     /*   8597 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8655), // Rule ID 2653 //
     /*   8602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8621 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8624 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8629 */     // MIs[1] pattern
     /*   8629 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8632 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8639 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8653 */     GIR_RootConstrainSelectedInstOperands,
     /*   8654 */     // GIR_Coverage, 2653,
     /*   8654 */     GIR_EraseRootFromParent_Done,
     /*   8655 */   // Label 222: @8655
     /*   8655 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8713), // Rule ID 10065 //
     /*   8660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8679 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8682 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8687 */     // MIs[1] pattern
     /*   8687 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8690 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8711 */     GIR_RootConstrainSelectedInstOperands,
     /*   8712 */     // GIR_Coverage, 10065,
     /*   8712 */     GIR_EraseRootFromParent_Done,
     /*   8713 */   // Label 223: @8713
     /*   8713 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8771), // Rule ID 10077 //
     /*   8718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8745 */     // MIs[1] pattern
     /*   8745 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8748 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8755 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8769 */     GIR_RootConstrainSelectedInstOperands,
     /*   8770 */     // GIR_Coverage, 10077,
     /*   8770 */     GIR_EraseRootFromParent_Done,
     /*   8771 */   // Label 224: @8771
     /*   8771 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8829), // Rule ID 10089 //
     /*   8776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8795 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8798 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8803 */     // MIs[1] pattern
     /*   8803 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8806 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8813 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8827 */     GIR_RootConstrainSelectedInstOperands,
     /*   8828 */     // GIR_Coverage, 10089,
     /*   8828 */     GIR_EraseRootFromParent_Done,
     /*   8829 */   // Label 225: @8829
     /*   8829 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8926), // Rule ID 14060 //
     /*   8834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8858 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8882 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8924 */     GIR_RootConstrainSelectedInstOperands,
     /*   8925 */     // GIR_Coverage, 14060,
     /*   8925 */     GIR_EraseRootFromParent_Done,
     /*   8926 */   // Label 226: @8926
     /*   8926 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9023), // Rule ID 14061 //
     /*   8931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8972 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8979 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   9002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   9010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   9012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   9015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   9021 */     GIR_RootConstrainSelectedInstOperands,
     /*   9022 */     // GIR_Coverage, 14061,
     /*   9022 */     GIR_EraseRootFromParent_Done,
     /*   9023 */   // Label 227: @9023
     /*   9023 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9186), // Rule ID 14169 //
     /*   9028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9070 */     // MIs[1] Operand 2
     /*   9070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9087 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9087 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9090 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9094 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9113 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9120 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9168 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9185 */     // GIR_Coverage, 14169,
     /*   9185 */     GIR_EraseRootFromParent_Done,
     /*   9186 */   // Label 228: @9186
     /*   9186 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9349), // Rule ID 14166 //
     /*   9191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9233 */     // MIs[1] Operand 2
     /*   9233 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9250 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9276 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9283 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9331 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9348 */     // GIR_Coverage, 14166,
     /*   9348 */     GIR_EraseRootFromParent_Done,
     /*   9349 */   // Label 229: @9349
     /*   9349 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9499), // Rule ID 14175 //
     /*   9354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9387 */     // MIs[1] Operand 2
     /*   9387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9404 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9498 */     // GIR_Coverage, 14175,
     /*   9498 */     GIR_EraseRootFromParent_Done,
     /*   9499 */   // Label 230: @9499
     /*   9499 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9649), // Rule ID 14178 //
     /*   9504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9537 */     // MIs[1] Operand 2
     /*   9537 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9554 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9554 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9557 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9561 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9580 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9587 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9648 */     // GIR_Coverage, 14178,
     /*   9648 */     GIR_EraseRootFromParent_Done,
     /*   9649 */   // Label 231: @9649
     /*   9649 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9799), // Rule ID 14174 //
     /*   9654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9687 */     // MIs[1] Operand 2
     /*   9687 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9704 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9798 */     // GIR_Coverage, 14174,
     /*   9798 */     GIR_EraseRootFromParent_Done,
     /*   9799 */   // Label 232: @9799
     /*   9799 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9962), // Rule ID 5407 //
     /*   9804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9850 */     // MIs[1] Operand 2
     /*   9850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9863 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9863 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9866 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9870 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9889 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9896 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9944 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9961 */     // GIR_Coverage, 5407,
     /*   9961 */     GIR_EraseRootFromParent_Done,
     /*   9962 */   // Label 233: @9962
     /*   9962 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10125), // Rule ID 5404 //
     /*   9967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10013 */     // MIs[1] Operand 2
     /*  10013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10026 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10026 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10029 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10033 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10040 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10043 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10047 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10052 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  10059 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  10084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  10100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10107 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10124 */     // GIR_Coverage, 5404,
     /*  10124 */     GIR_EraseRootFromParent_Done,
     /*  10125 */   // Label 234: @10125
     /*  10125 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10275), // Rule ID 5431 //
     /*  10130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10167 */     // MIs[1] Operand 2
     /*  10167 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10180 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10180 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10183 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10187 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10206 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10209 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10213 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10274 */     // GIR_Coverage, 5431,
     /*  10274 */     GIR_EraseRootFromParent_Done,
     /*  10275 */   // Label 235: @10275
     /*  10275 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10425), // Rule ID 5437 //
     /*  10280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10317 */     // MIs[1] Operand 2
     /*  10317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10330 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  10388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10424 */     // GIR_Coverage, 5437,
     /*  10424 */     GIR_EraseRootFromParent_Done,
     /*  10425 */   // Label 236: @10425
     /*  10425 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10575), // Rule ID 5430 //
     /*  10430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10467 */     // MIs[1] Operand 2
     /*  10467 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10480 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10506 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10557 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10574 */     // GIR_Coverage, 5430,
     /*  10574 */     GIR_EraseRootFromParent_Done,
     /*  10575 */   // Label 237: @10575
     /*  10575 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10608), // Rule ID 13460 //
     /*  10580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10595 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10606 */     GIR_RootConstrainSelectedInstOperands,
     /*  10607 */     // GIR_Coverage, 13460,
     /*  10607 */     GIR_EraseRootFromParent_Done,
     /*  10608 */   // Label 238: @10608
     /*  10608 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10644), // Rule ID 14040 //
     /*  10613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10628 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10642 */     GIR_RootConstrainSelectedInstOperands,
     /*  10643 */     // GIR_Coverage, 14040,
     /*  10643 */     GIR_EraseRootFromParent_Done,
     /*  10644 */   // Label 239: @10644
     /*  10644 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10756), // Rule ID 4020 //
     /*  10649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10669 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10674 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10685 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10697 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*  10754 */     GIR_RootConstrainSelectedInstOperands,
     /*  10755 */     // GIR_Coverage, 4020,
     /*  10755 */     GIR_EraseRootFromParent_Done,
     /*  10756 */   // Label 240: @10756
     /*  10756 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10789), // Rule ID 98 //
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10776 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10787 */     GIR_RootConstrainSelectedInstOperands,
     /*  10788 */     // GIR_Coverage, 98,
     /*  10788 */     GIR_EraseRootFromParent_Done,
     /*  10789 */   // Label 241: @10789
     /*  10789 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10825), // Rule ID 3955 //
     /*  10794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10809 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10823 */     GIR_RootConstrainSelectedInstOperands,
     /*  10824 */     // GIR_Coverage, 3955,
     /*  10824 */     GIR_EraseRootFromParent_Done,
     /*  10825 */   // Label 242: @10825
     /*  10825 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10937), // Rule ID 14058 //
     /*  10830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10854 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10859 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10878 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10906 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10935 */     GIR_RootConstrainSelectedInstOperands,
     /*  10936 */     // GIR_Coverage, 14058,
     /*  10936 */     GIR_EraseRootFromParent_Done,
     /*  10937 */   // Label 243: @10937
     /*  10937 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10970), // Rule ID 13458 //
     /*  10942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10957 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10968 */     GIR_RootConstrainSelectedInstOperands,
     /*  10969 */     // GIR_Coverage, 13458,
     /*  10969 */     GIR_EraseRootFromParent_Done,
     /*  10970 */   // Label 244: @10970
     /*  10970 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11033), // Rule ID 15791 //
     /*  10975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10990 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10993 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  11002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11009 */     // MIs[1] pred
     /*  11009 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11020 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11031 */     GIR_RootConstrainSelectedInstOperands,
     /*  11032 */     // GIR_Coverage, 15791,
     /*  11032 */     GIR_EraseRootFromParent_Done,
     /*  11033 */   // Label 245: @11033
     /*  11033 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11096), // Rule ID 15792 //
     /*  11038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11053 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11056 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11072 */     // MIs[1] pred
     /*  11072 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11083 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11094 */     GIR_RootConstrainSelectedInstOperands,
     /*  11095 */     // GIR_Coverage, 15792,
     /*  11095 */     GIR_EraseRootFromParent_Done,
     /*  11096 */   // Label 246: @11096
     /*  11096 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11159), // Rule ID 15793 //
     /*  11101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11116 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11119 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11128 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11135 */     // MIs[1] pred
     /*  11135 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11146 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11157 */     GIR_RootConstrainSelectedInstOperands,
     /*  11158 */     // GIR_Coverage, 15793,
     /*  11158 */     GIR_EraseRootFromParent_Done,
     /*  11159 */   // Label 247: @11159
     /*  11159 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11222), // Rule ID 15794 //
     /*  11164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11179 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11182 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11198 */     // MIs[1] pred
     /*  11198 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11209 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11220 */     GIR_RootConstrainSelectedInstOperands,
     /*  11221 */     // GIR_Coverage, 15794,
     /*  11221 */     GIR_EraseRootFromParent_Done,
     /*  11222 */   // Label 248: @11222
     /*  11222 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11255), // Rule ID 96 //
     /*  11227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  11242 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  11242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  11245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  11253 */     GIR_RootConstrainSelectedInstOperands,
     /*  11254 */     // GIR_Coverage, 96,
     /*  11254 */     GIR_EraseRootFromParent_Done,
     /*  11255 */   // Label 249: @11255
     /*  11255 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11318), // Rule ID 10176 //
     /*  11260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  11291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11298 */     // MIs[1] pred
     /*  11298 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11305 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11316 */     GIR_RootConstrainSelectedInstOperands,
     /*  11317 */     // GIR_Coverage, 10176,
     /*  11317 */     GIR_EraseRootFromParent_Done,
     /*  11318 */   // Label 250: @11318
     /*  11318 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11381), // Rule ID 10177 //
     /*  11323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11342 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11345 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11354 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11361 */     // MIs[1] pred
     /*  11361 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11368 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11379 */     GIR_RootConstrainSelectedInstOperands,
     /*  11380 */     // GIR_Coverage, 10177,
     /*  11380 */     GIR_EraseRootFromParent_Done,
     /*  11381 */   // Label 251: @11381
     /*  11381 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11444), // Rule ID 10178 //
     /*  11386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11405 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11408 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11424 */     // MIs[1] pred
     /*  11424 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11431 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11442 */     GIR_RootConstrainSelectedInstOperands,
     /*  11443 */     // GIR_Coverage, 10178,
     /*  11443 */     GIR_EraseRootFromParent_Done,
     /*  11444 */   // Label 252: @11444
     /*  11444 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11507), // Rule ID 10179 //
     /*  11449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11487 */     // MIs[1] pred
     /*  11487 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11494 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11505 */     GIR_RootConstrainSelectedInstOperands,
     /*  11506 */     // GIR_Coverage, 10179,
     /*  11506 */     GIR_EraseRootFromParent_Done,
     /*  11507 */   // Label 253: @11507
     /*  11507 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11563), // Rule ID 13568 //
     /*  11512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 13568,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 254: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11619), // Rule ID 13580 //
     /*  11568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11583 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11586 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11606 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11617 */     GIR_RootConstrainSelectedInstOperands,
     /*  11618 */     // GIR_Coverage, 13580,
     /*  11618 */     GIR_EraseRootFromParent_Done,
     /*  11619 */   // Label 255: @11619
     /*  11619 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11686), // Rule ID 13796 //
     /*  11624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11648 */     // MIs[1] imm
     /*  11648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11660 */     // MIs[2] Operand 1
     /*  11660 */     // No operand predicates
     /*  11660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11670 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11684 */     GIR_RootConstrainSelectedInstOperands,
     /*  11685 */     // GIR_Coverage, 13796,
     /*  11685 */     GIR_EraseRootFromParent_Done,
     /*  11686 */   // Label 256: @11686
     /*  11686 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11753), // Rule ID 13799 //
     /*  11691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11715 */     // MIs[1] imm
     /*  11715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11727 */     // MIs[2] Operand 1
     /*  11727 */     // No operand predicates
     /*  11727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11737 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11751 */     GIR_RootConstrainSelectedInstOperands,
     /*  11752 */     // GIR_Coverage, 13799,
     /*  11752 */     GIR_EraseRootFromParent_Done,
     /*  11753 */   // Label 257: @11753
     /*  11753 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11809), // Rule ID 1001 //
     /*  11758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11796 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11807 */     GIR_RootConstrainSelectedInstOperands,
     /*  11808 */     // GIR_Coverage, 1001,
     /*  11808 */     GIR_EraseRootFromParent_Done,
     /*  11809 */   // Label 258: @11809
     /*  11809 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11865), // Rule ID 1062 //
     /*  11814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11833 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11836 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11852 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11863 */     GIR_RootConstrainSelectedInstOperands,
     /*  11864 */     // GIR_Coverage, 1062,
     /*  11864 */     GIR_EraseRootFromParent_Done,
     /*  11865 */   // Label 259: @11865
     /*  11865 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11932), // Rule ID 2125 //
     /*  11870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11898 */     // MIs[1] imm
     /*  11898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11910 */     // MIs[2] Operand 1
     /*  11910 */     // No operand predicates
     /*  11910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11916 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11930 */     GIR_RootConstrainSelectedInstOperands,
     /*  11931 */     // GIR_Coverage, 2125,
     /*  11931 */     GIR_EraseRootFromParent_Done,
     /*  11932 */   // Label 260: @11932
     /*  11932 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11999), // Rule ID 2134 //
     /*  11937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11965 */     // MIs[1] imm
     /*  11965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11973 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11977 */     // MIs[2] Operand 1
     /*  11977 */     // No operand predicates
     /*  11977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11983 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11997 */     GIR_RootConstrainSelectedInstOperands,
     /*  11998 */     // GIR_Coverage, 2134,
     /*  11998 */     GIR_EraseRootFromParent_Done,
     /*  11999 */   // Label 261: @11999
     /*  11999 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12047), // Rule ID 13567 //
     /*  12004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12034 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12045 */     GIR_RootConstrainSelectedInstOperands,
     /*  12046 */     // GIR_Coverage, 13567,
     /*  12046 */     GIR_EraseRootFromParent_Done,
     /*  12047 */   // Label 262: @12047
     /*  12047 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12095), // Rule ID 13579 //
     /*  12052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12082 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12093 */     GIR_RootConstrainSelectedInstOperands,
     /*  12094 */     // GIR_Coverage, 13579,
     /*  12094 */     GIR_EraseRootFromParent_Done,
     /*  12095 */   // Label 263: @12095
     /*  12095 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12143), // Rule ID 1000 //
     /*  12100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12130 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12141 */     GIR_RootConstrainSelectedInstOperands,
     /*  12142 */     // GIR_Coverage, 1000,
     /*  12142 */     GIR_EraseRootFromParent_Done,
     /*  12143 */   // Label 264: @12143
     /*  12143 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12191), // Rule ID 1061 //
     /*  12148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12178 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12189 */     GIR_RootConstrainSelectedInstOperands,
     /*  12190 */     // GIR_Coverage, 1061,
     /*  12190 */     GIR_EraseRootFromParent_Done,
     /*  12191 */   // Label 265: @12191
     /*  12191 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12215), // Rule ID 94 //
     /*  12196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12208 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  12208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  12213 */     GIR_RootConstrainSelectedInstOperands,
     /*  12214 */     // GIR_Coverage, 94,
     /*  12214 */     GIR_Done,
     /*  12215 */   // Label 266: @12215
     /*  12215 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 1611 //
     /*  12220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12235 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  12235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 1611,
     /*  12241 */     GIR_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Reject,
     /*  12243 */ // Label 196: @12243
     /*  12243 */ GIM_Reject,
     /*  12244 */ // Label 158: @12244
     /*  12244 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(15851),
     /*  12249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12255 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12443), // Rule ID 7010 //
     /*  12260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12297 */     // MIs[2] Operand 2
     /*  12297 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12316 */     // MIs[3] Rn
     /*  12316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12321 */     // MIs[3] Operand 2
     /*  12321 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12336 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12340 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12348 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12352 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12356 */     // MIs[5] Rn
     /*  12356 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12361 */     // MIs[5] Operand 2
     /*  12361 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12372 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12376 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12380 */     // MIs[6] Rn
     /*  12380 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12385 */     // MIs[6] Operand 2
     /*  12385 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12396 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12398 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12425 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12442 */     // GIR_Coverage, 7010,
     /*  12442 */     GIR_EraseRootFromParent_Done,
     /*  12443 */   // Label 269: @12443
     /*  12443 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12631), // Rule ID 14208 //
     /*  12448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12485 */     // MIs[2] Operand 2
     /*  12485 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12504 */     // MIs[3] Rn
     /*  12504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12509 */     // MIs[3] Operand 2
     /*  12509 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12524 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12528 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12532 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12536 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12540 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12544 */     // MIs[5] Rn
     /*  12544 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12549 */     // MIs[5] Operand 2
     /*  12549 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12560 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12564 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12568 */     // MIs[6] Rn
     /*  12568 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12573 */     // MIs[6] Operand 2
     /*  12573 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12584 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12586 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12613 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12630 */     // GIR_Coverage, 14208,
     /*  12630 */     GIR_EraseRootFromParent_Done,
     /*  12631 */   // Label 270: @12631
     /*  12631 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12767), // Rule ID 5421 //
     /*  12636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12669 */     // MIs[1] Operand 2
     /*  12669 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12700 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12704 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12709 */     // MIs[3] Operand 2
     /*  12709 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12720 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12722 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12766 */     // GIR_Coverage, 5421,
     /*  12766 */     GIR_EraseRootFromParent_Done,
     /*  12767 */   // Label 271: @12767
     /*  12767 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12903), // Rule ID 5420 //
     /*  12772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12805 */     // MIs[1] Operand 2
     /*  12805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12832 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12836 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12840 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12845 */     // MIs[3] Operand 2
     /*  12845 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12858 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12902 */     // GIR_Coverage, 5420,
     /*  12902 */     GIR_EraseRootFromParent_Done,
     /*  12903 */   // Label 272: @12903
     /*  12903 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13039), // Rule ID 5433 //
     /*  12908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12941 */     // MIs[1] Operand 2
     /*  12941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12976 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12981 */     // MIs[3] Operand 2
     /*  12981 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12992 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12994 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  13001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13038 */     // GIR_Coverage, 5433,
     /*  13038 */     GIR_EraseRootFromParent_Done,
     /*  13039 */   // Label 273: @13039
     /*  13039 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13175), // Rule ID 5419 //
     /*  13044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13077 */     // MIs[1] Operand 2
     /*  13077 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13108 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13112 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13117 */     // MIs[3] Operand 2
     /*  13117 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13128 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13130 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13174 */     // GIR_Coverage, 5419,
     /*  13174 */     GIR_EraseRootFromParent_Done,
     /*  13175 */   // Label 274: @13175
     /*  13175 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13311), // Rule ID 5418 //
     /*  13180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13213 */     // MIs[1] Operand 2
     /*  13213 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13240 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13244 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13248 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13253 */     // MIs[3] Operand 2
     /*  13253 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13266 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13293 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13310 */     // GIR_Coverage, 5418,
     /*  13310 */     GIR_EraseRootFromParent_Done,
     /*  13311 */   // Label 275: @13311
     /*  13311 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13474), // Rule ID 14168 //
     /*  13316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13358 */     // MIs[1] Operand 2
     /*  13358 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13375 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13375 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13378 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13382 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13401 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13404 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13408 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13445 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13456 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13473 */     // GIR_Coverage, 14168,
     /*  13473 */     GIR_EraseRootFromParent_Done,
     /*  13474 */   // Label 276: @13474
     /*  13474 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13637), // Rule ID 14165 //
     /*  13479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13521 */     // MIs[1] Operand 2
     /*  13521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13538 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13564 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13619 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13636 */     // GIR_Coverage, 14165,
     /*  13636 */     GIR_EraseRootFromParent_Done,
     /*  13637 */   // Label 277: @13637
     /*  13637 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13787), // Rule ID 14173 //
     /*  13642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13675 */     // MIs[1] Operand 2
     /*  13675 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13692 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13786 */     // GIR_Coverage, 14173,
     /*  13786 */     GIR_EraseRootFromParent_Done,
     /*  13787 */   // Label 278: @13787
     /*  13787 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13937), // Rule ID 14177 //
     /*  13792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13825 */     // MIs[1] Operand 2
     /*  13825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13842 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13842 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13845 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13849 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13868 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13875 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13919 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13936 */     // GIR_Coverage, 14177,
     /*  13936 */     GIR_EraseRootFromParent_Done,
     /*  13937 */   // Label 279: @13937
     /*  13937 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14087), // Rule ID 14172 //
     /*  13942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13975 */     // MIs[1] Operand 2
     /*  13975 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13992 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13992 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13995 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13999 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14018 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14021 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  14025 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14086 */     // GIR_Coverage, 14172,
     /*  14086 */     GIR_EraseRootFromParent_Done,
     /*  14087 */   // Label 280: @14087
     /*  14087 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14250), // Rule ID 5406 //
     /*  14092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  14120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14138 */     // MIs[1] Operand 2
     /*  14138 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14151 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14177 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  14209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14232 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14249 */     // GIR_Coverage, 5406,
     /*  14249 */     GIR_EraseRootFromParent_Done,
     /*  14250 */   // Label 281: @14250
     /*  14250 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14413), // Rule ID 5403 //
     /*  14255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  14283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14301 */     // MIs[1] Operand 2
     /*  14301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14314 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14340 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  14372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14395 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14412 */     // GIR_Coverage, 5403,
     /*  14412 */     GIR_EraseRootFromParent_Done,
     /*  14413 */   // Label 282: @14413
     /*  14413 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14563), // Rule ID 5429 //
     /*  14418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14455 */     // MIs[1] Operand 2
     /*  14455 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14468 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14468 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14471 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14475 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14494 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14497 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14501 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14531 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14562 */     // GIR_Coverage, 5429,
     /*  14562 */     GIR_EraseRootFromParent_Done,
     /*  14563 */   // Label 283: @14563
     /*  14563 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14713), // Rule ID 5436 //
     /*  14568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14605 */     // MIs[1] Operand 2
     /*  14605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14618 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14644 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14651 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14654 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14695 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14712 */     // GIR_Coverage, 5436,
     /*  14712 */     GIR_EraseRootFromParent_Done,
     /*  14713 */   // Label 284: @14713
     /*  14713 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14863), // Rule ID 5428 //
     /*  14718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14755 */     // MIs[1] Operand 2
     /*  14755 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14768 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14768 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14771 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14775 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14794 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14797 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14801 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14862 */     // GIR_Coverage, 5428,
     /*  14862 */     GIR_EraseRootFromParent_Done,
     /*  14863 */   // Label 285: @14863
     /*  14863 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14932), // Rule ID 13602 //
     /*  14868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14883 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14886 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14895 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14915 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14930 */     GIR_RootConstrainSelectedInstOperands,
     /*  14931 */     // GIR_Coverage, 13602,
     /*  14931 */     GIR_EraseRootFromParent_Done,
     /*  14932 */   // Label 286: @14932
     /*  14932 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(15001), // Rule ID 13614 //
     /*  14937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14952 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14955 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14984 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14999 */     GIR_RootConstrainSelectedInstOperands,
     /*  15000 */     // GIR_Coverage, 13614,
     /*  15000 */     GIR_EraseRootFromParent_Done,
     /*  15001 */   // Label 287: @15001
     /*  15001 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(15057), // Rule ID 13564 //
     /*  15006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15021 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15024 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15044 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15055 */     GIR_RootConstrainSelectedInstOperands,
     /*  15056 */     // GIR_Coverage, 13564,
     /*  15056 */     GIR_EraseRootFromParent_Done,
     /*  15057 */   // Label 288: @15057
     /*  15057 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15113), // Rule ID 13576 //
     /*  15062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15077 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15080 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15100 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15111 */     GIR_RootConstrainSelectedInstOperands,
     /*  15112 */     // GIR_Coverage, 13576,
     /*  15112 */     GIR_EraseRootFromParent_Done,
     /*  15113 */   // Label 289: @15113
     /*  15113 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15180), // Rule ID 13816 //
     /*  15118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15142 */     // MIs[1] imm
     /*  15142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15154 */     // MIs[2] Operand 1
     /*  15154 */     // No operand predicates
     /*  15154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15164 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15178 */     GIR_RootConstrainSelectedInstOperands,
     /*  15179 */     // GIR_Coverage, 13816,
     /*  15179 */     GIR_EraseRootFromParent_Done,
     /*  15180 */   // Label 290: @15180
     /*  15180 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15247), // Rule ID 13837 //
     /*  15185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15209 */     // MIs[1] imm
     /*  15209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15217 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15221 */     // MIs[2] Operand 1
     /*  15221 */     // No operand predicates
     /*  15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15231 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15245 */     GIR_RootConstrainSelectedInstOperands,
     /*  15246 */     // GIR_Coverage, 13837,
     /*  15246 */     GIR_EraseRootFromParent_Done,
     /*  15247 */   // Label 291: @15247
     /*  15247 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15316), // Rule ID 1369 //
     /*  15252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15271 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15274 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  15279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15299 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 1369,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 292: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15385), // Rule ID 1492 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15340 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15343 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  15348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15352 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15368 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  15371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15383 */     GIR_RootConstrainSelectedInstOperands,
     /*  15384 */     // GIR_Coverage, 1492,
     /*  15384 */     GIR_EraseRootFromParent_Done,
     /*  15385 */   // Label 293: @15385
     /*  15385 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15441), // Rule ID 997 //
     /*  15390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15428 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15439 */     GIR_RootConstrainSelectedInstOperands,
     /*  15440 */     // GIR_Coverage, 997,
     /*  15440 */     GIR_EraseRootFromParent_Done,
     /*  15441 */   // Label 294: @15441
     /*  15441 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15497), // Rule ID 1058 //
     /*  15446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15465 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15468 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15484 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15495 */     GIR_RootConstrainSelectedInstOperands,
     /*  15496 */     // GIR_Coverage, 1058,
     /*  15496 */     GIR_EraseRootFromParent_Done,
     /*  15497 */   // Label 295: @15497
     /*  15497 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15564), // Rule ID 2242 //
     /*  15502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15530 */     // MIs[1] imm
     /*  15530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15542 */     // MIs[2] Operand 1
     /*  15542 */     // No operand predicates
     /*  15542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15548 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15562 */     GIR_RootConstrainSelectedInstOperands,
     /*  15563 */     // GIR_Coverage, 2242,
     /*  15563 */     GIR_EraseRootFromParent_Done,
     /*  15564 */   // Label 296: @15564
     /*  15564 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15631), // Rule ID 2301 //
     /*  15569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15597 */     // MIs[1] imm
     /*  15597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15609 */     // MIs[2] Operand 1
     /*  15609 */     // No operand predicates
     /*  15609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15615 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15629 */     GIR_RootConstrainSelectedInstOperands,
     /*  15630 */     // GIR_Coverage, 2301,
     /*  15630 */     GIR_EraseRootFromParent_Done,
     /*  15631 */   // Label 297: @15631
     /*  15631 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15679), // Rule ID 13563 //
     /*  15636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15666 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15677 */     GIR_RootConstrainSelectedInstOperands,
     /*  15678 */     // GIR_Coverage, 13563,
     /*  15678 */     GIR_EraseRootFromParent_Done,
     /*  15679 */   // Label 298: @15679
     /*  15679 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15727), // Rule ID 13575 //
     /*  15684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15714 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15725 */     GIR_RootConstrainSelectedInstOperands,
     /*  15726 */     // GIR_Coverage, 13575,
     /*  15726 */     GIR_EraseRootFromParent_Done,
     /*  15727 */   // Label 299: @15727
     /*  15727 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15775), // Rule ID 996 //
     /*  15732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15762 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15773 */     GIR_RootConstrainSelectedInstOperands,
     /*  15774 */     // GIR_Coverage, 996,
     /*  15774 */     GIR_EraseRootFromParent_Done,
     /*  15775 */   // Label 300: @15775
     /*  15775 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15823), // Rule ID 1057 //
     /*  15780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15810 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15821 */     GIR_RootConstrainSelectedInstOperands,
     /*  15822 */     // GIR_Coverage, 1057,
     /*  15822 */     GIR_EraseRootFromParent_Done,
     /*  15823 */   // Label 301: @15823
     /*  15823 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15850), // Rule ID 1108 //
     /*  15828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15843 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15848 */     GIR_RootConstrainSelectedInstOperands,
     /*  15849 */     // GIR_Coverage, 1108,
     /*  15849 */     GIR_Done,
     /*  15850 */   // Label 302: @15850
     /*  15850 */   GIM_Reject,
     /*  15851 */ // Label 268: @15851
     /*  15851 */ GIM_Reject,
     /*  15852 */ // Label 159: @15852
     /*  15852 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(21753),
     /*  15857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15863 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15981), // Rule ID 13745 //
     /*  15868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15932 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15936 */     // MIs[4] Operand 1
     /*  15936 */     // No operand predicates
     /*  15936 */     // MIs[2] Operand 2
     /*  15936 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15960 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15979 */     GIR_RootConstrainSelectedInstOperands,
     /*  15980 */     // GIR_Coverage, 13745,
     /*  15980 */     GIR_EraseRootFromParent_Done,
     /*  15981 */   // Label 304: @15981
     /*  15981 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16099), // Rule ID 13746 //
     /*  15986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16050 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16054 */     // MIs[4] Operand 1
     /*  16054 */     // No operand predicates
     /*  16054 */     // MIs[2] Operand 2
     /*  16054 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16078 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16097 */     GIR_RootConstrainSelectedInstOperands,
     /*  16098 */     // GIR_Coverage, 13746,
     /*  16098 */     GIR_EraseRootFromParent_Done,
     /*  16099 */   // Label 305: @16099
     /*  16099 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16217), // Rule ID 13781 //
     /*  16104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16160 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16164 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16168 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16172 */     // MIs[4] Operand 1
     /*  16172 */     // No operand predicates
     /*  16172 */     // MIs[2] Operand 2
     /*  16172 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16187 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16196 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16215 */     GIR_RootConstrainSelectedInstOperands,
     /*  16216 */     // GIR_Coverage, 13781,
     /*  16216 */     GIR_EraseRootFromParent_Done,
     /*  16217 */   // Label 306: @16217
     /*  16217 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16335), // Rule ID 13782 //
     /*  16222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16273 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16282 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16286 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16290 */     // MIs[4] Operand 1
     /*  16290 */     // No operand predicates
     /*  16290 */     // MIs[2] Operand 2
     /*  16290 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16305 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16314 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16333 */     GIR_RootConstrainSelectedInstOperands,
     /*  16334 */     // GIR_Coverage, 13782,
     /*  16334 */     GIR_EraseRootFromParent_Done,
     /*  16335 */   // Label 307: @16335
     /*  16335 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16453), // Rule ID 2046 //
     /*  16340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16408 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16412 */     // MIs[4] Operand 1
     /*  16412 */     // No operand predicates
     /*  16412 */     // MIs[2] Operand 2
     /*  16412 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16423 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16432 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16451 */     GIR_RootConstrainSelectedInstOperands,
     /*  16452 */     // GIR_Coverage, 2046,
     /*  16452 */     GIR_EraseRootFromParent_Done,
     /*  16453 */   // Label 308: @16453
     /*  16453 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16571), // Rule ID 13744 //
     /*  16458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16509 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16526 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16530 */     // MIs[4] Operand 1
     /*  16530 */     // No operand predicates
     /*  16530 */     // MIs[2] Operand 2
     /*  16530 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16550 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16569 */     GIR_RootConstrainSelectedInstOperands,
     /*  16570 */     // GIR_Coverage, 13744,
     /*  16570 */     GIR_EraseRootFromParent_Done,
     /*  16571 */   // Label 309: @16571
     /*  16571 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16689), // Rule ID 2098 //
     /*  16576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16627 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16644 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16648 */     // MIs[4] Operand 1
     /*  16648 */     // No operand predicates
     /*  16648 */     // MIs[2] Operand 2
     /*  16648 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16659 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16668 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16687 */     GIR_RootConstrainSelectedInstOperands,
     /*  16688 */     // GIR_Coverage, 2098,
     /*  16688 */     GIR_EraseRootFromParent_Done,
     /*  16689 */   // Label 310: @16689
     /*  16689 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16807), // Rule ID 13780 //
     /*  16694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16745 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16749 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16754 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16758 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16762 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16766 */     // MIs[4] Operand 1
     /*  16766 */     // No operand predicates
     /*  16766 */     // MIs[2] Operand 2
     /*  16766 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16777 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16786 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16805 */     GIR_RootConstrainSelectedInstOperands,
     /*  16806 */     // GIR_Coverage, 13780,
     /*  16806 */     GIR_EraseRootFromParent_Done,
     /*  16807 */   // Label 311: @16807
     /*  16807 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16894), // Rule ID 13646 //
     /*  16812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16839 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16842 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16851 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16875 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16892 */     GIR_RootConstrainSelectedInstOperands,
     /*  16893 */     // GIR_Coverage, 13646,
     /*  16893 */     GIR_EraseRootFromParent_Done,
     /*  16894 */   // Label 312: @16894
     /*  16894 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16981), // Rule ID 13674 //
     /*  16899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16926 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16929 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16938 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16962 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16979 */     GIR_RootConstrainSelectedInstOperands,
     /*  16980 */     // GIR_Coverage, 13674,
     /*  16980 */     GIR_EraseRootFromParent_Done,
     /*  16981 */   // Label 313: @16981
     /*  16981 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17068), // Rule ID 1703 //
     /*  16986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17017 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17020 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  17025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17029 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17049 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  17052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17066 */     GIR_RootConstrainSelectedInstOperands,
     /*  17067 */     // GIR_Coverage, 1703,
     /*  17067 */     GIR_EraseRootFromParent_Done,
     /*  17068 */   // Label 314: @17068
     /*  17068 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17155), // Rule ID 1781 //
     /*  17073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17104 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17107 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  17112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17116 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17136 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  17139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17153 */     GIR_RootConstrainSelectedInstOperands,
     /*  17154 */     // GIR_Coverage, 1781,
     /*  17154 */     GIR_EraseRootFromParent_Done,
     /*  17155 */   // Label 315: @17155
     /*  17155 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17270), // Rule ID 13740 //
     /*  17160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17207 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17220 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17224 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17228 */     // MIs[4] Operand 1
     /*  17228 */     // No operand predicates
     /*  17228 */     // MIs[2] Operand 2
     /*  17228 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17248 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17250 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17268 */     GIR_RootConstrainSelectedInstOperands,
     /*  17269 */     // GIR_Coverage, 13740,
     /*  17269 */     GIR_EraseRootFromParent_Done,
     /*  17270 */   // Label 316: @17270
     /*  17270 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17385), // Rule ID 13739 //
     /*  17275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17323 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17327 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17331 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17344 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17348 */     // MIs[4] Operand 1
     /*  17348 */     // No operand predicates
     /*  17348 */     // MIs[2] Operand 2
     /*  17348 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17365 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17383 */     GIR_RootConstrainSelectedInstOperands,
     /*  17384 */     // GIR_Coverage, 13739,
     /*  17384 */     GIR_EraseRootFromParent_Done,
     /*  17385 */   // Label 317: @17385
     /*  17385 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17500), // Rule ID 13776 //
     /*  17390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17437 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17441 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17450 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17454 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17458 */     // MIs[4] Operand 1
     /*  17458 */     // No operand predicates
     /*  17458 */     // MIs[2] Operand 2
     /*  17458 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17480 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17498 */     GIR_RootConstrainSelectedInstOperands,
     /*  17499 */     // GIR_Coverage, 13776,
     /*  17499 */     GIR_EraseRootFromParent_Done,
     /*  17500 */   // Label 318: @17500
     /*  17500 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17615), // Rule ID 13775 //
     /*  17505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17557 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17574 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17578 */     // MIs[4] Operand 1
     /*  17578 */     // No operand predicates
     /*  17578 */     // MIs[2] Operand 2
     /*  17578 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17593 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17595 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17613 */     GIR_RootConstrainSelectedInstOperands,
     /*  17614 */     // GIR_Coverage, 13775,
     /*  17614 */     GIR_EraseRootFromParent_Done,
     /*  17615 */   // Label 319: @17615
     /*  17615 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17684), // Rule ID 1805 //
     /*  17620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17667 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17682 */     GIR_RootConstrainSelectedInstOperands,
     /*  17683 */     // GIR_Coverage, 1805,
     /*  17683 */     GIR_EraseRootFromParent_Done,
     /*  17684 */   // Label 320: @17684
     /*  17684 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17753), // Rule ID 1804 //
     /*  17689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17736 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17751 */     GIR_RootConstrainSelectedInstOperands,
     /*  17752 */     // GIR_Coverage, 1804,
     /*  17752 */     GIR_EraseRootFromParent_Done,
     /*  17753 */   // Label 321: @17753
     /*  17753 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17822), // Rule ID 1721 //
     /*  17758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17805 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17820 */     GIR_RootConstrainSelectedInstOperands,
     /*  17821 */     // GIR_Coverage, 1721,
     /*  17821 */     GIR_EraseRootFromParent_Done,
     /*  17822 */   // Label 322: @17822
     /*  17822 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17891), // Rule ID 1803 //
     /*  17827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17874 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17889 */     GIR_RootConstrainSelectedInstOperands,
     /*  17890 */     // GIR_Coverage, 1803,
     /*  17890 */     GIR_EraseRootFromParent_Done,
     /*  17891 */   // Label 323: @17891
     /*  17891 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17960), // Rule ID 1802 //
     /*  17896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17943 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17958 */     GIR_RootConstrainSelectedInstOperands,
     /*  17959 */     // GIR_Coverage, 1802,
     /*  17959 */     GIR_EraseRootFromParent_Done,
     /*  17960 */   // Label 324: @17960
     /*  17960 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18075), // Rule ID 13738 //
     /*  17965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18033 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18037 */     // MIs[4] Operand 1
     /*  18037 */     // No operand predicates
     /*  18037 */     // MIs[2] Operand 2
     /*  18037 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18055 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18073 */     GIR_RootConstrainSelectedInstOperands,
     /*  18074 */     // GIR_Coverage, 13738,
     /*  18074 */     GIR_EraseRootFromParent_Done,
     /*  18075 */   // Label 325: @18075
     /*  18075 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18190), // Rule ID 2044 //
     /*  18080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18149 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18153 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18157 */     // MIs[4] Operand 1
     /*  18157 */     // No operand predicates
     /*  18157 */     // MIs[2] Operand 2
     /*  18157 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18168 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18170 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18188 */     GIR_RootConstrainSelectedInstOperands,
     /*  18189 */     // GIR_Coverage, 2044,
     /*  18189 */     GIR_EraseRootFromParent_Done,
     /*  18190 */   // Label 326: @18190
     /*  18190 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18305), // Rule ID 13774 //
     /*  18195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18250 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18255 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18259 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18263 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18267 */     // MIs[4] Operand 1
     /*  18267 */     // No operand predicates
     /*  18267 */     // MIs[2] Operand 2
     /*  18267 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18283 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18285 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18303 */     GIR_RootConstrainSelectedInstOperands,
     /*  18304 */     // GIR_Coverage, 13774,
     /*  18304 */     GIR_EraseRootFromParent_Done,
     /*  18305 */   // Label 327: @18305
     /*  18305 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18420), // Rule ID 2096 //
     /*  18310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18362 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18366 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18370 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18375 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18379 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18383 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18387 */     // MIs[4] Operand 1
     /*  18387 */     // No operand predicates
     /*  18387 */     // MIs[2] Operand 2
     /*  18387 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18400 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18418 */     GIR_RootConstrainSelectedInstOperands,
     /*  18419 */     // GIR_Coverage, 2096,
     /*  18419 */     GIR_EraseRootFromParent_Done,
     /*  18420 */   // Label 328: @18420
     /*  18420 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18487), // Rule ID 13658 //
     /*  18425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18468 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18485 */     GIR_RootConstrainSelectedInstOperands,
     /*  18486 */     // GIR_Coverage, 13658,
     /*  18486 */     GIR_EraseRootFromParent_Done,
     /*  18487 */   // Label 329: @18487
     /*  18487 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18554), // Rule ID 13692 //
     /*  18492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18535 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18552 */     GIR_RootConstrainSelectedInstOperands,
     /*  18553 */     // GIR_Coverage, 13692,
     /*  18553 */     GIR_EraseRootFromParent_Done,
     /*  18554 */   // Label 330: @18554
     /*  18554 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18621), // Rule ID 1733 //
     /*  18559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18602 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18619 */     GIR_RootConstrainSelectedInstOperands,
     /*  18620 */     // GIR_Coverage, 1733,
     /*  18620 */     GIR_EraseRootFromParent_Done,
     /*  18621 */   // Label 331: @18621
     /*  18621 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18688), // Rule ID 1823 //
     /*  18626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18669 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18686 */     GIR_RootConstrainSelectedInstOperands,
     /*  18687 */     // GIR_Coverage, 1823,
     /*  18687 */     GIR_EraseRootFromParent_Done,
     /*  18688 */   // Label 332: @18688
     /*  18688 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18769), // Rule ID 13644 //
     /*  18693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18720 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18723 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18732 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18752 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18767 */     GIR_RootConstrainSelectedInstOperands,
     /*  18768 */     // GIR_Coverage, 13644,
     /*  18768 */     GIR_EraseRootFromParent_Done,
     /*  18769 */   // Label 333: @18769
     /*  18769 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18850), // Rule ID 13672 //
     /*  18774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18801 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18804 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18813 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18833 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18848 */     GIR_RootConstrainSelectedInstOperands,
     /*  18849 */     // GIR_Coverage, 13672,
     /*  18849 */     GIR_EraseRootFromParent_Done,
     /*  18850 */   // Label 334: @18850
     /*  18850 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18931), // Rule ID 1701 //
     /*  18855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18886 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18889 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18898 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18914 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18929 */     GIR_RootConstrainSelectedInstOperands,
     /*  18930 */     // GIR_Coverage, 1701,
     /*  18930 */     GIR_EraseRootFromParent_Done,
     /*  18931 */   // Label 335: @18931
     /*  18931 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19012), // Rule ID 1779 //
     /*  18936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18967 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18970 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18979 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18995 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  19006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  19010 */     GIR_RootConstrainSelectedInstOperands,
     /*  19011 */     // GIR_Coverage, 1779,
     /*  19011 */     GIR_EraseRootFromParent_Done,
     /*  19012 */   // Label 336: @19012
     /*  19012 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19104), // Rule ID 13743 //
     /*  19017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19073 */     // MIs[3] Operand 1
     /*  19073 */     // No operand predicates
     /*  19073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19084 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19102 */     GIR_RootConstrainSelectedInstOperands,
     /*  19103 */     // GIR_Coverage, 13743,
     /*  19103 */     GIR_EraseRootFromParent_Done,
     /*  19104 */   // Label 337: @19104
     /*  19104 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19196), // Rule ID 13742 //
     /*  19109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19170 */     // MIs[3] Operand 1
     /*  19170 */     // No operand predicates
     /*  19170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19176 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19194 */     GIR_RootConstrainSelectedInstOperands,
     /*  19195 */     // GIR_Coverage, 13742,
     /*  19195 */     GIR_EraseRootFromParent_Done,
     /*  19196 */   // Label 338: @19196
     /*  19196 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19288), // Rule ID 13779 //
     /*  19201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19253 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19257 */     // MIs[3] Operand 1
     /*  19257 */     // No operand predicates
     /*  19257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19268 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19286 */     GIR_RootConstrainSelectedInstOperands,
     /*  19287 */     // GIR_Coverage, 13779,
     /*  19287 */     GIR_EraseRootFromParent_Done,
     /*  19288 */   // Label 339: @19288
     /*  19288 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19380), // Rule ID 13778 //
     /*  19293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19354 */     // MIs[3] Operand 1
     /*  19354 */     // No operand predicates
     /*  19354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19360 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19378 */     GIR_RootConstrainSelectedInstOperands,
     /*  19379 */     // GIR_Coverage, 13778,
     /*  19379 */     GIR_EraseRootFromParent_Done,
     /*  19380 */   // Label 340: @19380
     /*  19380 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19472), // Rule ID 13741 //
     /*  19385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19445 */     // MIs[3] Operand 1
     /*  19445 */     // No operand predicates
     /*  19445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19452 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19470 */     GIR_RootConstrainSelectedInstOperands,
     /*  19471 */     // GIR_Coverage, 13741,
     /*  19471 */     GIR_EraseRootFromParent_Done,
     /*  19472 */   // Label 341: @19472
     /*  19472 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19564), // Rule ID 2045 //
     /*  19477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19542 */     // MIs[3] Operand 1
     /*  19542 */     // No operand predicates
     /*  19542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19544 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19562 */     GIR_RootConstrainSelectedInstOperands,
     /*  19563 */     // GIR_Coverage, 2045,
     /*  19563 */     GIR_EraseRootFromParent_Done,
     /*  19564 */   // Label 342: @19564
     /*  19564 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19656), // Rule ID 13777 //
     /*  19569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19629 */     // MIs[3] Operand 1
     /*  19629 */     // No operand predicates
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19636 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19654 */     GIR_RootConstrainSelectedInstOperands,
     /*  19655 */     // GIR_Coverage, 13777,
     /*  19655 */     GIR_EraseRootFromParent_Done,
     /*  19656 */   // Label 343: @19656
     /*  19656 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19748), // Rule ID 2097 //
     /*  19661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19726 */     // MIs[3] Operand 1
     /*  19726 */     // No operand predicates
     /*  19726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19728 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19746 */     GIR_RootConstrainSelectedInstOperands,
     /*  19747 */     // GIR_Coverage, 2097,
     /*  19747 */     GIR_EraseRootFromParent_Done,
     /*  19748 */   // Label 344: @19748
     /*  19748 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19799), // Rule ID 13686 //
     /*  19753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19785 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 13686,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 345: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19850), // Rule ID 13652 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19836 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19848 */     GIR_RootConstrainSelectedInstOperands,
     /*  19849 */     // GIR_Coverage, 13652,
     /*  19849 */     GIR_EraseRootFromParent_Done,
     /*  19850 */   // Label 346: @19850
     /*  19850 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19901), // Rule ID 13685 //
     /*  19855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19887 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19899 */     GIR_RootConstrainSelectedInstOperands,
     /*  19900 */     // GIR_Coverage, 13685,
     /*  19900 */     GIR_EraseRootFromParent_Done,
     /*  19901 */   // Label 347: @19901
     /*  19901 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19952), // Rule ID 1817 //
     /*  19906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19938 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19950 */     GIR_RootConstrainSelectedInstOperands,
     /*  19951 */     // GIR_Coverage, 1817,
     /*  19951 */     GIR_EraseRootFromParent_Done,
     /*  19952 */   // Label 348: @19952
     /*  19952 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(20003), // Rule ID 1727 //
     /*  19957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19989 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  20001 */     GIR_RootConstrainSelectedInstOperands,
     /*  20002 */     // GIR_Coverage, 1727,
     /*  20002 */     GIR_EraseRootFromParent_Done,
     /*  20003 */   // Label 349: @20003
     /*  20003 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(20054), // Rule ID 1816 //
     /*  20008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  20040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  20040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  20043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  20052 */     GIR_RootConstrainSelectedInstOperands,
     /*  20053 */     // GIR_Coverage, 1816,
     /*  20053 */     GIR_EraseRootFromParent_Done,
     /*  20054 */   // Label 350: @20054
     /*  20054 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20110), // Rule ID 13570 //
     /*  20059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20074 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20077 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20097 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20108 */     GIR_RootConstrainSelectedInstOperands,
     /*  20109 */     // GIR_Coverage, 13570,
     /*  20109 */     GIR_EraseRootFromParent_Done,
     /*  20110 */   // Label 351: @20110
     /*  20110 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20166), // Rule ID 13582 //
     /*  20115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20130 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20133 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20153 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20164 */     GIR_RootConstrainSelectedInstOperands,
     /*  20165 */     // GIR_Coverage, 13582,
     /*  20165 */     GIR_EraseRootFromParent_Done,
     /*  20166 */   // Label 352: @20166
     /*  20166 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20233), // Rule ID 13820 //
     /*  20171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20195 */     // MIs[1] imm
     /*  20195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20207 */     // MIs[2] Operand 1
     /*  20207 */     // No operand predicates
     /*  20207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20217 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20231 */     GIR_RootConstrainSelectedInstOperands,
     /*  20232 */     // GIR_Coverage, 13820,
     /*  20232 */     GIR_EraseRootFromParent_Done,
     /*  20233 */   // Label 353: @20233
     /*  20233 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20300), // Rule ID 13841 //
     /*  20238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20262 */     // MIs[1] imm
     /*  20262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20274 */     // MIs[2] Operand 1
     /*  20274 */     // No operand predicates
     /*  20274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20284 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20298 */     GIR_RootConstrainSelectedInstOperands,
     /*  20299 */     // GIR_Coverage, 13841,
     /*  20299 */     GIR_EraseRootFromParent_Done,
     /*  20300 */   // Label 354: @20300
     /*  20300 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20356), // Rule ID 1003 //
     /*  20305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20343 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20354 */     GIR_RootConstrainSelectedInstOperands,
     /*  20355 */     // GIR_Coverage, 1003,
     /*  20355 */     GIR_EraseRootFromParent_Done,
     /*  20356 */   // Label 355: @20356
     /*  20356 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20412), // Rule ID 1064 //
     /*  20361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20380 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20383 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20399 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20410 */     GIR_RootConstrainSelectedInstOperands,
     /*  20411 */     // GIR_Coverage, 1064,
     /*  20411 */     GIR_EraseRootFromParent_Done,
     /*  20412 */   // Label 356: @20412
     /*  20412 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20479), // Rule ID 2246 //
     /*  20417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20445 */     // MIs[1] imm
     /*  20445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20453 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20457 */     // MIs[2] Operand 1
     /*  20457 */     // No operand predicates
     /*  20457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20463 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20477 */     GIR_RootConstrainSelectedInstOperands,
     /*  20478 */     // GIR_Coverage, 2246,
     /*  20478 */     GIR_EraseRootFromParent_Done,
     /*  20479 */   // Label 357: @20479
     /*  20479 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20546), // Rule ID 2305 //
     /*  20484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20512 */     // MIs[1] imm
     /*  20512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20524 */     // MIs[2] Operand 1
     /*  20524 */     // No operand predicates
     /*  20524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20530 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20544 */     GIR_RootConstrainSelectedInstOperands,
     /*  20545 */     // GIR_Coverage, 2305,
     /*  20545 */     GIR_EraseRootFromParent_Done,
     /*  20546 */   // Label 358: @20546
     /*  20546 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20616), // Rule ID 7006 //
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20589 */     // MIs[2] Rn
     /*  20589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20594 */     // MIs[2] Rm
     /*  20594 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20601 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20614 */     GIR_RootConstrainSelectedInstOperands,
     /*  20615 */     // GIR_Coverage, 7006,
     /*  20615 */     GIR_EraseRootFromParent_Done,
     /*  20616 */   // Label 359: @20616
     /*  20616 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20686), // Rule ID 14204 //
     /*  20621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20659 */     // MIs[2] Rn
     /*  20659 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20664 */     // MIs[2] Rm
     /*  20664 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20671 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20684 */     GIR_RootConstrainSelectedInstOperands,
     /*  20685 */     // GIR_Coverage, 14204,
     /*  20685 */     GIR_EraseRootFromParent_Done,
     /*  20686 */   // Label 360: @20686
     /*  20686 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20749), // Rule ID 1801 //
     /*  20691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20734 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20747 */     GIR_RootConstrainSelectedInstOperands,
     /*  20748 */     // GIR_Coverage, 1801,
     /*  20748 */     GIR_EraseRootFromParent_Done,
     /*  20749 */   // Label 361: @20749
     /*  20749 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20812), // Rule ID 1800 //
     /*  20754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20797 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20810 */     GIR_RootConstrainSelectedInstOperands,
     /*  20811 */     // GIR_Coverage, 1800,
     /*  20811 */     GIR_EraseRootFromParent_Done,
     /*  20812 */   // Label 362: @20812
     /*  20812 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20875), // Rule ID 1720 //
     /*  20817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20860 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20873 */     GIR_RootConstrainSelectedInstOperands,
     /*  20874 */     // GIR_Coverage, 1720,
     /*  20874 */     GIR_EraseRootFromParent_Done,
     /*  20875 */   // Label 363: @20875
     /*  20875 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20938), // Rule ID 1799 //
     /*  20880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20923 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20936 */     GIR_RootConstrainSelectedInstOperands,
     /*  20937 */     // GIR_Coverage, 1799,
     /*  20937 */     GIR_EraseRootFromParent_Done,
     /*  20938 */   // Label 364: @20938
     /*  20938 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(21001), // Rule ID 1798 //
     /*  20943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20986 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1798,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 365: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(21062), // Rule ID 13657 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21045 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21060 */     GIR_RootConstrainSelectedInstOperands,
     /*  21061 */     // GIR_Coverage, 13657,
     /*  21061 */     GIR_EraseRootFromParent_Done,
     /*  21062 */   // Label 366: @21062
     /*  21062 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(21123), // Rule ID 13691 //
     /*  21067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21106 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21121 */     GIR_RootConstrainSelectedInstOperands,
     /*  21122 */     // GIR_Coverage, 13691,
     /*  21122 */     GIR_EraseRootFromParent_Done,
     /*  21123 */   // Label 367: @21123
     /*  21123 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(21171), // Rule ID 13684 //
     /*  21128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21158 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21169 */     GIR_RootConstrainSelectedInstOperands,
     /*  21170 */     // GIR_Coverage, 13684,
     /*  21170 */     GIR_EraseRootFromParent_Done,
     /*  21171 */   // Label 368: @21171
     /*  21171 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21219), // Rule ID 13569 //
     /*  21176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21206 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21217 */     GIR_RootConstrainSelectedInstOperands,
     /*  21218 */     // GIR_Coverage, 13569,
     /*  21218 */     GIR_EraseRootFromParent_Done,
     /*  21219 */   // Label 369: @21219
     /*  21219 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21267), // Rule ID 13651 //
     /*  21224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21254 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21265 */     GIR_RootConstrainSelectedInstOperands,
     /*  21266 */     // GIR_Coverage, 13651,
     /*  21266 */     GIR_EraseRootFromParent_Done,
     /*  21267 */   // Label 370: @21267
     /*  21267 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21315), // Rule ID 13581 //
     /*  21272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21302 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21313 */     GIR_RootConstrainSelectedInstOperands,
     /*  21314 */     // GIR_Coverage, 13581,
     /*  21314 */     GIR_EraseRootFromParent_Done,
     /*  21315 */   // Label 371: @21315
     /*  21315 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21363), // Rule ID 13683 //
     /*  21320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21350 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21361 */     GIR_RootConstrainSelectedInstOperands,
     /*  21362 */     // GIR_Coverage, 13683,
     /*  21362 */     GIR_EraseRootFromParent_Done,
     /*  21363 */   // Label 372: @21363
     /*  21363 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21424), // Rule ID 1732 //
     /*  21368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21407 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21422 */     GIR_RootConstrainSelectedInstOperands,
     /*  21423 */     // GIR_Coverage, 1732,
     /*  21423 */     GIR_EraseRootFromParent_Done,
     /*  21424 */   // Label 373: @21424
     /*  21424 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21485), // Rule ID 1822 //
     /*  21429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21468 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21483 */     GIR_RootConstrainSelectedInstOperands,
     /*  21484 */     // GIR_Coverage, 1822,
     /*  21484 */     GIR_EraseRootFromParent_Done,
     /*  21485 */   // Label 374: @21485
     /*  21485 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21533), // Rule ID 1815 //
     /*  21490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21520 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21531 */     GIR_RootConstrainSelectedInstOperands,
     /*  21532 */     // GIR_Coverage, 1815,
     /*  21532 */     GIR_EraseRootFromParent_Done,
     /*  21533 */   // Label 375: @21533
     /*  21533 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21581), // Rule ID 1002 //
     /*  21538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21568 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21579 */     GIR_RootConstrainSelectedInstOperands,
     /*  21580 */     // GIR_Coverage, 1002,
     /*  21580 */     GIR_EraseRootFromParent_Done,
     /*  21581 */   // Label 376: @21581
     /*  21581 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21629), // Rule ID 1726 //
     /*  21586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21616 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21627 */     GIR_RootConstrainSelectedInstOperands,
     /*  21628 */     // GIR_Coverage, 1726,
     /*  21628 */     GIR_EraseRootFromParent_Done,
     /*  21629 */   // Label 377: @21629
     /*  21629 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21677), // Rule ID 1063 //
     /*  21634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21664 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21675 */     GIR_RootConstrainSelectedInstOperands,
     /*  21676 */     // GIR_Coverage, 1063,
     /*  21676 */     GIR_EraseRootFromParent_Done,
     /*  21677 */   // Label 378: @21677
     /*  21677 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21725), // Rule ID 1814 //
     /*  21682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21712 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21723 */     GIR_RootConstrainSelectedInstOperands,
     /*  21724 */     // GIR_Coverage, 1814,
     /*  21724 */     GIR_EraseRootFromParent_Done,
     /*  21725 */   // Label 379: @21725
     /*  21725 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21752), // Rule ID 1110 //
     /*  21730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21745 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21750 */     GIR_RootConstrainSelectedInstOperands,
     /*  21751 */     // GIR_Coverage, 1110,
     /*  21751 */     GIR_Done,
     /*  21752 */   // Label 380: @21752
     /*  21752 */   GIM_Reject,
     /*  21753 */ // Label 303: @21753
     /*  21753 */ GIM_Reject,
     /*  21754 */ // Label 160: @21754
     /*  21754 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(25251),
     /*  21759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21765 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21901), // Rule ID 5417 //
     /*  21770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21803 */     // MIs[1] Operand 2
     /*  21803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21838 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21843 */     // MIs[3] Operand 2
     /*  21843 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21856 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21900 */     // GIR_Coverage, 5417,
     /*  21900 */     GIR_EraseRootFromParent_Done,
     /*  21901 */   // Label 382: @21901
     /*  21901 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22037), // Rule ID 5416 //
     /*  21906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21939 */     // MIs[1] Operand 2
     /*  21939 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21970 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21974 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21979 */     // MIs[3] Operand 2
     /*  21979 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21992 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22036 */     // GIR_Coverage, 5416,
     /*  22036 */     GIR_EraseRootFromParent_Done,
     /*  22037 */   // Label 383: @22037
     /*  22037 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22173), // Rule ID 5432 //
     /*  22042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22075 */     // MIs[1] Operand 2
     /*  22075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22106 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22110 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22115 */     // MIs[3] Operand 2
     /*  22115 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22128 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  22135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22155 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22172 */     // GIR_Coverage, 5432,
     /*  22172 */     GIR_EraseRootFromParent_Done,
     /*  22173 */   // Label 384: @22173
     /*  22173 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22309), // Rule ID 5415 //
     /*  22178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22211 */     // MIs[1] Operand 2
     /*  22211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22246 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22251 */     // MIs[3] Operand 2
     /*  22251 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22262 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22264 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22308 */     // GIR_Coverage, 5415,
     /*  22308 */     GIR_EraseRootFromParent_Done,
     /*  22309 */   // Label 385: @22309
     /*  22309 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22445), // Rule ID 5414 //
     /*  22314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22347 */     // MIs[1] Operand 2
     /*  22347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22370 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22374 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22378 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22382 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22387 */     // MIs[3] Operand 2
     /*  22387 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22400 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22444 */     // GIR_Coverage, 5414,
     /*  22444 */     GIR_EraseRootFromParent_Done,
     /*  22445 */   // Label 386: @22445
     /*  22445 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22578), // Rule ID 14209 //
     /*  22450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22495 */     // MIs[1] Operand 2
     /*  22495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22510 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22514 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22518 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22522 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22526 */     // MIs[5] Rn
     /*  22526 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22531 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22533 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22577 */     // GIR_Coverage, 14209,
     /*  22577 */     GIR_EraseRootFromParent_Done,
     /*  22578 */   // Label 387: @22578
     /*  22578 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22711), // Rule ID 7011 //
     /*  22583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22640 */     // MIs[4] Rn
     /*  22640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22645 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22649 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22653 */     // MIs[3] Operand 2
     /*  22653 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22664 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22666 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22710 */     // GIR_Coverage, 7011,
     /*  22710 */     GIR_EraseRootFromParent_Done,
     /*  22711 */   // Label 388: @22711
     /*  22711 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22874), // Rule ID 14167 //
     /*  22716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22758 */     // MIs[1] Operand 2
     /*  22758 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22775 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22801 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22808 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22856 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22873 */     // GIR_Coverage, 14167,
     /*  22873 */     GIR_EraseRootFromParent_Done,
     /*  22874 */   // Label 389: @22874
     /*  22874 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23037), // Rule ID 14164 //
     /*  22879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22921 */     // MIs[1] Operand 2
     /*  22921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22938 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22964 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22971 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23036 */     // GIR_Coverage, 14164,
     /*  23036 */     GIR_EraseRootFromParent_Done,
     /*  23037 */   // Label 390: @23037
     /*  23037 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23187), // Rule ID 14171 //
     /*  23042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23075 */     // MIs[1] Operand 2
     /*  23075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23092 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23092 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23095 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23099 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23118 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23125 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23169 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23186 */     // GIR_Coverage, 14171,
     /*  23186 */     GIR_EraseRootFromParent_Done,
     /*  23187 */   // Label 391: @23187
     /*  23187 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23337), // Rule ID 14176 //
     /*  23192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23225 */     // MIs[1] Operand 2
     /*  23225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23242 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23268 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23275 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23319 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23336 */     // GIR_Coverage, 14176,
     /*  23336 */     GIR_EraseRootFromParent_Done,
     /*  23337 */   // Label 392: @23337
     /*  23337 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23487), // Rule ID 14170 //
     /*  23342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23375 */     // MIs[1] Operand 2
     /*  23375 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23392 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23392 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23395 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23399 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23418 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23425 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23486 */     // GIR_Coverage, 14170,
     /*  23486 */     GIR_EraseRootFromParent_Done,
     /*  23487 */   // Label 393: @23487
     /*  23487 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23650), // Rule ID 5405 //
     /*  23492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23538 */     // MIs[1] Operand 2
     /*  23538 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23551 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23649 */     // GIR_Coverage, 5405,
     /*  23649 */     GIR_EraseRootFromParent_Done,
     /*  23650 */   // Label 394: @23650
     /*  23650 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23813), // Rule ID 5402 //
     /*  23655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23701 */     // MIs[1] Operand 2
     /*  23701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23714 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23728 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23731 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23735 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23740 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23747 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23812 */     // GIR_Coverage, 5402,
     /*  23812 */     GIR_EraseRootFromParent_Done,
     /*  23813 */   // Label 395: @23813
     /*  23813 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23963), // Rule ID 5427 //
     /*  23818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23855 */     // MIs[1] Operand 2
     /*  23855 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23868 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23868 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23871 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23875 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23894 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23897 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23901 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23962 */     // GIR_Coverage, 5427,
     /*  23962 */     GIR_EraseRootFromParent_Done,
     /*  23963 */   // Label 396: @23963
     /*  23963 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24113), // Rule ID 5435 //
     /*  23968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24005 */     // MIs[1] Operand 2
     /*  24005 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24018 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24018 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24021 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24025 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24044 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24051 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24064 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  24076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24095 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24112 */     // GIR_Coverage, 5435,
     /*  24112 */     GIR_EraseRootFromParent_Done,
     /*  24113 */   // Label 397: @24113
     /*  24113 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24263), // Rule ID 5426 //
     /*  24118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24155 */     // MIs[1] Operand 2
     /*  24155 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24168 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24194 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24201 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  24226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24262 */     // GIR_Coverage, 5426,
     /*  24262 */     GIR_EraseRootFromParent_Done,
     /*  24263 */   // Label 398: @24263
     /*  24263 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24332), // Rule ID 13598 //
     /*  24268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24283 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24286 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24295 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24315 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24330 */     GIR_RootConstrainSelectedInstOperands,
     /*  24331 */     // GIR_Coverage, 13598,
     /*  24331 */     GIR_EraseRootFromParent_Done,
     /*  24332 */   // Label 399: @24332
     /*  24332 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24401), // Rule ID 13610 //
     /*  24337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24352 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24355 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24384 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24399 */     GIR_RootConstrainSelectedInstOperands,
     /*  24400 */     // GIR_Coverage, 13610,
     /*  24400 */     GIR_EraseRootFromParent_Done,
     /*  24401 */   // Label 400: @24401
     /*  24401 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24457), // Rule ID 13560 //
     /*  24406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24421 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24424 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24444 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24455 */     GIR_RootConstrainSelectedInstOperands,
     /*  24456 */     // GIR_Coverage, 13560,
     /*  24456 */     GIR_EraseRootFromParent_Done,
     /*  24457 */   // Label 401: @24457
     /*  24457 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24513), // Rule ID 13572 //
     /*  24462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24500 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24511 */     GIR_RootConstrainSelectedInstOperands,
     /*  24512 */     // GIR_Coverage, 13572,
     /*  24512 */     GIR_EraseRootFromParent_Done,
     /*  24513 */   // Label 402: @24513
     /*  24513 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24580), // Rule ID 13812 //
     /*  24518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24542 */     // MIs[1] imm
     /*  24542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24554 */     // MIs[2] Operand 1
     /*  24554 */     // No operand predicates
     /*  24554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24564 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24578 */     GIR_RootConstrainSelectedInstOperands,
     /*  24579 */     // GIR_Coverage, 13812,
     /*  24579 */     GIR_EraseRootFromParent_Done,
     /*  24580 */   // Label 403: @24580
     /*  24580 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24647), // Rule ID 13833 //
     /*  24585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24609 */     // MIs[1] imm
     /*  24609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24621 */     // MIs[2] Operand 1
     /*  24621 */     // No operand predicates
     /*  24621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24631 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24645 */     GIR_RootConstrainSelectedInstOperands,
     /*  24646 */     // GIR_Coverage, 13833,
     /*  24646 */     GIR_EraseRootFromParent_Done,
     /*  24647 */   // Label 404: @24647
     /*  24647 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24716), // Rule ID 1365 //
     /*  24652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24699 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24714 */     GIR_RootConstrainSelectedInstOperands,
     /*  24715 */     // GIR_Coverage, 1365,
     /*  24715 */     GIR_EraseRootFromParent_Done,
     /*  24716 */   // Label 405: @24716
     /*  24716 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24785), // Rule ID 1488 //
     /*  24721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24740 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24743 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24768 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24783 */     GIR_RootConstrainSelectedInstOperands,
     /*  24784 */     // GIR_Coverage, 1488,
     /*  24784 */     GIR_EraseRootFromParent_Done,
     /*  24785 */   // Label 406: @24785
     /*  24785 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24841), // Rule ID 993 //
     /*  24790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24809 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24812 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24828 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24839 */     GIR_RootConstrainSelectedInstOperands,
     /*  24840 */     // GIR_Coverage, 993,
     /*  24840 */     GIR_EraseRootFromParent_Done,
     /*  24841 */   // Label 407: @24841
     /*  24841 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24897), // Rule ID 1054 //
     /*  24846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24865 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24868 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24884 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24895 */     GIR_RootConstrainSelectedInstOperands,
     /*  24896 */     // GIR_Coverage, 1054,
     /*  24896 */     GIR_EraseRootFromParent_Done,
     /*  24897 */   // Label 408: @24897
     /*  24897 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24964), // Rule ID 2238 //
     /*  24902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24930 */     // MIs[1] imm
     /*  24930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24942 */     // MIs[2] Operand 1
     /*  24942 */     // No operand predicates
     /*  24942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24948 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24962 */     GIR_RootConstrainSelectedInstOperands,
     /*  24963 */     // GIR_Coverage, 2238,
     /*  24963 */     GIR_EraseRootFromParent_Done,
     /*  24964 */   // Label 409: @24964
     /*  24964 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25031), // Rule ID 2297 //
     /*  24969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24997 */     // MIs[1] imm
     /*  24997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  25009 */     // MIs[2] Operand 1
     /*  25009 */     // No operand predicates
     /*  25009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  25013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25015 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  25015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  25018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  25029 */     GIR_RootConstrainSelectedInstOperands,
     /*  25030 */     // GIR_Coverage, 2297,
     /*  25030 */     GIR_EraseRootFromParent_Done,
     /*  25031 */   // Label 410: @25031
     /*  25031 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25079), // Rule ID 13559 //
     /*  25036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25066 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25077 */     GIR_RootConstrainSelectedInstOperands,
     /*  25078 */     // GIR_Coverage, 13559,
     /*  25078 */     GIR_EraseRootFromParent_Done,
     /*  25079 */   // Label 411: @25079
     /*  25079 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25127), // Rule ID 13571 //
     /*  25084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25114 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25125 */     GIR_RootConstrainSelectedInstOperands,
     /*  25126 */     // GIR_Coverage, 13571,
     /*  25126 */     GIR_EraseRootFromParent_Done,
     /*  25127 */   // Label 412: @25127
     /*  25127 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25175), // Rule ID 992 //
     /*  25132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25162 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25173 */     GIR_RootConstrainSelectedInstOperands,
     /*  25174 */     // GIR_Coverage, 992,
     /*  25174 */     GIR_EraseRootFromParent_Done,
     /*  25175 */   // Label 413: @25175
     /*  25175 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25223), // Rule ID 1053 //
     /*  25180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25210 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25221 */     GIR_RootConstrainSelectedInstOperands,
     /*  25222 */     // GIR_Coverage, 1053,
     /*  25222 */     GIR_EraseRootFromParent_Done,
     /*  25223 */   // Label 414: @25223
     /*  25223 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25250), // Rule ID 1106 //
     /*  25228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25243 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  25248 */     GIR_RootConstrainSelectedInstOperands,
     /*  25249 */     // GIR_Coverage, 1106,
     /*  25249 */     GIR_Done,
     /*  25250 */   // Label 415: @25250
     /*  25250 */   GIM_Reject,
     /*  25251 */ // Label 381: @25251
     /*  25251 */ GIM_Reject,
     /*  25252 */ // Label 161: @25252
     /*  25252 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(31429),
     /*  25257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25263 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25381), // Rule ID 13736 //
     /*  25268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25311 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25315 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25319 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25332 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25336 */     // MIs[4] Operand 1
     /*  25336 */     // No operand predicates
     /*  25336 */     // MIs[2] Operand 2
     /*  25336 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25360 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25379 */     GIR_RootConstrainSelectedInstOperands,
     /*  25380 */     // GIR_Coverage, 13736,
     /*  25380 */     GIR_EraseRootFromParent_Done,
     /*  25381 */   // Label 417: @25381
     /*  25381 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25499), // Rule ID 13737 //
     /*  25386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25450 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25454 */     // MIs[4] Operand 1
     /*  25454 */     // No operand predicates
     /*  25454 */     // MIs[2] Operand 2
     /*  25454 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25478 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25497 */     GIR_RootConstrainSelectedInstOperands,
     /*  25498 */     // GIR_Coverage, 13737,
     /*  25498 */     GIR_EraseRootFromParent_Done,
     /*  25499 */   // Label 418: @25499
     /*  25499 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25617), // Rule ID 13772 //
     /*  25504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25568 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25572 */     // MIs[4] Operand 1
     /*  25572 */     // No operand predicates
     /*  25572 */     // MIs[2] Operand 2
     /*  25572 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25596 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25615 */     GIR_RootConstrainSelectedInstOperands,
     /*  25616 */     // GIR_Coverage, 13772,
     /*  25616 */     GIR_EraseRootFromParent_Done,
     /*  25617 */   // Label 419: @25617
     /*  25617 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25735), // Rule ID 13773 //
     /*  25622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25690 */     // MIs[4] Operand 1
     /*  25690 */     // No operand predicates
     /*  25690 */     // MIs[2] Operand 2
     /*  25690 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25705 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25714 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25733 */     GIR_RootConstrainSelectedInstOperands,
     /*  25734 */     // GIR_Coverage, 13773,
     /*  25734 */     GIR_EraseRootFromParent_Done,
     /*  25735 */   // Label 420: @25735
     /*  25735 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25853), // Rule ID 2043 //
     /*  25740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25804 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25808 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25812 */     // MIs[4] Operand 1
     /*  25812 */     // No operand predicates
     /*  25812 */     // MIs[2] Operand 2
     /*  25812 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25823 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25832 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25851 */     GIR_RootConstrainSelectedInstOperands,
     /*  25852 */     // GIR_Coverage, 2043,
     /*  25852 */     GIR_EraseRootFromParent_Done,
     /*  25853 */   // Label 421: @25853
     /*  25853 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25971), // Rule ID 13735 //
     /*  25858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25905 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25909 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25913 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25918 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25922 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25926 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25930 */     // MIs[4] Operand 1
     /*  25930 */     // No operand predicates
     /*  25930 */     // MIs[2] Operand 2
     /*  25930 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25950 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25969 */     GIR_RootConstrainSelectedInstOperands,
     /*  25970 */     // GIR_Coverage, 13735,
     /*  25970 */     GIR_EraseRootFromParent_Done,
     /*  25971 */   // Label 422: @25971
     /*  25971 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26089), // Rule ID 2095 //
     /*  25976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26031 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26040 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26044 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26048 */     // MIs[4] Operand 1
     /*  26048 */     // No operand predicates
     /*  26048 */     // MIs[2] Operand 2
     /*  26048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26059 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26068 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26087 */     GIR_RootConstrainSelectedInstOperands,
     /*  26088 */     // GIR_Coverage, 2095,
     /*  26088 */     GIR_EraseRootFromParent_Done,
     /*  26089 */   // Label 423: @26089
     /*  26089 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26207), // Rule ID 13771 //
     /*  26094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26145 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26162 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26166 */     // MIs[4] Operand 1
     /*  26166 */     // No operand predicates
     /*  26166 */     // MIs[2] Operand 2
     /*  26166 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26177 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26186 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26205 */     GIR_RootConstrainSelectedInstOperands,
     /*  26206 */     // GIR_Coverage, 13771,
     /*  26206 */     GIR_EraseRootFromParent_Done,
     /*  26207 */   // Label 424: @26207
     /*  26207 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26294), // Rule ID 13642 //
     /*  26212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26239 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26242 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26251 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26275 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26292 */     GIR_RootConstrainSelectedInstOperands,
     /*  26293 */     // GIR_Coverage, 13642,
     /*  26293 */     GIR_EraseRootFromParent_Done,
     /*  26294 */   // Label 425: @26294
     /*  26294 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26381), // Rule ID 13670 //
     /*  26299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26326 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26329 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26338 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26362 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26379 */     GIR_RootConstrainSelectedInstOperands,
     /*  26380 */     // GIR_Coverage, 13670,
     /*  26380 */     GIR_EraseRootFromParent_Done,
     /*  26381 */   // Label 426: @26381
     /*  26381 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26468), // Rule ID 1699 //
     /*  26386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26417 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26420 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26429 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26449 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26466 */     GIR_RootConstrainSelectedInstOperands,
     /*  26467 */     // GIR_Coverage, 1699,
     /*  26467 */     GIR_EraseRootFromParent_Done,
     /*  26468 */   // Label 427: @26468
     /*  26468 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26555), // Rule ID 1777 //
     /*  26473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26504 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26507 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26516 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26536 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26553 */     GIR_RootConstrainSelectedInstOperands,
     /*  26554 */     // GIR_Coverage, 1777,
     /*  26554 */     GIR_EraseRootFromParent_Done,
     /*  26555 */   // Label 428: @26555
     /*  26555 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26670), // Rule ID 13731 //
     /*  26560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26628 */     // MIs[4] Operand 1
     /*  26628 */     // No operand predicates
     /*  26628 */     // MIs[2] Operand 2
     /*  26628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26648 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26650 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26668 */     GIR_RootConstrainSelectedInstOperands,
     /*  26669 */     // GIR_Coverage, 13731,
     /*  26669 */     GIR_EraseRootFromParent_Done,
     /*  26670 */   // Label 429: @26670
     /*  26670 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26785), // Rule ID 13730 //
     /*  26675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26727 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26731 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26744 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26748 */     // MIs[4] Operand 1
     /*  26748 */     // No operand predicates
     /*  26748 */     // MIs[2] Operand 2
     /*  26748 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26763 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26765 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26783 */     GIR_RootConstrainSelectedInstOperands,
     /*  26784 */     // GIR_Coverage, 13730,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 430: @26785
     /*  26785 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26900), // Rule ID 13767 //
     /*  26790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26833 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26837 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26841 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26854 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26858 */     // MIs[4] Operand 1
     /*  26858 */     // No operand predicates
     /*  26858 */     // MIs[2] Operand 2
     /*  26858 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26880 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26898 */     GIR_RootConstrainSelectedInstOperands,
     /*  26899 */     // GIR_Coverage, 13767,
     /*  26899 */     GIR_EraseRootFromParent_Done,
     /*  26900 */   // Label 431: @26900
     /*  26900 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(27015), // Rule ID 13766 //
     /*  26905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26957 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26961 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26974 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26978 */     // MIs[4] Operand 1
     /*  26978 */     // No operand predicates
     /*  26978 */     // MIs[2] Operand 2
     /*  26978 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26993 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26995 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27013 */     GIR_RootConstrainSelectedInstOperands,
     /*  27014 */     // GIR_Coverage, 13766,
     /*  27014 */     GIR_EraseRootFromParent_Done,
     /*  27015 */   // Label 432: @27015
     /*  27015 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27084), // Rule ID 1797 //
     /*  27020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27067 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27082 */     GIR_RootConstrainSelectedInstOperands,
     /*  27083 */     // GIR_Coverage, 1797,
     /*  27083 */     GIR_EraseRootFromParent_Done,
     /*  27084 */   // Label 433: @27084
     /*  27084 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27153), // Rule ID 1796 //
     /*  27089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27151 */     GIR_RootConstrainSelectedInstOperands,
     /*  27152 */     // GIR_Coverage, 1796,
     /*  27152 */     GIR_EraseRootFromParent_Done,
     /*  27153 */   // Label 434: @27153
     /*  27153 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27222), // Rule ID 1719 //
     /*  27158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27205 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  27208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27220 */     GIR_RootConstrainSelectedInstOperands,
     /*  27221 */     // GIR_Coverage, 1719,
     /*  27221 */     GIR_EraseRootFromParent_Done,
     /*  27222 */   // Label 435: @27222
     /*  27222 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27291), // Rule ID 1795 //
     /*  27227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27274 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27289 */     GIR_RootConstrainSelectedInstOperands,
     /*  27290 */     // GIR_Coverage, 1795,
     /*  27290 */     GIR_EraseRootFromParent_Done,
     /*  27291 */   // Label 436: @27291
     /*  27291 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27360), // Rule ID 1794 //
     /*  27296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27343 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27358 */     GIR_RootConstrainSelectedInstOperands,
     /*  27359 */     // GIR_Coverage, 1794,
     /*  27359 */     GIR_EraseRootFromParent_Done,
     /*  27360 */   // Label 437: @27360
     /*  27360 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27475), // Rule ID 13729 //
     /*  27365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27420 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27433 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27437 */     // MIs[4] Operand 1
     /*  27437 */     // No operand predicates
     /*  27437 */     // MIs[2] Operand 2
     /*  27437 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27473 */     GIR_RootConstrainSelectedInstOperands,
     /*  27474 */     // GIR_Coverage, 13729,
     /*  27474 */     GIR_EraseRootFromParent_Done,
     /*  27475 */   // Label 438: @27475
     /*  27475 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27590), // Rule ID 2041 //
     /*  27480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27557 */     // MIs[4] Operand 1
     /*  27557 */     // No operand predicates
     /*  27557 */     // MIs[2] Operand 2
     /*  27557 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27570 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27588 */     GIR_RootConstrainSelectedInstOperands,
     /*  27589 */     // GIR_Coverage, 2041,
     /*  27589 */     GIR_EraseRootFromParent_Done,
     /*  27590 */   // Label 439: @27590
     /*  27590 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27705), // Rule ID 13765 //
     /*  27595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27650 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27655 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27659 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27663 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27667 */     // MIs[4] Operand 1
     /*  27667 */     // No operand predicates
     /*  27667 */     // MIs[2] Operand 2
     /*  27667 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27683 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27685 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27703 */     GIR_RootConstrainSelectedInstOperands,
     /*  27704 */     // GIR_Coverage, 13765,
     /*  27704 */     GIR_EraseRootFromParent_Done,
     /*  27705 */   // Label 440: @27705
     /*  27705 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27820), // Rule ID 2093 //
     /*  27710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27770 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27775 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27779 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27783 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27787 */     // MIs[4] Operand 1
     /*  27787 */     // No operand predicates
     /*  27787 */     // MIs[2] Operand 2
     /*  27787 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27798 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27800 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27818 */     GIR_RootConstrainSelectedInstOperands,
     /*  27819 */     // GIR_Coverage, 2093,
     /*  27819 */     GIR_EraseRootFromParent_Done,
     /*  27820 */   // Label 441: @27820
     /*  27820 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27887), // Rule ID 13656 //
     /*  27825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27868 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27885 */     GIR_RootConstrainSelectedInstOperands,
     /*  27886 */     // GIR_Coverage, 13656,
     /*  27886 */     GIR_EraseRootFromParent_Done,
     /*  27887 */   // Label 442: @27887
     /*  27887 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27954), // Rule ID 13690 //
     /*  27892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27935 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27952 */     GIR_RootConstrainSelectedInstOperands,
     /*  27953 */     // GIR_Coverage, 13690,
     /*  27953 */     GIR_EraseRootFromParent_Done,
     /*  27954 */   // Label 443: @27954
     /*  27954 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28021), // Rule ID 1731 //
     /*  27959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28002 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  28005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  28014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28019 */     GIR_RootConstrainSelectedInstOperands,
     /*  28020 */     // GIR_Coverage, 1731,
     /*  28020 */     GIR_EraseRootFromParent_Done,
     /*  28021 */   // Label 444: @28021
     /*  28021 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28088), // Rule ID 1821 //
     /*  28026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28069 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  28072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  28081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28086 */     GIR_RootConstrainSelectedInstOperands,
     /*  28087 */     // GIR_Coverage, 1821,
     /*  28087 */     GIR_EraseRootFromParent_Done,
     /*  28088 */   // Label 445: @28088
     /*  28088 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28169), // Rule ID 13640 //
     /*  28093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28120 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28123 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28132 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28152 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28167 */     GIR_RootConstrainSelectedInstOperands,
     /*  28168 */     // GIR_Coverage, 13640,
     /*  28168 */     GIR_EraseRootFromParent_Done,
     /*  28169 */   // Label 446: @28169
     /*  28169 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28250), // Rule ID 13668 //
     /*  28174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28201 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28204 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28213 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28233 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28248 */     GIR_RootConstrainSelectedInstOperands,
     /*  28249 */     // GIR_Coverage, 13668,
     /*  28249 */     GIR_EraseRootFromParent_Done,
     /*  28250 */   // Label 447: @28250
     /*  28250 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28331), // Rule ID 1697 //
     /*  28255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28286 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28289 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28298 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28314 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28329 */     GIR_RootConstrainSelectedInstOperands,
     /*  28330 */     // GIR_Coverage, 1697,
     /*  28330 */     GIR_EraseRootFromParent_Done,
     /*  28331 */   // Label 448: @28331
     /*  28331 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28412), // Rule ID 1775 //
     /*  28336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28367 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28370 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28379 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28395 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28410 */     GIR_RootConstrainSelectedInstOperands,
     /*  28411 */     // GIR_Coverage, 1775,
     /*  28411 */     GIR_EraseRootFromParent_Done,
     /*  28412 */   // Label 449: @28412
     /*  28412 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28504), // Rule ID 13734 //
     /*  28417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28473 */     // MIs[3] Operand 1
     /*  28473 */     // No operand predicates
     /*  28473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28484 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28502 */     GIR_RootConstrainSelectedInstOperands,
     /*  28503 */     // GIR_Coverage, 13734,
     /*  28503 */     GIR_EraseRootFromParent_Done,
     /*  28504 */   // Label 450: @28504
     /*  28504 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28596), // Rule ID 13733 //
     /*  28509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28570 */     // MIs[3] Operand 1
     /*  28570 */     // No operand predicates
     /*  28570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28576 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28594 */     GIR_RootConstrainSelectedInstOperands,
     /*  28595 */     // GIR_Coverage, 13733,
     /*  28595 */     GIR_EraseRootFromParent_Done,
     /*  28596 */   // Label 451: @28596
     /*  28596 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28688), // Rule ID 13770 //
     /*  28601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28657 */     // MIs[3] Operand 1
     /*  28657 */     // No operand predicates
     /*  28657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28668 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28686 */     GIR_RootConstrainSelectedInstOperands,
     /*  28687 */     // GIR_Coverage, 13770,
     /*  28687 */     GIR_EraseRootFromParent_Done,
     /*  28688 */   // Label 452: @28688
     /*  28688 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28780), // Rule ID 13769 //
     /*  28693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28750 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28754 */     // MIs[3] Operand 1
     /*  28754 */     // No operand predicates
     /*  28754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28760 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28778 */     GIR_RootConstrainSelectedInstOperands,
     /*  28779 */     // GIR_Coverage, 13769,
     /*  28779 */     GIR_EraseRootFromParent_Done,
     /*  28780 */   // Label 453: @28780
     /*  28780 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28872), // Rule ID 13732 //
     /*  28785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28845 */     // MIs[3] Operand 1
     /*  28845 */     // No operand predicates
     /*  28845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28852 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28870 */     GIR_RootConstrainSelectedInstOperands,
     /*  28871 */     // GIR_Coverage, 13732,
     /*  28871 */     GIR_EraseRootFromParent_Done,
     /*  28872 */   // Label 454: @28872
     /*  28872 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28964), // Rule ID 2042 //
     /*  28877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28942 */     // MIs[3] Operand 1
     /*  28942 */     // No operand predicates
     /*  28942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28944 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 2042,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 455: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(29056), // Rule ID 13768 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  29004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  29012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29029 */     // MIs[3] Operand 1
     /*  29029 */     // No operand predicates
     /*  29029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29036 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29054 */     GIR_RootConstrainSelectedInstOperands,
     /*  29055 */     // GIR_Coverage, 13768,
     /*  29055 */     GIR_EraseRootFromParent_Done,
     /*  29056 */   // Label 456: @29056
     /*  29056 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29148), // Rule ID 2094 //
     /*  29061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  29080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  29088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  29101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  29109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29126 */     // MIs[3] Operand 1
     /*  29126 */     // No operand predicates
     /*  29126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29128 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29146 */     GIR_RootConstrainSelectedInstOperands,
     /*  29147 */     // GIR_Coverage, 2094,
     /*  29147 */     GIR_EraseRootFromParent_Done,
     /*  29148 */   // Label 457: @29148
     /*  29148 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29199), // Rule ID 13682 //
     /*  29153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29185 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29197 */     GIR_RootConstrainSelectedInstOperands,
     /*  29198 */     // GIR_Coverage, 13682,
     /*  29198 */     GIR_EraseRootFromParent_Done,
     /*  29199 */   // Label 458: @29199
     /*  29199 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29250), // Rule ID 13650 //
     /*  29204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29236 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29248 */     GIR_RootConstrainSelectedInstOperands,
     /*  29249 */     // GIR_Coverage, 13650,
     /*  29249 */     GIR_EraseRootFromParent_Done,
     /*  29250 */   // Label 459: @29250
     /*  29250 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29301), // Rule ID 13681 //
     /*  29255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29287 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29299 */     GIR_RootConstrainSelectedInstOperands,
     /*  29300 */     // GIR_Coverage, 13681,
     /*  29300 */     GIR_EraseRootFromParent_Done,
     /*  29301 */   // Label 460: @29301
     /*  29301 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29352), // Rule ID 1813 //
     /*  29306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29338 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29350 */     GIR_RootConstrainSelectedInstOperands,
     /*  29351 */     // GIR_Coverage, 1813,
     /*  29351 */     GIR_EraseRootFromParent_Done,
     /*  29352 */   // Label 461: @29352
     /*  29352 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29403), // Rule ID 1725 //
     /*  29357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29389 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29401 */     GIR_RootConstrainSelectedInstOperands,
     /*  29402 */     // GIR_Coverage, 1725,
     /*  29402 */     GIR_EraseRootFromParent_Done,
     /*  29403 */   // Label 462: @29403
     /*  29403 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29454), // Rule ID 1812 //
     /*  29408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29452 */     GIR_RootConstrainSelectedInstOperands,
     /*  29453 */     // GIR_Coverage, 1812,
     /*  29453 */     GIR_EraseRootFromParent_Done,
     /*  29454 */   // Label 463: @29454
     /*  29454 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29523), // Rule ID 13604 //
     /*  29459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29474 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29477 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29486 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29506 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29521 */     GIR_RootConstrainSelectedInstOperands,
     /*  29522 */     // GIR_Coverage, 13604,
     /*  29522 */     GIR_EraseRootFromParent_Done,
     /*  29523 */   // Label 464: @29523
     /*  29523 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29592), // Rule ID 13616 //
     /*  29528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29543 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29546 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29575 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29590 */     GIR_RootConstrainSelectedInstOperands,
     /*  29591 */     // GIR_Coverage, 13616,
     /*  29591 */     GIR_EraseRootFromParent_Done,
     /*  29592 */   // Label 465: @29592
     /*  29592 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29648), // Rule ID 13566 //
     /*  29597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29612 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29615 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29635 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29646 */     GIR_RootConstrainSelectedInstOperands,
     /*  29647 */     // GIR_Coverage, 13566,
     /*  29647 */     GIR_EraseRootFromParent_Done,
     /*  29648 */   // Label 466: @29648
     /*  29648 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29704), // Rule ID 13578 //
     /*  29653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29668 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29671 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29691 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29702 */     GIR_RootConstrainSelectedInstOperands,
     /*  29703 */     // GIR_Coverage, 13578,
     /*  29703 */     GIR_EraseRootFromParent_Done,
     /*  29704 */   // Label 467: @29704
     /*  29704 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29771), // Rule ID 13818 //
     /*  29709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29733 */     // MIs[1] imm
     /*  29733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29741 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29745 */     // MIs[2] Operand 1
     /*  29745 */     // No operand predicates
     /*  29745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29755 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29769 */     GIR_RootConstrainSelectedInstOperands,
     /*  29770 */     // GIR_Coverage, 13818,
     /*  29770 */     GIR_EraseRootFromParent_Done,
     /*  29771 */   // Label 468: @29771
     /*  29771 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29838), // Rule ID 13839 //
     /*  29776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29800 */     // MIs[1] imm
     /*  29800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29812 */     // MIs[2] Operand 1
     /*  29812 */     // No operand predicates
     /*  29812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29822 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29836 */     GIR_RootConstrainSelectedInstOperands,
     /*  29837 */     // GIR_Coverage, 13839,
     /*  29837 */     GIR_EraseRootFromParent_Done,
     /*  29838 */   // Label 469: @29838
     /*  29838 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29907), // Rule ID 1371 //
     /*  29843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29862 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29865 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29874 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29890 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29905 */     GIR_RootConstrainSelectedInstOperands,
     /*  29906 */     // GIR_Coverage, 1371,
     /*  29906 */     GIR_EraseRootFromParent_Done,
     /*  29907 */   // Label 470: @29907
     /*  29907 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29976), // Rule ID 1494 //
     /*  29912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29959 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29974 */     GIR_RootConstrainSelectedInstOperands,
     /*  29975 */     // GIR_Coverage, 1494,
     /*  29975 */     GIR_EraseRootFromParent_Done,
     /*  29976 */   // Label 471: @29976
     /*  29976 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(30032), // Rule ID 999 //
     /*  29981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30000 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  30003 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  30008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30019 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30030 */     GIR_RootConstrainSelectedInstOperands,
     /*  30031 */     // GIR_Coverage, 999,
     /*  30031 */     GIR_EraseRootFromParent_Done,
     /*  30032 */   // Label 472: @30032
     /*  30032 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30088), // Rule ID 1060 //
     /*  30037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  30059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  30064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30075 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30086 */     GIR_RootConstrainSelectedInstOperands,
     /*  30087 */     // GIR_Coverage, 1060,
     /*  30087 */     GIR_EraseRootFromParent_Done,
     /*  30088 */   // Label 473: @30088
     /*  30088 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30155), // Rule ID 2244 //
     /*  30093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  30112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30121 */     // MIs[1] imm
     /*  30121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30129 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30133 */     // MIs[2] Operand 1
     /*  30133 */     // No operand predicates
     /*  30133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30139 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  30142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30153 */     GIR_RootConstrainSelectedInstOperands,
     /*  30154 */     // GIR_Coverage, 2244,
     /*  30154 */     GIR_EraseRootFromParent_Done,
     /*  30155 */   // Label 474: @30155
     /*  30155 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30222), // Rule ID 2303 //
     /*  30160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  30179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30188 */     // MIs[1] imm
     /*  30188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30196 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30200 */     // MIs[2] Operand 1
     /*  30200 */     // No operand predicates
     /*  30200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30206 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30220 */     GIR_RootConstrainSelectedInstOperands,
     /*  30221 */     // GIR_Coverage, 2303,
     /*  30221 */     GIR_EraseRootFromParent_Done,
     /*  30222 */   // Label 475: @30222
     /*  30222 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30292), // Rule ID 7007 //
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30265 */     // MIs[2] Rn
     /*  30265 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30270 */     // MIs[2] Rm
     /*  30270 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30277 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30290 */     GIR_RootConstrainSelectedInstOperands,
     /*  30291 */     // GIR_Coverage, 7007,
     /*  30291 */     GIR_EraseRootFromParent_Done,
     /*  30292 */   // Label 476: @30292
     /*  30292 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30362), // Rule ID 14205 //
     /*  30297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  30309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  30335 */     // MIs[2] Rn
     /*  30335 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30340 */     // MIs[2] Rm
     /*  30340 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30347 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30360 */     GIR_RootConstrainSelectedInstOperands,
     /*  30361 */     // GIR_Coverage, 14205,
     /*  30361 */     GIR_EraseRootFromParent_Done,
     /*  30362 */   // Label 477: @30362
     /*  30362 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30425), // Rule ID 1793 //
     /*  30367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30410 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30423 */     GIR_RootConstrainSelectedInstOperands,
     /*  30424 */     // GIR_Coverage, 1793,
     /*  30424 */     GIR_EraseRootFromParent_Done,
     /*  30425 */   // Label 478: @30425
     /*  30425 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30488), // Rule ID 1792 //
     /*  30430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30473 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30486 */     GIR_RootConstrainSelectedInstOperands,
     /*  30487 */     // GIR_Coverage, 1792,
     /*  30487 */     GIR_EraseRootFromParent_Done,
     /*  30488 */   // Label 479: @30488
     /*  30488 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30551), // Rule ID 1718 //
     /*  30493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30536 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30549 */     GIR_RootConstrainSelectedInstOperands,
     /*  30550 */     // GIR_Coverage, 1718,
     /*  30550 */     GIR_EraseRootFromParent_Done,
     /*  30551 */   // Label 480: @30551
     /*  30551 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30614), // Rule ID 1791 //
     /*  30556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30599 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30612 */     GIR_RootConstrainSelectedInstOperands,
     /*  30613 */     // GIR_Coverage, 1791,
     /*  30613 */     GIR_EraseRootFromParent_Done,
     /*  30614 */   // Label 481: @30614
     /*  30614 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30677), // Rule ID 1790 //
     /*  30619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30662 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1790,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 482: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30738), // Rule ID 13655 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30721 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30736 */     GIR_RootConstrainSelectedInstOperands,
     /*  30737 */     // GIR_Coverage, 13655,
     /*  30737 */     GIR_EraseRootFromParent_Done,
     /*  30738 */   // Label 483: @30738
     /*  30738 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30799), // Rule ID 13689 //
     /*  30743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30782 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30797 */     GIR_RootConstrainSelectedInstOperands,
     /*  30798 */     // GIR_Coverage, 13689,
     /*  30798 */     GIR_EraseRootFromParent_Done,
     /*  30799 */   // Label 484: @30799
     /*  30799 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30847), // Rule ID 13680 //
     /*  30804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30834 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30845 */     GIR_RootConstrainSelectedInstOperands,
     /*  30846 */     // GIR_Coverage, 13680,
     /*  30846 */     GIR_EraseRootFromParent_Done,
     /*  30847 */   // Label 485: @30847
     /*  30847 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30895), // Rule ID 13565 //
     /*  30852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30882 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30893 */     GIR_RootConstrainSelectedInstOperands,
     /*  30894 */     // GIR_Coverage, 13565,
     /*  30894 */     GIR_EraseRootFromParent_Done,
     /*  30895 */   // Label 486: @30895
     /*  30895 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30943), // Rule ID 13649 //
     /*  30900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30930 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30941 */     GIR_RootConstrainSelectedInstOperands,
     /*  30942 */     // GIR_Coverage, 13649,
     /*  30942 */     GIR_EraseRootFromParent_Done,
     /*  30943 */   // Label 487: @30943
     /*  30943 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30991), // Rule ID 13577 //
     /*  30948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30978 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30989 */     GIR_RootConstrainSelectedInstOperands,
     /*  30990 */     // GIR_Coverage, 13577,
     /*  30990 */     GIR_EraseRootFromParent_Done,
     /*  30991 */   // Label 488: @30991
     /*  30991 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31039), // Rule ID 13679 //
     /*  30996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31026 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31037 */     GIR_RootConstrainSelectedInstOperands,
     /*  31038 */     // GIR_Coverage, 13679,
     /*  31038 */     GIR_EraseRootFromParent_Done,
     /*  31039 */   // Label 489: @31039
     /*  31039 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(31100), // Rule ID 1730 //
     /*  31044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  31063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31083 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  31086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31098 */     GIR_RootConstrainSelectedInstOperands,
     /*  31099 */     // GIR_Coverage, 1730,
     /*  31099 */     GIR_EraseRootFromParent_Done,
     /*  31100 */   // Label 490: @31100
     /*  31100 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31161), // Rule ID 1820 //
     /*  31105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  31124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31144 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  31147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31159 */     GIR_RootConstrainSelectedInstOperands,
     /*  31160 */     // GIR_Coverage, 1820,
     /*  31160 */     GIR_EraseRootFromParent_Done,
     /*  31161 */   // Label 491: @31161
     /*  31161 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31209), // Rule ID 1811 //
     /*  31166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31196 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31207 */     GIR_RootConstrainSelectedInstOperands,
     /*  31208 */     // GIR_Coverage, 1811,
     /*  31208 */     GIR_EraseRootFromParent_Done,
     /*  31209 */   // Label 492: @31209
     /*  31209 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31257), // Rule ID 998 //
     /*  31214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  31233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31244 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  31247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31255 */     GIR_RootConstrainSelectedInstOperands,
     /*  31256 */     // GIR_Coverage, 998,
     /*  31256 */     GIR_EraseRootFromParent_Done,
     /*  31257 */   // Label 493: @31257
     /*  31257 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31305), // Rule ID 1724 //
     /*  31262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31292 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  31295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31303 */     GIR_RootConstrainSelectedInstOperands,
     /*  31304 */     // GIR_Coverage, 1724,
     /*  31304 */     GIR_EraseRootFromParent_Done,
     /*  31305 */   // Label 494: @31305
     /*  31305 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31353), // Rule ID 1059 //
     /*  31310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  31329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31340 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  31343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31351 */     GIR_RootConstrainSelectedInstOperands,
     /*  31352 */     // GIR_Coverage, 1059,
     /*  31352 */     GIR_EraseRootFromParent_Done,
     /*  31353 */   // Label 495: @31353
     /*  31353 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31401), // Rule ID 1810 //
     /*  31358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31388 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31399 */     GIR_RootConstrainSelectedInstOperands,
     /*  31400 */     // GIR_Coverage, 1810,
     /*  31400 */     GIR_EraseRootFromParent_Done,
     /*  31401 */   // Label 496: @31401
     /*  31401 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31428), // Rule ID 1109 //
     /*  31406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31421 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31426 */     GIR_RootConstrainSelectedInstOperands,
     /*  31427 */     // GIR_Coverage, 1109,
     /*  31427 */     GIR_Done,
     /*  31428 */   // Label 497: @31428
     /*  31428 */   GIM_Reject,
     /*  31429 */ // Label 416: @31429
     /*  31429 */ GIM_Reject,
     /*  31430 */ // Label 162: @31430
     /*  31430 */ GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(32279),
     /*  31435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31441 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31574), // Rule ID 14210 //
     /*  31446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31491 */     // MIs[1] Operand 2
     /*  31491 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31510 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31514 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31518 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31522 */     // MIs[5] Rn
     /*  31522 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31527 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31529 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31556 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31573 */     // GIR_Coverage, 14210,
     /*  31573 */     GIR_EraseRootFromParent_Done,
     /*  31574 */   // Label 499: @31574
     /*  31574 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31707), // Rule ID 7012 //
     /*  31579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31628 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31632 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31636 */     // MIs[4] Rn
     /*  31636 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31641 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31645 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31649 */     // MIs[3] Operand 2
     /*  31649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31660 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31662 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31706 */     // GIR_Coverage, 7012,
     /*  31706 */     GIR_EraseRootFromParent_Done,
     /*  31707 */   // Label 500: @31707
     /*  31707 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31776), // Rule ID 13594 //
     /*  31712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31727 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31730 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31759 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31774 */     GIR_RootConstrainSelectedInstOperands,
     /*  31775 */     // GIR_Coverage, 13594,
     /*  31775 */     GIR_EraseRootFromParent_Done,
     /*  31776 */   // Label 501: @31776
     /*  31776 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31845), // Rule ID 13606 //
     /*  31781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31796 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31799 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31808 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31828 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31843 */     GIR_RootConstrainSelectedInstOperands,
     /*  31844 */     // GIR_Coverage, 13606,
     /*  31844 */     GIR_EraseRootFromParent_Done,
     /*  31845 */   // Label 502: @31845
     /*  31845 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31912), // Rule ID 13808 //
     /*  31850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31874 */     // MIs[1] imm
     /*  31874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31886 */     // MIs[2] Operand 1
     /*  31886 */     // No operand predicates
     /*  31886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31896 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31910 */     GIR_RootConstrainSelectedInstOperands,
     /*  31911 */     // GIR_Coverage, 13808,
     /*  31911 */     GIR_EraseRootFromParent_Done,
     /*  31912 */   // Label 503: @31912
     /*  31912 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31979), // Rule ID 13829 //
     /*  31917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31941 */     // MIs[1] imm
     /*  31941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31953 */     // MIs[2] Operand 1
     /*  31953 */     // No operand predicates
     /*  31953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31963 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31977 */     GIR_RootConstrainSelectedInstOperands,
     /*  31978 */     // GIR_Coverage, 13829,
     /*  31978 */     GIR_EraseRootFromParent_Done,
     /*  31979 */   // Label 504: @31979
     /*  31979 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(32048), // Rule ID 1361 //
     /*  31984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32003 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32006 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32031 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  32034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32046 */     GIR_RootConstrainSelectedInstOperands,
     /*  32047 */     // GIR_Coverage, 1361,
     /*  32047 */     GIR_EraseRootFromParent_Done,
     /*  32048 */   // Label 505: @32048
     /*  32048 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32117), // Rule ID 1484 //
     /*  32053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32072 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32075 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32100 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  32103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32115 */     GIR_RootConstrainSelectedInstOperands,
     /*  32116 */     // GIR_Coverage, 1484,
     /*  32116 */     GIR_EraseRootFromParent_Done,
     /*  32117 */   // Label 506: @32117
     /*  32117 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32184), // Rule ID 2234 //
     /*  32122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32150 */     // MIs[1] imm
     /*  32150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32162 */     // MIs[2] Operand 1
     /*  32162 */     // No operand predicates
     /*  32162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32168 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  32171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32182 */     GIR_RootConstrainSelectedInstOperands,
     /*  32183 */     // GIR_Coverage, 2234,
     /*  32183 */     GIR_EraseRootFromParent_Done,
     /*  32184 */   // Label 507: @32184
     /*  32184 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32251), // Rule ID 2293 //
     /*  32189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32217 */     // MIs[1] imm
     /*  32217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32229 */     // MIs[2] Operand 1
     /*  32229 */     // No operand predicates
     /*  32229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32235 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  32238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32249 */     GIR_RootConstrainSelectedInstOperands,
     /*  32250 */     // GIR_Coverage, 2293,
     /*  32250 */     GIR_EraseRootFromParent_Done,
     /*  32251 */   // Label 508: @32251
     /*  32251 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32278), // Rule ID 1104 //
     /*  32256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32271 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  32276 */     GIR_RootConstrainSelectedInstOperands,
     /*  32277 */     // GIR_Coverage, 1104,
     /*  32277 */     GIR_Done,
     /*  32278 */   // Label 509: @32278
     /*  32278 */   GIM_Reject,
     /*  32279 */ // Label 498: @32279
     /*  32279 */ GIM_Reject,
     /*  32280 */ // Label 163: @32280
     /*  32280 */ GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(35857),
     /*  32285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32291 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32378), // Rule ID 13638 //
     /*  32296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32323 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32326 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32335 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32359 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32376 */     GIR_RootConstrainSelectedInstOperands,
     /*  32377 */     // GIR_Coverage, 13638,
     /*  32377 */     GIR_EraseRootFromParent_Done,
     /*  32378 */   // Label 511: @32378
     /*  32378 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32465), // Rule ID 13666 //
     /*  32383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32410 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32413 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32422 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32446 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32463 */     GIR_RootConstrainSelectedInstOperands,
     /*  32464 */     // GIR_Coverage, 13666,
     /*  32464 */     GIR_EraseRootFromParent_Done,
     /*  32465 */   // Label 512: @32465
     /*  32465 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32552), // Rule ID 1695 //
     /*  32470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32501 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32504 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32513 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32533 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32550 */     GIR_RootConstrainSelectedInstOperands,
     /*  32551 */     // GIR_Coverage, 1695,
     /*  32551 */     GIR_EraseRootFromParent_Done,
     /*  32552 */   // Label 513: @32552
     /*  32552 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32639), // Rule ID 1773 //
     /*  32557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32588 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32591 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32600 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32620 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32637 */     GIR_RootConstrainSelectedInstOperands,
     /*  32638 */     // GIR_Coverage, 1773,
     /*  32638 */     GIR_EraseRootFromParent_Done,
     /*  32639 */   // Label 514: @32639
     /*  32639 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32708), // Rule ID 1789 //
     /*  32644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32691 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32706 */     GIR_RootConstrainSelectedInstOperands,
     /*  32707 */     // GIR_Coverage, 1789,
     /*  32707 */     GIR_EraseRootFromParent_Done,
     /*  32708 */   // Label 515: @32708
     /*  32708 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32777), // Rule ID 1788 //
     /*  32713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32760 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32775 */     GIR_RootConstrainSelectedInstOperands,
     /*  32776 */     // GIR_Coverage, 1788,
     /*  32776 */     GIR_EraseRootFromParent_Done,
     /*  32777 */   // Label 516: @32777
     /*  32777 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32846), // Rule ID 1717 //
     /*  32782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32829 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32844 */     GIR_RootConstrainSelectedInstOperands,
     /*  32845 */     // GIR_Coverage, 1717,
     /*  32845 */     GIR_EraseRootFromParent_Done,
     /*  32846 */   // Label 517: @32846
     /*  32846 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32915), // Rule ID 1787 //
     /*  32851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32898 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32913 */     GIR_RootConstrainSelectedInstOperands,
     /*  32914 */     // GIR_Coverage, 1787,
     /*  32914 */     GIR_EraseRootFromParent_Done,
     /*  32915 */   // Label 518: @32915
     /*  32915 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32984), // Rule ID 1786 //
     /*  32920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32967 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32982 */     GIR_RootConstrainSelectedInstOperands,
     /*  32983 */     // GIR_Coverage, 1786,
     /*  32983 */     GIR_EraseRootFromParent_Done,
     /*  32984 */   // Label 519: @32984
     /*  32984 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33051), // Rule ID 13654 //
     /*  32989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33032 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33049 */     GIR_RootConstrainSelectedInstOperands,
     /*  33050 */     // GIR_Coverage, 13654,
     /*  33050 */     GIR_EraseRootFromParent_Done,
     /*  33051 */   // Label 520: @33051
     /*  33051 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33118), // Rule ID 13688 //
     /*  33056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33099 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33116 */     GIR_RootConstrainSelectedInstOperands,
     /*  33117 */     // GIR_Coverage, 13688,
     /*  33117 */     GIR_EraseRootFromParent_Done,
     /*  33118 */   // Label 521: @33118
     /*  33118 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33185), // Rule ID 1729 //
     /*  33123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33166 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33183 */     GIR_RootConstrainSelectedInstOperands,
     /*  33184 */     // GIR_Coverage, 1729,
     /*  33184 */     GIR_EraseRootFromParent_Done,
     /*  33185 */   // Label 522: @33185
     /*  33185 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33252), // Rule ID 1819 //
     /*  33190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33233 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33250 */     GIR_RootConstrainSelectedInstOperands,
     /*  33251 */     // GIR_Coverage, 1819,
     /*  33251 */     GIR_EraseRootFromParent_Done,
     /*  33252 */   // Label 523: @33252
     /*  33252 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33333), // Rule ID 13636 //
     /*  33257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33284 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33287 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33296 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33316 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33331 */     GIR_RootConstrainSelectedInstOperands,
     /*  33332 */     // GIR_Coverage, 13636,
     /*  33332 */     GIR_EraseRootFromParent_Done,
     /*  33333 */   // Label 524: @33333
     /*  33333 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33414), // Rule ID 13664 //
     /*  33338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33365 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33368 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33377 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33397 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33412 */     GIR_RootConstrainSelectedInstOperands,
     /*  33413 */     // GIR_Coverage, 13664,
     /*  33413 */     GIR_EraseRootFromParent_Done,
     /*  33414 */   // Label 525: @33414
     /*  33414 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33495), // Rule ID 1693 //
     /*  33419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33450 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33453 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33462 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33478 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33493 */     GIR_RootConstrainSelectedInstOperands,
     /*  33494 */     // GIR_Coverage, 1693,
     /*  33494 */     GIR_EraseRootFromParent_Done,
     /*  33495 */   // Label 526: @33495
     /*  33495 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33576), // Rule ID 1771 //
     /*  33500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33531 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33534 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33543 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33559 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33574 */     GIR_RootConstrainSelectedInstOperands,
     /*  33575 */     // GIR_Coverage, 1771,
     /*  33575 */     GIR_EraseRootFromParent_Done,
     /*  33576 */   // Label 527: @33576
     /*  33576 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33627), // Rule ID 13678 //
     /*  33581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33613 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33625 */     GIR_RootConstrainSelectedInstOperands,
     /*  33626 */     // GIR_Coverage, 13678,
     /*  33626 */     GIR_EraseRootFromParent_Done,
     /*  33627 */   // Label 528: @33627
     /*  33627 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33678), // Rule ID 13648 //
     /*  33632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33664 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33676 */     GIR_RootConstrainSelectedInstOperands,
     /*  33677 */     // GIR_Coverage, 13648,
     /*  33677 */     GIR_EraseRootFromParent_Done,
     /*  33678 */   // Label 529: @33678
     /*  33678 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33729), // Rule ID 13677 //
     /*  33683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33715 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33727 */     GIR_RootConstrainSelectedInstOperands,
     /*  33728 */     // GIR_Coverage, 13677,
     /*  33728 */     GIR_EraseRootFromParent_Done,
     /*  33729 */   // Label 530: @33729
     /*  33729 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33780), // Rule ID 1809 //
     /*  33734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33766 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33778 */     GIR_RootConstrainSelectedInstOperands,
     /*  33779 */     // GIR_Coverage, 1809,
     /*  33779 */     GIR_EraseRootFromParent_Done,
     /*  33780 */   // Label 531: @33780
     /*  33780 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33831), // Rule ID 1723 //
     /*  33785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33817 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33829 */     GIR_RootConstrainSelectedInstOperands,
     /*  33830 */     // GIR_Coverage, 1723,
     /*  33830 */     GIR_EraseRootFromParent_Done,
     /*  33831 */   // Label 532: @33831
     /*  33831 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33882), // Rule ID 1808 //
     /*  33836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33868 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33880 */     GIR_RootConstrainSelectedInstOperands,
     /*  33881 */     // GIR_Coverage, 1808,
     /*  33881 */     GIR_EraseRootFromParent_Done,
     /*  33882 */   // Label 533: @33882
     /*  33882 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33951), // Rule ID 13600 //
     /*  33887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33902 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33905 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33914 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33934 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33949 */     GIR_RootConstrainSelectedInstOperands,
     /*  33950 */     // GIR_Coverage, 13600,
     /*  33950 */     GIR_EraseRootFromParent_Done,
     /*  33951 */   // Label 534: @33951
     /*  33951 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(34020), // Rule ID 13612 //
     /*  33956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33971 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33974 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34003 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  34006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34018 */     GIR_RootConstrainSelectedInstOperands,
     /*  34019 */     // GIR_Coverage, 13612,
     /*  34019 */     GIR_EraseRootFromParent_Done,
     /*  34020 */   // Label 535: @34020
     /*  34020 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34076), // Rule ID 13562 //
     /*  34025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34063 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34074 */     GIR_RootConstrainSelectedInstOperands,
     /*  34075 */     // GIR_Coverage, 13562,
     /*  34075 */     GIR_EraseRootFromParent_Done,
     /*  34076 */   // Label 536: @34076
     /*  34076 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34132), // Rule ID 13574 //
     /*  34081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34119 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34130 */     GIR_RootConstrainSelectedInstOperands,
     /*  34131 */     // GIR_Coverage, 13574,
     /*  34131 */     GIR_EraseRootFromParent_Done,
     /*  34132 */   // Label 537: @34132
     /*  34132 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34199), // Rule ID 13814 //
     /*  34137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34161 */     // MIs[1] imm
     /*  34161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34173 */     // MIs[2] Operand 1
     /*  34173 */     // No operand predicates
     /*  34173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34183 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34197 */     GIR_RootConstrainSelectedInstOperands,
     /*  34198 */     // GIR_Coverage, 13814,
     /*  34198 */     GIR_EraseRootFromParent_Done,
     /*  34199 */   // Label 538: @34199
     /*  34199 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34266), // Rule ID 13835 //
     /*  34204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34228 */     // MIs[1] imm
     /*  34228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34240 */     // MIs[2] Operand 1
     /*  34240 */     // No operand predicates
     /*  34240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34250 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34264 */     GIR_RootConstrainSelectedInstOperands,
     /*  34265 */     // GIR_Coverage, 13835,
     /*  34265 */     GIR_EraseRootFromParent_Done,
     /*  34266 */   // Label 539: @34266
     /*  34266 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34335), // Rule ID 1367 //
     /*  34271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34290 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34293 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  34298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34302 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34318 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  34321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34333 */     GIR_RootConstrainSelectedInstOperands,
     /*  34334 */     // GIR_Coverage, 1367,
     /*  34334 */     GIR_EraseRootFromParent_Done,
     /*  34335 */   // Label 540: @34335
     /*  34335 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34404), // Rule ID 1490 //
     /*  34340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  34367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34387 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  34390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34402 */     GIR_RootConstrainSelectedInstOperands,
     /*  34403 */     // GIR_Coverage, 1490,
     /*  34403 */     GIR_EraseRootFromParent_Done,
     /*  34404 */   // Label 541: @34404
     /*  34404 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34460), // Rule ID 995 //
     /*  34409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34447 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34458 */     GIR_RootConstrainSelectedInstOperands,
     /*  34459 */     // GIR_Coverage, 995,
     /*  34459 */     GIR_EraseRootFromParent_Done,
     /*  34460 */   // Label 542: @34460
     /*  34460 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34516), // Rule ID 1056 //
     /*  34465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34484 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34487 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34503 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34514 */     GIR_RootConstrainSelectedInstOperands,
     /*  34515 */     // GIR_Coverage, 1056,
     /*  34515 */     GIR_EraseRootFromParent_Done,
     /*  34516 */   // Label 543: @34516
     /*  34516 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34583), // Rule ID 2240 //
     /*  34521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34549 */     // MIs[1] imm
     /*  34549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34561 */     // MIs[2] Operand 1
     /*  34561 */     // No operand predicates
     /*  34561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34567 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34581 */     GIR_RootConstrainSelectedInstOperands,
     /*  34582 */     // GIR_Coverage, 2240,
     /*  34582 */     GIR_EraseRootFromParent_Done,
     /*  34583 */   // Label 544: @34583
     /*  34583 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34650), // Rule ID 2299 //
     /*  34588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34616 */     // MIs[1] imm
     /*  34616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34624 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34628 */     // MIs[2] Operand 1
     /*  34628 */     // No operand predicates
     /*  34628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34634 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34648 */     GIR_RootConstrainSelectedInstOperands,
     /*  34649 */     // GIR_Coverage, 2299,
     /*  34649 */     GIR_EraseRootFromParent_Done,
     /*  34650 */   // Label 545: @34650
     /*  34650 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34720), // Rule ID 7008 //
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34693 */     // MIs[2] Rn
     /*  34693 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34698 */     // MIs[2] Rm
     /*  34698 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34705 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34718 */     GIR_RootConstrainSelectedInstOperands,
     /*  34719 */     // GIR_Coverage, 7008,
     /*  34719 */     GIR_EraseRootFromParent_Done,
     /*  34720 */   // Label 546: @34720
     /*  34720 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34790), // Rule ID 14206 //
     /*  34725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34763 */     // MIs[2] Rn
     /*  34763 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34768 */     // MIs[2] Rm
     /*  34768 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34775 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34788 */     GIR_RootConstrainSelectedInstOperands,
     /*  34789 */     // GIR_Coverage, 14206,
     /*  34789 */     GIR_EraseRootFromParent_Done,
     /*  34790 */   // Label 547: @34790
     /*  34790 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34853), // Rule ID 1785 //
     /*  34795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34838 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34851 */     GIR_RootConstrainSelectedInstOperands,
     /*  34852 */     // GIR_Coverage, 1785,
     /*  34852 */     GIR_EraseRootFromParent_Done,
     /*  34853 */   // Label 548: @34853
     /*  34853 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34916), // Rule ID 1784 //
     /*  34858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34901 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34914 */     GIR_RootConstrainSelectedInstOperands,
     /*  34915 */     // GIR_Coverage, 1784,
     /*  34915 */     GIR_EraseRootFromParent_Done,
     /*  34916 */   // Label 549: @34916
     /*  34916 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34979), // Rule ID 1716 //
     /*  34921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34964 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34977 */     GIR_RootConstrainSelectedInstOperands,
     /*  34978 */     // GIR_Coverage, 1716,
     /*  34978 */     GIR_EraseRootFromParent_Done,
     /*  34979 */   // Label 550: @34979
     /*  34979 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(35042), // Rule ID 1783 //
     /*  34984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35027 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35040 */     GIR_RootConstrainSelectedInstOperands,
     /*  35041 */     // GIR_Coverage, 1783,
     /*  35041 */     GIR_EraseRootFromParent_Done,
     /*  35042 */   // Label 551: @35042
     /*  35042 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(35105), // Rule ID 1782 //
     /*  35047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35090 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1782,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 552: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(35166), // Rule ID 13653 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35149 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35164 */     GIR_RootConstrainSelectedInstOperands,
     /*  35165 */     // GIR_Coverage, 13653,
     /*  35165 */     GIR_EraseRootFromParent_Done,
     /*  35166 */   // Label 553: @35166
     /*  35166 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35227), // Rule ID 13687 //
     /*  35171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35210 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35225 */     GIR_RootConstrainSelectedInstOperands,
     /*  35226 */     // GIR_Coverage, 13687,
     /*  35226 */     GIR_EraseRootFromParent_Done,
     /*  35227 */   // Label 554: @35227
     /*  35227 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35275), // Rule ID 13676 //
     /*  35232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35262 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35273 */     GIR_RootConstrainSelectedInstOperands,
     /*  35274 */     // GIR_Coverage, 13676,
     /*  35274 */     GIR_EraseRootFromParent_Done,
     /*  35275 */   // Label 555: @35275
     /*  35275 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35323), // Rule ID 13561 //
     /*  35280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35310 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35321 */     GIR_RootConstrainSelectedInstOperands,
     /*  35322 */     // GIR_Coverage, 13561,
     /*  35322 */     GIR_EraseRootFromParent_Done,
     /*  35323 */   // Label 556: @35323
     /*  35323 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35371), // Rule ID 13647 //
     /*  35328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35358 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35369 */     GIR_RootConstrainSelectedInstOperands,
     /*  35370 */     // GIR_Coverage, 13647,
     /*  35370 */     GIR_EraseRootFromParent_Done,
     /*  35371 */   // Label 557: @35371
     /*  35371 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35419), // Rule ID 13573 //
     /*  35376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35406 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35417 */     GIR_RootConstrainSelectedInstOperands,
     /*  35418 */     // GIR_Coverage, 13573,
     /*  35418 */     GIR_EraseRootFromParent_Done,
     /*  35419 */   // Label 558: @35419
     /*  35419 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35467), // Rule ID 13675 //
     /*  35424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35454 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35465 */     GIR_RootConstrainSelectedInstOperands,
     /*  35466 */     // GIR_Coverage, 13675,
     /*  35466 */     GIR_EraseRootFromParent_Done,
     /*  35467 */   // Label 559: @35467
     /*  35467 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35528), // Rule ID 1728 //
     /*  35472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35511 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35526 */     GIR_RootConstrainSelectedInstOperands,
     /*  35527 */     // GIR_Coverage, 1728,
     /*  35527 */     GIR_EraseRootFromParent_Done,
     /*  35528 */   // Label 560: @35528
     /*  35528 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35589), // Rule ID 1818 //
     /*  35533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35572 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35587 */     GIR_RootConstrainSelectedInstOperands,
     /*  35588 */     // GIR_Coverage, 1818,
     /*  35588 */     GIR_EraseRootFromParent_Done,
     /*  35589 */   // Label 561: @35589
     /*  35589 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35637), // Rule ID 1807 //
     /*  35594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35624 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35635 */     GIR_RootConstrainSelectedInstOperands,
     /*  35636 */     // GIR_Coverage, 1807,
     /*  35636 */     GIR_EraseRootFromParent_Done,
     /*  35637 */   // Label 562: @35637
     /*  35637 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35685), // Rule ID 994 //
     /*  35642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35672 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35683 */     GIR_RootConstrainSelectedInstOperands,
     /*  35684 */     // GIR_Coverage, 994,
     /*  35684 */     GIR_EraseRootFromParent_Done,
     /*  35685 */   // Label 563: @35685
     /*  35685 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35733), // Rule ID 1722 //
     /*  35690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35720 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35731 */     GIR_RootConstrainSelectedInstOperands,
     /*  35732 */     // GIR_Coverage, 1722,
     /*  35732 */     GIR_EraseRootFromParent_Done,
     /*  35733 */   // Label 564: @35733
     /*  35733 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35781), // Rule ID 1055 //
     /*  35738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35768 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35779 */     GIR_RootConstrainSelectedInstOperands,
     /*  35780 */     // GIR_Coverage, 1055,
     /*  35780 */     GIR_EraseRootFromParent_Done,
     /*  35781 */   // Label 565: @35781
     /*  35781 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35829), // Rule ID 1806 //
     /*  35786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35816 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35827 */     GIR_RootConstrainSelectedInstOperands,
     /*  35828 */     // GIR_Coverage, 1806,
     /*  35828 */     GIR_EraseRootFromParent_Done,
     /*  35829 */   // Label 566: @35829
     /*  35829 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35856), // Rule ID 1107 //
     /*  35834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35849 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35854 */     GIR_RootConstrainSelectedInstOperands,
     /*  35855 */     // GIR_Coverage, 1107,
     /*  35855 */     GIR_Done,
     /*  35856 */   // Label 567: @35856
     /*  35856 */   GIM_Reject,
     /*  35857 */ // Label 510: @35857
     /*  35857 */ GIM_Reject,
     /*  35858 */ // Label 164: @35858
     /*  35858 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(36581),
     /*  35863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35869 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35938), // Rule ID 13596 //
     /*  35874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35889 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35892 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35901 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35921 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35936 */     GIR_RootConstrainSelectedInstOperands,
     /*  35937 */     // GIR_Coverage, 13596,
     /*  35937 */     GIR_EraseRootFromParent_Done,
     /*  35938 */   // Label 569: @35938
     /*  35938 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(36007), // Rule ID 13608 //
     /*  35943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35958 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35961 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35970 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35990 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36005 */     GIR_RootConstrainSelectedInstOperands,
     /*  36006 */     // GIR_Coverage, 13608,
     /*  36006 */     GIR_EraseRootFromParent_Done,
     /*  36007 */   // Label 570: @36007
     /*  36007 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36074), // Rule ID 13810 //
     /*  36012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     // MIs[1] imm
     /*  36036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36044 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36048 */     // MIs[2] Operand 1
     /*  36048 */     // No operand predicates
     /*  36048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36058 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36072 */     GIR_RootConstrainSelectedInstOperands,
     /*  36073 */     // GIR_Coverage, 13810,
     /*  36073 */     GIR_EraseRootFromParent_Done,
     /*  36074 */   // Label 571: @36074
     /*  36074 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36141), // Rule ID 13831 //
     /*  36079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36103 */     // MIs[1] imm
     /*  36103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36115 */     // MIs[2] Operand 1
     /*  36115 */     // No operand predicates
     /*  36115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36125 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36139 */     GIR_RootConstrainSelectedInstOperands,
     /*  36140 */     // GIR_Coverage, 13831,
     /*  36140 */     GIR_EraseRootFromParent_Done,
     /*  36141 */   // Label 572: @36141
     /*  36141 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36210), // Rule ID 1363 //
     /*  36146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  36173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36177 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36193 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  36196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36208 */     GIR_RootConstrainSelectedInstOperands,
     /*  36209 */     // GIR_Coverage, 1363,
     /*  36209 */     GIR_EraseRootFromParent_Done,
     /*  36210 */   // Label 573: @36210
     /*  36210 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36279), // Rule ID 1486 //
     /*  36215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  36242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36262 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  36265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36277 */     GIR_RootConstrainSelectedInstOperands,
     /*  36278 */     // GIR_Coverage, 1486,
     /*  36278 */     GIR_EraseRootFromParent_Done,
     /*  36279 */   // Label 574: @36279
     /*  36279 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36346), // Rule ID 2236 //
     /*  36284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36312 */     // MIs[1] imm
     /*  36312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36324 */     // MIs[2] Operand 1
     /*  36324 */     // No operand predicates
     /*  36324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36330 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36344 */     GIR_RootConstrainSelectedInstOperands,
     /*  36345 */     // GIR_Coverage, 2236,
     /*  36345 */     GIR_EraseRootFromParent_Done,
     /*  36346 */   // Label 575: @36346
     /*  36346 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36413), // Rule ID 2295 //
     /*  36351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36379 */     // MIs[1] imm
     /*  36379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36391 */     // MIs[2] Operand 1
     /*  36391 */     // No operand predicates
     /*  36391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36397 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36411 */     GIR_RootConstrainSelectedInstOperands,
     /*  36412 */     // GIR_Coverage, 2295,
     /*  36412 */     GIR_EraseRootFromParent_Done,
     /*  36413 */   // Label 576: @36413
     /*  36413 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36483), // Rule ID 7009 //
     /*  36418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36456 */     // MIs[2] Rn
     /*  36456 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36461 */     // MIs[2] Rm
     /*  36461 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36468 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36481 */     GIR_RootConstrainSelectedInstOperands,
     /*  36482 */     // GIR_Coverage, 7009,
     /*  36482 */     GIR_EraseRootFromParent_Done,
     /*  36483 */   // Label 577: @36483
     /*  36483 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36553), // Rule ID 14207 //
     /*  36488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36526 */     // MIs[2] Rn
     /*  36526 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36531 */     // MIs[2] Rm
     /*  36531 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36538 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36551 */     GIR_RootConstrainSelectedInstOperands,
     /*  36552 */     // GIR_Coverage, 14207,
     /*  36552 */     GIR_EraseRootFromParent_Done,
     /*  36553 */   // Label 578: @36553
     /*  36553 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36580), // Rule ID 1105 //
     /*  36558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36573 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36578 */     GIR_RootConstrainSelectedInstOperands,
     /*  36579 */     // GIR_Coverage, 1105,
     /*  36579 */     GIR_Done,
     /*  36580 */   // Label 579: @36580
     /*  36580 */   GIM_Reject,
     /*  36581 */ // Label 568: @36581
     /*  36581 */ GIM_Reject,
     /*  36582 */ // Label 165: @36582
     /*  36582 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36953),
     /*  36587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36597 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36659), // Rule ID 15394 //
     /*  36602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36633 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36646 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36657 */     GIR_RootConstrainSelectedInstOperands,
     /*  36658 */     // GIR_Coverage, 15394,
     /*  36658 */     GIR_EraseRootFromParent_Done,
     /*  36659 */   // Label 581: @36659
     /*  36659 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36721), // Rule ID 15393 //
     /*  36664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36708 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36719 */     GIR_RootConstrainSelectedInstOperands,
     /*  36720 */     // GIR_Coverage, 15393,
     /*  36720 */     GIR_EraseRootFromParent_Done,
     /*  36721 */   // Label 582: @36721
     /*  36721 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36783), // Rule ID 15392 //
     /*  36726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36757 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36770 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36781 */     GIR_RootConstrainSelectedInstOperands,
     /*  36782 */     // GIR_Coverage, 15392,
     /*  36782 */     GIR_EraseRootFromParent_Done,
     /*  36783 */   // Label 583: @36783
     /*  36783 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36845), // Rule ID 9015 //
     /*  36788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36819 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36832 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36843 */     GIR_RootConstrainSelectedInstOperands,
     /*  36844 */     // GIR_Coverage, 9015,
     /*  36844 */     GIR_EraseRootFromParent_Done,
     /*  36845 */   // Label 584: @36845
     /*  36845 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36891), // Rule ID 15395 //
     /*  36850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36865 */     // MIs[1] Operand 2
     /*  36865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36878 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36889 */     GIR_RootConstrainSelectedInstOperands,
     /*  36890 */     // GIR_Coverage, 15395,
     /*  36890 */     GIR_EraseRootFromParent_Done,
     /*  36891 */   // Label 585: @36891
     /*  36891 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36937), // Rule ID 9016 //
     /*  36896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36911 */     // MIs[1] Operand 2
     /*  36911 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36924 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36935 */     GIR_RootConstrainSelectedInstOperands,
     /*  36936 */     // GIR_Coverage, 9016,
     /*  36936 */     GIR_EraseRootFromParent_Done,
     /*  36937 */   // Label 586: @36937
     /*  36937 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36952), // Rule ID 2780 //
     /*  36942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36945 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36950 */     GIR_RootConstrainSelectedInstOperands,
     /*  36951 */     // GIR_Coverage, 2780,
     /*  36951 */     GIR_Done,
     /*  36952 */   // Label 587: @36952
     /*  36952 */   GIM_Reject,
     /*  36953 */ // Label 580: @36953
     /*  36953 */ GIM_Reject,
     /*  36954 */ // Label 166: @36954
     /*  36954 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36979), // Rule ID 2779 //
     /*  36959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36972 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36977 */   GIR_RootConstrainSelectedInstOperands,
     /*  36978 */   // GIR_Coverage, 2779,
     /*  36978 */   GIR_Done,
     /*  36979 */ // Label 588: @36979
     /*  36979 */ GIM_Reject,
     /*  36980 */ // Label 167: @36980
     /*  36980 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(37005), // Rule ID 2778 //
     /*  36985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36998 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  37003 */   GIR_RootConstrainSelectedInstOperands,
     /*  37004 */   // GIR_Coverage, 2778,
     /*  37004 */   GIR_Done,
     /*  37005 */ // Label 589: @37005
     /*  37005 */ GIM_Reject,
     /*  37006 */ // Label 168: @37006
     /*  37006 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(37031), // Rule ID 2777 //
     /*  37011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  37017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  37020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  37024 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  37024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  37029 */   GIR_RootConstrainSelectedInstOperands,
     /*  37030 */   // GIR_Coverage, 2777,
     /*  37030 */   GIR_Done,
     /*  37031 */ // Label 590: @37031
     /*  37031 */ GIM_Reject,
     /*  37032 */ // Label 169: @37032
     /*  37032 */ GIM_Reject,
     /*  37033 */ // Label 1: @37033
     /*  37033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 604*/ GIMT_Encode4(51884),
     /*  37044 */ /*GILLT_s32*//*Label 591*/ GIMT_Encode4(37132),
     /*  37048 */ /*GILLT_s64*//*Label 592*/ GIMT_Encode4(38614), GIMT_Encode4(0),
     /*  37056 */ /*GILLT_v2s32*//*Label 593*/ GIMT_Encode4(42520),
     /*  37060 */ /*GILLT_v2s64*//*Label 594*/ GIMT_Encode4(44011),
     /*  37064 */ /*GILLT_v4s16*//*Label 595*/ GIMT_Encode4(46471),
     /*  37068 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(47962),
     /*  37072 */ /*GILLT_v8s8*//*Label 597*/ GIMT_Encode4(50422),
     /*  37076 */ /*GILLT_v8s16*//*Label 598*/ GIMT_Encode4(50497),
     /*  37080 */ /*GILLT_v16s8*//*Label 599*/ GIMT_Encode4(51705), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37100 */ /*GILLT_nxv2s64*//*Label 600*/ GIMT_Encode4(51780), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37112 */ /*GILLT_nxv4s32*//*Label 601*/ GIMT_Encode4(51806), GIMT_Encode4(0),
     /*  37120 */ /*GILLT_nxv8s16*//*Label 602*/ GIMT_Encode4(51832), GIMT_Encode4(0),
     /*  37128 */ /*GILLT_nxv16s8*//*Label 603*/ GIMT_Encode4(51858),
     /*  37132 */ // Label 591: @37132
     /*  37132 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(38613),
     /*  37137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  37140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37143 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37295), // Rule ID 10062 //
     /*  37148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37179 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37182 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37187 */     // MIs[2] pattern
     /*  37187 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37190 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37197 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37223 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37230 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37294 */     // GIR_Coverage, 10062,
     /*  37294 */     GIR_EraseRootFromParent_Done,
     /*  37295 */   // Label 606: @37295
     /*  37295 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37447), // Rule ID 10074 //
     /*  37300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37331 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37334 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37339 */     // MIs[2] pattern
     /*  37339 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37342 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37349 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37375 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37412 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37446 */     // GIR_Coverage, 10074,
     /*  37446 */     GIR_EraseRootFromParent_Done,
     /*  37447 */   // Label 607: @37447
     /*  37447 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37599), // Rule ID 10086 //
     /*  37452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37483 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37486 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37491 */     // MIs[2] pattern
     /*  37491 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37494 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37501 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37527 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37530 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37534 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37564 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37598 */     // GIR_Coverage, 10086,
     /*  37598 */     GIR_EraseRootFromParent_Done,
     /*  37599 */   // Label 608: @37599
     /*  37599 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37751), // Rule ID 10098 //
     /*  37604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37635 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37638 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37643 */     // MIs[2] pattern
     /*  37643 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37646 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37653 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37653 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37656 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37660 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37679 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37686 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37750 */     // GIR_Coverage, 10098,
     /*  37750 */     GIR_EraseRootFromParent_Done,
     /*  37751 */   // Label 609: @37751
     /*  37751 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37813), // Rule ID 3986 //
     /*  37756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37792 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37811 */     GIR_RootConstrainSelectedInstOperands,
     /*  37812 */     // GIR_Coverage, 3986,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 610: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37970), // Rule ID 10200 //
     /*  37818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37849 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37852 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37868 */     // MIs[2] pred
     /*  37868 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37875 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37875 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37878 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37882 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37901 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37904 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37908 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37952 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37969 */     // GIR_Coverage, 10200,
     /*  37969 */     GIR_EraseRootFromParent_Done,
     /*  37970 */   // Label 611: @37970
     /*  37970 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38127), // Rule ID 10201 //
     /*  37975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38006 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38009 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  38018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38025 */     // MIs[2] pred
     /*  38025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38032 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38032 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38035 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38039 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38058 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38061 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38065 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38068 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  38090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38126 */     // GIR_Coverage, 10201,
     /*  38126 */     GIR_EraseRootFromParent_Done,
     /*  38127 */   // Label 612: @38127
     /*  38127 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38284), // Rule ID 10202 //
     /*  38132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  38175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38182 */     // MIs[2] pred
     /*  38182 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38189 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38189 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38192 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38196 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38215 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38222 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  38247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38256 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38266 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38283 */     // GIR_Coverage, 10202,
     /*  38283 */     GIR_EraseRootFromParent_Done,
     /*  38284 */   // Label 613: @38284
     /*  38284 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38441), // Rule ID 10203 //
     /*  38289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38320 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38323 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  38332 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38339 */     // MIs[2] pred
     /*  38339 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38346 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  38404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38440 */     // GIR_Coverage, 10203,
     /*  38440 */     GIR_EraseRootFromParent_Done,
     /*  38441 */   // Label 614: @38441
     /*  38441 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38477), // Rule ID 3951 //
     /*  38446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38461 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38466 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38475 */     GIR_RootConstrainSelectedInstOperands,
     /*  38476 */     // GIR_Coverage, 3951,
     /*  38476 */     GIR_EraseRootFromParent_Done,
     /*  38477 */   // Label 615: @38477
     /*  38477 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38510), // Rule ID 3956 //
     /*  38482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38497 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38508 */     GIR_RootConstrainSelectedInstOperands,
     /*  38509 */     // GIR_Coverage, 3956,
     /*  38509 */     GIR_EraseRootFromParent_Done,
     /*  38510 */   // Label 616: @38510
     /*  38510 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38546), // Rule ID 3945 //
     /*  38515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38530 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38544 */     GIR_RootConstrainSelectedInstOperands,
     /*  38545 */     // GIR_Coverage, 3945,
     /*  38545 */     GIR_EraseRootFromParent_Done,
     /*  38546 */   // Label 617: @38546
     /*  38546 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38582), // Rule ID 3949 //
     /*  38551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38566 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38580 */     GIR_RootConstrainSelectedInstOperands,
     /*  38581 */     // GIR_Coverage, 3949,
     /*  38581 */     GIR_EraseRootFromParent_Done,
     /*  38582 */   // Label 618: @38582
     /*  38582 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38612), // Rule ID 3947 //
     /*  38587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38599 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38604 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38610 */     GIR_RootConstrainSelectedInstOperands,
     /*  38611 */     // GIR_Coverage, 3947,
     /*  38611 */     GIR_Done,
     /*  38612 */   // Label 619: @38612
     /*  38612 */   GIM_Reject,
     /*  38613 */ // Label 605: @38613
     /*  38613 */ GIM_Reject,
     /*  38614 */ // Label 592: @38614
     /*  38614 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(42519),
     /*  38619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38625 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38761), // Rule ID 5449 //
     /*  38630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38663 */     // MIs[1] Operand 2
     /*  38663 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38686 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38690 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38694 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38698 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38703 */     // MIs[3] Operand 2
     /*  38703 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38714 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38716 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38743 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38760 */     // GIR_Coverage, 5449,
     /*  38760 */     GIR_EraseRootFromParent_Done,
     /*  38761 */   // Label 621: @38761
     /*  38761 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38897), // Rule ID 5448 //
     /*  38766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38799 */     // MIs[1] Operand 2
     /*  38799 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38818 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38830 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38834 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38839 */     // MIs[3] Operand 2
     /*  38839 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38852 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38879 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38896 */     // GIR_Coverage, 5448,
     /*  38896 */     GIR_EraseRootFromParent_Done,
     /*  38897 */   // Label 622: @38897
     /*  38897 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39033), // Rule ID 5458 //
     /*  38902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38935 */     // MIs[1] Operand 2
     /*  38935 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38966 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38970 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38975 */     // MIs[3] Operand 2
     /*  38975 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38986 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38988 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39015 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39032 */     // GIR_Coverage, 5458,
     /*  39032 */     GIR_EraseRootFromParent_Done,
     /*  39033 */   // Label 623: @39033
     /*  39033 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39169), // Rule ID 5447 //
     /*  39038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39071 */     // MIs[1] Operand 2
     /*  39071 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39094 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39098 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39102 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39106 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39111 */     // MIs[3] Operand 2
     /*  39111 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39122 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39124 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39151 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39168 */     // GIR_Coverage, 5447,
     /*  39168 */     GIR_EraseRootFromParent_Done,
     /*  39169 */   // Label 624: @39169
     /*  39169 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39305), // Rule ID 5446 //
     /*  39174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39207 */     // MIs[1] Operand 2
     /*  39207 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39238 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39242 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39247 */     // MIs[3] Operand 2
     /*  39247 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39258 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39260 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39304 */     // GIR_Coverage, 5446,
     /*  39304 */     GIR_EraseRootFromParent_Done,
     /*  39305 */   // Label 625: @39305
     /*  39305 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39442), // Rule ID 4003 //
     /*  39310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39351 */     // MIs[2] Operand 2
     /*  39351 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39374 */     // MIs[3] Operand 1
     /*  39374 */     // No operand predicates
     /*  39374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39376 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39388 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39407 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39440 */     GIR_RootConstrainSelectedInstOperands,
     /*  39441 */     // GIR_Coverage, 4003,
     /*  39441 */     GIR_EraseRootFromParent_Done,
     /*  39442 */   // Label 626: @39442
     /*  39442 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39541), // Rule ID 4001 //
     /*  39447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39500 */     // MIs[3] Operand 1
     /*  39500 */     // No operand predicates
     /*  39500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39502 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39514 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39539 */     GIR_RootConstrainSelectedInstOperands,
     /*  39540 */     // GIR_Coverage, 4001,
     /*  39540 */     GIR_EraseRootFromParent_Done,
     /*  39541 */   // Label 627: @39541
     /*  39541 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39640), // Rule ID 4002 //
     /*  39546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39599 */     // MIs[3] Operand 1
     /*  39599 */     // No operand predicates
     /*  39599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39601 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39613 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39638 */     GIR_RootConstrainSelectedInstOperands,
     /*  39639 */     // GIR_Coverage, 4002,
     /*  39639 */     GIR_EraseRootFromParent_Done,
     /*  39640 */   // Label 628: @39640
     /*  39640 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39726), // Rule ID 3996 //
     /*  39645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39694 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39698 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39705 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39724 */     GIR_RootConstrainSelectedInstOperands,
     /*  39725 */     // GIR_Coverage, 3996,
     /*  39725 */     GIR_EraseRootFromParent_Done,
     /*  39726 */   // Label 629: @39726
     /*  39726 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39812), // Rule ID 3997 //
     /*  39731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39791 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39810 */     GIR_RootConstrainSelectedInstOperands,
     /*  39811 */     // GIR_Coverage, 3997,
     /*  39811 */     GIR_EraseRootFromParent_Done,
     /*  39812 */   // Label 630: @39812
     /*  39812 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39913), // Rule ID 4023 //
     /*  39817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39841 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39865 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39911 */     GIR_RootConstrainSelectedInstOperands,
     /*  39912 */     // GIR_Coverage, 4023,
     /*  39912 */     GIR_EraseRootFromParent_Done,
     /*  39913 */   // Label 631: @39913
     /*  39913 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(40014), // Rule ID 14062 //
     /*  39918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39959 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39966 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40012 */     GIR_RootConstrainSelectedInstOperands,
     /*  40013 */     // GIR_Coverage, 14062,
     /*  40013 */     GIR_EraseRootFromParent_Done,
     /*  40014 */   // Label 632: @40014
     /*  40014 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40130), // Rule ID 4022 //
     /*  40019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40043 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40048 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40055 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  40055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40067 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  40073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40128 */     GIR_RootConstrainSelectedInstOperands,
     /*  40129 */     // GIR_Coverage, 4022,
     /*  40129 */     GIR_EraseRootFromParent_Done,
     /*  40130 */   // Label 633: @40130
     /*  40130 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40263), // Rule ID 4009 //
     /*  40135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  40167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  40171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40176 */     // MIs[2] Operand 2
     /*  40176 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  40187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40199 */     // MIs[3] Operand 1
     /*  40199 */     // No operand predicates
     /*  40199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40201 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40213 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  40220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40232 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40261 */     GIR_RootConstrainSelectedInstOperands,
     /*  40262 */     // GIR_Coverage, 4009,
     /*  40262 */     GIR_EraseRootFromParent_Done,
     /*  40263 */   // Label 634: @40263
     /*  40263 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40358), // Rule ID 4007 //
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40317 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40321 */     // MIs[3] Operand 1
     /*  40321 */     // No operand predicates
     /*  40321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40323 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40335 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40356 */     GIR_RootConstrainSelectedInstOperands,
     /*  40357 */     // GIR_Coverage, 4007,
     /*  40357 */     GIR_EraseRootFromParent_Done,
     /*  40358 */   // Label 635: @40358
     /*  40358 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40453), // Rule ID 4008 //
     /*  40363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40412 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  40416 */     // MIs[3] Operand 1
     /*  40416 */     // No operand predicates
     /*  40416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40418 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40430 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40451 */     GIR_RootConstrainSelectedInstOperands,
     /*  40452 */     // GIR_Coverage, 4008,
     /*  40452 */     GIR_EraseRootFromParent_Done,
     /*  40453 */   // Label 636: @40453
     /*  40453 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40535), // Rule ID 124 //
     /*  40458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40507 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40511 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40518 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40533 */     GIR_RootConstrainSelectedInstOperands,
     /*  40534 */     // GIR_Coverage, 124,
     /*  40534 */     GIR_EraseRootFromParent_Done,
     /*  40535 */   // Label 637: @40535
     /*  40535 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40617), // Rule ID 126 //
     /*  40540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40600 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40615 */     GIR_RootConstrainSelectedInstOperands,
     /*  40616 */     // GIR_Coverage, 126,
     /*  40616 */     GIR_EraseRootFromParent_Done,
     /*  40617 */   // Label 638: @40617
     /*  40617 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40679), // Rule ID 3987 //
     /*  40622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40658 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  40658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  40661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  40667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  40671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40677 */     GIR_RootConstrainSelectedInstOperands,
     /*  40678 */     // GIR_Coverage, 3987,
     /*  40678 */     GIR_EraseRootFromParent_Done,
     /*  40679 */   // Label 639: @40679
     /*  40679 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40737), // Rule ID 10059 //
     /*  40684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40703 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40706 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  40711 */     // MIs[1] pattern
     /*  40711 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40714 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40721 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  40724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40735 */     GIR_RootConstrainSelectedInstOperands,
     /*  40736 */     // GIR_Coverage, 10059,
     /*  40736 */     GIR_EraseRootFromParent_Done,
     /*  40737 */   // Label 640: @40737
     /*  40737 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40795), // Rule ID 10071 //
     /*  40742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40769 */     // MIs[1] pattern
     /*  40769 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40772 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40779 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40793 */     GIR_RootConstrainSelectedInstOperands,
     /*  40794 */     // GIR_Coverage, 10071,
     /*  40794 */     GIR_EraseRootFromParent_Done,
     /*  40795 */   // Label 641: @40795
     /*  40795 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40853), // Rule ID 10083 //
     /*  40800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40819 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40822 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40827 */     // MIs[1] pattern
     /*  40827 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40830 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40837 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40851 */     GIR_RootConstrainSelectedInstOperands,
     /*  40852 */     // GIR_Coverage, 10083,
     /*  40852 */     GIR_EraseRootFromParent_Done,
     /*  40853 */   // Label 642: @40853
     /*  40853 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40911), // Rule ID 10095 //
     /*  40858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40877 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40880 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40885 */     // MIs[1] pattern
     /*  40885 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40888 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40895 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40909 */     GIR_RootConstrainSelectedInstOperands,
     /*  40910 */     // GIR_Coverage, 10095,
     /*  40910 */     GIR_EraseRootFromParent_Done,
     /*  40911 */   // Label 643: @40911
     /*  40911 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 4025 //
     /*  40916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40940 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40964 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40976 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 4025,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41105), // Rule ID 14063 //
     /*  41013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41054 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41061 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  41061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41073 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  41079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  41092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  41103 */     GIR_RootConstrainSelectedInstOperands,
     /*  41104 */     // GIR_Coverage, 14063,
     /*  41104 */     GIR_EraseRootFromParent_Done,
     /*  41105 */   // Label 645: @41105
     /*  41105 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41268), // Rule ID 5413 //
     /*  41110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41156 */     // MIs[1] Operand 2
     /*  41156 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41169 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41169 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41172 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41176 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41195 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41198 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41202 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  41227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41267 */     // GIR_Coverage, 5413,
     /*  41267 */     GIR_EraseRootFromParent_Done,
     /*  41268 */   // Label 646: @41268
     /*  41268 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41431), // Rule ID 5410 //
     /*  41273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  41301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41319 */     // MIs[1] Operand 2
     /*  41319 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41332 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41332 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41335 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41339 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41346 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41349 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41353 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41358 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41361 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41365 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  41390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41430 */     // GIR_Coverage, 5410,
     /*  41430 */     GIR_EraseRootFromParent_Done,
     /*  41431 */   // Label 647: @41431
     /*  41431 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41581), // Rule ID 5455 //
     /*  41436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41473 */     // MIs[1] Operand 2
     /*  41473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41486 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41512 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41519 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41549 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41563 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41580 */     // GIR_Coverage, 5455,
     /*  41580 */     GIR_EraseRootFromParent_Done,
     /*  41581 */   // Label 648: @41581
     /*  41581 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41731), // Rule ID 5461 //
     /*  41586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41623 */     // MIs[1] Operand 2
     /*  41623 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41636 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41636 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41639 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41643 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41662 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41669 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  41694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41713 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41730 */     // GIR_Coverage, 5461,
     /*  41730 */     GIR_EraseRootFromParent_Done,
     /*  41731 */   // Label 649: @41731
     /*  41731 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41881), // Rule ID 5454 //
     /*  41736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41773 */     // MIs[1] Operand 2
     /*  41773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41786 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41786 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41789 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41793 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41812 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41819 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41849 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41880 */     // GIR_Coverage, 5454,
     /*  41880 */     GIR_EraseRootFromParent_Done,
     /*  41881 */   // Label 650: @41881
     /*  41881 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41917), // Rule ID 3952 //
     /*  41886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  41901 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  41901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  41904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41906 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  41908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  41912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41915 */     GIR_RootConstrainSelectedInstOperands,
     /*  41916 */     // GIR_Coverage, 3952,
     /*  41916 */     GIR_EraseRootFromParent_Done,
     /*  41917 */   // Label 651: @41917
     /*  41917 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41950), // Rule ID 3957 //
     /*  41922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41937 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41948 */     GIR_RootConstrainSelectedInstOperands,
     /*  41949 */     // GIR_Coverage, 3957,
     /*  41949 */     GIR_EraseRootFromParent_Done,
     /*  41950 */   // Label 652: @41950
     /*  41950 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(42062), // Rule ID 4024 //
     /*  41955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41979 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41984 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41991 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  41991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  41994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42003 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  42009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  42014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42031 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  42037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  42042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  42050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  42060 */     GIR_RootConstrainSelectedInstOperands,
     /*  42061 */     // GIR_Coverage, 4024,
     /*  42061 */     GIR_EraseRootFromParent_Done,
     /*  42062 */   // Label 653: @42062
     /*  42062 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42098), // Rule ID 3946 //
     /*  42067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  42075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  42082 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  42082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  42085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  42093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42096 */     GIR_RootConstrainSelectedInstOperands,
     /*  42097 */     // GIR_Coverage, 3946,
     /*  42097 */     GIR_EraseRootFromParent_Done,
     /*  42098 */   // Label 654: @42098
     /*  42098 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42134), // Rule ID 3950 //
     /*  42103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  42118 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  42118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  42121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  42129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42132 */     GIR_RootConstrainSelectedInstOperands,
     /*  42133 */     // GIR_Coverage, 3950,
     /*  42133 */     GIR_EraseRootFromParent_Done,
     /*  42134 */   // Label 655: @42134
     /*  42134 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42197), // Rule ID 10192 //
     /*  42139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42158 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42161 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  42170 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42177 */     // MIs[1] pred
     /*  42177 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42184 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  42187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42195 */     GIR_RootConstrainSelectedInstOperands,
     /*  42196 */     // GIR_Coverage, 10192,
     /*  42196 */     GIR_EraseRootFromParent_Done,
     /*  42197 */   // Label 656: @42197
     /*  42197 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42260), // Rule ID 10193 //
     /*  42202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42221 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42224 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  42233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42240 */     // MIs[1] pred
     /*  42240 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42247 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  42250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42258 */     GIR_RootConstrainSelectedInstOperands,
     /*  42259 */     // GIR_Coverage, 10193,
     /*  42259 */     GIR_EraseRootFromParent_Done,
     /*  42260 */   // Label 657: @42260
     /*  42260 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42323), // Rule ID 10194 //
     /*  42265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42284 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42287 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  42296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42303 */     // MIs[1] pred
     /*  42303 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42310 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  42313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42321 */     GIR_RootConstrainSelectedInstOperands,
     /*  42322 */     // GIR_Coverage, 10194,
     /*  42322 */     GIR_EraseRootFromParent_Done,
     /*  42323 */   // Label 658: @42323
     /*  42323 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42386), // Rule ID 10195 //
     /*  42328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42347 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42350 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  42359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42366 */     // MIs[1] pred
     /*  42366 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42373 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  42376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42384 */     GIR_RootConstrainSelectedInstOperands,
     /*  42385 */     // GIR_Coverage, 10195,
     /*  42385 */     GIR_EraseRootFromParent_Done,
     /*  42386 */   // Label 659: @42386
     /*  42386 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42425), // Rule ID 1659 //
     /*  42391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42416 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  42416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42423 */     GIR_RootConstrainSelectedInstOperands,
     /*  42424 */     // GIR_Coverage, 1659,
     /*  42424 */     GIR_EraseRootFromParent_Done,
     /*  42425 */   // Label 660: @42425
     /*  42425 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42461), // Rule ID 5296 //
     /*  42430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42452 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  42452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42459 */     GIR_RootConstrainSelectedInstOperands,
     /*  42460 */     // GIR_Coverage, 5296,
     /*  42460 */     GIR_EraseRootFromParent_Done,
     /*  42461 */   // Label 661: @42461
     /*  42461 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42488), // Rule ID 1648 //
     /*  42466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42481 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  42481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  42486 */     GIR_RootConstrainSelectedInstOperands,
     /*  42487 */     // GIR_Coverage, 1648,
     /*  42487 */     GIR_Done,
     /*  42488 */   // Label 662: @42488
     /*  42488 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42518), // Rule ID 3948 //
     /*  42493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42505 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  42505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  42510 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  42516 */     GIR_RootConstrainSelectedInstOperands,
     /*  42517 */     // GIR_Coverage, 3948,
     /*  42517 */     GIR_Done,
     /*  42518 */   // Label 663: @42518
     /*  42518 */   GIM_Reject,
     /*  42519 */ // Label 620: @42519
     /*  42519 */ GIM_Reject,
     /*  42520 */ // Label 593: @42520
     /*  42520 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(44010),
     /*  42525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42535 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42667), // Rule ID 5445 //
     /*  42540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42569 */     // MIs[1] Operand 2
     /*  42569 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42600 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42604 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42609 */     // MIs[3] Operand 2
     /*  42609 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42622 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42666 */     // GIR_Coverage, 5445,
     /*  42666 */     GIR_EraseRootFromParent_Done,
     /*  42667 */   // Label 665: @42667
     /*  42667 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42799), // Rule ID 5444 //
     /*  42672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42701 */     // MIs[1] Operand 2
     /*  42701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42728 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42732 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42736 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42741 */     // MIs[3] Operand 2
     /*  42741 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42752 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42754 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42798 */     // GIR_Coverage, 5444,
     /*  42798 */     GIR_EraseRootFromParent_Done,
     /*  42799 */   // Label 666: @42799
     /*  42799 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42931), // Rule ID 5457 //
     /*  42804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42833 */     // MIs[1] Operand 2
     /*  42833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42868 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42873 */     // MIs[3] Operand 2
     /*  42873 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42886 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  42893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42930 */     // GIR_Coverage, 5457,
     /*  42930 */     GIR_EraseRootFromParent_Done,
     /*  42931 */   // Label 667: @42931
     /*  42931 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43063), // Rule ID 5443 //
     /*  42936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42965 */     // MIs[1] Operand 2
     /*  42965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42996 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43000 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43005 */     // MIs[3] Operand 2
     /*  43005 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43016 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43018 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43062 */     // GIR_Coverage, 5443,
     /*  43062 */     GIR_EraseRootFromParent_Done,
     /*  43063 */   // Label 668: @43063
     /*  43063 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43195), // Rule ID 5442 //
     /*  43068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43097 */     // MIs[1] Operand 2
     /*  43097 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43124 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43128 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43132 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43137 */     // MIs[3] Operand 2
     /*  43137 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43150 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43194 */     // GIR_Coverage, 5442,
     /*  43194 */     GIR_EraseRootFromParent_Done,
     /*  43195 */   // Label 669: @43195
     /*  43195 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43354), // Rule ID 5412 //
     /*  43200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43242 */     // MIs[1] Operand 2
     /*  43242 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43255 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43255 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43258 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43262 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43281 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43284 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43288 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  43313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43336 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43353 */     // GIR_Coverage, 5412,
     /*  43353 */     GIR_EraseRootFromParent_Done,
     /*  43354 */   // Label 670: @43354
     /*  43354 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43513), // Rule ID 5409 //
     /*  43359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43401 */     // MIs[1] Operand 2
     /*  43401 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43414 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43414 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43417 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43421 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43440 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43447 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43460 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  43472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43477 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43495 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43512 */     // GIR_Coverage, 5409,
     /*  43512 */     GIR_EraseRootFromParent_Done,
     /*  43513 */   // Label 671: @43513
     /*  43513 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43659), // Rule ID 5453 //
     /*  43518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43551 */     // MIs[1] Operand 2
     /*  43551 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43564 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43564 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43567 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43571 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43590 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43597 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43658 */     // GIR_Coverage, 5453,
     /*  43658 */     GIR_EraseRootFromParent_Done,
     /*  43659 */   // Label 672: @43659
     /*  43659 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43805), // Rule ID 5460 //
     /*  43664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43697 */     // MIs[1] Operand 2
     /*  43697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43710 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43710 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43713 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43717 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43736 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43743 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  43768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43773 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43804 */     // GIR_Coverage, 5460,
     /*  43804 */     GIR_EraseRootFromParent_Done,
     /*  43805 */   // Label 673: @43805
     /*  43805 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43951), // Rule ID 5452 //
     /*  43810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43843 */     // MIs[1] Operand 2
     /*  43843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43856 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43856 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43859 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43863 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43882 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43885 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43902 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43919 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43933 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43950 */     // GIR_Coverage, 5452,
     /*  43950 */     GIR_EraseRootFromParent_Done,
     /*  43951 */   // Label 674: @43951
     /*  43951 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43986), // Rule ID 973 //
     /*  43956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43963 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43969 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  43971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43977 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  43977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  43980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  43984 */     GIR_RootConstrainSelectedInstOperands,
     /*  43985 */     // GIR_Coverage, 973,
     /*  43985 */     GIR_EraseRootFromParent_Done,
     /*  43986 */   // Label 675: @43986
     /*  43986 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(44009), // Rule ID 1480 //
     /*  43991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44002 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  44007 */     GIR_RootConstrainSelectedInstOperands,
     /*  44008 */     // GIR_Coverage, 1480,
     /*  44008 */     GIR_Done,
     /*  44009 */   // Label 676: @44009
     /*  44009 */   GIM_Reject,
     /*  44010 */ // Label 664: @44010
     /*  44010 */ GIM_Reject,
     /*  44011 */ // Label 594: @44011
     /*  44011 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(46470),
     /*  44016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  44019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  44022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44026 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44140), // Rule ID 2052 //
     /*  44031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44082 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44091 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44095 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44099 */     // MIs[4] Operand 1
     /*  44099 */     // No operand predicates
     /*  44099 */     // MIs[2] Operand 2
     /*  44099 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44119 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44138 */     GIR_RootConstrainSelectedInstOperands,
     /*  44139 */     // GIR_Coverage, 2052,
     /*  44139 */     GIR_EraseRootFromParent_Done,
     /*  44140 */   // Label 678: @44140
     /*  44140 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44254), // Rule ID 13752 //
     /*  44145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44192 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44196 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44209 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44213 */     // MIs[4] Operand 1
     /*  44213 */     // No operand predicates
     /*  44213 */     // MIs[2] Operand 2
     /*  44213 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44224 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44233 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44252 */     GIR_RootConstrainSelectedInstOperands,
     /*  44253 */     // GIR_Coverage, 13752,
     /*  44253 */     GIR_EraseRootFromParent_Done,
     /*  44254 */   // Label 679: @44254
     /*  44254 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44368), // Rule ID 2104 //
     /*  44259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44315 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44319 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44323 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44327 */     // MIs[4] Operand 1
     /*  44327 */     // No operand predicates
     /*  44327 */     // MIs[2] Operand 2
     /*  44327 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44338 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44347 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44366 */     GIR_RootConstrainSelectedInstOperands,
     /*  44367 */     // GIR_Coverage, 2104,
     /*  44367 */     GIR_EraseRootFromParent_Done,
     /*  44368 */   // Label 680: @44368
     /*  44368 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44482), // Rule ID 13788 //
     /*  44373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44420 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44424 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44437 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44441 */     // MIs[4] Operand 1
     /*  44441 */     // No operand predicates
     /*  44441 */     // MIs[2] Operand 2
     /*  44441 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44452 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44461 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44480 */     GIR_RootConstrainSelectedInstOperands,
     /*  44481 */     // GIR_Coverage, 13788,
     /*  44481 */     GIR_EraseRootFromParent_Done,
     /*  44482 */   // Label 681: @44482
     /*  44482 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44547), // Rule ID 1859 //
     /*  44487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44530 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44545 */     GIR_RootConstrainSelectedInstOperands,
     /*  44546 */     // GIR_Coverage, 1859,
     /*  44546 */     GIR_EraseRootFromParent_Done,
     /*  44547 */   // Label 682: @44547
     /*  44547 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44612), // Rule ID 1858 //
     /*  44552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44595 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44610 */     GIR_RootConstrainSelectedInstOperands,
     /*  44611 */     // GIR_Coverage, 1858,
     /*  44611 */     GIR_EraseRootFromParent_Done,
     /*  44612 */   // Label 683: @44612
     /*  44612 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44677), // Rule ID 1763 //
     /*  44617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44660 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  44663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1763,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 684: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44742), // Rule ID 1857 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44725 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44740 */     GIR_RootConstrainSelectedInstOperands,
     /*  44741 */     // GIR_Coverage, 1857,
     /*  44741 */     GIR_EraseRootFromParent_Done,
     /*  44742 */   // Label 685: @44742
     /*  44742 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44807), // Rule ID 1856 //
     /*  44747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44790 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44805 */     GIR_RootConstrainSelectedInstOperands,
     /*  44806 */     // GIR_Coverage, 1856,
     /*  44806 */     GIR_EraseRootFromParent_Done,
     /*  44807 */   // Label 686: @44807
     /*  44807 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44918), // Rule ID 13750 //
     /*  44812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44859 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44876 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44880 */     // MIs[4] Operand 1
     /*  44880 */     // No operand predicates
     /*  44880 */     // MIs[2] Operand 2
     /*  44880 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44898 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44916 */     GIR_RootConstrainSelectedInstOperands,
     /*  44917 */     // GIR_Coverage, 13750,
     /*  44917 */     GIR_EraseRootFromParent_Done,
     /*  44918 */   // Label 687: @44918
     /*  44918 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(45029), // Rule ID 2050 //
     /*  44923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44992 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44996 */     // MIs[4] Operand 1
     /*  44996 */     // No operand predicates
     /*  44996 */     // MIs[2] Operand 2
     /*  44996 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45007 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45009 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45027 */     GIR_RootConstrainSelectedInstOperands,
     /*  45028 */     // GIR_Coverage, 2050,
     /*  45028 */     GIR_EraseRootFromParent_Done,
     /*  45029 */   // Label 688: @45029
     /*  45029 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(45140), // Rule ID 13786 //
     /*  45034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45081 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45085 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45098 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45102 */     // MIs[4] Operand 1
     /*  45102 */     // No operand predicates
     /*  45102 */     // MIs[2] Operand 2
     /*  45102 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45120 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45138 */     GIR_RootConstrainSelectedInstOperands,
     /*  45139 */     // GIR_Coverage, 13786,
     /*  45139 */     GIR_EraseRootFromParent_Done,
     /*  45140 */   // Label 689: @45140
     /*  45140 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(45251), // Rule ID 2102 //
     /*  45145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45214 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45218 */     // MIs[4] Operand 1
     /*  45218 */     // No operand predicates
     /*  45218 */     // MIs[2] Operand 2
     /*  45218 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45229 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45231 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45249 */     GIR_RootConstrainSelectedInstOperands,
     /*  45250 */     // GIR_Coverage, 2102,
     /*  45250 */     GIR_EraseRootFromParent_Done,
     /*  45251 */   // Label 690: @45251
     /*  45251 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(45314), // Rule ID 1739 //
     /*  45256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45295 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  45298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45312 */     GIR_RootConstrainSelectedInstOperands,
     /*  45313 */     // GIR_Coverage, 1739,
     /*  45313 */     GIR_EraseRootFromParent_Done,
     /*  45314 */   // Label 691: @45314
     /*  45314 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45377), // Rule ID 1829 //
     /*  45319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45358 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  45361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45375 */     GIR_RootConstrainSelectedInstOperands,
     /*  45376 */     // GIR_Coverage, 1829,
     /*  45376 */     GIR_EraseRootFromParent_Done,
     /*  45377 */   // Label 692: @45377
     /*  45377 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45465), // Rule ID 13751 //
     /*  45382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45434 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45438 */     // MIs[3] Operand 1
     /*  45438 */     // No operand predicates
     /*  45438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45445 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45463 */     GIR_RootConstrainSelectedInstOperands,
     /*  45464 */     // GIR_Coverage, 13751,
     /*  45464 */     GIR_EraseRootFromParent_Done,
     /*  45465 */   // Label 693: @45465
     /*  45465 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45553), // Rule ID 2051 //
     /*  45470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45527 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45531 */     // MIs[3] Operand 1
     /*  45531 */     // No operand predicates
     /*  45531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45533 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45551 */     GIR_RootConstrainSelectedInstOperands,
     /*  45552 */     // GIR_Coverage, 2051,
     /*  45552 */     GIR_EraseRootFromParent_Done,
     /*  45553 */   // Label 694: @45553
     /*  45553 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45641), // Rule ID 13787 //
     /*  45558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45610 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45614 */     // MIs[3] Operand 1
     /*  45614 */     // No operand predicates
     /*  45614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45621 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45639 */     GIR_RootConstrainSelectedInstOperands,
     /*  45640 */     // GIR_Coverage, 13787,
     /*  45640 */     GIR_EraseRootFromParent_Done,
     /*  45641 */   // Label 695: @45641
     /*  45641 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45729), // Rule ID 2103 //
     /*  45646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45703 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45707 */     // MIs[3] Operand 1
     /*  45707 */     // No operand predicates
     /*  45707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45709 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45727 */     GIR_RootConstrainSelectedInstOperands,
     /*  45728 */     // GIR_Coverage, 2103,
     /*  45728 */     GIR_EraseRootFromParent_Done,
     /*  45729 */   // Label 696: @45729
     /*  45729 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45776), // Rule ID 1871 //
     /*  45734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45762 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45774 */     GIR_RootConstrainSelectedInstOperands,
     /*  45775 */     // GIR_Coverage, 1871,
     /*  45775 */     GIR_EraseRootFromParent_Done,
     /*  45776 */   // Label 697: @45776
     /*  45776 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45823), // Rule ID 1769 //
     /*  45781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45809 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  45812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45821 */     GIR_RootConstrainSelectedInstOperands,
     /*  45822 */     // GIR_Coverage, 1769,
     /*  45822 */     GIR_EraseRootFromParent_Done,
     /*  45823 */   // Label 698: @45823
     /*  45823 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45870), // Rule ID 1870 //
     /*  45828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45856 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45868 */     GIR_RootConstrainSelectedInstOperands,
     /*  45869 */     // GIR_Coverage, 1870,
     /*  45869 */     GIR_EraseRootFromParent_Done,
     /*  45870 */   // Label 699: @45870
     /*  45870 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45929), // Rule ID 1855 //
     /*  45875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45914 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45927 */     GIR_RootConstrainSelectedInstOperands,
     /*  45928 */     // GIR_Coverage, 1855,
     /*  45928 */     GIR_EraseRootFromParent_Done,
     /*  45929 */   // Label 700: @45929
     /*  45929 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45988), // Rule ID 1854 //
     /*  45934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45973 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45986 */     GIR_RootConstrainSelectedInstOperands,
     /*  45987 */     // GIR_Coverage, 1854,
     /*  45987 */     GIR_EraseRootFromParent_Done,
     /*  45988 */   // Label 701: @45988
     /*  45988 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46047), // Rule ID 1762 //
     /*  45993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46032 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  46035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46045 */     GIR_RootConstrainSelectedInstOperands,
     /*  46046 */     // GIR_Coverage, 1762,
     /*  46046 */     GIR_EraseRootFromParent_Done,
     /*  46047 */   // Label 702: @46047
     /*  46047 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46106), // Rule ID 1853 //
     /*  46052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46091 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46104 */     GIR_RootConstrainSelectedInstOperands,
     /*  46105 */     // GIR_Coverage, 1853,
     /*  46105 */     GIR_EraseRootFromParent_Done,
     /*  46106 */   // Label 703: @46106
     /*  46106 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46165), // Rule ID 1852 //
     /*  46111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46150 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46163 */     GIR_RootConstrainSelectedInstOperands,
     /*  46164 */     // GIR_Coverage, 1852,
     /*  46164 */     GIR_EraseRootFromParent_Done,
     /*  46165 */   // Label 704: @46165
     /*  46165 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46200), // Rule ID 975 //
     /*  46170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46191 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  46191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  46194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46198 */     GIR_RootConstrainSelectedInstOperands,
     /*  46199 */     // GIR_Coverage, 975,
     /*  46199 */     GIR_EraseRootFromParent_Done,
     /*  46200 */   // Label 705: @46200
     /*  46200 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46257), // Rule ID 1738 //
     /*  46205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46240 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  46243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46255 */     GIR_RootConstrainSelectedInstOperands,
     /*  46256 */     // GIR_Coverage, 1738,
     /*  46256 */     GIR_EraseRootFromParent_Done,
     /*  46257 */   // Label 706: @46257
     /*  46257 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46314), // Rule ID 1828 //
     /*  46262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46297 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  46300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46312 */     GIR_RootConstrainSelectedInstOperands,
     /*  46313 */     // GIR_Coverage, 1828,
     /*  46313 */     GIR_EraseRootFromParent_Done,
     /*  46314 */   // Label 707: @46314
     /*  46314 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46358), // Rule ID 1869 //
     /*  46319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46345 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46356 */     GIR_RootConstrainSelectedInstOperands,
     /*  46357 */     // GIR_Coverage, 1869,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 708: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46402), // Rule ID 1768 //
     /*  46363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46389 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  46392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46400 */     GIR_RootConstrainSelectedInstOperands,
     /*  46401 */     // GIR_Coverage, 1768,
     /*  46401 */     GIR_EraseRootFromParent_Done,
     /*  46402 */   // Label 709: @46402
     /*  46402 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46446), // Rule ID 1868 //
     /*  46407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46433 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46444 */     GIR_RootConstrainSelectedInstOperands,
     /*  46445 */     // GIR_Coverage, 1868,
     /*  46445 */     GIR_EraseRootFromParent_Done,
     /*  46446 */   // Label 710: @46446
     /*  46446 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46469), // Rule ID 1482 //
     /*  46451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46462 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  46462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  46467 */     GIR_RootConstrainSelectedInstOperands,
     /*  46468 */     // GIR_Coverage, 1482,
     /*  46468 */     GIR_Done,
     /*  46469 */   // Label 711: @46469
     /*  46469 */   GIM_Reject,
     /*  46470 */ // Label 677: @46470
     /*  46470 */ GIM_Reject,
     /*  46471 */ // Label 595: @46471
     /*  46471 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(47961),
     /*  46476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46486 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46618), // Rule ID 5441 //
     /*  46491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46520 */     // MIs[1] Operand 2
     /*  46520 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46539 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46551 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46560 */     // MIs[3] Operand 2
     /*  46560 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46573 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46617 */     // GIR_Coverage, 5441,
     /*  46617 */     GIR_EraseRootFromParent_Done,
     /*  46618 */   // Label 713: @46618
     /*  46618 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46750), // Rule ID 5440 //
     /*  46623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46652 */     // MIs[1] Operand 2
     /*  46652 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46683 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46687 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46692 */     // MIs[3] Operand 2
     /*  46692 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46703 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46705 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46732 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46749 */     // GIR_Coverage, 5440,
     /*  46749 */     GIR_EraseRootFromParent_Done,
     /*  46750 */   // Label 714: @46750
     /*  46750 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46882), // Rule ID 5456 //
     /*  46755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46784 */     // MIs[1] Operand 2
     /*  46784 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46824 */     // MIs[3] Operand 2
     /*  46824 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46837 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  46844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46881 */     // GIR_Coverage, 5456,
     /*  46881 */     GIR_EraseRootFromParent_Done,
     /*  46882 */   // Label 715: @46882
     /*  46882 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47014), // Rule ID 5439 //
     /*  46887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46916 */     // MIs[1] Operand 2
     /*  46916 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46939 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46943 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46947 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46951 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46956 */     // MIs[3] Operand 2
     /*  46956 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46969 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47013 */     // GIR_Coverage, 5439,
     /*  47013 */     GIR_EraseRootFromParent_Done,
     /*  47014 */   // Label 716: @47014
     /*  47014 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47146), // Rule ID 5438 //
     /*  47019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47048 */     // MIs[1] Operand 2
     /*  47048 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  47075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47079 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47083 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47088 */     // MIs[3] Operand 2
     /*  47088 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  47099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47101 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  47121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47128 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47145 */     // GIR_Coverage, 5438,
     /*  47145 */     GIR_EraseRootFromParent_Done,
     /*  47146 */   // Label 717: @47146
     /*  47146 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47305), // Rule ID 5411 //
     /*  47151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  47175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47193 */     // MIs[1] Operand 2
     /*  47193 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47206 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47206 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47209 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47213 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47232 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47239 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47304 */     // GIR_Coverage, 5411,
     /*  47304 */     GIR_EraseRootFromParent_Done,
     /*  47305 */   // Label 718: @47305
     /*  47305 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47464), // Rule ID 5408 //
     /*  47310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  47334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47352 */     // MIs[1] Operand 2
     /*  47352 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47365 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47391 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47398 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47446 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47463 */     // GIR_Coverage, 5408,
     /*  47463 */     GIR_EraseRootFromParent_Done,
     /*  47464 */   // Label 719: @47464
     /*  47464 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47610), // Rule ID 5451 //
     /*  47469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47502 */     // MIs[1] Operand 2
     /*  47502 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47515 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47515 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47518 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47522 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47541 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47548 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47592 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47609 */     // GIR_Coverage, 5451,
     /*  47609 */     GIR_EraseRootFromParent_Done,
     /*  47610 */   // Label 720: @47610
     /*  47610 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47756), // Rule ID 5459 //
     /*  47615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47648 */     // MIs[1] Operand 2
     /*  47648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47661 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47687 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47738 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47755 */     // GIR_Coverage, 5459,
     /*  47755 */     GIR_EraseRootFromParent_Done,
     /*  47756 */   // Label 721: @47756
     /*  47756 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47902), // Rule ID 5450 //
     /*  47761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47794 */     // MIs[1] Operand 2
     /*  47794 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47807 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47807 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47810 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47814 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47833 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47836 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47840 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47884 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47901 */     // GIR_Coverage, 5450,
     /*  47901 */     GIR_EraseRootFromParent_Done,
     /*  47902 */   // Label 722: @47902
     /*  47902 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47937), // Rule ID 971 //
     /*  47907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47928 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  47928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  47931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47935 */     GIR_RootConstrainSelectedInstOperands,
     /*  47936 */     // GIR_Coverage, 971,
     /*  47936 */     GIR_EraseRootFromParent_Done,
     /*  47937 */   // Label 723: @47937
     /*  47937 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47960), // Rule ID 1478 //
     /*  47942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47953 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  47953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  47958 */     GIR_RootConstrainSelectedInstOperands,
     /*  47959 */     // GIR_Coverage, 1478,
     /*  47959 */     GIR_Done,
     /*  47960 */   // Label 724: @47960
     /*  47960 */   GIM_Reject,
     /*  47961 */ // Label 712: @47961
     /*  47961 */ GIM_Reject,
     /*  47962 */ // Label 596: @47962
     /*  47962 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(50421),
     /*  47967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47977 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48091), // Rule ID 2049 //
     /*  47982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48025 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48029 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48033 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48042 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48046 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48050 */     // MIs[4] Operand 1
     /*  48050 */     // No operand predicates
     /*  48050 */     // MIs[2] Operand 2
     /*  48050 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48070 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48089 */     GIR_RootConstrainSelectedInstOperands,
     /*  48090 */     // GIR_Coverage, 2049,
     /*  48090 */     GIR_EraseRootFromParent_Done,
     /*  48091 */   // Label 726: @48091
     /*  48091 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48205), // Rule ID 13749 //
     /*  48096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48147 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48160 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48164 */     // MIs[4] Operand 1
     /*  48164 */     // No operand predicates
     /*  48164 */     // MIs[2] Operand 2
     /*  48164 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48184 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48203 */     GIR_RootConstrainSelectedInstOperands,
     /*  48204 */     // GIR_Coverage, 13749,
     /*  48204 */     GIR_EraseRootFromParent_Done,
     /*  48205 */   // Label 727: @48205
     /*  48205 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48319), // Rule ID 2101 //
     /*  48210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48257 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48261 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48266 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48270 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48274 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48278 */     // MIs[4] Operand 1
     /*  48278 */     // No operand predicates
     /*  48278 */     // MIs[2] Operand 2
     /*  48278 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48298 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48317 */     GIR_RootConstrainSelectedInstOperands,
     /*  48318 */     // GIR_Coverage, 2101,
     /*  48318 */     GIR_EraseRootFromParent_Done,
     /*  48319 */   // Label 728: @48319
     /*  48319 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48433), // Rule ID 13785 //
     /*  48324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48371 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48375 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48380 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48384 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48388 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48392 */     // MIs[4] Operand 1
     /*  48392 */     // No operand predicates
     /*  48392 */     // MIs[2] Operand 2
     /*  48392 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48403 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48412 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48431 */     GIR_RootConstrainSelectedInstOperands,
     /*  48432 */     // GIR_Coverage, 13785,
     /*  48432 */     GIR_EraseRootFromParent_Done,
     /*  48433 */   // Label 729: @48433
     /*  48433 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48498), // Rule ID 1851 //
     /*  48438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48481 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48496 */     GIR_RootConstrainSelectedInstOperands,
     /*  48497 */     // GIR_Coverage, 1851,
     /*  48497 */     GIR_EraseRootFromParent_Done,
     /*  48498 */   // Label 730: @48498
     /*  48498 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48563), // Rule ID 1850 //
     /*  48503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48546 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48561 */     GIR_RootConstrainSelectedInstOperands,
     /*  48562 */     // GIR_Coverage, 1850,
     /*  48562 */     GIR_EraseRootFromParent_Done,
     /*  48563 */   // Label 731: @48563
     /*  48563 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48628), // Rule ID 1761 //
     /*  48568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48611 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  48614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1761,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 732: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48693), // Rule ID 1849 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48676 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48691 */     GIR_RootConstrainSelectedInstOperands,
     /*  48692 */     // GIR_Coverage, 1849,
     /*  48692 */     GIR_EraseRootFromParent_Done,
     /*  48693 */   // Label 733: @48693
     /*  48693 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48758), // Rule ID 1848 //
     /*  48698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48741 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48756 */     GIR_RootConstrainSelectedInstOperands,
     /*  48757 */     // GIR_Coverage, 1848,
     /*  48757 */     GIR_EraseRootFromParent_Done,
     /*  48758 */   // Label 734: @48758
     /*  48758 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48869), // Rule ID 13747 //
     /*  48763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48827 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48831 */     // MIs[4] Operand 1
     /*  48831 */     // No operand predicates
     /*  48831 */     // MIs[2] Operand 2
     /*  48831 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48849 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48867 */     GIR_RootConstrainSelectedInstOperands,
     /*  48868 */     // GIR_Coverage, 13747,
     /*  48868 */     GIR_EraseRootFromParent_Done,
     /*  48869 */   // Label 735: @48869
     /*  48869 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48980), // Rule ID 2047 //
     /*  48874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48926 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48930 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48943 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48947 */     // MIs[4] Operand 1
     /*  48947 */     // No operand predicates
     /*  48947 */     // MIs[2] Operand 2
     /*  48947 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48960 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48978 */     GIR_RootConstrainSelectedInstOperands,
     /*  48979 */     // GIR_Coverage, 2047,
     /*  48979 */     GIR_EraseRootFromParent_Done,
     /*  48980 */   // Label 736: @48980
     /*  48980 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(49091), // Rule ID 13783 //
     /*  48985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49045 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49049 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49053 */     // MIs[4] Operand 1
     /*  49053 */     // No operand predicates
     /*  49053 */     // MIs[2] Operand 2
     /*  49053 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49071 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49089 */     GIR_RootConstrainSelectedInstOperands,
     /*  49090 */     // GIR_Coverage, 13783,
     /*  49090 */     GIR_EraseRootFromParent_Done,
     /*  49091 */   // Label 737: @49091
     /*  49091 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(49202), // Rule ID 2099 //
     /*  49096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49148 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49152 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49157 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49161 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49165 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49169 */     // MIs[4] Operand 1
     /*  49169 */     // No operand predicates
     /*  49169 */     // MIs[2] Operand 2
     /*  49169 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49180 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49182 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49200 */     GIR_RootConstrainSelectedInstOperands,
     /*  49201 */     // GIR_Coverage, 2099,
     /*  49201 */     GIR_EraseRootFromParent_Done,
     /*  49202 */   // Label 738: @49202
     /*  49202 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(49265), // Rule ID 1737 //
     /*  49207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49246 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  49249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49263 */     GIR_RootConstrainSelectedInstOperands,
     /*  49264 */     // GIR_Coverage, 1737,
     /*  49264 */     GIR_EraseRootFromParent_Done,
     /*  49265 */   // Label 739: @49265
     /*  49265 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(49328), // Rule ID 1827 //
     /*  49270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49309 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  49312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49326 */     GIR_RootConstrainSelectedInstOperands,
     /*  49327 */     // GIR_Coverage, 1827,
     /*  49327 */     GIR_EraseRootFromParent_Done,
     /*  49328 */   // Label 740: @49328
     /*  49328 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49416), // Rule ID 13748 //
     /*  49333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49389 */     // MIs[3] Operand 1
     /*  49389 */     // No operand predicates
     /*  49389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49396 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49414 */     GIR_RootConstrainSelectedInstOperands,
     /*  49415 */     // GIR_Coverage, 13748,
     /*  49415 */     GIR_EraseRootFromParent_Done,
     /*  49416 */   // Label 741: @49416
     /*  49416 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49504), // Rule ID 2048 //
     /*  49421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49482 */     // MIs[3] Operand 1
     /*  49482 */     // No operand predicates
     /*  49482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49484 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49502 */     GIR_RootConstrainSelectedInstOperands,
     /*  49503 */     // GIR_Coverage, 2048,
     /*  49503 */     GIR_EraseRootFromParent_Done,
     /*  49504 */   // Label 742: @49504
     /*  49504 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49592), // Rule ID 13784 //
     /*  49509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49565 */     // MIs[3] Operand 1
     /*  49565 */     // No operand predicates
     /*  49565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49572 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49590 */     GIR_RootConstrainSelectedInstOperands,
     /*  49591 */     // GIR_Coverage, 13784,
     /*  49591 */     GIR_EraseRootFromParent_Done,
     /*  49592 */   // Label 743: @49592
     /*  49592 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49680), // Rule ID 2100 //
     /*  49597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49654 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49658 */     // MIs[3] Operand 1
     /*  49658 */     // No operand predicates
     /*  49658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49660 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49678 */     GIR_RootConstrainSelectedInstOperands,
     /*  49679 */     // GIR_Coverage, 2100,
     /*  49679 */     GIR_EraseRootFromParent_Done,
     /*  49680 */   // Label 744: @49680
     /*  49680 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49727), // Rule ID 1867 //
     /*  49685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49713 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49725 */     GIR_RootConstrainSelectedInstOperands,
     /*  49726 */     // GIR_Coverage, 1867,
     /*  49726 */     GIR_EraseRootFromParent_Done,
     /*  49727 */   // Label 745: @49727
     /*  49727 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49774), // Rule ID 1767 //
     /*  49732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49760 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  49763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49772 */     GIR_RootConstrainSelectedInstOperands,
     /*  49773 */     // GIR_Coverage, 1767,
     /*  49773 */     GIR_EraseRootFromParent_Done,
     /*  49774 */   // Label 746: @49774
     /*  49774 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49821), // Rule ID 1866 //
     /*  49779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49807 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49819 */     GIR_RootConstrainSelectedInstOperands,
     /*  49820 */     // GIR_Coverage, 1866,
     /*  49820 */     GIR_EraseRootFromParent_Done,
     /*  49821 */   // Label 747: @49821
     /*  49821 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49880), // Rule ID 1847 //
     /*  49826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49865 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49878 */     GIR_RootConstrainSelectedInstOperands,
     /*  49879 */     // GIR_Coverage, 1847,
     /*  49879 */     GIR_EraseRootFromParent_Done,
     /*  49880 */   // Label 748: @49880
     /*  49880 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49939), // Rule ID 1846 //
     /*  49885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49924 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49937 */     GIR_RootConstrainSelectedInstOperands,
     /*  49938 */     // GIR_Coverage, 1846,
     /*  49938 */     GIR_EraseRootFromParent_Done,
     /*  49939 */   // Label 749: @49939
     /*  49939 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49998), // Rule ID 1760 //
     /*  49944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49983 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  49986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49996 */     GIR_RootConstrainSelectedInstOperands,
     /*  49997 */     // GIR_Coverage, 1760,
     /*  49997 */     GIR_EraseRootFromParent_Done,
     /*  49998 */   // Label 750: @49998
     /*  49998 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(50057), // Rule ID 1845 //
     /*  50003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50042 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50055 */     GIR_RootConstrainSelectedInstOperands,
     /*  50056 */     // GIR_Coverage, 1845,
     /*  50056 */     GIR_EraseRootFromParent_Done,
     /*  50057 */   // Label 751: @50057
     /*  50057 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(50116), // Rule ID 1844 //
     /*  50062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50101 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50114 */     GIR_RootConstrainSelectedInstOperands,
     /*  50115 */     // GIR_Coverage, 1844,
     /*  50115 */     GIR_EraseRootFromParent_Done,
     /*  50116 */   // Label 752: @50116
     /*  50116 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50151), // Rule ID 974 //
     /*  50121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50128 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50134 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50142 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  50142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  50145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50149 */     GIR_RootConstrainSelectedInstOperands,
     /*  50150 */     // GIR_Coverage, 974,
     /*  50150 */     GIR_EraseRootFromParent_Done,
     /*  50151 */   // Label 753: @50151
     /*  50151 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(50208), // Rule ID 1736 //
     /*  50156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50191 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  50194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50206 */     GIR_RootConstrainSelectedInstOperands,
     /*  50207 */     // GIR_Coverage, 1736,
     /*  50207 */     GIR_EraseRootFromParent_Done,
     /*  50208 */   // Label 754: @50208
     /*  50208 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(50265), // Rule ID 1826 //
     /*  50213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50248 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  50251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50263 */     GIR_RootConstrainSelectedInstOperands,
     /*  50264 */     // GIR_Coverage, 1826,
     /*  50264 */     GIR_EraseRootFromParent_Done,
     /*  50265 */   // Label 755: @50265
     /*  50265 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(50309), // Rule ID 1865 //
     /*  50270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50296 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50307 */     GIR_RootConstrainSelectedInstOperands,
     /*  50308 */     // GIR_Coverage, 1865,
     /*  50308 */     GIR_EraseRootFromParent_Done,
     /*  50309 */   // Label 756: @50309
     /*  50309 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50353), // Rule ID 1766 //
     /*  50314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50340 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  50343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50351 */     GIR_RootConstrainSelectedInstOperands,
     /*  50352 */     // GIR_Coverage, 1766,
     /*  50352 */     GIR_EraseRootFromParent_Done,
     /*  50353 */   // Label 757: @50353
     /*  50353 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(50397), // Rule ID 1864 //
     /*  50358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50384 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50395 */     GIR_RootConstrainSelectedInstOperands,
     /*  50396 */     // GIR_Coverage, 1864,
     /*  50396 */     GIR_EraseRootFromParent_Done,
     /*  50397 */   // Label 758: @50397
     /*  50397 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(50420), // Rule ID 1481 //
     /*  50402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50413 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  50413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  50418 */     GIR_RootConstrainSelectedInstOperands,
     /*  50419 */     // GIR_Coverage, 1481,
     /*  50419 */     GIR_Done,
     /*  50420 */   // Label 759: @50420
     /*  50420 */   GIM_Reject,
     /*  50421 */ // Label 725: @50421
     /*  50421 */ GIM_Reject,
     /*  50422 */ // Label 597: @50422
     /*  50422 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(50496),
     /*  50427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50437 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50472), // Rule ID 969 //
     /*  50442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50449 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50455 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50463 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  50463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  50466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50470 */     GIR_RootConstrainSelectedInstOperands,
     /*  50471 */     // GIR_Coverage, 969,
     /*  50471 */     GIR_EraseRootFromParent_Done,
     /*  50472 */   // Label 761: @50472
     /*  50472 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(50495), // Rule ID 1476 //
     /*  50477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50488 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  50493 */     GIR_RootConstrainSelectedInstOperands,
     /*  50494 */     // GIR_Coverage, 1476,
     /*  50494 */     GIR_Done,
     /*  50495 */   // Label 762: @50495
     /*  50495 */   GIM_Reject,
     /*  50496 */ // Label 760: @50496
     /*  50496 */ GIM_Reject,
     /*  50497 */ // Label 598: @50497
     /*  50497 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(51704),
     /*  50502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50512 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50577), // Rule ID 1843 //
     /*  50517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50560 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50575 */     GIR_RootConstrainSelectedInstOperands,
     /*  50576 */     // GIR_Coverage, 1843,
     /*  50576 */     GIR_EraseRootFromParent_Done,
     /*  50577 */   // Label 764: @50577
     /*  50577 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50642), // Rule ID 1842 //
     /*  50582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50625 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50640 */     GIR_RootConstrainSelectedInstOperands,
     /*  50641 */     // GIR_Coverage, 1842,
     /*  50641 */     GIR_EraseRootFromParent_Done,
     /*  50642 */   // Label 765: @50642
     /*  50642 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50707), // Rule ID 1759 //
     /*  50647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50690 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  50693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50705 */     GIR_RootConstrainSelectedInstOperands,
     /*  50706 */     // GIR_Coverage, 1759,
     /*  50706 */     GIR_EraseRootFromParent_Done,
     /*  50707 */   // Label 766: @50707
     /*  50707 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50772), // Rule ID 1841 //
     /*  50712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50755 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50770 */     GIR_RootConstrainSelectedInstOperands,
     /*  50771 */     // GIR_Coverage, 1841,
     /*  50771 */     GIR_EraseRootFromParent_Done,
     /*  50772 */   // Label 767: @50772
     /*  50772 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50837), // Rule ID 1840 //
     /*  50777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50820 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50835 */     GIR_RootConstrainSelectedInstOperands,
     /*  50836 */     // GIR_Coverage, 1840,
     /*  50836 */     GIR_EraseRootFromParent_Done,
     /*  50837 */   // Label 768: @50837
     /*  50837 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50900), // Rule ID 1735 //
     /*  50842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50881 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  50884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50898 */     GIR_RootConstrainSelectedInstOperands,
     /*  50899 */     // GIR_Coverage, 1735,
     /*  50899 */     GIR_EraseRootFromParent_Done,
     /*  50900 */   // Label 769: @50900
     /*  50900 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50963), // Rule ID 1825 //
     /*  50905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50944 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  50947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50961 */     GIR_RootConstrainSelectedInstOperands,
     /*  50962 */     // GIR_Coverage, 1825,
     /*  50962 */     GIR_EraseRootFromParent_Done,
     /*  50963 */   // Label 770: @50963
     /*  50963 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(51010), // Rule ID 1863 //
     /*  50968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50996 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51008 */     GIR_RootConstrainSelectedInstOperands,
     /*  51009 */     // GIR_Coverage, 1863,
     /*  51009 */     GIR_EraseRootFromParent_Done,
     /*  51010 */   // Label 771: @51010
     /*  51010 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(51057), // Rule ID 1765 //
     /*  51015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51043 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  51046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51055 */     GIR_RootConstrainSelectedInstOperands,
     /*  51056 */     // GIR_Coverage, 1765,
     /*  51056 */     GIR_EraseRootFromParent_Done,
     /*  51057 */   // Label 772: @51057
     /*  51057 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(51104), // Rule ID 1862 //
     /*  51062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51090 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  51093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51102 */     GIR_RootConstrainSelectedInstOperands,
     /*  51103 */     // GIR_Coverage, 1862,
     /*  51103 */     GIR_EraseRootFromParent_Done,
     /*  51104 */   // Label 773: @51104
     /*  51104 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(51163), // Rule ID 1839 //
     /*  51109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51148 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51161 */     GIR_RootConstrainSelectedInstOperands,
     /*  51162 */     // GIR_Coverage, 1839,
     /*  51162 */     GIR_EraseRootFromParent_Done,
     /*  51163 */   // Label 774: @51163
     /*  51163 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(51222), // Rule ID 1838 //
     /*  51168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51207 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51220 */     GIR_RootConstrainSelectedInstOperands,
     /*  51221 */     // GIR_Coverage, 1838,
     /*  51221 */     GIR_EraseRootFromParent_Done,
     /*  51222 */   // Label 775: @51222
     /*  51222 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(51281), // Rule ID 1758 //
     /*  51227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51266 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  51269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51279 */     GIR_RootConstrainSelectedInstOperands,
     /*  51280 */     // GIR_Coverage, 1758,
     /*  51280 */     GIR_EraseRootFromParent_Done,
     /*  51281 */   // Label 776: @51281
     /*  51281 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(51340), // Rule ID 1837 //
     /*  51286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51325 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51338 */     GIR_RootConstrainSelectedInstOperands,
     /*  51339 */     // GIR_Coverage, 1837,
     /*  51339 */     GIR_EraseRootFromParent_Done,
     /*  51340 */   // Label 777: @51340
     /*  51340 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(51399), // Rule ID 1836 //
     /*  51345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51384 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51397 */     GIR_RootConstrainSelectedInstOperands,
     /*  51398 */     // GIR_Coverage, 1836,
     /*  51398 */     GIR_EraseRootFromParent_Done,
     /*  51399 */   // Label 778: @51399
     /*  51399 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(51434), // Rule ID 972 //
     /*  51404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51425 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  51425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  51428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51432 */     GIR_RootConstrainSelectedInstOperands,
     /*  51433 */     // GIR_Coverage, 972,
     /*  51433 */     GIR_EraseRootFromParent_Done,
     /*  51434 */   // Label 779: @51434
     /*  51434 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(51491), // Rule ID 1734 //
     /*  51439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  51454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51474 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  51477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51489 */     GIR_RootConstrainSelectedInstOperands,
     /*  51490 */     // GIR_Coverage, 1734,
     /*  51490 */     GIR_EraseRootFromParent_Done,
     /*  51491 */   // Label 780: @51491
     /*  51491 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(51548), // Rule ID 1824 //
     /*  51496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  51511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51531 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  51534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51546 */     GIR_RootConstrainSelectedInstOperands,
     /*  51547 */     // GIR_Coverage, 1824,
     /*  51547 */     GIR_EraseRootFromParent_Done,
     /*  51548 */   // Label 781: @51548
     /*  51548 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(51592), // Rule ID 1861 //
     /*  51553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51579 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51590 */     GIR_RootConstrainSelectedInstOperands,
     /*  51591 */     // GIR_Coverage, 1861,
     /*  51591 */     GIR_EraseRootFromParent_Done,
     /*  51592 */   // Label 782: @51592
     /*  51592 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(51636), // Rule ID 1764 //
     /*  51597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51623 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  51626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51634 */     GIR_RootConstrainSelectedInstOperands,
     /*  51635 */     // GIR_Coverage, 1764,
     /*  51635 */     GIR_EraseRootFromParent_Done,
     /*  51636 */   // Label 783: @51636
     /*  51636 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(51680), // Rule ID 1860 //
     /*  51641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51667 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51678 */     GIR_RootConstrainSelectedInstOperands,
     /*  51679 */     // GIR_Coverage, 1860,
     /*  51679 */     GIR_EraseRootFromParent_Done,
     /*  51680 */   // Label 784: @51680
     /*  51680 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(51703), // Rule ID 1479 //
     /*  51685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51696 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  51696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  51701 */     GIR_RootConstrainSelectedInstOperands,
     /*  51702 */     // GIR_Coverage, 1479,
     /*  51702 */     GIR_Done,
     /*  51703 */   // Label 785: @51703
     /*  51703 */   GIM_Reject,
     /*  51704 */ // Label 763: @51704
     /*  51704 */ GIM_Reject,
     /*  51705 */ // Label 599: @51705
     /*  51705 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(51779),
     /*  51710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  51713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51720 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(51755), // Rule ID 970 //
     /*  51725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51732 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51738 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51746 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  51746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  51749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51753 */     GIR_RootConstrainSelectedInstOperands,
     /*  51754 */     // GIR_Coverage, 970,
     /*  51754 */     GIR_EraseRootFromParent_Done,
     /*  51755 */   // Label 787: @51755
     /*  51755 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(51778), // Rule ID 1477 //
     /*  51760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51771 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  51776 */     GIR_RootConstrainSelectedInstOperands,
     /*  51777 */     // GIR_Coverage, 1477,
     /*  51777 */     GIR_Done,
     /*  51778 */   // Label 788: @51778
     /*  51778 */   GIM_Reject,
     /*  51779 */ // Label 786: @51779
     /*  51779 */ GIM_Reject,
     /*  51780 */ // Label 600: @51780
     /*  51780 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(51805), // Rule ID 7537 //
     /*  51785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  51791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  51794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51798 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  51798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  51803 */   GIR_RootConstrainSelectedInstOperands,
     /*  51804 */   // GIR_Coverage, 7537,
     /*  51804 */   GIR_Done,
     /*  51805 */ // Label 789: @51805
     /*  51805 */ GIM_Reject,
     /*  51806 */ // Label 601: @51806
     /*  51806 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(51831), // Rule ID 7536 //
     /*  51811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  51817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  51820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51824 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  51824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  51829 */   GIR_RootConstrainSelectedInstOperands,
     /*  51830 */   // GIR_Coverage, 7536,
     /*  51830 */   GIR_Done,
     /*  51831 */ // Label 790: @51831
     /*  51831 */ GIM_Reject,
     /*  51832 */ // Label 602: @51832
     /*  51832 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(51857), // Rule ID 7535 //
     /*  51837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  51843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  51846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51850 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  51850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  51855 */   GIR_RootConstrainSelectedInstOperands,
     /*  51856 */   // GIR_Coverage, 7535,
     /*  51856 */   GIR_Done,
     /*  51857 */ // Label 791: @51857
     /*  51857 */ GIM_Reject,
     /*  51858 */ // Label 603: @51858
     /*  51858 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(51883), // Rule ID 7534 //
     /*  51863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  51869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  51872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51876 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  51876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  51881 */   GIR_RootConstrainSelectedInstOperands,
     /*  51882 */   // GIR_Coverage, 7534,
     /*  51882 */   GIR_Done,
     /*  51883 */ // Label 792: @51883
     /*  51883 */ GIM_Reject,
     /*  51884 */ // Label 604: @51884
     /*  51884 */ GIM_Reject,
     /*  51885 */ // Label 2: @51885
     /*  51885 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 801*/ GIMT_Encode4(54649),
     /*  51896 */ /*GILLT_s32*//*Label 793*/ GIMT_Encode4(51936),
     /*  51900 */ /*GILLT_s64*//*Label 794*/ GIMT_Encode4(52093), GIMT_Encode4(0),
     /*  51908 */ /*GILLT_v2s32*//*Label 795*/ GIMT_Encode4(53573), GIMT_Encode4(0),
     /*  51916 */ /*GILLT_v4s16*//*Label 796*/ GIMT_Encode4(53911),
     /*  51920 */ /*GILLT_v4s32*//*Label 797*/ GIMT_Encode4(54249),
     /*  51924 */ /*GILLT_v8s8*//*Label 798*/ GIMT_Encode4(54415),
     /*  51928 */ /*GILLT_v8s16*//*Label 799*/ GIMT_Encode4(54449),
     /*  51932 */ /*GILLT_v16s8*//*Label 800*/ GIMT_Encode4(54615),
     /*  51936 */ // Label 793: @51936
     /*  51936 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(52092),
     /*  51941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  51947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51951 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(52006), // Rule ID 3988 //
     /*  51956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51987 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52004 */     GIR_RootConstrainSelectedInstOperands,
     /*  52005 */     // GIR_Coverage, 3988,
     /*  52005 */     GIR_EraseRootFromParent_Done,
     /*  52006 */   // Label 803: @52006
     /*  52006 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(52061), // Rule ID 14043 //
     /*  52011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52042 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  52045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52059 */     GIR_RootConstrainSelectedInstOperands,
     /*  52060 */     // GIR_Coverage, 14043,
     /*  52060 */     GIR_EraseRootFromParent_Done,
     /*  52061 */   // Label 804: @52061
     /*  52061 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(52091), // Rule ID 3984 //
     /*  52066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52074 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  52077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52089 */     GIR_RootConstrainSelectedInstOperands,
     /*  52090 */     // GIR_Coverage, 3984,
     /*  52090 */     GIR_EraseRootFromParent_Done,
     /*  52091 */   // Label 805: @52091
     /*  52091 */   GIM_Reject,
     /*  52092 */ // Label 802: @52092
     /*  52092 */ GIM_Reject,
     /*  52093 */ // Label 794: @52093
     /*  52093 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(53572),
     /*  52098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52108 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52254), // Rule ID 3993 //
     /*  52113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52134 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52166 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52179 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52191 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52219 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52252 */     GIR_RootConstrainSelectedInstOperands,
     /*  52253 */     // GIR_Coverage, 3993,
     /*  52253 */     GIR_EraseRootFromParent_Done,
     /*  52254 */   // Label 807: @52254
     /*  52254 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52358), // Rule ID 3994 //
     /*  52259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52280 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52310 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52356 */     GIR_RootConstrainSelectedInstOperands,
     /*  52357 */     // GIR_Coverage, 3994,
     /*  52357 */     GIR_EraseRootFromParent_Done,
     /*  52358 */   // Label 808: @52358
     /*  52358 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52462), // Rule ID 14046 //
     /*  52363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52401 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52414 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52426 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52460 */     GIR_RootConstrainSelectedInstOperands,
     /*  52461 */     // GIR_Coverage, 14046,
     /*  52461 */     GIR_EraseRootFromParent_Done,
     /*  52462 */   // Label 809: @52462
     /*  52462 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52517), // Rule ID 3989 //
     /*  52467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52498 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52515 */     GIR_RootConstrainSelectedInstOperands,
     /*  52516 */     // GIR_Coverage, 3989,
     /*  52516 */     GIR_EraseRootFromParent_Done,
     /*  52517 */   // Label 810: @52517
     /*  52517 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52572), // Rule ID 14044 //
     /*  52522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52542 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52553 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52570 */     GIR_RootConstrainSelectedInstOperands,
     /*  52571 */     // GIR_Coverage, 14044,
     /*  52571 */     GIR_EraseRootFromParent_Done,
     /*  52572 */   // Label 811: @52572
     /*  52572 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52685), // Rule ID 4000 //
     /*  52577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52594 */     // MIs[1] Operand 2
     /*  52594 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52617 */     // MIs[2] Operand 1
     /*  52617 */     // No operand predicates
     /*  52617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52619 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52631 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52650 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52683 */     GIR_RootConstrainSelectedInstOperands,
     /*  52684 */     // GIR_Coverage, 4000,
     /*  52684 */     GIR_EraseRootFromParent_Done,
     /*  52685 */   // Label 812: @52685
     /*  52685 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52760), // Rule ID 3998 //
     /*  52690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52719 */     // MIs[2] Operand 1
     /*  52719 */     // No operand predicates
     /*  52719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52721 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52733 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52758 */     GIR_RootConstrainSelectedInstOperands,
     /*  52759 */     // GIR_Coverage, 3998,
     /*  52759 */     GIR_EraseRootFromParent_Done,
     /*  52760 */   // Label 813: @52760
     /*  52760 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52835), // Rule ID 3999 //
     /*  52765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  52794 */     // MIs[2] Operand 1
     /*  52794 */     // No operand predicates
     /*  52794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52796 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52808 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52833 */     GIR_RootConstrainSelectedInstOperands,
     /*  52834 */     // GIR_Coverage, 3999,
     /*  52834 */     GIR_EraseRootFromParent_Done,
     /*  52835 */   // Label 814: @52835
     /*  52835 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52973), // Rule ID 3990 //
     /*  52840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52857 */     // MIs[1] Operand 2
     /*  52857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52885 */     // MIs[2] Operand 2
     /*  52885 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  52896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52898 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52910 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52938 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52971 */     GIR_RootConstrainSelectedInstOperands,
     /*  52972 */     // GIR_Coverage, 3990,
     /*  52972 */     GIR_EraseRootFromParent_Done,
     /*  52973 */   // Label 815: @52973
     /*  52973 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(53073), // Rule ID 3991 //
     /*  52978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52995 */     // MIs[1] Operand 2
     /*  52995 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  53006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53025 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53071 */     GIR_RootConstrainSelectedInstOperands,
     /*  53072 */     // GIR_Coverage, 3991,
     /*  53072 */     GIR_EraseRootFromParent_Done,
     /*  53073 */   // Label 816: @53073
     /*  53073 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(53173), // Rule ID 14045 //
     /*  53078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  53103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53112 */     // MIs[2] Operand 2
     /*  53112 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  53123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53125 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53137 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53171 */     GIR_RootConstrainSelectedInstOperands,
     /*  53172 */     // GIR_Coverage, 14045,
     /*  53172 */     GIR_EraseRootFromParent_Done,
     /*  53173 */   // Label 817: @53173
     /*  53173 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(53235), // Rule ID 3992 //
     /*  53178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53214 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53233 */     GIR_RootConstrainSelectedInstOperands,
     /*  53234 */     // GIR_Coverage, 3992,
     /*  53234 */     GIR_EraseRootFromParent_Done,
     /*  53235 */   // Label 818: @53235
     /*  53235 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(53297), // Rule ID 3995 //
     /*  53240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53276 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53295 */     GIR_RootConstrainSelectedInstOperands,
     /*  53296 */     // GIR_Coverage, 3995,
     /*  53296 */     GIR_EraseRootFromParent_Done,
     /*  53297 */   // Label 819: @53297
     /*  53297 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(53374), // Rule ID 4019 //
     /*  53302 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53326 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53372 */     GIR_RootConstrainSelectedInstOperands,
     /*  53373 */     // GIR_Coverage, 4019,
     /*  53373 */     GIR_EraseRootFromParent_Done,
     /*  53374 */   // Label 820: @53374
     /*  53374 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(53451), // Rule ID 14057 //
     /*  53379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53396 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53403 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53415 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53449 */     GIR_RootConstrainSelectedInstOperands,
     /*  53450 */     // GIR_Coverage, 14057,
     /*  53450 */     GIR_EraseRootFromParent_Done,
     /*  53451 */   // Label 821: @53451
     /*  53451 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(53541), // Rule ID 4018 //
     /*  53456 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53461 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53466 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  53466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  53469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53478 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  53484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  53533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53539 */     GIR_RootConstrainSelectedInstOperands,
     /*  53540 */     // GIR_Coverage, 4018,
     /*  53540 */     GIR_EraseRootFromParent_Done,
     /*  53541 */   // Label 822: @53541
     /*  53541 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(53571), // Rule ID 3985 //
     /*  53546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53554 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  53554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  53557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  53563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53569 */     GIR_RootConstrainSelectedInstOperands,
     /*  53570 */     // GIR_Coverage, 3985,
     /*  53570 */     GIR_EraseRootFromParent_Done,
     /*  53571 */   // Label 823: @53571
     /*  53571 */   GIM_Reject,
     /*  53572 */ // Label 806: @53572
     /*  53572 */ GIM_Reject,
     /*  53573 */ // Label 795: @53573
     /*  53573 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(53910),
     /*  53578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  53581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53588 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53674), // Rule ID 13726 //
     /*  53593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53641 */     // MIs[3] Operand 1
     /*  53641 */     // No operand predicates
     /*  53641 */     // MIs[1] Operand 2
     /*  53641 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53658 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53672 */     GIR_RootConstrainSelectedInstOperands,
     /*  53673 */     // GIR_Coverage, 13726,
     /*  53673 */     GIR_EraseRootFromParent_Done,
     /*  53674 */   // Label 825: @53674
     /*  53674 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53760), // Rule ID 2038 //
     /*  53679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53727 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53731 */     // MIs[3] Operand 1
     /*  53731 */     // No operand predicates
     /*  53731 */     // MIs[1] Operand 2
     /*  53731 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53744 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53758 */     GIR_RootConstrainSelectedInstOperands,
     /*  53759 */     // GIR_Coverage, 2038,
     /*  53759 */     GIR_EraseRootFromParent_Done,
     /*  53760 */   // Label 826: @53760
     /*  53760 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53823), // Rule ID 13727 //
     /*  53765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53801 */     // MIs[2] Operand 1
     /*  53801 */     // No operand predicates
     /*  53801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53807 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 13727,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 827: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53886), // Rule ID 2039 //
     /*  53828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53868 */     // MIs[2] Operand 1
     /*  53868 */     // No operand predicates
     /*  53868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53870 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53884 */     GIR_RootConstrainSelectedInstOperands,
     /*  53885 */     // GIR_Coverage, 2039,
     /*  53885 */     GIR_EraseRootFromParent_Done,
     /*  53886 */   // Label 828: @53886
     /*  53886 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53909), // Rule ID 1356 //
     /*  53891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53902 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  53902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  53907 */     GIR_RootConstrainSelectedInstOperands,
     /*  53908 */     // GIR_Coverage, 1356,
     /*  53908 */     GIR_Done,
     /*  53909 */   // Label 829: @53909
     /*  53909 */   GIM_Reject,
     /*  53910 */ // Label 824: @53910
     /*  53910 */ GIM_Reject,
     /*  53911 */ // Label 796: @53911
     /*  53911 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(54248),
     /*  53916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  53919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(54012), // Rule ID 13723 //
     /*  53931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53979 */     // MIs[3] Operand 1
     /*  53979 */     // No operand predicates
     /*  53979 */     // MIs[1] Operand 2
     /*  53979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53996 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  53999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  54007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  54010 */     GIR_RootConstrainSelectedInstOperands,
     /*  54011 */     // GIR_Coverage, 13723,
     /*  54011 */     GIR_EraseRootFromParent_Done,
     /*  54012 */   // Label 831: @54012
     /*  54012 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(54098), // Rule ID 2035 //
     /*  54017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  54032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54069 */     // MIs[3] Operand 1
     /*  54069 */     // No operand predicates
     /*  54069 */     // MIs[1] Operand 2
     /*  54069 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  54080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54082 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  54093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  54096 */     GIR_RootConstrainSelectedInstOperands,
     /*  54097 */     // GIR_Coverage, 2035,
     /*  54097 */     GIR_EraseRootFromParent_Done,
     /*  54098 */   // Label 832: @54098
     /*  54098 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54161), // Rule ID 13724 //
     /*  54103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54139 */     // MIs[2] Operand 1
     /*  54139 */     // No operand predicates
     /*  54139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54145 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54159 */     GIR_RootConstrainSelectedInstOperands,
     /*  54160 */     // GIR_Coverage, 13724,
     /*  54160 */     GIR_EraseRootFromParent_Done,
     /*  54161 */   // Label 833: @54161
     /*  54161 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(54224), // Rule ID 2036 //
     /*  54166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54202 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54206 */     // MIs[2] Operand 1
     /*  54206 */     // No operand predicates
     /*  54206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54208 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54222 */     GIR_RootConstrainSelectedInstOperands,
     /*  54223 */     // GIR_Coverage, 2036,
     /*  54223 */     GIR_EraseRootFromParent_Done,
     /*  54224 */   // Label 834: @54224
     /*  54224 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(54247), // Rule ID 1354 //
     /*  54229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54240 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  54240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  54245 */     GIR_RootConstrainSelectedInstOperands,
     /*  54246 */     // GIR_Coverage, 1354,
     /*  54246 */     GIR_Done,
     /*  54247 */   // Label 835: @54247
     /*  54247 */   GIM_Reject,
     /*  54248 */ // Label 830: @54248
     /*  54248 */ GIM_Reject,
     /*  54249 */ // Label 797: @54249
     /*  54249 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(54414),
     /*  54254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54264 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(54327), // Rule ID 13728 //
     /*  54269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54305 */     // MIs[2] Operand 1
     /*  54305 */     // No operand predicates
     /*  54305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54311 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54325 */     GIR_RootConstrainSelectedInstOperands,
     /*  54326 */     // GIR_Coverage, 13728,
     /*  54326 */     GIR_EraseRootFromParent_Done,
     /*  54327 */   // Label 837: @54327
     /*  54327 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(54390), // Rule ID 2040 //
     /*  54332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54372 */     // MIs[2] Operand 1
     /*  54372 */     // No operand predicates
     /*  54372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54374 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54388 */     GIR_RootConstrainSelectedInstOperands,
     /*  54389 */     // GIR_Coverage, 2040,
     /*  54389 */     GIR_EraseRootFromParent_Done,
     /*  54390 */   // Label 838: @54390
     /*  54390 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(54413), // Rule ID 1357 //
     /*  54395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54406 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  54406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  54411 */     GIR_RootConstrainSelectedInstOperands,
     /*  54412 */     // GIR_Coverage, 1357,
     /*  54412 */     GIR_Done,
     /*  54413 */   // Label 839: @54413
     /*  54413 */   GIM_Reject,
     /*  54414 */ // Label 836: @54414
     /*  54414 */ GIM_Reject,
     /*  54415 */ // Label 798: @54415
     /*  54415 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(54448), // Rule ID 1352 //
     /*  54420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  54426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54441 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  54441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  54446 */   GIR_RootConstrainSelectedInstOperands,
     /*  54447 */   // GIR_Coverage, 1352,
     /*  54447 */   GIR_Done,
     /*  54448 */ // Label 840: @54448
     /*  54448 */ GIM_Reject,
     /*  54449 */ // Label 799: @54449
     /*  54449 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(54614),
     /*  54454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54464 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(54527), // Rule ID 13725 //
     /*  54469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54505 */     // MIs[2] Operand 1
     /*  54505 */     // No operand predicates
     /*  54505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54511 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54525 */     GIR_RootConstrainSelectedInstOperands,
     /*  54526 */     // GIR_Coverage, 13725,
     /*  54526 */     GIR_EraseRootFromParent_Done,
     /*  54527 */   // Label 842: @54527
     /*  54527 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(54590), // Rule ID 2037 //
     /*  54532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54572 */     // MIs[2] Operand 1
     /*  54572 */     // No operand predicates
     /*  54572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54574 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54588 */     GIR_RootConstrainSelectedInstOperands,
     /*  54589 */     // GIR_Coverage, 2037,
     /*  54589 */     GIR_EraseRootFromParent_Done,
     /*  54590 */   // Label 843: @54590
     /*  54590 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(54613), // Rule ID 1355 //
     /*  54595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54606 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  54606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  54611 */     GIR_RootConstrainSelectedInstOperands,
     /*  54612 */     // GIR_Coverage, 1355,
     /*  54612 */     GIR_Done,
     /*  54613 */   // Label 844: @54613
     /*  54613 */   GIM_Reject,
     /*  54614 */ // Label 841: @54614
     /*  54614 */ GIM_Reject,
     /*  54615 */ // Label 800: @54615
     /*  54615 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(54648), // Rule ID 1353 //
     /*  54620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  54629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54641 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  54641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  54646 */   GIR_RootConstrainSelectedInstOperands,
     /*  54647 */   // GIR_Coverage, 1353,
     /*  54647 */   GIR_Done,
     /*  54648 */ // Label 845: @54648
     /*  54648 */ GIM_Reject,
     /*  54649 */ // Label 801: @54649
     /*  54649 */ GIM_Reject,
     /*  54650 */ // Label 3: @54650
     /*  54650 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 848*/ GIMT_Encode4(54731),
     /*  54661 */ /*GILLT_s32*//*Label 846*/ GIMT_Encode4(54669),
     /*  54665 */ /*GILLT_s64*//*Label 847*/ GIMT_Encode4(54700),
     /*  54669 */ // Label 846: @54669
     /*  54669 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(54699), // Rule ID 117 //
     /*  54674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54692 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  54697 */   GIR_RootConstrainSelectedInstOperands,
     /*  54698 */   // GIR_Coverage, 117,
     /*  54698 */   GIR_Done,
     /*  54699 */ // Label 849: @54699
     /*  54699 */ GIM_Reject,
     /*  54700 */ // Label 847: @54700
     /*  54700 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(54730), // Rule ID 118 //
     /*  54705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54723 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  54728 */   GIR_RootConstrainSelectedInstOperands,
     /*  54729 */   // GIR_Coverage, 118,
     /*  54729 */   GIR_Done,
     /*  54730 */ // Label 850: @54730
     /*  54730 */ GIM_Reject,
     /*  54731 */ // Label 848: @54731
     /*  54731 */ GIM_Reject,
     /*  54732 */ // Label 4: @54732
     /*  54732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 853*/ GIMT_Encode4(54813),
     /*  54743 */ /*GILLT_s32*//*Label 851*/ GIMT_Encode4(54751),
     /*  54747 */ /*GILLT_s64*//*Label 852*/ GIMT_Encode4(54782),
     /*  54751 */ // Label 851: @54751
     /*  54751 */ GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(54781), // Rule ID 115 //
     /*  54756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54774 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  54779 */   GIR_RootConstrainSelectedInstOperands,
     /*  54780 */   // GIR_Coverage, 115,
     /*  54780 */   GIR_Done,
     /*  54781 */ // Label 854: @54781
     /*  54781 */ GIM_Reject,
     /*  54782 */ // Label 852: @54782
     /*  54782 */ GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(54812), // Rule ID 116 //
     /*  54787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54805 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  54810 */   GIR_RootConstrainSelectedInstOperands,
     /*  54811 */   // GIR_Coverage, 116,
     /*  54811 */   GIR_Done,
     /*  54812 */ // Label 855: @54812
     /*  54812 */ GIM_Reject,
     /*  54813 */ // Label 853: @54813
     /*  54813 */ GIM_Reject,
     /*  54814 */ // Label 5: @54814
     /*  54814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 874*/ GIMT_Encode4(62559),
     /*  54825 */ /*GILLT_s32*//*Label 856*/ GIMT_Encode4(54913),
     /*  54829 */ /*GILLT_s64*//*Label 857*/ GIMT_Encode4(55411), GIMT_Encode4(0),
     /*  54837 */ /*GILLT_v2s32*//*Label 858*/ GIMT_Encode4(56846),
     /*  54841 */ /*GILLT_v2s64*//*Label 859*/ GIMT_Encode4(57006),
     /*  54845 */ /*GILLT_v4s16*//*Label 860*/ GIMT_Encode4(57166),
     /*  54849 */ /*GILLT_v4s32*//*Label 861*/ GIMT_Encode4(57326),
     /*  54853 */ /*GILLT_v8s8*//*Label 862*/ GIMT_Encode4(57486),
     /*  54857 */ /*GILLT_v8s16*//*Label 863*/ GIMT_Encode4(57646),
     /*  54861 */ /*GILLT_v16s8*//*Label 864*/ GIMT_Encode4(57806),
     /*  54865 */ /*GILLT_nxv1s1*//*Label 865*/ GIMT_Encode4(57966),
     /*  54869 */ /*GILLT_nxv2s1*//*Label 866*/ GIMT_Encode4(58507), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  54881 */ /*GILLT_nxv2s64*//*Label 867*/ GIMT_Encode4(59048),
     /*  54885 */ /*GILLT_nxv4s1*//*Label 868*/ GIMT_Encode4(59520), GIMT_Encode4(0),
     /*  54893 */ /*GILLT_nxv4s32*//*Label 869*/ GIMT_Encode4(60061),
     /*  54897 */ /*GILLT_nxv8s1*//*Label 870*/ GIMT_Encode4(60533),
     /*  54901 */ /*GILLT_nxv8s16*//*Label 871*/ GIMT_Encode4(61074),
     /*  54905 */ /*GILLT_nxv16s1*//*Label 872*/ GIMT_Encode4(61546),
     /*  54909 */ /*GILLT_nxv16s8*//*Label 873*/ GIMT_Encode4(62087),
     /*  54913 */ // Label 856: @54913
     /*  54913 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(55410),
     /*  54918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54924 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54979), // Rule ID 13479 //
     /*  54929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  54966 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  54966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  54969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54977 */     GIR_RootConstrainSelectedInstOperands,
     /*  54978 */     // GIR_Coverage, 13479,
     /*  54978 */     GIR_EraseRootFromParent_Done,
     /*  54979 */   // Label 876: @54979
     /*  54979 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(55034), // Rule ID 162 //
     /*  54984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55021 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  55024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55032 */     GIR_RootConstrainSelectedInstOperands,
     /*  55033 */     // GIR_Coverage, 162,
     /*  55033 */     GIR_EraseRootFromParent_Done,
     /*  55034 */   // Label 877: @55034
     /*  55034 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55103), // Rule ID 5710 //
     /*  55039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55076 */     // MIs[2] Operand 1
     /*  55076 */     // No operand predicates
     /*  55076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55089 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 5710,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 878: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55172), // Rule ID 5711 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55145 */     // MIs[2] Operand 1
     /*  55145 */     // No operand predicates
     /*  55145 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55158 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  55158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55170 */     GIR_RootConstrainSelectedInstOperands,
     /*  55171 */     // GIR_Coverage, 5711,
     /*  55171 */     GIR_EraseRootFromParent_Done,
     /*  55172 */   // Label 879: @55172
     /*  55172 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55225), // Rule ID 13477 //
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55202 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55212 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55223 */     GIR_RootConstrainSelectedInstOperands,
     /*  55224 */     // GIR_Coverage, 13477,
     /*  55224 */     GIR_EraseRootFromParent_Done,
     /*  55225 */   // Label 880: @55225
     /*  55225 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55278), // Rule ID 160 //
     /*  55230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55265 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55276 */     GIR_RootConstrainSelectedInstOperands,
     /*  55277 */     // GIR_Coverage, 160,
     /*  55277 */     GIR_EraseRootFromParent_Done,
     /*  55278 */   // Label 881: @55278
     /*  55278 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55319), // Rule ID 142 //
     /*  55283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  55287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55299 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  55303 */     // MIs[1] Operand 1
     /*  55303 */     // No operand predicates
     /*  55303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55305 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  55305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  55308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55312 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  55317 */     GIR_RootConstrainSelectedInstOperands,
     /*  55318 */     // GIR_Coverage, 142,
     /*  55318 */     GIR_EraseRootFromParent_Done,
     /*  55319 */   // Label 882: @55319
     /*  55319 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55352), // Rule ID 13475 //
     /*  55324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55339 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55350 */     GIR_RootConstrainSelectedInstOperands,
     /*  55351 */     // GIR_Coverage, 13475,
     /*  55351 */     GIR_EraseRootFromParent_Done,
     /*  55352 */   // Label 883: @55352
     /*  55352 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55385), // Rule ID 158 //
     /*  55357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55372 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55383 */     GIR_RootConstrainSelectedInstOperands,
     /*  55384 */     // GIR_Coverage, 158,
     /*  55384 */     GIR_EraseRootFromParent_Done,
     /*  55385 */   // Label 884: @55385
     /*  55385 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55409), // Rule ID 156 //
     /*  55390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55402 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  55407 */     GIR_RootConstrainSelectedInstOperands,
     /*  55408 */     // GIR_Coverage, 156,
     /*  55408 */     GIR_Done,
     /*  55409 */   // Label 885: @55409
     /*  55409 */   GIM_Reject,
     /*  55410 */ // Label 875: @55410
     /*  55410 */ GIM_Reject,
     /*  55411 */ // Label 857: @55411
     /*  55411 */ GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(56845),
     /*  55416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  55419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55422 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55477), // Rule ID 13480 //
     /*  55427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55447 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55464 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55475 */     GIR_RootConstrainSelectedInstOperands,
     /*  55476 */     // GIR_Coverage, 13480,
     /*  55476 */     GIR_EraseRootFromParent_Done,
     /*  55477 */   // Label 887: @55477
     /*  55477 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55532), // Rule ID 163 //
     /*  55482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55506 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55519 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55530 */     GIR_RootConstrainSelectedInstOperands,
     /*  55531 */     // GIR_Coverage, 163,
     /*  55531 */     GIR_EraseRootFromParent_Done,
     /*  55532 */   // Label 888: @55532
     /*  55532 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55645), // Rule ID 5712 //
     /*  55537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55582 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55586 */     // MIs[3] Operand 1
     /*  55586 */     // No operand predicates
     /*  55586 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55599 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  55599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55644 */     // GIR_Coverage, 5712,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 889: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55758), // Rule ID 5713 //
     /*  55650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55695 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55699 */     // MIs[3] Operand 1
     /*  55699 */     // No operand predicates
     /*  55699 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55712 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  55712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55757 */     // GIR_Coverage, 5713,
     /*  55757 */     GIR_EraseRootFromParent_Done,
     /*  55758 */   // Label 890: @55758
     /*  55758 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55857), // Rule ID 7186 //
     /*  55763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55775 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55778 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55783 */     // MIs[1] addr
     /*  55783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55792 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  55796 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55809 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  55816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55825 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55856 */     // GIR_Coverage, 7186,
     /*  55856 */     GIR_EraseRootFromParent_Done,
     /*  55857 */   // Label 891: @55857
     /*  55857 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55956), // Rule ID 7187 //
     /*  55862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55874 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55877 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55882 */     // MIs[1] addr
     /*  55882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55891 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  55895 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55908 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  55915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55924 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55955 */     // GIR_Coverage, 7187,
     /*  55955 */     GIR_EraseRootFromParent_Done,
     /*  55956 */   // Label 892: @55956
     /*  55956 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56055), // Rule ID 7188 //
     /*  55961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55973 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55976 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55981 */     // MIs[1] addr
     /*  55981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55990 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  55994 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56007 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  56014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56054 */     // GIR_Coverage, 7188,
     /*  56054 */     GIR_EraseRootFromParent_Done,
     /*  56055 */   // Label 893: @56055
     /*  56055 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56154), // Rule ID 7193 //
     /*  56060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56072 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56075 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56080 */     // MIs[1] addr
     /*  56080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56089 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  56093 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  56104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56106 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  56113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56122 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56153 */     // GIR_Coverage, 7193,
     /*  56153 */     GIR_EraseRootFromParent_Done,
     /*  56154 */   // Label 894: @56154
     /*  56154 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56253), // Rule ID 7194 //
     /*  56159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56171 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56174 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56179 */     // MIs[1] addr
     /*  56179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56188 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  56192 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  56203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56205 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  56212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56221 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56252 */     // GIR_Coverage, 7194,
     /*  56252 */     GIR_EraseRootFromParent_Done,
     /*  56253 */   // Label 895: @56253
     /*  56253 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56352), // Rule ID 7195 //
     /*  56258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56270 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56273 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56278 */     // MIs[1] addr
     /*  56278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56287 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  56291 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56304 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  56311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56351 */     // GIR_Coverage, 7195,
     /*  56351 */     GIR_EraseRootFromParent_Done,
     /*  56352 */   // Label 896: @56352
     /*  56352 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56405), // Rule ID 13478 //
     /*  56357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56392 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56403 */     GIR_RootConstrainSelectedInstOperands,
     /*  56404 */     // GIR_Coverage, 13478,
     /*  56404 */     GIR_EraseRootFromParent_Done,
     /*  56405 */   // Label 897: @56405
     /*  56405 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56458), // Rule ID 161 //
     /*  56410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56439 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56445 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56456 */     GIR_RootConstrainSelectedInstOperands,
     /*  56457 */     // GIR_Coverage, 161,
     /*  56457 */     GIR_EraseRootFromParent_Done,
     /*  56458 */   // Label 898: @56458
     /*  56458 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56558), // Rule ID 4037 //
     /*  56463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56471 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56482 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  56482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  56485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56494 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  56500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  56517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  56531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56557 */     // GIR_Coverage, 4037,
     /*  56557 */     GIR_EraseRootFromParent_Done,
     /*  56558 */   // Label 899: @56558
     /*  56558 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56599), // Rule ID 143 //
     /*  56563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  56579 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  56583 */     // MIs[1] Operand 1
     /*  56583 */     // No operand predicates
     /*  56583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56585 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  56585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  56588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56592 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 143,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 900: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56632), // Rule ID 13476 //
     /*  56604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56619 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56630 */     GIR_RootConstrainSelectedInstOperands,
     /*  56631 */     // GIR_Coverage, 13476,
     /*  56631 */     GIR_EraseRootFromParent_Done,
     /*  56632 */   // Label 901: @56632
     /*  56632 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56665), // Rule ID 159 //
     /*  56637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56652 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56663 */     GIR_RootConstrainSelectedInstOperands,
     /*  56664 */     // GIR_Coverage, 159,
     /*  56664 */     GIR_EraseRootFromParent_Done,
     /*  56665 */   // Label 902: @56665
     /*  56665 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56729), // Rule ID 14151 //
     /*  56670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56702 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56716 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56721 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56727 */     GIR_RootConstrainSelectedInstOperands,
     /*  56728 */     // GIR_Coverage, 14151,
     /*  56728 */     GIR_EraseRootFromParent_Done,
     /*  56729 */   // Label 903: @56729
     /*  56729 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56793), // Rule ID 5092 //
     /*  56734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56770 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56780 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56785 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56791 */     GIR_RootConstrainSelectedInstOperands,
     /*  56792 */     // GIR_Coverage, 5092,
     /*  56792 */     GIR_EraseRootFromParent_Done,
     /*  56793 */   // Label 904: @56793
     /*  56793 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56817), // Rule ID 157 //
     /*  56798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56810 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  56815 */     GIR_RootConstrainSelectedInstOperands,
     /*  56816 */     // GIR_Coverage, 157,
     /*  56816 */     GIR_Done,
     /*  56817 */   // Label 905: @56817
     /*  56817 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56844), // Rule ID 2484 //
     /*  56822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56837 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56842 */     GIR_RootConstrainSelectedInstOperands,
     /*  56843 */     // GIR_Coverage, 2484,
     /*  56843 */     GIR_Done,
     /*  56844 */   // Label 906: @56844
     /*  56844 */   GIM_Reject,
     /*  56845 */ // Label 886: @56845
     /*  56845 */ GIM_Reject,
     /*  56846 */ // Label 858: @56846
     /*  56846 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57005),
     /*  56851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56861 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56921), // Rule ID 14150 //
     /*  56866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56908 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56913 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56919 */     GIR_RootConstrainSelectedInstOperands,
     /*  56920 */     // GIR_Coverage, 14150,
     /*  56920 */     GIR_EraseRootFromParent_Done,
     /*  56921 */   // Label 908: @56921
     /*  56921 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56981), // Rule ID 5091 //
     /*  56926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56958 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56968 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56973 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56979 */     GIR_RootConstrainSelectedInstOperands,
     /*  56980 */     // GIR_Coverage, 5091,
     /*  56980 */     GIR_EraseRootFromParent_Done,
     /*  56981 */   // Label 909: @56981
     /*  56981 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57004), // Rule ID 2483 //
     /*  56986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56997 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57002 */     GIR_RootConstrainSelectedInstOperands,
     /*  57003 */     // GIR_Coverage, 2483,
     /*  57003 */     GIR_Done,
     /*  57004 */   // Label 910: @57004
     /*  57004 */   GIM_Reject,
     /*  57005 */ // Label 907: @57005
     /*  57005 */ GIM_Reject,
     /*  57006 */ // Label 859: @57006
     /*  57006 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57165),
     /*  57011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57021 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57081), // Rule ID 14154 //
     /*  57026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57054 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57079 */     GIR_RootConstrainSelectedInstOperands,
     /*  57080 */     // GIR_Coverage, 14154,
     /*  57080 */     GIR_EraseRootFromParent_Done,
     /*  57081 */   // Label 912: @57081
     /*  57081 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57141), // Rule ID 5095 //
     /*  57086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57118 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57128 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57133 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57139 */     GIR_RootConstrainSelectedInstOperands,
     /*  57140 */     // GIR_Coverage, 5095,
     /*  57140 */     GIR_EraseRootFromParent_Done,
     /*  57141 */   // Label 913: @57141
     /*  57141 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57164), // Rule ID 2487 //
     /*  57146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57157 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57162 */     GIR_RootConstrainSelectedInstOperands,
     /*  57163 */     // GIR_Coverage, 2487,
     /*  57163 */     GIR_Done,
     /*  57164 */   // Label 914: @57164
     /*  57164 */   GIM_Reject,
     /*  57165 */ // Label 911: @57165
     /*  57165 */ GIM_Reject,
     /*  57166 */ // Label 860: @57166
     /*  57166 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57325),
     /*  57171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57181 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57241), // Rule ID 14149 //
     /*  57186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57214 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57228 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57233 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57239 */     GIR_RootConstrainSelectedInstOperands,
     /*  57240 */     // GIR_Coverage, 14149,
     /*  57240 */     GIR_EraseRootFromParent_Done,
     /*  57241 */   // Label 916: @57241
     /*  57241 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57301), // Rule ID 5090 //
     /*  57246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57288 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57293 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57299 */     GIR_RootConstrainSelectedInstOperands,
     /*  57300 */     // GIR_Coverage, 5090,
     /*  57300 */     GIR_EraseRootFromParent_Done,
     /*  57301 */   // Label 917: @57301
     /*  57301 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57324), // Rule ID 2482 //
     /*  57306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57317 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57322 */     GIR_RootConstrainSelectedInstOperands,
     /*  57323 */     // GIR_Coverage, 2482,
     /*  57323 */     GIR_Done,
     /*  57324 */   // Label 918: @57324
     /*  57324 */   GIM_Reject,
     /*  57325 */ // Label 915: @57325
     /*  57325 */ GIM_Reject,
     /*  57326 */ // Label 861: @57326
     /*  57326 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57485),
     /*  57331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57341 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57401), // Rule ID 14153 //
     /*  57346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57374 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57380 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57388 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57393 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57399 */     GIR_RootConstrainSelectedInstOperands,
     /*  57400 */     // GIR_Coverage, 14153,
     /*  57400 */     GIR_EraseRootFromParent_Done,
     /*  57401 */   // Label 920: @57401
     /*  57401 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(57461), // Rule ID 5094 //
     /*  57406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57438 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57444 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57448 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57453 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57459 */     GIR_RootConstrainSelectedInstOperands,
     /*  57460 */     // GIR_Coverage, 5094,
     /*  57460 */     GIR_EraseRootFromParent_Done,
     /*  57461 */   // Label 921: @57461
     /*  57461 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(57484), // Rule ID 2486 //
     /*  57466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57477 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57482 */     GIR_RootConstrainSelectedInstOperands,
     /*  57483 */     // GIR_Coverage, 2486,
     /*  57483 */     GIR_Done,
     /*  57484 */   // Label 922: @57484
     /*  57484 */   GIM_Reject,
     /*  57485 */ // Label 919: @57485
     /*  57485 */ GIM_Reject,
     /*  57486 */ // Label 862: @57486
     /*  57486 */ GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(57645),
     /*  57491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57501 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(57561), // Rule ID 13617 //
     /*  57506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57548 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57559 */     GIR_RootConstrainSelectedInstOperands,
     /*  57560 */     // GIR_Coverage, 13617,
     /*  57560 */     GIR_EraseRootFromParent_Done,
     /*  57561 */   // Label 924: @57561
     /*  57561 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(57621), // Rule ID 1601 //
     /*  57566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57598 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57608 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57619 */     GIR_RootConstrainSelectedInstOperands,
     /*  57620 */     // GIR_Coverage, 1601,
     /*  57620 */     GIR_EraseRootFromParent_Done,
     /*  57621 */   // Label 925: @57621
     /*  57621 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(57644), // Rule ID 1599 //
     /*  57626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57637 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57642 */     GIR_RootConstrainSelectedInstOperands,
     /*  57643 */     // GIR_Coverage, 1599,
     /*  57643 */     GIR_Done,
     /*  57644 */   // Label 926: @57644
     /*  57644 */   GIM_Reject,
     /*  57645 */ // Label 923: @57645
     /*  57645 */ GIM_Reject,
     /*  57646 */ // Label 863: @57646
     /*  57646 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(57805),
     /*  57651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57661 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(57721), // Rule ID 14152 //
     /*  57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57694 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57700 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57708 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57713 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57719 */     GIR_RootConstrainSelectedInstOperands,
     /*  57720 */     // GIR_Coverage, 14152,
     /*  57720 */     GIR_EraseRootFromParent_Done,
     /*  57721 */   // Label 928: @57721
     /*  57721 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57781), // Rule ID 5093 //
     /*  57726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57758 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57768 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57773 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57779 */     GIR_RootConstrainSelectedInstOperands,
     /*  57780 */     // GIR_Coverage, 5093,
     /*  57780 */     GIR_EraseRootFromParent_Done,
     /*  57781 */   // Label 929: @57781
     /*  57781 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57804), // Rule ID 2485 //
     /*  57786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57797 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57802 */     GIR_RootConstrainSelectedInstOperands,
     /*  57803 */     // GIR_Coverage, 2485,
     /*  57803 */     GIR_Done,
     /*  57804 */   // Label 930: @57804
     /*  57804 */   GIM_Reject,
     /*  57805 */ // Label 927: @57805
     /*  57805 */ GIM_Reject,
     /*  57806 */ // Label 864: @57806
     /*  57806 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57965),
     /*  57811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57821 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57881), // Rule ID 13618 //
     /*  57826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57854 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57868 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57879 */     GIR_RootConstrainSelectedInstOperands,
     /*  57880 */     // GIR_Coverage, 13618,
     /*  57880 */     GIR_EraseRootFromParent_Done,
     /*  57881 */   // Label 932: @57881
     /*  57881 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57941), // Rule ID 1602 //
     /*  57886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57928 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57939 */     GIR_RootConstrainSelectedInstOperands,
     /*  57940 */     // GIR_Coverage, 1602,
     /*  57940 */     GIR_EraseRootFromParent_Done,
     /*  57941 */   // Label 933: @57941
     /*  57941 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57964), // Rule ID 1600 //
     /*  57946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57957 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57962 */     GIR_RootConstrainSelectedInstOperands,
     /*  57963 */     // GIR_Coverage, 1600,
     /*  57963 */     GIR_Done,
     /*  57964 */   // Label 934: @57964
     /*  57964 */   GIM_Reject,
     /*  57965 */ // Label 931: @57965
     /*  57965 */ GIM_Reject,
     /*  57966 */ // Label 865: @57966
     /*  57966 */ GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(58506),
     /*  57971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57981 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(58038), // Rule ID 15349 //
     /*  57986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58023 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58036 */     GIR_RootConstrainSelectedInstOperands,
     /*  58037 */     // GIR_Coverage, 15349,
     /*  58037 */     GIR_EraseRootFromParent_Done,
     /*  58038 */   // Label 936: @58038
     /*  58038 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(58095), // Rule ID 15352 //
     /*  58043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58080 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58093 */     GIR_RootConstrainSelectedInstOperands,
     /*  58094 */     // GIR_Coverage, 15352,
     /*  58094 */     GIR_EraseRootFromParent_Done,
     /*  58095 */   // Label 937: @58095
     /*  58095 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(58152), // Rule ID 15348 //
     /*  58100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58137 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58150 */     GIR_RootConstrainSelectedInstOperands,
     /*  58151 */     // GIR_Coverage, 15348,
     /*  58151 */     GIR_EraseRootFromParent_Done,
     /*  58152 */   // Label 938: @58152
     /*  58152 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(58209), // Rule ID 15351 //
     /*  58157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58194 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58207 */     GIR_RootConstrainSelectedInstOperands,
     /*  58208 */     // GIR_Coverage, 15351,
     /*  58208 */     GIR_EraseRootFromParent_Done,
     /*  58209 */   // Label 939: @58209
     /*  58209 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(58266), // Rule ID 15347 //
     /*  58214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58245 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58251 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58264 */     GIR_RootConstrainSelectedInstOperands,
     /*  58265 */     // GIR_Coverage, 15347,
     /*  58265 */     GIR_EraseRootFromParent_Done,
     /*  58266 */   // Label 940: @58266
     /*  58266 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58323), // Rule ID 15350 //
     /*  58271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58302 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58308 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58321 */     GIR_RootConstrainSelectedInstOperands,
     /*  58322 */     // GIR_Coverage, 15350,
     /*  58322 */     GIR_EraseRootFromParent_Done,
     /*  58323 */   // Label 941: @58323
     /*  58323 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(58380), // Rule ID 8554 //
     /*  58328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58365 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58378 */     GIR_RootConstrainSelectedInstOperands,
     /*  58379 */     // GIR_Coverage, 8554,
     /*  58379 */     GIR_EraseRootFromParent_Done,
     /*  58380 */   // Label 942: @58380
     /*  58380 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(58437), // Rule ID 8555 //
     /*  58385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58416 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58422 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58435 */     GIR_RootConstrainSelectedInstOperands,
     /*  58436 */     // GIR_Coverage, 8555,
     /*  58436 */     GIR_EraseRootFromParent_Done,
     /*  58437 */   // Label 943: @58437
     /*  58437 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(58484), // Rule ID 10820 //
     /*  58442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58453 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  58453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58482 */     GIR_RootConstrainSelectedInstOperands,
     /*  58483 */     // GIR_Coverage, 10820,
     /*  58483 */     GIR_EraseRootFromParent_Done,
     /*  58484 */   // Label 944: @58484
     /*  58484 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(58505), // Rule ID 2753 //
     /*  58489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58492 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58503 */     GIR_RootConstrainSelectedInstOperands,
     /*  58504 */     // GIR_Coverage, 2753,
     /*  58504 */     GIR_EraseRootFromParent_Done,
     /*  58505 */   // Label 945: @58505
     /*  58505 */   GIM_Reject,
     /*  58506 */ // Label 935: @58506
     /*  58506 */ GIM_Reject,
     /*  58507 */ // Label 866: @58507
     /*  58507 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(59047),
     /*  58512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58522 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(58579), // Rule ID 15340 //
     /*  58527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58558 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58564 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58577 */     GIR_RootConstrainSelectedInstOperands,
     /*  58578 */     // GIR_Coverage, 15340,
     /*  58578 */     GIR_EraseRootFromParent_Done,
     /*  58579 */   // Label 947: @58579
     /*  58579 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(58636), // Rule ID 15343 //
     /*  58584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58615 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58621 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58634 */     GIR_RootConstrainSelectedInstOperands,
     /*  58635 */     // GIR_Coverage, 15343,
     /*  58635 */     GIR_EraseRootFromParent_Done,
     /*  58636 */   // Label 948: @58636
     /*  58636 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58693), // Rule ID 15339 //
     /*  58641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58672 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58678 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58691 */     GIR_RootConstrainSelectedInstOperands,
     /*  58692 */     // GIR_Coverage, 15339,
     /*  58692 */     GIR_EraseRootFromParent_Done,
     /*  58693 */   // Label 949: @58693
     /*  58693 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58750), // Rule ID 15342 //
     /*  58698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58729 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58735 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58748 */     GIR_RootConstrainSelectedInstOperands,
     /*  58749 */     // GIR_Coverage, 15342,
     /*  58749 */     GIR_EraseRootFromParent_Done,
     /*  58750 */   // Label 950: @58750
     /*  58750 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58807), // Rule ID 15338 //
     /*  58755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58792 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58805 */     GIR_RootConstrainSelectedInstOperands,
     /*  58806 */     // GIR_Coverage, 15338,
     /*  58806 */     GIR_EraseRootFromParent_Done,
     /*  58807 */   // Label 951: @58807
     /*  58807 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58864), // Rule ID 15341 //
     /*  58812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58843 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58849 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58862 */     GIR_RootConstrainSelectedInstOperands,
     /*  58863 */     // GIR_Coverage, 15341,
     /*  58863 */     GIR_EraseRootFromParent_Done,
     /*  58864 */   // Label 952: @58864
     /*  58864 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58921), // Rule ID 8550 //
     /*  58869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58906 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58919 */     GIR_RootConstrainSelectedInstOperands,
     /*  58920 */     // GIR_Coverage, 8550,
     /*  58920 */     GIR_EraseRootFromParent_Done,
     /*  58921 */   // Label 953: @58921
     /*  58921 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58978), // Rule ID 8551 //
     /*  58926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58957 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58963 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58976 */     GIR_RootConstrainSelectedInstOperands,
     /*  58977 */     // GIR_Coverage, 8551,
     /*  58977 */     GIR_EraseRootFromParent_Done,
     /*  58978 */   // Label 954: @58978
     /*  58978 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(59025), // Rule ID 10819 //
     /*  58983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58994 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  58994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  59001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59023 */     GIR_RootConstrainSelectedInstOperands,
     /*  59024 */     // GIR_Coverage, 10819,
     /*  59024 */     GIR_EraseRootFromParent_Done,
     /*  59025 */   // Label 955: @59025
     /*  59025 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(59046), // Rule ID 2752 //
     /*  59030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59033 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  59033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59044 */     GIR_RootConstrainSelectedInstOperands,
     /*  59045 */     // GIR_Coverage, 2752,
     /*  59045 */     GIR_EraseRootFromParent_Done,
     /*  59046 */   // Label 956: @59046
     /*  59046 */   GIM_Reject,
     /*  59047 */ // Label 946: @59047
     /*  59047 */ GIM_Reject,
     /*  59048 */ // Label 867: @59048
     /*  59048 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(59519),
     /*  59053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59063 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(59118), // Rule ID 15278 //
     /*  59068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59105 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59116 */     GIR_RootConstrainSelectedInstOperands,
     /*  59117 */     // GIR_Coverage, 15278,
     /*  59117 */     GIR_EraseRootFromParent_Done,
     /*  59118 */   // Label 958: @59118
     /*  59118 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(59173), // Rule ID 15281 //
     /*  59123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59154 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59160 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59171 */     GIR_RootConstrainSelectedInstOperands,
     /*  59172 */     // GIR_Coverage, 15281,
     /*  59172 */     GIR_EraseRootFromParent_Done,
     /*  59173 */   // Label 959: @59173
     /*  59173 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(59228), // Rule ID 15277 //
     /*  59178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59215 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59226 */     GIR_RootConstrainSelectedInstOperands,
     /*  59227 */     // GIR_Coverage, 15277,
     /*  59227 */     GIR_EraseRootFromParent_Done,
     /*  59228 */   // Label 960: @59228
     /*  59228 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(59283), // Rule ID 15280 //
     /*  59233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59270 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59281 */     GIR_RootConstrainSelectedInstOperands,
     /*  59282 */     // GIR_Coverage, 15280,
     /*  59282 */     GIR_EraseRootFromParent_Done,
     /*  59283 */   // Label 961: @59283
     /*  59283 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59338), // Rule ID 15276 //
     /*  59288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59319 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59325 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59336 */     GIR_RootConstrainSelectedInstOperands,
     /*  59337 */     // GIR_Coverage, 15276,
     /*  59337 */     GIR_EraseRootFromParent_Done,
     /*  59338 */   // Label 962: @59338
     /*  59338 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(59393), // Rule ID 15279 //
     /*  59343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59374 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59380 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59391 */     GIR_RootConstrainSelectedInstOperands,
     /*  59392 */     // GIR_Coverage, 15279,
     /*  59392 */     GIR_EraseRootFromParent_Done,
     /*  59393 */   // Label 963: @59393
     /*  59393 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(59448), // Rule ID 7574 //
     /*  59398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59429 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59435 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59446 */     GIR_RootConstrainSelectedInstOperands,
     /*  59447 */     // GIR_Coverage, 7574,
     /*  59447 */     GIR_EraseRootFromParent_Done,
     /*  59448 */   // Label 964: @59448
     /*  59448 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(59503), // Rule ID 7575 //
     /*  59453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59490 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59501 */     GIR_RootConstrainSelectedInstOperands,
     /*  59502 */     // GIR_Coverage, 7575,
     /*  59502 */     GIR_EraseRootFromParent_Done,
     /*  59503 */   // Label 965: @59503
     /*  59503 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(59518), // Rule ID 3161 //
     /*  59508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59511 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59516 */     GIR_RootConstrainSelectedInstOperands,
     /*  59517 */     // GIR_Coverage, 3161,
     /*  59517 */     GIR_Done,
     /*  59518 */   // Label 966: @59518
     /*  59518 */   GIM_Reject,
     /*  59519 */ // Label 957: @59519
     /*  59519 */ GIM_Reject,
     /*  59520 */ // Label 868: @59520
     /*  59520 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(60060),
     /*  59525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59535 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59592), // Rule ID 15331 //
     /*  59540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59571 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59577 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59590 */     GIR_RootConstrainSelectedInstOperands,
     /*  59591 */     // GIR_Coverage, 15331,
     /*  59591 */     GIR_EraseRootFromParent_Done,
     /*  59592 */   // Label 968: @59592
     /*  59592 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59649), // Rule ID 15334 //
     /*  59597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59628 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59634 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59647 */     GIR_RootConstrainSelectedInstOperands,
     /*  59648 */     // GIR_Coverage, 15334,
     /*  59648 */     GIR_EraseRootFromParent_Done,
     /*  59649 */   // Label 969: @59649
     /*  59649 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59706), // Rule ID 15330 //
     /*  59654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59691 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59704 */     GIR_RootConstrainSelectedInstOperands,
     /*  59705 */     // GIR_Coverage, 15330,
     /*  59705 */     GIR_EraseRootFromParent_Done,
     /*  59706 */   // Label 970: @59706
     /*  59706 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59763), // Rule ID 15333 //
     /*  59711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59748 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59761 */     GIR_RootConstrainSelectedInstOperands,
     /*  59762 */     // GIR_Coverage, 15333,
     /*  59762 */     GIR_EraseRootFromParent_Done,
     /*  59763 */   // Label 971: @59763
     /*  59763 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59820), // Rule ID 15329 //
     /*  59768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59799 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59805 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59818 */     GIR_RootConstrainSelectedInstOperands,
     /*  59819 */     // GIR_Coverage, 15329,
     /*  59819 */     GIR_EraseRootFromParent_Done,
     /*  59820 */   // Label 972: @59820
     /*  59820 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59877), // Rule ID 15332 //
     /*  59825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59856 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59862 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59875 */     GIR_RootConstrainSelectedInstOperands,
     /*  59876 */     // GIR_Coverage, 15332,
     /*  59876 */     GIR_EraseRootFromParent_Done,
     /*  59877 */   // Label 973: @59877
     /*  59877 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59934), // Rule ID 8546 //
     /*  59882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59913 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59919 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59932 */     GIR_RootConstrainSelectedInstOperands,
     /*  59933 */     // GIR_Coverage, 8546,
     /*  59933 */     GIR_EraseRootFromParent_Done,
     /*  59934 */   // Label 974: @59934
     /*  59934 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59991), // Rule ID 8547 //
     /*  59939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59970 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59976 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59989 */     GIR_RootConstrainSelectedInstOperands,
     /*  59990 */     // GIR_Coverage, 8547,
     /*  59990 */     GIR_EraseRootFromParent_Done,
     /*  59991 */   // Label 975: @59991
     /*  59991 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(60038), // Rule ID 10818 //
     /*  59996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60007 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  60007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  60014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60036 */     GIR_RootConstrainSelectedInstOperands,
     /*  60037 */     // GIR_Coverage, 10818,
     /*  60037 */     GIR_EraseRootFromParent_Done,
     /*  60038 */   // Label 976: @60038
     /*  60038 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(60059), // Rule ID 2751 //
     /*  60043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60046 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  60046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60057 */     GIR_RootConstrainSelectedInstOperands,
     /*  60058 */     // GIR_Coverage, 2751,
     /*  60058 */     GIR_EraseRootFromParent_Done,
     /*  60059 */   // Label 977: @60059
     /*  60059 */   GIM_Reject,
     /*  60060 */ // Label 967: @60060
     /*  60060 */ GIM_Reject,
     /*  60061 */ // Label 869: @60061
     /*  60061 */ GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(60532),
     /*  60066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60076 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(60131), // Rule ID 15269 //
     /*  60081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60112 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60118 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60129 */     GIR_RootConstrainSelectedInstOperands,
     /*  60130 */     // GIR_Coverage, 15269,
     /*  60130 */     GIR_EraseRootFromParent_Done,
     /*  60131 */   // Label 979: @60131
     /*  60131 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(60186), // Rule ID 15272 //
     /*  60136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60167 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60173 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60184 */     GIR_RootConstrainSelectedInstOperands,
     /*  60185 */     // GIR_Coverage, 15272,
     /*  60185 */     GIR_EraseRootFromParent_Done,
     /*  60186 */   // Label 980: @60186
     /*  60186 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60241), // Rule ID 15268 //
     /*  60191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60222 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60228 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60239 */     GIR_RootConstrainSelectedInstOperands,
     /*  60240 */     // GIR_Coverage, 15268,
     /*  60240 */     GIR_EraseRootFromParent_Done,
     /*  60241 */   // Label 981: @60241
     /*  60241 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(60296), // Rule ID 15271 //
     /*  60246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60277 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60283 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60294 */     GIR_RootConstrainSelectedInstOperands,
     /*  60295 */     // GIR_Coverage, 15271,
     /*  60295 */     GIR_EraseRootFromParent_Done,
     /*  60296 */   // Label 982: @60296
     /*  60296 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60351), // Rule ID 15267 //
     /*  60301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60332 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60338 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60349 */     GIR_RootConstrainSelectedInstOperands,
     /*  60350 */     // GIR_Coverage, 15267,
     /*  60350 */     GIR_EraseRootFromParent_Done,
     /*  60351 */   // Label 983: @60351
     /*  60351 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(60406), // Rule ID 15270 //
     /*  60356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60387 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60393 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60404 */     GIR_RootConstrainSelectedInstOperands,
     /*  60405 */     // GIR_Coverage, 15270,
     /*  60405 */     GIR_EraseRootFromParent_Done,
     /*  60406 */   // Label 984: @60406
     /*  60406 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(60461), // Rule ID 7570 //
     /*  60411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60442 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60448 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60459 */     GIR_RootConstrainSelectedInstOperands,
     /*  60460 */     // GIR_Coverage, 7570,
     /*  60460 */     GIR_EraseRootFromParent_Done,
     /*  60461 */   // Label 985: @60461
     /*  60461 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(60516), // Rule ID 7571 //
     /*  60466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60503 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60514 */     GIR_RootConstrainSelectedInstOperands,
     /*  60515 */     // GIR_Coverage, 7571,
     /*  60515 */     GIR_EraseRootFromParent_Done,
     /*  60516 */   // Label 986: @60516
     /*  60516 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(60531), // Rule ID 3160 //
     /*  60521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60524 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60529 */     GIR_RootConstrainSelectedInstOperands,
     /*  60530 */     // GIR_Coverage, 3160,
     /*  60530 */     GIR_Done,
     /*  60531 */   // Label 987: @60531
     /*  60531 */   GIM_Reject,
     /*  60532 */ // Label 978: @60532
     /*  60532 */ GIM_Reject,
     /*  60533 */ // Label 870: @60533
     /*  60533 */ GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(61073),
     /*  60538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60548 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60605), // Rule ID 15322 //
     /*  60553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60584 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60590 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60603 */     GIR_RootConstrainSelectedInstOperands,
     /*  60604 */     // GIR_Coverage, 15322,
     /*  60604 */     GIR_EraseRootFromParent_Done,
     /*  60605 */   // Label 989: @60605
     /*  60605 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60662), // Rule ID 15325 //
     /*  60610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60641 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60647 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60660 */     GIR_RootConstrainSelectedInstOperands,
     /*  60661 */     // GIR_Coverage, 15325,
     /*  60661 */     GIR_EraseRootFromParent_Done,
     /*  60662 */   // Label 990: @60662
     /*  60662 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60719), // Rule ID 15321 //
     /*  60667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60698 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60704 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60717 */     GIR_RootConstrainSelectedInstOperands,
     /*  60718 */     // GIR_Coverage, 15321,
     /*  60718 */     GIR_EraseRootFromParent_Done,
     /*  60719 */   // Label 991: @60719
     /*  60719 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60776), // Rule ID 15324 //
     /*  60724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60755 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60761 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60774 */     GIR_RootConstrainSelectedInstOperands,
     /*  60775 */     // GIR_Coverage, 15324,
     /*  60775 */     GIR_EraseRootFromParent_Done,
     /*  60776 */   // Label 992: @60776
     /*  60776 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60833), // Rule ID 15320 //
     /*  60781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60812 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60818 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60831 */     GIR_RootConstrainSelectedInstOperands,
     /*  60832 */     // GIR_Coverage, 15320,
     /*  60832 */     GIR_EraseRootFromParent_Done,
     /*  60833 */   // Label 993: @60833
     /*  60833 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60890), // Rule ID 15323 //
     /*  60838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60869 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60875 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60888 */     GIR_RootConstrainSelectedInstOperands,
     /*  60889 */     // GIR_Coverage, 15323,
     /*  60889 */     GIR_EraseRootFromParent_Done,
     /*  60890 */   // Label 994: @60890
     /*  60890 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60947), // Rule ID 8542 //
     /*  60895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60926 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60932 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60945 */     GIR_RootConstrainSelectedInstOperands,
     /*  60946 */     // GIR_Coverage, 8542,
     /*  60946 */     GIR_EraseRootFromParent_Done,
     /*  60947 */   // Label 995: @60947
     /*  60947 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61004), // Rule ID 8543 //
     /*  60952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60983 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60989 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61002 */     GIR_RootConstrainSelectedInstOperands,
     /*  61003 */     // GIR_Coverage, 8543,
     /*  61003 */     GIR_EraseRootFromParent_Done,
     /*  61004 */   // Label 996: @61004
     /*  61004 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61051), // Rule ID 10817 //
     /*  61009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61020 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  61020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  61023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  61027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61032 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  61035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  61047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  61049 */     GIR_RootConstrainSelectedInstOperands,
     /*  61050 */     // GIR_Coverage, 10817,
     /*  61050 */     GIR_EraseRootFromParent_Done,
     /*  61051 */   // Label 997: @61051
     /*  61051 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61072), // Rule ID 2750 //
     /*  61056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61059 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  61059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  61070 */     GIR_RootConstrainSelectedInstOperands,
     /*  61071 */     // GIR_Coverage, 2750,
     /*  61071 */     GIR_EraseRootFromParent_Done,
     /*  61072 */   // Label 998: @61072
     /*  61072 */   GIM_Reject,
     /*  61073 */ // Label 988: @61073
     /*  61073 */ GIM_Reject,
     /*  61074 */ // Label 871: @61074
     /*  61074 */ GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61545),
     /*  61079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  61089 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61144), // Rule ID 15260 //
     /*  61094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61125 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61131 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61142 */     GIR_RootConstrainSelectedInstOperands,
     /*  61143 */     // GIR_Coverage, 15260,
     /*  61143 */     GIR_EraseRootFromParent_Done,
     /*  61144 */   // Label 1000: @61144
     /*  61144 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61199), // Rule ID 15263 //
     /*  61149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61180 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61186 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61197 */     GIR_RootConstrainSelectedInstOperands,
     /*  61198 */     // GIR_Coverage, 15263,
     /*  61198 */     GIR_EraseRootFromParent_Done,
     /*  61199 */   // Label 1001: @61199
     /*  61199 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61254), // Rule ID 15259 //
     /*  61204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61235 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61241 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61252 */     GIR_RootConstrainSelectedInstOperands,
     /*  61253 */     // GIR_Coverage, 15259,
     /*  61253 */     GIR_EraseRootFromParent_Done,
     /*  61254 */   // Label 1002: @61254
     /*  61254 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61309), // Rule ID 15262 //
     /*  61259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61296 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61307 */     GIR_RootConstrainSelectedInstOperands,
     /*  61308 */     // GIR_Coverage, 15262,
     /*  61308 */     GIR_EraseRootFromParent_Done,
     /*  61309 */   // Label 1003: @61309
     /*  61309 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61364), // Rule ID 15258 //
     /*  61314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61345 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61351 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61362 */     GIR_RootConstrainSelectedInstOperands,
     /*  61363 */     // GIR_Coverage, 15258,
     /*  61363 */     GIR_EraseRootFromParent_Done,
     /*  61364 */   // Label 1004: @61364
     /*  61364 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(61419), // Rule ID 15261 //
     /*  61369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61400 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61406 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61417 */     GIR_RootConstrainSelectedInstOperands,
     /*  61418 */     // GIR_Coverage, 15261,
     /*  61418 */     GIR_EraseRootFromParent_Done,
     /*  61419 */   // Label 1005: @61419
     /*  61419 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(61474), // Rule ID 7566 //
     /*  61424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61455 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61461 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61472 */     GIR_RootConstrainSelectedInstOperands,
     /*  61473 */     // GIR_Coverage, 7566,
     /*  61473 */     GIR_EraseRootFromParent_Done,
     /*  61474 */   // Label 1006: @61474
     /*  61474 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(61529), // Rule ID 7567 //
     /*  61479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61510 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61516 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61527 */     GIR_RootConstrainSelectedInstOperands,
     /*  61528 */     // GIR_Coverage, 7567,
     /*  61528 */     GIR_EraseRootFromParent_Done,
     /*  61529 */   // Label 1007: @61529
     /*  61529 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(61544), // Rule ID 3159 //
     /*  61534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61537 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61542 */     GIR_RootConstrainSelectedInstOperands,
     /*  61543 */     // GIR_Coverage, 3159,
     /*  61543 */     GIR_Done,
     /*  61544 */   // Label 1008: @61544
     /*  61544 */   GIM_Reject,
     /*  61545 */ // Label 999: @61545
     /*  61545 */ GIM_Reject,
     /*  61546 */ // Label 872: @61546
     /*  61546 */ GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62086),
     /*  61551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  61561 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61618), // Rule ID 15313 //
     /*  61566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61597 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61603 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61616 */     GIR_RootConstrainSelectedInstOperands,
     /*  61617 */     // GIR_Coverage, 15313,
     /*  61617 */     GIR_EraseRootFromParent_Done,
     /*  61618 */   // Label 1010: @61618
     /*  61618 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(61675), // Rule ID 15316 //
     /*  61623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61654 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61660 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61673 */     GIR_RootConstrainSelectedInstOperands,
     /*  61674 */     // GIR_Coverage, 15316,
     /*  61674 */     GIR_EraseRootFromParent_Done,
     /*  61675 */   // Label 1011: @61675
     /*  61675 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61732), // Rule ID 15312 //
     /*  61680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61711 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61717 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61730 */     GIR_RootConstrainSelectedInstOperands,
     /*  61731 */     // GIR_Coverage, 15312,
     /*  61731 */     GIR_EraseRootFromParent_Done,
     /*  61732 */   // Label 1012: @61732
     /*  61732 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61789), // Rule ID 15315 //
     /*  61737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61774 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61787 */     GIR_RootConstrainSelectedInstOperands,
     /*  61788 */     // GIR_Coverage, 15315,
     /*  61788 */     GIR_EraseRootFromParent_Done,
     /*  61789 */   // Label 1013: @61789
     /*  61789 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(61846), // Rule ID 15311 //
     /*  61794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61825 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61831 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61844 */     GIR_RootConstrainSelectedInstOperands,
     /*  61845 */     // GIR_Coverage, 15311,
     /*  61845 */     GIR_EraseRootFromParent_Done,
     /*  61846 */   // Label 1014: @61846
     /*  61846 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(61903), // Rule ID 15314 //
     /*  61851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61882 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61888 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61901 */     GIR_RootConstrainSelectedInstOperands,
     /*  61902 */     // GIR_Coverage, 15314,
     /*  61902 */     GIR_EraseRootFromParent_Done,
     /*  61903 */   // Label 1015: @61903
     /*  61903 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(61960), // Rule ID 8538 //
     /*  61908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61939 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61945 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61958 */     GIR_RootConstrainSelectedInstOperands,
     /*  61959 */     // GIR_Coverage, 8538,
     /*  61959 */     GIR_EraseRootFromParent_Done,
     /*  61960 */   // Label 1016: @61960
     /*  61960 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62017), // Rule ID 8539 //
     /*  61965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61996 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62002 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  62002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  62005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62015 */     GIR_RootConstrainSelectedInstOperands,
     /*  62016 */     // GIR_Coverage, 8539,
     /*  62016 */     GIR_EraseRootFromParent_Done,
     /*  62017 */   // Label 1017: @62017
     /*  62017 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62064), // Rule ID 10816 //
     /*  62022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62033 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  62033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  62036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  62040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  62048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  62060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  62062 */     GIR_RootConstrainSelectedInstOperands,
     /*  62063 */     // GIR_Coverage, 10816,
     /*  62063 */     GIR_EraseRootFromParent_Done,
     /*  62064 */   // Label 1018: @62064
     /*  62064 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62085), // Rule ID 2749 //
     /*  62069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62072 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  62072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  62083 */     GIR_RootConstrainSelectedInstOperands,
     /*  62084 */     // GIR_Coverage, 2749,
     /*  62084 */     GIR_EraseRootFromParent_Done,
     /*  62085 */   // Label 1019: @62085
     /*  62085 */   GIM_Reject,
     /*  62086 */ // Label 1009: @62086
     /*  62086 */ GIM_Reject,
     /*  62087 */ // Label 873: @62087
     /*  62087 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(62558),
     /*  62092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  62102 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(62157), // Rule ID 15251 //
     /*  62107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62138 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62144 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62155 */     GIR_RootConstrainSelectedInstOperands,
     /*  62156 */     // GIR_Coverage, 15251,
     /*  62156 */     GIR_EraseRootFromParent_Done,
     /*  62157 */   // Label 1021: @62157
     /*  62157 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(62212), // Rule ID 15254 //
     /*  62162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62199 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62210 */     GIR_RootConstrainSelectedInstOperands,
     /*  62211 */     // GIR_Coverage, 15254,
     /*  62211 */     GIR_EraseRootFromParent_Done,
     /*  62212 */   // Label 1022: @62212
     /*  62212 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(62267), // Rule ID 15250 //
     /*  62217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62248 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62254 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62265 */     GIR_RootConstrainSelectedInstOperands,
     /*  62266 */     // GIR_Coverage, 15250,
     /*  62266 */     GIR_EraseRootFromParent_Done,
     /*  62267 */   // Label 1023: @62267
     /*  62267 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(62322), // Rule ID 15253 //
     /*  62272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62309 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62320 */     GIR_RootConstrainSelectedInstOperands,
     /*  62321 */     // GIR_Coverage, 15253,
     /*  62321 */     GIR_EraseRootFromParent_Done,
     /*  62322 */   // Label 1024: @62322
     /*  62322 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(62377), // Rule ID 15249 //
     /*  62327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62358 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62364 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62375 */     GIR_RootConstrainSelectedInstOperands,
     /*  62376 */     // GIR_Coverage, 15249,
     /*  62376 */     GIR_EraseRootFromParent_Done,
     /*  62377 */   // Label 1025: @62377
     /*  62377 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(62432), // Rule ID 15252 //
     /*  62382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62413 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62419 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62430 */     GIR_RootConstrainSelectedInstOperands,
     /*  62431 */     // GIR_Coverage, 15252,
     /*  62431 */     GIR_EraseRootFromParent_Done,
     /*  62432 */   // Label 1026: @62432
     /*  62432 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(62487), // Rule ID 7562 //
     /*  62437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62474 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62485 */     GIR_RootConstrainSelectedInstOperands,
     /*  62486 */     // GIR_Coverage, 7562,
     /*  62486 */     GIR_EraseRootFromParent_Done,
     /*  62487 */   // Label 1027: @62487
     /*  62487 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(62542), // Rule ID 7563 //
     /*  62492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62523 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62529 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 7563,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1028: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(62557), // Rule ID 3158 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62550 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  62555 */     GIR_RootConstrainSelectedInstOperands,
     /*  62556 */     // GIR_Coverage, 3158,
     /*  62556 */     GIR_Done,
     /*  62557 */   // Label 1029: @62557
     /*  62557 */   GIM_Reject,
     /*  62558 */ // Label 1020: @62558
     /*  62558 */ GIM_Reject,
     /*  62559 */ // Label 874: @62559
     /*  62559 */ GIM_Reject,
     /*  62560 */ // Label 6: @62560
     /*  62560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1048*/ GIMT_Encode4(87674),
     /*  62571 */ /*GILLT_s32*//*Label 1030*/ GIMT_Encode4(62659),
     /*  62575 */ /*GILLT_s64*//*Label 1031*/ GIMT_Encode4(63019), GIMT_Encode4(0),
     /*  62583 */ /*GILLT_v2s32*//*Label 1032*/ GIMT_Encode4(64918),
     /*  62587 */ /*GILLT_v2s64*//*Label 1033*/ GIMT_Encode4(66226),
     /*  62591 */ /*GILLT_v4s16*//*Label 1034*/ GIMT_Encode4(67534),
     /*  62595 */ /*GILLT_v4s32*//*Label 1035*/ GIMT_Encode4(68842),
     /*  62599 */ /*GILLT_v8s8*//*Label 1036*/ GIMT_Encode4(70150),
     /*  62603 */ /*GILLT_v8s16*//*Label 1037*/ GIMT_Encode4(71458),
     /*  62607 */ /*GILLT_v16s8*//*Label 1038*/ GIMT_Encode4(72766),
     /*  62611 */ /*GILLT_nxv1s1*//*Label 1039*/ GIMT_Encode4(74074),
     /*  62615 */ /*GILLT_nxv2s1*//*Label 1040*/ GIMT_Encode4(74106), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  62627 */ /*GILLT_nxv2s64*//*Label 1041*/ GIMT_Encode4(74138),
     /*  62631 */ /*GILLT_nxv4s1*//*Label 1042*/ GIMT_Encode4(77498), GIMT_Encode4(0),
     /*  62639 */ /*GILLT_nxv4s32*//*Label 1043*/ GIMT_Encode4(77530),
     /*  62643 */ /*GILLT_nxv8s1*//*Label 1044*/ GIMT_Encode4(80890),
     /*  62647 */ /*GILLT_nxv8s16*//*Label 1045*/ GIMT_Encode4(80922),
     /*  62651 */ /*GILLT_nxv16s1*//*Label 1046*/ GIMT_Encode4(84282),
     /*  62655 */ /*GILLT_nxv16s8*//*Label 1047*/ GIMT_Encode4(84314),
     /*  62659 */ // Label 1030: @62659
     /*  62659 */ GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(63018),
     /*  62664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  62667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62670 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62725), // Rule ID 13501 //
     /*  62675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62712 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62723 */     GIR_RootConstrainSelectedInstOperands,
     /*  62724 */     // GIR_Coverage, 13501,
     /*  62724 */     GIR_EraseRootFromParent_Done,
     /*  62725 */   // Label 1050: @62725
     /*  62725 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62780), // Rule ID 178 //
     /*  62730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62767 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62778 */     GIR_RootConstrainSelectedInstOperands,
     /*  62779 */     // GIR_Coverage, 178,
     /*  62779 */     GIR_EraseRootFromParent_Done,
     /*  62780 */   // Label 1051: @62780
     /*  62780 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62821), // Rule ID 146 //
     /*  62785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  62789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62801 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  62805 */     // MIs[1] Operand 1
     /*  62805 */     // No operand predicates
     /*  62805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62807 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  62807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  62810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62814 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  62819 */     GIR_RootConstrainSelectedInstOperands,
     /*  62820 */     // GIR_Coverage, 146,
     /*  62820 */     GIR_EraseRootFromParent_Done,
     /*  62821 */   // Label 1052: @62821
     /*  62821 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62854), // Rule ID 13503 //
     /*  62826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62841 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62852 */     GIR_RootConstrainSelectedInstOperands,
     /*  62853 */     // GIR_Coverage, 13503,
     /*  62853 */     GIR_EraseRootFromParent_Done,
     /*  62854 */   // Label 1053: @62854
     /*  62854 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62887), // Rule ID 182 //
     /*  62859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62874 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62885 */     GIR_RootConstrainSelectedInstOperands,
     /*  62886 */     // GIR_Coverage, 182,
     /*  62886 */     GIR_EraseRootFromParent_Done,
     /*  62887 */   // Label 1054: @62887
     /*  62887 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62940), // Rule ID 13499 //
     /*  62892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62917 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62927 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62938 */     GIR_RootConstrainSelectedInstOperands,
     /*  62939 */     // GIR_Coverage, 13499,
     /*  62939 */     GIR_EraseRootFromParent_Done,
     /*  62940 */   // Label 1055: @62940
     /*  62940 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62993), // Rule ID 176 //
     /*  62945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62974 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62980 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62991 */     GIR_RootConstrainSelectedInstOperands,
     /*  62992 */     // GIR_Coverage, 176,
     /*  62992 */     GIR_EraseRootFromParent_Done,
     /*  62993 */   // Label 1056: @62993
     /*  62993 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(63017), // Rule ID 180 //
     /*  62998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  63002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  63010 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  63010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  63015 */     GIR_RootConstrainSelectedInstOperands,
     /*  63016 */     // GIR_Coverage, 180,
     /*  63016 */     GIR_Done,
     /*  63017 */   // Label 1057: @63017
     /*  63017 */   GIM_Reject,
     /*  63018 */ // Label 1049: @63018
     /*  63018 */ GIM_Reject,
     /*  63019 */ // Label 1031: @63019
     /*  63019 */ GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(64917),
     /*  63024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  63027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63030 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63152), // Rule ID 4050 //
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63076 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63080 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63107 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63111 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63115 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63119 */     // MIs[4] Rn
     /*  63119 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63124 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63128 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63139 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63141 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63150 */     GIR_RootConstrainSelectedInstOperands,
     /*  63151 */     // GIR_Coverage, 4050,
     /*  63151 */     GIR_EraseRootFromParent_Done,
     /*  63152 */   // Label 1059: @63152
     /*  63152 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63274), // Rule ID 14066 //
     /*  63157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63198 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63202 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63221 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63225 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63229 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63233 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63237 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63241 */     // MIs[4] Rn
     /*  63241 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63246 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63250 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63261 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63263 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63272 */     GIR_RootConstrainSelectedInstOperands,
     /*  63273 */     // GIR_Coverage, 14066,
     /*  63273 */     GIR_EraseRootFromParent_Done,
     /*  63274 */   // Label 1060: @63274
     /*  63274 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63329), // Rule ID 13502 //
     /*  63279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63316 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63327 */     GIR_RootConstrainSelectedInstOperands,
     /*  63328 */     // GIR_Coverage, 13502,
     /*  63328 */     GIR_EraseRootFromParent_Done,
     /*  63329 */   // Label 1061: @63329
     /*  63329 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63384), // Rule ID 179 //
     /*  63334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63371 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63382 */     GIR_RootConstrainSelectedInstOperands,
     /*  63383 */     // GIR_Coverage, 179,
     /*  63383 */     GIR_EraseRootFromParent_Done,
     /*  63384 */   // Label 1062: @63384
     /*  63384 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63493), // Rule ID 13861 //
     /*  63389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63458 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63462 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63467 */     // MIs[4] LHS
     /*  63467 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63474 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63491 */     GIR_RootConstrainSelectedInstOperands,
     /*  63492 */     // GIR_Coverage, 13861,
     /*  63492 */     GIR_EraseRootFromParent_Done,
     /*  63493 */   // Label 1063: @63493
     /*  63493 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63602), // Rule ID 13860 //
     /*  63498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63546 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63567 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63571 */     // MIs[4] LHS
     /*  63571 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63576 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63581 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63583 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63600 */     GIR_RootConstrainSelectedInstOperands,
     /*  63601 */     // GIR_Coverage, 13860,
     /*  63601 */     GIR_EraseRootFromParent_Done,
     /*  63602 */   // Label 1064: @63602
     /*  63602 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63711), // Rule ID 13863 //
     /*  63607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63660 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63676 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63680 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63685 */     // MIs[4] LHS
     /*  63685 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63692 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63709 */     GIR_RootConstrainSelectedInstOperands,
     /*  63710 */     // GIR_Coverage, 13863,
     /*  63710 */     GIR_EraseRootFromParent_Done,
     /*  63711 */   // Label 1065: @63711
     /*  63711 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63820), // Rule ID 13862 //
     /*  63716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63789 */     // MIs[4] LHS
     /*  63789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63794 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63799 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63801 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63818 */     GIR_RootConstrainSelectedInstOperands,
     /*  63819 */     // GIR_Coverage, 13862,
     /*  63819 */     GIR_EraseRootFromParent_Done,
     /*  63820 */   // Label 1066: @63820
     /*  63820 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63929), // Rule ID 2478 //
     /*  63825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63882 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63886 */     // MIs[3] LHS
     /*  63886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63891 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63895 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63908 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63910 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63927 */     GIR_RootConstrainSelectedInstOperands,
     /*  63928 */     // GIR_Coverage, 2478,
     /*  63928 */     GIR_EraseRootFromParent_Done,
     /*  63929 */   // Label 1067: @63929
     /*  63929 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64038), // Rule ID 13858 //
     /*  63934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63991 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63995 */     // MIs[3] LHS
     /*  63995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64004 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64010 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64019 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64036 */     GIR_RootConstrainSelectedInstOperands,
     /*  64037 */     // GIR_Coverage, 13858,
     /*  64037 */     GIR_EraseRootFromParent_Done,
     /*  64038 */   // Label 1068: @64038
     /*  64038 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(64147), // Rule ID 13857 //
     /*  64043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64105 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64109 */     // MIs[3] LHS
     /*  64109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64118 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64128 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64145 */     GIR_RootConstrainSelectedInstOperands,
     /*  64146 */     // GIR_Coverage, 13857,
     /*  64146 */     GIR_EraseRootFromParent_Done,
     /*  64147 */   // Label 1069: @64147
     /*  64147 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(64256), // Rule ID 13859 //
     /*  64152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64214 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64218 */     // MIs[3] LHS
     /*  64218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64223 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64227 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64233 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64235 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64237 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64254 */     GIR_RootConstrainSelectedInstOperands,
     /*  64255 */     // GIR_Coverage, 13859,
     /*  64255 */     GIR_EraseRootFromParent_Done,
     /*  64256 */   // Label 1070: @64256
     /*  64256 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(64297), // Rule ID 147 //
     /*  64261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  64265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64277 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  64281 */     // MIs[1] Operand 1
     /*  64281 */     // No operand predicates
     /*  64281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64283 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  64283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  64286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64290 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  64295 */     GIR_RootConstrainSelectedInstOperands,
     /*  64296 */     // GIR_Coverage, 147,
     /*  64296 */     GIR_EraseRootFromParent_Done,
     /*  64297 */   // Label 1071: @64297
     /*  64297 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(64330), // Rule ID 13504 //
     /*  64302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64317 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64328 */     GIR_RootConstrainSelectedInstOperands,
     /*  64329 */     // GIR_Coverage, 13504,
     /*  64329 */     GIR_EraseRootFromParent_Done,
     /*  64330 */   // Label 1072: @64330
     /*  64330 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64363), // Rule ID 183 //
     /*  64335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64350 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64361 */     GIR_RootConstrainSelectedInstOperands,
     /*  64362 */     // GIR_Coverage, 183,
     /*  64362 */     GIR_EraseRootFromParent_Done,
     /*  64363 */   // Label 1073: @64363
     /*  64363 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64430), // Rule ID 13797 //
     /*  64368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64392 */     // MIs[1] imm
     /*  64392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64404 */     // MIs[2] Operand 1
     /*  64404 */     // No operand predicates
     /*  64404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64414 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64428 */     GIR_RootConstrainSelectedInstOperands,
     /*  64429 */     // GIR_Coverage, 13797,
     /*  64429 */     GIR_EraseRootFromParent_Done,
     /*  64430 */   // Label 1074: @64430
     /*  64430 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64497), // Rule ID 13800 //
     /*  64435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64459 */     // MIs[1] imm
     /*  64459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64471 */     // MIs[2] Operand 1
     /*  64471 */     // No operand predicates
     /*  64471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64481 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64495 */     GIR_RootConstrainSelectedInstOperands,
     /*  64496 */     // GIR_Coverage, 13800,
     /*  64496 */     GIR_EraseRootFromParent_Done,
     /*  64497 */   // Label 1075: @64497
     /*  64497 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64550), // Rule ID 13500 //
     /*  64502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64537 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64548 */     GIR_RootConstrainSelectedInstOperands,
     /*  64549 */     // GIR_Coverage, 13500,
     /*  64549 */     GIR_EraseRootFromParent_Done,
     /*  64550 */   // Label 1076: @64550
     /*  64550 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64617), // Rule ID 2126 //
     /*  64555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64583 */     // MIs[1] imm
     /*  64583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64591 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64595 */     // MIs[2] Operand 1
     /*  64595 */     // No operand predicates
     /*  64595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64601 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64615 */     GIR_RootConstrainSelectedInstOperands,
     /*  64616 */     // GIR_Coverage, 2126,
     /*  64616 */     GIR_EraseRootFromParent_Done,
     /*  64617 */   // Label 1077: @64617
     /*  64617 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64684), // Rule ID 2135 //
     /*  64622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64650 */     // MIs[1] imm
     /*  64650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64658 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64662 */     // MIs[2] Operand 1
     /*  64662 */     // No operand predicates
     /*  64662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64668 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64682 */     GIR_RootConstrainSelectedInstOperands,
     /*  64683 */     // GIR_Coverage, 2135,
     /*  64683 */     GIR_EraseRootFromParent_Done,
     /*  64684 */   // Label 1078: @64684
     /*  64684 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64737), // Rule ID 177 //
     /*  64689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64718 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64724 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64735 */     GIR_RootConstrainSelectedInstOperands,
     /*  64736 */     // GIR_Coverage, 177,
     /*  64736 */     GIR_EraseRootFromParent_Done,
     /*  64737 */   // Label 1079: @64737
     /*  64737 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64801), // Rule ID 14157 //
     /*  64742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64788 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64793 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64799 */     GIR_RootConstrainSelectedInstOperands,
     /*  64800 */     // GIR_Coverage, 14157,
     /*  64800 */     GIR_EraseRootFromParent_Done,
     /*  64801 */   // Label 1080: @64801
     /*  64801 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64865), // Rule ID 5104 //
     /*  64806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64852 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64857 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64863 */     GIR_RootConstrainSelectedInstOperands,
     /*  64864 */     // GIR_Coverage, 5104,
     /*  64864 */     GIR_EraseRootFromParent_Done,
     /*  64865 */   // Label 1081: @64865
     /*  64865 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64889), // Rule ID 181 //
     /*  64870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64882 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  64887 */     GIR_RootConstrainSelectedInstOperands,
     /*  64888 */     // GIR_Coverage, 181,
     /*  64888 */     GIR_Done,
     /*  64889 */   // Label 1082: @64889
     /*  64889 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64916), // Rule ID 5110 //
     /*  64894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64909 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64914 */     GIR_RootConstrainSelectedInstOperands,
     /*  64915 */     // GIR_Coverage, 5110,
     /*  64915 */     GIR_Done,
     /*  64916 */   // Label 1083: @64916
     /*  64916 */   GIM_Reject,
     /*  64917 */ // Label 1058: @64917
     /*  64917 */ GIM_Reject,
     /*  64918 */ // Label 1032: @64918
     /*  64918 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66225),
     /*  64923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64929 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(65038), // Rule ID 13854 //
     /*  64934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64982 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64999 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65003 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65012 */     // MIs[4] LHS
     /*  65012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65019 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65036 */     GIR_RootConstrainSelectedInstOperands,
     /*  65037 */     // GIR_Coverage, 13854,
     /*  65037 */     GIR_EraseRootFromParent_Done,
     /*  65038 */   // Label 1085: @65038
     /*  65038 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65147), // Rule ID 13853 //
     /*  65043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65091 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65116 */     // MIs[4] LHS
     /*  65116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65121 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65128 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65145 */     GIR_RootConstrainSelectedInstOperands,
     /*  65146 */     // GIR_Coverage, 13853,
     /*  65146 */     GIR_EraseRootFromParent_Done,
     /*  65147 */   // Label 1086: @65147
     /*  65147 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65256), // Rule ID 13856 //
     /*  65152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65221 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65230 */     // MIs[4] LHS
     /*  65230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65235 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65237 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65254 */     GIR_RootConstrainSelectedInstOperands,
     /*  65255 */     // GIR_Coverage, 13856,
     /*  65255 */     GIR_EraseRootFromParent_Done,
     /*  65256 */   // Label 1087: @65256
     /*  65256 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65365), // Rule ID 13855 //
     /*  65261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65334 */     // MIs[4] LHS
     /*  65334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65346 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65363 */     GIR_RootConstrainSelectedInstOperands,
     /*  65364 */     // GIR_Coverage, 13855,
     /*  65364 */     GIR_EraseRootFromParent_Done,
     /*  65365 */   // Label 1088: @65365
     /*  65365 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65474), // Rule ID 2477 //
     /*  65370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65431 */     // MIs[3] LHS
     /*  65431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65455 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65472 */     GIR_RootConstrainSelectedInstOperands,
     /*  65473 */     // GIR_Coverage, 2477,
     /*  65473 */     GIR_EraseRootFromParent_Done,
     /*  65474 */   // Label 1089: @65474
     /*  65474 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65583), // Rule ID 13851 //
     /*  65479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65540 */     // MIs[3] LHS
     /*  65540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65549 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65562 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65564 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65581 */     GIR_RootConstrainSelectedInstOperands,
     /*  65582 */     // GIR_Coverage, 13851,
     /*  65582 */     GIR_EraseRootFromParent_Done,
     /*  65583 */   // Label 1090: @65583
     /*  65583 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65692), // Rule ID 13850 //
     /*  65588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65654 */     // MIs[3] LHS
     /*  65654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65673 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65690 */     GIR_RootConstrainSelectedInstOperands,
     /*  65691 */     // GIR_Coverage, 13850,
     /*  65691 */     GIR_EraseRootFromParent_Done,
     /*  65692 */   // Label 1091: @65692
     /*  65692 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65801), // Rule ID 13852 //
     /*  65697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65759 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65763 */     // MIs[3] LHS
     /*  65763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65782 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65799 */     GIR_RootConstrainSelectedInstOperands,
     /*  65800 */     // GIR_Coverage, 13852,
     /*  65800 */     GIR_EraseRootFromParent_Done,
     /*  65801 */   // Label 1092: @65801
     /*  65801 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65868), // Rule ID 13817 //
     /*  65806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65830 */     // MIs[1] imm
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65842 */     // MIs[2] Operand 1
     /*  65842 */     // No operand predicates
     /*  65842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65852 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65866 */     GIR_RootConstrainSelectedInstOperands,
     /*  65867 */     // GIR_Coverage, 13817,
     /*  65867 */     GIR_EraseRootFromParent_Done,
     /*  65868 */   // Label 1093: @65868
     /*  65868 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65935), // Rule ID 13838 //
     /*  65873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65897 */     // MIs[1] imm
     /*  65897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65905 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65909 */     // MIs[2] Operand 1
     /*  65909 */     // No operand predicates
     /*  65909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65919 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  65922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65933 */     GIR_RootConstrainSelectedInstOperands,
     /*  65934 */     // GIR_Coverage, 13838,
     /*  65934 */     GIR_EraseRootFromParent_Done,
     /*  65935 */   // Label 1094: @65935
     /*  65935 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(66002), // Rule ID 2243 //
     /*  65940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65968 */     // MIs[1] imm
     /*  65968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65980 */     // MIs[2] Operand 1
     /*  65980 */     // No operand predicates
     /*  65980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65986 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66000 */     GIR_RootConstrainSelectedInstOperands,
     /*  66001 */     // GIR_Coverage, 2243,
     /*  66001 */     GIR_EraseRootFromParent_Done,
     /*  66002 */   // Label 1095: @66002
     /*  66002 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(66069), // Rule ID 2302 //
     /*  66007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66035 */     // MIs[1] imm
     /*  66035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  66047 */     // MIs[2] Operand 1
     /*  66047 */     // No operand predicates
     /*  66047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66053 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  66056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66067 */     GIR_RootConstrainSelectedInstOperands,
     /*  66068 */     // GIR_Coverage, 2302,
     /*  66068 */     GIR_EraseRootFromParent_Done,
     /*  66069 */   // Label 1096: @66069
     /*  66069 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66133), // Rule ID 14156 //
     /*  66074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66120 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66125 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66131 */     GIR_RootConstrainSelectedInstOperands,
     /*  66132 */     // GIR_Coverage, 14156,
     /*  66132 */     GIR_EraseRootFromParent_Done,
     /*  66133 */   // Label 1097: @66133
     /*  66133 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66197), // Rule ID 5103 //
     /*  66138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66174 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66184 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66189 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66195 */     GIR_RootConstrainSelectedInstOperands,
     /*  66196 */     // GIR_Coverage, 5103,
     /*  66196 */     GIR_EraseRootFromParent_Done,
     /*  66197 */   // Label 1098: @66197
     /*  66197 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66224), // Rule ID 5109 //
     /*  66202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66217 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66222 */     GIR_RootConstrainSelectedInstOperands,
     /*  66223 */     // GIR_Coverage, 5109,
     /*  66223 */     GIR_Done,
     /*  66224 */   // Label 1099: @66224
     /*  66224 */   GIM_Reject,
     /*  66225 */ // Label 1084: @66225
     /*  66225 */ GIM_Reject,
     /*  66226 */ // Label 1033: @66226
     /*  66226 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67533),
     /*  66231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66237 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66346), // Rule ID 13882 //
     /*  66242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66290 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66307 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66311 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66315 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66320 */     // MIs[4] LHS
     /*  66320 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66325 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66327 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66344 */     GIR_RootConstrainSelectedInstOperands,
     /*  66345 */     // GIR_Coverage, 13882,
     /*  66345 */     GIR_EraseRootFromParent_Done,
     /*  66346 */   // Label 1101: @66346
     /*  66346 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66455), // Rule ID 13881 //
     /*  66351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66420 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66424 */     // MIs[4] LHS
     /*  66424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66429 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66436 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66453 */     GIR_RootConstrainSelectedInstOperands,
     /*  66454 */     // GIR_Coverage, 13881,
     /*  66454 */     GIR_EraseRootFromParent_Done,
     /*  66455 */   // Label 1102: @66455
     /*  66455 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66564), // Rule ID 13884 //
     /*  66460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66521 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66525 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66529 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66538 */     // MIs[4] LHS
     /*  66538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66545 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66562 */     GIR_RootConstrainSelectedInstOperands,
     /*  66563 */     // GIR_Coverage, 13884,
     /*  66563 */     GIR_EraseRootFromParent_Done,
     /*  66564 */   // Label 1103: @66564
     /*  66564 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66673), // Rule ID 13883 //
     /*  66569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66634 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66638 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66642 */     // MIs[4] LHS
     /*  66642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66654 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66671 */     GIR_RootConstrainSelectedInstOperands,
     /*  66672 */     // GIR_Coverage, 13883,
     /*  66672 */     GIR_EraseRootFromParent_Done,
     /*  66673 */   // Label 1104: @66673
     /*  66673 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66782), // Rule ID 2481 //
     /*  66678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66739 */     // MIs[3] LHS
     /*  66739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66763 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66780 */     GIR_RootConstrainSelectedInstOperands,
     /*  66781 */     // GIR_Coverage, 2481,
     /*  66781 */     GIR_EraseRootFromParent_Done,
     /*  66782 */   // Label 1105: @66782
     /*  66782 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66891), // Rule ID 13879 //
     /*  66787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66848 */     // MIs[3] LHS
     /*  66848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66857 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66872 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66889 */     GIR_RootConstrainSelectedInstOperands,
     /*  66890 */     // GIR_Coverage, 13879,
     /*  66890 */     GIR_EraseRootFromParent_Done,
     /*  66891 */   // Label 1106: @66891
     /*  66891 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(67000), // Rule ID 13878 //
     /*  66896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66962 */     // MIs[3] LHS
     /*  66962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66967 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66971 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66979 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66981 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66998 */     GIR_RootConstrainSelectedInstOperands,
     /*  66999 */     // GIR_Coverage, 13878,
     /*  66999 */     GIR_EraseRootFromParent_Done,
     /*  67000 */   // Label 1107: @67000
     /*  67000 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67109), // Rule ID 13880 //
     /*  67005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67071 */     // MIs[3] LHS
     /*  67071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67088 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67090 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  67090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67107 */     GIR_RootConstrainSelectedInstOperands,
     /*  67108 */     // GIR_Coverage, 13880,
     /*  67108 */     GIR_EraseRootFromParent_Done,
     /*  67109 */   // Label 1108: @67109
     /*  67109 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(67176), // Rule ID 13821 //
     /*  67114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67138 */     // MIs[1] imm
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67150 */     // MIs[2] Operand 1
     /*  67150 */     // No operand predicates
     /*  67150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67160 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67174 */     GIR_RootConstrainSelectedInstOperands,
     /*  67175 */     // GIR_Coverage, 13821,
     /*  67175 */     GIR_EraseRootFromParent_Done,
     /*  67176 */   // Label 1109: @67176
     /*  67176 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67243), // Rule ID 13842 //
     /*  67181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67205 */     // MIs[1] imm
     /*  67205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67217 */     // MIs[2] Operand 1
     /*  67217 */     // No operand predicates
     /*  67217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67227 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67241 */     GIR_RootConstrainSelectedInstOperands,
     /*  67242 */     // GIR_Coverage, 13842,
     /*  67242 */     GIR_EraseRootFromParent_Done,
     /*  67243 */   // Label 1110: @67243
     /*  67243 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67310), // Rule ID 2247 //
     /*  67248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67276 */     // MIs[1] imm
     /*  67276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67288 */     // MIs[2] Operand 1
     /*  67288 */     // No operand predicates
     /*  67288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67294 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67308 */     GIR_RootConstrainSelectedInstOperands,
     /*  67309 */     // GIR_Coverage, 2247,
     /*  67309 */     GIR_EraseRootFromParent_Done,
     /*  67310 */   // Label 1111: @67310
     /*  67310 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67377), // Rule ID 2306 //
     /*  67315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67343 */     // MIs[1] imm
     /*  67343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67355 */     // MIs[2] Operand 1
     /*  67355 */     // No operand predicates
     /*  67355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67361 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67375 */     GIR_RootConstrainSelectedInstOperands,
     /*  67376 */     // GIR_Coverage, 2306,
     /*  67376 */     GIR_EraseRootFromParent_Done,
     /*  67377 */   // Label 1112: @67377
     /*  67377 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67441), // Rule ID 14160 //
     /*  67382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67428 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67433 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67439 */     GIR_RootConstrainSelectedInstOperands,
     /*  67440 */     // GIR_Coverage, 14160,
     /*  67440 */     GIR_EraseRootFromParent_Done,
     /*  67441 */   // Label 1113: @67441
     /*  67441 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67505), // Rule ID 5107 //
     /*  67446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67482 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67492 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67497 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67503 */     GIR_RootConstrainSelectedInstOperands,
     /*  67504 */     // GIR_Coverage, 5107,
     /*  67504 */     GIR_EraseRootFromParent_Done,
     /*  67505 */   // Label 1114: @67505
     /*  67505 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67532), // Rule ID 5113 //
     /*  67510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67525 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67530 */     GIR_RootConstrainSelectedInstOperands,
     /*  67531 */     // GIR_Coverage, 5113,
     /*  67531 */     GIR_Done,
     /*  67532 */   // Label 1115: @67532
     /*  67532 */   GIM_Reject,
     /*  67533 */ // Label 1100: @67533
     /*  67533 */ GIM_Reject,
     /*  67534 */ // Label 1034: @67534
     /*  67534 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68841),
     /*  67539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67545 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67654), // Rule ID 13847 //
     /*  67550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67598 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67619 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67623 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67628 */     // MIs[4] LHS
     /*  67628 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67633 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67635 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67652 */     GIR_RootConstrainSelectedInstOperands,
     /*  67653 */     // GIR_Coverage, 13847,
     /*  67653 */     GIR_EraseRootFromParent_Done,
     /*  67654 */   // Label 1117: @67654
     /*  67654 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67763), // Rule ID 13846 //
     /*  67659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67707 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67728 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67732 */     // MIs[4] LHS
     /*  67732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67737 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67742 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67744 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67761 */     GIR_RootConstrainSelectedInstOperands,
     /*  67762 */     // GIR_Coverage, 13846,
     /*  67762 */     GIR_EraseRootFromParent_Done,
     /*  67763 */   // Label 1118: @67763
     /*  67763 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67872), // Rule ID 13849 //
     /*  67768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67821 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67833 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67837 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67841 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67846 */     // MIs[4] LHS
     /*  67846 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67851 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67853 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67870 */     GIR_RootConstrainSelectedInstOperands,
     /*  67871 */     // GIR_Coverage, 13849,
     /*  67871 */     GIR_EraseRootFromParent_Done,
     /*  67872 */   // Label 1119: @67872
     /*  67872 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67981), // Rule ID 13848 //
     /*  67877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67930 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67946 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67950 */     // MIs[4] LHS
     /*  67950 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67955 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67962 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67979 */     GIR_RootConstrainSelectedInstOperands,
     /*  67980 */     // GIR_Coverage, 13848,
     /*  67980 */     GIR_EraseRootFromParent_Done,
     /*  67981 */   // Label 1120: @67981
     /*  67981 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68090), // Rule ID 2476 //
     /*  67986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68047 */     // MIs[3] LHS
     /*  68047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68071 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68088 */     GIR_RootConstrainSelectedInstOperands,
     /*  68089 */     // GIR_Coverage, 2476,
     /*  68089 */     GIR_EraseRootFromParent_Done,
     /*  68090 */   // Label 1121: @68090
     /*  68090 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68199), // Rule ID 13844 //
     /*  68095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68156 */     // MIs[3] LHS
     /*  68156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68165 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68178 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68180 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68197 */     GIR_RootConstrainSelectedInstOperands,
     /*  68198 */     // GIR_Coverage, 13844,
     /*  68198 */     GIR_EraseRootFromParent_Done,
     /*  68199 */   // Label 1122: @68199
     /*  68199 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68308), // Rule ID 13843 //
     /*  68204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68270 */     // MIs[3] LHS
     /*  68270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68279 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68285 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68287 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68289 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68306 */     GIR_RootConstrainSelectedInstOperands,
     /*  68307 */     // GIR_Coverage, 13843,
     /*  68307 */     GIR_EraseRootFromParent_Done,
     /*  68308 */   // Label 1123: @68308
     /*  68308 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68417), // Rule ID 13845 //
     /*  68313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68379 */     // MIs[3] LHS
     /*  68379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68388 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68396 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68398 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68415 */     GIR_RootConstrainSelectedInstOperands,
     /*  68416 */     // GIR_Coverage, 13845,
     /*  68416 */     GIR_EraseRootFromParent_Done,
     /*  68417 */   // Label 1124: @68417
     /*  68417 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68484), // Rule ID 13813 //
     /*  68422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68446 */     // MIs[1] imm
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68458 */     // MIs[2] Operand 1
     /*  68458 */     // No operand predicates
     /*  68458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68468 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68482 */     GIR_RootConstrainSelectedInstOperands,
     /*  68483 */     // GIR_Coverage, 13813,
     /*  68483 */     GIR_EraseRootFromParent_Done,
     /*  68484 */   // Label 1125: @68484
     /*  68484 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68551), // Rule ID 13834 //
     /*  68489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68513 */     // MIs[1] imm
     /*  68513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68525 */     // MIs[2] Operand 1
     /*  68525 */     // No operand predicates
     /*  68525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68535 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68549 */     GIR_RootConstrainSelectedInstOperands,
     /*  68550 */     // GIR_Coverage, 13834,
     /*  68550 */     GIR_EraseRootFromParent_Done,
     /*  68551 */   // Label 1126: @68551
     /*  68551 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68618), // Rule ID 2239 //
     /*  68556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68584 */     // MIs[1] imm
     /*  68584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68596 */     // MIs[2] Operand 1
     /*  68596 */     // No operand predicates
     /*  68596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68602 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68616 */     GIR_RootConstrainSelectedInstOperands,
     /*  68617 */     // GIR_Coverage, 2239,
     /*  68617 */     GIR_EraseRootFromParent_Done,
     /*  68618 */   // Label 1127: @68618
     /*  68618 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68685), // Rule ID 2298 //
     /*  68623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68651 */     // MIs[1] imm
     /*  68651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68663 */     // MIs[2] Operand 1
     /*  68663 */     // No operand predicates
     /*  68663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68669 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68683 */     GIR_RootConstrainSelectedInstOperands,
     /*  68684 */     // GIR_Coverage, 2298,
     /*  68684 */     GIR_EraseRootFromParent_Done,
     /*  68685 */   // Label 1128: @68685
     /*  68685 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68749), // Rule ID 14155 //
     /*  68690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68722 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68736 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68741 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68747 */     GIR_RootConstrainSelectedInstOperands,
     /*  68748 */     // GIR_Coverage, 14155,
     /*  68748 */     GIR_EraseRootFromParent_Done,
     /*  68749 */   // Label 1129: @68749
     /*  68749 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68813), // Rule ID 5102 //
     /*  68754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68800 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68805 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68811 */     GIR_RootConstrainSelectedInstOperands,
     /*  68812 */     // GIR_Coverage, 5102,
     /*  68812 */     GIR_EraseRootFromParent_Done,
     /*  68813 */   // Label 1130: @68813
     /*  68813 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68840), // Rule ID 5108 //
     /*  68818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68833 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  68838 */     GIR_RootConstrainSelectedInstOperands,
     /*  68839 */     // GIR_Coverage, 5108,
     /*  68839 */     GIR_Done,
     /*  68840 */   // Label 1131: @68840
     /*  68840 */   GIM_Reject,
     /*  68841 */ // Label 1116: @68841
     /*  68841 */ GIM_Reject,
     /*  68842 */ // Label 1035: @68842
     /*  68842 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70149),
     /*  68847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68853 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68962), // Rule ID 13875 //
     /*  68858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68906 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68912 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68923 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68927 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68931 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68936 */     // MIs[4] LHS
     /*  68936 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68943 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  68952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  68956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  68960 */     GIR_RootConstrainSelectedInstOperands,
     /*  68961 */     // GIR_Coverage, 13875,
     /*  68961 */     GIR_EraseRootFromParent_Done,
     /*  68962 */   // Label 1133: @68962
     /*  68962 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(69071), // Rule ID 13874 //
     /*  68967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69015 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69036 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69040 */     // MIs[4] LHS
     /*  69040 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69045 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69052 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69069 */     GIR_RootConstrainSelectedInstOperands,
     /*  69070 */     // GIR_Coverage, 13874,
     /*  69070 */     GIR_EraseRootFromParent_Done,
     /*  69071 */   // Label 1134: @69071
     /*  69071 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69180), // Rule ID 13877 //
     /*  69076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69129 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69137 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69141 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69145 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69149 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69154 */     // MIs[4] LHS
     /*  69154 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69161 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69178 */     GIR_RootConstrainSelectedInstOperands,
     /*  69179 */     // GIR_Coverage, 13877,
     /*  69179 */     GIR_EraseRootFromParent_Done,
     /*  69180 */   // Label 1135: @69180
     /*  69180 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69289), // Rule ID 13876 //
     /*  69185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69238 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69250 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69254 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69258 */     // MIs[4] LHS
     /*  69258 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69263 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69268 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69270 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69287 */     GIR_RootConstrainSelectedInstOperands,
     /*  69288 */     // GIR_Coverage, 13876,
     /*  69288 */     GIR_EraseRootFromParent_Done,
     /*  69289 */   // Label 1136: @69289
     /*  69289 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69398), // Rule ID 2480 //
     /*  69294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69351 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69355 */     // MIs[3] LHS
     /*  69355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69364 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69377 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69379 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69396 */     GIR_RootConstrainSelectedInstOperands,
     /*  69397 */     // GIR_Coverage, 2480,
     /*  69397 */     GIR_EraseRootFromParent_Done,
     /*  69398 */   // Label 1137: @69398
     /*  69398 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69507), // Rule ID 13872 //
     /*  69403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69460 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69464 */     // MIs[3] LHS
     /*  69464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69469 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69473 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69488 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69505 */     GIR_RootConstrainSelectedInstOperands,
     /*  69506 */     // GIR_Coverage, 13872,
     /*  69506 */     GIR_EraseRootFromParent_Done,
     /*  69507 */   // Label 1138: @69507
     /*  69507 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69616), // Rule ID 13871 //
     /*  69512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69574 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69578 */     // MIs[3] LHS
     /*  69578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69583 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69587 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69597 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69614 */     GIR_RootConstrainSelectedInstOperands,
     /*  69615 */     // GIR_Coverage, 13871,
     /*  69615 */     GIR_EraseRootFromParent_Done,
     /*  69616 */   // Label 1139: @69616
     /*  69616 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69725), // Rule ID 13873 //
     /*  69621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69687 */     // MIs[3] LHS
     /*  69687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69696 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69706 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69723 */     GIR_RootConstrainSelectedInstOperands,
     /*  69724 */     // GIR_Coverage, 13873,
     /*  69724 */     GIR_EraseRootFromParent_Done,
     /*  69725 */   // Label 1140: @69725
     /*  69725 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69792), // Rule ID 13819 //
     /*  69730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69754 */     // MIs[1] imm
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69762 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69766 */     // MIs[2] Operand 1
     /*  69766 */     // No operand predicates
     /*  69766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69776 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69790 */     GIR_RootConstrainSelectedInstOperands,
     /*  69791 */     // GIR_Coverage, 13819,
     /*  69791 */     GIR_EraseRootFromParent_Done,
     /*  69792 */   // Label 1141: @69792
     /*  69792 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69859), // Rule ID 13840 //
     /*  69797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69821 */     // MIs[1] imm
     /*  69821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69833 */     // MIs[2] Operand 1
     /*  69833 */     // No operand predicates
     /*  69833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69843 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69857 */     GIR_RootConstrainSelectedInstOperands,
     /*  69858 */     // GIR_Coverage, 13840,
     /*  69858 */     GIR_EraseRootFromParent_Done,
     /*  69859 */   // Label 1142: @69859
     /*  69859 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69926), // Rule ID 2245 //
     /*  69864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69892 */     // MIs[1] imm
     /*  69892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69904 */     // MIs[2] Operand 1
     /*  69904 */     // No operand predicates
     /*  69904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69910 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69924 */     GIR_RootConstrainSelectedInstOperands,
     /*  69925 */     // GIR_Coverage, 2245,
     /*  69925 */     GIR_EraseRootFromParent_Done,
     /*  69926 */   // Label 1143: @69926
     /*  69926 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69993), // Rule ID 2304 //
     /*  69931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69959 */     // MIs[1] imm
     /*  69959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69971 */     // MIs[2] Operand 1
     /*  69971 */     // No operand predicates
     /*  69971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69977 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69991 */     GIR_RootConstrainSelectedInstOperands,
     /*  69992 */     // GIR_Coverage, 2304,
     /*  69992 */     GIR_EraseRootFromParent_Done,
     /*  69993 */   // Label 1144: @69993
     /*  69993 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70057), // Rule ID 14159 //
     /*  69998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70030 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70036 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70044 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70049 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70055 */     GIR_RootConstrainSelectedInstOperands,
     /*  70056 */     // GIR_Coverage, 14159,
     /*  70056 */     GIR_EraseRootFromParent_Done,
     /*  70057 */   // Label 1145: @70057
     /*  70057 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(70121), // Rule ID 5106 //
     /*  70062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70098 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70104 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70108 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70113 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70119 */     GIR_RootConstrainSelectedInstOperands,
     /*  70120 */     // GIR_Coverage, 5106,
     /*  70120 */     GIR_EraseRootFromParent_Done,
     /*  70121 */   // Label 1146: @70121
     /*  70121 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(70148), // Rule ID 5112 //
     /*  70126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70141 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70146 */     GIR_RootConstrainSelectedInstOperands,
     /*  70147 */     // GIR_Coverage, 5112,
     /*  70147 */     GIR_Done,
     /*  70148 */   // Label 1147: @70148
     /*  70148 */   GIM_Reject,
     /*  70149 */ // Label 1132: @70149
     /*  70149 */ GIM_Reject,
     /*  70150 */ // Label 1036: @70150
     /*  70150 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71457),
     /*  70155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70161 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70270), // Rule ID 13625 //
     /*  70166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70214 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70227 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70231 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70235 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70239 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70244 */     // MIs[4] Rd
     /*  70244 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70249 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70251 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70268 */     GIR_RootConstrainSelectedInstOperands,
     /*  70269 */     // GIR_Coverage, 13625,
     /*  70269 */     GIR_EraseRootFromParent_Done,
     /*  70270 */   // Label 1149: @70270
     /*  70270 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70379), // Rule ID 13624 //
     /*  70275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70323 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70344 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70348 */     // MIs[4] Rd
     /*  70348 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70353 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70360 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70377 */     GIR_RootConstrainSelectedInstOperands,
     /*  70378 */     // GIR_Coverage, 13624,
     /*  70378 */     GIR_EraseRootFromParent_Done,
     /*  70379 */   // Label 1150: @70379
     /*  70379 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70488), // Rule ID 13627 //
     /*  70384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70445 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70449 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70453 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70457 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70462 */     // MIs[4] Rd
     /*  70462 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70467 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70469 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70486 */     GIR_RootConstrainSelectedInstOperands,
     /*  70487 */     // GIR_Coverage, 13627,
     /*  70487 */     GIR_EraseRootFromParent_Done,
     /*  70488 */   // Label 1151: @70488
     /*  70488 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70597), // Rule ID 13626 //
     /*  70493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70546 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70554 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70558 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70562 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70566 */     // MIs[4] Rd
     /*  70566 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70571 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70578 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70595 */     GIR_RootConstrainSelectedInstOperands,
     /*  70596 */     // GIR_Coverage, 13626,
     /*  70596 */     GIR_EraseRootFromParent_Done,
     /*  70597 */   // Label 1152: @70597
     /*  70597 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70706), // Rule ID 1609 //
     /*  70602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70663 */     // MIs[3] Rd
     /*  70663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70672 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70687 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70704 */     GIR_RootConstrainSelectedInstOperands,
     /*  70705 */     // GIR_Coverage, 1609,
     /*  70705 */     GIR_EraseRootFromParent_Done,
     /*  70706 */   // Label 1153: @70706
     /*  70706 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70815), // Rule ID 13622 //
     /*  70711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70772 */     // MIs[3] Rd
     /*  70772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70781 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70787 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70796 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  70805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70813 */     GIR_RootConstrainSelectedInstOperands,
     /*  70814 */     // GIR_Coverage, 13622,
     /*  70814 */     GIR_EraseRootFromParent_Done,
     /*  70815 */   // Label 1154: @70815
     /*  70815 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70924), // Rule ID 13621 //
     /*  70820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70882 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70886 */     // MIs[3] Rd
     /*  70886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70891 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70895 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70905 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  70922 */     GIR_RootConstrainSelectedInstOperands,
     /*  70923 */     // GIR_Coverage, 13621,
     /*  70923 */     GIR_EraseRootFromParent_Done,
     /*  70924 */   // Label 1155: @70924
     /*  70924 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71033), // Rule ID 13623 //
     /*  70929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70991 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70995 */     // MIs[3] Rd
     /*  70995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71004 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71010 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71014 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  71017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71031 */     GIR_RootConstrainSelectedInstOperands,
     /*  71032 */     // GIR_Coverage, 13623,
     /*  71032 */     GIR_EraseRootFromParent_Done,
     /*  71033 */   // Label 1156: @71033
     /*  71033 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71100), // Rule ID 13809 //
     /*  71038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71062 */     // MIs[1] imm
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71074 */     // MIs[2] Operand 1
     /*  71074 */     // No operand predicates
     /*  71074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71084 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71098 */     GIR_RootConstrainSelectedInstOperands,
     /*  71099 */     // GIR_Coverage, 13809,
     /*  71099 */     GIR_EraseRootFromParent_Done,
     /*  71100 */   // Label 1157: @71100
     /*  71100 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71167), // Rule ID 13830 //
     /*  71105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71129 */     // MIs[1] imm
     /*  71129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71141 */     // MIs[2] Operand 1
     /*  71141 */     // No operand predicates
     /*  71141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71151 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71165 */     GIR_RootConstrainSelectedInstOperands,
     /*  71166 */     // GIR_Coverage, 13830,
     /*  71166 */     GIR_EraseRootFromParent_Done,
     /*  71167 */   // Label 1158: @71167
     /*  71167 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71234), // Rule ID 2235 //
     /*  71172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71200 */     // MIs[1] imm
     /*  71200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71212 */     // MIs[2] Operand 1
     /*  71212 */     // No operand predicates
     /*  71212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71218 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71232 */     GIR_RootConstrainSelectedInstOperands,
     /*  71233 */     // GIR_Coverage, 2235,
     /*  71233 */     GIR_EraseRootFromParent_Done,
     /*  71234 */   // Label 1159: @71234
     /*  71234 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71301), // Rule ID 2294 //
     /*  71239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71267 */     // MIs[1] imm
     /*  71267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71275 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71279 */     // MIs[2] Operand 1
     /*  71279 */     // No operand predicates
     /*  71279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71285 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71299 */     GIR_RootConstrainSelectedInstOperands,
     /*  71300 */     // GIR_Coverage, 2294,
     /*  71300 */     GIR_EraseRootFromParent_Done,
     /*  71301 */   // Label 1160: @71301
     /*  71301 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71365), // Rule ID 13619 //
     /*  71306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71338 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71352 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71363 */     GIR_RootConstrainSelectedInstOperands,
     /*  71364 */     // GIR_Coverage, 13619,
     /*  71364 */     GIR_EraseRootFromParent_Done,
     /*  71365 */   // Label 1161: @71365
     /*  71365 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71429), // Rule ID 1605 //
     /*  71370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71416 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71427 */     GIR_RootConstrainSelectedInstOperands,
     /*  71428 */     // GIR_Coverage, 1605,
     /*  71428 */     GIR_EraseRootFromParent_Done,
     /*  71429 */   // Label 1162: @71429
     /*  71429 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71456), // Rule ID 1607 //
     /*  71434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71449 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  71454 */     GIR_RootConstrainSelectedInstOperands,
     /*  71455 */     // GIR_Coverage, 1607,
     /*  71455 */     GIR_Done,
     /*  71456 */   // Label 1163: @71456
     /*  71456 */   GIM_Reject,
     /*  71457 */ // Label 1148: @71457
     /*  71457 */ GIM_Reject,
     /*  71458 */ // Label 1037: @71458
     /*  71458 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72765),
     /*  71463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71469 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71578), // Rule ID 13868 //
     /*  71474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71522 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71528 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71547 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71552 */     // MIs[4] LHS
     /*  71552 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71557 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71559 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71576 */     GIR_RootConstrainSelectedInstOperands,
     /*  71577 */     // GIR_Coverage, 13868,
     /*  71577 */     GIR_EraseRootFromParent_Done,
     /*  71578 */   // Label 1165: @71578
     /*  71578 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71687), // Rule ID 13867 //
     /*  71583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71631 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71652 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71656 */     // MIs[4] LHS
     /*  71656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71661 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71668 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71685 */     GIR_RootConstrainSelectedInstOperands,
     /*  71686 */     // GIR_Coverage, 13867,
     /*  71686 */     GIR_EraseRootFromParent_Done,
     /*  71687 */   // Label 1166: @71687
     /*  71687 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71796), // Rule ID 13870 //
     /*  71692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71745 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71751 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71753 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71757 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71761 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71765 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71770 */     // MIs[4] LHS
     /*  71770 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71775 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71777 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71794 */     GIR_RootConstrainSelectedInstOperands,
     /*  71795 */     // GIR_Coverage, 13870,
     /*  71795 */     GIR_EraseRootFromParent_Done,
     /*  71796 */   // Label 1167: @71796
     /*  71796 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71905), // Rule ID 13869 //
     /*  71801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71854 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71870 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71874 */     // MIs[4] LHS
     /*  71874 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71879 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71886 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71903 */     GIR_RootConstrainSelectedInstOperands,
     /*  71904 */     // GIR_Coverage, 13869,
     /*  71904 */     GIR_EraseRootFromParent_Done,
     /*  71905 */   // Label 1168: @71905
     /*  71905 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72014), // Rule ID 2479 //
     /*  71910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71967 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71971 */     // MIs[3] LHS
     /*  71971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71980 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71993 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71995 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  72004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  72008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  72012 */     GIR_RootConstrainSelectedInstOperands,
     /*  72013 */     // GIR_Coverage, 2479,
     /*  72013 */     GIR_EraseRootFromParent_Done,
     /*  72014 */   // Label 1169: @72014
     /*  72014 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72123), // Rule ID 13865 //
     /*  72019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  72072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72080 */     // MIs[3] LHS
     /*  72080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72085 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72089 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72095 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72104 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  72121 */     GIR_RootConstrainSelectedInstOperands,
     /*  72122 */     // GIR_Coverage, 13865,
     /*  72122 */     GIR_EraseRootFromParent_Done,
     /*  72123 */   // Label 1170: @72123
     /*  72123 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72232), // Rule ID 13864 //
     /*  72128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72194 */     // MIs[3] LHS
     /*  72194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72199 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72203 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72211 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72213 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  72222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  72226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72230 */     GIR_RootConstrainSelectedInstOperands,
     /*  72231 */     // GIR_Coverage, 13864,
     /*  72231 */     GIR_EraseRootFromParent_Done,
     /*  72232 */   // Label 1171: @72232
     /*  72232 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72341), // Rule ID 13866 //
     /*  72237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72303 */     // MIs[3] LHS
     /*  72303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72312 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72318 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72320 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72322 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72339 */     GIR_RootConstrainSelectedInstOperands,
     /*  72340 */     // GIR_Coverage, 13866,
     /*  72340 */     GIR_EraseRootFromParent_Done,
     /*  72341 */   // Label 1172: @72341
     /*  72341 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72408), // Rule ID 13815 //
     /*  72346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     // MIs[1] imm
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72378 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72382 */     // MIs[2] Operand 1
     /*  72382 */     // No operand predicates
     /*  72382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72392 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72406 */     GIR_RootConstrainSelectedInstOperands,
     /*  72407 */     // GIR_Coverage, 13815,
     /*  72407 */     GIR_EraseRootFromParent_Done,
     /*  72408 */   // Label 1173: @72408
     /*  72408 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72475), // Rule ID 13836 //
     /*  72413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72437 */     // MIs[1] imm
     /*  72437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72445 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72449 */     // MIs[2] Operand 1
     /*  72449 */     // No operand predicates
     /*  72449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72459 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72473 */     GIR_RootConstrainSelectedInstOperands,
     /*  72474 */     // GIR_Coverage, 13836,
     /*  72474 */     GIR_EraseRootFromParent_Done,
     /*  72475 */   // Label 1174: @72475
     /*  72475 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72542), // Rule ID 2241 //
     /*  72480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72508 */     // MIs[1] imm
     /*  72508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72520 */     // MIs[2] Operand 1
     /*  72520 */     // No operand predicates
     /*  72520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72526 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72540 */     GIR_RootConstrainSelectedInstOperands,
     /*  72541 */     // GIR_Coverage, 2241,
     /*  72541 */     GIR_EraseRootFromParent_Done,
     /*  72542 */   // Label 1175: @72542
     /*  72542 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72609), // Rule ID 2300 //
     /*  72547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72575 */     // MIs[1] imm
     /*  72575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72587 */     // MIs[2] Operand 1
     /*  72587 */     // No operand predicates
     /*  72587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72593 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72607 */     GIR_RootConstrainSelectedInstOperands,
     /*  72608 */     // GIR_Coverage, 2300,
     /*  72608 */     GIR_EraseRootFromParent_Done,
     /*  72609 */   // Label 1176: @72609
     /*  72609 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72673), // Rule ID 14158 //
     /*  72614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72646 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72652 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72660 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72665 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  72667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72671 */     GIR_RootConstrainSelectedInstOperands,
     /*  72672 */     // GIR_Coverage, 14158,
     /*  72672 */     GIR_EraseRootFromParent_Done,
     /*  72673 */   // Label 1177: @72673
     /*  72673 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72737), // Rule ID 5105 //
     /*  72678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72714 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72724 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72729 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  72731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72735 */     GIR_RootConstrainSelectedInstOperands,
     /*  72736 */     // GIR_Coverage, 5105,
     /*  72736 */     GIR_EraseRootFromParent_Done,
     /*  72737 */   // Label 1178: @72737
     /*  72737 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72764), // Rule ID 5111 //
     /*  72742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72757 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72762 */     GIR_RootConstrainSelectedInstOperands,
     /*  72763 */     // GIR_Coverage, 5111,
     /*  72763 */     GIR_Done,
     /*  72764 */   // Label 1179: @72764
     /*  72764 */   GIM_Reject,
     /*  72765 */ // Label 1164: @72765
     /*  72765 */ GIM_Reject,
     /*  72766 */ // Label 1038: @72766
     /*  72766 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(74073),
     /*  72771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72777 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72886), // Rule ID 13632 //
     /*  72782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72830 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72836 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72843 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72847 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72851 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72855 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72860 */     // MIs[4] Rd
     /*  72860 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72865 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72867 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  72880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72884 */     GIR_RootConstrainSelectedInstOperands,
     /*  72885 */     // GIR_Coverage, 13632,
     /*  72885 */     GIR_EraseRootFromParent_Done,
     /*  72886 */   // Label 1181: @72886
     /*  72886 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72995), // Rule ID 13631 //
     /*  72891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72960 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72964 */     // MIs[4] Rd
     /*  72964 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72969 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72976 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  72989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72993 */     GIR_RootConstrainSelectedInstOperands,
     /*  72994 */     // GIR_Coverage, 13631,
     /*  72994 */     GIR_EraseRootFromParent_Done,
     /*  72995 */   // Label 1182: @72995
     /*  72995 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73104), // Rule ID 13634 //
     /*  73000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73053 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73061 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73065 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73069 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73073 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73078 */     // MIs[4] Rd
     /*  73078 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73085 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  73098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73102 */     GIR_RootConstrainSelectedInstOperands,
     /*  73103 */     // GIR_Coverage, 13634,
     /*  73103 */     GIR_EraseRootFromParent_Done,
     /*  73104 */   // Label 1183: @73104
     /*  73104 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73213), // Rule ID 13633 //
     /*  73109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73162 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73178 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73182 */     // MIs[4] Rd
     /*  73182 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73187 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73192 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73194 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  73207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73211 */     GIR_RootConstrainSelectedInstOperands,
     /*  73212 */     // GIR_Coverage, 13633,
     /*  73212 */     GIR_EraseRootFromParent_Done,
     /*  73213 */   // Label 1184: @73213
     /*  73213 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73322), // Rule ID 1610 //
     /*  73218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73279 */     // MIs[3] Rd
     /*  73279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73301 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73303 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73320 */     GIR_RootConstrainSelectedInstOperands,
     /*  73321 */     // GIR_Coverage, 1610,
     /*  73321 */     GIR_EraseRootFromParent_Done,
     /*  73322 */   // Label 1185: @73322
     /*  73322 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73431), // Rule ID 13629 //
     /*  73327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73388 */     // MIs[3] Rd
     /*  73388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73393 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73397 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73403 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73410 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73412 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73429 */     GIR_RootConstrainSelectedInstOperands,
     /*  73430 */     // GIR_Coverage, 13629,
     /*  73430 */     GIR_EraseRootFromParent_Done,
     /*  73431 */   // Label 1186: @73431
     /*  73431 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73540), // Rule ID 13628 //
     /*  73436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73498 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73502 */     // MIs[3] Rd
     /*  73502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73507 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73511 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73519 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73521 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73538 */     GIR_RootConstrainSelectedInstOperands,
     /*  73539 */     // GIR_Coverage, 13628,
     /*  73539 */     GIR_EraseRootFromParent_Done,
     /*  73540 */   // Label 1187: @73540
     /*  73540 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73649), // Rule ID 13630 //
     /*  73545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73611 */     // MIs[3] Rd
     /*  73611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73620 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73626 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73630 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73647 */     GIR_RootConstrainSelectedInstOperands,
     /*  73648 */     // GIR_Coverage, 13630,
     /*  73648 */     GIR_EraseRootFromParent_Done,
     /*  73649 */   // Label 1188: @73649
     /*  73649 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73716), // Rule ID 13811 //
     /*  73654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73678 */     // MIs[1] imm
     /*  73678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73686 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73690 */     // MIs[2] Operand 1
     /*  73690 */     // No operand predicates
     /*  73690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73700 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73714 */     GIR_RootConstrainSelectedInstOperands,
     /*  73715 */     // GIR_Coverage, 13811,
     /*  73715 */     GIR_EraseRootFromParent_Done,
     /*  73716 */   // Label 1189: @73716
     /*  73716 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73783), // Rule ID 13832 //
     /*  73721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73745 */     // MIs[1] imm
     /*  73745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73757 */     // MIs[2] Operand 1
     /*  73757 */     // No operand predicates
     /*  73757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73767 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73781 */     GIR_RootConstrainSelectedInstOperands,
     /*  73782 */     // GIR_Coverage, 13832,
     /*  73782 */     GIR_EraseRootFromParent_Done,
     /*  73783 */   // Label 1190: @73783
     /*  73783 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73850), // Rule ID 2237 //
     /*  73788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73816 */     // MIs[1] imm
     /*  73816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73824 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73828 */     // MIs[2] Operand 1
     /*  73828 */     // No operand predicates
     /*  73828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73834 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73848 */     GIR_RootConstrainSelectedInstOperands,
     /*  73849 */     // GIR_Coverage, 2237,
     /*  73849 */     GIR_EraseRootFromParent_Done,
     /*  73850 */   // Label 1191: @73850
     /*  73850 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73917), // Rule ID 2296 //
     /*  73855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73883 */     // MIs[1] imm
     /*  73883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73891 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73895 */     // MIs[2] Operand 1
     /*  73895 */     // No operand predicates
     /*  73895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73901 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73915 */     GIR_RootConstrainSelectedInstOperands,
     /*  73916 */     // GIR_Coverage, 2296,
     /*  73916 */     GIR_EraseRootFromParent_Done,
     /*  73917 */   // Label 1192: @73917
     /*  73917 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73981), // Rule ID 13620 //
     /*  73922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73954 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  73962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73968 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  73971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73979 */     GIR_RootConstrainSelectedInstOperands,
     /*  73980 */     // GIR_Coverage, 13620,
     /*  73980 */     GIR_EraseRootFromParent_Done,
     /*  73981 */   // Label 1193: @73981
     /*  73981 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74045), // Rule ID 1606 //
     /*  73986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  74009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74022 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74032 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  74035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  74043 */     GIR_RootConstrainSelectedInstOperands,
     /*  74044 */     // GIR_Coverage, 1606,
     /*  74044 */     GIR_EraseRootFromParent_Done,
     /*  74045 */   // Label 1194: @74045
     /*  74045 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74072), // Rule ID 1608 //
     /*  74050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74065 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  74070 */     GIR_RootConstrainSelectedInstOperands,
     /*  74071 */     // GIR_Coverage, 1608,
     /*  74071 */     GIR_Done,
     /*  74072 */   // Label 1195: @74072
     /*  74072 */   GIM_Reject,
     /*  74073 */ // Label 1180: @74073
     /*  74073 */ GIM_Reject,
     /*  74074 */ // Label 1039: @74074
     /*  74074 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74105), // Rule ID 8577 //
     /*  74079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  74085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  74088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74092 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  74092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74099 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74101 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74103 */   GIR_RootConstrainSelectedInstOperands,
     /*  74104 */   // GIR_Coverage, 8577,
     /*  74104 */   GIR_EraseRootFromParent_Done,
     /*  74105 */ // Label 1196: @74105
     /*  74105 */ GIM_Reject,
     /*  74106 */ // Label 1040: @74106
     /*  74106 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74137), // Rule ID 8576 //
     /*  74111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  74117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  74120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74124 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  74124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74129 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74131 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74133 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74135 */   GIR_RootConstrainSelectedInstOperands,
     /*  74136 */   // GIR_Coverage, 8576,
     /*  74136 */   GIR_EraseRootFromParent_Done,
     /*  74137 */ // Label 1197: @74137
     /*  74137 */ GIM_Reject,
     /*  74138 */ // Label 1041: @74138
     /*  74138 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(77497),
     /*  74143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74153 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74271), // Rule ID 16135 //
     /*  74158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74197 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74205 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74209 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74213 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74217 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74221 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74225 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74233 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74237 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74241 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74245 */     // MIs[6] Op3
     /*  74245 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74250 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74252 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74269 */     GIR_RootConstrainSelectedInstOperands,
     /*  74270 */     // GIR_Coverage, 16135,
     /*  74270 */     GIR_EraseRootFromParent_Done,
     /*  74271 */   // Label 1199: @74271
     /*  74271 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74389), // Rule ID 16137 //
     /*  74276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74315 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74323 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74327 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74331 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74335 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74339 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74343 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74351 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74355 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74359 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74363 */     // MIs[6] Op3
     /*  74363 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74368 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74370 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74387 */     GIR_RootConstrainSelectedInstOperands,
     /*  74388 */     // GIR_Coverage, 16137,
     /*  74388 */     GIR_EraseRootFromParent_Done,
     /*  74389 */   // Label 1200: @74389
     /*  74389 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74507), // Rule ID 16134 //
     /*  74394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74433 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74441 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74445 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74449 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74453 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74457 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74461 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74469 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74473 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74477 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74481 */     // MIs[6] Op3
     /*  74481 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74486 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74488 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74505 */     GIR_RootConstrainSelectedInstOperands,
     /*  74506 */     // GIR_Coverage, 16134,
     /*  74506 */     GIR_EraseRootFromParent_Done,
     /*  74507 */   // Label 1201: @74507
     /*  74507 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74625), // Rule ID 16136 //
     /*  74512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74567 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74571 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74575 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74579 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74587 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74591 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74595 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74599 */     // MIs[6] Op3
     /*  74599 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74604 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74606 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74623 */     GIR_RootConstrainSelectedInstOperands,
     /*  74624 */     // GIR_Coverage, 16136,
     /*  74624 */     GIR_EraseRootFromParent_Done,
     /*  74625 */   // Label 1202: @74625
     /*  74625 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74743), // Rule ID 16026 //
     /*  74630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74677 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74681 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74685 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74689 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74693 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74697 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74701 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74705 */     // MIs[5] Op3
     /*  74705 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74710 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74714 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74722 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74724 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  74737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74741 */     GIR_RootConstrainSelectedInstOperands,
     /*  74742 */     // GIR_Coverage, 16026,
     /*  74742 */     GIR_EraseRootFromParent_Done,
     /*  74743 */   // Label 1203: @74743
     /*  74743 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74861), // Rule ID 16031 //
     /*  74748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74787 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74793 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74795 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74799 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74803 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74807 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74811 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74815 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74819 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74823 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74827 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74835 */     // MIs[4] Op3
     /*  74835 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74840 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74842 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74859 */     GIR_RootConstrainSelectedInstOperands,
     /*  74860 */     // GIR_Coverage, 16031,
     /*  74860 */     GIR_EraseRootFromParent_Done,
     /*  74861 */   // Label 1204: @74861
     /*  74861 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74979), // Rule ID 16032 //
     /*  74866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74905 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74913 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74917 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74921 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74925 */     // MIs[4] Op3
     /*  74925 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74930 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74934 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74938 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74942 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74946 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74950 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74958 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74960 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74977 */     GIR_RootConstrainSelectedInstOperands,
     /*  74978 */     // GIR_Coverage, 16032,
     /*  74978 */     GIR_EraseRootFromParent_Done,
     /*  74979 */   // Label 1205: @74979
     /*  74979 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75097), // Rule ID 12071 //
     /*  74984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75023 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75043 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75055 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75059 */     // MIs[5] Op3
     /*  75059 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75064 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75068 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75076 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75078 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75095 */     GIR_RootConstrainSelectedInstOperands,
     /*  75096 */     // GIR_Coverage, 12071,
     /*  75096 */     GIR_EraseRootFromParent_Done,
     /*  75097 */   // Label 1206: @75097
     /*  75097 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75215), // Rule ID 16028 //
     /*  75102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75141 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75153 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75157 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75161 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75165 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75169 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75173 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75177 */     // MIs[5] Op3
     /*  75177 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75182 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75186 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75192 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75194 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75196 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  75209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75213 */     GIR_RootConstrainSelectedInstOperands,
     /*  75214 */     // GIR_Coverage, 16028,
     /*  75214 */     GIR_EraseRootFromParent_Done,
     /*  75215 */   // Label 1207: @75215
     /*  75215 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75333), // Rule ID 16029 //
     /*  75220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75259 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75271 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75275 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75279 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75283 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75287 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75291 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75295 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75299 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75307 */     // MIs[4] Op3
     /*  75307 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75312 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75314 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75331 */     GIR_RootConstrainSelectedInstOperands,
     /*  75332 */     // GIR_Coverage, 16029,
     /*  75332 */     GIR_EraseRootFromParent_Done,
     /*  75333 */   // Label 1208: @75333
     /*  75333 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75451), // Rule ID 16030 //
     /*  75338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75377 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75385 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75389 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75393 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75397 */     // MIs[4] Op3
     /*  75397 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75402 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75406 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75410 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75414 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75418 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75422 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75430 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75432 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75449 */     GIR_RootConstrainSelectedInstOperands,
     /*  75450 */     // GIR_Coverage, 16030,
     /*  75450 */     GIR_EraseRootFromParent_Done,
     /*  75451 */   // Label 1209: @75451
     /*  75451 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75569), // Rule ID 16027 //
     /*  75456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75495 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75503 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75507 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75511 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75515 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75519 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75523 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75527 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75531 */     // MIs[5] Op3
     /*  75531 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75536 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75540 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75548 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75550 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75567 */     GIR_RootConstrainSelectedInstOperands,
     /*  75568 */     // GIR_Coverage, 16027,
     /*  75568 */     GIR_EraseRootFromParent_Done,
     /*  75569 */   // Label 1210: @75569
     /*  75569 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75687), // Rule ID 16131 //
     /*  75574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75621 */     // MIs[3] Op3
     /*  75621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75630 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75646 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75650 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75654 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75658 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75664 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75666 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75668 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75685 */     GIR_RootConstrainSelectedInstOperands,
     /*  75686 */     // GIR_Coverage, 16131,
     /*  75686 */     GIR_EraseRootFromParent_Done,
     /*  75687 */   // Label 1211: @75687
     /*  75687 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75805), // Rule ID 16133 //
     /*  75692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75739 */     // MIs[3] Op3
     /*  75739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75764 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75768 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75772 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75776 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75782 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75784 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75786 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75803 */     GIR_RootConstrainSelectedInstOperands,
     /*  75804 */     // GIR_Coverage, 16133,
     /*  75804 */     GIR_EraseRootFromParent_Done,
     /*  75805 */   // Label 1212: @75805
     /*  75805 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75923), // Rule ID 12098 //
     /*  75810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75853 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75857 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75865 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75873 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75877 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75881 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75885 */     // MIs[5] Op3
     /*  75885 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75890 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75894 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75902 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75904 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75921 */     GIR_RootConstrainSelectedInstOperands,
     /*  75922 */     // GIR_Coverage, 12098,
     /*  75922 */     GIR_EraseRootFromParent_Done,
     /*  75923 */   // Label 1213: @75923
     /*  75923 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(76041), // Rule ID 16132 //
     /*  75928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75983 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75989 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75991 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75995 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75999 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76003 */     // MIs[5] Op3
     /*  76003 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76008 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76012 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76020 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76022 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  76035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76039 */     GIR_RootConstrainSelectedInstOperands,
     /*  76040 */     // GIR_Coverage, 16132,
     /*  76040 */     GIR_EraseRootFromParent_Done,
     /*  76041 */   // Label 1214: @76041
     /*  76041 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76131), // Rule ID 15948 //
     /*  76046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76085 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76091 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76093 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76097 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76101 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76105 */     // MIs[4] Op3
     /*  76105 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76112 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76129 */     GIR_RootConstrainSelectedInstOperands,
     /*  76130 */     // GIR_Coverage, 15948,
     /*  76130 */     GIR_EraseRootFromParent_Done,
     /*  76131 */   // Label 1215: @76131
     /*  76131 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76221), // Rule ID 15947 //
     /*  76136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76195 */     // MIs[4] Op3
     /*  76195 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76202 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76219 */     GIR_RootConstrainSelectedInstOperands,
     /*  76220 */     // GIR_Coverage, 15947,
     /*  76220 */     GIR_EraseRootFromParent_Done,
     /*  76221 */   // Label 1216: @76221
     /*  76221 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(76311), // Rule ID 15946 //
     /*  76226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76265 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76281 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76285 */     // MIs[4] Op3
     /*  76285 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76290 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76292 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76309 */     GIR_RootConstrainSelectedInstOperands,
     /*  76310 */     // GIR_Coverage, 15946,
     /*  76310 */     GIR_EraseRootFromParent_Done,
     /*  76311 */   // Label 1217: @76311
     /*  76311 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76401), // Rule ID 15945 //
     /*  76316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76355 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76367 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76371 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76375 */     // MIs[4] Op3
     /*  76375 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76382 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76399 */     GIR_RootConstrainSelectedInstOperands,
     /*  76400 */     // GIR_Coverage, 15945,
     /*  76400 */     GIR_EraseRootFromParent_Done,
     /*  76401 */   // Label 1218: @76401
     /*  76401 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76491), // Rule ID 15942 //
     /*  76406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76449 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76453 */     // MIs[3] Op3
     /*  76453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76462 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76472 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76489 */     GIR_RootConstrainSelectedInstOperands,
     /*  76490 */     // GIR_Coverage, 15942,
     /*  76490 */     GIR_EraseRootFromParent_Done,
     /*  76491 */   // Label 1219: @76491
     /*  76491 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76581), // Rule ID 15944 //
     /*  76496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76539 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76543 */     // MIs[3] Op3
     /*  76543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76552 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76558 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76562 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76579 */     GIR_RootConstrainSelectedInstOperands,
     /*  76580 */     // GIR_Coverage, 15944,
     /*  76580 */     GIR_EraseRootFromParent_Done,
     /*  76581 */   // Label 1220: @76581
     /*  76581 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76671), // Rule ID 12047 //
     /*  76586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76629 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76633 */     // MIs[3] Op3
     /*  76633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76638 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76642 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76652 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76669 */     GIR_RootConstrainSelectedInstOperands,
     /*  76670 */     // GIR_Coverage, 12047,
     /*  76670 */     GIR_EraseRootFromParent_Done,
     /*  76671 */   // Label 1221: @76671
     /*  76671 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76761), // Rule ID 15943 //
     /*  76676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76723 */     // MIs[3] Op3
     /*  76723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76740 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76742 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76759 */     GIR_RootConstrainSelectedInstOperands,
     /*  76760 */     // GIR_Coverage, 15943,
     /*  76760 */     GIR_EraseRootFromParent_Done,
     /*  76761 */   // Label 1222: @76761
     /*  76761 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76851), // Rule ID 16138 //
     /*  76766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76813 */     // MIs[3] Op3
     /*  76813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76822 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76828 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76830 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76832 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76849 */     GIR_RootConstrainSelectedInstOperands,
     /*  76850 */     // GIR_Coverage, 16138,
     /*  76850 */     GIR_EraseRootFromParent_Done,
     /*  76851 */   // Label 1223: @76851
     /*  76851 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76941), // Rule ID 16140 //
     /*  76856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76903 */     // MIs[3] Op3
     /*  76903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76912 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76918 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76920 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76922 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76939 */     GIR_RootConstrainSelectedInstOperands,
     /*  76940 */     // GIR_Coverage, 16140,
     /*  76940 */     GIR_EraseRootFromParent_Done,
     /*  76941 */   // Label 1224: @76941
     /*  76941 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(77031), // Rule ID 12099 //
     /*  76946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76993 */     // MIs[3] Op3
     /*  76993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  77002 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77010 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77012 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77029 */     GIR_RootConstrainSelectedInstOperands,
     /*  77030 */     // GIR_Coverage, 12099,
     /*  77030 */     GIR_EraseRootFromParent_Done,
     /*  77031 */   // Label 1225: @77031
     /*  77031 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77121), // Rule ID 16139 //
     /*  77036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77083 */     // MIs[3] Op3
     /*  77083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  77092 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77102 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77119 */     GIR_RootConstrainSelectedInstOperands,
     /*  77120 */     // GIR_Coverage, 16139,
     /*  77120 */     GIR_EraseRootFromParent_Done,
     /*  77121 */   // Label 1226: @77121
     /*  77121 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77211), // Rule ID 16142 //
     /*  77126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77165 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77173 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77177 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77181 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77185 */     // MIs[4] Op3
     /*  77185 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77190 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77192 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77209 */     GIR_RootConstrainSelectedInstOperands,
     /*  77210 */     // GIR_Coverage, 16142,
     /*  77210 */     GIR_EraseRootFromParent_Done,
     /*  77211 */   // Label 1227: @77211
     /*  77211 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77301), // Rule ID 16144 //
     /*  77216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77255 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77261 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77263 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77267 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77271 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77275 */     // MIs[4] Op3
     /*  77275 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77280 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77282 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77299 */     GIR_RootConstrainSelectedInstOperands,
     /*  77300 */     // GIR_Coverage, 16144,
     /*  77300 */     GIR_EraseRootFromParent_Done,
     /*  77301 */   // Label 1228: @77301
     /*  77301 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77391), // Rule ID 16141 //
     /*  77306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77345 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77357 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77361 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77365 */     // MIs[4] Op3
     /*  77365 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77370 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77372 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77389 */     GIR_RootConstrainSelectedInstOperands,
     /*  77390 */     // GIR_Coverage, 16141,
     /*  77390 */     GIR_EraseRootFromParent_Done,
     /*  77391 */   // Label 1229: @77391
     /*  77391 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77481), // Rule ID 16143 //
     /*  77396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77447 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77451 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77455 */     // MIs[4] Op3
     /*  77455 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77460 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77462 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77479 */     GIR_RootConstrainSelectedInstOperands,
     /*  77480 */     // GIR_Coverage, 16143,
     /*  77480 */     GIR_EraseRootFromParent_Done,
     /*  77481 */   // Label 1230: @77481
     /*  77481 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77496), // Rule ID 7557 //
     /*  77486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77489 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  77494 */     GIR_RootConstrainSelectedInstOperands,
     /*  77495 */     // GIR_Coverage, 7557,
     /*  77495 */     GIR_Done,
     /*  77496 */   // Label 1231: @77496
     /*  77496 */   GIM_Reject,
     /*  77497 */ // Label 1198: @77497
     /*  77497 */ GIM_Reject,
     /*  77498 */ // Label 1042: @77498
     /*  77498 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77529), // Rule ID 8575 //
     /*  77503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77516 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  77519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77521 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77523 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77525 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77527 */   GIR_RootConstrainSelectedInstOperands,
     /*  77528 */   // GIR_Coverage, 8575,
     /*  77528 */   GIR_EraseRootFromParent_Done,
     /*  77529 */ // Label 1232: @77529
     /*  77529 */ GIM_Reject,
     /*  77530 */ // Label 1043: @77530
     /*  77530 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(80889),
     /*  77535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77545 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(77663), // Rule ID 16121 //
     /*  77550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77609 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77613 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77617 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77623 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77625 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77629 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77633 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77637 */     // MIs[6] Op3
     /*  77637 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77642 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77644 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77661 */     GIR_RootConstrainSelectedInstOperands,
     /*  77662 */     // GIR_Coverage, 16121,
     /*  77662 */     GIR_EraseRootFromParent_Done,
     /*  77663 */   // Label 1234: @77663
     /*  77663 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(77781), // Rule ID 16123 //
     /*  77668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77707 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77715 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77719 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77723 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77727 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77731 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77735 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77743 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77747 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77751 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77755 */     // MIs[6] Op3
     /*  77755 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77760 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77762 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77779 */     GIR_RootConstrainSelectedInstOperands,
     /*  77780 */     // GIR_Coverage, 16123,
     /*  77780 */     GIR_EraseRootFromParent_Done,
     /*  77781 */   // Label 1235: @77781
     /*  77781 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77899), // Rule ID 16120 //
     /*  77786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77825 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77833 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77837 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77841 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77845 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77849 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77853 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77861 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77865 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77869 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77873 */     // MIs[6] Op3
     /*  77873 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77878 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77880 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77897 */     GIR_RootConstrainSelectedInstOperands,
     /*  77898 */     // GIR_Coverage, 16120,
     /*  77898 */     GIR_EraseRootFromParent_Done,
     /*  77899 */   // Label 1236: @77899
     /*  77899 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78017), // Rule ID 16122 //
     /*  77904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77943 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77955 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77959 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77963 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77967 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77971 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77979 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77983 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77987 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77991 */     // MIs[6] Op3
     /*  77991 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77996 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77998 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  78007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78015 */     GIR_RootConstrainSelectedInstOperands,
     /*  78016 */     // GIR_Coverage, 16122,
     /*  78016 */     GIR_EraseRootFromParent_Done,
     /*  78017 */   // Label 1237: @78017
     /*  78017 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78135), // Rule ID 16019 //
     /*  78022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78061 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78073 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78077 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78081 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78085 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78089 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78093 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78097 */     // MIs[5] Op3
     /*  78097 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78102 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78106 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78114 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78116 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78133 */     GIR_RootConstrainSelectedInstOperands,
     /*  78134 */     // GIR_Coverage, 16019,
     /*  78134 */     GIR_EraseRootFromParent_Done,
     /*  78135 */   // Label 1238: @78135
     /*  78135 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78253), // Rule ID 16024 //
     /*  78140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78179 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78185 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78187 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78191 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78195 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78207 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78211 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78215 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78219 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78225 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78227 */     // MIs[4] Op3
     /*  78227 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78232 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78234 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78251 */     GIR_RootConstrainSelectedInstOperands,
     /*  78252 */     // GIR_Coverage, 16024,
     /*  78252 */     GIR_EraseRootFromParent_Done,
     /*  78253 */   // Label 1239: @78253
     /*  78253 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78371), // Rule ID 16025 //
     /*  78258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78297 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78313 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78317 */     // MIs[4] Op3
     /*  78317 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78322 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78326 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78330 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78334 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78338 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78342 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78350 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78352 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78369 */     GIR_RootConstrainSelectedInstOperands,
     /*  78370 */     // GIR_Coverage, 16025,
     /*  78370 */     GIR_EraseRootFromParent_Done,
     /*  78371 */   // Label 1240: @78371
     /*  78371 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78489), // Rule ID 12069 //
     /*  78376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78435 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78447 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78451 */     // MIs[5] Op3
     /*  78451 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78456 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78460 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78468 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78470 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78487 */     GIR_RootConstrainSelectedInstOperands,
     /*  78488 */     // GIR_Coverage, 12069,
     /*  78488 */     GIR_EraseRootFromParent_Done,
     /*  78489 */   // Label 1241: @78489
     /*  78489 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78607), // Rule ID 16021 //
     /*  78494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78533 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78545 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78549 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78553 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78557 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78561 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78565 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78569 */     // MIs[5] Op3
     /*  78569 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78574 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78578 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78584 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78586 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78588 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78605 */     GIR_RootConstrainSelectedInstOperands,
     /*  78606 */     // GIR_Coverage, 16021,
     /*  78606 */     GIR_EraseRootFromParent_Done,
     /*  78607 */   // Label 1242: @78607
     /*  78607 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78725), // Rule ID 16022 //
     /*  78612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78651 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78667 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78671 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78675 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78679 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78683 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78687 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78691 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78699 */     // MIs[4] Op3
     /*  78699 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78704 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78706 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78723 */     GIR_RootConstrainSelectedInstOperands,
     /*  78724 */     // GIR_Coverage, 16022,
     /*  78724 */     GIR_EraseRootFromParent_Done,
     /*  78725 */   // Label 1243: @78725
     /*  78725 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78843), // Rule ID 16023 //
     /*  78730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78789 */     // MIs[4] Op3
     /*  78789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78794 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78798 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78802 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78806 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78810 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78814 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78822 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78824 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78841 */     GIR_RootConstrainSelectedInstOperands,
     /*  78842 */     // GIR_Coverage, 16023,
     /*  78842 */     GIR_EraseRootFromParent_Done,
     /*  78843 */   // Label 1244: @78843
     /*  78843 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(78961), // Rule ID 16020 //
     /*  78848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78887 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78895 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78899 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78903 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78907 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78911 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78915 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78919 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78923 */     // MIs[5] Op3
     /*  78923 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78928 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78932 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78940 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78942 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78959 */     GIR_RootConstrainSelectedInstOperands,
     /*  78960 */     // GIR_Coverage, 16020,
     /*  78960 */     GIR_EraseRootFromParent_Done,
     /*  78961 */   // Label 1245: @78961
     /*  78961 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79079), // Rule ID 16117 //
     /*  78966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79009 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79013 */     // MIs[3] Op3
     /*  79013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79018 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79022 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79030 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79034 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79038 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79042 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79046 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79050 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79058 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79060 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79077 */     GIR_RootConstrainSelectedInstOperands,
     /*  79078 */     // GIR_Coverage, 16117,
     /*  79078 */     GIR_EraseRootFromParent_Done,
     /*  79079 */   // Label 1246: @79079
     /*  79079 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79197), // Rule ID 16119 //
     /*  79084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79131 */     // MIs[3] Op3
     /*  79131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79140 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79146 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79148 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79152 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79156 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79160 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79164 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79168 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79176 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79178 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79195 */     GIR_RootConstrainSelectedInstOperands,
     /*  79196 */     // GIR_Coverage, 16119,
     /*  79196 */     GIR_EraseRootFromParent_Done,
     /*  79197 */   // Label 1247: @79197
     /*  79197 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79315), // Rule ID 12095 //
     /*  79202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79249 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79257 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79265 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79269 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79273 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79277 */     // MIs[5] Op3
     /*  79277 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79282 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79286 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79294 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79296 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79313 */     GIR_RootConstrainSelectedInstOperands,
     /*  79314 */     // GIR_Coverage, 12095,
     /*  79314 */     GIR_EraseRootFromParent_Done,
     /*  79315 */   // Label 1248: @79315
     /*  79315 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79433), // Rule ID 16118 //
     /*  79320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79363 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79367 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79371 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79375 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79381 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79383 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79387 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79391 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79395 */     // MIs[5] Op3
     /*  79395 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79400 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79404 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79412 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79414 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79431 */     GIR_RootConstrainSelectedInstOperands,
     /*  79432 */     // GIR_Coverage, 16118,
     /*  79432 */     GIR_EraseRootFromParent_Done,
     /*  79433 */   // Label 1249: @79433
     /*  79433 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79523), // Rule ID 15941 //
     /*  79438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79477 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79485 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79489 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79493 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79497 */     // MIs[4] Op3
     /*  79497 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79502 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79504 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79521 */     GIR_RootConstrainSelectedInstOperands,
     /*  79522 */     // GIR_Coverage, 15941,
     /*  79522 */     GIR_EraseRootFromParent_Done,
     /*  79523 */   // Label 1250: @79523
     /*  79523 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79613), // Rule ID 15940 //
     /*  79528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79567 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79575 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79579 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79583 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79587 */     // MIs[4] Op3
     /*  79587 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79594 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79611 */     GIR_RootConstrainSelectedInstOperands,
     /*  79612 */     // GIR_Coverage, 15940,
     /*  79612 */     GIR_EraseRootFromParent_Done,
     /*  79613 */   // Label 1251: @79613
     /*  79613 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79703), // Rule ID 15939 //
     /*  79618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79657 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79669 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79673 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79677 */     // MIs[4] Op3
     /*  79677 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79684 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79701 */     GIR_RootConstrainSelectedInstOperands,
     /*  79702 */     // GIR_Coverage, 15939,
     /*  79702 */     GIR_EraseRootFromParent_Done,
     /*  79703 */   // Label 1252: @79703
     /*  79703 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79793), // Rule ID 15938 //
     /*  79708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79747 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79753 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79755 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79759 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79763 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79767 */     // MIs[4] Op3
     /*  79767 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79774 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79791 */     GIR_RootConstrainSelectedInstOperands,
     /*  79792 */     // GIR_Coverage, 15938,
     /*  79792 */     GIR_EraseRootFromParent_Done,
     /*  79793 */   // Label 1253: @79793
     /*  79793 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79883), // Rule ID 15935 //
     /*  79798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79845 */     // MIs[3] Op3
     /*  79845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79854 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79864 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79881 */     GIR_RootConstrainSelectedInstOperands,
     /*  79882 */     // GIR_Coverage, 15935,
     /*  79882 */     GIR_EraseRootFromParent_Done,
     /*  79883 */   // Label 1254: @79883
     /*  79883 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79973), // Rule ID 15937 //
     /*  79888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79935 */     // MIs[3] Op3
     /*  79935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79952 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79954 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79971 */     GIR_RootConstrainSelectedInstOperands,
     /*  79972 */     // GIR_Coverage, 15937,
     /*  79972 */     GIR_EraseRootFromParent_Done,
     /*  79973 */   // Label 1255: @79973
     /*  79973 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(80063), // Rule ID 12045 //
     /*  79978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80021 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80025 */     // MIs[3] Op3
     /*  80025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80034 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80042 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80044 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80061 */     GIR_RootConstrainSelectedInstOperands,
     /*  80062 */     // GIR_Coverage, 12045,
     /*  80062 */     GIR_EraseRootFromParent_Done,
     /*  80063 */   // Label 1256: @80063
     /*  80063 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80153), // Rule ID 15936 //
     /*  80068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80115 */     // MIs[3] Op3
     /*  80115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80134 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80151 */     GIR_RootConstrainSelectedInstOperands,
     /*  80152 */     // GIR_Coverage, 15936,
     /*  80152 */     GIR_EraseRootFromParent_Done,
     /*  80153 */   // Label 1257: @80153
     /*  80153 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80243), // Rule ID 16124 //
     /*  80158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80201 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80205 */     // MIs[3] Op3
     /*  80205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80210 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80214 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80224 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80241 */     GIR_RootConstrainSelectedInstOperands,
     /*  80242 */     // GIR_Coverage, 16124,
     /*  80242 */     GIR_EraseRootFromParent_Done,
     /*  80243 */   // Label 1258: @80243
     /*  80243 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80333), // Rule ID 16126 //
     /*  80248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80291 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80295 */     // MIs[3] Op3
     /*  80295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80300 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80304 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80310 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80312 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80314 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80331 */     GIR_RootConstrainSelectedInstOperands,
     /*  80332 */     // GIR_Coverage, 16126,
     /*  80332 */     GIR_EraseRootFromParent_Done,
     /*  80333 */   // Label 1259: @80333
     /*  80333 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80423), // Rule ID 12096 //
     /*  80338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80385 */     // MIs[3] Op3
     /*  80385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80390 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80394 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80402 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80404 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80421 */     GIR_RootConstrainSelectedInstOperands,
     /*  80422 */     // GIR_Coverage, 12096,
     /*  80422 */     GIR_EraseRootFromParent_Done,
     /*  80423 */   // Label 1260: @80423
     /*  80423 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80513), // Rule ID 16125 //
     /*  80428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80471 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80475 */     // MIs[3] Op3
     /*  80475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80492 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80494 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80511 */     GIR_RootConstrainSelectedInstOperands,
     /*  80512 */     // GIR_Coverage, 16125,
     /*  80512 */     GIR_EraseRootFromParent_Done,
     /*  80513 */   // Label 1261: @80513
     /*  80513 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80603), // Rule ID 16128 //
     /*  80518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80573 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80577 */     // MIs[4] Op3
     /*  80577 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80584 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80601 */     GIR_RootConstrainSelectedInstOperands,
     /*  80602 */     // GIR_Coverage, 16128,
     /*  80602 */     GIR_EraseRootFromParent_Done,
     /*  80603 */   // Label 1262: @80603
     /*  80603 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80693), // Rule ID 16130 //
     /*  80608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80647 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80655 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80659 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80663 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80667 */     // MIs[4] Op3
     /*  80667 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80672 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80674 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80691 */     GIR_RootConstrainSelectedInstOperands,
     /*  80692 */     // GIR_Coverage, 16130,
     /*  80692 */     GIR_EraseRootFromParent_Done,
     /*  80693 */   // Label 1263: @80693
     /*  80693 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80783), // Rule ID 16127 //
     /*  80698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80737 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80743 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80745 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80749 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80753 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80757 */     // MIs[4] Op3
     /*  80757 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80762 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80764 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80781 */     GIR_RootConstrainSelectedInstOperands,
     /*  80782 */     // GIR_Coverage, 16127,
     /*  80782 */     GIR_EraseRootFromParent_Done,
     /*  80783 */   // Label 1264: @80783
     /*  80783 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80873), // Rule ID 16129 //
     /*  80788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80843 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80847 */     // MIs[4] Op3
     /*  80847 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80852 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80854 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80871 */     GIR_RootConstrainSelectedInstOperands,
     /*  80872 */     // GIR_Coverage, 16129,
     /*  80872 */     GIR_EraseRootFromParent_Done,
     /*  80873 */   // Label 1265: @80873
     /*  80873 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(80888), // Rule ID 7556 //
     /*  80878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80881 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  80881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  80886 */     GIR_RootConstrainSelectedInstOperands,
     /*  80887 */     // GIR_Coverage, 7556,
     /*  80887 */     GIR_Done,
     /*  80888 */   // Label 1266: @80888
     /*  80888 */   GIM_Reject,
     /*  80889 */ // Label 1233: @80889
     /*  80889 */ GIM_Reject,
     /*  80890 */ // Label 1044: @80890
     /*  80890 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(80921), // Rule ID 8574 //
     /*  80895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  80901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  80904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  80908 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  80908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  80911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  80913 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80917 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  80919 */   GIR_RootConstrainSelectedInstOperands,
     /*  80920 */   // GIR_Coverage, 8574,
     /*  80920 */   GIR_EraseRootFromParent_Done,
     /*  80921 */ // Label 1267: @80921
     /*  80921 */ GIM_Reject,
     /*  80922 */ // Label 1045: @80922
     /*  80922 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(84281),
     /*  80927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  80937 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81055), // Rule ID 16107 //
     /*  80942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  80993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80997 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81001 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81005 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81009 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81017 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81021 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81025 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81029 */     // MIs[6] Op3
     /*  81029 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81034 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81036 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81053 */     GIR_RootConstrainSelectedInstOperands,
     /*  81054 */     // GIR_Coverage, 16107,
     /*  81054 */     GIR_EraseRootFromParent_Done,
     /*  81055 */   // Label 1269: @81055
     /*  81055 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81173), // Rule ID 16109 //
     /*  81060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81099 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81105 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81107 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81111 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81115 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81119 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81123 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81127 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81135 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81139 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81143 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81147 */     // MIs[6] Op3
     /*  81147 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81152 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81154 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81171 */     GIR_RootConstrainSelectedInstOperands,
     /*  81172 */     // GIR_Coverage, 16109,
     /*  81172 */     GIR_EraseRootFromParent_Done,
     /*  81173 */   // Label 1270: @81173
     /*  81173 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81291), // Rule ID 16106 //
     /*  81178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81217 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81223 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81225 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81229 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81233 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81237 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81241 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81245 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81253 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81257 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81261 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81265 */     // MIs[6] Op3
     /*  81265 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81270 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81272 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81289 */     GIR_RootConstrainSelectedInstOperands,
     /*  81290 */     // GIR_Coverage, 16106,
     /*  81290 */     GIR_EraseRootFromParent_Done,
     /*  81291 */   // Label 1271: @81291
     /*  81291 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81409), // Rule ID 16108 //
     /*  81296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81335 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81351 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81355 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81359 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81363 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81371 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81375 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81379 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81383 */     // MIs[6] Op3
     /*  81383 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81388 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81390 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81407 */     GIR_RootConstrainSelectedInstOperands,
     /*  81408 */     // GIR_Coverage, 16108,
     /*  81408 */     GIR_EraseRootFromParent_Done,
     /*  81409 */   // Label 1272: @81409
     /*  81409 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81527), // Rule ID 16012 //
     /*  81414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81469 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81473 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81477 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81481 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81485 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81489 */     // MIs[5] Op3
     /*  81489 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81494 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81498 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81506 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81508 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81525 */     GIR_RootConstrainSelectedInstOperands,
     /*  81526 */     // GIR_Coverage, 16012,
     /*  81526 */     GIR_EraseRootFromParent_Done,
     /*  81527 */   // Label 1273: @81527
     /*  81527 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81645), // Rule ID 16017 //
     /*  81532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81571 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81579 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81583 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81587 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81591 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81595 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81599 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81603 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81607 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81611 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81617 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81619 */     // MIs[4] Op3
     /*  81619 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81624 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81626 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81643 */     GIR_RootConstrainSelectedInstOperands,
     /*  81644 */     // GIR_Coverage, 16017,
     /*  81644 */     GIR_EraseRootFromParent_Done,
     /*  81645 */   // Label 1274: @81645
     /*  81645 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81763), // Rule ID 16018 //
     /*  81650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81689 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81697 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81701 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81705 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81709 */     // MIs[4] Op3
     /*  81709 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81714 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81718 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81722 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81726 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81730 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81734 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81742 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81744 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81761 */     GIR_RootConstrainSelectedInstOperands,
     /*  81762 */     // GIR_Coverage, 16018,
     /*  81762 */     GIR_EraseRootFromParent_Done,
     /*  81763 */   // Label 1275: @81763
     /*  81763 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(81881), // Rule ID 12067 //
     /*  81768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81807 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81813 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81815 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81819 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81823 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81827 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81831 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81835 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81839 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81843 */     // MIs[5] Op3
     /*  81843 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81848 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81852 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81860 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81862 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81879 */     GIR_RootConstrainSelectedInstOperands,
     /*  81880 */     // GIR_Coverage, 12067,
     /*  81880 */     GIR_EraseRootFromParent_Done,
     /*  81881 */   // Label 1276: @81881
     /*  81881 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(81999), // Rule ID 16014 //
     /*  81886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81933 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81937 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81941 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81945 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81949 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81953 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81957 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81961 */     // MIs[5] Op3
     /*  81961 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81966 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81970 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81978 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81980 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81997 */     GIR_RootConstrainSelectedInstOperands,
     /*  81998 */     // GIR_Coverage, 16014,
     /*  81998 */     GIR_EraseRootFromParent_Done,
     /*  81999 */   // Label 1277: @81999
     /*  81999 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82117), // Rule ID 16015 //
     /*  82004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82043 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82049 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82051 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82055 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82059 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82063 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  82067 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82071 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82075 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82079 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82083 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82091 */     // MIs[4] Op3
     /*  82091 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82096 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82098 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82115 */     GIR_RootConstrainSelectedInstOperands,
     /*  82116 */     // GIR_Coverage, 16015,
     /*  82116 */     GIR_EraseRootFromParent_Done,
     /*  82117 */   // Label 1278: @82117
     /*  82117 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82235), // Rule ID 16016 //
     /*  82122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82177 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82181 */     // MIs[4] Op3
     /*  82181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82186 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82190 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82194 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82198 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82202 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82206 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82214 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82216 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82233 */     GIR_RootConstrainSelectedInstOperands,
     /*  82234 */     // GIR_Coverage, 16016,
     /*  82234 */     GIR_EraseRootFromParent_Done,
     /*  82235 */   // Label 1279: @82235
     /*  82235 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82353), // Rule ID 16013 //
     /*  82240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82279 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82285 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82299 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82303 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82307 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82311 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82315 */     // MIs[5] Op3
     /*  82315 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82320 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82324 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82330 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82332 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82334 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  82343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  82347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82351 */     GIR_RootConstrainSelectedInstOperands,
     /*  82352 */     // GIR_Coverage, 16013,
     /*  82352 */     GIR_EraseRootFromParent_Done,
     /*  82353 */   // Label 1280: @82353
     /*  82353 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82471), // Rule ID 16103 //
     /*  82358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82401 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82405 */     // MIs[3] Op3
     /*  82405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82414 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82422 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82426 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82430 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82434 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82438 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82442 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82450 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82452 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82469 */     GIR_RootConstrainSelectedInstOperands,
     /*  82470 */     // GIR_Coverage, 16103,
     /*  82470 */     GIR_EraseRootFromParent_Done,
     /*  82471 */   // Label 1281: @82471
     /*  82471 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82589), // Rule ID 16105 //
     /*  82476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82519 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82523 */     // MIs[3] Op3
     /*  82523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82532 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82538 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82540 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82544 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82548 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82552 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82556 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82560 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82568 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82570 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82587 */     GIR_RootConstrainSelectedInstOperands,
     /*  82588 */     // GIR_Coverage, 16105,
     /*  82588 */     GIR_EraseRootFromParent_Done,
     /*  82589 */   // Label 1282: @82589
     /*  82589 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82707), // Rule ID 12092 //
     /*  82594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82645 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82649 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82657 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82661 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82665 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82669 */     // MIs[5] Op3
     /*  82669 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82674 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82678 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82686 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82688 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82705 */     GIR_RootConstrainSelectedInstOperands,
     /*  82706 */     // GIR_Coverage, 12092,
     /*  82706 */     GIR_EraseRootFromParent_Done,
     /*  82707 */   // Label 1283: @82707
     /*  82707 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82825), // Rule ID 16104 //
     /*  82712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82755 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82759 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82767 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82775 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82779 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82783 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82787 */     // MIs[5] Op3
     /*  82787 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82792 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82796 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82804 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82806 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82823 */     GIR_RootConstrainSelectedInstOperands,
     /*  82824 */     // GIR_Coverage, 16104,
     /*  82824 */     GIR_EraseRootFromParent_Done,
     /*  82825 */   // Label 1284: @82825
     /*  82825 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82915), // Rule ID 15934 //
     /*  82830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82869 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82875 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82877 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82881 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82885 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82889 */     // MIs[4] Op3
     /*  82889 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82896 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82913 */     GIR_RootConstrainSelectedInstOperands,
     /*  82914 */     // GIR_Coverage, 15934,
     /*  82914 */     GIR_EraseRootFromParent_Done,
     /*  82915 */   // Label 1285: @82915
     /*  82915 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(83005), // Rule ID 15933 //
     /*  82920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82959 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82965 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82967 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82971 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82975 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82979 */     // MIs[4] Op3
     /*  82979 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82984 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82986 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83003 */     GIR_RootConstrainSelectedInstOperands,
     /*  83004 */     // GIR_Coverage, 15933,
     /*  83004 */     GIR_EraseRootFromParent_Done,
     /*  83005 */   // Label 1286: @83005
     /*  83005 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(83095), // Rule ID 15932 //
     /*  83010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83049 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83055 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83057 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83061 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83065 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83069 */     // MIs[4] Op3
     /*  83069 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83074 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83076 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83093 */     GIR_RootConstrainSelectedInstOperands,
     /*  83094 */     // GIR_Coverage, 15932,
     /*  83094 */     GIR_EraseRootFromParent_Done,
     /*  83095 */   // Label 1287: @83095
     /*  83095 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(83185), // Rule ID 15931 //
     /*  83100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83139 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83155 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83159 */     // MIs[4] Op3
     /*  83159 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83166 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  83175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83183 */     GIR_RootConstrainSelectedInstOperands,
     /*  83184 */     // GIR_Coverage, 15931,
     /*  83184 */     GIR_EraseRootFromParent_Done,
     /*  83185 */   // Label 1288: @83185
     /*  83185 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83275), // Rule ID 15928 //
     /*  83190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83237 */     // MIs[3] Op3
     /*  83237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83242 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83246 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83254 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83256 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83273 */     GIR_RootConstrainSelectedInstOperands,
     /*  83274 */     // GIR_Coverage, 15928,
     /*  83274 */     GIR_EraseRootFromParent_Done,
     /*  83275 */   // Label 1289: @83275
     /*  83275 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83365), // Rule ID 15930 //
     /*  83280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83323 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83327 */     // MIs[3] Op3
     /*  83327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83336 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83346 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83363 */     GIR_RootConstrainSelectedInstOperands,
     /*  83364 */     // GIR_Coverage, 15930,
     /*  83364 */     GIR_EraseRootFromParent_Done,
     /*  83365 */   // Label 1290: @83365
     /*  83365 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83455), // Rule ID 12043 //
     /*  83370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83413 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83417 */     // MIs[3] Op3
     /*  83417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83426 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83436 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83453 */     GIR_RootConstrainSelectedInstOperands,
     /*  83454 */     // GIR_Coverage, 12043,
     /*  83454 */     GIR_EraseRootFromParent_Done,
     /*  83455 */   // Label 1291: @83455
     /*  83455 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83545), // Rule ID 15929 //
     /*  83460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83507 */     // MIs[3] Op3
     /*  83507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83526 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83543 */     GIR_RootConstrainSelectedInstOperands,
     /*  83544 */     // GIR_Coverage, 15929,
     /*  83544 */     GIR_EraseRootFromParent_Done,
     /*  83545 */   // Label 1292: @83545
     /*  83545 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83635), // Rule ID 16110 //
     /*  83550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83593 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83597 */     // MIs[3] Op3
     /*  83597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83606 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83616 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83633 */     GIR_RootConstrainSelectedInstOperands,
     /*  83634 */     // GIR_Coverage, 16110,
     /*  83634 */     GIR_EraseRootFromParent_Done,
     /*  83635 */   // Label 1293: @83635
     /*  83635 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83725), // Rule ID 16112 //
     /*  83640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83687 */     // MIs[3] Op3
     /*  83687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83696 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83706 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83723 */     GIR_RootConstrainSelectedInstOperands,
     /*  83724 */     // GIR_Coverage, 16112,
     /*  83724 */     GIR_EraseRootFromParent_Done,
     /*  83725 */   // Label 1294: @83725
     /*  83725 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83815), // Rule ID 12093 //
     /*  83730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83777 */     // MIs[3] Op3
     /*  83777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83786 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83796 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83813 */     GIR_RootConstrainSelectedInstOperands,
     /*  83814 */     // GIR_Coverage, 12093,
     /*  83814 */     GIR_EraseRootFromParent_Done,
     /*  83815 */   // Label 1295: @83815
     /*  83815 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83905), // Rule ID 16111 //
     /*  83820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83867 */     // MIs[3] Op3
     /*  83867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83876 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83886 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83903 */     GIR_RootConstrainSelectedInstOperands,
     /*  83904 */     // GIR_Coverage, 16111,
     /*  83904 */     GIR_EraseRootFromParent_Done,
     /*  83905 */   // Label 1296: @83905
     /*  83905 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(83995), // Rule ID 16114 //
     /*  83910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  83949 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83955 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83957 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83961 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83965 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83969 */     // MIs[4] Op3
     /*  83969 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  83974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83976 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  83993 */     GIR_RootConstrainSelectedInstOperands,
     /*  83994 */     // GIR_Coverage, 16114,
     /*  83994 */     GIR_EraseRootFromParent_Done,
     /*  83995 */   // Label 1297: @83995
     /*  83995 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84085), // Rule ID 16116 //
     /*  84000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84039 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84045 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84055 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84059 */     // MIs[4] Op3
     /*  84059 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84066 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84083 */     GIR_RootConstrainSelectedInstOperands,
     /*  84084 */     // GIR_Coverage, 16116,
     /*  84084 */     GIR_EraseRootFromParent_Done,
     /*  84085 */   // Label 1298: @84085
     /*  84085 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84175), // Rule ID 16113 //
     /*  84090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84129 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84137 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84141 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84145 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84149 */     // MIs[4] Op3
     /*  84149 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  84154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84156 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  84173 */     GIR_RootConstrainSelectedInstOperands,
     /*  84174 */     // GIR_Coverage, 16113,
     /*  84174 */     GIR_EraseRootFromParent_Done,
     /*  84175 */   // Label 1299: @84175
     /*  84175 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84265), // Rule ID 16115 //
     /*  84180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84219 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84225 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84227 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84231 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84235 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84239 */     // MIs[4] Op3
     /*  84239 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84246 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84263 */     GIR_RootConstrainSelectedInstOperands,
     /*  84264 */     // GIR_Coverage, 16115,
     /*  84264 */     GIR_EraseRootFromParent_Done,
     /*  84265 */   // Label 1300: @84265
     /*  84265 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84280), // Rule ID 7555 //
     /*  84270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84273 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  84273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  84278 */     GIR_RootConstrainSelectedInstOperands,
     /*  84279 */     // GIR_Coverage, 7555,
     /*  84279 */     GIR_Done,
     /*  84280 */   // Label 1301: @84280
     /*  84280 */   GIM_Reject,
     /*  84281 */ // Label 1268: @84281
     /*  84281 */ GIM_Reject,
     /*  84282 */ // Label 1046: @84282
     /*  84282 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84313), // Rule ID 8573 //
     /*  84287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  84293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  84296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  84300 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  84300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  84303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  84305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84307 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84309 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  84311 */   GIR_RootConstrainSelectedInstOperands,
     /*  84312 */   // GIR_Coverage, 8573,
     /*  84312 */   GIR_EraseRootFromParent_Done,
     /*  84313 */ // Label 1302: @84313
     /*  84313 */ GIM_Reject,
     /*  84314 */ // Label 1047: @84314
     /*  84314 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(87673),
     /*  84319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  84329 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84447), // Rule ID 16093 //
     /*  84334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84389 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84393 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84397 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84401 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84409 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84413 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84417 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84421 */     // MIs[6] Op3
     /*  84421 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84426 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84428 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84445 */     GIR_RootConstrainSelectedInstOperands,
     /*  84446 */     // GIR_Coverage, 16093,
     /*  84446 */     GIR_EraseRootFromParent_Done,
     /*  84447 */   // Label 1304: @84447
     /*  84447 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84565), // Rule ID 16095 //
     /*  84452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84491 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84511 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84515 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84519 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84527 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84531 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84535 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84539 */     // MIs[6] Op3
     /*  84539 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84544 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84546 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84563 */     GIR_RootConstrainSelectedInstOperands,
     /*  84564 */     // GIR_Coverage, 16095,
     /*  84564 */     GIR_EraseRootFromParent_Done,
     /*  84565 */   // Label 1305: @84565
     /*  84565 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84683), // Rule ID 16092 //
     /*  84570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84609 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84621 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84625 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84629 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84633 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84637 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84645 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84649 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84653 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84657 */     // MIs[6] Op3
     /*  84657 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84662 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84664 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84681 */     GIR_RootConstrainSelectedInstOperands,
     /*  84682 */     // GIR_Coverage, 16092,
     /*  84682 */     GIR_EraseRootFromParent_Done,
     /*  84683 */   // Label 1306: @84683
     /*  84683 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(84801), // Rule ID 16094 //
     /*  84688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84727 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84735 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84739 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84743 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84747 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84751 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84755 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84763 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84767 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84771 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84775 */     // MIs[6] Op3
     /*  84775 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84780 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84782 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84799 */     GIR_RootConstrainSelectedInstOperands,
     /*  84800 */     // GIR_Coverage, 16094,
     /*  84800 */     GIR_EraseRootFromParent_Done,
     /*  84801 */   // Label 1307: @84801
     /*  84801 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(84919), // Rule ID 16005 //
     /*  84806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84861 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84865 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84869 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84873 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84877 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84881 */     // MIs[5] Op3
     /*  84881 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84886 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84890 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84898 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84900 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  84913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84917 */     GIR_RootConstrainSelectedInstOperands,
     /*  84918 */     // GIR_Coverage, 16005,
     /*  84918 */     GIR_EraseRootFromParent_Done,
     /*  84919 */   // Label 1308: @84919
     /*  84919 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85037), // Rule ID 16010 //
     /*  84924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84963 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84979 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84987 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84991 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84995 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84999 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85003 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85009 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85011 */     // MIs[4] Op3
     /*  85011 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85016 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85018 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85035 */     GIR_RootConstrainSelectedInstOperands,
     /*  85036 */     // GIR_Coverage, 16010,
     /*  85036 */     GIR_EraseRootFromParent_Done,
     /*  85037 */   // Label 1309: @85037
     /*  85037 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85155), // Rule ID 16011 //
     /*  85042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85081 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85087 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85089 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85093 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85097 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85101 */     // MIs[4] Op3
     /*  85101 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85106 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85110 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85114 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85118 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85122 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85126 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85134 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85136 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85153 */     GIR_RootConstrainSelectedInstOperands,
     /*  85154 */     // GIR_Coverage, 16011,
     /*  85154 */     GIR_EraseRootFromParent_Done,
     /*  85155 */   // Label 1310: @85155
     /*  85155 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85273), // Rule ID 12065 //
     /*  85160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85199 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85205 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85207 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85211 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85215 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85219 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85223 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85227 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85231 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85235 */     // MIs[5] Op3
     /*  85235 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85240 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85244 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85250 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85252 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85254 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85271 */     GIR_RootConstrainSelectedInstOperands,
     /*  85272 */     // GIR_Coverage, 12065,
     /*  85272 */     GIR_EraseRootFromParent_Done,
     /*  85273 */   // Label 1311: @85273
     /*  85273 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85391), // Rule ID 16007 //
     /*  85278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85325 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85329 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85333 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85337 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85341 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85345 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85349 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85353 */     // MIs[5] Op3
     /*  85353 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85358 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85362 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85368 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85370 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85372 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  85385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85389 */     GIR_RootConstrainSelectedInstOperands,
     /*  85390 */     // GIR_Coverage, 16007,
     /*  85390 */     GIR_EraseRootFromParent_Done,
     /*  85391 */   // Label 1312: @85391
     /*  85391 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85509), // Rule ID 16008 //
     /*  85396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85447 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85451 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85455 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85459 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85463 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85467 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85471 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85475 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85483 */     // MIs[4] Op3
     /*  85483 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85488 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85490 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85507 */     GIR_RootConstrainSelectedInstOperands,
     /*  85508 */     // GIR_Coverage, 16008,
     /*  85508 */     GIR_EraseRootFromParent_Done,
     /*  85509 */   // Label 1313: @85509
     /*  85509 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85627), // Rule ID 16009 //
     /*  85514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85573 */     // MIs[4] Op3
     /*  85573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85578 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85582 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85586 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85590 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85594 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85598 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85606 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85608 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85625 */     GIR_RootConstrainSelectedInstOperands,
     /*  85626 */     // GIR_Coverage, 16009,
     /*  85626 */     GIR_EraseRootFromParent_Done,
     /*  85627 */   // Label 1314: @85627
     /*  85627 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85745), // Rule ID 16006 //
     /*  85632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85671 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85677 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85679 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85683 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85687 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85691 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85695 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85699 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85703 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85707 */     // MIs[5] Op3
     /*  85707 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85712 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85716 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85724 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85726 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85743 */     GIR_RootConstrainSelectedInstOperands,
     /*  85744 */     // GIR_Coverage, 16006,
     /*  85744 */     GIR_EraseRootFromParent_Done,
     /*  85745 */   // Label 1315: @85745
     /*  85745 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85863), // Rule ID 16089 //
     /*  85750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85797 */     // MIs[3] Op3
     /*  85797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85822 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85826 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85830 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85834 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85842 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85844 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85861 */     GIR_RootConstrainSelectedInstOperands,
     /*  85862 */     // GIR_Coverage, 16089,
     /*  85862 */     GIR_EraseRootFromParent_Done,
     /*  85863 */   // Label 1316: @85863
     /*  85863 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85981), // Rule ID 16091 //
     /*  85868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85911 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85915 */     // MIs[3] Op3
     /*  85915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85924 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85930 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85940 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85944 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85948 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85952 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85960 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85962 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85979 */     GIR_RootConstrainSelectedInstOperands,
     /*  85980 */     // GIR_Coverage, 16091,
     /*  85980 */     GIR_EraseRootFromParent_Done,
     /*  85981 */   // Label 1317: @85981
     /*  85981 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86099), // Rule ID 12089 //
     /*  85986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86041 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86049 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86053 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86057 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86061 */     // MIs[5] Op3
     /*  86061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86070 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86078 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86080 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86097 */     GIR_RootConstrainSelectedInstOperands,
     /*  86098 */     // GIR_Coverage, 12089,
     /*  86098 */     GIR_EraseRootFromParent_Done,
     /*  86099 */   // Label 1318: @86099
     /*  86099 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86217), // Rule ID 16090 //
     /*  86104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86159 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86167 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86171 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86175 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86179 */     // MIs[5] Op3
     /*  86179 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86184 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86188 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86196 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86198 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86215 */     GIR_RootConstrainSelectedInstOperands,
     /*  86216 */     // GIR_Coverage, 16090,
     /*  86216 */     GIR_EraseRootFromParent_Done,
     /*  86217 */   // Label 1319: @86217
     /*  86217 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86307), // Rule ID 15927 //
     /*  86222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86261 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86267 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86269 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86273 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86277 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86281 */     // MIs[4] Op3
     /*  86281 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86286 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86288 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86305 */     GIR_RootConstrainSelectedInstOperands,
     /*  86306 */     // GIR_Coverage, 15927,
     /*  86306 */     GIR_EraseRootFromParent_Done,
     /*  86307 */   // Label 1320: @86307
     /*  86307 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(86397), // Rule ID 15926 //
     /*  86312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86351 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86367 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86371 */     // MIs[4] Op3
     /*  86371 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86376 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86378 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86395 */     GIR_RootConstrainSelectedInstOperands,
     /*  86396 */     // GIR_Coverage, 15926,
     /*  86396 */     GIR_EraseRootFromParent_Done,
     /*  86397 */   // Label 1321: @86397
     /*  86397 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(86487), // Rule ID 15925 //
     /*  86402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86441 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86453 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86457 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86461 */     // MIs[4] Op3
     /*  86461 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86466 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86468 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86485 */     GIR_RootConstrainSelectedInstOperands,
     /*  86486 */     // GIR_Coverage, 15925,
     /*  86486 */     GIR_EraseRootFromParent_Done,
     /*  86487 */   // Label 1322: @86487
     /*  86487 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(86577), // Rule ID 15924 //
     /*  86492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86531 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86537 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86543 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86547 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86551 */     // MIs[4] Op3
     /*  86551 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86556 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86558 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86575 */     GIR_RootConstrainSelectedInstOperands,
     /*  86576 */     // GIR_Coverage, 15924,
     /*  86576 */     GIR_EraseRootFromParent_Done,
     /*  86577 */   // Label 1323: @86577
     /*  86577 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(86667), // Rule ID 15921 //
     /*  86582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86629 */     // MIs[3] Op3
     /*  86629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86634 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86638 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86644 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86646 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86648 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86665 */     GIR_RootConstrainSelectedInstOperands,
     /*  86666 */     // GIR_Coverage, 15921,
     /*  86666 */     GIR_EraseRootFromParent_Done,
     /*  86667 */   // Label 1324: @86667
     /*  86667 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(86757), // Rule ID 15923 //
     /*  86672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86715 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86719 */     // MIs[3] Op3
     /*  86719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86728 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86734 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86736 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86738 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86755 */     GIR_RootConstrainSelectedInstOperands,
     /*  86756 */     // GIR_Coverage, 15923,
     /*  86756 */     GIR_EraseRootFromParent_Done,
     /*  86757 */   // Label 1325: @86757
     /*  86757 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(86847), // Rule ID 12041 //
     /*  86762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86809 */     // MIs[3] Op3
     /*  86809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86818 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86826 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86828 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86845 */     GIR_RootConstrainSelectedInstOperands,
     /*  86846 */     // GIR_Coverage, 12041,
     /*  86846 */     GIR_EraseRootFromParent_Done,
     /*  86847 */   // Label 1326: @86847
     /*  86847 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(86937), // Rule ID 15922 //
     /*  86852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86899 */     // MIs[3] Op3
     /*  86899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86916 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86918 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86935 */     GIR_RootConstrainSelectedInstOperands,
     /*  86936 */     // GIR_Coverage, 15922,
     /*  86936 */     GIR_EraseRootFromParent_Done,
     /*  86937 */   // Label 1327: @86937
     /*  86937 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(87027), // Rule ID 16096 //
     /*  86942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86985 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86989 */     // MIs[3] Op3
     /*  86989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  86998 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87008 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87025 */     GIR_RootConstrainSelectedInstOperands,
     /*  87026 */     // GIR_Coverage, 16096,
     /*  87026 */     GIR_EraseRootFromParent_Done,
     /*  87027 */   // Label 1328: @87027
     /*  87027 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(87117), // Rule ID 16098 //
     /*  87032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87075 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87079 */     // MIs[3] Op3
     /*  87079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87088 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87094 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87098 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87115 */     GIR_RootConstrainSelectedInstOperands,
     /*  87116 */     // GIR_Coverage, 16098,
     /*  87116 */     GIR_EraseRootFromParent_Done,
     /*  87117 */   // Label 1329: @87117
     /*  87117 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(87207), // Rule ID 12090 //
     /*  87122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87169 */     // MIs[3] Op3
     /*  87169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  87174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87178 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87184 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87188 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87205 */     GIR_RootConstrainSelectedInstOperands,
     /*  87206 */     // GIR_Coverage, 12090,
     /*  87206 */     GIR_EraseRootFromParent_Done,
     /*  87207 */   // Label 1330: @87207
     /*  87207 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(87297), // Rule ID 16097 //
     /*  87212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87259 */     // MIs[3] Op3
     /*  87259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87268 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87274 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87278 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87295 */     GIR_RootConstrainSelectedInstOperands,
     /*  87296 */     // GIR_Coverage, 16097,
     /*  87296 */     GIR_EraseRootFromParent_Done,
     /*  87297 */   // Label 1331: @87297
     /*  87297 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(87387), // Rule ID 16100 //
     /*  87302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87341 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87347 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87349 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87353 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87357 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87361 */     // MIs[4] Op3
     /*  87361 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87368 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87385 */     GIR_RootConstrainSelectedInstOperands,
     /*  87386 */     // GIR_Coverage, 16100,
     /*  87386 */     GIR_EraseRootFromParent_Done,
     /*  87387 */   // Label 1332: @87387
     /*  87387 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(87477), // Rule ID 16102 //
     /*  87392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87431 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87443 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87447 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87451 */     // MIs[4] Op3
     /*  87451 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87458 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87475 */     GIR_RootConstrainSelectedInstOperands,
     /*  87476 */     // GIR_Coverage, 16102,
     /*  87476 */     GIR_EraseRootFromParent_Done,
     /*  87477 */   // Label 1333: @87477
     /*  87477 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(87567), // Rule ID 16099 //
     /*  87482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87521 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87537 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87541 */     // MIs[4] Op3
     /*  87541 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87548 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87565 */     GIR_RootConstrainSelectedInstOperands,
     /*  87566 */     // GIR_Coverage, 16099,
     /*  87566 */     GIR_EraseRootFromParent_Done,
     /*  87567 */   // Label 1334: @87567
     /*  87567 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(87657), // Rule ID 16101 //
     /*  87572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87611 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87617 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87619 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87623 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87627 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87631 */     // MIs[4] Op3
     /*  87631 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87638 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87655 */     GIR_RootConstrainSelectedInstOperands,
     /*  87656 */     // GIR_Coverage, 16101,
     /*  87656 */     GIR_EraseRootFromParent_Done,
     /*  87657 */   // Label 1335: @87657
     /*  87657 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(87672), // Rule ID 7554 //
     /*  87662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87665 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  87665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  87670 */     GIR_RootConstrainSelectedInstOperands,
     /*  87671 */     // GIR_Coverage, 7554,
     /*  87671 */     GIR_Done,
     /*  87672 */   // Label 1336: @87672
     /*  87672 */   GIM_Reject,
     /*  87673 */ // Label 1303: @87673
     /*  87673 */ GIM_Reject,
     /*  87674 */ // Label 1048: @87674
     /*  87674 */ GIM_Reject,
     /*  87675 */ // Label 7: @87675
     /*  87675 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1355*/ GIMT_Encode4(99010),
     /*  87686 */ /*GILLT_s32*//*Label 1337*/ GIMT_Encode4(87774),
     /*  87690 */ /*GILLT_s64*//*Label 1338*/ GIMT_Encode4(88638), GIMT_Encode4(0),
     /*  87698 */ /*GILLT_v2s32*//*Label 1339*/ GIMT_Encode4(89665),
     /*  87702 */ /*GILLT_v2s64*//*Label 1340*/ GIMT_Encode4(89900),
     /*  87706 */ /*GILLT_v4s16*//*Label 1341*/ GIMT_Encode4(90589),
     /*  87710 */ /*GILLT_v4s32*//*Label 1342*/ GIMT_Encode4(90824),
     /*  87714 */ /*GILLT_v8s8*//*Label 1343*/ GIMT_Encode4(91513),
     /*  87718 */ /*GILLT_v8s16*//*Label 1344*/ GIMT_Encode4(91751),
     /*  87722 */ /*GILLT_v16s8*//*Label 1345*/ GIMT_Encode4(92440),
     /*  87726 */ /*GILLT_nxv1s1*//*Label 1346*/ GIMT_Encode4(93132),
     /*  87730 */ /*GILLT_nxv2s1*//*Label 1347*/ GIMT_Encode4(93182), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87742 */ /*GILLT_nxv2s64*//*Label 1348*/ GIMT_Encode4(93232),
     /*  87746 */ /*GILLT_nxv4s1*//*Label 1349*/ GIMT_Encode4(94639), GIMT_Encode4(0),
     /*  87754 */ /*GILLT_nxv4s32*//*Label 1350*/ GIMT_Encode4(94689),
     /*  87758 */ /*GILLT_nxv8s1*//*Label 1351*/ GIMT_Encode4(96096),
     /*  87762 */ /*GILLT_nxv8s16*//*Label 1352*/ GIMT_Encode4(96146),
     /*  87766 */ /*GILLT_nxv16s1*//*Label 1353*/ GIMT_Encode4(97553),
     /*  87770 */ /*GILLT_nxv16s8*//*Label 1354*/ GIMT_Encode4(97603),
     /*  87774 */ // Label 1337: @87774
     /*  87774 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(88637),
     /*  87779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  87785 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87847), // Rule ID 13490 //
     /*  87790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87815 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  87819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87832 */     // (xor:{ *:[i32] } (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)<<P:Predicate_or_disjoint>>, -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87841 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87845 */     GIR_RootConstrainSelectedInstOperands,
     /*  87846 */     // GIR_Coverage, 13490,
     /*  87846 */     GIR_EraseRootFromParent_Done,
     /*  87847 */   // Label 1357: @87847
     /*  87847 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87909), // Rule ID 169 //
     /*  87852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87877 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  87881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87894 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)<<P:Predicate_or_disjoint>>, -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87907 */     GIR_RootConstrainSelectedInstOperands,
     /*  87908 */     // GIR_Coverage, 169,
     /*  87908 */     GIR_EraseRootFromParent_Done,
     /*  87909 */   // Label 1358: @87909
     /*  87909 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87967), // Rule ID 13488 //
     /*  87914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87952 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87965 */     GIR_RootConstrainSelectedInstOperands,
     /*  87966 */     // GIR_Coverage, 13488,
     /*  87966 */     GIR_EraseRootFromParent_Done,
     /*  87967 */   // Label 1359: @87967
     /*  87967 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(88022), // Rule ID 13487 //
     /*  87972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88009 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88020 */     GIR_RootConstrainSelectedInstOperands,
     /*  88021 */     // GIR_Coverage, 13487,
     /*  88021 */     GIR_EraseRootFromParent_Done,
     /*  88022 */   // Label 1360: @88022
     /*  88022 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(88080), // Rule ID 13485 //
     /*  88027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88065 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88078 */     GIR_RootConstrainSelectedInstOperands,
     /*  88079 */     // GIR_Coverage, 13485,
     /*  88079 */     GIR_EraseRootFromParent_Done,
     /*  88080 */   // Label 1361: @88080
     /*  88080 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(88138), // Rule ID 168 //
     /*  88085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88123 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88136 */     GIR_RootConstrainSelectedInstOperands,
     /*  88137 */     // GIR_Coverage, 168,
     /*  88137 */     GIR_EraseRootFromParent_Done,
     /*  88138 */   // Label 1362: @88138
     /*  88138 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(88196), // Rule ID 13486 //
     /*  88143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88181 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88194 */     GIR_RootConstrainSelectedInstOperands,
     /*  88195 */     // GIR_Coverage, 13486,
     /*  88195 */     GIR_EraseRootFromParent_Done,
     /*  88196 */   // Label 1363: @88196
     /*  88196 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(88251), // Rule ID 13489 //
     /*  88201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88238 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88249 */     GIR_RootConstrainSelectedInstOperands,
     /*  88250 */     // GIR_Coverage, 13489,
     /*  88250 */     GIR_EraseRootFromParent_Done,
     /*  88251 */   // Label 1364: @88251
     /*  88251 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(88292), // Rule ID 144 //
     /*  88256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  88260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88272 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  88276 */     // MIs[1] Operand 1
     /*  88276 */     // No operand predicates
     /*  88276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88278 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  88278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  88281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88285 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  88290 */     GIR_RootConstrainSelectedInstOperands,
     /*  88291 */     // GIR_Coverage, 144,
     /*  88291 */     GIR_EraseRootFromParent_Done,
     /*  88292 */   // Label 1365: @88292
     /*  88292 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(88325), // Rule ID 13497 //
     /*  88297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88312 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88323 */     GIR_RootConstrainSelectedInstOperands,
     /*  88324 */     // GIR_Coverage, 13497,
     /*  88324 */     GIR_EraseRootFromParent_Done,
     /*  88325 */   // Label 1366: @88325
     /*  88325 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(88385), // Rule ID 165 //
     /*  88330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  88342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88360 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  88364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88370 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_or_disjoint>>, -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  88383 */     GIR_RootConstrainSelectedInstOperands,
     /*  88384 */     // GIR_Coverage, 165,
     /*  88384 */     GIR_EraseRootFromParent_Done,
     /*  88385 */   // Label 1367: @88385
     /*  88385 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(88418), // Rule ID 174 //
     /*  88390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88405 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88416 */     GIR_RootConstrainSelectedInstOperands,
     /*  88417 */     // GIR_Coverage, 174,
     /*  88417 */     GIR_EraseRootFromParent_Done,
     /*  88418 */   // Label 1368: @88418
     /*  88418 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(88471), // Rule ID 13481 //
     /*  88423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88458 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  88469 */     GIR_RootConstrainSelectedInstOperands,
     /*  88470 */     // GIR_Coverage, 13481,
     /*  88470 */     GIR_EraseRootFromParent_Done,
     /*  88471 */   // Label 1369: @88471
     /*  88471 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(88527), // Rule ID 164 //
     /*  88476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88512 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  88525 */     GIR_RootConstrainSelectedInstOperands,
     /*  88526 */     // GIR_Coverage, 164,
     /*  88526 */     GIR_EraseRootFromParent_Done,
     /*  88527 */   // Label 1370: @88527
     /*  88527 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(88580), // Rule ID 13482 //
     /*  88532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88561 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88567 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  88578 */     GIR_RootConstrainSelectedInstOperands,
     /*  88579 */     // GIR_Coverage, 13482,
     /*  88579 */     GIR_EraseRootFromParent_Done,
     /*  88580 */   // Label 1371: @88580
     /*  88580 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(88612), // Rule ID 4035 //
     /*  88585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88597 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  88597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  88600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  88610 */     GIR_RootConstrainSelectedInstOperands,
     /*  88611 */     // GIR_Coverage, 4035,
     /*  88611 */     GIR_EraseRootFromParent_Done,
     /*  88612 */   // Label 1372: @88612
     /*  88612 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88636), // Rule ID 172 //
     /*  88617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88629 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  88634 */     GIR_RootConstrainSelectedInstOperands,
     /*  88635 */     // GIR_Coverage, 172,
     /*  88635 */     GIR_Done,
     /*  88636 */   // Label 1373: @88636
     /*  88636 */   GIM_Reject,
     /*  88637 */ // Label 1356: @88637
     /*  88637 */ GIM_Reject,
     /*  88638 */ // Label 1338: @88638
     /*  88638 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(89664),
     /*  88643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  88649 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88711), // Rule ID 13496 //
     /*  88654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  88666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88679 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  88683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88696 */     // (xor:{ *:[i64] } (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)<<P:Predicate_or_disjoint>>, -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88709 */     GIR_RootConstrainSelectedInstOperands,
     /*  88710 */     // GIR_Coverage, 13496,
     /*  88710 */     GIR_EraseRootFromParent_Done,
     /*  88711 */   // Label 1375: @88711
     /*  88711 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88773), // Rule ID 171 //
     /*  88716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  88728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88741 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  88745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88758 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)<<P:Predicate_or_disjoint>>, -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88771 */     GIR_RootConstrainSelectedInstOperands,
     /*  88772 */     // GIR_Coverage, 171,
     /*  88772 */     GIR_EraseRootFromParent_Done,
     /*  88773 */   // Label 1376: @88773
     /*  88773 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88831), // Rule ID 13494 //
     /*  88778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88816 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88829 */     GIR_RootConstrainSelectedInstOperands,
     /*  88830 */     // GIR_Coverage, 13494,
     /*  88830 */     GIR_EraseRootFromParent_Done,
     /*  88831 */   // Label 1377: @88831
     /*  88831 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88886), // Rule ID 13493 //
     /*  88836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88873 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88884 */     GIR_RootConstrainSelectedInstOperands,
     /*  88885 */     // GIR_Coverage, 13493,
     /*  88885 */     GIR_EraseRootFromParent_Done,
     /*  88886 */   // Label 1378: @88886
     /*  88886 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88944), // Rule ID 13491 //
     /*  88891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88929 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88942 */     GIR_RootConstrainSelectedInstOperands,
     /*  88943 */     // GIR_Coverage, 13491,
     /*  88943 */     GIR_EraseRootFromParent_Done,
     /*  88944 */   // Label 1379: @88944
     /*  88944 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(89002), // Rule ID 170 //
     /*  88949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88987 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  89000 */     GIR_RootConstrainSelectedInstOperands,
     /*  89001 */     // GIR_Coverage, 170,
     /*  89001 */     GIR_EraseRootFromParent_Done,
     /*  89002 */   // Label 1380: @89002
     /*  89002 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(89060), // Rule ID 13492 //
     /*  89007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  89045 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  89045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  89048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  89058 */     GIR_RootConstrainSelectedInstOperands,
     /*  89059 */     // GIR_Coverage, 13492,
     /*  89059 */     GIR_EraseRootFromParent_Done,
     /*  89060 */   // Label 1381: @89060
     /*  89060 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89115), // Rule ID 13495 //
     /*  89065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  89102 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  89102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  89105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  89113 */     GIR_RootConstrainSelectedInstOperands,
     /*  89114 */     // GIR_Coverage, 13495,
     /*  89114 */     GIR_EraseRootFromParent_Done,
     /*  89115 */   // Label 1382: @89115
     /*  89115 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89215), // Rule ID 1617 //
     /*  89120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  89143 */     // MIs[1] Operand 1
     /*  89143 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  89160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  89164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89178 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89190 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89198 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89200 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  89200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  89203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89213 */     GIR_RootConstrainSelectedInstOperands,
     /*  89214 */     // GIR_Coverage, 1617,
     /*  89214 */     GIR_EraseRootFromParent_Done,
     /*  89215 */   // Label 1383: @89215
     /*  89215 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89256), // Rule ID 145 //
     /*  89220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  89224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89236 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  89240 */     // MIs[1] Operand 1
     /*  89240 */     // No operand predicates
     /*  89240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89242 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  89242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  89245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89249 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  89254 */     GIR_RootConstrainSelectedInstOperands,
     /*  89255 */     // GIR_Coverage, 145,
     /*  89255 */     GIR_EraseRootFromParent_Done,
     /*  89256 */   // Label 1384: @89256
     /*  89256 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89289), // Rule ID 13498 //
     /*  89261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  89276 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  89276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  89279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  89283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  89287 */     GIR_RootConstrainSelectedInstOperands,
     /*  89288 */     // GIR_Coverage, 13498,
     /*  89288 */     GIR_EraseRootFromParent_Done,
     /*  89289 */   // Label 1385: @89289
     /*  89289 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89349), // Rule ID 167 //
     /*  89294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  89306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89324 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_or_disjoint),
     /*  89328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89334 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_or_disjoint>>, -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  89347 */     GIR_RootConstrainSelectedInstOperands,
     /*  89348 */     // GIR_Coverage, 167,
     /*  89348 */     GIR_EraseRootFromParent_Done,
     /*  89349 */   // Label 1386: @89349
     /*  89349 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89382), // Rule ID 175 //
     /*  89354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  89369 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  89369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  89372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  89380 */     GIR_RootConstrainSelectedInstOperands,
     /*  89381 */     // GIR_Coverage, 175,
     /*  89381 */     GIR_EraseRootFromParent_Done,
     /*  89382 */   // Label 1387: @89382
     /*  89382 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89435), // Rule ID 13483 //
     /*  89387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89412 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89422 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  89433 */     GIR_RootConstrainSelectedInstOperands,
     /*  89434 */     // GIR_Coverage, 13483,
     /*  89434 */     GIR_EraseRootFromParent_Done,
     /*  89435 */   // Label 1388: @89435
     /*  89435 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89491), // Rule ID 166 //
     /*  89440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89476 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  89489 */     GIR_RootConstrainSelectedInstOperands,
     /*  89490 */     // GIR_Coverage, 166,
     /*  89490 */     GIR_EraseRootFromParent_Done,
     /*  89491 */   // Label 1389: @89491
     /*  89491 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89544), // Rule ID 13484 //
     /*  89496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89525 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89531 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  89542 */     GIR_RootConstrainSelectedInstOperands,
     /*  89543 */     // GIR_Coverage, 13484,
     /*  89543 */     GIR_EraseRootFromParent_Done,
     /*  89544 */   // Label 1390: @89544
     /*  89544 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89576), // Rule ID 4036 //
     /*  89549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89561 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  89561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  89564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  89574 */     GIR_RootConstrainSelectedInstOperands,
     /*  89575 */     // GIR_Coverage, 4036,
     /*  89575 */     GIR_EraseRootFromParent_Done,
     /*  89576 */   // Label 1391: @89576
     /*  89576 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(89612), // Rule ID 5020 //
     /*  89581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89593 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89603 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  89603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89610 */     GIR_RootConstrainSelectedInstOperands,
     /*  89611 */     // GIR_Coverage, 5020,
     /*  89611 */     GIR_EraseRootFromParent_Done,
     /*  89612 */   // Label 1392: @89612
     /*  89612 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(89636), // Rule ID 173 //
     /*  89617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89629 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  89634 */     GIR_RootConstrainSelectedInstOperands,
     /*  89635 */     // GIR_Coverage, 173,
     /*  89635 */     GIR_Done,
     /*  89636 */   // Label 1393: @89636
     /*  89636 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89663), // Rule ID 5098 //
     /*  89641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89656 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  89656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89661 */     GIR_RootConstrainSelectedInstOperands,
     /*  89662 */     // GIR_Coverage, 5098,
     /*  89662 */     GIR_Done,
     /*  89663 */   // Label 1394: @89663
     /*  89663 */   GIM_Reject,
     /*  89664 */ // Label 1374: @89664
     /*  89664 */ GIM_Reject,
     /*  89665 */ // Label 1339: @89665
     /*  89665 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89899),
     /*  89670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89680 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89776), // Rule ID 1164 //
     /*  89685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89704 */     // MIs[1] Operand 1
     /*  89704 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89739 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89751 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89761 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  89761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89774 */     GIR_RootConstrainSelectedInstOperands,
     /*  89775 */     // GIR_Coverage, 1164,
     /*  89775 */     GIR_EraseRootFromParent_Done,
     /*  89776 */   // Label 1396: @89776
     /*  89776 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89843), // Rule ID 5067 //
     /*  89781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89793 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89797 */     // MIs[1] Operand 1
     /*  89797 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89806 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89812 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89828 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  89828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89841 */     GIR_RootConstrainSelectedInstOperands,
     /*  89842 */     // GIR_Coverage, 5067,
     /*  89842 */     GIR_EraseRootFromParent_Done,
     /*  89843 */   // Label 1397: @89843
     /*  89843 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89875), // Rule ID 5018 //
     /*  89848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89866 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  89866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89873 */     GIR_RootConstrainSelectedInstOperands,
     /*  89874 */     // GIR_Coverage, 5018,
     /*  89874 */     GIR_EraseRootFromParent_Done,
     /*  89875 */   // Label 1398: @89875
     /*  89875 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89898), // Rule ID 5097 //
     /*  89880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89891 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  89891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89896 */     GIR_RootConstrainSelectedInstOperands,
     /*  89897 */     // GIR_Coverage, 5097,
     /*  89897 */     GIR_Done,
     /*  89898 */   // Label 1399: @89898
     /*  89898 */   GIM_Reject,
     /*  89899 */ // Label 1395: @89899
     /*  89899 */ GIM_Reject,
     /*  89900 */ // Label 1340: @89900
     /*  89900 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(90588),
     /*  89905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89915 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(90011), // Rule ID 1166 //
     /*  89920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89939 */     // MIs[1] Operand 1
     /*  89939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89974 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89980 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89986 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89994 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89996 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  89996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90009 */     GIR_RootConstrainSelectedInstOperands,
     /*  90010 */     // GIR_Coverage, 1166,
     /*  90010 */     GIR_EraseRootFromParent_Done,
     /*  90011 */   // Label 1401: @90011
     /*  90011 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(90078), // Rule ID 5069 //
     /*  90016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90032 */     // MIs[1] Operand 1
     /*  90032 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90041 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90047 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90053 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90063 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  90063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  90066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90076 */     GIR_RootConstrainSelectedInstOperands,
     /*  90077 */     // GIR_Coverage, 5069,
     /*  90077 */     GIR_EraseRootFromParent_Done,
     /*  90078 */   // Label 1402: @90078
     /*  90078 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(90163), // Rule ID 14035 //
     /*  90083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90127 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90146 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90161 */     GIR_RootConstrainSelectedInstOperands,
     /*  90162 */     // GIR_Coverage, 14035,
     /*  90162 */     GIR_EraseRootFromParent_Done,
     /*  90163 */   // Label 1403: @90163
     /*  90163 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(90248), // Rule ID 14034 //
     /*  90168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90217 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90223 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90231 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90246 */     GIR_RootConstrainSelectedInstOperands,
     /*  90247 */     // GIR_Coverage, 14034,
     /*  90247 */     GIR_EraseRootFromParent_Done,
     /*  90248 */   // Label 1404: @90248
     /*  90248 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(90333), // Rule ID 14033 //
     /*  90253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90301 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90316 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90331 */     GIR_RootConstrainSelectedInstOperands,
     /*  90332 */     // GIR_Coverage, 14033,
     /*  90332 */     GIR_EraseRootFromParent_Done,
     /*  90333 */   // Label 1405: @90333
     /*  90333 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(90418), // Rule ID 3863 //
     /*  90338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90401 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90416 */     GIR_RootConstrainSelectedInstOperands,
     /*  90417 */     // GIR_Coverage, 3863,
     /*  90417 */     GIR_EraseRootFromParent_Done,
     /*  90418 */   // Label 1406: @90418
     /*  90418 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(90450), // Rule ID 5021 //
     /*  90423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90441 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  90441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90448 */     GIR_RootConstrainSelectedInstOperands,
     /*  90449 */     // GIR_Coverage, 5021,
     /*  90449 */     GIR_EraseRootFromParent_Done,
     /*  90450 */   // Label 1407: @90450
     /*  90450 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(90507), // Rule ID 3859 //
     /*  90455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90490 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90505 */     GIR_RootConstrainSelectedInstOperands,
     /*  90506 */     // GIR_Coverage, 3859,
     /*  90506 */     GIR_EraseRootFromParent_Done,
     /*  90507 */   // Label 1408: @90507
     /*  90507 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(90564), // Rule ID 14023 //
     /*  90512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90547 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90562 */     GIR_RootConstrainSelectedInstOperands,
     /*  90563 */     // GIR_Coverage, 14023,
     /*  90563 */     GIR_EraseRootFromParent_Done,
     /*  90564 */   // Label 1409: @90564
     /*  90564 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90587), // Rule ID 5101 //
     /*  90569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90580 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  90580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90585 */     GIR_RootConstrainSelectedInstOperands,
     /*  90586 */     // GIR_Coverage, 5101,
     /*  90586 */     GIR_Done,
     /*  90587 */   // Label 1410: @90587
     /*  90587 */   GIM_Reject,
     /*  90588 */ // Label 1400: @90588
     /*  90588 */ GIM_Reject,
     /*  90589 */ // Label 1341: @90589
     /*  90589 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(90823),
     /*  90594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90604 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90700), // Rule ID 1162 //
     /*  90609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90624 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90628 */     // MIs[1] Operand 1
     /*  90628 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90663 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90675 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90683 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90685 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  90685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90698 */     GIR_RootConstrainSelectedInstOperands,
     /*  90699 */     // GIR_Coverage, 1162,
     /*  90699 */     GIR_EraseRootFromParent_Done,
     /*  90700 */   // Label 1412: @90700
     /*  90700 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90767), // Rule ID 5065 //
     /*  90705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90717 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90721 */     // MIs[1] Operand 1
     /*  90721 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90730 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90736 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90752 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  90752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90765 */     GIR_RootConstrainSelectedInstOperands,
     /*  90766 */     // GIR_Coverage, 5065,
     /*  90766 */     GIR_EraseRootFromParent_Done,
     /*  90767 */   // Label 1413: @90767
     /*  90767 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90799), // Rule ID 5016 //
     /*  90772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90790 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  90790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  90793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90797 */     GIR_RootConstrainSelectedInstOperands,
     /*  90798 */     // GIR_Coverage, 5016,
     /*  90798 */     GIR_EraseRootFromParent_Done,
     /*  90799 */   // Label 1414: @90799
     /*  90799 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90822), // Rule ID 5096 //
     /*  90804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90815 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  90815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  90820 */     GIR_RootConstrainSelectedInstOperands,
     /*  90821 */     // GIR_Coverage, 5096,
     /*  90821 */     GIR_Done,
     /*  90822 */   // Label 1415: @90822
     /*  90822 */   GIM_Reject,
     /*  90823 */ // Label 1411: @90823
     /*  90823 */ GIM_Reject,
     /*  90824 */ // Label 1342: @90824
     /*  90824 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(91512),
     /*  90829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90839 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90935), // Rule ID 1165 //
     /*  90844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90863 */     // MIs[1] Operand 1
     /*  90863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90898 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90910 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90918 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90920 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  90920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90933 */     GIR_RootConstrainSelectedInstOperands,
     /*  90934 */     // GIR_Coverage, 1165,
     /*  90934 */     GIR_EraseRootFromParent_Done,
     /*  90935 */   // Label 1417: @90935
     /*  90935 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91002), // Rule ID 5068 //
     /*  90940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90952 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90956 */     // MIs[1] Operand 1
     /*  90956 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90965 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90971 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90977 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90987 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  90987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91000 */     GIR_RootConstrainSelectedInstOperands,
     /*  91001 */     // GIR_Coverage, 5068,
     /*  91001 */     GIR_EraseRootFromParent_Done,
     /*  91002 */   // Label 1418: @91002
     /*  91002 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91087), // Rule ID 14032 //
     /*  91007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91051 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91057 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91070 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91085 */     GIR_RootConstrainSelectedInstOperands,
     /*  91086 */     // GIR_Coverage, 14032,
     /*  91086 */     GIR_EraseRootFromParent_Done,
     /*  91087 */   // Label 1419: @91087
     /*  91087 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91172), // Rule ID 14031 //
     /*  91092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91141 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91155 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91170 */     GIR_RootConstrainSelectedInstOperands,
     /*  91171 */     // GIR_Coverage, 14031,
     /*  91171 */     GIR_EraseRootFromParent_Done,
     /*  91172 */   // Label 1420: @91172
     /*  91172 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91257), // Rule ID 14030 //
     /*  91177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91225 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91240 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91255 */     GIR_RootConstrainSelectedInstOperands,
     /*  91256 */     // GIR_Coverage, 14030,
     /*  91256 */     GIR_EraseRootFromParent_Done,
     /*  91257 */   // Label 1421: @91257
     /*  91257 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91342), // Rule ID 3862 //
     /*  91262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91315 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91325 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91340 */     GIR_RootConstrainSelectedInstOperands,
     /*  91341 */     // GIR_Coverage, 3862,
     /*  91341 */     GIR_EraseRootFromParent_Done,
     /*  91342 */   // Label 1422: @91342
     /*  91342 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91374), // Rule ID 5019 //
     /*  91347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91365 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  91365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91372 */     GIR_RootConstrainSelectedInstOperands,
     /*  91373 */     // GIR_Coverage, 5019,
     /*  91373 */     GIR_EraseRootFromParent_Done,
     /*  91374 */   // Label 1423: @91374
     /*  91374 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91431), // Rule ID 3858 //
     /*  91379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91414 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91429 */     GIR_RootConstrainSelectedInstOperands,
     /*  91430 */     // GIR_Coverage, 3858,
     /*  91430 */     GIR_EraseRootFromParent_Done,
     /*  91431 */   // Label 1424: @91431
     /*  91431 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91488), // Rule ID 14022 //
     /*  91436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91471 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91486 */     GIR_RootConstrainSelectedInstOperands,
     /*  91487 */     // GIR_Coverage, 14022,
     /*  91487 */     GIR_EraseRootFromParent_Done,
     /*  91488 */   // Label 1425: @91488
     /*  91488 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91511), // Rule ID 5100 //
     /*  91493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91504 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  91504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91509 */     GIR_RootConstrainSelectedInstOperands,
     /*  91510 */     // GIR_Coverage, 5100,
     /*  91510 */     GIR_Done,
     /*  91511 */   // Label 1426: @91511
     /*  91511 */   GIM_Reject,
     /*  91512 */ // Label 1416: @91512
     /*  91512 */ GIM_Reject,
     /*  91513 */ // Label 1343: @91513
     /*  91513 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91750),
     /*  91518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91528 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91624), // Rule ID 1160 //
     /*  91533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91552 */     // MIs[1] Operand 1
     /*  91552 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91587 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91593 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91599 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91605 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91607 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91609 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91622 */     GIR_RootConstrainSelectedInstOperands,
     /*  91623 */     // GIR_Coverage, 1160,
     /*  91623 */     GIR_EraseRootFromParent_Done,
     /*  91624 */   // Label 1428: @91624
     /*  91624 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91691), // Rule ID 5063 //
     /*  91629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91641 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91645 */     // MIs[1] Operand 1
     /*  91645 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91654 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91660 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91676 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  91676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91689 */     GIR_RootConstrainSelectedInstOperands,
     /*  91690 */     // GIR_Coverage, 5063,
     /*  91690 */     GIR_EraseRootFromParent_Done,
     /*  91691 */   // Label 1429: @91691
     /*  91691 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91726), // Rule ID 976 //
     /*  91696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91717 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  91717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  91720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91724 */     GIR_RootConstrainSelectedInstOperands,
     /*  91725 */     // GIR_Coverage, 976,
     /*  91725 */     GIR_EraseRootFromParent_Done,
     /*  91726 */   // Label 1430: @91726
     /*  91726 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91749), // Rule ID 1603 //
     /*  91731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91742 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  91747 */     GIR_RootConstrainSelectedInstOperands,
     /*  91748 */     // GIR_Coverage, 1603,
     /*  91748 */     GIR_Done,
     /*  91749 */   // Label 1431: @91749
     /*  91749 */   GIM_Reject,
     /*  91750 */ // Label 1427: @91750
     /*  91750 */ GIM_Reject,
     /*  91751 */ // Label 1344: @91751
     /*  91751 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(92439),
     /*  91756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91766 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91862), // Rule ID 1163 //
     /*  91771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91786 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91790 */     // MIs[1] Operand 1
     /*  91790 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91825 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91833 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91837 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91845 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91847 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  91847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91860 */     GIR_RootConstrainSelectedInstOperands,
     /*  91861 */     // GIR_Coverage, 1163,
     /*  91861 */     GIR_EraseRootFromParent_Done,
     /*  91862 */   // Label 1433: @91862
     /*  91862 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(91929), // Rule ID 5066 //
     /*  91867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91883 */     // MIs[1] Operand 1
     /*  91883 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91892 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91898 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91904 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91910 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91914 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  91914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91927 */     GIR_RootConstrainSelectedInstOperands,
     /*  91928 */     // GIR_Coverage, 5066,
     /*  91928 */     GIR_EraseRootFromParent_Done,
     /*  91929 */   // Label 1434: @91929
     /*  91929 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92014), // Rule ID 14029 //
     /*  91934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91978 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91997 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92012 */     GIR_RootConstrainSelectedInstOperands,
     /*  92013 */     // GIR_Coverage, 14029,
     /*  92013 */     GIR_EraseRootFromParent_Done,
     /*  92014 */   // Label 1435: @92014
     /*  92014 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92099), // Rule ID 14028 //
     /*  92019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92068 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92082 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92097 */     GIR_RootConstrainSelectedInstOperands,
     /*  92098 */     // GIR_Coverage, 14028,
     /*  92098 */     GIR_EraseRootFromParent_Done,
     /*  92099 */   // Label 1436: @92099
     /*  92099 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92184), // Rule ID 14027 //
     /*  92104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92152 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92167 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92182 */     GIR_RootConstrainSelectedInstOperands,
     /*  92183 */     // GIR_Coverage, 14027,
     /*  92183 */     GIR_EraseRootFromParent_Done,
     /*  92184 */   // Label 1437: @92184
     /*  92184 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92269), // Rule ID 3861 //
     /*  92189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92242 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92248 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92252 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92267 */     GIR_RootConstrainSelectedInstOperands,
     /*  92268 */     // GIR_Coverage, 3861,
     /*  92268 */     GIR_EraseRootFromParent_Done,
     /*  92269 */   // Label 1438: @92269
     /*  92269 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92301), // Rule ID 5017 //
     /*  92274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  92290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92292 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  92292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  92295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  92299 */     GIR_RootConstrainSelectedInstOperands,
     /*  92300 */     // GIR_Coverage, 5017,
     /*  92300 */     GIR_EraseRootFromParent_Done,
     /*  92301 */   // Label 1439: @92301
     /*  92301 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92358), // Rule ID 3857 //
     /*  92306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92341 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  92356 */     GIR_RootConstrainSelectedInstOperands,
     /*  92357 */     // GIR_Coverage, 3857,
     /*  92357 */     GIR_EraseRootFromParent_Done,
     /*  92358 */   // Label 1440: @92358
     /*  92358 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92415), // Rule ID 14021 //
     /*  92363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92398 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92413 */     GIR_RootConstrainSelectedInstOperands,
     /*  92414 */     // GIR_Coverage, 14021,
     /*  92414 */     GIR_EraseRootFromParent_Done,
     /*  92415 */   // Label 1441: @92415
     /*  92415 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92438), // Rule ID 5099 //
     /*  92420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92431 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  92431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92436 */     GIR_RootConstrainSelectedInstOperands,
     /*  92437 */     // GIR_Coverage, 5099,
     /*  92437 */     GIR_Done,
     /*  92438 */   // Label 1442: @92438
     /*  92438 */   GIM_Reject,
     /*  92439 */ // Label 1432: @92439
     /*  92439 */ GIM_Reject,
     /*  92440 */ // Label 1345: @92440
     /*  92440 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(93131),
     /*  92445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92455 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92551), // Rule ID 1161 //
     /*  92460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92479 */     // MIs[1] Operand 1
     /*  92479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  92514 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  92522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  92526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92534 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  92536 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  92545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  92549 */     GIR_RootConstrainSelectedInstOperands,
     /*  92550 */     // GIR_Coverage, 1161,
     /*  92550 */     GIR_EraseRootFromParent_Done,
     /*  92551 */   // Label 1444: @92551
     /*  92551 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92618), // Rule ID 5064 //
     /*  92556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92572 */     // MIs[1] Operand 1
     /*  92572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  92581 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  92589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  92593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92603 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  92603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92616 */     GIR_RootConstrainSelectedInstOperands,
     /*  92617 */     // GIR_Coverage, 5064,
     /*  92617 */     GIR_EraseRootFromParent_Done,
     /*  92618 */   // Label 1445: @92618
     /*  92618 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92703), // Rule ID 14026 //
     /*  92623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92686 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92701 */     GIR_RootConstrainSelectedInstOperands,
     /*  92702 */     // GIR_Coverage, 14026,
     /*  92702 */     GIR_EraseRootFromParent_Done,
     /*  92703 */   // Label 1446: @92703
     /*  92703 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92788), // Rule ID 14025 //
     /*  92708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92757 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92771 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92786 */     GIR_RootConstrainSelectedInstOperands,
     /*  92787 */     // GIR_Coverage, 14025,
     /*  92787 */     GIR_EraseRootFromParent_Done,
     /*  92788 */   // Label 1447: @92788
     /*  92788 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92873), // Rule ID 14024 //
     /*  92793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92841 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92856 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92871 */     GIR_RootConstrainSelectedInstOperands,
     /*  92872 */     // GIR_Coverage, 14024,
     /*  92872 */     GIR_EraseRootFromParent_Done,
     /*  92873 */   // Label 1448: @92873
     /*  92873 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92958), // Rule ID 3860 //
     /*  92878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92931 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92941 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 3860,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1449: @92958
     /*  92958 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92993), // Rule ID 977 //
     /*  92963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92974 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92980 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  92982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92984 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  92984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  92987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  92991 */     GIR_RootConstrainSelectedInstOperands,
     /*  92992 */     // GIR_Coverage, 977,
     /*  92992 */     GIR_EraseRootFromParent_Done,
     /*  92993 */   // Label 1450: @92993
     /*  92993 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(93050), // Rule ID 3856 //
     /*  92998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  93001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93033 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  93033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  93036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  93038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  93042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  93046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  93048 */     GIR_RootConstrainSelectedInstOperands,
     /*  93049 */     // GIR_Coverage, 3856,
     /*  93049 */     GIR_EraseRootFromParent_Done,
     /*  93050 */   // Label 1451: @93050
     /*  93050 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93107), // Rule ID 14020 //
     /*  93055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  93058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93090 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  93090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  93093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  93095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  93099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  93103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  93105 */     GIR_RootConstrainSelectedInstOperands,
     /*  93106 */     // GIR_Coverage, 14020,
     /*  93106 */     GIR_EraseRootFromParent_Done,
     /*  93107 */   // Label 1452: @93107
     /*  93107 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(93130), // Rule ID 1604 //
     /*  93112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93123 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  93123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  93128 */     GIR_RootConstrainSelectedInstOperands,
     /*  93129 */     // GIR_Coverage, 1604,
     /*  93129 */     GIR_Done,
     /*  93130 */   // Label 1453: @93130
     /*  93130 */   GIM_Reject,
     /*  93131 */ // Label 1443: @93131
     /*  93131 */ GIM_Reject,
     /*  93132 */ // Label 1346: @93132
     /*  93132 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93181), // Rule ID 8567 //
     /*  93137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  93140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  93143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  93146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  93150 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  93150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  93153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  93157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93162 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  93165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  93170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  93172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93175 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93177 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  93179 */   GIR_RootConstrainSelectedInstOperands,
     /*  93180 */   // GIR_Coverage, 8567,
     /*  93180 */   GIR_EraseRootFromParent_Done,
     /*  93181 */ // Label 1454: @93181
     /*  93181 */ GIM_Reject,
     /*  93182 */ // Label 1347: @93182
     /*  93182 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93231), // Rule ID 8566 //
     /*  93187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  93190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  93193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  93196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  93200 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  93200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  93203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  93207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93212 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  93215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  93220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  93222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  93229 */   GIR_RootConstrainSelectedInstOperands,
     /*  93230 */   // GIR_Coverage, 8566,
     /*  93230 */   GIR_EraseRootFromParent_Done,
     /*  93231 */ // Label 1455: @93231
     /*  93231 */ GIM_Reject,
     /*  93232 */ // Label 1348: @93232
     /*  93232 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(94638),
     /*  93237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93247 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93365), // Rule ID 16284 //
     /*  93252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93295 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93307 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93315 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93319 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93323 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93327 */     // MIs[5] Op3
     /*  93327 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93332 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93336 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93346 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93363 */     GIR_RootConstrainSelectedInstOperands,
     /*  93364 */     // GIR_Coverage, 16284,
     /*  93364 */     GIR_EraseRootFromParent_Done,
     /*  93365 */   // Label 1457: @93365
     /*  93365 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93483), // Rule ID 16283 //
     /*  93370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93425 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93433 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93437 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93441 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93445 */     // MIs[5] Op3
     /*  93445 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93450 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93454 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93462 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93464 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93481 */     GIR_RootConstrainSelectedInstOperands,
     /*  93482 */     // GIR_Coverage, 16283,
     /*  93482 */     GIR_EraseRootFromParent_Done,
     /*  93483 */   // Label 1458: @93483
     /*  93483 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93601), // Rule ID 16282 //
     /*  93488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93543 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93551 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93555 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93559 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93563 */     // MIs[5] Op3
     /*  93563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93572 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93580 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93582 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93599 */     GIR_RootConstrainSelectedInstOperands,
     /*  93600 */     // GIR_Coverage, 16282,
     /*  93600 */     GIR_EraseRootFromParent_Done,
     /*  93601 */   // Label 1459: @93601
     /*  93601 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93719), // Rule ID 16281 //
     /*  93606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93653 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93661 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93667 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93669 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93673 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93677 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93681 */     // MIs[5] Op3
     /*  93681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93690 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93698 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93700 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93717 */     GIR_RootConstrainSelectedInstOperands,
     /*  93718 */     // GIR_Coverage, 16281,
     /*  93718 */     GIR_EraseRootFromParent_Done,
     /*  93719 */   // Label 1460: @93719
     /*  93719 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93837), // Rule ID 16278 //
     /*  93724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93767 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93771 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93775 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93779 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93783 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93787 */     // MIs[4] Op3
     /*  93787 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93792 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93796 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93804 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93808 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93816 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93818 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93835 */     GIR_RootConstrainSelectedInstOperands,
     /*  93836 */     // GIR_Coverage, 16278,
     /*  93836 */     GIR_EraseRootFromParent_Done,
     /*  93837 */   // Label 1461: @93837
     /*  93837 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93955), // Rule ID 16280 //
     /*  93842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93889 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93901 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93905 */     // MIs[4] Op3
     /*  93905 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93910 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93914 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93922 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93926 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93934 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93936 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93953 */     GIR_RootConstrainSelectedInstOperands,
     /*  93954 */     // GIR_Coverage, 16280,
     /*  93954 */     GIR_EraseRootFromParent_Done,
     /*  93955 */   // Label 1462: @93955
     /*  93955 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(94073), // Rule ID 12131 //
     /*  93960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94003 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94015 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94023 */     // MIs[4] Op3
     /*  94023 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94028 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94032 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94038 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94044 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94052 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94054 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  94067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94071 */     GIR_RootConstrainSelectedInstOperands,
     /*  94072 */     // GIR_Coverage, 12131,
     /*  94072 */     GIR_EraseRootFromParent_Done,
     /*  94073 */   // Label 1463: @94073
     /*  94073 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94191), // Rule ID 16279 //
     /*  94078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94125 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94137 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94141 */     // MIs[4] Op3
     /*  94141 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94150 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94162 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94170 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94172 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  94181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  94185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94189 */     GIR_RootConstrainSelectedInstOperands,
     /*  94190 */     // GIR_Coverage, 16279,
     /*  94190 */     GIR_EraseRootFromParent_Done,
     /*  94191 */   // Label 1464: @94191
     /*  94191 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94262), // Rule ID 15896 //
     /*  94196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94235 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94245 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  94252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94260 */     GIR_RootConstrainSelectedInstOperands,
     /*  94261 */     // GIR_Coverage, 15896,
     /*  94261 */     GIR_EraseRootFromParent_Done,
     /*  94262 */   // Label 1465: @94262
     /*  94262 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94333), // Rule ID 15895 //
     /*  94267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94306 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94316 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  94323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94331 */     GIR_RootConstrainSelectedInstOperands,
     /*  94332 */     // GIR_Coverage, 15895,
     /*  94332 */     GIR_EraseRootFromParent_Done,
     /*  94333 */   // Label 1466: @94333
     /*  94333 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94404), // Rule ID 15894 //
     /*  94338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94377 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94387 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94402 */     GIR_RootConstrainSelectedInstOperands,
     /*  94403 */     // GIR_Coverage, 15894,
     /*  94403 */     GIR_EraseRootFromParent_Done,
     /*  94404 */   // Label 1467: @94404
     /*  94404 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94475), // Rule ID 12023 //
     /*  94409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94448 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94458 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94473 */     GIR_RootConstrainSelectedInstOperands,
     /*  94474 */     // GIR_Coverage, 12023,
     /*  94474 */     GIR_EraseRootFromParent_Done,
     /*  94475 */   // Label 1468: @94475
     /*  94475 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94536), // Rule ID 12130 //
     /*  94480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  94503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94507 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94517 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94534 */     GIR_RootConstrainSelectedInstOperands,
     /*  94535 */     // GIR_Coverage, 12130,
     /*  94535 */     GIR_EraseRootFromParent_Done,
     /*  94536 */   // Label 1469: @94536
     /*  94536 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(94579), // Rule ID 13985 //
     /*  94541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94562 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94577 */     GIR_RootConstrainSelectedInstOperands,
     /*  94578 */     // GIR_Coverage, 13985,
     /*  94578 */     GIR_EraseRootFromParent_Done,
     /*  94579 */   // Label 1470: @94579
     /*  94579 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94622), // Rule ID 3169 //
     /*  94584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94605 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94620 */     GIR_RootConstrainSelectedInstOperands,
     /*  94621 */     // GIR_Coverage, 3169,
     /*  94621 */     GIR_EraseRootFromParent_Done,
     /*  94622 */   // Label 1471: @94622
     /*  94622 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94637), // Rule ID 7561 //
     /*  94627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94630 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  94630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94635 */     GIR_RootConstrainSelectedInstOperands,
     /*  94636 */     // GIR_Coverage, 7561,
     /*  94636 */     GIR_Done,
     /*  94637 */   // Label 1472: @94637
     /*  94637 */   GIM_Reject,
     /*  94638 */ // Label 1456: @94638
     /*  94638 */ GIM_Reject,
     /*  94639 */ // Label 1349: @94639
     /*  94639 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94688), // Rule ID 8565 //
     /*  94644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  94650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  94653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94657 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  94657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  94664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94669 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94682 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94684 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94686 */   GIR_RootConstrainSelectedInstOperands,
     /*  94687 */   // GIR_Coverage, 8565,
     /*  94687 */   GIR_EraseRootFromParent_Done,
     /*  94688 */ // Label 1473: @94688
     /*  94688 */ GIM_Reject,
     /*  94689 */ // Label 1350: @94689
     /*  94689 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(96095),
     /*  94694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94704 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(94822), // Rule ID 16277 //
     /*  94709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94764 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94770 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94772 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94776 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94780 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94784 */     // MIs[5] Op3
     /*  94784 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94789 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94793 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94799 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94801 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94803 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94820 */     GIR_RootConstrainSelectedInstOperands,
     /*  94821 */     // GIR_Coverage, 16277,
     /*  94821 */     GIR_EraseRootFromParent_Done,
     /*  94822 */   // Label 1475: @94822
     /*  94822 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(94940), // Rule ID 16276 //
     /*  94827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94874 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94882 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94888 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94898 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94902 */     // MIs[5] Op3
     /*  94902 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94907 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94911 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94917 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94919 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94921 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94938 */     GIR_RootConstrainSelectedInstOperands,
     /*  94939 */     // GIR_Coverage, 16276,
     /*  94939 */     GIR_EraseRootFromParent_Done,
     /*  94940 */   // Label 1476: @94940
     /*  94940 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95058), // Rule ID 16275 //
     /*  94945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95000 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95006 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95016 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95020 */     // MIs[5] Op3
     /*  95020 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95025 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95029 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95035 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95037 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95039 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  95052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95056 */     GIR_RootConstrainSelectedInstOperands,
     /*  95057 */     // GIR_Coverage, 16275,
     /*  95057 */     GIR_EraseRootFromParent_Done,
     /*  95058 */   // Label 1477: @95058
     /*  95058 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95176), // Rule ID 16274 //
     /*  95063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95118 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95126 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95130 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95134 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95138 */     // MIs[5] Op3
     /*  95138 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95143 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95147 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95153 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95155 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95157 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  95166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  95170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95174 */     GIR_RootConstrainSelectedInstOperands,
     /*  95175 */     // GIR_Coverage, 16274,
     /*  95175 */     GIR_EraseRootFromParent_Done,
     /*  95176 */   // Label 1478: @95176
     /*  95176 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95294), // Rule ID 16271 //
     /*  95181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  95236 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95240 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95244 */     // MIs[4] Op3
     /*  95244 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95249 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95253 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95259 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95261 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95265 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95273 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95275 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  95288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95292 */     GIR_RootConstrainSelectedInstOperands,
     /*  95293 */     // GIR_Coverage, 16271,
     /*  95293 */     GIR_EraseRootFromParent_Done,
     /*  95294 */   // Label 1479: @95294
     /*  95294 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95412), // Rule ID 16273 //
     /*  95299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  95354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95362 */     // MIs[4] Op3
     /*  95362 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95371 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95379 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95383 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95391 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95393 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  95406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95410 */     GIR_RootConstrainSelectedInstOperands,
     /*  95411 */     // GIR_Coverage, 16273,
     /*  95411 */     GIR_EraseRootFromParent_Done,
     /*  95412 */   // Label 1480: @95412
     /*  95412 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95530), // Rule ID 12129 //
     /*  95417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95464 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95476 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95480 */     // MIs[4] Op3
     /*  95480 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95485 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95489 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95497 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95501 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95509 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95511 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95528 */     GIR_RootConstrainSelectedInstOperands,
     /*  95529 */     // GIR_Coverage, 12129,
     /*  95529 */     GIR_EraseRootFromParent_Done,
     /*  95530 */   // Label 1481: @95530
     /*  95530 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95648), // Rule ID 16272 //
     /*  95535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95594 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95598 */     // MIs[4] Op3
     /*  95598 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95603 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95607 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95613 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95615 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95619 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95625 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95627 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95629 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95646 */     GIR_RootConstrainSelectedInstOperands,
     /*  95647 */     // GIR_Coverage, 16272,
     /*  95647 */     GIR_EraseRootFromParent_Done,
     /*  95648 */   // Label 1482: @95648
     /*  95648 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95719), // Rule ID 15893 //
     /*  95653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95692 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95702 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95717 */     GIR_RootConstrainSelectedInstOperands,
     /*  95718 */     // GIR_Coverage, 15893,
     /*  95718 */     GIR_EraseRootFromParent_Done,
     /*  95719 */   // Label 1483: @95719
     /*  95719 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95790), // Rule ID 15892 //
     /*  95724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95773 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95788 */     GIR_RootConstrainSelectedInstOperands,
     /*  95789 */     // GIR_Coverage, 15892,
     /*  95789 */     GIR_EraseRootFromParent_Done,
     /*  95790 */   // Label 1484: @95790
     /*  95790 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95861), // Rule ID 15891 //
     /*  95795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95834 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95844 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95859 */     GIR_RootConstrainSelectedInstOperands,
     /*  95860 */     // GIR_Coverage, 15891,
     /*  95860 */     GIR_EraseRootFromParent_Done,
     /*  95861 */   // Label 1485: @95861
     /*  95861 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95932), // Rule ID 12021 //
     /*  95866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95905 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95915 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95930 */     GIR_RootConstrainSelectedInstOperands,
     /*  95931 */     // GIR_Coverage, 12021,
     /*  95931 */     GIR_EraseRootFromParent_Done,
     /*  95932 */   // Label 1486: @95932
     /*  95932 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95993), // Rule ID 12128 //
     /*  95937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95956 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  95960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95964 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95974 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95991 */     GIR_RootConstrainSelectedInstOperands,
     /*  95992 */     // GIR_Coverage, 12128,
     /*  95992 */     GIR_EraseRootFromParent_Done,
     /*  95993 */   // Label 1487: @95993
     /*  95993 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(96036), // Rule ID 13984 //
     /*  95998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  96017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96019 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  96019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  96022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  96028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  96034 */     GIR_RootConstrainSelectedInstOperands,
     /*  96035 */     // GIR_Coverage, 13984,
     /*  96035 */     GIR_EraseRootFromParent_Done,
     /*  96036 */   // Label 1488: @96036
     /*  96036 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(96079), // Rule ID 3167 //
     /*  96041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  96060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96062 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  96062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  96065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  96077 */     GIR_RootConstrainSelectedInstOperands,
     /*  96078 */     // GIR_Coverage, 3167,
     /*  96078 */     GIR_EraseRootFromParent_Done,
     /*  96079 */   // Label 1489: @96079
     /*  96079 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(96094), // Rule ID 7560 //
     /*  96084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96087 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  96087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  96092 */     GIR_RootConstrainSelectedInstOperands,
     /*  96093 */     // GIR_Coverage, 7560,
     /*  96093 */     GIR_Done,
     /*  96094 */   // Label 1490: @96094
     /*  96094 */   GIM_Reject,
     /*  96095 */ // Label 1474: @96095
     /*  96095 */ GIM_Reject,
     /*  96096 */ // Label 1351: @96096
     /*  96096 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96145), // Rule ID 8564 //
     /*  96101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  96107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  96110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  96114 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  96114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  96117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  96121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96126 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  96129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  96134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  96136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96139 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96141 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  96143 */   GIR_RootConstrainSelectedInstOperands,
     /*  96144 */   // GIR_Coverage, 8564,
     /*  96144 */   GIR_EraseRootFromParent_Done,
     /*  96145 */ // Label 1491: @96145
     /*  96145 */ GIM_Reject,
     /*  96146 */ // Label 1352: @96146
     /*  96146 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(97552),
     /*  96151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96161 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96279), // Rule ID 16270 //
     /*  96166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  96205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96209 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96213 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96217 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96221 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96229 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96233 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96237 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96241 */     // MIs[5] Op3
     /*  96241 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96246 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96250 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96258 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96260 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  96273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96277 */     GIR_RootConstrainSelectedInstOperands,
     /*  96278 */     // GIR_Coverage, 16270,
     /*  96278 */     GIR_EraseRootFromParent_Done,
     /*  96279 */   // Label 1493: @96279
     /*  96279 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96397), // Rule ID 16269 //
     /*  96284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  96323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96327 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96331 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96335 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96339 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96347 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96351 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96355 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96359 */     // MIs[5] Op3
     /*  96359 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96364 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96368 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96374 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96376 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96378 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  96391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96395 */     GIR_RootConstrainSelectedInstOperands,
     /*  96396 */     // GIR_Coverage, 16269,
     /*  96396 */     GIR_EraseRootFromParent_Done,
     /*  96397 */   // Label 1494: @96397
     /*  96397 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96515), // Rule ID 16268 //
     /*  96402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96445 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96449 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96465 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96469 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96473 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96477 */     // MIs[5] Op3
     /*  96477 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96482 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96486 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96494 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96496 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96513 */     GIR_RootConstrainSelectedInstOperands,
     /*  96514 */     // GIR_Coverage, 16268,
     /*  96514 */     GIR_EraseRootFromParent_Done,
     /*  96515 */   // Label 1495: @96515
     /*  96515 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96633), // Rule ID 16267 //
     /*  96520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96563 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96567 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96571 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96575 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96581 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96583 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96587 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96591 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96595 */     // MIs[5] Op3
     /*  96595 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96600 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96604 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96612 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96614 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96631 */     GIR_RootConstrainSelectedInstOperands,
     /*  96632 */     // GIR_Coverage, 16267,
     /*  96632 */     GIR_EraseRootFromParent_Done,
     /*  96633 */   // Label 1496: @96633
     /*  96633 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96751), // Rule ID 16264 //
     /*  96638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96681 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96685 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96689 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96693 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96697 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96701 */     // MIs[4] Op3
     /*  96701 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96706 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96710 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96718 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96722 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96730 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96732 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96749 */     GIR_RootConstrainSelectedInstOperands,
     /*  96750 */     // GIR_Coverage, 16264,
     /*  96750 */     GIR_EraseRootFromParent_Done,
     /*  96751 */   // Label 1497: @96751
     /*  96751 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(96869), // Rule ID 16266 //
     /*  96756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96815 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96819 */     // MIs[4] Op3
     /*  96819 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96824 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96828 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96836 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96840 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96848 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96850 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96867 */     GIR_RootConstrainSelectedInstOperands,
     /*  96868 */     // GIR_Coverage, 16266,
     /*  96868 */     GIR_EraseRootFromParent_Done,
     /*  96869 */   // Label 1498: @96869
     /*  96869 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(96987), // Rule ID 12127 //
     /*  96874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96917 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96921 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96925 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96929 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96933 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96937 */     // MIs[4] Op3
     /*  96937 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96946 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96954 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96958 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96966 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96968 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96985 */     GIR_RootConstrainSelectedInstOperands,
     /*  96986 */     // GIR_Coverage, 12127,
     /*  96986 */     GIR_EraseRootFromParent_Done,
     /*  96987 */   // Label 1499: @96987
     /*  96987 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(97105), // Rule ID 16265 //
     /*  96992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97039 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97051 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97055 */     // MIs[4] Op3
     /*  97055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  97060 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97064 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97072 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97076 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97084 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97086 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  97095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  97099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97103 */     GIR_RootConstrainSelectedInstOperands,
     /*  97104 */     // GIR_Coverage, 16265,
     /*  97104 */     GIR_EraseRootFromParent_Done,
     /*  97105 */   // Label 1500: @97105
     /*  97105 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97176), // Rule ID 15890 //
     /*  97110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97149 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  97157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97159 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  97162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  97166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97174 */     GIR_RootConstrainSelectedInstOperands,
     /*  97175 */     // GIR_Coverage, 15890,
     /*  97175 */     GIR_EraseRootFromParent_Done,
     /*  97176 */   // Label 1501: @97176
     /*  97176 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97247), // Rule ID 15889 //
     /*  97181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  97204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97220 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  97228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97230 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  97233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  97237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97245 */     GIR_RootConstrainSelectedInstOperands,
     /*  97246 */     // GIR_Coverage, 15889,
     /*  97246 */     GIR_EraseRootFromParent_Done,
     /*  97247 */   // Label 1502: @97247
     /*  97247 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97318), // Rule ID 15888 //
     /*  97252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  97299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97301 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  97304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97316 */     GIR_RootConstrainSelectedInstOperands,
     /*  97317 */     // GIR_Coverage, 15888,
     /*  97317 */     GIR_EraseRootFromParent_Done,
     /*  97318 */   // Label 1503: @97318
     /*  97318 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97389), // Rule ID 12019 //
     /*  97323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  97346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97362 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97368 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  97370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97372 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  97375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97387 */     GIR_RootConstrainSelectedInstOperands,
     /*  97388 */     // GIR_Coverage, 12019,
     /*  97388 */     GIR_EraseRootFromParent_Done,
     /*  97389 */   // Label 1504: @97389
     /*  97389 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(97450), // Rule ID 12126 //
     /*  97394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  97405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97413 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  97417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97421 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97431 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97448 */     GIR_RootConstrainSelectedInstOperands,
     /*  97449 */     // GIR_Coverage, 12126,
     /*  97449 */     GIR_EraseRootFromParent_Done,
     /*  97450 */   // Label 1505: @97450
     /*  97450 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(97493), // Rule ID 13983 //
     /*  97455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97476 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97491 */     GIR_RootConstrainSelectedInstOperands,
     /*  97492 */     // GIR_Coverage, 13983,
     /*  97492 */     GIR_EraseRootFromParent_Done,
     /*  97493 */   // Label 1506: @97493
     /*  97493 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(97536), // Rule ID 3165 //
     /*  97498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97519 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97534 */     GIR_RootConstrainSelectedInstOperands,
     /*  97535 */     // GIR_Coverage, 3165,
     /*  97535 */     GIR_EraseRootFromParent_Done,
     /*  97536 */   // Label 1507: @97536
     /*  97536 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(97551), // Rule ID 7559 //
     /*  97541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97544 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  97544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97549 */     GIR_RootConstrainSelectedInstOperands,
     /*  97550 */     // GIR_Coverage, 7559,
     /*  97550 */     GIR_Done,
     /*  97551 */   // Label 1508: @97551
     /*  97551 */   GIM_Reject,
     /*  97552 */ // Label 1492: @97552
     /*  97552 */ GIM_Reject,
     /*  97553 */ // Label 1353: @97553
     /*  97553 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(97602), // Rule ID 8563 //
     /*  97558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  97564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  97567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  97571 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  97571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  97574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  97578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97583 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  97586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  97591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  97593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97596 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97598 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  97600 */   GIR_RootConstrainSelectedInstOperands,
     /*  97601 */   // GIR_Coverage, 8563,
     /*  97601 */   GIR_EraseRootFromParent_Done,
     /*  97602 */ // Label 1509: @97602
     /*  97602 */ GIM_Reject,
     /*  97603 */ // Label 1354: @97603
     /*  97603 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(99009),
     /*  97608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97618 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(97736), // Rule ID 16263 //
     /*  97623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97670 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97678 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97686 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97690 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97694 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97698 */     // MIs[5] Op3
     /*  97698 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97703 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97707 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97715 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97717 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97734 */     GIR_RootConstrainSelectedInstOperands,
     /*  97735 */     // GIR_Coverage, 16263,
     /*  97735 */     GIR_EraseRootFromParent_Done,
     /*  97736 */   // Label 1511: @97736
     /*  97736 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(97854), // Rule ID 16262 //
     /*  97741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97796 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97804 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97808 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97812 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97816 */     // MIs[5] Op3
     /*  97816 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97821 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97825 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97833 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97835 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97852 */     GIR_RootConstrainSelectedInstOperands,
     /*  97853 */     // GIR_Coverage, 16262,
     /*  97853 */     GIR_EraseRootFromParent_Done,
     /*  97854 */   // Label 1512: @97854
     /*  97854 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(97972), // Rule ID 16261 //
     /*  97859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97914 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97922 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97926 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97930 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97934 */     // MIs[5] Op3
     /*  97934 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97939 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97943 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97951 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97953 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97970 */     GIR_RootConstrainSelectedInstOperands,
     /*  97971 */     // GIR_Coverage, 16261,
     /*  97971 */     GIR_EraseRootFromParent_Done,
     /*  97972 */   // Label 1513: @97972
     /*  97972 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(98090), // Rule ID 16260 //
     /*  97977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98032 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98038 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  98040 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  98044 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98048 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98052 */     // MIs[5] Op3
     /*  98052 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  98057 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98061 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98069 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98071 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  98080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  98084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  98088 */     GIR_RootConstrainSelectedInstOperands,
     /*  98089 */     // GIR_Coverage, 16260,
     /*  98089 */     GIR_EraseRootFromParent_Done,
     /*  98090 */   // Label 1514: @98090
     /*  98090 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(98208), // Rule ID 16257 //
     /*  98095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98154 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98158 */     // MIs[4] Op3
     /*  98158 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  98163 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98167 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98175 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98179 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98185 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98187 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98189 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  98198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  98202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  98206 */     GIR_RootConstrainSelectedInstOperands,
     /*  98207 */     // GIR_Coverage, 16257,
     /*  98207 */     GIR_EraseRootFromParent_Done,
     /*  98208 */   // Label 1515: @98208
     /*  98208 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(98326), // Rule ID 16259 //
     /*  98213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98260 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98272 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98276 */     // MIs[4] Op3
     /*  98276 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  98281 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98285 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98293 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98297 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98305 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98307 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  98316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  98320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98324 */     GIR_RootConstrainSelectedInstOperands,
     /*  98325 */     // GIR_Coverage, 16259,
     /*  98325 */     GIR_EraseRootFromParent_Done,
     /*  98326 */   // Label 1516: @98326
     /*  98326 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(98444), // Rule ID 12125 //
     /*  98331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98386 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98390 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98394 */     // MIs[4] Op3
     /*  98394 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  98399 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98403 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98411 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98415 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98423 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98425 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  98434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  98442 */     GIR_RootConstrainSelectedInstOperands,
     /*  98443 */     // GIR_Coverage, 12125,
     /*  98443 */     GIR_EraseRootFromParent_Done,
     /*  98444 */   // Label 1517: @98444
     /*  98444 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(98562), // Rule ID 16258 //
     /*  98449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98496 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98504 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98508 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98512 */     // MIs[4] Op3
     /*  98512 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  98517 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98521 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98529 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98533 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98541 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98543 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  98552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98560 */     GIR_RootConstrainSelectedInstOperands,
     /*  98561 */     // GIR_Coverage, 16258,
     /*  98561 */     GIR_EraseRootFromParent_Done,
     /*  98562 */   // Label 1518: @98562
     /*  98562 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(98633), // Rule ID 15887 //
     /*  98567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98616 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98631 */     GIR_RootConstrainSelectedInstOperands,
     /*  98632 */     // GIR_Coverage, 15887,
     /*  98632 */     GIR_EraseRootFromParent_Done,
     /*  98633 */   // Label 1519: @98633
     /*  98633 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(98704), // Rule ID 15886 //
     /*  98638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98677 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98687 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98702 */     GIR_RootConstrainSelectedInstOperands,
     /*  98703 */     // GIR_Coverage, 15886,
     /*  98703 */     GIR_EraseRootFromParent_Done,
     /*  98704 */   // Label 1520: @98704
     /*  98704 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98775), // Rule ID 15885 //
     /*  98709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98748 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98758 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98773 */     GIR_RootConstrainSelectedInstOperands,
     /*  98774 */     // GIR_Coverage, 15885,
     /*  98774 */     GIR_EraseRootFromParent_Done,
     /*  98775 */   // Label 1521: @98775
     /*  98775 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(98846), // Rule ID 12017 //
     /*  98780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98829 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98844 */     GIR_RootConstrainSelectedInstOperands,
     /*  98845 */     // GIR_Coverage, 12017,
     /*  98845 */     GIR_EraseRootFromParent_Done,
     /*  98846 */   // Label 1522: @98846
     /*  98846 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(98907), // Rule ID 12124 //
     /*  98851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  98862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98870 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  98874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  98878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  98886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98888 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  98897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  98901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  98905 */     GIR_RootConstrainSelectedInstOperands,
     /*  98906 */     // GIR_Coverage, 12124,
     /*  98906 */     GIR_EraseRootFromParent_Done,
     /*  98907 */   // Label 1523: @98907
     /*  98907 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(98950), // Rule ID 13982 //
     /*  98912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98933 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  98942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  98948 */     GIR_RootConstrainSelectedInstOperands,
     /*  98949 */     // GIR_Coverage, 13982,
     /*  98949 */     GIR_EraseRootFromParent_Done,
     /*  98950 */   // Label 1524: @98950
     /*  98950 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(98993), // Rule ID 3163 //
     /*  98955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98976 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  98991 */     GIR_RootConstrainSelectedInstOperands,
     /*  98992 */     // GIR_Coverage, 3163,
     /*  98992 */     GIR_EraseRootFromParent_Done,
     /*  98993 */   // Label 1525: @98993
     /*  98993 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(99008), // Rule ID 7558 //
     /*  98998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  99001 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  99001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  99006 */     GIR_RootConstrainSelectedInstOperands,
     /*  99007 */     // GIR_Coverage, 7558,
     /*  99007 */     GIR_Done,
     /*  99008 */   // Label 1526: @99008
     /*  99008 */   GIM_Reject,
     /*  99009 */ // Label 1510: @99009
     /*  99009 */ GIM_Reject,
     /*  99010 */ // Label 1355: @99010
     /*  99010 */ GIM_Reject,
     /*  99011 */ // Label 8: @99011
     /*  99011 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(106534),
     /*  99016 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  99019 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1539*/ GIMT_Encode4(106533),
     /*  99030 */   /*GILLT_v2s64*//*Label 1528*/ GIMT_Encode4(99098), GIMT_Encode4(0),
     /*  99038 */   /*GILLT_v4s32*//*Label 1529*/ GIMT_Encode4(99619), GIMT_Encode4(0),
     /*  99046 */   /*GILLT_v8s16*//*Label 1530*/ GIMT_Encode4(102031),
     /*  99050 */   /*GILLT_v16s8*//*Label 1531*/ GIMT_Encode4(104440), GIMT_Encode4(0),
     /*  99058 */   /*GILLT_nxv2s1*//*Label 1532*/ GIMT_Encode4(106351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99074 */   /*GILLT_nxv4s1*//*Label 1533*/ GIMT_Encode4(106377),
     /*  99078 */   /*GILLT_nxv4s16*//*Label 1534*/ GIMT_Encode4(106403),
     /*  99082 */   /*GILLT_nxv4s32*//*Label 1535*/ GIMT_Encode4(106429),
     /*  99086 */   /*GILLT_nxv8s1*//*Label 1536*/ GIMT_Encode4(106455),
     /*  99090 */   /*GILLT_nxv8s16*//*Label 1537*/ GIMT_Encode4(106481),
     /*  99094 */   /*GILLT_nxv16s1*//*Label 1538*/ GIMT_Encode4(106507),
     /*  99098 */   // Label 1528: @99098
     /*  99098 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99618),
     /*  99103 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  99106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  99109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99117 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99179), // Rule ID 5856 //
     /*  99122 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99126 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99132 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99134 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99136 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  99136 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99139 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99143 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99148 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99152 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99159 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99165 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99168 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99173 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99178 */       // GIR_Coverage, 5856,
     /*  99178 */       GIR_EraseRootFromParent_Done,
     /*  99179 */     // Label 1541: @99179
     /*  99179 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99241), // Rule ID 5860 //
     /*  99184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99188 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99194 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99196 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99198 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  99198 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99201 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99205 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99210 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99214 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99216 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99219 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99221 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99224 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99227 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99230 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99235 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99240 */       // GIR_Coverage, 5860,
     /*  99240 */       GIR_EraseRootFromParent_Done,
     /*  99241 */     // Label 1542: @99241
     /*  99241 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99299), // Rule ID 5857 //
     /*  99246 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99250 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99254 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99256 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  99256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  99259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99268 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99270 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99273 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99275 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99278 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99280 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99283 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99288 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99293 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99298 */       // GIR_Coverage, 5857,
     /*  99298 */       GIR_EraseRootFromParent_Done,
     /*  99299 */     // Label 1543: @99299
     /*  99299 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99357), // Rule ID 5861 //
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99312 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99314 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  99314 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  99317 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99321 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99326 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99328 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99331 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99333 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99336 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99338 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99341 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99346 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99351 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99356 */       // GIR_Coverage, 5861,
     /*  99356 */       GIR_EraseRootFromParent_Done,
     /*  99357 */     // Label 1544: @99357
     /*  99357 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99487), // Rule ID 5855 //
     /*  99362 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99366 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99366 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99369 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99373 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99378 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99380 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99383 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99387 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99392 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99395 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99399 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99402 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99407 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99412 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99417 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99420 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99424 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99429 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99431 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99434 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99438 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99443 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99446 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99450 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99453 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99458 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99463 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99468 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99471 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99473 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99476 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99479 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99482 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99485 */       GIR_RootConstrainSelectedInstOperands,
     /*  99486 */       // GIR_Coverage, 5855,
     /*  99486 */       GIR_EraseRootFromParent_Done,
     /*  99487 */     // Label 1545: @99487
     /*  99487 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99617), // Rule ID 5859 //
     /*  99492 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99496 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99496 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99499 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99503 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99508 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99510 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99513 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99517 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99522 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99525 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99529 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99532 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99537 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99542 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99547 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99550 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99554 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99559 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99561 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99564 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99568 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99573 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99576 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99580 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99583 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99593 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99598 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99601 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99603 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99606 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99615 */       GIR_RootConstrainSelectedInstOperands,
     /*  99616 */       // GIR_Coverage, 5859,
     /*  99616 */       GIR_EraseRootFromParent_Done,
     /*  99617 */     // Label 1546: @99617
     /*  99617 */     GIM_Reject,
     /*  99618 */   // Label 1540: @99618
     /*  99618 */   GIM_Reject,
     /*  99619 */   // Label 1529: @99619
     /*  99619 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(102030),
     /*  99624 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  99630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99634 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(99763), // Rule ID 5479 //
     /*  99639 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99643 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99647 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99651 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99655 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99659 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99663 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99667 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99671 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  99675 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99679 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99683 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99688 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  99692 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99698 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  99700 */       // MIs[2] Operand 2
     /*  99700 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99711 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99713 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  99713 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99716 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99720 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99725 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99728 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99732 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99735 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99740 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99750 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99753 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99757 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99761 */       GIR_RootConstrainSelectedInstOperands,
     /*  99762 */       // GIR_Coverage, 5479,
     /*  99762 */       GIR_EraseRootFromParent_Done,
     /*  99763 */     // Label 1548: @99763
     /*  99763 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99885), // Rule ID 5475 //
     /*  99768 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99772 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99776 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99780 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99784 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99788 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99792 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99796 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99800 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  99804 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99808 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99812 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99817 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99822 */       // MIs[2] Operand 2
     /*  99822 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99833 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99835 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99835 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99838 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99842 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99847 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99850 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99854 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99862 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99867 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  99870 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99872 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99875 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99879 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99883 */       GIR_RootConstrainSelectedInstOperands,
     /*  99884 */       // GIR_Coverage, 5475,
     /*  99884 */       GIR_EraseRootFromParent_Done,
     /*  99885 */     // Label 1549: @99885
     /*  99885 */     GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100007), // Rule ID 5477 //
     /*  99890 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99894 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99898 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99902 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99906 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99910 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99914 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99918 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99922 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  99926 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99930 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99934 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99939 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99944 */       // MIs[2] Operand 2
     /*  99944 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99955 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99957 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99957 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99960 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99964 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99969 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99972 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99976 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99979 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99984 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99989 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99992 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99994 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99997 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100001 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100005 */       GIR_RootConstrainSelectedInstOperands,
     /* 100006 */       // GIR_Coverage, 5477,
     /* 100006 */       GIR_EraseRootFromParent_Done,
     /* 100007 */     // Label 1550: @100007
     /* 100007 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100109), // Rule ID 5625 //
     /* 100012 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100016 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100020 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100024 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100028 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100032 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100036 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100041 */       // MIs[2] Operand 2
     /* 100041 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /* 100052 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 100056 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100060 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100064 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 100068 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100072 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100076 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100081 */       // MIs[4] Operand 2
     /* 100081 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /* 100092 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100094 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 100094 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 100097 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100099 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 100103 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 100107 */       GIR_RootConstrainSelectedInstOperands,
     /* 100108 */       // GIR_Coverage, 5625,
     /* 100108 */       GIR_EraseRootFromParent_Done,
     /* 100109 */     // Label 1551: @100109
     /* 100109 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100238), // Rule ID 6411 //
     /* 100114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100118 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100122 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100126 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100129 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100134 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100138 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100142 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100147 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /* 100151 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100153 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 100153 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /* 100156 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 100160 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100165 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100168 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100170 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100173 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100177 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100182 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100184 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100187 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100191 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100196 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100199 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 100203 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100206 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100211 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100216 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /* 100224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100226 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100229 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 100233 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100236 */       GIR_RootConstrainSelectedInstOperands,
     /* 100237 */       // GIR_Coverage, 6411,
     /* 100237 */       GIR_EraseRootFromParent_Done,
     /* 100238 */     // Label 1552: @100238
     /* 100238 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100280), // Rule ID 5866 //
     /* 100243 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 100250 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 100257 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /* 100257 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100260 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100262 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100267 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100270 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100275 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100278 */       GIR_RootConstrainSelectedInstOperands,
     /* 100279 */       // GIR_Coverage, 5866,
     /* 100279 */       GIR_EraseRootFromParent_Done,
     /* 100280 */     // Label 1553: @100280
     /* 100280 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100322), // Rule ID 5870 //
     /* 100285 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 100292 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 100299 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /* 100299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100304 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100309 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100312 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100317 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100320 */       GIR_RootConstrainSelectedInstOperands,
     /* 100321 */       // GIR_Coverage, 5870,
     /* 100321 */       GIR_EraseRootFromParent_Done,
     /* 100322 */     // Label 1554: @100322
     /* 100322 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100445), // Rule ID 2578 //
     /* 100327 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100330 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100334 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100338 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100342 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100345 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100350 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100354 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100358 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100363 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 100367 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100371 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100375 */       // MIs[2] Operand 1
     /* 100375 */       // No operand predicates
     /* 100375 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100377 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 100377 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100380 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100384 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100389 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100391 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100394 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100398 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100403 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100406 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100410 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100413 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100418 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100423 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100428 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /* 100431 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100433 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100436 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100440 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100443 */       GIR_RootConstrainSelectedInstOperands,
     /* 100444 */       // GIR_Coverage, 2578,
     /* 100444 */       GIR_EraseRootFromParent_Done,
     /* 100445 */     // Label 1555: @100445
     /* 100445 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100568), // Rule ID 6381 //
     /* 100450 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100453 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100457 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100461 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100465 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100469 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100473 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 100477 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100481 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100486 */       // MIs[2] imm
     /* 100486 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100490 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100494 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100498 */       // MIs[3] Operand 1
     /* 100498 */       // No operand predicates
     /* 100498 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100500 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 100500 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100503 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100507 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100512 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100514 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100517 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100521 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100526 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100529 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100533 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100536 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100541 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100551 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100554 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100556 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100559 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100563 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100566 */       GIR_RootConstrainSelectedInstOperands,
     /* 100567 */       // GIR_Coverage, 6381,
     /* 100567 */       GIR_EraseRootFromParent_Done,
     /* 100568 */     // Label 1556: @100568
     /* 100568 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100688), // Rule ID 6417 //
     /* 100573 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100577 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100581 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100585 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100589 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100593 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100597 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100601 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100606 */       // MIs[2] imm
     /* 100606 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100610 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100614 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100618 */       // MIs[3] Operand 1
     /* 100618 */       // No operand predicates
     /* 100618 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100620 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100620 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100623 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100627 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100632 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100634 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100637 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100641 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100646 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100649 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100653 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100656 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100661 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100666 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100671 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100674 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100676 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100679 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100683 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100686 */       GIR_RootConstrainSelectedInstOperands,
     /* 100687 */       // GIR_Coverage, 6417,
     /* 100687 */       GIR_EraseRootFromParent_Done,
     /* 100688 */     // Label 1557: @100688
     /* 100688 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100805), // Rule ID 2501 //
     /* 100693 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100696 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100700 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100704 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100708 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100711 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 100716 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100720 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100724 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100729 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100734 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100736 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100736 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100739 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100743 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100748 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100750 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100753 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100757 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100762 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100765 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100769 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100772 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100777 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100782 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100787 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /* 100790 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100792 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100795 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100799 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100803 */       GIR_RootConstrainSelectedInstOperands,
     /* 100804 */       // GIR_Coverage, 2501,
     /* 100804 */       GIR_EraseRootFromParent_Done,
     /* 100805 */     // Label 1558: @100805
     /* 100805 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(100922), // Rule ID 5395 //
     /* 100810 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100813 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100817 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100821 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100825 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100828 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 100833 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100837 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100841 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100846 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100851 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100853 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100853 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100856 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100860 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100865 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100867 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100870 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100874 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100879 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100882 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100886 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100899 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100904 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /* 100907 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100909 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100912 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100916 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100920 */       GIR_RootConstrainSelectedInstOperands,
     /* 100921 */       // GIR_Coverage, 5395,
     /* 100921 */       GIR_EraseRootFromParent_Done,
     /* 100922 */     // Label 1559: @100922
     /* 100922 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101039), // Rule ID 5398 //
     /* 100927 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100930 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100938 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100942 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100945 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 100950 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100954 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100958 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100963 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100968 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100970 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100970 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100973 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100977 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100982 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100984 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100987 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100991 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100996 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100999 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101003 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101006 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101011 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101016 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101021 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /* 101024 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101026 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101029 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101037 */       GIR_RootConstrainSelectedInstOperands,
     /* 101038 */       // GIR_Coverage, 5398,
     /* 101038 */       GIR_EraseRootFromParent_Done,
     /* 101039 */     // Label 1560: @101039
     /* 101039 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101156), // Rule ID 5401 //
     /* 101044 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101047 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101051 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101055 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101059 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101062 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 101067 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 101071 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 101075 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101080 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101085 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101087 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 101087 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101090 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101094 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101099 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101101 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101104 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101108 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101113 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101116 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101120 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101138 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /* 101141 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101143 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101146 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101150 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101154 */       GIR_RootConstrainSelectedInstOperands,
     /* 101155 */       // GIR_Coverage, 5401,
     /* 101155 */       GIR_EraseRootFromParent_Done,
     /* 101156 */     // Label 1561: @101156
     /* 101156 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101260), // Rule ID 2497 //
     /* 101161 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101164 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101168 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101172 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101176 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 101179 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 101184 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 101188 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101193 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101195 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 101195 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101198 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101202 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101207 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101209 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101212 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101216 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101221 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101224 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101228 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101231 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101236 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101241 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101246 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /* 101249 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101251 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101254 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101258 */       GIR_RootConstrainSelectedInstOperands,
     /* 101259 */       // GIR_Coverage, 2497,
     /* 101259 */       GIR_EraseRootFromParent_Done,
     /* 101260 */     // Label 1562: @101260
     /* 101260 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101316), // Rule ID 5558 //
     /* 101265 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101269 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101273 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101282 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 101286 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101290 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101294 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101299 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 101301 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 101301 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 101304 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101306 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 101310 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 101314 */       GIR_RootConstrainSelectedInstOperands,
     /* 101315 */       // GIR_Coverage, 5558,
     /* 101315 */       GIR_EraseRootFromParent_Done,
     /* 101316 */     // Label 1563: @101316
     /* 101316 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101382), // Rule ID 5864 //
     /* 101321 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101325 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101329 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101335 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101337 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101339 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 101339 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101342 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101346 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101351 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101355 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101362 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101368 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101376 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101381 */       // GIR_Coverage, 5864,
     /* 101381 */       GIR_EraseRootFromParent_Done,
     /* 101382 */     // Label 1564: @101382
     /* 101382 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101448), // Rule ID 5868 //
     /* 101387 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101391 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101395 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101401 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101403 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101405 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /* 101405 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101408 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101412 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101417 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101421 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101423 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101426 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101428 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101431 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101434 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101437 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101442 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101447 */       // GIR_Coverage, 5868,
     /* 101447 */       GIR_EraseRootFromParent_Done,
     /* 101448 */     // Label 1565: @101448
     /* 101448 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101541), // Rule ID 4983 //
     /* 101453 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101457 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101461 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 101465 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101469 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101474 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101476 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 101476 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101479 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101483 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101502 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101505 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101509 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /* 101530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101532 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101535 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101539 */       GIR_RootConstrainSelectedInstOperands,
     /* 101540 */       // GIR_Coverage, 4983,
     /* 101540 */       GIR_EraseRootFromParent_Done,
     /* 101541 */     // Label 1566: @101541
     /* 101541 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101637), // Rule ID 5030 //
     /* 101546 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101549 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101553 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101557 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101561 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101565 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101570 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101572 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /* 101572 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101575 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101579 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101584 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101586 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101589 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101593 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101598 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101601 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101605 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101608 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101613 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101618 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101623 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /* 101626 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101628 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101631 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101635 */       GIR_RootConstrainSelectedInstOperands,
     /* 101636 */       // GIR_Coverage, 5030,
     /* 101636 */       GIR_EraseRootFromParent_Done,
     /* 101637 */     // Label 1567: @101637
     /* 101637 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101699), // Rule ID 5865 //
     /* 101642 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101646 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101650 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101654 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101656 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /* 101656 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101659 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101663 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101668 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101670 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101673 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101675 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101678 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101680 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101683 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101688 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101693 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101698 */       // GIR_Coverage, 5865,
     /* 101698 */       GIR_EraseRootFromParent_Done,
     /* 101699 */     // Label 1568: @101699
     /* 101699 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(101761), // Rule ID 5869 //
     /* 101704 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101708 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101712 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101716 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101718 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /* 101718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101732 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101735 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101737 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101740 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101742 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101745 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101750 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101755 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101760 */       // GIR_Coverage, 5869,
     /* 101760 */       GIR_EraseRootFromParent_Done,
     /* 101761 */     // Label 1569: @101761
     /* 101761 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(101895), // Rule ID 5863 //
     /* 101766 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101770 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101774 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101774 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101777 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101781 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101786 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101788 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101791 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101795 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101800 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101803 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101807 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101810 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101815 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101820 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101825 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101828 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101832 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101837 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101839 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101842 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101846 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101851 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101854 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101858 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101866 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101876 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101879 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101881 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101884 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101887 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101890 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101893 */       GIR_RootConstrainSelectedInstOperands,
     /* 101894 */       // GIR_Coverage, 5863,
     /* 101894 */       GIR_EraseRootFromParent_Done,
     /* 101895 */     // Label 1570: @101895
     /* 101895 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102029), // Rule ID 5867 //
     /* 101900 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101904 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101908 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101908 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101911 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101915 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101920 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101922 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101925 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101929 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101934 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101937 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101941 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101944 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101949 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101954 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101959 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101962 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101966 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101971 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101973 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101976 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101980 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101985 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101988 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101992 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101995 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102000 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102005 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102010 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102013 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102015 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102018 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102021 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102024 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102027 */       GIR_RootConstrainSelectedInstOperands,
     /* 102028 */       // GIR_Coverage, 5867,
     /* 102028 */       GIR_EraseRootFromParent_Done,
     /* 102029 */     // Label 1571: @102029
     /* 102029 */     GIM_Reject,
     /* 102030 */   // Label 1547: @102030
     /* 102030 */   GIM_Reject,
     /* 102031 */   // Label 1530: @102031
     /* 102031 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(104439),
     /* 102036 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102046 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102175), // Rule ID 5473 //
     /* 102051 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102055 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102059 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102063 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102067 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102071 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102075 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102079 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102083 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 102087 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102091 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102095 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102100 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 102104 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 102110 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 102112 */       // MIs[2] Operand 2
     /* 102112 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102123 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102125 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 102125 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102128 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102132 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102137 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102140 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102144 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102165 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102173 */       GIR_RootConstrainSelectedInstOperands,
     /* 102174 */       // GIR_Coverage, 5473,
     /* 102174 */       GIR_EraseRootFromParent_Done,
     /* 102175 */     // Label 1573: @102175
     /* 102175 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102297), // Rule ID 5469 //
     /* 102180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102196 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102200 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102204 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102208 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102212 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 102216 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102220 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102224 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102229 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102234 */       // MIs[2] Operand 2
     /* 102234 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102245 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102247 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102247 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102250 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102254 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102259 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102262 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102266 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102274 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102279 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 102282 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102284 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102287 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102291 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102295 */       GIR_RootConstrainSelectedInstOperands,
     /* 102296 */       // GIR_Coverage, 5469,
     /* 102296 */       GIR_EraseRootFromParent_Done,
     /* 102297 */     // Label 1574: @102297
     /* 102297 */     GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(102419), // Rule ID 5471 //
     /* 102302 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102306 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102310 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102314 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102318 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102322 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102326 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102330 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102334 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 102338 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102342 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102346 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102351 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102356 */       // MIs[2] Operand 2
     /* 102356 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102367 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102369 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102369 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102372 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102376 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102381 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102384 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102388 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102391 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102396 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102401 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102404 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102406 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102409 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102413 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102417 */       GIR_RootConstrainSelectedInstOperands,
     /* 102418 */       // GIR_Coverage, 5471,
     /* 102418 */       GIR_EraseRootFromParent_Done,
     /* 102419 */     // Label 1575: @102419
     /* 102419 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102521), // Rule ID 5624 //
     /* 102424 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102428 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102432 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102436 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102440 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102444 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102448 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102453 */       // MIs[2] Operand 2
     /* 102453 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102464 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 102468 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102472 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102476 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 102480 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102484 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102488 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102493 */       // MIs[4] Operand 2
     /* 102493 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 102504 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102506 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 102506 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 102509 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102511 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 102515 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 102519 */       GIR_RootConstrainSelectedInstOperands,
     /* 102520 */       // GIR_Coverage, 5624,
     /* 102520 */       GIR_EraseRootFromParent_Done,
     /* 102521 */     // Label 1576: @102521
     /* 102521 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102650), // Rule ID 6410 //
     /* 102526 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102530 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102534 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102538 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102541 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102546 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102550 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102554 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102559 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 102563 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102565 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 102565 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 102568 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 102572 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102577 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102580 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102582 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102585 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102589 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102594 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102596 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102599 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102603 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102608 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102611 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 102615 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102618 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102623 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102628 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102633 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 102636 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102638 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102641 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 102645 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102648 */       GIR_RootConstrainSelectedInstOperands,
     /* 102649 */       // GIR_Coverage, 6410,
     /* 102649 */       GIR_EraseRootFromParent_Done,
     /* 102650 */     // Label 1577: @102650
     /* 102650 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102692), // Rule ID 5874 //
     /* 102655 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102662 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102669 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 102669 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102672 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102674 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102679 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102682 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102687 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102690 */       GIR_RootConstrainSelectedInstOperands,
     /* 102691 */       // GIR_Coverage, 5874,
     /* 102691 */       GIR_EraseRootFromParent_Done,
     /* 102692 */     // Label 1578: @102692
     /* 102692 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(102734), // Rule ID 5878 //
     /* 102697 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102704 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102711 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 102711 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102714 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102716 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102721 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102724 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102729 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102732 */       GIR_RootConstrainSelectedInstOperands,
     /* 102733 */       // GIR_Coverage, 5878,
     /* 102733 */       GIR_EraseRootFromParent_Done,
     /* 102734 */     // Label 1579: @102734
     /* 102734 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(102857), // Rule ID 2576 //
     /* 102739 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102742 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102746 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102750 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102754 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102757 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102762 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102766 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102770 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102775 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 102779 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102783 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102787 */       // MIs[2] Operand 1
     /* 102787 */       // No operand predicates
     /* 102787 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 102789 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102789 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102792 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102796 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102801 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102803 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102806 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102810 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102815 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102818 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102822 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102825 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102830 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102835 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102840 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 102843 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102845 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102848 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102852 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 102855 */       GIR_RootConstrainSelectedInstOperands,
     /* 102856 */       // GIR_Coverage, 2576,
     /* 102856 */       GIR_EraseRootFromParent_Done,
     /* 102857 */     // Label 1580: @102857
     /* 102857 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(102980), // Rule ID 6380 //
     /* 102862 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102865 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102869 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102873 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102877 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102881 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102885 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 102889 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102893 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102898 */       // MIs[2] imm
     /* 102898 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102902 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102906 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102910 */       // MIs[3] Operand 1
     /* 102910 */       // No operand predicates
     /* 102910 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102912 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102912 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102915 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102919 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102924 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102926 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102929 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102933 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102938 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102941 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102945 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102948 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102953 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102958 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102963 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102966 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102968 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102971 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102975 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102978 */       GIR_RootConstrainSelectedInstOperands,
     /* 102979 */       // GIR_Coverage, 6380,
     /* 102979 */       GIR_EraseRootFromParent_Done,
     /* 102980 */     // Label 1581: @102980
     /* 102980 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103100), // Rule ID 6416 //
     /* 102985 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102989 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102993 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102997 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103001 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103005 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103009 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103013 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103018 */       // MIs[2] imm
     /* 103018 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103022 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103026 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 103030 */       // MIs[3] Operand 1
     /* 103030 */       // No operand predicates
     /* 103030 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103032 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 103032 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103035 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103039 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103044 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103046 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103049 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103053 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103058 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103061 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103065 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103068 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103073 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103078 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103083 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 103086 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103088 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103091 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103095 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103098 */       GIR_RootConstrainSelectedInstOperands,
     /* 103099 */       // GIR_Coverage, 6416,
     /* 103099 */       GIR_EraseRootFromParent_Done,
     /* 103100 */     // Label 1582: @103100
     /* 103100 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103217), // Rule ID 2500 //
     /* 103105 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103108 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103112 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103116 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103120 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103123 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 103128 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103132 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103136 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103141 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103146 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103148 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103148 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103151 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103155 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103160 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103162 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103165 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103169 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103174 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103177 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103181 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103184 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103189 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103194 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103199 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 103202 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103204 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103207 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103211 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103215 */       GIR_RootConstrainSelectedInstOperands,
     /* 103216 */       // GIR_Coverage, 2500,
     /* 103216 */       GIR_EraseRootFromParent_Done,
     /* 103217 */     // Label 1583: @103217
     /* 103217 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103334), // Rule ID 5394 //
     /* 103222 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103225 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103229 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103233 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103237 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103240 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 103245 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103249 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103253 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103258 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103263 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103265 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103265 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103268 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103272 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103277 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103279 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103282 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103286 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103291 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103294 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103298 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103301 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103306 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103311 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103316 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 103319 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103321 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103324 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103328 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103332 */       GIR_RootConstrainSelectedInstOperands,
     /* 103333 */       // GIR_Coverage, 5394,
     /* 103333 */       GIR_EraseRootFromParent_Done,
     /* 103334 */     // Label 1584: @103334
     /* 103334 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103451), // Rule ID 5397 //
     /* 103339 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103342 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103346 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103350 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103354 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103357 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 103362 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103366 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103370 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103375 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103380 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103382 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103382 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103385 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103389 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103394 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103396 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103399 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103403 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103408 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103411 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103415 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103418 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103423 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103428 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103433 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 103436 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103438 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103441 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103445 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103449 */       GIR_RootConstrainSelectedInstOperands,
     /* 103450 */       // GIR_Coverage, 5397,
     /* 103450 */       GIR_EraseRootFromParent_Done,
     /* 103451 */     // Label 1585: @103451
     /* 103451 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103568), // Rule ID 5400 //
     /* 103456 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103459 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103463 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103467 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103471 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103474 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103479 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103483 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103487 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103492 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103497 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103499 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103499 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103502 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103506 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103511 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103513 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103516 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103520 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103525 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103528 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103532 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103535 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103550 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 103553 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103555 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103558 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103562 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103566 */       GIR_RootConstrainSelectedInstOperands,
     /* 103567 */       // GIR_Coverage, 5400,
     /* 103567 */       GIR_EraseRootFromParent_Done,
     /* 103568 */     // Label 1586: @103568
     /* 103568 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103669), // Rule ID 4977 //
     /* 103573 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103577 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103581 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103585 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 103588 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 103593 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103597 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103602 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103604 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103604 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103607 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103611 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103616 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103618 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103621 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103625 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103630 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103633 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103637 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103640 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103645 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103650 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103655 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103658 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103660 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103663 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103667 */       GIR_RootConstrainSelectedInstOperands,
     /* 103668 */       // GIR_Coverage, 4977,
     /* 103668 */       GIR_EraseRootFromParent_Done,
     /* 103669 */     // Label 1587: @103669
     /* 103669 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(103725), // Rule ID 5549 //
     /* 103674 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103678 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103682 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103686 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103691 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 103695 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103699 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103703 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103708 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103710 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 103710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 103713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103715 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 103719 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 103723 */       GIR_RootConstrainSelectedInstOperands,
     /* 103724 */       // GIR_Coverage, 5549,
     /* 103724 */       GIR_EraseRootFromParent_Done,
     /* 103725 */     // Label 1588: @103725
     /* 103725 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(103791), // Rule ID 5872 //
     /* 103730 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103734 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103738 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103744 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103746 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103748 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 103748 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103751 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103755 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103760 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103764 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103766 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103769 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103771 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103777 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103780 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103785 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103790 */       // GIR_Coverage, 5872,
     /* 103790 */       GIR_EraseRootFromParent_Done,
     /* 103791 */     // Label 1589: @103791
     /* 103791 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(103857), // Rule ID 5876 //
     /* 103796 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103804 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103810 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103814 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 103814 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103817 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103821 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103826 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103830 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103832 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103835 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103840 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103843 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103846 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103851 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103856 */       // GIR_Coverage, 5876,
     /* 103856 */       GIR_EraseRootFromParent_Done,
     /* 103857 */     // Label 1590: @103857
     /* 103857 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(103950), // Rule ID 4985 //
     /* 103862 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103866 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103870 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 103874 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103883 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103885 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103918 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103948 */       GIR_RootConstrainSelectedInstOperands,
     /* 103949 */       // GIR_Coverage, 4985,
     /* 103949 */       GIR_EraseRootFromParent_Done,
     /* 103950 */     // Label 1591: @103950
     /* 103950 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104046), // Rule ID 5029 //
     /* 103955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103958 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103962 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103966 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103970 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103979 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103981 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 103981 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103984 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103988 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103993 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103995 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103998 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104002 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104007 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104010 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104014 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104017 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104022 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104027 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104032 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 104035 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104037 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104040 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104044 */       GIR_RootConstrainSelectedInstOperands,
     /* 104045 */       // GIR_Coverage, 5029,
     /* 104045 */       GIR_EraseRootFromParent_Done,
     /* 104046 */     // Label 1592: @104046
     /* 104046 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104108), // Rule ID 5873 //
     /* 104051 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104055 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104059 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104063 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104065 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 104065 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 104068 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104072 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104077 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104079 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104082 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104084 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104087 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104089 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104092 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104097 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104102 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104107 */       // GIR_Coverage, 5873,
     /* 104107 */       GIR_EraseRootFromParent_Done,
     /* 104108 */     // Label 1593: @104108
     /* 104108 */     GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104170), // Rule ID 5877 //
     /* 104113 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104117 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104121 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104125 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104127 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 104127 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 104130 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104134 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104141 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104144 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104146 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104149 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104151 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104154 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104159 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104164 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104169 */       // GIR_Coverage, 5877,
     /* 104169 */       GIR_EraseRootFromParent_Done,
     /* 104170 */     // Label 1594: @104170
     /* 104170 */     GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104304), // Rule ID 5871 //
     /* 104175 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104179 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104183 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104183 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104186 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104190 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104195 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104197 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104200 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104204 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104209 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104212 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104216 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104219 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104224 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104229 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104234 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104237 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104241 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104246 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104248 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104251 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104255 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104260 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104263 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104267 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104275 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104280 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104290 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104293 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104296 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104299 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104302 */       GIR_RootConstrainSelectedInstOperands,
     /* 104303 */       // GIR_Coverage, 5871,
     /* 104303 */       GIR_EraseRootFromParent_Done,
     /* 104304 */     // Label 1595: @104304
     /* 104304 */     GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104438), // Rule ID 5875 //
     /* 104309 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104313 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104317 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104317 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104320 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104324 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104329 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104331 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104334 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104338 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104343 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104346 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104350 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104353 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104358 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104363 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104368 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104371 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104375 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104380 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104382 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104385 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104389 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104394 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104397 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104401 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104404 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104409 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104414 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104419 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104422 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104424 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104427 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104430 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104433 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104436 */       GIR_RootConstrainSelectedInstOperands,
     /* 104437 */       // GIR_Coverage, 5875,
     /* 104437 */       GIR_EraseRootFromParent_Done,
     /* 104438 */     // Label 1596: @104438
     /* 104438 */     GIM_Reject,
     /* 104439 */   // Label 1572: @104439
     /* 104439 */   GIM_Reject,
     /* 104440 */   // Label 1531: @104440
     /* 104440 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106350),
     /* 104445 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104455 */     GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104584), // Rule ID 5467 //
     /* 104460 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104464 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104468 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104472 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104476 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104480 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104484 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104488 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104492 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 104496 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104500 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104504 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104509 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 104513 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104519 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 104521 */       // MIs[2] Operand 2
     /* 104521 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104532 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104534 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 104534 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104537 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104541 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104546 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104549 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104553 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104556 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104561 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104566 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104569 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104571 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104574 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104578 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104582 */       GIR_RootConstrainSelectedInstOperands,
     /* 104583 */       // GIR_Coverage, 5467,
     /* 104583 */       GIR_EraseRootFromParent_Done,
     /* 104584 */     // Label 1598: @104584
     /* 104584 */     GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104706), // Rule ID 5463 //
     /* 104589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104617 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104621 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 104625 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104629 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104633 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104638 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104643 */       // MIs[2] Operand 2
     /* 104643 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104654 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104656 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104656 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104659 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104663 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104668 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104671 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104675 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104678 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104683 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104688 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 104691 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104693 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104696 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104700 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104704 */       GIR_RootConstrainSelectedInstOperands,
     /* 104705 */       // GIR_Coverage, 5463,
     /* 104705 */       GIR_EraseRootFromParent_Done,
     /* 104706 */     // Label 1599: @104706
     /* 104706 */     GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(104828), // Rule ID 5465 //
     /* 104711 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104715 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104719 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104723 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104727 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104731 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104735 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104739 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104743 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 104747 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104751 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104755 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104760 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104765 */       // MIs[2] Operand 2
     /* 104765 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104776 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104778 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104778 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104781 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104785 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104790 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104793 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104797 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104815 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104818 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104822 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104826 */       GIR_RootConstrainSelectedInstOperands,
     /* 104827 */       // GIR_Coverage, 5465,
     /* 104827 */       GIR_EraseRootFromParent_Done,
     /* 104828 */     // Label 1600: @104828
     /* 104828 */     GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(104930), // Rule ID 5623 //
     /* 104833 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104837 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104841 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104845 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104849 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104853 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104857 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104862 */       // MIs[2] Operand 2
     /* 104862 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104873 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 104877 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104881 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104885 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 104889 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104893 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104897 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104902 */       // MIs[4] Operand 2
     /* 104902 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 104913 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104915 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104915 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 104918 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104920 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 104924 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 104928 */       GIR_RootConstrainSelectedInstOperands,
     /* 104929 */       // GIR_Coverage, 5623,
     /* 104929 */       GIR_EraseRootFromParent_Done,
     /* 104930 */     // Label 1601: @104930
     /* 104930 */     GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(105059), // Rule ID 6409 //
     /* 104935 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104939 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104943 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104947 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104950 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104955 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104959 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104963 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104968 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 104972 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104974 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 104974 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 104977 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 104981 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104986 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104989 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104991 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104994 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104998 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105003 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105005 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105008 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105012 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105017 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105020 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 105024 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105027 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105032 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105037 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105042 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 105045 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105047 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105050 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105057 */       GIR_RootConstrainSelectedInstOperands,
     /* 105058 */       // GIR_Coverage, 6409,
     /* 105058 */       GIR_EraseRootFromParent_Done,
     /* 105059 */     // Label 1602: @105059
     /* 105059 */     GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(105101), // Rule ID 5882 //
     /* 105064 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 105071 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 105078 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 105078 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 105081 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105083 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 105088 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105091 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105096 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105099 */       GIR_RootConstrainSelectedInstOperands,
     /* 105100 */       // GIR_Coverage, 5882,
     /* 105100 */       GIR_EraseRootFromParent_Done,
     /* 105101 */     // Label 1603: @105101
     /* 105101 */     GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(105224), // Rule ID 2574 //
     /* 105106 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105109 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105113 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105117 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105121 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105124 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 105129 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105133 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105137 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105142 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 105146 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105150 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105154 */       // MIs[2] Operand 1
     /* 105154 */       // No operand predicates
     /* 105154 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105156 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105156 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105159 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105163 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105168 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105170 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105173 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105177 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105182 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105185 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105189 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105192 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105197 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105202 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105207 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 105210 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105212 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105215 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105219 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 105222 */       GIR_RootConstrainSelectedInstOperands,
     /* 105223 */       // GIR_Coverage, 2574,
     /* 105223 */       GIR_EraseRootFromParent_Done,
     /* 105224 */     // Label 1604: @105224
     /* 105224 */     GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(105347), // Rule ID 6379 //
     /* 105229 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105232 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105236 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105240 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105244 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105248 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 105252 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 105256 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105260 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105265 */       // MIs[2] imm
     /* 105265 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105269 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105273 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105277 */       // MIs[3] Operand 1
     /* 105277 */       // No operand predicates
     /* 105277 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105279 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105279 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105282 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105286 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105291 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105293 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105296 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105300 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105305 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105308 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105312 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105330 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 105333 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105335 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105338 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 105342 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 105345 */       GIR_RootConstrainSelectedInstOperands,
     /* 105346 */       // GIR_Coverage, 6379,
     /* 105346 */       GIR_EraseRootFromParent_Done,
     /* 105347 */     // Label 1605: @105347
     /* 105347 */     GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(105467), // Rule ID 6415 //
     /* 105352 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105356 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105360 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105364 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105368 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 105372 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 105376 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105380 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105385 */       // MIs[2] imm
     /* 105385 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105389 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105393 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105397 */       // MIs[3] Operand 1
     /* 105397 */       // No operand predicates
     /* 105397 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105399 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105399 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105402 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105406 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105411 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105413 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105416 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105420 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105425 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105428 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105432 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105445 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105450 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 105453 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105455 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105458 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 105462 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 105465 */       GIR_RootConstrainSelectedInstOperands,
     /* 105466 */       // GIR_Coverage, 6415,
     /* 105466 */       GIR_EraseRootFromParent_Done,
     /* 105467 */     // Label 1606: @105467
     /* 105467 */     GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(105584), // Rule ID 2499 //
     /* 105472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105475 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105479 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105483 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105487 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105490 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 105495 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105499 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105503 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105508 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105513 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105515 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105515 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105518 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105522 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105527 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105529 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105532 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105536 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105541 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105544 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105548 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105556 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105561 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105566 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 105569 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105571 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105574 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105578 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105582 */       GIR_RootConstrainSelectedInstOperands,
     /* 105583 */       // GIR_Coverage, 2499,
     /* 105583 */       GIR_EraseRootFromParent_Done,
     /* 105584 */     // Label 1607: @105584
     /* 105584 */     GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105701), // Rule ID 5393 //
     /* 105589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105596 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105600 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105604 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105607 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 105612 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105616 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105620 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105625 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105630 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105632 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105632 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105635 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105639 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105644 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105646 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105649 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105653 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105658 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105661 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105665 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105668 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105673 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105678 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105683 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 105686 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105688 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105691 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105699 */       GIR_RootConstrainSelectedInstOperands,
     /* 105700 */       // GIR_Coverage, 5393,
     /* 105700 */       GIR_EraseRootFromParent_Done,
     /* 105701 */     // Label 1608: @105701
     /* 105701 */     GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(105818), // Rule ID 5396 //
     /* 105706 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105721 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105724 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 105729 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105733 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105737 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105742 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105747 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105749 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105749 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105752 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105756 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105761 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105763 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105766 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105770 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105775 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105778 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105782 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105785 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105790 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105795 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105800 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 105803 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105805 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105808 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105812 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105816 */       GIR_RootConstrainSelectedInstOperands,
     /* 105817 */       // GIR_Coverage, 5396,
     /* 105817 */       GIR_EraseRootFromParent_Done,
     /* 105818 */     // Label 1609: @105818
     /* 105818 */     GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(105935), // Rule ID 5399 //
     /* 105823 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105826 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105830 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105834 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105838 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105841 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 105846 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105850 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105854 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105859 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105864 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105866 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105866 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105869 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105873 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105878 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105880 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105883 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105887 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105892 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105895 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105899 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105902 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105907 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105912 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 105920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105922 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105925 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105929 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105933 */       GIR_RootConstrainSelectedInstOperands,
     /* 105934 */       // GIR_Coverage, 5399,
     /* 105934 */       GIR_EraseRootFromParent_Done,
     /* 105935 */     // Label 1610: @105935
     /* 105935 */     GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(105991), // Rule ID 5540 //
     /* 105940 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105944 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105948 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105952 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105957 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 105961 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105965 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105969 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105974 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105976 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 105976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 105979 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105981 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 105985 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 105989 */       GIR_RootConstrainSelectedInstOperands,
     /* 105990 */       // GIR_Coverage, 5540,
     /* 105990 */       GIR_EraseRootFromParent_Done,
     /* 105991 */     // Label 1611: @105991
     /* 105991 */     GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(106057), // Rule ID 5880 //
     /* 105996 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106000 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106004 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 106010 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 106012 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106014 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 106014 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106017 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 106021 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106026 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 106030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106032 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106035 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106037 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106040 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 106046 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106051 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106056 */       // GIR_Coverage, 5880,
     /* 106056 */       GIR_EraseRootFromParent_Done,
     /* 106057 */     // Label 1612: @106057
     /* 106057 */     GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(106153), // Rule ID 5028 //
     /* 106062 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 106065 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106069 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106073 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 106077 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 106081 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106086 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106088 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 106088 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 106091 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106095 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106100 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106102 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 106105 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106109 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106114 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106117 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 106121 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 106124 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106129 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106139 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 106142 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106144 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106147 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 106151 */       GIR_RootConstrainSelectedInstOperands,
     /* 106152 */       // GIR_Coverage, 5028,
     /* 106152 */       GIR_EraseRootFromParent_Done,
     /* 106153 */     // Label 1613: @106153
     /* 106153 */     GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(106215), // Rule ID 5881 //
     /* 106158 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106162 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106166 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 106170 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106172 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 106172 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 106175 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106179 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106184 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106186 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106189 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106191 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106194 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 106196 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 106199 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106204 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106209 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106214 */       // GIR_Coverage, 5881,
     /* 106214 */       GIR_EraseRootFromParent_Done,
     /* 106215 */     // Label 1614: @106215
     /* 106215 */     GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(106349), // Rule ID 5879 //
     /* 106220 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106224 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106228 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 106228 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 106231 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106235 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106240 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106242 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 106245 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106249 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106254 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106257 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 106261 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 106264 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106269 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106274 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106279 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 106282 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106286 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106291 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106293 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 106296 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106300 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106305 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106308 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 106312 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 106315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106330 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 106333 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106335 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106338 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106341 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 106344 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106347 */       GIR_RootConstrainSelectedInstOperands,
     /* 106348 */       // GIR_Coverage, 5879,
     /* 106348 */       GIR_EraseRootFromParent_Done,
     /* 106349 */     // Label 1615: @106349
     /* 106349 */     GIM_Reject,
     /* 106350 */   // Label 1597: @106350
     /* 106350 */   GIM_Reject,
     /* 106351 */   // Label 1532: @106351
     /* 106351 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(106376), // Rule ID 9194 //
     /* 106356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106359 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 106362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 106365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106369 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 106369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 106374 */     GIR_RootConstrainSelectedInstOperands,
     /* 106375 */     // GIR_Coverage, 9194,
     /* 106375 */     GIR_Done,
     /* 106376 */   // Label 1616: @106376
     /* 106376 */   GIM_Reject,
     /* 106377 */   // Label 1533: @106377
     /* 106377 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(106402), // Rule ID 9195 //
     /* 106382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106385 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 106388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 106391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106395 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 106395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 106400 */     GIR_RootConstrainSelectedInstOperands,
     /* 106401 */     // GIR_Coverage, 9195,
     /* 106401 */     GIR_Done,
     /* 106402 */   // Label 1617: @106402
     /* 106402 */   GIM_Reject,
     /* 106403 */   // Label 1534: @106403
     /* 106403 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(106428), // Rule ID 9198 //
     /* 106408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106411 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 106414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 106417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106421 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 106421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106426 */     GIR_RootConstrainSelectedInstOperands,
     /* 106427 */     // GIR_Coverage, 9198,
     /* 106427 */     GIR_Done,
     /* 106428 */   // Label 1618: @106428
     /* 106428 */   GIM_Reject,
     /* 106429 */   // Label 1535: @106429
     /* 106429 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(106454), // Rule ID 9200 //
     /* 106434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106437 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 106440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 106443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106447 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 106447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106452 */     GIR_RootConstrainSelectedInstOperands,
     /* 106453 */     // GIR_Coverage, 9200,
     /* 106453 */     GIR_Done,
     /* 106454 */   // Label 1619: @106454
     /* 106454 */   GIM_Reject,
     /* 106455 */   // Label 1536: @106455
     /* 106455 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(106480), // Rule ID 9196 //
     /* 106460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106463 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 106466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 106469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106473 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 106473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 106478 */     GIR_RootConstrainSelectedInstOperands,
     /* 106479 */     // GIR_Coverage, 9196,
     /* 106479 */     GIR_Done,
     /* 106480 */   // Label 1620: @106480
     /* 106480 */   GIM_Reject,
     /* 106481 */   // Label 1537: @106481
     /* 106481 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(106506), // Rule ID 9199 //
     /* 106486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106489 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 106492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 106495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106499 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 106499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 106504 */     GIR_RootConstrainSelectedInstOperands,
     /* 106505 */     // GIR_Coverage, 9199,
     /* 106505 */     GIR_Done,
     /* 106506 */   // Label 1621: @106506
     /* 106506 */   GIM_Reject,
     /* 106507 */   // Label 1538: @106507
     /* 106507 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(106532), // Rule ID 9197 //
     /* 106512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106515 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 106518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 106521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106525 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 106525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 106530 */     GIR_RootConstrainSelectedInstOperands,
     /* 106531 */     // GIR_Coverage, 9197,
     /* 106531 */     GIR_Done,
     /* 106532 */   // Label 1622: @106532
     /* 106532 */   GIM_Reject,
     /* 106533 */   // Label 1539: @106533
     /* 106533 */   GIM_Reject,
     /* 106534 */ // Label 1527: @106534
     /* 106534 */ GIM_Reject,
     /* 106535 */ // Label 9: @106535
     /* 106535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1637*/ GIMT_Encode4(116616),
     /* 106546 */ /*GILLT_s32*//*Label 1623*/ GIMT_Encode4(106634),
     /* 106550 */ /*GILLT_s64*//*Label 1624*/ GIMT_Encode4(107137),
     /* 106554 */ /*GILLT_s128*//*Label 1625*/ GIMT_Encode4(109128),
     /* 106558 */ /*GILLT_v2s32*//*Label 1626*/ GIMT_Encode4(109774),
     /* 106562 */ /*GILLT_v2s64*//*Label 1627*/ GIMT_Encode4(110689),
     /* 106566 */ /*GILLT_v4s16*//*Label 1628*/ GIMT_Encode4(111458),
     /* 106570 */ /*GILLT_v4s32*//*Label 1629*/ GIMT_Encode4(112373),
     /* 106574 */ /*GILLT_v8s8*//*Label 1630*/ GIMT_Encode4(113218),
     /* 106578 */ /*GILLT_v8s16*//*Label 1631*/ GIMT_Encode4(113779),
     /* 106582 */ /*GILLT_v16s8*//*Label 1632*/ GIMT_Encode4(114624), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106602 */ /*GILLT_nxv2s64*//*Label 1633*/ GIMT_Encode4(115076), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106614 */ /*GILLT_nxv4s32*//*Label 1634*/ GIMT_Encode4(115525), GIMT_Encode4(0),
     /* 106622 */ /*GILLT_nxv8s16*//*Label 1635*/ GIMT_Encode4(115974), GIMT_Encode4(0),
     /* 106630 */ /*GILLT_nxv16s8*//*Label 1636*/ GIMT_Encode4(116423),
     /* 106634 */ // Label 1623: @106634
     /* 106634 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(107136),
     /* 106639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106642 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106716), // Rule ID 7146 //
     /* 106647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106659 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106666 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106673 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106689 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 106689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 106692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106714 */     GIR_RootConstrainSelectedInstOperands,
     /* 106715 */     // GIR_Coverage, 7146,
     /* 106715 */     GIR_EraseRootFromParent_Done,
     /* 106716 */   // Label 1639: @106716
     /* 106716 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106790), // Rule ID 7147 //
     /* 106721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106733 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106740 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106747 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106763 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 106763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 106766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106788 */     GIR_RootConstrainSelectedInstOperands,
     /* 106789 */     // GIR_Coverage, 7147,
     /* 106789 */     GIR_EraseRootFromParent_Done,
     /* 106790 */   // Label 1640: @106790
     /* 106790 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106859), // Rule ID 7148 //
     /* 106795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106807 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106814 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106821 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 106837 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 106840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106857 */     GIR_RootConstrainSelectedInstOperands,
     /* 106858 */     // GIR_Coverage, 7148,
     /* 106858 */     GIR_EraseRootFromParent_Done,
     /* 106859 */   // Label 1641: @106859
     /* 106859 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106928), // Rule ID 7149 //
     /* 106864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106876 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106883 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106890 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106893 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 106906 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 106909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106926 */     GIR_RootConstrainSelectedInstOperands,
     /* 106927 */     // GIR_Coverage, 7149,
     /* 106927 */     GIR_EraseRootFromParent_Done,
     /* 106928 */   // Label 1642: @106928
     /* 106928 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106981), // Rule ID 5841 //
     /* 106933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 106949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106959 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 106959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106964 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 106970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106980 */     // GIR_Coverage, 5841,
     /* 106980 */     GIR_EraseRootFromParent_Done,
     /* 106981 */   // Label 1643: @106981
     /* 106981 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(107034), // Rule ID 5842 //
     /* 106986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107006 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107012 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 107012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107017 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 107023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 107028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107033 */     // GIR_Coverage, 5842,
     /* 107033 */     GIR_EraseRootFromParent_Done,
     /* 107034 */   // Label 1644: @107034
     /* 107034 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(107087), // Rule ID 5843 //
     /* 107039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 107043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107059 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107065 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 107065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107070 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 107076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 107081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107086 */     // GIR_Coverage, 5843,
     /* 107086 */     GIR_EraseRootFromParent_Done,
     /* 107087 */   // Label 1645: @107087
     /* 107087 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(107111), // Rule ID 6751 //
     /* 107092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 107096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107100 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 107100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 107110 */     // GIR_Coverage, 6751,
     /* 107110 */     GIR_Done,
     /* 107111 */   // Label 1646: @107111
     /* 107111 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(107135), // Rule ID 6752 //
     /* 107116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 107124 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 107124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107134 */     // GIR_Coverage, 6752,
     /* 107134 */     GIR_Done,
     /* 107135 */   // Label 1647: @107135
     /* 107135 */   GIM_Reject,
     /* 107136 */ // Label 1638: @107136
     /* 107136 */ GIM_Reject,
     /* 107137 */ // Label 1624: @107137
     /* 107137 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(107214), // Rule ID 7150 //
     /* 107142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 107157 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107160 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107164 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107171 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107174 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107180 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 107187 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 107187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 107190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107212 */   GIR_RootConstrainSelectedInstOperands,
     /* 107213 */   // GIR_Coverage, 7150,
     /* 107213 */   GIR_EraseRootFromParent_Done,
     /* 107214 */ // Label 1648: @107214
     /* 107214 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107291), // Rule ID 7151 //
     /* 107219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 107234 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107237 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107241 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107248 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107251 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107257 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 107264 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 107264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 107267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107289 */   GIR_RootConstrainSelectedInstOperands,
     /* 107290 */   // GIR_Coverage, 7151,
     /* 107290 */   GIR_EraseRootFromParent_Done,
     /* 107291 */ // Label 1649: @107291
     /* 107291 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107363), // Rule ID 7152 //
     /* 107296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 107311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107314 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107318 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107325 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107328 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107334 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 107341 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 107341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 107344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107361 */   GIR_RootConstrainSelectedInstOperands,
     /* 107362 */   // GIR_Coverage, 7152,
     /* 107362 */   GIR_EraseRootFromParent_Done,
     /* 107363 */ // Label 1650: @107363
     /* 107363 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107435), // Rule ID 7153 //
     /* 107368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 107383 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107386 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107390 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107397 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107400 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107404 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107406 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 107413 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 107416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107433 */   GIR_RootConstrainSelectedInstOperands,
     /* 107434 */   // GIR_Coverage, 7153,
     /* 107434 */   GIR_EraseRootFromParent_Done,
     /* 107435 */ // Label 1651: @107435
     /* 107435 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107491), // Rule ID 5844 //
     /* 107440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107455 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107463 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107469 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 107469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107474 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 107480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107490 */   // GIR_Coverage, 5844,
     /* 107490 */   GIR_EraseRootFromParent_Done,
     /* 107491 */ // Label 1652: @107491
     /* 107491 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107521), // Rule ID 6726 //
     /* 107496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107510 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 107510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107520 */   // GIR_Coverage, 6726,
     /* 107520 */   GIR_Done,
     /* 107521 */ // Label 1653: @107521
     /* 107521 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107551), // Rule ID 6727 //
     /* 107526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107540 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 107540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107550 */   // GIR_Coverage, 6727,
     /* 107550 */   GIR_Done,
     /* 107551 */ // Label 1654: @107551
     /* 107551 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107581), // Rule ID 6728 //
     /* 107556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107570 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 107570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107580 */   // GIR_Coverage, 6728,
     /* 107580 */   GIR_Done,
     /* 107581 */ // Label 1655: @107581
     /* 107581 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107611), // Rule ID 6729 //
     /* 107586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107600 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 107600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107610 */   // GIR_Coverage, 6729,
     /* 107610 */   GIR_Done,
     /* 107611 */ // Label 1656: @107611
     /* 107611 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107641), // Rule ID 6730 //
     /* 107616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107630 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 107630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107640 */   // GIR_Coverage, 6730,
     /* 107640 */   GIR_Done,
     /* 107641 */ // Label 1657: @107641
     /* 107641 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107671), // Rule ID 6731 //
     /* 107646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107660 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107670 */   // GIR_Coverage, 6731,
     /* 107670 */   GIR_Done,
     /* 107671 */ // Label 1658: @107671
     /* 107671 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107721), // Rule ID 6737 //
     /* 107676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107690 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 107690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107702 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107719 */   GIR_RootConstrainSelectedInstOperands,
     /* 107720 */   // GIR_Coverage, 6737,
     /* 107720 */   GIR_EraseRootFromParent_Done,
     /* 107721 */ // Label 1659: @107721
     /* 107721 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107771), // Rule ID 6738 //
     /* 107726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107740 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107769 */   GIR_RootConstrainSelectedInstOperands,
     /* 107770 */   // GIR_Coverage, 6738,
     /* 107770 */   GIR_EraseRootFromParent_Done,
     /* 107771 */ // Label 1660: @107771
     /* 107771 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107821), // Rule ID 6739 //
     /* 107776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107790 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107802 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107806 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107819 */   GIR_RootConstrainSelectedInstOperands,
     /* 107820 */   // GIR_Coverage, 6739,
     /* 107820 */   GIR_EraseRootFromParent_Done,
     /* 107821 */ // Label 1661: @107821
     /* 107821 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(107871), // Rule ID 6740 //
     /* 107826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107840 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107852 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107856 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107869 */   GIR_RootConstrainSelectedInstOperands,
     /* 107870 */   // GIR_Coverage, 6740,
     /* 107870 */   GIR_EraseRootFromParent_Done,
     /* 107871 */ // Label 1662: @107871
     /* 107871 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(107921), // Rule ID 6741 //
     /* 107876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107890 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107919 */   GIR_RootConstrainSelectedInstOperands,
     /* 107920 */   // GIR_Coverage, 6741,
     /* 107920 */   GIR_EraseRootFromParent_Done,
     /* 107921 */ // Label 1663: @107921
     /* 107921 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(107948), // Rule ID 6742 //
     /* 107926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107937 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107947 */   // GIR_Coverage, 6742,
     /* 107947 */   GIR_Done,
     /* 107948 */ // Label 1664: @107948
     /* 107948 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(107975), // Rule ID 6743 //
     /* 107953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107964 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107974 */   // GIR_Coverage, 6743,
     /* 107974 */   GIR_Done,
     /* 107975 */ // Label 1665: @107975
     /* 107975 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(108002), // Rule ID 6744 //
     /* 107980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107991 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 107991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107996 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108001 */   // GIR_Coverage, 6744,
     /* 108001 */   GIR_Done,
     /* 108002 */ // Label 1666: @108002
     /* 108002 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(108029), // Rule ID 6753 //
     /* 108007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108018 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 108018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108023 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108028 */   // GIR_Coverage, 6753,
     /* 108028 */   GIR_Done,
     /* 108029 */ // Label 1667: @108029
     /* 108029 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(108056), // Rule ID 6754 //
     /* 108034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108045 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 108045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108055 */   // GIR_Coverage, 6754,
     /* 108055 */   GIR_Done,
     /* 108056 */ // Label 1668: @108056
     /* 108056 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(108083), // Rule ID 6755 //
     /* 108061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108072 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 108072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108082 */   // GIR_Coverage, 6755,
     /* 108082 */   GIR_Done,
     /* 108083 */ // Label 1669: @108083
     /* 108083 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(108115), // Rule ID 6756 //
     /* 108088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108102 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108114 */   // GIR_Coverage, 6756,
     /* 108114 */   GIR_EraseRootFromParent_Done,
     /* 108115 */ // Label 1670: @108115
     /* 108115 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(108147), // Rule ID 6757 //
     /* 108120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108134 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108146 */   // GIR_Coverage, 6757,
     /* 108146 */   GIR_EraseRootFromParent_Done,
     /* 108147 */ // Label 1671: @108147
     /* 108147 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(108179), // Rule ID 6758 //
     /* 108152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108166 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108178 */   // GIR_Coverage, 6758,
     /* 108178 */   GIR_EraseRootFromParent_Done,
     /* 108179 */ // Label 1672: @108179
     /* 108179 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(108211), // Rule ID 6759 //
     /* 108184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108198 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108210 */   // GIR_Coverage, 6759,
     /* 108210 */   GIR_EraseRootFromParent_Done,
     /* 108211 */ // Label 1673: @108211
     /* 108211 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(108243), // Rule ID 6760 //
     /* 108216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108230 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108242 */   // GIR_Coverage, 6760,
     /* 108242 */   GIR_EraseRootFromParent_Done,
     /* 108243 */ // Label 1674: @108243
     /* 108243 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(108269), // Rule ID 6761 //
     /* 108248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108262 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 108262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108267 */   GIR_RootConstrainSelectedInstOperands,
     /* 108268 */   // GIR_Coverage, 6761,
     /* 108268 */   GIR_Done,
     /* 108269 */ // Label 1675: @108269
     /* 108269 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(108295), // Rule ID 6762 //
     /* 108274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108288 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 108288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108293 */   GIR_RootConstrainSelectedInstOperands,
     /* 108294 */   // GIR_Coverage, 6762,
     /* 108294 */   GIR_Done,
     /* 108295 */ // Label 1676: @108295
     /* 108295 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(108321), // Rule ID 6763 //
     /* 108300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108314 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 108314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108319 */   GIR_RootConstrainSelectedInstOperands,
     /* 108320 */   // GIR_Coverage, 6763,
     /* 108320 */   GIR_Done,
     /* 108321 */ // Label 1677: @108321
     /* 108321 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(108347), // Rule ID 6764 //
     /* 108326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108340 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 108340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108345 */   GIR_RootConstrainSelectedInstOperands,
     /* 108346 */   // GIR_Coverage, 6764,
     /* 108346 */   GIR_Done,
     /* 108347 */ // Label 1678: @108347
     /* 108347 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(108373), // Rule ID 6765 //
     /* 108352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108366 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 108366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108371 */   GIR_RootConstrainSelectedInstOperands,
     /* 108372 */   // GIR_Coverage, 6765,
     /* 108372 */   GIR_Done,
     /* 108373 */ // Label 1679: @108373
     /* 108373 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(108402), // Rule ID 6766 //
     /* 108378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108389 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108401 */   // GIR_Coverage, 6766,
     /* 108401 */   GIR_EraseRootFromParent_Done,
     /* 108402 */ // Label 1680: @108402
     /* 108402 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(108431), // Rule ID 6767 //
     /* 108407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108418 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108421 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108423 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108430 */   // GIR_Coverage, 6767,
     /* 108430 */   GIR_EraseRootFromParent_Done,
     /* 108431 */ // Label 1681: @108431
     /* 108431 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(108463), // Rule ID 6821 //
     /* 108436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108450 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108453 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108462 */   // GIR_Coverage, 6821,
     /* 108462 */   GIR_EraseRootFromParent_Done,
     /* 108463 */ // Label 1682: @108463
     /* 108463 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(108495), // Rule ID 6822 //
     /* 108468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108482 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108485 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108494 */   // GIR_Coverage, 6822,
     /* 108494 */   GIR_EraseRootFromParent_Done,
     /* 108495 */ // Label 1683: @108495
     /* 108495 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(108527), // Rule ID 6823 //
     /* 108500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108514 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108517 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108519 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108526 */   // GIR_Coverage, 6823,
     /* 108526 */   GIR_EraseRootFromParent_Done,
     /* 108527 */ // Label 1684: @108527
     /* 108527 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(108559), // Rule ID 6824 //
     /* 108532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108546 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108549 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108551 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108558 */   // GIR_Coverage, 6824,
     /* 108558 */   GIR_EraseRootFromParent_Done,
     /* 108559 */ // Label 1685: @108559
     /* 108559 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(108591), // Rule ID 6825 //
     /* 108564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108578 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108581 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108590 */   // GIR_Coverage, 6825,
     /* 108590 */   GIR_EraseRootFromParent_Done,
     /* 108591 */ // Label 1686: @108591
     /* 108591 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(108617), // Rule ID 6826 //
     /* 108596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108610 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108615 */   GIR_RootConstrainSelectedInstOperands,
     /* 108616 */   // GIR_Coverage, 6826,
     /* 108616 */   GIR_Done,
     /* 108617 */ // Label 1687: @108617
     /* 108617 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108643), // Rule ID 6827 //
     /* 108622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108636 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108641 */   GIR_RootConstrainSelectedInstOperands,
     /* 108642 */   // GIR_Coverage, 6827,
     /* 108642 */   GIR_Done,
     /* 108643 */ // Label 1688: @108643
     /* 108643 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108669), // Rule ID 6828 //
     /* 108648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108662 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108667 */   GIR_RootConstrainSelectedInstOperands,
     /* 108668 */   // GIR_Coverage, 6828,
     /* 108668 */   GIR_Done,
     /* 108669 */ // Label 1689: @108669
     /* 108669 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108695), // Rule ID 6829 //
     /* 108674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108688 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108693 */   GIR_RootConstrainSelectedInstOperands,
     /* 108694 */   // GIR_Coverage, 6829,
     /* 108694 */   GIR_Done,
     /* 108695 */ // Label 1690: @108695
     /* 108695 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108721), // Rule ID 6830 //
     /* 108700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108714 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108719 */   GIR_RootConstrainSelectedInstOperands,
     /* 108720 */   // GIR_Coverage, 6830,
     /* 108720 */   GIR_Done,
     /* 108721 */ // Label 1691: @108721
     /* 108721 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108750), // Rule ID 6831 //
     /* 108726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108737 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108749 */   // GIR_Coverage, 6831,
     /* 108749 */   GIR_EraseRootFromParent_Done,
     /* 108750 */ // Label 1692: @108750
     /* 108750 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108779), // Rule ID 6832 //
     /* 108755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108766 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108778 */   // GIR_Coverage, 6832,
     /* 108778 */   GIR_EraseRootFromParent_Done,
     /* 108779 */ // Label 1693: @108779
     /* 108779 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108811), // Rule ID 6833 //
     /* 108784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108798 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108810 */   // GIR_Coverage, 6833,
     /* 108810 */   GIR_EraseRootFromParent_Done,
     /* 108811 */ // Label 1694: @108811
     /* 108811 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108843), // Rule ID 6834 //
     /* 108816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108830 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108842 */   // GIR_Coverage, 6834,
     /* 108842 */   GIR_EraseRootFromParent_Done,
     /* 108843 */ // Label 1695: @108843
     /* 108843 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108875), // Rule ID 6835 //
     /* 108848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108862 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108874 */   // GIR_Coverage, 6835,
     /* 108874 */   GIR_EraseRootFromParent_Done,
     /* 108875 */ // Label 1696: @108875
     /* 108875 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108907), // Rule ID 6836 //
     /* 108880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108894 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108906 */   // GIR_Coverage, 6836,
     /* 108906 */   GIR_EraseRootFromParent_Done,
     /* 108907 */ // Label 1697: @108907
     /* 108907 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108939), // Rule ID 6837 //
     /* 108912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108926 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108938 */   // GIR_Coverage, 6837,
     /* 108938 */   GIR_EraseRootFromParent_Done,
     /* 108939 */ // Label 1698: @108939
     /* 108939 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108965), // Rule ID 6838 //
     /* 108944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108958 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108963 */   GIR_RootConstrainSelectedInstOperands,
     /* 108964 */   // GIR_Coverage, 6838,
     /* 108964 */   GIR_Done,
     /* 108965 */ // Label 1699: @108965
     /* 108965 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108991), // Rule ID 6839 //
     /* 108970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108984 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108989 */   GIR_RootConstrainSelectedInstOperands,
     /* 108990 */   // GIR_Coverage, 6839,
     /* 108990 */   GIR_Done,
     /* 108991 */ // Label 1700: @108991
     /* 108991 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(109017), // Rule ID 6840 //
     /* 108996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109010 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 109010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 109015 */   GIR_RootConstrainSelectedInstOperands,
     /* 109016 */   // GIR_Coverage, 6840,
     /* 109016 */   GIR_Done,
     /* 109017 */ // Label 1701: @109017
     /* 109017 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(109043), // Rule ID 6841 //
     /* 109022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109036 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 109036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109041 */   GIR_RootConstrainSelectedInstOperands,
     /* 109042 */   // GIR_Coverage, 6841,
     /* 109042 */   GIR_Done,
     /* 109043 */ // Label 1702: @109043
     /* 109043 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(109069), // Rule ID 6842 //
     /* 109048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109062 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 109062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109067 */   GIR_RootConstrainSelectedInstOperands,
     /* 109068 */   // GIR_Coverage, 6842,
     /* 109068 */   GIR_Done,
     /* 109069 */ // Label 1703: @109069
     /* 109069 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(109098), // Rule ID 6843 //
     /* 109074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109085 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 109085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109088 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109090 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109097 */   // GIR_Coverage, 6843,
     /* 109097 */   GIR_EraseRootFromParent_Done,
     /* 109098 */ // Label 1704: @109098
     /* 109098 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(109127), // Rule ID 6844 //
     /* 109103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109114 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 109114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109117 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109126 */   // GIR_Coverage, 6844,
     /* 109126 */   GIR_EraseRootFromParent_Done,
     /* 109127 */ // Label 1705: @109127
     /* 109127 */ GIM_Reject,
     /* 109128 */ // Label 1625: @109128
     /* 109128 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(109160), // Rule ID 6858 //
     /* 109133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109147 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109150 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109152 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109159 */   // GIR_Coverage, 6858,
     /* 109159 */   GIR_EraseRootFromParent_Done,
     /* 109160 */ // Label 1706: @109160
     /* 109160 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(109192), // Rule ID 6859 //
     /* 109165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109179 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109184 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109191 */   // GIR_Coverage, 6859,
     /* 109191 */   GIR_EraseRootFromParent_Done,
     /* 109192 */ // Label 1707: @109192
     /* 109192 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(109224), // Rule ID 6860 //
     /* 109197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109211 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109214 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109223 */   // GIR_Coverage, 6860,
     /* 109223 */   GIR_EraseRootFromParent_Done,
     /* 109224 */ // Label 1708: @109224
     /* 109224 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(109256), // Rule ID 6861 //
     /* 109229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109243 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109246 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109248 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109250 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109255 */   // GIR_Coverage, 6861,
     /* 109255 */   GIR_EraseRootFromParent_Done,
     /* 109256 */ // Label 1709: @109256
     /* 109256 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(109288), // Rule ID 6862 //
     /* 109261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109275 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109278 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109280 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109287 */   // GIR_Coverage, 6862,
     /* 109287 */   GIR_EraseRootFromParent_Done,
     /* 109288 */ // Label 1710: @109288
     /* 109288 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(109320), // Rule ID 6863 //
     /* 109293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109307 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109310 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109312 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109319 */   // GIR_Coverage, 6863,
     /* 109319 */   GIR_EraseRootFromParent_Done,
     /* 109320 */ // Label 1711: @109320
     /* 109320 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(109352), // Rule ID 6864 //
     /* 109325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109339 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 109339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109342 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109344 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109346 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109351 */   // GIR_Coverage, 6864,
     /* 109351 */   GIR_EraseRootFromParent_Done,
     /* 109352 */ // Label 1712: @109352
     /* 109352 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109385), // Rule ID 6865 //
     /* 109357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109371 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 109371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109378 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109383 */   GIR_RootConstrainSelectedInstOperands,
     /* 109384 */   // GIR_Coverage, 6865,
     /* 109384 */   GIR_EraseRootFromParent_Done,
     /* 109385 */ // Label 1713: @109385
     /* 109385 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109456), // Rule ID 6866 //
     /* 109390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109404 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 109404 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109407 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109411 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109416 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109454 */   GIR_RootConstrainSelectedInstOperands,
     /* 109455 */   // GIR_Coverage, 6866,
     /* 109455 */   GIR_EraseRootFromParent_Done,
     /* 109456 */ // Label 1714: @109456
     /* 109456 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109527), // Rule ID 6867 //
     /* 109461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109475 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 109475 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109478 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109482 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109487 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109505 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109525 */   GIR_RootConstrainSelectedInstOperands,
     /* 109526 */   // GIR_Coverage, 6867,
     /* 109526 */   GIR_EraseRootFromParent_Done,
     /* 109527 */ // Label 1715: @109527
     /* 109527 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109598), // Rule ID 6868 //
     /* 109532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109546 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 109546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109558 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109596 */   GIR_RootConstrainSelectedInstOperands,
     /* 109597 */   // GIR_Coverage, 6868,
     /* 109597 */   GIR_EraseRootFromParent_Done,
     /* 109598 */ // Label 1716: @109598
     /* 109598 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109631), // Rule ID 6869 //
     /* 109603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109617 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 109617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109624 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109629 */   GIR_RootConstrainSelectedInstOperands,
     /* 109630 */   // GIR_Coverage, 6869,
     /* 109630 */   GIR_EraseRootFromParent_Done,
     /* 109631 */ // Label 1717: @109631
     /* 109631 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109702), // Rule ID 6870 //
     /* 109636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109650 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 109650 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109653 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109657 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109662 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109680 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109700 */   GIR_RootConstrainSelectedInstOperands,
     /* 109701 */   // GIR_Coverage, 6870,
     /* 109701 */   GIR_EraseRootFromParent_Done,
     /* 109702 */ // Label 1718: @109702
     /* 109702 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109773), // Rule ID 6871 //
     /* 109707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109721 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 109721 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109724 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109728 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109733 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109751 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109771 */   GIR_RootConstrainSelectedInstOperands,
     /* 109772 */   // GIR_Coverage, 6871,
     /* 109772 */   GIR_EraseRootFromParent_Done,
     /* 109773 */ // Label 1719: @109773
     /* 109773 */ GIM_Reject,
     /* 109774 */ // Label 1626: @109774
     /* 109774 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109804), // Rule ID 6723 //
     /* 109779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109793 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109803 */   // GIR_Coverage, 6723,
     /* 109803 */   GIR_Done,
     /* 109804 */ // Label 1720: @109804
     /* 109804 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109834), // Rule ID 6725 //
     /* 109809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109823 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109833 */   // GIR_Coverage, 6725,
     /* 109833 */   GIR_Done,
     /* 109834 */ // Label 1721: @109834
     /* 109834 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109884), // Rule ID 6734 //
     /* 109839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109853 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109865 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109882 */   GIR_RootConstrainSelectedInstOperands,
     /* 109883 */   // GIR_Coverage, 6734,
     /* 109883 */   GIR_EraseRootFromParent_Done,
     /* 109884 */ // Label 1722: @109884
     /* 109884 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109934), // Rule ID 6736 //
     /* 109889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109903 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109915 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109932 */   GIR_RootConstrainSelectedInstOperands,
     /* 109933 */   // GIR_Coverage, 6736,
     /* 109933 */   GIR_EraseRootFromParent_Done,
     /* 109934 */ // Label 1723: @109934
     /* 109934 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109966), // Rule ID 6768 //
     /* 109939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109953 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109956 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109958 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109965 */   // GIR_Coverage, 6768,
     /* 109965 */   GIR_EraseRootFromParent_Done,
     /* 109966 */ // Label 1724: @109966
     /* 109966 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109998), // Rule ID 6769 //
     /* 109971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109985 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109988 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109990 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109997 */   // GIR_Coverage, 6769,
     /* 109997 */   GIR_EraseRootFromParent_Done,
     /* 109998 */ // Label 1725: @109998
     /* 109998 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(110030), // Rule ID 6770 //
     /* 110003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110017 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 110017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110029 */   // GIR_Coverage, 6770,
     /* 110029 */   GIR_EraseRootFromParent_Done,
     /* 110030 */ // Label 1726: @110030
     /* 110030 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(110062), // Rule ID 6771 //
     /* 110035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110049 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 110049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110061 */   // GIR_Coverage, 6771,
     /* 110061 */   GIR_EraseRootFromParent_Done,
     /* 110062 */ // Label 1727: @110062
     /* 110062 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(110094), // Rule ID 6772 //
     /* 110067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110081 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 110081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110084 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110086 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110093 */   // GIR_Coverage, 6772,
     /* 110093 */   GIR_EraseRootFromParent_Done,
     /* 110094 */ // Label 1728: @110094
     /* 110094 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(110126), // Rule ID 6773 //
     /* 110099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110113 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 110113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110116 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110118 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110125 */   // GIR_Coverage, 6773,
     /* 110125 */   GIR_EraseRootFromParent_Done,
     /* 110126 */ // Label 1729: @110126
     /* 110126 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(110152), // Rule ID 6774 //
     /* 110131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110145 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 110145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110150 */   GIR_RootConstrainSelectedInstOperands,
     /* 110151 */   // GIR_Coverage, 6774,
     /* 110151 */   GIR_Done,
     /* 110152 */ // Label 1730: @110152
     /* 110152 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(110178), // Rule ID 6775 //
     /* 110157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110171 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 110171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110176 */   GIR_RootConstrainSelectedInstOperands,
     /* 110177 */   // GIR_Coverage, 6775,
     /* 110177 */   GIR_Done,
     /* 110178 */ // Label 1731: @110178
     /* 110178 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(110204), // Rule ID 6776 //
     /* 110183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110197 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 110197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 110202 */   GIR_RootConstrainSelectedInstOperands,
     /* 110203 */   // GIR_Coverage, 6776,
     /* 110203 */   GIR_Done,
     /* 110204 */ // Label 1732: @110204
     /* 110204 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(110230), // Rule ID 6777 //
     /* 110209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110223 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 110223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110228 */   GIR_RootConstrainSelectedInstOperands,
     /* 110229 */   // GIR_Coverage, 6777,
     /* 110229 */   GIR_Done,
     /* 110230 */ // Label 1733: @110230
     /* 110230 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(110256), // Rule ID 6778 //
     /* 110235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110249 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 110249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110254 */   GIR_RootConstrainSelectedInstOperands,
     /* 110255 */   // GIR_Coverage, 6778,
     /* 110255 */   GIR_Done,
     /* 110256 */ // Label 1734: @110256
     /* 110256 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(110282), // Rule ID 6779 //
     /* 110261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110275 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 110275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110280 */   GIR_RootConstrainSelectedInstOperands,
     /* 110281 */   // GIR_Coverage, 6779,
     /* 110281 */   GIR_Done,
     /* 110282 */ // Label 1735: @110282
     /* 110282 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(110311), // Rule ID 6780 //
     /* 110287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110298 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 110298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110301 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110303 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110310 */   // GIR_Coverage, 6780,
     /* 110310 */   GIR_EraseRootFromParent_Done,
     /* 110311 */ // Label 1736: @110311
     /* 110311 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(110343), // Rule ID 6845 //
     /* 110316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110330 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110333 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110342 */   // GIR_Coverage, 6845,
     /* 110342 */   GIR_EraseRootFromParent_Done,
     /* 110343 */ // Label 1737: @110343
     /* 110343 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(110375), // Rule ID 6846 //
     /* 110348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110362 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110365 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110367 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110374 */   // GIR_Coverage, 6846,
     /* 110374 */   GIR_EraseRootFromParent_Done,
     /* 110375 */ // Label 1738: @110375
     /* 110375 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(110407), // Rule ID 6847 //
     /* 110380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110394 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110397 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110406 */   // GIR_Coverage, 6847,
     /* 110406 */   GIR_EraseRootFromParent_Done,
     /* 110407 */ // Label 1739: @110407
     /* 110407 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110439), // Rule ID 6848 //
     /* 110412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110426 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110429 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110431 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110438 */   // GIR_Coverage, 6848,
     /* 110438 */   GIR_EraseRootFromParent_Done,
     /* 110439 */ // Label 1740: @110439
     /* 110439 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110471), // Rule ID 6849 //
     /* 110444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110458 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110461 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110463 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110470 */   // GIR_Coverage, 6849,
     /* 110470 */   GIR_EraseRootFromParent_Done,
     /* 110471 */ // Label 1741: @110471
     /* 110471 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110503), // Rule ID 6850 //
     /* 110476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110490 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110493 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110495 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110502 */   // GIR_Coverage, 6850,
     /* 110502 */   GIR_EraseRootFromParent_Done,
     /* 110503 */ // Label 1742: @110503
     /* 110503 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110529), // Rule ID 6851 //
     /* 110508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110522 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 110522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110527 */   GIR_RootConstrainSelectedInstOperands,
     /* 110528 */   // GIR_Coverage, 6851,
     /* 110528 */   GIR_Done,
     /* 110529 */ // Label 1743: @110529
     /* 110529 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110555), // Rule ID 6852 //
     /* 110534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110548 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 110548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110553 */   GIR_RootConstrainSelectedInstOperands,
     /* 110554 */   // GIR_Coverage, 6852,
     /* 110554 */   GIR_Done,
     /* 110555 */ // Label 1744: @110555
     /* 110555 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110581), // Rule ID 6853 //
     /* 110560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110574 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 110574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 110579 */   GIR_RootConstrainSelectedInstOperands,
     /* 110580 */   // GIR_Coverage, 6853,
     /* 110580 */   GIR_Done,
     /* 110581 */ // Label 1745: @110581
     /* 110581 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110607), // Rule ID 6854 //
     /* 110586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110600 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 110600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110605 */   GIR_RootConstrainSelectedInstOperands,
     /* 110606 */   // GIR_Coverage, 6854,
     /* 110606 */   GIR_Done,
     /* 110607 */ // Label 1746: @110607
     /* 110607 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110633), // Rule ID 6855 //
     /* 110612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110626 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 110626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110631 */   GIR_RootConstrainSelectedInstOperands,
     /* 110632 */   // GIR_Coverage, 6855,
     /* 110632 */   GIR_Done,
     /* 110633 */ // Label 1747: @110633
     /* 110633 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110659), // Rule ID 6856 //
     /* 110638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110652 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 110652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110657 */   GIR_RootConstrainSelectedInstOperands,
     /* 110658 */   // GIR_Coverage, 6856,
     /* 110658 */   GIR_Done,
     /* 110659 */ // Label 1748: @110659
     /* 110659 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110688), // Rule ID 6857 //
     /* 110664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110675 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110687 */   // GIR_Coverage, 6857,
     /* 110687 */   GIR_EraseRootFromParent_Done,
     /* 110688 */ // Label 1749: @110688
     /* 110688 */ GIM_Reject,
     /* 110689 */ // Label 1627: @110689
     /* 110689 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110721), // Rule ID 6872 //
     /* 110694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110708 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // GIR_Coverage, 6872,
     /* 110720 */   GIR_EraseRootFromParent_Done,
     /* 110721 */ // Label 1750: @110721
     /* 110721 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110753), // Rule ID 6873 //
     /* 110726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110740 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110752 */   // GIR_Coverage, 6873,
     /* 110752 */   GIR_EraseRootFromParent_Done,
     /* 110753 */ // Label 1751: @110753
     /* 110753 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110785), // Rule ID 6874 //
     /* 110758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110772 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   // GIR_Coverage, 6874,
     /* 110784 */   GIR_EraseRootFromParent_Done,
     /* 110785 */ // Label 1752: @110785
     /* 110785 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110817), // Rule ID 6875 //
     /* 110790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110804 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110816 */   // GIR_Coverage, 6875,
     /* 110816 */   GIR_EraseRootFromParent_Done,
     /* 110817 */ // Label 1753: @110817
     /* 110817 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110849), // Rule ID 6876 //
     /* 110822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110836 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110848 */   // GIR_Coverage, 6876,
     /* 110848 */   GIR_EraseRootFromParent_Done,
     /* 110849 */ // Label 1754: @110849
     /* 110849 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(110881), // Rule ID 6877 //
     /* 110854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110868 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110880 */   // GIR_Coverage, 6877,
     /* 110880 */   GIR_EraseRootFromParent_Done,
     /* 110881 */ // Label 1755: @110881
     /* 110881 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(110914), // Rule ID 6878 //
     /* 110886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110900 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110912 */   GIR_RootConstrainSelectedInstOperands,
     /* 110913 */   // GIR_Coverage, 6878,
     /* 110913 */   GIR_EraseRootFromParent_Done,
     /* 110914 */ // Label 1756: @110914
     /* 110914 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(110940), // Rule ID 6879 //
     /* 110919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110933 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 110933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110938 */   GIR_RootConstrainSelectedInstOperands,
     /* 110939 */   // GIR_Coverage, 6879,
     /* 110939 */   GIR_Done,
     /* 110940 */ // Label 1757: @110940
     /* 110940 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(110966), // Rule ID 6880 //
     /* 110945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110959 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 110959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110964 */   GIR_RootConstrainSelectedInstOperands,
     /* 110965 */   // GIR_Coverage, 6880,
     /* 110965 */   GIR_Done,
     /* 110966 */ // Label 1758: @110966
     /* 110966 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(110992), // Rule ID 6881 //
     /* 110971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110985 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 110985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110990 */   GIR_RootConstrainSelectedInstOperands,
     /* 110991 */   // GIR_Coverage, 6881,
     /* 110991 */   GIR_Done,
     /* 110992 */ // Label 1759: @110992
     /* 110992 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(111018), // Rule ID 6882 //
     /* 110997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111011 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 111011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 111016 */   GIR_RootConstrainSelectedInstOperands,
     /* 111017 */   // GIR_Coverage, 6882,
     /* 111017 */   GIR_Done,
     /* 111018 */ // Label 1760: @111018
     /* 111018 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(111044), // Rule ID 6883 //
     /* 111023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111037 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 111037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111042 */   GIR_RootConstrainSelectedInstOperands,
     /* 111043 */   // GIR_Coverage, 6883,
     /* 111043 */   GIR_Done,
     /* 111044 */ // Label 1761: @111044
     /* 111044 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(111073), // Rule ID 6884 //
     /* 111049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111060 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 111060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111072 */   // GIR_Coverage, 6884,
     /* 111072 */   GIR_EraseRootFromParent_Done,
     /* 111073 */ // Label 1762: @111073
     /* 111073 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(111105), // Rule ID 6898 //
     /* 111078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111092 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111104 */   // GIR_Coverage, 6898,
     /* 111104 */   GIR_EraseRootFromParent_Done,
     /* 111105 */ // Label 1763: @111105
     /* 111105 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(111137), // Rule ID 6899 //
     /* 111110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111124 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111127 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111136 */   // GIR_Coverage, 6899,
     /* 111136 */   GIR_EraseRootFromParent_Done,
     /* 111137 */ // Label 1764: @111137
     /* 111137 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(111169), // Rule ID 6900 //
     /* 111142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111156 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111159 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111161 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111168 */   // GIR_Coverage, 6900,
     /* 111168 */   GIR_EraseRootFromParent_Done,
     /* 111169 */ // Label 1765: @111169
     /* 111169 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(111201), // Rule ID 6901 //
     /* 111174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111188 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111191 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111193 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111200 */   // GIR_Coverage, 6901,
     /* 111200 */   GIR_EraseRootFromParent_Done,
     /* 111201 */ // Label 1766: @111201
     /* 111201 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(111233), // Rule ID 6902 //
     /* 111206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111220 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111223 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111225 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111232 */   // GIR_Coverage, 6902,
     /* 111232 */   GIR_EraseRootFromParent_Done,
     /* 111233 */ // Label 1767: @111233
     /* 111233 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(111265), // Rule ID 6903 //
     /* 111238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111252 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111255 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111264 */   // GIR_Coverage, 6903,
     /* 111264 */   GIR_EraseRootFromParent_Done,
     /* 111265 */ // Label 1768: @111265
     /* 111265 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(111298), // Rule ID 6904 //
     /* 111270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111284 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 111284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 111287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111289 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111291 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 111296 */   GIR_RootConstrainSelectedInstOperands,
     /* 111297 */   // GIR_Coverage, 6904,
     /* 111297 */   GIR_EraseRootFromParent_Done,
     /* 111298 */ // Label 1769: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(111324), // Rule ID 6905 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 111317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111322 */   GIR_RootConstrainSelectedInstOperands,
     /* 111323 */   // GIR_Coverage, 6905,
     /* 111323 */   GIR_Done,
     /* 111324 */ // Label 1770: @111324
     /* 111324 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(111350), // Rule ID 6906 //
     /* 111329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111343 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 111343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 111348 */   GIR_RootConstrainSelectedInstOperands,
     /* 111349 */   // GIR_Coverage, 6906,
     /* 111349 */   GIR_Done,
     /* 111350 */ // Label 1771: @111350
     /* 111350 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(111376), // Rule ID 6907 //
     /* 111355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111369 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 111369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 111374 */   GIR_RootConstrainSelectedInstOperands,
     /* 111375 */   // GIR_Coverage, 6907,
     /* 111375 */   GIR_Done,
     /* 111376 */ // Label 1772: @111376
     /* 111376 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(111402), // Rule ID 6908 //
     /* 111381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111395 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 111395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111400 */   GIR_RootConstrainSelectedInstOperands,
     /* 111401 */   // GIR_Coverage, 6908,
     /* 111401 */   GIR_Done,
     /* 111402 */ // Label 1773: @111402
     /* 111402 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(111428), // Rule ID 6909 //
     /* 111407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111421 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 111421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 111426 */   GIR_RootConstrainSelectedInstOperands,
     /* 111427 */   // GIR_Coverage, 6909,
     /* 111427 */   GIR_Done,
     /* 111428 */ // Label 1774: @111428
     /* 111428 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(111457), // Rule ID 6910 //
     /* 111433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111444 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111456 */   // GIR_Coverage, 6910,
     /* 111456 */   GIR_EraseRootFromParent_Done,
     /* 111457 */ // Label 1775: @111457
     /* 111457 */ GIM_Reject,
     /* 111458 */ // Label 1628: @111458
     /* 111458 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(111488), // Rule ID 6722 //
     /* 111463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111477 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111487 */   // GIR_Coverage, 6722,
     /* 111487 */   GIR_Done,
     /* 111488 */ // Label 1776: @111488
     /* 111488 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(111518), // Rule ID 6724 //
     /* 111493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111507 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111517 */   // GIR_Coverage, 6724,
     /* 111517 */   GIR_Done,
     /* 111518 */ // Label 1777: @111518
     /* 111518 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(111568), // Rule ID 6733 //
     /* 111523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111537 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111566 */   GIR_RootConstrainSelectedInstOperands,
     /* 111567 */   // GIR_Coverage, 6733,
     /* 111567 */   GIR_EraseRootFromParent_Done,
     /* 111568 */ // Label 1778: @111568
     /* 111568 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(111618), // Rule ID 6735 //
     /* 111573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111587 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111616 */   GIR_RootConstrainSelectedInstOperands,
     /* 111617 */   // GIR_Coverage, 6735,
     /* 111617 */   GIR_EraseRootFromParent_Done,
     /* 111618 */ // Label 1779: @111618
     /* 111618 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(111650), // Rule ID 6781 //
     /* 111623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111637 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111649 */   // GIR_Coverage, 6781,
     /* 111649 */   GIR_EraseRootFromParent_Done,
     /* 111650 */ // Label 1780: @111650
     /* 111650 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(111682), // Rule ID 6782 //
     /* 111655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111669 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111681 */   // GIR_Coverage, 6782,
     /* 111681 */   GIR_EraseRootFromParent_Done,
     /* 111682 */ // Label 1781: @111682
     /* 111682 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(111714), // Rule ID 6783 //
     /* 111687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111701 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111713 */   // GIR_Coverage, 6783,
     /* 111713 */   GIR_EraseRootFromParent_Done,
     /* 111714 */ // Label 1782: @111714
     /* 111714 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(111746), // Rule ID 6784 //
     /* 111719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111733 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111736 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111738 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111745 */   // GIR_Coverage, 6784,
     /* 111745 */   GIR_EraseRootFromParent_Done,
     /* 111746 */ // Label 1783: @111746
     /* 111746 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(111778), // Rule ID 6785 //
     /* 111751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111765 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111768 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   // GIR_Coverage, 6785,
     /* 111777 */   GIR_EraseRootFromParent_Done,
     /* 111778 */ // Label 1784: @111778
     /* 111778 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(111810), // Rule ID 6786 //
     /* 111783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111797 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111800 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111802 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111809 */   // GIR_Coverage, 6786,
     /* 111809 */   GIR_EraseRootFromParent_Done,
     /* 111810 */ // Label 1785: @111810
     /* 111810 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(111836), // Rule ID 6787 //
     /* 111815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 111829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111834 */   GIR_RootConstrainSelectedInstOperands,
     /* 111835 */   // GIR_Coverage, 6787,
     /* 111835 */   GIR_Done,
     /* 111836 */ // Label 1786: @111836
     /* 111836 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(111862), // Rule ID 6788 //
     /* 111841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111855 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 111855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111860 */   GIR_RootConstrainSelectedInstOperands,
     /* 111861 */   // GIR_Coverage, 6788,
     /* 111861 */   GIR_Done,
     /* 111862 */ // Label 1787: @111862
     /* 111862 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111888), // Rule ID 6789 //
     /* 111867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111881 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 111881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111886 */   GIR_RootConstrainSelectedInstOperands,
     /* 111887 */   // GIR_Coverage, 6789,
     /* 111887 */   GIR_Done,
     /* 111888 */ // Label 1788: @111888
     /* 111888 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111914), // Rule ID 6790 //
     /* 111893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111907 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 111907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 6790,
     /* 111913 */   GIR_Done,
     /* 111914 */ // Label 1789: @111914
     /* 111914 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111940), // Rule ID 6791 //
     /* 111919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111933 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 111933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111938 */   GIR_RootConstrainSelectedInstOperands,
     /* 111939 */   // GIR_Coverage, 6791,
     /* 111939 */   GIR_Done,
     /* 111940 */ // Label 1790: @111940
     /* 111940 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111966), // Rule ID 6792 //
     /* 111945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111959 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 111959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111964 */   GIR_RootConstrainSelectedInstOperands,
     /* 111965 */   // GIR_Coverage, 6792,
     /* 111965 */   GIR_Done,
     /* 111966 */ // Label 1791: @111966
     /* 111966 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111995), // Rule ID 6793 //
     /* 111971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111982 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111994 */   // GIR_Coverage, 6793,
     /* 111994 */   GIR_EraseRootFromParent_Done,
     /* 111995 */ // Label 1792: @111995
     /* 111995 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(112027), // Rule ID 6794 //
     /* 112000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112014 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112026 */   // GIR_Coverage, 6794,
     /* 112026 */   GIR_EraseRootFromParent_Done,
     /* 112027 */ // Label 1793: @112027
     /* 112027 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(112059), // Rule ID 6795 //
     /* 112032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112046 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112058 */   // GIR_Coverage, 6795,
     /* 112058 */   GIR_EraseRootFromParent_Done,
     /* 112059 */ // Label 1794: @112059
     /* 112059 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(112091), // Rule ID 6796 //
     /* 112064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112078 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112090 */   // GIR_Coverage, 6796,
     /* 112090 */   GIR_EraseRootFromParent_Done,
     /* 112091 */ // Label 1795: @112091
     /* 112091 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(112123), // Rule ID 6797 //
     /* 112096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112110 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112122 */   // GIR_Coverage, 6797,
     /* 112122 */   GIR_EraseRootFromParent_Done,
     /* 112123 */ // Label 1796: @112123
     /* 112123 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(112155), // Rule ID 6798 //
     /* 112128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112142 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112154 */   // GIR_Coverage, 6798,
     /* 112154 */   GIR_EraseRootFromParent_Done,
     /* 112155 */ // Label 1797: @112155
     /* 112155 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(112187), // Rule ID 6799 //
     /* 112160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112174 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112177 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112186 */   // GIR_Coverage, 6799,
     /* 112186 */   GIR_EraseRootFromParent_Done,
     /* 112187 */ // Label 1798: @112187
     /* 112187 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(112213), // Rule ID 6800 //
     /* 112192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112206 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 112206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 112211 */   GIR_RootConstrainSelectedInstOperands,
     /* 112212 */   // GIR_Coverage, 6800,
     /* 112212 */   GIR_Done,
     /* 112213 */ // Label 1799: @112213
     /* 112213 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(112239), // Rule ID 6801 //
     /* 112218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112232 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 112232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 112237 */   GIR_RootConstrainSelectedInstOperands,
     /* 112238 */   // GIR_Coverage, 6801,
     /* 112238 */   GIR_Done,
     /* 112239 */ // Label 1800: @112239
     /* 112239 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(112265), // Rule ID 6802 //
     /* 112244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112258 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 112258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 112263 */   GIR_RootConstrainSelectedInstOperands,
     /* 112264 */   // GIR_Coverage, 6802,
     /* 112264 */   GIR_Done,
     /* 112265 */ // Label 1801: @112265
     /* 112265 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(112291), // Rule ID 6803 //
     /* 112270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112284 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 112284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 112289 */   GIR_RootConstrainSelectedInstOperands,
     /* 112290 */   // GIR_Coverage, 6803,
     /* 112290 */   GIR_Done,
     /* 112291 */ // Label 1802: @112291
     /* 112291 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(112317), // Rule ID 6804 //
     /* 112296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112310 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 112310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 112315 */   GIR_RootConstrainSelectedInstOperands,
     /* 112316 */   // GIR_Coverage, 6804,
     /* 112316 */   GIR_Done,
     /* 112317 */ // Label 1803: @112317
     /* 112317 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(112343), // Rule ID 6805 //
     /* 112322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112336 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 112336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 112341 */   GIR_RootConstrainSelectedInstOperands,
     /* 112342 */   // GIR_Coverage, 6805,
     /* 112342 */   GIR_Done,
     /* 112343 */ // Label 1804: @112343
     /* 112343 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(112372), // Rule ID 6806 //
     /* 112348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112359 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 112359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112362 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112371 */   // GIR_Coverage, 6806,
     /* 112371 */   GIR_EraseRootFromParent_Done,
     /* 112372 */ // Label 1805: @112372
     /* 112372 */ GIM_Reject,
     /* 112373 */ // Label 1629: @112373
     /* 112373 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(112405), // Rule ID 6885 //
     /* 112378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112392 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112404 */   // GIR_Coverage, 6885,
     /* 112404 */   GIR_EraseRootFromParent_Done,
     /* 112405 */ // Label 1806: @112405
     /* 112405 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(112437), // Rule ID 6886 //
     /* 112410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112424 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112436 */   // GIR_Coverage, 6886,
     /* 112436 */   GIR_EraseRootFromParent_Done,
     /* 112437 */ // Label 1807: @112437
     /* 112437 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(112469), // Rule ID 6887 //
     /* 112442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112456 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112468 */   // GIR_Coverage, 6887,
     /* 112468 */   GIR_EraseRootFromParent_Done,
     /* 112469 */ // Label 1808: @112469
     /* 112469 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(112501), // Rule ID 6888 //
     /* 112474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112488 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112500 */   // GIR_Coverage, 6888,
     /* 112500 */   GIR_EraseRootFromParent_Done,
     /* 112501 */ // Label 1809: @112501
     /* 112501 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(112533), // Rule ID 6889 //
     /* 112506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112520 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112532 */   // GIR_Coverage, 6889,
     /* 112532 */   GIR_EraseRootFromParent_Done,
     /* 112533 */ // Label 1810: @112533
     /* 112533 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(112565), // Rule ID 6890 //
     /* 112538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112552 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112555 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112564 */   // GIR_Coverage, 6890,
     /* 112564 */   GIR_EraseRootFromParent_Done,
     /* 112565 */ // Label 1811: @112565
     /* 112565 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112636), // Rule ID 6891 //
     /* 112570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112584 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112584 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112587 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112591 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112596 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112614 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112634 */   GIR_RootConstrainSelectedInstOperands,
     /* 112635 */   // GIR_Coverage, 6891,
     /* 112635 */   GIR_EraseRootFromParent_Done,
     /* 112636 */ // Label 1812: @112636
     /* 112636 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(112662), // Rule ID 6892 //
     /* 112641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112655 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 112655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112660 */   GIR_RootConstrainSelectedInstOperands,
     /* 112661 */   // GIR_Coverage, 6892,
     /* 112661 */   GIR_Done,
     /* 112662 */ // Label 1813: @112662
     /* 112662 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112688), // Rule ID 6893 //
     /* 112667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112681 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 112681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112686 */   GIR_RootConstrainSelectedInstOperands,
     /* 112687 */   // GIR_Coverage, 6893,
     /* 112687 */   GIR_Done,
     /* 112688 */ // Label 1814: @112688
     /* 112688 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112714), // Rule ID 6894 //
     /* 112693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112707 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 112707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112712 */   GIR_RootConstrainSelectedInstOperands,
     /* 112713 */   // GIR_Coverage, 6894,
     /* 112713 */   GIR_Done,
     /* 112714 */ // Label 1815: @112714
     /* 112714 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112740), // Rule ID 6895 //
     /* 112719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112733 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 112733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112738 */   GIR_RootConstrainSelectedInstOperands,
     /* 112739 */   // GIR_Coverage, 6895,
     /* 112739 */   GIR_Done,
     /* 112740 */ // Label 1816: @112740
     /* 112740 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112766), // Rule ID 6896 //
     /* 112745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112759 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 112759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112764 */   GIR_RootConstrainSelectedInstOperands,
     /* 112765 */   // GIR_Coverage, 6896,
     /* 112765 */   GIR_Done,
     /* 112766 */ // Label 1817: @112766
     /* 112766 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112795), // Rule ID 6897 //
     /* 112771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112782 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112794 */   // GIR_Coverage, 6897,
     /* 112794 */   GIR_EraseRootFromParent_Done,
     /* 112795 */ // Label 1818: @112795
     /* 112795 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112827), // Rule ID 6911 //
     /* 112800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112814 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112826 */   // GIR_Coverage, 6911,
     /* 112826 */   GIR_EraseRootFromParent_Done,
     /* 112827 */ // Label 1819: @112827
     /* 112827 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112859), // Rule ID 6912 //
     /* 112832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112846 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112858 */   // GIR_Coverage, 6912,
     /* 112858 */   GIR_EraseRootFromParent_Done,
     /* 112859 */ // Label 1820: @112859
     /* 112859 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112891), // Rule ID 6913 //
     /* 112864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112878 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112881 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112890 */   // GIR_Coverage, 6913,
     /* 112890 */   GIR_EraseRootFromParent_Done,
     /* 112891 */ // Label 1821: @112891
     /* 112891 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112923), // Rule ID 6914 //
     /* 112896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112910 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112913 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112915 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112922 */   // GIR_Coverage, 6914,
     /* 112922 */   GIR_EraseRootFromParent_Done,
     /* 112923 */ // Label 1822: @112923
     /* 112923 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112955), // Rule ID 6915 //
     /* 112928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112942 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112945 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112947 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112954 */   // GIR_Coverage, 6915,
     /* 112954 */   GIR_EraseRootFromParent_Done,
     /* 112955 */ // Label 1823: @112955
     /* 112955 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112987), // Rule ID 6916 //
     /* 112960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112974 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112977 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112979 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112986 */   // GIR_Coverage, 6916,
     /* 112986 */   GIR_EraseRootFromParent_Done,
     /* 112987 */ // Label 1824: @112987
     /* 112987 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(113058), // Rule ID 6917 //
     /* 112992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113006 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113006 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113009 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 113013 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113018 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 113031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113036 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113056 */   GIR_RootConstrainSelectedInstOperands,
     /* 113057 */   // GIR_Coverage, 6917,
     /* 113057 */   GIR_EraseRootFromParent_Done,
     /* 113058 */ // Label 1825: @113058
     /* 113058 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(113084), // Rule ID 6918 //
     /* 113063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113077 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 113077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 113082 */   GIR_RootConstrainSelectedInstOperands,
     /* 113083 */   // GIR_Coverage, 6918,
     /* 113083 */   GIR_Done,
     /* 113084 */ // Label 1826: @113084
     /* 113084 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(113110), // Rule ID 6919 //
     /* 113089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113103 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 113103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113108 */   GIR_RootConstrainSelectedInstOperands,
     /* 113109 */   // GIR_Coverage, 6919,
     /* 113109 */   GIR_Done,
     /* 113110 */ // Label 1827: @113110
     /* 113110 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(113136), // Rule ID 6920 //
     /* 113115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113129 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 113129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113134 */   GIR_RootConstrainSelectedInstOperands,
     /* 113135 */   // GIR_Coverage, 6920,
     /* 113135 */   GIR_Done,
     /* 113136 */ // Label 1828: @113136
     /* 113136 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(113162), // Rule ID 6921 //
     /* 113141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113155 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 113155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 113160 */   GIR_RootConstrainSelectedInstOperands,
     /* 113161 */   // GIR_Coverage, 6921,
     /* 113161 */   GIR_Done,
     /* 113162 */ // Label 1829: @113162
     /* 113162 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(113188), // Rule ID 6922 //
     /* 113167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113181 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 113181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113186 */   GIR_RootConstrainSelectedInstOperands,
     /* 113187 */   // GIR_Coverage, 6922,
     /* 113187 */   GIR_Done,
     /* 113188 */ // Label 1830: @113188
     /* 113188 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(113217), // Rule ID 6923 //
     /* 113193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113204 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 113204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113207 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113216 */   // GIR_Coverage, 6923,
     /* 113216 */   GIR_EraseRootFromParent_Done,
     /* 113217 */ // Label 1831: @113217
     /* 113217 */ GIM_Reject,
     /* 113218 */ // Label 1630: @113218
     /* 113218 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(113292), // Rule ID 5718 //
     /* 113223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 113238 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113249 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 113249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 113256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 113265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 113281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113291 */   // GIR_Coverage, 5718,
     /* 113291 */   GIR_EraseRootFromParent_Done,
     /* 113292 */ // Label 1832: @113292
     /* 113292 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(113322), // Rule ID 6721 //
     /* 113297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 113311 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 113311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113321 */   // GIR_Coverage, 6721,
     /* 113321 */   GIR_Done,
     /* 113322 */ // Label 1833: @113322
     /* 113322 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(113372), // Rule ID 6732 //
     /* 113327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 113341 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 113341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 113344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113353 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 113357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113370 */   GIR_RootConstrainSelectedInstOperands,
     /* 113371 */   // GIR_Coverage, 6732,
     /* 113371 */   GIR_EraseRootFromParent_Done,
     /* 113372 */ // Label 1834: @113372
     /* 113372 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(113404), // Rule ID 6807 //
     /* 113377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113391 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113394 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113396 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113403 */   // GIR_Coverage, 6807,
     /* 113403 */   GIR_EraseRootFromParent_Done,
     /* 113404 */ // Label 1835: @113404
     /* 113404 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(113436), // Rule ID 6808 //
     /* 113409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113423 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113426 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113428 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113435 */   // GIR_Coverage, 6808,
     /* 113435 */   GIR_EraseRootFromParent_Done,
     /* 113436 */ // Label 1836: @113436
     /* 113436 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(113468), // Rule ID 6809 //
     /* 113441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113455 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113467 */   // GIR_Coverage, 6809,
     /* 113467 */   GIR_EraseRootFromParent_Done,
     /* 113468 */ // Label 1837: @113468
     /* 113468 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(113500), // Rule ID 6810 //
     /* 113473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113487 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113490 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113492 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113499 */   // GIR_Coverage, 6810,
     /* 113499 */   GIR_EraseRootFromParent_Done,
     /* 113500 */ // Label 1838: @113500
     /* 113500 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113532), // Rule ID 6811 //
     /* 113505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113519 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113522 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113524 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113531 */   // GIR_Coverage, 6811,
     /* 113531 */   GIR_EraseRootFromParent_Done,
     /* 113532 */ // Label 1839: @113532
     /* 113532 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113564), // Rule ID 6812 //
     /* 113537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113551 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113554 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113563 */   // GIR_Coverage, 6812,
     /* 113563 */   GIR_EraseRootFromParent_Done,
     /* 113564 */ // Label 1840: @113564
     /* 113564 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113596), // Rule ID 6813 //
     /* 113569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113583 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113586 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113588 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113595 */   // GIR_Coverage, 6813,
     /* 113595 */   GIR_EraseRootFromParent_Done,
     /* 113596 */ // Label 1841: @113596
     /* 113596 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113622), // Rule ID 6814 //
     /* 113601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113615 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 113615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113620 */   GIR_RootConstrainSelectedInstOperands,
     /* 113621 */   // GIR_Coverage, 6814,
     /* 113621 */   GIR_Done,
     /* 113622 */ // Label 1842: @113622
     /* 113622 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113648), // Rule ID 6815 //
     /* 113627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113641 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 113641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113646 */   GIR_RootConstrainSelectedInstOperands,
     /* 113647 */   // GIR_Coverage, 6815,
     /* 113647 */   GIR_Done,
     /* 113648 */ // Label 1843: @113648
     /* 113648 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113674), // Rule ID 6816 //
     /* 113653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113667 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 113667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113672 */   GIR_RootConstrainSelectedInstOperands,
     /* 113673 */   // GIR_Coverage, 6816,
     /* 113673 */   GIR_Done,
     /* 113674 */ // Label 1844: @113674
     /* 113674 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113700), // Rule ID 6817 //
     /* 113679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113693 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 113693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113698 */   GIR_RootConstrainSelectedInstOperands,
     /* 113699 */   // GIR_Coverage, 6817,
     /* 113699 */   GIR_Done,
     /* 113700 */ // Label 1845: @113700
     /* 113700 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113726), // Rule ID 6818 //
     /* 113705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113719 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 113719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113724 */   GIR_RootConstrainSelectedInstOperands,
     /* 113725 */   // GIR_Coverage, 6818,
     /* 113725 */   GIR_Done,
     /* 113726 */ // Label 1846: @113726
     /* 113726 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113752), // Rule ID 6819 //
     /* 113731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113745 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 113745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113750 */   GIR_RootConstrainSelectedInstOperands,
     /* 113751 */   // GIR_Coverage, 6819,
     /* 113751 */   GIR_Done,
     /* 113752 */ // Label 1847: @113752
     /* 113752 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(113778), // Rule ID 6820 //
     /* 113757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113771 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 113771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113776 */   GIR_RootConstrainSelectedInstOperands,
     /* 113777 */   // GIR_Coverage, 6820,
     /* 113777 */   GIR_Done,
     /* 113778 */ // Label 1848: @113778
     /* 113778 */ GIM_Reject,
     /* 113779 */ // Label 1631: @113779
     /* 113779 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(113811), // Rule ID 6924 //
     /* 113784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113798 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113810 */   // GIR_Coverage, 6924,
     /* 113810 */   GIR_EraseRootFromParent_Done,
     /* 113811 */ // Label 1849: @113811
     /* 113811 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(113843), // Rule ID 6925 //
     /* 113816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113830 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113842 */   // GIR_Coverage, 6925,
     /* 113842 */   GIR_EraseRootFromParent_Done,
     /* 113843 */ // Label 1850: @113843
     /* 113843 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(113875), // Rule ID 6926 //
     /* 113848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113862 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113874 */   // GIR_Coverage, 6926,
     /* 113874 */   GIR_EraseRootFromParent_Done,
     /* 113875 */ // Label 1851: @113875
     /* 113875 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(113907), // Rule ID 6927 //
     /* 113880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113894 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113906 */   // GIR_Coverage, 6927,
     /* 113906 */   GIR_EraseRootFromParent_Done,
     /* 113907 */ // Label 1852: @113907
     /* 113907 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(113939), // Rule ID 6928 //
     /* 113912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113926 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113938 */   // GIR_Coverage, 6928,
     /* 113938 */   GIR_EraseRootFromParent_Done,
     /* 113939 */ // Label 1853: @113939
     /* 113939 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(113971), // Rule ID 6929 //
     /* 113944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113958 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113970 */   // GIR_Coverage, 6929,
     /* 113970 */   GIR_EraseRootFromParent_Done,
     /* 113971 */ // Label 1854: @113971
     /* 113971 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(114042), // Rule ID 6930 //
     /* 113976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113990 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114002 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114020 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114040 */   GIR_RootConstrainSelectedInstOperands,
     /* 114041 */   // GIR_Coverage, 6930,
     /* 114041 */   GIR_EraseRootFromParent_Done,
     /* 114042 */ // Label 1855: @114042
     /* 114042 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(114068), // Rule ID 6931 //
     /* 114047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114061 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 114061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114066 */   GIR_RootConstrainSelectedInstOperands,
     /* 114067 */   // GIR_Coverage, 6931,
     /* 114067 */   GIR_Done,
     /* 114068 */ // Label 1856: @114068
     /* 114068 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(114094), // Rule ID 6932 //
     /* 114073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114087 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 114087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114092 */   GIR_RootConstrainSelectedInstOperands,
     /* 114093 */   // GIR_Coverage, 6932,
     /* 114093 */   GIR_Done,
     /* 114094 */ // Label 1857: @114094
     /* 114094 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(114120), // Rule ID 6933 //
     /* 114099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114113 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 114113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114118 */   GIR_RootConstrainSelectedInstOperands,
     /* 114119 */   // GIR_Coverage, 6933,
     /* 114119 */   GIR_Done,
     /* 114120 */ // Label 1858: @114120
     /* 114120 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(114146), // Rule ID 6934 //
     /* 114125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114139 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 114139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114144 */   GIR_RootConstrainSelectedInstOperands,
     /* 114145 */   // GIR_Coverage, 6934,
     /* 114145 */   GIR_Done,
     /* 114146 */ // Label 1859: @114146
     /* 114146 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(114172), // Rule ID 6935 //
     /* 114151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114165 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 114165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114170 */   GIR_RootConstrainSelectedInstOperands,
     /* 114171 */   // GIR_Coverage, 6935,
     /* 114171 */   GIR_Done,
     /* 114172 */ // Label 1860: @114172
     /* 114172 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(114201), // Rule ID 6936 //
     /* 114177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114188 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 114188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114191 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114193 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114200 */   // GIR_Coverage, 6936,
     /* 114200 */   GIR_EraseRootFromParent_Done,
     /* 114201 */ // Label 1861: @114201
     /* 114201 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(114233), // Rule ID 6937 //
     /* 114206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114220 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114223 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114225 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114232 */   // GIR_Coverage, 6937,
     /* 114232 */   GIR_EraseRootFromParent_Done,
     /* 114233 */ // Label 1862: @114233
     /* 114233 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(114265), // Rule ID 6938 //
     /* 114238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114252 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114255 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114264 */   // GIR_Coverage, 6938,
     /* 114264 */   GIR_EraseRootFromParent_Done,
     /* 114265 */ // Label 1863: @114265
     /* 114265 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(114297), // Rule ID 6939 //
     /* 114270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114284 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114287 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114289 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114296 */   // GIR_Coverage, 6939,
     /* 114296 */   GIR_EraseRootFromParent_Done,
     /* 114297 */ // Label 1864: @114297
     /* 114297 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(114329), // Rule ID 6940 //
     /* 114302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114316 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114328 */   // GIR_Coverage, 6940,
     /* 114328 */   GIR_EraseRootFromParent_Done,
     /* 114329 */ // Label 1865: @114329
     /* 114329 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(114361), // Rule ID 6941 //
     /* 114334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114348 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114360 */   // GIR_Coverage, 6941,
     /* 114360 */   GIR_EraseRootFromParent_Done,
     /* 114361 */ // Label 1866: @114361
     /* 114361 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(114393), // Rule ID 6942 //
     /* 114366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114380 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114392 */   // GIR_Coverage, 6942,
     /* 114392 */   GIR_EraseRootFromParent_Done,
     /* 114393 */ // Label 1867: @114393
     /* 114393 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(114464), // Rule ID 6943 //
     /* 114398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114412 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114424 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114462 */   GIR_RootConstrainSelectedInstOperands,
     /* 114463 */   // GIR_Coverage, 6943,
     /* 114463 */   GIR_EraseRootFromParent_Done,
     /* 114464 */ // Label 1868: @114464
     /* 114464 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(114490), // Rule ID 6944 //
     /* 114469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114483 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 114483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114488 */   GIR_RootConstrainSelectedInstOperands,
     /* 114489 */   // GIR_Coverage, 6944,
     /* 114489 */   GIR_Done,
     /* 114490 */ // Label 1869: @114490
     /* 114490 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(114516), // Rule ID 6945 //
     /* 114495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114509 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 114509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114514 */   GIR_RootConstrainSelectedInstOperands,
     /* 114515 */   // GIR_Coverage, 6945,
     /* 114515 */   GIR_Done,
     /* 114516 */ // Label 1870: @114516
     /* 114516 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(114542), // Rule ID 6946 //
     /* 114521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114535 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 114535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114540 */   GIR_RootConstrainSelectedInstOperands,
     /* 114541 */   // GIR_Coverage, 6946,
     /* 114541 */   GIR_Done,
     /* 114542 */ // Label 1871: @114542
     /* 114542 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(114568), // Rule ID 6947 //
     /* 114547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114561 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 114561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114566 */   GIR_RootConstrainSelectedInstOperands,
     /* 114567 */   // GIR_Coverage, 6947,
     /* 114567 */   GIR_Done,
     /* 114568 */ // Label 1872: @114568
     /* 114568 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(114594), // Rule ID 6948 //
     /* 114573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114587 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 114587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114592 */   GIR_RootConstrainSelectedInstOperands,
     /* 114593 */   // GIR_Coverage, 6948,
     /* 114593 */   GIR_Done,
     /* 114594 */ // Label 1873: @114594
     /* 114594 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(114623), // Rule ID 6949 //
     /* 114599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114610 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114622 */   // GIR_Coverage, 6949,
     /* 114622 */   GIR_EraseRootFromParent_Done,
     /* 114623 */ // Label 1874: @114623
     /* 114623 */ GIM_Reject,
     /* 114624 */ // Label 1632: @114624
     /* 114624 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(114656), // Rule ID 6950 //
     /* 114629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114643 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114655 */   // GIR_Coverage, 6950,
     /* 114655 */   GIR_EraseRootFromParent_Done,
     /* 114656 */ // Label 1875: @114656
     /* 114656 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(114688), // Rule ID 6951 //
     /* 114661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114675 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114687 */   // GIR_Coverage, 6951,
     /* 114687 */   GIR_EraseRootFromParent_Done,
     /* 114688 */ // Label 1876: @114688
     /* 114688 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(114720), // Rule ID 6952 //
     /* 114693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114707 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114719 */   // GIR_Coverage, 6952,
     /* 114719 */   GIR_EraseRootFromParent_Done,
     /* 114720 */ // Label 1877: @114720
     /* 114720 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(114752), // Rule ID 6953 //
     /* 114725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114739 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114751 */   // GIR_Coverage, 6953,
     /* 114751 */   GIR_EraseRootFromParent_Done,
     /* 114752 */ // Label 1878: @114752
     /* 114752 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(114784), // Rule ID 6954 //
     /* 114757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114771 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114783 */   // GIR_Coverage, 6954,
     /* 114783 */   GIR_EraseRootFromParent_Done,
     /* 114784 */ // Label 1879: @114784
     /* 114784 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(114816), // Rule ID 6955 //
     /* 114789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114803 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114815 */   // GIR_Coverage, 6955,
     /* 114815 */   GIR_EraseRootFromParent_Done,
     /* 114816 */ // Label 1880: @114816
     /* 114816 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(114848), // Rule ID 6956 //
     /* 114821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114835 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114838 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114847 */   // GIR_Coverage, 6956,
     /* 114847 */   GIR_EraseRootFromParent_Done,
     /* 114848 */ // Label 1881: @114848
     /* 114848 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(114919), // Rule ID 6957 //
     /* 114853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114867 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114867 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114870 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114874 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114879 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114917 */   GIR_RootConstrainSelectedInstOperands,
     /* 114918 */   // GIR_Coverage, 6957,
     /* 114918 */   GIR_EraseRootFromParent_Done,
     /* 114919 */ // Label 1882: @114919
     /* 114919 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(114945), // Rule ID 6958 //
     /* 114924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114938 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 114938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114943 */   GIR_RootConstrainSelectedInstOperands,
     /* 114944 */   // GIR_Coverage, 6958,
     /* 114944 */   GIR_Done,
     /* 114945 */ // Label 1883: @114945
     /* 114945 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(114971), // Rule ID 6959 //
     /* 114950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114964 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 114964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114969 */   GIR_RootConstrainSelectedInstOperands,
     /* 114970 */   // GIR_Coverage, 6959,
     /* 114970 */   GIR_Done,
     /* 114971 */ // Label 1884: @114971
     /* 114971 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(114997), // Rule ID 6960 //
     /* 114976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114990 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 114990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114995 */   GIR_RootConstrainSelectedInstOperands,
     /* 114996 */   // GIR_Coverage, 6960,
     /* 114996 */   GIR_Done,
     /* 114997 */ // Label 1885: @114997
     /* 114997 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(115023), // Rule ID 6961 //
     /* 115002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 115005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115016 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 115016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 115021 */   GIR_RootConstrainSelectedInstOperands,
     /* 115022 */   // GIR_Coverage, 6961,
     /* 115022 */   GIR_Done,
     /* 115023 */ // Label 1886: @115023
     /* 115023 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(115049), // Rule ID 6962 //
     /* 115028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 115031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115042 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 115042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 115047 */   GIR_RootConstrainSelectedInstOperands,
     /* 115048 */   // GIR_Coverage, 6962,
     /* 115048 */   GIR_Done,
     /* 115049 */ // Label 1887: @115049
     /* 115049 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(115075), // Rule ID 6963 //
     /* 115054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 115057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115068 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 115068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 115073 */   GIR_RootConstrainSelectedInstOperands,
     /* 115074 */   // GIR_Coverage, 6963,
     /* 115074 */   GIR_Done,
     /* 115075 */ // Label 1888: @115075
     /* 115075 */ GIM_Reject,
     /* 115076 */ // Label 1633: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(115108), // Rule ID 10697 //
     /* 115081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115095 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115107 */   // GIR_Coverage, 10697,
     /* 115107 */   GIR_EraseRootFromParent_Done,
     /* 115108 */ // Label 1889: @115108
     /* 115108 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(115140), // Rule ID 10698 //
     /* 115113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115127 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115139 */   // GIR_Coverage, 10698,
     /* 115139 */   GIR_EraseRootFromParent_Done,
     /* 115140 */ // Label 1890: @115140
     /* 115140 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(115172), // Rule ID 10699 //
     /* 115145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115159 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115171 */   // GIR_Coverage, 10699,
     /* 115171 */   GIR_EraseRootFromParent_Done,
     /* 115172 */ // Label 1891: @115172
     /* 115172 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(115204), // Rule ID 10700 //
     /* 115177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115191 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115203 */   // GIR_Coverage, 10700,
     /* 115203 */   GIR_EraseRootFromParent_Done,
     /* 115204 */ // Label 1892: @115204
     /* 115204 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(115236), // Rule ID 10701 //
     /* 115209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115223 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115226 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115228 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115235 */   // GIR_Coverage, 10701,
     /* 115235 */   GIR_EraseRootFromParent_Done,
     /* 115236 */ // Label 1893: @115236
     /* 115236 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(115268), // Rule ID 10702 //
     /* 115241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115255 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115258 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115260 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115267 */   // GIR_Coverage, 10702,
     /* 115267 */   GIR_EraseRootFromParent_Done,
     /* 115268 */ // Label 1894: @115268
     /* 115268 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(115300), // Rule ID 10715 //
     /* 115273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115287 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115290 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115292 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115299 */   // GIR_Coverage, 10715,
     /* 115299 */   GIR_EraseRootFromParent_Done,
     /* 115300 */ // Label 1895: @115300
     /* 115300 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(115332), // Rule ID 10716 //
     /* 115305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115319 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115322 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115331 */   // GIR_Coverage, 10716,
     /* 115331 */   GIR_EraseRootFromParent_Done,
     /* 115332 */ // Label 1896: @115332
     /* 115332 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(115364), // Rule ID 10717 //
     /* 115337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115351 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115354 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115356 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115363 */   // GIR_Coverage, 10717,
     /* 115363 */   GIR_EraseRootFromParent_Done,
     /* 115364 */ // Label 1897: @115364
     /* 115364 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(115396), // Rule ID 10718 //
     /* 115369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115383 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115386 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115395 */   // GIR_Coverage, 10718,
     /* 115395 */   GIR_EraseRootFromParent_Done,
     /* 115396 */ // Label 1898: @115396
     /* 115396 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(115428), // Rule ID 10719 //
     /* 115401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115415 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115418 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115420 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115427 */   // GIR_Coverage, 10719,
     /* 115427 */   GIR_EraseRootFromParent_Done,
     /* 115428 */ // Label 1899: @115428
     /* 115428 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(115460), // Rule ID 10720 //
     /* 115433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115447 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115450 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115452 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115459 */   // GIR_Coverage, 10720,
     /* 115459 */   GIR_EraseRootFromParent_Done,
     /* 115460 */ // Label 1900: @115460
     /* 115460 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(115492), // Rule ID 10725 //
     /* 115465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115479 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115482 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115484 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115491 */   // GIR_Coverage, 10725,
     /* 115491 */   GIR_EraseRootFromParent_Done,
     /* 115492 */ // Label 1901: @115492
     /* 115492 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(115524), // Rule ID 10726 //
     /* 115497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115511 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115514 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115516 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115523 */   // GIR_Coverage, 10726,
     /* 115523 */   GIR_EraseRootFromParent_Done,
     /* 115524 */ // Label 1902: @115524
     /* 115524 */ GIM_Reject,
     /* 115525 */ // Label 1634: @115525
     /* 115525 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(115557), // Rule ID 10691 //
     /* 115530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115544 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115556 */   // GIR_Coverage, 10691,
     /* 115556 */   GIR_EraseRootFromParent_Done,
     /* 115557 */ // Label 1903: @115557
     /* 115557 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(115589), // Rule ID 10692 //
     /* 115562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115576 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115588 */   // GIR_Coverage, 10692,
     /* 115588 */   GIR_EraseRootFromParent_Done,
     /* 115589 */ // Label 1904: @115589
     /* 115589 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(115621), // Rule ID 10693 //
     /* 115594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115608 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115620 */   // GIR_Coverage, 10693,
     /* 115620 */   GIR_EraseRootFromParent_Done,
     /* 115621 */ // Label 1905: @115621
     /* 115621 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(115653), // Rule ID 10694 //
     /* 115626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115640 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115652 */   // GIR_Coverage, 10694,
     /* 115652 */   GIR_EraseRootFromParent_Done,
     /* 115653 */ // Label 1906: @115653
     /* 115653 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(115685), // Rule ID 10695 //
     /* 115658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115672 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115684 */   // GIR_Coverage, 10695,
     /* 115684 */   GIR_EraseRootFromParent_Done,
     /* 115685 */ // Label 1907: @115685
     /* 115685 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(115717), // Rule ID 10696 //
     /* 115690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115704 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115716 */   // GIR_Coverage, 10696,
     /* 115716 */   GIR_EraseRootFromParent_Done,
     /* 115717 */ // Label 1908: @115717
     /* 115717 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(115749), // Rule ID 10709 //
     /* 115722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115736 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115748 */   // GIR_Coverage, 10709,
     /* 115748 */   GIR_EraseRootFromParent_Done,
     /* 115749 */ // Label 1909: @115749
     /* 115749 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(115781), // Rule ID 10710 //
     /* 115754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115768 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115780 */   // GIR_Coverage, 10710,
     /* 115780 */   GIR_EraseRootFromParent_Done,
     /* 115781 */ // Label 1910: @115781
     /* 115781 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(115813), // Rule ID 10711 //
     /* 115786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115800 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115812 */   // GIR_Coverage, 10711,
     /* 115812 */   GIR_EraseRootFromParent_Done,
     /* 115813 */ // Label 1911: @115813
     /* 115813 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(115845), // Rule ID 10712 //
     /* 115818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115832 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115844 */   // GIR_Coverage, 10712,
     /* 115844 */   GIR_EraseRootFromParent_Done,
     /* 115845 */ // Label 1912: @115845
     /* 115845 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115877), // Rule ID 10713 //
     /* 115850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115864 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115876 */   // GIR_Coverage, 10713,
     /* 115876 */   GIR_EraseRootFromParent_Done,
     /* 115877 */ // Label 1913: @115877
     /* 115877 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(115909), // Rule ID 10714 //
     /* 115882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115896 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115908 */   // GIR_Coverage, 10714,
     /* 115908 */   GIR_EraseRootFromParent_Done,
     /* 115909 */ // Label 1914: @115909
     /* 115909 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115941), // Rule ID 10723 //
     /* 115914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115928 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115931 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115933 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115940 */   // GIR_Coverage, 10723,
     /* 115940 */   GIR_EraseRootFromParent_Done,
     /* 115941 */ // Label 1915: @115941
     /* 115941 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115973), // Rule ID 10724 //
     /* 115946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115960 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115963 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115972 */   // GIR_Coverage, 10724,
     /* 115972 */   GIR_EraseRootFromParent_Done,
     /* 115973 */ // Label 1916: @115973
     /* 115973 */ GIM_Reject,
     /* 115974 */ // Label 1635: @115974
     /* 115974 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(116006), // Rule ID 10685 //
     /* 115979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115993 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115996 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115998 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116005 */   // GIR_Coverage, 10685,
     /* 116005 */   GIR_EraseRootFromParent_Done,
     /* 116006 */ // Label 1917: @116006
     /* 116006 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(116038), // Rule ID 10686 //
     /* 116011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116025 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116028 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116037 */   // GIR_Coverage, 10686,
     /* 116037 */   GIR_EraseRootFromParent_Done,
     /* 116038 */ // Label 1918: @116038
     /* 116038 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(116070), // Rule ID 10687 //
     /* 116043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116057 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116069 */   // GIR_Coverage, 10687,
     /* 116069 */   GIR_EraseRootFromParent_Done,
     /* 116070 */ // Label 1919: @116070
     /* 116070 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(116102), // Rule ID 10688 //
     /* 116075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116089 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116101 */   // GIR_Coverage, 10688,
     /* 116101 */   GIR_EraseRootFromParent_Done,
     /* 116102 */ // Label 1920: @116102
     /* 116102 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(116134), // Rule ID 10689 //
     /* 116107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116121 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116133 */   // GIR_Coverage, 10689,
     /* 116133 */   GIR_EraseRootFromParent_Done,
     /* 116134 */ // Label 1921: @116134
     /* 116134 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(116166), // Rule ID 10690 //
     /* 116139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116153 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116165 */   // GIR_Coverage, 10690,
     /* 116165 */   GIR_EraseRootFromParent_Done,
     /* 116166 */ // Label 1922: @116166
     /* 116166 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(116198), // Rule ID 10703 //
     /* 116171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 116177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116185 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116197 */   // GIR_Coverage, 10703,
     /* 116197 */   GIR_EraseRootFromParent_Done,
     /* 116198 */ // Label 1923: @116198
     /* 116198 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(116230), // Rule ID 10704 //
     /* 116203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116217 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116229 */   // GIR_Coverage, 10704,
     /* 116229 */   GIR_EraseRootFromParent_Done,
     /* 116230 */ // Label 1924: @116230
     /* 116230 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(116262), // Rule ID 10705 //
     /* 116235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116249 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116261 */   // GIR_Coverage, 10705,
     /* 116261 */   GIR_EraseRootFromParent_Done,
     /* 116262 */ // Label 1925: @116262
     /* 116262 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(116294), // Rule ID 10706 //
     /* 116267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116281 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116284 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116286 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116293 */   // GIR_Coverage, 10706,
     /* 116293 */   GIR_EraseRootFromParent_Done,
     /* 116294 */ // Label 1926: @116294
     /* 116294 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(116326), // Rule ID 10707 //
     /* 116299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116313 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116316 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116318 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116325 */   // GIR_Coverage, 10707,
     /* 116325 */   GIR_EraseRootFromParent_Done,
     /* 116326 */ // Label 1927: @116326
     /* 116326 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(116358), // Rule ID 10708 //
     /* 116331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116345 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116348 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116357 */   // GIR_Coverage, 10708,
     /* 116357 */   GIR_EraseRootFromParent_Done,
     /* 116358 */ // Label 1928: @116358
     /* 116358 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(116390), // Rule ID 10721 //
     /* 116363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 116366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116377 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 116377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116380 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116389 */   // GIR_Coverage, 10721,
     /* 116389 */   GIR_EraseRootFromParent_Done,
     /* 116390 */ // Label 1929: @116390
     /* 116390 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(116422), // Rule ID 10722 //
     /* 116395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 116398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116409 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116412 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116414 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116421 */   // GIR_Coverage, 10722,
     /* 116421 */   GIR_EraseRootFromParent_Done,
     /* 116422 */ // Label 1930: @116422
     /* 116422 */ GIM_Reject,
     /* 116423 */ // Label 1636: @116423
     /* 116423 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(116455), // Rule ID 10679 //
     /* 116428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116442 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116445 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116447 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116454 */   // GIR_Coverage, 10679,
     /* 116454 */   GIR_EraseRootFromParent_Done,
     /* 116455 */ // Label 1931: @116455
     /* 116455 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(116487), // Rule ID 10680 //
     /* 116460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116474 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116477 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116486 */   // GIR_Coverage, 10680,
     /* 116486 */   GIR_EraseRootFromParent_Done,
     /* 116487 */ // Label 1932: @116487
     /* 116487 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(116519), // Rule ID 10681 //
     /* 116492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116506 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116509 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116511 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116518 */   // GIR_Coverage, 10681,
     /* 116518 */   GIR_EraseRootFromParent_Done,
     /* 116519 */ // Label 1933: @116519
     /* 116519 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(116551), // Rule ID 10682 //
     /* 116524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116538 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116541 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116550 */   // GIR_Coverage, 10682,
     /* 116550 */   GIR_EraseRootFromParent_Done,
     /* 116551 */ // Label 1934: @116551
     /* 116551 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(116583), // Rule ID 10683 //
     /* 116556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116570 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116573 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116575 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116582 */   // GIR_Coverage, 10683,
     /* 116582 */   GIR_EraseRootFromParent_Done,
     /* 116583 */ // Label 1935: @116583
     /* 116583 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(116615), // Rule ID 10684 //
     /* 116588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116602 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116605 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116607 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116614 */   // GIR_Coverage, 10684,
     /* 116614 */   GIR_EraseRootFromParent_Done,
     /* 116615 */ // Label 1936: @116615
     /* 116615 */ GIM_Reject,
     /* 116616 */ // Label 1637: @116616
     /* 116616 */ GIM_Reject,
     /* 116617 */ // Label 10: @116617
     /* 116617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1945*/ GIMT_Encode4(117107),
     /* 116628 */ /*GILLT_s16*//*Label 1937*/ GIMT_Encode4(116668),
     /* 116632 */ /*GILLT_s32*//*Label 1938*/ GIMT_Encode4(116699),
     /* 116636 */ /*GILLT_s64*//*Label 1939*/ GIMT_Encode4(116730), GIMT_Encode4(0),
     /* 116644 */ /*GILLT_v2s32*//*Label 1940*/ GIMT_Encode4(116761),
     /* 116648 */ /*GILLT_v2s64*//*Label 1941*/ GIMT_Encode4(116792),
     /* 116652 */ /*GILLT_v4s16*//*Label 1942*/ GIMT_Encode4(116823),
     /* 116656 */ /*GILLT_v4s32*//*Label 1943*/ GIMT_Encode4(116854), GIMT_Encode4(0),
     /* 116664 */ /*GILLT_v8s16*//*Label 1944*/ GIMT_Encode4(116885),
     /* 116668 */ // Label 1937: @116668
     /* 116668 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(116698), // Rule ID 568 //
     /* 116673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116687 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 116692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116696 */   GIR_RootConstrainSelectedInstOperands,
     /* 116697 */   // GIR_Coverage, 568,
     /* 116697 */   GIR_Done,
     /* 116698 */ // Label 1946: @116698
     /* 116698 */ GIM_Reject,
     /* 116699 */ // Label 1938: @116699
     /* 116699 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(116729), // Rule ID 570 //
     /* 116704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116718 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 116723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116727 */   GIR_RootConstrainSelectedInstOperands,
     /* 116728 */   // GIR_Coverage, 570,
     /* 116728 */   GIR_Done,
     /* 116729 */ // Label 1947: @116729
     /* 116729 */ GIM_Reject,
     /* 116730 */ // Label 1939: @116730
     /* 116730 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(116760), // Rule ID 572 //
     /* 116735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116749 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 116754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116758 */   GIR_RootConstrainSelectedInstOperands,
     /* 116759 */   // GIR_Coverage, 572,
     /* 116759 */   GIR_Done,
     /* 116760 */ // Label 1948: @116760
     /* 116760 */ GIM_Reject,
     /* 116761 */ // Label 1940: @116761
     /* 116761 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(116791), // Rule ID 937 //
     /* 116766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116780 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 116785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116789 */   GIR_RootConstrainSelectedInstOperands,
     /* 116790 */   // GIR_Coverage, 937,
     /* 116790 */   GIR_Done,
     /* 116791 */ // Label 1949: @116791
     /* 116791 */ GIM_Reject,
     /* 116792 */ // Label 1941: @116792
     /* 116792 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(116822), // Rule ID 941 //
     /* 116797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116811 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 116816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116820 */   GIR_RootConstrainSelectedInstOperands,
     /* 116821 */   // GIR_Coverage, 941,
     /* 116821 */   GIR_Done,
     /* 116822 */ // Label 1950: @116822
     /* 116822 */ GIM_Reject,
     /* 116823 */ // Label 1942: @116823
     /* 116823 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(116853), // Rule ID 933 //
     /* 116828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116842 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 116847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116851 */   GIR_RootConstrainSelectedInstOperands,
     /* 116852 */   // GIR_Coverage, 933,
     /* 116852 */   GIR_Done,
     /* 116853 */ // Label 1951: @116853
     /* 116853 */ GIM_Reject,
     /* 116854 */ // Label 1943: @116854
     /* 116854 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(116884), // Rule ID 939 //
     /* 116859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116873 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116882 */   GIR_RootConstrainSelectedInstOperands,
     /* 116883 */   // GIR_Coverage, 939,
     /* 116883 */   GIR_Done,
     /* 116884 */ // Label 1952: @116884
     /* 116884 */ GIM_Reject,
     /* 116885 */ // Label 1944: @116885
     /* 116885 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(117106),
     /* 116890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116901 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(116920), // Rule ID 935 //
     /* 116906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116909 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 116914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116918 */     GIR_RootConstrainSelectedInstOperands,
     /* 116919 */     // GIR_Coverage, 935,
     /* 116919 */     GIR_Done,
     /* 116920 */   // Label 1954: @116920
     /* 116920 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(117105), // Rule ID 7088 //
     /* 116925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116928 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116928 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116931 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116935 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116940 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116946 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116949 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116953 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116958 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116963 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116966 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116970 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116975 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116981 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116986 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117003 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 117006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 117008 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 117011 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 117015 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117020 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 117023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 117028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 117032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117037 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 117040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 117045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117068 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 117074 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 117095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 117103 */     GIR_RootConstrainSelectedInstOperands,
     /* 117104 */     // GIR_Coverage, 7088,
     /* 117104 */     GIR_EraseRootFromParent_Done,
     /* 117105 */   // Label 1955: @117105
     /* 117105 */   GIM_Reject,
     /* 117106 */ // Label 1953: @117106
     /* 117106 */ GIM_Reject,
     /* 117107 */ // Label 1945: @117107
     /* 117107 */ GIM_Reject,
     /* 117108 */ // Label 11: @117108
     /* 117108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1964*/ GIMT_Encode4(117598),
     /* 117119 */ /*GILLT_s16*//*Label 1956*/ GIMT_Encode4(117159),
     /* 117123 */ /*GILLT_s32*//*Label 1957*/ GIMT_Encode4(117190),
     /* 117127 */ /*GILLT_s64*//*Label 1958*/ GIMT_Encode4(117221), GIMT_Encode4(0),
     /* 117135 */ /*GILLT_v2s32*//*Label 1959*/ GIMT_Encode4(117252),
     /* 117139 */ /*GILLT_v2s64*//*Label 1960*/ GIMT_Encode4(117283),
     /* 117143 */ /*GILLT_v4s16*//*Label 1961*/ GIMT_Encode4(117314),
     /* 117147 */ /*GILLT_v4s32*//*Label 1962*/ GIMT_Encode4(117345), GIMT_Encode4(0),
     /* 117155 */ /*GILLT_v8s16*//*Label 1963*/ GIMT_Encode4(117376),
     /* 117159 */ // Label 1956: @117159
     /* 117159 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(117189), // Rule ID 532 //
     /* 117164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117178 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 117178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 117183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117187 */   GIR_RootConstrainSelectedInstOperands,
     /* 117188 */   // GIR_Coverage, 532,
     /* 117188 */   GIR_Done,
     /* 117189 */ // Label 1965: @117189
     /* 117189 */ GIM_Reject,
     /* 117190 */ // Label 1957: @117190
     /* 117190 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(117220), // Rule ID 534 //
     /* 117195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117209 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 117209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 117214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117218 */   GIR_RootConstrainSelectedInstOperands,
     /* 117219 */   // GIR_Coverage, 534,
     /* 117219 */   GIR_Done,
     /* 117220 */ // Label 1966: @117220
     /* 117220 */ GIM_Reject,
     /* 117221 */ // Label 1958: @117221
     /* 117221 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(117251), // Rule ID 536 //
     /* 117226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117240 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 117240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 117245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117249 */   GIR_RootConstrainSelectedInstOperands,
     /* 117250 */   // GIR_Coverage, 536,
     /* 117250 */   GIR_Done,
     /* 117251 */ // Label 1967: @117251
     /* 117251 */ GIM_Reject,
     /* 117252 */ // Label 1959: @117252
     /* 117252 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(117282), // Rule ID 877 //
     /* 117257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117271 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 117271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 117276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117280 */   GIR_RootConstrainSelectedInstOperands,
     /* 117281 */   // GIR_Coverage, 877,
     /* 117281 */   GIR_Done,
     /* 117282 */ // Label 1968: @117282
     /* 117282 */ GIM_Reject,
     /* 117283 */ // Label 1960: @117283
     /* 117283 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(117313), // Rule ID 881 //
     /* 117288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117302 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 117302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 117307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117311 */   GIR_RootConstrainSelectedInstOperands,
     /* 117312 */   // GIR_Coverage, 881,
     /* 117312 */   GIR_Done,
     /* 117313 */ // Label 1969: @117313
     /* 117313 */ GIM_Reject,
     /* 117314 */ // Label 1961: @117314
     /* 117314 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(117344), // Rule ID 873 //
     /* 117319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117333 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 117333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 117338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117342 */   GIR_RootConstrainSelectedInstOperands,
     /* 117343 */   // GIR_Coverage, 873,
     /* 117343 */   GIR_Done,
     /* 117344 */ // Label 1970: @117344
     /* 117344 */ GIM_Reject,
     /* 117345 */ // Label 1962: @117345
     /* 117345 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(117375), // Rule ID 879 //
     /* 117350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117364 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 117364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117373 */   GIR_RootConstrainSelectedInstOperands,
     /* 117374 */   // GIR_Coverage, 879,
     /* 117374 */   GIR_Done,
     /* 117375 */ // Label 1971: @117375
     /* 117375 */ GIM_Reject,
     /* 117376 */ // Label 1963: @117376
     /* 117376 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(117597),
     /* 117381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117392 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(117411), // Rule ID 875 //
     /* 117397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117400 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 117405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117409 */     GIR_RootConstrainSelectedInstOperands,
     /* 117410 */     // GIR_Coverage, 875,
     /* 117410 */     GIR_Done,
     /* 117411 */   // Label 1973: @117411
     /* 117411 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(117596), // Rule ID 7082 //
     /* 117416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117419 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117419 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117422 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117426 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117431 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117437 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117440 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117444 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117449 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117454 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117457 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117461 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117466 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 117485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 117489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117494 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 117497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 117499 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 117502 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117506 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117511 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 117514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 117519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 117523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117528 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 117531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 117536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 117565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 117586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 117594 */     GIR_RootConstrainSelectedInstOperands,
     /* 117595 */     // GIR_Coverage, 7082,
     /* 117595 */     GIR_EraseRootFromParent_Done,
     /* 117596 */   // Label 1974: @117596
     /* 117596 */   GIM_Reject,
     /* 117597 */ // Label 1972: @117597
     /* 117597 */ GIM_Reject,
     /* 117598 */ // Label 1964: @117598
     /* 117598 */ GIM_Reject,
     /* 117599 */ // Label 12: @117599
     /* 117599 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1977*/ GIMT_Encode4(117866),
     /* 117610 */ /*GILLT_s32*//*Label 1975*/ GIMT_Encode4(117618),
     /* 117614 */ /*GILLT_s64*//*Label 1976*/ GIMT_Encode4(117742),
     /* 117618 */ // Label 1975: @117618
     /* 117618 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(117661), // Rule ID 4854 //
     /* 117623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117633 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 117654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117659 */   GIR_RootConstrainSelectedInstOperands,
     /* 117660 */   // GIR_Coverage, 4854,
     /* 117660 */   GIR_EraseRootFromParent_Done,
     /* 117661 */ // Label 1978: @117661
     /* 117661 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(117701), // Rule ID 4860 //
     /* 117666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117673 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 117694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117699 */   GIR_RootConstrainSelectedInstOperands,
     /* 117700 */   // GIR_Coverage, 4860,
     /* 117700 */   GIR_EraseRootFromParent_Done,
     /* 117701 */ // Label 1979: @117701
     /* 117701 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(117741), // Rule ID 4862 //
     /* 117706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117713 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117725 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 117734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117739 */   GIR_RootConstrainSelectedInstOperands,
     /* 117740 */   // GIR_Coverage, 4862,
     /* 117740 */   GIR_EraseRootFromParent_Done,
     /* 117741 */ // Label 1980: @117741
     /* 117741 */ GIM_Reject,
     /* 117742 */ // Label 1976: @117742
     /* 117742 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(117785), // Rule ID 4856 //
     /* 117747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117757 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117783 */   GIR_RootConstrainSelectedInstOperands,
     /* 117784 */   // GIR_Coverage, 4856,
     /* 117784 */   GIR_EraseRootFromParent_Done,
     /* 117785 */ // Label 1981: @117785
     /* 117785 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(117825), // Rule ID 4864 //
     /* 117790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117797 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117809 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117823 */   GIR_RootConstrainSelectedInstOperands,
     /* 117824 */   // GIR_Coverage, 4864,
     /* 117824 */   GIR_EraseRootFromParent_Done,
     /* 117825 */ // Label 1982: @117825
     /* 117825 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(117865), // Rule ID 4866 //
     /* 117830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117837 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117849 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117863 */   GIR_RootConstrainSelectedInstOperands,
     /* 117864 */   // GIR_Coverage, 4866,
     /* 117864 */   GIR_EraseRootFromParent_Done,
     /* 117865 */ // Label 1983: @117865
     /* 117865 */ GIM_Reject,
     /* 117866 */ // Label 1977: @117866
     /* 117866 */ GIM_Reject,
     /* 117867 */ // Label 13: @117867
     /* 117867 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(118016),
     /* 117872 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 117875 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1988*/ GIMT_Encode4(118015),
     /* 117886 */   /*GILLT_s16*//*Label 1985*/ GIMT_Encode4(117898),
     /* 117890 */   /*GILLT_s32*//*Label 1986*/ GIMT_Encode4(117939),
     /* 117894 */   /*GILLT_s64*//*Label 1987*/ GIMT_Encode4(117977),
     /* 117898 */   // Label 1985: @117898
     /* 117898 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(117938), // Rule ID 4858 //
     /* 117903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117910 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117936 */     GIR_RootConstrainSelectedInstOperands,
     /* 117937 */     // GIR_Coverage, 4858,
     /* 117937 */     GIR_EraseRootFromParent_Done,
     /* 117938 */   // Label 1989: @117938
     /* 117938 */   GIM_Reject,
     /* 117939 */   // Label 1986: @117939
     /* 117939 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(117976), // Rule ID 4868 //
     /* 117944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117948 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117974 */     GIR_RootConstrainSelectedInstOperands,
     /* 117975 */     // GIR_Coverage, 4868,
     /* 117975 */     GIR_EraseRootFromParent_Done,
     /* 117976 */   // Label 1990: @117976
     /* 117976 */   GIM_Reject,
     /* 117977 */   // Label 1987: @117977
     /* 117977 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(118014), // Rule ID 4870 //
     /* 117982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117986 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 118002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 118007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 118009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118012 */     GIR_RootConstrainSelectedInstOperands,
     /* 118013 */     // GIR_Coverage, 4870,
     /* 118013 */     GIR_EraseRootFromParent_Done,
     /* 118014 */   // Label 1991: @118014
     /* 118014 */   GIM_Reject,
     /* 118015 */   // Label 1988: @118015
     /* 118015 */   GIM_Reject,
     /* 118016 */ // Label 1984: @118016
     /* 118016 */ GIM_Reject,
     /* 118017 */ // Label 14: @118017
     /* 118017 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 2000*/ GIMT_Encode4(118507),
     /* 118028 */ /*GILLT_s16*//*Label 1992*/ GIMT_Encode4(118068),
     /* 118032 */ /*GILLT_s32*//*Label 1993*/ GIMT_Encode4(118099),
     /* 118036 */ /*GILLT_s64*//*Label 1994*/ GIMT_Encode4(118130), GIMT_Encode4(0),
     /* 118044 */ /*GILLT_v2s32*//*Label 1995*/ GIMT_Encode4(118161),
     /* 118048 */ /*GILLT_v2s64*//*Label 1996*/ GIMT_Encode4(118192),
     /* 118052 */ /*GILLT_v4s16*//*Label 1997*/ GIMT_Encode4(118223),
     /* 118056 */ /*GILLT_v4s32*//*Label 1998*/ GIMT_Encode4(118254), GIMT_Encode4(0),
     /* 118064 */ /*GILLT_v8s16*//*Label 1999*/ GIMT_Encode4(118285),
     /* 118068 */ // Label 1992: @118068
     /* 118068 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(118098), // Rule ID 550 //
     /* 118073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 118076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118087 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 118087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 118092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118096 */   GIR_RootConstrainSelectedInstOperands,
     /* 118097 */   // GIR_Coverage, 550,
     /* 118097 */   GIR_Done,
     /* 118098 */ // Label 2001: @118098
     /* 118098 */ GIM_Reject,
     /* 118099 */ // Label 1993: @118099
     /* 118099 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(118129), // Rule ID 552 //
     /* 118104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118118 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 118118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 118123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118127 */   GIR_RootConstrainSelectedInstOperands,
     /* 118128 */   // GIR_Coverage, 552,
     /* 118128 */   GIR_Done,
     /* 118129 */ // Label 2002: @118129
     /* 118129 */ GIM_Reject,
     /* 118130 */ // Label 1994: @118130
     /* 118130 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(118160), // Rule ID 554 //
     /* 118135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 118141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118149 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 118149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 118154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118158 */   GIR_RootConstrainSelectedInstOperands,
     /* 118159 */   // GIR_Coverage, 554,
     /* 118159 */   GIR_Done,
     /* 118160 */ // Label 2003: @118160
     /* 118160 */ GIM_Reject,
     /* 118161 */ // Label 1995: @118161
     /* 118161 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(118191), // Rule ID 907 //
     /* 118166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118180 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 118180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 118185 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118189 */   GIR_RootConstrainSelectedInstOperands,
     /* 118190 */   // GIR_Coverage, 907,
     /* 118190 */   GIR_Done,
     /* 118191 */ // Label 2004: @118191
     /* 118191 */ GIM_Reject,
     /* 118192 */ // Label 1996: @118192
     /* 118192 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(118222), // Rule ID 911 //
     /* 118197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118211 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 118211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 118216 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118220 */   GIR_RootConstrainSelectedInstOperands,
     /* 118221 */   // GIR_Coverage, 911,
     /* 118221 */   GIR_Done,
     /* 118222 */ // Label 2005: @118222
     /* 118222 */ GIM_Reject,
     /* 118223 */ // Label 1997: @118223
     /* 118223 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(118253), // Rule ID 903 //
     /* 118228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118242 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 118242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 118247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118251 */   GIR_RootConstrainSelectedInstOperands,
     /* 118252 */   // GIR_Coverage, 903,
     /* 118252 */   GIR_Done,
     /* 118253 */ // Label 2006: @118253
     /* 118253 */ GIM_Reject,
     /* 118254 */ // Label 1998: @118254
     /* 118254 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(118284), // Rule ID 909 //
     /* 118259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118273 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 118273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118282 */   GIR_RootConstrainSelectedInstOperands,
     /* 118283 */   // GIR_Coverage, 909,
     /* 118283 */   GIR_Done,
     /* 118284 */ // Label 2007: @118284
     /* 118284 */ GIM_Reject,
     /* 118285 */ // Label 1999: @118285
     /* 118285 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(118506),
     /* 118290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118301 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(118320), // Rule ID 905 //
     /* 118306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118309 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 118309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 118314 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 118318 */     GIR_RootConstrainSelectedInstOperands,
     /* 118319 */     // GIR_Coverage, 905,
     /* 118319 */     GIR_Done,
     /* 118320 */   // Label 2009: @118320
     /* 118320 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(118505), // Rule ID 7084 //
     /* 118325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 118328 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 118328 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 118331 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 118335 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118340 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 118344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 118346 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 118349 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118353 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118358 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 118361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 118363 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 118366 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118370 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118375 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 118381 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118386 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118391 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 118394 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 118398 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118403 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 118406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118408 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 118411 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118415 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118420 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118425 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 118428 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 118432 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118437 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118442 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 118445 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118449 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 118459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 118474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 118477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 118495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 118503 */     GIR_RootConstrainSelectedInstOperands,
     /* 118504 */     // GIR_Coverage, 7084,
     /* 118504 */     GIR_EraseRootFromParent_Done,
     /* 118505 */   // Label 2010: @118505
     /* 118505 */   GIM_Reject,
     /* 118506 */ // Label 2008: @118506
     /* 118506 */ GIM_Reject,
     /* 118507 */ // Label 2000: @118507
     /* 118507 */ GIM_Reject,
     /* 118508 */ // Label 15: @118508
     /* 118508 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(118540), // Rule ID 3937 //
     /* 118513 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 118516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118520 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 118520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 118523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118525 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 118535 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 118538 */   GIR_RootConstrainSelectedInstOperands,
     /* 118539 */   // GIR_Coverage, 3937,
     /* 118539 */   GIR_EraseRootFromParent_Done,
     /* 118540 */ // Label 2011: @118540
     /* 118540 */ GIM_Reject,
     /* 118541 */ // Label 16: @118541
     /* 118541 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2032*/ GIMT_Encode4(127478),
     /* 118552 */ /*GILLT_s8*//*Label 2012*/ GIMT_Encode4(118648),
     /* 118556 */ /*GILLT_s16*//*Label 2013*/ GIMT_Encode4(118824),
     /* 118560 */ /*GILLT_s32*//*Label 2014*/ GIMT_Encode4(119000),
     /* 118564 */ /*GILLT_s64*//*Label 2015*/ GIMT_Encode4(121394),
     /* 118568 */ /*GILLT_s128*//*Label 2016*/ GIMT_Encode4(124107),
     /* 118572 */ /*GILLT_v2s32*//*Label 2017*/ GIMT_Encode4(124316),
     /* 118576 */ /*GILLT_v2s64*//*Label 2018*/ GIMT_Encode4(124694),
     /* 118580 */ /*GILLT_v4s16*//*Label 2019*/ GIMT_Encode4(125072),
     /* 118584 */ /*GILLT_v4s32*//*Label 2020*/ GIMT_Encode4(125450),
     /* 118588 */ /*GILLT_v8s8*//*Label 2021*/ GIMT_Encode4(125828),
     /* 118592 */ /*GILLT_v8s16*//*Label 2022*/ GIMT_Encode4(126036),
     /* 118596 */ /*GILLT_v16s8*//*Label 2023*/ GIMT_Encode4(126414), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118608 */ /*GILLT_nxv2s16*//*Label 2024*/ GIMT_Encode4(126622),
     /* 118612 */ /*GILLT_nxv2s32*//*Label 2025*/ GIMT_Encode4(126686),
     /* 118616 */ /*GILLT_nxv2s64*//*Label 2026*/ GIMT_Encode4(126750), GIMT_Encode4(0),
     /* 118624 */ /*GILLT_nxv4s16*//*Label 2027*/ GIMT_Encode4(126924),
     /* 118628 */ /*GILLT_nxv4s32*//*Label 2028*/ GIMT_Encode4(126988), GIMT_Encode4(0),
     /* 118636 */ /*GILLT_nxv8s16*//*Label 2029*/ GIMT_Encode4(127162),
     /* 118640 */ /*GILLT_nxv16s1*//*Label 2030*/ GIMT_Encode4(127336),
     /* 118644 */ /*GILLT_nxv16s8*//*Label 2031*/ GIMT_Encode4(127380),
     /* 118648 */ // Label 2012: @118648
     /* 118648 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118823),
     /* 118653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 118664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118668 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118709), // Rule ID 241 //
     /* 118673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118683 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 118686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118707 */     GIR_RootConstrainSelectedInstOperands,
     /* 118708 */     // GIR_Coverage, 241,
     /* 118708 */     GIR_EraseRootFromParent_Done,
     /* 118709 */   // Label 2034: @118709
     /* 118709 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118750), // Rule ID 242 //
     /* 118714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118724 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 118727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118748 */     GIR_RootConstrainSelectedInstOperands,
     /* 118749 */     // GIR_Coverage, 242,
     /* 118749 */     GIR_EraseRootFromParent_Done,
     /* 118750 */   // Label 2035: @118750
     /* 118750 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118786), // Rule ID 265 //
     /* 118755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118765 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 118768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118784 */     GIR_RootConstrainSelectedInstOperands,
     /* 118785 */     // GIR_Coverage, 265,
     /* 118785 */     GIR_EraseRootFromParent_Done,
     /* 118786 */   // Label 2036: @118786
     /* 118786 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118822), // Rule ID 286 //
     /* 118791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118801 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 118804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118820 */     GIR_RootConstrainSelectedInstOperands,
     /* 118821 */     // GIR_Coverage, 286,
     /* 118821 */     GIR_EraseRootFromParent_Done,
     /* 118822 */   // Label 2037: @118822
     /* 118822 */   GIM_Reject,
     /* 118823 */ // Label 2033: @118823
     /* 118823 */ GIM_Reject,
     /* 118824 */ // Label 2013: @118824
     /* 118824 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118999),
     /* 118829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118832 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118844 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118885), // Rule ID 243 //
     /* 118849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118859 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 118862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118883 */     GIR_RootConstrainSelectedInstOperands,
     /* 118884 */     // GIR_Coverage, 243,
     /* 118884 */     GIR_EraseRootFromParent_Done,
     /* 118885 */   // Label 2039: @118885
     /* 118885 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118926), // Rule ID 244 //
     /* 118890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118900 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 118903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118924 */     GIR_RootConstrainSelectedInstOperands,
     /* 118925 */     // GIR_Coverage, 244,
     /* 118925 */     GIR_EraseRootFromParent_Done,
     /* 118926 */   // Label 2040: @118926
     /* 118926 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118962), // Rule ID 266 //
     /* 118931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118941 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 118944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118960 */     GIR_RootConstrainSelectedInstOperands,
     /* 118961 */     // GIR_Coverage, 266,
     /* 118961 */     GIR_EraseRootFromParent_Done,
     /* 118962 */   // Label 2041: @118962
     /* 118962 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118998), // Rule ID 287 //
     /* 118967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118977 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 118980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118996 */     GIR_RootConstrainSelectedInstOperands,
     /* 118997 */     // GIR_Coverage, 287,
     /* 118997 */     GIR_EraseRootFromParent_Done,
     /* 118998 */   // Label 2042: @118998
     /* 118998 */   GIM_Reject,
     /* 118999 */ // Label 2038: @118999
     /* 118999 */ GIM_Reject,
     /* 119000 */ // Label 2014: @119000
     /* 119000 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(119053), // Rule ID 237 //
     /* 119005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119008 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119027 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119051 */   GIR_RootConstrainSelectedInstOperands,
     /* 119052 */   // GIR_Coverage, 237,
     /* 119052 */   GIR_EraseRootFromParent_Done,
     /* 119053 */ // Label 2043: @119053
     /* 119053 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(119106), // Rule ID 238 //
     /* 119058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119080 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119104 */   GIR_RootConstrainSelectedInstOperands,
     /* 119105 */   // GIR_Coverage, 238,
     /* 119105 */   GIR_EraseRootFromParent_Done,
     /* 119106 */ // Label 2044: @119106
     /* 119106 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(119162), // Rule ID 245 //
     /* 119111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119136 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 119139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119160 */   GIR_RootConstrainSelectedInstOperands,
     /* 119161 */   // GIR_Coverage, 245,
     /* 119161 */   GIR_EraseRootFromParent_Done,
     /* 119162 */ // Label 2045: @119162
     /* 119162 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(119218), // Rule ID 246 //
     /* 119167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119185 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119192 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 119195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119216 */   GIR_RootConstrainSelectedInstOperands,
     /* 119217 */   // GIR_Coverage, 246,
     /* 119217 */   GIR_EraseRootFromParent_Done,
     /* 119218 */ // Label 2046: @119218
     /* 119218 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(119278), // Rule ID 4153 //
     /* 119223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119226 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119252 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 119252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119276 */   GIR_RootConstrainSelectedInstOperands,
     /* 119277 */   // GIR_Coverage, 4153,
     /* 119277 */   GIR_EraseRootFromParent_Done,
     /* 119278 */ // Label 2047: @119278
     /* 119278 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(119338), // Rule ID 4154 //
     /* 119283 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119286 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119290 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119312 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119336 */   GIR_RootConstrainSelectedInstOperands,
     /* 119337 */   // GIR_Coverage, 4154,
     /* 119337 */   GIR_EraseRootFromParent_Done,
     /* 119338 */ // Label 2048: @119338
     /* 119338 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(119398), // Rule ID 4155 //
     /* 119343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119346 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119361 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119372 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 119375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119392 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119396 */   GIR_RootConstrainSelectedInstOperands,
     /* 119397 */   // GIR_Coverage, 4155,
     /* 119397 */   GIR_EraseRootFromParent_Done,
     /* 119398 */ // Label 2049: @119398
     /* 119398 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(119458), // Rule ID 4156 //
     /* 119403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119406 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119410 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119421 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119425 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119432 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119456 */   GIR_RootConstrainSelectedInstOperands,
     /* 119457 */   // GIR_Coverage, 4156,
     /* 119457 */   GIR_EraseRootFromParent_Done,
     /* 119458 */ // Label 2050: @119458
     /* 119458 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(119518), // Rule ID 4157 //
     /* 119463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119466 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119485 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119492 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119516 */   GIR_RootConstrainSelectedInstOperands,
     /* 119517 */   // GIR_Coverage, 4157,
     /* 119517 */   GIR_EraseRootFromParent_Done,
     /* 119518 */ // Label 2051: @119518
     /* 119518 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(119578), // Rule ID 4158 //
     /* 119523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119526 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119552 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119576 */   GIR_RootConstrainSelectedInstOperands,
     /* 119577 */   // GIR_Coverage, 4158,
     /* 119577 */   GIR_EraseRootFromParent_Done,
     /* 119578 */ // Label 2052: @119578
     /* 119578 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119626), // Rule ID 264 //
     /* 119583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119586 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119605 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 119608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119624 */   GIR_RootConstrainSelectedInstOperands,
     /* 119625 */   // GIR_Coverage, 264,
     /* 119625 */   GIR_EraseRootFromParent_Done,
     /* 119626 */ // Label 2053: @119626
     /* 119626 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119677), // Rule ID 267 //
     /* 119631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119656 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 119659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119675 */   GIR_RootConstrainSelectedInstOperands,
     /* 119676 */   // GIR_Coverage, 267,
     /* 119676 */   GIR_EraseRootFromParent_Done,
     /* 119677 */ // Label 2054: @119677
     /* 119677 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119740), // Rule ID 7114 //
     /* 119682 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119685 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119696 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119714 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 119714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119738 */   GIR_RootConstrainSelectedInstOperands,
     /* 119739 */   // GIR_Coverage, 7114,
     /* 119739 */   GIR_EraseRootFromParent_Done,
     /* 119740 */ // Label 2055: @119740
     /* 119740 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119803), // Rule ID 7116 //
     /* 119745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119748 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119759 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119777 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 119777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119801 */   GIR_RootConstrainSelectedInstOperands,
     /* 119802 */   // GIR_Coverage, 7116,
     /* 119802 */   GIR_EraseRootFromParent_Done,
     /* 119803 */ // Label 2056: @119803
     /* 119803 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119866), // Rule ID 7126 //
     /* 119808 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119811 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119822 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119840 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 119843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119864 */   GIR_RootConstrainSelectedInstOperands,
     /* 119865 */   // GIR_Coverage, 7126,
     /* 119865 */   GIR_EraseRootFromParent_Done,
     /* 119866 */ // Label 2057: @119866
     /* 119866 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119929), // Rule ID 7128 //
     /* 119871 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119874 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119878 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119885 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119903 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119927 */   GIR_RootConstrainSelectedInstOperands,
     /* 119928 */   // GIR_Coverage, 7128,
     /* 119928 */   GIR_EraseRootFromParent_Done,
     /* 119929 */ // Label 2058: @119929
     /* 119929 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119992), // Rule ID 7136 //
     /* 119934 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119937 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119948 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119966 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119990 */   GIR_RootConstrainSelectedInstOperands,
     /* 119991 */   // GIR_Coverage, 7136,
     /* 119991 */   GIR_EraseRootFromParent_Done,
     /* 119992 */ // Label 2059: @119992
     /* 119992 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(120055), // Rule ID 7137 //
     /* 119997 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120011 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120029 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 120029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 120032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120053 */   GIR_RootConstrainSelectedInstOperands,
     /* 120054 */   // GIR_Coverage, 7137,
     /* 120054 */   GIR_EraseRootFromParent_Done,
     /* 120055 */ // Label 2060: @120055
     /* 120055 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(120103), // Rule ID 285 //
     /* 120060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120075 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120082 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 120085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120101 */   GIR_RootConstrainSelectedInstOperands,
     /* 120102 */   // GIR_Coverage, 285,
     /* 120102 */   GIR_EraseRootFromParent_Done,
     /* 120103 */ // Label 2061: @120103
     /* 120103 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120154), // Rule ID 288 //
     /* 120108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 120122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120133 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 120136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120152 */   GIR_RootConstrainSelectedInstOperands,
     /* 120153 */   // GIR_Coverage, 288,
     /* 120153 */   GIR_EraseRootFromParent_Done,
     /* 120154 */ // Label 2062: @120154
     /* 120154 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(120209), // Rule ID 4180 //
     /* 120159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120188 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 120191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120207 */   GIR_RootConstrainSelectedInstOperands,
     /* 120208 */   // GIR_Coverage, 4180,
     /* 120208 */   GIR_EraseRootFromParent_Done,
     /* 120209 */ // Label 2063: @120209
     /* 120209 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(120264), // Rule ID 4181 //
     /* 120214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120217 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120232 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120243 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120262 */   GIR_RootConstrainSelectedInstOperands,
     /* 120263 */   // GIR_Coverage, 4181,
     /* 120263 */   GIR_EraseRootFromParent_Done,
     /* 120264 */ // Label 2064: @120264
     /* 120264 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(120319), // Rule ID 4182 //
     /* 120269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120272 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120298 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120317 */   GIR_RootConstrainSelectedInstOperands,
     /* 120318 */   // GIR_Coverage, 4182,
     /* 120318 */   GIR_EraseRootFromParent_Done,
     /* 120319 */ // Label 2065: @120319
     /* 120319 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(120374), // Rule ID 4203 //
     /* 120324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120327 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120342 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120346 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120353 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 120356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120372 */   GIR_RootConstrainSelectedInstOperands,
     /* 120373 */   // GIR_Coverage, 4203,
     /* 120373 */   GIR_EraseRootFromParent_Done,
     /* 120374 */ // Label 2066: @120374
     /* 120374 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(120429), // Rule ID 4204 //
     /* 120379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120382 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120397 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120401 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120408 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120427 */   GIR_RootConstrainSelectedInstOperands,
     /* 120428 */   // GIR_Coverage, 4204,
     /* 120428 */   GIR_EraseRootFromParent_Done,
     /* 120429 */ // Label 2067: @120429
     /* 120429 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120484), // Rule ID 4205 //
     /* 120434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120437 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120463 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120482 */   GIR_RootConstrainSelectedInstOperands,
     /* 120483 */   // GIR_Coverage, 4205,
     /* 120483 */   GIR_EraseRootFromParent_Done,
     /* 120484 */ // Label 2068: @120484
     /* 120484 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(120542), // Rule ID 7118 //
     /* 120489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120492 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120503 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120521 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120540 */   GIR_RootConstrainSelectedInstOperands,
     /* 120541 */   // GIR_Coverage, 7118,
     /* 120541 */   GIR_EraseRootFromParent_Done,
     /* 120542 */ // Label 2069: @120542
     /* 120542 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(120600), // Rule ID 7120 //
     /* 120547 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120550 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120554 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120561 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120579 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15871>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120598 */   GIR_RootConstrainSelectedInstOperands,
     /* 120599 */   // GIR_Coverage, 7120,
     /* 120599 */   GIR_EraseRootFromParent_Done,
     /* 120600 */ // Label 2070: @120600
     /* 120600 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(120658), // Rule ID 7130 //
     /* 120605 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120608 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120619 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120637 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 120640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120656 */   GIR_RootConstrainSelectedInstOperands,
     /* 120657 */   // GIR_Coverage, 7130,
     /* 120657 */   GIR_EraseRootFromParent_Done,
     /* 120658 */ // Label 2071: @120658
     /* 120658 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(120716), // Rule ID 7132 //
     /* 120663 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120666 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120670 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120677 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120695 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15879>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 120698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120714 */   GIR_RootConstrainSelectedInstOperands,
     /* 120715 */   // GIR_Coverage, 7132,
     /* 120715 */   GIR_EraseRootFromParent_Done,
     /* 120716 */ // Label 2072: @120716
     /* 120716 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120774), // Rule ID 7138 //
     /* 120721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120735 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120753 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 120756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120772 */   GIR_RootConstrainSelectedInstOperands,
     /* 120773 */   // GIR_Coverage, 7138,
     /* 120773 */   GIR_EraseRootFromParent_Done,
     /* 120774 */ // Label 2073: @120774
     /* 120774 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120832), // Rule ID 7139 //
     /* 120779 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120793 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120811 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15887>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 120814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120830 */   GIR_RootConstrainSelectedInstOperands,
     /* 120831 */   // GIR_Coverage, 7139,
     /* 120831 */   GIR_EraseRootFromParent_Done,
     /* 120832 */ // Label 2074: @120832
     /* 120832 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120893), // Rule ID 7524 //
     /* 120837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120840 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120843 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120847 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120854 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120872 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15860>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 120875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120891 */   GIR_RootConstrainSelectedInstOperands,
     /* 120892 */   // GIR_Coverage, 7524,
     /* 120892 */   GIR_EraseRootFromParent_Done,
     /* 120893 */ // Label 2075: @120893
     /* 120893 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120954), // Rule ID 7526 //
     /* 120898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120904 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120933 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15862>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 120936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120952 */   GIR_RootConstrainSelectedInstOperands,
     /* 120953 */   // GIR_Coverage, 7526,
     /* 120953 */   GIR_EraseRootFromParent_Done,
     /* 120954 */ // Label 2076: @120954
     /* 120954 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(121015), // Rule ID 7528 //
     /* 120959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120965 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120994 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15864>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 120997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121013 */   GIR_RootConstrainSelectedInstOperands,
     /* 121014 */   // GIR_Coverage, 7528,
     /* 121014 */   GIR_EraseRootFromParent_Done,
     /* 121015 */ // Label 2077: @121015
     /* 121015 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(121059), // Rule ID 7104 //
     /* 121020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 121023 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121026 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121044 */   // MIs[0] ptr
     /* 121044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121052 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15860>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 121057 */   GIR_RootConstrainSelectedInstOperands,
     /* 121058 */   // GIR_Coverage, 7104,
     /* 121058 */   GIR_Done,
     /* 121059 */ // Label 2078: @121059
     /* 121059 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(121103), // Rule ID 7106 //
     /* 121064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 121067 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121070 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121074 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121081 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121088 */   // MIs[0] ptr
     /* 121088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121096 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15862>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 121101 */   GIR_RootConstrainSelectedInstOperands,
     /* 121102 */   // GIR_Coverage, 7106,
     /* 121102 */   GIR_Done,
     /* 121103 */ // Label 2079: @121103
     /* 121103 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(121147), // Rule ID 7108 //
     /* 121108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 121111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121132 */   // MIs[0] ptr
     /* 121132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121140 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15864>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 121145 */   GIR_RootConstrainSelectedInstOperands,
     /* 121146 */   // GIR_Coverage, 7108,
     /* 121146 */   GIR_Done,
     /* 121147 */ // Label 2080: @121147
     /* 121147 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(121188), // Rule ID 7110 //
     /* 121152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121173 */   // MIs[0] ptr
     /* 121173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121181 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15868>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 121186 */   GIR_RootConstrainSelectedInstOperands,
     /* 121187 */   // GIR_Coverage, 7110,
     /* 121187 */   GIR_Done,
     /* 121188 */ // Label 2081: @121188
     /* 121188 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(121229), // Rule ID 7112 //
     /* 121193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121214 */   // MIs[0] ptr
     /* 121214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121222 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15860>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 121227 */   GIR_RootConstrainSelectedInstOperands,
     /* 121228 */   // GIR_Coverage, 7112,
     /* 121228 */   GIR_Done,
     /* 121229 */ // Label 2082: @121229
     /* 121229 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(121270), // Rule ID 7122 //
     /* 121234 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121237 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121255 */   // MIs[0] ptr
     /* 121255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121263 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15876>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 121268 */   GIR_RootConstrainSelectedInstOperands,
     /* 121269 */   // GIR_Coverage, 7122,
     /* 121269 */   GIR_Done,
     /* 121270 */ // Label 2083: @121270
     /* 121270 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(121311), // Rule ID 7124 //
     /* 121275 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121278 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121296 */   // MIs[0] ptr
     /* 121296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121304 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15862>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 121309 */   GIR_RootConstrainSelectedInstOperands,
     /* 121310 */   // GIR_Coverage, 7124,
     /* 121310 */   GIR_Done,
     /* 121311 */ // Label 2084: @121311
     /* 121311 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121352), // Rule ID 7134 //
     /* 121316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121337 */   // MIs[0] ptr
     /* 121337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121345 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15884>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 121350 */   GIR_RootConstrainSelectedInstOperands,
     /* 121351 */   // GIR_Coverage, 7134,
     /* 121351 */   GIR_Done,
     /* 121352 */ // Label 2085: @121352
     /* 121352 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121393), // Rule ID 7135 //
     /* 121357 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121378 */   // MIs[0] ptr
     /* 121378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121386 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15864>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 121391 */   GIR_RootConstrainSelectedInstOperands,
     /* 121392 */   // GIR_Coverage, 7135,
     /* 121392 */   GIR_Done,
     /* 121393 */ // Label 2086: @121393
     /* 121393 */ GIM_Reject,
     /* 121394 */ // Label 2015: @121394
     /* 121394 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121447), // Rule ID 239 //
     /* 121399 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121402 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121421 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 121424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121445 */   GIR_RootConstrainSelectedInstOperands,
     /* 121446 */   // GIR_Coverage, 239,
     /* 121446 */   GIR_EraseRootFromParent_Done,
     /* 121447 */ // Label 2087: @121447
     /* 121447 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121500), // Rule ID 240 //
     /* 121452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121474 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 121477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121498 */   GIR_RootConstrainSelectedInstOperands,
     /* 121499 */   // GIR_Coverage, 240,
     /* 121499 */   GIR_EraseRootFromParent_Done,
     /* 121500 */ // Label 2088: @121500
     /* 121500 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121556), // Rule ID 247 //
     /* 121505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121530 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121554 */   GIR_RootConstrainSelectedInstOperands,
     /* 121555 */   // GIR_Coverage, 247,
     /* 121555 */   GIR_EraseRootFromParent_Done,
     /* 121556 */ // Label 2089: @121556
     /* 121556 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121612), // Rule ID 248 //
     /* 121561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121575 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121586 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121610 */   GIR_RootConstrainSelectedInstOperands,
     /* 121611 */   // GIR_Coverage, 248,
     /* 121611 */   GIR_EraseRootFromParent_Done,
     /* 121612 */ // Label 2090: @121612
     /* 121612 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121665), // Rule ID 4119 //
     /* 121617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121620 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121639 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121663 */   GIR_RootConstrainSelectedInstOperands,
     /* 121664 */   // GIR_Coverage, 4119,
     /* 121664 */   GIR_EraseRootFromParent_Done,
     /* 121665 */ // Label 2091: @121665
     /* 121665 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121718), // Rule ID 4120 //
     /* 121670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121673 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121692 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121716 */   GIR_RootConstrainSelectedInstOperands,
     /* 121717 */   // GIR_Coverage, 4120,
     /* 121717 */   GIR_EraseRootFromParent_Done,
     /* 121718 */ // Label 2092: @121718
     /* 121718 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121771), // Rule ID 4121 //
     /* 121723 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121726 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121745 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121769 */   GIR_RootConstrainSelectedInstOperands,
     /* 121770 */   // GIR_Coverage, 4121,
     /* 121770 */   GIR_EraseRootFromParent_Done,
     /* 121771 */ // Label 2093: @121771
     /* 121771 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121824), // Rule ID 4122 //
     /* 121776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121787 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121798 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121822 */   GIR_RootConstrainSelectedInstOperands,
     /* 121823 */   // GIR_Coverage, 4122,
     /* 121823 */   GIR_EraseRootFromParent_Done,
     /* 121824 */ // Label 2094: @121824
     /* 121824 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(121916), // Rule ID 4145 //
     /* 121829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121832 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121836 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 121858 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 121865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121885 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121915 */   // GIR_Coverage, 4145,
     /* 121915 */   GIR_EraseRootFromParent_Done,
     /* 121916 */ // Label 2095: @121916
     /* 121916 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(122008), // Rule ID 4146 //
     /* 121921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121924 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121928 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 121950 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 121957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121977 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122007 */   // GIR_Coverage, 4146,
     /* 122007 */   GIR_EraseRootFromParent_Done,
     /* 122008 */ // Label 2096: @122008
     /* 122008 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(122100), // Rule ID 4147 //
     /* 122013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122016 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 122042 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 122049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122069 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122099 */   // GIR_Coverage, 4147,
     /* 122099 */   GIR_EraseRootFromParent_Done,
     /* 122100 */ // Label 2097: @122100
     /* 122100 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(122192), // Rule ID 4148 //
     /* 122105 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 122134 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 122141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122161 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122191 */   // GIR_Coverage, 4148,
     /* 122191 */   GIR_EraseRootFromParent_Done,
     /* 122192 */ // Label 2098: @122192
     /* 122192 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(122284), // Rule ID 4149 //
     /* 122197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 122226 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 122233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122253 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122283 */   // GIR_Coverage, 4149,
     /* 122283 */   GIR_EraseRootFromParent_Done,
     /* 122284 */ // Label 2099: @122284
     /* 122284 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122376), // Rule ID 4150 //
     /* 122289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122292 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 122318 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 122325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122345 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122375 */   // GIR_Coverage, 4150,
     /* 122375 */   GIR_EraseRootFromParent_Done,
     /* 122376 */ // Label 2100: @122376
     /* 122376 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122468), // Rule ID 4151 //
     /* 122381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122384 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122388 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 122410 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 122417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122437 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122467 */   // GIR_Coverage, 4151,
     /* 122467 */   GIR_EraseRootFromParent_Done,
     /* 122468 */ // Label 2101: @122468
     /* 122468 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122560), // Rule ID 4152 //
     /* 122473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122476 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122480 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 122502 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 122509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122529 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122559 */   // GIR_Coverage, 4152,
     /* 122559 */   GIR_EraseRootFromParent_Done,
     /* 122560 */ // Label 2102: @122560
     /* 122560 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122608), // Rule ID 263 //
     /* 122565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122568 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122587 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 122590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122606 */   GIR_RootConstrainSelectedInstOperands,
     /* 122607 */   // GIR_Coverage, 263,
     /* 122607 */   GIR_EraseRootFromParent_Done,
     /* 122608 */ // Label 2103: @122608
     /* 122608 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122659), // Rule ID 268 //
     /* 122613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122616 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122619 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122638 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122657 */   GIR_RootConstrainSelectedInstOperands,
     /* 122658 */   // GIR_Coverage, 268,
     /* 122658 */   GIR_EraseRootFromParent_Done,
     /* 122659 */ // Label 2104: @122659
     /* 122659 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122722), // Rule ID 7142 //
     /* 122664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122671 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122678 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122696 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 122699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122720 */   GIR_RootConstrainSelectedInstOperands,
     /* 122721 */   // GIR_Coverage, 7142,
     /* 122721 */   GIR_EraseRootFromParent_Done,
     /* 122722 */ // Label 2105: @122722
     /* 122722 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122785), // Rule ID 7143 //
     /* 122727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122741 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122752 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122759 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 122762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122783 */   GIR_RootConstrainSelectedInstOperands,
     /* 122784 */   // GIR_Coverage, 7143,
     /* 122784 */   GIR_EraseRootFromParent_Done,
     /* 122785 */ // Label 2106: @122785
     /* 122785 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122833), // Rule ID 284 //
     /* 122790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122812 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122831 */   GIR_RootConstrainSelectedInstOperands,
     /* 122832 */   // GIR_Coverage, 284,
     /* 122832 */   GIR_EraseRootFromParent_Done,
     /* 122833 */ // Label 2107: @122833
     /* 122833 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122884), // Rule ID 289 //
     /* 122838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122863 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122882 */   GIR_RootConstrainSelectedInstOperands,
     /* 122883 */   // GIR_Coverage, 289,
     /* 122883 */   GIR_EraseRootFromParent_Done,
     /* 122884 */ // Label 2108: @122884
     /* 122884 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122932), // Rule ID 4166 //
     /* 122889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122911 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122930 */   GIR_RootConstrainSelectedInstOperands,
     /* 122931 */   // GIR_Coverage, 4166,
     /* 122931 */   GIR_EraseRootFromParent_Done,
     /* 122932 */ // Label 2109: @122932
     /* 122932 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(122980), // Rule ID 4167 //
     /* 122937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122959 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122978 */   GIR_RootConstrainSelectedInstOperands,
     /* 122979 */   // GIR_Coverage, 4167,
     /* 122979 */   GIR_EraseRootFromParent_Done,
     /* 122980 */ // Label 2110: @122980
     /* 122980 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(123067), // Rule ID 4183 //
     /* 122985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122988 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122992 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123003 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 123014 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 123014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 123021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123036 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123066 */   // GIR_Coverage, 4183,
     /* 123066 */   GIR_EraseRootFromParent_Done,
     /* 123067 */ // Label 2111: @123067
     /* 123067 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(123154), // Rule ID 4184 //
     /* 123072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123075 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 123101 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 123101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 123108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123123 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123153 */   // GIR_Coverage, 4184,
     /* 123153 */   GIR_EraseRootFromParent_Done,
     /* 123154 */ // Label 2112: @123154
     /* 123154 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(123241), // Rule ID 4185 //
     /* 123159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 123188 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 123188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 123195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123210 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123240 */   // GIR_Coverage, 4185,
     /* 123240 */   GIR_EraseRootFromParent_Done,
     /* 123241 */ // Label 2113: @123241
     /* 123241 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(123328), // Rule ID 4186 //
     /* 123246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123249 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123253 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 123275 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 123275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 123282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123297 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123327 */   // GIR_Coverage, 4186,
     /* 123327 */   GIR_EraseRootFromParent_Done,
     /* 123328 */ // Label 2114: @123328
     /* 123328 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(123376), // Rule ID 4194 //
     /* 123333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123355 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123374 */   GIR_RootConstrainSelectedInstOperands,
     /* 123375 */   // GIR_Coverage, 4194,
     /* 123375 */   GIR_EraseRootFromParent_Done,
     /* 123376 */ // Label 2115: @123376
     /* 123376 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(123424), // Rule ID 4195 //
     /* 123381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123403 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123422 */   GIR_RootConstrainSelectedInstOperands,
     /* 123423 */   // GIR_Coverage, 4195,
     /* 123423 */   GIR_EraseRootFromParent_Done,
     /* 123424 */ // Label 2116: @123424
     /* 123424 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(123511), // Rule ID 4206 //
     /* 123429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123432 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123436 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 123458 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 123465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123480 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123510 */   // GIR_Coverage, 4206,
     /* 123510 */   GIR_EraseRootFromParent_Done,
     /* 123511 */ // Label 2117: @123511
     /* 123511 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(123598), // Rule ID 4207 //
     /* 123516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123519 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 123545 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 123552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123567 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123597 */   // GIR_Coverage, 4207,
     /* 123597 */   GIR_EraseRootFromParent_Done,
     /* 123598 */ // Label 2118: @123598
     /* 123598 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(123685), // Rule ID 4208 //
     /* 123603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123632 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123654 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123684 */   // GIR_Coverage, 4208,
     /* 123684 */   GIR_EraseRootFromParent_Done,
     /* 123685 */ // Label 2119: @123685
     /* 123685 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(123772), // Rule ID 4209 //
     /* 123690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123719 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123741 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123771 */   // GIR_Coverage, 4209,
     /* 123771 */   GIR_EraseRootFromParent_Done,
     /* 123772 */ // Label 2120: @123772
     /* 123772 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(123830), // Rule ID 7144 //
     /* 123777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123780 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123791 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123809 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 123812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123828 */   GIR_RootConstrainSelectedInstOperands,
     /* 123829 */   // GIR_Coverage, 7144,
     /* 123829 */   GIR_EraseRootFromParent_Done,
     /* 123830 */ // Label 2121: @123830
     /* 123830 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123888), // Rule ID 7145 //
     /* 123835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123849 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123867 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15895>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 123870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123886 */   GIR_RootConstrainSelectedInstOperands,
     /* 123887 */   // GIR_Coverage, 7145,
     /* 123887 */   GIR_EraseRootFromParent_Done,
     /* 123888 */ // Label 2122: @123888
     /* 123888 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(123949), // Rule ID 7529 //
     /* 123893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 123896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123903 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123928 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15866>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 123931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123947 */   GIR_RootConstrainSelectedInstOperands,
     /* 123948 */   // GIR_Coverage, 7529,
     /* 123948 */   GIR_EraseRootFromParent_Done,
     /* 123949 */ // Label 2123: @123949
     /* 123949 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(123980), // Rule ID 6471 //
     /* 123954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123965 */   // MIs[0] Rn
     /* 123965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123973 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 123978 */   GIR_RootConstrainSelectedInstOperands,
     /* 123979 */   // GIR_Coverage, 6471,
     /* 123979 */   GIR_Done,
     /* 123980 */ // Label 2124: @123980
     /* 123980 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(124024), // Rule ID 7109 //
     /* 123985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 123988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123995 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124009 */   // MIs[0] ptr
     /* 124009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124017 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15866>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 124017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 124022 */   GIR_RootConstrainSelectedInstOperands,
     /* 124023 */   // GIR_Coverage, 7109,
     /* 124023 */   GIR_Done,
     /* 124024 */ // Label 2125: @124024
     /* 124024 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(124065), // Rule ID 7140 //
     /* 124029 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 124032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124036 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124050 */   // MIs[0] ptr
     /* 124050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124058 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15892>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 124058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 124063 */   GIR_RootConstrainSelectedInstOperands,
     /* 124064 */   // GIR_Coverage, 7140,
     /* 124064 */   GIR_Done,
     /* 124065 */ // Label 2126: @124065
     /* 124065 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(124106), // Rule ID 7141 //
     /* 124070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 124073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124091 */   // MIs[0] ptr
     /* 124091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124099 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15866>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 124099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 124104 */   GIR_RootConstrainSelectedInstOperands,
     /* 124105 */   // GIR_Coverage, 7141,
     /* 124105 */   GIR_Done,
     /* 124106 */ // Label 2127: @124106
     /* 124106 */ GIM_Reject,
     /* 124107 */ // Label 2016: @124107
     /* 124107 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(124315),
     /* 124112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124115 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124127 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(124168), // Rule ID 249 //
     /* 124132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 124135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124142 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124166 */     GIR_RootConstrainSelectedInstOperands,
     /* 124167 */     // GIR_Coverage, 249,
     /* 124167 */     GIR_EraseRootFromParent_Done,
     /* 124168 */   // Label 2129: @124168
     /* 124168 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(124209), // Rule ID 250 //
     /* 124173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 124176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124183 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124207 */     GIR_RootConstrainSelectedInstOperands,
     /* 124208 */     // GIR_Coverage, 250,
     /* 124208 */     GIR_EraseRootFromParent_Done,
     /* 124209 */   // Label 2130: @124209
     /* 124209 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(124245), // Rule ID 269 //
     /* 124214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 124217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124224 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124243 */     GIR_RootConstrainSelectedInstOperands,
     /* 124244 */     // GIR_Coverage, 269,
     /* 124244 */     GIR_EraseRootFromParent_Done,
     /* 124245 */   // Label 2131: @124245
     /* 124245 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(124281), // Rule ID 290 //
     /* 124250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 124253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124260 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 124260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124279 */     GIR_RootConstrainSelectedInstOperands,
     /* 124280 */     // GIR_Coverage, 290,
     /* 124280 */     GIR_EraseRootFromParent_Done,
     /* 124281 */   // Label 2132: @124281
     /* 124281 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(124314), // Rule ID 4175 //
     /* 124286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124293 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124312 */     GIR_RootConstrainSelectedInstOperands,
     /* 124313 */     // GIR_Coverage, 4175,
     /* 124313 */     GIR_EraseRootFromParent_Done,
     /* 124314 */   // Label 2133: @124314
     /* 124314 */   GIM_Reject,
     /* 124315 */ // Label 2128: @124315
     /* 124315 */ GIM_Reject,
     /* 124316 */ // Label 2017: @124316
     /* 124316 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(124693),
     /* 124321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124332 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(124377), // Rule ID 4109 //
     /* 124337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124351 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124375 */     GIR_RootConstrainSelectedInstOperands,
     /* 124376 */     // GIR_Coverage, 4109,
     /* 124376 */     GIR_EraseRootFromParent_Done,
     /* 124377 */   // Label 2135: @124377
     /* 124377 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(124422), // Rule ID 4110 //
     /* 124382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124396 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124420 */     GIR_RootConstrainSelectedInstOperands,
     /* 124421 */     // GIR_Coverage, 4110,
     /* 124421 */     GIR_EraseRootFromParent_Done,
     /* 124422 */   // Label 2136: @124422
     /* 124422 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(124467), // Rule ID 4111 //
     /* 124427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124441 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124465 */     GIR_RootConstrainSelectedInstOperands,
     /* 124466 */     // GIR_Coverage, 4111,
     /* 124466 */     GIR_EraseRootFromParent_Done,
     /* 124467 */   // Label 2137: @124467
     /* 124467 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(124512), // Rule ID 4112 //
     /* 124472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124486 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124510 */     GIR_RootConstrainSelectedInstOperands,
     /* 124511 */     // GIR_Coverage, 4112,
     /* 124511 */     GIR_EraseRootFromParent_Done,
     /* 124512 */   // Label 2138: @124512
     /* 124512 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(124552), // Rule ID 4161 //
     /* 124517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124531 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124550 */     GIR_RootConstrainSelectedInstOperands,
     /* 124551 */     // GIR_Coverage, 4161,
     /* 124551 */     GIR_EraseRootFromParent_Done,
     /* 124552 */   // Label 2139: @124552
     /* 124552 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(124592), // Rule ID 4164 //
     /* 124557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124571 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124590 */     GIR_RootConstrainSelectedInstOperands,
     /* 124591 */     // GIR_Coverage, 4164,
     /* 124591 */     GIR_EraseRootFromParent_Done,
     /* 124592 */   // Label 2140: @124592
     /* 124592 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(124632), // Rule ID 4189 //
     /* 124597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124611 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124630 */     GIR_RootConstrainSelectedInstOperands,
     /* 124631 */     // GIR_Coverage, 4189,
     /* 124631 */     GIR_EraseRootFromParent_Done,
     /* 124632 */   // Label 2141: @124632
     /* 124632 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(124672), // Rule ID 4190 //
     /* 124637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124651 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124670 */     GIR_RootConstrainSelectedInstOperands,
     /* 124671 */     // GIR_Coverage, 4190,
     /* 124671 */     GIR_EraseRootFromParent_Done,
     /* 124672 */   // Label 2142: @124672
     /* 124672 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(124692), // Rule ID 6470 //
     /* 124677 */     // MIs[0] Rn
     /* 124677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124685 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 124690 */     GIR_RootConstrainSelectedInstOperands,
     /* 124691 */     // GIR_Coverage, 6470,
     /* 124691 */     GIR_Done,
     /* 124692 */   // Label 2143: @124692
     /* 124692 */   GIM_Reject,
     /* 124693 */ // Label 2134: @124693
     /* 124693 */ GIM_Reject,
     /* 124694 */ // Label 2018: @124694
     /* 124694 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(125071),
     /* 124699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124710 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(124755), // Rule ID 4123 //
     /* 124715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124729 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124753 */     GIR_RootConstrainSelectedInstOperands,
     /* 124754 */     // GIR_Coverage, 4123,
     /* 124754 */     GIR_EraseRootFromParent_Done,
     /* 124755 */   // Label 2145: @124755
     /* 124755 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(124800), // Rule ID 4124 //
     /* 124760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124774 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124798 */     GIR_RootConstrainSelectedInstOperands,
     /* 124799 */     // GIR_Coverage, 4124,
     /* 124799 */     GIR_EraseRootFromParent_Done,
     /* 124800 */   // Label 2146: @124800
     /* 124800 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(124845), // Rule ID 4125 //
     /* 124805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124819 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124843 */     GIR_RootConstrainSelectedInstOperands,
     /* 124844 */     // GIR_Coverage, 4125,
     /* 124844 */     GIR_EraseRootFromParent_Done,
     /* 124845 */   // Label 2147: @124845
     /* 124845 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(124890), // Rule ID 4126 //
     /* 124850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124864 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124888 */     GIR_RootConstrainSelectedInstOperands,
     /* 124889 */     // GIR_Coverage, 4126,
     /* 124889 */     GIR_EraseRootFromParent_Done,
     /* 124890 */   // Label 2148: @124890
     /* 124890 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(124930), // Rule ID 4169 //
     /* 124895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124909 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124928 */     GIR_RootConstrainSelectedInstOperands,
     /* 124929 */     // GIR_Coverage, 4169,
     /* 124929 */     GIR_EraseRootFromParent_Done,
     /* 124930 */   // Label 2149: @124930
     /* 124930 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(124970), // Rule ID 4173 //
     /* 124935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124949 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124968 */     GIR_RootConstrainSelectedInstOperands,
     /* 124969 */     // GIR_Coverage, 4173,
     /* 124969 */     GIR_EraseRootFromParent_Done,
     /* 124970 */   // Label 2150: @124970
     /* 124970 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(125010), // Rule ID 4196 //
     /* 124975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124989 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125008 */     GIR_RootConstrainSelectedInstOperands,
     /* 125009 */     // GIR_Coverage, 4196,
     /* 125009 */     GIR_EraseRootFromParent_Done,
     /* 125010 */   // Label 2151: @125010
     /* 125010 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(125050), // Rule ID 4197 //
     /* 125015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125029 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125048 */     GIR_RootConstrainSelectedInstOperands,
     /* 125049 */     // GIR_Coverage, 4197,
     /* 125049 */     GIR_EraseRootFromParent_Done,
     /* 125050 */   // Label 2152: @125050
     /* 125050 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(125070), // Rule ID 6467 //
     /* 125055 */     // MIs[0] Rn
     /* 125055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125063 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 125068 */     GIR_RootConstrainSelectedInstOperands,
     /* 125069 */     // GIR_Coverage, 6467,
     /* 125069 */     GIR_Done,
     /* 125070 */   // Label 2153: @125070
     /* 125070 */   GIM_Reject,
     /* 125071 */ // Label 2144: @125071
     /* 125071 */ GIM_Reject,
     /* 125072 */ // Label 2019: @125072
     /* 125072 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(125449),
     /* 125077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 125088 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(125133), // Rule ID 4115 //
     /* 125093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125107 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125131 */     GIR_RootConstrainSelectedInstOperands,
     /* 125132 */     // GIR_Coverage, 4115,
     /* 125132 */     GIR_EraseRootFromParent_Done,
     /* 125133 */   // Label 2155: @125133
     /* 125133 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(125178), // Rule ID 4116 //
     /* 125138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125152 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125176 */     GIR_RootConstrainSelectedInstOperands,
     /* 125177 */     // GIR_Coverage, 4116,
     /* 125177 */     GIR_EraseRootFromParent_Done,
     /* 125178 */   // Label 2156: @125178
     /* 125178 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(125223), // Rule ID 4117 //
     /* 125183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125197 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125221 */     GIR_RootConstrainSelectedInstOperands,
     /* 125222 */     // GIR_Coverage, 4117,
     /* 125222 */     GIR_EraseRootFromParent_Done,
     /* 125223 */   // Label 2157: @125223
     /* 125223 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(125268), // Rule ID 4118 //
     /* 125228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125242 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125266 */     GIR_RootConstrainSelectedInstOperands,
     /* 125267 */     // GIR_Coverage, 4118,
     /* 125267 */     GIR_EraseRootFromParent_Done,
     /* 125268 */   // Label 2158: @125268
     /* 125268 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(125308), // Rule ID 4163 //
     /* 125273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125287 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125306 */     GIR_RootConstrainSelectedInstOperands,
     /* 125307 */     // GIR_Coverage, 4163,
     /* 125307 */     GIR_EraseRootFromParent_Done,
     /* 125308 */   // Label 2159: @125308
     /* 125308 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(125348), // Rule ID 4165 //
     /* 125313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125327 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125346 */     GIR_RootConstrainSelectedInstOperands,
     /* 125347 */     // GIR_Coverage, 4165,
     /* 125347 */     GIR_EraseRootFromParent_Done,
     /* 125348 */   // Label 2160: @125348
     /* 125348 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(125388), // Rule ID 4191 //
     /* 125353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125367 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125386 */     GIR_RootConstrainSelectedInstOperands,
     /* 125387 */     // GIR_Coverage, 4191,
     /* 125387 */     GIR_EraseRootFromParent_Done,
     /* 125388 */   // Label 2161: @125388
     /* 125388 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(125428), // Rule ID 4193 //
     /* 125393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125407 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125426 */     GIR_RootConstrainSelectedInstOperands,
     /* 125427 */     // GIR_Coverage, 4193,
     /* 125427 */     GIR_EraseRootFromParent_Done,
     /* 125428 */   // Label 2162: @125428
     /* 125428 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(125448), // Rule ID 6469 //
     /* 125433 */     // MIs[0] Rn
     /* 125433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125441 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 125446 */     GIR_RootConstrainSelectedInstOperands,
     /* 125447 */     // GIR_Coverage, 6469,
     /* 125447 */     GIR_Done,
     /* 125448 */   // Label 2163: @125448
     /* 125448 */   GIM_Reject,
     /* 125449 */ // Label 2154: @125449
     /* 125449 */ GIM_Reject,
     /* 125450 */ // Label 2020: @125450
     /* 125450 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(125827),
     /* 125455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125466 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(125511), // Rule ID 4127 //
     /* 125471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125485 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125509 */     GIR_RootConstrainSelectedInstOperands,
     /* 125510 */     // GIR_Coverage, 4127,
     /* 125510 */     GIR_EraseRootFromParent_Done,
     /* 125511 */   // Label 2165: @125511
     /* 125511 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(125556), // Rule ID 4128 //
     /* 125516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125530 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125554 */     GIR_RootConstrainSelectedInstOperands,
     /* 125555 */     // GIR_Coverage, 4128,
     /* 125555 */     GIR_EraseRootFromParent_Done,
     /* 125556 */   // Label 2166: @125556
     /* 125556 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(125601), // Rule ID 4129 //
     /* 125561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125575 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125599 */     GIR_RootConstrainSelectedInstOperands,
     /* 125600 */     // GIR_Coverage, 4129,
     /* 125600 */     GIR_EraseRootFromParent_Done,
     /* 125601 */   // Label 2167: @125601
     /* 125601 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(125646), // Rule ID 4130 //
     /* 125606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125620 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125644 */     GIR_RootConstrainSelectedInstOperands,
     /* 125645 */     // GIR_Coverage, 4130,
     /* 125645 */     GIR_EraseRootFromParent_Done,
     /* 125646 */   // Label 2168: @125646
     /* 125646 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(125686), // Rule ID 4168 //
     /* 125651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125665 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125684 */     GIR_RootConstrainSelectedInstOperands,
     /* 125685 */     // GIR_Coverage, 4168,
     /* 125685 */     GIR_EraseRootFromParent_Done,
     /* 125686 */   // Label 2169: @125686
     /* 125686 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(125726), // Rule ID 4172 //
     /* 125691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125705 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125724 */     GIR_RootConstrainSelectedInstOperands,
     /* 125725 */     // GIR_Coverage, 4172,
     /* 125725 */     GIR_EraseRootFromParent_Done,
     /* 125726 */   // Label 2170: @125726
     /* 125726 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(125766), // Rule ID 4198 //
     /* 125731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125745 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125764 */     GIR_RootConstrainSelectedInstOperands,
     /* 125765 */     // GIR_Coverage, 4198,
     /* 125765 */     GIR_EraseRootFromParent_Done,
     /* 125766 */   // Label 2171: @125766
     /* 125766 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(125806), // Rule ID 4199 //
     /* 125771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125785 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125804 */     GIR_RootConstrainSelectedInstOperands,
     /* 125805 */     // GIR_Coverage, 4199,
     /* 125805 */     GIR_EraseRootFromParent_Done,
     /* 125806 */   // Label 2172: @125806
     /* 125806 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(125826), // Rule ID 6466 //
     /* 125811 */     // MIs[0] Rn
     /* 125811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125819 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 125824 */     GIR_RootConstrainSelectedInstOperands,
     /* 125825 */     // GIR_Coverage, 6466,
     /* 125825 */     GIR_Done,
     /* 125826 */   // Label 2173: @125826
     /* 125826 */   GIM_Reject,
     /* 125827 */ // Label 2164: @125827
     /* 125827 */ GIM_Reject,
     /* 125828 */ // Label 2021: @125828
     /* 125828 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(126035),
     /* 125833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 125844 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(125889), // Rule ID 4113 //
     /* 125849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125863 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125887 */     GIR_RootConstrainSelectedInstOperands,
     /* 125888 */     // GIR_Coverage, 4113,
     /* 125888 */     GIR_EraseRootFromParent_Done,
     /* 125889 */   // Label 2175: @125889
     /* 125889 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125934), // Rule ID 4114 //
     /* 125894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125908 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125932 */     GIR_RootConstrainSelectedInstOperands,
     /* 125933 */     // GIR_Coverage, 4114,
     /* 125933 */     GIR_EraseRootFromParent_Done,
     /* 125934 */   // Label 2176: @125934
     /* 125934 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(125974), // Rule ID 4162 //
     /* 125939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125953 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125972 */     GIR_RootConstrainSelectedInstOperands,
     /* 125973 */     // GIR_Coverage, 4162,
     /* 125973 */     GIR_EraseRootFromParent_Done,
     /* 125974 */   // Label 2177: @125974
     /* 125974 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(126014), // Rule ID 4192 //
     /* 125979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125993 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126012 */     GIR_RootConstrainSelectedInstOperands,
     /* 126013 */     // GIR_Coverage, 4192,
     /* 126013 */     GIR_EraseRootFromParent_Done,
     /* 126014 */   // Label 2178: @126014
     /* 126014 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(126034), // Rule ID 6468 //
     /* 126019 */     // MIs[0] Rn
     /* 126019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126027 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 126032 */     GIR_RootConstrainSelectedInstOperands,
     /* 126033 */     // GIR_Coverage, 6468,
     /* 126033 */     GIR_Done,
     /* 126034 */   // Label 2179: @126034
     /* 126034 */   GIM_Reject,
     /* 126035 */ // Label 2174: @126035
     /* 126035 */ GIM_Reject,
     /* 126036 */ // Label 2022: @126036
     /* 126036 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(126413),
     /* 126041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 126052 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(126097), // Rule ID 4131 //
     /* 126057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126071 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126095 */     GIR_RootConstrainSelectedInstOperands,
     /* 126096 */     // GIR_Coverage, 4131,
     /* 126096 */     GIR_EraseRootFromParent_Done,
     /* 126097 */   // Label 2181: @126097
     /* 126097 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(126142), // Rule ID 4132 //
     /* 126102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126116 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126140 */     GIR_RootConstrainSelectedInstOperands,
     /* 126141 */     // GIR_Coverage, 4132,
     /* 126141 */     GIR_EraseRootFromParent_Done,
     /* 126142 */   // Label 2182: @126142
     /* 126142 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(126187), // Rule ID 4133 //
     /* 126147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126161 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126185 */     GIR_RootConstrainSelectedInstOperands,
     /* 126186 */     // GIR_Coverage, 4133,
     /* 126186 */     GIR_EraseRootFromParent_Done,
     /* 126187 */   // Label 2183: @126187
     /* 126187 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(126232), // Rule ID 4134 //
     /* 126192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126206 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126230 */     GIR_RootConstrainSelectedInstOperands,
     /* 126231 */     // GIR_Coverage, 4134,
     /* 126231 */     GIR_EraseRootFromParent_Done,
     /* 126232 */   // Label 2184: @126232
     /* 126232 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(126272), // Rule ID 4171 //
     /* 126237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126251 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126270 */     GIR_RootConstrainSelectedInstOperands,
     /* 126271 */     // GIR_Coverage, 4171,
     /* 126271 */     GIR_EraseRootFromParent_Done,
     /* 126272 */   // Label 2185: @126272
     /* 126272 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(126312), // Rule ID 4174 //
     /* 126277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126291 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126310 */     GIR_RootConstrainSelectedInstOperands,
     /* 126311 */     // GIR_Coverage, 4174,
     /* 126311 */     GIR_EraseRootFromParent_Done,
     /* 126312 */   // Label 2186: @126312
     /* 126312 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(126352), // Rule ID 4200 //
     /* 126317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126331 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126350 */     GIR_RootConstrainSelectedInstOperands,
     /* 126351 */     // GIR_Coverage, 4200,
     /* 126351 */     GIR_EraseRootFromParent_Done,
     /* 126352 */   // Label 2187: @126352
     /* 126352 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(126392), // Rule ID 4202 //
     /* 126357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126371 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126390 */     GIR_RootConstrainSelectedInstOperands,
     /* 126391 */     // GIR_Coverage, 4202,
     /* 126391 */     GIR_EraseRootFromParent_Done,
     /* 126392 */   // Label 2188: @126392
     /* 126392 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(126412), // Rule ID 6465 //
     /* 126397 */     // MIs[0] Rn
     /* 126397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126405 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 126410 */     GIR_RootConstrainSelectedInstOperands,
     /* 126411 */     // GIR_Coverage, 6465,
     /* 126411 */     GIR_Done,
     /* 126412 */   // Label 2189: @126412
     /* 126412 */   GIM_Reject,
     /* 126413 */ // Label 2180: @126413
     /* 126413 */ GIM_Reject,
     /* 126414 */ // Label 2023: @126414
     /* 126414 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(126621),
     /* 126419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 126430 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(126475), // Rule ID 4135 //
     /* 126435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126449 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126473 */     GIR_RootConstrainSelectedInstOperands,
     /* 126474 */     // GIR_Coverage, 4135,
     /* 126474 */     GIR_EraseRootFromParent_Done,
     /* 126475 */   // Label 2191: @126475
     /* 126475 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(126520), // Rule ID 4136 //
     /* 126480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126494 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126518 */     GIR_RootConstrainSelectedInstOperands,
     /* 126519 */     // GIR_Coverage, 4136,
     /* 126519 */     GIR_EraseRootFromParent_Done,
     /* 126520 */   // Label 2192: @126520
     /* 126520 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(126560), // Rule ID 4170 //
     /* 126525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126539 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126558 */     GIR_RootConstrainSelectedInstOperands,
     /* 126559 */     // GIR_Coverage, 4170,
     /* 126559 */     GIR_EraseRootFromParent_Done,
     /* 126560 */   // Label 2193: @126560
     /* 126560 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(126600), // Rule ID 4201 //
     /* 126565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126579 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126598 */     GIR_RootConstrainSelectedInstOperands,
     /* 126599 */     // GIR_Coverage, 4201,
     /* 126599 */     GIR_EraseRootFromParent_Done,
     /* 126600 */   // Label 2194: @126600
     /* 126600 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(126620), // Rule ID 6464 //
     /* 126605 */     // MIs[0] Rn
     /* 126605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126613 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 126618 */     GIR_RootConstrainSelectedInstOperands,
     /* 126619 */     // GIR_Coverage, 6464,
     /* 126619 */     GIR_Done,
     /* 126620 */   // Label 2195: @126620
     /* 126620 */   GIM_Reject,
     /* 126621 */ // Label 2190: @126621
     /* 126621 */ GIM_Reject,
     /* 126622 */ // Label 2024: @126622
     /* 126622 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(126685), // Rule ID 11081 //
     /* 126627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126641 */   // MIs[0] base
     /* 126641 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126649 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126661 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 126669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126674 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126683 */   GIR_RootConstrainSelectedInstOperands,
     /* 126684 */   // GIR_Coverage, 11081,
     /* 126684 */   GIR_EraseRootFromParent_Done,
     /* 126685 */ // Label 2196: @126685
     /* 126685 */ GIM_Reject,
     /* 126686 */ // Label 2025: @126686
     /* 126686 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(126749), // Rule ID 11087 //
     /* 126691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126697 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126705 */   // MIs[0] base
     /* 126705 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126713 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126725 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 126733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126738 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126747 */   GIR_RootConstrainSelectedInstOperands,
     /* 126748 */   // GIR_Coverage, 11087,
     /* 126748 */   GIR_EraseRootFromParent_Done,
     /* 126749 */ // Label 2197: @126749
     /* 126749 */ GIM_Reject,
     /* 126750 */ // Label 2026: @126750
     /* 126750 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(126923),
     /* 126755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126770 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126818), // Rule ID 11072 //
     /* 126775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126782 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126807 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126816 */     GIR_RootConstrainSelectedInstOperands,
     /* 126817 */     // GIR_Coverage, 11072,
     /* 126817 */     GIR_EraseRootFromParent_Done,
     /* 126818 */   // Label 2199: @126818
     /* 126818 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(126866), // Rule ID 11090 //
     /* 126823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126830 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126855 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126864 */     GIR_RootConstrainSelectedInstOperands,
     /* 126865 */     // GIR_Coverage, 11090,
     /* 126865 */     GIR_EraseRootFromParent_Done,
     /* 126866 */   // Label 2200: @126866
     /* 126866 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(126894), // Rule ID 11117 //
     /* 126871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126878 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126883 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126892 */     GIR_RootConstrainSelectedInstOperands,
     /* 126893 */     // GIR_Coverage, 11117,
     /* 126893 */     GIR_EraseRootFromParent_Done,
     /* 126894 */   // Label 2201: @126894
     /* 126894 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(126922), // Rule ID 11129 //
     /* 126899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126906 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126911 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126920 */     GIR_RootConstrainSelectedInstOperands,
     /* 126921 */     // GIR_Coverage, 11129,
     /* 126921 */     GIR_EraseRootFromParent_Done,
     /* 126922 */   // Label 2202: @126922
     /* 126922 */   GIM_Reject,
     /* 126923 */ // Label 2198: @126923
     /* 126923 */ GIM_Reject,
     /* 126924 */ // Label 2027: @126924
     /* 126924 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(126987), // Rule ID 11078 //
     /* 126929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126943 */   // MIs[0] base
     /* 126943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126951 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126963 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 126971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126976 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126985 */   GIR_RootConstrainSelectedInstOperands,
     /* 126986 */   // GIR_Coverage, 11078,
     /* 126986 */   GIR_EraseRootFromParent_Done,
     /* 126987 */ // Label 2203: @126987
     /* 126987 */ GIM_Reject,
     /* 126988 */ // Label 2028: @126988
     /* 126988 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(127161),
     /* 126993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127008 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(127056), // Rule ID 11060 //
     /* 127013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127020 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 127027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127032 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 127040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127045 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127054 */     GIR_RootConstrainSelectedInstOperands,
     /* 127055 */     // GIR_Coverage, 11060,
     /* 127055 */     GIR_EraseRootFromParent_Done,
     /* 127056 */   // Label 2205: @127056
     /* 127056 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(127104), // Rule ID 11084 //
     /* 127061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127068 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 127075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 127088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127093 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127102 */     GIR_RootConstrainSelectedInstOperands,
     /* 127103 */     // GIR_Coverage, 11084,
     /* 127103 */     GIR_EraseRootFromParent_Done,
     /* 127104 */   // Label 2206: @127104
     /* 127104 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(127132), // Rule ID 11113 //
     /* 127109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127116 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127121 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127130 */     GIR_RootConstrainSelectedInstOperands,
     /* 127131 */     // GIR_Coverage, 11113,
     /* 127131 */     GIR_EraseRootFromParent_Done,
     /* 127132 */   // Label 2207: @127132
     /* 127132 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(127160), // Rule ID 11125 //
     /* 127137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127144 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127149 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127158 */     GIR_RootConstrainSelectedInstOperands,
     /* 127159 */     // GIR_Coverage, 11125,
     /* 127159 */     GIR_EraseRootFromParent_Done,
     /* 127160 */   // Label 2208: @127160
     /* 127160 */   GIM_Reject,
     /* 127161 */ // Label 2204: @127161
     /* 127161 */ GIM_Reject,
     /* 127162 */ // Label 2029: @127162
     /* 127162 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(127335),
     /* 127167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127182 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(127230), // Rule ID 11039 //
     /* 127187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127194 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 127201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127219 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127228 */     GIR_RootConstrainSelectedInstOperands,
     /* 127229 */     // GIR_Coverage, 11039,
     /* 127229 */     GIR_EraseRootFromParent_Done,
     /* 127230 */   // Label 2210: @127230
     /* 127230 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(127278), // Rule ID 11075 //
     /* 127235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127242 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 127249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 127262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127267 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127276 */     GIR_RootConstrainSelectedInstOperands,
     /* 127277 */     // GIR_Coverage, 11075,
     /* 127277 */     GIR_EraseRootFromParent_Done,
     /* 127278 */   // Label 2211: @127278
     /* 127278 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(127306), // Rule ID 11109 //
     /* 127283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127290 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127295 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127304 */     GIR_RootConstrainSelectedInstOperands,
     /* 127305 */     // GIR_Coverage, 11109,
     /* 127305 */     GIR_EraseRootFromParent_Done,
     /* 127306 */   // Label 2212: @127306
     /* 127306 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(127334), // Rule ID 11121 //
     /* 127311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127318 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127323 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127332 */     GIR_RootConstrainSelectedInstOperands,
     /* 127333 */     // GIR_Coverage, 11121,
     /* 127333 */     GIR_EraseRootFromParent_Done,
     /* 127334 */   // Label 2213: @127334
     /* 127334 */   GIM_Reject,
     /* 127335 */ // Label 2209: @127335
     /* 127335 */ GIM_Reject,
     /* 127336 */ // Label 2030: @127336
     /* 127336 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(127379), // Rule ID 2435 //
     /* 127341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 127355 */   // MIs[0] base
     /* 127355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127363 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 127366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 127368 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127377 */   GIR_RootConstrainSelectedInstOperands,
     /* 127378 */   // GIR_Coverage, 2435,
     /* 127378 */   GIR_EraseRootFromParent_Done,
     /* 127379 */ // Label 2214: @127379
     /* 127379 */ GIM_Reject,
     /* 127380 */ // Label 2031: @127380
     /* 127380 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(127477),
     /* 127385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127400 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(127448), // Rule ID 11007 //
     /* 127405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127412 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 127419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 127432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127437 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127446 */     GIR_RootConstrainSelectedInstOperands,
     /* 127447 */     // GIR_Coverage, 11007,
     /* 127447 */     GIR_EraseRootFromParent_Done,
     /* 127448 */   // Label 2216: @127448
     /* 127448 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(127476), // Rule ID 11105 //
     /* 127453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127460 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127465 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127474 */     GIR_RootConstrainSelectedInstOperands,
     /* 127475 */     // GIR_Coverage, 11105,
     /* 127475 */     GIR_EraseRootFromParent_Done,
     /* 127476 */   // Label 2217: @127476
     /* 127476 */   GIM_Reject,
     /* 127477 */ // Label 2215: @127477
     /* 127477 */ GIM_Reject,
     /* 127478 */ // Label 2032: @127478
     /* 127478 */ GIM_Reject,
     /* 127479 */ // Label 17: @127479
     /* 127479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2220*/ GIMT_Encode4(128528),
     /* 127490 */ /*GILLT_s32*//*Label 2218*/ GIMT_Encode4(127498),
     /* 127494 */ /*GILLT_s64*//*Label 2219*/ GIMT_Encode4(127912),
     /* 127498 */ // Label 2218: @127498
     /* 127498 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(127911),
     /* 127503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127506 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(127559), // Rule ID 251 //
     /* 127511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127533 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 127536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127557 */     GIR_RootConstrainSelectedInstOperands,
     /* 127558 */     // GIR_Coverage, 251,
     /* 127558 */     GIR_EraseRootFromParent_Done,
     /* 127559 */   // Label 2222: @127559
     /* 127559 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(127612), // Rule ID 252 //
     /* 127564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127586 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 127589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127610 */     GIR_RootConstrainSelectedInstOperands,
     /* 127611 */     // GIR_Coverage, 252,
     /* 127611 */     GIR_EraseRootFromParent_Done,
     /* 127612 */   // Label 2223: @127612
     /* 127612 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(127665), // Rule ID 255 //
     /* 127617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127639 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 127642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127663 */     GIR_RootConstrainSelectedInstOperands,
     /* 127664 */     // GIR_Coverage, 255,
     /* 127664 */     GIR_EraseRootFromParent_Done,
     /* 127665 */   // Label 2224: @127665
     /* 127665 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(127718), // Rule ID 256 //
     /* 127670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127692 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 127695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127716 */     GIR_RootConstrainSelectedInstOperands,
     /* 127717 */     // GIR_Coverage, 256,
     /* 127717 */     GIR_EraseRootFromParent_Done,
     /* 127718 */   // Label 2225: @127718
     /* 127718 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(127766), // Rule ID 272 //
     /* 127723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127745 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 127748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127764 */     GIR_RootConstrainSelectedInstOperands,
     /* 127765 */     // GIR_Coverage, 272,
     /* 127765 */     GIR_EraseRootFromParent_Done,
     /* 127766 */   // Label 2226: @127766
     /* 127766 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(127814), // Rule ID 274 //
     /* 127771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127793 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 127796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127812 */     GIR_RootConstrainSelectedInstOperands,
     /* 127813 */     // GIR_Coverage, 274,
     /* 127813 */     GIR_EraseRootFromParent_Done,
     /* 127814 */   // Label 2227: @127814
     /* 127814 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(127862), // Rule ID 293 //
     /* 127819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127841 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 127844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127860 */     GIR_RootConstrainSelectedInstOperands,
     /* 127861 */     // GIR_Coverage, 293,
     /* 127861 */     GIR_EraseRootFromParent_Done,
     /* 127862 */   // Label 2228: @127862
     /* 127862 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127910), // Rule ID 295 //
     /* 127867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127889 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 127892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127908 */     GIR_RootConstrainSelectedInstOperands,
     /* 127909 */     // GIR_Coverage, 295,
     /* 127909 */     GIR_EraseRootFromParent_Done,
     /* 127910 */   // Label 2229: @127910
     /* 127910 */   GIM_Reject,
     /* 127911 */ // Label 2221: @127911
     /* 127911 */ GIM_Reject,
     /* 127912 */ // Label 2219: @127912
     /* 127912 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(128527),
     /* 127917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127920 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127973), // Rule ID 253 //
     /* 127925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127947 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 127950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127971 */     GIR_RootConstrainSelectedInstOperands,
     /* 127972 */     // GIR_Coverage, 253,
     /* 127972 */     GIR_EraseRootFromParent_Done,
     /* 127973 */   // Label 2231: @127973
     /* 127973 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(128026), // Rule ID 254 //
     /* 127978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128000 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 128003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128024 */     GIR_RootConstrainSelectedInstOperands,
     /* 128025 */     // GIR_Coverage, 254,
     /* 128025 */     GIR_EraseRootFromParent_Done,
     /* 128026 */   // Label 2232: @128026
     /* 128026 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(128079), // Rule ID 257 //
     /* 128031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128053 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 128056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128077 */     GIR_RootConstrainSelectedInstOperands,
     /* 128078 */     // GIR_Coverage, 257,
     /* 128078 */     GIR_EraseRootFromParent_Done,
     /* 128079 */   // Label 2233: @128079
     /* 128079 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(128132), // Rule ID 258 //
     /* 128084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128106 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 128109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128130 */     GIR_RootConstrainSelectedInstOperands,
     /* 128131 */     // GIR_Coverage, 258,
     /* 128131 */     GIR_EraseRootFromParent_Done,
     /* 128132 */   // Label 2234: @128132
     /* 128132 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(128185), // Rule ID 259 //
     /* 128137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 128159 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 128159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 128162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128183 */     GIR_RootConstrainSelectedInstOperands,
     /* 128184 */     // GIR_Coverage, 259,
     /* 128184 */     GIR_EraseRootFromParent_Done,
     /* 128185 */   // Label 2235: @128185
     /* 128185 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(128238), // Rule ID 260 //
     /* 128190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 128212 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 128212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 128215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128236 */     GIR_RootConstrainSelectedInstOperands,
     /* 128237 */     // GIR_Coverage, 260,
     /* 128237 */     GIR_EraseRootFromParent_Done,
     /* 128238 */   // Label 2236: @128238
     /* 128238 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(128286), // Rule ID 273 //
     /* 128243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128265 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 128265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 128268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128284 */     GIR_RootConstrainSelectedInstOperands,
     /* 128285 */     // GIR_Coverage, 273,
     /* 128285 */     GIR_EraseRootFromParent_Done,
     /* 128286 */   // Label 2237: @128286
     /* 128286 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(128334), // Rule ID 275 //
     /* 128291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128313 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 128316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128332 */     GIR_RootConstrainSelectedInstOperands,
     /* 128333 */     // GIR_Coverage, 275,
     /* 128333 */     GIR_EraseRootFromParent_Done,
     /* 128334 */   // Label 2238: @128334
     /* 128334 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(128382), // Rule ID 276 //
     /* 128339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 128361 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 128361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 128364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128380 */     GIR_RootConstrainSelectedInstOperands,
     /* 128381 */     // GIR_Coverage, 276,
     /* 128381 */     GIR_EraseRootFromParent_Done,
     /* 128382 */   // Label 2239: @128382
     /* 128382 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(128430), // Rule ID 294 //
     /* 128387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128409 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 128412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128428 */     GIR_RootConstrainSelectedInstOperands,
     /* 128429 */     // GIR_Coverage, 294,
     /* 128429 */     GIR_EraseRootFromParent_Done,
     /* 128430 */   // Label 2240: @128430
     /* 128430 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(128478), // Rule ID 296 //
     /* 128435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 128457 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 128460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128476 */     GIR_RootConstrainSelectedInstOperands,
     /* 128477 */     // GIR_Coverage, 296,
     /* 128477 */     GIR_EraseRootFromParent_Done,
     /* 128478 */   // Label 2241: @128478
     /* 128478 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(128526), // Rule ID 297 //
     /* 128483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 128505 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 128508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128524 */     GIR_RootConstrainSelectedInstOperands,
     /* 128525 */     // GIR_Coverage, 297,
     /* 128525 */     GIR_EraseRootFromParent_Done,
     /* 128526 */   // Label 2242: @128526
     /* 128526 */   GIM_Reject,
     /* 128527 */ // Label 2230: @128527
     /* 128527 */ GIM_Reject,
     /* 128528 */ // Label 2220: @128528
     /* 128528 */ GIM_Reject,
     /* 128529 */ // Label 18: @128529
     /* 128529 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2245*/ GIMT_Encode4(131577),
     /* 128540 */ /*GILLT_s32*//*Label 2243*/ GIMT_Encode4(128548),
     /* 128544 */ /*GILLT_s64*//*Label 2244*/ GIMT_Encode4(130087),
     /* 128548 */ // Label 2243: @128548
     /* 128548 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(128604), // Rule ID 233 //
     /* 128553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128556 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128578 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128602 */   GIR_RootConstrainSelectedInstOperands,
     /* 128603 */   // GIR_Coverage, 233,
     /* 128603 */   GIR_EraseRootFromParent_Done,
     /* 128604 */ // Label 2246: @128604
     /* 128604 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(128660), // Rule ID 234 //
     /* 128609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128627 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128634 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128658 */   GIR_RootConstrainSelectedInstOperands,
     /* 128659 */   // GIR_Coverage, 234,
     /* 128659 */   GIR_EraseRootFromParent_Done,
     /* 128660 */ // Label 2247: @128660
     /* 128660 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128716), // Rule ID 235 //
     /* 128665 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128690 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128714 */   GIR_RootConstrainSelectedInstOperands,
     /* 128715 */   // GIR_Coverage, 235,
     /* 128715 */   GIR_EraseRootFromParent_Done,
     /* 128716 */ // Label 2248: @128716
     /* 128716 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128772), // Rule ID 236 //
     /* 128721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128746 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128770 */   GIR_RootConstrainSelectedInstOperands,
     /* 128771 */   // GIR_Coverage, 236,
     /* 128771 */   GIR_EraseRootFromParent_Done,
     /* 128772 */ // Label 2249: @128772
     /* 128772 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128828), // Rule ID 4159 //
     /* 128777 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128802 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128826 */   GIR_RootConstrainSelectedInstOperands,
     /* 128827 */   // GIR_Coverage, 4159,
     /* 128827 */   GIR_EraseRootFromParent_Done,
     /* 128828 */ // Label 2250: @128828
     /* 128828 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128884), // Rule ID 4160 //
     /* 128833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128836 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128858 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128882 */   GIR_RootConstrainSelectedInstOperands,
     /* 128883 */   // GIR_Coverage, 4160,
     /* 128883 */   GIR_EraseRootFromParent_Done,
     /* 128884 */ // Label 2251: @128884
     /* 128884 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128935), // Rule ID 270 //
     /* 128889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128914 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 128914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 128917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128933 */   GIR_RootConstrainSelectedInstOperands,
     /* 128934 */   // GIR_Coverage, 270,
     /* 128934 */   GIR_EraseRootFromParent_Done,
     /* 128935 */ // Label 2252: @128935
     /* 128935 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128986), // Rule ID 271 //
     /* 128940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128965 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128980 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128984 */   GIR_RootConstrainSelectedInstOperands,
     /* 128985 */   // GIR_Coverage, 271,
     /* 128985 */   GIR_EraseRootFromParent_Done,
     /* 128986 */ // Label 2253: @128986
     /* 128986 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129045), // Rule ID 7115 //
     /* 128991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129001 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 129019 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 129019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 129022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129043 */   GIR_RootConstrainSelectedInstOperands,
     /* 129044 */   // GIR_Coverage, 7115,
     /* 129044 */   GIR_EraseRootFromParent_Done,
     /* 129045 */ // Label 2254: @129045
     /* 129045 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(129104), // Rule ID 7117 //
     /* 129050 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129060 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 129078 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 129078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 129081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129102 */   GIR_RootConstrainSelectedInstOperands,
     /* 129103 */   // GIR_Coverage, 7117,
     /* 129103 */   GIR_EraseRootFromParent_Done,
     /* 129104 */ // Label 2255: @129104
     /* 129104 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(129163), // Rule ID 7127 //
     /* 129109 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129119 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 129137 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 129137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 129140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129161 */   GIR_RootConstrainSelectedInstOperands,
     /* 129162 */   // GIR_Coverage, 7127,
     /* 129162 */   GIR_EraseRootFromParent_Done,
     /* 129163 */ // Label 2256: @129163
     /* 129163 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(129222), // Rule ID 7129 //
     /* 129168 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129178 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 129196 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 129196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 129199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129220 */   GIR_RootConstrainSelectedInstOperands,
     /* 129221 */   // GIR_Coverage, 7129,
     /* 129221 */   GIR_EraseRootFromParent_Done,
     /* 129222 */ // Label 2257: @129222
     /* 129222 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(129273), // Rule ID 291 //
     /* 129227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129252 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 129252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129271 */   GIR_RootConstrainSelectedInstOperands,
     /* 129272 */   // GIR_Coverage, 291,
     /* 129272 */   GIR_EraseRootFromParent_Done,
     /* 129273 */ // Label 2258: @129273
     /* 129273 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(129324), // Rule ID 292 //
     /* 129278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129303 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 129303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129322 */   GIR_RootConstrainSelectedInstOperands,
     /* 129323 */   // GIR_Coverage, 292,
     /* 129323 */   GIR_EraseRootFromParent_Done,
     /* 129324 */ // Label 2259: @129324
     /* 129324 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(129375), // Rule ID 4178 //
     /* 129329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129332 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129343 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129347 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129354 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 129354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129373 */   GIR_RootConstrainSelectedInstOperands,
     /* 129374 */   // GIR_Coverage, 4178,
     /* 129374 */   GIR_EraseRootFromParent_Done,
     /* 129375 */ // Label 2260: @129375
     /* 129375 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(129426), // Rule ID 4210 //
     /* 129380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129383 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129394 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129405 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129424 */   GIR_RootConstrainSelectedInstOperands,
     /* 129425 */   // GIR_Coverage, 4210,
     /* 129425 */   GIR_EraseRootFromParent_Done,
     /* 129426 */ // Label 2261: @129426
     /* 129426 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(129477), // Rule ID 4211 //
     /* 129431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129456 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129475 */   GIR_RootConstrainSelectedInstOperands,
     /* 129476 */   // GIR_Coverage, 4211,
     /* 129476 */   GIR_EraseRootFromParent_Done,
     /* 129477 */ // Label 2262: @129477
     /* 129477 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(129528), // Rule ID 4212 //
     /* 129482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129507 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129526 */   GIR_RootConstrainSelectedInstOperands,
     /* 129527 */   // GIR_Coverage, 4212,
     /* 129527 */   GIR_EraseRootFromParent_Done,
     /* 129528 */ // Label 2263: @129528
     /* 129528 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129582), // Rule ID 7119 //
     /* 129533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129561 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15871>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 129561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129580 */   GIR_RootConstrainSelectedInstOperands,
     /* 129581 */   // GIR_Coverage, 7119,
     /* 129581 */   GIR_EraseRootFromParent_Done,
     /* 129582 */ // Label 2264: @129582
     /* 129582 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129636), // Rule ID 7121 //
     /* 129587 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129597 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129615 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15871>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129634 */   GIR_RootConstrainSelectedInstOperands,
     /* 129635 */   // GIR_Coverage, 7121,
     /* 129635 */   GIR_EraseRootFromParent_Done,
     /* 129636 */ // Label 2265: @129636
     /* 129636 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129690), // Rule ID 7131 //
     /* 129641 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129651 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129669 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15879>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 129669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129688 */   GIR_RootConstrainSelectedInstOperands,
     /* 129689 */   // GIR_Coverage, 7131,
     /* 129689 */   GIR_EraseRootFromParent_Done,
     /* 129690 */ // Label 2266: @129690
     /* 129690 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129744), // Rule ID 7133 //
     /* 129695 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129705 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129723 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15879>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129742 */   GIR_RootConstrainSelectedInstOperands,
     /* 129743 */   // GIR_Coverage, 7133,
     /* 129743 */   GIR_EraseRootFromParent_Done,
     /* 129744 */ // Label 2267: @129744
     /* 129744 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129801), // Rule ID 7525 //
     /* 129749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129752 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129755 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129762 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129780 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15860>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 129783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129799 */   GIR_RootConstrainSelectedInstOperands,
     /* 129800 */   // GIR_Coverage, 7525,
     /* 129800 */   GIR_EraseRootFromParent_Done,
     /* 129801 */ // Label 2268: @129801
     /* 129801 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129858), // Rule ID 7527 //
     /* 129806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129812 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129837 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15862>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 129840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129856 */   GIR_RootConstrainSelectedInstOperands,
     /* 129857 */   // GIR_Coverage, 7527,
     /* 129857 */   GIR_EraseRootFromParent_Done,
     /* 129858 */ // Label 2269: @129858
     /* 129858 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129898), // Rule ID 7105 //
     /* 129863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129866 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129883 */   // MIs[0] ptr
     /* 129883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129891 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15860>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 129896 */   GIR_RootConstrainSelectedInstOperands,
     /* 129897 */   // GIR_Coverage, 7105,
     /* 129897 */   GIR_Done,
     /* 129898 */ // Label 2270: @129898
     /* 129898 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129938), // Rule ID 7107 //
     /* 129903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129906 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129909 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129923 */   // MIs[0] ptr
     /* 129923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129931 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15862>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 129936 */   GIR_RootConstrainSelectedInstOperands,
     /* 129937 */   // GIR_Coverage, 7107,
     /* 129937 */   GIR_Done,
     /* 129938 */ // Label 2271: @129938
     /* 129938 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129975), // Rule ID 7111 //
     /* 129943 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129953 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129960 */   // MIs[0] ptr
     /* 129960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129968 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15868>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129973 */   GIR_RootConstrainSelectedInstOperands,
     /* 129974 */   // GIR_Coverage, 7111,
     /* 129974 */   GIR_Done,
     /* 129975 */ // Label 2272: @129975
     /* 129975 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(130012), // Rule ID 7113 //
     /* 129980 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129997 */   // MIs[0] ptr
     /* 129997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130005 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15860>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 130005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 130010 */   GIR_RootConstrainSelectedInstOperands,
     /* 130011 */   // GIR_Coverage, 7113,
     /* 130011 */   GIR_Done,
     /* 130012 */ // Label 2273: @130012
     /* 130012 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(130049), // Rule ID 7123 //
     /* 130017 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 130020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130034 */   // MIs[0] ptr
     /* 130034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130042 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15876>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 130042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 130047 */   GIR_RootConstrainSelectedInstOperands,
     /* 130048 */   // GIR_Coverage, 7123,
     /* 130048 */   GIR_Done,
     /* 130049 */ // Label 2274: @130049
     /* 130049 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(130086), // Rule ID 7125 //
     /* 130054 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 130057 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130064 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130071 */   // MIs[0] ptr
     /* 130071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130079 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15862>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 130079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 130084 */   GIR_RootConstrainSelectedInstOperands,
     /* 130085 */   // GIR_Coverage, 7125,
     /* 130085 */   GIR_Done,
     /* 130086 */ // Label 2275: @130086
     /* 130086 */ GIM_Reject,
     /* 130087 */ // Label 2244: @130087
     /* 130087 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(131576),
     /* 130092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130095 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(130180), // Rule ID 4137 //
     /* 130100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130122 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 130129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130149 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130179 */     // GIR_Coverage, 4137,
     /* 130179 */     GIR_EraseRootFromParent_Done,
     /* 130180 */   // Label 2277: @130180
     /* 130180 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(130265), // Rule ID 4138 //
     /* 130185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130207 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 130214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130264 */     // GIR_Coverage, 4138,
     /* 130264 */     GIR_EraseRootFromParent_Done,
     /* 130265 */   // Label 2278: @130265
     /* 130265 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(130350), // Rule ID 4139 //
     /* 130270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130292 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 130299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130319 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130349 */     // GIR_Coverage, 4139,
     /* 130349 */     GIR_EraseRootFromParent_Done,
     /* 130350 */   // Label 2279: @130350
     /* 130350 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(130435), // Rule ID 4140 //
     /* 130355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130377 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 130384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130434 */     // GIR_Coverage, 4140,
     /* 130434 */     GIR_EraseRootFromParent_Done,
     /* 130435 */   // Label 2280: @130435
     /* 130435 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(130520), // Rule ID 4141 //
     /* 130440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 130462 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 130469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130489 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130519 */     // GIR_Coverage, 4141,
     /* 130519 */     GIR_EraseRootFromParent_Done,
     /* 130520 */   // Label 2281: @130520
     /* 130520 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(130605), // Rule ID 4142 //
     /* 130525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 130547 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 130554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130604 */     // GIR_Coverage, 4142,
     /* 130604 */     GIR_EraseRootFromParent_Done,
     /* 130605 */   // Label 2282: @130605
     /* 130605 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(130690), // Rule ID 4143 //
     /* 130610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130632 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 130639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130659 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130689 */     // GIR_Coverage, 4143,
     /* 130689 */     GIR_EraseRootFromParent_Done,
     /* 130690 */   // Label 2283: @130690
     /* 130690 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(130775), // Rule ID 4144 //
     /* 130695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130717 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 130724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130744 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130774 */     // GIR_Coverage, 4144,
     /* 130774 */     GIR_EraseRootFromParent_Done,
     /* 130775 */   // Label 2284: @130775
     /* 130775 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(130855), // Rule ID 4176 //
     /* 130780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130802 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130854 */     // GIR_Coverage, 4176,
     /* 130854 */     GIR_EraseRootFromParent_Done,
     /* 130855 */   // Label 2285: @130855
     /* 130855 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(130935), // Rule ID 4177 //
     /* 130860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130882 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 130889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130904 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130934 */     // GIR_Coverage, 4177,
     /* 130934 */     GIR_EraseRootFromParent_Done,
     /* 130935 */   // Label 2286: @130935
     /* 130935 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(131015), // Rule ID 4179 //
     /* 130940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130962 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131014 */     // GIR_Coverage, 4179,
     /* 131014 */     GIR_EraseRootFromParent_Done,
     /* 131015 */   // Label 2287: @131015
     /* 131015 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(131095), // Rule ID 4187 //
     /* 131020 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 131042 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 131042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 131049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131094 */     // GIR_Coverage, 4187,
     /* 131094 */     GIR_EraseRootFromParent_Done,
     /* 131095 */   // Label 2288: @131095
     /* 131095 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(131175), // Rule ID 4213 //
     /* 131100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 131122 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 131129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131174 */     // GIR_Coverage, 4213,
     /* 131174 */     GIR_EraseRootFromParent_Done,
     /* 131175 */   // Label 2289: @131175
     /* 131175 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(131255), // Rule ID 4214 //
     /* 131180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131202 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 131209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131224 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131254 */     // GIR_Coverage, 4214,
     /* 131254 */     GIR_EraseRootFromParent_Done,
     /* 131255 */   // Label 2290: @131255
     /* 131255 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(131335), // Rule ID 4215 //
     /* 131260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131282 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131334 */     // GIR_Coverage, 4215,
     /* 131334 */     GIR_EraseRootFromParent_Done,
     /* 131335 */   // Label 2291: @131335
     /* 131335 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(131415), // Rule ID 4216 //
     /* 131340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131362 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131384 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131414 */     // GIR_Coverage, 4216,
     /* 131414 */     GIR_EraseRootFromParent_Done,
     /* 131415 */   // Label 2292: @131415
     /* 131415 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(131495), // Rule ID 4217 //
     /* 131420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131442 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131494 */     // GIR_Coverage, 4217,
     /* 131494 */     GIR_EraseRootFromParent_Done,
     /* 131495 */   // Label 2293: @131495
     /* 131495 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(131575), // Rule ID 4218 //
     /* 131500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131522 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 131529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131544 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131574 */     // GIR_Coverage, 4218,
     /* 131574 */     GIR_EraseRootFromParent_Done,
     /* 131575 */   // Label 2294: @131575
     /* 131575 */   GIM_Reject,
     /* 131576 */ // Label 2276: @131576
     /* 131576 */ GIM_Reject,
     /* 131577 */ // Label 2245: @131577
     /* 131577 */ GIM_Reject,
     /* 131578 */ // Label 19: @131578
     /* 131578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2315*/ GIMT_Encode4(145103),
     /* 131589 */ /*GILLT_s8*//*Label 2295*/ GIMT_Encode4(131685),
     /* 131593 */ /*GILLT_s16*//*Label 2296*/ GIMT_Encode4(132052),
     /* 131597 */ /*GILLT_s32*//*Label 2297*/ GIMT_Encode4(133191),
     /* 131601 */ /*GILLT_s64*//*Label 2298*/ GIMT_Encode4(137786),
     /* 131605 */ /*GILLT_s128*//*Label 2299*/ GIMT_Encode4(141555),
     /* 131609 */ /*GILLT_v2s32*//*Label 2300*/ GIMT_Encode4(141761),
     /* 131613 */ /*GILLT_v2s64*//*Label 2301*/ GIMT_Encode4(142167),
     /* 131617 */ /*GILLT_v4s16*//*Label 2302*/ GIMT_Encode4(142617),
     /* 131621 */ /*GILLT_v4s32*//*Label 2303*/ GIMT_Encode4(143023),
     /* 131625 */ /*GILLT_v8s8*//*Label 2304*/ GIMT_Encode4(143429),
     /* 131629 */ /*GILLT_v8s16*//*Label 2305*/ GIMT_Encode4(143649),
     /* 131633 */ /*GILLT_v16s8*//*Label 2306*/ GIMT_Encode4(144055), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131645 */ /*GILLT_nxv2s16*//*Label 2307*/ GIMT_Encode4(144275),
     /* 131649 */ /*GILLT_nxv2s32*//*Label 2308*/ GIMT_Encode4(144335),
     /* 131653 */ /*GILLT_nxv2s64*//*Label 2309*/ GIMT_Encode4(144395), GIMT_Encode4(0),
     /* 131661 */ /*GILLT_nxv4s16*//*Label 2310*/ GIMT_Encode4(144565),
     /* 131665 */ /*GILLT_nxv4s32*//*Label 2311*/ GIMT_Encode4(144625), GIMT_Encode4(0),
     /* 131673 */ /*GILLT_nxv8s16*//*Label 2312*/ GIMT_Encode4(144795),
     /* 131677 */ /*GILLT_nxv16s1*//*Label 2313*/ GIMT_Encode4(144965),
     /* 131681 */ /*GILLT_nxv16s8*//*Label 2314*/ GIMT_Encode4(145009),
     /* 131685 */ // Label 2295: @131685
     /* 131685 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(132051),
     /* 131690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131697 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131765), // Rule ID 13440 //
     /* 131702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 131714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131735 */     // MIs[2] Operand 1
     /* 131735 */     // No operand predicates
     /* 131735 */     // MIs[0] Rn
     /* 131735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131745 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131763 */     GIR_RootConstrainSelectedInstOperands,
     /* 131764 */     // GIR_Coverage, 13440,
     /* 131764 */     GIR_EraseRootFromParent_Done,
     /* 131765 */   // Label 2317: @131765
     /* 131765 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131864), // Rule ID 13441 //
     /* 131770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 131782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131803 */     // MIs[2] Operand 1
     /* 131803 */     // No operand predicates
     /* 131803 */     // MIs[0] Rn
     /* 131803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131813 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131862 */     GIR_RootConstrainSelectedInstOperands,
     /* 131863 */     // GIR_Coverage, 13441,
     /* 131863 */     GIR_EraseRootFromParent_Done,
     /* 131864 */   // Label 2318: @131864
     /* 131864 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131913), // Rule ID 307 //
     /* 131869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 131887 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 131887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 131890 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131911 */     GIR_RootConstrainSelectedInstOperands,
     /* 131912 */     // GIR_Coverage, 307,
     /* 131912 */     GIR_EraseRootFromParent_Done,
     /* 131913 */   // Label 2319: @131913
     /* 131913 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131962), // Rule ID 308 //
     /* 131918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 131936 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 131936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 131939 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131960 */     GIR_RootConstrainSelectedInstOperands,
     /* 131961 */     // GIR_Coverage, 308,
     /* 131961 */     GIR_EraseRootFromParent_Done,
     /* 131962 */   // Label 2320: @131962
     /* 131962 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132006), // Rule ID 317 //
     /* 131967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 131985 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 131985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 131988 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132004 */     GIR_RootConstrainSelectedInstOperands,
     /* 132005 */     // GIR_Coverage, 317,
     /* 132005 */     GIR_EraseRootFromParent_Done,
     /* 132006 */   // Label 2321: @132006
     /* 132006 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132050), // Rule ID 325 //
     /* 132011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 132018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 132029 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 132029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 132032 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132048 */     GIR_RootConstrainSelectedInstOperands,
     /* 132049 */     // GIR_Coverage, 325,
     /* 132049 */     GIR_EraseRootFromParent_Done,
     /* 132050 */   // Label 2322: @132050
     /* 132050 */   GIM_Reject,
     /* 132051 */ // Label 2316: @132051
     /* 132051 */ GIM_Reject,
     /* 132052 */ // Label 2296: @132052
     /* 132052 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(133190),
     /* 132057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132064 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132163), // Rule ID 4551 //
     /* 132069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132090 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132107 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132161 */     GIR_RootConstrainSelectedInstOperands,
     /* 132162 */     // GIR_Coverage, 4551,
     /* 132162 */     GIR_EraseRootFromParent_Done,
     /* 132163 */   // Label 2324: @132163
     /* 132163 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132262), // Rule ID 4552 //
     /* 132168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132189 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132206 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132260 */     GIR_RootConstrainSelectedInstOperands,
     /* 132261 */     // GIR_Coverage, 4552,
     /* 132261 */     GIR_EraseRootFromParent_Done,
     /* 132262 */   // Label 2325: @132262
     /* 132262 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132361), // Rule ID 13438 //
     /* 132267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132305 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132359 */     GIR_RootConstrainSelectedInstOperands,
     /* 132360 */     // GIR_Coverage, 13438,
     /* 132360 */     GIR_EraseRootFromParent_Done,
     /* 132361 */   // Label 2326: @132361
     /* 132361 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132460), // Rule ID 13439 //
     /* 132366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132387 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132404 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132458 */     GIR_RootConstrainSelectedInstOperands,
     /* 132459 */     // GIR_Coverage, 13439,
     /* 132459 */     GIR_EraseRootFromParent_Done,
     /* 132460 */   // Label 2327: @132460
     /* 132460 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132554), // Rule ID 4580 //
     /* 132465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132486 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132503 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132552 */     GIR_RootConstrainSelectedInstOperands,
     /* 132553 */     // GIR_Coverage, 4580,
     /* 132553 */     GIR_EraseRootFromParent_Done,
     /* 132554 */   // Label 2328: @132554
     /* 132554 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132648), // Rule ID 4607 //
     /* 132559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132580 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132597 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132609 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132646 */     GIR_RootConstrainSelectedInstOperands,
     /* 132647 */     // GIR_Coverage, 4607,
     /* 132647 */     GIR_EraseRootFromParent_Done,
     /* 132648 */   // Label 2329: @132648
     /* 132648 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132742), // Rule ID 13437 //
     /* 132653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132674 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132691 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132703 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132740 */     GIR_RootConstrainSelectedInstOperands,
     /* 132741 */     // GIR_Coverage, 13437,
     /* 132741 */     GIR_EraseRootFromParent_Done,
     /* 132742 */   // Label 2330: @132742
     /* 132742 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132836), // Rule ID 13443 //
     /* 132747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132785 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132834 */     GIR_RootConstrainSelectedInstOperands,
     /* 132835 */     // GIR_Coverage, 13443,
     /* 132835 */     GIR_EraseRootFromParent_Done,
     /* 132836 */   // Label 2331: @132836
     /* 132836 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132904), // Rule ID 6541 //
     /* 132841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132874 */     // MIs[2] Operand 1
     /* 132874 */     // No operand predicates
     /* 132874 */     // MIs[0] Rn
     /* 132874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132884 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132902 */     GIR_RootConstrainSelectedInstOperands,
     /* 132903 */     // GIR_Coverage, 6541,
     /* 132903 */     GIR_EraseRootFromParent_Done,
     /* 132904 */   // Label 2332: @132904
     /* 132904 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133003), // Rule ID 6546 //
     /* 132909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132942 */     // MIs[2] Operand 1
     /* 132942 */     // No operand predicates
     /* 132942 */     // MIs[0] Rn
     /* 132942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132952 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 132955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 132959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 132967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 132974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133001 */     GIR_RootConstrainSelectedInstOperands,
     /* 133002 */     // GIR_Coverage, 6546,
     /* 133002 */     GIR_EraseRootFromParent_Done,
     /* 133003 */   // Label 2333: @133003
     /* 133003 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133052), // Rule ID 309 //
     /* 133008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133026 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 133029 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133050 */     GIR_RootConstrainSelectedInstOperands,
     /* 133051 */     // GIR_Coverage, 309,
     /* 133051 */     GIR_EraseRootFromParent_Done,
     /* 133052 */   // Label 2334: @133052
     /* 133052 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133101), // Rule ID 310 //
     /* 133057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133075 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 133078 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133099 */     GIR_RootConstrainSelectedInstOperands,
     /* 133100 */     // GIR_Coverage, 310,
     /* 133100 */     GIR_EraseRootFromParent_Done,
     /* 133101 */   // Label 2335: @133101
     /* 133101 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133145), // Rule ID 318 //
     /* 133106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 133124 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 133124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 133127 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133143 */     GIR_RootConstrainSelectedInstOperands,
     /* 133144 */     // GIR_Coverage, 318,
     /* 133144 */     GIR_EraseRootFromParent_Done,
     /* 133145 */   // Label 2336: @133145
     /* 133145 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133189), // Rule ID 326 //
     /* 133150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 133168 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 133168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 133171 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133187 */     GIR_RootConstrainSelectedInstOperands,
     /* 133188 */     // GIR_Coverage, 326,
     /* 133188 */     GIR_EraseRootFromParent_Done,
     /* 133189 */   // Label 2337: @133189
     /* 133189 */   GIM_Reject,
     /* 133190 */ // Label 2323: @133190
     /* 133190 */ GIM_Reject,
     /* 133191 */ // Label 2297: @133191
     /* 133191 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133304), // Rule ID 4549 //
     /* 133196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133199 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133218 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133222 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133226 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133231 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133248 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 133251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133260 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 133266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 133279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133302 */   GIR_RootConstrainSelectedInstOperands,
     /* 133303 */   // GIR_Coverage, 4549,
     /* 133303 */   GIR_EraseRootFromParent_Done,
     /* 133304 */ // Label 2338: @133304
     /* 133304 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133417), // Rule ID 4550 //
     /* 133309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133312 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133344 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133361 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 133364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133373 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 133379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 133392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133415 */   GIR_RootConstrainSelectedInstOperands,
     /* 133416 */   // GIR_Coverage, 4550,
     /* 133416 */   GIR_EraseRootFromParent_Done,
     /* 133417 */ // Label 2339: @133417
     /* 133417 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133523), // Rule ID 4553 //
     /* 133422 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133425 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133437 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133441 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133445 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133450 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133460 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133467 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133479 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133490 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133521 */   GIR_RootConstrainSelectedInstOperands,
     /* 133522 */   // GIR_Coverage, 4553,
     /* 133522 */   GIR_EraseRootFromParent_Done,
     /* 133523 */ // Label 2340: @133523
     /* 133523 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133629), // Rule ID 4554 //
     /* 133528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133531 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133543 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133547 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133551 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133556 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133573 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133585 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133627 */   GIR_RootConstrainSelectedInstOperands,
     /* 133628 */   // GIR_Coverage, 4554,
     /* 133628 */   GIR_EraseRootFromParent_Done,
     /* 133629 */ // Label 2341: @133629
     /* 133629 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133735), // Rule ID 4555 //
     /* 133634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133649 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133653 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133657 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133662 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133679 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133691 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133733 */   GIR_RootConstrainSelectedInstOperands,
     /* 133734 */   // GIR_Coverage, 4555,
     /* 133734 */   GIR_EraseRootFromParent_Done,
     /* 133735 */ // Label 2342: @133735
     /* 133735 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133841), // Rule ID 4556 //
     /* 133740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133763 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133768 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133785 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133797 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133839 */   GIR_RootConstrainSelectedInstOperands,
     /* 133840 */   // GIR_Coverage, 4556,
     /* 133840 */   GIR_EraseRootFromParent_Done,
     /* 133841 */ // Label 2343: @133841
     /* 133841 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133947), // Rule ID 13445 //
     /* 133846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133861 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133874 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133891 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133903 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133945 */   GIR_RootConstrainSelectedInstOperands,
     /* 133946 */   // GIR_Coverage, 13445,
     /* 133946 */   GIR_EraseRootFromParent_Done,
     /* 133947 */ // Label 2344: @133947
     /* 133947 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134053), // Rule ID 13446 //
     /* 133952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133967 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133971 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133980 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133997 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134009 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134020 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134051 */   GIR_RootConstrainSelectedInstOperands,
     /* 134052 */   // GIR_Coverage, 13446,
     /* 134052 */   GIR_EraseRootFromParent_Done,
     /* 134053 */ // Label 2345: @134053
     /* 134053 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134161), // Rule ID 4579 //
     /* 134058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134061 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134080 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134084 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134093 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 134110 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 134110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 134113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134122 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 134128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 134141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134159 */   GIR_RootConstrainSelectedInstOperands,
     /* 134160 */   // GIR_Coverage, 4579,
     /* 134160 */   GIR_EraseRootFromParent_Done,
     /* 134161 */ // Label 2346: @134161
     /* 134161 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134262), // Rule ID 4581 //
     /* 134166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134169 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134181 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134194 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134211 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134223 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134229 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134260 */   GIR_RootConstrainSelectedInstOperands,
     /* 134261 */   // GIR_Coverage, 4581,
     /* 134261 */   GIR_EraseRootFromParent_Done,
     /* 134262 */ // Label 2347: @134262
     /* 134262 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134363), // Rule ID 4582 //
     /* 134267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134290 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134295 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134312 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134324 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134335 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134361 */   GIR_RootConstrainSelectedInstOperands,
     /* 134362 */   // GIR_Coverage, 4582,
     /* 134362 */   GIR_EraseRootFromParent_Done,
     /* 134363 */ // Label 2348: @134363
     /* 134363 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134471), // Rule ID 4606 //
     /* 134368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134403 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134420 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 134423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134432 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 134438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 134451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134469 */   GIR_RootConstrainSelectedInstOperands,
     /* 134470 */   // GIR_Coverage, 4606,
     /* 134470 */   GIR_EraseRootFromParent_Done,
     /* 134471 */ // Label 2349: @134471
     /* 134471 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134572), // Rule ID 4608 //
     /* 134476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134499 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134504 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134521 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134533 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134570 */   GIR_RootConstrainSelectedInstOperands,
     /* 134571 */   // GIR_Coverage, 4608,
     /* 134571 */   GIR_EraseRootFromParent_Done,
     /* 134572 */ // Label 2350: @134572
     /* 134572 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134673), // Rule ID 4609 //
     /* 134577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134596 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134605 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134615 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134622 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134634 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134645 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134671 */   GIR_RootConstrainSelectedInstOperands,
     /* 134672 */   // GIR_Coverage, 4609,
     /* 134672 */   GIR_EraseRootFromParent_Done,
     /* 134673 */ // Label 2351: @134673
     /* 134673 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134774), // Rule ID 13442 //
     /* 134678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134693 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134701 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134706 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134723 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134735 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134772 */   GIR_RootConstrainSelectedInstOperands,
     /* 134773 */   // GIR_Coverage, 13442,
     /* 134773 */   GIR_EraseRootFromParent_Done,
     /* 134774 */ // Label 2352: @134774
     /* 134774 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134875), // Rule ID 13444 //
     /* 134779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134807 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 134824 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134836 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134847 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134873 */   GIR_RootConstrainSelectedInstOperands,
     /* 134874 */   // GIR_Coverage, 13444,
     /* 134874 */   GIR_EraseRootFromParent_Done,
     /* 134875 */ // Label 2353: @134875
     /* 134875 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134957), // Rule ID 6535 //
     /* 134880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134883 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134902 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 134906 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134915 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134919 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134923 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134927 */   // MIs[2] Operand 1
     /* 134927 */   // No operand predicates
     /* 134927 */   // MIs[0] Rn
     /* 134927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134935 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134937 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134940 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134944 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134947 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134955 */   GIR_RootConstrainSelectedInstOperands,
     /* 134956 */   // GIR_Coverage, 6535,
     /* 134956 */   GIR_EraseRootFromParent_Done,
     /* 134957 */ // Label 2354: @134957
     /* 134957 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(135039), // Rule ID 6536 //
     /* 134962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134965 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134997 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135001 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135005 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 135009 */   // MIs[2] Operand 1
     /* 135009 */   // No operand predicates
     /* 135009 */   // MIs[0] Rn
     /* 135009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135019 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 135022 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135026 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135029 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135037 */   GIR_RootConstrainSelectedInstOperands,
     /* 135038 */   // GIR_Coverage, 6536,
     /* 135038 */   GIR_EraseRootFromParent_Done,
     /* 135039 */ // Label 2355: @135039
     /* 135039 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(135114), // Rule ID 6537 //
     /* 135044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135059 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 135063 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135067 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135080 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135084 */   // MIs[2] Operand 1
     /* 135084 */   // No operand predicates
     /* 135084 */   // MIs[0] Rn
     /* 135084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135092 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135094 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135097 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135101 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135104 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135112 */   GIR_RootConstrainSelectedInstOperands,
     /* 135113 */   // GIR_Coverage, 6537,
     /* 135113 */   GIR_EraseRootFromParent_Done,
     /* 135114 */ // Label 2356: @135114
     /* 135114 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(135189), // Rule ID 6538 //
     /* 135119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 135138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135155 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135159 */   // MIs[2] Operand 1
     /* 135159 */   // No operand predicates
     /* 135159 */   // MIs[0] Rn
     /* 135159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135169 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135172 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135176 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135187 */   GIR_RootConstrainSelectedInstOperands,
     /* 135188 */   // GIR_Coverage, 6538,
     /* 135188 */   GIR_EraseRootFromParent_Done,
     /* 135189 */ // Label 2357: @135189
     /* 135189 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(135302), // Rule ID 6542 //
     /* 135194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135197 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 135220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135229 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135233 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135237 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 135241 */   // MIs[2] Operand 1
     /* 135241 */   // No operand predicates
     /* 135241 */   // MIs[0] Rn
     /* 135241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135249 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135251 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135263 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135270 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 135286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135289 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135300 */   GIR_RootConstrainSelectedInstOperands,
     /* 135301 */   // GIR_Coverage, 6542,
     /* 135301 */   GIR_EraseRootFromParent_Done,
     /* 135302 */ // Label 2358: @135302
     /* 135302 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135415), // Rule ID 6543 //
     /* 135307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135310 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135321 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135325 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135329 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 135333 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135337 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135342 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135346 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135350 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 135354 */   // MIs[2] Operand 1
     /* 135354 */   // No operand predicates
     /* 135354 */   // MIs[0] Rn
     /* 135354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135362 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135364 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135376 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135379 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135383 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135386 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 135399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135402 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135405 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135413 */   GIR_RootConstrainSelectedInstOperands,
     /* 135414 */   // GIR_Coverage, 6543,
     /* 135414 */   GIR_EraseRootFromParent_Done,
     /* 135415 */ // Label 2359: @135415
     /* 135415 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135521), // Rule ID 6544 //
     /* 135420 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135435 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135448 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135452 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135456 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135460 */   // MIs[2] Operand 1
     /* 135460 */   // No operand predicates
     /* 135460 */   // MIs[0] Rn
     /* 135460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135468 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135470 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135482 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135489 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135508 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135511 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135519 */   GIR_RootConstrainSelectedInstOperands,
     /* 135520 */   // GIR_Coverage, 6544,
     /* 135520 */   GIR_EraseRootFromParent_Done,
     /* 135521 */ // Label 2360: @135521
     /* 135521 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135627), // Rule ID 6545 //
     /* 135526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135541 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135545 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135554 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135558 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135562 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135566 */   // MIs[2] Operand 1
     /* 135566 */   // No operand predicates
     /* 135566 */   // MIs[0] Rn
     /* 135566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135574 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135576 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135595 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135614 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135617 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135625 */   GIR_RootConstrainSelectedInstOperands,
     /* 135626 */   // GIR_Coverage, 6545,
     /* 135626 */   GIR_EraseRootFromParent_Done,
     /* 135627 */ // Label 2361: @135627
     /* 135627 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135687), // Rule ID 299 //
     /* 135632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 135661 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 135661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 135664 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135685 */   GIR_RootConstrainSelectedInstOperands,
     /* 135686 */   // GIR_Coverage, 299,
     /* 135686 */   GIR_EraseRootFromParent_Done,
     /* 135687 */ // Label 2362: @135687
     /* 135687 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135747), // Rule ID 300 //
     /* 135692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135695 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135699 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 135721 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 135721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 135724 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135745 */   GIR_RootConstrainSelectedInstOperands,
     /* 135746 */   // GIR_Coverage, 300,
     /* 135746 */   GIR_EraseRootFromParent_Done,
     /* 135747 */ // Label 2363: @135747
     /* 135747 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135807), // Rule ID 301 //
     /* 135752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135755 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135759 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 135781 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 135781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 135784 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135805 */   GIR_RootConstrainSelectedInstOperands,
     /* 135806 */   // GIR_Coverage, 301,
     /* 135806 */   GIR_EraseRootFromParent_Done,
     /* 135807 */ // Label 2364: @135807
     /* 135807 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135867), // Rule ID 302 //
     /* 135812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 135841 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 135841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 135844 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135865 */   GIR_RootConstrainSelectedInstOperands,
     /* 135866 */   // GIR_Coverage, 302,
     /* 135866 */   GIR_EraseRootFromParent_Done,
     /* 135867 */ // Label 2365: @135867
     /* 135867 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135920), // Rule ID 303 //
     /* 135872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135887 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135894 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 135897 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135914 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135918 */   GIR_RootConstrainSelectedInstOperands,
     /* 135919 */   // GIR_Coverage, 303,
     /* 135919 */   GIR_EraseRootFromParent_Done,
     /* 135920 */ // Label 2366: @135920
     /* 135920 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135973), // Rule ID 304 //
     /* 135925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135947 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 135950 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135971 */   GIR_RootConstrainSelectedInstOperands,
     /* 135972 */   // GIR_Coverage, 304,
     /* 135972 */   GIR_EraseRootFromParent_Done,
     /* 135973 */ // Label 2367: @135973
     /* 135973 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(136029), // Rule ID 311 //
     /* 135978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136003 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 136006 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136027 */   GIR_RootConstrainSelectedInstOperands,
     /* 136028 */   // GIR_Coverage, 311,
     /* 136028 */   GIR_EraseRootFromParent_Done,
     /* 136029 */ // Label 2368: @136029
     /* 136029 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(136085), // Rule ID 312 //
     /* 136034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136040 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136048 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136052 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136059 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 136062 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136083 */   GIR_RootConstrainSelectedInstOperands,
     /* 136084 */   // GIR_Coverage, 312,
     /* 136084 */   GIR_EraseRootFromParent_Done,
     /* 136085 */ // Label 2369: @136085
     /* 136085 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(136137), // Rule ID 316 //
     /* 136090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136112 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 136115 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136135 */   GIR_RootConstrainSelectedInstOperands,
     /* 136136 */   // GIR_Coverage, 316,
     /* 136136 */   GIR_EraseRootFromParent_Done,
     /* 136137 */ // Label 2370: @136137
     /* 136137 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(136188), // Rule ID 319 //
     /* 136142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136167 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 136170 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136186 */   GIR_RootConstrainSelectedInstOperands,
     /* 136187 */   // GIR_Coverage, 319,
     /* 136187 */   GIR_EraseRootFromParent_Done,
     /* 136188 */ // Label 2371: @136188
     /* 136188 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(136247), // Rule ID 321 //
     /* 136193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 136222 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 136222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 136225 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136241 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136245 */   GIR_RootConstrainSelectedInstOperands,
     /* 136246 */   // GIR_Coverage, 321,
     /* 136246 */   GIR_EraseRootFromParent_Done,
     /* 136247 */ // Label 2372: @136247
     /* 136247 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(136306), // Rule ID 322 //
     /* 136252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136255 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136259 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 136281 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 136281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 136284 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136304 */   GIR_RootConstrainSelectedInstOperands,
     /* 136305 */   // GIR_Coverage, 322,
     /* 136305 */   GIR_EraseRootFromParent_Done,
     /* 136306 */ // Label 2373: @136306
     /* 136306 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(136383), // Rule ID 7174 //
     /* 136311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136321 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136336 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136347 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136354 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 136357 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136381 */   GIR_RootConstrainSelectedInstOperands,
     /* 136382 */   // GIR_Coverage, 7174,
     /* 136382 */   GIR_EraseRootFromParent_Done,
     /* 136383 */ // Label 2374: @136383
     /* 136383 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(136460), // Rule ID 7175 //
     /* 136388 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136398 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136409 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136413 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136431 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 136434 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136458 */   GIR_RootConstrainSelectedInstOperands,
     /* 136459 */   // GIR_Coverage, 7175,
     /* 136459 */   GIR_EraseRootFromParent_Done,
     /* 136460 */ // Label 2375: @136460
     /* 136460 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(136519), // Rule ID 7155 //
     /* 136465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136475 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 136493 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15910>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 136493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 136496 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136517 */   GIR_RootConstrainSelectedInstOperands,
     /* 136518 */   // GIR_Coverage, 7155,
     /* 136518 */   GIR_EraseRootFromParent_Done,
     /* 136519 */ // Label 2376: @136519
     /* 136519 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(136578), // Rule ID 7156 //
     /* 136524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136534 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 136552 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15910>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 136552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 136555 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136576 */   GIR_RootConstrainSelectedInstOperands,
     /* 136577 */   // GIR_Coverage, 7156,
     /* 136577 */   GIR_EraseRootFromParent_Done,
     /* 136578 */ // Label 2377: @136578
     /* 136578 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136637), // Rule ID 7160 //
     /* 136583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136593 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 136611 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15917>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 136611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 136614 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136635 */   GIR_RootConstrainSelectedInstOperands,
     /* 136636 */   // GIR_Coverage, 7160,
     /* 136636 */   GIR_EraseRootFromParent_Done,
     /* 136637 */ // Label 2378: @136637
     /* 136637 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136696), // Rule ID 7161 //
     /* 136642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136652 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 136670 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15917>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 136670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 136673 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136694 */   GIR_RootConstrainSelectedInstOperands,
     /* 136695 */   // GIR_Coverage, 7161,
     /* 136695 */   GIR_EraseRootFromParent_Done,
     /* 136696 */ // Label 2379: @136696
     /* 136696 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136755), // Rule ID 7165 //
     /* 136701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136711 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136729 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 136732 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136749 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136753 */   GIR_RootConstrainSelectedInstOperands,
     /* 136754 */   // GIR_Coverage, 7165,
     /* 136754 */   GIR_EraseRootFromParent_Done,
     /* 136755 */ // Label 2380: @136755
     /* 136755 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136814), // Rule ID 7166 //
     /* 136760 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136763 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136770 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136781 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136788 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 136791 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136812 */   GIR_RootConstrainSelectedInstOperands,
     /* 136813 */   // GIR_Coverage, 7166,
     /* 136813 */   GIR_EraseRootFromParent_Done,
     /* 136814 */ // Label 2381: @136814
     /* 136814 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136886), // Rule ID 7176 //
     /* 136819 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136822 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136829 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136832 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136840 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136844 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136855 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136862 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 136865 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136884 */   GIR_RootConstrainSelectedInstOperands,
     /* 136885 */   // GIR_Coverage, 7176,
     /* 136885 */   GIR_EraseRootFromParent_Done,
     /* 136886 */ // Label 2382: @136886
     /* 136886 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136958), // Rule ID 7177 //
     /* 136891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136894 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136901 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136912 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136916 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136934 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136937 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136956 */   GIR_RootConstrainSelectedInstOperands,
     /* 136957 */   // GIR_Coverage, 7177,
     /* 136957 */   GIR_EraseRootFromParent_Done,
     /* 136958 */ // Label 2383: @136958
     /* 136958 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(137010), // Rule ID 324 //
     /* 136963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136985 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 136988 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137008 */   GIR_RootConstrainSelectedInstOperands,
     /* 137009 */   // GIR_Coverage, 324,
     /* 137009 */   GIR_EraseRootFromParent_Done,
     /* 137010 */ // Label 2384: @137010
     /* 137010 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(137061), // Rule ID 327 //
     /* 137015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137040 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 137040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 137043 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137059 */   GIR_RootConstrainSelectedInstOperands,
     /* 137060 */   // GIR_Coverage, 327,
     /* 137060 */   GIR_EraseRootFromParent_Done,
     /* 137061 */ // Label 2385: @137061
     /* 137061 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(137120), // Rule ID 330 //
     /* 137066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137069 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137095 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 137095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 137098 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 137104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137114 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137118 */   GIR_RootConstrainSelectedInstOperands,
     /* 137119 */   // GIR_Coverage, 330,
     /* 137119 */   GIR_EraseRootFromParent_Done,
     /* 137120 */ // Label 2386: @137120
     /* 137120 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(137179), // Rule ID 331 //
     /* 137125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137128 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137154 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 137154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 137157 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 137163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137177 */   GIR_RootConstrainSelectedInstOperands,
     /* 137178 */   // GIR_Coverage, 331,
     /* 137178 */   GIR_EraseRootFromParent_Done,
     /* 137179 */ // Label 2387: @137179
     /* 137179 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(137233), // Rule ID 7157 //
     /* 137184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137194 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 137212 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15910>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 137212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 137215 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137231 */   GIR_RootConstrainSelectedInstOperands,
     /* 137232 */   // GIR_Coverage, 7157,
     /* 137232 */   GIR_EraseRootFromParent_Done,
     /* 137233 */ // Label 2388: @137233
     /* 137233 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137287), // Rule ID 7158 //
     /* 137238 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137248 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137266 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15910>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 137269 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137285 */   GIR_RootConstrainSelectedInstOperands,
     /* 137286 */   // GIR_Coverage, 7158,
     /* 137286 */   GIR_EraseRootFromParent_Done,
     /* 137287 */ // Label 2389: @137287
     /* 137287 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137341), // Rule ID 7162 //
     /* 137292 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137302 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 137320 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15917>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 137320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 137323 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137339 */   GIR_RootConstrainSelectedInstOperands,
     /* 137340 */   // GIR_Coverage, 7162,
     /* 137340 */   GIR_EraseRootFromParent_Done,
     /* 137341 */ // Label 2390: @137341
     /* 137341 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137395), // Rule ID 7163 //
     /* 137346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137356 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137367 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137374 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15917>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 137377 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137393 */   GIR_RootConstrainSelectedInstOperands,
     /* 137394 */   // GIR_Coverage, 7163,
     /* 137394 */   GIR_EraseRootFromParent_Done,
     /* 137395 */ // Label 2391: @137395
     /* 137395 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137449), // Rule ID 7167 //
     /* 137400 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137410 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 137428 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 137428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 137431 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137447 */   GIR_RootConstrainSelectedInstOperands,
     /* 137448 */   // GIR_Coverage, 7167,
     /* 137448 */   GIR_EraseRootFromParent_Done,
     /* 137449 */ // Label 2392: @137449
     /* 137449 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137503), // Rule ID 7168 //
     /* 137454 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137464 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137482 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15924>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 137485 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137501 */   GIR_RootConstrainSelectedInstOperands,
     /* 137502 */   // GIR_Coverage, 7168,
     /* 137502 */   GIR_EraseRootFromParent_Done,
     /* 137503 */ // Label 2393: @137503
     /* 137503 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137560), // Rule ID 7530 //
     /* 137508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137539 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15908>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 137542 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137558 */   GIR_RootConstrainSelectedInstOperands,
     /* 137559 */   // GIR_Coverage, 7530,
     /* 137559 */   GIR_EraseRootFromParent_Done,
     /* 137560 */ // Label 2394: @137560
     /* 137560 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137617), // Rule ID 7531 //
     /* 137565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137568 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137571 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137578 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137596 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15915>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 137599 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137615 */   GIR_RootConstrainSelectedInstOperands,
     /* 137616 */   // GIR_Coverage, 7531,
     /* 137616 */   GIR_EraseRootFromParent_Done,
     /* 137617 */ // Label 2395: @137617
     /* 137617 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137674), // Rule ID 7532 //
     /* 137622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137635 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137653 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15922>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 137656 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137672 */   GIR_RootConstrainSelectedInstOperands,
     /* 137673 */   // GIR_Coverage, 7532,
     /* 137673 */   GIR_EraseRootFromParent_Done,
     /* 137674 */ // Label 2396: @137674
     /* 137674 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137711), // Rule ID 7154 //
     /* 137679 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137682 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137689 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137696 */   // MIs[0] ptr
     /* 137696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137704 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15908>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 137709 */   GIR_RootConstrainSelectedInstOperands,
     /* 137710 */   // GIR_Coverage, 7154,
     /* 137710 */   GIR_Done,
     /* 137711 */ // Label 2397: @137711
     /* 137711 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137748), // Rule ID 7159 //
     /* 137716 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137726 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137733 */   // MIs[0] ptr
     /* 137733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137741 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15915>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 137746 */   GIR_RootConstrainSelectedInstOperands,
     /* 137747 */   // GIR_Coverage, 7159,
     /* 137747 */   GIR_Done,
     /* 137748 */ // Label 2398: @137748
     /* 137748 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(137785), // Rule ID 7164 //
     /* 137753 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137763 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137770 */   // MIs[0] ptr
     /* 137770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137778 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15922>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 137783 */   GIR_RootConstrainSelectedInstOperands,
     /* 137784 */   // GIR_Coverage, 7164,
     /* 137784 */   GIR_Done,
     /* 137785 */ // Label 2399: @137785
     /* 137785 */ GIM_Reject,
     /* 137786 */ // Label 2298: @137786
     /* 137786 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(137892), // Rule ID 4557 //
     /* 137791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137798 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137806 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137814 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137819 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137823 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137836 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137848 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137854 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137890 */   GIR_RootConstrainSelectedInstOperands,
     /* 137891 */   // GIR_Coverage, 4557,
     /* 137891 */   GIR_EraseRootFromParent_Done,
     /* 137892 */ // Label 2400: @137892
     /* 137892 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(137998), // Rule ID 4558 //
     /* 137897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137900 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137912 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137916 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137920 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137925 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137929 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137942 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137954 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137996 */   GIR_RootConstrainSelectedInstOperands,
     /* 137997 */   // GIR_Coverage, 4558,
     /* 137997 */   GIR_EraseRootFromParent_Done,
     /* 137998 */ // Label 2401: @137998
     /* 137998 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(138104), // Rule ID 4559 //
     /* 138003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138031 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138048 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138060 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138102 */   GIR_RootConstrainSelectedInstOperands,
     /* 138103 */   // GIR_Coverage, 4559,
     /* 138103 */   GIR_EraseRootFromParent_Done,
     /* 138104 */ // Label 2402: @138104
     /* 138104 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(138210), // Rule ID 4560 //
     /* 138109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138137 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138154 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138166 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138172 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138208 */   GIR_RootConstrainSelectedInstOperands,
     /* 138209 */   // GIR_Coverage, 4560,
     /* 138209 */   GIR_EraseRootFromParent_Done,
     /* 138210 */ // Label 2403: @138210
     /* 138210 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138311), // Rule ID 4583 //
     /* 138215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138218 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138222 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138230 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138234 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138238 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138243 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138260 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138272 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138304 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138309 */   GIR_RootConstrainSelectedInstOperands,
     /* 138310 */   // GIR_Coverage, 4583,
     /* 138310 */   GIR_EraseRootFromParent_Done,
     /* 138311 */ // Label 2404: @138311
     /* 138311 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138412), // Rule ID 4584 //
     /* 138316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138344 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138361 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138373 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138410 */   GIR_RootConstrainSelectedInstOperands,
     /* 138411 */   // GIR_Coverage, 4584,
     /* 138411 */   GIR_EraseRootFromParent_Done,
     /* 138412 */ // Label 2405: @138412
     /* 138412 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138513), // Rule ID 4610 //
     /* 138417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138432 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138440 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138445 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138462 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138474 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138511 */   GIR_RootConstrainSelectedInstOperands,
     /* 138512 */   // GIR_Coverage, 4610,
     /* 138512 */   GIR_EraseRootFromParent_Done,
     /* 138513 */ // Label 2406: @138513
     /* 138513 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138614), // Rule ID 4611 //
     /* 138518 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138521 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138533 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138537 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138546 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138563 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138575 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138612 */   GIR_RootConstrainSelectedInstOperands,
     /* 138613 */   // GIR_Coverage, 4611,
     /* 138613 */   GIR_EraseRootFromParent_Done,
     /* 138614 */ // Label 2407: @138614
     /* 138614 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138689), // Rule ID 6539 //
     /* 138619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138647 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138651 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138655 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138659 */   // MIs[2] Operand 1
     /* 138659 */   // No operand predicates
     /* 138659 */   // MIs[0] Rn
     /* 138659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138667 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138669 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138672 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138676 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138679 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138687 */   GIR_RootConstrainSelectedInstOperands,
     /* 138688 */   // GIR_Coverage, 6539,
     /* 138688 */   GIR_EraseRootFromParent_Done,
     /* 138689 */ // Label 2408: @138689
     /* 138689 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138764), // Rule ID 6540 //
     /* 138694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138697 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138709 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138713 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138717 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138722 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138726 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138730 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138734 */   // MIs[2] Operand 1
     /* 138734 */   // No operand predicates
     /* 138734 */   // MIs[0] Rn
     /* 138734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138742 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138744 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138747 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138754 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138762 */   GIR_RootConstrainSelectedInstOperands,
     /* 138763 */   // GIR_Coverage, 6540,
     /* 138763 */   GIR_EraseRootFromParent_Done,
     /* 138764 */ // Label 2409: @138764
     /* 138764 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138817), // Rule ID 305 //
     /* 138769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138780 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138791 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138794 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138811 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138815 */   GIR_RootConstrainSelectedInstOperands,
     /* 138816 */   // GIR_Coverage, 305,
     /* 138816 */   GIR_EraseRootFromParent_Done,
     /* 138817 */ // Label 2410: @138817
     /* 138817 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138870), // Rule ID 306 //
     /* 138822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138844 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138847 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138868 */   GIR_RootConstrainSelectedInstOperands,
     /* 138869 */   // GIR_Coverage, 306,
     /* 138869 */   GIR_EraseRootFromParent_Done,
     /* 138870 */ // Label 2411: @138870
     /* 138870 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(138926), // Rule ID 313 //
     /* 138875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138881 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138900 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138903 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138924 */   GIR_RootConstrainSelectedInstOperands,
     /* 138925 */   // GIR_Coverage, 313,
     /* 138925 */   GIR_EraseRootFromParent_Done,
     /* 138926 */ // Label 2412: @138926
     /* 138926 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(138982), // Rule ID 314 //
     /* 138931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138937 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138945 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138949 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138956 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138959 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138980 */   GIR_RootConstrainSelectedInstOperands,
     /* 138981 */   // GIR_Coverage, 314,
     /* 138981 */   GIR_EraseRootFromParent_Done,
     /* 138982 */ // Label 2413: @138982
     /* 138982 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(139071), // Rule ID 4515 //
     /* 138987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138990 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 139016 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 139016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139028 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139034 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139039 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 139047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139069 */   GIR_RootConstrainSelectedInstOperands,
     /* 139070 */   // GIR_Coverage, 4515,
     /* 139070 */   GIR_EraseRootFromParent_Done,
     /* 139071 */ // Label 2414: @139071
     /* 139071 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(139160), // Rule ID 4516 //
     /* 139076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139079 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139098 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 139105 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 139105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139117 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 139136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139158 */   GIR_RootConstrainSelectedInstOperands,
     /* 139159 */   // GIR_Coverage, 4516,
     /* 139159 */   GIR_EraseRootFromParent_Done,
     /* 139160 */ // Label 2415: @139160
     /* 139160 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(139249), // Rule ID 4517 //
     /* 139165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139168 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 139194 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 139194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139206 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 139225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139247 */   GIR_RootConstrainSelectedInstOperands,
     /* 139248 */   // GIR_Coverage, 4517,
     /* 139248 */   GIR_EraseRootFromParent_Done,
     /* 139249 */ // Label 2416: @139249
     /* 139249 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(139338), // Rule ID 4518 //
     /* 139254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139257 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139276 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 139283 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 139283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139295 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 139314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139336 */   GIR_RootConstrainSelectedInstOperands,
     /* 139337 */   // GIR_Coverage, 4518,
     /* 139337 */   GIR_EraseRootFromParent_Done,
     /* 139338 */ // Label 2417: @139338
     /* 139338 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(139427), // Rule ID 4519 //
     /* 139343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139346 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139361 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 139372 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 139372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139384 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139390 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 139403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139421 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139425 */   GIR_RootConstrainSelectedInstOperands,
     /* 139426 */   // GIR_Coverage, 4519,
     /* 139426 */   GIR_EraseRootFromParent_Done,
     /* 139427 */ // Label 2418: @139427
     /* 139427 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139516), // Rule ID 4520 //
     /* 139432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139435 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139439 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 139461 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 139461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139473 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139484 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 139492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139514 */   GIR_RootConstrainSelectedInstOperands,
     /* 139515 */   // GIR_Coverage, 4520,
     /* 139515 */   GIR_EraseRootFromParent_Done,
     /* 139516 */ // Label 2419: @139516
     /* 139516 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139569), // Rule ID 4531 //
     /* 139521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139536 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139543 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139546 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139567 */   GIR_RootConstrainSelectedInstOperands,
     /* 139568 */   // GIR_Coverage, 4531,
     /* 139568 */   GIR_EraseRootFromParent_Done,
     /* 139569 */ // Label 2420: @139569
     /* 139569 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139622), // Rule ID 4532 //
     /* 139574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139596 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139599 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139620 */   GIR_RootConstrainSelectedInstOperands,
     /* 139621 */   // GIR_Coverage, 4532,
     /* 139621 */   GIR_EraseRootFromParent_Done,
     /* 139622 */ // Label 2421: @139622
     /* 139622 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139675), // Rule ID 4533 //
     /* 139627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139649 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139652 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139673 */   GIR_RootConstrainSelectedInstOperands,
     /* 139674 */   // GIR_Coverage, 4533,
     /* 139674 */   GIR_EraseRootFromParent_Done,
     /* 139675 */ // Label 2422: @139675
     /* 139675 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139728), // Rule ID 4534 //
     /* 139680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139683 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139702 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139705 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139726 */   GIR_RootConstrainSelectedInstOperands,
     /* 139727 */   // GIR_Coverage, 4534,
     /* 139727 */   GIR_EraseRootFromParent_Done,
     /* 139728 */ // Label 2423: @139728
     /* 139728 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139780), // Rule ID 315 //
     /* 139733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139755 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 139758 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 139764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139778 */   GIR_RootConstrainSelectedInstOperands,
     /* 139779 */   // GIR_Coverage, 315,
     /* 139779 */   GIR_EraseRootFromParent_Done,
     /* 139780 */ // Label 2424: @139780
     /* 139780 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139831), // Rule ID 320 //
     /* 139785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139810 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139813 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139829 */   GIR_RootConstrainSelectedInstOperands,
     /* 139830 */   // GIR_Coverage, 320,
     /* 139830 */   GIR_EraseRootFromParent_Done,
     /* 139831 */ // Label 2425: @139831
     /* 139831 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139879), // Rule ID 4561 //
     /* 139836 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139858 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139861 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139877 */   GIR_RootConstrainSelectedInstOperands,
     /* 139878 */   // GIR_Coverage, 4561,
     /* 139878 */   GIR_EraseRootFromParent_Done,
     /* 139879 */ // Label 2426: @139879
     /* 139879 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(139927), // Rule ID 4562 //
     /* 139884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139899 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139906 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139909 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139925 */   GIR_RootConstrainSelectedInstOperands,
     /* 139926 */   // GIR_Coverage, 4562,
     /* 139926 */   GIR_EraseRootFromParent_Done,
     /* 139927 */ // Label 2427: @139927
     /* 139927 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(140011), // Rule ID 4576 //
     /* 139932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 139961 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 139961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139973 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 139992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140009 */   GIR_RootConstrainSelectedInstOperands,
     /* 140010 */   // GIR_Coverage, 4576,
     /* 140010 */   GIR_EraseRootFromParent_Done,
     /* 140011 */ // Label 2428: @140011
     /* 140011 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(140095), // Rule ID 4577 //
     /* 140016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140038 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 140045 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 140045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140057 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 140076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140093 */   GIR_RootConstrainSelectedInstOperands,
     /* 140094 */   // GIR_Coverage, 4577,
     /* 140094 */   GIR_EraseRootFromParent_Done,
     /* 140095 */ // Label 2429: @140095
     /* 140095 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(140179), // Rule ID 4578 //
     /* 140100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140103 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 140129 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 140129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140141 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 140160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140177 */   GIR_RootConstrainSelectedInstOperands,
     /* 140178 */   // GIR_Coverage, 4578,
     /* 140178 */   GIR_EraseRootFromParent_Done,
     /* 140179 */ // Label 2430: @140179
     /* 140179 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(140256), // Rule ID 7178 //
     /* 140184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140194 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140205 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140209 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140227 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140230 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140254 */   GIR_RootConstrainSelectedInstOperands,
     /* 140255 */   // GIR_Coverage, 7178,
     /* 140255 */   GIR_EraseRootFromParent_Done,
     /* 140256 */ // Label 2431: @140256
     /* 140256 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(140333), // Rule ID 7179 //
     /* 140261 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140271 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140304 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140307 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140331 */   GIR_RootConstrainSelectedInstOperands,
     /* 140332 */   // GIR_Coverage, 7179,
     /* 140332 */   GIR_EraseRootFromParent_Done,
     /* 140333 */ // Label 2432: @140333
     /* 140333 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(140392), // Rule ID 7170 //
     /* 140338 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140341 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140348 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140366 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 140369 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140390 */   GIR_RootConstrainSelectedInstOperands,
     /* 140391 */   // GIR_Coverage, 7170,
     /* 140391 */   GIR_EraseRootFromParent_Done,
     /* 140392 */ // Label 2433: @140392
     /* 140392 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(140451), // Rule ID 7171 //
     /* 140397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140425 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 140428 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140449 */   GIR_RootConstrainSelectedInstOperands,
     /* 140450 */   // GIR_Coverage, 7171,
     /* 140450 */   GIR_EraseRootFromParent_Done,
     /* 140451 */ // Label 2434: @140451
     /* 140451 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(140523), // Rule ID 7180 //
     /* 140456 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140466 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140490 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140499 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 140499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140502 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140521 */   GIR_RootConstrainSelectedInstOperands,
     /* 140522 */   // GIR_Coverage, 7180,
     /* 140522 */   GIR_EraseRootFromParent_Done,
     /* 140523 */ // Label 2435: @140523
     /* 140523 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140595), // Rule ID 7181 //
     /* 140528 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140538 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140549 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140571 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140593 */   GIR_RootConstrainSelectedInstOperands,
     /* 140594 */   // GIR_Coverage, 7181,
     /* 140594 */   GIR_EraseRootFromParent_Done,
     /* 140595 */ // Label 2436: @140595
     /* 140595 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(140692), // Rule ID 7522 //
     /* 140600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140603 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140624 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140628 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 140632 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140636 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140640 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140644 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140649 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 140653 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140657 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140661 */   // MIs[3] Operand 1
     /* 140661 */   // No operand predicates
     /* 140661 */   // MIs[0] Rn
     /* 140661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140669 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140671 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15929>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140674 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 140678 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 140681 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 140690 */   GIR_RootConstrainSelectedInstOperands,
     /* 140691 */   // GIR_Coverage, 7522,
     /* 140691 */   GIR_EraseRootFromParent_Done,
     /* 140692 */ // Label 2437: @140692
     /* 140692 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140744), // Rule ID 323 //
     /* 140697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140719 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140722 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 140728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140742 */   GIR_RootConstrainSelectedInstOperands,
     /* 140743 */   // GIR_Coverage, 323,
     /* 140743 */   GIR_EraseRootFromParent_Done,
     /* 140744 */ // Label 2438: @140744
     /* 140744 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140795), // Rule ID 328 //
     /* 140749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140774 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140777 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140793 */   GIR_RootConstrainSelectedInstOperands,
     /* 140794 */   // GIR_Coverage, 328,
     /* 140794 */   GIR_EraseRootFromParent_Done,
     /* 140795 */ // Label 2439: @140795
     /* 140795 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140849), // Rule ID 7172 //
     /* 140800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140828 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 140831 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140847 */   GIR_RootConstrainSelectedInstOperands,
     /* 140848 */   // GIR_Coverage, 7172,
     /* 140848 */   GIR_EraseRootFromParent_Done,
     /* 140849 */ // Label 2440: @140849
     /* 140849 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140903), // Rule ID 7173 //
     /* 140854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140882 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15931>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140885 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140901 */   GIR_RootConstrainSelectedInstOperands,
     /* 140902 */   // GIR_Coverage, 7173,
     /* 140902 */   GIR_EraseRootFromParent_Done,
     /* 140903 */ // Label 2441: @140903
     /* 140903 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(140960), // Rule ID 7533 //
     /* 140908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 140911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140914 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140921 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140939 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15929>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 140942 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140958 */   GIR_RootConstrainSelectedInstOperands,
     /* 140959 */   // GIR_Coverage, 7533,
     /* 140959 */   GIR_EraseRootFromParent_Done,
     /* 140960 */ // Label 2442: @140960
     /* 140960 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(141008), // Rule ID 4585 //
     /* 140965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140987 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140990 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141006 */   GIR_RootConstrainSelectedInstOperands,
     /* 141007 */   // GIR_Coverage, 4585,
     /* 141007 */   GIR_EraseRootFromParent_Done,
     /* 141008 */ // Label 2443: @141008
     /* 141008 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(141056), // Rule ID 4586 //
     /* 141013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141028 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141035 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141038 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141054 */   GIR_RootConstrainSelectedInstOperands,
     /* 141055 */   // GIR_Coverage, 4586,
     /* 141055 */   GIR_EraseRootFromParent_Done,
     /* 141056 */ // Label 2444: @141056
     /* 141056 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(141140), // Rule ID 4601 //
     /* 141061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141064 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141068 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 141075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 141090 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141102 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 141108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 141121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141138 */   GIR_RootConstrainSelectedInstOperands,
     /* 141139 */   // GIR_Coverage, 4601,
     /* 141139 */   GIR_EraseRootFromParent_Done,
     /* 141140 */ // Label 2445: @141140
     /* 141140 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(141224), // Rule ID 4602 //
     /* 141145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141148 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 141159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 141174 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141186 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 141192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 141205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141222 */   GIR_RootConstrainSelectedInstOperands,
     /* 141223 */   // GIR_Coverage, 4602,
     /* 141223 */   GIR_EraseRootFromParent_Done,
     /* 141224 */ // Label 2446: @141224
     /* 141224 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(141308), // Rule ID 4603 //
     /* 141229 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141232 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141236 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 141258 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141270 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 141276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 141289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141306 */   GIR_RootConstrainSelectedInstOperands,
     /* 141307 */   // GIR_Coverage, 4603,
     /* 141307 */   GIR_EraseRootFromParent_Done,
     /* 141308 */ // Label 2447: @141308
     /* 141308 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(141392), // Rule ID 7521 //
     /* 141313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 141316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141319 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141326 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 141333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 141337 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 141341 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141350 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141354 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 141358 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 141362 */   // MIs[2] Operand 1
     /* 141362 */   // No operand predicates
     /* 141362 */   // MIs[0] Rn
     /* 141362 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141370 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 141372 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15929>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 141372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 141375 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 141379 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 141382 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 141390 */   GIR_RootConstrainSelectedInstOperands,
     /* 141391 */   // GIR_Coverage, 7521,
     /* 141391 */   GIR_EraseRootFromParent_Done,
     /* 141392 */ // Label 2448: @141392
     /* 141392 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(141490), // Rule ID 7523 //
     /* 141397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 141400 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141410 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 141417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 141421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 141425 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141430 */   // MIs[0] Rn
     /* 141430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141440 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15929>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 141440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 141443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 141447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141452 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 141455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 141459 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 141462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 141475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141488 */   GIR_RootConstrainSelectedInstOperands,
     /* 141489 */   // GIR_Coverage, 7523,
     /* 141489 */   GIR_EraseRootFromParent_Done,
     /* 141490 */ // Label 2449: @141490
     /* 141490 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(141527), // Rule ID 7169 //
     /* 141495 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141498 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141512 */   // MIs[0] ptr
     /* 141512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141520 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15929>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 141520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 141525 */   GIR_RootConstrainSelectedInstOperands,
     /* 141526 */   // GIR_Coverage, 7169,
     /* 141526 */   GIR_Done,
     /* 141527 */ // Label 2450: @141527
     /* 141527 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(141554), // Rule ID 6479 //
     /* 141532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141535 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141539 */   // MIs[0] Rn
     /* 141539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141547 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 141552 */   GIR_RootConstrainSelectedInstOperands,
     /* 141553 */   // GIR_Coverage, 6479,
     /* 141553 */   GIR_Done,
     /* 141554 */ // Label 2451: @141554
     /* 141554 */ GIM_Reject,
     /* 141555 */ // Label 2299: @141555
     /* 141555 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(141760),
     /* 141560 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141563 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141575 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(141616), // Rule ID 4513 //
     /* 141580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141590 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141593 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141614 */     GIR_RootConstrainSelectedInstOperands,
     /* 141615 */     // GIR_Coverage, 4513,
     /* 141615 */     GIR_EraseRootFromParent_Done,
     /* 141616 */   // Label 2453: @141616
     /* 141616 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(141657), // Rule ID 4514 //
     /* 141621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141631 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141634 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141655 */     GIR_RootConstrainSelectedInstOperands,
     /* 141656 */     // GIR_Coverage, 4514,
     /* 141656 */     GIR_EraseRootFromParent_Done,
     /* 141657 */   // Label 2454: @141657
     /* 141657 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(141690), // Rule ID 4568 //
     /* 141662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141669 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141672 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141688 */     GIR_RootConstrainSelectedInstOperands,
     /* 141689 */     // GIR_Coverage, 4568,
     /* 141689 */     GIR_EraseRootFromParent_Done,
     /* 141690 */   // Label 2455: @141690
     /* 141690 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(141723), // Rule ID 4592 //
     /* 141695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141702 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141705 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141721 */     GIR_RootConstrainSelectedInstOperands,
     /* 141722 */     // GIR_Coverage, 4592,
     /* 141722 */     GIR_EraseRootFromParent_Done,
     /* 141723 */   // Label 2456: @141723
     /* 141723 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141759), // Rule ID 329 //
     /* 141728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141738 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 141738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141741 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141757 */     GIR_RootConstrainSelectedInstOperands,
     /* 141758 */     // GIR_Coverage, 329,
     /* 141758 */     GIR_EraseRootFromParent_Done,
     /* 141759 */   // Label 2457: @141759
     /* 141759 */   GIM_Reject,
     /* 141760 */ // Label 2452: @141760
     /* 141760 */ GIM_Reject,
     /* 141761 */ // Label 2300: @141761
     /* 141761 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(142166),
     /* 141766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141773 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(141822), // Rule ID 4521 //
     /* 141778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141796 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141799 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141820 */     GIR_RootConstrainSelectedInstOperands,
     /* 141821 */     // GIR_Coverage, 4521,
     /* 141821 */     GIR_EraseRootFromParent_Done,
     /* 141822 */   // Label 2459: @141822
     /* 141822 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(141871), // Rule ID 4522 //
     /* 141827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141845 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141848 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141869 */     GIR_RootConstrainSelectedInstOperands,
     /* 141870 */     // GIR_Coverage, 4522,
     /* 141870 */     GIR_EraseRootFromParent_Done,
     /* 141871 */   // Label 2460: @141871
     /* 141871 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(141920), // Rule ID 4523 //
     /* 141876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141894 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141918 */     GIR_RootConstrainSelectedInstOperands,
     /* 141919 */     // GIR_Coverage, 4523,
     /* 141919 */     GIR_EraseRootFromParent_Done,
     /* 141920 */   // Label 2461: @141920
     /* 141920 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141969), // Rule ID 4524 //
     /* 141925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141943 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141946 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141967 */     GIR_RootConstrainSelectedInstOperands,
     /* 141968 */     // GIR_Coverage, 4524,
     /* 141968 */     GIR_EraseRootFromParent_Done,
     /* 141969 */   // Label 2462: @141969
     /* 141969 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(142013), // Rule ID 4563 //
     /* 141974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141992 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141995 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142011 */     GIR_RootConstrainSelectedInstOperands,
     /* 142012 */     // GIR_Coverage, 4563,
     /* 142012 */     GIR_EraseRootFromParent_Done,
     /* 142013 */   // Label 2463: @142013
     /* 142013 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(142057), // Rule ID 4566 //
     /* 142018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142036 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142039 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142055 */     GIR_RootConstrainSelectedInstOperands,
     /* 142056 */     // GIR_Coverage, 4566,
     /* 142056 */     GIR_EraseRootFromParent_Done,
     /* 142057 */   // Label 2464: @142057
     /* 142057 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(142101), // Rule ID 4587 //
     /* 142062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142080 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142083 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142099 */     GIR_RootConstrainSelectedInstOperands,
     /* 142100 */     // GIR_Coverage, 4587,
     /* 142100 */     GIR_EraseRootFromParent_Done,
     /* 142101 */   // Label 2465: @142101
     /* 142101 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(142145), // Rule ID 4590 //
     /* 142106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142124 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142127 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142143 */     GIR_RootConstrainSelectedInstOperands,
     /* 142144 */     // GIR_Coverage, 4590,
     /* 142144 */     GIR_EraseRootFromParent_Done,
     /* 142145 */   // Label 2466: @142145
     /* 142145 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(142165), // Rule ID 6478 //
     /* 142150 */     // MIs[0] Rn
     /* 142150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142158 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 142163 */     GIR_RootConstrainSelectedInstOperands,
     /* 142164 */     // GIR_Coverage, 6478,
     /* 142164 */     GIR_Done,
     /* 142165 */   // Label 2467: @142165
     /* 142165 */   GIM_Reject,
     /* 142166 */ // Label 2458: @142166
     /* 142166 */ GIM_Reject,
     /* 142167 */ // Label 2301: @142167
     /* 142167 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(142616),
     /* 142172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142179 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(142228), // Rule ID 4535 //
     /* 142184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142202 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142205 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142226 */     GIR_RootConstrainSelectedInstOperands,
     /* 142227 */     // GIR_Coverage, 4535,
     /* 142227 */     GIR_EraseRootFromParent_Done,
     /* 142228 */   // Label 2469: @142228
     /* 142228 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(142277), // Rule ID 4536 //
     /* 142233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142251 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142254 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142275 */     GIR_RootConstrainSelectedInstOperands,
     /* 142276 */     // GIR_Coverage, 4536,
     /* 142276 */     GIR_EraseRootFromParent_Done,
     /* 142277 */   // Label 2470: @142277
     /* 142277 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(142326), // Rule ID 4537 //
     /* 142282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142300 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142303 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142324 */     GIR_RootConstrainSelectedInstOperands,
     /* 142325 */     // GIR_Coverage, 4537,
     /* 142325 */     GIR_EraseRootFromParent_Done,
     /* 142326 */   // Label 2471: @142326
     /* 142326 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(142375), // Rule ID 4538 //
     /* 142331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142349 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142373 */     GIR_RootConstrainSelectedInstOperands,
     /* 142374 */     // GIR_Coverage, 4538,
     /* 142374 */     GIR_EraseRootFromParent_Done,
     /* 142375 */   // Label 2472: @142375
     /* 142375 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(142419), // Rule ID 4570 //
     /* 142380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142398 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142401 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142417 */     GIR_RootConstrainSelectedInstOperands,
     /* 142418 */     // GIR_Coverage, 4570,
     /* 142418 */     GIR_EraseRootFromParent_Done,
     /* 142419 */   // Label 2473: @142419
     /* 142419 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(142463), // Rule ID 4574 //
     /* 142424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142442 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142445 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142461 */     GIR_RootConstrainSelectedInstOperands,
     /* 142462 */     // GIR_Coverage, 4574,
     /* 142462 */     GIR_EraseRootFromParent_Done,
     /* 142463 */   // Label 2474: @142463
     /* 142463 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(142507), // Rule ID 4594 //
     /* 142468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142486 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142489 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142505 */     GIR_RootConstrainSelectedInstOperands,
     /* 142506 */     // GIR_Coverage, 4594,
     /* 142506 */     GIR_EraseRootFromParent_Done,
     /* 142507 */   // Label 2475: @142507
     /* 142507 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(142551), // Rule ID 4598 //
     /* 142512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142530 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142533 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142549 */     GIR_RootConstrainSelectedInstOperands,
     /* 142550 */     // GIR_Coverage, 4598,
     /* 142550 */     GIR_EraseRootFromParent_Done,
     /* 142551 */   // Label 2476: @142551
     /* 142551 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(142595), // Rule ID 4599 //
     /* 142556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142574 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142577 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142593 */     GIR_RootConstrainSelectedInstOperands,
     /* 142594 */     // GIR_Coverage, 4599,
     /* 142594 */     GIR_EraseRootFromParent_Done,
     /* 142595 */   // Label 2477: @142595
     /* 142595 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(142615), // Rule ID 6475 //
     /* 142600 */     // MIs[0] Rn
     /* 142600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142608 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 142613 */     GIR_RootConstrainSelectedInstOperands,
     /* 142614 */     // GIR_Coverage, 6475,
     /* 142614 */     GIR_Done,
     /* 142615 */   // Label 2478: @142615
     /* 142615 */   GIM_Reject,
     /* 142616 */ // Label 2468: @142616
     /* 142616 */ GIM_Reject,
     /* 142617 */ // Label 2302: @142617
     /* 142617 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(143022),
     /* 142622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142629 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(142678), // Rule ID 4525 //
     /* 142634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142652 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142655 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142676 */     GIR_RootConstrainSelectedInstOperands,
     /* 142677 */     // GIR_Coverage, 4525,
     /* 142677 */     GIR_EraseRootFromParent_Done,
     /* 142678 */   // Label 2480: @142678
     /* 142678 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(142727), // Rule ID 4526 //
     /* 142683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142701 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142704 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142725 */     GIR_RootConstrainSelectedInstOperands,
     /* 142726 */     // GIR_Coverage, 4526,
     /* 142726 */     GIR_EraseRootFromParent_Done,
     /* 142727 */   // Label 2481: @142727
     /* 142727 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(142776), // Rule ID 4529 //
     /* 142732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142750 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142753 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142774 */     GIR_RootConstrainSelectedInstOperands,
     /* 142775 */     // GIR_Coverage, 4529,
     /* 142775 */     GIR_EraseRootFromParent_Done,
     /* 142776 */   // Label 2482: @142776
     /* 142776 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142825), // Rule ID 4530 //
     /* 142781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142799 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142802 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142823 */     GIR_RootConstrainSelectedInstOperands,
     /* 142824 */     // GIR_Coverage, 4530,
     /* 142824 */     GIR_EraseRootFromParent_Done,
     /* 142825 */   // Label 2483: @142825
     /* 142825 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(142869), // Rule ID 4565 //
     /* 142830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142848 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142851 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142867 */     GIR_RootConstrainSelectedInstOperands,
     /* 142868 */     // GIR_Coverage, 4565,
     /* 142868 */     GIR_EraseRootFromParent_Done,
     /* 142869 */   // Label 2484: @142869
     /* 142869 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(142913), // Rule ID 4567 //
     /* 142874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142892 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142895 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142911 */     GIR_RootConstrainSelectedInstOperands,
     /* 142912 */     // GIR_Coverage, 4567,
     /* 142912 */     GIR_EraseRootFromParent_Done,
     /* 142913 */   // Label 2485: @142913
     /* 142913 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(142957), // Rule ID 4589 //
     /* 142918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142936 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142939 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142955 */     GIR_RootConstrainSelectedInstOperands,
     /* 142956 */     // GIR_Coverage, 4589,
     /* 142956 */     GIR_EraseRootFromParent_Done,
     /* 142957 */   // Label 2486: @142957
     /* 142957 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(143001), // Rule ID 4591 //
     /* 142962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142980 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142983 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142999 */     GIR_RootConstrainSelectedInstOperands,
     /* 143000 */     // GIR_Coverage, 4591,
     /* 143000 */     GIR_EraseRootFromParent_Done,
     /* 143001 */   // Label 2487: @143001
     /* 143001 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(143021), // Rule ID 6477 //
     /* 143006 */     // MIs[0] Rn
     /* 143006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143014 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 143019 */     GIR_RootConstrainSelectedInstOperands,
     /* 143020 */     // GIR_Coverage, 6477,
     /* 143020 */     GIR_Done,
     /* 143021 */   // Label 2488: @143021
     /* 143021 */   GIM_Reject,
     /* 143022 */ // Label 2479: @143022
     /* 143022 */ GIM_Reject,
     /* 143023 */ // Label 2303: @143023
     /* 143023 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(143428),
     /* 143028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143031 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143035 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(143084), // Rule ID 4539 //
     /* 143040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143058 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143061 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143082 */     GIR_RootConstrainSelectedInstOperands,
     /* 143083 */     // GIR_Coverage, 4539,
     /* 143083 */     GIR_EraseRootFromParent_Done,
     /* 143084 */   // Label 2490: @143084
     /* 143084 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(143133), // Rule ID 4540 //
     /* 143089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143107 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143110 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143131 */     GIR_RootConstrainSelectedInstOperands,
     /* 143132 */     // GIR_Coverage, 4540,
     /* 143132 */     GIR_EraseRootFromParent_Done,
     /* 143133 */   // Label 2491: @143133
     /* 143133 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(143182), // Rule ID 4541 //
     /* 143138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143156 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143159 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143180 */     GIR_RootConstrainSelectedInstOperands,
     /* 143181 */     // GIR_Coverage, 4541,
     /* 143181 */     GIR_EraseRootFromParent_Done,
     /* 143182 */   // Label 2492: @143182
     /* 143182 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(143231), // Rule ID 4542 //
     /* 143187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143205 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143208 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143229 */     GIR_RootConstrainSelectedInstOperands,
     /* 143230 */     // GIR_Coverage, 4542,
     /* 143230 */     GIR_EraseRootFromParent_Done,
     /* 143231 */   // Label 2493: @143231
     /* 143231 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(143275), // Rule ID 4569 //
     /* 143236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143254 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143257 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143273 */     GIR_RootConstrainSelectedInstOperands,
     /* 143274 */     // GIR_Coverage, 4569,
     /* 143274 */     GIR_EraseRootFromParent_Done,
     /* 143275 */   // Label 2494: @143275
     /* 143275 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(143319), // Rule ID 4573 //
     /* 143280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143298 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143301 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143317 */     GIR_RootConstrainSelectedInstOperands,
     /* 143318 */     // GIR_Coverage, 4573,
     /* 143318 */     GIR_EraseRootFromParent_Done,
     /* 143319 */   // Label 2495: @143319
     /* 143319 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(143363), // Rule ID 4593 //
     /* 143324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143342 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143345 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143361 */     GIR_RootConstrainSelectedInstOperands,
     /* 143362 */     // GIR_Coverage, 4593,
     /* 143362 */     GIR_EraseRootFromParent_Done,
     /* 143363 */   // Label 2496: @143363
     /* 143363 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(143407), // Rule ID 4597 //
     /* 143368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143386 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143389 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143405 */     GIR_RootConstrainSelectedInstOperands,
     /* 143406 */     // GIR_Coverage, 4597,
     /* 143406 */     GIR_EraseRootFromParent_Done,
     /* 143407 */   // Label 2497: @143407
     /* 143407 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(143427), // Rule ID 6474 //
     /* 143412 */     // MIs[0] Rn
     /* 143412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143420 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 143425 */     GIR_RootConstrainSelectedInstOperands,
     /* 143426 */     // GIR_Coverage, 6474,
     /* 143426 */     GIR_Done,
     /* 143427 */   // Label 2498: @143427
     /* 143427 */   GIM_Reject,
     /* 143428 */ // Label 2489: @143428
     /* 143428 */ GIM_Reject,
     /* 143429 */ // Label 2304: @143429
     /* 143429 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(143648),
     /* 143434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143441 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(143490), // Rule ID 4527 //
     /* 143446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 143464 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 143464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 143467 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143488 */     GIR_RootConstrainSelectedInstOperands,
     /* 143489 */     // GIR_Coverage, 4527,
     /* 143489 */     GIR_EraseRootFromParent_Done,
     /* 143490 */   // Label 2500: @143490
     /* 143490 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(143539), // Rule ID 4528 //
     /* 143495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 143513 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 143513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 143516 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143537 */     GIR_RootConstrainSelectedInstOperands,
     /* 143538 */     // GIR_Coverage, 4528,
     /* 143538 */     GIR_EraseRootFromParent_Done,
     /* 143539 */   // Label 2501: @143539
     /* 143539 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(143583), // Rule ID 4564 //
     /* 143544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 143562 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 143562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 143565 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143581 */     GIR_RootConstrainSelectedInstOperands,
     /* 143582 */     // GIR_Coverage, 4564,
     /* 143582 */     GIR_EraseRootFromParent_Done,
     /* 143583 */   // Label 2502: @143583
     /* 143583 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(143627), // Rule ID 4588 //
     /* 143588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 143606 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 143609 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143625 */     GIR_RootConstrainSelectedInstOperands,
     /* 143626 */     // GIR_Coverage, 4588,
     /* 143626 */     GIR_EraseRootFromParent_Done,
     /* 143627 */   // Label 2503: @143627
     /* 143627 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(143647), // Rule ID 6476 //
     /* 143632 */     // MIs[0] Rn
     /* 143632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143640 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 143645 */     GIR_RootConstrainSelectedInstOperands,
     /* 143646 */     // GIR_Coverage, 6476,
     /* 143646 */     GIR_Done,
     /* 143647 */   // Label 2504: @143647
     /* 143647 */   GIM_Reject,
     /* 143648 */ // Label 2499: @143648
     /* 143648 */ GIM_Reject,
     /* 143649 */ // Label 2305: @143649
     /* 143649 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(144054),
     /* 143654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143661 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(143710), // Rule ID 4543 //
     /* 143666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143684 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143687 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143708 */     GIR_RootConstrainSelectedInstOperands,
     /* 143709 */     // GIR_Coverage, 4543,
     /* 143709 */     GIR_EraseRootFromParent_Done,
     /* 143710 */   // Label 2506: @143710
     /* 143710 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(143759), // Rule ID 4544 //
     /* 143715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143733 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143736 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143757 */     GIR_RootConstrainSelectedInstOperands,
     /* 143758 */     // GIR_Coverage, 4544,
     /* 143758 */     GIR_EraseRootFromParent_Done,
     /* 143759 */   // Label 2507: @143759
     /* 143759 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(143808), // Rule ID 4547 //
     /* 143764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143782 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143785 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143806 */     GIR_RootConstrainSelectedInstOperands,
     /* 143807 */     // GIR_Coverage, 4547,
     /* 143807 */     GIR_EraseRootFromParent_Done,
     /* 143808 */   // Label 2508: @143808
     /* 143808 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(143857), // Rule ID 4548 //
     /* 143813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143831 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143834 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143855 */     GIR_RootConstrainSelectedInstOperands,
     /* 143856 */     // GIR_Coverage, 4548,
     /* 143856 */     GIR_EraseRootFromParent_Done,
     /* 143857 */   // Label 2509: @143857
     /* 143857 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(143901), // Rule ID 4572 //
     /* 143862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143880 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143883 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143899 */     GIR_RootConstrainSelectedInstOperands,
     /* 143900 */     // GIR_Coverage, 4572,
     /* 143900 */     GIR_EraseRootFromParent_Done,
     /* 143901 */   // Label 2510: @143901
     /* 143901 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(143945), // Rule ID 4575 //
     /* 143906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143924 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143927 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143943 */     GIR_RootConstrainSelectedInstOperands,
     /* 143944 */     // GIR_Coverage, 4575,
     /* 143944 */     GIR_EraseRootFromParent_Done,
     /* 143945 */   // Label 2511: @143945
     /* 143945 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143989), // Rule ID 4596 //
     /* 143950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143968 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143971 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143987 */     GIR_RootConstrainSelectedInstOperands,
     /* 143988 */     // GIR_Coverage, 4596,
     /* 143988 */     GIR_EraseRootFromParent_Done,
     /* 143989 */   // Label 2512: @143989
     /* 143989 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(144033), // Rule ID 4600 //
     /* 143994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 144012 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 144012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 144015 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 144017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 144022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144031 */     GIR_RootConstrainSelectedInstOperands,
     /* 144032 */     // GIR_Coverage, 4600,
     /* 144032 */     GIR_EraseRootFromParent_Done,
     /* 144033 */   // Label 2513: @144033
     /* 144033 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(144053), // Rule ID 6473 //
     /* 144038 */     // MIs[0] Rn
     /* 144038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144046 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 144046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 144051 */     GIR_RootConstrainSelectedInstOperands,
     /* 144052 */     // GIR_Coverage, 6473,
     /* 144052 */     GIR_Done,
     /* 144053 */   // Label 2514: @144053
     /* 144053 */   GIM_Reject,
     /* 144054 */ // Label 2505: @144054
     /* 144054 */ GIM_Reject,
     /* 144055 */ // Label 2306: @144055
     /* 144055 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(144274),
     /* 144060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144067 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(144116), // Rule ID 4545 //
     /* 144072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 144075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 144090 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 144090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 144093 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 144095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 144100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 144105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 144110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144114 */     GIR_RootConstrainSelectedInstOperands,
     /* 144115 */     // GIR_Coverage, 4545,
     /* 144115 */     GIR_EraseRootFromParent_Done,
     /* 144116 */   // Label 2516: @144116
     /* 144116 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(144165), // Rule ID 4546 //
     /* 144121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 144124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 144139 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 144139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 144142 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 144144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 144149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 144154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 144159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144163 */     GIR_RootConstrainSelectedInstOperands,
     /* 144164 */     // GIR_Coverage, 4546,
     /* 144164 */     GIR_EraseRootFromParent_Done,
     /* 144165 */   // Label 2517: @144165
     /* 144165 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(144209), // Rule ID 4571 //
     /* 144170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 144173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 144188 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 144188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 144191 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 144193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 144198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144207 */     GIR_RootConstrainSelectedInstOperands,
     /* 144208 */     // GIR_Coverage, 4571,
     /* 144208 */     GIR_EraseRootFromParent_Done,
     /* 144209 */   // Label 2518: @144209
     /* 144209 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(144253), // Rule ID 4595 //
     /* 144214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 144217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 144232 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 144232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 144235 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 144237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 144242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144251 */     GIR_RootConstrainSelectedInstOperands,
     /* 144252 */     // GIR_Coverage, 4595,
     /* 144252 */     GIR_EraseRootFromParent_Done,
     /* 144253 */   // Label 2519: @144253
     /* 144253 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(144273), // Rule ID 6472 //
     /* 144258 */     // MIs[0] Rn
     /* 144258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144266 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 144266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 144271 */     GIR_RootConstrainSelectedInstOperands,
     /* 144272 */     // GIR_Coverage, 6472,
     /* 144272 */     GIR_Done,
     /* 144273 */   // Label 2520: @144273
     /* 144273 */   GIM_Reject,
     /* 144274 */ // Label 2515: @144274
     /* 144274 */ GIM_Reject,
     /* 144275 */ // Label 2307: @144275
     /* 144275 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(144334), // Rule ID 10997 //
     /* 144280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144283 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144290 */   // MIs[0] base
     /* 144290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144298 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144310 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 144318 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144323 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144332 */   GIR_RootConstrainSelectedInstOperands,
     /* 144333 */   // GIR_Coverage, 10997,
     /* 144333 */   GIR_EraseRootFromParent_Done,
     /* 144334 */ // Label 2521: @144334
     /* 144334 */ GIM_Reject,
     /* 144335 */ // Label 2308: @144335
     /* 144335 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(144394), // Rule ID 11003 //
     /* 144340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144350 */   // MIs[0] base
     /* 144350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144358 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144370 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 144378 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144383 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144392 */   GIR_RootConstrainSelectedInstOperands,
     /* 144393 */   // GIR_Coverage, 11003,
     /* 144393 */   GIR_EraseRootFromParent_Done,
     /* 144394 */ // Label 2522: @144394
     /* 144394 */ GIM_Reject,
     /* 144395 */ // Label 2309: @144395
     /* 144395 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(144564),
     /* 144400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144411 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144459), // Rule ID 10988 //
     /* 144416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144423 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144443 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144448 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144457 */     GIR_RootConstrainSelectedInstOperands,
     /* 144458 */     // GIR_Coverage, 10988,
     /* 144458 */     GIR_EraseRootFromParent_Done,
     /* 144459 */   // Label 2524: @144459
     /* 144459 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(144507), // Rule ID 11006 //
     /* 144464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144471 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144491 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144496 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144505 */     GIR_RootConstrainSelectedInstOperands,
     /* 144506 */     // GIR_Coverage, 11006,
     /* 144506 */     GIR_EraseRootFromParent_Done,
     /* 144507 */   // Label 2525: @144507
     /* 144507 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(144535), // Rule ID 11118 //
     /* 144512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144519 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144522 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144524 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144533 */     GIR_RootConstrainSelectedInstOperands,
     /* 144534 */     // GIR_Coverage, 11118,
     /* 144534 */     GIR_EraseRootFromParent_Done,
     /* 144535 */   // Label 2526: @144535
     /* 144535 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(144563), // Rule ID 11130 //
     /* 144540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144547 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144550 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144552 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144561 */     GIR_RootConstrainSelectedInstOperands,
     /* 144562 */     // GIR_Coverage, 11130,
     /* 144562 */     GIR_EraseRootFromParent_Done,
     /* 144563 */   // Label 2527: @144563
     /* 144563 */   GIM_Reject,
     /* 144564 */ // Label 2523: @144564
     /* 144564 */ GIM_Reject,
     /* 144565 */ // Label 2310: @144565
     /* 144565 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(144624), // Rule ID 10994 //
     /* 144570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144580 */   // MIs[0] base
     /* 144580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144588 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144600 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 144608 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144613 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144622 */   GIR_RootConstrainSelectedInstOperands,
     /* 144623 */   // GIR_Coverage, 10994,
     /* 144623 */   GIR_EraseRootFromParent_Done,
     /* 144624 */ // Label 2528: @144624
     /* 144624 */ GIM_Reject,
     /* 144625 */ // Label 2311: @144625
     /* 144625 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(144794),
     /* 144630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144641 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(144689), // Rule ID 10982 //
     /* 144646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144653 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144678 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144687 */     GIR_RootConstrainSelectedInstOperands,
     /* 144688 */     // GIR_Coverage, 10982,
     /* 144688 */     GIR_EraseRootFromParent_Done,
     /* 144689 */   // Label 2530: @144689
     /* 144689 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(144737), // Rule ID 11000 //
     /* 144694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144701 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144721 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144726 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144735 */     GIR_RootConstrainSelectedInstOperands,
     /* 144736 */     // GIR_Coverage, 11000,
     /* 144736 */     GIR_EraseRootFromParent_Done,
     /* 144737 */   // Label 2531: @144737
     /* 144737 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(144765), // Rule ID 11114 //
     /* 144742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144749 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144752 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144754 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144763 */     GIR_RootConstrainSelectedInstOperands,
     /* 144764 */     // GIR_Coverage, 11114,
     /* 144764 */     GIR_EraseRootFromParent_Done,
     /* 144765 */   // Label 2532: @144765
     /* 144765 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(144793), // Rule ID 11126 //
     /* 144770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144777 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144780 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144782 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144791 */     GIR_RootConstrainSelectedInstOperands,
     /* 144792 */     // GIR_Coverage, 11126,
     /* 144792 */     GIR_EraseRootFromParent_Done,
     /* 144793 */   // Label 2533: @144793
     /* 144793 */   GIM_Reject,
     /* 144794 */ // Label 2529: @144794
     /* 144794 */ GIM_Reject,
     /* 144795 */ // Label 2312: @144795
     /* 144795 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(144964),
     /* 144800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144811 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(144859), // Rule ID 10973 //
     /* 144816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144823 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144843 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144848 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144857 */     GIR_RootConstrainSelectedInstOperands,
     /* 144858 */     // GIR_Coverage, 10973,
     /* 144858 */     GIR_EraseRootFromParent_Done,
     /* 144859 */   // Label 2535: @144859
     /* 144859 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(144907), // Rule ID 10991 //
     /* 144864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144871 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144883 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144891 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144896 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144905 */     GIR_RootConstrainSelectedInstOperands,
     /* 144906 */     // GIR_Coverage, 10991,
     /* 144906 */     GIR_EraseRootFromParent_Done,
     /* 144907 */   // Label 2536: @144907
     /* 144907 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(144935), // Rule ID 11110 //
     /* 144912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144919 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144922 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144924 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144933 */     GIR_RootConstrainSelectedInstOperands,
     /* 144934 */     // GIR_Coverage, 11110,
     /* 144934 */     GIR_EraseRootFromParent_Done,
     /* 144935 */   // Label 2537: @144935
     /* 144935 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(144963), // Rule ID 11122 //
     /* 144940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144947 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144950 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144952 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144961 */     GIR_RootConstrainSelectedInstOperands,
     /* 144962 */     // GIR_Coverage, 11122,
     /* 144962 */     GIR_EraseRootFromParent_Done,
     /* 144963 */   // Label 2538: @144963
     /* 144963 */   GIM_Reject,
     /* 144964 */ // Label 2534: @144964
     /* 144964 */ GIM_Reject,
     /* 144965 */ // Label 2313: @144965
     /* 144965 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(145008), // Rule ID 2437 //
     /* 144970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144984 */   // MIs[0] base
     /* 144984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144992 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 144995 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 144997 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145006 */   GIR_RootConstrainSelectedInstOperands,
     /* 145007 */   // GIR_Coverage, 2437,
     /* 145007 */   GIR_EraseRootFromParent_Done,
     /* 145008 */ // Label 2539: @145008
     /* 145008 */ GIM_Reject,
     /* 145009 */ // Label 2314: @145009
     /* 145009 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(145102),
     /* 145014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 145021 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145025 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(145073), // Rule ID 10959 //
     /* 145030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145037 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 145037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 145040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 145044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 145052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 145054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 145057 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 145059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145062 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 145064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145071 */     GIR_RootConstrainSelectedInstOperands,
     /* 145072 */     // GIR_Coverage, 10959,
     /* 145072 */     GIR_EraseRootFromParent_Done,
     /* 145073 */   // Label 2541: @145073
     /* 145073 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(145101), // Rule ID 11106 //
     /* 145078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 145081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145085 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 145085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 145088 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 145090 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 145092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145099 */     GIR_RootConstrainSelectedInstOperands,
     /* 145100 */     // GIR_Coverage, 11106,
     /* 145100 */     GIR_EraseRootFromParent_Done,
     /* 145101 */   // Label 2542: @145101
     /* 145101 */   GIM_Reject,
     /* 145102 */ // Label 2540: @145102
     /* 145102 */ GIM_Reject,
     /* 145103 */ // Label 2315: @145103
     /* 145103 */ GIM_Reject,
     /* 145104 */ // Label 20: @145104
     /* 145104 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2545*/ GIMT_Encode4(146454),
     /* 145115 */ /*GILLT_s32*//*Label 2543*/ GIMT_Encode4(145123),
     /* 145119 */ /*GILLT_s64*//*Label 2544*/ GIMT_Encode4(146141),
     /* 145123 */ // Label 2543: @145123
     /* 145123 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(146140),
     /* 145128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 145134 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(145189), // Rule ID 7392 //
     /* 145139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145156 */     // MIs[0] Rn
     /* 145156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145172 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 145175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145187 */     GIR_RootConstrainSelectedInstOperands,
     /* 145188 */     // GIR_Coverage, 7392,
     /* 145188 */     GIR_EraseRootFromParent_Done,
     /* 145189 */   // Label 2547: @145189
     /* 145189 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(145244), // Rule ID 7393 //
     /* 145194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145211 */     // MIs[0] Rn
     /* 145211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145227 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 145230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145242 */     GIR_RootConstrainSelectedInstOperands,
     /* 145243 */     // GIR_Coverage, 7393,
     /* 145243 */     GIR_EraseRootFromParent_Done,
     /* 145244 */   // Label 2548: @145244
     /* 145244 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(145299), // Rule ID 7394 //
     /* 145249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145266 */     // MIs[0] Rn
     /* 145266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145282 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 145285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145297 */     GIR_RootConstrainSelectedInstOperands,
     /* 145298 */     // GIR_Coverage, 7394,
     /* 145298 */     GIR_EraseRootFromParent_Done,
     /* 145299 */   // Label 2549: @145299
     /* 145299 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(145354), // Rule ID 7395 //
     /* 145304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145307 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145321 */     // MIs[0] Rn
     /* 145321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145337 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 145340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145352 */     GIR_RootConstrainSelectedInstOperands,
     /* 145353 */     // GIR_Coverage, 7395,
     /* 145353 */     GIR_EraseRootFromParent_Done,
     /* 145354 */   // Label 2550: @145354
     /* 145354 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(145409), // Rule ID 7396 //
     /* 145359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145376 */     // MIs[0] Rn
     /* 145376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145392 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 145395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145407 */     GIR_RootConstrainSelectedInstOperands,
     /* 145408 */     // GIR_Coverage, 7396,
     /* 145408 */     GIR_EraseRootFromParent_Done,
     /* 145409 */   // Label 2551: @145409
     /* 145409 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(145464), // Rule ID 7397 //
     /* 145414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145431 */     // MIs[0] Rn
     /* 145431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145447 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 145450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145462 */     GIR_RootConstrainSelectedInstOperands,
     /* 145463 */     // GIR_Coverage, 7397,
     /* 145463 */     GIR_EraseRootFromParent_Done,
     /* 145464 */   // Label 2552: @145464
     /* 145464 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145519), // Rule ID 7398 //
     /* 145469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145486 */     // MIs[0] Rn
     /* 145486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145502 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 145505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145517 */     GIR_RootConstrainSelectedInstOperands,
     /* 145518 */     // GIR_Coverage, 7398,
     /* 145518 */     GIR_EraseRootFromParent_Done,
     /* 145519 */   // Label 2553: @145519
     /* 145519 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(145574), // Rule ID 7399 //
     /* 145524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145541 */     // MIs[0] Rn
     /* 145541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145557 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 145560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145572 */     GIR_RootConstrainSelectedInstOperands,
     /* 145573 */     // GIR_Coverage, 7399,
     /* 145573 */     GIR_EraseRootFromParent_Done,
     /* 145574 */   // Label 2554: @145574
     /* 145574 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(145629), // Rule ID 7400 //
     /* 145579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145596 */     // MIs[0] Rn
     /* 145596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145612 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145627 */     GIR_RootConstrainSelectedInstOperands,
     /* 145628 */     // GIR_Coverage, 7400,
     /* 145628 */     GIR_EraseRootFromParent_Done,
     /* 145629 */   // Label 2555: @145629
     /* 145629 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(145684), // Rule ID 7401 //
     /* 145634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145651 */     // MIs[0] Rn
     /* 145651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145667 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145682 */     GIR_RootConstrainSelectedInstOperands,
     /* 145683 */     // GIR_Coverage, 7401,
     /* 145683 */     GIR_EraseRootFromParent_Done,
     /* 145684 */   // Label 2556: @145684
     /* 145684 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(145739), // Rule ID 7402 //
     /* 145689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145706 */     // MIs[0] Rn
     /* 145706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145722 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 145725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145737 */     GIR_RootConstrainSelectedInstOperands,
     /* 145738 */     // GIR_Coverage, 7402,
     /* 145738 */     GIR_EraseRootFromParent_Done,
     /* 145739 */   // Label 2557: @145739
     /* 145739 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(145794), // Rule ID 7403 //
     /* 145744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145761 */     // MIs[0] Rn
     /* 145761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145777 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 145780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145792 */     GIR_RootConstrainSelectedInstOperands,
     /* 145793 */     // GIR_Coverage, 7403,
     /* 145793 */     GIR_EraseRootFromParent_Done,
     /* 145794 */   // Label 2558: @145794
     /* 145794 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(145849), // Rule ID 7404 //
     /* 145799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145816 */     // MIs[0] Rn
     /* 145816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145832 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 145835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145847 */     GIR_RootConstrainSelectedInstOperands,
     /* 145848 */     // GIR_Coverage, 7404,
     /* 145848 */     GIR_EraseRootFromParent_Done,
     /* 145849 */   // Label 2559: @145849
     /* 145849 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(145904), // Rule ID 7405 //
     /* 145854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145871 */     // MIs[0] Rn
     /* 145871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145887 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145902 */     GIR_RootConstrainSelectedInstOperands,
     /* 145903 */     // GIR_Coverage, 7405,
     /* 145903 */     GIR_EraseRootFromParent_Done,
     /* 145904 */   // Label 2560: @145904
     /* 145904 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145959), // Rule ID 7406 //
     /* 145909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145926 */     // MIs[0] Rn
     /* 145926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145942 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145957 */     GIR_RootConstrainSelectedInstOperands,
     /* 145958 */     // GIR_Coverage, 7406,
     /* 145958 */     GIR_EraseRootFromParent_Done,
     /* 145959 */   // Label 2561: @145959
     /* 145959 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(146019), // Rule ID 13369 //
     /* 145964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145978 */     // MIs[0] addr
     /* 145978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145994 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 146000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146002 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146007 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146009 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146011 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146017 */     GIR_RootConstrainSelectedInstOperands,
     /* 146018 */     // GIR_Coverage, 13369,
     /* 146018 */     GIR_EraseRootFromParent_Done,
     /* 146019 */   // Label 2562: @146019
     /* 146019 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(146079), // Rule ID 13370 //
     /* 146024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146038 */     // MIs[0] addr
     /* 146038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146054 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 146054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 146060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146062 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146067 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146069 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146071 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146077 */     GIR_RootConstrainSelectedInstOperands,
     /* 146078 */     // GIR_Coverage, 13370,
     /* 146078 */     GIR_EraseRootFromParent_Done,
     /* 146079 */   // Label 2563: @146079
     /* 146079 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(146139), // Rule ID 13371 //
     /* 146084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146098 */     // MIs[0] addr
     /* 146098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146114 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 146114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 146120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146122 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146127 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146129 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146131 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146137 */     GIR_RootConstrainSelectedInstOperands,
     /* 146138 */     // GIR_Coverage, 13371,
     /* 146138 */     GIR_EraseRootFromParent_Done,
     /* 146139 */   // Label 2564: @146139
     /* 146139 */   GIM_Reject,
     /* 146140 */ // Label 2546: @146140
     /* 146140 */ GIM_Reject,
     /* 146141 */ // Label 2544: @146141
     /* 146141 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(146453),
     /* 146146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 146152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146159 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(146207), // Rule ID 2589 //
     /* 146164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146174 */     // MIs[0] Rn
     /* 146174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146190 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 146190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 146193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146205 */     GIR_RootConstrainSelectedInstOperands,
     /* 146206 */     // GIR_Coverage, 2589,
     /* 146206 */     GIR_EraseRootFromParent_Done,
     /* 146207 */   // Label 2566: @146207
     /* 146207 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(146255), // Rule ID 2590 //
     /* 146212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146222 */     // MIs[0] Rn
     /* 146222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146238 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 146238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 146241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146253 */     GIR_RootConstrainSelectedInstOperands,
     /* 146254 */     // GIR_Coverage, 2590,
     /* 146254 */     GIR_EraseRootFromParent_Done,
     /* 146255 */   // Label 2567: @146255
     /* 146255 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(146303), // Rule ID 2591 //
     /* 146260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146270 */     // MIs[0] Rn
     /* 146270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146286 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 146286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 146289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146301 */     GIR_RootConstrainSelectedInstOperands,
     /* 146302 */     // GIR_Coverage, 2591,
     /* 146302 */     GIR_EraseRootFromParent_Done,
     /* 146303 */   // Label 2568: @146303
     /* 146303 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(146351), // Rule ID 2592 //
     /* 146308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146318 */     // MIs[0] Rn
     /* 146318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146334 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 146334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146349 */     GIR_RootConstrainSelectedInstOperands,
     /* 146350 */     // GIR_Coverage, 2592,
     /* 146350 */     GIR_EraseRootFromParent_Done,
     /* 146351 */   // Label 2569: @146351
     /* 146351 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(146399), // Rule ID 2593 //
     /* 146356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146366 */     // MIs[0] Rn
     /* 146366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146382 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 146382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 146385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146397 */     GIR_RootConstrainSelectedInstOperands,
     /* 146398 */     // GIR_Coverage, 2593,
     /* 146398 */     GIR_EraseRootFromParent_Done,
     /* 146399 */   // Label 2570: @146399
     /* 146399 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(146452), // Rule ID 13372 //
     /* 146404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146411 */     // MIs[0] addr
     /* 146411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146427 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 146427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 146433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146435 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146440 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146442 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146444 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146450 */     GIR_RootConstrainSelectedInstOperands,
     /* 146451 */     // GIR_Coverage, 13372,
     /* 146451 */     GIR_EraseRootFromParent_Done,
     /* 146452 */   // Label 2571: @146452
     /* 146452 */   GIM_Reject,
     /* 146453 */ // Label 2565: @146453
     /* 146453 */ GIM_Reject,
     /* 146454 */ // Label 2545: @146454
     /* 146454 */ GIM_Reject,
     /* 146455 */ // Label 21: @146455
     /* 146455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(147446),
     /* 146466 */ /*GILLT_s32*//*Label 2572*/ GIMT_Encode4(146474),
     /* 146470 */ /*GILLT_s64*//*Label 2573*/ GIMT_Encode4(147219),
     /* 146474 */ // Label 2572: @146474
     /* 146474 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(147218),
     /* 146479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146482 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(146531), // Rule ID 7377 //
     /* 146487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146504 */     // MIs[0] Rn
     /* 146504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146516 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 146519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146529 */     GIR_RootConstrainSelectedInstOperands,
     /* 146530 */     // GIR_Coverage, 7377,
     /* 146530 */     GIR_EraseRootFromParent_Done,
     /* 146531 */   // Label 2576: @146531
     /* 146531 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(146580), // Rule ID 7378 //
     /* 146536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146553 */     // MIs[0] Rn
     /* 146553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146565 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 146568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146578 */     GIR_RootConstrainSelectedInstOperands,
     /* 146579 */     // GIR_Coverage, 7378,
     /* 146579 */     GIR_EraseRootFromParent_Done,
     /* 146580 */   // Label 2577: @146580
     /* 146580 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146629), // Rule ID 7379 //
     /* 146585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146602 */     // MIs[0] Rn
     /* 146602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146614 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 146617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146627 */     GIR_RootConstrainSelectedInstOperands,
     /* 146628 */     // GIR_Coverage, 7379,
     /* 146628 */     GIR_EraseRootFromParent_Done,
     /* 146629 */   // Label 2578: @146629
     /* 146629 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(146678), // Rule ID 7380 //
     /* 146634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146651 */     // MIs[0] Rn
     /* 146651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146663 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146676 */     GIR_RootConstrainSelectedInstOperands,
     /* 146677 */     // GIR_Coverage, 7380,
     /* 146677 */     GIR_EraseRootFromParent_Done,
     /* 146678 */   // Label 2579: @146678
     /* 146678 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(146727), // Rule ID 7381 //
     /* 146683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146700 */     // MIs[0] Rn
     /* 146700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146712 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146725 */     GIR_RootConstrainSelectedInstOperands,
     /* 146726 */     // GIR_Coverage, 7381,
     /* 146726 */     GIR_EraseRootFromParent_Done,
     /* 146727 */   // Label 2580: @146727
     /* 146727 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(146776), // Rule ID 7382 //
     /* 146732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146749 */     // MIs[0] Rn
     /* 146749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146761 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 146764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146774 */     GIR_RootConstrainSelectedInstOperands,
     /* 146775 */     // GIR_Coverage, 7382,
     /* 146775 */     GIR_EraseRootFromParent_Done,
     /* 146776 */   // Label 2581: @146776
     /* 146776 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(146825), // Rule ID 7383 //
     /* 146781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146798 */     // MIs[0] Rn
     /* 146798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146810 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 146813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146823 */     GIR_RootConstrainSelectedInstOperands,
     /* 146824 */     // GIR_Coverage, 7383,
     /* 146824 */     GIR_EraseRootFromParent_Done,
     /* 146825 */   // Label 2582: @146825
     /* 146825 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(146874), // Rule ID 7384 //
     /* 146830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146847 */     // MIs[0] Rn
     /* 146847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146859 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 146862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146872 */     GIR_RootConstrainSelectedInstOperands,
     /* 146873 */     // GIR_Coverage, 7384,
     /* 146873 */     GIR_EraseRootFromParent_Done,
     /* 146874 */   // Label 2583: @146874
     /* 146874 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(146923), // Rule ID 7385 //
     /* 146879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146896 */     // MIs[0] Rn
     /* 146896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146908 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146921 */     GIR_RootConstrainSelectedInstOperands,
     /* 146922 */     // GIR_Coverage, 7385,
     /* 146922 */     GIR_EraseRootFromParent_Done,
     /* 146923 */   // Label 2584: @146923
     /* 146923 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(146972), // Rule ID 7386 //
     /* 146928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146945 */     // MIs[0] Rn
     /* 146945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146957 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146970 */     GIR_RootConstrainSelectedInstOperands,
     /* 146971 */     // GIR_Coverage, 7386,
     /* 146971 */     GIR_EraseRootFromParent_Done,
     /* 146972 */   // Label 2585: @146972
     /* 146972 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(147021), // Rule ID 7387 //
     /* 146977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146994 */     // MIs[0] Rn
     /* 146994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147006 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 147009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147019 */     GIR_RootConstrainSelectedInstOperands,
     /* 147020 */     // GIR_Coverage, 7387,
     /* 147020 */     GIR_EraseRootFromParent_Done,
     /* 147021 */   // Label 2586: @147021
     /* 147021 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(147070), // Rule ID 7388 //
     /* 147026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147043 */     // MIs[0] Rn
     /* 147043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147055 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 147058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147068 */     GIR_RootConstrainSelectedInstOperands,
     /* 147069 */     // GIR_Coverage, 7388,
     /* 147069 */     GIR_EraseRootFromParent_Done,
     /* 147070 */   // Label 2587: @147070
     /* 147070 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(147119), // Rule ID 7389 //
     /* 147075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147092 */     // MIs[0] Rn
     /* 147092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147104 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 147107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147117 */     GIR_RootConstrainSelectedInstOperands,
     /* 147118 */     // GIR_Coverage, 7389,
     /* 147118 */     GIR_EraseRootFromParent_Done,
     /* 147119 */   // Label 2588: @147119
     /* 147119 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(147168), // Rule ID 7390 //
     /* 147124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147127 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147134 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147141 */     // MIs[0] Rn
     /* 147141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147153 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 147156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147166 */     GIR_RootConstrainSelectedInstOperands,
     /* 147167 */     // GIR_Coverage, 7390,
     /* 147167 */     GIR_EraseRootFromParent_Done,
     /* 147168 */   // Label 2589: @147168
     /* 147168 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(147217), // Rule ID 7391 //
     /* 147173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147190 */     // MIs[0] Rn
     /* 147190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147202 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 147205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147215 */     GIR_RootConstrainSelectedInstOperands,
     /* 147216 */     // GIR_Coverage, 7391,
     /* 147216 */     GIR_EraseRootFromParent_Done,
     /* 147217 */   // Label 2590: @147217
     /* 147217 */   GIM_Reject,
     /* 147218 */ // Label 2575: @147218
     /* 147218 */ GIM_Reject,
     /* 147219 */ // Label 2573: @147219
     /* 147219 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(147445),
     /* 147224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147227 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147234 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(147276), // Rule ID 7372 //
     /* 147239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147249 */     // MIs[0] Rn
     /* 147249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147261 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 147264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147274 */     GIR_RootConstrainSelectedInstOperands,
     /* 147275 */     // GIR_Coverage, 7372,
     /* 147275 */     GIR_EraseRootFromParent_Done,
     /* 147276 */   // Label 2592: @147276
     /* 147276 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(147318), // Rule ID 7373 //
     /* 147281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147291 */     // MIs[0] Rn
     /* 147291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147303 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 147306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147316 */     GIR_RootConstrainSelectedInstOperands,
     /* 147317 */     // GIR_Coverage, 7373,
     /* 147317 */     GIR_EraseRootFromParent_Done,
     /* 147318 */   // Label 2593: @147318
     /* 147318 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(147360), // Rule ID 7374 //
     /* 147323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147333 */     // MIs[0] Rn
     /* 147333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147345 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 147348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147358 */     GIR_RootConstrainSelectedInstOperands,
     /* 147359 */     // GIR_Coverage, 7374,
     /* 147359 */     GIR_EraseRootFromParent_Done,
     /* 147360 */   // Label 2594: @147360
     /* 147360 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(147402), // Rule ID 7375 //
     /* 147365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147375 */     // MIs[0] Rn
     /* 147375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147387 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147400 */     GIR_RootConstrainSelectedInstOperands,
     /* 147401 */     // GIR_Coverage, 7375,
     /* 147401 */     GIR_EraseRootFromParent_Done,
     /* 147402 */   // Label 2595: @147402
     /* 147402 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(147444), // Rule ID 7376 //
     /* 147407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147417 */     // MIs[0] Rn
     /* 147417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147429 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147442 */     GIR_RootConstrainSelectedInstOperands,
     /* 147443 */     // GIR_Coverage, 7376,
     /* 147443 */     GIR_EraseRootFromParent_Done,
     /* 147444 */   // Label 2596: @147444
     /* 147444 */   GIM_Reject,
     /* 147445 */ // Label 2591: @147445
     /* 147445 */ GIM_Reject,
     /* 147446 */ // Label 2574: @147446
     /* 147446 */ GIM_Reject,
     /* 147447 */ // Label 22: @147447
     /* 147447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(148438),
     /* 147458 */ /*GILLT_s32*//*Label 2597*/ GIMT_Encode4(147466),
     /* 147462 */ /*GILLT_s64*//*Label 2598*/ GIMT_Encode4(148211),
     /* 147466 */ // Label 2597: @147466
     /* 147466 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(148210),
     /* 147471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147474 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(147523), // Rule ID 7217 //
     /* 147479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147496 */     // MIs[0] Rn
     /* 147496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147508 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 147511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147521 */     GIR_RootConstrainSelectedInstOperands,
     /* 147522 */     // GIR_Coverage, 7217,
     /* 147522 */     GIR_EraseRootFromParent_Done,
     /* 147523 */   // Label 2601: @147523
     /* 147523 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(147572), // Rule ID 7218 //
     /* 147528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147545 */     // MIs[0] Rn
     /* 147545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147557 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 147560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147570 */     GIR_RootConstrainSelectedInstOperands,
     /* 147571 */     // GIR_Coverage, 7218,
     /* 147571 */     GIR_EraseRootFromParent_Done,
     /* 147572 */   // Label 2602: @147572
     /* 147572 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147621), // Rule ID 7219 //
     /* 147577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147594 */     // MIs[0] Rn
     /* 147594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147606 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 147609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147619 */     GIR_RootConstrainSelectedInstOperands,
     /* 147620 */     // GIR_Coverage, 7219,
     /* 147620 */     GIR_EraseRootFromParent_Done,
     /* 147621 */   // Label 2603: @147621
     /* 147621 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(147670), // Rule ID 7220 //
     /* 147626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147643 */     // MIs[0] Rn
     /* 147643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147655 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147668 */     GIR_RootConstrainSelectedInstOperands,
     /* 147669 */     // GIR_Coverage, 7220,
     /* 147669 */     GIR_EraseRootFromParent_Done,
     /* 147670 */   // Label 2604: @147670
     /* 147670 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(147719), // Rule ID 7221 //
     /* 147675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147692 */     // MIs[0] Rn
     /* 147692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147704 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147717 */     GIR_RootConstrainSelectedInstOperands,
     /* 147718 */     // GIR_Coverage, 7221,
     /* 147718 */     GIR_EraseRootFromParent_Done,
     /* 147719 */   // Label 2605: @147719
     /* 147719 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(147768), // Rule ID 7222 //
     /* 147724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147741 */     // MIs[0] Rn
     /* 147741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147753 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147766 */     GIR_RootConstrainSelectedInstOperands,
     /* 147767 */     // GIR_Coverage, 7222,
     /* 147767 */     GIR_EraseRootFromParent_Done,
     /* 147768 */   // Label 2606: @147768
     /* 147768 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(147817), // Rule ID 7223 //
     /* 147773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147790 */     // MIs[0] Rn
     /* 147790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147802 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147815 */     GIR_RootConstrainSelectedInstOperands,
     /* 147816 */     // GIR_Coverage, 7223,
     /* 147816 */     GIR_EraseRootFromParent_Done,
     /* 147817 */   // Label 2607: @147817
     /* 147817 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(147866), // Rule ID 7224 //
     /* 147822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147825 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147839 */     // MIs[0] Rn
     /* 147839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147851 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147864 */     GIR_RootConstrainSelectedInstOperands,
     /* 147865 */     // GIR_Coverage, 7224,
     /* 147865 */     GIR_EraseRootFromParent_Done,
     /* 147866 */   // Label 2608: @147866
     /* 147866 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147915), // Rule ID 7225 //
     /* 147871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147888 */     // MIs[0] Rn
     /* 147888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147900 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147913 */     GIR_RootConstrainSelectedInstOperands,
     /* 147914 */     // GIR_Coverage, 7225,
     /* 147914 */     GIR_EraseRootFromParent_Done,
     /* 147915 */   // Label 2609: @147915
     /* 147915 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147964), // Rule ID 7226 //
     /* 147920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147937 */     // MIs[0] Rn
     /* 147937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147949 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147962 */     GIR_RootConstrainSelectedInstOperands,
     /* 147963 */     // GIR_Coverage, 7226,
     /* 147963 */     GIR_EraseRootFromParent_Done,
     /* 147964 */   // Label 2610: @147964
     /* 147964 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(148013), // Rule ID 7227 //
     /* 147969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147986 */     // MIs[0] Rn
     /* 147986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147998 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 148001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148011 */     GIR_RootConstrainSelectedInstOperands,
     /* 148012 */     // GIR_Coverage, 7227,
     /* 148012 */     GIR_EraseRootFromParent_Done,
     /* 148013 */   // Label 2611: @148013
     /* 148013 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(148062), // Rule ID 7228 //
     /* 148018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148035 */     // MIs[0] Rn
     /* 148035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148047 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 148050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148060 */     GIR_RootConstrainSelectedInstOperands,
     /* 148061 */     // GIR_Coverage, 7228,
     /* 148061 */     GIR_EraseRootFromParent_Done,
     /* 148062 */   // Label 2612: @148062
     /* 148062 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(148111), // Rule ID 7229 //
     /* 148067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148084 */     // MIs[0] Rn
     /* 148084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148096 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 148099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148109 */     GIR_RootConstrainSelectedInstOperands,
     /* 148110 */     // GIR_Coverage, 7229,
     /* 148110 */     GIR_EraseRootFromParent_Done,
     /* 148111 */   // Label 2613: @148111
     /* 148111 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(148160), // Rule ID 7230 //
     /* 148116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148133 */     // MIs[0] Rn
     /* 148133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148145 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 148148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148158 */     GIR_RootConstrainSelectedInstOperands,
     /* 148159 */     // GIR_Coverage, 7230,
     /* 148159 */     GIR_EraseRootFromParent_Done,
     /* 148160 */   // Label 2614: @148160
     /* 148160 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(148209), // Rule ID 7231 //
     /* 148165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148168 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148182 */     // MIs[0] Rn
     /* 148182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148194 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 148197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148207 */     GIR_RootConstrainSelectedInstOperands,
     /* 148208 */     // GIR_Coverage, 7231,
     /* 148208 */     GIR_EraseRootFromParent_Done,
     /* 148209 */   // Label 2615: @148209
     /* 148209 */   GIM_Reject,
     /* 148210 */ // Label 2600: @148210
     /* 148210 */ GIM_Reject,
     /* 148211 */ // Label 2598: @148211
     /* 148211 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(148437),
     /* 148216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148226 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(148268), // Rule ID 2579 //
     /* 148231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148241 */     // MIs[0] Rn
     /* 148241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148253 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 148256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148266 */     GIR_RootConstrainSelectedInstOperands,
     /* 148267 */     // GIR_Coverage, 2579,
     /* 148267 */     GIR_EraseRootFromParent_Done,
     /* 148268 */   // Label 2617: @148268
     /* 148268 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(148310), // Rule ID 2580 //
     /* 148273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148283 */     // MIs[0] Rn
     /* 148283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148295 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 148298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148308 */     GIR_RootConstrainSelectedInstOperands,
     /* 148309 */     // GIR_Coverage, 2580,
     /* 148309 */     GIR_EraseRootFromParent_Done,
     /* 148310 */   // Label 2618: @148310
     /* 148310 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148352), // Rule ID 2581 //
     /* 148315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148325 */     // MIs[0] Rn
     /* 148325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148337 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 148340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148350 */     GIR_RootConstrainSelectedInstOperands,
     /* 148351 */     // GIR_Coverage, 2581,
     /* 148351 */     GIR_EraseRootFromParent_Done,
     /* 148352 */   // Label 2619: @148352
     /* 148352 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(148394), // Rule ID 2582 //
     /* 148357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148367 */     // MIs[0] Rn
     /* 148367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148379 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148392 */     GIR_RootConstrainSelectedInstOperands,
     /* 148393 */     // GIR_Coverage, 2582,
     /* 148393 */     GIR_EraseRootFromParent_Done,
     /* 148394 */   // Label 2620: @148394
     /* 148394 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(148436), // Rule ID 2583 //
     /* 148399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148409 */     // MIs[0] Rn
     /* 148409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148421 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148434 */     GIR_RootConstrainSelectedInstOperands,
     /* 148435 */     // GIR_Coverage, 2583,
     /* 148435 */     GIR_EraseRootFromParent_Done,
     /* 148436 */   // Label 2621: @148436
     /* 148436 */   GIM_Reject,
     /* 148437 */ // Label 2616: @148437
     /* 148437 */ GIM_Reject,
     /* 148438 */ // Label 2599: @148438
     /* 148438 */ GIM_Reject,
     /* 148439 */ // Label 23: @148439
     /* 148439 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2624*/ GIMT_Encode4(149930),
     /* 148450 */ /*GILLT_s32*//*Label 2622*/ GIMT_Encode4(148458),
     /* 148454 */ /*GILLT_s64*//*Label 2623*/ GIMT_Encode4(149578),
     /* 148458 */ // Label 2622: @148458
     /* 148458 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(149577),
     /* 148463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148466 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(148540), // Rule ID 7412 //
     /* 148471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148488 */     // MIs[0] Rn
     /* 148488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148500 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148512 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 148527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148538 */     GIR_RootConstrainSelectedInstOperands,
     /* 148539 */     // GIR_Coverage, 7412,
     /* 148539 */     GIR_EraseRootFromParent_Done,
     /* 148540 */   // Label 2626: @148540
     /* 148540 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(148614), // Rule ID 7413 //
     /* 148545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148562 */     // MIs[0] Rn
     /* 148562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148574 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148586 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 148601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148612 */     GIR_RootConstrainSelectedInstOperands,
     /* 148613 */     // GIR_Coverage, 7413,
     /* 148613 */     GIR_EraseRootFromParent_Done,
     /* 148614 */   // Label 2627: @148614
     /* 148614 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(148688), // Rule ID 7414 //
     /* 148619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148636 */     // MIs[0] Rn
     /* 148636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148648 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148660 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 148675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148686 */     GIR_RootConstrainSelectedInstOperands,
     /* 148687 */     // GIR_Coverage, 7414,
     /* 148687 */     GIR_EraseRootFromParent_Done,
     /* 148688 */   // Label 2628: @148688
     /* 148688 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148762), // Rule ID 7415 //
     /* 148693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148710 */     // MIs[0] Rn
     /* 148710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148722 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148734 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148760 */     GIR_RootConstrainSelectedInstOperands,
     /* 148761 */     // GIR_Coverage, 7415,
     /* 148761 */     GIR_EraseRootFromParent_Done,
     /* 148762 */   // Label 2629: @148762
     /* 148762 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148836), // Rule ID 7416 //
     /* 148767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148784 */     // MIs[0] Rn
     /* 148784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148796 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148808 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148834 */     GIR_RootConstrainSelectedInstOperands,
     /* 148835 */     // GIR_Coverage, 7416,
     /* 148835 */     GIR_EraseRootFromParent_Done,
     /* 148836 */   // Label 2630: @148836
     /* 148836 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148910), // Rule ID 7417 //
     /* 148841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148858 */     // MIs[0] Rn
     /* 148858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148870 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148882 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 148897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148908 */     GIR_RootConstrainSelectedInstOperands,
     /* 148909 */     // GIR_Coverage, 7417,
     /* 148909 */     GIR_EraseRootFromParent_Done,
     /* 148910 */   // Label 2631: @148910
     /* 148910 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148984), // Rule ID 7418 //
     /* 148915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148932 */     // MIs[0] Rn
     /* 148932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148944 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148956 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 148971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148982 */     GIR_RootConstrainSelectedInstOperands,
     /* 148983 */     // GIR_Coverage, 7418,
     /* 148983 */     GIR_EraseRootFromParent_Done,
     /* 148984 */   // Label 2632: @148984
     /* 148984 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(149058), // Rule ID 7419 //
     /* 148989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149006 */     // MIs[0] Rn
     /* 149006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149018 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 149045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149056 */     GIR_RootConstrainSelectedInstOperands,
     /* 149057 */     // GIR_Coverage, 7419,
     /* 149057 */     GIR_EraseRootFromParent_Done,
     /* 149058 */   // Label 2633: @149058
     /* 149058 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(149132), // Rule ID 7420 //
     /* 149063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149080 */     // MIs[0] Rn
     /* 149080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149092 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149104 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 149119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149130 */     GIR_RootConstrainSelectedInstOperands,
     /* 149131 */     // GIR_Coverage, 7420,
     /* 149131 */     GIR_EraseRootFromParent_Done,
     /* 149132 */   // Label 2634: @149132
     /* 149132 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(149206), // Rule ID 7421 //
     /* 149137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149154 */     // MIs[0] Rn
     /* 149154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149166 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149178 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 149193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149204 */     GIR_RootConstrainSelectedInstOperands,
     /* 149205 */     // GIR_Coverage, 7421,
     /* 149205 */     GIR_EraseRootFromParent_Done,
     /* 149206 */   // Label 2635: @149206
     /* 149206 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(149280), // Rule ID 7422 //
     /* 149211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149228 */     // MIs[0] Rn
     /* 149228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149240 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149252 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 149267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149278 */     GIR_RootConstrainSelectedInstOperands,
     /* 149279 */     // GIR_Coverage, 7422,
     /* 149279 */     GIR_EraseRootFromParent_Done,
     /* 149280 */   // Label 2636: @149280
     /* 149280 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(149354), // Rule ID 7423 //
     /* 149285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149302 */     // MIs[0] Rn
     /* 149302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149314 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149326 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 149341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149352 */     GIR_RootConstrainSelectedInstOperands,
     /* 149353 */     // GIR_Coverage, 7423,
     /* 149353 */     GIR_EraseRootFromParent_Done,
     /* 149354 */   // Label 2637: @149354
     /* 149354 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(149428), // Rule ID 7424 //
     /* 149359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149376 */     // MIs[0] Rn
     /* 149376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149388 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149400 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 149415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149426 */     GIR_RootConstrainSelectedInstOperands,
     /* 149427 */     // GIR_Coverage, 7424,
     /* 149427 */     GIR_EraseRootFromParent_Done,
     /* 149428 */   // Label 2638: @149428
     /* 149428 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(149502), // Rule ID 7425 //
     /* 149433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149450 */     // MIs[0] Rn
     /* 149450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149462 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149474 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149500 */     GIR_RootConstrainSelectedInstOperands,
     /* 149501 */     // GIR_Coverage, 7425,
     /* 149501 */     GIR_EraseRootFromParent_Done,
     /* 149502 */   // Label 2639: @149502
     /* 149502 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(149576), // Rule ID 7426 //
     /* 149507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149524 */     // MIs[0] Rn
     /* 149524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149536 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149548 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149574 */     GIR_RootConstrainSelectedInstOperands,
     /* 149575 */     // GIR_Coverage, 7426,
     /* 149575 */     GIR_EraseRootFromParent_Done,
     /* 149576 */   // Label 2640: @149576
     /* 149576 */   GIM_Reject,
     /* 149577 */ // Label 2625: @149577
     /* 149577 */ GIM_Reject,
     /* 149578 */ // Label 2623: @149578
     /* 149578 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(149929),
     /* 149583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149593 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(149660), // Rule ID 7407 //
     /* 149598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149608 */     // MIs[0] Rn
     /* 149608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149620 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149632 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 149647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149658 */     GIR_RootConstrainSelectedInstOperands,
     /* 149659 */     // GIR_Coverage, 7407,
     /* 149659 */     GIR_EraseRootFromParent_Done,
     /* 149660 */   // Label 2642: @149660
     /* 149660 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(149727), // Rule ID 7408 //
     /* 149665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149675 */     // MIs[0] Rn
     /* 149675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149687 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149699 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 149714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149725 */     GIR_RootConstrainSelectedInstOperands,
     /* 149726 */     // GIR_Coverage, 7408,
     /* 149726 */     GIR_EraseRootFromParent_Done,
     /* 149727 */   // Label 2643: @149727
     /* 149727 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149794), // Rule ID 7409 //
     /* 149732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149742 */     // MIs[0] Rn
     /* 149742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149754 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149766 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 149781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149792 */     GIR_RootConstrainSelectedInstOperands,
     /* 149793 */     // GIR_Coverage, 7409,
     /* 149793 */     GIR_EraseRootFromParent_Done,
     /* 149794 */   // Label 2644: @149794
     /* 149794 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149861), // Rule ID 7410 //
     /* 149799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149809 */     // MIs[0] Rn
     /* 149809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149821 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149833 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149859 */     GIR_RootConstrainSelectedInstOperands,
     /* 149860 */     // GIR_Coverage, 7410,
     /* 149860 */     GIR_EraseRootFromParent_Done,
     /* 149861 */   // Label 2645: @149861
     /* 149861 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149928), // Rule ID 7411 //
     /* 149866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149876 */     // MIs[0] Rn
     /* 149876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149888 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149900 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149926 */     GIR_RootConstrainSelectedInstOperands,
     /* 149927 */     // GIR_Coverage, 7411,
     /* 149927 */     GIR_EraseRootFromParent_Done,
     /* 149928 */   // Label 2646: @149928
     /* 149928 */   GIM_Reject,
     /* 149929 */ // Label 2641: @149929
     /* 149929 */ GIM_Reject,
     /* 149930 */ // Label 2624: @149930
     /* 149930 */ GIM_Reject,
     /* 149931 */ // Label 24: @149931
     /* 149931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2649*/ GIMT_Encode4(151422),
     /* 149942 */ /*GILLT_s32*//*Label 2647*/ GIMT_Encode4(149950),
     /* 149946 */ /*GILLT_s64*//*Label 2648*/ GIMT_Encode4(151070),
     /* 149950 */ // Label 2647: @149950
     /* 149950 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(151069),
     /* 149955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149958 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(150032), // Rule ID 7432 //
     /* 149963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149980 */     // MIs[0] Rn
     /* 149980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149992 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150004 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 150019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150030 */     GIR_RootConstrainSelectedInstOperands,
     /* 150031 */     // GIR_Coverage, 7432,
     /* 150031 */     GIR_EraseRootFromParent_Done,
     /* 150032 */   // Label 2651: @150032
     /* 150032 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(150106), // Rule ID 7433 //
     /* 150037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150054 */     // MIs[0] Rn
     /* 150054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150066 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150078 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 150093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150104 */     GIR_RootConstrainSelectedInstOperands,
     /* 150105 */     // GIR_Coverage, 7433,
     /* 150105 */     GIR_EraseRootFromParent_Done,
     /* 150106 */   // Label 2652: @150106
     /* 150106 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150180), // Rule ID 7434 //
     /* 150111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150128 */     // MIs[0] Rn
     /* 150128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150140 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150152 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 150167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150178 */     GIR_RootConstrainSelectedInstOperands,
     /* 150179 */     // GIR_Coverage, 7434,
     /* 150179 */     GIR_EraseRootFromParent_Done,
     /* 150180 */   // Label 2653: @150180
     /* 150180 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(150254), // Rule ID 7435 //
     /* 150185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150202 */     // MIs[0] Rn
     /* 150202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150214 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150226 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 150241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150252 */     GIR_RootConstrainSelectedInstOperands,
     /* 150253 */     // GIR_Coverage, 7435,
     /* 150253 */     GIR_EraseRootFromParent_Done,
     /* 150254 */   // Label 2654: @150254
     /* 150254 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(150328), // Rule ID 7436 //
     /* 150259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150276 */     // MIs[0] Rn
     /* 150276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150288 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150300 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 150315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150326 */     GIR_RootConstrainSelectedInstOperands,
     /* 150327 */     // GIR_Coverage, 7436,
     /* 150327 */     GIR_EraseRootFromParent_Done,
     /* 150328 */   // Label 2655: @150328
     /* 150328 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(150402), // Rule ID 7437 //
     /* 150333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150350 */     // MIs[0] Rn
     /* 150350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150362 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150374 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 150389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150400 */     GIR_RootConstrainSelectedInstOperands,
     /* 150401 */     // GIR_Coverage, 7437,
     /* 150401 */     GIR_EraseRootFromParent_Done,
     /* 150402 */   // Label 2656: @150402
     /* 150402 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(150476), // Rule ID 7438 //
     /* 150407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150424 */     // MIs[0] Rn
     /* 150424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150436 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150448 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 150463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150474 */     GIR_RootConstrainSelectedInstOperands,
     /* 150475 */     // GIR_Coverage, 7438,
     /* 150475 */     GIR_EraseRootFromParent_Done,
     /* 150476 */   // Label 2657: @150476
     /* 150476 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(150550), // Rule ID 7439 //
     /* 150481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150498 */     // MIs[0] Rn
     /* 150498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150510 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 150537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150548 */     GIR_RootConstrainSelectedInstOperands,
     /* 150549 */     // GIR_Coverage, 7439,
     /* 150549 */     GIR_EraseRootFromParent_Done,
     /* 150550 */   // Label 2658: @150550
     /* 150550 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(150624), // Rule ID 7440 //
     /* 150555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150572 */     // MIs[0] Rn
     /* 150572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150584 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150596 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150622 */     GIR_RootConstrainSelectedInstOperands,
     /* 150623 */     // GIR_Coverage, 7440,
     /* 150623 */     GIR_EraseRootFromParent_Done,
     /* 150624 */   // Label 2659: @150624
     /* 150624 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(150698), // Rule ID 7441 //
     /* 150629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150646 */     // MIs[0] Rn
     /* 150646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150658 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150670 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150696 */     GIR_RootConstrainSelectedInstOperands,
     /* 150697 */     // GIR_Coverage, 7441,
     /* 150697 */     GIR_EraseRootFromParent_Done,
     /* 150698 */   // Label 2660: @150698
     /* 150698 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(150772), // Rule ID 7442 //
     /* 150703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150720 */     // MIs[0] Rn
     /* 150720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150732 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150744 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 150759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150770 */     GIR_RootConstrainSelectedInstOperands,
     /* 150771 */     // GIR_Coverage, 7442,
     /* 150771 */     GIR_EraseRootFromParent_Done,
     /* 150772 */   // Label 2661: @150772
     /* 150772 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150846), // Rule ID 7443 //
     /* 150777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150794 */     // MIs[0] Rn
     /* 150794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150806 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150818 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 150833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150844 */     GIR_RootConstrainSelectedInstOperands,
     /* 150845 */     // GIR_Coverage, 7443,
     /* 150845 */     GIR_EraseRootFromParent_Done,
     /* 150846 */   // Label 2662: @150846
     /* 150846 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150920), // Rule ID 7444 //
     /* 150851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150868 */     // MIs[0] Rn
     /* 150868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150880 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150892 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 150907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150918 */     GIR_RootConstrainSelectedInstOperands,
     /* 150919 */     // GIR_Coverage, 7444,
     /* 150919 */     GIR_EraseRootFromParent_Done,
     /* 150920 */   // Label 2663: @150920
     /* 150920 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150994), // Rule ID 7445 //
     /* 150925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150942 */     // MIs[0] Rn
     /* 150942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150954 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150966 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150992 */     GIR_RootConstrainSelectedInstOperands,
     /* 150993 */     // GIR_Coverage, 7445,
     /* 150993 */     GIR_EraseRootFromParent_Done,
     /* 150994 */   // Label 2664: @150994
     /* 150994 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(151068), // Rule ID 7446 //
     /* 150999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151016 */     // MIs[0] Rn
     /* 151016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151028 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 151031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 151035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151040 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 151055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151066 */     GIR_RootConstrainSelectedInstOperands,
     /* 151067 */     // GIR_Coverage, 7446,
     /* 151067 */     GIR_EraseRootFromParent_Done,
     /* 151068 */   // Label 2665: @151068
     /* 151068 */   GIM_Reject,
     /* 151069 */ // Label 2650: @151069
     /* 151069 */ GIM_Reject,
     /* 151070 */ // Label 2648: @151070
     /* 151070 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(151421),
     /* 151075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151085 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(151152), // Rule ID 7427 //
     /* 151090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151100 */     // MIs[0] Rn
     /* 151100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151112 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151124 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 151139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151150 */     GIR_RootConstrainSelectedInstOperands,
     /* 151151 */     // GIR_Coverage, 7427,
     /* 151151 */     GIR_EraseRootFromParent_Done,
     /* 151152 */   // Label 2667: @151152
     /* 151152 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(151219), // Rule ID 7428 //
     /* 151157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151167 */     // MIs[0] Rn
     /* 151167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151179 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151191 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 151206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151217 */     GIR_RootConstrainSelectedInstOperands,
     /* 151218 */     // GIR_Coverage, 7428,
     /* 151218 */     GIR_EraseRootFromParent_Done,
     /* 151219 */   // Label 2668: @151219
     /* 151219 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(151286), // Rule ID 7429 //
     /* 151224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151234 */     // MIs[0] Rn
     /* 151234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151246 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 151273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151284 */     GIR_RootConstrainSelectedInstOperands,
     /* 151285 */     // GIR_Coverage, 7429,
     /* 151285 */     GIR_EraseRootFromParent_Done,
     /* 151286 */   // Label 2669: @151286
     /* 151286 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(151353), // Rule ID 7430 //
     /* 151291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151301 */     // MIs[0] Rn
     /* 151301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151313 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151325 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 151340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151351 */     GIR_RootConstrainSelectedInstOperands,
     /* 151352 */     // GIR_Coverage, 7430,
     /* 151352 */     GIR_EraseRootFromParent_Done,
     /* 151353 */   // Label 2670: @151353
     /* 151353 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(151420), // Rule ID 7431 //
     /* 151358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151368 */     // MIs[0] Rn
     /* 151368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151380 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 151380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 151383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151392 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 151407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151418 */     GIR_RootConstrainSelectedInstOperands,
     /* 151419 */     // GIR_Coverage, 7431,
     /* 151419 */     GIR_EraseRootFromParent_Done,
     /* 151420 */   // Label 2671: @151420
     /* 151420 */   GIM_Reject,
     /* 151421 */ // Label 2666: @151421
     /* 151421 */ GIM_Reject,
     /* 151422 */ // Label 2649: @151422
     /* 151422 */ GIM_Reject,
     /* 151423 */ // Label 25: @151423
     /* 151423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2674*/ GIMT_Encode4(152414),
     /* 151434 */ /*GILLT_s32*//*Label 2672*/ GIMT_Encode4(151442),
     /* 151438 */ /*GILLT_s64*//*Label 2673*/ GIMT_Encode4(152187),
     /* 151442 */ // Label 2672: @151442
     /* 151442 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(152186),
     /* 151447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151450 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(151499), // Rule ID 7237 //
     /* 151455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151472 */     // MIs[0] Rn
     /* 151472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151484 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 151487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151497 */     GIR_RootConstrainSelectedInstOperands,
     /* 151498 */     // GIR_Coverage, 7237,
     /* 151498 */     GIR_EraseRootFromParent_Done,
     /* 151499 */   // Label 2676: @151499
     /* 151499 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(151548), // Rule ID 7238 //
     /* 151504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151521 */     // MIs[0] Rn
     /* 151521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151533 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 151536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151546 */     GIR_RootConstrainSelectedInstOperands,
     /* 151547 */     // GIR_Coverage, 7238,
     /* 151547 */     GIR_EraseRootFromParent_Done,
     /* 151548 */   // Label 2677: @151548
     /* 151548 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151597), // Rule ID 7239 //
     /* 151553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151570 */     // MIs[0] Rn
     /* 151570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151582 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 151585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151595 */     GIR_RootConstrainSelectedInstOperands,
     /* 151596 */     // GIR_Coverage, 7239,
     /* 151596 */     GIR_EraseRootFromParent_Done,
     /* 151597 */   // Label 2678: @151597
     /* 151597 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(151646), // Rule ID 7240 //
     /* 151602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151619 */     // MIs[0] Rn
     /* 151619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151631 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151644 */     GIR_RootConstrainSelectedInstOperands,
     /* 151645 */     // GIR_Coverage, 7240,
     /* 151645 */     GIR_EraseRootFromParent_Done,
     /* 151646 */   // Label 2679: @151646
     /* 151646 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(151695), // Rule ID 7241 //
     /* 151651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151668 */     // MIs[0] Rn
     /* 151668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151680 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151693 */     GIR_RootConstrainSelectedInstOperands,
     /* 151694 */     // GIR_Coverage, 7241,
     /* 151694 */     GIR_EraseRootFromParent_Done,
     /* 151695 */   // Label 2680: @151695
     /* 151695 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(151744), // Rule ID 7242 //
     /* 151700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151717 */     // MIs[0] Rn
     /* 151717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151729 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 151732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151742 */     GIR_RootConstrainSelectedInstOperands,
     /* 151743 */     // GIR_Coverage, 7242,
     /* 151743 */     GIR_EraseRootFromParent_Done,
     /* 151744 */   // Label 2681: @151744
     /* 151744 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(151793), // Rule ID 7243 //
     /* 151749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151766 */     // MIs[0] Rn
     /* 151766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151778 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 151781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151791 */     GIR_RootConstrainSelectedInstOperands,
     /* 151792 */     // GIR_Coverage, 7243,
     /* 151792 */     GIR_EraseRootFromParent_Done,
     /* 151793 */   // Label 2682: @151793
     /* 151793 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(151842), // Rule ID 7244 //
     /* 151798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151815 */     // MIs[0] Rn
     /* 151815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151827 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 151830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151840 */     GIR_RootConstrainSelectedInstOperands,
     /* 151841 */     // GIR_Coverage, 7244,
     /* 151841 */     GIR_EraseRootFromParent_Done,
     /* 151842 */   // Label 2683: @151842
     /* 151842 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(151891), // Rule ID 7245 //
     /* 151847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151864 */     // MIs[0] Rn
     /* 151864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151876 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151889 */     GIR_RootConstrainSelectedInstOperands,
     /* 151890 */     // GIR_Coverage, 7245,
     /* 151890 */     GIR_EraseRootFromParent_Done,
     /* 151891 */   // Label 2684: @151891
     /* 151891 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(151940), // Rule ID 7246 //
     /* 151896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151913 */     // MIs[0] Rn
     /* 151913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151925 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151938 */     GIR_RootConstrainSelectedInstOperands,
     /* 151939 */     // GIR_Coverage, 7246,
     /* 151939 */     GIR_EraseRootFromParent_Done,
     /* 151940 */   // Label 2685: @151940
     /* 151940 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(151989), // Rule ID 7247 //
     /* 151945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151962 */     // MIs[0] Rn
     /* 151962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151974 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 151977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151987 */     GIR_RootConstrainSelectedInstOperands,
     /* 151988 */     // GIR_Coverage, 7247,
     /* 151988 */     GIR_EraseRootFromParent_Done,
     /* 151989 */   // Label 2686: @151989
     /* 151989 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(152038), // Rule ID 7248 //
     /* 151994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152011 */     // MIs[0] Rn
     /* 152011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152023 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 152026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152036 */     GIR_RootConstrainSelectedInstOperands,
     /* 152037 */     // GIR_Coverage, 7248,
     /* 152037 */     GIR_EraseRootFromParent_Done,
     /* 152038 */   // Label 2687: @152038
     /* 152038 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(152087), // Rule ID 7249 //
     /* 152043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152060 */     // MIs[0] Rn
     /* 152060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152072 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 152075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152085 */     GIR_RootConstrainSelectedInstOperands,
     /* 152086 */     // GIR_Coverage, 7249,
     /* 152086 */     GIR_EraseRootFromParent_Done,
     /* 152087 */   // Label 2688: @152087
     /* 152087 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(152136), // Rule ID 7250 //
     /* 152092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152109 */     // MIs[0] Rn
     /* 152109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152121 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 152124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152134 */     GIR_RootConstrainSelectedInstOperands,
     /* 152135 */     // GIR_Coverage, 7250,
     /* 152135 */     GIR_EraseRootFromParent_Done,
     /* 152136 */   // Label 2689: @152136
     /* 152136 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(152185), // Rule ID 7251 //
     /* 152141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152158 */     // MIs[0] Rn
     /* 152158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152170 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 152173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152183 */     GIR_RootConstrainSelectedInstOperands,
     /* 152184 */     // GIR_Coverage, 7251,
     /* 152184 */     GIR_EraseRootFromParent_Done,
     /* 152185 */   // Label 2690: @152185
     /* 152185 */   GIM_Reject,
     /* 152186 */ // Label 2675: @152186
     /* 152186 */ GIM_Reject,
     /* 152187 */ // Label 2673: @152187
     /* 152187 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(152413),
     /* 152192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152195 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152202 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(152244), // Rule ID 7232 //
     /* 152207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152217 */     // MIs[0] Rn
     /* 152217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152229 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 152232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152242 */     GIR_RootConstrainSelectedInstOperands,
     /* 152243 */     // GIR_Coverage, 7232,
     /* 152243 */     GIR_EraseRootFromParent_Done,
     /* 152244 */   // Label 2692: @152244
     /* 152244 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(152286), // Rule ID 7233 //
     /* 152249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152259 */     // MIs[0] Rn
     /* 152259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152271 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 152274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152284 */     GIR_RootConstrainSelectedInstOperands,
     /* 152285 */     // GIR_Coverage, 7233,
     /* 152285 */     GIR_EraseRootFromParent_Done,
     /* 152286 */   // Label 2693: @152286
     /* 152286 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(152328), // Rule ID 7234 //
     /* 152291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152301 */     // MIs[0] Rn
     /* 152301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152313 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 152316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152326 */     GIR_RootConstrainSelectedInstOperands,
     /* 152327 */     // GIR_Coverage, 7234,
     /* 152327 */     GIR_EraseRootFromParent_Done,
     /* 152328 */   // Label 2694: @152328
     /* 152328 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(152370), // Rule ID 7235 //
     /* 152333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152343 */     // MIs[0] Rn
     /* 152343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152355 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 152358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152368 */     GIR_RootConstrainSelectedInstOperands,
     /* 152369 */     // GIR_Coverage, 7235,
     /* 152369 */     GIR_EraseRootFromParent_Done,
     /* 152370 */   // Label 2695: @152370
     /* 152370 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(152412), // Rule ID 7236 //
     /* 152375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152385 */     // MIs[0] Rn
     /* 152385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152397 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 152400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152410 */     GIR_RootConstrainSelectedInstOperands,
     /* 152411 */     // GIR_Coverage, 7236,
     /* 152411 */     GIR_EraseRootFromParent_Done,
     /* 152412 */   // Label 2696: @152412
     /* 152412 */   GIM_Reject,
     /* 152413 */ // Label 2691: @152413
     /* 152413 */ GIM_Reject,
     /* 152414 */ // Label 2674: @152414
     /* 152414 */ GIM_Reject,
     /* 152415 */ // Label 26: @152415
     /* 152415 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2699*/ GIMT_Encode4(153406),
     /* 152426 */ /*GILLT_s32*//*Label 2697*/ GIMT_Encode4(152434),
     /* 152430 */ /*GILLT_s64*//*Label 2698*/ GIMT_Encode4(153179),
     /* 152434 */ // Label 2697: @152434
     /* 152434 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(153178),
     /* 152439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152442 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(152491), // Rule ID 7257 //
     /* 152447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152464 */     // MIs[0] Rn
     /* 152464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152476 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 152479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152489 */     GIR_RootConstrainSelectedInstOperands,
     /* 152490 */     // GIR_Coverage, 7257,
     /* 152490 */     GIR_EraseRootFromParent_Done,
     /* 152491 */   // Label 2701: @152491
     /* 152491 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(152540), // Rule ID 7258 //
     /* 152496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152513 */     // MIs[0] Rn
     /* 152513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152525 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 152528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152538 */     GIR_RootConstrainSelectedInstOperands,
     /* 152539 */     // GIR_Coverage, 7258,
     /* 152539 */     GIR_EraseRootFromParent_Done,
     /* 152540 */   // Label 2702: @152540
     /* 152540 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152589), // Rule ID 7259 //
     /* 152545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152562 */     // MIs[0] Rn
     /* 152562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152574 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 152577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152587 */     GIR_RootConstrainSelectedInstOperands,
     /* 152588 */     // GIR_Coverage, 7259,
     /* 152588 */     GIR_EraseRootFromParent_Done,
     /* 152589 */   // Label 2703: @152589
     /* 152589 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(152638), // Rule ID 7260 //
     /* 152594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152611 */     // MIs[0] Rn
     /* 152611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152623 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152636 */     GIR_RootConstrainSelectedInstOperands,
     /* 152637 */     // GIR_Coverage, 7260,
     /* 152637 */     GIR_EraseRootFromParent_Done,
     /* 152638 */   // Label 2704: @152638
     /* 152638 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(152687), // Rule ID 7261 //
     /* 152643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152660 */     // MIs[0] Rn
     /* 152660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152672 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152685 */     GIR_RootConstrainSelectedInstOperands,
     /* 152686 */     // GIR_Coverage, 7261,
     /* 152686 */     GIR_EraseRootFromParent_Done,
     /* 152687 */   // Label 2705: @152687
     /* 152687 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(152736), // Rule ID 7262 //
     /* 152692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152709 */     // MIs[0] Rn
     /* 152709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152721 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 152724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152734 */     GIR_RootConstrainSelectedInstOperands,
     /* 152735 */     // GIR_Coverage, 7262,
     /* 152735 */     GIR_EraseRootFromParent_Done,
     /* 152736 */   // Label 2706: @152736
     /* 152736 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(152785), // Rule ID 7263 //
     /* 152741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152758 */     // MIs[0] Rn
     /* 152758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152770 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 152773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152783 */     GIR_RootConstrainSelectedInstOperands,
     /* 152784 */     // GIR_Coverage, 7263,
     /* 152784 */     GIR_EraseRootFromParent_Done,
     /* 152785 */   // Label 2707: @152785
     /* 152785 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(152834), // Rule ID 7264 //
     /* 152790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152807 */     // MIs[0] Rn
     /* 152807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152819 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 152822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152832 */     GIR_RootConstrainSelectedInstOperands,
     /* 152833 */     // GIR_Coverage, 7264,
     /* 152833 */     GIR_EraseRootFromParent_Done,
     /* 152834 */   // Label 2708: @152834
     /* 152834 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(152883), // Rule ID 7265 //
     /* 152839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152856 */     // MIs[0] Rn
     /* 152856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152868 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152881 */     GIR_RootConstrainSelectedInstOperands,
     /* 152882 */     // GIR_Coverage, 7265,
     /* 152882 */     GIR_EraseRootFromParent_Done,
     /* 152883 */   // Label 2709: @152883
     /* 152883 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(152932), // Rule ID 7266 //
     /* 152888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152905 */     // MIs[0] Rn
     /* 152905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152917 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152930 */     GIR_RootConstrainSelectedInstOperands,
     /* 152931 */     // GIR_Coverage, 7266,
     /* 152931 */     GIR_EraseRootFromParent_Done,
     /* 152932 */   // Label 2710: @152932
     /* 152932 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(152981), // Rule ID 7267 //
     /* 152937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152954 */     // MIs[0] Rn
     /* 152954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152966 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 152969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152979 */     GIR_RootConstrainSelectedInstOperands,
     /* 152980 */     // GIR_Coverage, 7267,
     /* 152980 */     GIR_EraseRootFromParent_Done,
     /* 152981 */   // Label 2711: @152981
     /* 152981 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(153030), // Rule ID 7268 //
     /* 152986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153003 */     // MIs[0] Rn
     /* 153003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153015 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 153018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153028 */     GIR_RootConstrainSelectedInstOperands,
     /* 153029 */     // GIR_Coverage, 7268,
     /* 153029 */     GIR_EraseRootFromParent_Done,
     /* 153030 */   // Label 2712: @153030
     /* 153030 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(153079), // Rule ID 7269 //
     /* 153035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153052 */     // MIs[0] Rn
     /* 153052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153064 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 153067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153077 */     GIR_RootConstrainSelectedInstOperands,
     /* 153078 */     // GIR_Coverage, 7269,
     /* 153078 */     GIR_EraseRootFromParent_Done,
     /* 153079 */   // Label 2713: @153079
     /* 153079 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(153128), // Rule ID 7270 //
     /* 153084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153101 */     // MIs[0] Rn
     /* 153101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153113 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 153116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153126 */     GIR_RootConstrainSelectedInstOperands,
     /* 153127 */     // GIR_Coverage, 7270,
     /* 153127 */     GIR_EraseRootFromParent_Done,
     /* 153128 */   // Label 2714: @153128
     /* 153128 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(153177), // Rule ID 7271 //
     /* 153133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153150 */     // MIs[0] Rn
     /* 153150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153162 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 153165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153175 */     GIR_RootConstrainSelectedInstOperands,
     /* 153176 */     // GIR_Coverage, 7271,
     /* 153176 */     GIR_EraseRootFromParent_Done,
     /* 153177 */   // Label 2715: @153177
     /* 153177 */   GIM_Reject,
     /* 153178 */ // Label 2700: @153178
     /* 153178 */ GIM_Reject,
     /* 153179 */ // Label 2698: @153179
     /* 153179 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(153405),
     /* 153184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153194 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(153236), // Rule ID 7252 //
     /* 153199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153209 */     // MIs[0] Rn
     /* 153209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153221 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 153224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153234 */     GIR_RootConstrainSelectedInstOperands,
     /* 153235 */     // GIR_Coverage, 7252,
     /* 153235 */     GIR_EraseRootFromParent_Done,
     /* 153236 */   // Label 2717: @153236
     /* 153236 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(153278), // Rule ID 7253 //
     /* 153241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153251 */     // MIs[0] Rn
     /* 153251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153263 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 153266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153276 */     GIR_RootConstrainSelectedInstOperands,
     /* 153277 */     // GIR_Coverage, 7253,
     /* 153277 */     GIR_EraseRootFromParent_Done,
     /* 153278 */   // Label 2718: @153278
     /* 153278 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(153320), // Rule ID 7254 //
     /* 153283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153293 */     // MIs[0] Rn
     /* 153293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153305 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 153308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153318 */     GIR_RootConstrainSelectedInstOperands,
     /* 153319 */     // GIR_Coverage, 7254,
     /* 153319 */     GIR_EraseRootFromParent_Done,
     /* 153320 */   // Label 2719: @153320
     /* 153320 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(153362), // Rule ID 7255 //
     /* 153325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153335 */     // MIs[0] Rn
     /* 153335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153347 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 153350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153360 */     GIR_RootConstrainSelectedInstOperands,
     /* 153361 */     // GIR_Coverage, 7255,
     /* 153361 */     GIR_EraseRootFromParent_Done,
     /* 153362 */   // Label 2720: @153362
     /* 153362 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(153404), // Rule ID 7256 //
     /* 153367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153377 */     // MIs[0] Rn
     /* 153377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153389 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 153392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153402 */     GIR_RootConstrainSelectedInstOperands,
     /* 153403 */     // GIR_Coverage, 7256,
     /* 153403 */     GIR_EraseRootFromParent_Done,
     /* 153404 */   // Label 2721: @153404
     /* 153404 */   GIM_Reject,
     /* 153405 */ // Label 2716: @153405
     /* 153405 */ GIM_Reject,
     /* 153406 */ // Label 2699: @153406
     /* 153406 */ GIM_Reject,
     /* 153407 */ // Label 27: @153407
     /* 153407 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2724*/ GIMT_Encode4(154398),
     /* 153418 */ /*GILLT_s32*//*Label 2722*/ GIMT_Encode4(153426),
     /* 153422 */ /*GILLT_s64*//*Label 2723*/ GIMT_Encode4(154171),
     /* 153426 */ // Label 2722: @153426
     /* 153426 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(154170),
     /* 153431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153434 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(153483), // Rule ID 7297 //
     /* 153439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153456 */     // MIs[0] Rn
     /* 153456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153468 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 153471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153481 */     GIR_RootConstrainSelectedInstOperands,
     /* 153482 */     // GIR_Coverage, 7297,
     /* 153482 */     GIR_EraseRootFromParent_Done,
     /* 153483 */   // Label 2726: @153483
     /* 153483 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(153532), // Rule ID 7298 //
     /* 153488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153505 */     // MIs[0] Rn
     /* 153505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153517 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 153520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153530 */     GIR_RootConstrainSelectedInstOperands,
     /* 153531 */     // GIR_Coverage, 7298,
     /* 153531 */     GIR_EraseRootFromParent_Done,
     /* 153532 */   // Label 2727: @153532
     /* 153532 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153581), // Rule ID 7299 //
     /* 153537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153554 */     // MIs[0] Rn
     /* 153554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153566 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 153569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153579 */     GIR_RootConstrainSelectedInstOperands,
     /* 153580 */     // GIR_Coverage, 7299,
     /* 153580 */     GIR_EraseRootFromParent_Done,
     /* 153581 */   // Label 2728: @153581
     /* 153581 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(153630), // Rule ID 7300 //
     /* 153586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153603 */     // MIs[0] Rn
     /* 153603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153615 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153628 */     GIR_RootConstrainSelectedInstOperands,
     /* 153629 */     // GIR_Coverage, 7300,
     /* 153629 */     GIR_EraseRootFromParent_Done,
     /* 153630 */   // Label 2729: @153630
     /* 153630 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(153679), // Rule ID 7301 //
     /* 153635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153652 */     // MIs[0] Rn
     /* 153652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153664 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153677 */     GIR_RootConstrainSelectedInstOperands,
     /* 153678 */     // GIR_Coverage, 7301,
     /* 153678 */     GIR_EraseRootFromParent_Done,
     /* 153679 */   // Label 2730: @153679
     /* 153679 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(153728), // Rule ID 7302 //
     /* 153684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153701 */     // MIs[0] Rn
     /* 153701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153713 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 153716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153726 */     GIR_RootConstrainSelectedInstOperands,
     /* 153727 */     // GIR_Coverage, 7302,
     /* 153727 */     GIR_EraseRootFromParent_Done,
     /* 153728 */   // Label 2731: @153728
     /* 153728 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(153777), // Rule ID 7303 //
     /* 153733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153750 */     // MIs[0] Rn
     /* 153750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153762 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 153765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153775 */     GIR_RootConstrainSelectedInstOperands,
     /* 153776 */     // GIR_Coverage, 7303,
     /* 153776 */     GIR_EraseRootFromParent_Done,
     /* 153777 */   // Label 2732: @153777
     /* 153777 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(153826), // Rule ID 7304 //
     /* 153782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153799 */     // MIs[0] Rn
     /* 153799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153811 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 153814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153824 */     GIR_RootConstrainSelectedInstOperands,
     /* 153825 */     // GIR_Coverage, 7304,
     /* 153825 */     GIR_EraseRootFromParent_Done,
     /* 153826 */   // Label 2733: @153826
     /* 153826 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(153875), // Rule ID 7305 //
     /* 153831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153848 */     // MIs[0] Rn
     /* 153848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153860 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153873 */     GIR_RootConstrainSelectedInstOperands,
     /* 153874 */     // GIR_Coverage, 7305,
     /* 153874 */     GIR_EraseRootFromParent_Done,
     /* 153875 */   // Label 2734: @153875
     /* 153875 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(153924), // Rule ID 7306 //
     /* 153880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153897 */     // MIs[0] Rn
     /* 153897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153909 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153922 */     GIR_RootConstrainSelectedInstOperands,
     /* 153923 */     // GIR_Coverage, 7306,
     /* 153923 */     GIR_EraseRootFromParent_Done,
     /* 153924 */   // Label 2735: @153924
     /* 153924 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(153973), // Rule ID 7307 //
     /* 153929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153946 */     // MIs[0] Rn
     /* 153946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153958 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 153961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153971 */     GIR_RootConstrainSelectedInstOperands,
     /* 153972 */     // GIR_Coverage, 7307,
     /* 153972 */     GIR_EraseRootFromParent_Done,
     /* 153973 */   // Label 2736: @153973
     /* 153973 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(154022), // Rule ID 7308 //
     /* 153978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153995 */     // MIs[0] Rn
     /* 153995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154007 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 154010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154020 */     GIR_RootConstrainSelectedInstOperands,
     /* 154021 */     // GIR_Coverage, 7308,
     /* 154021 */     GIR_EraseRootFromParent_Done,
     /* 154022 */   // Label 2737: @154022
     /* 154022 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(154071), // Rule ID 7309 //
     /* 154027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154044 */     // MIs[0] Rn
     /* 154044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154056 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 154059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154069 */     GIR_RootConstrainSelectedInstOperands,
     /* 154070 */     // GIR_Coverage, 7309,
     /* 154070 */     GIR_EraseRootFromParent_Done,
     /* 154071 */   // Label 2738: @154071
     /* 154071 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(154120), // Rule ID 7310 //
     /* 154076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154093 */     // MIs[0] Rn
     /* 154093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154105 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 154108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154118 */     GIR_RootConstrainSelectedInstOperands,
     /* 154119 */     // GIR_Coverage, 7310,
     /* 154119 */     GIR_EraseRootFromParent_Done,
     /* 154120 */   // Label 2739: @154120
     /* 154120 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(154169), // Rule ID 7311 //
     /* 154125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154142 */     // MIs[0] Rn
     /* 154142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154154 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 154157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154167 */     GIR_RootConstrainSelectedInstOperands,
     /* 154168 */     // GIR_Coverage, 7311,
     /* 154168 */     GIR_EraseRootFromParent_Done,
     /* 154169 */   // Label 2740: @154169
     /* 154169 */   GIM_Reject,
     /* 154170 */ // Label 2725: @154170
     /* 154170 */ GIM_Reject,
     /* 154171 */ // Label 2723: @154171
     /* 154171 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(154397),
     /* 154176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154186 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(154228), // Rule ID 7292 //
     /* 154191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154201 */     // MIs[0] Rn
     /* 154201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154213 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 154216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154226 */     GIR_RootConstrainSelectedInstOperands,
     /* 154227 */     // GIR_Coverage, 7292,
     /* 154227 */     GIR_EraseRootFromParent_Done,
     /* 154228 */   // Label 2742: @154228
     /* 154228 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(154270), // Rule ID 7293 //
     /* 154233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154243 */     // MIs[0] Rn
     /* 154243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154255 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 154258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154268 */     GIR_RootConstrainSelectedInstOperands,
     /* 154269 */     // GIR_Coverage, 7293,
     /* 154269 */     GIR_EraseRootFromParent_Done,
     /* 154270 */   // Label 2743: @154270
     /* 154270 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(154312), // Rule ID 7294 //
     /* 154275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154285 */     // MIs[0] Rn
     /* 154285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154297 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 154300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154310 */     GIR_RootConstrainSelectedInstOperands,
     /* 154311 */     // GIR_Coverage, 7294,
     /* 154311 */     GIR_EraseRootFromParent_Done,
     /* 154312 */   // Label 2744: @154312
     /* 154312 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(154354), // Rule ID 7295 //
     /* 154317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154327 */     // MIs[0] Rn
     /* 154327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154339 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 154342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154352 */     GIR_RootConstrainSelectedInstOperands,
     /* 154353 */     // GIR_Coverage, 7295,
     /* 154353 */     GIR_EraseRootFromParent_Done,
     /* 154354 */   // Label 2745: @154354
     /* 154354 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154396), // Rule ID 7296 //
     /* 154359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154369 */     // MIs[0] Rn
     /* 154369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154381 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 154384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154394 */     GIR_RootConstrainSelectedInstOperands,
     /* 154395 */     // GIR_Coverage, 7296,
     /* 154395 */     GIR_EraseRootFromParent_Done,
     /* 154396 */   // Label 2746: @154396
     /* 154396 */   GIM_Reject,
     /* 154397 */ // Label 2741: @154397
     /* 154397 */ GIM_Reject,
     /* 154398 */ // Label 2724: @154398
     /* 154398 */ GIM_Reject,
     /* 154399 */ // Label 28: @154399
     /* 154399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2749*/ GIMT_Encode4(155390),
     /* 154410 */ /*GILLT_s32*//*Label 2747*/ GIMT_Encode4(154418),
     /* 154414 */ /*GILLT_s64*//*Label 2748*/ GIMT_Encode4(155163),
     /* 154418 */ // Label 2747: @154418
     /* 154418 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(155162),
     /* 154423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154426 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(154475), // Rule ID 7317 //
     /* 154431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154448 */     // MIs[0] Rn
     /* 154448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154460 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 154463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154473 */     GIR_RootConstrainSelectedInstOperands,
     /* 154474 */     // GIR_Coverage, 7317,
     /* 154474 */     GIR_EraseRootFromParent_Done,
     /* 154475 */   // Label 2751: @154475
     /* 154475 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(154524), // Rule ID 7318 //
     /* 154480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154497 */     // MIs[0] Rn
     /* 154497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154509 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 154512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154522 */     GIR_RootConstrainSelectedInstOperands,
     /* 154523 */     // GIR_Coverage, 7318,
     /* 154523 */     GIR_EraseRootFromParent_Done,
     /* 154524 */   // Label 2752: @154524
     /* 154524 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154573), // Rule ID 7319 //
     /* 154529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154546 */     // MIs[0] Rn
     /* 154546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154558 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 154561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154571 */     GIR_RootConstrainSelectedInstOperands,
     /* 154572 */     // GIR_Coverage, 7319,
     /* 154572 */     GIR_EraseRootFromParent_Done,
     /* 154573 */   // Label 2753: @154573
     /* 154573 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(154622), // Rule ID 7320 //
     /* 154578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154595 */     // MIs[0] Rn
     /* 154595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154607 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154620 */     GIR_RootConstrainSelectedInstOperands,
     /* 154621 */     // GIR_Coverage, 7320,
     /* 154621 */     GIR_EraseRootFromParent_Done,
     /* 154622 */   // Label 2754: @154622
     /* 154622 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(154671), // Rule ID 7321 //
     /* 154627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154644 */     // MIs[0] Rn
     /* 154644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154656 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154669 */     GIR_RootConstrainSelectedInstOperands,
     /* 154670 */     // GIR_Coverage, 7321,
     /* 154670 */     GIR_EraseRootFromParent_Done,
     /* 154671 */   // Label 2755: @154671
     /* 154671 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(154720), // Rule ID 7322 //
     /* 154676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154693 */     // MIs[0] Rn
     /* 154693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154705 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 154708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154718 */     GIR_RootConstrainSelectedInstOperands,
     /* 154719 */     // GIR_Coverage, 7322,
     /* 154719 */     GIR_EraseRootFromParent_Done,
     /* 154720 */   // Label 2756: @154720
     /* 154720 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(154769), // Rule ID 7323 //
     /* 154725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154742 */     // MIs[0] Rn
     /* 154742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154754 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 154757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154767 */     GIR_RootConstrainSelectedInstOperands,
     /* 154768 */     // GIR_Coverage, 7323,
     /* 154768 */     GIR_EraseRootFromParent_Done,
     /* 154769 */   // Label 2757: @154769
     /* 154769 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(154818), // Rule ID 7324 //
     /* 154774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154791 */     // MIs[0] Rn
     /* 154791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154803 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 154806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154816 */     GIR_RootConstrainSelectedInstOperands,
     /* 154817 */     // GIR_Coverage, 7324,
     /* 154817 */     GIR_EraseRootFromParent_Done,
     /* 154818 */   // Label 2758: @154818
     /* 154818 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(154867), // Rule ID 7325 //
     /* 154823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154840 */     // MIs[0] Rn
     /* 154840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154852 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154865 */     GIR_RootConstrainSelectedInstOperands,
     /* 154866 */     // GIR_Coverage, 7325,
     /* 154866 */     GIR_EraseRootFromParent_Done,
     /* 154867 */   // Label 2759: @154867
     /* 154867 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(154916), // Rule ID 7326 //
     /* 154872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154889 */     // MIs[0] Rn
     /* 154889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154901 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154914 */     GIR_RootConstrainSelectedInstOperands,
     /* 154915 */     // GIR_Coverage, 7326,
     /* 154915 */     GIR_EraseRootFromParent_Done,
     /* 154916 */   // Label 2760: @154916
     /* 154916 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(154965), // Rule ID 7327 //
     /* 154921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154938 */     // MIs[0] Rn
     /* 154938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154950 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 154953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154963 */     GIR_RootConstrainSelectedInstOperands,
     /* 154964 */     // GIR_Coverage, 7327,
     /* 154964 */     GIR_EraseRootFromParent_Done,
     /* 154965 */   // Label 2761: @154965
     /* 154965 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(155014), // Rule ID 7328 //
     /* 154970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154987 */     // MIs[0] Rn
     /* 154987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154999 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 155002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155012 */     GIR_RootConstrainSelectedInstOperands,
     /* 155013 */     // GIR_Coverage, 7328,
     /* 155013 */     GIR_EraseRootFromParent_Done,
     /* 155014 */   // Label 2762: @155014
     /* 155014 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(155063), // Rule ID 7329 //
     /* 155019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155036 */     // MIs[0] Rn
     /* 155036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155048 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 155051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155061 */     GIR_RootConstrainSelectedInstOperands,
     /* 155062 */     // GIR_Coverage, 7329,
     /* 155062 */     GIR_EraseRootFromParent_Done,
     /* 155063 */   // Label 2763: @155063
     /* 155063 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(155112), // Rule ID 7330 //
     /* 155068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155085 */     // MIs[0] Rn
     /* 155085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155097 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 155100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155110 */     GIR_RootConstrainSelectedInstOperands,
     /* 155111 */     // GIR_Coverage, 7330,
     /* 155111 */     GIR_EraseRootFromParent_Done,
     /* 155112 */   // Label 2764: @155112
     /* 155112 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(155161), // Rule ID 7331 //
     /* 155117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155134 */     // MIs[0] Rn
     /* 155134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155146 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 155149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155159 */     GIR_RootConstrainSelectedInstOperands,
     /* 155160 */     // GIR_Coverage, 7331,
     /* 155160 */     GIR_EraseRootFromParent_Done,
     /* 155161 */   // Label 2765: @155161
     /* 155161 */   GIM_Reject,
     /* 155162 */ // Label 2750: @155162
     /* 155162 */ GIM_Reject,
     /* 155163 */ // Label 2748: @155163
     /* 155163 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(155389),
     /* 155168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155178 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(155220), // Rule ID 7312 //
     /* 155183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155193 */     // MIs[0] Rn
     /* 155193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155205 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 155208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155218 */     GIR_RootConstrainSelectedInstOperands,
     /* 155219 */     // GIR_Coverage, 7312,
     /* 155219 */     GIR_EraseRootFromParent_Done,
     /* 155220 */   // Label 2767: @155220
     /* 155220 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(155262), // Rule ID 7313 //
     /* 155225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155235 */     // MIs[0] Rn
     /* 155235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155247 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 155250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155260 */     GIR_RootConstrainSelectedInstOperands,
     /* 155261 */     // GIR_Coverage, 7313,
     /* 155261 */     GIR_EraseRootFromParent_Done,
     /* 155262 */   // Label 2768: @155262
     /* 155262 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(155304), // Rule ID 7314 //
     /* 155267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155277 */     // MIs[0] Rn
     /* 155277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155289 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 155292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155302 */     GIR_RootConstrainSelectedInstOperands,
     /* 155303 */     // GIR_Coverage, 7314,
     /* 155303 */     GIR_EraseRootFromParent_Done,
     /* 155304 */   // Label 2769: @155304
     /* 155304 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(155346), // Rule ID 7315 //
     /* 155309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155319 */     // MIs[0] Rn
     /* 155319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155331 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 155334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155344 */     GIR_RootConstrainSelectedInstOperands,
     /* 155345 */     // GIR_Coverage, 7315,
     /* 155345 */     GIR_EraseRootFromParent_Done,
     /* 155346 */   // Label 2770: @155346
     /* 155346 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(155388), // Rule ID 7316 //
     /* 155351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155361 */     // MIs[0] Rn
     /* 155361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155373 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 155376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155386 */     GIR_RootConstrainSelectedInstOperands,
     /* 155387 */     // GIR_Coverage, 7316,
     /* 155387 */     GIR_EraseRootFromParent_Done,
     /* 155388 */   // Label 2771: @155388
     /* 155388 */   GIM_Reject,
     /* 155389 */ // Label 2766: @155389
     /* 155389 */ GIM_Reject,
     /* 155390 */ // Label 2749: @155390
     /* 155390 */ GIM_Reject,
     /* 155391 */ // Label 29: @155391
     /* 155391 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2774*/ GIMT_Encode4(156382),
     /* 155402 */ /*GILLT_s32*//*Label 2772*/ GIMT_Encode4(155410),
     /* 155406 */ /*GILLT_s64*//*Label 2773*/ GIMT_Encode4(156155),
     /* 155410 */ // Label 2772: @155410
     /* 155410 */ GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(156154),
     /* 155415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155418 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(155467), // Rule ID 7337 //
     /* 155423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155440 */     // MIs[0] Rn
     /* 155440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155452 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 155455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155465 */     GIR_RootConstrainSelectedInstOperands,
     /* 155466 */     // GIR_Coverage, 7337,
     /* 155466 */     GIR_EraseRootFromParent_Done,
     /* 155467 */   // Label 2776: @155467
     /* 155467 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(155516), // Rule ID 7338 //
     /* 155472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155489 */     // MIs[0] Rn
     /* 155489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155501 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 155504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155514 */     GIR_RootConstrainSelectedInstOperands,
     /* 155515 */     // GIR_Coverage, 7338,
     /* 155515 */     GIR_EraseRootFromParent_Done,
     /* 155516 */   // Label 2777: @155516
     /* 155516 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155565), // Rule ID 7339 //
     /* 155521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155538 */     // MIs[0] Rn
     /* 155538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155550 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 155553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155563 */     GIR_RootConstrainSelectedInstOperands,
     /* 155564 */     // GIR_Coverage, 7339,
     /* 155564 */     GIR_EraseRootFromParent_Done,
     /* 155565 */   // Label 2778: @155565
     /* 155565 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(155614), // Rule ID 7340 //
     /* 155570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155587 */     // MIs[0] Rn
     /* 155587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155599 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155612 */     GIR_RootConstrainSelectedInstOperands,
     /* 155613 */     // GIR_Coverage, 7340,
     /* 155613 */     GIR_EraseRootFromParent_Done,
     /* 155614 */   // Label 2779: @155614
     /* 155614 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(155663), // Rule ID 7341 //
     /* 155619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155636 */     // MIs[0] Rn
     /* 155636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155648 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155661 */     GIR_RootConstrainSelectedInstOperands,
     /* 155662 */     // GIR_Coverage, 7341,
     /* 155662 */     GIR_EraseRootFromParent_Done,
     /* 155663 */   // Label 2780: @155663
     /* 155663 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(155712), // Rule ID 7342 //
     /* 155668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155685 */     // MIs[0] Rn
     /* 155685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155697 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 155700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155710 */     GIR_RootConstrainSelectedInstOperands,
     /* 155711 */     // GIR_Coverage, 7342,
     /* 155711 */     GIR_EraseRootFromParent_Done,
     /* 155712 */   // Label 2781: @155712
     /* 155712 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155761), // Rule ID 7343 //
     /* 155717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155734 */     // MIs[0] Rn
     /* 155734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155746 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 155749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155759 */     GIR_RootConstrainSelectedInstOperands,
     /* 155760 */     // GIR_Coverage, 7343,
     /* 155760 */     GIR_EraseRootFromParent_Done,
     /* 155761 */   // Label 2782: @155761
     /* 155761 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155810), // Rule ID 7344 //
     /* 155766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155783 */     // MIs[0] Rn
     /* 155783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155795 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 155798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155808 */     GIR_RootConstrainSelectedInstOperands,
     /* 155809 */     // GIR_Coverage, 7344,
     /* 155809 */     GIR_EraseRootFromParent_Done,
     /* 155810 */   // Label 2783: @155810
     /* 155810 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155859), // Rule ID 7345 //
     /* 155815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155832 */     // MIs[0] Rn
     /* 155832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155844 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155857 */     GIR_RootConstrainSelectedInstOperands,
     /* 155858 */     // GIR_Coverage, 7345,
     /* 155858 */     GIR_EraseRootFromParent_Done,
     /* 155859 */   // Label 2784: @155859
     /* 155859 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155908), // Rule ID 7346 //
     /* 155864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155881 */     // MIs[0] Rn
     /* 155881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155893 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155906 */     GIR_RootConstrainSelectedInstOperands,
     /* 155907 */     // GIR_Coverage, 7346,
     /* 155907 */     GIR_EraseRootFromParent_Done,
     /* 155908 */   // Label 2785: @155908
     /* 155908 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155957), // Rule ID 7347 //
     /* 155913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155930 */     // MIs[0] Rn
     /* 155930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155942 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 155945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155955 */     GIR_RootConstrainSelectedInstOperands,
     /* 155956 */     // GIR_Coverage, 7347,
     /* 155956 */     GIR_EraseRootFromParent_Done,
     /* 155957 */   // Label 2786: @155957
     /* 155957 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(156006), // Rule ID 7348 //
     /* 155962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155979 */     // MIs[0] Rn
     /* 155979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155991 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 155994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156004 */     GIR_RootConstrainSelectedInstOperands,
     /* 156005 */     // GIR_Coverage, 7348,
     /* 156005 */     GIR_EraseRootFromParent_Done,
     /* 156006 */   // Label 2787: @156006
     /* 156006 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(156055), // Rule ID 7349 //
     /* 156011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156028 */     // MIs[0] Rn
     /* 156028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156040 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 156043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156053 */     GIR_RootConstrainSelectedInstOperands,
     /* 156054 */     // GIR_Coverage, 7349,
     /* 156054 */     GIR_EraseRootFromParent_Done,
     /* 156055 */   // Label 2788: @156055
     /* 156055 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(156104), // Rule ID 7350 //
     /* 156060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156077 */     // MIs[0] Rn
     /* 156077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156089 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 156092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156102 */     GIR_RootConstrainSelectedInstOperands,
     /* 156103 */     // GIR_Coverage, 7350,
     /* 156103 */     GIR_EraseRootFromParent_Done,
     /* 156104 */   // Label 2789: @156104
     /* 156104 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(156153), // Rule ID 7351 //
     /* 156109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156126 */     // MIs[0] Rn
     /* 156126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156138 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 156141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156151 */     GIR_RootConstrainSelectedInstOperands,
     /* 156152 */     // GIR_Coverage, 7351,
     /* 156152 */     GIR_EraseRootFromParent_Done,
     /* 156153 */   // Label 2790: @156153
     /* 156153 */   GIM_Reject,
     /* 156154 */ // Label 2775: @156154
     /* 156154 */ GIM_Reject,
     /* 156155 */ // Label 2773: @156155
     /* 156155 */ GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(156381),
     /* 156160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156170 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(156212), // Rule ID 7332 //
     /* 156175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156185 */     // MIs[0] Rn
     /* 156185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156197 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 156200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156210 */     GIR_RootConstrainSelectedInstOperands,
     /* 156211 */     // GIR_Coverage, 7332,
     /* 156211 */     GIR_EraseRootFromParent_Done,
     /* 156212 */   // Label 2792: @156212
     /* 156212 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(156254), // Rule ID 7333 //
     /* 156217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156227 */     // MIs[0] Rn
     /* 156227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156239 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 156242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156252 */     GIR_RootConstrainSelectedInstOperands,
     /* 156253 */     // GIR_Coverage, 7333,
     /* 156253 */     GIR_EraseRootFromParent_Done,
     /* 156254 */   // Label 2793: @156254
     /* 156254 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(156296), // Rule ID 7334 //
     /* 156259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156269 */     // MIs[0] Rn
     /* 156269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156281 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 156284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156294 */     GIR_RootConstrainSelectedInstOperands,
     /* 156295 */     // GIR_Coverage, 7334,
     /* 156295 */     GIR_EraseRootFromParent_Done,
     /* 156296 */   // Label 2794: @156296
     /* 156296 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(156338), // Rule ID 7335 //
     /* 156301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156311 */     // MIs[0] Rn
     /* 156311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156323 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 156326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156336 */     GIR_RootConstrainSelectedInstOperands,
     /* 156337 */     // GIR_Coverage, 7335,
     /* 156337 */     GIR_EraseRootFromParent_Done,
     /* 156338 */   // Label 2795: @156338
     /* 156338 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(156380), // Rule ID 7336 //
     /* 156343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156353 */     // MIs[0] Rn
     /* 156353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156365 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 156368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156378 */     GIR_RootConstrainSelectedInstOperands,
     /* 156379 */     // GIR_Coverage, 7336,
     /* 156379 */     GIR_EraseRootFromParent_Done,
     /* 156380 */   // Label 2796: @156380
     /* 156380 */   GIM_Reject,
     /* 156381 */ // Label 2791: @156381
     /* 156381 */ GIM_Reject,
     /* 156382 */ // Label 2774: @156382
     /* 156382 */ GIM_Reject,
     /* 156383 */ // Label 30: @156383
     /* 156383 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2799*/ GIMT_Encode4(157374),
     /* 156394 */ /*GILLT_s32*//*Label 2797*/ GIMT_Encode4(156402),
     /* 156398 */ /*GILLT_s64*//*Label 2798*/ GIMT_Encode4(157147),
     /* 156402 */ // Label 2797: @156402
     /* 156402 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(157146),
     /* 156407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156410 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156459), // Rule ID 7357 //
     /* 156415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156432 */     // MIs[0] Rn
     /* 156432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156444 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 156447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156457 */     GIR_RootConstrainSelectedInstOperands,
     /* 156458 */     // GIR_Coverage, 7357,
     /* 156458 */     GIR_EraseRootFromParent_Done,
     /* 156459 */   // Label 2801: @156459
     /* 156459 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156508), // Rule ID 7358 //
     /* 156464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156481 */     // MIs[0] Rn
     /* 156481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156493 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 156496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156506 */     GIR_RootConstrainSelectedInstOperands,
     /* 156507 */     // GIR_Coverage, 7358,
     /* 156507 */     GIR_EraseRootFromParent_Done,
     /* 156508 */   // Label 2802: @156508
     /* 156508 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156557), // Rule ID 7359 //
     /* 156513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156530 */     // MIs[0] Rn
     /* 156530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156542 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 156545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156555 */     GIR_RootConstrainSelectedInstOperands,
     /* 156556 */     // GIR_Coverage, 7359,
     /* 156556 */     GIR_EraseRootFromParent_Done,
     /* 156557 */   // Label 2803: @156557
     /* 156557 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156606), // Rule ID 7360 //
     /* 156562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156579 */     // MIs[0] Rn
     /* 156579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156591 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156604 */     GIR_RootConstrainSelectedInstOperands,
     /* 156605 */     // GIR_Coverage, 7360,
     /* 156605 */     GIR_EraseRootFromParent_Done,
     /* 156606 */   // Label 2804: @156606
     /* 156606 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156655), // Rule ID 7361 //
     /* 156611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156628 */     // MIs[0] Rn
     /* 156628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156640 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156653 */     GIR_RootConstrainSelectedInstOperands,
     /* 156654 */     // GIR_Coverage, 7361,
     /* 156654 */     GIR_EraseRootFromParent_Done,
     /* 156655 */   // Label 2805: @156655
     /* 156655 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156704), // Rule ID 7362 //
     /* 156660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156677 */     // MIs[0] Rn
     /* 156677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156689 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 156692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156702 */     GIR_RootConstrainSelectedInstOperands,
     /* 156703 */     // GIR_Coverage, 7362,
     /* 156703 */     GIR_EraseRootFromParent_Done,
     /* 156704 */   // Label 2806: @156704
     /* 156704 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156753), // Rule ID 7363 //
     /* 156709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156726 */     // MIs[0] Rn
     /* 156726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156738 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 156741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156751 */     GIR_RootConstrainSelectedInstOperands,
     /* 156752 */     // GIR_Coverage, 7363,
     /* 156752 */     GIR_EraseRootFromParent_Done,
     /* 156753 */   // Label 2807: @156753
     /* 156753 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156802), // Rule ID 7364 //
     /* 156758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156775 */     // MIs[0] Rn
     /* 156775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156787 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 156790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156800 */     GIR_RootConstrainSelectedInstOperands,
     /* 156801 */     // GIR_Coverage, 7364,
     /* 156801 */     GIR_EraseRootFromParent_Done,
     /* 156802 */   // Label 2808: @156802
     /* 156802 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156851), // Rule ID 7365 //
     /* 156807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156824 */     // MIs[0] Rn
     /* 156824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156836 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156849 */     GIR_RootConstrainSelectedInstOperands,
     /* 156850 */     // GIR_Coverage, 7365,
     /* 156850 */     GIR_EraseRootFromParent_Done,
     /* 156851 */   // Label 2809: @156851
     /* 156851 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156900), // Rule ID 7366 //
     /* 156856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156873 */     // MIs[0] Rn
     /* 156873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156885 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156898 */     GIR_RootConstrainSelectedInstOperands,
     /* 156899 */     // GIR_Coverage, 7366,
     /* 156899 */     GIR_EraseRootFromParent_Done,
     /* 156900 */   // Label 2810: @156900
     /* 156900 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156949), // Rule ID 7367 //
     /* 156905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156922 */     // MIs[0] Rn
     /* 156922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156934 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 156937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156947 */     GIR_RootConstrainSelectedInstOperands,
     /* 156948 */     // GIR_Coverage, 7367,
     /* 156948 */     GIR_EraseRootFromParent_Done,
     /* 156949 */   // Label 2811: @156949
     /* 156949 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156998), // Rule ID 7368 //
     /* 156954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156964 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156971 */     // MIs[0] Rn
     /* 156971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156983 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 156986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156996 */     GIR_RootConstrainSelectedInstOperands,
     /* 156997 */     // GIR_Coverage, 7368,
     /* 156997 */     GIR_EraseRootFromParent_Done,
     /* 156998 */   // Label 2812: @156998
     /* 156998 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(157047), // Rule ID 7369 //
     /* 157003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157020 */     // MIs[0] Rn
     /* 157020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157032 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 157035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157045 */     GIR_RootConstrainSelectedInstOperands,
     /* 157046 */     // GIR_Coverage, 7369,
     /* 157046 */     GIR_EraseRootFromParent_Done,
     /* 157047 */   // Label 2813: @157047
     /* 157047 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(157096), // Rule ID 7370 //
     /* 157052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157069 */     // MIs[0] Rn
     /* 157069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157081 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 157084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157094 */     GIR_RootConstrainSelectedInstOperands,
     /* 157095 */     // GIR_Coverage, 7370,
     /* 157095 */     GIR_EraseRootFromParent_Done,
     /* 157096 */   // Label 2814: @157096
     /* 157096 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(157145), // Rule ID 7371 //
     /* 157101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157118 */     // MIs[0] Rn
     /* 157118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 157130 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 157133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157143 */     GIR_RootConstrainSelectedInstOperands,
     /* 157144 */     // GIR_Coverage, 7371,
     /* 157144 */     GIR_EraseRootFromParent_Done,
     /* 157145 */   // Label 2815: @157145
     /* 157145 */   GIM_Reject,
     /* 157146 */ // Label 2800: @157146
     /* 157146 */ GIM_Reject,
     /* 157147 */ // Label 2798: @157147
     /* 157147 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(157373),
     /* 157152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157162 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(157204), // Rule ID 7352 //
     /* 157167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157177 */     // MIs[0] Rn
     /* 157177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157189 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 157192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157202 */     GIR_RootConstrainSelectedInstOperands,
     /* 157203 */     // GIR_Coverage, 7352,
     /* 157203 */     GIR_EraseRootFromParent_Done,
     /* 157204 */   // Label 2817: @157204
     /* 157204 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(157246), // Rule ID 7353 //
     /* 157209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157219 */     // MIs[0] Rn
     /* 157219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157231 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 157234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157244 */     GIR_RootConstrainSelectedInstOperands,
     /* 157245 */     // GIR_Coverage, 7353,
     /* 157245 */     GIR_EraseRootFromParent_Done,
     /* 157246 */   // Label 2818: @157246
     /* 157246 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(157288), // Rule ID 7354 //
     /* 157251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157261 */     // MIs[0] Rn
     /* 157261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157273 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 157276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157286 */     GIR_RootConstrainSelectedInstOperands,
     /* 157287 */     // GIR_Coverage, 7354,
     /* 157287 */     GIR_EraseRootFromParent_Done,
     /* 157288 */   // Label 2819: @157288
     /* 157288 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(157330), // Rule ID 7355 //
     /* 157293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157303 */     // MIs[0] Rn
     /* 157303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157315 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 157318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157328 */     GIR_RootConstrainSelectedInstOperands,
     /* 157329 */     // GIR_Coverage, 7355,
     /* 157329 */     GIR_EraseRootFromParent_Done,
     /* 157330 */   // Label 2820: @157330
     /* 157330 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(157372), // Rule ID 7356 //
     /* 157335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 157338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157345 */     // MIs[0] Rn
     /* 157345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 157353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157357 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 157357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 157360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157370 */     GIR_RootConstrainSelectedInstOperands,
     /* 157371 */     // GIR_Coverage, 7356,
     /* 157371 */     GIR_EraseRootFromParent_Done,
     /* 157372 */   // Label 2821: @157372
     /* 157372 */   GIM_Reject,
     /* 157373 */ // Label 2816: @157373
     /* 157373 */ GIM_Reject,
     /* 157374 */ // Label 2799: @157374
     /* 157374 */ GIM_Reject,
     /* 157375 */ // Label 31: @157375
     /* 157375 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(158079),
     /* 157386 */ /*GILLT_s16*//*Label 2822*/ GIMT_Encode4(157398),
     /* 157390 */ /*GILLT_s32*//*Label 2823*/ GIMT_Encode4(157625),
     /* 157394 */ /*GILLT_s64*//*Label 2824*/ GIMT_Encode4(157852),
     /* 157398 */ // Label 2822: @157398
     /* 157398 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(157624),
     /* 157403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157413 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(157455), // Rule ID 2584 //
     /* 157418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157428 */     // MIs[0] Rn
     /* 157428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157440 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 157443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157453 */     GIR_RootConstrainSelectedInstOperands,
     /* 157454 */     // GIR_Coverage, 2584,
     /* 157454 */     GIR_EraseRootFromParent_Done,
     /* 157455 */   // Label 2827: @157455
     /* 157455 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(157497), // Rule ID 2585 //
     /* 157460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157470 */     // MIs[0] Rn
     /* 157470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157482 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 157485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157495 */     GIR_RootConstrainSelectedInstOperands,
     /* 157496 */     // GIR_Coverage, 2585,
     /* 157496 */     GIR_EraseRootFromParent_Done,
     /* 157497 */   // Label 2828: @157497
     /* 157497 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(157539), // Rule ID 2586 //
     /* 157502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157512 */     // MIs[0] Rn
     /* 157512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157524 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 157527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157537 */     GIR_RootConstrainSelectedInstOperands,
     /* 157538 */     // GIR_Coverage, 2586,
     /* 157538 */     GIR_EraseRootFromParent_Done,
     /* 157539 */   // Label 2829: @157539
     /* 157539 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(157581), // Rule ID 2587 //
     /* 157544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157554 */     // MIs[0] Rn
     /* 157554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157566 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157579 */     GIR_RootConstrainSelectedInstOperands,
     /* 157580 */     // GIR_Coverage, 2587,
     /* 157580 */     GIR_EraseRootFromParent_Done,
     /* 157581 */   // Label 2830: @157581
     /* 157581 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(157623), // Rule ID 2588 //
     /* 157586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157596 */     // MIs[0] Rn
     /* 157596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157608 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157621 */     GIR_RootConstrainSelectedInstOperands,
     /* 157622 */     // GIR_Coverage, 2588,
     /* 157622 */     GIR_EraseRootFromParent_Done,
     /* 157623 */   // Label 2831: @157623
     /* 157623 */   GIM_Reject,
     /* 157624 */ // Label 2826: @157624
     /* 157624 */ GIM_Reject,
     /* 157625 */ // Label 2823: @157625
     /* 157625 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(157851),
     /* 157630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157633 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157640 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(157682), // Rule ID 7447 //
     /* 157645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157655 */     // MIs[0] Rn
     /* 157655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157667 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 157670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157680 */     GIR_RootConstrainSelectedInstOperands,
     /* 157681 */     // GIR_Coverage, 7447,
     /* 157681 */     GIR_EraseRootFromParent_Done,
     /* 157682 */   // Label 2833: @157682
     /* 157682 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(157724), // Rule ID 7448 //
     /* 157687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157697 */     // MIs[0] Rn
     /* 157697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157709 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 157712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157722 */     GIR_RootConstrainSelectedInstOperands,
     /* 157723 */     // GIR_Coverage, 7448,
     /* 157723 */     GIR_EraseRootFromParent_Done,
     /* 157724 */   // Label 2834: @157724
     /* 157724 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(157766), // Rule ID 7449 //
     /* 157729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157739 */     // MIs[0] Rn
     /* 157739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157751 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 157754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157764 */     GIR_RootConstrainSelectedInstOperands,
     /* 157765 */     // GIR_Coverage, 7449,
     /* 157765 */     GIR_EraseRootFromParent_Done,
     /* 157766 */   // Label 2835: @157766
     /* 157766 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(157808), // Rule ID 7450 //
     /* 157771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157781 */     // MIs[0] Rn
     /* 157781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157793 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157806 */     GIR_RootConstrainSelectedInstOperands,
     /* 157807 */     // GIR_Coverage, 7450,
     /* 157807 */     GIR_EraseRootFromParent_Done,
     /* 157808 */   // Label 2836: @157808
     /* 157808 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(157850), // Rule ID 7451 //
     /* 157813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157823 */     // MIs[0] Rn
     /* 157823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157835 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157848 */     GIR_RootConstrainSelectedInstOperands,
     /* 157849 */     // GIR_Coverage, 7451,
     /* 157849 */     GIR_EraseRootFromParent_Done,
     /* 157850 */   // Label 2837: @157850
     /* 157850 */   GIM_Reject,
     /* 157851 */ // Label 2832: @157851
     /* 157851 */ GIM_Reject,
     /* 157852 */ // Label 2824: @157852
     /* 157852 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(158078),
     /* 157857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157867 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(157909), // Rule ID 7452 //
     /* 157872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157882 */     // MIs[0] Rn
     /* 157882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157894 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 157897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157907 */     GIR_RootConstrainSelectedInstOperands,
     /* 157908 */     // GIR_Coverage, 7452,
     /* 157908 */     GIR_EraseRootFromParent_Done,
     /* 157909 */   // Label 2839: @157909
     /* 157909 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(157951), // Rule ID 7453 //
     /* 157914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157924 */     // MIs[0] Rn
     /* 157924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157936 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 157939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157949 */     GIR_RootConstrainSelectedInstOperands,
     /* 157950 */     // GIR_Coverage, 7453,
     /* 157950 */     GIR_EraseRootFromParent_Done,
     /* 157951 */   // Label 2840: @157951
     /* 157951 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(157993), // Rule ID 7454 //
     /* 157956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157966 */     // MIs[0] Rn
     /* 157966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157978 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 157981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157991 */     GIR_RootConstrainSelectedInstOperands,
     /* 157992 */     // GIR_Coverage, 7454,
     /* 157992 */     GIR_EraseRootFromParent_Done,
     /* 157993 */   // Label 2841: @157993
     /* 157993 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(158035), // Rule ID 7455 //
     /* 157998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158008 */     // MIs[0] Rn
     /* 158008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158020 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 158023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158033 */     GIR_RootConstrainSelectedInstOperands,
     /* 158034 */     // GIR_Coverage, 7455,
     /* 158034 */     GIR_EraseRootFromParent_Done,
     /* 158035 */   // Label 2842: @158035
     /* 158035 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(158077), // Rule ID 7456 //
     /* 158040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158050 */     // MIs[0] Rn
     /* 158050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158062 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 158065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158075 */     GIR_RootConstrainSelectedInstOperands,
     /* 158076 */     // GIR_Coverage, 7456,
     /* 158076 */     GIR_EraseRootFromParent_Done,
     /* 158077 */   // Label 2843: @158077
     /* 158077 */   GIM_Reject,
     /* 158078 */ // Label 2838: @158078
     /* 158078 */ GIM_Reject,
     /* 158079 */ // Label 2825: @158079
     /* 158079 */ GIM_Reject,
     /* 158080 */ // Label 32: @158080
     /* 158080 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2847*/ GIMT_Encode4(158784),
     /* 158091 */ /*GILLT_s16*//*Label 2844*/ GIMT_Encode4(158103),
     /* 158095 */ /*GILLT_s32*//*Label 2845*/ GIMT_Encode4(158330),
     /* 158099 */ /*GILLT_s64*//*Label 2846*/ GIMT_Encode4(158557),
     /* 158103 */ // Label 2844: @158103
     /* 158103 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(158329),
     /* 158108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(158160), // Rule ID 7457 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158133 */     // MIs[0] Rn
     /* 158133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158145 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 158148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158158 */     GIR_RootConstrainSelectedInstOperands,
     /* 158159 */     // GIR_Coverage, 7457,
     /* 158159 */     GIR_EraseRootFromParent_Done,
     /* 158160 */   // Label 2849: @158160
     /* 158160 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(158202), // Rule ID 7458 //
     /* 158165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158175 */     // MIs[0] Rn
     /* 158175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158187 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 158190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158200 */     GIR_RootConstrainSelectedInstOperands,
     /* 158201 */     // GIR_Coverage, 7458,
     /* 158201 */     GIR_EraseRootFromParent_Done,
     /* 158202 */   // Label 2850: @158202
     /* 158202 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(158244), // Rule ID 7459 //
     /* 158207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158217 */     // MIs[0] Rn
     /* 158217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158229 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 158232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158242 */     GIR_RootConstrainSelectedInstOperands,
     /* 158243 */     // GIR_Coverage, 7459,
     /* 158243 */     GIR_EraseRootFromParent_Done,
     /* 158244 */   // Label 2851: @158244
     /* 158244 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(158286), // Rule ID 7460 //
     /* 158249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158259 */     // MIs[0] Rn
     /* 158259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158271 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 158274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158284 */     GIR_RootConstrainSelectedInstOperands,
     /* 158285 */     // GIR_Coverage, 7460,
     /* 158285 */     GIR_EraseRootFromParent_Done,
     /* 158286 */   // Label 2852: @158286
     /* 158286 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(158328), // Rule ID 7461 //
     /* 158291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158301 */     // MIs[0] Rn
     /* 158301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158313 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 158316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158326 */     GIR_RootConstrainSelectedInstOperands,
     /* 158327 */     // GIR_Coverage, 7461,
     /* 158327 */     GIR_EraseRootFromParent_Done,
     /* 158328 */   // Label 2853: @158328
     /* 158328 */   GIM_Reject,
     /* 158329 */ // Label 2848: @158329
     /* 158329 */ GIM_Reject,
     /* 158330 */ // Label 2845: @158330
     /* 158330 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(158556),
     /* 158335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158345 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(158387), // Rule ID 7462 //
     /* 158350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158360 */     // MIs[0] Rn
     /* 158360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158372 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 158375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158385 */     GIR_RootConstrainSelectedInstOperands,
     /* 158386 */     // GIR_Coverage, 7462,
     /* 158386 */     GIR_EraseRootFromParent_Done,
     /* 158387 */   // Label 2855: @158387
     /* 158387 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(158429), // Rule ID 7463 //
     /* 158392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158402 */     // MIs[0] Rn
     /* 158402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158414 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 158417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158427 */     GIR_RootConstrainSelectedInstOperands,
     /* 158428 */     // GIR_Coverage, 7463,
     /* 158428 */     GIR_EraseRootFromParent_Done,
     /* 158429 */   // Label 2856: @158429
     /* 158429 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(158471), // Rule ID 7464 //
     /* 158434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158444 */     // MIs[0] Rn
     /* 158444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158456 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 158459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158469 */     GIR_RootConstrainSelectedInstOperands,
     /* 158470 */     // GIR_Coverage, 7464,
     /* 158470 */     GIR_EraseRootFromParent_Done,
     /* 158471 */   // Label 2857: @158471
     /* 158471 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(158513), // Rule ID 7465 //
     /* 158476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158486 */     // MIs[0] Rn
     /* 158486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158498 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158511 */     GIR_RootConstrainSelectedInstOperands,
     /* 158512 */     // GIR_Coverage, 7465,
     /* 158512 */     GIR_EraseRootFromParent_Done,
     /* 158513 */   // Label 2858: @158513
     /* 158513 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(158555), // Rule ID 7466 //
     /* 158518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158528 */     // MIs[0] Rn
     /* 158528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158540 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158553 */     GIR_RootConstrainSelectedInstOperands,
     /* 158554 */     // GIR_Coverage, 7466,
     /* 158554 */     GIR_EraseRootFromParent_Done,
     /* 158555 */   // Label 2859: @158555
     /* 158555 */   GIM_Reject,
     /* 158556 */ // Label 2854: @158556
     /* 158556 */ GIM_Reject,
     /* 158557 */ // Label 2846: @158557
     /* 158557 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(158783),
     /* 158562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158565 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158572 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(158614), // Rule ID 7467 //
     /* 158577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158587 */     // MIs[0] Rn
     /* 158587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158599 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 158602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158612 */     GIR_RootConstrainSelectedInstOperands,
     /* 158613 */     // GIR_Coverage, 7467,
     /* 158613 */     GIR_EraseRootFromParent_Done,
     /* 158614 */   // Label 2861: @158614
     /* 158614 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(158656), // Rule ID 7468 //
     /* 158619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158629 */     // MIs[0] Rn
     /* 158629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158641 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 158644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158654 */     GIR_RootConstrainSelectedInstOperands,
     /* 158655 */     // GIR_Coverage, 7468,
     /* 158655 */     GIR_EraseRootFromParent_Done,
     /* 158656 */   // Label 2862: @158656
     /* 158656 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(158698), // Rule ID 7469 //
     /* 158661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158671 */     // MIs[0] Rn
     /* 158671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158683 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 158686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158696 */     GIR_RootConstrainSelectedInstOperands,
     /* 158697 */     // GIR_Coverage, 7469,
     /* 158697 */     GIR_EraseRootFromParent_Done,
     /* 158698 */   // Label 2863: @158698
     /* 158698 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(158740), // Rule ID 7470 //
     /* 158703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158713 */     // MIs[0] Rn
     /* 158713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158725 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158738 */     GIR_RootConstrainSelectedInstOperands,
     /* 158739 */     // GIR_Coverage, 7470,
     /* 158739 */     GIR_EraseRootFromParent_Done,
     /* 158740 */   // Label 2864: @158740
     /* 158740 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(158782), // Rule ID 7471 //
     /* 158745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158755 */     // MIs[0] Rn
     /* 158755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158767 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158780 */     GIR_RootConstrainSelectedInstOperands,
     /* 158781 */     // GIR_Coverage, 7471,
     /* 158781 */     GIR_EraseRootFromParent_Done,
     /* 158782 */   // Label 2865: @158782
     /* 158782 */   GIM_Reject,
     /* 158783 */ // Label 2860: @158783
     /* 158783 */ GIM_Reject,
     /* 158784 */ // Label 2847: @158784
     /* 158784 */ GIM_Reject,
     /* 158785 */ // Label 33: @158785
     /* 158785 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(159489),
     /* 158796 */ /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(158808),
     /* 158800 */ /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(159035),
     /* 158804 */ /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(159262),
     /* 158808 */ // Label 2866: @158808
     /* 158808 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(159034),
     /* 158813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158823 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(158865), // Rule ID 7472 //
     /* 158828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158838 */     // MIs[0] Rn
     /* 158838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158850 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 158853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158863 */     GIR_RootConstrainSelectedInstOperands,
     /* 158864 */     // GIR_Coverage, 7472,
     /* 158864 */     GIR_EraseRootFromParent_Done,
     /* 158865 */   // Label 2871: @158865
     /* 158865 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(158907), // Rule ID 7473 //
     /* 158870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158880 */     // MIs[0] Rn
     /* 158880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158892 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 158895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158905 */     GIR_RootConstrainSelectedInstOperands,
     /* 158906 */     // GIR_Coverage, 7473,
     /* 158906 */     GIR_EraseRootFromParent_Done,
     /* 158907 */   // Label 2872: @158907
     /* 158907 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(158949), // Rule ID 7474 //
     /* 158912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158922 */     // MIs[0] Rn
     /* 158922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158934 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 158937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158947 */     GIR_RootConstrainSelectedInstOperands,
     /* 158948 */     // GIR_Coverage, 7474,
     /* 158948 */     GIR_EraseRootFromParent_Done,
     /* 158949 */   // Label 2873: @158949
     /* 158949 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(158991), // Rule ID 7475 //
     /* 158954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158964 */     // MIs[0] Rn
     /* 158964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158976 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158989 */     GIR_RootConstrainSelectedInstOperands,
     /* 158990 */     // GIR_Coverage, 7475,
     /* 158990 */     GIR_EraseRootFromParent_Done,
     /* 158991 */   // Label 2874: @158991
     /* 158991 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(159033), // Rule ID 7476 //
     /* 158996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159006 */     // MIs[0] Rn
     /* 159006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159018 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 159021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159031 */     GIR_RootConstrainSelectedInstOperands,
     /* 159032 */     // GIR_Coverage, 7476,
     /* 159032 */     GIR_EraseRootFromParent_Done,
     /* 159033 */   // Label 2875: @159033
     /* 159033 */   GIM_Reject,
     /* 159034 */ // Label 2870: @159034
     /* 159034 */ GIM_Reject,
     /* 159035 */ // Label 2867: @159035
     /* 159035 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(159261),
     /* 159040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159050 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(159092), // Rule ID 7477 //
     /* 159055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159065 */     // MIs[0] Rn
     /* 159065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159077 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 159080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159090 */     GIR_RootConstrainSelectedInstOperands,
     /* 159091 */     // GIR_Coverage, 7477,
     /* 159091 */     GIR_EraseRootFromParent_Done,
     /* 159092 */   // Label 2877: @159092
     /* 159092 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(159134), // Rule ID 7478 //
     /* 159097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159107 */     // MIs[0] Rn
     /* 159107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159119 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 159122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159132 */     GIR_RootConstrainSelectedInstOperands,
     /* 159133 */     // GIR_Coverage, 7478,
     /* 159133 */     GIR_EraseRootFromParent_Done,
     /* 159134 */   // Label 2878: @159134
     /* 159134 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(159176), // Rule ID 7479 //
     /* 159139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159149 */     // MIs[0] Rn
     /* 159149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159161 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 159164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159174 */     GIR_RootConstrainSelectedInstOperands,
     /* 159175 */     // GIR_Coverage, 7479,
     /* 159175 */     GIR_EraseRootFromParent_Done,
     /* 159176 */   // Label 2879: @159176
     /* 159176 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(159218), // Rule ID 7480 //
     /* 159181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159191 */     // MIs[0] Rn
     /* 159191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159203 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 159206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159216 */     GIR_RootConstrainSelectedInstOperands,
     /* 159217 */     // GIR_Coverage, 7480,
     /* 159217 */     GIR_EraseRootFromParent_Done,
     /* 159218 */   // Label 2880: @159218
     /* 159218 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(159260), // Rule ID 7481 //
     /* 159223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159233 */     // MIs[0] Rn
     /* 159233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159245 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 159248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159258 */     GIR_RootConstrainSelectedInstOperands,
     /* 159259 */     // GIR_Coverage, 7481,
     /* 159259 */     GIR_EraseRootFromParent_Done,
     /* 159260 */   // Label 2881: @159260
     /* 159260 */   GIM_Reject,
     /* 159261 */ // Label 2876: @159261
     /* 159261 */ GIM_Reject,
     /* 159262 */ // Label 2868: @159262
     /* 159262 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(159488),
     /* 159267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159277 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(159319), // Rule ID 7482 //
     /* 159282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159292 */     // MIs[0] Rn
     /* 159292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159304 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 159307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159317 */     GIR_RootConstrainSelectedInstOperands,
     /* 159318 */     // GIR_Coverage, 7482,
     /* 159318 */     GIR_EraseRootFromParent_Done,
     /* 159319 */   // Label 2883: @159319
     /* 159319 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(159361), // Rule ID 7483 //
     /* 159324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159334 */     // MIs[0] Rn
     /* 159334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159346 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 159349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159359 */     GIR_RootConstrainSelectedInstOperands,
     /* 159360 */     // GIR_Coverage, 7483,
     /* 159360 */     GIR_EraseRootFromParent_Done,
     /* 159361 */   // Label 2884: @159361
     /* 159361 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(159403), // Rule ID 7484 //
     /* 159366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159376 */     // MIs[0] Rn
     /* 159376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159388 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 159391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159401 */     GIR_RootConstrainSelectedInstOperands,
     /* 159402 */     // GIR_Coverage, 7484,
     /* 159402 */     GIR_EraseRootFromParent_Done,
     /* 159403 */   // Label 2885: @159403
     /* 159403 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(159445), // Rule ID 7485 //
     /* 159408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159418 */     // MIs[0] Rn
     /* 159418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159430 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159443 */     GIR_RootConstrainSelectedInstOperands,
     /* 159444 */     // GIR_Coverage, 7485,
     /* 159444 */     GIR_EraseRootFromParent_Done,
     /* 159445 */   // Label 2886: @159445
     /* 159445 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(159487), // Rule ID 7486 //
     /* 159450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159460 */     // MIs[0] Rn
     /* 159460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159472 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159485 */     GIR_RootConstrainSelectedInstOperands,
     /* 159486 */     // GIR_Coverage, 7486,
     /* 159486 */     GIR_EraseRootFromParent_Done,
     /* 159487 */   // Label 2887: @159487
     /* 159487 */   GIM_Reject,
     /* 159488 */ // Label 2882: @159488
     /* 159488 */ GIM_Reject,
     /* 159489 */ // Label 2869: @159489
     /* 159489 */ GIM_Reject,
     /* 159490 */ // Label 34: @159490
     /* 159490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2891*/ GIMT_Encode4(160194),
     /* 159501 */ /*GILLT_s16*//*Label 2888*/ GIMT_Encode4(159513),
     /* 159505 */ /*GILLT_s32*//*Label 2889*/ GIMT_Encode4(159740),
     /* 159509 */ /*GILLT_s64*//*Label 2890*/ GIMT_Encode4(159967),
     /* 159513 */ // Label 2888: @159513
     /* 159513 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(159739),
     /* 159518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159521 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159528 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(159570), // Rule ID 7487 //
     /* 159533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159543 */     // MIs[0] Rn
     /* 159543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159555 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 159558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159568 */     GIR_RootConstrainSelectedInstOperands,
     /* 159569 */     // GIR_Coverage, 7487,
     /* 159569 */     GIR_EraseRootFromParent_Done,
     /* 159570 */   // Label 2893: @159570
     /* 159570 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(159612), // Rule ID 7488 //
     /* 159575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159585 */     // MIs[0] Rn
     /* 159585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159597 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 159600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159610 */     GIR_RootConstrainSelectedInstOperands,
     /* 159611 */     // GIR_Coverage, 7488,
     /* 159611 */     GIR_EraseRootFromParent_Done,
     /* 159612 */   // Label 2894: @159612
     /* 159612 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(159654), // Rule ID 7489 //
     /* 159617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159627 */     // MIs[0] Rn
     /* 159627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159639 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 159642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159652 */     GIR_RootConstrainSelectedInstOperands,
     /* 159653 */     // GIR_Coverage, 7489,
     /* 159653 */     GIR_EraseRootFromParent_Done,
     /* 159654 */   // Label 2895: @159654
     /* 159654 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(159696), // Rule ID 7490 //
     /* 159659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159669 */     // MIs[0] Rn
     /* 159669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159681 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159694 */     GIR_RootConstrainSelectedInstOperands,
     /* 159695 */     // GIR_Coverage, 7490,
     /* 159695 */     GIR_EraseRootFromParent_Done,
     /* 159696 */   // Label 2896: @159696
     /* 159696 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(159738), // Rule ID 7491 //
     /* 159701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159711 */     // MIs[0] Rn
     /* 159711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159723 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159736 */     GIR_RootConstrainSelectedInstOperands,
     /* 159737 */     // GIR_Coverage, 7491,
     /* 159737 */     GIR_EraseRootFromParent_Done,
     /* 159738 */   // Label 2897: @159738
     /* 159738 */   GIM_Reject,
     /* 159739 */ // Label 2892: @159739
     /* 159739 */ GIM_Reject,
     /* 159740 */ // Label 2889: @159740
     /* 159740 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(159966),
     /* 159745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159755 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(159797), // Rule ID 7492 //
     /* 159760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159770 */     // MIs[0] Rn
     /* 159770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159782 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 159785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159795 */     GIR_RootConstrainSelectedInstOperands,
     /* 159796 */     // GIR_Coverage, 7492,
     /* 159796 */     GIR_EraseRootFromParent_Done,
     /* 159797 */   // Label 2899: @159797
     /* 159797 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(159839), // Rule ID 7493 //
     /* 159802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159812 */     // MIs[0] Rn
     /* 159812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159824 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 159827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159837 */     GIR_RootConstrainSelectedInstOperands,
     /* 159838 */     // GIR_Coverage, 7493,
     /* 159838 */     GIR_EraseRootFromParent_Done,
     /* 159839 */   // Label 2900: @159839
     /* 159839 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(159881), // Rule ID 7494 //
     /* 159844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159847 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159854 */     // MIs[0] Rn
     /* 159854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159866 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 159869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159879 */     GIR_RootConstrainSelectedInstOperands,
     /* 159880 */     // GIR_Coverage, 7494,
     /* 159880 */     GIR_EraseRootFromParent_Done,
     /* 159881 */   // Label 2901: @159881
     /* 159881 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(159923), // Rule ID 7495 //
     /* 159886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159896 */     // MIs[0] Rn
     /* 159896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159908 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159921 */     GIR_RootConstrainSelectedInstOperands,
     /* 159922 */     // GIR_Coverage, 7495,
     /* 159922 */     GIR_EraseRootFromParent_Done,
     /* 159923 */   // Label 2902: @159923
     /* 159923 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(159965), // Rule ID 7496 //
     /* 159928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159938 */     // MIs[0] Rn
     /* 159938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159950 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159963 */     GIR_RootConstrainSelectedInstOperands,
     /* 159964 */     // GIR_Coverage, 7496,
     /* 159964 */     GIR_EraseRootFromParent_Done,
     /* 159965 */   // Label 2903: @159965
     /* 159965 */   GIM_Reject,
     /* 159966 */ // Label 2898: @159966
     /* 159966 */ GIM_Reject,
     /* 159967 */ // Label 2890: @159967
     /* 159967 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(160193),
     /* 159972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159982 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(160024), // Rule ID 7497 //
     /* 159987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159997 */     // MIs[0] Rn
     /* 159997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160009 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 160012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160022 */     GIR_RootConstrainSelectedInstOperands,
     /* 160023 */     // GIR_Coverage, 7497,
     /* 160023 */     GIR_EraseRootFromParent_Done,
     /* 160024 */   // Label 2905: @160024
     /* 160024 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(160066), // Rule ID 7498 //
     /* 160029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160039 */     // MIs[0] Rn
     /* 160039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160051 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 160054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160064 */     GIR_RootConstrainSelectedInstOperands,
     /* 160065 */     // GIR_Coverage, 7498,
     /* 160065 */     GIR_EraseRootFromParent_Done,
     /* 160066 */   // Label 2906: @160066
     /* 160066 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(160108), // Rule ID 7499 //
     /* 160071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160081 */     // MIs[0] Rn
     /* 160081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160093 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 160096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160106 */     GIR_RootConstrainSelectedInstOperands,
     /* 160107 */     // GIR_Coverage, 7499,
     /* 160107 */     GIR_EraseRootFromParent_Done,
     /* 160108 */   // Label 2907: @160108
     /* 160108 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(160150), // Rule ID 7500 //
     /* 160113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160123 */     // MIs[0] Rn
     /* 160123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160135 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 160138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160148 */     GIR_RootConstrainSelectedInstOperands,
     /* 160149 */     // GIR_Coverage, 7500,
     /* 160149 */     GIR_EraseRootFromParent_Done,
     /* 160150 */   // Label 2908: @160150
     /* 160150 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(160192), // Rule ID 7501 //
     /* 160155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160165 */     // MIs[0] Rn
     /* 160165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160177 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 160180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160190 */     GIR_RootConstrainSelectedInstOperands,
     /* 160191 */     // GIR_Coverage, 7501,
     /* 160191 */     GIR_EraseRootFromParent_Done,
     /* 160192 */   // Label 2909: @160192
     /* 160192 */   GIM_Reject,
     /* 160193 */ // Label 2904: @160193
     /* 160193 */ GIM_Reject,
     /* 160194 */ // Label 2891: @160194
     /* 160194 */ GIM_Reject,
     /* 160195 */ // Label 35: @160195
     /* 160195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2913*/ GIMT_Encode4(160899),
     /* 160206 */ /*GILLT_s16*//*Label 2910*/ GIMT_Encode4(160218),
     /* 160210 */ /*GILLT_s32*//*Label 2911*/ GIMT_Encode4(160445),
     /* 160214 */ /*GILLT_s64*//*Label 2912*/ GIMT_Encode4(160672),
     /* 160218 */ // Label 2910: @160218
     /* 160218 */ GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(160444),
     /* 160223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 160233 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(160275), // Rule ID 7502 //
     /* 160238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160248 */     // MIs[0] Rn
     /* 160248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160260 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 160263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160273 */     GIR_RootConstrainSelectedInstOperands,
     /* 160274 */     // GIR_Coverage, 7502,
     /* 160274 */     GIR_EraseRootFromParent_Done,
     /* 160275 */   // Label 2915: @160275
     /* 160275 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(160317), // Rule ID 7503 //
     /* 160280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160290 */     // MIs[0] Rn
     /* 160290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160302 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 160305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160315 */     GIR_RootConstrainSelectedInstOperands,
     /* 160316 */     // GIR_Coverage, 7503,
     /* 160316 */     GIR_EraseRootFromParent_Done,
     /* 160317 */   // Label 2916: @160317
     /* 160317 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(160359), // Rule ID 7504 //
     /* 160322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160332 */     // MIs[0] Rn
     /* 160332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160344 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 160347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160357 */     GIR_RootConstrainSelectedInstOperands,
     /* 160358 */     // GIR_Coverage, 7504,
     /* 160358 */     GIR_EraseRootFromParent_Done,
     /* 160359 */   // Label 2917: @160359
     /* 160359 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(160401), // Rule ID 7505 //
     /* 160364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160374 */     // MIs[0] Rn
     /* 160374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160386 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160399 */     GIR_RootConstrainSelectedInstOperands,
     /* 160400 */     // GIR_Coverage, 7505,
     /* 160400 */     GIR_EraseRootFromParent_Done,
     /* 160401 */   // Label 2918: @160401
     /* 160401 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(160443), // Rule ID 7506 //
     /* 160406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160416 */     // MIs[0] Rn
     /* 160416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160428 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160441 */     GIR_RootConstrainSelectedInstOperands,
     /* 160442 */     // GIR_Coverage, 7506,
     /* 160442 */     GIR_EraseRootFromParent_Done,
     /* 160443 */   // Label 2919: @160443
     /* 160443 */   GIM_Reject,
     /* 160444 */ // Label 2914: @160444
     /* 160444 */ GIM_Reject,
     /* 160445 */ // Label 2911: @160445
     /* 160445 */ GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(160671),
     /* 160450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160453 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160460 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(160502), // Rule ID 7507 //
     /* 160465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160475 */     // MIs[0] Rn
     /* 160475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160487 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 160490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160500 */     GIR_RootConstrainSelectedInstOperands,
     /* 160501 */     // GIR_Coverage, 7507,
     /* 160501 */     GIR_EraseRootFromParent_Done,
     /* 160502 */   // Label 2921: @160502
     /* 160502 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(160544), // Rule ID 7508 //
     /* 160507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160510 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160517 */     // MIs[0] Rn
     /* 160517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160529 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 160532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160542 */     GIR_RootConstrainSelectedInstOperands,
     /* 160543 */     // GIR_Coverage, 7508,
     /* 160543 */     GIR_EraseRootFromParent_Done,
     /* 160544 */   // Label 2922: @160544
     /* 160544 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(160586), // Rule ID 7509 //
     /* 160549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160559 */     // MIs[0] Rn
     /* 160559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160571 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 160574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160584 */     GIR_RootConstrainSelectedInstOperands,
     /* 160585 */     // GIR_Coverage, 7509,
     /* 160585 */     GIR_EraseRootFromParent_Done,
     /* 160586 */   // Label 2923: @160586
     /* 160586 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(160628), // Rule ID 7510 //
     /* 160591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160601 */     // MIs[0] Rn
     /* 160601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160613 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160626 */     GIR_RootConstrainSelectedInstOperands,
     /* 160627 */     // GIR_Coverage, 7510,
     /* 160627 */     GIR_EraseRootFromParent_Done,
     /* 160628 */   // Label 2924: @160628
     /* 160628 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(160670), // Rule ID 7511 //
     /* 160633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160643 */     // MIs[0] Rn
     /* 160643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160655 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160668 */     GIR_RootConstrainSelectedInstOperands,
     /* 160669 */     // GIR_Coverage, 7511,
     /* 160669 */     GIR_EraseRootFromParent_Done,
     /* 160670 */   // Label 2925: @160670
     /* 160670 */   GIM_Reject,
     /* 160671 */ // Label 2920: @160671
     /* 160671 */ GIM_Reject,
     /* 160672 */ // Label 2912: @160672
     /* 160672 */ GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(160898),
     /* 160677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 160687 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(160729), // Rule ID 7512 //
     /* 160692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160702 */     // MIs[0] Rn
     /* 160702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160714 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 160717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160727 */     GIR_RootConstrainSelectedInstOperands,
     /* 160728 */     // GIR_Coverage, 7512,
     /* 160728 */     GIR_EraseRootFromParent_Done,
     /* 160729 */   // Label 2927: @160729
     /* 160729 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(160771), // Rule ID 7513 //
     /* 160734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160744 */     // MIs[0] Rn
     /* 160744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160756 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 160759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160769 */     GIR_RootConstrainSelectedInstOperands,
     /* 160770 */     // GIR_Coverage, 7513,
     /* 160770 */     GIR_EraseRootFromParent_Done,
     /* 160771 */   // Label 2928: @160771
     /* 160771 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(160813), // Rule ID 7514 //
     /* 160776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160786 */     // MIs[0] Rn
     /* 160786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160798 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 160801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160811 */     GIR_RootConstrainSelectedInstOperands,
     /* 160812 */     // GIR_Coverage, 7514,
     /* 160812 */     GIR_EraseRootFromParent_Done,
     /* 160813 */   // Label 2929: @160813
     /* 160813 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(160855), // Rule ID 7515 //
     /* 160818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160828 */     // MIs[0] Rn
     /* 160828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160840 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160853 */     GIR_RootConstrainSelectedInstOperands,
     /* 160854 */     // GIR_Coverage, 7515,
     /* 160854 */     GIR_EraseRootFromParent_Done,
     /* 160855 */   // Label 2930: @160855
     /* 160855 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(160897), // Rule ID 7516 //
     /* 160860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160870 */     // MIs[0] Rn
     /* 160870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160882 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160895 */     GIR_RootConstrainSelectedInstOperands,
     /* 160896 */     // GIR_Coverage, 7516,
     /* 160896 */     GIR_EraseRootFromParent_Done,
     /* 160897 */   // Label 2931: @160897
     /* 160897 */   GIM_Reject,
     /* 160898 */ // Label 2926: @160898
     /* 160898 */ GIM_Reject,
     /* 160899 */ // Label 2913: @160899
     /* 160899 */ GIM_Reject,
     /* 160900 */ // Label 36: @160900
     /* 160900 */ GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(160927), // Rule ID 7102 //
     /* 160905 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160908 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 160912 */   // MIs[0] Operand 1
     /* 160912 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160915 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 160915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160925 */   GIR_RootConstrainSelectedInstOperands,
     /* 160926 */   // GIR_Coverage, 7102,
     /* 160926 */   GIR_EraseRootFromParent_Done,
     /* 160927 */ // Label 2932: @160927
     /* 160927 */ GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160950), // Rule ID 7103 //
     /* 160932 */   // MIs[0] Operand 0
     /* 160932 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 160935 */   // MIs[0] Operand 1
     /* 160935 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160938 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 160938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 160944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160948 */   GIR_RootConstrainSelectedInstOperands,
     /* 160949 */   // GIR_Coverage, 7103,
     /* 160949 */   GIR_EraseRootFromParent_Done,
     /* 160950 */ // Label 2933: @160950
     /* 160950 */ GIM_Reject,
     /* 160951 */ // Label 37: @160951
     /* 160951 */ GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(173478),
     /* 160956 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 160959 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(161050), // Rule ID 6575 //
     /* 160964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 160972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160990 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160993 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 160998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161002 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161018 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 161018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 161021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 161025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 161034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 161038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161048 */     GIR_RootConstrainSelectedInstOperands,
     /* 161049 */     // GIR_Coverage, 6575,
     /* 161049 */     GIR_EraseRootFromParent_Done,
     /* 161050 */   // Label 2935: @161050
     /* 161050 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(161141), // Rule ID 6576 //
     /* 161055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 161058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 161063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 161081 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 161084 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 161089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161093 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161109 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 161109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 161112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 161116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 161125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 161129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 161134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161139 */     GIR_RootConstrainSelectedInstOperands,
     /* 161140 */     // GIR_Coverage, 6576,
     /* 161140 */     GIR_EraseRootFromParent_Done,
     /* 161141 */   // Label 2936: @161141
     /* 161141 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(161202), // Rule ID 4967 //
     /* 161146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 161151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 161169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161178 */     // MIs[1] Operand 2
     /* 161178 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 161189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161191 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 161191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 161194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 161200 */     GIR_RootConstrainSelectedInstOperands,
     /* 161201 */     // GIR_Coverage, 4967,
     /* 161201 */     GIR_EraseRootFromParent_Done,
     /* 161202 */   // Label 2937: @161202
     /* 161202 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(161242), // Rule ID 2651 //
     /* 161207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 161210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 161215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161222 */     // MIs[0] pattern
     /* 161222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 161225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 161230 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 161230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 161233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161235 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 161237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 161240 */     GIR_RootConstrainSelectedInstOperands,
     /* 161241 */     // GIR_Coverage, 2651,
     /* 161241 */     GIR_EraseRootFromParent_Done,
     /* 161242 */   // Label 2938: @161242
     /* 161242 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(161282), // Rule ID 10048 //
     /* 161247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 161250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 161255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161262 */     // MIs[0] pattern
     /* 161262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 161265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 161270 */     // (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 161270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 161273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161275 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 161277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 161280 */     GIR_RootConstrainSelectedInstOperands,
     /* 161281 */     // GIR_Coverage, 10048,
     /* 161281 */     GIR_EraseRootFromParent_Done,
     /* 161282 */   // Label 2939: @161282
     /* 161282 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(161322), // Rule ID 10051 //
     /* 161287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 161290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 161295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161302 */     // MIs[0] pattern
     /* 161302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 161305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 161310 */     // (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 161310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 161313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161315 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 161317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 161320 */     GIR_RootConstrainSelectedInstOperands,
     /* 161321 */     // GIR_Coverage, 10051,
     /* 161321 */     GIR_EraseRootFromParent_Done,
     /* 161322 */   // Label 2940: @161322
     /* 161322 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(161362), // Rule ID 10054 //
     /* 161327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 161330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 161335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161342 */     // MIs[0] pattern
     /* 161342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 161345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 161350 */     // (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 161350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 161353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161355 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 161357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 161360 */     GIR_RootConstrainSelectedInstOperands,
     /* 161361 */     // GIR_Coverage, 10054,
     /* 161361 */     GIR_EraseRootFromParent_Done,
     /* 161362 */   // Label 2941: @161362
     /* 161362 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(161401), // Rule ID 66 //
     /* 161367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 161370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 161375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161389 */     // (intrinsic_wo_chain:{ *:[i32] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 161392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 161399 */     GIR_RootConstrainSelectedInstOperands,
     /* 161400 */     // GIR_Coverage, 66,
     /* 161400 */     GIR_EraseRootFromParent_Done,
     /* 161401 */   // Label 2942: @161401
     /* 161401 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(161437), // Rule ID 350 //
     /* 161406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161428 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 161431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161435 */     GIR_RootConstrainSelectedInstOperands,
     /* 161436 */     // GIR_Coverage, 350,
     /* 161436 */     GIR_EraseRootFromParent_Done,
     /* 161437 */   // Label 2943: @161437
     /* 161437 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(161473), // Rule ID 351 //
     /* 161442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161464 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 161467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161471 */     GIR_RootConstrainSelectedInstOperands,
     /* 161472 */     // GIR_Coverage, 351,
     /* 161472 */     GIR_EraseRootFromParent_Done,
     /* 161473 */   // Label 2944: @161473
     /* 161473 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(161509), // Rule ID 352 //
     /* 161478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161500 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 161503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161507 */     GIR_RootConstrainSelectedInstOperands,
     /* 161508 */     // GIR_Coverage, 352,
     /* 161508 */     GIR_EraseRootFromParent_Done,
     /* 161509 */   // Label 2945: @161509
     /* 161509 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(161545), // Rule ID 353 //
     /* 161514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161536 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 161539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161543 */     GIR_RootConstrainSelectedInstOperands,
     /* 161544 */     // GIR_Coverage, 353,
     /* 161544 */     GIR_EraseRootFromParent_Done,
     /* 161545 */   // Label 2946: @161545
     /* 161545 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(161581), // Rule ID 354 //
     /* 161550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161572 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 161575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161579 */     GIR_RootConstrainSelectedInstOperands,
     /* 161580 */     // GIR_Coverage, 354,
     /* 161580 */     GIR_EraseRootFromParent_Done,
     /* 161581 */   // Label 2947: @161581
     /* 161581 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(161617), // Rule ID 355 //
     /* 161586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161608 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 161611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161615 */     GIR_RootConstrainSelectedInstOperands,
     /* 161616 */     // GIR_Coverage, 355,
     /* 161616 */     GIR_EraseRootFromParent_Done,
     /* 161617 */   // Label 2948: @161617
     /* 161617 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(161653), // Rule ID 356 //
     /* 161622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161644 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 161647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161651 */     GIR_RootConstrainSelectedInstOperands,
     /* 161652 */     // GIR_Coverage, 356,
     /* 161652 */     GIR_EraseRootFromParent_Done,
     /* 161653 */   // Label 2949: @161653
     /* 161653 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(161689), // Rule ID 357 //
     /* 161658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161680 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 161683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161687 */     GIR_RootConstrainSelectedInstOperands,
     /* 161688 */     // GIR_Coverage, 357,
     /* 161688 */     GIR_EraseRootFromParent_Done,
     /* 161689 */   // Label 2950: @161689
     /* 161689 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(161725), // Rule ID 358 //
     /* 161694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161716 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 161719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161723 */     GIR_RootConstrainSelectedInstOperands,
     /* 161724 */     // GIR_Coverage, 358,
     /* 161724 */     GIR_EraseRootFromParent_Done,
     /* 161725 */   // Label 2951: @161725
     /* 161725 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(161761), // Rule ID 359 //
     /* 161730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161752 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 161755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161759 */     GIR_RootConstrainSelectedInstOperands,
     /* 161760 */     // GIR_Coverage, 359,
     /* 161760 */     GIR_EraseRootFromParent_Done,
     /* 161761 */   // Label 2952: @161761
     /* 161761 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(161797), // Rule ID 360 //
     /* 161766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161788 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 161791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161795 */     GIR_RootConstrainSelectedInstOperands,
     /* 161796 */     // GIR_Coverage, 360,
     /* 161796 */     GIR_EraseRootFromParent_Done,
     /* 161797 */   // Label 2953: @161797
     /* 161797 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(161833), // Rule ID 361 //
     /* 161802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161824 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 161827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161831 */     GIR_RootConstrainSelectedInstOperands,
     /* 161832 */     // GIR_Coverage, 361,
     /* 161832 */     GIR_EraseRootFromParent_Done,
     /* 161833 */   // Label 2954: @161833
     /* 161833 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(161869), // Rule ID 362 //
     /* 161838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161860 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 161863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161867 */     GIR_RootConstrainSelectedInstOperands,
     /* 161868 */     // GIR_Coverage, 362,
     /* 161868 */     GIR_EraseRootFromParent_Done,
     /* 161869 */   // Label 2955: @161869
     /* 161869 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(161905), // Rule ID 363 //
     /* 161874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161896 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 161899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161903 */     GIR_RootConstrainSelectedInstOperands,
     /* 161904 */     // GIR_Coverage, 363,
     /* 161904 */     GIR_EraseRootFromParent_Done,
     /* 161905 */   // Label 2956: @161905
     /* 161905 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(161941), // Rule ID 364 //
     /* 161910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161932 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 161935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161939 */     GIR_RootConstrainSelectedInstOperands,
     /* 161940 */     // GIR_Coverage, 364,
     /* 161940 */     GIR_EraseRootFromParent_Done,
     /* 161941 */   // Label 2957: @161941
     /* 161941 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(161977), // Rule ID 365 //
     /* 161946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161968 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 161971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161975 */     GIR_RootConstrainSelectedInstOperands,
     /* 161976 */     // GIR_Coverage, 365,
     /* 161976 */     GIR_EraseRootFromParent_Done,
     /* 161977 */   // Label 2958: @161977
     /* 161977 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(162013), // Rule ID 366 //
     /* 161982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162004 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 162007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162011 */     GIR_RootConstrainSelectedInstOperands,
     /* 162012 */     // GIR_Coverage, 366,
     /* 162012 */     GIR_EraseRootFromParent_Done,
     /* 162013 */   // Label 2959: @162013
     /* 162013 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(162049), // Rule ID 367 //
     /* 162018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162040 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 162043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162047 */     GIR_RootConstrainSelectedInstOperands,
     /* 162048 */     // GIR_Coverage, 367,
     /* 162048 */     GIR_EraseRootFromParent_Done,
     /* 162049 */   // Label 2960: @162049
     /* 162049 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(162085), // Rule ID 368 //
     /* 162054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162076 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 162079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162083 */     GIR_RootConstrainSelectedInstOperands,
     /* 162084 */     // GIR_Coverage, 368,
     /* 162084 */     GIR_EraseRootFromParent_Done,
     /* 162085 */   // Label 2961: @162085
     /* 162085 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(162121), // Rule ID 369 //
     /* 162090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162112 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 162115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162119 */     GIR_RootConstrainSelectedInstOperands,
     /* 162120 */     // GIR_Coverage, 369,
     /* 162120 */     GIR_EraseRootFromParent_Done,
     /* 162121 */   // Label 2962: @162121
     /* 162121 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(162157), // Rule ID 370 //
     /* 162126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162148 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 162151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162155 */     GIR_RootConstrainSelectedInstOperands,
     /* 162156 */     // GIR_Coverage, 370,
     /* 162156 */     GIR_EraseRootFromParent_Done,
     /* 162157 */   // Label 2963: @162157
     /* 162157 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(162193), // Rule ID 371 //
     /* 162162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162184 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 162187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162191 */     GIR_RootConstrainSelectedInstOperands,
     /* 162192 */     // GIR_Coverage, 371,
     /* 162192 */     GIR_EraseRootFromParent_Done,
     /* 162193 */   // Label 2964: @162193
     /* 162193 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(162229), // Rule ID 372 //
     /* 162198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162220 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 162223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162227 */     GIR_RootConstrainSelectedInstOperands,
     /* 162228 */     // GIR_Coverage, 372,
     /* 162228 */     GIR_EraseRootFromParent_Done,
     /* 162229 */   // Label 2965: @162229
     /* 162229 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(162265), // Rule ID 373 //
     /* 162234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162256 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 162259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162263 */     GIR_RootConstrainSelectedInstOperands,
     /* 162264 */     // GIR_Coverage, 373,
     /* 162264 */     GIR_EraseRootFromParent_Done,
     /* 162265 */   // Label 2966: @162265
     /* 162265 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(162301), // Rule ID 374 //
     /* 162270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162292 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 162295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162299 */     GIR_RootConstrainSelectedInstOperands,
     /* 162300 */     // GIR_Coverage, 374,
     /* 162300 */     GIR_EraseRootFromParent_Done,
     /* 162301 */   // Label 2967: @162301
     /* 162301 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(162337), // Rule ID 375 //
     /* 162306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162328 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 162331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162335 */     GIR_RootConstrainSelectedInstOperands,
     /* 162336 */     // GIR_Coverage, 375,
     /* 162336 */     GIR_EraseRootFromParent_Done,
     /* 162337 */   // Label 2968: @162337
     /* 162337 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(162373), // Rule ID 376 //
     /* 162342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162364 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 162367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162371 */     GIR_RootConstrainSelectedInstOperands,
     /* 162372 */     // GIR_Coverage, 376,
     /* 162372 */     GIR_EraseRootFromParent_Done,
     /* 162373 */   // Label 2969: @162373
     /* 162373 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(162409), // Rule ID 377 //
     /* 162378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162400 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 162403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162407 */     GIR_RootConstrainSelectedInstOperands,
     /* 162408 */     // GIR_Coverage, 377,
     /* 162408 */     GIR_EraseRootFromParent_Done,
     /* 162409 */   // Label 2970: @162409
     /* 162409 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(162445), // Rule ID 378 //
     /* 162414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162436 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 162439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162443 */     GIR_RootConstrainSelectedInstOperands,
     /* 162444 */     // GIR_Coverage, 378,
     /* 162444 */     GIR_EraseRootFromParent_Done,
     /* 162445 */   // Label 2971: @162445
     /* 162445 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(162481), // Rule ID 379 //
     /* 162450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162472 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 162475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162479 */     GIR_RootConstrainSelectedInstOperands,
     /* 162480 */     // GIR_Coverage, 379,
     /* 162480 */     GIR_EraseRootFromParent_Done,
     /* 162481 */   // Label 2972: @162481
     /* 162481 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(162517), // Rule ID 380 //
     /* 162486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162508 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 162511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162515 */     GIR_RootConstrainSelectedInstOperands,
     /* 162516 */     // GIR_Coverage, 380,
     /* 162516 */     GIR_EraseRootFromParent_Done,
     /* 162517 */   // Label 2973: @162517
     /* 162517 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(162553), // Rule ID 381 //
     /* 162522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162544 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 162547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162551 */     GIR_RootConstrainSelectedInstOperands,
     /* 162552 */     // GIR_Coverage, 381,
     /* 162552 */     GIR_EraseRootFromParent_Done,
     /* 162553 */   // Label 2974: @162553
     /* 162553 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(162589), // Rule ID 382 //
     /* 162558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162580 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 162583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162587 */     GIR_RootConstrainSelectedInstOperands,
     /* 162588 */     // GIR_Coverage, 382,
     /* 162588 */     GIR_EraseRootFromParent_Done,
     /* 162589 */   // Label 2975: @162589
     /* 162589 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(162625), // Rule ID 383 //
     /* 162594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162616 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 162619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162623 */     GIR_RootConstrainSelectedInstOperands,
     /* 162624 */     // GIR_Coverage, 383,
     /* 162624 */     GIR_EraseRootFromParent_Done,
     /* 162625 */   // Label 2976: @162625
     /* 162625 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(162661), // Rule ID 384 //
     /* 162630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162652 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 162655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162659 */     GIR_RootConstrainSelectedInstOperands,
     /* 162660 */     // GIR_Coverage, 384,
     /* 162660 */     GIR_EraseRootFromParent_Done,
     /* 162661 */   // Label 2977: @162661
     /* 162661 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(162697), // Rule ID 385 //
     /* 162666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162688 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 162691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162695 */     GIR_RootConstrainSelectedInstOperands,
     /* 162696 */     // GIR_Coverage, 385,
     /* 162696 */     GIR_EraseRootFromParent_Done,
     /* 162697 */   // Label 2978: @162697
     /* 162697 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(162733), // Rule ID 386 //
     /* 162702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162724 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 162727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162731 */     GIR_RootConstrainSelectedInstOperands,
     /* 162732 */     // GIR_Coverage, 386,
     /* 162732 */     GIR_EraseRootFromParent_Done,
     /* 162733 */   // Label 2979: @162733
     /* 162733 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(162769), // Rule ID 387 //
     /* 162738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162760 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 162763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162767 */     GIR_RootConstrainSelectedInstOperands,
     /* 162768 */     // GIR_Coverage, 387,
     /* 162768 */     GIR_EraseRootFromParent_Done,
     /* 162769 */   // Label 2980: @162769
     /* 162769 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(162805), // Rule ID 388 //
     /* 162774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162796 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 162799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162803 */     GIR_RootConstrainSelectedInstOperands,
     /* 162804 */     // GIR_Coverage, 388,
     /* 162804 */     GIR_EraseRootFromParent_Done,
     /* 162805 */   // Label 2981: @162805
     /* 162805 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(162841), // Rule ID 389 //
     /* 162810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162832 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 162835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162839 */     GIR_RootConstrainSelectedInstOperands,
     /* 162840 */     // GIR_Coverage, 389,
     /* 162840 */     GIR_EraseRootFromParent_Done,
     /* 162841 */   // Label 2982: @162841
     /* 162841 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(162877), // Rule ID 390 //
     /* 162846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162868 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 162871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162875 */     GIR_RootConstrainSelectedInstOperands,
     /* 162876 */     // GIR_Coverage, 390,
     /* 162876 */     GIR_EraseRootFromParent_Done,
     /* 162877 */   // Label 2983: @162877
     /* 162877 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(162913), // Rule ID 391 //
     /* 162882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162904 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 162907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162911 */     GIR_RootConstrainSelectedInstOperands,
     /* 162912 */     // GIR_Coverage, 391,
     /* 162912 */     GIR_EraseRootFromParent_Done,
     /* 162913 */   // Label 2984: @162913
     /* 162913 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(162949), // Rule ID 392 //
     /* 162918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162940 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 162943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162947 */     GIR_RootConstrainSelectedInstOperands,
     /* 162948 */     // GIR_Coverage, 392,
     /* 162948 */     GIR_EraseRootFromParent_Done,
     /* 162949 */   // Label 2985: @162949
     /* 162949 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(162985), // Rule ID 393 //
     /* 162954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162976 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 162979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162983 */     GIR_RootConstrainSelectedInstOperands,
     /* 162984 */     // GIR_Coverage, 393,
     /* 162984 */     GIR_EraseRootFromParent_Done,
     /* 162985 */   // Label 2986: @162985
     /* 162985 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(163021), // Rule ID 394 //
     /* 162990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163012 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 163012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 163015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163019 */     GIR_RootConstrainSelectedInstOperands,
     /* 163020 */     // GIR_Coverage, 394,
     /* 163020 */     GIR_EraseRootFromParent_Done,
     /* 163021 */   // Label 2987: @163021
     /* 163021 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(163057), // Rule ID 395 //
     /* 163026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 163029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163048 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 163048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 163051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163055 */     GIR_RootConstrainSelectedInstOperands,
     /* 163056 */     // GIR_Coverage, 395,
     /* 163056 */     GIR_EraseRootFromParent_Done,
     /* 163057 */   // Label 2988: @163057
     /* 163057 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(163093), // Rule ID 396 //
     /* 163062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 163065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 163080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163084 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 163084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 163087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163091 */     GIR_RootConstrainSelectedInstOperands,
     /* 163092 */     // GIR_Coverage, 396,
     /* 163092 */     GIR_EraseRootFromParent_Done,
     /* 163093 */   // Label 2989: @163093
     /* 163093 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(163129), // Rule ID 397 //
     /* 163098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 163101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163120 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 163120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 163123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163127 */     GIR_RootConstrainSelectedInstOperands,
     /* 163128 */     // GIR_Coverage, 397,
     /* 163128 */     GIR_EraseRootFromParent_Done,
     /* 163129 */   // Label 2990: @163129
     /* 163129 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(163165), // Rule ID 579 //
     /* 163134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 163142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163156 */     // (intrinsic_wo_chain:{ *:[f32] } 558:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 163156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 163159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163163 */     GIR_RootConstrainSelectedInstOperands,
     /* 163164 */     // GIR_Coverage, 579,
     /* 163164 */     GIR_EraseRootFromParent_Done,
     /* 163165 */   // Label 2991: @163165
     /* 163165 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(163201), // Rule ID 580 //
     /* 163170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 163178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163192 */     // (intrinsic_wo_chain:{ *:[f64] } 558:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 163195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163199 */     GIR_RootConstrainSelectedInstOperands,
     /* 163200 */     // GIR_Coverage, 580,
     /* 163200 */     GIR_EraseRootFromParent_Done,
     /* 163201 */   // Label 2992: @163201
     /* 163201 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(163237), // Rule ID 581 //
     /* 163206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 163214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163228 */     // (intrinsic_wo_chain:{ *:[f32] } 560:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 163228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 163231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163235 */     GIR_RootConstrainSelectedInstOperands,
     /* 163236 */     // GIR_Coverage, 581,
     /* 163236 */     GIR_EraseRootFromParent_Done,
     /* 163237 */   // Label 2993: @163237
     /* 163237 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(163273), // Rule ID 582 //
     /* 163242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 163250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163264 */     // (intrinsic_wo_chain:{ *:[f64] } 560:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 163267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163271 */     GIR_RootConstrainSelectedInstOperands,
     /* 163272 */     // GIR_Coverage, 582,
     /* 163272 */     GIR_EraseRootFromParent_Done,
     /* 163273 */   // Label 2994: @163273
     /* 163273 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(163309), // Rule ID 583 //
     /* 163278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 163286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163300 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 163300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 163303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163307 */     GIR_RootConstrainSelectedInstOperands,
     /* 163308 */     // GIR_Coverage, 583,
     /* 163308 */     GIR_EraseRootFromParent_Done,
     /* 163309 */   // Label 2995: @163309
     /* 163309 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(163345), // Rule ID 584 //
     /* 163314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 163322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163336 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 163339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163343 */     GIR_RootConstrainSelectedInstOperands,
     /* 163344 */     // GIR_Coverage, 584,
     /* 163344 */     GIR_EraseRootFromParent_Done,
     /* 163345 */   // Label 2996: @163345
     /* 163345 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(163381), // Rule ID 585 //
     /* 163350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 163358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163372 */     // (intrinsic_wo_chain:{ *:[f32] } 559:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 163372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 163375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163379 */     GIR_RootConstrainSelectedInstOperands,
     /* 163380 */     // GIR_Coverage, 585,
     /* 163380 */     GIR_EraseRootFromParent_Done,
     /* 163381 */   // Label 2997: @163381
     /* 163381 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(163417), // Rule ID 586 //
     /* 163386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 163394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163408 */     // (intrinsic_wo_chain:{ *:[f64] } 559:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 163411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163415 */     GIR_RootConstrainSelectedInstOperands,
     /* 163416 */     // GIR_Coverage, 586,
     /* 163416 */     GIR_EraseRootFromParent_Done,
     /* 163417 */   // Label 2998: @163417
     /* 163417 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(163453), // Rule ID 714 //
     /* 163422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163444 */     // (intrinsic_wo_chain:{ *:[v8i8] } 585:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 163444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 163447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163451 */     GIR_RootConstrainSelectedInstOperands,
     /* 163452 */     // GIR_Coverage, 714,
     /* 163452 */     GIR_EraseRootFromParent_Done,
     /* 163453 */   // Label 2999: @163453
     /* 163453 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(163489), // Rule ID 715 //
     /* 163458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 163469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163480 */     // (intrinsic_wo_chain:{ *:[v16i8] } 585:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 163480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 163483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163487 */     GIR_RootConstrainSelectedInstOperands,
     /* 163488 */     // GIR_Coverage, 715,
     /* 163488 */     GIR_EraseRootFromParent_Done,
     /* 163489 */   // Label 3000: @163489
     /* 163489 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(163525), // Rule ID 716 //
     /* 163494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 163516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 163519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163523 */     GIR_RootConstrainSelectedInstOperands,
     /* 163524 */     // GIR_Coverage, 716,
     /* 163524 */     GIR_EraseRootFromParent_Done,
     /* 163525 */   // Label 3001: @163525
     /* 163525 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(163561), // Rule ID 717 //
     /* 163530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 163552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 163555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163559 */     GIR_RootConstrainSelectedInstOperands,
     /* 163560 */     // GIR_Coverage, 717,
     /* 163560 */     GIR_EraseRootFromParent_Done,
     /* 163561 */   // Label 3002: @163561
     /* 163561 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(163597), // Rule ID 718 //
     /* 163566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 163588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 163591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163595 */     GIR_RootConstrainSelectedInstOperands,
     /* 163596 */     // GIR_Coverage, 718,
     /* 163596 */     GIR_EraseRootFromParent_Done,
     /* 163597 */   // Label 3003: @163597
     /* 163597 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(163633), // Rule ID 719 //
     /* 163602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 163624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 163627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163631 */     GIR_RootConstrainSelectedInstOperands,
     /* 163632 */     // GIR_Coverage, 719,
     /* 163632 */     GIR_EraseRootFromParent_Done,
     /* 163633 */   // Label 3004: @163633
     /* 163633 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(163669), // Rule ID 800 //
     /* 163638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163660 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 163663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163667 */     GIR_RootConstrainSelectedInstOperands,
     /* 163668 */     // GIR_Coverage, 800,
     /* 163668 */     GIR_EraseRootFromParent_Done,
     /* 163669 */   // Label 3005: @163669
     /* 163669 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(163705), // Rule ID 801 //
     /* 163674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163696 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 163699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163703 */     GIR_RootConstrainSelectedInstOperands,
     /* 163704 */     // GIR_Coverage, 801,
     /* 163704 */     GIR_EraseRootFromParent_Done,
     /* 163705 */   // Label 3006: @163705
     /* 163705 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(163741), // Rule ID 802 //
     /* 163710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163732 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 163735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163739 */     GIR_RootConstrainSelectedInstOperands,
     /* 163740 */     // GIR_Coverage, 802,
     /* 163740 */     GIR_EraseRootFromParent_Done,
     /* 163741 */   // Label 3007: @163741
     /* 163741 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(163777), // Rule ID 803 //
     /* 163746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 163771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163775 */     GIR_RootConstrainSelectedInstOperands,
     /* 163776 */     // GIR_Coverage, 803,
     /* 163776 */     GIR_EraseRootFromParent_Done,
     /* 163777 */   // Label 3008: @163777
     /* 163777 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(163813), // Rule ID 804 //
     /* 163782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163804 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 163807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163811 */     GIR_RootConstrainSelectedInstOperands,
     /* 163812 */     // GIR_Coverage, 804,
     /* 163812 */     GIR_EraseRootFromParent_Done,
     /* 163813 */   // Label 3009: @163813
     /* 163813 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(163849), // Rule ID 805 //
     /* 163818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 163843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163847 */     GIR_RootConstrainSelectedInstOperands,
     /* 163848 */     // GIR_Coverage, 805,
     /* 163848 */     GIR_EraseRootFromParent_Done,
     /* 163849 */   // Label 3010: @163849
     /* 163849 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(163885), // Rule ID 806 //
     /* 163854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163876 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 163879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163883 */     GIR_RootConstrainSelectedInstOperands,
     /* 163884 */     // GIR_Coverage, 806,
     /* 163884 */     GIR_EraseRootFromParent_Done,
     /* 163885 */   // Label 3011: @163885
     /* 163885 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(163921), // Rule ID 807 //
     /* 163890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 163915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163919 */     GIR_RootConstrainSelectedInstOperands,
     /* 163920 */     // GIR_Coverage, 807,
     /* 163920 */     GIR_EraseRootFromParent_Done,
     /* 163921 */   // Label 3012: @163921
     /* 163921 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(163957), // Rule ID 808 //
     /* 163926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 163951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163955 */     GIR_RootConstrainSelectedInstOperands,
     /* 163956 */     // GIR_Coverage, 808,
     /* 163956 */     GIR_EraseRootFromParent_Done,
     /* 163957 */   // Label 3013: @163957
     /* 163957 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(163993), // Rule ID 809 //
     /* 163962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163984 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 163987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163991 */     GIR_RootConstrainSelectedInstOperands,
     /* 163992 */     // GIR_Coverage, 809,
     /* 163992 */     GIR_EraseRootFromParent_Done,
     /* 163993 */   // Label 3014: @163993
     /* 163993 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(164029), // Rule ID 810 //
     /* 163998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 164006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164020 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 164023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164027 */     GIR_RootConstrainSelectedInstOperands,
     /* 164028 */     // GIR_Coverage, 810,
     /* 164028 */     GIR_EraseRootFromParent_Done,
     /* 164029 */   // Label 3015: @164029
     /* 164029 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(164065), // Rule ID 811 //
     /* 164034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 164042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 164059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164063 */     GIR_RootConstrainSelectedInstOperands,
     /* 164064 */     // GIR_Coverage, 811,
     /* 164064 */     GIR_EraseRootFromParent_Done,
     /* 164065 */   // Label 3016: @164065
     /* 164065 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(164101), // Rule ID 812 //
     /* 164070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 164078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164092 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 164095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164099 */     GIR_RootConstrainSelectedInstOperands,
     /* 164100 */     // GIR_Coverage, 812,
     /* 164100 */     GIR_EraseRootFromParent_Done,
     /* 164101 */   // Label 3017: @164101
     /* 164101 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(164137), // Rule ID 813 //
     /* 164106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 164114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 164131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164135 */     GIR_RootConstrainSelectedInstOperands,
     /* 164136 */     // GIR_Coverage, 813,
     /* 164136 */     GIR_EraseRootFromParent_Done,
     /* 164137 */   // Label 3018: @164137
     /* 164137 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(164173), // Rule ID 814 //
     /* 164142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 164150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 164167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164171 */     GIR_RootConstrainSelectedInstOperands,
     /* 164172 */     // GIR_Coverage, 814,
     /* 164172 */     GIR_EraseRootFromParent_Done,
     /* 164173 */   // Label 3019: @164173
     /* 164173 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(164209), // Rule ID 815 //
     /* 164178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 164186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164200 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 164203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164207 */     GIR_RootConstrainSelectedInstOperands,
     /* 164208 */     // GIR_Coverage, 815,
     /* 164208 */     GIR_EraseRootFromParent_Done,
     /* 164209 */   // Label 3020: @164209
     /* 164209 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(164245), // Rule ID 816 //
     /* 164214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 164222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164236 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 164239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164243 */     GIR_RootConstrainSelectedInstOperands,
     /* 164244 */     // GIR_Coverage, 816,
     /* 164244 */     GIR_EraseRootFromParent_Done,
     /* 164245 */   // Label 3021: @164245
     /* 164245 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(164281), // Rule ID 817 //
     /* 164250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 164258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164272 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 164275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164279 */     GIR_RootConstrainSelectedInstOperands,
     /* 164280 */     // GIR_Coverage, 817,
     /* 164280 */     GIR_EraseRootFromParent_Done,
     /* 164281 */   // Label 3022: @164281
     /* 164281 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(164317), // Rule ID 818 //
     /* 164286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 164294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164308 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 164311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164315 */     GIR_RootConstrainSelectedInstOperands,
     /* 164316 */     // GIR_Coverage, 818,
     /* 164316 */     GIR_EraseRootFromParent_Done,
     /* 164317 */   // Label 3023: @164317
     /* 164317 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(164353), // Rule ID 819 //
     /* 164322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 164330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164344 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 164347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164351 */     GIR_RootConstrainSelectedInstOperands,
     /* 164352 */     // GIR_Coverage, 819,
     /* 164352 */     GIR_EraseRootFromParent_Done,
     /* 164353 */   // Label 3024: @164353
     /* 164353 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(164389), // Rule ID 820 //
     /* 164358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164380 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 164383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164387 */     GIR_RootConstrainSelectedInstOperands,
     /* 164388 */     // GIR_Coverage, 820,
     /* 164388 */     GIR_EraseRootFromParent_Done,
     /* 164389 */   // Label 3025: @164389
     /* 164389 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(164425), // Rule ID 821 //
     /* 164394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 164419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164423 */     GIR_RootConstrainSelectedInstOperands,
     /* 164424 */     // GIR_Coverage, 821,
     /* 164424 */     GIR_EraseRootFromParent_Done,
     /* 164425 */   // Label 3026: @164425
     /* 164425 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(164461), // Rule ID 822 //
     /* 164430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164452 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 164455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164459 */     GIR_RootConstrainSelectedInstOperands,
     /* 164460 */     // GIR_Coverage, 822,
     /* 164460 */     GIR_EraseRootFromParent_Done,
     /* 164461 */   // Label 3027: @164461
     /* 164461 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(164497), // Rule ID 823 //
     /* 164466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 164491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164495 */     GIR_RootConstrainSelectedInstOperands,
     /* 164496 */     // GIR_Coverage, 823,
     /* 164496 */     GIR_EraseRootFromParent_Done,
     /* 164497 */   // Label 3028: @164497
     /* 164497 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(164533), // Rule ID 824 //
     /* 164502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164524 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 164527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164531 */     GIR_RootConstrainSelectedInstOperands,
     /* 164532 */     // GIR_Coverage, 824,
     /* 164532 */     GIR_EraseRootFromParent_Done,
     /* 164533 */   // Label 3029: @164533
     /* 164533 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(164569), // Rule ID 825 //
     /* 164538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164560 */     // (intrinsic_wo_chain:{ *:[v4i16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 164563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164567 */     GIR_RootConstrainSelectedInstOperands,
     /* 164568 */     // GIR_Coverage, 825,
     /* 164568 */     GIR_EraseRootFromParent_Done,
     /* 164569 */   // Label 3030: @164569
     /* 164569 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(164605), // Rule ID 826 //
     /* 164574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164596 */     // (intrinsic_wo_chain:{ *:[v8i16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 164599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164603 */     GIR_RootConstrainSelectedInstOperands,
     /* 164604 */     // GIR_Coverage, 826,
     /* 164604 */     GIR_EraseRootFromParent_Done,
     /* 164605 */   // Label 3031: @164605
     /* 164605 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(164641), // Rule ID 827 //
     /* 164610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164632 */     // (intrinsic_wo_chain:{ *:[v2i32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 164635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164639 */     GIR_RootConstrainSelectedInstOperands,
     /* 164640 */     // GIR_Coverage, 827,
     /* 164640 */     GIR_EraseRootFromParent_Done,
     /* 164641 */   // Label 3032: @164641
     /* 164641 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(164677), // Rule ID 828 //
     /* 164646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164668 */     // (intrinsic_wo_chain:{ *:[v4i32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 164671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164675 */     GIR_RootConstrainSelectedInstOperands,
     /* 164676 */     // GIR_Coverage, 828,
     /* 164676 */     GIR_EraseRootFromParent_Done,
     /* 164677 */   // Label 3033: @164677
     /* 164677 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(164713), // Rule ID 829 //
     /* 164682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164704 */     // (intrinsic_wo_chain:{ *:[v2i64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 164707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164711 */     GIR_RootConstrainSelectedInstOperands,
     /* 164712 */     // GIR_Coverage, 829,
     /* 164712 */     GIR_EraseRootFromParent_Done,
     /* 164713 */   // Label 3034: @164713
     /* 164713 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(164749), // Rule ID 830 //
     /* 164718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164740 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 164743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164747 */     GIR_RootConstrainSelectedInstOperands,
     /* 164748 */     // GIR_Coverage, 830,
     /* 164748 */     GIR_EraseRootFromParent_Done,
     /* 164749 */   // Label 3035: @164749
     /* 164749 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(164785), // Rule ID 831 //
     /* 164754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 164779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164783 */     GIR_RootConstrainSelectedInstOperands,
     /* 164784 */     // GIR_Coverage, 831,
     /* 164784 */     GIR_EraseRootFromParent_Done,
     /* 164785 */   // Label 3036: @164785
     /* 164785 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(164821), // Rule ID 832 //
     /* 164790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164812 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 164815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164819 */     GIR_RootConstrainSelectedInstOperands,
     /* 164820 */     // GIR_Coverage, 832,
     /* 164820 */     GIR_EraseRootFromParent_Done,
     /* 164821 */   // Label 3037: @164821
     /* 164821 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(164857), // Rule ID 833 //
     /* 164826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164848 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 164851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164855 */     GIR_RootConstrainSelectedInstOperands,
     /* 164856 */     // GIR_Coverage, 833,
     /* 164856 */     GIR_EraseRootFromParent_Done,
     /* 164857 */   // Label 3038: @164857
     /* 164857 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(164893), // Rule ID 834 //
     /* 164862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164884 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 164887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164891 */     GIR_RootConstrainSelectedInstOperands,
     /* 164892 */     // GIR_Coverage, 834,
     /* 164892 */     GIR_EraseRootFromParent_Done,
     /* 164893 */   // Label 3039: @164893
     /* 164893 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(164929), // Rule ID 835 //
     /* 164898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164920 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 164923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164927 */     GIR_RootConstrainSelectedInstOperands,
     /* 164928 */     // GIR_Coverage, 835,
     /* 164928 */     GIR_EraseRootFromParent_Done,
     /* 164929 */   // Label 3040: @164929
     /* 164929 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(164965), // Rule ID 836 //
     /* 164934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164956 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 164959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164963 */     GIR_RootConstrainSelectedInstOperands,
     /* 164964 */     // GIR_Coverage, 836,
     /* 164964 */     GIR_EraseRootFromParent_Done,
     /* 164965 */   // Label 3041: @164965
     /* 164965 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(165001), // Rule ID 837 //
     /* 164970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164992 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 164995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164999 */     GIR_RootConstrainSelectedInstOperands,
     /* 165000 */     // GIR_Coverage, 837,
     /* 165000 */     GIR_EraseRootFromParent_Done,
     /* 165001 */   // Label 3042: @165001
     /* 165001 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(165037), // Rule ID 838 //
     /* 165006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 165014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 165028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 165031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165035 */     GIR_RootConstrainSelectedInstOperands,
     /* 165036 */     // GIR_Coverage, 838,
     /* 165036 */     GIR_EraseRootFromParent_Done,
     /* 165037 */   // Label 3043: @165037
     /* 165037 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(165073), // Rule ID 839 //
     /* 165042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 165050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165064 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 165064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 165067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165071 */     GIR_RootConstrainSelectedInstOperands,
     /* 165072 */     // GIR_Coverage, 839,
     /* 165072 */     GIR_EraseRootFromParent_Done,
     /* 165073 */   // Label 3044: @165073
     /* 165073 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(165109), // Rule ID 840 //
     /* 165078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 165086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165100 */     // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 165100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 165103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165107 */     GIR_RootConstrainSelectedInstOperands,
     /* 165108 */     // GIR_Coverage, 840,
     /* 165108 */     GIR_EraseRootFromParent_Done,
     /* 165109 */   // Label 3045: @165109
     /* 165109 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(165145), // Rule ID 867 //
     /* 165114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 165122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165136 */     // (intrinsic_wo_chain:{ *:[v4f16] } 642:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 165139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165143 */     GIR_RootConstrainSelectedInstOperands,
     /* 165144 */     // GIR_Coverage, 867,
     /* 165144 */     GIR_EraseRootFromParent_Done,
     /* 165145 */   // Label 3046: @165145
     /* 165145 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(165181), // Rule ID 868 //
     /* 165150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 165158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165172 */     // (intrinsic_wo_chain:{ *:[v8f16] } 642:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 165175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165179 */     GIR_RootConstrainSelectedInstOperands,
     /* 165180 */     // GIR_Coverage, 868,
     /* 165180 */     GIR_EraseRootFromParent_Done,
     /* 165181 */   // Label 3047: @165181
     /* 165181 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(165217), // Rule ID 869 //
     /* 165186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 165194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165208 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 165211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165215 */     GIR_RootConstrainSelectedInstOperands,
     /* 165216 */     // GIR_Coverage, 869,
     /* 165216 */     GIR_EraseRootFromParent_Done,
     /* 165217 */   // Label 3048: @165217
     /* 165217 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(165253), // Rule ID 870 //
     /* 165222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 165230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165244 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 165247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165251 */     GIR_RootConstrainSelectedInstOperands,
     /* 165252 */     // GIR_Coverage, 870,
     /* 165252 */     GIR_EraseRootFromParent_Done,
     /* 165253 */   // Label 3049: @165253
     /* 165253 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(165289), // Rule ID 871 //
     /* 165258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 165266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165280 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 165283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165287 */     GIR_RootConstrainSelectedInstOperands,
     /* 165288 */     // GIR_Coverage, 871,
     /* 165288 */     GIR_EraseRootFromParent_Done,
     /* 165289 */   // Label 3050: @165289
     /* 165289 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(165325), // Rule ID 942 //
     /* 165294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 165302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165316 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 165319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165323 */     GIR_RootConstrainSelectedInstOperands,
     /* 165324 */     // GIR_Coverage, 942,
     /* 165324 */     GIR_EraseRootFromParent_Done,
     /* 165325 */   // Label 3051: @165325
     /* 165325 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(165361), // Rule ID 943 //
     /* 165330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 165338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 165355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165359 */     GIR_RootConstrainSelectedInstOperands,
     /* 165360 */     // GIR_Coverage, 943,
     /* 165360 */     GIR_EraseRootFromParent_Done,
     /* 165361 */   // Label 3052: @165361
     /* 165361 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(165397), // Rule ID 944 //
     /* 165366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 165374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165388 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 165391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165395 */     GIR_RootConstrainSelectedInstOperands,
     /* 165396 */     // GIR_Coverage, 944,
     /* 165396 */     GIR_EraseRootFromParent_Done,
     /* 165397 */   // Label 3053: @165397
     /* 165397 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(165433), // Rule ID 945 //
     /* 165402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165424 */     // (intrinsic_wo_chain:{ *:[v2f32] } 648:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 165427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165431 */     GIR_RootConstrainSelectedInstOperands,
     /* 165432 */     // GIR_Coverage, 945,
     /* 165432 */     GIR_EraseRootFromParent_Done,
     /* 165433 */   // Label 3054: @165433
     /* 165433 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(165469), // Rule ID 946 //
     /* 165438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165460 */     // (intrinsic_wo_chain:{ *:[v4f32] } 648:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 165463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165467 */     GIR_RootConstrainSelectedInstOperands,
     /* 165468 */     // GIR_Coverage, 946,
     /* 165468 */     GIR_EraseRootFromParent_Done,
     /* 165469 */   // Label 3055: @165469
     /* 165469 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(165505), // Rule ID 947 //
     /* 165474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165496 */     // (intrinsic_wo_chain:{ *:[v2f64] } 648:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 165499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165503 */     GIR_RootConstrainSelectedInstOperands,
     /* 165504 */     // GIR_Coverage, 947,
     /* 165504 */     GIR_EraseRootFromParent_Done,
     /* 165505 */   // Label 3056: @165505
     /* 165505 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(165541), // Rule ID 948 //
     /* 165510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165532 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 165535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165539 */     GIR_RootConstrainSelectedInstOperands,
     /* 165540 */     // GIR_Coverage, 948,
     /* 165540 */     GIR_EraseRootFromParent_Done,
     /* 165541 */   // Label 3057: @165541
     /* 165541 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(165577), // Rule ID 949 //
     /* 165546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165568 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 165571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165575 */     GIR_RootConstrainSelectedInstOperands,
     /* 165576 */     // GIR_Coverage, 949,
     /* 165576 */     GIR_EraseRootFromParent_Done,
     /* 165577 */   // Label 3058: @165577
     /* 165577 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(165613), // Rule ID 950 //
     /* 165582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165604 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 165607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165611 */     GIR_RootConstrainSelectedInstOperands,
     /* 165612 */     // GIR_Coverage, 950,
     /* 165612 */     GIR_EraseRootFromParent_Done,
     /* 165613 */   // Label 3059: @165613
     /* 165613 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(165649), // Rule ID 951 //
     /* 165618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165640 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 165643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165647 */     GIR_RootConstrainSelectedInstOperands,
     /* 165648 */     // GIR_Coverage, 951,
     /* 165648 */     GIR_EraseRootFromParent_Done,
     /* 165649 */   // Label 3060: @165649
     /* 165649 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(165685), // Rule ID 952 //
     /* 165654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165676 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 165679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165683 */     GIR_RootConstrainSelectedInstOperands,
     /* 165684 */     // GIR_Coverage, 952,
     /* 165684 */     GIR_EraseRootFromParent_Done,
     /* 165685 */   // Label 3061: @165685
     /* 165685 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(165721), // Rule ID 953 //
     /* 165690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165712 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 165715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165719 */     GIR_RootConstrainSelectedInstOperands,
     /* 165720 */     // GIR_Coverage, 953,
     /* 165720 */     GIR_EraseRootFromParent_Done,
     /* 165721 */   // Label 3062: @165721
     /* 165721 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(165757), // Rule ID 954 //
     /* 165726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165748 */     // (intrinsic_wo_chain:{ *:[v4f16] } 649:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 165751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165755 */     GIR_RootConstrainSelectedInstOperands,
     /* 165756 */     // GIR_Coverage, 954,
     /* 165756 */     GIR_EraseRootFromParent_Done,
     /* 165757 */   // Label 3063: @165757
     /* 165757 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165793), // Rule ID 955 //
     /* 165762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165784 */     // (intrinsic_wo_chain:{ *:[v8f16] } 649:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 165787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165791 */     GIR_RootConstrainSelectedInstOperands,
     /* 165792 */     // GIR_Coverage, 955,
     /* 165792 */     GIR_EraseRootFromParent_Done,
     /* 165793 */   // Label 3064: @165793
     /* 165793 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(165829), // Rule ID 956 //
     /* 165798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165820 */     // (intrinsic_wo_chain:{ *:[v2f32] } 649:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 165823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165827 */     GIR_RootConstrainSelectedInstOperands,
     /* 165828 */     // GIR_Coverage, 956,
     /* 165828 */     GIR_EraseRootFromParent_Done,
     /* 165829 */   // Label 3065: @165829
     /* 165829 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(165865), // Rule ID 957 //
     /* 165834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165856 */     // (intrinsic_wo_chain:{ *:[v4f32] } 649:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 165859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165863 */     GIR_RootConstrainSelectedInstOperands,
     /* 165864 */     // GIR_Coverage, 957,
     /* 165864 */     GIR_EraseRootFromParent_Done,
     /* 165865 */   // Label 3066: @165865
     /* 165865 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(165901), // Rule ID 958 //
     /* 165870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165892 */     // (intrinsic_wo_chain:{ *:[v2f64] } 649:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 165895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165899 */     GIR_RootConstrainSelectedInstOperands,
     /* 165900 */     // GIR_Coverage, 958,
     /* 165900 */     GIR_EraseRootFromParent_Done,
     /* 165901 */   // Label 3067: @165901
     /* 165901 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165937), // Rule ID 1005 //
     /* 165906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165928 */     // (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 165928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 165931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165935 */     GIR_RootConstrainSelectedInstOperands,
     /* 165936 */     // GIR_Coverage, 1005,
     /* 165936 */     GIR_EraseRootFromParent_Done,
     /* 165937 */   // Label 3068: @165937
     /* 165937 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165973), // Rule ID 1007 //
     /* 165942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 165964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 165967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165971 */     GIR_RootConstrainSelectedInstOperands,
     /* 165972 */     // GIR_Coverage, 1007,
     /* 165972 */     GIR_EraseRootFromParent_Done,
     /* 165973 */   // Label 3069: @165973
     /* 165973 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(166009), // Rule ID 1009 //
     /* 165978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 166000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 166003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166007 */     GIR_RootConstrainSelectedInstOperands,
     /* 166008 */     // GIR_Coverage, 1009,
     /* 166008 */     GIR_EraseRootFromParent_Done,
     /* 166009 */   // Label 3070: @166009
     /* 166009 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(166045), // Rule ID 1011 //
     /* 166014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 166022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 166036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 166039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166043 */     GIR_RootConstrainSelectedInstOperands,
     /* 166044 */     // GIR_Coverage, 1011,
     /* 166044 */     GIR_EraseRootFromParent_Done,
     /* 166045 */   // Label 3071: @166045
     /* 166045 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(166081), // Rule ID 1013 //
     /* 166050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 166058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166072 */     // (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 166072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 166075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166079 */     GIR_RootConstrainSelectedInstOperands,
     /* 166080 */     // GIR_Coverage, 1013,
     /* 166080 */     GIR_EraseRootFromParent_Done,
     /* 166081 */   // Label 3072: @166081
     /* 166081 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(166117), // Rule ID 1015 //
     /* 166086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 166094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166108 */     // (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 166108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 166111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166115 */     GIR_RootConstrainSelectedInstOperands,
     /* 166116 */     // GIR_Coverage, 1015,
     /* 166116 */     GIR_EraseRootFromParent_Done,
     /* 166117 */   // Label 3073: @166117
     /* 166117 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(166153), // Rule ID 1026 //
     /* 166122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166144 */     // (intrinsic_wo_chain:{ *:[v8i8] } 688:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 166144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 166147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166151 */     GIR_RootConstrainSelectedInstOperands,
     /* 166152 */     // GIR_Coverage, 1026,
     /* 166152 */     GIR_EraseRootFromParent_Done,
     /* 166153 */   // Label 3074: @166153
     /* 166153 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(166189), // Rule ID 1027 //
     /* 166158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166180 */     // (intrinsic_wo_chain:{ *:[v16i8] } 688:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 166180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 166183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166187 */     GIR_RootConstrainSelectedInstOperands,
     /* 166188 */     // GIR_Coverage, 1027,
     /* 166188 */     GIR_EraseRootFromParent_Done,
     /* 166189 */   // Label 3075: @166189
     /* 166189 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(166225), // Rule ID 1028 //
     /* 166194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166216 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 166216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 166219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166223 */     GIR_RootConstrainSelectedInstOperands,
     /* 166224 */     // GIR_Coverage, 1028,
     /* 166224 */     GIR_EraseRootFromParent_Done,
     /* 166225 */   // Label 3076: @166225
     /* 166225 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(166261), // Rule ID 1029 //
     /* 166230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166252 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 166252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 166255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166259 */     GIR_RootConstrainSelectedInstOperands,
     /* 166260 */     // GIR_Coverage, 1029,
     /* 166260 */     GIR_EraseRootFromParent_Done,
     /* 166261 */   // Label 3077: @166261
     /* 166261 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(166297), // Rule ID 1030 //
     /* 166266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166288 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 166291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166295 */     GIR_RootConstrainSelectedInstOperands,
     /* 166296 */     // GIR_Coverage, 1030,
     /* 166296 */     GIR_EraseRootFromParent_Done,
     /* 166297 */   // Label 3078: @166297
     /* 166297 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(166333), // Rule ID 1031 //
     /* 166302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166324 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 166327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166331 */     GIR_RootConstrainSelectedInstOperands,
     /* 166332 */     // GIR_Coverage, 1031,
     /* 166332 */     GIR_EraseRootFromParent_Done,
     /* 166333 */   // Label 3079: @166333
     /* 166333 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(166369), // Rule ID 1032 //
     /* 166338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166360 */     // (intrinsic_wo_chain:{ *:[v2i64] } 688:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 166360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 166363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166367 */     GIR_RootConstrainSelectedInstOperands,
     /* 166368 */     // GIR_Coverage, 1032,
     /* 166368 */     GIR_EraseRootFromParent_Done,
     /* 166369 */   // Label 3080: @166369
     /* 166369 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(166405), // Rule ID 1033 //
     /* 166374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166396 */     // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 166396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 166399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166403 */     GIR_RootConstrainSelectedInstOperands,
     /* 166404 */     // GIR_Coverage, 1033,
     /* 166404 */     GIR_EraseRootFromParent_Done,
     /* 166405 */   // Label 3081: @166405
     /* 166405 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(166441), // Rule ID 1034 //
     /* 166410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166432 */     // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 166432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 166435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166439 */     GIR_RootConstrainSelectedInstOperands,
     /* 166440 */     // GIR_Coverage, 1034,
     /* 166440 */     GIR_EraseRootFromParent_Done,
     /* 166441 */   // Label 3082: @166441
     /* 166441 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(166477), // Rule ID 1035 //
     /* 166446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166468 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 166468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 166471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166475 */     GIR_RootConstrainSelectedInstOperands,
     /* 166476 */     // GIR_Coverage, 1035,
     /* 166476 */     GIR_EraseRootFromParent_Done,
     /* 166477 */   // Label 3083: @166477
     /* 166477 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(166513), // Rule ID 1036 //
     /* 166482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166504 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 166504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 166507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166511 */     GIR_RootConstrainSelectedInstOperands,
     /* 166512 */     // GIR_Coverage, 1036,
     /* 166512 */     GIR_EraseRootFromParent_Done,
     /* 166513 */   // Label 3084: @166513
     /* 166513 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(166549), // Rule ID 1037 //
     /* 166518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166540 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 166543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166547 */     GIR_RootConstrainSelectedInstOperands,
     /* 166548 */     // GIR_Coverage, 1037,
     /* 166548 */     GIR_EraseRootFromParent_Done,
     /* 166549 */   // Label 3085: @166549
     /* 166549 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(166585), // Rule ID 1038 //
     /* 166554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 166579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166583 */     GIR_RootConstrainSelectedInstOperands,
     /* 166584 */     // GIR_Coverage, 1038,
     /* 166584 */     GIR_EraseRootFromParent_Done,
     /* 166585 */   // Label 3086: @166585
     /* 166585 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(166621), // Rule ID 1039 //
     /* 166590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166612 */     // (intrinsic_wo_chain:{ *:[v2i64] } 695:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 166612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 166615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166619 */     GIR_RootConstrainSelectedInstOperands,
     /* 166620 */     // GIR_Coverage, 1039,
     /* 166620 */     GIR_EraseRootFromParent_Done,
     /* 166621 */   // Label 3087: @166621
     /* 166621 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(166657), // Rule ID 1066 //
     /* 166626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 166648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 166651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166655 */     GIR_RootConstrainSelectedInstOperands,
     /* 166656 */     // GIR_Coverage, 1066,
     /* 166656 */     GIR_EraseRootFromParent_Done,
     /* 166657 */   // Label 3088: @166657
     /* 166657 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(166693), // Rule ID 1068 //
     /* 166662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 166684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 166687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166691 */     GIR_RootConstrainSelectedInstOperands,
     /* 166692 */     // GIR_Coverage, 1068,
     /* 166692 */     GIR_EraseRootFromParent_Done,
     /* 166693 */   // Label 3089: @166693
     /* 166693 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166729), // Rule ID 1070 //
     /* 166698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166720 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 166720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 166723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166727 */     GIR_RootConstrainSelectedInstOperands,
     /* 166728 */     // GIR_Coverage, 1070,
     /* 166728 */     GIR_EraseRootFromParent_Done,
     /* 166729 */   // Label 3090: @166729
     /* 166729 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166765), // Rule ID 1072 //
     /* 166734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166756 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 166756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 166759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166763 */     GIR_RootConstrainSelectedInstOperands,
     /* 166764 */     // GIR_Coverage, 1072,
     /* 166764 */     GIR_EraseRootFromParent_Done,
     /* 166765 */   // Label 3091: @166765
     /* 166765 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166801), // Rule ID 1074 //
     /* 166770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166792 */     // (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 166792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 166795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166799 */     GIR_RootConstrainSelectedInstOperands,
     /* 166800 */     // GIR_Coverage, 1074,
     /* 166800 */     GIR_EraseRootFromParent_Done,
     /* 166801 */   // Label 3092: @166801
     /* 166801 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166837), // Rule ID 1076 //
     /* 166806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166828 */     // (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 166828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 166831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166835 */     GIR_RootConstrainSelectedInstOperands,
     /* 166836 */     // GIR_Coverage, 1076,
     /* 166836 */     GIR_EraseRootFromParent_Done,
     /* 166837 */   // Label 3093: @166837
     /* 166837 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166873), // Rule ID 1090 //
     /* 166842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166864 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 166867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166871 */     GIR_RootConstrainSelectedInstOperands,
     /* 166872 */     // GIR_Coverage, 1090,
     /* 166872 */     GIR_EraseRootFromParent_Done,
     /* 166873 */   // Label 3094: @166873
     /* 166873 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166909), // Rule ID 1091 //
     /* 166878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166900 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 166903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166907 */     GIR_RootConstrainSelectedInstOperands,
     /* 166908 */     // GIR_Coverage, 1091,
     /* 166908 */     GIR_EraseRootFromParent_Done,
     /* 166909 */   // Label 3095: @166909
     /* 166909 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166945), // Rule ID 1092 //
     /* 166914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166936 */     // (intrinsic_wo_chain:{ *:[v2i32] } 759:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 166939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166943 */     GIR_RootConstrainSelectedInstOperands,
     /* 166944 */     // GIR_Coverage, 1092,
     /* 166944 */     GIR_EraseRootFromParent_Done,
     /* 166945 */   // Label 3096: @166945
     /* 166945 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166981), // Rule ID 1093 //
     /* 166950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 759:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 166975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166979 */     GIR_RootConstrainSelectedInstOperands,
     /* 166980 */     // GIR_Coverage, 1093,
     /* 166980 */     GIR_EraseRootFromParent_Done,
     /* 166981 */   // Label 3097: @166981
     /* 166981 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(167017), // Rule ID 1657 //
     /* 166986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 166994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167008 */     // (intrinsic_wo_chain:{ *:[f32] } 796:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 167008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 167011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167015 */     GIR_RootConstrainSelectedInstOperands,
     /* 167016 */     // GIR_Coverage, 1657,
     /* 167016 */     GIR_EraseRootFromParent_Done,
     /* 167017 */   // Label 3098: @167017
     /* 167017 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(167053), // Rule ID 1663 //
     /* 167022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167044 */     // (intrinsic_wo_chain:{ *:[i64] } 688:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 167044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 167047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167051 */     GIR_RootConstrainSelectedInstOperands,
     /* 167052 */     // GIR_Coverage, 1663,
     /* 167052 */     GIR_EraseRootFromParent_Done,
     /* 167053 */   // Label 3099: @167053
     /* 167053 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(167089), // Rule ID 1664 //
     /* 167058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167080 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 167083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167087 */     GIR_RootConstrainSelectedInstOperands,
     /* 167088 */     // GIR_Coverage, 1664,
     /* 167088 */     GIR_EraseRootFromParent_Done,
     /* 167089 */   // Label 3100: @167089
     /* 167089 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(167125), // Rule ID 1665 //
     /* 167094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 167102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167116 */     // (intrinsic_wo_chain:{ *:[i64] } 695:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 167116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 167119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167123 */     GIR_RootConstrainSelectedInstOperands,
     /* 167124 */     // GIR_Coverage, 1665,
     /* 167124 */     GIR_EraseRootFromParent_Done,
     /* 167125 */   // Label 3101: @167125
     /* 167125 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(167161), // Rule ID 1666 //
     /* 167130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 167138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167152 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 167155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167159 */     GIR_RootConstrainSelectedInstOperands,
     /* 167160 */     // GIR_Coverage, 1666,
     /* 167160 */     GIR_EraseRootFromParent_Done,
     /* 167161 */   // Label 3102: @167161
     /* 167161 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(167197), // Rule ID 1667 //
     /* 167166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 167174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167188 */     // (intrinsic_wo_chain:{ *:[f32] } 673:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 167188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 167191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167195 */     GIR_RootConstrainSelectedInstOperands,
     /* 167196 */     // GIR_Coverage, 1667,
     /* 167196 */     GIR_EraseRootFromParent_Done,
     /* 167197 */   // Label 3103: @167197
     /* 167197 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(167233), // Rule ID 1668 //
     /* 167202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 167210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167224 */     // (intrinsic_wo_chain:{ *:[f32] } 674:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 167224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 167227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167231 */     GIR_RootConstrainSelectedInstOperands,
     /* 167232 */     // GIR_Coverage, 1668,
     /* 167232 */     GIR_EraseRootFromParent_Done,
     /* 167233 */   // Label 3104: @167233
     /* 167233 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(167269), // Rule ID 1674 //
     /* 167238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 167246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167260 */     // (intrinsic_wo_chain:{ *:[f32] } 675:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 167260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 167263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167267 */     GIR_RootConstrainSelectedInstOperands,
     /* 167268 */     // GIR_Coverage, 1674,
     /* 167268 */     GIR_EraseRootFromParent_Done,
     /* 167269 */   // Label 3105: @167269
     /* 167269 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(167305), // Rule ID 1947 //
     /* 167274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167296 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 167299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167303 */     GIR_RootConstrainSelectedInstOperands,
     /* 167304 */     // GIR_Coverage, 1947,
     /* 167304 */     GIR_EraseRootFromParent_Done,
     /* 167305 */   // Label 3106: @167305
     /* 167305 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(167341), // Rule ID 1949 //
     /* 167310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167332 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 167335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167339 */     GIR_RootConstrainSelectedInstOperands,
     /* 167340 */     // GIR_Coverage, 1949,
     /* 167340 */     GIR_EraseRootFromParent_Done,
     /* 167341 */   // Label 3107: @167341
     /* 167341 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(167377), // Rule ID 1951 //
     /* 167346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167368 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 167371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167375 */     GIR_RootConstrainSelectedInstOperands,
     /* 167376 */     // GIR_Coverage, 1951,
     /* 167376 */     GIR_EraseRootFromParent_Done,
     /* 167377 */   // Label 3108: @167377
     /* 167377 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(167413), // Rule ID 1953 //
     /* 167382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167404 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 167407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167411 */     GIR_RootConstrainSelectedInstOperands,
     /* 167412 */     // GIR_Coverage, 1953,
     /* 167412 */     GIR_EraseRootFromParent_Done,
     /* 167413 */   // Label 3109: @167413
     /* 167413 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(167449), // Rule ID 1955 //
     /* 167418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167440 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 167443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167447 */     GIR_RootConstrainSelectedInstOperands,
     /* 167448 */     // GIR_Coverage, 1955,
     /* 167448 */     GIR_EraseRootFromParent_Done,
     /* 167449 */   // Label 3110: @167449
     /* 167449 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167485), // Rule ID 1957 //
     /* 167454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167476 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 167479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167483 */     GIR_RootConstrainSelectedInstOperands,
     /* 167484 */     // GIR_Coverage, 1957,
     /* 167484 */     GIR_EraseRootFromParent_Done,
     /* 167485 */   // Label 3111: @167485
     /* 167485 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167521), // Rule ID 1959 //
     /* 167490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167512 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 167515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167519 */     GIR_RootConstrainSelectedInstOperands,
     /* 167520 */     // GIR_Coverage, 1959,
     /* 167520 */     GIR_EraseRootFromParent_Done,
     /* 167521 */   // Label 3112: @167521
     /* 167521 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167557), // Rule ID 1961 //
     /* 167526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167548 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 167551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167555 */     GIR_RootConstrainSelectedInstOperands,
     /* 167556 */     // GIR_Coverage, 1961,
     /* 167556 */     GIR_EraseRootFromParent_Done,
     /* 167557 */   // Label 3113: @167557
     /* 167557 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167593), // Rule ID 1963 //
     /* 167562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167584 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 167587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167591 */     GIR_RootConstrainSelectedInstOperands,
     /* 167592 */     // GIR_Coverage, 1963,
     /* 167592 */     GIR_EraseRootFromParent_Done,
     /* 167593 */   // Label 3114: @167593
     /* 167593 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167629), // Rule ID 1965 //
     /* 167598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167620 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 167623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167627 */     GIR_RootConstrainSelectedInstOperands,
     /* 167628 */     // GIR_Coverage, 1965,
     /* 167628 */     GIR_EraseRootFromParent_Done,
     /* 167629 */   // Label 3115: @167629
     /* 167629 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167665), // Rule ID 1967 //
     /* 167634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167656 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 167659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167663 */     GIR_RootConstrainSelectedInstOperands,
     /* 167664 */     // GIR_Coverage, 1967,
     /* 167664 */     GIR_EraseRootFromParent_Done,
     /* 167665 */   // Label 3116: @167665
     /* 167665 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167701), // Rule ID 1969 //
     /* 167670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167692 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 167695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167699 */     GIR_RootConstrainSelectedInstOperands,
     /* 167700 */     // GIR_Coverage, 1969,
     /* 167700 */     GIR_EraseRootFromParent_Done,
     /* 167701 */   // Label 3117: @167701
     /* 167701 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167737), // Rule ID 2309 //
     /* 167706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 167714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167728 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 167731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167735 */     GIR_RootConstrainSelectedInstOperands,
     /* 167736 */     // GIR_Coverage, 2309,
     /* 167736 */     GIR_EraseRootFromParent_Done,
     /* 167737 */   // Label 3118: @167737
     /* 167737 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167773), // Rule ID 2310 //
     /* 167742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 167750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167764 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 167767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167771 */     GIR_RootConstrainSelectedInstOperands,
     /* 167772 */     // GIR_Coverage, 2310,
     /* 167772 */     GIR_EraseRootFromParent_Done,
     /* 167773 */   // Label 3119: @167773
     /* 167773 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167809), // Rule ID 2318 //
     /* 167778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 167781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 167786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167800 */     // (intrinsic_wo_chain:{ *:[i32] } 531:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 167803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167807 */     GIR_RootConstrainSelectedInstOperands,
     /* 167808 */     // GIR_Coverage, 2318,
     /* 167808 */     GIR_EraseRootFromParent_Done,
     /* 167809 */   // Label 3120: @167809
     /* 167809 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167845), // Rule ID 2515 //
     /* 167814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167836 */     // (intrinsic_wo_chain:{ *:[v1i64] } 688:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 167836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 167839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167843 */     GIR_RootConstrainSelectedInstOperands,
     /* 167844 */     // GIR_Coverage, 2515,
     /* 167844 */     GIR_EraseRootFromParent_Done,
     /* 167845 */   // Label 3121: @167845
     /* 167845 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167884), // Rule ID 3575 //
     /* 167850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 167861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 167872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 167875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167882 */     GIR_RootConstrainSelectedInstOperands,
     /* 167883 */     // GIR_Coverage, 3575,
     /* 167883 */     GIR_EraseRootFromParent_Done,
     /* 167884 */   // Label 3122: @167884
     /* 167884 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167923), // Rule ID 3576 //
     /* 167889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 167900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 167911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 167914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167921 */     GIR_RootConstrainSelectedInstOperands,
     /* 167922 */     // GIR_Coverage, 3576,
     /* 167922 */     GIR_EraseRootFromParent_Done,
     /* 167923 */   // Label 3123: @167923
     /* 167923 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167962), // Rule ID 3577 //
     /* 167928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 167939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 167950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 167953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167960 */     GIR_RootConstrainSelectedInstOperands,
     /* 167961 */     // GIR_Coverage, 3577,
     /* 167961 */     GIR_EraseRootFromParent_Done,
     /* 167962 */   // Label 3124: @167962
     /* 167962 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(168001), // Rule ID 3578 //
     /* 167967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 167978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 167989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 167992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167999 */     GIR_RootConstrainSelectedInstOperands,
     /* 168000 */     // GIR_Coverage, 3578,
     /* 168000 */     GIR_EraseRootFromParent_Done,
     /* 168001 */   // Label 3125: @168001
     /* 168001 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(168057), // Rule ID 3582 //
     /* 168006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 168009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 168014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 168017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 168020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 168028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 168028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 168031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 168045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 168055 */     GIR_RootConstrainSelectedInstOperands,
     /* 168056 */     // GIR_Coverage, 3582,
     /* 168056 */     GIR_EraseRootFromParent_Done,
     /* 168057 */   // Label 3126: @168057
     /* 168057 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(168113), // Rule ID 3583 //
     /* 168062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 168065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 168070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 168073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 168076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 168084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1639:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 168084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 168087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 168101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 168111 */     GIR_RootConstrainSelectedInstOperands,
     /* 168112 */     // GIR_Coverage, 3583,
     /* 168112 */     GIR_EraseRootFromParent_Done,
     /* 168113 */   // Label 3127: @168113
     /* 168113 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(168169), // Rule ID 3584 //
     /* 168118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 168121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 168126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 168129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 168132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 168140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 168140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 168143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 168157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 168167 */     GIR_RootConstrainSelectedInstOperands,
     /* 168168 */     // GIR_Coverage, 3584,
     /* 168168 */     GIR_EraseRootFromParent_Done,
     /* 168169 */   // Label 3128: @168169
     /* 168169 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(168225), // Rule ID 3585 //
     /* 168174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 168177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 168182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 168185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 168188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 168192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 168196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 168196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 168199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 168213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 168215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 168223 */     GIR_RootConstrainSelectedInstOperands,
     /* 168224 */     // GIR_Coverage, 3585,
     /* 168224 */     GIR_EraseRootFromParent_Done,
     /* 168225 */   // Label 3129: @168225
     /* 168225 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(168258), // Rule ID 4042 //
     /* 168230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 168235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168249 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 168249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 168252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168256 */     GIR_RootConstrainSelectedInstOperands,
     /* 168257 */     // GIR_Coverage, 4042,
     /* 168257 */     GIR_EraseRootFromParent_Done,
     /* 168258 */   // Label 3130: @168258
     /* 168258 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(168323), // Rule ID 4043 //
     /* 168263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 168268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 168282 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 168282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 168289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 168298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 168312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 168322 */     // GIR_Coverage, 4043,
     /* 168322 */     GIR_EraseRootFromParent_Done,
     /* 168323 */   // Label 3131: @168323
     /* 168323 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(168356), // Rule ID 4849 //
     /* 168328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 168333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168347 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 168350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168354 */     GIR_RootConstrainSelectedInstOperands,
     /* 168355 */     // GIR_Coverage, 4849,
     /* 168355 */     GIR_EraseRootFromParent_Done,
     /* 168356 */   // Label 3132: @168356
     /* 168356 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168389), // Rule ID 4850 //
     /* 168361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 168366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168380 */     // (intrinsic_wo_chain:{ *:[v1f64] } 648:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 168383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168387 */     GIR_RootConstrainSelectedInstOperands,
     /* 168388 */     // GIR_Coverage, 4850,
     /* 168388 */     GIR_EraseRootFromParent_Done,
     /* 168389 */   // Label 3133: @168389
     /* 168389 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168422), // Rule ID 4851 //
     /* 168394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 168399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168413 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 168416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168420 */     GIR_RootConstrainSelectedInstOperands,
     /* 168421 */     // GIR_Coverage, 4851,
     /* 168421 */     GIR_EraseRootFromParent_Done,
     /* 168422 */   // Label 3134: @168422
     /* 168422 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168455), // Rule ID 4852 //
     /* 168427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 168432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168446 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 168449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168453 */     GIR_RootConstrainSelectedInstOperands,
     /* 168454 */     // GIR_Coverage, 4852,
     /* 168454 */     GIR_EraseRootFromParent_Done,
     /* 168455 */   // Label 3135: @168455
     /* 168455 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168488), // Rule ID 4966 //
     /* 168460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 168465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168479 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 168479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 168482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168486 */     GIR_RootConstrainSelectedInstOperands,
     /* 168487 */     // GIR_Coverage, 4966,
     /* 168487 */     GIR_EraseRootFromParent_Done,
     /* 168488 */   // Label 3136: @168488
     /* 168488 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168521), // Rule ID 4976 //
     /* 168493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 168498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168512 */     // (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 168512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 168515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168519 */     GIR_RootConstrainSelectedInstOperands,
     /* 168520 */     // GIR_Coverage, 4976,
     /* 168520 */     GIR_EraseRootFromParent_Done,
     /* 168521 */   // Label 3137: @168521
     /* 168521 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168557), // Rule ID 5297 //
     /* 168526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 168534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168548 */     // (intrinsic_wo_chain:{ *:[v1i64] } 695:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 168548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 168551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168555 */     GIR_RootConstrainSelectedInstOperands,
     /* 168556 */     // GIR_Coverage, 5297,
     /* 168556 */     GIR_EraseRootFromParent_Done,
     /* 168557 */   // Label 3138: @168557
     /* 168557 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168590), // Rule ID 5300 //
     /* 168562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 168567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168581 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 168584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168588 */     GIR_RootConstrainSelectedInstOperands,
     /* 168589 */     // GIR_Coverage, 5300,
     /* 168589 */     GIR_EraseRootFromParent_Done,
     /* 168590 */   // Label 3139: @168590
     /* 168590 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168623), // Rule ID 5301 //
     /* 168595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 168600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168614 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 168617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168621 */     GIR_RootConstrainSelectedInstOperands,
     /* 168622 */     // GIR_Coverage, 5301,
     /* 168622 */     GIR_EraseRootFromParent_Done,
     /* 168623 */   // Label 3140: @168623
     /* 168623 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168656), // Rule ID 5302 //
     /* 168628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 168633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168647 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 168650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168654 */     GIR_RootConstrainSelectedInstOperands,
     /* 168655 */     // GIR_Coverage, 5302,
     /* 168655 */     GIR_EraseRootFromParent_Done,
     /* 168656 */   // Label 3141: @168656
     /* 168656 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168689), // Rule ID 5303 //
     /* 168661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 168666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168680 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 168683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168687 */     GIR_RootConstrainSelectedInstOperands,
     /* 168688 */     // GIR_Coverage, 5303,
     /* 168688 */     GIR_EraseRootFromParent_Done,
     /* 168689 */   // Label 3142: @168689
     /* 168689 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168722), // Rule ID 5304 //
     /* 168694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 168699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168713 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 168716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168720 */     GIR_RootConstrainSelectedInstOperands,
     /* 168721 */     // GIR_Coverage, 5304,
     /* 168721 */     GIR_EraseRootFromParent_Done,
     /* 168722 */   // Label 3143: @168722
     /* 168722 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168755), // Rule ID 5305 //
     /* 168727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 168732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168746 */     // (intrinsic_wo_chain:{ *:[v1i64] } 598:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 168749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168753 */     GIR_RootConstrainSelectedInstOperands,
     /* 168754 */     // GIR_Coverage, 5305,
     /* 168754 */     GIR_EraseRootFromParent_Done,
     /* 168755 */   // Label 3144: @168755
     /* 168755 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168788), // Rule ID 5306 //
     /* 168760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 168765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168779 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 168782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168786 */     GIR_RootConstrainSelectedInstOperands,
     /* 168787 */     // GIR_Coverage, 5306,
     /* 168787 */     GIR_EraseRootFromParent_Done,
     /* 168788 */   // Label 3145: @168788
     /* 168788 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168821), // Rule ID 5307 //
     /* 168793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 168798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168812 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 168815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168819 */     GIR_RootConstrainSelectedInstOperands,
     /* 168820 */     // GIR_Coverage, 5307,
     /* 168820 */     GIR_EraseRootFromParent_Done,
     /* 168821 */   // Label 3146: @168821
     /* 168821 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168854), // Rule ID 5308 //
     /* 168826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 168831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168845 */     // (intrinsic_wo_chain:{ *:[v1i64] } 602:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 168848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168852 */     GIR_RootConstrainSelectedInstOperands,
     /* 168853 */     // GIR_Coverage, 5308,
     /* 168853 */     GIR_EraseRootFromParent_Done,
     /* 168854 */   // Label 3147: @168854
     /* 168854 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(168887), // Rule ID 5309 //
     /* 168859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 168864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168878 */     // (intrinsic_wo_chain:{ *:[v1i64] } 603:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 168881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168885 */     GIR_RootConstrainSelectedInstOperands,
     /* 168886 */     // GIR_Coverage, 5309,
     /* 168886 */     GIR_EraseRootFromParent_Done,
     /* 168887 */   // Label 3148: @168887
     /* 168887 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(168920), // Rule ID 5310 //
     /* 168892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168911 */     // (intrinsic_wo_chain:{ *:[f16] } 642:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 168914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168918 */     GIR_RootConstrainSelectedInstOperands,
     /* 168919 */     // GIR_Coverage, 5310,
     /* 168919 */     GIR_EraseRootFromParent_Done,
     /* 168920 */   // Label 3149: @168920
     /* 168920 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168953), // Rule ID 5311 //
     /* 168925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168944 */     // (intrinsic_wo_chain:{ *:[f32] } 642:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 168947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168951 */     GIR_RootConstrainSelectedInstOperands,
     /* 168952 */     // GIR_Coverage, 5311,
     /* 168952 */     GIR_EraseRootFromParent_Done,
     /* 168953 */   // Label 3150: @168953
     /* 168953 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168986), // Rule ID 5312 //
     /* 168958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168977 */     // (intrinsic_wo_chain:{ *:[f64] } 642:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168984 */     GIR_RootConstrainSelectedInstOperands,
     /* 168985 */     // GIR_Coverage, 5312,
     /* 168985 */     GIR_EraseRootFromParent_Done,
     /* 168986 */   // Label 3151: @168986
     /* 168986 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(169019), // Rule ID 5313 //
     /* 168991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169010 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 169010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 169013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169017 */     GIR_RootConstrainSelectedInstOperands,
     /* 169018 */     // GIR_Coverage, 5313,
     /* 169018 */     GIR_EraseRootFromParent_Done,
     /* 169019 */   // Label 3152: @169019
     /* 169019 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(169052), // Rule ID 5325 //
     /* 169024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 169029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 169035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169043 */     // (intrinsic_wo_chain:{ *:[f16] } 644:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 169043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 169046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169050 */     GIR_RootConstrainSelectedInstOperands,
     /* 169051 */     // GIR_Coverage, 5325,
     /* 169051 */     GIR_EraseRootFromParent_Done,
     /* 169052 */   // Label 3153: @169052
     /* 169052 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(169085), // Rule ID 5326 //
     /* 169057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 169062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169076 */     // (intrinsic_wo_chain:{ *:[f32] } 644:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 169076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 169079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169083 */     GIR_RootConstrainSelectedInstOperands,
     /* 169084 */     // GIR_Coverage, 5326,
     /* 169084 */     GIR_EraseRootFromParent_Done,
     /* 169085 */   // Label 3154: @169085
     /* 169085 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(169118), // Rule ID 5327 //
     /* 169090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 169095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169109 */     // (intrinsic_wo_chain:{ *:[f64] } 644:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 169109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 169112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169116 */     GIR_RootConstrainSelectedInstOperands,
     /* 169117 */     // GIR_Coverage, 5327,
     /* 169117 */     GIR_EraseRootFromParent_Done,
     /* 169118 */   // Label 3155: @169118
     /* 169118 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169151), // Rule ID 5328 //
     /* 169123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 169128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 169134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169142 */     // (intrinsic_wo_chain:{ *:[f16] } 649:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 169142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169149 */     GIR_RootConstrainSelectedInstOperands,
     /* 169150 */     // GIR_Coverage, 5328,
     /* 169150 */     GIR_EraseRootFromParent_Done,
     /* 169151 */   // Label 3156: @169151
     /* 169151 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169184), // Rule ID 5329 //
     /* 169156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 169161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169175 */     // (intrinsic_wo_chain:{ *:[f32] } 649:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 169175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 169178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169182 */     GIR_RootConstrainSelectedInstOperands,
     /* 169183 */     // GIR_Coverage, 5329,
     /* 169183 */     GIR_EraseRootFromParent_Done,
     /* 169184 */   // Label 3157: @169184
     /* 169184 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169217), // Rule ID 5330 //
     /* 169189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 169194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169208 */     // (intrinsic_wo_chain:{ *:[f64] } 649:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 169208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169215 */     GIR_RootConstrainSelectedInstOperands,
     /* 169216 */     // GIR_Coverage, 5330,
     /* 169216 */     GIR_EraseRootFromParent_Done,
     /* 169217 */   // Label 3158: @169217
     /* 169217 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169250), // Rule ID 5331 //
     /* 169222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 169227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169241 */     // (intrinsic_wo_chain:{ *:[v1f64] } 649:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 169241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 169244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169248 */     GIR_RootConstrainSelectedInstOperands,
     /* 169249 */     // GIR_Coverage, 5331,
     /* 169249 */     GIR_EraseRootFromParent_Done,
     /* 169250 */   // Label 3159: @169250
     /* 169250 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169283), // Rule ID 5661 //
     /* 169255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 169260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169274 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 169277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169281 */     GIR_RootConstrainSelectedInstOperands,
     /* 169282 */     // GIR_Coverage, 5661,
     /* 169282 */     GIR_EraseRootFromParent_Done,
     /* 169283 */   // Label 3160: @169283
     /* 169283 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169368), // Rule ID 5662 //
     /* 169288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 169293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169307 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 169307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 169310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 169314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169341 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 169348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 169361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169366 */     GIR_RootConstrainSelectedInstOperands,
     /* 169367 */     // GIR_Coverage, 5662,
     /* 169367 */     GIR_EraseRootFromParent_Done,
     /* 169368 */   // Label 3161: @169368
     /* 169368 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(169401), // Rule ID 5663 //
     /* 169373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 169378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169392 */     // (intrinsic_wo_chain:{ *:[f64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 169395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169399 */     GIR_RootConstrainSelectedInstOperands,
     /* 169400 */     // GIR_Coverage, 5663,
     /* 169400 */     GIR_EraseRootFromParent_Done,
     /* 169401 */   // Label 3162: @169401
     /* 169401 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(169434), // Rule ID 5665 //
     /* 169406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169425 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 169428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169432 */     GIR_RootConstrainSelectedInstOperands,
     /* 169433 */     // GIR_Coverage, 5665,
     /* 169433 */     GIR_EraseRootFromParent_Done,
     /* 169434 */   // Label 3163: @169434
     /* 169434 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(169467), // Rule ID 5667 //
     /* 169439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169458 */     // (intrinsic_wo_chain:{ *:[f64] } 607:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 169461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169465 */     GIR_RootConstrainSelectedInstOperands,
     /* 169466 */     // GIR_Coverage, 5667,
     /* 169466 */     GIR_EraseRootFromParent_Done,
     /* 169467 */   // Label 3164: @169467
     /* 169467 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169500), // Rule ID 5669 //
     /* 169472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169491 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 169494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169498 */     GIR_RootConstrainSelectedInstOperands,
     /* 169499 */     // GIR_Coverage, 5669,
     /* 169499 */     GIR_EraseRootFromParent_Done,
     /* 169500 */   // Label 3165: @169500
     /* 169500 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169533), // Rule ID 5671 //
     /* 169505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169524 */     // (intrinsic_wo_chain:{ *:[f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 169527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169531 */     GIR_RootConstrainSelectedInstOperands,
     /* 169532 */     // GIR_Coverage, 5671,
     /* 169532 */     GIR_EraseRootFromParent_Done,
     /* 169533 */   // Label 3166: @169533
     /* 169533 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169566), // Rule ID 5673 //
     /* 169538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169557 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 169560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169564 */     GIR_RootConstrainSelectedInstOperands,
     /* 169565 */     // GIR_Coverage, 5673,
     /* 169565 */     GIR_EraseRootFromParent_Done,
     /* 169566 */   // Label 3167: @169566
     /* 169566 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169599), // Rule ID 5675 //
     /* 169571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169590 */     // (intrinsic_wo_chain:{ *:[f64] } 613:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 169593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169597 */     GIR_RootConstrainSelectedInstOperands,
     /* 169598 */     // GIR_Coverage, 5675,
     /* 169598 */     GIR_EraseRootFromParent_Done,
     /* 169599 */   // Label 3168: @169599
     /* 169599 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169632), // Rule ID 5677 //
     /* 169604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169623 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 169626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169630 */     GIR_RootConstrainSelectedInstOperands,
     /* 169631 */     // GIR_Coverage, 5677,
     /* 169631 */     GIR_EraseRootFromParent_Done,
     /* 169632 */   // Label 3169: @169632
     /* 169632 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169665), // Rule ID 5679 //
     /* 169637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169656 */     // (intrinsic_wo_chain:{ *:[f64] } 615:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 169659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169663 */     GIR_RootConstrainSelectedInstOperands,
     /* 169664 */     // GIR_Coverage, 5679,
     /* 169664 */     GIR_EraseRootFromParent_Done,
     /* 169665 */   // Label 3170: @169665
     /* 169665 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169698), // Rule ID 13376 //
     /* 169670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169689 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169696 */     GIR_RootConstrainSelectedInstOperands,
     /* 169697 */     // GIR_Coverage, 13376,
     /* 169697 */     GIR_EraseRootFromParent_Done,
     /* 169698 */   // Label 3171: @169698
     /* 169698 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169731), // Rule ID 13378 //
     /* 169703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169722 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169729 */     GIR_RootConstrainSelectedInstOperands,
     /* 169730 */     // GIR_Coverage, 13378,
     /* 169730 */     GIR_EraseRootFromParent_Done,
     /* 169731 */   // Label 3172: @169731
     /* 169731 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169764), // Rule ID 13380 //
     /* 169736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169755 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169762 */     GIR_RootConstrainSelectedInstOperands,
     /* 169763 */     // GIR_Coverage, 13380,
     /* 169763 */     GIR_EraseRootFromParent_Done,
     /* 169764 */   // Label 3173: @169764
     /* 169764 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169797), // Rule ID 13382 //
     /* 169769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169788 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169795 */     GIR_RootConstrainSelectedInstOperands,
     /* 169796 */     // GIR_Coverage, 13382,
     /* 169796 */     GIR_EraseRootFromParent_Done,
     /* 169797 */   // Label 3174: @169797
     /* 169797 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169912), // Rule ID 13383 //
     /* 169802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169821 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169821 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169824 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169828 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169833 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169894 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169911 */     // GIR_Coverage, 13383,
     /* 169911 */     GIR_EraseRootFromParent_Done,
     /* 169912 */   // Label 3175: @169912
     /* 169912 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(169945), // Rule ID 13385 //
     /* 169917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169936 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169943 */     GIR_RootConstrainSelectedInstOperands,
     /* 169944 */     // GIR_Coverage, 13385,
     /* 169944 */     GIR_EraseRootFromParent_Done,
     /* 169945 */   // Label 3176: @169945
     /* 169945 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(169978), // Rule ID 13387 //
     /* 169950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169969 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169976 */     GIR_RootConstrainSelectedInstOperands,
     /* 169977 */     // GIR_Coverage, 13387,
     /* 169977 */     GIR_EraseRootFromParent_Done,
     /* 169978 */   // Label 3177: @169978
     /* 169978 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170011), // Rule ID 13389 //
     /* 169983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170002 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 170005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170009 */     GIR_RootConstrainSelectedInstOperands,
     /* 170010 */     // GIR_Coverage, 13389,
     /* 170010 */     GIR_EraseRootFromParent_Done,
     /* 170011 */   // Label 3178: @170011
     /* 170011 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170044), // Rule ID 13391 //
     /* 170016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170035 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 170038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170042 */     GIR_RootConstrainSelectedInstOperands,
     /* 170043 */     // GIR_Coverage, 13391,
     /* 170043 */     GIR_EraseRootFromParent_Done,
     /* 170044 */   // Label 3179: @170044
     /* 170044 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170159), // Rule ID 13392 //
     /* 170049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170068 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170068 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170071 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 170075 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170080 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170158 */     // GIR_Coverage, 13392,
     /* 170158 */     GIR_EraseRootFromParent_Done,
     /* 170159 */   // Label 3180: @170159
     /* 170159 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(170278), // Rule ID 13393 //
     /* 170164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 170169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170183 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170183 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170186 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170190 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170195 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170199 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170277 */     // GIR_Coverage, 13393,
     /* 170277 */     GIR_EraseRootFromParent_Done,
     /* 170278 */   // Label 3181: @170278
     /* 170278 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(170393), // Rule ID 13394 //
     /* 170283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 170288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170302 */     // (intrinsic_wo_chain:{ *:[i64] } 672:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 170302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 170309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170314 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 170323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 170337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170375 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 170382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170392 */     // GIR_Coverage, 13394,
     /* 170392 */     GIR_EraseRootFromParent_Done,
     /* 170393 */   // Label 3182: @170393
     /* 170393 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(170512), // Rule ID 13395 //
     /* 170398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170417 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170417 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170420 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170424 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170429 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170433 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170494 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170511 */     // GIR_Coverage, 13395,
     /* 170511 */     GIR_EraseRootFromParent_Done,
     /* 170512 */   // Label 3183: @170512
     /* 170512 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(170627), // Rule ID 13396 //
     /* 170517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170536 */     // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 170536 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170539 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 170543 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170548 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 170557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 170571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 170616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170626 */     // GIR_Coverage, 13396,
     /* 170626 */     GIR_EraseRootFromParent_Done,
     /* 170627 */   // Label 3184: @170627
     /* 170627 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170660), // Rule ID 13398 //
     /* 170632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170651 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 170654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170658 */     GIR_RootConstrainSelectedInstOperands,
     /* 170659 */     // GIR_Coverage, 13398,
     /* 170659 */     GIR_EraseRootFromParent_Done,
     /* 170660 */   // Label 3185: @170660
     /* 170660 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170693), // Rule ID 13400 //
     /* 170665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170684 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 170687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170691 */     GIR_RootConstrainSelectedInstOperands,
     /* 170692 */     // GIR_Coverage, 13400,
     /* 170692 */     GIR_EraseRootFromParent_Done,
     /* 170693 */   // Label 3186: @170693
     /* 170693 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170726), // Rule ID 13402 //
     /* 170698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170717 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 170720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170724 */     GIR_RootConstrainSelectedInstOperands,
     /* 170725 */     // GIR_Coverage, 13402,
     /* 170725 */     GIR_EraseRootFromParent_Done,
     /* 170726 */   // Label 3187: @170726
     /* 170726 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170759), // Rule ID 13404 //
     /* 170731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170750 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 170753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170757 */     GIR_RootConstrainSelectedInstOperands,
     /* 170758 */     // GIR_Coverage, 13404,
     /* 170758 */     GIR_EraseRootFromParent_Done,
     /* 170759 */   // Label 3188: @170759
     /* 170759 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170874), // Rule ID 13405 //
     /* 170764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170783 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 170790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170795 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170856 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170873 */     // GIR_Coverage, 13405,
     /* 170873 */     GIR_EraseRootFromParent_Done,
     /* 170874 */   // Label 3189: @170874
     /* 170874 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170993), // Rule ID 13406 //
     /* 170879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170898 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 170905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170910 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170914 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170992 */     // GIR_Coverage, 13406,
     /* 170992 */     GIR_EraseRootFromParent_Done,
     /* 170993 */   // Label 3190: @170993
     /* 170993 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(171026), // Rule ID 13408 //
     /* 170998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171017 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 171020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171024 */     GIR_RootConstrainSelectedInstOperands,
     /* 171025 */     // GIR_Coverage, 13408,
     /* 171025 */     GIR_EraseRootFromParent_Done,
     /* 171026 */   // Label 3191: @171026
     /* 171026 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(171059), // Rule ID 13410 //
     /* 171031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171050 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 171053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171057 */     GIR_RootConstrainSelectedInstOperands,
     /* 171058 */     // GIR_Coverage, 13410,
     /* 171058 */     GIR_EraseRootFromParent_Done,
     /* 171059 */   // Label 3192: @171059
     /* 171059 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(171092), // Rule ID 13412 //
     /* 171064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171083 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 171086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171090 */     GIR_RootConstrainSelectedInstOperands,
     /* 171091 */     // GIR_Coverage, 13412,
     /* 171091 */     GIR_EraseRootFromParent_Done,
     /* 171092 */   // Label 3193: @171092
     /* 171092 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(171125), // Rule ID 13414 //
     /* 171097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171116 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 171119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171123 */     GIR_RootConstrainSelectedInstOperands,
     /* 171124 */     // GIR_Coverage, 13414,
     /* 171124 */     GIR_EraseRootFromParent_Done,
     /* 171125 */   // Label 3194: @171125
     /* 171125 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(171240), // Rule ID 13415 //
     /* 171130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171149 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 171156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171161 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171222 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171239 */     // GIR_Coverage, 13415,
     /* 171239 */     GIR_EraseRootFromParent_Done,
     /* 171240 */   // Label 3195: @171240
     /* 171240 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(171359), // Rule ID 13416 //
     /* 171245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 171250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171264 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171264 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171267 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 171271 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171276 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171280 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171312 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171315 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171358 */     // GIR_Coverage, 13416,
     /* 171358 */     GIR_EraseRootFromParent_Done,
     /* 171359 */   // Label 3196: @171359
     /* 171359 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(171392), // Rule ID 13418 //
     /* 171364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171383 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 171386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171390 */     GIR_RootConstrainSelectedInstOperands,
     /* 171391 */     // GIR_Coverage, 13418,
     /* 171391 */     GIR_EraseRootFromParent_Done,
     /* 171392 */   // Label 3197: @171392
     /* 171392 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(171425), // Rule ID 13420 //
     /* 171397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171416 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 171419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171423 */     GIR_RootConstrainSelectedInstOperands,
     /* 171424 */     // GIR_Coverage, 13420,
     /* 171424 */     GIR_EraseRootFromParent_Done,
     /* 171425 */   // Label 3198: @171425
     /* 171425 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(171458), // Rule ID 13422 //
     /* 171430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171449 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 171452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171456 */     GIR_RootConstrainSelectedInstOperands,
     /* 171457 */     // GIR_Coverage, 13422,
     /* 171457 */     GIR_EraseRootFromParent_Done,
     /* 171458 */   // Label 3199: @171458
     /* 171458 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(171491), // Rule ID 13424 //
     /* 171463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171482 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 171485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171489 */     GIR_RootConstrainSelectedInstOperands,
     /* 171490 */     // GIR_Coverage, 13424,
     /* 171490 */     GIR_EraseRootFromParent_Done,
     /* 171491 */   // Label 3200: @171491
     /* 171491 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(171606), // Rule ID 13425 //
     /* 171496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171515 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171515 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171518 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 171522 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171527 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171588 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171605 */     // GIR_Coverage, 13425,
     /* 171605 */     GIR_EraseRootFromParent_Done,
     /* 171606 */   // Label 3201: @171606
     /* 171606 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(171725), // Rule ID 13426 //
     /* 171611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171630 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 171637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171642 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171646 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171659 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171724 */     // GIR_Coverage, 13426,
     /* 171724 */     GIR_EraseRootFromParent_Done,
     /* 171725 */   // Label 3202: @171725
     /* 171725 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(171758), // Rule ID 13428 //
     /* 171730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171749 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 171752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171756 */     GIR_RootConstrainSelectedInstOperands,
     /* 171757 */     // GIR_Coverage, 13428,
     /* 171757 */     GIR_EraseRootFromParent_Done,
     /* 171758 */   // Label 3203: @171758
     /* 171758 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(171791), // Rule ID 13430 //
     /* 171763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171782 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 171785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171789 */     GIR_RootConstrainSelectedInstOperands,
     /* 171790 */     // GIR_Coverage, 13430,
     /* 171790 */     GIR_EraseRootFromParent_Done,
     /* 171791 */   // Label 3204: @171791
     /* 171791 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(171824), // Rule ID 13432 //
     /* 171796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171815 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 171818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171822 */     GIR_RootConstrainSelectedInstOperands,
     /* 171823 */     // GIR_Coverage, 13432,
     /* 171823 */     GIR_EraseRootFromParent_Done,
     /* 171824 */   // Label 3205: @171824
     /* 171824 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(171857), // Rule ID 13434 //
     /* 171829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171848 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 171851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171855 */     GIR_RootConstrainSelectedInstOperands,
     /* 171856 */     // GIR_Coverage, 13434,
     /* 171856 */     GIR_EraseRootFromParent_Done,
     /* 171857 */   // Label 3206: @171857
     /* 171857 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(171972), // Rule ID 13435 //
     /* 171862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171881 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171881 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171884 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 171888 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171893 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171925 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171954 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171971 */     // GIR_Coverage, 13435,
     /* 171971 */     GIR_EraseRootFromParent_Done,
     /* 171972 */   // Label 3207: @171972
     /* 171972 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(172091), // Rule ID 13436 //
     /* 171977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171996 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171996 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171999 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 172003 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172008 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 172012 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 172016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 172018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 172021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 172025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 172032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 172035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 172039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 172050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 172053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172073 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 172080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172090 */     // GIR_Coverage, 13436,
     /* 172090 */     GIR_EraseRootFromParent_Done,
     /* 172091 */   // Label 3208: @172091
     /* 172091 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(172123), // Rule ID 2397 //
     /* 172096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 172104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 172107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1679:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 172114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 172117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 172121 */     GIR_RootConstrainSelectedInstOperands,
     /* 172122 */     // GIR_Coverage, 2397,
     /* 172122 */     GIR_EraseRootFromParent_Done,
     /* 172123 */   // Label 3209: @172123
     /* 172123 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(172155), // Rule ID 2398 //
     /* 172128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 172136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 172139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1680:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 172146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 172149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 172153 */     GIR_RootConstrainSelectedInstOperands,
     /* 172154 */     // GIR_Coverage, 2398,
     /* 172154 */     GIR_EraseRootFromParent_Done,
     /* 172155 */   // Label 3210: @172155
     /* 172155 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(172187), // Rule ID 2399 //
     /* 172160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 172168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 172171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172178 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1681:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 172178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 2399,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3211: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(172219), // Rule ID 3108 //
     /* 172192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 172200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 172213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172217 */     GIR_RootConstrainSelectedInstOperands,
     /* 172218 */     // GIR_Coverage, 3108,
     /* 172218 */     GIR_EraseRootFromParent_Done,
     /* 172219 */   // Label 3212: @172219
     /* 172219 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(172251), // Rule ID 3109 //
     /* 172224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 172232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 172245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172249 */     GIR_RootConstrainSelectedInstOperands,
     /* 172250 */     // GIR_Coverage, 3109,
     /* 172250 */     GIR_EraseRootFromParent_Done,
     /* 172251 */   // Label 3213: @172251
     /* 172251 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(172283), // Rule ID 3110 //
     /* 172256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 172264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 172277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172281 */     GIR_RootConstrainSelectedInstOperands,
     /* 172282 */     // GIR_Coverage, 3110,
     /* 172282 */     GIR_EraseRootFromParent_Done,
     /* 172283 */   // Label 3214: @172283
     /* 172283 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(172315), // Rule ID 3368 //
     /* 172288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 172296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 172299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172306 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 172306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 172309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172313 */     GIR_RootConstrainSelectedInstOperands,
     /* 172314 */     // GIR_Coverage, 3368,
     /* 172314 */     GIR_EraseRootFromParent_Done,
     /* 172315 */   // Label 3215: @172315
     /* 172315 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(172347), // Rule ID 3369 //
     /* 172320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 172328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 172331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 172334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1671:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 172338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 172341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172345 */     GIR_RootConstrainSelectedInstOperands,
     /* 172346 */     // GIR_Coverage, 3369,
     /* 172346 */     GIR_EraseRootFromParent_Done,
     /* 172347 */   // Label 3216: @172347
     /* 172347 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(172379), // Rule ID 3370 //
     /* 172352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 172360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 172363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 172366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1671:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 172370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 172373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172377 */     GIR_RootConstrainSelectedInstOperands,
     /* 172378 */     // GIR_Coverage, 3370,
     /* 172378 */     GIR_EraseRootFromParent_Done,
     /* 172379 */   // Label 3217: @172379
     /* 172379 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(172411), // Rule ID 3452 //
     /* 172384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 172405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172409 */     GIR_RootConstrainSelectedInstOperands,
     /* 172410 */     // GIR_Coverage, 3452,
     /* 172410 */     GIR_EraseRootFromParent_Done,
     /* 172411 */   // Label 3218: @172411
     /* 172411 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(172443), // Rule ID 3453 //
     /* 172416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 172437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172441 */     GIR_RootConstrainSelectedInstOperands,
     /* 172442 */     // GIR_Coverage, 3453,
     /* 172442 */     GIR_EraseRootFromParent_Done,
     /* 172443 */   // Label 3219: @172443
     /* 172443 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(172475), // Rule ID 3454 //
     /* 172448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 172459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172466 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 172469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172473 */     GIR_RootConstrainSelectedInstOperands,
     /* 172474 */     // GIR_Coverage, 3454,
     /* 172474 */     GIR_EraseRootFromParent_Done,
     /* 172475 */   // Label 3220: @172475
     /* 172475 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(172507), // Rule ID 3479 //
     /* 172480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 172483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 172488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 172494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172498 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 172498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 172501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 172503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172505 */     GIR_RootConstrainSelectedInstOperands,
     /* 172506 */     // GIR_Coverage, 3479,
     /* 172506 */     GIR_EraseRootFromParent_Done,
     /* 172507 */   // Label 3221: @172507
     /* 172507 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(172539), // Rule ID 4694 //
     /* 172512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172530 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 172533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172537 */     GIR_RootConstrainSelectedInstOperands,
     /* 172538 */     // GIR_Coverage, 4694,
     /* 172538 */     GIR_EraseRootFromParent_Done,
     /* 172539 */   // Label 3222: @172539
     /* 172539 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(172571), // Rule ID 4695 //
     /* 172544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172562 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 172565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172569 */     GIR_RootConstrainSelectedInstOperands,
     /* 172570 */     // GIR_Coverage, 4695,
     /* 172570 */     GIR_EraseRootFromParent_Done,
     /* 172571 */   // Label 3223: @172571
     /* 172571 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(172600), // Rule ID 4696 //
     /* 172576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172591 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 172594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172598 */     GIR_RootConstrainSelectedInstOperands,
     /* 172599 */     // GIR_Coverage, 4696,
     /* 172599 */     GIR_EraseRootFromParent_Done,
     /* 172600 */   // Label 3224: @172600
     /* 172600 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(172629), // Rule ID 4697 //
     /* 172605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172620 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 172623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172627 */     GIR_RootConstrainSelectedInstOperands,
     /* 172628 */     // GIR_Coverage, 4697,
     /* 172628 */     GIR_EraseRootFromParent_Done,
     /* 172629 */   // Label 3225: @172629
     /* 172629 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(172658), // Rule ID 4698 //
     /* 172634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172649 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 172652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172656 */     GIR_RootConstrainSelectedInstOperands,
     /* 172657 */     // GIR_Coverage, 4698,
     /* 172657 */     GIR_EraseRootFromParent_Done,
     /* 172658 */   // Label 3226: @172658
     /* 172658 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(172687), // Rule ID 4699 //
     /* 172663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172678 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 172681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172685 */     GIR_RootConstrainSelectedInstOperands,
     /* 172686 */     // GIR_Coverage, 4699,
     /* 172686 */     GIR_EraseRootFromParent_Done,
     /* 172687 */   // Label 3227: @172687
     /* 172687 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(172719), // Rule ID 4706 //
     /* 172692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172710 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 172713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172717 */     GIR_RootConstrainSelectedInstOperands,
     /* 172718 */     // GIR_Coverage, 4706,
     /* 172718 */     GIR_EraseRootFromParent_Done,
     /* 172719 */   // Label 3228: @172719
     /* 172719 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(172751), // Rule ID 4707 //
     /* 172724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172742 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 172745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172749 */     GIR_RootConstrainSelectedInstOperands,
     /* 172750 */     // GIR_Coverage, 4707,
     /* 172750 */     GIR_EraseRootFromParent_Done,
     /* 172751 */   // Label 3229: @172751
     /* 172751 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(172780), // Rule ID 4708 //
     /* 172756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172771 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 172774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172778 */     GIR_RootConstrainSelectedInstOperands,
     /* 172779 */     // GIR_Coverage, 4708,
     /* 172779 */     GIR_EraseRootFromParent_Done,
     /* 172780 */   // Label 3230: @172780
     /* 172780 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(172809), // Rule ID 4709 //
     /* 172785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172800 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 172803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172807 */     GIR_RootConstrainSelectedInstOperands,
     /* 172808 */     // GIR_Coverage, 4709,
     /* 172808 */     GIR_EraseRootFromParent_Done,
     /* 172809 */   // Label 3231: @172809
     /* 172809 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(172838), // Rule ID 4710 //
     /* 172814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172829 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 172832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172836 */     GIR_RootConstrainSelectedInstOperands,
     /* 172837 */     // GIR_Coverage, 4710,
     /* 172837 */     GIR_EraseRootFromParent_Done,
     /* 172838 */   // Label 3232: @172838
     /* 172838 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(172867), // Rule ID 4711 //
     /* 172843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172858 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 172861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172865 */     GIR_RootConstrainSelectedInstOperands,
     /* 172866 */     // GIR_Coverage, 4711,
     /* 172866 */     GIR_EraseRootFromParent_Done,
     /* 172867 */   // Label 3233: @172867
     /* 172867 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(172896), // Rule ID 5006 //
     /* 172872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172887 */     // (intrinsic_wo_chain:{ *:[v4i16] } 602:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 172890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172894 */     GIR_RootConstrainSelectedInstOperands,
     /* 172895 */     // GIR_Coverage, 5006,
     /* 172895 */     GIR_EraseRootFromParent_Done,
     /* 172896 */   // Label 3234: @172896
     /* 172896 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172925), // Rule ID 5007 //
     /* 172901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172916 */     // (intrinsic_wo_chain:{ *:[v8i16] } 602:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 172919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172923 */     GIR_RootConstrainSelectedInstOperands,
     /* 172924 */     // GIR_Coverage, 5007,
     /* 172924 */     GIR_EraseRootFromParent_Done,
     /* 172925 */   // Label 3235: @172925
     /* 172925 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172954), // Rule ID 5008 //
     /* 172930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172945 */     // (intrinsic_wo_chain:{ *:[v2i32] } 602:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 172948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172952 */     GIR_RootConstrainSelectedInstOperands,
     /* 172953 */     // GIR_Coverage, 5008,
     /* 172953 */     GIR_EraseRootFromParent_Done,
     /* 172954 */   // Label 3236: @172954
     /* 172954 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172983), // Rule ID 5009 //
     /* 172959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172974 */     // (intrinsic_wo_chain:{ *:[v4i32] } 602:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 172977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172981 */     GIR_RootConstrainSelectedInstOperands,
     /* 172982 */     // GIR_Coverage, 5009,
     /* 172982 */     GIR_EraseRootFromParent_Done,
     /* 172983 */   // Label 3237: @172983
     /* 172983 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(173012), // Rule ID 5010 //
     /* 172988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173003 */     // (intrinsic_wo_chain:{ *:[v2i64] } 602:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 173003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 173006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173010 */     GIR_RootConstrainSelectedInstOperands,
     /* 173011 */     // GIR_Coverage, 5010,
     /* 173011 */     GIR_EraseRootFromParent_Done,
     /* 173012 */   // Label 3238: @173012
     /* 173012 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(173041), // Rule ID 5011 //
     /* 173017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 173022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173032 */     // (intrinsic_wo_chain:{ *:[v4i16] } 603:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 173032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 173035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173039 */     GIR_RootConstrainSelectedInstOperands,
     /* 173040 */     // GIR_Coverage, 5011,
     /* 173040 */     GIR_EraseRootFromParent_Done,
     /* 173041 */   // Label 3239: @173041
     /* 173041 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(173070), // Rule ID 5012 //
     /* 173046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 173051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173061 */     // (intrinsic_wo_chain:{ *:[v8i16] } 603:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 173061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 173064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173068 */     GIR_RootConstrainSelectedInstOperands,
     /* 173069 */     // GIR_Coverage, 5012,
     /* 173069 */     GIR_EraseRootFromParent_Done,
     /* 173070 */   // Label 3240: @173070
     /* 173070 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(173099), // Rule ID 5013 //
     /* 173075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 173080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173090 */     // (intrinsic_wo_chain:{ *:[v2i32] } 603:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 173090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 173093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173097 */     GIR_RootConstrainSelectedInstOperands,
     /* 173098 */     // GIR_Coverage, 5013,
     /* 173098 */     GIR_EraseRootFromParent_Done,
     /* 173099 */   // Label 3241: @173099
     /* 173099 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(173128), // Rule ID 5014 //
     /* 173104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 173109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173119 */     // (intrinsic_wo_chain:{ *:[v4i32] } 603:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 173119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 173122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173126 */     GIR_RootConstrainSelectedInstOperands,
     /* 173127 */     // GIR_Coverage, 5014,
     /* 173127 */     GIR_EraseRootFromParent_Done,
     /* 173128 */   // Label 3242: @173128
     /* 173128 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(173157), // Rule ID 5015 //
     /* 173133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 173138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173148 */     // (intrinsic_wo_chain:{ *:[v2i64] } 603:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 173148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 173151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173155 */     GIR_RootConstrainSelectedInstOperands,
     /* 173156 */     // GIR_Coverage, 5015,
     /* 173156 */     GIR_EraseRootFromParent_Done,
     /* 173157 */   // Label 3243: @173157
     /* 173157 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173189), // Rule ID 8526 //
     /* 173162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 173165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 173170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 173173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 173176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 173180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 173180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 173183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 173185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173187 */     GIR_RootConstrainSelectedInstOperands,
     /* 173188 */     // GIR_Coverage, 8526,
     /* 173188 */     GIR_EraseRootFromParent_Done,
     /* 173189 */   // Label 3244: @173189
     /* 173189 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173221), // Rule ID 8527 //
     /* 173194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 173197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 173202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 173205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 173208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 173212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1670:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 173212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 173215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 173217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173219 */     GIR_RootConstrainSelectedInstOperands,
     /* 173220 */     // GIR_Coverage, 8527,
     /* 173220 */     GIR_EraseRootFromParent_Done,
     /* 173221 */   // Label 3245: @173221
     /* 173221 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173253), // Rule ID 8528 //
     /* 173226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 173229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 173234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 173237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 173240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 173244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1670:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 173244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 173247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 173249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173251 */     GIR_RootConstrainSelectedInstOperands,
     /* 173252 */     // GIR_Coverage, 8528,
     /* 173252 */     GIR_EraseRootFromParent_Done,
     /* 173253 */   // Label 3246: @173253
     /* 173253 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173285), // Rule ID 11951 //
     /* 173258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 173266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 173272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 173276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 173279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173283 */     GIR_RootConstrainSelectedInstOperands,
     /* 173284 */     // GIR_Coverage, 11951,
     /* 173284 */     GIR_EraseRootFromParent_Done,
     /* 173285 */   // Label 3247: @173285
     /* 173285 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173317), // Rule ID 11952 //
     /* 173290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 173298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 173301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 173304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 173308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 173311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173315 */     GIR_RootConstrainSelectedInstOperands,
     /* 173316 */     // GIR_Coverage, 11952,
     /* 173316 */     GIR_EraseRootFromParent_Done,
     /* 173317 */   // Label 3248: @173317
     /* 173317 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173349), // Rule ID 11953 //
     /* 173322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 173330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 173333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 173336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 173340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 173343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173347 */     GIR_RootConstrainSelectedInstOperands,
     /* 173348 */     // GIR_Coverage, 11953,
     /* 173348 */     GIR_EraseRootFromParent_Done,
     /* 173349 */   // Label 3249: @173349
     /* 173349 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173381), // Rule ID 11954 //
     /* 173354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 173368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173372 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 173372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 173375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173379 */     GIR_RootConstrainSelectedInstOperands,
     /* 173380 */     // GIR_Coverage, 11954,
     /* 173380 */     GIR_EraseRootFromParent_Done,
     /* 173381 */   // Label 3250: @173381
     /* 173381 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173413), // Rule ID 11955 //
     /* 173386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 173397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 173400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 173404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 173407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173411 */     GIR_RootConstrainSelectedInstOperands,
     /* 173412 */     // GIR_Coverage, 11955,
     /* 173412 */     GIR_EraseRootFromParent_Done,
     /* 173413 */   // Label 3251: @173413
     /* 173413 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173445), // Rule ID 11956 //
     /* 173418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 173429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 173432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 173436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 173439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173443 */     GIR_RootConstrainSelectedInstOperands,
     /* 173444 */     // GIR_Coverage, 11956,
     /* 173444 */     GIR_EraseRootFromParent_Done,
     /* 173445 */   // Label 3252: @173445
     /* 173445 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(173477), // Rule ID 12222 //
     /* 173450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 173453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 173458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 173464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1270:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 173468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 173471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 173473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173475 */     GIR_RootConstrainSelectedInstOperands,
     /* 173476 */     // GIR_Coverage, 12222,
     /* 173476 */     GIR_EraseRootFromParent_Done,
     /* 173477 */   // Label 3253: @173477
     /* 173477 */   GIM_Reject,
     /* 173478 */ // Label 2934: @173478
     /* 173478 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(215915),
     /* 173483 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 173486 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(173670), // Rule ID 2568 //
     /* 173491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173540 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173543 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173552 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173581 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173585 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173589 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173594 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173598 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173602 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173606 */     // MIs[5] Operand 1
     /* 173606 */     // No operand predicates
     /* 173606 */     // MIs[3] Operand 2
     /* 173606 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173617 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173621 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173623 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173668 */     GIR_RootConstrainSelectedInstOperands,
     /* 173669 */     // GIR_Coverage, 2568,
     /* 173669 */     GIR_EraseRootFromParent_Done,
     /* 173670 */   // Label 3255: @173670
     /* 173670 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(173854), // Rule ID 6335 //
     /* 173675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173724 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173727 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173736 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173761 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173765 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173773 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173786 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173790 */     // MIs[5] Operand 1
     /* 173790 */     // No operand predicates
     /* 173790 */     // MIs[3] Operand 2
     /* 173790 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173805 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173807 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173819 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173852 */     GIR_RootConstrainSelectedInstOperands,
     /* 173853 */     // GIR_Coverage, 6335,
     /* 173853 */     GIR_EraseRootFromParent_Done,
     /* 173854 */   // Label 3256: @173854
     /* 173854 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174015), // Rule ID 2569 //
     /* 173859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173908 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173911 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173920 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173941 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173958 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173962 */     // MIs[4] Operand 1
     /* 173962 */     // No operand predicates
     /* 173962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173966 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173968 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 174010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 174013 */     GIR_RootConstrainSelectedInstOperands,
     /* 174014 */     // GIR_Coverage, 2569,
     /* 174014 */     GIR_EraseRootFromParent_Done,
     /* 174015 */   // Label 3257: @174015
     /* 174015 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(174176), // Rule ID 6336 //
     /* 174020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174069 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174072 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174081 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 174094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174111 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 174115 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174119 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174123 */     // MIs[4] Operand 1
     /* 174123 */     // No operand predicates
     /* 174123 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174127 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 174129 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 174129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174141 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 174171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 174174 */     GIR_RootConstrainSelectedInstOperands,
     /* 174175 */     // GIR_Coverage, 6336,
     /* 174175 */     GIR_EraseRootFromParent_Done,
     /* 174176 */   // Label 3258: @174176
     /* 174176 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174286), // Rule ID 2089 //
     /* 174181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174247 */     // MIs[3] Operand 1
     /* 174247 */     // No operand predicates
     /* 174247 */     // MIs[1] Operand 2
     /* 174247 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 174258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 174267 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 174270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 174277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174284 */     GIR_RootConstrainSelectedInstOperands,
     /* 174285 */     // GIR_Coverage, 2089,
     /* 174285 */     GIR_EraseRootFromParent_Done,
     /* 174286 */   // Label 3259: @174286
     /* 174286 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174396), // Rule ID 2092 //
     /* 174291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 174332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174357 */     // MIs[3] Operand 1
     /* 174357 */     // No operand predicates
     /* 174357 */     // MIs[1] Operand 2
     /* 174357 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 174368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 174377 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 174380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 174387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174394 */     GIR_RootConstrainSelectedInstOperands,
     /* 174395 */     // GIR_Coverage, 2092,
     /* 174395 */     GIR_EraseRootFromParent_Done,
     /* 174396 */   // Label 3260: @174396
     /* 174396 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(174518), // Rule ID 6997 //
     /* 174401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174436 */     // MIs[1] Operand 2
     /* 174436 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174455 */     // MIs[2] Rn
     /* 174455 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174460 */     // MIs[2] Operand 2
     /* 174460 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174473 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 174473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 174480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174500 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174517 */     // GIR_Coverage, 6997,
     /* 174517 */     GIR_EraseRootFromParent_Done,
     /* 174518 */   // Label 3261: @174518
     /* 174518 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(174640), // Rule ID 6999 //
     /* 174523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174558 */     // MIs[1] Operand 2
     /* 174558 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174577 */     // MIs[2] Rn
     /* 174577 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174582 */     // MIs[2] Operand 2
     /* 174582 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174595 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174622 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174639 */     // GIR_Coverage, 6999,
     /* 174639 */     GIR_EraseRootFromParent_Done,
     /* 174640 */   // Label 3262: @174640
     /* 174640 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(174762), // Rule ID 7001 //
     /* 174645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174680 */     // MIs[1] Operand 2
     /* 174680 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174699 */     // MIs[2] Rn
     /* 174699 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174704 */     // MIs[2] Operand 2
     /* 174704 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174717 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174761 */     // GIR_Coverage, 7001,
     /* 174761 */     GIR_EraseRootFromParent_Done,
     /* 174762 */   // Label 3263: @174762
     /* 174762 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(174884), // Rule ID 7003 //
     /* 174767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174802 */     // MIs[1] Operand 2
     /* 174802 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174821 */     // MIs[2] Rn
     /* 174821 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174826 */     // MIs[2] Operand 2
     /* 174826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174839 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174866 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174883 */     // GIR_Coverage, 7003,
     /* 174883 */     GIR_EraseRootFromParent_Done,
     /* 174884 */   // Label 3264: @174884
     /* 174884 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175006), // Rule ID 7005 //
     /* 174889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174924 */     // MIs[1] Operand 2
     /* 174924 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174943 */     // MIs[2] Rn
     /* 174943 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174948 */     // MIs[2] Operand 2
     /* 174948 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174961 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175005 */     // GIR_Coverage, 7005,
     /* 175005 */     GIR_EraseRootFromParent_Done,
     /* 175006 */   // Label 3265: @175006
     /* 175006 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175189), // Rule ID 2567 //
     /* 175011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 175060 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 175063 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175072 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175086 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 175092 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 175092 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 175095 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175099 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 175106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 175109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 175113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175118 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 175121 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 175125 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 175128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175155 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 175174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 175184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175187 */     GIR_RootConstrainSelectedInstOperands,
     /* 175188 */     // GIR_Coverage, 2567,
     /* 175188 */     GIR_EraseRootFromParent_Done,
     /* 175189 */   // Label 3266: @175189
     /* 175189 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175372), // Rule ID 6334 //
     /* 175194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 175243 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 175246 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175255 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175269 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 175275 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 175275 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 175278 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175282 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 175289 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 175292 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 175296 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175301 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 175304 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 175308 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 175311 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175316 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 175357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 175367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175370 */     GIR_RootConstrainSelectedInstOperands,
     /* 175371 */     // GIR_Coverage, 6334,
     /* 175371 */     GIR_EraseRootFromParent_Done,
     /* 175372 */   // Label 3267: @175372
     /* 175372 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175476), // Rule ID 13693 //
     /* 175377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175439 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175443 */     // MIs[3] Operand 1
     /* 175443 */     // No operand predicates
     /* 175443 */     // MIs[1] Operand 2
     /* 175443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175460 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 175463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175474 */     GIR_RootConstrainSelectedInstOperands,
     /* 175475 */     // GIR_Coverage, 13693,
     /* 175475 */     GIR_EraseRootFromParent_Done,
     /* 175476 */   // Label 3268: @175476
     /* 175476 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(175580), // Rule ID 13696 //
     /* 175481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175543 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175547 */     // MIs[3] Operand 1
     /* 175547 */     // No operand predicates
     /* 175547 */     // MIs[1] Operand 2
     /* 175547 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175564 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175578 */     GIR_RootConstrainSelectedInstOperands,
     /* 175579 */     // GIR_Coverage, 13696,
     /* 175579 */     GIR_EraseRootFromParent_Done,
     /* 175580 */   // Label 3269: @175580
     /* 175580 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(175711), // Rule ID 2524 //
     /* 175585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175627 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175660 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175664 */     // MIs[3] Operand 1
     /* 175664 */     // No operand predicates
     /* 175664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175666 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175709 */     GIR_RootConstrainSelectedInstOperands,
     /* 175710 */     // GIR_Coverage, 2524,
     /* 175710 */     GIR_EraseRootFromParent_Done,
     /* 175711 */   // Label 3270: @175711
     /* 175711 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(175842), // Rule ID 2525 //
     /* 175716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175758 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175791 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175795 */     // MIs[3] Operand 1
     /* 175795 */     // No operand predicates
     /* 175795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175797 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175840 */     GIR_RootConstrainSelectedInstOperands,
     /* 175841 */     // GIR_Coverage, 2525,
     /* 175841 */     GIR_EraseRootFromParent_Done,
     /* 175842 */   // Label 3271: @175842
     /* 175842 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(175973), // Rule ID 2526 //
     /* 175847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175926 */     // MIs[3] Operand 1
     /* 175926 */     // No operand predicates
     /* 175926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175928 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175940 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175971 */     GIR_RootConstrainSelectedInstOperands,
     /* 175972 */     // GIR_Coverage, 2526,
     /* 175972 */     GIR_EraseRootFromParent_Done,
     /* 175973 */   // Label 3272: @175973
     /* 175973 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176104), // Rule ID 13885 //
     /* 175978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176032 */     // MIs[2] Operand 1
     /* 176032 */     // No operand predicates
     /* 176032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 176036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 176048 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176053 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 176057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176059 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 176059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 176077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 176090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176102 */     GIR_RootConstrainSelectedInstOperands,
     /* 176103 */     // GIR_Coverage, 13885,
     /* 176103 */     GIR_EraseRootFromParent_Done,
     /* 176104 */   // Label 3273: @176104
     /* 176104 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176235), // Rule ID 13886 //
     /* 176109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176163 */     // MIs[2] Operand 1
     /* 176163 */     // No operand predicates
     /* 176163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 176167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176175 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 176179 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176184 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 176188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176190 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 176190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176202 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 176208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176233 */     GIR_RootConstrainSelectedInstOperands,
     /* 176234 */     // GIR_Coverage, 13886,
     /* 176234 */     GIR_EraseRootFromParent_Done,
     /* 176235 */   // Label 3274: @176235
     /* 176235 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176366), // Rule ID 13887 //
     /* 176240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 176294 */     // MIs[2] Operand 1
     /* 176294 */     // No operand predicates
     /* 176294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 176298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 176310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176315 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 176319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176321 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 176321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 176324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176333 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 176339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 176352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176364 */     GIR_RootConstrainSelectedInstOperands,
     /* 176365 */     // GIR_Coverage, 13887,
     /* 176365 */     GIR_EraseRootFromParent_Done,
     /* 176366 */   // Label 3275: @176366
     /* 176366 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176480), // Rule ID 2065 //
     /* 176371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176404 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176407 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176416 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176458 */     // MIs[3] Operand 1
     /* 176458 */     // No operand predicates
     /* 176458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176460 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176478 */     GIR_RootConstrainSelectedInstOperands,
     /* 176479 */     // GIR_Coverage, 2065,
     /* 176479 */     GIR_EraseRootFromParent_Done,
     /* 176480 */   // Label 3276: @176480
     /* 176480 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176594), // Rule ID 2072 //
     /* 176485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176518 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176521 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176530 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176572 */     // MIs[3] Operand 1
     /* 176572 */     // No operand predicates
     /* 176572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176574 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176592 */     GIR_RootConstrainSelectedInstOperands,
     /* 176593 */     // GIR_Coverage, 2072,
     /* 176593 */     GIR_EraseRootFromParent_Done,
     /* 176594 */   // Label 3277: @176594
     /* 176594 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(176698), // Rule ID 1991 //
     /* 176599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176665 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176669 */     // MIs[3] Operand 1
     /* 176669 */     // No operand predicates
     /* 176669 */     // MIs[1] Operand 2
     /* 176669 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176682 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176696 */     GIR_RootConstrainSelectedInstOperands,
     /* 176697 */     // GIR_Coverage, 1991,
     /* 176697 */     GIR_EraseRootFromParent_Done,
     /* 176698 */   // Label 3278: @176698
     /* 176698 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(176802), // Rule ID 2021 //
     /* 176703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176773 */     // MIs[3] Operand 1
     /* 176773 */     // No operand predicates
     /* 176773 */     // MIs[1] Operand 2
     /* 176773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176786 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176800 */     GIR_RootConstrainSelectedInstOperands,
     /* 176801 */     // GIR_Coverage, 2021,
     /* 176801 */     GIR_EraseRootFromParent_Done,
     /* 176802 */   // Label 3279: @176802
     /* 176802 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(176906), // Rule ID 2028 //
     /* 176807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176873 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176877 */     // MIs[3] Operand 1
     /* 176877 */     // No operand predicates
     /* 176877 */     // MIs[1] Operand 2
     /* 176877 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176890 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176904 */     GIR_RootConstrainSelectedInstOperands,
     /* 176905 */     // GIR_Coverage, 2028,
     /* 176905 */     GIR_EraseRootFromParent_Done,
     /* 176906 */   // Label 3280: @176906
     /* 176906 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177010), // Rule ID 2087 //
     /* 176911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176977 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176981 */     // MIs[3] Operand 1
     /* 176981 */     // No operand predicates
     /* 176981 */     // MIs[1] Operand 2
     /* 176981 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176994 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 176997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177008 */     GIR_RootConstrainSelectedInstOperands,
     /* 177009 */     // GIR_Coverage, 2087,
     /* 177009 */     GIR_EraseRootFromParent_Done,
     /* 177010 */   // Label 3281: @177010
     /* 177010 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177114), // Rule ID 1994 //
     /* 177015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177085 */     // MIs[3] Operand 1
     /* 177085 */     // No operand predicates
     /* 177085 */     // MIs[1] Operand 2
     /* 177085 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177098 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 177101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177112 */     GIR_RootConstrainSelectedInstOperands,
     /* 177113 */     // GIR_Coverage, 1994,
     /* 177113 */     GIR_EraseRootFromParent_Done,
     /* 177114 */   // Label 3282: @177114
     /* 177114 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177218), // Rule ID 2024 //
     /* 177119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177189 */     // MIs[3] Operand 1
     /* 177189 */     // No operand predicates
     /* 177189 */     // MIs[1] Operand 2
     /* 177189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177202 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 177205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177216 */     GIR_RootConstrainSelectedInstOperands,
     /* 177217 */     // GIR_Coverage, 2024,
     /* 177217 */     GIR_EraseRootFromParent_Done,
     /* 177218 */   // Label 3283: @177218
     /* 177218 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177322), // Rule ID 2031 //
     /* 177223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177293 */     // MIs[3] Operand 1
     /* 177293 */     // No operand predicates
     /* 177293 */     // MIs[1] Operand 2
     /* 177293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177306 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 177309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177320 */     GIR_RootConstrainSelectedInstOperands,
     /* 177321 */     // GIR_Coverage, 2031,
     /* 177321 */     GIR_EraseRootFromParent_Done,
     /* 177322 */   // Label 3284: @177322
     /* 177322 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177426), // Rule ID 2090 //
     /* 177327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177397 */     // MIs[3] Operand 1
     /* 177397 */     // No operand predicates
     /* 177397 */     // MIs[1] Operand 2
     /* 177397 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177410 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177424 */     GIR_RootConstrainSelectedInstOperands,
     /* 177425 */     // GIR_Coverage, 2090,
     /* 177425 */     GIR_EraseRootFromParent_Done,
     /* 177426 */   // Label 3285: @177426
     /* 177426 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177483), // Rule ID 1755 //
     /* 177431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177481 */     GIR_RootConstrainSelectedInstOperands,
     /* 177482 */     // GIR_Coverage, 1755,
     /* 177482 */     GIR_EraseRootFromParent_Done,
     /* 177483 */   // Label 3286: @177483
     /* 177483 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177540), // Rule ID 1757 //
     /* 177488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177523 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177538 */     GIR_RootConstrainSelectedInstOperands,
     /* 177539 */     // GIR_Coverage, 1757,
     /* 177539 */     GIR_EraseRootFromParent_Done,
     /* 177540 */   // Label 3287: @177540
     /* 177540 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177650), // Rule ID 6353 //
     /* 177545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177603 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177607 */     // MIs[2] Operand 1
     /* 177607 */     // No operand predicates
     /* 177607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177609 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177621 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177648 */     GIR_RootConstrainSelectedInstOperands,
     /* 177649 */     // GIR_Coverage, 6353,
     /* 177649 */     GIR_EraseRootFromParent_Done,
     /* 177650 */   // Label 3288: @177650
     /* 177650 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(177747), // Rule ID 14161 //
     /* 177655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177697 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177707 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177719 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177745 */     GIR_RootConstrainSelectedInstOperands,
     /* 177746 */     // GIR_Coverage, 14161,
     /* 177746 */     GIR_EraseRootFromParent_Done,
     /* 177747 */   // Label 3289: @177747
     /* 177747 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(177844), // Rule ID 14162 //
     /* 177752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177804 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177842 */     GIR_RootConstrainSelectedInstOperands,
     /* 177843 */     // GIR_Coverage, 14162,
     /* 177843 */     GIR_EraseRootFromParent_Done,
     /* 177844 */   // Label 3290: @177844
     /* 177844 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(177941), // Rule ID 14163 //
     /* 177849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177901 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177939 */     GIR_RootConstrainSelectedInstOperands,
     /* 177940 */     // GIR_Coverage, 14163,
     /* 177940 */     GIR_EraseRootFromParent_Done,
     /* 177941 */   // Label 3291: @177941
     /* 177941 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178021), // Rule ID 5285 //
     /* 177946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177976 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177979 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177988 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178004 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 178007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178019 */     GIR_RootConstrainSelectedInstOperands,
     /* 178020 */     // GIR_Coverage, 5285,
     /* 178020 */     GIR_EraseRootFromParent_Done,
     /* 178021 */   // Label 3292: @178021
     /* 178021 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178101), // Rule ID 5286 //
     /* 178026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 178068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 178072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178084 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 178087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178099 */     GIR_RootConstrainSelectedInstOperands,
     /* 178100 */     // GIR_Coverage, 5286,
     /* 178100 */     GIR_EraseRootFromParent_Done,
     /* 178101 */   // Label 3293: @178101
     /* 178101 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178198), // Rule ID 5282 //
     /* 178106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178152 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178158 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 178158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 178176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 178189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178196 */     GIR_RootConstrainSelectedInstOperands,
     /* 178197 */     // GIR_Coverage, 5282,
     /* 178197 */     GIR_EraseRootFromParent_Done,
     /* 178198 */   // Label 3294: @178198
     /* 178198 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178295), // Rule ID 5283 //
     /* 178203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178249 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178255 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 178255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 178273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 178286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178293 */     GIR_RootConstrainSelectedInstOperands,
     /* 178294 */     // GIR_Coverage, 5283,
     /* 178294 */     GIR_EraseRootFromParent_Done,
     /* 178295 */   // Label 3295: @178295
     /* 178295 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178392), // Rule ID 5284 //
     /* 178300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178346 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178352 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 178352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 178370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178390 */     GIR_RootConstrainSelectedInstOperands,
     /* 178391 */     // GIR_Coverage, 5284,
     /* 178391 */     GIR_EraseRootFromParent_Done,
     /* 178392 */   // Label 3296: @178392
     /* 178392 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178473), // Rule ID 13694 //
     /* 178397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178451 */     // MIs[2] Operand 1
     /* 178451 */     // No operand predicates
     /* 178451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178457 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178471 */     GIR_RootConstrainSelectedInstOperands,
     /* 178472 */     // GIR_Coverage, 13694,
     /* 178472 */     GIR_EraseRootFromParent_Done,
     /* 178473 */   // Label 3297: @178473
     /* 178473 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178554), // Rule ID 13695 //
     /* 178478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178532 */     // MIs[2] Operand 1
     /* 178532 */     // No operand predicates
     /* 178532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178538 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178552 */     GIR_RootConstrainSelectedInstOperands,
     /* 178553 */     // GIR_Coverage, 13695,
     /* 178553 */     GIR_EraseRootFromParent_Done,
     /* 178554 */   // Label 3298: @178554
     /* 178554 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178635), // Rule ID 13697 //
     /* 178559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178613 */     // MIs[2] Operand 1
     /* 178613 */     // No operand predicates
     /* 178613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178619 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 178622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178633 */     GIR_RootConstrainSelectedInstOperands,
     /* 178634 */     // GIR_Coverage, 13697,
     /* 178634 */     GIR_EraseRootFromParent_Done,
     /* 178635 */   // Label 3299: @178635
     /* 178635 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178716), // Rule ID 13698 //
     /* 178640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178694 */     // MIs[2] Operand 1
     /* 178694 */     // No operand predicates
     /* 178694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178700 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 178703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178714 */     GIR_RootConstrainSelectedInstOperands,
     /* 178715 */     // GIR_Coverage, 13698,
     /* 178715 */     GIR_EraseRootFromParent_Done,
     /* 178716 */   // Label 3300: @178716
     /* 178716 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(178797), // Rule ID 13699 //
     /* 178721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178775 */     // MIs[2] Operand 1
     /* 178775 */     // No operand predicates
     /* 178775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178781 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178795 */     GIR_RootConstrainSelectedInstOperands,
     /* 178796 */     // GIR_Coverage, 13699,
     /* 178796 */     GIR_EraseRootFromParent_Done,
     /* 178797 */   // Label 3301: @178797
     /* 178797 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(178878), // Rule ID 13700 //
     /* 178802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178856 */     // MIs[2] Operand 1
     /* 178856 */     // No operand predicates
     /* 178856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178862 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178876 */     GIR_RootConstrainSelectedInstOperands,
     /* 178877 */     // GIR_Coverage, 13700,
     /* 178877 */     GIR_EraseRootFromParent_Done,
     /* 178878 */   // Label 3302: @178878
     /* 178878 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(178959), // Rule ID 13701 //
     /* 178883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178937 */     // MIs[2] Operand 1
     /* 178937 */     // No operand predicates
     /* 178937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178943 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178957 */     GIR_RootConstrainSelectedInstOperands,
     /* 178958 */     // GIR_Coverage, 13701,
     /* 178958 */     GIR_EraseRootFromParent_Done,
     /* 178959 */   // Label 3303: @178959
     /* 178959 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179040), // Rule ID 13702 //
     /* 178964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179018 */     // MIs[2] Operand 1
     /* 179018 */     // No operand predicates
     /* 179018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179024 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 179027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179038 */     GIR_RootConstrainSelectedInstOperands,
     /* 179039 */     // GIR_Coverage, 13702,
     /* 179039 */     GIR_EraseRootFromParent_Done,
     /* 179040 */   // Label 3304: @179040
     /* 179040 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179146), // Rule ID 6350 //
     /* 179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 179071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 179075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179080 */     // MIs[1] Operand 2
     /* 179080 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 179091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 179095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 179103 */     // MIs[2] Operand 1
     /* 179103 */     // No operand predicates
     /* 179103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179105 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 179105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 179108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 179123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 179136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 179144 */     GIR_RootConstrainSelectedInstOperands,
     /* 179145 */     // GIR_Coverage, 6350,
     /* 179145 */     GIR_EraseRootFromParent_Done,
     /* 179146 */   // Label 3305: @179146
     /* 179146 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179227), // Rule ID 1992 //
     /* 179151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179209 */     // MIs[2] Operand 1
     /* 179209 */     // No operand predicates
     /* 179209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179211 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 179214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179225 */     GIR_RootConstrainSelectedInstOperands,
     /* 179226 */     // GIR_Coverage, 1992,
     /* 179226 */     GIR_EraseRootFromParent_Done,
     /* 179227 */   // Label 3306: @179227
     /* 179227 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179308), // Rule ID 1993 //
     /* 179232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179290 */     // MIs[2] Operand 1
     /* 179290 */     // No operand predicates
     /* 179290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179292 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 179295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179306 */     GIR_RootConstrainSelectedInstOperands,
     /* 179307 */     // GIR_Coverage, 1993,
     /* 179307 */     GIR_EraseRootFromParent_Done,
     /* 179308 */   // Label 3307: @179308
     /* 179308 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179389), // Rule ID 2022 //
     /* 179313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179371 */     // MIs[2] Operand 1
     /* 179371 */     // No operand predicates
     /* 179371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179373 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 179376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179387 */     GIR_RootConstrainSelectedInstOperands,
     /* 179388 */     // GIR_Coverage, 2022,
     /* 179388 */     GIR_EraseRootFromParent_Done,
     /* 179389 */   // Label 3308: @179389
     /* 179389 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179470), // Rule ID 2023 //
     /* 179394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179452 */     // MIs[2] Operand 1
     /* 179452 */     // No operand predicates
     /* 179452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179454 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179468 */     GIR_RootConstrainSelectedInstOperands,
     /* 179469 */     // GIR_Coverage, 2023,
     /* 179469 */     GIR_EraseRootFromParent_Done,
     /* 179470 */   // Label 3309: @179470
     /* 179470 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179551), // Rule ID 2029 //
     /* 179475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179533 */     // MIs[2] Operand 1
     /* 179533 */     // No operand predicates
     /* 179533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179535 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179549 */     GIR_RootConstrainSelectedInstOperands,
     /* 179550 */     // GIR_Coverage, 2029,
     /* 179550 */     GIR_EraseRootFromParent_Done,
     /* 179551 */   // Label 3310: @179551
     /* 179551 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179632), // Rule ID 2030 //
     /* 179556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179614 */     // MIs[2] Operand 1
     /* 179614 */     // No operand predicates
     /* 179614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 179619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179630 */     GIR_RootConstrainSelectedInstOperands,
     /* 179631 */     // GIR_Coverage, 2030,
     /* 179631 */     GIR_EraseRootFromParent_Done,
     /* 179632 */   // Label 3311: @179632
     /* 179632 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179713), // Rule ID 2088 //
     /* 179637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179695 */     // MIs[2] Operand 1
     /* 179695 */     // No operand predicates
     /* 179695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179697 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 179700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179711 */     GIR_RootConstrainSelectedInstOperands,
     /* 179712 */     // GIR_Coverage, 2088,
     /* 179712 */     GIR_EraseRootFromParent_Done,
     /* 179713 */   // Label 3312: @179713
     /* 179713 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179794), // Rule ID 1995 //
     /* 179718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179776 */     // MIs[2] Operand 1
     /* 179776 */     // No operand predicates
     /* 179776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179778 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 179781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179792 */     GIR_RootConstrainSelectedInstOperands,
     /* 179793 */     // GIR_Coverage, 1995,
     /* 179793 */     GIR_EraseRootFromParent_Done,
     /* 179794 */   // Label 3313: @179794
     /* 179794 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(179875), // Rule ID 1996 //
     /* 179799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179857 */     // MIs[2] Operand 1
     /* 179857 */     // No operand predicates
     /* 179857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179859 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 179862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179873 */     GIR_RootConstrainSelectedInstOperands,
     /* 179874 */     // GIR_Coverage, 1996,
     /* 179874 */     GIR_EraseRootFromParent_Done,
     /* 179875 */   // Label 3314: @179875
     /* 179875 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(179956), // Rule ID 2025 //
     /* 179880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179938 */     // MIs[2] Operand 1
     /* 179938 */     // No operand predicates
     /* 179938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179940 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 179943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179954 */     GIR_RootConstrainSelectedInstOperands,
     /* 179955 */     // GIR_Coverage, 2025,
     /* 179955 */     GIR_EraseRootFromParent_Done,
     /* 179956 */   // Label 3315: @179956
     /* 179956 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180037), // Rule ID 2026 //
     /* 179961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180019 */     // MIs[2] Operand 1
     /* 180019 */     // No operand predicates
     /* 180019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 180024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180035 */     GIR_RootConstrainSelectedInstOperands,
     /* 180036 */     // GIR_Coverage, 2026,
     /* 180036 */     GIR_EraseRootFromParent_Done,
     /* 180037 */   // Label 3316: @180037
     /* 180037 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180118), // Rule ID 2032 //
     /* 180042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180100 */     // MIs[2] Operand 1
     /* 180100 */     // No operand predicates
     /* 180100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180102 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 180105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180116 */     GIR_RootConstrainSelectedInstOperands,
     /* 180117 */     // GIR_Coverage, 2032,
     /* 180117 */     GIR_EraseRootFromParent_Done,
     /* 180118 */   // Label 3317: @180118
     /* 180118 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180199), // Rule ID 2033 //
     /* 180123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180181 */     // MIs[2] Operand 1
     /* 180181 */     // No operand predicates
     /* 180181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 180186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180197 */     GIR_RootConstrainSelectedInstOperands,
     /* 180198 */     // GIR_Coverage, 2033,
     /* 180198 */     GIR_EraseRootFromParent_Done,
     /* 180199 */   // Label 3318: @180199
     /* 180199 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180280), // Rule ID 2091 //
     /* 180204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180262 */     // MIs[2] Operand 1
     /* 180262 */     // No operand predicates
     /* 180262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180264 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 180267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180278 */     GIR_RootConstrainSelectedInstOperands,
     /* 180279 */     // GIR_Coverage, 2091,
     /* 180279 */     GIR_EraseRootFromParent_Done,
     /* 180280 */   // Label 3319: @180280
     /* 180280 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180361), // Rule ID 1997 //
     /* 180285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 180318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180339 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180343 */     // MIs[2] Operand 1
     /* 180343 */     // No operand predicates
     /* 180343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180345 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 180348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180359 */     GIR_RootConstrainSelectedInstOperands,
     /* 180360 */     // GIR_Coverage, 1997,
     /* 180360 */     GIR_EraseRootFromParent_Done,
     /* 180361 */   // Label 3320: @180361
     /* 180361 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(180442), // Rule ID 1998 //
     /* 180366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 180369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180424 */     // MIs[2] Operand 1
     /* 180424 */     // No operand predicates
     /* 180424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180426 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180440 */     GIR_RootConstrainSelectedInstOperands,
     /* 180441 */     // GIR_Coverage, 1998,
     /* 180441 */     GIR_EraseRootFromParent_Done,
     /* 180442 */   // Label 3321: @180442
     /* 180442 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(180523), // Rule ID 1999 //
     /* 180447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180505 */     // MIs[2] Operand 1
     /* 180505 */     // No operand predicates
     /* 180505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180507 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180521 */     GIR_RootConstrainSelectedInstOperands,
     /* 180522 */     // GIR_Coverage, 1999,
     /* 180522 */     GIR_EraseRootFromParent_Done,
     /* 180523 */   // Label 3322: @180523
     /* 180523 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(180604), // Rule ID 2000 //
     /* 180528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180582 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180586 */     // MIs[2] Operand 1
     /* 180586 */     // No operand predicates
     /* 180586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180588 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180602 */     GIR_RootConstrainSelectedInstOperands,
     /* 180603 */     // GIR_Coverage, 2000,
     /* 180603 */     GIR_EraseRootFromParent_Done,
     /* 180604 */   // Label 3323: @180604
     /* 180604 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180685), // Rule ID 2027 //
     /* 180609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180667 */     // MIs[2] Operand 1
     /* 180667 */     // No operand predicates
     /* 180667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180669 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 180672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180683 */     GIR_RootConstrainSelectedInstOperands,
     /* 180684 */     // GIR_Coverage, 2027,
     /* 180684 */     GIR_EraseRootFromParent_Done,
     /* 180685 */   // Label 3324: @180685
     /* 180685 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180766), // Rule ID 2034 //
     /* 180690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180748 */     // MIs[2] Operand 1
     /* 180748 */     // No operand predicates
     /* 180748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180750 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 180753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180764 */     GIR_RootConstrainSelectedInstOperands,
     /* 180765 */     // GIR_Coverage, 2034,
     /* 180765 */     GIR_EraseRootFromParent_Done,
     /* 180766 */   // Label 3325: @180766
     /* 180766 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180844), // Rule ID 6337 //
     /* 180771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180826 */     // MIs[2] Operand 1
     /* 180826 */     // No operand predicates
     /* 180826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180828 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 180828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 180831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 180839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180842 */     GIR_RootConstrainSelectedInstOperands,
     /* 180843 */     // GIR_Coverage, 6337,
     /* 180843 */     GIR_EraseRootFromParent_Done,
     /* 180844 */   // Label 3326: @180844
     /* 180844 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180904), // Rule ID 6403 //
     /* 180849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 180857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 180875 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 180875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 180878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 180895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180902 */     GIR_RootConstrainSelectedInstOperands,
     /* 180903 */     // GIR_Coverage, 6403,
     /* 180903 */     GIR_EraseRootFromParent_Done,
     /* 180904 */   // Label 3327: @180904
     /* 180904 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180964), // Rule ID 6404 //
     /* 180909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 180935 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 180935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 180938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180947 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 180955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180962 */     GIR_RootConstrainSelectedInstOperands,
     /* 180963 */     // GIR_Coverage, 6404,
     /* 180963 */     GIR_EraseRootFromParent_Done,
     /* 180964 */   // Label 3328: @180964
     /* 180964 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(181024), // Rule ID 6405 //
     /* 180969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 180995 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 180995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 180998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 181015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181022 */     GIR_RootConstrainSelectedInstOperands,
     /* 181023 */     // GIR_Coverage, 6405,
     /* 181023 */     GIR_EraseRootFromParent_Done,
     /* 181024 */   // Label 3329: @181024
     /* 181024 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(181071), // Rule ID 3930 //
     /* 181029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181051 */     // MIs[0] Operand 3
     /* 181051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 181062 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181069 */     GIR_RootConstrainSelectedInstOperands,
     /* 181070 */     // GIR_Coverage, 3930,
     /* 181070 */     GIR_EraseRootFromParent_Done,
     /* 181071 */   // Label 3330: @181071
     /* 181071 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181118), // Rule ID 3931 //
     /* 181076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181098 */     // MIs[0] Operand 3
     /* 181098 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 181109 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181116 */     GIR_RootConstrainSelectedInstOperands,
     /* 181117 */     // GIR_Coverage, 3931,
     /* 181117 */     GIR_EraseRootFromParent_Done,
     /* 181118 */   // Label 3331: @181118
     /* 181118 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181165), // Rule ID 3932 //
     /* 181123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181145 */     // MIs[0] Operand 3
     /* 181145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 181156 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181163 */     GIR_RootConstrainSelectedInstOperands,
     /* 181164 */     // GIR_Coverage, 3932,
     /* 181164 */     GIR_EraseRootFromParent_Done,
     /* 181165 */   // Label 3332: @181165
     /* 181165 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181212), // Rule ID 3933 //
     /* 181170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181192 */     // MIs[0] Operand 3
     /* 181192 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 181203 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181210 */     GIR_RootConstrainSelectedInstOperands,
     /* 181211 */     // GIR_Coverage, 3933,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 3333: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181258), // Rule ID 3571 //
     /* 181217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181239 */     // MIs[0] Idx
     /* 181239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 181247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 181247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 181250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181256 */     GIR_RootConstrainSelectedInstOperands,
     /* 181257 */     // GIR_Coverage, 3571,
     /* 181257 */     GIR_EraseRootFromParent_Done,
     /* 181258 */   // Label 3334: @181258
     /* 181258 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181304), // Rule ID 3572 //
     /* 181263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 181274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181285 */     // MIs[0] Idx
     /* 181285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 181293 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 181293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 181296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181302 */     GIR_RootConstrainSelectedInstOperands,
     /* 181303 */     // GIR_Coverage, 3572,
     /* 181303 */     GIR_EraseRootFromParent_Done,
     /* 181304 */   // Label 3335: @181304
     /* 181304 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181350), // Rule ID 3573 //
     /* 181309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 181320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181331 */     // MIs[0] Idx
     /* 181331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 181339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 181339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 181342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181348 */     GIR_RootConstrainSelectedInstOperands,
     /* 181349 */     // GIR_Coverage, 3573,
     /* 181349 */     GIR_EraseRootFromParent_Done,
     /* 181350 */   // Label 3336: @181350
     /* 181350 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181396), // Rule ID 3574 //
     /* 181355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 181366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181377 */     // MIs[0] Idx
     /* 181377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181385 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181394 */     GIR_RootConstrainSelectedInstOperands,
     /* 181395 */     // GIR_Coverage, 3574,
     /* 181395 */     GIR_EraseRootFromParent_Done,
     /* 181396 */   // Label 3337: @181396
     /* 181396 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181452), // Rule ID 2113 //
     /* 181401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181438 */     // MIs[1] Operand 1
     /* 181438 */     // No operand predicates
     /* 181438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181440 */     // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181450 */     GIR_RootConstrainSelectedInstOperands,
     /* 181451 */     // GIR_Coverage, 2113,
     /* 181451 */     GIR_EraseRootFromParent_Done,
     /* 181452 */   // Label 3338: @181452
     /* 181452 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(181508), // Rule ID 2114 //
     /* 181457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181494 */     // MIs[1] Operand 1
     /* 181494 */     // No operand predicates
     /* 181494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181496 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181506 */     GIR_RootConstrainSelectedInstOperands,
     /* 181507 */     // GIR_Coverage, 2114,
     /* 181507 */     GIR_EraseRootFromParent_Done,
     /* 181508 */   // Label 3339: @181508
     /* 181508 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181564), // Rule ID 2119 //
     /* 181513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181550 */     // MIs[1] Operand 1
     /* 181550 */     // No operand predicates
     /* 181550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181552 */     // (intrinsic_wo_chain:{ *:[i32] } 706:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181562 */     GIR_RootConstrainSelectedInstOperands,
     /* 181563 */     // GIR_Coverage, 2119,
     /* 181563 */     GIR_EraseRootFromParent_Done,
     /* 181564 */   // Label 3340: @181564
     /* 181564 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181620), // Rule ID 2120 //
     /* 181569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181606 */     // MIs[1] Operand 1
     /* 181606 */     // No operand predicates
     /* 181606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181608 */     // (intrinsic_wo_chain:{ *:[i32] } 707:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181618 */     GIR_RootConstrainSelectedInstOperands,
     /* 181619 */     // GIR_Coverage, 2120,
     /* 181619 */     GIR_EraseRootFromParent_Done,
     /* 181620 */   // Label 3341: @181620
     /* 181620 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181676), // Rule ID 2127 //
     /* 181625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 181633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181662 */     // MIs[1] Operand 1
     /* 181662 */     // No operand predicates
     /* 181662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181664 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 181667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181674 */     GIR_RootConstrainSelectedInstOperands,
     /* 181675 */     // GIR_Coverage, 2127,
     /* 181675 */     GIR_EraseRootFromParent_Done,
     /* 181676 */   // Label 3342: @181676
     /* 181676 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181732), // Rule ID 2130 //
     /* 181681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 181689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181718 */     // MIs[1] Operand 1
     /* 181718 */     // No operand predicates
     /* 181718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181720 */     // (intrinsic_wo_chain:{ *:[i32] } 753:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 181723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181730 */     GIR_RootConstrainSelectedInstOperands,
     /* 181731 */     // GIR_Coverage, 2130,
     /* 181731 */     GIR_EraseRootFromParent_Done,
     /* 181732 */   // Label 3343: @181732
     /* 181732 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181788), // Rule ID 2152 //
     /* 181737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 181774 */     // MIs[1] Operand 1
     /* 181774 */     // No operand predicates
     /* 181774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181776 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 181779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181786 */     GIR_RootConstrainSelectedInstOperands,
     /* 181787 */     // GIR_Coverage, 2152,
     /* 181787 */     GIR_EraseRootFromParent_Done,
     /* 181788 */   // Label 3344: @181788
     /* 181788 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181844), // Rule ID 2154 //
     /* 181793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 181830 */     // MIs[1] Operand 1
     /* 181830 */     // No operand predicates
     /* 181830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181832 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 181835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181842 */     GIR_RootConstrainSelectedInstOperands,
     /* 181843 */     // GIR_Coverage, 2154,
     /* 181843 */     GIR_EraseRootFromParent_Done,
     /* 181844 */   // Label 3345: @181844
     /* 181844 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181900), // Rule ID 2156 //
     /* 181849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 181886 */     // MIs[1] Operand 1
     /* 181886 */     // No operand predicates
     /* 181886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 181891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181898 */     GIR_RootConstrainSelectedInstOperands,
     /* 181899 */     // GIR_Coverage, 2156,
     /* 181899 */     GIR_EraseRootFromParent_Done,
     /* 181900 */   // Label 3346: @181900
     /* 181900 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181953), // Rule ID 6338 //
     /* 181905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181939 */     // MIs[1] Operand 1
     /* 181939 */     // No operand predicates
     /* 181939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181941 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 181944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181951 */     GIR_RootConstrainSelectedInstOperands,
     /* 181952 */     // GIR_Coverage, 6338,
     /* 181952 */     GIR_EraseRootFromParent_Done,
     /* 181953 */   // Label 3347: @181953
     /* 181953 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(182006), // Rule ID 6339 //
     /* 181958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181992 */     // MIs[1] Operand 1
     /* 181992 */     // No operand predicates
     /* 181992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181994 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 181997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182004 */     GIR_RootConstrainSelectedInstOperands,
     /* 182005 */     // GIR_Coverage, 6339,
     /* 182005 */     GIR_EraseRootFromParent_Done,
     /* 182006 */   // Label 3348: @182006
     /* 182006 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(182059), // Rule ID 6340 //
     /* 182011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182045 */     // MIs[1] Operand 1
     /* 182045 */     // No operand predicates
     /* 182045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182047 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182057 */     GIR_RootConstrainSelectedInstOperands,
     /* 182058 */     // GIR_Coverage, 6340,
     /* 182058 */     GIR_EraseRootFromParent_Done,
     /* 182059 */   // Label 3349: @182059
     /* 182059 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182112), // Rule ID 6341 //
     /* 182064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182098 */     // MIs[1] Operand 1
     /* 182098 */     // No operand predicates
     /* 182098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182100 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182110 */     GIR_RootConstrainSelectedInstOperands,
     /* 182111 */     // GIR_Coverage, 6341,
     /* 182111 */     GIR_EraseRootFromParent_Done,
     /* 182112 */   // Label 3350: @182112
     /* 182112 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182165), // Rule ID 6342 //
     /* 182117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182151 */     // MIs[1] Operand 1
     /* 182151 */     // No operand predicates
     /* 182151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182153 */     // (intrinsic_wo_chain:{ *:[v1i64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182163 */     GIR_RootConstrainSelectedInstOperands,
     /* 182164 */     // GIR_Coverage, 6342,
     /* 182164 */     GIR_EraseRootFromParent_Done,
     /* 182165 */   // Label 3351: @182165
     /* 182165 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182218), // Rule ID 6343 //
     /* 182170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182204 */     // MIs[1] Operand 1
     /* 182204 */     // No operand predicates
     /* 182204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182206 */     // (intrinsic_wo_chain:{ *:[v1i64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182216 */     GIR_RootConstrainSelectedInstOperands,
     /* 182217 */     // GIR_Coverage, 6343,
     /* 182217 */     GIR_EraseRootFromParent_Done,
     /* 182218 */   // Label 3352: @182218
     /* 182218 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182271), // Rule ID 6344 //
     /* 182223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182257 */     // MIs[1] Operand 1
     /* 182257 */     // No operand predicates
     /* 182257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182259 */     // (intrinsic_wo_chain:{ *:[f32] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 182262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182269 */     GIR_RootConstrainSelectedInstOperands,
     /* 182270 */     // GIR_Coverage, 6344,
     /* 182270 */     GIR_EraseRootFromParent_Done,
     /* 182271 */   // Label 3353: @182271
     /* 182271 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182324), // Rule ID 6345 //
     /* 182276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182310 */     // MIs[1] Operand 1
     /* 182310 */     // No operand predicates
     /* 182310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182312 */     // (intrinsic_wo_chain:{ *:[f64] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182322 */     GIR_RootConstrainSelectedInstOperands,
     /* 182323 */     // GIR_Coverage, 6345,
     /* 182323 */     GIR_EraseRootFromParent_Done,
     /* 182324 */   // Label 3354: @182324
     /* 182324 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182377), // Rule ID 6346 //
     /* 182329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182363 */     // MIs[1] Operand 1
     /* 182363 */     // No operand predicates
     /* 182363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182365 */     // (intrinsic_wo_chain:{ *:[v1f64] } 775:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182375 */     GIR_RootConstrainSelectedInstOperands,
     /* 182376 */     // GIR_Coverage, 6346,
     /* 182376 */     GIR_EraseRootFromParent_Done,
     /* 182377 */   // Label 3355: @182377
     /* 182377 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182430), // Rule ID 6347 //
     /* 182382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182416 */     // MIs[1] Operand 1
     /* 182416 */     // No operand predicates
     /* 182416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182418 */     // (intrinsic_wo_chain:{ *:[f64] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182428 */     GIR_RootConstrainSelectedInstOperands,
     /* 182429 */     // GIR_Coverage, 6347,
     /* 182429 */     GIR_EraseRootFromParent_Done,
     /* 182430 */   // Label 3356: @182430
     /* 182430 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(182483), // Rule ID 6348 //
     /* 182435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182469 */     // MIs[1] Operand 1
     /* 182469 */     // No operand predicates
     /* 182469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182471 */     // (intrinsic_wo_chain:{ *:[v1f64] } 776:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182481 */     GIR_RootConstrainSelectedInstOperands,
     /* 182482 */     // GIR_Coverage, 6348,
     /* 182482 */     GIR_EraseRootFromParent_Done,
     /* 182483 */   // Label 3357: @182483
     /* 182483 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182536), // Rule ID 6349 //
     /* 182488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182522 */     // MIs[1] Operand 1
     /* 182522 */     // No operand predicates
     /* 182522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182524 */     // (intrinsic_wo_chain:{ *:[f32] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182534 */     GIR_RootConstrainSelectedInstOperands,
     /* 182535 */     // GIR_Coverage, 6349,
     /* 182535 */     GIR_EraseRootFromParent_Done,
     /* 182536 */   // Label 3358: @182536
     /* 182536 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182618), // Rule ID 6351 //
     /* 182541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182575 */     // MIs[1] Operand 1
     /* 182575 */     // No operand predicates
     /* 182575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182577 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182589 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182616 */     GIR_RootConstrainSelectedInstOperands,
     /* 182617 */     // GIR_Coverage, 6351,
     /* 182617 */     GIR_EraseRootFromParent_Done,
     /* 182618 */   // Label 3359: @182618
     /* 182618 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182700), // Rule ID 6352 //
     /* 182623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182657 */     // MIs[1] Operand 1
     /* 182657 */     // No operand predicates
     /* 182657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182659 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182671 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182698 */     GIR_RootConstrainSelectedInstOperands,
     /* 182699 */     // GIR_Coverage, 6352,
     /* 182699 */     GIR_EraseRootFromParent_Done,
     /* 182700 */   // Label 3360: @182700
     /* 182700 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(182782), // Rule ID 6354 //
     /* 182705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182739 */     // MIs[1] Operand 1
     /* 182739 */     // No operand predicates
     /* 182739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182741 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182780 */     GIR_RootConstrainSelectedInstOperands,
     /* 182781 */     // GIR_Coverage, 6354,
     /* 182781 */     GIR_EraseRootFromParent_Done,
     /* 182782 */   // Label 3361: @182782
     /* 182782 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(182864), // Rule ID 6355 //
     /* 182787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182821 */     // MIs[1] Operand 1
     /* 182821 */     // No operand predicates
     /* 182821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182823 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182835 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182862 */     GIR_RootConstrainSelectedInstOperands,
     /* 182863 */     // GIR_Coverage, 6355,
     /* 182863 */     GIR_EraseRootFromParent_Done,
     /* 182864 */   // Label 3362: @182864
     /* 182864 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(182970), // Rule ID 6356 //
     /* 182869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182903 */     // MIs[1] Operand 1
     /* 182903 */     // No operand predicates
     /* 182903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182905 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182969 */     // GIR_Coverage, 6356,
     /* 182969 */     GIR_EraseRootFromParent_Done,
     /* 182970 */   // Label 3363: @182970
     /* 182970 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183076), // Rule ID 6357 //
     /* 182975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183009 */     // MIs[1] Operand 1
     /* 183009 */     // No operand predicates
     /* 183009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183011 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 183018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183075 */     // GIR_Coverage, 6357,
     /* 183075 */     GIR_EraseRootFromParent_Done,
     /* 183076 */   // Label 3364: @183076
     /* 183076 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183182), // Rule ID 6358 //
     /* 183081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 183115 */     // MIs[1] Operand 1
     /* 183115 */     // No operand predicates
     /* 183115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183117 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 183117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183181 */     // GIR_Coverage, 6358,
     /* 183181 */     GIR_EraseRootFromParent_Done,
     /* 183182 */   // Label 3365: @183182
     /* 183182 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183288), // Rule ID 6359 //
     /* 183187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183221 */     // MIs[1] Operand 1
     /* 183221 */     // No operand predicates
     /* 183221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183223 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183287 */     // GIR_Coverage, 6359,
     /* 183287 */     GIR_EraseRootFromParent_Done,
     /* 183288 */   // Label 3366: @183288
     /* 183288 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183346), // Rule ID 7058 //
     /* 183293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 183327 */     // MIs[1] Operand 1
     /* 183327 */     // No operand predicates
     /* 183327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183329 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 183329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 183332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183336 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 183341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 183344 */     GIR_RootConstrainSelectedInstOperands,
     /* 183345 */     // GIR_Coverage, 7058,
     /* 183345 */     GIR_EraseRootFromParent_Done,
     /* 183346 */   // Label 3367: @183346
     /* 183346 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183388), // Rule ID 3060 //
     /* 183351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183369 */     // MIs[0] Op2
     /* 183369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 183380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183386 */     GIR_RootConstrainSelectedInstOperands,
     /* 183387 */     // GIR_Coverage, 3060,
     /* 183387 */     GIR_EraseRootFromParent_Done,
     /* 183388 */   // Label 3368: @183388
     /* 183388 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183430), // Rule ID 3061 //
     /* 183393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183411 */     // MIs[0] Op2
     /* 183411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183428 */     GIR_RootConstrainSelectedInstOperands,
     /* 183429 */     // GIR_Coverage, 3061,
     /* 183429 */     GIR_EraseRootFromParent_Done,
     /* 183430 */   // Label 3369: @183430
     /* 183430 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183472), // Rule ID 3062 //
     /* 183435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183453 */     // MIs[0] Op2
     /* 183453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183470 */     GIR_RootConstrainSelectedInstOperands,
     /* 183471 */     // GIR_Coverage, 3062,
     /* 183471 */     GIR_EraseRootFromParent_Done,
     /* 183472 */   // Label 3370: @183472
     /* 183472 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183514), // Rule ID 3096 //
     /* 183477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183495 */     // MIs[0] Op2
     /* 183495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183503 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183512 */     GIR_RootConstrainSelectedInstOperands,
     /* 183513 */     // GIR_Coverage, 3096,
     /* 183513 */     GIR_EraseRootFromParent_Done,
     /* 183514 */   // Label 3371: @183514
     /* 183514 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(183556), // Rule ID 3097 //
     /* 183519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183537 */     // MIs[0] Op2
     /* 183537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183554 */     GIR_RootConstrainSelectedInstOperands,
     /* 183555 */     // GIR_Coverage, 3097,
     /* 183555 */     GIR_EraseRootFromParent_Done,
     /* 183556 */   // Label 3372: @183556
     /* 183556 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(183598), // Rule ID 3098 //
     /* 183561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183579 */     // MIs[0] Op2
     /* 183579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183596 */     GIR_RootConstrainSelectedInstOperands,
     /* 183597 */     // GIR_Coverage, 3098,
     /* 183597 */     GIR_EraseRootFromParent_Done,
     /* 183598 */   // Label 3373: @183598
     /* 183598 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(183640), // Rule ID 3557 //
     /* 183603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183621 */     // MIs[0] Op2
     /* 183621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 183629 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1355:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 183629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 183632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183638 */     GIR_RootConstrainSelectedInstOperands,
     /* 183639 */     // GIR_Coverage, 3557,
     /* 183639 */     GIR_EraseRootFromParent_Done,
     /* 183640 */   // Label 3374: @183640
     /* 183640 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(183682), // Rule ID 3558 //
     /* 183645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183663 */     // MIs[0] Op2
     /* 183663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1355:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183680 */     GIR_RootConstrainSelectedInstOperands,
     /* 183681 */     // GIR_Coverage, 3558,
     /* 183681 */     GIR_EraseRootFromParent_Done,
     /* 183682 */   // Label 3375: @183682
     /* 183682 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(183724), // Rule ID 3559 //
     /* 183687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183705 */     // MIs[0] Op2
     /* 183705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1355:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183722 */     GIR_RootConstrainSelectedInstOperands,
     /* 183723 */     // GIR_Coverage, 3559,
     /* 183723 */     GIR_EraseRootFromParent_Done,
     /* 183724 */   // Label 3376: @183724
     /* 183724 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(183766), // Rule ID 3560 //
     /* 183729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183747 */     // MIs[0] Op2
     /* 183747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1355:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183764 */     GIR_RootConstrainSelectedInstOperands,
     /* 183765 */     // GIR_Coverage, 3560,
     /* 183765 */     GIR_EraseRootFromParent_Done,
     /* 183766 */   // Label 3377: @183766
     /* 183766 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(183808), // Rule ID 3561 //
     /* 183771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183789 */     // MIs[0] Op2
     /* 183789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183806 */     GIR_RootConstrainSelectedInstOperands,
     /* 183807 */     // GIR_Coverage, 3561,
     /* 183807 */     GIR_EraseRootFromParent_Done,
     /* 183808 */   // Label 3378: @183808
     /* 183808 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(183850), // Rule ID 3562 //
     /* 183813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183831 */     // MIs[0] Op2
     /* 183831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183839 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183848 */     GIR_RootConstrainSelectedInstOperands,
     /* 183849 */     // GIR_Coverage, 3562,
     /* 183849 */     GIR_EraseRootFromParent_Done,
     /* 183850 */   // Label 3379: @183850
     /* 183850 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(183892), // Rule ID 3563 //
     /* 183855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183873 */     // MIs[0] Op2
     /* 183873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183881 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183890 */     GIR_RootConstrainSelectedInstOperands,
     /* 183891 */     // GIR_Coverage, 3563,
     /* 183891 */     GIR_EraseRootFromParent_Done,
     /* 183892 */   // Label 3380: @183892
     /* 183892 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(183934), // Rule ID 11888 //
     /* 183897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183915 */     // MIs[0] Op2
     /* 183915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183923 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 183926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183932 */     GIR_RootConstrainSelectedInstOperands,
     /* 183933 */     // GIR_Coverage, 11888,
     /* 183933 */     GIR_EraseRootFromParent_Done,
     /* 183934 */   // Label 3381: @183934
     /* 183934 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183976), // Rule ID 11889 //
     /* 183939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183957 */     // MIs[0] Op2
     /* 183957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 183968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183974 */     GIR_RootConstrainSelectedInstOperands,
     /* 183975 */     // GIR_Coverage, 11889,
     /* 183975 */     GIR_EraseRootFromParent_Done,
     /* 183976 */   // Label 3382: @183976
     /* 183976 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(184018), // Rule ID 11890 //
     /* 183981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183999 */     // MIs[0] Op2
     /* 183999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 184010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184016 */     GIR_RootConstrainSelectedInstOperands,
     /* 184017 */     // GIR_Coverage, 11890,
     /* 184017 */     GIR_EraseRootFromParent_Done,
     /* 184018 */   // Label 3383: @184018
     /* 184018 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(184060), // Rule ID 11891 //
     /* 184023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184041 */     // MIs[0] Op2
     /* 184041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184049 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 184052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184058 */     GIR_RootConstrainSelectedInstOperands,
     /* 184059 */     // GIR_Coverage, 11891,
     /* 184059 */     GIR_EraseRootFromParent_Done,
     /* 184060 */   // Label 3384: @184060
     /* 184060 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(184102), // Rule ID 11892 //
     /* 184065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184083 */     // MIs[0] Op2
     /* 184083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 184094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184100 */     GIR_RootConstrainSelectedInstOperands,
     /* 184101 */     // GIR_Coverage, 11892,
     /* 184101 */     GIR_EraseRootFromParent_Done,
     /* 184102 */   // Label 3385: @184102
     /* 184102 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184144), // Rule ID 11893 //
     /* 184107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184125 */     // MIs[0] Op2
     /* 184125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 184136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184142 */     GIR_RootConstrainSelectedInstOperands,
     /* 184143 */     // GIR_Coverage, 11893,
     /* 184143 */     GIR_EraseRootFromParent_Done,
     /* 184144 */   // Label 3386: @184144
     /* 184144 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184186), // Rule ID 11895 //
     /* 184149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184167 */     // MIs[0] Op2
     /* 184167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184175 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 184178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184184 */     GIR_RootConstrainSelectedInstOperands,
     /* 184185 */     // GIR_Coverage, 11895,
     /* 184185 */     GIR_EraseRootFromParent_Done,
     /* 184186 */   // Label 3387: @184186
     /* 184186 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184228), // Rule ID 11897 //
     /* 184191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184209 */     // MIs[0] Op2
     /* 184209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184217 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 184220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184226 */     GIR_RootConstrainSelectedInstOperands,
     /* 184227 */     // GIR_Coverage, 11897,
     /* 184227 */     GIR_EraseRootFromParent_Done,
     /* 184228 */   // Label 3388: @184228
     /* 184228 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184270), // Rule ID 11899 //
     /* 184233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184251 */     // MIs[0] Op2
     /* 184251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 184262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184268 */     GIR_RootConstrainSelectedInstOperands,
     /* 184269 */     // GIR_Coverage, 11899,
     /* 184269 */     GIR_EraseRootFromParent_Done,
     /* 184270 */   // Label 3389: @184270
     /* 184270 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184312), // Rule ID 11900 //
     /* 184275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184293 */     // MIs[0] Op2
     /* 184293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 184304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184310 */     GIR_RootConstrainSelectedInstOperands,
     /* 184311 */     // GIR_Coverage, 11900,
     /* 184311 */     GIR_EraseRootFromParent_Done,
     /* 184312 */   // Label 3390: @184312
     /* 184312 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184354), // Rule ID 11901 //
     /* 184317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184335 */     // MIs[0] Op2
     /* 184335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 184346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184352 */     GIR_RootConstrainSelectedInstOperands,
     /* 184353 */     // GIR_Coverage, 11901,
     /* 184353 */     GIR_EraseRootFromParent_Done,
     /* 184354 */   // Label 3391: @184354
     /* 184354 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184396), // Rule ID 11902 //
     /* 184359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184377 */     // MIs[0] Op2
     /* 184377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184385 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184394 */     GIR_RootConstrainSelectedInstOperands,
     /* 184395 */     // GIR_Coverage, 11902,
     /* 184395 */     GIR_EraseRootFromParent_Done,
     /* 184396 */   // Label 3392: @184396
     /* 184396 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184438), // Rule ID 11903 //
     /* 184401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184419 */     // MIs[0] Op2
     /* 184419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184427 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184436 */     GIR_RootConstrainSelectedInstOperands,
     /* 184437 */     // GIR_Coverage, 11903,
     /* 184437 */     GIR_EraseRootFromParent_Done,
     /* 184438 */   // Label 3393: @184438
     /* 184438 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184480), // Rule ID 11904 //
     /* 184443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184461 */     // MIs[0] Op2
     /* 184461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184478 */     GIR_RootConstrainSelectedInstOperands,
     /* 184479 */     // GIR_Coverage, 11904,
     /* 184479 */     GIR_EraseRootFromParent_Done,
     /* 184480 */   // Label 3394: @184480
     /* 184480 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184522), // Rule ID 11905 //
     /* 184485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184503 */     // MIs[0] Op2
     /* 184503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184520 */     GIR_RootConstrainSelectedInstOperands,
     /* 184521 */     // GIR_Coverage, 11905,
     /* 184521 */     GIR_EraseRootFromParent_Done,
     /* 184522 */   // Label 3395: @184522
     /* 184522 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(184564), // Rule ID 11906 //
     /* 184527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184545 */     // MIs[0] Op2
     /* 184545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184553 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184562 */     GIR_RootConstrainSelectedInstOperands,
     /* 184563 */     // GIR_Coverage, 11906,
     /* 184563 */     GIR_EraseRootFromParent_Done,
     /* 184564 */   // Label 3396: @184564
     /* 184564 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(184606), // Rule ID 11907 //
     /* 184569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184587 */     // MIs[0] Op2
     /* 184587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184604 */     GIR_RootConstrainSelectedInstOperands,
     /* 184605 */     // GIR_Coverage, 11907,
     /* 184605 */     GIR_EraseRootFromParent_Done,
     /* 184606 */   // Label 3397: @184606
     /* 184606 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(184648), // Rule ID 11908 //
     /* 184611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184629 */     // MIs[0] Op2
     /* 184629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 184640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184646 */     GIR_RootConstrainSelectedInstOperands,
     /* 184647 */     // GIR_Coverage, 11908,
     /* 184647 */     GIR_EraseRootFromParent_Done,
     /* 184648 */   // Label 3398: @184648
     /* 184648 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(184690), // Rule ID 11909 //
     /* 184653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184671 */     // MIs[0] Op2
     /* 184671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184679 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 184682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184688 */     GIR_RootConstrainSelectedInstOperands,
     /* 184689 */     // GIR_Coverage, 11909,
     /* 184689 */     GIR_EraseRootFromParent_Done,
     /* 184690 */   // Label 3399: @184690
     /* 184690 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(184732), // Rule ID 11910 //
     /* 184695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184713 */     // MIs[0] Op2
     /* 184713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184716 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 184724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184730 */     GIR_RootConstrainSelectedInstOperands,
     /* 184731 */     // GIR_Coverage, 11910,
     /* 184731 */     GIR_EraseRootFromParent_Done,
     /* 184732 */   // Label 3400: @184732
     /* 184732 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(184774), // Rule ID 11911 //
     /* 184737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184755 */     // MIs[0] Op2
     /* 184755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184763 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 184766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184772 */     GIR_RootConstrainSelectedInstOperands,
     /* 184773 */     // GIR_Coverage, 11911,
     /* 184773 */     GIR_EraseRootFromParent_Done,
     /* 184774 */   // Label 3401: @184774
     /* 184774 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184816), // Rule ID 11969 //
     /* 184779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184797 */     // MIs[0] Op2
     /* 184797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 184808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184814 */     GIR_RootConstrainSelectedInstOperands,
     /* 184815 */     // GIR_Coverage, 11969,
     /* 184815 */     GIR_EraseRootFromParent_Done,
     /* 184816 */   // Label 3402: @184816
     /* 184816 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184858), // Rule ID 11970 //
     /* 184821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184839 */     // MIs[0] Op2
     /* 184839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 184850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184856 */     GIR_RootConstrainSelectedInstOperands,
     /* 184857 */     // GIR_Coverage, 11970,
     /* 184857 */     GIR_EraseRootFromParent_Done,
     /* 184858 */   // Label 3403: @184858
     /* 184858 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184900), // Rule ID 11971 //
     /* 184863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184881 */     // MIs[0] Op2
     /* 184881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 184892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184898 */     GIR_RootConstrainSelectedInstOperands,
     /* 184899 */     // GIR_Coverage, 11971,
     /* 184899 */     GIR_EraseRootFromParent_Done,
     /* 184900 */   // Label 3404: @184900
     /* 184900 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184942), // Rule ID 11972 //
     /* 184905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184923 */     // MIs[0] Op2
     /* 184923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 184934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184940 */     GIR_RootConstrainSelectedInstOperands,
     /* 184941 */     // GIR_Coverage, 11972,
     /* 184941 */     GIR_EraseRootFromParent_Done,
     /* 184942 */   // Label 3405: @184942
     /* 184942 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184984), // Rule ID 11973 //
     /* 184947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184965 */     // MIs[0] Op2
     /* 184965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 184976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184982 */     GIR_RootConstrainSelectedInstOperands,
     /* 184983 */     // GIR_Coverage, 11973,
     /* 184983 */     GIR_EraseRootFromParent_Done,
     /* 184984 */   // Label 3406: @184984
     /* 184984 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(185026), // Rule ID 11974 //
     /* 184989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185007 */     // MIs[0] Op2
     /* 185007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 185018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185024 */     GIR_RootConstrainSelectedInstOperands,
     /* 185025 */     // GIR_Coverage, 11974,
     /* 185025 */     GIR_EraseRootFromParent_Done,
     /* 185026 */   // Label 3407: @185026
     /* 185026 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(185068), // Rule ID 11975 //
     /* 185031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185049 */     // MIs[0] Op2
     /* 185049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 185060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185066 */     GIR_RootConstrainSelectedInstOperands,
     /* 185067 */     // GIR_Coverage, 11975,
     /* 185067 */     GIR_EraseRootFromParent_Done,
     /* 185068 */   // Label 3408: @185068
     /* 185068 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185110), // Rule ID 11976 //
     /* 185073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185091 */     // MIs[0] Op2
     /* 185091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 185102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185108 */     GIR_RootConstrainSelectedInstOperands,
     /* 185109 */     // GIR_Coverage, 11976,
     /* 185109 */     GIR_EraseRootFromParent_Done,
     /* 185110 */   // Label 3409: @185110
     /* 185110 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185152), // Rule ID 11977 //
     /* 185115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185133 */     // MIs[0] Op2
     /* 185133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 185144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185150 */     GIR_RootConstrainSelectedInstOperands,
     /* 185151 */     // GIR_Coverage, 11977,
     /* 185151 */     GIR_EraseRootFromParent_Done,
     /* 185152 */   // Label 3410: @185152
     /* 185152 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185204), // Rule ID 2136 //
     /* 185157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185190 */     // MIs[1] Operand 1
     /* 185190 */     // No operand predicates
     /* 185190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185192 */     // (intrinsic_wo_chain:{ *:[v4i16] } 772:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 185195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185202 */     GIR_RootConstrainSelectedInstOperands,
     /* 185203 */     // GIR_Coverage, 2136,
     /* 185203 */     GIR_EraseRootFromParent_Done,
     /* 185204 */   // Label 3411: @185204
     /* 185204 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185256), // Rule ID 2137 //
     /* 185209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185242 */     // MIs[1] Operand 1
     /* 185242 */     // No operand predicates
     /* 185242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 772:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 185247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185254 */     GIR_RootConstrainSelectedInstOperands,
     /* 185255 */     // GIR_Coverage, 2137,
     /* 185255 */     GIR_EraseRootFromParent_Done,
     /* 185256 */   // Label 3412: @185256
     /* 185256 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185308), // Rule ID 2138 //
     /* 185261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185294 */     // MIs[1] Operand 1
     /* 185294 */     // No operand predicates
     /* 185294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185296 */     // (intrinsic_wo_chain:{ *:[v2i32] } 772:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 185299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185306 */     GIR_RootConstrainSelectedInstOperands,
     /* 185307 */     // GIR_Coverage, 2138,
     /* 185307 */     GIR_EraseRootFromParent_Done,
     /* 185308 */   // Label 3413: @185308
     /* 185308 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185360), // Rule ID 2139 //
     /* 185313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185346 */     // MIs[1] Operand 1
     /* 185346 */     // No operand predicates
     /* 185346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 772:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 185351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185358 */     GIR_RootConstrainSelectedInstOperands,
     /* 185359 */     // GIR_Coverage, 2139,
     /* 185359 */     GIR_EraseRootFromParent_Done,
     /* 185360 */   // Label 3414: @185360
     /* 185360 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185412), // Rule ID 2140 //
     /* 185365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185398 */     // MIs[1] Operand 1
     /* 185398 */     // No operand predicates
     /* 185398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 772:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185410 */     GIR_RootConstrainSelectedInstOperands,
     /* 185411 */     // GIR_Coverage, 2140,
     /* 185411 */     GIR_EraseRootFromParent_Done,
     /* 185412 */   // Label 3415: @185412
     /* 185412 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185464), // Rule ID 2141 //
     /* 185417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185450 */     // MIs[1] Operand 1
     /* 185450 */     // No operand predicates
     /* 185450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185452 */     // (intrinsic_wo_chain:{ *:[v4i16] } 773:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185462 */     GIR_RootConstrainSelectedInstOperands,
     /* 185463 */     // GIR_Coverage, 2141,
     /* 185463 */     GIR_EraseRootFromParent_Done,
     /* 185464 */   // Label 3416: @185464
     /* 185464 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(185516), // Rule ID 2142 //
     /* 185469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185502 */     // MIs[1] Operand 1
     /* 185502 */     // No operand predicates
     /* 185502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185504 */     // (intrinsic_wo_chain:{ *:[v8i16] } 773:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185514 */     GIR_RootConstrainSelectedInstOperands,
     /* 185515 */     // GIR_Coverage, 2142,
     /* 185515 */     GIR_EraseRootFromParent_Done,
     /* 185516 */   // Label 3417: @185516
     /* 185516 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(185568), // Rule ID 2143 //
     /* 185521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185554 */     // MIs[1] Operand 1
     /* 185554 */     // No operand predicates
     /* 185554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185556 */     // (intrinsic_wo_chain:{ *:[v2i32] } 773:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185566 */     GIR_RootConstrainSelectedInstOperands,
     /* 185567 */     // GIR_Coverage, 2143,
     /* 185567 */     GIR_EraseRootFromParent_Done,
     /* 185568 */   // Label 3418: @185568
     /* 185568 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(185620), // Rule ID 2144 //
     /* 185573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185606 */     // MIs[1] Operand 1
     /* 185606 */     // No operand predicates
     /* 185606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 773:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185618 */     GIR_RootConstrainSelectedInstOperands,
     /* 185619 */     // GIR_Coverage, 2144,
     /* 185619 */     GIR_EraseRootFromParent_Done,
     /* 185620 */   // Label 3419: @185620
     /* 185620 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(185672), // Rule ID 2145 //
     /* 185625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185658 */     // MIs[1] Operand 1
     /* 185658 */     // No operand predicates
     /* 185658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185660 */     // (intrinsic_wo_chain:{ *:[v2i64] } 773:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 185663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185670 */     GIR_RootConstrainSelectedInstOperands,
     /* 185671 */     // GIR_Coverage, 2145,
     /* 185671 */     GIR_EraseRootFromParent_Done,
     /* 185672 */   // Label 3420: @185672
     /* 185672 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(185724), // Rule ID 2146 //
     /* 185677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185710 */     // MIs[1] Operand 1
     /* 185710 */     // No operand predicates
     /* 185710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185712 */     // (intrinsic_wo_chain:{ *:[v4f16] } 775:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 185715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185722 */     GIR_RootConstrainSelectedInstOperands,
     /* 185723 */     // GIR_Coverage, 2146,
     /* 185723 */     GIR_EraseRootFromParent_Done,
     /* 185724 */   // Label 3421: @185724
     /* 185724 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(185776), // Rule ID 2147 //
     /* 185729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185762 */     // MIs[1] Operand 1
     /* 185762 */     // No operand predicates
     /* 185762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185764 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 185767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185774 */     GIR_RootConstrainSelectedInstOperands,
     /* 185775 */     // GIR_Coverage, 2147,
     /* 185775 */     GIR_EraseRootFromParent_Done,
     /* 185776 */   // Label 3422: @185776
     /* 185776 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185828), // Rule ID 2148 //
     /* 185781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185814 */     // MIs[1] Operand 1
     /* 185814 */     // No operand predicates
     /* 185814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185816 */     // (intrinsic_wo_chain:{ *:[v2f32] } 775:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 185819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185826 */     GIR_RootConstrainSelectedInstOperands,
     /* 185827 */     // GIR_Coverage, 2148,
     /* 185827 */     GIR_EraseRootFromParent_Done,
     /* 185828 */   // Label 3423: @185828
     /* 185828 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185880), // Rule ID 2149 //
     /* 185833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185866 */     // MIs[1] Operand 1
     /* 185866 */     // No operand predicates
     /* 185866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185868 */     // (intrinsic_wo_chain:{ *:[v4f32] } 775:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 185871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185878 */     GIR_RootConstrainSelectedInstOperands,
     /* 185879 */     // GIR_Coverage, 2149,
     /* 185879 */     GIR_EraseRootFromParent_Done,
     /* 185880 */   // Label 3424: @185880
     /* 185880 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185932), // Rule ID 2150 //
     /* 185885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185918 */     // MIs[1] Operand 1
     /* 185918 */     // No operand predicates
     /* 185918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185920 */     // (intrinsic_wo_chain:{ *:[v2f64] } 775:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 185923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185930 */     GIR_RootConstrainSelectedInstOperands,
     /* 185931 */     // GIR_Coverage, 2150,
     /* 185931 */     GIR_EraseRootFromParent_Done,
     /* 185932 */   // Label 3425: @185932
     /* 185932 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185984), // Rule ID 2248 //
     /* 185937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185970 */     // MIs[1] Operand 1
     /* 185970 */     // No operand predicates
     /* 185970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185972 */     // (intrinsic_wo_chain:{ *:[v4f16] } 776:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 185975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185982 */     GIR_RootConstrainSelectedInstOperands,
     /* 185983 */     // GIR_Coverage, 2248,
     /* 185983 */     GIR_EraseRootFromParent_Done,
     /* 185984 */   // Label 3426: @185984
     /* 185984 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(186036), // Rule ID 2249 //
     /* 185989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186022 */     // MIs[1] Operand 1
     /* 186022 */     // No operand predicates
     /* 186022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186024 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186034 */     GIR_RootConstrainSelectedInstOperands,
     /* 186035 */     // GIR_Coverage, 2249,
     /* 186035 */     GIR_EraseRootFromParent_Done,
     /* 186036 */   // Label 3427: @186036
     /* 186036 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(186088), // Rule ID 2250 //
     /* 186041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186074 */     // MIs[1] Operand 1
     /* 186074 */     // No operand predicates
     /* 186074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186076 */     // (intrinsic_wo_chain:{ *:[v2f32] } 776:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 186079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186086 */     GIR_RootConstrainSelectedInstOperands,
     /* 186087 */     // GIR_Coverage, 2250,
     /* 186087 */     GIR_EraseRootFromParent_Done,
     /* 186088 */   // Label 3428: @186088
     /* 186088 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186140), // Rule ID 2251 //
     /* 186093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186126 */     // MIs[1] Operand 1
     /* 186126 */     // No operand predicates
     /* 186126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186128 */     // (intrinsic_wo_chain:{ *:[v4f32] } 776:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 186131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186138 */     GIR_RootConstrainSelectedInstOperands,
     /* 186139 */     // GIR_Coverage, 2251,
     /* 186139 */     GIR_EraseRootFromParent_Done,
     /* 186140 */   // Label 3429: @186140
     /* 186140 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186192), // Rule ID 2252 //
     /* 186145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186178 */     // MIs[1] Operand 1
     /* 186178 */     // No operand predicates
     /* 186178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186180 */     // (intrinsic_wo_chain:{ *:[v2f64] } 776:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 186183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186190 */     GIR_RootConstrainSelectedInstOperands,
     /* 186191 */     // GIR_Coverage, 2252,
     /* 186191 */     GIR_EraseRootFromParent_Done,
     /* 186192 */   // Label 3430: @186192
     /* 186192 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186237), // Rule ID 63 //
     /* 186197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 186200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 186205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186226 */     // (intrinsic_wo_chain:{ *:[i64] } 301:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 186226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 186229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186235 */     GIR_RootConstrainSelectedInstOperands,
     /* 186236 */     // GIR_Coverage, 63,
     /* 186236 */     GIR_EraseRootFromParent_Done,
     /* 186237 */   // Label 3431: @186237
     /* 186237 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186282), // Rule ID 129 //
     /* 186242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 186250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186271 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 186274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186280 */     GIR_RootConstrainSelectedInstOperands,
     /* 186281 */     // GIR_Coverage, 129,
     /* 186281 */     GIR_EraseRootFromParent_Done,
     /* 186282 */   // Label 3432: @186282
     /* 186282 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186327), // Rule ID 130 //
     /* 186287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 186295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186316 */     // (intrinsic_wo_chain:{ *:[i32] } 518:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 186319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186325 */     GIR_RootConstrainSelectedInstOperands,
     /* 186326 */     // GIR_Coverage, 130,
     /* 186326 */     GIR_EraseRootFromParent_Done,
     /* 186327 */   // Label 3433: @186327
     /* 186327 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186372), // Rule ID 131 //
     /* 186332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 186340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186361 */     // (intrinsic_wo_chain:{ *:[i32] } 519:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 186364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186370 */     GIR_RootConstrainSelectedInstOperands,
     /* 186371 */     // GIR_Coverage, 131,
     /* 186371 */     GIR_EraseRootFromParent_Done,
     /* 186372 */   // Label 3434: @186372
     /* 186372 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186417), // Rule ID 132 //
     /* 186377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186406 */     // (intrinsic_wo_chain:{ *:[i32] } 520:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186415 */     GIR_RootConstrainSelectedInstOperands,
     /* 186416 */     // GIR_Coverage, 132,
     /* 186416 */     GIR_EraseRootFromParent_Done,
     /* 186417 */   // Label 3435: @186417
     /* 186417 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186462), // Rule ID 133 //
     /* 186422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186451 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186460 */     GIR_RootConstrainSelectedInstOperands,
     /* 186461 */     // GIR_Coverage, 133,
     /* 186461 */     GIR_EraseRootFromParent_Done,
     /* 186462 */   // Label 3436: @186462
     /* 186462 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186507), // Rule ID 134 //
     /* 186467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186496 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186505 */     GIR_RootConstrainSelectedInstOperands,
     /* 186506 */     // GIR_Coverage, 134,
     /* 186506 */     GIR_EraseRootFromParent_Done,
     /* 186507 */   // Label 3437: @186507
     /* 186507 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(186552), // Rule ID 135 //
     /* 186512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186541 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186550 */     GIR_RootConstrainSelectedInstOperands,
     /* 186551 */     // GIR_Coverage, 135,
     /* 186551 */     GIR_EraseRootFromParent_Done,
     /* 186552 */   // Label 3438: @186552
     /* 186552 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(186597), // Rule ID 136 //
     /* 186557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186586 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186595 */     GIR_RootConstrainSelectedInstOperands,
     /* 186596 */     // GIR_Coverage, 136,
     /* 186596 */     GIR_EraseRootFromParent_Done,
     /* 186597 */   // Label 3439: @186597
     /* 186597 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(186642), // Rule ID 1046 //
     /* 186602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186631 */     // (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 186634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186640 */     GIR_RootConstrainSelectedInstOperands,
     /* 186641 */     // GIR_Coverage, 1046,
     /* 186641 */     GIR_EraseRootFromParent_Done,
     /* 186642 */   // Label 3440: @186642
     /* 186642 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(186687), // Rule ID 1047 //
     /* 186647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186676 */     // (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 186679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186685 */     GIR_RootConstrainSelectedInstOperands,
     /* 186686 */     // GIR_Coverage, 1047,
     /* 186686 */     GIR_EraseRootFromParent_Done,
     /* 186687 */   // Label 3441: @186687
     /* 186687 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(186732), // Rule ID 1048 //
     /* 186692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186721 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 186724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186730 */     GIR_RootConstrainSelectedInstOperands,
     /* 186731 */     // GIR_Coverage, 1048,
     /* 186731 */     GIR_EraseRootFromParent_Done,
     /* 186732 */   // Label 3442: @186732
     /* 186732 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(186777), // Rule ID 1049 //
     /* 186737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186766 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 186769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186775 */     GIR_RootConstrainSelectedInstOperands,
     /* 186776 */     // GIR_Coverage, 1049,
     /* 186776 */     GIR_EraseRootFromParent_Done,
     /* 186777 */   // Label 3443: @186777
     /* 186777 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(186822), // Rule ID 1050 //
     /* 186782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186811 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 186814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186820 */     GIR_RootConstrainSelectedInstOperands,
     /* 186821 */     // GIR_Coverage, 1050,
     /* 186821 */     GIR_EraseRootFromParent_Done,
     /* 186822 */   // Label 3444: @186822
     /* 186822 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(186867), // Rule ID 1051 //
     /* 186827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 186859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186865 */     GIR_RootConstrainSelectedInstOperands,
     /* 186866 */     // GIR_Coverage, 1051,
     /* 186866 */     GIR_EraseRootFromParent_Done,
     /* 186867 */   // Label 3445: @186867
     /* 186867 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186912), // Rule ID 1052 //
     /* 186872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186901 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 186904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186910 */     GIR_RootConstrainSelectedInstOperands,
     /* 186911 */     // GIR_Coverage, 1052,
     /* 186911 */     GIR_EraseRootFromParent_Done,
     /* 186912 */   // Label 3446: @186912
     /* 186912 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186957), // Rule ID 1094 //
     /* 186917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186946 */     // (intrinsic_wo_chain:{ *:[v8i8] } 764:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 186949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186955 */     GIR_RootConstrainSelectedInstOperands,
     /* 186956 */     // GIR_Coverage, 1094,
     /* 186956 */     GIR_EraseRootFromParent_Done,
     /* 186957 */   // Label 3447: @186957
     /* 186957 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(187002), // Rule ID 1095 //
     /* 186962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186991 */     // (intrinsic_wo_chain:{ *:[v16i8] } 764:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 186994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187000 */     GIR_RootConstrainSelectedInstOperands,
     /* 187001 */     // GIR_Coverage, 1095,
     /* 187001 */     GIR_EraseRootFromParent_Done,
     /* 187002 */   // Label 3448: @187002
     /* 187002 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(187047), // Rule ID 1096 //
     /* 187007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187036 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 187036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 187039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187045 */     GIR_RootConstrainSelectedInstOperands,
     /* 187046 */     // GIR_Coverage, 1096,
     /* 187046 */     GIR_EraseRootFromParent_Done,
     /* 187047 */   // Label 3449: @187047
     /* 187047 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(187092), // Rule ID 1097 //
     /* 187052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 764:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 187081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 187084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187090 */     GIR_RootConstrainSelectedInstOperands,
     /* 187091 */     // GIR_Coverage, 1097,
     /* 187091 */     GIR_EraseRootFromParent_Done,
     /* 187092 */   // Label 3450: @187092
     /* 187092 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187137), // Rule ID 1098 //
     /* 187097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187126 */     // (intrinsic_wo_chain:{ *:[v2i32] } 764:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 187126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 187129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187135 */     GIR_RootConstrainSelectedInstOperands,
     /* 187136 */     // GIR_Coverage, 1098,
     /* 187136 */     GIR_EraseRootFromParent_Done,
     /* 187137 */   // Label 3451: @187137
     /* 187137 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187182), // Rule ID 1099 //
     /* 187142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187171 */     // (intrinsic_wo_chain:{ *:[v4i32] } 764:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 187171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 187174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187180 */     GIR_RootConstrainSelectedInstOperands,
     /* 187181 */     // GIR_Coverage, 1099,
     /* 187181 */     GIR_EraseRootFromParent_Done,
     /* 187182 */   // Label 3452: @187182
     /* 187182 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187227), // Rule ID 1100 //
     /* 187187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 764:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 187216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 187219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187225 */     GIR_RootConstrainSelectedInstOperands,
     /* 187226 */     // GIR_Coverage, 1100,
     /* 187226 */     GIR_EraseRootFromParent_Done,
     /* 187227 */   // Label 3453: @187227
     /* 187227 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187272), // Rule ID 1112 //
     /* 187232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187261 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 187261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 187264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187270 */     GIR_RootConstrainSelectedInstOperands,
     /* 187271 */     // GIR_Coverage, 1112,
     /* 187271 */     GIR_EraseRootFromParent_Done,
     /* 187272 */   // Label 3454: @187272
     /* 187272 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187317), // Rule ID 1114 //
     /* 187277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187306 */     // (intrinsic_wo_chain:{ *:[v16i8] } 580:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 187306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 187309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187315 */     GIR_RootConstrainSelectedInstOperands,
     /* 187316 */     // GIR_Coverage, 1114,
     /* 187316 */     GIR_EraseRootFromParent_Done,
     /* 187317 */   // Label 3455: @187317
     /* 187317 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187362), // Rule ID 1116 //
     /* 187322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187351 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 187351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 187354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187360 */     GIR_RootConstrainSelectedInstOperands,
     /* 187361 */     // GIR_Coverage, 1116,
     /* 187361 */     GIR_EraseRootFromParent_Done,
     /* 187362 */   // Label 3456: @187362
     /* 187362 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187407), // Rule ID 1118 //
     /* 187367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187396 */     // (intrinsic_wo_chain:{ *:[v8i16] } 580:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187405 */     GIR_RootConstrainSelectedInstOperands,
     /* 187406 */     // GIR_Coverage, 1118,
     /* 187406 */     GIR_EraseRootFromParent_Done,
     /* 187407 */   // Label 3457: @187407
     /* 187407 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187452), // Rule ID 1120 //
     /* 187412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187441 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187450 */     GIR_RootConstrainSelectedInstOperands,
     /* 187451 */     // GIR_Coverage, 1120,
     /* 187451 */     GIR_EraseRootFromParent_Done,
     /* 187452 */   // Label 3458: @187452
     /* 187452 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187497), // Rule ID 1122 //
     /* 187457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 580:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187495 */     GIR_RootConstrainSelectedInstOperands,
     /* 187496 */     // GIR_Coverage, 1122,
     /* 187496 */     GIR_EraseRootFromParent_Done,
     /* 187497 */   // Label 3459: @187497
     /* 187497 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(187542), // Rule ID 1124 //
     /* 187502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187531 */     // (intrinsic_wo_chain:{ *:[v2i64] } 580:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187540 */     GIR_RootConstrainSelectedInstOperands,
     /* 187541 */     // GIR_Coverage, 1124,
     /* 187541 */     GIR_EraseRootFromParent_Done,
     /* 187542 */   // Label 3460: @187542
     /* 187542 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(187587), // Rule ID 1167 //
     /* 187547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187576 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187585 */     GIR_RootConstrainSelectedInstOperands,
     /* 187586 */     // GIR_Coverage, 1167,
     /* 187586 */     GIR_EraseRootFromParent_Done,
     /* 187587 */   // Label 3461: @187587
     /* 187587 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(187632), // Rule ID 1168 //
     /* 187592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187621 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 187624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187630 */     GIR_RootConstrainSelectedInstOperands,
     /* 187631 */     // GIR_Coverage, 1168,
     /* 187631 */     GIR_EraseRootFromParent_Done,
     /* 187632 */   // Label 3462: @187632
     /* 187632 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(187677), // Rule ID 1169 //
     /* 187637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187666 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 187669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187675 */     GIR_RootConstrainSelectedInstOperands,
     /* 187676 */     // GIR_Coverage, 1169,
     /* 187676 */     GIR_EraseRootFromParent_Done,
     /* 187677 */   // Label 3463: @187677
     /* 187677 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(187722), // Rule ID 1170 //
     /* 187682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187711 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 187714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187720 */     GIR_RootConstrainSelectedInstOperands,
     /* 187721 */     // GIR_Coverage, 1170,
     /* 187721 */     GIR_EraseRootFromParent_Done,
     /* 187722 */   // Label 3464: @187722
     /* 187722 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(187767), // Rule ID 1171 //
     /* 187727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187756 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 187759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187765 */     GIR_RootConstrainSelectedInstOperands,
     /* 187766 */     // GIR_Coverage, 1171,
     /* 187766 */     GIR_EraseRootFromParent_Done,
     /* 187767 */   // Label 3465: @187767
     /* 187767 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(187812), // Rule ID 1173 //
     /* 187772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187801 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 187804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187810 */     GIR_RootConstrainSelectedInstOperands,
     /* 187811 */     // GIR_Coverage, 1173,
     /* 187811 */     GIR_EraseRootFromParent_Done,
     /* 187812 */   // Label 3466: @187812
     /* 187812 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(187857), // Rule ID 1175 //
     /* 187817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187846 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 187849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187855 */     GIR_RootConstrainSelectedInstOperands,
     /* 187856 */     // GIR_Coverage, 1175,
     /* 187856 */     GIR_EraseRootFromParent_Done,
     /* 187857 */   // Label 3467: @187857
     /* 187857 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187902), // Rule ID 1177 //
     /* 187862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187891 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 187894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187900 */     GIR_RootConstrainSelectedInstOperands,
     /* 187901 */     // GIR_Coverage, 1177,
     /* 187901 */     GIR_EraseRootFromParent_Done,
     /* 187902 */   // Label 3468: @187902
     /* 187902 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187947), // Rule ID 1179 //
     /* 187907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187936 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 187939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187945 */     GIR_RootConstrainSelectedInstOperands,
     /* 187946 */     // GIR_Coverage, 1179,
     /* 187946 */     GIR_EraseRootFromParent_Done,
     /* 187947 */   // Label 3469: @187947
     /* 187947 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187992), // Rule ID 1181 //
     /* 187952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187981 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 187984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187990 */     GIR_RootConstrainSelectedInstOperands,
     /* 187991 */     // GIR_Coverage, 1181,
     /* 187991 */     GIR_EraseRootFromParent_Done,
     /* 187992 */   // Label 3470: @187992
     /* 187992 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(188037), // Rule ID 1183 //
     /* 187997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188026 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 188029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188035 */     GIR_RootConstrainSelectedInstOperands,
     /* 188036 */     // GIR_Coverage, 1183,
     /* 188036 */     GIR_EraseRootFromParent_Done,
     /* 188037 */   // Label 3471: @188037
     /* 188037 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(188082), // Rule ID 1185 //
     /* 188042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188071 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 188074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188080 */     GIR_RootConstrainSelectedInstOperands,
     /* 188081 */     // GIR_Coverage, 1185,
     /* 188081 */     GIR_EraseRootFromParent_Done,
     /* 188082 */   // Label 3472: @188082
     /* 188082 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188127), // Rule ID 1187 //
     /* 188087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188116 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 188119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188125 */     GIR_RootConstrainSelectedInstOperands,
     /* 188126 */     // GIR_Coverage, 1187,
     /* 188126 */     GIR_EraseRootFromParent_Done,
     /* 188127 */   // Label 3473: @188127
     /* 188127 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188172), // Rule ID 1189 //
     /* 188132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188161 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 188164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188170 */     GIR_RootConstrainSelectedInstOperands,
     /* 188171 */     // GIR_Coverage, 1189,
     /* 188171 */     GIR_EraseRootFromParent_Done,
     /* 188172 */   // Label 3474: @188172
     /* 188172 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188217), // Rule ID 1191 //
     /* 188177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188206 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 188209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188215 */     GIR_RootConstrainSelectedInstOperands,
     /* 188216 */     // GIR_Coverage, 1191,
     /* 188216 */     GIR_EraseRootFromParent_Done,
     /* 188217 */   // Label 3475: @188217
     /* 188217 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188262), // Rule ID 1193 //
     /* 188222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188251 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 188254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188260 */     GIR_RootConstrainSelectedInstOperands,
     /* 188261 */     // GIR_Coverage, 1193,
     /* 188261 */     GIR_EraseRootFromParent_Done,
     /* 188262 */   // Label 3476: @188262
     /* 188262 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188307), // Rule ID 1195 //
     /* 188267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188296 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 188299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188305 */     GIR_RootConstrainSelectedInstOperands,
     /* 188306 */     // GIR_Coverage, 1195,
     /* 188306 */     GIR_EraseRootFromParent_Done,
     /* 188307 */   // Label 3477: @188307
     /* 188307 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188352), // Rule ID 1197 //
     /* 188312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188341 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 188344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188350 */     GIR_RootConstrainSelectedInstOperands,
     /* 188351 */     // GIR_Coverage, 1197,
     /* 188351 */     GIR_EraseRootFromParent_Done,
     /* 188352 */   // Label 3478: @188352
     /* 188352 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188397), // Rule ID 1199 //
     /* 188357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188386 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188395 */     GIR_RootConstrainSelectedInstOperands,
     /* 188396 */     // GIR_Coverage, 1199,
     /* 188396 */     GIR_EraseRootFromParent_Done,
     /* 188397 */   // Label 3479: @188397
     /* 188397 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188442), // Rule ID 1201 //
     /* 188402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188431 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188440 */     GIR_RootConstrainSelectedInstOperands,
     /* 188441 */     // GIR_Coverage, 1201,
     /* 188441 */     GIR_EraseRootFromParent_Done,
     /* 188442 */   // Label 3480: @188442
     /* 188442 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188487), // Rule ID 1237 //
     /* 188447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188476 */     // (intrinsic_wo_chain:{ *:[v4f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188485 */     GIR_RootConstrainSelectedInstOperands,
     /* 188486 */     // GIR_Coverage, 1237,
     /* 188486 */     GIR_EraseRootFromParent_Done,
     /* 188487 */   // Label 3481: @188487
     /* 188487 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(188532), // Rule ID 1238 //
     /* 188492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188521 */     // (intrinsic_wo_chain:{ *:[v8f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188530 */     GIR_RootConstrainSelectedInstOperands,
     /* 188531 */     // GIR_Coverage, 1238,
     /* 188531 */     GIR_EraseRootFromParent_Done,
     /* 188532 */   // Label 3482: @188532
     /* 188532 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(188577), // Rule ID 1239 //
     /* 188537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188566 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188575 */     GIR_RootConstrainSelectedInstOperands,
     /* 188576 */     // GIR_Coverage, 1239,
     /* 188576 */     GIR_EraseRootFromParent_Done,
     /* 188577 */   // Label 3483: @188577
     /* 188577 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(188622), // Rule ID 1240 //
     /* 188582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188611 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 188614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188620 */     GIR_RootConstrainSelectedInstOperands,
     /* 188621 */     // GIR_Coverage, 1240,
     /* 188621 */     GIR_EraseRootFromParent_Done,
     /* 188622 */   // Label 3484: @188622
     /* 188622 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(188667), // Rule ID 1241 //
     /* 188627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188656 */     // (intrinsic_wo_chain:{ *:[v2f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 188659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188665 */     GIR_RootConstrainSelectedInstOperands,
     /* 188666 */     // GIR_Coverage, 1241,
     /* 188666 */     GIR_EraseRootFromParent_Done,
     /* 188667 */   // Label 3485: @188667
     /* 188667 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(188712), // Rule ID 1252 //
     /* 188672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188701 */     // (intrinsic_wo_chain:{ *:[v4f16] } 608:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 188704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188710 */     GIR_RootConstrainSelectedInstOperands,
     /* 188711 */     // GIR_Coverage, 1252,
     /* 188711 */     GIR_EraseRootFromParent_Done,
     /* 188712 */   // Label 3486: @188712
     /* 188712 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(188757), // Rule ID 1253 //
     /* 188717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188746 */     // (intrinsic_wo_chain:{ *:[v8f16] } 608:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 188749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188755 */     GIR_RootConstrainSelectedInstOperands,
     /* 188756 */     // GIR_Coverage, 1253,
     /* 188756 */     GIR_EraseRootFromParent_Done,
     /* 188757 */   // Label 3487: @188757
     /* 188757 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(188802), // Rule ID 1254 //
     /* 188762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188791 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 188794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188800 */     GIR_RootConstrainSelectedInstOperands,
     /* 188801 */     // GIR_Coverage, 1254,
     /* 188801 */     GIR_EraseRootFromParent_Done,
     /* 188802 */   // Label 3488: @188802
     /* 188802 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(188847), // Rule ID 1255 //
     /* 188807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188836 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 188839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188845 */     GIR_RootConstrainSelectedInstOperands,
     /* 188846 */     // GIR_Coverage, 1255,
     /* 188846 */     GIR_EraseRootFromParent_Done,
     /* 188847 */   // Label 3489: @188847
     /* 188847 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188892), // Rule ID 1256 //
     /* 188852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188881 */     // (intrinsic_wo_chain:{ *:[v2f64] } 608:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 188884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188890 */     GIR_RootConstrainSelectedInstOperands,
     /* 188891 */     // GIR_Coverage, 1256,
     /* 188891 */     GIR_EraseRootFromParent_Done,
     /* 188892 */   // Label 3490: @188892
     /* 188892 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188937), // Rule ID 1267 //
     /* 188897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188926 */     // (intrinsic_wo_chain:{ *:[v4f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 188929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188935 */     GIR_RootConstrainSelectedInstOperands,
     /* 188936 */     // GIR_Coverage, 1267,
     /* 188936 */     GIR_EraseRootFromParent_Done,
     /* 188937 */   // Label 3491: @188937
     /* 188937 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188982), // Rule ID 1268 //
     /* 188942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188971 */     // (intrinsic_wo_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 188974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188980 */     GIR_RootConstrainSelectedInstOperands,
     /* 188981 */     // GIR_Coverage, 1268,
     /* 188981 */     GIR_EraseRootFromParent_Done,
     /* 188982 */   // Label 3492: @188982
     /* 188982 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(189027), // Rule ID 1269 //
     /* 188987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189016 */     // (intrinsic_wo_chain:{ *:[v2f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 189019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189025 */     GIR_RootConstrainSelectedInstOperands,
     /* 189026 */     // GIR_Coverage, 1269,
     /* 189026 */     GIR_EraseRootFromParent_Done,
     /* 189027 */   // Label 3493: @189027
     /* 189027 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(189072), // Rule ID 1270 //
     /* 189032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189061 */     // (intrinsic_wo_chain:{ *:[v4f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 189064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189070 */     GIR_RootConstrainSelectedInstOperands,
     /* 189071 */     // GIR_Coverage, 1270,
     /* 189071 */     GIR_EraseRootFromParent_Done,
     /* 189072 */   // Label 3494: @189072
     /* 189072 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189117), // Rule ID 1271 //
     /* 189077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189106 */     // (intrinsic_wo_chain:{ *:[v2f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 189109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189115 */     GIR_RootConstrainSelectedInstOperands,
     /* 189116 */     // GIR_Coverage, 1271,
     /* 189116 */     GIR_EraseRootFromParent_Done,
     /* 189117 */   // Label 3495: @189117
     /* 189117 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189162), // Rule ID 1282 //
     /* 189122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189151 */     // (intrinsic_wo_chain:{ *:[v4f16] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 189154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189160 */     GIR_RootConstrainSelectedInstOperands,
     /* 189161 */     // GIR_Coverage, 1282,
     /* 189161 */     GIR_EraseRootFromParent_Done,
     /* 189162 */   // Label 3496: @189162
     /* 189162 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189207), // Rule ID 1283 //
     /* 189167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189196 */     // (intrinsic_wo_chain:{ *:[v8f16] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 189199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189205 */     GIR_RootConstrainSelectedInstOperands,
     /* 189206 */     // GIR_Coverage, 1283,
     /* 189206 */     GIR_EraseRootFromParent_Done,
     /* 189207 */   // Label 3497: @189207
     /* 189207 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189252), // Rule ID 1284 //
     /* 189212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189241 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 189244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189250 */     GIR_RootConstrainSelectedInstOperands,
     /* 189251 */     // GIR_Coverage, 1284,
     /* 189251 */     GIR_EraseRootFromParent_Done,
     /* 189252 */   // Label 3498: @189252
     /* 189252 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189297), // Rule ID 1285 //
     /* 189257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189286 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 189289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189295 */     GIR_RootConstrainSelectedInstOperands,
     /* 189296 */     // GIR_Coverage, 1285,
     /* 189296 */     GIR_EraseRootFromParent_Done,
     /* 189297 */   // Label 3499: @189297
     /* 189297 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189342), // Rule ID 1286 //
     /* 189302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189331 */     // (intrinsic_wo_chain:{ *:[v2f64] } 614:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 189334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189340 */     GIR_RootConstrainSelectedInstOperands,
     /* 189341 */     // GIR_Coverage, 1286,
     /* 189341 */     GIR_EraseRootFromParent_Done,
     /* 189342 */   // Label 3500: @189342
     /* 189342 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189387), // Rule ID 1317 //
     /* 189347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189376 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 189379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189385 */     GIR_RootConstrainSelectedInstOperands,
     /* 189386 */     // GIR_Coverage, 1317,
     /* 189386 */     GIR_EraseRootFromParent_Done,
     /* 189387 */   // Label 3501: @189387
     /* 189387 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189432), // Rule ID 1318 //
     /* 189392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189421 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189430 */     GIR_RootConstrainSelectedInstOperands,
     /* 189431 */     // GIR_Coverage, 1318,
     /* 189431 */     GIR_EraseRootFromParent_Done,
     /* 189432 */   // Label 3502: @189432
     /* 189432 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189477), // Rule ID 1319 //
     /* 189437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189466 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189475 */     GIR_RootConstrainSelectedInstOperands,
     /* 189476 */     // GIR_Coverage, 1319,
     /* 189476 */     GIR_EraseRootFromParent_Done,
     /* 189477 */   // Label 3503: @189477
     /* 189477 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(189522), // Rule ID 1320 //
     /* 189482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189511 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189520 */     GIR_RootConstrainSelectedInstOperands,
     /* 189521 */     // GIR_Coverage, 1320,
     /* 189521 */     GIR_EraseRootFromParent_Done,
     /* 189522 */   // Label 3504: @189522
     /* 189522 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(189567), // Rule ID 1321 //
     /* 189527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189556 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189565 */     GIR_RootConstrainSelectedInstOperands,
     /* 189566 */     // GIR_Coverage, 1321,
     /* 189566 */     GIR_EraseRootFromParent_Done,
     /* 189567 */   // Label 3505: @189567
     /* 189567 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(189612), // Rule ID 1332 //
     /* 189572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189601 */     // (intrinsic_wo_chain:{ *:[v4f16] } 643:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189610 */     GIR_RootConstrainSelectedInstOperands,
     /* 189611 */     // GIR_Coverage, 1332,
     /* 189611 */     GIR_EraseRootFromParent_Done,
     /* 189612 */   // Label 3506: @189612
     /* 189612 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(189657), // Rule ID 1333 //
     /* 189617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189646 */     // (intrinsic_wo_chain:{ *:[v8f16] } 643:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 189649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189655 */     GIR_RootConstrainSelectedInstOperands,
     /* 189656 */     // GIR_Coverage, 1333,
     /* 189656 */     GIR_EraseRootFromParent_Done,
     /* 189657 */   // Label 3507: @189657
     /* 189657 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(189702), // Rule ID 1334 //
     /* 189662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189691 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 189694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189700 */     GIR_RootConstrainSelectedInstOperands,
     /* 189701 */     // GIR_Coverage, 1334,
     /* 189701 */     GIR_EraseRootFromParent_Done,
     /* 189702 */   // Label 3508: @189702
     /* 189702 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(189747), // Rule ID 1335 //
     /* 189707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189736 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 189739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189745 */     GIR_RootConstrainSelectedInstOperands,
     /* 189746 */     // GIR_Coverage, 1335,
     /* 189746 */     GIR_EraseRootFromParent_Done,
     /* 189747 */   // Label 3509: @189747
     /* 189747 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(189792), // Rule ID 1336 //
     /* 189752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189781 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 189784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189790 */     GIR_RootConstrainSelectedInstOperands,
     /* 189791 */     // GIR_Coverage, 1336,
     /* 189791 */     GIR_EraseRootFromParent_Done,
     /* 189792 */   // Label 3510: @189792
     /* 189792 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(189837), // Rule ID 1337 //
     /* 189797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189826 */     // (intrinsic_wo_chain:{ *:[v4f16] } 650:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 189829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189835 */     GIR_RootConstrainSelectedInstOperands,
     /* 189836 */     // GIR_Coverage, 1337,
     /* 189836 */     GIR_EraseRootFromParent_Done,
     /* 189837 */   // Label 3511: @189837
     /* 189837 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189882), // Rule ID 1338 //
     /* 189842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189871 */     // (intrinsic_wo_chain:{ *:[v8f16] } 650:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 189874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189880 */     GIR_RootConstrainSelectedInstOperands,
     /* 189881 */     // GIR_Coverage, 1338,
     /* 189881 */     GIR_EraseRootFromParent_Done,
     /* 189882 */   // Label 3512: @189882
     /* 189882 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189927), // Rule ID 1339 //
     /* 189887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189916 */     // (intrinsic_wo_chain:{ *:[v2f32] } 650:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 189919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189925 */     GIR_RootConstrainSelectedInstOperands,
     /* 189926 */     // GIR_Coverage, 1339,
     /* 189926 */     GIR_EraseRootFromParent_Done,
     /* 189927 */   // Label 3513: @189927
     /* 189927 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189972), // Rule ID 1340 //
     /* 189932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189961 */     // (intrinsic_wo_chain:{ *:[v4f32] } 650:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 189964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189970 */     GIR_RootConstrainSelectedInstOperands,
     /* 189971 */     // GIR_Coverage, 1340,
     /* 189971 */     GIR_EraseRootFromParent_Done,
     /* 189972 */   // Label 3514: @189972
     /* 189972 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(190017), // Rule ID 1341 //
     /* 189977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190006 */     // (intrinsic_wo_chain:{ *:[v2f64] } 650:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 190006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 190009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190015 */     GIR_RootConstrainSelectedInstOperands,
     /* 190016 */     // GIR_Coverage, 1341,
     /* 190016 */     GIR_EraseRootFromParent_Done,
     /* 190017 */   // Label 3515: @190017
     /* 190017 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(190062), // Rule ID 1358 //
     /* 190022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190051 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 190054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190060 */     GIR_RootConstrainSelectedInstOperands,
     /* 190061 */     // GIR_Coverage, 1358,
     /* 190061 */     GIR_EraseRootFromParent_Done,
     /* 190062 */   // Label 3516: @190062
     /* 190062 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(190107), // Rule ID 1359 //
     /* 190067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 663:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 190099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190105 */     GIR_RootConstrainSelectedInstOperands,
     /* 190106 */     // GIR_Coverage, 1359,
     /* 190106 */     GIR_EraseRootFromParent_Done,
     /* 190107 */   // Label 3517: @190107
     /* 190107 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190152), // Rule ID 1373 //
     /* 190112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190141 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 190144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190150 */     GIR_RootConstrainSelectedInstOperands,
     /* 190151 */     // GIR_Coverage, 1373,
     /* 190151 */     GIR_EraseRootFromParent_Done,
     /* 190152 */   // Label 3518: @190152
     /* 190152 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190197), // Rule ID 1375 //
     /* 190157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190186 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 190189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190195 */     GIR_RootConstrainSelectedInstOperands,
     /* 190196 */     // GIR_Coverage, 1375,
     /* 190196 */     GIR_EraseRootFromParent_Done,
     /* 190197 */   // Label 3519: @190197
     /* 190197 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190242), // Rule ID 1377 //
     /* 190202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190231 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 190234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190240 */     GIR_RootConstrainSelectedInstOperands,
     /* 190241 */     // GIR_Coverage, 1377,
     /* 190241 */     GIR_EraseRootFromParent_Done,
     /* 190242 */   // Label 3520: @190242
     /* 190242 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190287), // Rule ID 1379 //
     /* 190247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190276 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 190279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190285 */     GIR_RootConstrainSelectedInstOperands,
     /* 190286 */     // GIR_Coverage, 1379,
     /* 190286 */     GIR_EraseRootFromParent_Done,
     /* 190287 */   // Label 3521: @190287
     /* 190287 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190332), // Rule ID 1381 //
     /* 190292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190321 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 190324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190330 */     GIR_RootConstrainSelectedInstOperands,
     /* 190331 */     // GIR_Coverage, 1381,
     /* 190331 */     GIR_EraseRootFromParent_Done,
     /* 190332 */   // Label 3522: @190332
     /* 190332 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190377), // Rule ID 1383 //
     /* 190337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190366 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 190369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190375 */     GIR_RootConstrainSelectedInstOperands,
     /* 190376 */     // GIR_Coverage, 1383,
     /* 190376 */     GIR_EraseRootFromParent_Done,
     /* 190377 */   // Label 3523: @190377
     /* 190377 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190422), // Rule ID 1390 //
     /* 190382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190411 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190420 */     GIR_RootConstrainSelectedInstOperands,
     /* 190421 */     // GIR_Coverage, 1390,
     /* 190421 */     GIR_EraseRootFromParent_Done,
     /* 190422 */   // Label 3524: @190422
     /* 190422 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190467), // Rule ID 1391 //
     /* 190427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190456 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190465 */     GIR_RootConstrainSelectedInstOperands,
     /* 190466 */     // GIR_Coverage, 1391,
     /* 190466 */     GIR_EraseRootFromParent_Done,
     /* 190467 */   // Label 3525: @190467
     /* 190467 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190512), // Rule ID 1392 //
     /* 190472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190501 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190510 */     GIR_RootConstrainSelectedInstOperands,
     /* 190511 */     // GIR_Coverage, 1392,
     /* 190511 */     GIR_EraseRootFromParent_Done,
     /* 190512 */   // Label 3526: @190512
     /* 190512 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(190557), // Rule ID 1393 //
     /* 190517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190546 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190555 */     GIR_RootConstrainSelectedInstOperands,
     /* 190556 */     // GIR_Coverage, 1393,
     /* 190556 */     GIR_EraseRootFromParent_Done,
     /* 190557 */   // Label 3527: @190557
     /* 190557 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(190602), // Rule ID 1394 //
     /* 190562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190591 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190600 */     GIR_RootConstrainSelectedInstOperands,
     /* 190601 */     // GIR_Coverage, 1394,
     /* 190601 */     GIR_EraseRootFromParent_Done,
     /* 190602 */   // Label 3528: @190602
     /* 190602 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(190647), // Rule ID 1395 //
     /* 190607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190636 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 190639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190645 */     GIR_RootConstrainSelectedInstOperands,
     /* 190646 */     // GIR_Coverage, 1395,
     /* 190646 */     GIR_EraseRootFromParent_Done,
     /* 190647 */   // Label 3529: @190647
     /* 190647 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(190692), // Rule ID 1396 //
     /* 190652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190681 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 190684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190690 */     GIR_RootConstrainSelectedInstOperands,
     /* 190691 */     // GIR_Coverage, 1396,
     /* 190691 */     GIR_EraseRootFromParent_Done,
     /* 190692 */   // Label 3530: @190692
     /* 190692 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(190737), // Rule ID 1397 //
     /* 190697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190726 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 190729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190735 */     GIR_RootConstrainSelectedInstOperands,
     /* 190736 */     // GIR_Coverage, 1397,
     /* 190736 */     GIR_EraseRootFromParent_Done,
     /* 190737 */   // Label 3531: @190737
     /* 190737 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(190782), // Rule ID 1398 //
     /* 190742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190771 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 190774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190780 */     GIR_RootConstrainSelectedInstOperands,
     /* 190781 */     // GIR_Coverage, 1398,
     /* 190781 */     GIR_EraseRootFromParent_Done,
     /* 190782 */   // Label 3532: @190782
     /* 190782 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(190827), // Rule ID 1399 //
     /* 190787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 190819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190825 */     GIR_RootConstrainSelectedInstOperands,
     /* 190826 */     // GIR_Coverage, 1399,
     /* 190826 */     GIR_EraseRootFromParent_Done,
     /* 190827 */   // Label 3533: @190827
     /* 190827 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(190872), // Rule ID 1400 //
     /* 190832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190861 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 190864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190870 */     GIR_RootConstrainSelectedInstOperands,
     /* 190871 */     // GIR_Coverage, 1400,
     /* 190871 */     GIR_EraseRootFromParent_Done,
     /* 190872 */   // Label 3534: @190872
     /* 190872 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190917), // Rule ID 1401 //
     /* 190877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 190909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190915 */     GIR_RootConstrainSelectedInstOperands,
     /* 190916 */     // GIR_Coverage, 1401,
     /* 190916 */     GIR_EraseRootFromParent_Done,
     /* 190917 */   // Label 3535: @190917
     /* 190917 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190962), // Rule ID 1408 //
     /* 190922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190951 */     // (intrinsic_wo_chain:{ *:[v8i8] } 684:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 190954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190960 */     GIR_RootConstrainSelectedInstOperands,
     /* 190961 */     // GIR_Coverage, 1408,
     /* 190961 */     GIR_EraseRootFromParent_Done,
     /* 190962 */   // Label 3536: @190962
     /* 190962 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(191007), // Rule ID 1409 //
     /* 190967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190996 */     // (intrinsic_wo_chain:{ *:[v16i8] } 684:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 190999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191005 */     GIR_RootConstrainSelectedInstOperands,
     /* 191006 */     // GIR_Coverage, 1409,
     /* 191006 */     GIR_EraseRootFromParent_Done,
     /* 191007 */   // Label 3537: @191007
     /* 191007 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(191052), // Rule ID 1410 //
     /* 191012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191041 */     // (intrinsic_wo_chain:{ *:[v4i16] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 191044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191050 */     GIR_RootConstrainSelectedInstOperands,
     /* 191051 */     // GIR_Coverage, 1410,
     /* 191051 */     GIR_EraseRootFromParent_Done,
     /* 191052 */   // Label 3538: @191052
     /* 191052 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(191097), // Rule ID 1411 //
     /* 191057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 684:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 191089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191095 */     GIR_RootConstrainSelectedInstOperands,
     /* 191096 */     // GIR_Coverage, 1411,
     /* 191096 */     GIR_EraseRootFromParent_Done,
     /* 191097 */   // Label 3539: @191097
     /* 191097 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191142), // Rule ID 1412 //
     /* 191102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191131 */     // (intrinsic_wo_chain:{ *:[v2i32] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 191134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191140 */     GIR_RootConstrainSelectedInstOperands,
     /* 191141 */     // GIR_Coverage, 1412,
     /* 191141 */     GIR_EraseRootFromParent_Done,
     /* 191142 */   // Label 3540: @191142
     /* 191142 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191187), // Rule ID 1413 //
     /* 191147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 191179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191185 */     GIR_RootConstrainSelectedInstOperands,
     /* 191186 */     // GIR_Coverage, 1413,
     /* 191186 */     GIR_EraseRootFromParent_Done,
     /* 191187 */   // Label 3541: @191187
     /* 191187 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191232), // Rule ID 1427 //
     /* 191192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191221 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 191224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191230 */     GIR_RootConstrainSelectedInstOperands,
     /* 191231 */     // GIR_Coverage, 1427,
     /* 191231 */     GIR_EraseRootFromParent_Done,
     /* 191232 */   // Label 3542: @191232
     /* 191232 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191277), // Rule ID 1428 //
     /* 191237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191266 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 191269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191275 */     GIR_RootConstrainSelectedInstOperands,
     /* 191276 */     // GIR_Coverage, 1428,
     /* 191276 */     GIR_EraseRootFromParent_Done,
     /* 191277 */   // Label 3543: @191277
     /* 191277 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191322), // Rule ID 1429 //
     /* 191282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191311 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 191314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191320 */     GIR_RootConstrainSelectedInstOperands,
     /* 191321 */     // GIR_Coverage, 1429,
     /* 191321 */     GIR_EraseRootFromParent_Done,
     /* 191322 */   // Label 3544: @191322
     /* 191322 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191367), // Rule ID 1430 //
     /* 191327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191356 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 191359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191365 */     GIR_RootConstrainSelectedInstOperands,
     /* 191366 */     // GIR_Coverage, 1430,
     /* 191366 */     GIR_EraseRootFromParent_Done,
     /* 191367 */   // Label 3545: @191367
     /* 191367 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191412), // Rule ID 1431 //
     /* 191372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191401 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 191404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191410 */     GIR_RootConstrainSelectedInstOperands,
     /* 191411 */     // GIR_Coverage, 1431,
     /* 191411 */     GIR_EraseRootFromParent_Done,
     /* 191412 */   // Label 3546: @191412
     /* 191412 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191457), // Rule ID 1432 //
     /* 191417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191446 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 191449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191455 */     GIR_RootConstrainSelectedInstOperands,
     /* 191456 */     // GIR_Coverage, 1432,
     /* 191456 */     GIR_EraseRootFromParent_Done,
     /* 191457 */   // Label 3547: @191457
     /* 191457 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191502), // Rule ID 1433 //
     /* 191462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191491 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 191494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191500 */     GIR_RootConstrainSelectedInstOperands,
     /* 191501 */     // GIR_Coverage, 1433,
     /* 191501 */     GIR_EraseRootFromParent_Done,
     /* 191502 */   // Label 3548: @191502
     /* 191502 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(191547), // Rule ID 1434 //
     /* 191507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 191539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191545 */     GIR_RootConstrainSelectedInstOperands,
     /* 191546 */     // GIR_Coverage, 1434,
     /* 191546 */     GIR_EraseRootFromParent_Done,
     /* 191547 */   // Label 3549: @191547
     /* 191547 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(191592), // Rule ID 1435 //
     /* 191552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191581 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 191584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191590 */     GIR_RootConstrainSelectedInstOperands,
     /* 191591 */     // GIR_Coverage, 1435,
     /* 191591 */     GIR_EraseRootFromParent_Done,
     /* 191592 */   // Label 3550: @191592
     /* 191592 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(191637), // Rule ID 1436 //
     /* 191597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191626 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 191629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191635 */     GIR_RootConstrainSelectedInstOperands,
     /* 191636 */     // GIR_Coverage, 1436,
     /* 191636 */     GIR_EraseRootFromParent_Done,
     /* 191637 */   // Label 3551: @191637
     /* 191637 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(191682), // Rule ID 1437 //
     /* 191642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191671 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 191674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191680 */     GIR_RootConstrainSelectedInstOperands,
     /* 191681 */     // GIR_Coverage, 1437,
     /* 191681 */     GIR_EraseRootFromParent_Done,
     /* 191682 */   // Label 3552: @191682
     /* 191682 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(191727), // Rule ID 1438 //
     /* 191687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 191719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191725 */     GIR_RootConstrainSelectedInstOperands,
     /* 191726 */     // GIR_Coverage, 1438,
     /* 191726 */     GIR_EraseRootFromParent_Done,
     /* 191727 */   // Label 3553: @191727
     /* 191727 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(191772), // Rule ID 1439 //
     /* 191732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191761 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 191764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191770 */     GIR_RootConstrainSelectedInstOperands,
     /* 191771 */     // GIR_Coverage, 1439,
     /* 191771 */     GIR_EraseRootFromParent_Done,
     /* 191772 */   // Label 3554: @191772
     /* 191772 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(191817), // Rule ID 1440 //
     /* 191777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 191809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191815 */     GIR_RootConstrainSelectedInstOperands,
     /* 191816 */     // GIR_Coverage, 1440,
     /* 191816 */     GIR_EraseRootFromParent_Done,
     /* 191817 */   // Label 3555: @191817
     /* 191817 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(191862), // Rule ID 1441 //
     /* 191822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191851 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 191854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191860 */     GIR_RootConstrainSelectedInstOperands,
     /* 191861 */     // GIR_Coverage, 1441,
     /* 191861 */     GIR_EraseRootFromParent_Done,
     /* 191862 */   // Label 3556: @191862
     /* 191862 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191907), // Rule ID 1442 //
     /* 191867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191896 */     // (intrinsic_wo_chain:{ *:[v8i8] } 704:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 191899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191905 */     GIR_RootConstrainSelectedInstOperands,
     /* 191906 */     // GIR_Coverage, 1442,
     /* 191906 */     GIR_EraseRootFromParent_Done,
     /* 191907 */   // Label 3557: @191907
     /* 191907 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191952), // Rule ID 1443 //
     /* 191912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191941 */     // (intrinsic_wo_chain:{ *:[v16i8] } 704:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 191944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191950 */     GIR_RootConstrainSelectedInstOperands,
     /* 191951 */     // GIR_Coverage, 1443,
     /* 191951 */     GIR_EraseRootFromParent_Done,
     /* 191952 */   // Label 3558: @191952
     /* 191952 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191997), // Rule ID 1444 //
     /* 191957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191986 */     // (intrinsic_wo_chain:{ *:[v4i16] } 704:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 191989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191995 */     GIR_RootConstrainSelectedInstOperands,
     /* 191996 */     // GIR_Coverage, 1444,
     /* 191996 */     GIR_EraseRootFromParent_Done,
     /* 191997 */   // Label 3559: @191997
     /* 191997 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(192042), // Rule ID 1445 //
     /* 192002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192031 */     // (intrinsic_wo_chain:{ *:[v8i16] } 704:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 192034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192040 */     GIR_RootConstrainSelectedInstOperands,
     /* 192041 */     // GIR_Coverage, 1445,
     /* 192041 */     GIR_EraseRootFromParent_Done,
     /* 192042 */   // Label 3560: @192042
     /* 192042 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(192087), // Rule ID 1446 //
     /* 192047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192076 */     // (intrinsic_wo_chain:{ *:[v2i32] } 704:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 192079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192085 */     GIR_RootConstrainSelectedInstOperands,
     /* 192086 */     // GIR_Coverage, 1446,
     /* 192086 */     GIR_EraseRootFromParent_Done,
     /* 192087 */   // Label 3561: @192087
     /* 192087 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192132), // Rule ID 1447 //
     /* 192092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192121 */     // (intrinsic_wo_chain:{ *:[v4i32] } 704:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 192124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192130 */     GIR_RootConstrainSelectedInstOperands,
     /* 192131 */     // GIR_Coverage, 1447,
     /* 192131 */     GIR_EraseRootFromParent_Done,
     /* 192132 */   // Label 3562: @192132
     /* 192132 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192177), // Rule ID 1448 //
     /* 192137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 704:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 192169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192175 */     GIR_RootConstrainSelectedInstOperands,
     /* 192176 */     // GIR_Coverage, 1448,
     /* 192176 */     GIR_EraseRootFromParent_Done,
     /* 192177 */   // Label 3563: @192177
     /* 192177 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192222), // Rule ID 1462 //
     /* 192182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192211 */     // (intrinsic_wo_chain:{ *:[v8i8] } 712:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 192214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192220 */     GIR_RootConstrainSelectedInstOperands,
     /* 192221 */     // GIR_Coverage, 1462,
     /* 192221 */     GIR_EraseRootFromParent_Done,
     /* 192222 */   // Label 3564: @192222
     /* 192222 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192267), // Rule ID 1463 //
     /* 192227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 712:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 192259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192265 */     GIR_RootConstrainSelectedInstOperands,
     /* 192266 */     // GIR_Coverage, 1463,
     /* 192266 */     GIR_EraseRootFromParent_Done,
     /* 192267 */   // Label 3565: @192267
     /* 192267 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192312), // Rule ID 1464 //
     /* 192272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192301 */     // (intrinsic_wo_chain:{ *:[v4i16] } 712:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 192304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192310 */     GIR_RootConstrainSelectedInstOperands,
     /* 192311 */     // GIR_Coverage, 1464,
     /* 192311 */     GIR_EraseRootFromParent_Done,
     /* 192312 */   // Label 3566: @192312
     /* 192312 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192357), // Rule ID 1465 //
     /* 192317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192346 */     // (intrinsic_wo_chain:{ *:[v8i16] } 712:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 192349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192355 */     GIR_RootConstrainSelectedInstOperands,
     /* 192356 */     // GIR_Coverage, 1465,
     /* 192356 */     GIR_EraseRootFromParent_Done,
     /* 192357 */   // Label 3567: @192357
     /* 192357 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192402), // Rule ID 1466 //
     /* 192362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192391 */     // (intrinsic_wo_chain:{ *:[v2i32] } 712:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 192394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192400 */     GIR_RootConstrainSelectedInstOperands,
     /* 192401 */     // GIR_Coverage, 1466,
     /* 192401 */     GIR_EraseRootFromParent_Done,
     /* 192402 */   // Label 3568: @192402
     /* 192402 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192447), // Rule ID 1467 //
     /* 192407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192436 */     // (intrinsic_wo_chain:{ *:[v4i32] } 712:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 192439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192445 */     GIR_RootConstrainSelectedInstOperands,
     /* 192446 */     // GIR_Coverage, 1467,
     /* 192446 */     GIR_EraseRootFromParent_Done,
     /* 192447 */   // Label 3569: @192447
     /* 192447 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192492), // Rule ID 1468 //
     /* 192452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192481 */     // (intrinsic_wo_chain:{ *:[v2i64] } 712:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 192484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192490 */     GIR_RootConstrainSelectedInstOperands,
     /* 192491 */     // GIR_Coverage, 1468,
     /* 192491 */     GIR_EraseRootFromParent_Done,
     /* 192492 */   // Label 3570: @192492
     /* 192492 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(192537), // Rule ID 1469 //
     /* 192497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192526 */     // (intrinsic_wo_chain:{ *:[v8i8] } 713:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 192529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192535 */     GIR_RootConstrainSelectedInstOperands,
     /* 192536 */     // GIR_Coverage, 1469,
     /* 192536 */     GIR_EraseRootFromParent_Done,
     /* 192537 */   // Label 3571: @192537
     /* 192537 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(192582), // Rule ID 1470 //
     /* 192542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192571 */     // (intrinsic_wo_chain:{ *:[v16i8] } 713:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 192574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192580 */     GIR_RootConstrainSelectedInstOperands,
     /* 192581 */     // GIR_Coverage, 1470,
     /* 192581 */     GIR_EraseRootFromParent_Done,
     /* 192582 */   // Label 3572: @192582
     /* 192582 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(192627), // Rule ID 1471 //
     /* 192587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192616 */     // (intrinsic_wo_chain:{ *:[v4i16] } 713:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 192619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192625 */     GIR_RootConstrainSelectedInstOperands,
     /* 192626 */     // GIR_Coverage, 1471,
     /* 192626 */     GIR_EraseRootFromParent_Done,
     /* 192627 */   // Label 3573: @192627
     /* 192627 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(192672), // Rule ID 1472 //
     /* 192632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192661 */     // (intrinsic_wo_chain:{ *:[v8i16] } 713:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 192664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192670 */     GIR_RootConstrainSelectedInstOperands,
     /* 192671 */     // GIR_Coverage, 1472,
     /* 192671 */     GIR_EraseRootFromParent_Done,
     /* 192672 */   // Label 3574: @192672
     /* 192672 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(192717), // Rule ID 1473 //
     /* 192677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 713:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 192709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192715 */     GIR_RootConstrainSelectedInstOperands,
     /* 192716 */     // GIR_Coverage, 1473,
     /* 192716 */     GIR_EraseRootFromParent_Done,
     /* 192717 */   // Label 3575: @192717
     /* 192717 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(192762), // Rule ID 1474 //
     /* 192722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192751 */     // (intrinsic_wo_chain:{ *:[v4i32] } 713:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 192754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192760 */     GIR_RootConstrainSelectedInstOperands,
     /* 192761 */     // GIR_Coverage, 1474,
     /* 192761 */     GIR_EraseRootFromParent_Done,
     /* 192762 */   // Label 3576: @192762
     /* 192762 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(192807), // Rule ID 1475 //
     /* 192767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 713:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 192799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192805 */     GIR_RootConstrainSelectedInstOperands,
     /* 192806 */     // GIR_Coverage, 1475,
     /* 192806 */     GIR_EraseRootFromParent_Done,
     /* 192807 */   // Label 3577: @192807
     /* 192807 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(192852), // Rule ID 1496 //
     /* 192812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192841 */     // (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 192844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192850 */     GIR_RootConstrainSelectedInstOperands,
     /* 192851 */     // GIR_Coverage, 1496,
     /* 192851 */     GIR_EraseRootFromParent_Done,
     /* 192852 */   // Label 3578: @192852
     /* 192852 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192897), // Rule ID 1498 //
     /* 192857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192886 */     // (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 192889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192895 */     GIR_RootConstrainSelectedInstOperands,
     /* 192896 */     // GIR_Coverage, 1498,
     /* 192896 */     GIR_EraseRootFromParent_Done,
     /* 192897 */   // Label 3579: @192897
     /* 192897 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192942), // Rule ID 1500 //
     /* 192902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192931 */     // (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 192934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192940 */     GIR_RootConstrainSelectedInstOperands,
     /* 192941 */     // GIR_Coverage, 1500,
     /* 192941 */     GIR_EraseRootFromParent_Done,
     /* 192942 */   // Label 3580: @192942
     /* 192942 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192987), // Rule ID 1502 //
     /* 192947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192976 */     // (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 192979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192985 */     GIR_RootConstrainSelectedInstOperands,
     /* 192986 */     // GIR_Coverage, 1502,
     /* 192986 */     GIR_EraseRootFromParent_Done,
     /* 192987 */   // Label 3581: @192987
     /* 192987 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(193032), // Rule ID 1504 //
     /* 192992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193021 */     // (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 193024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193030 */     GIR_RootConstrainSelectedInstOperands,
     /* 193031 */     // GIR_Coverage, 1504,
     /* 193031 */     GIR_EraseRootFromParent_Done,
     /* 193032 */   // Label 3582: @193032
     /* 193032 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(193077), // Rule ID 1506 //
     /* 193037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 193069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193075 */     GIR_RootConstrainSelectedInstOperands,
     /* 193076 */     // GIR_Coverage, 1506,
     /* 193076 */     GIR_EraseRootFromParent_Done,
     /* 193077 */   // Label 3583: @193077
     /* 193077 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193122), // Rule ID 1513 //
     /* 193082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193111 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 193114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193120 */     GIR_RootConstrainSelectedInstOperands,
     /* 193121 */     // GIR_Coverage, 1513,
     /* 193121 */     GIR_EraseRootFromParent_Done,
     /* 193122 */   // Label 3584: @193122
     /* 193122 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193167), // Rule ID 1514 //
     /* 193127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193156 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 193159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193165 */     GIR_RootConstrainSelectedInstOperands,
     /* 193166 */     // GIR_Coverage, 1514,
     /* 193166 */     GIR_EraseRootFromParent_Done,
     /* 193167 */   // Label 3585: @193167
     /* 193167 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193212), // Rule ID 1515 //
     /* 193172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193201 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 193204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193210 */     GIR_RootConstrainSelectedInstOperands,
     /* 193211 */     // GIR_Coverage, 1515,
     /* 193211 */     GIR_EraseRootFromParent_Done,
     /* 193212 */   // Label 3586: @193212
     /* 193212 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193257), // Rule ID 1516 //
     /* 193217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193246 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 193249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193255 */     GIR_RootConstrainSelectedInstOperands,
     /* 193256 */     // GIR_Coverage, 1516,
     /* 193256 */     GIR_EraseRootFromParent_Done,
     /* 193257 */   // Label 3587: @193257
     /* 193257 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193302), // Rule ID 1517 //
     /* 193262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193291 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 193294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193300 */     GIR_RootConstrainSelectedInstOperands,
     /* 193301 */     // GIR_Coverage, 1517,
     /* 193301 */     GIR_EraseRootFromParent_Done,
     /* 193302 */   // Label 3588: @193302
     /* 193302 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193347), // Rule ID 1518 //
     /* 193307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 193315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 193339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193345 */     GIR_RootConstrainSelectedInstOperands,
     /* 193346 */     // GIR_Coverage, 1518,
     /* 193346 */     GIR_EraseRootFromParent_Done,
     /* 193347 */   // Label 3589: @193347
     /* 193347 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193392), // Rule ID 1519 //
     /* 193352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193381 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 193384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193390 */     GIR_RootConstrainSelectedInstOperands,
     /* 193391 */     // GIR_Coverage, 1519,
     /* 193391 */     GIR_EraseRootFromParent_Done,
     /* 193392 */   // Label 3590: @193392
     /* 193392 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193437), // Rule ID 1520 //
     /* 193397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193426 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 193429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193435 */     GIR_RootConstrainSelectedInstOperands,
     /* 193436 */     // GIR_Coverage, 1520,
     /* 193436 */     GIR_EraseRootFromParent_Done,
     /* 193437 */   // Label 3591: @193437
     /* 193437 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193482), // Rule ID 1521 //
     /* 193442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193471 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 193474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193480 */     GIR_RootConstrainSelectedInstOperands,
     /* 193481 */     // GIR_Coverage, 1521,
     /* 193481 */     GIR_EraseRootFromParent_Done,
     /* 193482 */   // Label 3592: @193482
     /* 193482 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(193527), // Rule ID 1522 //
     /* 193487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193516 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 193519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193525 */     GIR_RootConstrainSelectedInstOperands,
     /* 193526 */     // GIR_Coverage, 1522,
     /* 193526 */     GIR_EraseRootFromParent_Done,
     /* 193527 */   // Label 3593: @193527
     /* 193527 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(193572), // Rule ID 1523 //
     /* 193532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 193564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193570 */     GIR_RootConstrainSelectedInstOperands,
     /* 193571 */     // GIR_Coverage, 1523,
     /* 193571 */     GIR_EraseRootFromParent_Done,
     /* 193572 */   // Label 3594: @193572
     /* 193572 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(193617), // Rule ID 1524 //
     /* 193577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 193609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193615 */     GIR_RootConstrainSelectedInstOperands,
     /* 193616 */     // GIR_Coverage, 1524,
     /* 193616 */     GIR_EraseRootFromParent_Done,
     /* 193617 */   // Label 3595: @193617
     /* 193617 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(193662), // Rule ID 1531 //
     /* 193622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193651 */     // (intrinsic_wo_chain:{ *:[v8i8] } 745:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 193654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193660 */     GIR_RootConstrainSelectedInstOperands,
     /* 193661 */     // GIR_Coverage, 1531,
     /* 193661 */     GIR_EraseRootFromParent_Done,
     /* 193662 */   // Label 3596: @193662
     /* 193662 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(193707), // Rule ID 1532 //
     /* 193667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193696 */     // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 193699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193705 */     GIR_RootConstrainSelectedInstOperands,
     /* 193706 */     // GIR_Coverage, 1532,
     /* 193706 */     GIR_EraseRootFromParent_Done,
     /* 193707 */   // Label 3597: @193707
     /* 193707 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(193752), // Rule ID 1533 //
     /* 193712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193741 */     // (intrinsic_wo_chain:{ *:[v4i16] } 745:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 193744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193750 */     GIR_RootConstrainSelectedInstOperands,
     /* 193751 */     // GIR_Coverage, 1533,
     /* 193751 */     GIR_EraseRootFromParent_Done,
     /* 193752 */   // Label 3598: @193752
     /* 193752 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(193797), // Rule ID 1534 //
     /* 193757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193786 */     // (intrinsic_wo_chain:{ *:[v8i16] } 745:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 193789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193795 */     GIR_RootConstrainSelectedInstOperands,
     /* 193796 */     // GIR_Coverage, 1534,
     /* 193796 */     GIR_EraseRootFromParent_Done,
     /* 193797 */   // Label 3599: @193797
     /* 193797 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(193842), // Rule ID 1535 //
     /* 193802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193831 */     // (intrinsic_wo_chain:{ *:[v2i32] } 745:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 193834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193840 */     GIR_RootConstrainSelectedInstOperands,
     /* 193841 */     // GIR_Coverage, 1535,
     /* 193841 */     GIR_EraseRootFromParent_Done,
     /* 193842 */   // Label 3600: @193842
     /* 193842 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193887), // Rule ID 1536 //
     /* 193847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193876 */     // (intrinsic_wo_chain:{ *:[v4i32] } 745:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 193879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193885 */     GIR_RootConstrainSelectedInstOperands,
     /* 193886 */     // GIR_Coverage, 1536,
     /* 193886 */     GIR_EraseRootFromParent_Done,
     /* 193887 */   // Label 3601: @193887
     /* 193887 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193932), // Rule ID 1550 //
     /* 193892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193921 */     // (intrinsic_wo_chain:{ *:[v8i8] } 750:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 193924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193930 */     GIR_RootConstrainSelectedInstOperands,
     /* 193931 */     // GIR_Coverage, 1550,
     /* 193931 */     GIR_EraseRootFromParent_Done,
     /* 193932 */   // Label 3602: @193932
     /* 193932 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193977), // Rule ID 1551 //
     /* 193937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193966 */     // (intrinsic_wo_chain:{ *:[v16i8] } 750:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 193969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193975 */     GIR_RootConstrainSelectedInstOperands,
     /* 193976 */     // GIR_Coverage, 1551,
     /* 193976 */     GIR_EraseRootFromParent_Done,
     /* 193977 */   // Label 3603: @193977
     /* 193977 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(194022), // Rule ID 1552 //
     /* 193982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194011 */     // (intrinsic_wo_chain:{ *:[v4i16] } 750:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 194014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194020 */     GIR_RootConstrainSelectedInstOperands,
     /* 194021 */     // GIR_Coverage, 1552,
     /* 194021 */     GIR_EraseRootFromParent_Done,
     /* 194022 */   // Label 3604: @194022
     /* 194022 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(194067), // Rule ID 1553 //
     /* 194027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 750:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 194059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194065 */     GIR_RootConstrainSelectedInstOperands,
     /* 194066 */     // GIR_Coverage, 1553,
     /* 194066 */     GIR_EraseRootFromParent_Done,
     /* 194067 */   // Label 3605: @194067
     /* 194067 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(194112), // Rule ID 1554 //
     /* 194072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194101 */     // (intrinsic_wo_chain:{ *:[v2i32] } 750:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 194104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194110 */     GIR_RootConstrainSelectedInstOperands,
     /* 194111 */     // GIR_Coverage, 1554,
     /* 194111 */     GIR_EraseRootFromParent_Done,
     /* 194112 */   // Label 3606: @194112
     /* 194112 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194157), // Rule ID 1555 //
     /* 194117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 750:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 194149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194155 */     GIR_RootConstrainSelectedInstOperands,
     /* 194156 */     // GIR_Coverage, 1555,
     /* 194156 */     GIR_EraseRootFromParent_Done,
     /* 194157 */   // Label 3607: @194157
     /* 194157 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194202), // Rule ID 1556 //
     /* 194162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194191 */     // (intrinsic_wo_chain:{ *:[v2i64] } 750:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 194194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194200 */     GIR_RootConstrainSelectedInstOperands,
     /* 194201 */     // GIR_Coverage, 1556,
     /* 194201 */     GIR_EraseRootFromParent_Done,
     /* 194202 */   // Label 3608: @194202
     /* 194202 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194247), // Rule ID 1557 //
     /* 194207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194236 */     // (intrinsic_wo_chain:{ *:[v8i8] } 752:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 194239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194245 */     GIR_RootConstrainSelectedInstOperands,
     /* 194246 */     // GIR_Coverage, 1557,
     /* 194246 */     GIR_EraseRootFromParent_Done,
     /* 194247 */   // Label 3609: @194247
     /* 194247 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194292), // Rule ID 1558 //
     /* 194252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194281 */     // (intrinsic_wo_chain:{ *:[v16i8] } 752:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 194284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194290 */     GIR_RootConstrainSelectedInstOperands,
     /* 194291 */     // GIR_Coverage, 1558,
     /* 194291 */     GIR_EraseRootFromParent_Done,
     /* 194292 */   // Label 3610: @194292
     /* 194292 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194337), // Rule ID 1559 //
     /* 194297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194326 */     // (intrinsic_wo_chain:{ *:[v4i16] } 752:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 194329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194335 */     GIR_RootConstrainSelectedInstOperands,
     /* 194336 */     // GIR_Coverage, 1559,
     /* 194336 */     GIR_EraseRootFromParent_Done,
     /* 194337 */   // Label 3611: @194337
     /* 194337 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194382), // Rule ID 1560 //
     /* 194342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194371 */     // (intrinsic_wo_chain:{ *:[v8i16] } 752:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 194374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194380 */     GIR_RootConstrainSelectedInstOperands,
     /* 194381 */     // GIR_Coverage, 1560,
     /* 194381 */     GIR_EraseRootFromParent_Done,
     /* 194382 */   // Label 3612: @194382
     /* 194382 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194427), // Rule ID 1561 //
     /* 194387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194416 */     // (intrinsic_wo_chain:{ *:[v2i32] } 752:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 194419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194425 */     GIR_RootConstrainSelectedInstOperands,
     /* 194426 */     // GIR_Coverage, 1561,
     /* 194426 */     GIR_EraseRootFromParent_Done,
     /* 194427 */   // Label 3613: @194427
     /* 194427 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194472), // Rule ID 1562 //
     /* 194432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194461 */     // (intrinsic_wo_chain:{ *:[v4i32] } 752:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 194464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194470 */     GIR_RootConstrainSelectedInstOperands,
     /* 194471 */     // GIR_Coverage, 1562,
     /* 194471 */     GIR_EraseRootFromParent_Done,
     /* 194472 */   // Label 3614: @194472
     /* 194472 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194517), // Rule ID 1563 //
     /* 194477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194506 */     // (intrinsic_wo_chain:{ *:[v2i64] } 752:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 194509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194515 */     GIR_RootConstrainSelectedInstOperands,
     /* 194516 */     // GIR_Coverage, 1563,
     /* 194516 */     GIR_EraseRootFromParent_Done,
     /* 194517 */   // Label 3615: @194517
     /* 194517 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(194562), // Rule ID 1577 //
     /* 194522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194551 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 194554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194560 */     GIR_RootConstrainSelectedInstOperands,
     /* 194561 */     // GIR_Coverage, 1577,
     /* 194561 */     GIR_EraseRootFromParent_Done,
     /* 194562 */   // Label 3616: @194562
     /* 194562 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(194607), // Rule ID 1578 //
     /* 194567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194596 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 194599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194605 */     GIR_RootConstrainSelectedInstOperands,
     /* 194606 */     // GIR_Coverage, 1578,
     /* 194606 */     GIR_EraseRootFromParent_Done,
     /* 194607 */   // Label 3617: @194607
     /* 194607 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(194652), // Rule ID 1579 //
     /* 194612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194641 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 194644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194650 */     GIR_RootConstrainSelectedInstOperands,
     /* 194651 */     // GIR_Coverage, 1579,
     /* 194651 */     GIR_EraseRootFromParent_Done,
     /* 194652 */   // Label 3618: @194652
     /* 194652 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(194697), // Rule ID 1580 //
     /* 194657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194686 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 194689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194695 */     GIR_RootConstrainSelectedInstOperands,
     /* 194696 */     // GIR_Coverage, 1580,
     /* 194696 */     GIR_EraseRootFromParent_Done,
     /* 194697 */   // Label 3619: @194697
     /* 194697 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(194742), // Rule ID 1581 //
     /* 194702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194731 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 194734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194740 */     GIR_RootConstrainSelectedInstOperands,
     /* 194741 */     // GIR_Coverage, 1581,
     /* 194741 */     GIR_EraseRootFromParent_Done,
     /* 194742 */   // Label 3620: @194742
     /* 194742 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(194787), // Rule ID 1582 //
     /* 194747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 194779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194785 */     GIR_RootConstrainSelectedInstOperands,
     /* 194786 */     // GIR_Coverage, 1582,
     /* 194786 */     GIR_EraseRootFromParent_Done,
     /* 194787 */   // Label 3621: @194787
     /* 194787 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(194832), // Rule ID 1583 //
     /* 194792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194821 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 194824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194830 */     GIR_RootConstrainSelectedInstOperands,
     /* 194831 */     // GIR_Coverage, 1583,
     /* 194831 */     GIR_EraseRootFromParent_Done,
     /* 194832 */   // Label 3622: @194832
     /* 194832 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194877), // Rule ID 1584 //
     /* 194837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194866 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 194869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194875 */     GIR_RootConstrainSelectedInstOperands,
     /* 194876 */     // GIR_Coverage, 1584,
     /* 194876 */     GIR_EraseRootFromParent_Done,
     /* 194877 */   // Label 3623: @194877
     /* 194877 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194922), // Rule ID 1585 //
     /* 194882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194911 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 194914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194920 */     GIR_RootConstrainSelectedInstOperands,
     /* 194921 */     // GIR_Coverage, 1585,
     /* 194921 */     GIR_EraseRootFromParent_Done,
     /* 194922 */   // Label 3624: @194922
     /* 194922 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194967), // Rule ID 1586 //
     /* 194927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194956 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 194959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194965 */     GIR_RootConstrainSelectedInstOperands,
     /* 194966 */     // GIR_Coverage, 1586,
     /* 194966 */     GIR_EraseRootFromParent_Done,
     /* 194967 */   // Label 3625: @194967
     /* 194967 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(195012), // Rule ID 1587 //
     /* 194972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195001 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 195004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195010 */     GIR_RootConstrainSelectedInstOperands,
     /* 195011 */     // GIR_Coverage, 1587,
     /* 195011 */     GIR_EraseRootFromParent_Done,
     /* 195012 */   // Label 3626: @195012
     /* 195012 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(195057), // Rule ID 1588 //
     /* 195017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195046 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 195049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195055 */     GIR_RootConstrainSelectedInstOperands,
     /* 195056 */     // GIR_Coverage, 1588,
     /* 195056 */     GIR_EraseRootFromParent_Done,
     /* 195057 */   // Label 3627: @195057
     /* 195057 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(195102), // Rule ID 1589 //
     /* 195062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 195094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195100 */     GIR_RootConstrainSelectedInstOperands,
     /* 195101 */     // GIR_Coverage, 1589,
     /* 195101 */     GIR_EraseRootFromParent_Done,
     /* 195102 */   // Label 3628: @195102
     /* 195102 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195147), // Rule ID 1590 //
     /* 195107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 195139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195145 */     GIR_RootConstrainSelectedInstOperands,
     /* 195146 */     // GIR_Coverage, 1590,
     /* 195146 */     GIR_EraseRootFromParent_Done,
     /* 195147 */   // Label 3629: @195147
     /* 195147 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195192), // Rule ID 1618 //
     /* 195152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 195160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195181 */     // (intrinsic_wo_chain:{ *:[f64] } 795:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 195184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195190 */     GIR_RootConstrainSelectedInstOperands,
     /* 195191 */     // GIR_Coverage, 1618,
     /* 195191 */     GIR_EraseRootFromParent_Done,
     /* 195192 */   // Label 3630: @195192
     /* 195192 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195237), // Rule ID 1619 //
     /* 195197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 195205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195226 */     // (intrinsic_wo_chain:{ *:[f32] } 795:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 195229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195235 */     GIR_RootConstrainSelectedInstOperands,
     /* 195236 */     // GIR_Coverage, 1619,
     /* 195236 */     GIR_EraseRootFromParent_Done,
     /* 195237 */   // Label 3631: @195237
     /* 195237 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195282), // Rule ID 1620 //
     /* 195242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 195245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 195250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195271 */     // (intrinsic_wo_chain:{ *:[f16] } 795:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 195274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195280 */     GIR_RootConstrainSelectedInstOperands,
     /* 195281 */     // GIR_Coverage, 1620,
     /* 195281 */     GIR_EraseRootFromParent_Done,
     /* 195282 */   // Label 3632: @195282
     /* 195282 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195327), // Rule ID 1621 //
     /* 195287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 195295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195316 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 195319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195325 */     GIR_RootConstrainSelectedInstOperands,
     /* 195326 */     // GIR_Coverage, 1621,
     /* 195326 */     GIR_EraseRootFromParent_Done,
     /* 195327 */   // Label 3633: @195327
     /* 195327 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195372), // Rule ID 1622 //
     /* 195332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 195340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195361 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 195364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195370 */     GIR_RootConstrainSelectedInstOperands,
     /* 195371 */     // GIR_Coverage, 1622,
     /* 195371 */     GIR_EraseRootFromParent_Done,
     /* 195372 */   // Label 3634: @195372
     /* 195372 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195417), // Rule ID 1623 //
     /* 195377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195406 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 195409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195415 */     GIR_RootConstrainSelectedInstOperands,
     /* 195416 */     // GIR_Coverage, 1623,
     /* 195416 */     GIR_EraseRootFromParent_Done,
     /* 195417 */   // Label 3635: @195417
     /* 195417 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195462), // Rule ID 1624 //
     /* 195422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195451 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 195454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195460 */     GIR_RootConstrainSelectedInstOperands,
     /* 195461 */     // GIR_Coverage, 1624,
     /* 195461 */     GIR_EraseRootFromParent_Done,
     /* 195462 */   // Label 3636: @195462
     /* 195462 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195507), // Rule ID 1631 //
     /* 195467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195496 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 195499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195505 */     GIR_RootConstrainSelectedInstOperands,
     /* 195506 */     // GIR_Coverage, 1631,
     /* 195506 */     GIR_EraseRootFromParent_Done,
     /* 195507 */   // Label 3637: @195507
     /* 195507 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(195552), // Rule ID 1632 //
     /* 195512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195541 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 195544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195550 */     GIR_RootConstrainSelectedInstOperands,
     /* 195551 */     // GIR_Coverage, 1632,
     /* 195551 */     GIR_EraseRootFromParent_Done,
     /* 195552 */   // Label 3638: @195552
     /* 195552 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(195597), // Rule ID 1633 //
     /* 195557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195586 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 195589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195595 */     GIR_RootConstrainSelectedInstOperands,
     /* 195596 */     // GIR_Coverage, 1633,
     /* 195596 */     GIR_EraseRootFromParent_Done,
     /* 195597 */   // Label 3639: @195597
     /* 195597 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(195642), // Rule ID 1634 //
     /* 195602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195631 */     // (intrinsic_wo_chain:{ *:[f64] } 643:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 195634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195640 */     GIR_RootConstrainSelectedInstOperands,
     /* 195641 */     // GIR_Coverage, 1634,
     /* 195641 */     GIR_EraseRootFromParent_Done,
     /* 195642 */   // Label 3640: @195642
     /* 195642 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(195687), // Rule ID 1635 //
     /* 195647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195676 */     // (intrinsic_wo_chain:{ *:[f32] } 643:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 195679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195685 */     GIR_RootConstrainSelectedInstOperands,
     /* 195686 */     // GIR_Coverage, 1635,
     /* 195686 */     GIR_EraseRootFromParent_Done,
     /* 195687 */   // Label 3641: @195687
     /* 195687 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(195732), // Rule ID 1636 //
     /* 195692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195721 */     // (intrinsic_wo_chain:{ *:[f16] } 643:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 195724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195730 */     GIR_RootConstrainSelectedInstOperands,
     /* 195731 */     // GIR_Coverage, 1636,
     /* 195731 */     GIR_EraseRootFromParent_Done,
     /* 195732 */   // Label 3642: @195732
     /* 195732 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(195777), // Rule ID 1637 //
     /* 195737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195766 */     // (intrinsic_wo_chain:{ *:[f64] } 650:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 195769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195775 */     GIR_RootConstrainSelectedInstOperands,
     /* 195776 */     // GIR_Coverage, 1637,
     /* 195776 */     GIR_EraseRootFromParent_Done,
     /* 195777 */   // Label 3643: @195777
     /* 195777 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(195822), // Rule ID 1638 //
     /* 195782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195811 */     // (intrinsic_wo_chain:{ *:[f32] } 650:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 195814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195820 */     GIR_RootConstrainSelectedInstOperands,
     /* 195821 */     // GIR_Coverage, 1638,
     /* 195821 */     GIR_EraseRootFromParent_Done,
     /* 195822 */   // Label 3644: @195822
     /* 195822 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(195867), // Rule ID 1639 //
     /* 195827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195856 */     // (intrinsic_wo_chain:{ *:[f16] } 650:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 195859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195865 */     GIR_RootConstrainSelectedInstOperands,
     /* 195866 */     // GIR_Coverage, 1639,
     /* 195866 */     GIR_EraseRootFromParent_Done,
     /* 195867 */   // Label 3645: @195867
     /* 195867 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195912), // Rule ID 1641 //
     /* 195872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 195880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195901 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 195904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195910 */     GIR_RootConstrainSelectedInstOperands,
     /* 195911 */     // GIR_Coverage, 1641,
     /* 195911 */     GIR_EraseRootFromParent_Done,
     /* 195912 */   // Label 3646: @195912
     /* 195912 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195957), // Rule ID 1642 //
     /* 195917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 195925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195946 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 195949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195955 */     GIR_RootConstrainSelectedInstOperands,
     /* 195956 */     // GIR_Coverage, 1642,
     /* 195956 */     GIR_EraseRootFromParent_Done,
     /* 195957 */   // Label 3647: @195957
     /* 195957 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(196002), // Rule ID 1643 //
     /* 195962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 195970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195991 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 195994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196000 */     GIR_RootConstrainSelectedInstOperands,
     /* 196001 */     // GIR_Coverage, 1643,
     /* 196001 */     GIR_EraseRootFromParent_Done,
     /* 196002 */   // Label 3648: @196002
     /* 196002 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(196047), // Rule ID 1644 //
     /* 196007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 196015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196036 */     // (intrinsic_wo_chain:{ *:[v1i64] } 704:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 196039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196045 */     GIR_RootConstrainSelectedInstOperands,
     /* 196046 */     // GIR_Coverage, 1644,
     /* 196046 */     GIR_EraseRootFromParent_Done,
     /* 196047 */   // Label 3649: @196047
     /* 196047 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(196092), // Rule ID 1646 //
     /* 196052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 196060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196081 */     // (intrinsic_wo_chain:{ *:[v1i64] } 712:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 196084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196090 */     GIR_RootConstrainSelectedInstOperands,
     /* 196091 */     // GIR_Coverage, 1646,
     /* 196091 */     GIR_EraseRootFromParent_Done,
     /* 196092 */   // Label 3650: @196092
     /* 196092 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196137), // Rule ID 1647 //
     /* 196097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 196105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196126 */     // (intrinsic_wo_chain:{ *:[v1i64] } 713:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 196129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196135 */     GIR_RootConstrainSelectedInstOperands,
     /* 196136 */     // GIR_Coverage, 1647,
     /* 196136 */     GIR_EraseRootFromParent_Done,
     /* 196137 */   // Label 3651: @196137
     /* 196137 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196182), // Rule ID 1650 //
     /* 196142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 196150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196171 */     // (intrinsic_wo_chain:{ *:[v1i64] } 750:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 196174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196180 */     GIR_RootConstrainSelectedInstOperands,
     /* 196181 */     // GIR_Coverage, 1650,
     /* 196181 */     GIR_EraseRootFromParent_Done,
     /* 196182 */   // Label 3652: @196182
     /* 196182 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196227), // Rule ID 1651 //
     /* 196187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 196195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196216 */     // (intrinsic_wo_chain:{ *:[v1i64] } 752:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 196219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196225 */     GIR_RootConstrainSelectedInstOperands,
     /* 196226 */     // GIR_Coverage, 1651,
     /* 196226 */     GIR_EraseRootFromParent_Done,
     /* 196227 */   // Label 3653: @196227
     /* 196227 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196272), // Rule ID 1653 //
     /* 196232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196261 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 196264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196270 */     GIR_RootConstrainSelectedInstOperands,
     /* 196271 */     // GIR_Coverage, 1653,
     /* 196271 */     GIR_EraseRootFromParent_Done,
     /* 196272 */   // Label 3654: @196272
     /* 196272 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196317), // Rule ID 1654 //
     /* 196277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196306 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 196306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 196309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196315 */     GIR_RootConstrainSelectedInstOperands,
     /* 196316 */     // GIR_Coverage, 1654,
     /* 196316 */     GIR_EraseRootFromParent_Done,
     /* 196317 */   // Label 3655: @196317
     /* 196317 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196362), // Rule ID 1655 //
     /* 196322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 196330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196351 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 196351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 196354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196360 */     GIR_RootConstrainSelectedInstOperands,
     /* 196361 */     // GIR_Coverage, 1655,
     /* 196361 */     GIR_EraseRootFromParent_Done,
     /* 196362 */   // Label 3656: @196362
     /* 196362 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196407), // Rule ID 1669 //
     /* 196367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196396 */     // (intrinsic_wo_chain:{ *:[i64] } 725:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196405 */     GIR_RootConstrainSelectedInstOperands,
     /* 196406 */     // GIR_Coverage, 1669,
     /* 196406 */     GIR_EraseRootFromParent_Done,
     /* 196407 */   // Label 3657: @196407
     /* 196407 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196452), // Rule ID 1670 //
     /* 196412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196441 */     // (intrinsic_wo_chain:{ *:[i32] } 725:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 196444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196450 */     GIR_RootConstrainSelectedInstOperands,
     /* 196451 */     // GIR_Coverage, 1670,
     /* 196451 */     GIR_EraseRootFromParent_Done,
     /* 196452 */   // Label 3658: @196452
     /* 196452 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196497), // Rule ID 1675 //
     /* 196457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196486 */     // (intrinsic_wo_chain:{ *:[i64] } 764:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 196489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196495 */     GIR_RootConstrainSelectedInstOperands,
     /* 196496 */     // GIR_Coverage, 1675,
     /* 196496 */     GIR_EraseRootFromParent_Done,
     /* 196497 */   // Label 3659: @196497
     /* 196497 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(196542), // Rule ID 1676 //
     /* 196502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196531 */     // (intrinsic_wo_chain:{ *:[i32] } 764:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 196534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196540 */     GIR_RootConstrainSelectedInstOperands,
     /* 196541 */     // GIR_Coverage, 1676,
     /* 196541 */     GIR_EraseRootFromParent_Done,
     /* 196542 */   // Label 3660: @196542
     /* 196542 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(196587), // Rule ID 1677 //
     /* 196547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196576 */     // (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 196579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196585 */     GIR_RootConstrainSelectedInstOperands,
     /* 196586 */     // GIR_Coverage, 1677,
     /* 196586 */     GIR_EraseRootFromParent_Done,
     /* 196587 */   // Label 3661: @196587
     /* 196587 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(196632), // Rule ID 1678 //
     /* 196592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196621 */     // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 196624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196630 */     GIR_RootConstrainSelectedInstOperands,
     /* 196631 */     // GIR_Coverage, 1678,
     /* 196631 */     GIR_EraseRootFromParent_Done,
     /* 196632 */   // Label 3662: @196632
     /* 196632 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(196677), // Rule ID 1679 //
     /* 196637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196666 */     // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 196669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196675 */     GIR_RootConstrainSelectedInstOperands,
     /* 196676 */     // GIR_Coverage, 1679,
     /* 196676 */     GIR_EraseRootFromParent_Done,
     /* 196677 */   // Label 3663: @196677
     /* 196677 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(196722), // Rule ID 1680 //
     /* 196682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196711 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 196714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196720 */     GIR_RootConstrainSelectedInstOperands,
     /* 196721 */     // GIR_Coverage, 1680,
     /* 196721 */     GIR_EraseRootFromParent_Done,
     /* 196722 */   // Label 3664: @196722
     /* 196722 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(196767), // Rule ID 1681 //
     /* 196727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196756 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 196759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196765 */     GIR_RootConstrainSelectedInstOperands,
     /* 196766 */     // GIR_Coverage, 1681,
     /* 196766 */     GIR_EraseRootFromParent_Done,
     /* 196767 */   // Label 3665: @196767
     /* 196767 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(196812), // Rule ID 1682 //
     /* 196772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196801 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 196804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196810 */     GIR_RootConstrainSelectedInstOperands,
     /* 196811 */     // GIR_Coverage, 1682,
     /* 196811 */     GIR_EraseRootFromParent_Done,
     /* 196812 */   // Label 3666: @196812
     /* 196812 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(196857), // Rule ID 1683 //
     /* 196817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196846 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 196849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196855 */     GIR_RootConstrainSelectedInstOperands,
     /* 196856 */     // GIR_Coverage, 1683,
     /* 196856 */     GIR_EraseRootFromParent_Done,
     /* 196857 */   // Label 3667: @196857
     /* 196857 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196902), // Rule ID 1684 //
     /* 196862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196891 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 196894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196900 */     GIR_RootConstrainSelectedInstOperands,
     /* 196901 */     // GIR_Coverage, 1684,
     /* 196901 */     GIR_EraseRootFromParent_Done,
     /* 196902 */   // Label 3668: @196902
     /* 196902 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196947), // Rule ID 1685 //
     /* 196907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196936 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 196939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196945 */     GIR_RootConstrainSelectedInstOperands,
     /* 196946 */     // GIR_Coverage, 1685,
     /* 196946 */     GIR_EraseRootFromParent_Done,
     /* 196947 */   // Label 3669: @196947
     /* 196947 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196992), // Rule ID 1686 //
     /* 196952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196981 */     // (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 196984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196990 */     GIR_RootConstrainSelectedInstOperands,
     /* 196991 */     // GIR_Coverage, 1686,
     /* 196991 */     GIR_EraseRootFromParent_Done,
     /* 196992 */   // Label 3670: @196992
     /* 196992 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(197037), // Rule ID 1687 //
     /* 196997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 197005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197026 */     // (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 197026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 197029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197035 */     GIR_RootConstrainSelectedInstOperands,
     /* 197036 */     // GIR_Coverage, 1687,
     /* 197036 */     GIR_EraseRootFromParent_Done,
     /* 197037 */   // Label 3671: @197037
     /* 197037 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(197082), // Rule ID 1688 //
     /* 197042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 197050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197071 */     // (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 197071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 197074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197080 */     GIR_RootConstrainSelectedInstOperands,
     /* 197081 */     // GIR_Coverage, 1688,
     /* 197081 */     GIR_EraseRootFromParent_Done,
     /* 197082 */   // Label 3672: @197082
     /* 197082 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197127), // Rule ID 1754 //
     /* 197087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 197095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197116 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 197116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 197119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197125 */     GIR_RootConstrainSelectedInstOperands,
     /* 197126 */     // GIR_Coverage, 1754,
     /* 197126 */     GIR_EraseRootFromParent_Done,
     /* 197127 */   // Label 3673: @197127
     /* 197127 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197172), // Rule ID 1756 //
     /* 197132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 197140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197161 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 197161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 197164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197170 */     GIR_RootConstrainSelectedInstOperands,
     /* 197171 */     // GIR_Coverage, 1756,
     /* 197171 */     GIR_EraseRootFromParent_Done,
     /* 197172 */   // Label 3674: @197172
     /* 197172 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197217), // Rule ID 2307 //
     /* 197177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 197180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 197185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 197191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 197194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197206 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 197206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 197209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197215 */     GIR_RootConstrainSelectedInstOperands,
     /* 197216 */     // GIR_Coverage, 2307,
     /* 197216 */     GIR_EraseRootFromParent_Done,
     /* 197217 */   // Label 3675: @197217
     /* 197217 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197262), // Rule ID 2308 //
     /* 197222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 197225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 197230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 197236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 197239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197251 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 197251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 197254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197260 */     GIR_RootConstrainSelectedInstOperands,
     /* 197261 */     // GIR_Coverage, 2308,
     /* 197261 */     GIR_EraseRootFromParent_Done,
     /* 197262 */   // Label 3676: @197262
     /* 197262 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197307), // Rule ID 2319 //
     /* 197267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 197270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 197275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 197296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 197299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197305 */     GIR_RootConstrainSelectedInstOperands,
     /* 197306 */     // GIR_Coverage, 2319,
     /* 197306 */     GIR_EraseRootFromParent_Done,
     /* 197307 */   // Label 3677: @197307
     /* 197307 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197352), // Rule ID 2320 //
     /* 197312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 197315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 197320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 197341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 197344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197350 */     GIR_RootConstrainSelectedInstOperands,
     /* 197351 */     // GIR_Coverage, 2320,
     /* 197351 */     GIR_EraseRootFromParent_Done,
     /* 197352 */   // Label 3678: @197352
     /* 197352 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197397), // Rule ID 2343 //
     /* 197357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197386 */     // (intrinsic_wo_chain:{ *:[v4f16] } 641:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 197386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 197389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197395 */     GIR_RootConstrainSelectedInstOperands,
     /* 197396 */     // GIR_Coverage, 2343,
     /* 197396 */     GIR_EraseRootFromParent_Done,
     /* 197397 */   // Label 3679: @197397
     /* 197397 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197442), // Rule ID 2344 //
     /* 197402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197431 */     // (intrinsic_wo_chain:{ *:[v8f16] } 641:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 197431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 197434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197440 */     GIR_RootConstrainSelectedInstOperands,
     /* 197441 */     // GIR_Coverage, 2344,
     /* 197441 */     GIR_EraseRootFromParent_Done,
     /* 197442 */   // Label 3680: @197442
     /* 197442 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197487), // Rule ID 2345 //
     /* 197447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197476 */     // (intrinsic_wo_chain:{ *:[v2f32] } 641:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 197476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 197479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197485 */     GIR_RootConstrainSelectedInstOperands,
     /* 197486 */     // GIR_Coverage, 2345,
     /* 197486 */     GIR_EraseRootFromParent_Done,
     /* 197487 */   // Label 3681: @197487
     /* 197487 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(197532), // Rule ID 2346 //
     /* 197492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197521 */     // (intrinsic_wo_chain:{ *:[v4f32] } 641:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 197521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 197524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197530 */     GIR_RootConstrainSelectedInstOperands,
     /* 197531 */     // GIR_Coverage, 2346,
     /* 197531 */     GIR_EraseRootFromParent_Done,
     /* 197532 */   // Label 3682: @197532
     /* 197532 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(197577), // Rule ID 2347 //
     /* 197537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197566 */     // (intrinsic_wo_chain:{ *:[v2f64] } 641:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 197566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 197569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197575 */     GIR_RootConstrainSelectedInstOperands,
     /* 197576 */     // GIR_Coverage, 2347,
     /* 197576 */     GIR_EraseRootFromParent_Done,
     /* 197577 */   // Label 3683: @197577
     /* 197577 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(197622), // Rule ID 2348 //
     /* 197582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197611 */     // (intrinsic_wo_chain:{ *:[v4f16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 197614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197620 */     GIR_RootConstrainSelectedInstOperands,
     /* 197621 */     // GIR_Coverage, 2348,
     /* 197621 */     GIR_EraseRootFromParent_Done,
     /* 197622 */   // Label 3684: @197622
     /* 197622 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(197667), // Rule ID 2351 //
     /* 197627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197656 */     // (intrinsic_wo_chain:{ *:[v8f16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 197659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197665 */     GIR_RootConstrainSelectedInstOperands,
     /* 197666 */     // GIR_Coverage, 2351,
     /* 197666 */     GIR_EraseRootFromParent_Done,
     /* 197667 */   // Label 3685: @197667
     /* 197667 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(197712), // Rule ID 2354 //
     /* 197672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197701 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 197704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197710 */     GIR_RootConstrainSelectedInstOperands,
     /* 197711 */     // GIR_Coverage, 2354,
     /* 197711 */     GIR_EraseRootFromParent_Done,
     /* 197712 */   // Label 3686: @197712
     /* 197712 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(197757), // Rule ID 2357 //
     /* 197717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197746 */     // (intrinsic_wo_chain:{ *:[v4f32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 197749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197755 */     GIR_RootConstrainSelectedInstOperands,
     /* 197756 */     // GIR_Coverage, 2357,
     /* 197756 */     GIR_EraseRootFromParent_Done,
     /* 197757 */   // Label 3687: @197757
     /* 197757 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(197802), // Rule ID 2360 //
     /* 197762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197791 */     // (intrinsic_wo_chain:{ *:[v2f64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 197794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197800 */     GIR_RootConstrainSelectedInstOperands,
     /* 197801 */     // GIR_Coverage, 2360,
     /* 197801 */     GIR_EraseRootFromParent_Done,
     /* 197802 */   // Label 3688: @197802
     /* 197802 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(197847), // Rule ID 2363 //
     /* 197807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197836 */     // (intrinsic_wo_chain:{ *:[v4f16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 197839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197845 */     GIR_RootConstrainSelectedInstOperands,
     /* 197846 */     // GIR_Coverage, 2363,
     /* 197846 */     GIR_EraseRootFromParent_Done,
     /* 197847 */   // Label 3689: @197847
     /* 197847 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197892), // Rule ID 2366 //
     /* 197852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197881 */     // (intrinsic_wo_chain:{ *:[v8f16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 197884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197890 */     GIR_RootConstrainSelectedInstOperands,
     /* 197891 */     // GIR_Coverage, 2366,
     /* 197891 */     GIR_EraseRootFromParent_Done,
     /* 197892 */   // Label 3690: @197892
     /* 197892 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197937), // Rule ID 2369 //
     /* 197897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197926 */     // (intrinsic_wo_chain:{ *:[v2f32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 197929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197935 */     GIR_RootConstrainSelectedInstOperands,
     /* 197936 */     // GIR_Coverage, 2369,
     /* 197936 */     GIR_EraseRootFromParent_Done,
     /* 197937 */   // Label 3691: @197937
     /* 197937 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197982), // Rule ID 2372 //
     /* 197942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197971 */     // (intrinsic_wo_chain:{ *:[v4f32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197980 */     GIR_RootConstrainSelectedInstOperands,
     /* 197981 */     // GIR_Coverage, 2372,
     /* 197981 */     GIR_EraseRootFromParent_Done,
     /* 197982 */   // Label 3692: @197982
     /* 197982 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(198027), // Rule ID 2375 //
     /* 197987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198016 */     // (intrinsic_wo_chain:{ *:[v2f64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 198016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 198019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198025 */     GIR_RootConstrainSelectedInstOperands,
     /* 198026 */     // GIR_Coverage, 2375,
     /* 198026 */     GIR_EraseRootFromParent_Done,
     /* 198027 */   // Label 3693: @198027
     /* 198027 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(198072), // Rule ID 2427 //
     /* 198032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 198035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 198040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198061 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 198061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 198064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198066 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 198068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 198070 */     GIR_RootConstrainSelectedInstOperands,
     /* 198071 */     // GIR_Coverage, 2427,
     /* 198071 */     GIR_EraseRootFromParent_Done,
     /* 198072 */   // Label 3694: @198072
     /* 198072 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198117), // Rule ID 2428 //
     /* 198077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 198080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 198085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 198106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 198109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198111 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 198113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 198115 */     GIR_RootConstrainSelectedInstOperands,
     /* 198116 */     // GIR_Coverage, 2428,
     /* 198116 */     GIR_EraseRootFromParent_Done,
     /* 198117 */   // Label 3695: @198117
     /* 198117 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198162), // Rule ID 2429 //
     /* 198122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVESM4),
     /* 198125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 198130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)
     /* 198151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 198154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198156 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 198158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 198160 */     GIR_RootConstrainSelectedInstOperands,
     /* 198161 */     // GIR_Coverage, 2429,
     /* 198161 */     GIR_EraseRootFromParent_Done,
     /* 198162 */   // Label 3696: @198162
     /* 198162 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198207), // Rule ID 2508 //
     /* 198167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 198175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198196 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 198199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198205 */     GIR_RootConstrainSelectedInstOperands,
     /* 198206 */     // GIR_Coverage, 2508,
     /* 198206 */     GIR_EraseRootFromParent_Done,
     /* 198207 */   // Label 3697: @198207
     /* 198207 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198252), // Rule ID 2509 //
     /* 198212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 198220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198241 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198250 */     GIR_RootConstrainSelectedInstOperands,
     /* 198251 */     // GIR_Coverage, 2509,
     /* 198251 */     GIR_EraseRootFromParent_Done,
     /* 198252 */   // Label 3698: @198252
     /* 198252 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198297), // Rule ID 2510 //
     /* 198257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 198265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198286 */     // (intrinsic_wo_chain:{ *:[v1f64] } 795:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 198286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 198289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198295 */     GIR_RootConstrainSelectedInstOperands,
     /* 198296 */     // GIR_Coverage, 2510,
     /* 198296 */     GIR_EraseRootFromParent_Done,
     /* 198297 */   // Label 3699: @198297
     /* 198297 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198342), // Rule ID 2511 //
     /* 198302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 198310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198331 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 198331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 198334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198340 */     GIR_RootConstrainSelectedInstOperands,
     /* 198341 */     // GIR_Coverage, 2511,
     /* 198341 */     GIR_EraseRootFromParent_Done,
     /* 198342 */   // Label 3700: @198342
     /* 198342 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198387), // Rule ID 2516 //
     /* 198347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 198355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198376 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 198376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 198379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198385 */     GIR_RootConstrainSelectedInstOperands,
     /* 198386 */     // GIR_Coverage, 2516,
     /* 198386 */     GIR_EraseRootFromParent_Done,
     /* 198387 */   // Label 3701: @198387
     /* 198387 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198432), // Rule ID 2634 //
     /* 198392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198421 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 198424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198430 */     GIR_RootConstrainSelectedInstOperands,
     /* 198431 */     // GIR_Coverage, 2634,
     /* 198431 */     GIR_EraseRootFromParent_Done,
     /* 198432 */   // Label 3702: @198432
     /* 198432 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198477), // Rule ID 2635 //
     /* 198437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198466 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 198469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198475 */     GIR_RootConstrainSelectedInstOperands,
     /* 198476 */     // GIR_Coverage, 2635,
     /* 198476 */     GIR_EraseRootFromParent_Done,
     /* 198477 */   // Label 3703: @198477
     /* 198477 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(198522), // Rule ID 2636 //
     /* 198482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198511 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 198514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198520 */     GIR_RootConstrainSelectedInstOperands,
     /* 198521 */     // GIR_Coverage, 2636,
     /* 198521 */     GIR_EraseRootFromParent_Done,
     /* 198522 */   // Label 3704: @198522
     /* 198522 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(198567), // Rule ID 2637 //
     /* 198527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198556 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 198559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198565 */     GIR_RootConstrainSelectedInstOperands,
     /* 198566 */     // GIR_Coverage, 2637,
     /* 198566 */     GIR_EraseRootFromParent_Done,
     /* 198567 */   // Label 3705: @198567
     /* 198567 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(198612), // Rule ID 2638 //
     /* 198572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198601 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 198604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198610 */     GIR_RootConstrainSelectedInstOperands,
     /* 198611 */     // GIR_Coverage, 2638,
     /* 198611 */     GIR_EraseRootFromParent_Done,
     /* 198612 */   // Label 3706: @198612
     /* 198612 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(198657), // Rule ID 2639 //
     /* 198617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198646 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 198649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198655 */     GIR_RootConstrainSelectedInstOperands,
     /* 198656 */     // GIR_Coverage, 2639,
     /* 198656 */     GIR_EraseRootFromParent_Done,
     /* 198657 */   // Label 3707: @198657
     /* 198657 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(198702), // Rule ID 2640 //
     /* 198662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198691 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 198694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198700 */     GIR_RootConstrainSelectedInstOperands,
     /* 198701 */     // GIR_Coverage, 2640,
     /* 198701 */     GIR_EraseRootFromParent_Done,
     /* 198702 */   // Label 3708: @198702
     /* 198702 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(198747), // Rule ID 2641 //
     /* 198707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198736 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 198739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198745 */     GIR_RootConstrainSelectedInstOperands,
     /* 198746 */     // GIR_Coverage, 2641,
     /* 198746 */     GIR_EraseRootFromParent_Done,
     /* 198747 */   // Label 3709: @198747
     /* 198747 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(198792), // Rule ID 3848 //
     /* 198752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 198760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198781 */     // (intrinsic_wo_chain:{ *:[v2i64] } 542:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 198784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198790 */     GIR_RootConstrainSelectedInstOperands,
     /* 198791 */     // GIR_Coverage, 3848,
     /* 198791 */     GIR_EraseRootFromParent_Done,
     /* 198792 */   // Label 3710: @198792
     /* 198792 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(198837), // Rule ID 3876 //
     /* 198797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 198805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198826 */     // (intrinsic_wo_chain:{ *:[v2i64] } 529:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 198829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198835 */     GIR_RootConstrainSelectedInstOperands,
     /* 198836 */     // GIR_Coverage, 3876,
     /* 198836 */     GIR_EraseRootFromParent_Done,
     /* 198837 */   // Label 3711: @198837
     /* 198837 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198882), // Rule ID 3886 //
     /* 198842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 198850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 552:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 198874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198880 */     GIR_RootConstrainSelectedInstOperands,
     /* 198881 */     // GIR_Coverage, 3886,
     /* 198881 */     GIR_EraseRootFromParent_Done,
     /* 198882 */   // Label 3712: @198882
     /* 198882 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198927), // Rule ID 3887 //
     /* 198887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 198895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 551:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 198919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198925 */     GIR_RootConstrainSelectedInstOperands,
     /* 198926 */     // GIR_Coverage, 3887,
     /* 198926 */     GIR_EraseRootFromParent_Done,
     /* 198927 */   // Label 3713: @198927
     /* 198927 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198975), // Rule ID 3888 //
     /* 198932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198961 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 198961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198973 */     GIR_RootConstrainSelectedInstOperands,
     /* 198974 */     // GIR_Coverage, 3888,
     /* 198974 */     GIR_EraseRootFromParent_Done,
     /* 198975 */   // Label 3714: @198975
     /* 198975 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(199023), // Rule ID 3889 //
     /* 198980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199009 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 199009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199021 */     GIR_RootConstrainSelectedInstOperands,
     /* 199022 */     // GIR_Coverage, 3889,
     /* 199022 */     GIR_EraseRootFromParent_Done,
     /* 199023 */   // Label 3715: @199023
     /* 199023 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(199071), // Rule ID 3890 //
     /* 199028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 199036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199057 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 199057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 199060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199069 */     GIR_RootConstrainSelectedInstOperands,
     /* 199070 */     // GIR_Coverage, 3890,
     /* 199070 */     GIR_EraseRootFromParent_Done,
     /* 199071 */   // Label 3716: @199071
     /* 199071 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199119), // Rule ID 3891 //
     /* 199076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 199084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199105 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 199105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 199108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199117 */     GIR_RootConstrainSelectedInstOperands,
     /* 199118 */     // GIR_Coverage, 3891,
     /* 199118 */     GIR_EraseRootFromParent_Done,
     /* 199119 */   // Label 3717: @199119
     /* 199119 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199167), // Rule ID 3892 //
     /* 199124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 199132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199153 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 199153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 199156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199165 */     GIR_RootConstrainSelectedInstOperands,
     /* 199166 */     // GIR_Coverage, 3892,
     /* 199166 */     GIR_EraseRootFromParent_Done,
     /* 199167 */   // Label 3718: @199167
     /* 199167 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199215), // Rule ID 3893 //
     /* 199172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 199180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199201 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 199201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 199204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199213 */     GIR_RootConstrainSelectedInstOperands,
     /* 199214 */     // GIR_Coverage, 3893,
     /* 199214 */     GIR_EraseRootFromParent_Done,
     /* 199215 */   // Label 3719: @199215
     /* 199215 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199263), // Rule ID 3894 //
     /* 199220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 199228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199249 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 199249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 199252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199261 */     GIR_RootConstrainSelectedInstOperands,
     /* 199262 */     // GIR_Coverage, 3894,
     /* 199262 */     GIR_EraseRootFromParent_Done,
     /* 199263 */   // Label 3720: @199263
     /* 199263 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199311), // Rule ID 3895 //
     /* 199268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 199276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199297 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 199297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 199300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199309 */     GIR_RootConstrainSelectedInstOperands,
     /* 199310 */     // GIR_Coverage, 3895,
     /* 199310 */     GIR_EraseRootFromParent_Done,
     /* 199311 */   // Label 3721: @199311
     /* 199311 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199359), // Rule ID 3896 //
     /* 199316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 199324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199345 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 199345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 199348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199357 */     GIR_RootConstrainSelectedInstOperands,
     /* 199358 */     // GIR_Coverage, 3896,
     /* 199358 */     GIR_EraseRootFromParent_Done,
     /* 199359 */   // Label 3722: @199359
     /* 199359 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199407), // Rule ID 3897 //
     /* 199364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 199372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199393 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 199393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 199396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199405 */     GIR_RootConstrainSelectedInstOperands,
     /* 199406 */     // GIR_Coverage, 3897,
     /* 199406 */     GIR_EraseRootFromParent_Done,
     /* 199407 */   // Label 3723: @199407
     /* 199407 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199449), // Rule ID 3962 //
     /* 199412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199438 */     // (intrinsic_wo_chain:{ *:[i32] } 2179:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 199441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 199448 */     // GIR_Coverage, 3962,
     /* 199448 */     GIR_EraseRootFromParent_Done,
     /* 199449 */   // Label 3724: @199449
     /* 199449 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199491), // Rule ID 3963 //
     /* 199454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199480 */     // (intrinsic_wo_chain:{ *:[i64] } 2179:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 199483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199489 */     GIR_RootConstrainSelectedInstOperands,
     /* 199490 */     // GIR_Coverage, 3963,
     /* 199490 */     GIR_EraseRootFromParent_Done,
     /* 199491 */   // Label 3725: @199491
     /* 199491 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199533), // Rule ID 3964 //
     /* 199496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199522 */     // (intrinsic_wo_chain:{ *:[i32] } 789:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 199525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199531 */     GIR_RootConstrainSelectedInstOperands,
     /* 199532 */     // GIR_Coverage, 3964,
     /* 199532 */     GIR_EraseRootFromParent_Done,
     /* 199533 */   // Label 3726: @199533
     /* 199533 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(199575), // Rule ID 3965 //
     /* 199538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199564 */     // (intrinsic_wo_chain:{ *:[i64] } 789:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 199567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199573 */     GIR_RootConstrainSelectedInstOperands,
     /* 199574 */     // GIR_Coverage, 3965,
     /* 199574 */     GIR_EraseRootFromParent_Done,
     /* 199575 */   // Label 3727: @199575
     /* 199575 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(199617), // Rule ID 5255 //
     /* 199580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 199585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199606 */     // (intrinsic_wo_chain:{ *:[v1f64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199615 */     GIR_RootConstrainSelectedInstOperands,
     /* 199616 */     // GIR_Coverage, 5255,
     /* 199616 */     GIR_EraseRootFromParent_Done,
     /* 199617 */   // Label 3728: @199617
     /* 199617 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(199662), // Rule ID 5259 //
     /* 199622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 199630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199651 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 199654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199660 */     GIR_RootConstrainSelectedInstOperands,
     /* 199661 */     // GIR_Coverage, 5259,
     /* 199661 */     GIR_EraseRootFromParent_Done,
     /* 199662 */   // Label 3729: @199662
     /* 199662 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(199707), // Rule ID 5263 //
     /* 199667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 199675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199696 */     // (intrinsic_wo_chain:{ *:[v1f64] } 620:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 199699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199705 */     GIR_RootConstrainSelectedInstOperands,
     /* 199706 */     // GIR_Coverage, 5263,
     /* 199706 */     GIR_EraseRootFromParent_Done,
     /* 199707 */   // Label 3730: @199707
     /* 199707 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(199752), // Rule ID 5264 //
     /* 199712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 199720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199741 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 199744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199750 */     GIR_RootConstrainSelectedInstOperands,
     /* 199751 */     // GIR_Coverage, 5264,
     /* 199751 */     GIR_EraseRootFromParent_Done,
     /* 199752 */   // Label 3731: @199752
     /* 199752 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199797), // Rule ID 5265 //
     /* 199757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 199765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199786 */     // (intrinsic_wo_chain:{ *:[v1f64] } 650:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 199789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199795 */     GIR_RootConstrainSelectedInstOperands,
     /* 199796 */     // GIR_Coverage, 5265,
     /* 199796 */     GIR_EraseRootFromParent_Done,
     /* 199797 */   // Label 3732: @199797
     /* 199797 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199842), // Rule ID 5266 //
     /* 199802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199831 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 199834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199840 */     GIR_RootConstrainSelectedInstOperands,
     /* 199841 */     // GIR_Coverage, 5266,
     /* 199841 */     GIR_EraseRootFromParent_Done,
     /* 199842 */   // Label 3733: @199842
     /* 199842 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199887), // Rule ID 5267 //
     /* 199847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199876 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 199879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199885 */     GIR_RootConstrainSelectedInstOperands,
     /* 199886 */     // GIR_Coverage, 5267,
     /* 199886 */     GIR_EraseRootFromParent_Done,
     /* 199887 */   // Label 3734: @199887
     /* 199887 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199932), // Rule ID 5268 //
     /* 199892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199921 */     // (intrinsic_wo_chain:{ *:[i64] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 199924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199930 */     GIR_RootConstrainSelectedInstOperands,
     /* 199931 */     // GIR_Coverage, 5268,
     /* 199931 */     GIR_EraseRootFromParent_Done,
     /* 199932 */   // Label 3735: @199932
     /* 199932 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199977), // Rule ID 5269 //
     /* 199937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199966 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 199969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199975 */     GIR_RootConstrainSelectedInstOperands,
     /* 199976 */     // GIR_Coverage, 5269,
     /* 199976 */     GIR_EraseRootFromParent_Done,
     /* 199977 */   // Label 3736: @199977
     /* 199977 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(200022), // Rule ID 5270 //
     /* 199982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200011 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 200014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200020 */     GIR_RootConstrainSelectedInstOperands,
     /* 200021 */     // GIR_Coverage, 5270,
     /* 200021 */     GIR_EraseRootFromParent_Done,
     /* 200022 */   // Label 3737: @200022
     /* 200022 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(200067), // Rule ID 5271 //
     /* 200027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 200035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200056 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 200059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200065 */     GIR_RootConstrainSelectedInstOperands,
     /* 200066 */     // GIR_Coverage, 5271,
     /* 200066 */     GIR_EraseRootFromParent_Done,
     /* 200067 */   // Label 3738: @200067
     /* 200067 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(200112), // Rule ID 5272 //
     /* 200072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 200080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200101 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 200104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200110 */     GIR_RootConstrainSelectedInstOperands,
     /* 200111 */     // GIR_Coverage, 5272,
     /* 200111 */     GIR_EraseRootFromParent_Done,
     /* 200112 */   // Label 3739: @200112
     /* 200112 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200157), // Rule ID 5273 //
     /* 200117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 200125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200146 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 200149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200155 */     GIR_RootConstrainSelectedInstOperands,
     /* 200156 */     // GIR_Coverage, 5273,
     /* 200156 */     GIR_EraseRootFromParent_Done,
     /* 200157 */   // Label 3740: @200157
     /* 200157 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200202), // Rule ID 5274 //
     /* 200162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 200170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200191 */     // (intrinsic_wo_chain:{ *:[i64] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 200194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200200 */     GIR_RootConstrainSelectedInstOperands,
     /* 200201 */     // GIR_Coverage, 5274,
     /* 200201 */     GIR_EraseRootFromParent_Done,
     /* 200202 */   // Label 3741: @200202
     /* 200202 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200247), // Rule ID 5275 //
     /* 200207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 200215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200236 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 200239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200245 */     GIR_RootConstrainSelectedInstOperands,
     /* 200246 */     // GIR_Coverage, 5275,
     /* 200246 */     GIR_EraseRootFromParent_Done,
     /* 200247 */   // Label 3742: @200247
     /* 200247 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200292), // Rule ID 5276 //
     /* 200252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 200260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200281 */     // (intrinsic_wo_chain:{ *:[i64] } 752:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 200284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200290 */     GIR_RootConstrainSelectedInstOperands,
     /* 200291 */     // GIR_Coverage, 5276,
     /* 200291 */     GIR_EraseRootFromParent_Done,
     /* 200292 */   // Label 3743: @200292
     /* 200292 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200337), // Rule ID 5277 //
     /* 200297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 200305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200326 */     // (intrinsic_wo_chain:{ *:[i32] } 752:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 200329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200335 */     GIR_RootConstrainSelectedInstOperands,
     /* 200336 */     // GIR_Coverage, 5277,
     /* 200336 */     GIR_EraseRootFromParent_Done,
     /* 200337 */   // Label 3744: @200337
     /* 200337 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200382), // Rule ID 5278 //
     /* 200342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 200350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200371 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 200374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200380 */     GIR_RootConstrainSelectedInstOperands,
     /* 200381 */     // GIR_Coverage, 5278,
     /* 200381 */     GIR_EraseRootFromParent_Done,
     /* 200382 */   // Label 3745: @200382
     /* 200382 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200427), // Rule ID 5279 //
     /* 200387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 200395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200416 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 200419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200425 */     GIR_RootConstrainSelectedInstOperands,
     /* 200426 */     // GIR_Coverage, 5279,
     /* 200426 */     GIR_EraseRootFromParent_Done,
     /* 200427 */   // Label 3746: @200427
     /* 200427 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200472), // Rule ID 5298 //
     /* 200432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 200440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200461 */     // (intrinsic_wo_chain:{ *:[v1i64] } 764:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 200461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 200464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200470 */     GIR_RootConstrainSelectedInstOperands,
     /* 200471 */     // GIR_Coverage, 5298,
     /* 200471 */     GIR_EraseRootFromParent_Done,
     /* 200472 */   // Label 3747: @200472
     /* 200472 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(200514), // Rule ID 5632 //
     /* 200477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 200485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 200491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200503 */     // (intrinsic_wo_chain:{ *:[v8i8] } 726:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 200503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 200506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 200512 */     GIR_RootConstrainSelectedInstOperands,
     /* 200513 */     // GIR_Coverage, 5632,
     /* 200513 */     GIR_EraseRootFromParent_Done,
     /* 200514 */   // Label 3748: @200514
     /* 200514 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(200556), // Rule ID 5633 //
     /* 200519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 200527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 200533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200545 */     // (intrinsic_wo_chain:{ *:[v16i8] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 200545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 200548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 200552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200554 */     GIR_RootConstrainSelectedInstOperands,
     /* 200555 */     // GIR_Coverage, 5633,
     /* 200555 */     GIR_EraseRootFromParent_Done,
     /* 200556 */   // Label 3749: @200556
     /* 200556 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(200653), // Rule ID 6360 //
     /* 200561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 200566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200587 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 200594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200652 */     // GIR_Coverage, 6360,
     /* 200652 */     GIR_EraseRootFromParent_Done,
     /* 200653 */   // Label 3750: @200653
     /* 200653 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(200750), // Rule ID 6361 //
     /* 200658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 200663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200684 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 200691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200700 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200749 */     // GIR_Coverage, 6361,
     /* 200749 */     GIR_EraseRootFromParent_Done,
     /* 200750 */   // Label 3751: @200750
     /* 200750 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(200792), // Rule ID 7016 //
     /* 200755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 200760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200781 */     // (intrinsic_wo_chain:{ *:[i64] } 713:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 200784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200790 */     GIR_RootConstrainSelectedInstOperands,
     /* 200791 */     // GIR_Coverage, 7016,
     /* 200791 */     GIR_EraseRootFromParent_Done,
     /* 200792 */   // Label 3752: @200792
     /* 200792 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(200834), // Rule ID 7017 //
     /* 200797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 200802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200823 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 200826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200832 */     GIR_RootConstrainSelectedInstOperands,
     /* 200833 */     // GIR_Coverage, 7017,
     /* 200833 */     GIR_EraseRootFromParent_Done,
     /* 200834 */   // Label 3753: @200834
     /* 200834 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(200876), // Rule ID 7018 //
     /* 200839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 200844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200865 */     // (intrinsic_wo_chain:{ *:[i64] } 712:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 200868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200874 */     GIR_RootConstrainSelectedInstOperands,
     /* 200875 */     // GIR_Coverage, 7018,
     /* 200875 */     GIR_EraseRootFromParent_Done,
     /* 200876 */   // Label 3754: @200876
     /* 200876 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200918), // Rule ID 7019 //
     /* 200881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 200886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200907 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 200910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200916 */     GIR_RootConstrainSelectedInstOperands,
     /* 200917 */     // GIR_Coverage, 7019,
     /* 200917 */     GIR_EraseRootFromParent_Done,
     /* 200918 */   // Label 3755: @200918
     /* 200918 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200966), // Rule ID 7059 //
     /* 200923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 200928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200949 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 200949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 200952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 200961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 200964 */     GIR_RootConstrainSelectedInstOperands,
     /* 200965 */     // GIR_Coverage, 7059,
     /* 200965 */     GIR_EraseRootFromParent_Done,
     /* 200966 */   // Label 3756: @200966
     /* 200966 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(201011), // Rule ID 10148 //
     /* 200971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201000 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 201003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201009 */     GIR_RootConstrainSelectedInstOperands,
     /* 201010 */     // GIR_Coverage, 10148,
     /* 201010 */     GIR_EraseRootFromParent_Done,
     /* 201011 */   // Label 3757: @201011
     /* 201011 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(201056), // Rule ID 10149 //
     /* 201016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 201024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201045 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 201048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201054 */     GIR_RootConstrainSelectedInstOperands,
     /* 201055 */     // GIR_Coverage, 10149,
     /* 201055 */     GIR_EraseRootFromParent_Done,
     /* 201056 */   // Label 3758: @201056
     /* 201056 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(201101), // Rule ID 10150 //
     /* 201061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 201069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201090 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 201093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201099 */     GIR_RootConstrainSelectedInstOperands,
     /* 201100 */     // GIR_Coverage, 10150,
     /* 201100 */     GIR_EraseRootFromParent_Done,
     /* 201101 */   // Label 3759: @201101
     /* 201101 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201146), // Rule ID 10151 //
     /* 201106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 201114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201135 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 201138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201144 */     GIR_RootConstrainSelectedInstOperands,
     /* 201145 */     // GIR_Coverage, 10151,
     /* 201145 */     GIR_EraseRootFromParent_Done,
     /* 201146 */   // Label 3760: @201146
     /* 201146 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201191), // Rule ID 10160 //
     /* 201151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 201159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201180 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 201183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201189 */     GIR_RootConstrainSelectedInstOperands,
     /* 201190 */     // GIR_Coverage, 10160,
     /* 201190 */     GIR_EraseRootFromParent_Done,
     /* 201191 */   // Label 3761: @201191
     /* 201191 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201236), // Rule ID 10161 //
     /* 201196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 201204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201225 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 201228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201234 */     GIR_RootConstrainSelectedInstOperands,
     /* 201235 */     // GIR_Coverage, 10161,
     /* 201235 */     GIR_EraseRootFromParent_Done,
     /* 201236 */   // Label 3762: @201236
     /* 201236 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201281), // Rule ID 10162 //
     /* 201241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 201249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201270 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 201273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201279 */     GIR_RootConstrainSelectedInstOperands,
     /* 201280 */     // GIR_Coverage, 10162,
     /* 201280 */     GIR_EraseRootFromParent_Done,
     /* 201281 */   // Label 3763: @201281
     /* 201281 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201326), // Rule ID 10163 //
     /* 201286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 201294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201315 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 201318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201324 */     GIR_RootConstrainSelectedInstOperands,
     /* 201325 */     // GIR_Coverage, 10163,
     /* 201325 */     GIR_EraseRootFromParent_Done,
     /* 201326 */   // Label 3764: @201326
     /* 201326 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201371), // Rule ID 10164 //
     /* 201331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201360 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 201363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201369 */     GIR_RootConstrainSelectedInstOperands,
     /* 201370 */     // GIR_Coverage, 10164,
     /* 201370 */     GIR_EraseRootFromParent_Done,
     /* 201371 */   // Label 3765: @201371
     /* 201371 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201416), // Rule ID 10165 //
     /* 201376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201405 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 201408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201414 */     GIR_RootConstrainSelectedInstOperands,
     /* 201415 */     // GIR_Coverage, 10165,
     /* 201415 */     GIR_EraseRootFromParent_Done,
     /* 201416 */   // Label 3766: @201416
     /* 201416 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201461), // Rule ID 10166 //
     /* 201421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201450 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 201453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201459 */     GIR_RootConstrainSelectedInstOperands,
     /* 201460 */     // GIR_Coverage, 10166,
     /* 201460 */     GIR_EraseRootFromParent_Done,
     /* 201461 */   // Label 3767: @201461
     /* 201461 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201506), // Rule ID 10167 //
     /* 201466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201495 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201504 */     GIR_RootConstrainSelectedInstOperands,
     /* 201505 */     // GIR_Coverage, 10167,
     /* 201505 */     GIR_EraseRootFromParent_Done,
     /* 201506 */   // Label 3768: @201506
     /* 201506 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201551), // Rule ID 10168 //
     /* 201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201540 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 201543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201549 */     GIR_RootConstrainSelectedInstOperands,
     /* 201550 */     // GIR_Coverage, 10168,
     /* 201550 */     GIR_EraseRootFromParent_Done,
     /* 201551 */   // Label 3769: @201551
     /* 201551 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201596), // Rule ID 10169 //
     /* 201556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201585 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 201588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201594 */     GIR_RootConstrainSelectedInstOperands,
     /* 201595 */     // GIR_Coverage, 10169,
     /* 201595 */     GIR_EraseRootFromParent_Done,
     /* 201596 */   // Label 3770: @201596
     /* 201596 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(201641), // Rule ID 10170 //
     /* 201601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201630 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 201633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201639 */     GIR_RootConstrainSelectedInstOperands,
     /* 201640 */     // GIR_Coverage, 10170,
     /* 201640 */     GIR_EraseRootFromParent_Done,
     /* 201641 */   // Label 3771: @201641
     /* 201641 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(201686), // Rule ID 10171 //
     /* 201646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201675 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 201678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201684 */     GIR_RootConstrainSelectedInstOperands,
     /* 201685 */     // GIR_Coverage, 10171,
     /* 201685 */     GIR_EraseRootFromParent_Done,
     /* 201686 */   // Label 3772: @201686
     /* 201686 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(201732), // Rule ID 138 //
     /* 201691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 201699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201709 */     // MIs[0] Rn
     /* 201709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201721 */     // (intrinsic_wo_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201730 */     GIR_RootConstrainSelectedInstOperands,
     /* 201731 */     // GIR_Coverage, 138,
     /* 201731 */     GIR_EraseRootFromParent_Done,
     /* 201732 */   // Label 3773: @201732
     /* 201732 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(201779), // Rule ID 139 //
     /* 201737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 201745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201752 */     // MIs[0] Rn
     /* 201752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201760 */     // MIs[0] Rm
     /* 201760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 201764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201768 */     // (intrinsic_wo_chain:{ *:[i64] } 1252:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 201768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 201771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201777 */     GIR_RootConstrainSelectedInstOperands,
     /* 201778 */     // GIR_Coverage, 139,
     /* 201778 */     GIR_EraseRootFromParent_Done,
     /* 201779 */   // Label 3774: @201779
     /* 201779 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(201816), // Rule ID 2403 //
     /* 201784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 201792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201805 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2161:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 201808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201814 */     GIR_RootConstrainSelectedInstOperands,
     /* 201815 */     // GIR_Coverage, 2403,
     /* 201815 */     GIR_EraseRootFromParent_Done,
     /* 201816 */   // Label 3775: @201816
     /* 201816 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(201853), // Rule ID 2404 //
     /* 201821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 201829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2162:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 201845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201851 */     GIR_RootConstrainSelectedInstOperands,
     /* 201852 */     // GIR_Coverage, 2404,
     /* 201852 */     GIR_EraseRootFromParent_Done,
     /* 201853 */   // Label 3776: @201853
     /* 201853 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(201890), // Rule ID 2405 //
     /* 201858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 201866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 201882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201888 */     GIR_RootConstrainSelectedInstOperands,
     /* 201889 */     // GIR_Coverage, 2405,
     /* 201889 */     GIR_EraseRootFromParent_Done,
     /* 201890 */   // Label 3777: @201890
     /* 201890 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(201927), // Rule ID 2407 //
     /* 201895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 201903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2166:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 201919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201925 */     GIR_RootConstrainSelectedInstOperands,
     /* 201926 */     // GIR_Coverage, 2407,
     /* 201926 */     GIR_EraseRootFromParent_Done,
     /* 201927 */   // Label 3778: @201927
     /* 201927 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(201964), // Rule ID 2408 //
     /* 201932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 201940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201953 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2167:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 201956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201962 */     GIR_RootConstrainSelectedInstOperands,
     /* 201963 */     // GIR_Coverage, 2408,
     /* 201963 */     GIR_EraseRootFromParent_Done,
     /* 201964 */   // Label 3779: @201964
     /* 201964 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(202001), // Rule ID 2409 //
     /* 201969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 201977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2168:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 201993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201999 */     GIR_RootConstrainSelectedInstOperands,
     /* 202000 */     // GIR_Coverage, 2409,
     /* 202000 */     GIR_EraseRootFromParent_Done,
     /* 202001 */   // Label 3780: @202001
     /* 202001 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(202038), // Rule ID 2411 //
     /* 202006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 202014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2087:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 202030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202036 */     GIR_RootConstrainSelectedInstOperands,
     /* 202037 */     // GIR_Coverage, 2411,
     /* 202037 */     GIR_EraseRootFromParent_Done,
     /* 202038 */   // Label 3781: @202038
     /* 202038 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(202075), // Rule ID 2412 //
     /* 202043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 202051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202064 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 202067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202073 */     GIR_RootConstrainSelectedInstOperands,
     /* 202074 */     // GIR_Coverage, 2412,
     /* 202074 */     GIR_EraseRootFromParent_Done,
     /* 202075 */   // Label 3782: @202075
     /* 202075 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(202112), // Rule ID 2413 //
     /* 202080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 202088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202101 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 202104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202110 */     GIR_RootConstrainSelectedInstOperands,
     /* 202111 */     // GIR_Coverage, 2413,
     /* 202111 */     GIR_EraseRootFromParent_Done,
     /* 202112 */   // Label 3783: @202112
     /* 202112 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(202149), // Rule ID 2415 //
     /* 202117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 202125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2092:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 202141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202147 */     GIR_RootConstrainSelectedInstOperands,
     /* 202148 */     // GIR_Coverage, 2415,
     /* 202148 */     GIR_EraseRootFromParent_Done,
     /* 202149 */   // Label 3784: @202149
     /* 202149 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202186), // Rule ID 2416 //
     /* 202154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 202162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2093:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 202178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202184 */     GIR_RootConstrainSelectedInstOperands,
     /* 202185 */     // GIR_Coverage, 2416,
     /* 202185 */     GIR_EraseRootFromParent_Done,
     /* 202186 */   // Label 3785: @202186
     /* 202186 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202223), // Rule ID 2417 //
     /* 202191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 202199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 202215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202221 */     GIR_RootConstrainSelectedInstOperands,
     /* 202222 */     // GIR_Coverage, 2417,
     /* 202222 */     GIR_EraseRootFromParent_Done,
     /* 202223 */   // Label 3786: @202223
     /* 202223 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202260), // Rule ID 2419 //
     /* 202228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 202236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202249 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1931:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 202252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202258 */     GIR_RootConstrainSelectedInstOperands,
     /* 202259 */     // GIR_Coverage, 2419,
     /* 202259 */     GIR_EraseRootFromParent_Done,
     /* 202260 */   // Label 3787: @202260
     /* 202260 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202297), // Rule ID 2420 //
     /* 202265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 202273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1932:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202295 */     GIR_RootConstrainSelectedInstOperands,
     /* 202296 */     // GIR_Coverage, 2420,
     /* 202296 */     GIR_EraseRootFromParent_Done,
     /* 202297 */   // Label 3788: @202297
     /* 202297 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202334), // Rule ID 2421 //
     /* 202302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 202310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 202326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202332 */     GIR_RootConstrainSelectedInstOperands,
     /* 202333 */     // GIR_Coverage, 2421,
     /* 202333 */     GIR_EraseRootFromParent_Done,
     /* 202334 */   // Label 3789: @202334
     /* 202334 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202371), // Rule ID 2423 //
     /* 202339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 202347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 202363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202369 */     GIR_RootConstrainSelectedInstOperands,
     /* 202370 */     // GIR_Coverage, 2423,
     /* 202370 */     GIR_EraseRootFromParent_Done,
     /* 202371 */   // Label 3790: @202371
     /* 202371 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(202408), // Rule ID 2424 //
     /* 202376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 202384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202397 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1937:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 202400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202406 */     GIR_RootConstrainSelectedInstOperands,
     /* 202407 */     // GIR_Coverage, 2424,
     /* 202407 */     GIR_EraseRootFromParent_Done,
     /* 202408 */   // Label 3791: @202408
     /* 202408 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(202445), // Rule ID 2425 //
     /* 202413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 202421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202434 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1938:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 202437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202443 */     GIR_RootConstrainSelectedInstOperands,
     /* 202444 */     // GIR_Coverage, 2425,
     /* 202444 */     GIR_EraseRootFromParent_Done,
     /* 202445 */   // Label 3792: @202445
     /* 202445 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(202482), // Rule ID 2426 //
     /* 202450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 202453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 202458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1556:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 202471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 202474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202480 */     GIR_RootConstrainSelectedInstOperands,
     /* 202481 */     // GIR_Coverage, 2426,
     /* 202481 */     GIR_EraseRootFromParent_Done,
     /* 202482 */   // Label 3793: @202482
     /* 202482 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(202522), // Rule ID 2621 //
     /* 202487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 202495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202508 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1635:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 202511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202520 */     GIR_RootConstrainSelectedInstOperands,
     /* 202521 */     // GIR_Coverage, 2621,
     /* 202521 */     GIR_EraseRootFromParent_Done,
     /* 202522 */   // Label 3794: @202522
     /* 202522 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(202562), // Rule ID 2622 //
     /* 202527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202560 */     GIR_RootConstrainSelectedInstOperands,
     /* 202561 */     // GIR_Coverage, 2622,
     /* 202561 */     GIR_EraseRootFromParent_Done,
     /* 202562 */   // Label 3795: @202562
     /* 202562 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(202602), // Rule ID 2623 //
     /* 202567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1643:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 202591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202600 */     GIR_RootConstrainSelectedInstOperands,
     /* 202601 */     // GIR_Coverage, 2623,
     /* 202601 */     GIR_EraseRootFromParent_Done,
     /* 202602 */   // Label 3796: @202602
     /* 202602 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(202642), // Rule ID 2624 //
     /* 202607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1643:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 202631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202640 */     GIR_RootConstrainSelectedInstOperands,
     /* 202641 */     // GIR_Coverage, 2624,
     /* 202641 */     GIR_EraseRootFromParent_Done,
     /* 202642 */   // Label 3797: @202642
     /* 202642 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(202682), // Rule ID 2625 //
     /* 202647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1643:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 202671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202680 */     GIR_RootConstrainSelectedInstOperands,
     /* 202681 */     // GIR_Coverage, 2625,
     /* 202681 */     GIR_EraseRootFromParent_Done,
     /* 202682 */   // Label 3798: @202682
     /* 202682 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(202719), // Rule ID 2642 //
     /* 202687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 202711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202717 */     GIR_RootConstrainSelectedInstOperands,
     /* 202718 */     // GIR_Coverage, 2642,
     /* 202718 */     GIR_EraseRootFromParent_Done,
     /* 202719 */   // Label 3799: @202719
     /* 202719 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(202756), // Rule ID 2643 //
     /* 202724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 202748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202754 */     GIR_RootConstrainSelectedInstOperands,
     /* 202755 */     // GIR_Coverage, 2643,
     /* 202755 */     GIR_EraseRootFromParent_Done,
     /* 202756 */   // Label 3800: @202756
     /* 202756 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(202793), // Rule ID 2644 //
     /* 202761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 202785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202791 */     GIR_RootConstrainSelectedInstOperands,
     /* 202792 */     // GIR_Coverage, 2644,
     /* 202792 */     GIR_EraseRootFromParent_Done,
     /* 202793 */   // Label 3801: @202793
     /* 202793 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(202830), // Rule ID 2645 //
     /* 202798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202819 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 202822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202828 */     GIR_RootConstrainSelectedInstOperands,
     /* 202829 */     // GIR_Coverage, 2645,
     /* 202829 */     GIR_EraseRootFromParent_Done,
     /* 202830 */   // Label 3802: @202830
     /* 202830 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(202867), // Rule ID 2646 //
     /* 202835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202856 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 202859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202865 */     GIR_RootConstrainSelectedInstOperands,
     /* 202866 */     // GIR_Coverage, 2646,
     /* 202866 */     GIR_EraseRootFromParent_Done,
     /* 202867 */   // Label 3803: @202867
     /* 202867 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(202904), // Rule ID 2647 //
     /* 202872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202893 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 202896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202902 */     GIR_RootConstrainSelectedInstOperands,
     /* 202903 */     // GIR_Coverage, 2647,
     /* 202903 */     GIR_EraseRootFromParent_Done,
     /* 202904 */   // Label 3804: @202904
     /* 202904 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(202941), // Rule ID 2648 //
     /* 202909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202930 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 202933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202939 */     GIR_RootConstrainSelectedInstOperands,
     /* 202940 */     // GIR_Coverage, 2648,
     /* 202940 */     GIR_EraseRootFromParent_Done,
     /* 202941 */   // Label 3805: @202941
     /* 202941 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(202978), // Rule ID 2826 //
     /* 202946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202967 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1553:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202976 */     GIR_RootConstrainSelectedInstOperands,
     /* 202977 */     // GIR_Coverage, 2826,
     /* 202977 */     GIR_EraseRootFromParent_Done,
     /* 202978 */   // Label 3806: @202978
     /* 202978 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(203015), // Rule ID 2827 //
     /* 202983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 203007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203013 */     GIR_RootConstrainSelectedInstOperands,
     /* 203014 */     // GIR_Coverage, 2827,
     /* 203014 */     GIR_EraseRootFromParent_Done,
     /* 203015 */   // Label 3807: @203015
     /* 203015 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(203052), // Rule ID 2828 //
     /* 203020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 203028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203041 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1553:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 203044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203050 */     GIR_RootConstrainSelectedInstOperands,
     /* 203051 */     // GIR_Coverage, 2828,
     /* 203051 */     GIR_EraseRootFromParent_Done,
     /* 203052 */   // Label 3808: @203052
     /* 203052 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(203089), // Rule ID 3014 //
     /* 203057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 203065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203078 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 203081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203087 */     GIR_RootConstrainSelectedInstOperands,
     /* 203088 */     // GIR_Coverage, 3014,
     /* 203088 */     GIR_EraseRootFromParent_Done,
     /* 203089 */   // Label 3809: @203089
     /* 203089 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(203126), // Rule ID 3015 //
     /* 203094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 203102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 203118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203124 */     GIR_RootConstrainSelectedInstOperands,
     /* 203125 */     // GIR_Coverage, 3015,
     /* 203125 */     GIR_EraseRootFromParent_Done,
     /* 203126 */   // Label 3810: @203126
     /* 203126 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203163), // Rule ID 3016 //
     /* 203131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 203139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 203155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203161 */     GIR_RootConstrainSelectedInstOperands,
     /* 203162 */     // GIR_Coverage, 3016,
     /* 203162 */     GIR_EraseRootFromParent_Done,
     /* 203163 */   // Label 3811: @203163
     /* 203163 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203200), // Rule ID 3017 //
     /* 203168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 203176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 203192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203198 */     GIR_RootConstrainSelectedInstOperands,
     /* 203199 */     // GIR_Coverage, 3017,
     /* 203199 */     GIR_EraseRootFromParent_Done,
     /* 203200 */   // Label 3812: @203200
     /* 203200 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203237), // Rule ID 3018 //
     /* 203205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 203213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 203229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203235 */     GIR_RootConstrainSelectedInstOperands,
     /* 203236 */     // GIR_Coverage, 3018,
     /* 203236 */     GIR_EraseRootFromParent_Done,
     /* 203237 */   // Label 3813: @203237
     /* 203237 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203274), // Rule ID 3040 //
     /* 203242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 203250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203263 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 203266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203272 */     GIR_RootConstrainSelectedInstOperands,
     /* 203273 */     // GIR_Coverage, 3040,
     /* 203273 */     GIR_EraseRootFromParent_Done,
     /* 203274 */   // Label 3814: @203274
     /* 203274 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203311), // Rule ID 3041 //
     /* 203279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 203287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 203303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203309 */     GIR_RootConstrainSelectedInstOperands,
     /* 203310 */     // GIR_Coverage, 3041,
     /* 203310 */     GIR_EraseRootFromParent_Done,
     /* 203311 */   // Label 3815: @203311
     /* 203311 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(203348), // Rule ID 3042 //
     /* 203316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 203324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 203340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203346 */     GIR_RootConstrainSelectedInstOperands,
     /* 203347 */     // GIR_Coverage, 3042,
     /* 203347 */     GIR_EraseRootFromParent_Done,
     /* 203348 */   // Label 3816: @203348
     /* 203348 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(203385), // Rule ID 3046 //
     /* 203353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 203356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1641:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 203377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203383 */     GIR_RootConstrainSelectedInstOperands,
     /* 203384 */     // GIR_Coverage, 3046,
     /* 203384 */     GIR_EraseRootFromParent_Done,
     /* 203385 */   // Label 3817: @203385
     /* 203385 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(203422), // Rule ID 3047 //
     /* 203390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203411 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1641:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 203414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203420 */     GIR_RootConstrainSelectedInstOperands,
     /* 203421 */     // GIR_Coverage, 3047,
     /* 203421 */     GIR_EraseRootFromParent_Done,
     /* 203422 */   // Label 3818: @203422
     /* 203422 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(203459), // Rule ID 3048 //
     /* 203427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1641:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 203451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203457 */     GIR_RootConstrainSelectedInstOperands,
     /* 203458 */     // GIR_Coverage, 3048,
     /* 203458 */     GIR_EraseRootFromParent_Done,
     /* 203459 */   // Label 3819: @203459
     /* 203459 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(203496), // Rule ID 3049 //
     /* 203464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203485 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1283:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 203488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203494 */     GIR_RootConstrainSelectedInstOperands,
     /* 203495 */     // GIR_Coverage, 3049,
     /* 203495 */     GIR_EraseRootFromParent_Done,
     /* 203496 */   // Label 3820: @203496
     /* 203496 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(203533), // Rule ID 3050 //
     /* 203501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1283:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 203525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203531 */     GIR_RootConstrainSelectedInstOperands,
     /* 203532 */     // GIR_Coverage, 3050,
     /* 203532 */     GIR_EraseRootFromParent_Done,
     /* 203533 */   // Label 3821: @203533
     /* 203533 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(203570), // Rule ID 3051 //
     /* 203538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1283:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 203562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203568 */     GIR_RootConstrainSelectedInstOperands,
     /* 203569 */     // GIR_Coverage, 3051,
     /* 203569 */     GIR_EraseRootFromParent_Done,
     /* 203570 */   // Label 3822: @203570
     /* 203570 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(203607), // Rule ID 3052 //
     /* 203575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1283:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 203599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203605 */     GIR_RootConstrainSelectedInstOperands,
     /* 203606 */     // GIR_Coverage, 3052,
     /* 203606 */     GIR_EraseRootFromParent_Done,
     /* 203607 */   // Label 3823: @203607
     /* 203607 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(203644), // Rule ID 3053 //
     /* 203612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 203636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203642 */     GIR_RootConstrainSelectedInstOperands,
     /* 203643 */     // GIR_Coverage, 3053,
     /* 203643 */     GIR_EraseRootFromParent_Done,
     /* 203644 */   // Label 3824: @203644
     /* 203644 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(203681), // Rule ID 3054 //
     /* 203649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 203673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203679 */     GIR_RootConstrainSelectedInstOperands,
     /* 203680 */     // GIR_Coverage, 3054,
     /* 203680 */     GIR_EraseRootFromParent_Done,
     /* 203681 */   // Label 3825: @203681
     /* 203681 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(203718), // Rule ID 3055 //
     /* 203686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 203710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203716 */     GIR_RootConstrainSelectedInstOperands,
     /* 203717 */     // GIR_Coverage, 3055,
     /* 203717 */     GIR_EraseRootFromParent_Done,
     /* 203718 */   // Label 3826: @203718
     /* 203718 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(203755), // Rule ID 3102 //
     /* 203723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 203747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203753 */     GIR_RootConstrainSelectedInstOperands,
     /* 203754 */     // GIR_Coverage, 3102,
     /* 203754 */     GIR_EraseRootFromParent_Done,
     /* 203755 */   // Label 3827: @203755
     /* 203755 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(203792), // Rule ID 3103 //
     /* 203760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 203784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203790 */     GIR_RootConstrainSelectedInstOperands,
     /* 203791 */     // GIR_Coverage, 3103,
     /* 203791 */     GIR_EraseRootFromParent_Done,
     /* 203792 */   // Label 3828: @203792
     /* 203792 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(203829), // Rule ID 3104 //
     /* 203797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 203821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203827 */     GIR_RootConstrainSelectedInstOperands,
     /* 203828 */     // GIR_Coverage, 3104,
     /* 203828 */     GIR_EraseRootFromParent_Done,
     /* 203829 */   // Label 3829: @203829
     /* 203829 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(203866), // Rule ID 3111 //
     /* 203834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203855 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 203858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203864 */     GIR_RootConstrainSelectedInstOperands,
     /* 203865 */     // GIR_Coverage, 3111,
     /* 203865 */     GIR_EraseRootFromParent_Done,
     /* 203866 */   // Label 3830: @203866
     /* 203866 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(203903), // Rule ID 3112 //
     /* 203871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 203895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203901 */     GIR_RootConstrainSelectedInstOperands,
     /* 203902 */     // GIR_Coverage, 3112,
     /* 203902 */     GIR_EraseRootFromParent_Done,
     /* 203903 */   // Label 3831: @203903
     /* 203903 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(203940), // Rule ID 3113 //
     /* 203908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 203932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203938 */     GIR_RootConstrainSelectedInstOperands,
     /* 203939 */     // GIR_Coverage, 3113,
     /* 203939 */     GIR_EraseRootFromParent_Done,
     /* 203940 */   // Label 3832: @203940
     /* 203940 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(203980), // Rule ID 3221 //
     /* 203945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203966 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 203969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203978 */     GIR_RootConstrainSelectedInstOperands,
     /* 203979 */     // GIR_Coverage, 3221,
     /* 203979 */     GIR_EraseRootFromParent_Done,
     /* 203980 */   // Label 3833: @203980
     /* 203980 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(204020), // Rule ID 3222 //
     /* 203985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 204009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204018 */     GIR_RootConstrainSelectedInstOperands,
     /* 204019 */     // GIR_Coverage, 3222,
     /* 204019 */     GIR_EraseRootFromParent_Done,
     /* 204020 */   // Label 3834: @204020
     /* 204020 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(204060), // Rule ID 3223 //
     /* 204025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204046 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 204049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204058 */     GIR_RootConstrainSelectedInstOperands,
     /* 204059 */     // GIR_Coverage, 3223,
     /* 204059 */     GIR_EraseRootFromParent_Done,
     /* 204060 */   // Label 3835: @204060
     /* 204060 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(204100), // Rule ID 3224 //
     /* 204065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 204089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204098 */     GIR_RootConstrainSelectedInstOperands,
     /* 204099 */     // GIR_Coverage, 3224,
     /* 204099 */     GIR_EraseRootFromParent_Done,
     /* 204100 */   // Label 3836: @204100
     /* 204100 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(204140), // Rule ID 3229 //
     /* 204105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204126 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 204129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204138 */     GIR_RootConstrainSelectedInstOperands,
     /* 204139 */     // GIR_Coverage, 3229,
     /* 204139 */     GIR_EraseRootFromParent_Done,
     /* 204140 */   // Label 3837: @204140
     /* 204140 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204180), // Rule ID 3230 //
     /* 204145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 204169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204178 */     GIR_RootConstrainSelectedInstOperands,
     /* 204179 */     // GIR_Coverage, 3230,
     /* 204179 */     GIR_EraseRootFromParent_Done,
     /* 204180 */   // Label 3838: @204180
     /* 204180 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204220), // Rule ID 3231 //
     /* 204185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 204209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 3231,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 3839: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204260), // Rule ID 3232 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 204233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 204249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204258 */     GIR_RootConstrainSelectedInstOperands,
     /* 204259 */     // GIR_Coverage, 3232,
     /* 204259 */     GIR_EraseRootFromParent_Done,
     /* 204260 */   // Label 3840: @204260
     /* 204260 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204297), // Rule ID 3421 //
     /* 204265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 204268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 204289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204295 */     GIR_RootConstrainSelectedInstOperands,
     /* 204296 */     // GIR_Coverage, 3421,
     /* 204296 */     GIR_EraseRootFromParent_Done,
     /* 204297 */   // Label 3841: @204297
     /* 204297 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(204334), // Rule ID 3422 //
     /* 204302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 204305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204323 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 204326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204332 */     GIR_RootConstrainSelectedInstOperands,
     /* 204333 */     // GIR_Coverage, 3422,
     /* 204333 */     GIR_EraseRootFromParent_Done,
     /* 204334 */   // Label 3842: @204334
     /* 204334 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(204371), // Rule ID 3423 //
     /* 204339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 204342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 204363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204369 */     GIR_RootConstrainSelectedInstOperands,
     /* 204370 */     // GIR_Coverage, 3423,
     /* 204370 */     GIR_EraseRootFromParent_Done,
     /* 204371 */   // Label 3843: @204371
     /* 204371 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(204408), // Rule ID 3424 //
     /* 204376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 204379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 204400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204406 */     GIR_RootConstrainSelectedInstOperands,
     /* 204407 */     // GIR_Coverage, 3424,
     /* 204407 */     GIR_EraseRootFromParent_Done,
     /* 204408 */   // Label 3844: @204408
     /* 204408 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(204445), // Rule ID 3425 //
     /* 204413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (COMPACT_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_B),
     /* 204437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204443 */     GIR_RootConstrainSelectedInstOperands,
     /* 204444 */     // GIR_Coverage, 3425,
     /* 204444 */     GIR_EraseRootFromParent_Done,
     /* 204445 */   // Label 3845: @204445
     /* 204445 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(204482), // Rule ID 3426 //
     /* 204450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204480 */     GIR_RootConstrainSelectedInstOperands,
     /* 204481 */     // GIR_Coverage, 3426,
     /* 204481 */     GIR_EraseRootFromParent_Done,
     /* 204482 */   // Label 3846: @204482
     /* 204482 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(204519), // Rule ID 3427 //
     /* 204487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204517 */     GIR_RootConstrainSelectedInstOperands,
     /* 204518 */     // GIR_Coverage, 3427,
     /* 204518 */     GIR_EraseRootFromParent_Done,
     /* 204519 */   // Label 3847: @204519
     /* 204519 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(204556), // Rule ID 3449 //
     /* 204524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1554:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 204548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204554 */     GIR_RootConstrainSelectedInstOperands,
     /* 204555 */     // GIR_Coverage, 3449,
     /* 204555 */     GIR_EraseRootFromParent_Done,
     /* 204556 */   // Label 3848: @204556
     /* 204556 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(204593), // Rule ID 3450 //
     /* 204561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1554:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 204585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204591 */     GIR_RootConstrainSelectedInstOperands,
     /* 204592 */     // GIR_Coverage, 3450,
     /* 204592 */     GIR_EraseRootFromParent_Done,
     /* 204593 */   // Label 3849: @204593
     /* 204593 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(204630), // Rule ID 3451 //
     /* 204598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1554:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 204622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204628 */     GIR_RootConstrainSelectedInstOperands,
     /* 204629 */     // GIR_Coverage, 3451,
     /* 204629 */     GIR_EraseRootFromParent_Done,
     /* 204630 */   // Label 3850: @204630
     /* 204630 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(204667), // Rule ID 3473 //
     /* 204635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 204643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204656 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 204659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204665 */     GIR_RootConstrainSelectedInstOperands,
     /* 204666 */     // GIR_Coverage, 3473,
     /* 204666 */     GIR_EraseRootFromParent_Done,
     /* 204667 */   // Label 3851: @204667
     /* 204667 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(204704), // Rule ID 3478 //
     /* 204672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVESM4),
     /* 204675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 204680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 204696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204702 */     GIR_RootConstrainSelectedInstOperands,
     /* 204703 */     // GIR_Coverage, 3478,
     /* 204703 */     GIR_EraseRootFromParent_Done,
     /* 204704 */   // Label 3852: @204704
     /* 204704 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(204741), // Rule ID 3487 //
     /* 204709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204739 */     GIR_RootConstrainSelectedInstOperands,
     /* 204740 */     // GIR_Coverage, 3487,
     /* 204740 */     GIR_EraseRootFromParent_Done,
     /* 204741 */   // Label 3853: @204741
     /* 204741 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(204778), // Rule ID 3488 //
     /* 204746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2164:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204776 */     GIR_RootConstrainSelectedInstOperands,
     /* 204777 */     // GIR_Coverage, 3488,
     /* 204777 */     GIR_EraseRootFromParent_Done,
     /* 204778 */   // Label 3854: @204778
     /* 204778 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(204815), // Rule ID 3489 //
     /* 204783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2164:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204813 */     GIR_RootConstrainSelectedInstOperands,
     /* 204814 */     // GIR_Coverage, 3489,
     /* 204814 */     GIR_EraseRootFromParent_Done,
     /* 204815 */   // Label 3855: @204815
     /* 204815 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(204852), // Rule ID 3490 //
     /* 204820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2164:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204850 */     GIR_RootConstrainSelectedInstOperands,
     /* 204851 */     // GIR_Coverage, 3490,
     /* 204851 */     GIR_EraseRootFromParent_Done,
     /* 204852 */   // Label 3856: @204852
     /* 204852 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(204889), // Rule ID 3491 //
     /* 204857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2164:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204887 */     GIR_RootConstrainSelectedInstOperands,
     /* 204888 */     // GIR_Coverage, 3491,
     /* 204888 */     GIR_EraseRootFromParent_Done,
     /* 204889 */   // Label 3857: @204889
     /* 204889 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(204926), // Rule ID 3492 //
     /* 204894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2164:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204924 */     GIR_RootConstrainSelectedInstOperands,
     /* 204925 */     // GIR_Coverage, 3492,
     /* 204925 */     GIR_EraseRootFromParent_Done,
     /* 204926 */   // Label 3858: @204926
     /* 204926 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(204963), // Rule ID 3493 //
     /* 204931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2164:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204961 */     GIR_RootConstrainSelectedInstOperands,
     /* 204962 */     // GIR_Coverage, 3493,
     /* 204962 */     GIR_EraseRootFromParent_Done,
     /* 204963 */   // Label 3859: @204963
     /* 204963 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(205000), // Rule ID 3554 //
     /* 204968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204989 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 204992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204998 */     GIR_RootConstrainSelectedInstOperands,
     /* 204999 */     // GIR_Coverage, 3554,
     /* 204999 */     GIR_EraseRootFromParent_Done,
     /* 205000 */   // Label 3860: @205000
     /* 205000 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(205037), // Rule ID 3555 //
     /* 205005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 205013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205026 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 205029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205035 */     GIR_RootConstrainSelectedInstOperands,
     /* 205036 */     // GIR_Coverage, 3555,
     /* 205036 */     GIR_EraseRootFromParent_Done,
     /* 205037 */   // Label 3861: @205037
     /* 205037 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(205074), // Rule ID 3556 //
     /* 205042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 205050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 205053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205063 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 205066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205072 */     GIR_RootConstrainSelectedInstOperands,
     /* 205073 */     // GIR_Coverage, 3556,
     /* 205073 */     GIR_EraseRootFromParent_Done,
     /* 205074 */   // Label 3862: @205074
     /* 205074 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(205111), // Rule ID 3586 //
     /* 205079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 205087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 205090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 205093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205100 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 205103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205109 */     GIR_RootConstrainSelectedInstOperands,
     /* 205110 */     // GIR_Coverage, 3586,
     /* 205110 */     GIR_EraseRootFromParent_Done,
     /* 205111 */   // Label 3863: @205111
     /* 205111 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(205148), // Rule ID 3587 //
     /* 205116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 205124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 205127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 205140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205146 */     GIR_RootConstrainSelectedInstOperands,
     /* 205147 */     // GIR_Coverage, 3587,
     /* 205147 */     GIR_EraseRootFromParent_Done,
     /* 205148 */   // Label 3864: @205148
     /* 205148 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205185), // Rule ID 3588 //
     /* 205153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 205161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 205164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205174 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 205177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205183 */     GIR_RootConstrainSelectedInstOperands,
     /* 205184 */     // GIR_Coverage, 3588,
     /* 205184 */     GIR_EraseRootFromParent_Done,
     /* 205185 */   // Label 3865: @205185
     /* 205185 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205222), // Rule ID 3589 //
     /* 205190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 205198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 205201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 205211 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 205214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 205216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205220 */     GIR_RootConstrainSelectedInstOperands,
     /* 205221 */     // GIR_Coverage, 3589,
     /* 205221 */     GIR_EraseRootFromParent_Done,
     /* 205222 */   // Label 3866: @205222
     /* 205222 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205259), // Rule ID 3590 //
     /* 205227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2172:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 205251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205257 */     GIR_RootConstrainSelectedInstOperands,
     /* 205258 */     // GIR_Coverage, 3590,
     /* 205258 */     GIR_EraseRootFromParent_Done,
     /* 205259 */   // Label 3867: @205259
     /* 205259 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205296), // Rule ID 3591 //
     /* 205264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2172:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 205288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205294 */     GIR_RootConstrainSelectedInstOperands,
     /* 205295 */     // GIR_Coverage, 3591,
     /* 205295 */     GIR_EraseRootFromParent_Done,
     /* 205296 */   // Label 3868: @205296
     /* 205296 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(205333), // Rule ID 3592 //
     /* 205301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2172:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 205325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205331 */     GIR_RootConstrainSelectedInstOperands,
     /* 205332 */     // GIR_Coverage, 3592,
     /* 205332 */     GIR_EraseRootFromParent_Done,
     /* 205333 */   // Label 3869: @205333
     /* 205333 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(205370), // Rule ID 3593 //
     /* 205338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2172:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 205362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205368 */     GIR_RootConstrainSelectedInstOperands,
     /* 205369 */     // GIR_Coverage, 3593,
     /* 205369 */     GIR_EraseRootFromParent_Done,
     /* 205370 */   // Label 3870: @205370
     /* 205370 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(205407), // Rule ID 3594 //
     /* 205375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2172:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 205399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205405 */     GIR_RootConstrainSelectedInstOperands,
     /* 205406 */     // GIR_Coverage, 3594,
     /* 205406 */     GIR_EraseRootFromParent_Done,
     /* 205407 */   // Label 3871: @205407
     /* 205407 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(205444), // Rule ID 3595 //
     /* 205412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205433 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2172:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 205436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205442 */     GIR_RootConstrainSelectedInstOperands,
     /* 205443 */     // GIR_Coverage, 3595,
     /* 205443 */     GIR_EraseRootFromParent_Done,
     /* 205444 */   // Label 3872: @205444
     /* 205444 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(205481), // Rule ID 3596 //
     /* 205449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2172:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 205473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205479 */     GIR_RootConstrainSelectedInstOperands,
     /* 205480 */     // GIR_Coverage, 3596,
     /* 205480 */     GIR_EraseRootFromParent_Done,
     /* 205481 */   // Label 3873: @205481
     /* 205481 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(205518), // Rule ID 3597 //
     /* 205486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1927:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 205510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205516 */     GIR_RootConstrainSelectedInstOperands,
     /* 205517 */     // GIR_Coverage, 3597,
     /* 205517 */     GIR_EraseRootFromParent_Done,
     /* 205518 */   // Label 3874: @205518
     /* 205518 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(205555), // Rule ID 3598 //
     /* 205523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205553 */     GIR_RootConstrainSelectedInstOperands,
     /* 205554 */     // GIR_Coverage, 3598,
     /* 205554 */     GIR_EraseRootFromParent_Done,
     /* 205555 */   // Label 3875: @205555
     /* 205555 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(205592), // Rule ID 3599 //
     /* 205560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1927:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205590 */     GIR_RootConstrainSelectedInstOperands,
     /* 205591 */     // GIR_Coverage, 3599,
     /* 205591 */     GIR_EraseRootFromParent_Done,
     /* 205592 */   // Label 3876: @205592
     /* 205592 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(205629), // Rule ID 3600 //
     /* 205597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1927:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205627 */     GIR_RootConstrainSelectedInstOperands,
     /* 205628 */     // GIR_Coverage, 3600,
     /* 205628 */     GIR_EraseRootFromParent_Done,
     /* 205629 */   // Label 3877: @205629
     /* 205629 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(205666), // Rule ID 3601 //
     /* 205634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1927:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205664 */     GIR_RootConstrainSelectedInstOperands,
     /* 205665 */     // GIR_Coverage, 3601,
     /* 205665 */     GIR_EraseRootFromParent_Done,
     /* 205666 */   // Label 3878: @205666
     /* 205666 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(205703), // Rule ID 3602 //
     /* 205671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1927:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205701 */     GIR_RootConstrainSelectedInstOperands,
     /* 205702 */     // GIR_Coverage, 3602,
     /* 205702 */     GIR_EraseRootFromParent_Done,
     /* 205703 */   // Label 3879: @205703
     /* 205703 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(205740), // Rule ID 3603 //
     /* 205708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1927:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205738 */     GIR_RootConstrainSelectedInstOperands,
     /* 205739 */     // GIR_Coverage, 3603,
     /* 205739 */     GIR_EraseRootFromParent_Done,
     /* 205740 */   // Label 3880: @205740
     /* 205740 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(205777), // Rule ID 8531 //
     /* 205745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 205753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 205759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 205762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 205766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 205769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205775 */     GIR_RootConstrainSelectedInstOperands,
     /* 205776 */     // GIR_Coverage, 8531,
     /* 205776 */     GIR_EraseRootFromParent_Done,
     /* 205777 */   // Label 3881: @205777
     /* 205777 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(205814), // Rule ID 9007 //
     /* 205782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 205806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205812 */     GIR_RootConstrainSelectedInstOperands,
     /* 205813 */     // GIR_Coverage, 9007,
     /* 205813 */     GIR_EraseRootFromParent_Done,
     /* 205814 */   // Label 3882: @205814
     /* 205814 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(205851), // Rule ID 9008 //
     /* 205819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1266:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 205843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205849 */     GIR_RootConstrainSelectedInstOperands,
     /* 205850 */     // GIR_Coverage, 9008,
     /* 205850 */     GIR_EraseRootFromParent_Done,
     /* 205851 */   // Label 3883: @205851
     /* 205851 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(205888), // Rule ID 9009 //
     /* 205856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 205880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205886 */     GIR_RootConstrainSelectedInstOperands,
     /* 205887 */     // GIR_Coverage, 9009,
     /* 205887 */     GIR_EraseRootFromParent_Done,
     /* 205888 */   // Label 3884: @205888
     /* 205888 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(205925), // Rule ID 9010 //
     /* 205893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1265:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 205917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205923 */     GIR_RootConstrainSelectedInstOperands,
     /* 205924 */     // GIR_Coverage, 9010,
     /* 205924 */     GIR_EraseRootFromParent_Done,
     /* 205925 */   // Label 3885: @205925
     /* 205925 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(205962), // Rule ID 9011 //
     /* 205930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 205954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205960 */     GIR_RootConstrainSelectedInstOperands,
     /* 205961 */     // GIR_Coverage, 9011,
     /* 205961 */     GIR_EraseRootFromParent_Done,
     /* 205962 */   // Label 3886: @205962
     /* 205962 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(205999), // Rule ID 9012 //
     /* 205967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1266:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 205991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205997 */     GIR_RootConstrainSelectedInstOperands,
     /* 205998 */     // GIR_Coverage, 9012,
     /* 205998 */     GIR_EraseRootFromParent_Done,
     /* 205999 */   // Label 3887: @205999
     /* 205999 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(206036), // Rule ID 9013 //
     /* 206004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 206012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 206028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206034 */     GIR_RootConstrainSelectedInstOperands,
     /* 206035 */     // GIR_Coverage, 9013,
     /* 206035 */     GIR_EraseRootFromParent_Done,
     /* 206036 */   // Label 3888: @206036
     /* 206036 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(206073), // Rule ID 9014 //
     /* 206041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 206049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1265:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 206065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206071 */     GIR_RootConstrainSelectedInstOperands,
     /* 206072 */     // GIR_Coverage, 9014,
     /* 206072 */     GIR_EraseRootFromParent_Done,
     /* 206073 */   // Label 3889: @206073
     /* 206073 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(206113), // Rule ID 10014 //
     /* 206078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206099 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 206102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206111 */     GIR_RootConstrainSelectedInstOperands,
     /* 206112 */     // GIR_Coverage, 10014,
     /* 206112 */     GIR_EraseRootFromParent_Done,
     /* 206113 */   // Label 3890: @206113
     /* 206113 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206153), // Rule ID 10015 //
     /* 206118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 206142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206151 */     GIR_RootConstrainSelectedInstOperands,
     /* 206152 */     // GIR_Coverage, 10015,
     /* 206152 */     GIR_EraseRootFromParent_Done,
     /* 206153 */   // Label 3891: @206153
     /* 206153 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206193), // Rule ID 10016 //
     /* 206158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 206182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206191 */     GIR_RootConstrainSelectedInstOperands,
     /* 206192 */     // GIR_Coverage, 10016,
     /* 206192 */     GIR_EraseRootFromParent_Done,
     /* 206193 */   // Label 3892: @206193
     /* 206193 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206233), // Rule ID 10017 //
     /* 206198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 206222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206231 */     GIR_RootConstrainSelectedInstOperands,
     /* 206232 */     // GIR_Coverage, 10017,
     /* 206232 */     GIR_EraseRootFromParent_Done,
     /* 206233 */   // Label 3893: @206233
     /* 206233 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206273), // Rule ID 10026 //
     /* 206238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206259 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 206262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206271 */     GIR_RootConstrainSelectedInstOperands,
     /* 206272 */     // GIR_Coverage, 10026,
     /* 206272 */     GIR_EraseRootFromParent_Done,
     /* 206273 */   // Label 3894: @206273
     /* 206273 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206313), // Rule ID 10027 //
     /* 206278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 206302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206311 */     GIR_RootConstrainSelectedInstOperands,
     /* 206312 */     // GIR_Coverage, 10027,
     /* 206312 */     GIR_EraseRootFromParent_Done,
     /* 206313 */   // Label 3895: @206313
     /* 206313 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(206353), // Rule ID 10028 //
     /* 206318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 206342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206351 */     GIR_RootConstrainSelectedInstOperands,
     /* 206352 */     // GIR_Coverage, 10028,
     /* 206352 */     GIR_EraseRootFromParent_Done,
     /* 206353 */   // Label 3896: @206353
     /* 206353 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(206393), // Rule ID 10029 //
     /* 206358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 206375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 206379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 206382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206391 */     GIR_RootConstrainSelectedInstOperands,
     /* 206392 */     // GIR_Coverage, 10029,
     /* 206392 */     GIR_EraseRootFromParent_Done,
     /* 206393 */   // Label 3897: @206393
     /* 206393 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(206433), // Rule ID 10030 //
     /* 206398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206419 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 206422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206431 */     GIR_RootConstrainSelectedInstOperands,
     /* 206432 */     // GIR_Coverage, 10030,
     /* 206432 */     GIR_EraseRootFromParent_Done,
     /* 206433 */   // Label 3898: @206433
     /* 206433 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(206473), // Rule ID 10031 //
     /* 206438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 206462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206471 */     GIR_RootConstrainSelectedInstOperands,
     /* 206472 */     // GIR_Coverage, 10031,
     /* 206472 */     GIR_EraseRootFromParent_Done,
     /* 206473 */   // Label 3899: @206473
     /* 206473 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(206513), // Rule ID 10032 //
     /* 206478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 206502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206511 */     GIR_RootConstrainSelectedInstOperands,
     /* 206512 */     // GIR_Coverage, 10032,
     /* 206512 */     GIR_EraseRootFromParent_Done,
     /* 206513 */   // Label 3900: @206513
     /* 206513 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(206553), // Rule ID 10033 //
     /* 206518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 206542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206551 */     GIR_RootConstrainSelectedInstOperands,
     /* 206552 */     // GIR_Coverage, 10033,
     /* 206552 */     GIR_EraseRootFromParent_Done,
     /* 206553 */   // Label 3901: @206553
     /* 206553 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(206593), // Rule ID 10042 //
     /* 206558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 206582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206591 */     GIR_RootConstrainSelectedInstOperands,
     /* 206592 */     // GIR_Coverage, 10042,
     /* 206592 */     GIR_EraseRootFromParent_Done,
     /* 206593 */   // Label 3902: @206593
     /* 206593 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(206633), // Rule ID 10043 //
     /* 206598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206619 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 206622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206631 */     GIR_RootConstrainSelectedInstOperands,
     /* 206632 */     // GIR_Coverage, 10043,
     /* 206632 */     GIR_EraseRootFromParent_Done,
     /* 206633 */   // Label 3903: @206633
     /* 206633 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(206673), // Rule ID 10044 //
     /* 206638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 206662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206671 */     GIR_RootConstrainSelectedInstOperands,
     /* 206672 */     // GIR_Coverage, 10044,
     /* 206672 */     GIR_EraseRootFromParent_Done,
     /* 206673 */   // Label 3904: @206673
     /* 206673 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(206713), // Rule ID 10045 //
     /* 206678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 206702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206711 */     GIR_RootConstrainSelectedInstOperands,
     /* 206712 */     // GIR_Coverage, 10045,
     /* 206712 */     GIR_EraseRootFromParent_Done,
     /* 206713 */   // Label 3905: @206713
     /* 206713 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(206750), // Rule ID 10204 //
     /* 206718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 206742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206748 */     GIR_RootConstrainSelectedInstOperands,
     /* 206749 */     // GIR_Coverage, 10204,
     /* 206749 */     GIR_EraseRootFromParent_Done,
     /* 206750 */   // Label 3906: @206750
     /* 206750 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(206787), // Rule ID 10205 //
     /* 206755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 206779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206785 */     GIR_RootConstrainSelectedInstOperands,
     /* 206786 */     // GIR_Coverage, 10205,
     /* 206786 */     GIR_EraseRootFromParent_Done,
     /* 206787 */   // Label 3907: @206787
     /* 206787 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(206824), // Rule ID 10206 //
     /* 206792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 206816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206822 */     GIR_RootConstrainSelectedInstOperands,
     /* 206823 */     // GIR_Coverage, 10206,
     /* 206823 */     GIR_EraseRootFromParent_Done,
     /* 206824 */   // Label 3908: @206824
     /* 206824 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(206861), // Rule ID 10207 //
     /* 206829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 206853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206859 */     GIR_RootConstrainSelectedInstOperands,
     /* 206860 */     // GIR_Coverage, 10207,
     /* 206860 */     GIR_EraseRootFromParent_Done,
     /* 206861 */   // Label 3909: @206861
     /* 206861 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(206898), // Rule ID 10208 //
     /* 206866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 206890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206896 */     GIR_RootConstrainSelectedInstOperands,
     /* 206897 */     // GIR_Coverage, 10208,
     /* 206897 */     GIR_EraseRootFromParent_Done,
     /* 206898 */   // Label 3910: @206898
     /* 206898 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(206935), // Rule ID 10209 //
     /* 206903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 206927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206933 */     GIR_RootConstrainSelectedInstOperands,
     /* 206934 */     // GIR_Coverage, 10209,
     /* 206934 */     GIR_EraseRootFromParent_Done,
     /* 206935 */   // Label 3911: @206935
     /* 206935 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(206972), // Rule ID 10210 //
     /* 206940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2020:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 206964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206970 */     GIR_RootConstrainSelectedInstOperands,
     /* 206971 */     // GIR_Coverage, 10210,
     /* 206971 */     GIR_EraseRootFromParent_Done,
     /* 206972 */   // Label 3912: @206972
     /* 206972 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(207009), // Rule ID 10211 //
     /* 206977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 207001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207007 */     GIR_RootConstrainSelectedInstOperands,
     /* 207008 */     // GIR_Coverage, 10211,
     /* 207008 */     GIR_EraseRootFromParent_Done,
     /* 207009 */   // Label 3913: @207009
     /* 207009 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(207046), // Rule ID 10212 //
     /* 207014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 207022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2020:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 207035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 207038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207044 */     GIR_RootConstrainSelectedInstOperands,
     /* 207045 */     // GIR_Coverage, 10212,
     /* 207045 */     GIR_EraseRootFromParent_Done,
     /* 207046 */   // Label 3914: @207046
     /* 207046 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(207083), // Rule ID 11402 //
     /* 207051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207081 */     GIR_RootConstrainSelectedInstOperands,
     /* 207082 */     // GIR_Coverage, 11402,
     /* 207082 */     GIR_EraseRootFromParent_Done,
     /* 207083 */   // Label 3915: @207083
     /* 207083 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(207120), // Rule ID 11403 //
     /* 207088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207118 */     GIR_RootConstrainSelectedInstOperands,
     /* 207119 */     // GIR_Coverage, 11403,
     /* 207119 */     GIR_EraseRootFromParent_Done,
     /* 207120 */   // Label 3916: @207120
     /* 207120 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(207157), // Rule ID 11404 //
     /* 207125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207146 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207155 */     GIR_RootConstrainSelectedInstOperands,
     /* 207156 */     // GIR_Coverage, 11404,
     /* 207156 */     GIR_EraseRootFromParent_Done,
     /* 207157 */   // Label 3917: @207157
     /* 207157 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207194), // Rule ID 11405 //
     /* 207162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207192 */     GIR_RootConstrainSelectedInstOperands,
     /* 207193 */     // GIR_Coverage, 11405,
     /* 207193 */     GIR_EraseRootFromParent_Done,
     /* 207194 */   // Label 3918: @207194
     /* 207194 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207231), // Rule ID 11406 //
     /* 207199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207220 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207229 */     GIR_RootConstrainSelectedInstOperands,
     /* 207230 */     // GIR_Coverage, 11406,
     /* 207230 */     GIR_EraseRootFromParent_Done,
     /* 207231 */   // Label 3919: @207231
     /* 207231 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207268), // Rule ID 11407 //
     /* 207236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207266 */     GIR_RootConstrainSelectedInstOperands,
     /* 207267 */     // GIR_Coverage, 11407,
     /* 207267 */     GIR_EraseRootFromParent_Done,
     /* 207268 */   // Label 3920: @207268
     /* 207268 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207305), // Rule ID 11408 //
     /* 207273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 207281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 207297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207303 */     GIR_RootConstrainSelectedInstOperands,
     /* 207304 */     // GIR_Coverage, 11408,
     /* 207304 */     GIR_EraseRootFromParent_Done,
     /* 207305 */   // Label 3921: @207305
     /* 207305 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(207342), // Rule ID 11409 //
     /* 207310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2090:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207340 */     GIR_RootConstrainSelectedInstOperands,
     /* 207341 */     // GIR_Coverage, 11409,
     /* 207341 */     GIR_EraseRootFromParent_Done,
     /* 207342 */   // Label 3922: @207342
     /* 207342 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(207379), // Rule ID 11410 //
     /* 207347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2090:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207377 */     GIR_RootConstrainSelectedInstOperands,
     /* 207378 */     // GIR_Coverage, 11410,
     /* 207378 */     GIR_EraseRootFromParent_Done,
     /* 207379 */   // Label 3923: @207379
     /* 207379 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(207416), // Rule ID 11411 //
     /* 207384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207405 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2090:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207414 */     GIR_RootConstrainSelectedInstOperands,
     /* 207415 */     // GIR_Coverage, 11411,
     /* 207415 */     GIR_EraseRootFromParent_Done,
     /* 207416 */   // Label 3924: @207416
     /* 207416 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(207453), // Rule ID 11412 //
     /* 207421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2090:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207451 */     GIR_RootConstrainSelectedInstOperands,
     /* 207452 */     // GIR_Coverage, 11412,
     /* 207452 */     GIR_EraseRootFromParent_Done,
     /* 207453 */   // Label 3925: @207453
     /* 207453 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(207490), // Rule ID 11413 //
     /* 207458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207479 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2090:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207488 */     GIR_RootConstrainSelectedInstOperands,
     /* 207489 */     // GIR_Coverage, 11413,
     /* 207489 */     GIR_EraseRootFromParent_Done,
     /* 207490 */   // Label 3926: @207490
     /* 207490 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(207527), // Rule ID 11414 //
     /* 207495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2090:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207525 */     GIR_RootConstrainSelectedInstOperands,
     /* 207526 */     // GIR_Coverage, 11414,
     /* 207526 */     GIR_EraseRootFromParent_Done,
     /* 207527 */   // Label 3927: @207527
     /* 207527 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(207564), // Rule ID 11415 //
     /* 207532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207553 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2090:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207562 */     GIR_RootConstrainSelectedInstOperands,
     /* 207563 */     // GIR_Coverage, 11415,
     /* 207563 */     GIR_EraseRootFromParent_Done,
     /* 207564 */   // Label 3928: @207564
     /* 207564 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(207601), // Rule ID 11416 //
     /* 207569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207599 */     GIR_RootConstrainSelectedInstOperands,
     /* 207600 */     // GIR_Coverage, 11416,
     /* 207600 */     GIR_EraseRootFromParent_Done,
     /* 207601 */   // Label 3929: @207601
     /* 207601 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(207638), // Rule ID 11417 //
     /* 207606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207636 */     GIR_RootConstrainSelectedInstOperands,
     /* 207637 */     // GIR_Coverage, 11417,
     /* 207637 */     GIR_EraseRootFromParent_Done,
     /* 207638 */   // Label 3930: @207638
     /* 207638 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(207675), // Rule ID 11418 //
     /* 207643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207664 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207673 */     GIR_RootConstrainSelectedInstOperands,
     /* 207674 */     // GIR_Coverage, 11418,
     /* 207674 */     GIR_EraseRootFromParent_Done,
     /* 207675 */   // Label 3931: @207675
     /* 207675 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(207712), // Rule ID 11419 //
     /* 207680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207710 */     GIR_RootConstrainSelectedInstOperands,
     /* 207711 */     // GIR_Coverage, 11419,
     /* 207711 */     GIR_EraseRootFromParent_Done,
     /* 207712 */   // Label 3932: @207712
     /* 207712 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(207749), // Rule ID 11420 //
     /* 207717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207738 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207747 */     GIR_RootConstrainSelectedInstOperands,
     /* 207748 */     // GIR_Coverage, 11420,
     /* 207748 */     GIR_EraseRootFromParent_Done,
     /* 207749 */   // Label 3933: @207749
     /* 207749 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(207786), // Rule ID 11421 //
     /* 207754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207784 */     GIR_RootConstrainSelectedInstOperands,
     /* 207785 */     // GIR_Coverage, 11421,
     /* 207785 */     GIR_EraseRootFromParent_Done,
     /* 207786 */   // Label 3934: @207786
     /* 207786 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(207823), // Rule ID 11422 //
     /* 207791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207812 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207821 */     GIR_RootConstrainSelectedInstOperands,
     /* 207822 */     // GIR_Coverage, 11422,
     /* 207822 */     GIR_EraseRootFromParent_Done,
     /* 207823 */   // Label 3935: @207823
     /* 207823 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(207860), // Rule ID 11423 //
     /* 207828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1934:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207858 */     GIR_RootConstrainSelectedInstOperands,
     /* 207859 */     // GIR_Coverage, 11423,
     /* 207859 */     GIR_EraseRootFromParent_Done,
     /* 207860 */   // Label 3936: @207860
     /* 207860 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(207897), // Rule ID 11424 //
     /* 207865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1934:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207895 */     GIR_RootConstrainSelectedInstOperands,
     /* 207896 */     // GIR_Coverage, 11424,
     /* 207896 */     GIR_EraseRootFromParent_Done,
     /* 207897 */   // Label 3937: @207897
     /* 207897 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(207934), // Rule ID 11425 //
     /* 207902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207923 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207932 */     GIR_RootConstrainSelectedInstOperands,
     /* 207933 */     // GIR_Coverage, 11425,
     /* 207933 */     GIR_EraseRootFromParent_Done,
     /* 207934 */   // Label 3938: @207934
     /* 207934 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(207971), // Rule ID 11426 //
     /* 207939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207969 */     GIR_RootConstrainSelectedInstOperands,
     /* 207970 */     // GIR_Coverage, 11426,
     /* 207970 */     GIR_EraseRootFromParent_Done,
     /* 207971 */   // Label 3939: @207971
     /* 207971 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(208008), // Rule ID 11427 //
     /* 207976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207997 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1934:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 208000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208006 */     GIR_RootConstrainSelectedInstOperands,
     /* 208007 */     // GIR_Coverage, 11427,
     /* 208007 */     GIR_EraseRootFromParent_Done,
     /* 208008 */   // Label 3940: @208008
     /* 208008 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(208045), // Rule ID 11428 //
     /* 208013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 208021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208034 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1934:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 208037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208043 */     GIR_RootConstrainSelectedInstOperands,
     /* 208044 */     // GIR_Coverage, 11428,
     /* 208044 */     GIR_EraseRootFromParent_Done,
     /* 208045 */   // Label 3941: @208045
     /* 208045 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(208082), // Rule ID 11429 //
     /* 208050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 208058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208071 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1934:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 208071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 208074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208080 */     GIR_RootConstrainSelectedInstOperands,
     /* 208081 */     // GIR_Coverage, 11429,
     /* 208081 */     GIR_EraseRootFromParent_Done,
     /* 208082 */   // Label 3942: @208082
     /* 208082 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(208119), // Rule ID 11430 //
     /* 208087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208108 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208117 */     GIR_RootConstrainSelectedInstOperands,
     /* 208118 */     // GIR_Coverage, 11430,
     /* 208118 */     GIR_EraseRootFromParent_Done,
     /* 208119 */   // Label 3943: @208119
     /* 208119 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(208156), // Rule ID 11431 //
     /* 208124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208145 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208154 */     GIR_RootConstrainSelectedInstOperands,
     /* 208155 */     // GIR_Coverage, 11431,
     /* 208155 */     GIR_EraseRootFromParent_Done,
     /* 208156 */   // Label 3944: @208156
     /* 208156 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208193), // Rule ID 11432 //
     /* 208161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1939:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 208182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208191 */     GIR_RootConstrainSelectedInstOperands,
     /* 208192 */     // GIR_Coverage, 11432,
     /* 208192 */     GIR_EraseRootFromParent_Done,
     /* 208193 */   // Label 3945: @208193
     /* 208193 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208230), // Rule ID 11433 //
     /* 208198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208228 */     GIR_RootConstrainSelectedInstOperands,
     /* 208229 */     // GIR_Coverage, 11433,
     /* 208229 */     GIR_EraseRootFromParent_Done,
     /* 208230 */   // Label 3946: @208230
     /* 208230 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208267), // Rule ID 11434 //
     /* 208235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208256 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1939:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 208256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208265 */     GIR_RootConstrainSelectedInstOperands,
     /* 208266 */     // GIR_Coverage, 11434,
     /* 208266 */     GIR_EraseRootFromParent_Done,
     /* 208267 */   // Label 3947: @208267
     /* 208267 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208304), // Rule ID 11435 //
     /* 208272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208293 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208302 */     GIR_RootConstrainSelectedInstOperands,
     /* 208303 */     // GIR_Coverage, 11435,
     /* 208303 */     GIR_EraseRootFromParent_Done,
     /* 208304 */   // Label 3948: @208304
     /* 208304 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(208341), // Rule ID 11436 //
     /* 208309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 208317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1939:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 208330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 208333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208339 */     GIR_RootConstrainSelectedInstOperands,
     /* 208340 */     // GIR_Coverage, 11436,
     /* 208340 */     GIR_EraseRootFromParent_Done,
     /* 208341 */   // Label 3949: @208341
     /* 208341 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(208378), // Rule ID 11456 //
     /* 208346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 208370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208376 */     GIR_RootConstrainSelectedInstOperands,
     /* 208377 */     // GIR_Coverage, 11456,
     /* 208377 */     GIR_EraseRootFromParent_Done,
     /* 208378 */   // Label 3950: @208378
     /* 208378 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(208415), // Rule ID 11457 //
     /* 208383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 208407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208413 */     GIR_RootConstrainSelectedInstOperands,
     /* 208414 */     // GIR_Coverage, 11457,
     /* 208414 */     GIR_EraseRootFromParent_Done,
     /* 208415 */   // Label 3951: @208415
     /* 208415 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(208452), // Rule ID 11458 //
     /* 208420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 208444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208450 */     GIR_RootConstrainSelectedInstOperands,
     /* 208451 */     // GIR_Coverage, 11458,
     /* 208451 */     GIR_EraseRootFromParent_Done,
     /* 208452 */   // Label 3952: @208452
     /* 208452 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(208489), // Rule ID 11459 //
     /* 208457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 208481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208487 */     GIR_RootConstrainSelectedInstOperands,
     /* 208488 */     // GIR_Coverage, 11459,
     /* 208488 */     GIR_EraseRootFromParent_Done,
     /* 208489 */   // Label 3953: @208489
     /* 208489 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(208526), // Rule ID 11747 //
     /* 208494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1700:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 208518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208524 */     GIR_RootConstrainSelectedInstOperands,
     /* 208525 */     // GIR_Coverage, 11747,
     /* 208525 */     GIR_EraseRootFromParent_Done,
     /* 208526 */   // Label 3954: @208526
     /* 208526 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(208563), // Rule ID 11748 //
     /* 208531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 208555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208561 */     GIR_RootConstrainSelectedInstOperands,
     /* 208562 */     // GIR_Coverage, 11748,
     /* 208562 */     GIR_EraseRootFromParent_Done,
     /* 208563 */   // Label 3955: @208563
     /* 208563 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(208600), // Rule ID 11749 //
     /* 208568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 208592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208598 */     GIR_RootConstrainSelectedInstOperands,
     /* 208599 */     // GIR_Coverage, 11749,
     /* 208599 */     GIR_EraseRootFromParent_Done,
     /* 208600 */   // Label 3956: @208600
     /* 208600 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(208637), // Rule ID 11750 //
     /* 208605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 208629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208635 */     GIR_RootConstrainSelectedInstOperands,
     /* 208636 */     // GIR_Coverage, 11750,
     /* 208636 */     GIR_EraseRootFromParent_Done,
     /* 208637 */   // Label 3957: @208637
     /* 208637 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(208674), // Rule ID 11751 //
     /* 208642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208663 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 208666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208672 */     GIR_RootConstrainSelectedInstOperands,
     /* 208673 */     // GIR_Coverage, 11751,
     /* 208673 */     GIR_EraseRootFromParent_Done,
     /* 208674 */   // Label 3958: @208674
     /* 208674 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(208711), // Rule ID 11752 //
     /* 208679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 208703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208709 */     GIR_RootConstrainSelectedInstOperands,
     /* 208710 */     // GIR_Coverage, 11752,
     /* 208710 */     GIR_EraseRootFromParent_Done,
     /* 208711 */   // Label 3959: @208711
     /* 208711 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(208748), // Rule ID 11753 //
     /* 208716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208737 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 208740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208746 */     GIR_RootConstrainSelectedInstOperands,
     /* 208747 */     // GIR_Coverage, 11753,
     /* 208747 */     GIR_EraseRootFromParent_Done,
     /* 208748 */   // Label 3960: @208748
     /* 208748 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(208785), // Rule ID 11754 //
     /* 208753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 208777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208783 */     GIR_RootConstrainSelectedInstOperands,
     /* 208784 */     // GIR_Coverage, 11754,
     /* 208784 */     GIR_EraseRootFromParent_Done,
     /* 208785 */   // Label 3961: @208785
     /* 208785 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(208822), // Rule ID 11755 //
     /* 208790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 208814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208820 */     GIR_RootConstrainSelectedInstOperands,
     /* 208821 */     // GIR_Coverage, 11755,
     /* 208821 */     GIR_EraseRootFromParent_Done,
     /* 208822 */   // Label 3962: @208822
     /* 208822 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(208859), // Rule ID 11756 //
     /* 208827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 208851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208857 */     GIR_RootConstrainSelectedInstOperands,
     /* 208858 */     // GIR_Coverage, 11756,
     /* 208858 */     GIR_EraseRootFromParent_Done,
     /* 208859 */   // Label 3963: @208859
     /* 208859 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(208896), // Rule ID 11757 //
     /* 208864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 208888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208894 */     GIR_RootConstrainSelectedInstOperands,
     /* 208895 */     // GIR_Coverage, 11757,
     /* 208895 */     GIR_EraseRootFromParent_Done,
     /* 208896 */   // Label 3964: @208896
     /* 208896 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(208933), // Rule ID 11758 //
     /* 208901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 208925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208931 */     GIR_RootConstrainSelectedInstOperands,
     /* 208932 */     // GIR_Coverage, 11758,
     /* 208932 */     GIR_EraseRootFromParent_Done,
     /* 208933 */   // Label 3965: @208933
     /* 208933 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(208970), // Rule ID 11759 //
     /* 208938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 208962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208968 */     GIR_RootConstrainSelectedInstOperands,
     /* 208969 */     // GIR_Coverage, 11759,
     /* 208969 */     GIR_EraseRootFromParent_Done,
     /* 208970 */   // Label 3966: @208970
     /* 208970 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(209007), // Rule ID 11760 //
     /* 208975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 208999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209005 */     GIR_RootConstrainSelectedInstOperands,
     /* 209006 */     // GIR_Coverage, 11760,
     /* 209006 */     GIR_EraseRootFromParent_Done,
     /* 209007 */   // Label 3967: @209007
     /* 209007 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(209044), // Rule ID 11761 //
     /* 209012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 209020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 209036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209042 */     GIR_RootConstrainSelectedInstOperands,
     /* 209043 */     // GIR_Coverage, 11761,
     /* 209043 */     GIR_EraseRootFromParent_Done,
     /* 209044 */   // Label 3968: @209044
     /* 209044 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(209081), // Rule ID 11762 //
     /* 209049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 209057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 209073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209079 */     GIR_RootConstrainSelectedInstOperands,
     /* 209080 */     // GIR_Coverage, 11762,
     /* 209080 */     GIR_EraseRootFromParent_Done,
     /* 209081 */   // Label 3969: @209081
     /* 209081 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(209118), // Rule ID 11763 //
     /* 209086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 209094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209107 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 209110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209116 */     GIR_RootConstrainSelectedInstOperands,
     /* 209117 */     // GIR_Coverage, 11763,
     /* 209117 */     GIR_EraseRootFromParent_Done,
     /* 209118 */   // Label 3970: @209118
     /* 209118 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(209155), // Rule ID 11764 //
     /* 209123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 209131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 209147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209153 */     GIR_RootConstrainSelectedInstOperands,
     /* 209154 */     // GIR_Coverage, 11764,
     /* 209154 */     GIR_EraseRootFromParent_Done,
     /* 209155 */   // Label 3971: @209155
     /* 209155 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209192), // Rule ID 11765 //
     /* 209160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 209168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 209184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209190 */     GIR_RootConstrainSelectedInstOperands,
     /* 209191 */     // GIR_Coverage, 11765,
     /* 209191 */     GIR_EraseRootFromParent_Done,
     /* 209192 */   // Label 3972: @209192
     /* 209192 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209229), // Rule ID 11766 //
     /* 209197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 209205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 209221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209227 */     GIR_RootConstrainSelectedInstOperands,
     /* 209228 */     // GIR_Coverage, 11766,
     /* 209228 */     GIR_EraseRootFromParent_Done,
     /* 209229 */   // Label 3973: @209229
     /* 209229 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209266), // Rule ID 11767 //
     /* 209234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 209242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209255 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 209258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209264 */     GIR_RootConstrainSelectedInstOperands,
     /* 209265 */     // GIR_Coverage, 11767,
     /* 209265 */     GIR_EraseRootFromParent_Done,
     /* 209266 */   // Label 3974: @209266
     /* 209266 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209303), // Rule ID 11768 //
     /* 209271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 209279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 209295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209301 */     GIR_RootConstrainSelectedInstOperands,
     /* 209302 */     // GIR_Coverage, 11768,
     /* 209302 */     GIR_EraseRootFromParent_Done,
     /* 209303 */   // Label 3975: @209303
     /* 209303 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(209340), // Rule ID 11769 //
     /* 209308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 209316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 209332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209338 */     GIR_RootConstrainSelectedInstOperands,
     /* 209339 */     // GIR_Coverage, 11769,
     /* 209339 */     GIR_EraseRootFromParent_Done,
     /* 209340 */   // Label 3976: @209340
     /* 209340 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(209377), // Rule ID 11770 //
     /* 209345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 209353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 209369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209375 */     GIR_RootConstrainSelectedInstOperands,
     /* 209376 */     // GIR_Coverage, 11770,
     /* 209376 */     GIR_EraseRootFromParent_Done,
     /* 209377 */   // Label 3977: @209377
     /* 209377 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(209414), // Rule ID 11771 //
     /* 209382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 209406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209412 */     GIR_RootConstrainSelectedInstOperands,
     /* 209413 */     // GIR_Coverage, 11771,
     /* 209413 */     GIR_EraseRootFromParent_Done,
     /* 209414 */   // Label 3978: @209414
     /* 209414 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(209451), // Rule ID 11772 //
     /* 209419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 209443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209449 */     GIR_RootConstrainSelectedInstOperands,
     /* 209450 */     // GIR_Coverage, 11772,
     /* 209450 */     GIR_EraseRootFromParent_Done,
     /* 209451 */   // Label 3979: @209451
     /* 209451 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(209488), // Rule ID 11773 //
     /* 209456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 209480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209486 */     GIR_RootConstrainSelectedInstOperands,
     /* 209487 */     // GIR_Coverage, 11773,
     /* 209487 */     GIR_EraseRootFromParent_Done,
     /* 209488 */   // Label 3980: @209488
     /* 209488 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(209525), // Rule ID 11774 //
     /* 209493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 209517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209523 */     GIR_RootConstrainSelectedInstOperands,
     /* 209524 */     // GIR_Coverage, 11774,
     /* 209524 */     GIR_EraseRootFromParent_Done,
     /* 209525 */   // Label 3981: @209525
     /* 209525 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(209562), // Rule ID 11775 //
     /* 209530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209551 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 209554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209560 */     GIR_RootConstrainSelectedInstOperands,
     /* 209561 */     // GIR_Coverage, 11775,
     /* 209561 */     GIR_EraseRootFromParent_Done,
     /* 209562 */   // Label 3982: @209562
     /* 209562 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(209599), // Rule ID 11776 //
     /* 209567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 209591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209597 */     GIR_RootConstrainSelectedInstOperands,
     /* 209598 */     // GIR_Coverage, 11776,
     /* 209598 */     GIR_EraseRootFromParent_Done,
     /* 209599 */   // Label 3983: @209599
     /* 209599 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(209636), // Rule ID 11777 //
     /* 209604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 209628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209634 */     GIR_RootConstrainSelectedInstOperands,
     /* 209635 */     // GIR_Coverage, 11777,
     /* 209635 */     GIR_EraseRootFromParent_Done,
     /* 209636 */   // Label 3984: @209636
     /* 209636 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(209673), // Rule ID 11778 //
     /* 209641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 209665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209671 */     GIR_RootConstrainSelectedInstOperands,
     /* 209672 */     // GIR_Coverage, 11778,
     /* 209672 */     GIR_EraseRootFromParent_Done,
     /* 209673 */   // Label 3985: @209673
     /* 209673 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(209710), // Rule ID 11779 //
     /* 209678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 209702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209708 */     GIR_RootConstrainSelectedInstOperands,
     /* 209709 */     // GIR_Coverage, 11779,
     /* 209709 */     GIR_EraseRootFromParent_Done,
     /* 209710 */   // Label 3986: @209710
     /* 209710 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(209747), // Rule ID 11789 //
     /* 209715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1881:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 209739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209745 */     GIR_RootConstrainSelectedInstOperands,
     /* 209746 */     // GIR_Coverage, 11789,
     /* 209746 */     GIR_EraseRootFromParent_Done,
     /* 209747 */   // Label 3987: @209747
     /* 209747 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(209784), // Rule ID 11790 //
     /* 209752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1881:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 209776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209782 */     GIR_RootConstrainSelectedInstOperands,
     /* 209783 */     // GIR_Coverage, 11790,
     /* 209783 */     GIR_EraseRootFromParent_Done,
     /* 209784 */   // Label 3988: @209784
     /* 209784 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(209821), // Rule ID 11791 //
     /* 209789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1881:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 209813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209819 */     GIR_RootConstrainSelectedInstOperands,
     /* 209820 */     // GIR_Coverage, 11791,
     /* 209820 */     GIR_EraseRootFromParent_Done,
     /* 209821 */   // Label 3989: @209821
     /* 209821 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(209858), // Rule ID 11792 //
     /* 209826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209847 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1882:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 209850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209856 */     GIR_RootConstrainSelectedInstOperands,
     /* 209857 */     // GIR_Coverage, 11792,
     /* 209857 */     GIR_EraseRootFromParent_Done,
     /* 209858 */   // Label 3990: @209858
     /* 209858 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(209895), // Rule ID 11793 //
     /* 209863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1882:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 209887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209893 */     GIR_RootConstrainSelectedInstOperands,
     /* 209894 */     // GIR_Coverage, 11793,
     /* 209894 */     GIR_EraseRootFromParent_Done,
     /* 209895 */   // Label 3991: @209895
     /* 209895 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(209932), // Rule ID 11794 //
     /* 209900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1882:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 209924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209930 */     GIR_RootConstrainSelectedInstOperands,
     /* 209931 */     // GIR_Coverage, 11794,
     /* 209931 */     GIR_EraseRootFromParent_Done,
     /* 209932 */   // Label 3992: @209932
     /* 209932 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(209969), // Rule ID 11795 //
     /* 209937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 209961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209967 */     GIR_RootConstrainSelectedInstOperands,
     /* 209968 */     // GIR_Coverage, 11795,
     /* 209968 */     GIR_EraseRootFromParent_Done,
     /* 209969 */   // Label 3993: @209969
     /* 209969 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(210006), // Rule ID 11796 //
     /* 209974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 209998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210004 */     GIR_RootConstrainSelectedInstOperands,
     /* 210005 */     // GIR_Coverage, 11796,
     /* 210005 */     GIR_EraseRootFromParent_Done,
     /* 210006 */   // Label 3994: @210006
     /* 210006 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(210043), // Rule ID 11797 //
     /* 210011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 210019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 210035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210041 */     GIR_RootConstrainSelectedInstOperands,
     /* 210042 */     // GIR_Coverage, 11797,
     /* 210042 */     GIR_EraseRootFromParent_Done,
     /* 210043 */   // Label 3995: @210043
     /* 210043 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(210080), // Rule ID 11798 //
     /* 210048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 210056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2076:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 210072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210078 */     GIR_RootConstrainSelectedInstOperands,
     /* 210079 */     // GIR_Coverage, 11798,
     /* 210079 */     GIR_EraseRootFromParent_Done,
     /* 210080 */   // Label 3996: @210080
     /* 210080 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(210117), // Rule ID 11799 //
     /* 210085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 210093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2076:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 210109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210115 */     GIR_RootConstrainSelectedInstOperands,
     /* 210116 */     // GIR_Coverage, 11799,
     /* 210116 */     GIR_EraseRootFromParent_Done,
     /* 210117 */   // Label 3997: @210117
     /* 210117 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(210154), // Rule ID 11800 //
     /* 210122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 210130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2076:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 210146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210152 */     GIR_RootConstrainSelectedInstOperands,
     /* 210153 */     // GIR_Coverage, 11800,
     /* 210153 */     GIR_EraseRootFromParent_Done,
     /* 210154 */   // Label 3998: @210154
     /* 210154 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210191), // Rule ID 11813 //
     /* 210159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 210167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 210183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210189 */     GIR_RootConstrainSelectedInstOperands,
     /* 210190 */     // GIR_Coverage, 11813,
     /* 210190 */     GIR_EraseRootFromParent_Done,
     /* 210191 */   // Label 3999: @210191
     /* 210191 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210228), // Rule ID 11814 //
     /* 210196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 210204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210217 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 210220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210226 */     GIR_RootConstrainSelectedInstOperands,
     /* 210227 */     // GIR_Coverage, 11814,
     /* 210227 */     GIR_EraseRootFromParent_Done,
     /* 210228 */   // Label 4000: @210228
     /* 210228 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210265), // Rule ID 11815 //
     /* 210233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 210241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 210257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210263 */     GIR_RootConstrainSelectedInstOperands,
     /* 210264 */     // GIR_Coverage, 11815,
     /* 210264 */     GIR_EraseRootFromParent_Done,
     /* 210265 */   // Label 4001: @210265
     /* 210265 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210302), // Rule ID 11816 //
     /* 210270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 210278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 210294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210300 */     GIR_RootConstrainSelectedInstOperands,
     /* 210301 */     // GIR_Coverage, 11816,
     /* 210301 */     GIR_EraseRootFromParent_Done,
     /* 210302 */   // Label 4002: @210302
     /* 210302 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(210339), // Rule ID 11817 //
     /* 210307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 210315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 210331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210337 */     GIR_RootConstrainSelectedInstOperands,
     /* 210338 */     // GIR_Coverage, 11817,
     /* 210338 */     GIR_EraseRootFromParent_Done,
     /* 210339 */   // Label 4003: @210339
     /* 210339 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(210376), // Rule ID 11818 //
     /* 210344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 210352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 210368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210374 */     GIR_RootConstrainSelectedInstOperands,
     /* 210375 */     // GIR_Coverage, 11818,
     /* 210375 */     GIR_EraseRootFromParent_Done,
     /* 210376 */   // Label 4004: @210376
     /* 210376 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(210413), // Rule ID 11819 //
     /* 210381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1764:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 210405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210411 */     GIR_RootConstrainSelectedInstOperands,
     /* 210412 */     // GIR_Coverage, 11819,
     /* 210412 */     GIR_EraseRootFromParent_Done,
     /* 210413 */   // Label 4005: @210413
     /* 210413 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(210450), // Rule ID 11820 //
     /* 210418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 210442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210448 */     GIR_RootConstrainSelectedInstOperands,
     /* 210449 */     // GIR_Coverage, 11820,
     /* 210449 */     GIR_EraseRootFromParent_Done,
     /* 210450 */   // Label 4006: @210450
     /* 210450 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(210487), // Rule ID 11821 //
     /* 210455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 210479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210485 */     GIR_RootConstrainSelectedInstOperands,
     /* 210486 */     // GIR_Coverage, 11821,
     /* 210486 */     GIR_EraseRootFromParent_Done,
     /* 210487 */   // Label 4007: @210487
     /* 210487 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(210524), // Rule ID 11822 //
     /* 210492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210522 */     GIR_RootConstrainSelectedInstOperands,
     /* 210523 */     // GIR_Coverage, 11822,
     /* 210523 */     GIR_EraseRootFromParent_Done,
     /* 210524 */   // Label 4008: @210524
     /* 210524 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(210561), // Rule ID 11823 //
     /* 210529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 210553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210559 */     GIR_RootConstrainSelectedInstOperands,
     /* 210560 */     // GIR_Coverage, 11823,
     /* 210560 */     GIR_EraseRootFromParent_Done,
     /* 210561 */   // Label 4009: @210561
     /* 210561 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(210598), // Rule ID 11824 //
     /* 210566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 210590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210596 */     GIR_RootConstrainSelectedInstOperands,
     /* 210597 */     // GIR_Coverage, 11824,
     /* 210597 */     GIR_EraseRootFromParent_Done,
     /* 210598 */   // Label 4010: @210598
     /* 210598 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(210635), // Rule ID 11825 //
     /* 210603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2002:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 210627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210633 */     GIR_RootConstrainSelectedInstOperands,
     /* 210634 */     // GIR_Coverage, 11825,
     /* 210634 */     GIR_EraseRootFromParent_Done,
     /* 210635 */   // Label 4011: @210635
     /* 210635 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(210672), // Rule ID 11826 //
     /* 210640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 210664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210670 */     GIR_RootConstrainSelectedInstOperands,
     /* 210671 */     // GIR_Coverage, 11826,
     /* 210671 */     GIR_EraseRootFromParent_Done,
     /* 210672 */   // Label 4012: @210672
     /* 210672 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(210709), // Rule ID 11827 //
     /* 210677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 210701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210707 */     GIR_RootConstrainSelectedInstOperands,
     /* 210708 */     // GIR_Coverage, 11827,
     /* 210708 */     GIR_EraseRootFromParent_Done,
     /* 210709 */   // Label 4013: @210709
     /* 210709 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(210746), // Rule ID 11828 //
     /* 210714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210735 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2004:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 210738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210744 */     GIR_RootConstrainSelectedInstOperands,
     /* 210745 */     // GIR_Coverage, 11828,
     /* 210745 */     GIR_EraseRootFromParent_Done,
     /* 210746 */   // Label 4014: @210746
     /* 210746 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(210783), // Rule ID 11829 //
     /* 210751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2004:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 210775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210781 */     GIR_RootConstrainSelectedInstOperands,
     /* 210782 */     // GIR_Coverage, 11829,
     /* 210782 */     GIR_EraseRootFromParent_Done,
     /* 210783 */   // Label 4015: @210783
     /* 210783 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(210820), // Rule ID 11830 //
     /* 210788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 210812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210818 */     GIR_RootConstrainSelectedInstOperands,
     /* 210819 */     // GIR_Coverage, 11830,
     /* 210819 */     GIR_EraseRootFromParent_Done,
     /* 210820 */   // Label 4016: @210820
     /* 210820 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(210857), // Rule ID 11831 //
     /* 210825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1642:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 210849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210855 */     GIR_RootConstrainSelectedInstOperands,
     /* 210856 */     // GIR_Coverage, 11831,
     /* 210856 */     GIR_EraseRootFromParent_Done,
     /* 210857 */   // Label 4017: @210857
     /* 210857 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(210894), // Rule ID 11832 //
     /* 210862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1642:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 210886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210892 */     GIR_RootConstrainSelectedInstOperands,
     /* 210893 */     // GIR_Coverage, 11832,
     /* 210893 */     GIR_EraseRootFromParent_Done,
     /* 210894 */   // Label 4018: @210894
     /* 210894 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(210931), // Rule ID 11933 //
     /* 210899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 210923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210929 */     GIR_RootConstrainSelectedInstOperands,
     /* 210930 */     // GIR_Coverage, 11933,
     /* 210930 */     GIR_EraseRootFromParent_Done,
     /* 210931 */   // Label 4019: @210931
     /* 210931 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(210968), // Rule ID 11934 //
     /* 210936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 210960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210966 */     GIR_RootConstrainSelectedInstOperands,
     /* 210967 */     // GIR_Coverage, 11934,
     /* 210967 */     GIR_EraseRootFromParent_Done,
     /* 210968 */   // Label 4020: @210968
     /* 210968 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(211005), // Rule ID 11935 //
     /* 210973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 210997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211003 */     GIR_RootConstrainSelectedInstOperands,
     /* 211004 */     // GIR_Coverage, 11935,
     /* 211004 */     GIR_EraseRootFromParent_Done,
     /* 211005 */   // Label 4021: @211005
     /* 211005 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(211042), // Rule ID 11936 //
     /* 211010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 211018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1913:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 211034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211040 */     GIR_RootConstrainSelectedInstOperands,
     /* 211041 */     // GIR_Coverage, 11936,
     /* 211041 */     GIR_EraseRootFromParent_Done,
     /* 211042 */   // Label 4022: @211042
     /* 211042 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(211079), // Rule ID 11937 //
     /* 211047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 211055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 211071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211077 */     GIR_RootConstrainSelectedInstOperands,
     /* 211078 */     // GIR_Coverage, 11937,
     /* 211078 */     GIR_EraseRootFromParent_Done,
     /* 211079 */   // Label 4023: @211079
     /* 211079 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(211116), // Rule ID 11938 //
     /* 211084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 211092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 211108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211114 */     GIR_RootConstrainSelectedInstOperands,
     /* 211115 */     // GIR_Coverage, 11938,
     /* 211115 */     GIR_EraseRootFromParent_Done,
     /* 211116 */   // Label 4024: @211116
     /* 211116 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(211153), // Rule ID 11939 //
     /* 211121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 211129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 211145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211151 */     GIR_RootConstrainSelectedInstOperands,
     /* 211152 */     // GIR_Coverage, 11939,
     /* 211152 */     GIR_EraseRootFromParent_Done,
     /* 211153 */   // Label 4025: @211153
     /* 211153 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211190), // Rule ID 11940 //
     /* 211158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 211166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 211182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211188 */     GIR_RootConstrainSelectedInstOperands,
     /* 211189 */     // GIR_Coverage, 11940,
     /* 211189 */     GIR_EraseRootFromParent_Done,
     /* 211190 */   // Label 4026: @211190
     /* 211190 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211227), // Rule ID 11941 //
     /* 211195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 211203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 211219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211225 */     GIR_RootConstrainSelectedInstOperands,
     /* 211226 */     // GIR_Coverage, 11941,
     /* 211226 */     GIR_EraseRootFromParent_Done,
     /* 211227 */   // Label 4027: @211227
     /* 211227 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211264), // Rule ID 11957 //
     /* 211232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 211240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 211256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211262 */     GIR_RootConstrainSelectedInstOperands,
     /* 211263 */     // GIR_Coverage, 11957,
     /* 211263 */     GIR_EraseRootFromParent_Done,
     /* 211264 */   // Label 4028: @211264
     /* 211264 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211301), // Rule ID 11958 //
     /* 211269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 211277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 211293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211299 */     GIR_RootConstrainSelectedInstOperands,
     /* 211300 */     // GIR_Coverage, 11958,
     /* 211300 */     GIR_EraseRootFromParent_Done,
     /* 211301 */   // Label 4029: @211301
     /* 211301 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(211338), // Rule ID 11959 //
     /* 211306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 211314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 211330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211336 */     GIR_RootConstrainSelectedInstOperands,
     /* 211337 */     // GIR_Coverage, 11959,
     /* 211337 */     GIR_EraseRootFromParent_Done,
     /* 211338 */   // Label 4030: @211338
     /* 211338 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(211375), // Rule ID 11960 //
     /* 211343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 211367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211373 */     GIR_RootConstrainSelectedInstOperands,
     /* 211374 */     // GIR_Coverage, 11960,
     /* 211374 */     GIR_EraseRootFromParent_Done,
     /* 211375 */   // Label 4031: @211375
     /* 211375 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(211412), // Rule ID 11961 //
     /* 211380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 211404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211410 */     GIR_RootConstrainSelectedInstOperands,
     /* 211411 */     // GIR_Coverage, 11961,
     /* 211411 */     GIR_EraseRootFromParent_Done,
     /* 211412 */   // Label 4032: @211412
     /* 211412 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(211449), // Rule ID 11962 //
     /* 211417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 211441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211447 */     GIR_RootConstrainSelectedInstOperands,
     /* 211448 */     // GIR_Coverage, 11962,
     /* 211448 */     GIR_EraseRootFromParent_Done,
     /* 211449 */   // Label 4033: @211449
     /* 211449 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(211486), // Rule ID 11978 //
     /* 211454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 211478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211484 */     GIR_RootConstrainSelectedInstOperands,
     /* 211485 */     // GIR_Coverage, 11978,
     /* 211485 */     GIR_EraseRootFromParent_Done,
     /* 211486 */   // Label 4034: @211486
     /* 211486 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(211523), // Rule ID 11979 //
     /* 211491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 211515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211521 */     GIR_RootConstrainSelectedInstOperands,
     /* 211522 */     // GIR_Coverage, 11979,
     /* 211522 */     GIR_EraseRootFromParent_Done,
     /* 211523 */   // Label 4035: @211523
     /* 211523 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(211560), // Rule ID 11980 //
     /* 211528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 211552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211558 */     GIR_RootConstrainSelectedInstOperands,
     /* 211559 */     // GIR_Coverage, 11980,
     /* 211559 */     GIR_EraseRootFromParent_Done,
     /* 211560 */   // Label 4036: @211560
     /* 211560 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(211597), // Rule ID 11981 //
     /* 211565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1880:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 211589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211595 */     GIR_RootConstrainSelectedInstOperands,
     /* 211596 */     // GIR_Coverage, 11981,
     /* 211596 */     GIR_EraseRootFromParent_Done,
     /* 211597 */   // Label 4037: @211597
     /* 211597 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(211634), // Rule ID 11982 //
     /* 211602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1880:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 211626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211632 */     GIR_RootConstrainSelectedInstOperands,
     /* 211633 */     // GIR_Coverage, 11982,
     /* 211633 */     GIR_EraseRootFromParent_Done,
     /* 211634 */   // Label 4038: @211634
     /* 211634 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(211671), // Rule ID 11983 //
     /* 211639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1880:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 211663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211669 */     GIR_RootConstrainSelectedInstOperands,
     /* 211670 */     // GIR_Coverage, 11983,
     /* 211670 */     GIR_EraseRootFromParent_Done,
     /* 211671 */   // Label 4039: @211671
     /* 211671 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(211711), // Rule ID 12170 //
     /* 211676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 211700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211709 */     GIR_RootConstrainSelectedInstOperands,
     /* 211710 */     // GIR_Coverage, 12170,
     /* 211710 */     GIR_EraseRootFromParent_Done,
     /* 211711 */   // Label 4040: @211711
     /* 211711 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(211751), // Rule ID 12171 //
     /* 211716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211737 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 211740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211749 */     GIR_RootConstrainSelectedInstOperands,
     /* 211750 */     // GIR_Coverage, 12171,
     /* 211750 */     GIR_EraseRootFromParent_Done,
     /* 211751 */   // Label 4041: @211751
     /* 211751 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(211791), // Rule ID 12172 //
     /* 211756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211777 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 211780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211789 */     GIR_RootConstrainSelectedInstOperands,
     /* 211790 */     // GIR_Coverage, 12172,
     /* 211790 */     GIR_EraseRootFromParent_Done,
     /* 211791 */   // Label 4042: @211791
     /* 211791 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(211831), // Rule ID 12173 //
     /* 211796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211817 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 211820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211829 */     GIR_RootConstrainSelectedInstOperands,
     /* 211830 */     // GIR_Coverage, 12173,
     /* 211830 */     GIR_EraseRootFromParent_Done,
     /* 211831 */   // Label 4043: @211831
     /* 211831 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(211871), // Rule ID 12174 //
     /* 211836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 211860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211869 */     GIR_RootConstrainSelectedInstOperands,
     /* 211870 */     // GIR_Coverage, 12174,
     /* 211870 */     GIR_EraseRootFromParent_Done,
     /* 211871 */   // Label 4044: @211871
     /* 211871 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(211911), // Rule ID 12175 //
     /* 211876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211897 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 211900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211909 */     GIR_RootConstrainSelectedInstOperands,
     /* 211910 */     // GIR_Coverage, 12175,
     /* 211910 */     GIR_EraseRootFromParent_Done,
     /* 211911 */   // Label 4045: @211911
     /* 211911 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(211951), // Rule ID 12176 //
     /* 211916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211937 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 211940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211949 */     GIR_RootConstrainSelectedInstOperands,
     /* 211950 */     // GIR_Coverage, 12176,
     /* 211950 */     GIR_EraseRootFromParent_Done,
     /* 211951 */   // Label 4046: @211951
     /* 211951 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(211991), // Rule ID 12177 //
     /* 211956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211977 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 211980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211989 */     GIR_RootConstrainSelectedInstOperands,
     /* 211990 */     // GIR_Coverage, 12177,
     /* 211990 */     GIR_EraseRootFromParent_Done,
     /* 211991 */   // Label 4047: @211991
     /* 211991 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(212031), // Rule ID 12182 //
     /* 211996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 212020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212029 */     GIR_RootConstrainSelectedInstOperands,
     /* 212030 */     // GIR_Coverage, 12182,
     /* 212030 */     GIR_EraseRootFromParent_Done,
     /* 212031 */   // Label 4048: @212031
     /* 212031 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(212071), // Rule ID 12183 //
     /* 212036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 212060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212069 */     GIR_RootConstrainSelectedInstOperands,
     /* 212070 */     // GIR_Coverage, 12183,
     /* 212070 */     GIR_EraseRootFromParent_Done,
     /* 212071 */   // Label 4049: @212071
     /* 212071 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(212111), // Rule ID 12184 //
     /* 212076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212097 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 212100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212109 */     GIR_RootConstrainSelectedInstOperands,
     /* 212110 */     // GIR_Coverage, 12184,
     /* 212110 */     GIR_EraseRootFromParent_Done,
     /* 212111 */   // Label 4050: @212111
     /* 212111 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212151), // Rule ID 12185 //
     /* 212116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212137 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 212140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212149 */     GIR_RootConstrainSelectedInstOperands,
     /* 212150 */     // GIR_Coverage, 12185,
     /* 212150 */     GIR_EraseRootFromParent_Done,
     /* 212151 */   // Label 4051: @212151
     /* 212151 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212191), // Rule ID 12186 //
     /* 212156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212177 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 212180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212189 */     GIR_RootConstrainSelectedInstOperands,
     /* 212190 */     // GIR_Coverage, 12186,
     /* 212190 */     GIR_EraseRootFromParent_Done,
     /* 212191 */   // Label 4052: @212191
     /* 212191 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212231), // Rule ID 12187 //
     /* 212196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 212220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212229 */     GIR_RootConstrainSelectedInstOperands,
     /* 212230 */     // GIR_Coverage, 12187,
     /* 212230 */     GIR_EraseRootFromParent_Done,
     /* 212231 */   // Label 4053: @212231
     /* 212231 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212271), // Rule ID 12188 //
     /* 212236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 212260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212269 */     GIR_RootConstrainSelectedInstOperands,
     /* 212270 */     // GIR_Coverage, 12188,
     /* 212270 */     GIR_EraseRootFromParent_Done,
     /* 212271 */   // Label 4054: @212271
     /* 212271 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212311), // Rule ID 12189 //
     /* 212276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212297 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 212297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 212300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212309 */     GIR_RootConstrainSelectedInstOperands,
     /* 212310 */     // GIR_Coverage, 12189,
     /* 212310 */     GIR_EraseRootFromParent_Done,
     /* 212311 */   // Label 4055: @212311
     /* 212311 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212351), // Rule ID 12194 //
     /* 212316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 212340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212349 */     GIR_RootConstrainSelectedInstOperands,
     /* 212350 */     // GIR_Coverage, 12194,
     /* 212350 */     GIR_EraseRootFromParent_Done,
     /* 212351 */   // Label 4056: @212351
     /* 212351 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(212391), // Rule ID 12195 //
     /* 212356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212377 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 212380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212389 */     GIR_RootConstrainSelectedInstOperands,
     /* 212390 */     // GIR_Coverage, 12195,
     /* 212390 */     GIR_EraseRootFromParent_Done,
     /* 212391 */   // Label 4057: @212391
     /* 212391 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(212431), // Rule ID 12196 //
     /* 212396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 212420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212429 */     GIR_RootConstrainSelectedInstOperands,
     /* 212430 */     // GIR_Coverage, 12196,
     /* 212430 */     GIR_EraseRootFromParent_Done,
     /* 212431 */   // Label 4058: @212431
     /* 212431 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(212471), // Rule ID 12197 //
     /* 212436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 212460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212469 */     GIR_RootConstrainSelectedInstOperands,
     /* 212470 */     // GIR_Coverage, 12197,
     /* 212470 */     GIR_EraseRootFromParent_Done,
     /* 212471 */   // Label 4059: @212471
     /* 212471 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(212511), // Rule ID 12198 //
     /* 212476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212497 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 212500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212509 */     GIR_RootConstrainSelectedInstOperands,
     /* 212510 */     // GIR_Coverage, 12198,
     /* 212510 */     GIR_EraseRootFromParent_Done,
     /* 212511 */   // Label 4060: @212511
     /* 212511 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(212551), // Rule ID 12199 //
     /* 212516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212537 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 212540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212549 */     GIR_RootConstrainSelectedInstOperands,
     /* 212550 */     // GIR_Coverage, 12199,
     /* 212550 */     GIR_EraseRootFromParent_Done,
     /* 212551 */   // Label 4061: @212551
     /* 212551 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(212591), // Rule ID 12200 //
     /* 212556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 212580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212589 */     GIR_RootConstrainSelectedInstOperands,
     /* 212590 */     // GIR_Coverage, 12200,
     /* 212590 */     GIR_EraseRootFromParent_Done,
     /* 212591 */   // Label 4062: @212591
     /* 212591 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(212631), // Rule ID 12201 //
     /* 212596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 212620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212629 */     GIR_RootConstrainSelectedInstOperands,
     /* 212630 */     // GIR_Coverage, 12201,
     /* 212630 */     GIR_EraseRootFromParent_Done,
     /* 212631 */   // Label 4063: @212631
     /* 212631 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(212671), // Rule ID 12206 //
     /* 212636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212657 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 212660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212669 */     GIR_RootConstrainSelectedInstOperands,
     /* 212670 */     // GIR_Coverage, 12206,
     /* 212670 */     GIR_EraseRootFromParent_Done,
     /* 212671 */   // Label 4064: @212671
     /* 212671 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(212711), // Rule ID 12207 //
     /* 212676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 212700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212709 */     GIR_RootConstrainSelectedInstOperands,
     /* 212710 */     // GIR_Coverage, 12207,
     /* 212710 */     GIR_EraseRootFromParent_Done,
     /* 212711 */   // Label 4065: @212711
     /* 212711 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(212751), // Rule ID 12208 //
     /* 212716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212737 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 212740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212749 */     GIR_RootConstrainSelectedInstOperands,
     /* 212750 */     // GIR_Coverage, 12208,
     /* 212750 */     GIR_EraseRootFromParent_Done,
     /* 212751 */   // Label 4066: @212751
     /* 212751 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(212791), // Rule ID 12209 //
     /* 212756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 212780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212789 */     GIR_RootConstrainSelectedInstOperands,
     /* 212790 */     // GIR_Coverage, 12209,
     /* 212790 */     GIR_EraseRootFromParent_Done,
     /* 212791 */   // Label 4067: @212791
     /* 212791 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(212831), // Rule ID 12210 //
     /* 212796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 212820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212829 */     GIR_RootConstrainSelectedInstOperands,
     /* 212830 */     // GIR_Coverage, 12210,
     /* 212830 */     GIR_EraseRootFromParent_Done,
     /* 212831 */   // Label 4068: @212831
     /* 212831 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(212871), // Rule ID 12211 //
     /* 212836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 212860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212869 */     GIR_RootConstrainSelectedInstOperands,
     /* 212870 */     // GIR_Coverage, 12211,
     /* 212870 */     GIR_EraseRootFromParent_Done,
     /* 212871 */   // Label 4069: @212871
     /* 212871 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(212911), // Rule ID 12212 //
     /* 212876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212897 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 212900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212909 */     GIR_RootConstrainSelectedInstOperands,
     /* 212910 */     // GIR_Coverage, 12212,
     /* 212910 */     GIR_EraseRootFromParent_Done,
     /* 212911 */   // Label 4070: @212911
     /* 212911 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(212951), // Rule ID 12213 //
     /* 212916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212937 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 212940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212949 */     GIR_RootConstrainSelectedInstOperands,
     /* 212950 */     // GIR_Coverage, 12213,
     /* 212950 */     GIR_EraseRootFromParent_Done,
     /* 212951 */   // Label 4071: @212951
     /* 212951 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(212988), // Rule ID 12223 //
     /* 212956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 212959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1642:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 212980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212986 */     GIR_RootConstrainSelectedInstOperands,
     /* 212987 */     // GIR_Coverage, 12223,
     /* 212987 */     GIR_EraseRootFromParent_Done,
     /* 212988 */   // Label 4072: @212988
     /* 212988 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(213025), // Rule ID 12224 //
     /* 212993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p1_HasSVESHA3),
     /* 212996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 213001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 213017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213023 */     GIR_RootConstrainSelectedInstOperands,
     /* 213024 */     // GIR_Coverage, 12224,
     /* 213024 */     GIR_EraseRootFromParent_Done,
     /* 213025 */   // Label 4073: @213025
     /* 213025 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(213062), // Rule ID 12225 //
     /* 213030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 213038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1282:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 213054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213060 */     GIR_RootConstrainSelectedInstOperands,
     /* 213061 */     // GIR_Coverage, 12225,
     /* 213061 */     GIR_EraseRootFromParent_Done,
     /* 213062 */   // Label 4074: @213062
     /* 213062 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(213099), // Rule ID 12226 //
     /* 213067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 213075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1282:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 213091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213097 */     GIR_RootConstrainSelectedInstOperands,
     /* 213098 */     // GIR_Coverage, 12226,
     /* 213098 */     GIR_EraseRootFromParent_Done,
     /* 213099 */   // Label 4075: @213099
     /* 213099 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(213136), // Rule ID 12227 //
     /* 213104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 213112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1282:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 213128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213134 */     GIR_RootConstrainSelectedInstOperands,
     /* 213135 */     // GIR_Coverage, 12227,
     /* 213135 */     GIR_EraseRootFromParent_Done,
     /* 213136 */   // Label 4076: @213136
     /* 213136 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213173), // Rule ID 12228 //
     /* 213141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 213149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1282:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 213165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213171 */     GIR_RootConstrainSelectedInstOperands,
     /* 213172 */     // GIR_Coverage, 12228,
     /* 213172 */     GIR_EraseRootFromParent_Done,
     /* 213173 */   // Label 4077: @213173
     /* 213173 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213210), // Rule ID 12229 //
     /* 213178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 213186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213199 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1299:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 213202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213208 */     GIR_RootConstrainSelectedInstOperands,
     /* 213209 */     // GIR_Coverage, 12229,
     /* 213209 */     GIR_EraseRootFromParent_Done,
     /* 213210 */   // Label 4078: @213210
     /* 213210 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213247), // Rule ID 12230 //
     /* 213215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 213223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1299:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 213239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213245 */     GIR_RootConstrainSelectedInstOperands,
     /* 213246 */     // GIR_Coverage, 12230,
     /* 213246 */     GIR_EraseRootFromParent_Done,
     /* 213247 */   // Label 4079: @213247
     /* 213247 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213284), // Rule ID 12231 //
     /* 213252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 213260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1299:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 213276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213282 */     GIR_RootConstrainSelectedInstOperands,
     /* 213283 */     // GIR_Coverage, 12231,
     /* 213283 */     GIR_EraseRootFromParent_Done,
     /* 213284 */   // Label 4080: @213284
     /* 213284 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213321), // Rule ID 12232 //
     /* 213289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 213292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 213297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1299:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 213313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213319 */     GIR_RootConstrainSelectedInstOperands,
     /* 213320 */     // GIR_Coverage, 12232,
     /* 213320 */     GIR_EraseRootFromParent_Done,
     /* 213321 */   // Label 4081: @213321
     /* 213321 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(213358), // Rule ID 12346 //
     /* 213326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 213334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213347 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 213350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213356 */     GIR_RootConstrainSelectedInstOperands,
     /* 213357 */     // GIR_Coverage, 12346,
     /* 213357 */     GIR_EraseRootFromParent_Done,
     /* 213358 */   // Label 4082: @213358
     /* 213358 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(213395), // Rule ID 12347 //
     /* 213363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 213371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213384 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 213387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213393 */     GIR_RootConstrainSelectedInstOperands,
     /* 213394 */     // GIR_Coverage, 12347,
     /* 213394 */     GIR_EraseRootFromParent_Done,
     /* 213395 */   // Label 4083: @213395
     /* 213395 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(213432), // Rule ID 12348 //
     /* 213400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 213408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213421 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 213424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213430 */     GIR_RootConstrainSelectedInstOperands,
     /* 213431 */     // GIR_Coverage, 12348,
     /* 213431 */     GIR_EraseRootFromParent_Done,
     /* 213432 */   // Label 4084: @213432
     /* 213432 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(213469), // Rule ID 12349 //
     /* 213437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213458 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 213461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213467 */     GIR_RootConstrainSelectedInstOperands,
     /* 213468 */     // GIR_Coverage, 12349,
     /* 213468 */     GIR_EraseRootFromParent_Done,
     /* 213469 */   // Label 4085: @213469
     /* 213469 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(213506), // Rule ID 12350 //
     /* 213474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213495 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 213498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213504 */     GIR_RootConstrainSelectedInstOperands,
     /* 213505 */     // GIR_Coverage, 12350,
     /* 213505 */     GIR_EraseRootFromParent_Done,
     /* 213506 */   // Label 4086: @213506
     /* 213506 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(213543), // Rule ID 12351 //
     /* 213511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213532 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 213535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213541 */     GIR_RootConstrainSelectedInstOperands,
     /* 213542 */     // GIR_Coverage, 12351,
     /* 213542 */     GIR_EraseRootFromParent_Done,
     /* 213543 */   // Label 4087: @213543
     /* 213543 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(213580), // Rule ID 12352 //
     /* 213548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213569 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1451:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 213572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213578 */     GIR_RootConstrainSelectedInstOperands,
     /* 213579 */     // GIR_Coverage, 12352,
     /* 213579 */     GIR_EraseRootFromParent_Done,
     /* 213580 */   // Label 4088: @213580
     /* 213580 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(213617), // Rule ID 12353 //
     /* 213585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213606 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 213609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213615 */     GIR_RootConstrainSelectedInstOperands,
     /* 213616 */     // GIR_Coverage, 12353,
     /* 213616 */     GIR_EraseRootFromParent_Done,
     /* 213617 */   // Label 4089: @213617
     /* 213617 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(213654), // Rule ID 12354 //
     /* 213622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213643 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 213646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213652 */     GIR_RootConstrainSelectedInstOperands,
     /* 213653 */     // GIR_Coverage, 12354,
     /* 213653 */     GIR_EraseRootFromParent_Done,
     /* 213654 */   // Label 4090: @213654
     /* 213654 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(213691), // Rule ID 12355 //
     /* 213659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213680 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 213683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213689 */     GIR_RootConstrainSelectedInstOperands,
     /* 213690 */     // GIR_Coverage, 12355,
     /* 213690 */     GIR_EraseRootFromParent_Done,
     /* 213691 */   // Label 4091: @213691
     /* 213691 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(213728), // Rule ID 12356 //
     /* 213696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213717 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 213720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213726 */     GIR_RootConstrainSelectedInstOperands,
     /* 213727 */     // GIR_Coverage, 12356,
     /* 213727 */     GIR_EraseRootFromParent_Done,
     /* 213728 */   // Label 4092: @213728
     /* 213728 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(213765), // Rule ID 12357 //
     /* 213733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213754 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 213757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213763 */     GIR_RootConstrainSelectedInstOperands,
     /* 213764 */     // GIR_Coverage, 12357,
     /* 213764 */     GIR_EraseRootFromParent_Done,
     /* 213765 */   // Label 4093: @213765
     /* 213765 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(213802), // Rule ID 12358 //
     /* 213770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213791 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1363:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 213794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213800 */     GIR_RootConstrainSelectedInstOperands,
     /* 213801 */     // GIR_Coverage, 12358,
     /* 213801 */     GIR_EraseRootFromParent_Done,
     /* 213802 */   // Label 4094: @213802
     /* 213802 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(213839), // Rule ID 12359 //
     /* 213807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 213831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213837 */     GIR_RootConstrainSelectedInstOperands,
     /* 213838 */     // GIR_Coverage, 12359,
     /* 213838 */     GIR_EraseRootFromParent_Done,
     /* 213839 */   // Label 4095: @213839
     /* 213839 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(213876), // Rule ID 12360 //
     /* 213844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213865 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 213868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213874 */     GIR_RootConstrainSelectedInstOperands,
     /* 213875 */     // GIR_Coverage, 12360,
     /* 213875 */     GIR_EraseRootFromParent_Done,
     /* 213876 */   // Label 4096: @213876
     /* 213876 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(213913), // Rule ID 12361 //
     /* 213881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213902 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 213905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213911 */     GIR_RootConstrainSelectedInstOperands,
     /* 213912 */     // GIR_Coverage, 12361,
     /* 213912 */     GIR_EraseRootFromParent_Done,
     /* 213913 */   // Label 4097: @213913
     /* 213913 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(213950), // Rule ID 12362 //
     /* 213918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213939 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1275:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 213942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213948 */     GIR_RootConstrainSelectedInstOperands,
     /* 213949 */     // GIR_Coverage, 12362,
     /* 213949 */     GIR_EraseRootFromParent_Done,
     /* 213950 */   // Label 4098: @213950
     /* 213950 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(213987), // Rule ID 12363 //
     /* 213955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213976 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 213979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213985 */     GIR_RootConstrainSelectedInstOperands,
     /* 213986 */     // GIR_Coverage, 12363,
     /* 213986 */     GIR_EraseRootFromParent_Done,
     /* 213987 */   // Label 4099: @213987
     /* 213987 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(214024), // Rule ID 12364 //
     /* 213992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 214000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214013 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 214016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214022 */     GIR_RootConstrainSelectedInstOperands,
     /* 214023 */     // GIR_Coverage, 12364,
     /* 214023 */     GIR_EraseRootFromParent_Done,
     /* 214024 */   // Label 4100: @214024
     /* 214024 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(214061), // Rule ID 12365 //
     /* 214029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 214037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214050 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 214053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214059 */     GIR_RootConstrainSelectedInstOperands,
     /* 214060 */     // GIR_Coverage, 12365,
     /* 214060 */     GIR_EraseRootFromParent_Done,
     /* 214061 */   // Label 4101: @214061
     /* 214061 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(214098), // Rule ID 12366 //
     /* 214066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 214074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214087 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1263:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 214090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214096 */     GIR_RootConstrainSelectedInstOperands,
     /* 214097 */     // GIR_Coverage, 12366,
     /* 214097 */     GIR_EraseRootFromParent_Done,
     /* 214098 */   // Label 4102: @214098
     /* 214098 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(214135), // Rule ID 12367 //
     /* 214103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 214111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214124 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1263:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 214127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214133 */     GIR_RootConstrainSelectedInstOperands,
     /* 214134 */     // GIR_Coverage, 12367,
     /* 214134 */     GIR_EraseRootFromParent_Done,
     /* 214135 */   // Label 4103: @214135
     /* 214135 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214172), // Rule ID 12368 //
     /* 214140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 214148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214161 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1263:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 214164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214170 */     GIR_RootConstrainSelectedInstOperands,
     /* 214171 */     // GIR_Coverage, 12368,
     /* 214171 */     GIR_EraseRootFromParent_Done,
     /* 214172 */   // Label 4104: @214172
     /* 214172 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214209), // Rule ID 12369 //
     /* 214177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 214185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214198 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1263:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 214201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214207 */     GIR_RootConstrainSelectedInstOperands,
     /* 214208 */     // GIR_Coverage, 12369,
     /* 214208 */     GIR_EraseRootFromParent_Done,
     /* 214209 */   // Label 4105: @214209
     /* 214209 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214246), // Rule ID 12370 //
     /* 214214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 214222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214235 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 214238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214244 */     GIR_RootConstrainSelectedInstOperands,
     /* 214245 */     // GIR_Coverage, 12370,
     /* 214245 */     GIR_EraseRootFromParent_Done,
     /* 214246 */   // Label 4106: @214246
     /* 214246 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214283), // Rule ID 12371 //
     /* 214251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 214259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1742:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 214275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214281 */     GIR_RootConstrainSelectedInstOperands,
     /* 214282 */     // GIR_Coverage, 12371,
     /* 214282 */     GIR_EraseRootFromParent_Done,
     /* 214283 */   // Label 4107: @214283
     /* 214283 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(214320), // Rule ID 12372 //
     /* 214288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 214296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1742:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 214312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214318 */     GIR_RootConstrainSelectedInstOperands,
     /* 214319 */     // GIR_Coverage, 12372,
     /* 214319 */     GIR_EraseRootFromParent_Done,
     /* 214320 */   // Label 4108: @214320
     /* 214320 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(214357), // Rule ID 12373 //
     /* 214325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 214333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214346 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1742:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 214349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214355 */     GIR_RootConstrainSelectedInstOperands,
     /* 214356 */     // GIR_Coverage, 12373,
     /* 214356 */     GIR_EraseRootFromParent_Done,
     /* 214357 */   // Label 4109: @214357
     /* 214357 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(214394), // Rule ID 12374 //
     /* 214362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214383 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1980:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 214386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214392 */     GIR_RootConstrainSelectedInstOperands,
     /* 214393 */     // GIR_Coverage, 12374,
     /* 214393 */     GIR_EraseRootFromParent_Done,
     /* 214394 */   // Label 4110: @214394
     /* 214394 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(214431), // Rule ID 12375 //
     /* 214399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1980:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 214423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214429 */     GIR_RootConstrainSelectedInstOperands,
     /* 214430 */     // GIR_Coverage, 12375,
     /* 214430 */     GIR_EraseRootFromParent_Done,
     /* 214431 */   // Label 4111: @214431
     /* 214431 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(214468), // Rule ID 12376 //
     /* 214436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214457 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1980:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 214460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214466 */     GIR_RootConstrainSelectedInstOperands,
     /* 214467 */     // GIR_Coverage, 12376,
     /* 214467 */     GIR_EraseRootFromParent_Done,
     /* 214468 */   // Label 4112: @214468
     /* 214468 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(214505), // Rule ID 12377 //
     /* 214473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214494 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1980:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 214497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214503 */     GIR_RootConstrainSelectedInstOperands,
     /* 214504 */     // GIR_Coverage, 12377,
     /* 214504 */     GIR_EraseRootFromParent_Done,
     /* 214505 */   // Label 4113: @214505
     /* 214505 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(214542), // Rule ID 12378 //
     /* 214510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214531 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1751:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 214534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214540 */     GIR_RootConstrainSelectedInstOperands,
     /* 214541 */     // GIR_Coverage, 12378,
     /* 214541 */     GIR_EraseRootFromParent_Done,
     /* 214542 */   // Label 4114: @214542
     /* 214542 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(214579), // Rule ID 12379 //
     /* 214547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214568 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1751:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 214571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214577 */     GIR_RootConstrainSelectedInstOperands,
     /* 214578 */     // GIR_Coverage, 12379,
     /* 214578 */     GIR_EraseRootFromParent_Done,
     /* 214579 */   // Label 4115: @214579
     /* 214579 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(214616), // Rule ID 12380 //
     /* 214584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214605 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1751:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 214608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214614 */     GIR_RootConstrainSelectedInstOperands,
     /* 214615 */     // GIR_Coverage, 12380,
     /* 214615 */     GIR_EraseRootFromParent_Done,
     /* 214616 */   // Label 4116: @214616
     /* 214616 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(214653), // Rule ID 12381 //
     /* 214621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1751:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 214645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214651 */     GIR_RootConstrainSelectedInstOperands,
     /* 214652 */     // GIR_Coverage, 12381,
     /* 214652 */     GIR_EraseRootFromParent_Done,
     /* 214653 */   // Label 4117: @214653
     /* 214653 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(214690), // Rule ID 12382 //
     /* 214658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 214682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214688 */     GIR_RootConstrainSelectedInstOperands,
     /* 214689 */     // GIR_Coverage, 12382,
     /* 214689 */     GIR_EraseRootFromParent_Done,
     /* 214690 */   // Label 4118: @214690
     /* 214690 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(214727), // Rule ID 12383 //
     /* 214695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1989:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 214719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214725 */     GIR_RootConstrainSelectedInstOperands,
     /* 214726 */     // GIR_Coverage, 12383,
     /* 214726 */     GIR_EraseRootFromParent_Done,
     /* 214727 */   // Label 4119: @214727
     /* 214727 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(214764), // Rule ID 12384 //
     /* 214732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214753 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1989:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 214756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214762 */     GIR_RootConstrainSelectedInstOperands,
     /* 214763 */     // GIR_Coverage, 12384,
     /* 214763 */     GIR_EraseRootFromParent_Done,
     /* 214764 */   // Label 4120: @214764
     /* 214764 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(214801), // Rule ID 12385 //
     /* 214769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214790 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1989:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 214793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214799 */     GIR_RootConstrainSelectedInstOperands,
     /* 214800 */     // GIR_Coverage, 12385,
     /* 214800 */     GIR_EraseRootFromParent_Done,
     /* 214801 */   // Label 4121: @214801
     /* 214801 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(214838), // Rule ID 12386 //
     /* 214806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2173:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 214830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214836 */     GIR_RootConstrainSelectedInstOperands,
     /* 214837 */     // GIR_Coverage, 12386,
     /* 214837 */     GIR_EraseRootFromParent_Done,
     /* 214838 */   // Label 4122: @214838
     /* 214838 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(214875), // Rule ID 12387 //
     /* 214843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2173:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214873 */     GIR_RootConstrainSelectedInstOperands,
     /* 214874 */     // GIR_Coverage, 12387,
     /* 214874 */     GIR_EraseRootFromParent_Done,
     /* 214875 */   // Label 4123: @214875
     /* 214875 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(214912), // Rule ID 12388 //
     /* 214880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2173:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214910 */     GIR_RootConstrainSelectedInstOperands,
     /* 214911 */     // GIR_Coverage, 12388,
     /* 214911 */     GIR_EraseRootFromParent_Done,
     /* 214912 */   // Label 4124: @214912
     /* 214912 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(214949), // Rule ID 12389 //
     /* 214917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2173:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214947 */     GIR_RootConstrainSelectedInstOperands,
     /* 214948 */     // GIR_Coverage, 12389,
     /* 214948 */     GIR_EraseRootFromParent_Done,
     /* 214949 */   // Label 4125: @214949
     /* 214949 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(214986), // Rule ID 12390 //
     /* 214954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2173:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214984 */     GIR_RootConstrainSelectedInstOperands,
     /* 214985 */     // GIR_Coverage, 12390,
     /* 214985 */     GIR_EraseRootFromParent_Done,
     /* 214986 */   // Label 4126: @214986
     /* 214986 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(215023), // Rule ID 12391 //
     /* 214991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2173:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 215015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215021 */     GIR_RootConstrainSelectedInstOperands,
     /* 215022 */     // GIR_Coverage, 12391,
     /* 215022 */     GIR_EraseRootFromParent_Done,
     /* 215023 */   // Label 4127: @215023
     /* 215023 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(215060), // Rule ID 12392 //
     /* 215028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 215036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215049 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2173:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 215052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215058 */     GIR_RootConstrainSelectedInstOperands,
     /* 215059 */     // GIR_Coverage, 12392,
     /* 215059 */     GIR_EraseRootFromParent_Done,
     /* 215060 */   // Label 4128: @215060
     /* 215060 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(215097), // Rule ID 12393 //
     /* 215065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2098:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 215089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215095 */     GIR_RootConstrainSelectedInstOperands,
     /* 215096 */     // GIR_Coverage, 12393,
     /* 215096 */     GIR_EraseRootFromParent_Done,
     /* 215097 */   // Label 4129: @215097
     /* 215097 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(215134), // Rule ID 12394 //
     /* 215102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2098:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 215126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215132 */     GIR_RootConstrainSelectedInstOperands,
     /* 215133 */     // GIR_Coverage, 12394,
     /* 215133 */     GIR_EraseRootFromParent_Done,
     /* 215134 */   // Label 4130: @215134
     /* 215134 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215171), // Rule ID 12395 //
     /* 215139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2098:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 215163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215169 */     GIR_RootConstrainSelectedInstOperands,
     /* 215170 */     // GIR_Coverage, 12395,
     /* 215170 */     GIR_EraseRootFromParent_Done,
     /* 215171 */   // Label 4131: @215171
     /* 215171 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215208), // Rule ID 12396 //
     /* 215176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2098:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215206 */     GIR_RootConstrainSelectedInstOperands,
     /* 215207 */     // GIR_Coverage, 12396,
     /* 215207 */     GIR_EraseRootFromParent_Done,
     /* 215208 */   // Label 4132: @215208
     /* 215208 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215245), // Rule ID 12397 //
     /* 215213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215234 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2098:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 215237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215243 */     GIR_RootConstrainSelectedInstOperands,
     /* 215244 */     // GIR_Coverage, 12397,
     /* 215244 */     GIR_EraseRootFromParent_Done,
     /* 215245 */   // Label 4133: @215245
     /* 215245 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215282), // Rule ID 12398 //
     /* 215250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215271 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2098:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 215274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215280 */     GIR_RootConstrainSelectedInstOperands,
     /* 215281 */     // GIR_Coverage, 12398,
     /* 215281 */     GIR_EraseRootFromParent_Done,
     /* 215282 */   // Label 4134: @215282
     /* 215282 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(215319), // Rule ID 12399 //
     /* 215287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 215295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215308 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2098:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 215311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215317 */     GIR_RootConstrainSelectedInstOperands,
     /* 215318 */     // GIR_Coverage, 12399,
     /* 215318 */     GIR_EraseRootFromParent_Done,
     /* 215319 */   // Label 4135: @215319
     /* 215319 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(215356), // Rule ID 12400 //
     /* 215324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2099:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 215348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215354 */     GIR_RootConstrainSelectedInstOperands,
     /* 215355 */     // GIR_Coverage, 12400,
     /* 215355 */     GIR_EraseRootFromParent_Done,
     /* 215356 */   // Label 4136: @215356
     /* 215356 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(215393), // Rule ID 12401 //
     /* 215361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2099:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215391 */     GIR_RootConstrainSelectedInstOperands,
     /* 215392 */     // GIR_Coverage, 12401,
     /* 215392 */     GIR_EraseRootFromParent_Done,
     /* 215393 */   // Label 4137: @215393
     /* 215393 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(215430), // Rule ID 12402 //
     /* 215398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2099:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215428 */     GIR_RootConstrainSelectedInstOperands,
     /* 215429 */     // GIR_Coverage, 12402,
     /* 215429 */     GIR_EraseRootFromParent_Done,
     /* 215430 */   // Label 4138: @215430
     /* 215430 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215467), // Rule ID 12403 //
     /* 215435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2099:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215465 */     GIR_RootConstrainSelectedInstOperands,
     /* 215466 */     // GIR_Coverage, 12403,
     /* 215466 */     GIR_EraseRootFromParent_Done,
     /* 215467 */   // Label 4139: @215467
     /* 215467 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215504), // Rule ID 12404 //
     /* 215472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215493 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2099:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215502 */     GIR_RootConstrainSelectedInstOperands,
     /* 215503 */     // GIR_Coverage, 12404,
     /* 215503 */     GIR_EraseRootFromParent_Done,
     /* 215504 */   // Label 4140: @215504
     /* 215504 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(215541), // Rule ID 12405 //
     /* 215509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2099:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215539 */     GIR_RootConstrainSelectedInstOperands,
     /* 215540 */     // GIR_Coverage, 12405,
     /* 215540 */     GIR_EraseRootFromParent_Done,
     /* 215541 */   // Label 4141: @215541
     /* 215541 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215578), // Rule ID 12406 //
     /* 215546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215567 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2099:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215576 */     GIR_RootConstrainSelectedInstOperands,
     /* 215577 */     // GIR_Coverage, 12406,
     /* 215577 */     GIR_EraseRootFromParent_Done,
     /* 215578 */   // Label 4142: @215578
     /* 215578 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215620), // Rule ID 3237 //
     /* 215583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 215591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215598 */     // MIs[0] Op1
     /* 215598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215602 */     // MIs[0] Op2
     /* 215602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 215609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215618 */     GIR_RootConstrainSelectedInstOperands,
     /* 215619 */     // GIR_Coverage, 3237,
     /* 215619 */     GIR_EraseRootFromParent_Done,
     /* 215620 */   // Label 4143: @215620
     /* 215620 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(215662), // Rule ID 3238 //
     /* 215625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 215633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215640 */     // MIs[0] Op1
     /* 215640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215644 */     // MIs[0] Op2
     /* 215644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2154:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 215651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215660 */     GIR_RootConstrainSelectedInstOperands,
     /* 215661 */     // GIR_Coverage, 3238,
     /* 215661 */     GIR_EraseRootFromParent_Done,
     /* 215662 */   // Label 4144: @215662
     /* 215662 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(215704), // Rule ID 3239 //
     /* 215667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 215675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215682 */     // MIs[0] Op1
     /* 215682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215686 */     // MIs[0] Op2
     /* 215686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2155:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 215693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215702 */     GIR_RootConstrainSelectedInstOperands,
     /* 215703 */     // GIR_Coverage, 3239,
     /* 215703 */     GIR_EraseRootFromParent_Done,
     /* 215704 */   // Label 4145: @215704
     /* 215704 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215746), // Rule ID 3240 //
     /* 215709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 215717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215724 */     // MIs[0] Op1
     /* 215724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215728 */     // MIs[0] Op2
     /* 215728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2153:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 215735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215744 */     GIR_RootConstrainSelectedInstOperands,
     /* 215745 */     // GIR_Coverage, 3240,
     /* 215745 */     GIR_EraseRootFromParent_Done,
     /* 215746 */   // Label 4146: @215746
     /* 215746 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(215788), // Rule ID 12218 //
     /* 215751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 215759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215766 */     // MIs[0] Op1
     /* 215766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215770 */     // MIs[0] Op2
     /* 215770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 215777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215786 */     GIR_RootConstrainSelectedInstOperands,
     /* 215787 */     // GIR_Coverage, 12218,
     /* 215787 */     GIR_EraseRootFromParent_Done,
     /* 215788 */   // Label 4147: @215788
     /* 215788 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(215830), // Rule ID 12219 //
     /* 215793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 215801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215808 */     // MIs[0] Op1
     /* 215808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215812 */     // MIs[0] Op2
     /* 215812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 215819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215828 */     GIR_RootConstrainSelectedInstOperands,
     /* 215829 */     // GIR_Coverage, 12219,
     /* 215829 */     GIR_EraseRootFromParent_Done,
     /* 215830 */   // Label 4148: @215830
     /* 215830 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(215872), // Rule ID 12220 //
     /* 215835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 215843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215850 */     // MIs[0] Op1
     /* 215850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215854 */     // MIs[0] Op2
     /* 215854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 215861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215870 */     GIR_RootConstrainSelectedInstOperands,
     /* 215871 */     // GIR_Coverage, 12220,
     /* 215871 */     GIR_EraseRootFromParent_Done,
     /* 215872 */   // Label 4149: @215872
     /* 215872 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(215914), // Rule ID 12221 //
     /* 215877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 215885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215892 */     // MIs[0] Op1
     /* 215892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215896 */     // MIs[0] Op2
     /* 215896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 215903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215912 */     GIR_RootConstrainSelectedInstOperands,
     /* 215913 */     // GIR_Coverage, 12221,
     /* 215913 */     GIR_EraseRootFromParent_Done,
     /* 215914 */   // Label 4150: @215914
     /* 215914 */   GIM_Reject,
     /* 215915 */ // Label 3254: @215915
     /* 215915 */ GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(259026),
     /* 215920 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 215923 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216036), // Rule ID 2073 //
     /* 215928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 216005 */     // MIs[3] Operand 1
     /* 216005 */     // No operand predicates
     /* 216005 */     // MIs[1] Operand 2
     /* 216005 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 216016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216018 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 216018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 216021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216034 */     GIR_RootConstrainSelectedInstOperands,
     /* 216035 */     // GIR_Coverage, 2073,
     /* 216035 */     GIR_EraseRootFromParent_Done,
     /* 216036 */   // Label 4152: @216036
     /* 216036 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216149), // Rule ID 2080 //
     /* 216041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 216049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 216081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 216085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 216093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 216097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 216106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216114 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 216118 */     // MIs[3] Operand 1
     /* 216118 */     // No operand predicates
     /* 216118 */     // MIs[1] Operand 2
     /* 216118 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 216129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216131 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 216131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 216134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216147 */     GIR_RootConstrainSelectedInstOperands,
     /* 216148 */     // GIR_Coverage, 2080,
     /* 216148 */     GIR_EraseRootFromParent_Done,
     /* 216149 */   // Label 4153: @216149
     /* 216149 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216262), // Rule ID 2076 //
     /* 216154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 216162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 216194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216231 */     // MIs[3] Operand 1
     /* 216231 */     // No operand predicates
     /* 216231 */     // MIs[1] Operand 2
     /* 216231 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 216242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216244 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 216244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 216247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216260 */     GIR_RootConstrainSelectedInstOperands,
     /* 216261 */     // GIR_Coverage, 2076,
     /* 216261 */     GIR_EraseRootFromParent_Done,
     /* 216262 */   // Label 4154: @216262
     /* 216262 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216375), // Rule ID 2083 //
     /* 216267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 216270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 216275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 216307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216340 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216344 */     // MIs[3] Operand 1
     /* 216344 */     // No operand predicates
     /* 216344 */     // MIs[1] Operand 2
     /* 216344 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 216355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216357 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 216357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 216360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216373 */     GIR_RootConstrainSelectedInstOperands,
     /* 216374 */     // GIR_Coverage, 2083,
     /* 216374 */     GIR_EraseRootFromParent_Done,
     /* 216375 */   // Label 4155: @216375
     /* 216375 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216480), // Rule ID 3902 //
     /* 216380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216457 */     // MIs[3] Operand 1
     /* 216457 */     // No operand predicates
     /* 216457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216459 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216478 */     GIR_RootConstrainSelectedInstOperands,
     /* 216479 */     // GIR_Coverage, 3902,
     /* 216479 */     GIR_EraseRootFromParent_Done,
     /* 216480 */   // Label 4156: @216480
     /* 216480 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216585), // Rule ID 3903 //
     /* 216485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216558 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216562 */     // MIs[3] Operand 1
     /* 216562 */     // No operand predicates
     /* 216562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216564 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216583 */     GIR_RootConstrainSelectedInstOperands,
     /* 216584 */     // GIR_Coverage, 3903,
     /* 216584 */     GIR_EraseRootFromParent_Done,
     /* 216585 */   // Label 4157: @216585
     /* 216585 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216690), // Rule ID 3904 //
     /* 216590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216667 */     // MIs[3] Operand 1
     /* 216667 */     // No operand predicates
     /* 216667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216669 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216688 */     GIR_RootConstrainSelectedInstOperands,
     /* 216689 */     // GIR_Coverage, 3904,
     /* 216689 */     GIR_EraseRootFromParent_Done,
     /* 216690 */   // Label 4158: @216690
     /* 216690 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(216795), // Rule ID 3905 //
     /* 216695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216768 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216772 */     // MIs[3] Operand 1
     /* 216772 */     // No operand predicates
     /* 216772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216774 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216793 */     GIR_RootConstrainSelectedInstOperands,
     /* 216794 */     // GIR_Coverage, 3905,
     /* 216794 */     GIR_EraseRootFromParent_Done,
     /* 216795 */   // Label 4159: @216795
     /* 216795 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(216900), // Rule ID 3910 //
     /* 216800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216873 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216877 */     // MIs[3] Operand 1
     /* 216877 */     // No operand predicates
     /* 216877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216879 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216898 */     GIR_RootConstrainSelectedInstOperands,
     /* 216899 */     // GIR_Coverage, 3910,
     /* 216899 */     GIR_EraseRootFromParent_Done,
     /* 216900 */   // Label 4160: @216900
     /* 216900 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(217005), // Rule ID 3911 //
     /* 216905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216978 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216982 */     // MIs[3] Operand 1
     /* 216982 */     // No operand predicates
     /* 216982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216984 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217003 */     GIR_RootConstrainSelectedInstOperands,
     /* 217004 */     // GIR_Coverage, 3911,
     /* 217004 */     GIR_EraseRootFromParent_Done,
     /* 217005 */   // Label 4161: @217005
     /* 217005 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217110), // Rule ID 3912 //
     /* 217010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 217062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 217087 */     // MIs[3] Operand 1
     /* 217087 */     // No operand predicates
     /* 217087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217089 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 217089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 217092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217108 */     GIR_RootConstrainSelectedInstOperands,
     /* 217109 */     // GIR_Coverage, 3912,
     /* 217109 */     GIR_EraseRootFromParent_Done,
     /* 217110 */   // Label 4162: @217110
     /* 217110 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217215), // Rule ID 3913 //
     /* 217115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 217167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217188 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 217192 */     // MIs[3] Operand 1
     /* 217192 */     // No operand predicates
     /* 217192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217194 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 217194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 217197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217213 */     GIR_RootConstrainSelectedInstOperands,
     /* 217214 */     // GIR_Coverage, 3913,
     /* 217214 */     GIR_EraseRootFromParent_Done,
     /* 217215 */   // Label 4163: @217215
     /* 217215 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217320), // Rule ID 3926 //
     /* 217220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217297 */     // MIs[3] Operand 1
     /* 217297 */     // No operand predicates
     /* 217297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217299 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 217299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217318 */     GIR_RootConstrainSelectedInstOperands,
     /* 217319 */     // GIR_Coverage, 3926,
     /* 217319 */     GIR_EraseRootFromParent_Done,
     /* 217320 */   // Label 4164: @217320
     /* 217320 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217425), // Rule ID 3927 //
     /* 217325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217402 */     // MIs[3] Operand 1
     /* 217402 */     // No operand predicates
     /* 217402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217404 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 217404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217423 */     GIR_RootConstrainSelectedInstOperands,
     /* 217424 */     // GIR_Coverage, 3927,
     /* 217424 */     GIR_EraseRootFromParent_Done,
     /* 217425 */   // Label 4165: @217425
     /* 217425 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217530), // Rule ID 3928 //
     /* 217430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217503 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217507 */     // MIs[3] Operand 1
     /* 217507 */     // No operand predicates
     /* 217507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217509 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 217509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217528 */     GIR_RootConstrainSelectedInstOperands,
     /* 217529 */     // GIR_Coverage, 3928,
     /* 217529 */     GIR_EraseRootFromParent_Done,
     /* 217530 */   // Label 4166: @217530
     /* 217530 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217635), // Rule ID 3929 //
     /* 217535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217608 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217612 */     // MIs[3] Operand 1
     /* 217612 */     // No operand predicates
     /* 217612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217614 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 217614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217633 */     GIR_RootConstrainSelectedInstOperands,
     /* 217634 */     // GIR_Coverage, 3929,
     /* 217634 */     GIR_EraseRootFromParent_Done,
     /* 217635 */   // Label 4167: @217635
     /* 217635 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217689), // Rule ID 59 //
     /* 217640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217665 */     // MIs[0] Operand 3
     /* 217665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 217676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217680 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 217683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217687 */     GIR_RootConstrainSelectedInstOperands,
     /* 217688 */     // GIR_Coverage, 59,
     /* 217688 */     GIR_EraseRootFromParent_Done,
     /* 217689 */   // Label 4168: @217689
     /* 217689 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217743), // Rule ID 60 //
     /* 217694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217719 */     // MIs[0] Operand 3
     /* 217719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 217730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217734 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 217737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217741 */     GIR_RootConstrainSelectedInstOperands,
     /* 217742 */     // GIR_Coverage, 60,
     /* 217742 */     GIR_EraseRootFromParent_Done,
     /* 217743 */   // Label 4169: @217743
     /* 217743 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217797), // Rule ID 61 //
     /* 217748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217773 */     // MIs[0] Operand 3
     /* 217773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 217784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217788 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 217791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217795 */     GIR_RootConstrainSelectedInstOperands,
     /* 217796 */     // GIR_Coverage, 61,
     /* 217796 */     GIR_EraseRootFromParent_Done,
     /* 217797 */   // Label 4170: @217797
     /* 217797 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217851), // Rule ID 62 //
     /* 217802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217827 */     // MIs[0] Operand 3
     /* 217827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 217838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217842 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 217845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217849 */     GIR_RootConstrainSelectedInstOperands,
     /* 217850 */     // GIR_Coverage, 62,
     /* 217850 */     GIR_EraseRootFromParent_Done,
     /* 217851 */   // Label 4171: @217851
     /* 217851 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217907), // Rule ID 2652 //
     /* 217856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 217864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217878 */     // MIs[0] pattern
     /* 217878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217886 */     // MIs[0] imm4
     /* 217886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 217897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217901 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217903 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217905 */     GIR_RootConstrainSelectedInstOperands,
     /* 217906 */     // GIR_Coverage, 2652,
     /* 217906 */     GIR_EraseRootFromParent_Done,
     /* 217907 */   // Label 4172: @217907
     /* 217907 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217963), // Rule ID 2661 //
     /* 217912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 217920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217934 */     // MIs[0] pattern
     /* 217934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217942 */     // MIs[0] imm4
     /* 217942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217950 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 217953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217957 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217959 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217961 */     GIR_RootConstrainSelectedInstOperands,
     /* 217962 */     // GIR_Coverage, 2661,
     /* 217962 */     GIR_EraseRootFromParent_Done,
     /* 217963 */   // Label 4173: @217963
     /* 217963 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(218019), // Rule ID 2662 //
     /* 217968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 217976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217990 */     // MIs[0] pattern
     /* 217990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217998 */     // MIs[0] imm4
     /* 217998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218006 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 218009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218013 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218015 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218017 */     GIR_RootConstrainSelectedInstOperands,
     /* 218018 */     // GIR_Coverage, 2662,
     /* 218018 */     GIR_EraseRootFromParent_Done,
     /* 218019 */   // Label 4174: @218019
     /* 218019 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(218075), // Rule ID 10103 //
     /* 218024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 218032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218046 */     // MIs[0] pattern
     /* 218046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218054 */     // MIs[0] imm4
     /* 218054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218062 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 218065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218069 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218071 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218073 */     GIR_RootConstrainSelectedInstOperands,
     /* 218074 */     // GIR_Coverage, 10103,
     /* 218074 */     GIR_EraseRootFromParent_Done,
     /* 218075 */   // Label 4175: @218075
     /* 218075 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(218131), // Rule ID 10104 //
     /* 218080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 218088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218102 */     // MIs[0] pattern
     /* 218102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218110 */     // MIs[0] imm4
     /* 218110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218118 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 218121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218127 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218129 */     GIR_RootConstrainSelectedInstOperands,
     /* 218130 */     // GIR_Coverage, 10104,
     /* 218130 */     GIR_EraseRootFromParent_Done,
     /* 218131 */   // Label 4176: @218131
     /* 218131 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(218187), // Rule ID 10105 //
     /* 218136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 218144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218158 */     // MIs[0] pattern
     /* 218158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218166 */     // MIs[0] imm4
     /* 218166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218174 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 218177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218181 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218183 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218185 */     GIR_RootConstrainSelectedInstOperands,
     /* 218186 */     // GIR_Coverage, 10105,
     /* 218186 */     GIR_EraseRootFromParent_Done,
     /* 218187 */   // Label 4177: @218187
     /* 218187 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(218243), // Rule ID 10106 //
     /* 218192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 218200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218214 */     // MIs[0] pattern
     /* 218214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218222 */     // MIs[0] imm4
     /* 218222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218230 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 218233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218237 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218239 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218241 */     GIR_RootConstrainSelectedInstOperands,
     /* 218242 */     // GIR_Coverage, 10106,
     /* 218242 */     GIR_EraseRootFromParent_Done,
     /* 218243 */   // Label 4178: @218243
     /* 218243 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(218299), // Rule ID 10109 //
     /* 218248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 218256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218270 */     // MIs[0] pattern
     /* 218270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218278 */     // MIs[0] imm4
     /* 218278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218286 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 218289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218293 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218295 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218297 */     GIR_RootConstrainSelectedInstOperands,
     /* 218298 */     // GIR_Coverage, 10109,
     /* 218298 */     GIR_EraseRootFromParent_Done,
     /* 218299 */   // Label 4179: @218299
     /* 218299 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(218355), // Rule ID 10112 //
     /* 218304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 218312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218326 */     // MIs[0] pattern
     /* 218326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218334 */     // MIs[0] imm4
     /* 218334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218342 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 218345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218349 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218351 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218353 */     GIR_RootConstrainSelectedInstOperands,
     /* 218354 */     // GIR_Coverage, 10112,
     /* 218354 */     GIR_EraseRootFromParent_Done,
     /* 218355 */   // Label 4180: @218355
     /* 218355 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(218411), // Rule ID 10113 //
     /* 218360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 218368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218382 */     // MIs[0] pattern
     /* 218382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218390 */     // MIs[0] imm4
     /* 218390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218398 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 218401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218405 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218407 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218409 */     GIR_RootConstrainSelectedInstOperands,
     /* 218410 */     // GIR_Coverage, 10113,
     /* 218410 */     GIR_EraseRootFromParent_Done,
     /* 218411 */   // Label 4181: @218411
     /* 218411 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(218467), // Rule ID 10114 //
     /* 218416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 218424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218438 */     // MIs[0] pattern
     /* 218438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218446 */     // MIs[0] imm4
     /* 218446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218454 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 218457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218461 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218463 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218465 */     GIR_RootConstrainSelectedInstOperands,
     /* 218466 */     // GIR_Coverage, 10114,
     /* 218466 */     GIR_EraseRootFromParent_Done,
     /* 218467 */   // Label 4182: @218467
     /* 218467 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(218523), // Rule ID 10115 //
     /* 218472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 218480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218494 */     // MIs[0] pattern
     /* 218494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218502 */     // MIs[0] imm4
     /* 218502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218510 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 218513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218517 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218519 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218521 */     GIR_RootConstrainSelectedInstOperands,
     /* 218522 */     // GIR_Coverage, 10115,
     /* 218522 */     GIR_EraseRootFromParent_Done,
     /* 218523 */   // Label 4183: @218523
     /* 218523 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218579), // Rule ID 10116 //
     /* 218528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 218536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218550 */     // MIs[0] pattern
     /* 218550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218558 */     // MIs[0] imm4
     /* 218558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218566 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 218569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218573 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218577 */     GIR_RootConstrainSelectedInstOperands,
     /* 218578 */     // GIR_Coverage, 10116,
     /* 218578 */     GIR_EraseRootFromParent_Done,
     /* 218579 */   // Label 4184: @218579
     /* 218579 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218635), // Rule ID 10119 //
     /* 218584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 218592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218606 */     // MIs[0] pattern
     /* 218606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218614 */     // MIs[0] imm4
     /* 218614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218622 */     // (intrinsic_wo_chain:{ *:[i32] } 2038:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 218625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218629 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218631 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218633 */     GIR_RootConstrainSelectedInstOperands,
     /* 218634 */     // GIR_Coverage, 10119,
     /* 218634 */     GIR_EraseRootFromParent_Done,
     /* 218635 */   // Label 4185: @218635
     /* 218635 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218691), // Rule ID 10122 //
     /* 218640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 218648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218662 */     // MIs[0] pattern
     /* 218662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218670 */     // MIs[0] imm4
     /* 218670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218678 */     // (intrinsic_wo_chain:{ *:[i32] } 2024:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 218681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218685 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218687 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218689 */     GIR_RootConstrainSelectedInstOperands,
     /* 218690 */     // GIR_Coverage, 10122,
     /* 218690 */     GIR_EraseRootFromParent_Done,
     /* 218691 */   // Label 4186: @218691
     /* 218691 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218747), // Rule ID 10123 //
     /* 218696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 218704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218718 */     // MIs[0] pattern
     /* 218718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218726 */     // MIs[0] imm4
     /* 218726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218734 */     // (intrinsic_wo_chain:{ *:[i64] } 1828:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218741 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218743 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218745 */     GIR_RootConstrainSelectedInstOperands,
     /* 218746 */     // GIR_Coverage, 10123,
     /* 218746 */     GIR_EraseRootFromParent_Done,
     /* 218747 */   // Label 4187: @218747
     /* 218747 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218803), // Rule ID 10124 //
     /* 218752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 218760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218774 */     // MIs[0] pattern
     /* 218774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218782 */     // MIs[0] imm4
     /* 218782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218790 */     // (intrinsic_wo_chain:{ *:[i64] } 2039:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 218793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218797 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218799 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218801 */     GIR_RootConstrainSelectedInstOperands,
     /* 218802 */     // GIR_Coverage, 10124,
     /* 218802 */     GIR_EraseRootFromParent_Done,
     /* 218803 */   // Label 4188: @218803
     /* 218803 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218859), // Rule ID 10125 //
     /* 218808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 218816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218830 */     // MIs[0] pattern
     /* 218830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218838 */     // MIs[0] imm4
     /* 218838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218846 */     // (intrinsic_wo_chain:{ *:[i64] } 1794:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 218849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218853 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218855 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218857 */     GIR_RootConstrainSelectedInstOperands,
     /* 218858 */     // GIR_Coverage, 10125,
     /* 218858 */     GIR_EraseRootFromParent_Done,
     /* 218859 */   // Label 4189: @218859
     /* 218859 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218915), // Rule ID 10126 //
     /* 218864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 218872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218886 */     // MIs[0] pattern
     /* 218886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218894 */     // MIs[0] imm4
     /* 218894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218902 */     // (intrinsic_wo_chain:{ *:[i64] } 2025:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 218905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218909 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218911 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218913 */     GIR_RootConstrainSelectedInstOperands,
     /* 218914 */     // GIR_Coverage, 10126,
     /* 218914 */     GIR_EraseRootFromParent_Done,
     /* 218915 */   // Label 4190: @218915
     /* 218915 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218971), // Rule ID 10129 //
     /* 218920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 218928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218942 */     // MIs[0] pattern
     /* 218942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218950 */     // MIs[0] imm4
     /* 218950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218958 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 218961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218965 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218967 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218969 */     GIR_RootConstrainSelectedInstOperands,
     /* 218970 */     // GIR_Coverage, 10129,
     /* 218970 */     GIR_EraseRootFromParent_Done,
     /* 218971 */   // Label 4191: @218971
     /* 218971 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(219027), // Rule ID 10132 //
     /* 218976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 218984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218998 */     // MIs[0] pattern
     /* 218998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219006 */     // MIs[0] imm4
     /* 219006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219014 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 219017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219021 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219023 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219025 */     GIR_RootConstrainSelectedInstOperands,
     /* 219026 */     // GIR_Coverage, 10132,
     /* 219026 */     GIR_EraseRootFromParent_Done,
     /* 219027 */   // Label 4192: @219027
     /* 219027 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(219083), // Rule ID 10133 //
     /* 219032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 219040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219054 */     // MIs[0] pattern
     /* 219054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219062 */     // MIs[0] imm4
     /* 219062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219070 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 219073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219077 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219079 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219081 */     GIR_RootConstrainSelectedInstOperands,
     /* 219082 */     // GIR_Coverage, 10133,
     /* 219082 */     GIR_EraseRootFromParent_Done,
     /* 219083 */   // Label 4193: @219083
     /* 219083 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(219139), // Rule ID 10134 //
     /* 219088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 219096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219110 */     // MIs[0] pattern
     /* 219110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219118 */     // MIs[0] imm4
     /* 219118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219126 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 219129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219133 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219135 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219137 */     GIR_RootConstrainSelectedInstOperands,
     /* 219138 */     // GIR_Coverage, 10134,
     /* 219138 */     GIR_EraseRootFromParent_Done,
     /* 219139 */   // Label 4194: @219139
     /* 219139 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219195), // Rule ID 10135 //
     /* 219144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 219152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219166 */     // MIs[0] pattern
     /* 219166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219174 */     // MIs[0] imm4
     /* 219174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219182 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 219185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219189 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219191 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219193 */     GIR_RootConstrainSelectedInstOperands,
     /* 219194 */     // GIR_Coverage, 10135,
     /* 219194 */     GIR_EraseRootFromParent_Done,
     /* 219195 */   // Label 4195: @219195
     /* 219195 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219251), // Rule ID 10136 //
     /* 219200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 219208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219222 */     // MIs[0] pattern
     /* 219222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219230 */     // MIs[0] imm4
     /* 219230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219238 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 219241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219245 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219247 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219249 */     GIR_RootConstrainSelectedInstOperands,
     /* 219250 */     // GIR_Coverage, 10136,
     /* 219250 */     GIR_EraseRootFromParent_Done,
     /* 219251 */   // Label 4196: @219251
     /* 219251 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219307), // Rule ID 10137 //
     /* 219256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 219264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219278 */     // MIs[0] pattern
     /* 219278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219286 */     // MIs[0] imm4
     /* 219286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 219297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219301 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219303 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219305 */     GIR_RootConstrainSelectedInstOperands,
     /* 219306 */     // GIR_Coverage, 10137,
     /* 219306 */     GIR_EraseRootFromParent_Done,
     /* 219307 */   // Label 4197: @219307
     /* 219307 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219363), // Rule ID 10138 //
     /* 219312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 219320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219334 */     // MIs[0] pattern
     /* 219334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219342 */     // MIs[0] imm4
     /* 219342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 219353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219357 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219359 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219361 */     GIR_RootConstrainSelectedInstOperands,
     /* 219362 */     // GIR_Coverage, 10138,
     /* 219362 */     GIR_EraseRootFromParent_Done,
     /* 219363 */   // Label 4198: @219363
     /* 219363 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219419), // Rule ID 10139 //
     /* 219368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 219376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219390 */     // MIs[0] pattern
     /* 219390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219398 */     // MIs[0] imm4
     /* 219398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 219409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219413 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219417 */     GIR_RootConstrainSelectedInstOperands,
     /* 219418 */     // GIR_Coverage, 10139,
     /* 219418 */     GIR_EraseRootFromParent_Done,
     /* 219419 */   // Label 4199: @219419
     /* 219419 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219475), // Rule ID 10140 //
     /* 219424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 219432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219446 */     // MIs[0] pattern
     /* 219446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219454 */     // MIs[0] imm4
     /* 219454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219462 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 219465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219469 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219471 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219473 */     GIR_RootConstrainSelectedInstOperands,
     /* 219474 */     // GIR_Coverage, 10140,
     /* 219474 */     GIR_EraseRootFromParent_Done,
     /* 219475 */   // Label 4200: @219475
     /* 219475 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219531), // Rule ID 10141 //
     /* 219480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 219488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219502 */     // MIs[0] pattern
     /* 219502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219510 */     // MIs[0] imm4
     /* 219510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 219521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219525 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219527 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219529 */     GIR_RootConstrainSelectedInstOperands,
     /* 219530 */     // GIR_Coverage, 10141,
     /* 219530 */     GIR_EraseRootFromParent_Done,
     /* 219531 */   // Label 4201: @219531
     /* 219531 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219587), // Rule ID 10142 //
     /* 219536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 219544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219558 */     // MIs[0] pattern
     /* 219558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219566 */     // MIs[0] imm4
     /* 219566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 219577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219581 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219583 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219585 */     GIR_RootConstrainSelectedInstOperands,
     /* 219586 */     // GIR_Coverage, 10142,
     /* 219586 */     GIR_EraseRootFromParent_Done,
     /* 219587 */   // Label 4202: @219587
     /* 219587 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219643), // Rule ID 10143 //
     /* 219592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 219600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219614 */     // MIs[0] pattern
     /* 219614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219622 */     // MIs[0] imm4
     /* 219622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 219633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219637 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219639 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219641 */     GIR_RootConstrainSelectedInstOperands,
     /* 219642 */     // GIR_Coverage, 10143,
     /* 219642 */     GIR_EraseRootFromParent_Done,
     /* 219643 */   // Label 4203: @219643
     /* 219643 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219699), // Rule ID 10144 //
     /* 219648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 219656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219670 */     // MIs[0] pattern
     /* 219670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219678 */     // MIs[0] imm4
     /* 219678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 219689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219693 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219695 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219697 */     GIR_RootConstrainSelectedInstOperands,
     /* 219698 */     // GIR_Coverage, 10144,
     /* 219698 */     GIR_EraseRootFromParent_Done,
     /* 219699 */   // Label 4204: @219699
     /* 219699 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219755), // Rule ID 10145 //
     /* 219704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 219712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219726 */     // MIs[0] pattern
     /* 219726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219734 */     // MIs[0] imm4
     /* 219734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2028:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 219745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219749 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219751 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219753 */     GIR_RootConstrainSelectedInstOperands,
     /* 219754 */     // GIR_Coverage, 10145,
     /* 219754 */     GIR_EraseRootFromParent_Done,
     /* 219755 */   // Label 4205: @219755
     /* 219755 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219811), // Rule ID 10146 //
     /* 219760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 219768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219782 */     // MIs[0] pattern
     /* 219782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219790 */     // MIs[0] imm4
     /* 219790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1783:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 219801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219805 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219807 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219809 */     GIR_RootConstrainSelectedInstOperands,
     /* 219810 */     // GIR_Coverage, 10146,
     /* 219810 */     GIR_EraseRootFromParent_Done,
     /* 219811 */   // Label 4206: @219811
     /* 219811 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(219867), // Rule ID 10147 //
     /* 219816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 219824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219838 */     // MIs[0] pattern
     /* 219838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219846 */     // MIs[0] imm4
     /* 219846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2014:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 219857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219861 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219863 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219865 */     GIR_RootConstrainSelectedInstOperands,
     /* 219866 */     // GIR_Coverage, 10147,
     /* 219866 */     GIR_EraseRootFromParent_Done,
     /* 219867 */   // Label 4207: @219867
     /* 219867 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(219957), // Rule ID 47 //
     /* 219872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219937 */     // MIs[2] Operand 1
     /* 219937 */     // No operand predicates
     /* 219937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219939 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 219942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219955 */     GIR_RootConstrainSelectedInstOperands,
     /* 219956 */     // GIR_Coverage, 47,
     /* 219956 */     GIR_EraseRootFromParent_Done,
     /* 219957 */   // Label 4208: @219957
     /* 219957 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220047), // Rule ID 48 //
     /* 219962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220027 */     // MIs[2] Operand 1
     /* 220027 */     // No operand predicates
     /* 220027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220029 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 220032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220045 */     GIR_RootConstrainSelectedInstOperands,
     /* 220046 */     // GIR_Coverage, 48,
     /* 220046 */     GIR_EraseRootFromParent_Done,
     /* 220047 */   // Label 4209: @220047
     /* 220047 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220137), // Rule ID 49 //
     /* 220052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 220060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220117 */     // MIs[2] Operand 1
     /* 220117 */     // No operand predicates
     /* 220117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220119 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 220122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220135 */     GIR_RootConstrainSelectedInstOperands,
     /* 220136 */     // GIR_Coverage, 49,
     /* 220136 */     GIR_EraseRootFromParent_Done,
     /* 220137 */   // Label 4210: @220137
     /* 220137 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220227), // Rule ID 50 //
     /* 220142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 220150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220207 */     // MIs[2] Operand 1
     /* 220207 */     // No operand predicates
     /* 220207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220209 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 220212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220225 */     GIR_RootConstrainSelectedInstOperands,
     /* 220226 */     // GIR_Coverage, 50,
     /* 220226 */     GIR_EraseRootFromParent_Done,
     /* 220227 */   // Label 4211: @220227
     /* 220227 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220317), // Rule ID 51 //
     /* 220232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 220240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220297 */     // MIs[2] Operand 1
     /* 220297 */     // No operand predicates
     /* 220297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220299 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 220302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220315 */     GIR_RootConstrainSelectedInstOperands,
     /* 220316 */     // GIR_Coverage, 51,
     /* 220316 */     GIR_EraseRootFromParent_Done,
     /* 220317 */   // Label 4212: @220317
     /* 220317 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220407), // Rule ID 52 //
     /* 220322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 220330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220387 */     // MIs[2] Operand 1
     /* 220387 */     // No operand predicates
     /* 220387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220389 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 220392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220405 */     GIR_RootConstrainSelectedInstOperands,
     /* 220406 */     // GIR_Coverage, 52,
     /* 220406 */     GIR_EraseRootFromParent_Done,
     /* 220407 */   // Label 4213: @220407
     /* 220407 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220497), // Rule ID 53 //
     /* 220412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220473 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220477 */     // MIs[2] Operand 1
     /* 220477 */     // No operand predicates
     /* 220477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220479 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 220482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220495 */     GIR_RootConstrainSelectedInstOperands,
     /* 220496 */     // GIR_Coverage, 53,
     /* 220496 */     GIR_EraseRootFromParent_Done,
     /* 220497 */   // Label 4214: @220497
     /* 220497 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220587), // Rule ID 54 //
     /* 220502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220567 */     // MIs[2] Operand 1
     /* 220567 */     // No operand predicates
     /* 220567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220569 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 220572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220585 */     GIR_RootConstrainSelectedInstOperands,
     /* 220586 */     // GIR_Coverage, 54,
     /* 220586 */     GIR_EraseRootFromParent_Done,
     /* 220587 */   // Label 4215: @220587
     /* 220587 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220677), // Rule ID 2074 //
     /* 220592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220657 */     // MIs[2] Operand 1
     /* 220657 */     // No operand predicates
     /* 220657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220659 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 220662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220675 */     GIR_RootConstrainSelectedInstOperands,
     /* 220676 */     // GIR_Coverage, 2074,
     /* 220676 */     GIR_EraseRootFromParent_Done,
     /* 220677 */   // Label 4216: @220677
     /* 220677 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220767), // Rule ID 2075 //
     /* 220682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220747 */     // MIs[2] Operand 1
     /* 220747 */     // No operand predicates
     /* 220747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220749 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 220752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220765 */     GIR_RootConstrainSelectedInstOperands,
     /* 220766 */     // GIR_Coverage, 2075,
     /* 220766 */     GIR_EraseRootFromParent_Done,
     /* 220767 */   // Label 4217: @220767
     /* 220767 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(220857), // Rule ID 2081 //
     /* 220772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220837 */     // MIs[2] Operand 1
     /* 220837 */     // No operand predicates
     /* 220837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220839 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 220842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220855 */     GIR_RootConstrainSelectedInstOperands,
     /* 220856 */     // GIR_Coverage, 2081,
     /* 220856 */     GIR_EraseRootFromParent_Done,
     /* 220857 */   // Label 4218: @220857
     /* 220857 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(220947), // Rule ID 2082 //
     /* 220862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220927 */     // MIs[2] Operand 1
     /* 220927 */     // No operand predicates
     /* 220927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220929 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 220932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220945 */     GIR_RootConstrainSelectedInstOperands,
     /* 220946 */     // GIR_Coverage, 2082,
     /* 220946 */     GIR_EraseRootFromParent_Done,
     /* 220947 */   // Label 4219: @220947
     /* 220947 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(221037), // Rule ID 2077 //
     /* 220952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221013 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221017 */     // MIs[2] Operand 1
     /* 221017 */     // No operand predicates
     /* 221017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221019 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 221022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221035 */     GIR_RootConstrainSelectedInstOperands,
     /* 221036 */     // GIR_Coverage, 2077,
     /* 221036 */     GIR_EraseRootFromParent_Done,
     /* 221037 */   // Label 4220: @221037
     /* 221037 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(221127), // Rule ID 2078 //
     /* 221042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 221050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 221053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 221059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 221062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 221082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221107 */     // MIs[2] Operand 1
     /* 221107 */     // No operand predicates
     /* 221107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 221112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221125 */     GIR_RootConstrainSelectedInstOperands,
     /* 221126 */     // GIR_Coverage, 2078,
     /* 221126 */     GIR_EraseRootFromParent_Done,
     /* 221127 */   // Label 4221: @221127
     /* 221127 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221217), // Rule ID 2084 //
     /* 221132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 221140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 221149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 221152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 221172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221197 */     // MIs[2] Operand 1
     /* 221197 */     // No operand predicates
     /* 221197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221199 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 221202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221215 */     GIR_RootConstrainSelectedInstOperands,
     /* 221216 */     // GIR_Coverage, 2084,
     /* 221216 */     GIR_EraseRootFromParent_Done,
     /* 221217 */   // Label 4222: @221217
     /* 221217 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221307), // Rule ID 2085 //
     /* 221222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 221230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 221233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 221239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 221242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 221262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221283 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221287 */     // MIs[2] Operand 1
     /* 221287 */     // No operand predicates
     /* 221287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221289 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 221292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221305 */     GIR_RootConstrainSelectedInstOperands,
     /* 221306 */     // GIR_Coverage, 2085,
     /* 221306 */     GIR_EraseRootFromParent_Done,
     /* 221307 */   // Label 4223: @221307
     /* 221307 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221397), // Rule ID 2079 //
     /* 221312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 221320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 221323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 221332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 221352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221377 */     // MIs[2] Operand 1
     /* 221377 */     // No operand predicates
     /* 221377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221379 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 221382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221395 */     GIR_RootConstrainSelectedInstOperands,
     /* 221396 */     // GIR_Coverage, 2079,
     /* 221396 */     GIR_EraseRootFromParent_Done,
     /* 221397 */   // Label 4224: @221397
     /* 221397 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221487), // Rule ID 2086 //
     /* 221402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 221410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 221413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 221422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 221442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221467 */     // MIs[2] Operand 1
     /* 221467 */     // No operand predicates
     /* 221467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221469 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 221472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221485 */     GIR_RootConstrainSelectedInstOperands,
     /* 221486 */     // GIR_Coverage, 2086,
     /* 221486 */     GIR_EraseRootFromParent_Done,
     /* 221487 */   // Label 4225: @221487
     /* 221487 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221564), // Rule ID 2781 //
     /* 221492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221544 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221548 */     // MIs[2] Operand 1
     /* 221548 */     // No operand predicates
     /* 221548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221550 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221562 */     GIR_RootConstrainSelectedInstOperands,
     /* 221563 */     // GIR_Coverage, 2781,
     /* 221563 */     GIR_EraseRootFromParent_Done,
     /* 221564 */   // Label 4226: @221564
     /* 221564 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221641), // Rule ID 2782 //
     /* 221569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221621 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221625 */     // MIs[2] Operand 1
     /* 221625 */     // No operand predicates
     /* 221625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221639 */     GIR_RootConstrainSelectedInstOperands,
     /* 221640 */     // GIR_Coverage, 2782,
     /* 221640 */     GIR_EraseRootFromParent_Done,
     /* 221641 */   // Label 4227: @221641
     /* 221641 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221718), // Rule ID 2783 //
     /* 221646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221698 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221702 */     // MIs[2] Operand 1
     /* 221702 */     // No operand predicates
     /* 221702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221716 */     GIR_RootConstrainSelectedInstOperands,
     /* 221717 */     // GIR_Coverage, 2783,
     /* 221717 */     GIR_EraseRootFromParent_Done,
     /* 221718 */   // Label 4228: @221718
     /* 221718 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221795), // Rule ID 2784 //
     /* 221723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221775 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221779 */     // MIs[2] Operand 1
     /* 221779 */     // No operand predicates
     /* 221779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221781 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221793 */     GIR_RootConstrainSelectedInstOperands,
     /* 221794 */     // GIR_Coverage, 2784,
     /* 221794 */     GIR_EraseRootFromParent_Done,
     /* 221795 */   // Label 4229: @221795
     /* 221795 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221872), // Rule ID 2785 //
     /* 221800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221852 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221856 */     // MIs[2] Operand 1
     /* 221856 */     // No operand predicates
     /* 221856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221870 */     GIR_RootConstrainSelectedInstOperands,
     /* 221871 */     // GIR_Coverage, 2785,
     /* 221871 */     GIR_EraseRootFromParent_Done,
     /* 221872 */   // Label 4230: @221872
     /* 221872 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(221949), // Rule ID 2786 //
     /* 221877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221929 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221933 */     // MIs[2] Operand 1
     /* 221933 */     // No operand predicates
     /* 221933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221935 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221947 */     GIR_RootConstrainSelectedInstOperands,
     /* 221948 */     // GIR_Coverage, 2786,
     /* 221948 */     GIR_EraseRootFromParent_Done,
     /* 221949 */   // Label 4231: @221949
     /* 221949 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(222026), // Rule ID 7965 //
     /* 221954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222006 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222010 */     // MIs[2] Operand 1
     /* 222010 */     // No operand predicates
     /* 222010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222012 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 222015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222024 */     GIR_RootConstrainSelectedInstOperands,
     /* 222025 */     // GIR_Coverage, 7965,
     /* 222025 */     GIR_EraseRootFromParent_Done,
     /* 222026 */   // Label 4232: @222026
     /* 222026 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(222103), // Rule ID 7966 //
     /* 222031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 222039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222083 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222087 */     // MIs[2] Operand 1
     /* 222087 */     // No operand predicates
     /* 222087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222089 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 222092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222101 */     GIR_RootConstrainSelectedInstOperands,
     /* 222102 */     // GIR_Coverage, 7966,
     /* 222102 */     GIR_EraseRootFromParent_Done,
     /* 222103 */   // Label 4233: @222103
     /* 222103 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(222180), // Rule ID 7967 //
     /* 222108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 222116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222160 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222164 */     // MIs[2] Operand 1
     /* 222164 */     // No operand predicates
     /* 222164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222166 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 222169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222178 */     GIR_RootConstrainSelectedInstOperands,
     /* 222179 */     // GIR_Coverage, 7967,
     /* 222179 */     GIR_EraseRootFromParent_Done,
     /* 222180 */   // Label 4234: @222180
     /* 222180 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222257), // Rule ID 7968 //
     /* 222185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 222193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222237 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222241 */     // MIs[2] Operand 1
     /* 222241 */     // No operand predicates
     /* 222241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222243 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 222246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222255 */     GIR_RootConstrainSelectedInstOperands,
     /* 222256 */     // GIR_Coverage, 7968,
     /* 222256 */     GIR_EraseRootFromParent_Done,
     /* 222257 */   // Label 4235: @222257
     /* 222257 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222334), // Rule ID 7969 //
     /* 222262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 222270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222314 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222318 */     // MIs[2] Operand 1
     /* 222318 */     // No operand predicates
     /* 222318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222320 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 222323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222332 */     GIR_RootConstrainSelectedInstOperands,
     /* 222333 */     // GIR_Coverage, 7969,
     /* 222333 */     GIR_EraseRootFromParent_Done,
     /* 222334 */   // Label 4236: @222334
     /* 222334 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222411), // Rule ID 7970 //
     /* 222339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 222347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222391 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222395 */     // MIs[2] Operand 1
     /* 222395 */     // No operand predicates
     /* 222395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 222400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222409 */     GIR_RootConstrainSelectedInstOperands,
     /* 222410 */     // GIR_Coverage, 7970,
     /* 222410 */     GIR_EraseRootFromParent_Done,
     /* 222411 */   // Label 4237: @222411
     /* 222411 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222488), // Rule ID 7971 //
     /* 222416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222468 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222472 */     // MIs[2] Operand 1
     /* 222472 */     // No operand predicates
     /* 222472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222474 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222486 */     GIR_RootConstrainSelectedInstOperands,
     /* 222487 */     // GIR_Coverage, 7971,
     /* 222487 */     GIR_EraseRootFromParent_Done,
     /* 222488 */   // Label 4238: @222488
     /* 222488 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222565), // Rule ID 7972 //
     /* 222493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222549 */     // MIs[2] Operand 1
     /* 222549 */     // No operand predicates
     /* 222549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222563 */     GIR_RootConstrainSelectedInstOperands,
     /* 222564 */     // GIR_Coverage, 7972,
     /* 222564 */     GIR_EraseRootFromParent_Done,
     /* 222565 */   // Label 4239: @222565
     /* 222565 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222642), // Rule ID 7973 //
     /* 222570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222626 */     // MIs[2] Operand 1
     /* 222626 */     // No operand predicates
     /* 222626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222628 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222640 */     GIR_RootConstrainSelectedInstOperands,
     /* 222641 */     // GIR_Coverage, 7973,
     /* 222641 */     GIR_EraseRootFromParent_Done,
     /* 222642 */   // Label 4240: @222642
     /* 222642 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222719), // Rule ID 7974 //
     /* 222647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222703 */     // MIs[2] Operand 1
     /* 222703 */     // No operand predicates
     /* 222703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222717 */     GIR_RootConstrainSelectedInstOperands,
     /* 222718 */     // GIR_Coverage, 7974,
     /* 222718 */     GIR_EraseRootFromParent_Done,
     /* 222719 */   // Label 4241: @222719
     /* 222719 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222796), // Rule ID 7975 //
     /* 222724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222780 */     // MIs[2] Operand 1
     /* 222780 */     // No operand predicates
     /* 222780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222782 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222794 */     GIR_RootConstrainSelectedInstOperands,
     /* 222795 */     // GIR_Coverage, 7975,
     /* 222795 */     GIR_EraseRootFromParent_Done,
     /* 222796 */   // Label 4242: @222796
     /* 222796 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222873), // Rule ID 7976 //
     /* 222801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222857 */     // MIs[2] Operand 1
     /* 222857 */     // No operand predicates
     /* 222857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222859 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222871 */     GIR_RootConstrainSelectedInstOperands,
     /* 222872 */     // GIR_Coverage, 7976,
     /* 222872 */     GIR_EraseRootFromParent_Done,
     /* 222873 */   // Label 4243: @222873
     /* 222873 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(222950), // Rule ID 7977 //
     /* 222878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222934 */     // MIs[2] Operand 1
     /* 222934 */     // No operand predicates
     /* 222934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222936 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222948 */     GIR_RootConstrainSelectedInstOperands,
     /* 222949 */     // GIR_Coverage, 7977,
     /* 222949 */     GIR_EraseRootFromParent_Done,
     /* 222950 */   // Label 4244: @222950
     /* 222950 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(223027), // Rule ID 7978 //
     /* 222955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223011 */     // MIs[2] Operand 1
     /* 223011 */     // No operand predicates
     /* 223011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223013 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 223016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223025 */     GIR_RootConstrainSelectedInstOperands,
     /* 223026 */     // GIR_Coverage, 7978,
     /* 223026 */     GIR_EraseRootFromParent_Done,
     /* 223027 */   // Label 4245: @223027
     /* 223027 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(223104), // Rule ID 7979 //
     /* 223032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223088 */     // MIs[2] Operand 1
     /* 223088 */     // No operand predicates
     /* 223088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223102 */     GIR_RootConstrainSelectedInstOperands,
     /* 223103 */     // GIR_Coverage, 7979,
     /* 223103 */     GIR_EraseRootFromParent_Done,
     /* 223104 */   // Label 4246: @223104
     /* 223104 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(223181), // Rule ID 7980 //
     /* 223109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223165 */     // MIs[2] Operand 1
     /* 223165 */     // No operand predicates
     /* 223165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223167 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 223170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223179 */     GIR_RootConstrainSelectedInstOperands,
     /* 223180 */     // GIR_Coverage, 7980,
     /* 223180 */     GIR_EraseRootFromParent_Done,
     /* 223181 */   // Label 4247: @223181
     /* 223181 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223258), // Rule ID 7981 //
     /* 223186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223242 */     // MIs[2] Operand 1
     /* 223242 */     // No operand predicates
     /* 223242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223244 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 223247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223256 */     GIR_RootConstrainSelectedInstOperands,
     /* 223257 */     // GIR_Coverage, 7981,
     /* 223257 */     GIR_EraseRootFromParent_Done,
     /* 223258 */   // Label 4248: @223258
     /* 223258 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223335), // Rule ID 7982 //
     /* 223263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223319 */     // MIs[2] Operand 1
     /* 223319 */     // No operand predicates
     /* 223319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 223324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223333 */     GIR_RootConstrainSelectedInstOperands,
     /* 223334 */     // GIR_Coverage, 7982,
     /* 223334 */     GIR_EraseRootFromParent_Done,
     /* 223335 */   // Label 4249: @223335
     /* 223335 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223412), // Rule ID 7983 //
     /* 223340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223396 */     // MIs[2] Operand 1
     /* 223396 */     // No operand predicates
     /* 223396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223398 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223410 */     GIR_RootConstrainSelectedInstOperands,
     /* 223411 */     // GIR_Coverage, 7983,
     /* 223411 */     GIR_EraseRootFromParent_Done,
     /* 223412 */   // Label 4250: @223412
     /* 223412 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223489), // Rule ID 7984 //
     /* 223417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223473 */     // MIs[2] Operand 1
     /* 223473 */     // No operand predicates
     /* 223473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223487 */     GIR_RootConstrainSelectedInstOperands,
     /* 223488 */     // GIR_Coverage, 7984,
     /* 223488 */     GIR_EraseRootFromParent_Done,
     /* 223489 */   // Label 4251: @223489
     /* 223489 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223566), // Rule ID 7985 //
     /* 223494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223550 */     // MIs[2] Operand 1
     /* 223550 */     // No operand predicates
     /* 223550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223564 */     GIR_RootConstrainSelectedInstOperands,
     /* 223565 */     // GIR_Coverage, 7985,
     /* 223565 */     GIR_EraseRootFromParent_Done,
     /* 223566 */   // Label 4252: @223566
     /* 223566 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223643), // Rule ID 7986 //
     /* 223571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223627 */     // MIs[2] Operand 1
     /* 223627 */     // No operand predicates
     /* 223627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223629 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223641 */     GIR_RootConstrainSelectedInstOperands,
     /* 223642 */     // GIR_Coverage, 7986,
     /* 223642 */     GIR_EraseRootFromParent_Done,
     /* 223643 */   // Label 4253: @223643
     /* 223643 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223720), // Rule ID 7987 //
     /* 223648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223704 */     // MIs[2] Operand 1
     /* 223704 */     // No operand predicates
     /* 223704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223706 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223718 */     GIR_RootConstrainSelectedInstOperands,
     /* 223719 */     // GIR_Coverage, 7987,
     /* 223719 */     GIR_EraseRootFromParent_Done,
     /* 223720 */   // Label 4254: @223720
     /* 223720 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223797), // Rule ID 7988 //
     /* 223725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223781 */     // MIs[2] Operand 1
     /* 223781 */     // No operand predicates
     /* 223781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223783 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223795 */     GIR_RootConstrainSelectedInstOperands,
     /* 223796 */     // GIR_Coverage, 7988,
     /* 223796 */     GIR_EraseRootFromParent_Done,
     /* 223797 */   // Label 4255: @223797
     /* 223797 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223874), // Rule ID 7989 //
     /* 223802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223858 */     // MIs[2] Operand 1
     /* 223858 */     // No operand predicates
     /* 223858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223872 */     GIR_RootConstrainSelectedInstOperands,
     /* 223873 */     // GIR_Coverage, 7989,
     /* 223873 */     GIR_EraseRootFromParent_Done,
     /* 223874 */   // Label 4256: @223874
     /* 223874 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(223951), // Rule ID 7990 //
     /* 223879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223935 */     // MIs[2] Operand 1
     /* 223935 */     // No operand predicates
     /* 223935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223937 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223949 */     GIR_RootConstrainSelectedInstOperands,
     /* 223950 */     // GIR_Coverage, 7990,
     /* 223950 */     GIR_EraseRootFromParent_Done,
     /* 223951 */   // Label 4257: @223951
     /* 223951 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(224028), // Rule ID 7991 //
     /* 223956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224012 */     // MIs[2] Operand 1
     /* 224012 */     // No operand predicates
     /* 224012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 224017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224026 */     GIR_RootConstrainSelectedInstOperands,
     /* 224027 */     // GIR_Coverage, 7991,
     /* 224027 */     GIR_EraseRootFromParent_Done,
     /* 224028 */   // Label 4258: @224028
     /* 224028 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(224105), // Rule ID 7992 //
     /* 224033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 224041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224085 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224089 */     // MIs[2] Operand 1
     /* 224089 */     // No operand predicates
     /* 224089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224091 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 224094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224103 */     GIR_RootConstrainSelectedInstOperands,
     /* 224104 */     // GIR_Coverage, 7992,
     /* 224104 */     GIR_EraseRootFromParent_Done,
     /* 224105 */   // Label 4259: @224105
     /* 224105 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(224182), // Rule ID 7993 //
     /* 224110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 224118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224162 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224166 */     // MIs[2] Operand 1
     /* 224166 */     // No operand predicates
     /* 224166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224168 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 224171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224180 */     GIR_RootConstrainSelectedInstOperands,
     /* 224181 */     // GIR_Coverage, 7993,
     /* 224181 */     GIR_EraseRootFromParent_Done,
     /* 224182 */   // Label 4260: @224182
     /* 224182 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(224259), // Rule ID 7994 //
     /* 224187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 224195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224239 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224243 */     // MIs[2] Operand 1
     /* 224243 */     // No operand predicates
     /* 224243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224245 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 224248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224257 */     GIR_RootConstrainSelectedInstOperands,
     /* 224258 */     // GIR_Coverage, 7994,
     /* 224258 */     GIR_EraseRootFromParent_Done,
     /* 224259 */   // Label 4261: @224259
     /* 224259 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(224336), // Rule ID 7995 //
     /* 224264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224316 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224320 */     // MIs[2] Operand 1
     /* 224320 */     // No operand predicates
     /* 224320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224322 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 224325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224334 */     GIR_RootConstrainSelectedInstOperands,
     /* 224335 */     // GIR_Coverage, 7995,
     /* 224335 */     GIR_EraseRootFromParent_Done,
     /* 224336 */   // Label 4262: @224336
     /* 224336 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(224413), // Rule ID 7996 //
     /* 224341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224393 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224397 */     // MIs[2] Operand 1
     /* 224397 */     // No operand predicates
     /* 224397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224399 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 224402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224411 */     GIR_RootConstrainSelectedInstOperands,
     /* 224412 */     // GIR_Coverage, 7996,
     /* 224412 */     GIR_EraseRootFromParent_Done,
     /* 224413 */   // Label 4263: @224413
     /* 224413 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224490), // Rule ID 7997 //
     /* 224418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224470 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224474 */     // MIs[2] Operand 1
     /* 224474 */     // No operand predicates
     /* 224474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224488 */     GIR_RootConstrainSelectedInstOperands,
     /* 224489 */     // GIR_Coverage, 7997,
     /* 224489 */     GIR_EraseRootFromParent_Done,
     /* 224490 */   // Label 4264: @224490
     /* 224490 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224567), // Rule ID 7998 //
     /* 224495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224547 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224551 */     // MIs[2] Operand 1
     /* 224551 */     // No operand predicates
     /* 224551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224553 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224565 */     GIR_RootConstrainSelectedInstOperands,
     /* 224566 */     // GIR_Coverage, 7998,
     /* 224566 */     GIR_EraseRootFromParent_Done,
     /* 224567 */   // Label 4265: @224567
     /* 224567 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224644), // Rule ID 7999 //
     /* 224572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224624 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224628 */     // MIs[2] Operand 1
     /* 224628 */     // No operand predicates
     /* 224628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224642 */     GIR_RootConstrainSelectedInstOperands,
     /* 224643 */     // GIR_Coverage, 7999,
     /* 224643 */     GIR_EraseRootFromParent_Done,
     /* 224644 */   // Label 4266: @224644
     /* 224644 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224721), // Rule ID 8000 //
     /* 224649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224701 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224705 */     // MIs[2] Operand 1
     /* 224705 */     // No operand predicates
     /* 224705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224707 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224719 */     GIR_RootConstrainSelectedInstOperands,
     /* 224720 */     // GIR_Coverage, 8000,
     /* 224720 */     GIR_EraseRootFromParent_Done,
     /* 224721 */   // Label 4267: @224721
     /* 224721 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224798), // Rule ID 8001 //
     /* 224726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224778 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224782 */     // MIs[2] Operand 1
     /* 224782 */     // No operand predicates
     /* 224782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224784 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224796 */     GIR_RootConstrainSelectedInstOperands,
     /* 224797 */     // GIR_Coverage, 8001,
     /* 224797 */     GIR_EraseRootFromParent_Done,
     /* 224798 */   // Label 4268: @224798
     /* 224798 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224875), // Rule ID 8002 //
     /* 224803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224855 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224859 */     // MIs[2] Operand 1
     /* 224859 */     // No operand predicates
     /* 224859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224873 */     GIR_RootConstrainSelectedInstOperands,
     /* 224874 */     // GIR_Coverage, 8002,
     /* 224874 */     GIR_EraseRootFromParent_Done,
     /* 224875 */   // Label 4269: @224875
     /* 224875 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224952), // Rule ID 8003 //
     /* 224880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224932 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224936 */     // MIs[2] Operand 1
     /* 224936 */     // No operand predicates
     /* 224936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224950 */     GIR_RootConstrainSelectedInstOperands,
     /* 224951 */     // GIR_Coverage, 8003,
     /* 224951 */     GIR_EraseRootFromParent_Done,
     /* 224952 */   // Label 4270: @224952
     /* 224952 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(225029), // Rule ID 8004 //
     /* 224957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225009 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225013 */     // MIs[2] Operand 1
     /* 225013 */     // No operand predicates
     /* 225013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225015 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 225018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225027 */     GIR_RootConstrainSelectedInstOperands,
     /* 225028 */     // GIR_Coverage, 8004,
     /* 225028 */     GIR_EraseRootFromParent_Done,
     /* 225029 */   // Label 4271: @225029
     /* 225029 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(225106), // Rule ID 8005 //
     /* 225034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 225042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225086 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225090 */     // MIs[2] Operand 1
     /* 225090 */     // No operand predicates
     /* 225090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 225092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 225095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225104 */     GIR_RootConstrainSelectedInstOperands,
     /* 225105 */     // GIR_Coverage, 8005,
     /* 225105 */     GIR_EraseRootFromParent_Done,
     /* 225106 */   // Label 4272: @225106
     /* 225106 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(225183), // Rule ID 8006 //
     /* 225111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 225119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225163 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225167 */     // MIs[2] Operand 1
     /* 225167 */     // No operand predicates
     /* 225167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225169 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 225172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225181 */     GIR_RootConstrainSelectedInstOperands,
     /* 225182 */     // GIR_Coverage, 8006,
     /* 225182 */     GIR_EraseRootFromParent_Done,
     /* 225183 */   // Label 4273: @225183
     /* 225183 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(225239), // Rule ID 55 //
     /* 225188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 225191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 225196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 225199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 225202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 225205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225213 */     // MIs[0] Operand 3
     /* 225213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 225224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225228 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 225231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225237 */     GIR_RootConstrainSelectedInstOperands,
     /* 225238 */     // GIR_Coverage, 55,
     /* 225238 */     GIR_EraseRootFromParent_Done,
     /* 225239 */   // Label 4274: @225239
     /* 225239 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(225295), // Rule ID 56 //
     /* 225244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 225247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 225252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 225255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 225258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 225261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225269 */     // MIs[0] Operand 3
     /* 225269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 225280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225284 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 225287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225293 */     GIR_RootConstrainSelectedInstOperands,
     /* 225294 */     // GIR_Coverage, 56,
     /* 225294 */     GIR_EraseRootFromParent_Done,
     /* 225295 */   // Label 4275: @225295
     /* 225295 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(225351), // Rule ID 57 //
     /* 225300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 225303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 225308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 225311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 225314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 225317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225325 */     // MIs[0] Operand 3
     /* 225325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 225336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225340 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 225343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225349 */     GIR_RootConstrainSelectedInstOperands,
     /* 225350 */     // GIR_Coverage, 57,
     /* 225350 */     GIR_EraseRootFromParent_Done,
     /* 225351 */   // Label 4276: @225351
     /* 225351 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(225407), // Rule ID 58 //
     /* 225356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 225359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 225364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 225367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 225370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 225373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 225381 */     // MIs[0] Operand 3
     /* 225381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 225392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225396 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 225399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225405 */     GIR_RootConstrainSelectedInstOperands,
     /* 225406 */     // GIR_Coverage, 58,
     /* 225406 */     GIR_EraseRootFromParent_Done,
     /* 225407 */   // Label 4277: @225407
     /* 225407 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(225462), // Rule ID 2799 //
     /* 225412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225441 */     // MIs[0] imm
     /* 225441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225449 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1552:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 225452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225458 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225460 */     GIR_RootConstrainSelectedInstOperands,
     /* 225461 */     // GIR_Coverage, 2799,
     /* 225461 */     GIR_EraseRootFromParent_Done,
     /* 225462 */   // Label 4278: @225462
     /* 225462 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225517), // Rule ID 2800 //
     /* 225467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225496 */     // MIs[0] imm
     /* 225496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1552:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 225507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225513 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225515 */     GIR_RootConstrainSelectedInstOperands,
     /* 225516 */     // GIR_Coverage, 2800,
     /* 225516 */     GIR_EraseRootFromParent_Done,
     /* 225517 */   // Label 4279: @225517
     /* 225517 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225572), // Rule ID 2801 //
     /* 225522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225551 */     // MIs[0] imm
     /* 225551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225559 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 225562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225568 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225570 */     GIR_RootConstrainSelectedInstOperands,
     /* 225571 */     // GIR_Coverage, 2801,
     /* 225571 */     GIR_EraseRootFromParent_Done,
     /* 225572 */   // Label 4280: @225572
     /* 225572 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225627), // Rule ID 3579 //
     /* 225577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225606 */     // MIs[0] Idx
     /* 225606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 225614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 225614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 225617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225625 */     GIR_RootConstrainSelectedInstOperands,
     /* 225626 */     // GIR_Coverage, 3579,
     /* 225626 */     GIR_EraseRootFromParent_Done,
     /* 225627 */   // Label 4281: @225627
     /* 225627 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225682), // Rule ID 3580 //
     /* 225632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225661 */     // MIs[0] Idx
     /* 225661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 225669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 225669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 225672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225680 */     GIR_RootConstrainSelectedInstOperands,
     /* 225681 */     // GIR_Coverage, 3580,
     /* 225681 */     GIR_EraseRootFromParent_Done,
     /* 225682 */   // Label 4282: @225682
     /* 225682 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225737), // Rule ID 3581 //
     /* 225687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225716 */     // MIs[0] Idx
     /* 225716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 225724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 225724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 225727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225735 */     GIR_RootConstrainSelectedInstOperands,
     /* 225736 */     // GIR_Coverage, 3581,
     /* 225736 */     GIR_EraseRootFromParent_Done,
     /* 225737 */   // Label 4283: @225737
     /* 225737 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225792), // Rule ID 3877 //
     /* 225742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 225745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 225750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 225753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 225759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225771 */     // MIs[0] imm
     /* 225771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 225779 */     // (intrinsic_wo_chain:{ *:[v2i64] } 553:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 225779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 225782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 225784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 225788 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225790 */     GIR_RootConstrainSelectedInstOperands,
     /* 225791 */     // GIR_Coverage, 3877,
     /* 225791 */     GIR_EraseRootFromParent_Done,
     /* 225792 */   // Label 4284: @225792
     /* 225792 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225839), // Rule ID 2862 //
     /* 225797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225818 */     // MIs[0] idx
     /* 225818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225826 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 225826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 225829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225835 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225837 */     GIR_RootConstrainSelectedInstOperands,
     /* 225838 */     // GIR_Coverage, 2862,
     /* 225838 */     GIR_EraseRootFromParent_Done,
     /* 225839 */   // Label 4285: @225839
     /* 225839 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225886), // Rule ID 2866 //
     /* 225844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225865 */     // MIs[0] idx
     /* 225865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225873 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 225873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 225876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225882 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225884 */     GIR_RootConstrainSelectedInstOperands,
     /* 225885 */     // GIR_Coverage, 2866,
     /* 225885 */     GIR_EraseRootFromParent_Done,
     /* 225886 */   // Label 4286: @225886
     /* 225886 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225933), // Rule ID 2870 //
     /* 225891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225912 */     // MIs[0] idx
     /* 225912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225920 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 225920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 225923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225929 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225931 */     GIR_RootConstrainSelectedInstOperands,
     /* 225932 */     // GIR_Coverage, 2870,
     /* 225932 */     GIR_EraseRootFromParent_Done,
     /* 225933 */   // Label 4287: @225933
     /* 225933 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225980), // Rule ID 3019 //
     /* 225938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225959 */     // MIs[0] Op3
     /* 225959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1619:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 225970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225978 */     GIR_RootConstrainSelectedInstOperands,
     /* 225979 */     // GIR_Coverage, 3019,
     /* 225979 */     GIR_EraseRootFromParent_Done,
     /* 225980 */   // Label 4288: @225980
     /* 225980 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(226027), // Rule ID 3020 //
     /* 225985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226006 */     // MIs[0] Op3
     /* 226006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1619:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 226017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226025 */     GIR_RootConstrainSelectedInstOperands,
     /* 226026 */     // GIR_Coverage, 3020,
     /* 226026 */     GIR_EraseRootFromParent_Done,
     /* 226027 */   // Label 4289: @226027
     /* 226027 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(226074), // Rule ID 3021 //
     /* 226032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 226040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226053 */     // MIs[0] Op3
     /* 226053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1619:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 226064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226072 */     GIR_RootConstrainSelectedInstOperands,
     /* 226073 */     // GIR_Coverage, 3021,
     /* 226073 */     GIR_EraseRootFromParent_Done,
     /* 226074 */   // Label 4290: @226074
     /* 226074 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(226121), // Rule ID 3022 //
     /* 226079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 226087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226100 */     // MIs[0] Op3
     /* 226100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 226111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226119 */     GIR_RootConstrainSelectedInstOperands,
     /* 226120 */     // GIR_Coverage, 3022,
     /* 226120 */     GIR_EraseRootFromParent_Done,
     /* 226121 */   // Label 4291: @226121
     /* 226121 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226168), // Rule ID 3023 //
     /* 226126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 226134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226147 */     // MIs[0] Op3
     /* 226147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 226158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226166 */     GIR_RootConstrainSelectedInstOperands,
     /* 226167 */     // GIR_Coverage, 3023,
     /* 226167 */     GIR_EraseRootFromParent_Done,
     /* 226168 */   // Label 4292: @226168
     /* 226168 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226215), // Rule ID 3071 //
     /* 226173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 226181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226194 */     // MIs[0] Op3
     /* 226194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 226205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226213 */     GIR_RootConstrainSelectedInstOperands,
     /* 226214 */     // GIR_Coverage, 3071,
     /* 226214 */     GIR_EraseRootFromParent_Done,
     /* 226215 */   // Label 4293: @226215
     /* 226215 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226262), // Rule ID 3073 //
     /* 226220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 226228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226241 */     // MIs[0] Op3
     /* 226241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 226252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226260 */     GIR_RootConstrainSelectedInstOperands,
     /* 226261 */     // GIR_Coverage, 3073,
     /* 226261 */     GIR_EraseRootFromParent_Done,
     /* 226262 */   // Label 4294: @226262
     /* 226262 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226309), // Rule ID 3075 //
     /* 226267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 226275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226288 */     // MIs[0] Op3
     /* 226288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 226299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226307 */     GIR_RootConstrainSelectedInstOperands,
     /* 226308 */     // GIR_Coverage, 3075,
     /* 226308 */     GIR_EraseRootFromParent_Done,
     /* 226309 */   // Label 4295: @226309
     /* 226309 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226356), // Rule ID 3077 //
     /* 226314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 226322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226335 */     // MIs[0] Op3
     /* 226335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 226346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226354 */     GIR_RootConstrainSelectedInstOperands,
     /* 226355 */     // GIR_Coverage, 3077,
     /* 226355 */     GIR_EraseRootFromParent_Done,
     /* 226356 */   // Label 4296: @226356
     /* 226356 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226403), // Rule ID 3099 //
     /* 226361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226382 */     // MIs[0] Op3
     /* 226382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 226393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226401 */     GIR_RootConstrainSelectedInstOperands,
     /* 226402 */     // GIR_Coverage, 3099,
     /* 226402 */     GIR_EraseRootFromParent_Done,
     /* 226403 */   // Label 4297: @226403
     /* 226403 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226450), // Rule ID 3100 //
     /* 226408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226429 */     // MIs[0] Op3
     /* 226429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 226440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226448 */     GIR_RootConstrainSelectedInstOperands,
     /* 226449 */     // GIR_Coverage, 3100,
     /* 226449 */     GIR_EraseRootFromParent_Done,
     /* 226450 */   // Label 4298: @226450
     /* 226450 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226497), // Rule ID 3101 //
     /* 226455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226476 */     // MIs[0] Op3
     /* 226476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 226487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226495 */     GIR_RootConstrainSelectedInstOperands,
     /* 226496 */     // GIR_Coverage, 3101,
     /* 226496 */     GIR_EraseRootFromParent_Done,
     /* 226497 */   // Label 4299: @226497
     /* 226497 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226544), // Rule ID 3174 //
     /* 226502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226523 */     // MIs[0] Op3
     /* 226523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 226534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226542 */     GIR_RootConstrainSelectedInstOperands,
     /* 226543 */     // GIR_Coverage, 3174,
     /* 226543 */     GIR_EraseRootFromParent_Done,
     /* 226544 */   // Label 4300: @226544
     /* 226544 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226591), // Rule ID 3175 //
     /* 226549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226570 */     // MIs[0] Op3
     /* 226570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 226581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226589 */     GIR_RootConstrainSelectedInstOperands,
     /* 226590 */     // GIR_Coverage, 3175,
     /* 226590 */     GIR_EraseRootFromParent_Done,
     /* 226591 */   // Label 4301: @226591
     /* 226591 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226638), // Rule ID 3176 //
     /* 226596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226617 */     // MIs[0] Op3
     /* 226617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226636 */     GIR_RootConstrainSelectedInstOperands,
     /* 226637 */     // GIR_Coverage, 3176,
     /* 226637 */     GIR_EraseRootFromParent_Done,
     /* 226638 */   // Label 4302: @226638
     /* 226638 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(226685), // Rule ID 3177 //
     /* 226643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226664 */     // MIs[0] Op3
     /* 226664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2157:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 226675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226683 */     GIR_RootConstrainSelectedInstOperands,
     /* 226684 */     // GIR_Coverage, 3177,
     /* 226684 */     GIR_EraseRootFromParent_Done,
     /* 226685 */   // Label 4303: @226685
     /* 226685 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(226732), // Rule ID 3564 //
     /* 226690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 226693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 226698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226711 */     // MIs[0] Op3
     /* 226711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 226719 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1367:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 226719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 226722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226730 */     GIR_RootConstrainSelectedInstOperands,
     /* 226731 */     // GIR_Coverage, 3564,
     /* 226731 */     GIR_EraseRootFromParent_Done,
     /* 226732 */   // Label 4304: @226732
     /* 226732 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(226779), // Rule ID 3612 //
     /* 226737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226758 */     // MIs[0] Op3
     /* 226758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 226769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226777 */     GIR_RootConstrainSelectedInstOperands,
     /* 226778 */     // GIR_Coverage, 3612,
     /* 226778 */     GIR_EraseRootFromParent_Done,
     /* 226779 */   // Label 4305: @226779
     /* 226779 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(226826), // Rule ID 3613 //
     /* 226784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226805 */     // MIs[0] Op3
     /* 226805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226813 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226824 */     GIR_RootConstrainSelectedInstOperands,
     /* 226825 */     // GIR_Coverage, 3613,
     /* 226825 */     GIR_EraseRootFromParent_Done,
     /* 226826 */   // Label 4306: @226826
     /* 226826 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226873), // Rule ID 3614 //
     /* 226831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226852 */     // MIs[0] Op3
     /* 226852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226871 */     GIR_RootConstrainSelectedInstOperands,
     /* 226872 */     // GIR_Coverage, 3614,
     /* 226872 */     GIR_EraseRootFromParent_Done,
     /* 226873 */   // Label 4307: @226873
     /* 226873 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226920), // Rule ID 3615 //
     /* 226878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226899 */     // MIs[0] Op3
     /* 226899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 226907 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 226907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 226910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226918 */     GIR_RootConstrainSelectedInstOperands,
     /* 226919 */     // GIR_Coverage, 3615,
     /* 226919 */     GIR_EraseRootFromParent_Done,
     /* 226920 */   // Label 4308: @226920
     /* 226920 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226967), // Rule ID 3616 //
     /* 226925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226946 */     // MIs[0] Op3
     /* 226946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226965 */     GIR_RootConstrainSelectedInstOperands,
     /* 226966 */     // GIR_Coverage, 3616,
     /* 226966 */     GIR_EraseRootFromParent_Done,
     /* 226967 */   // Label 4309: @226967
     /* 226967 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(227014), // Rule ID 3617 //
     /* 226972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasNonStreamingSVE2_or_SME2),
     /* 226975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226993 */     // MIs[0] Op3
     /* 226993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 227001 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 227001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 227004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227012 */     GIR_RootConstrainSelectedInstOperands,
     /* 227013 */     // GIR_Coverage, 3617,
     /* 227013 */     GIR_EraseRootFromParent_Done,
     /* 227014 */   // Label 4310: @227014
     /* 227014 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(227061), // Rule ID 11450 //
     /* 227019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 227027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227040 */     // MIs[0] Op3
     /* 227040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1806:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 227051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227059 */     GIR_RootConstrainSelectedInstOperands,
     /* 227060 */     // GIR_Coverage, 11450,
     /* 227060 */     GIR_EraseRootFromParent_Done,
     /* 227061 */   // Label 4311: @227061
     /* 227061 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227108), // Rule ID 11451 //
     /* 227066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 227074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227087 */     // MIs[0] Op3
     /* 227087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1806:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 227098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227106 */     GIR_RootConstrainSelectedInstOperands,
     /* 227107 */     // GIR_Coverage, 11451,
     /* 227107 */     GIR_EraseRootFromParent_Done,
     /* 227108 */   // Label 4312: @227108
     /* 227108 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227155), // Rule ID 11452 //
     /* 227113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 227121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227134 */     // MIs[0] Op3
     /* 227134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1806:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 227142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 227145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227153 */     GIR_RootConstrainSelectedInstOperands,
     /* 227154 */     // GIR_Coverage, 11452,
     /* 227154 */     GIR_EraseRootFromParent_Done,
     /* 227155 */   // Label 4313: @227155
     /* 227155 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227202), // Rule ID 11453 //
     /* 227160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 227168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227181 */     // MIs[0] Op3
     /* 227181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 227192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227200 */     GIR_RootConstrainSelectedInstOperands,
     /* 227201 */     // GIR_Coverage, 11453,
     /* 227201 */     GIR_EraseRootFromParent_Done,
     /* 227202 */   // Label 4314: @227202
     /* 227202 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227249), // Rule ID 11454 //
     /* 227207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 227215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227228 */     // MIs[0] Op3
     /* 227228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 227239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227247 */     GIR_RootConstrainSelectedInstOperands,
     /* 227248 */     // GIR_Coverage, 11454,
     /* 227248 */     GIR_EraseRootFromParent_Done,
     /* 227249 */   // Label 4315: @227249
     /* 227249 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227296), // Rule ID 11455 //
     /* 227254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 227262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227275 */     // MIs[0] Op3
     /* 227275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 227283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 227286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227294 */     GIR_RootConstrainSelectedInstOperands,
     /* 227295 */     // GIR_Coverage, 11455,
     /* 227295 */     GIR_EraseRootFromParent_Done,
     /* 227296 */   // Label 4316: @227296
     /* 227296 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227343), // Rule ID 11478 //
     /* 227301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 227309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227322 */     // MIs[0] Op3
     /* 227322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 227333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227341 */     GIR_RootConstrainSelectedInstOperands,
     /* 227342 */     // GIR_Coverage, 11478,
     /* 227342 */     GIR_EraseRootFromParent_Done,
     /* 227343 */   // Label 4317: @227343
     /* 227343 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227390), // Rule ID 11479 //
     /* 227348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 227356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227369 */     // MIs[0] Op3
     /* 227369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 227380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227388 */     GIR_RootConstrainSelectedInstOperands,
     /* 227389 */     // GIR_Coverage, 11479,
     /* 227389 */     GIR_EraseRootFromParent_Done,
     /* 227390 */   // Label 4318: @227390
     /* 227390 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227437), // Rule ID 11480 //
     /* 227395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227416 */     // MIs[0] Op3
     /* 227416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 227427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227435 */     GIR_RootConstrainSelectedInstOperands,
     /* 227436 */     // GIR_Coverage, 11480,
     /* 227436 */     GIR_EraseRootFromParent_Done,
     /* 227437 */   // Label 4319: @227437
     /* 227437 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227484), // Rule ID 11481 //
     /* 227442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227463 */     // MIs[0] Op3
     /* 227463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 227474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227482 */     GIR_RootConstrainSelectedInstOperands,
     /* 227483 */     // GIR_Coverage, 11481,
     /* 227483 */     GIR_EraseRootFromParent_Done,
     /* 227484 */   // Label 4320: @227484
     /* 227484 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227531), // Rule ID 11482 //
     /* 227489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227510 */     // MIs[0] Op3
     /* 227510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2005:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 227521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227529 */     GIR_RootConstrainSelectedInstOperands,
     /* 227530 */     // GIR_Coverage, 11482,
     /* 227530 */     GIR_EraseRootFromParent_Done,
     /* 227531 */   // Label 4321: @227531
     /* 227531 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(227578), // Rule ID 11483 //
     /* 227536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227557 */     // MIs[0] Op3
     /* 227557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2005:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 227568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227576 */     GIR_RootConstrainSelectedInstOperands,
     /* 227577 */     // GIR_Coverage, 11483,
     /* 227577 */     GIR_EraseRootFromParent_Done,
     /* 227578 */   // Label 4322: @227578
     /* 227578 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(227625), // Rule ID 11484 //
     /* 227583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227604 */     // MIs[0] Op3
     /* 227604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 227615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227623 */     GIR_RootConstrainSelectedInstOperands,
     /* 227624 */     // GIR_Coverage, 11484,
     /* 227624 */     GIR_EraseRootFromParent_Done,
     /* 227625 */   // Label 4323: @227625
     /* 227625 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(227672), // Rule ID 11485 //
     /* 227630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227651 */     // MIs[0] Op3
     /* 227651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227659 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 227662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227670 */     GIR_RootConstrainSelectedInstOperands,
     /* 227671 */     // GIR_Coverage, 11485,
     /* 227671 */     GIR_EraseRootFromParent_Done,
     /* 227672 */   // Label 4324: @227672
     /* 227672 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(227719), // Rule ID 11486 //
     /* 227677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227698 */     // MIs[0] Op3
     /* 227698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 227709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227717 */     GIR_RootConstrainSelectedInstOperands,
     /* 227718 */     // GIR_Coverage, 11486,
     /* 227718 */     GIR_EraseRootFromParent_Done,
     /* 227719 */   // Label 4325: @227719
     /* 227719 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(227766), // Rule ID 11487 //
     /* 227724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227745 */     // MIs[0] Op3
     /* 227745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 227756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227764 */     GIR_RootConstrainSelectedInstOperands,
     /* 227765 */     // GIR_Coverage, 11487,
     /* 227765 */     GIR_EraseRootFromParent_Done,
     /* 227766 */   // Label 4326: @227766
     /* 227766 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(227813), // Rule ID 11731 //
     /* 227771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227792 */     // MIs[0] Op3
     /* 227792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1872:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 227803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227811 */     GIR_RootConstrainSelectedInstOperands,
     /* 227812 */     // GIR_Coverage, 11731,
     /* 227812 */     GIR_EraseRootFromParent_Done,
     /* 227813 */   // Label 4327: @227813
     /* 227813 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227860), // Rule ID 11732 //
     /* 227818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227839 */     // MIs[0] Op3
     /* 227839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227847 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 227850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227858 */     GIR_RootConstrainSelectedInstOperands,
     /* 227859 */     // GIR_Coverage, 11732,
     /* 227859 */     GIR_EraseRootFromParent_Done,
     /* 227860 */   // Label 4328: @227860
     /* 227860 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227907), // Rule ID 11733 //
     /* 227865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227886 */     // MIs[0] Op3
     /* 227886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 227897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227905 */     GIR_RootConstrainSelectedInstOperands,
     /* 227906 */     // GIR_Coverage, 11733,
     /* 227906 */     GIR_EraseRootFromParent_Done,
     /* 227907 */   // Label 4329: @227907
     /* 227907 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227954), // Rule ID 11734 //
     /* 227912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227933 */     // MIs[0] Op3
     /* 227933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 227944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227952 */     GIR_RootConstrainSelectedInstOperands,
     /* 227953 */     // GIR_Coverage, 11734,
     /* 227953 */     GIR_EraseRootFromParent_Done,
     /* 227954 */   // Label 4330: @227954
     /* 227954 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(228001), // Rule ID 11735 //
     /* 227959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227980 */     // MIs[0] Op3
     /* 227980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 227991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227999 */     GIR_RootConstrainSelectedInstOperands,
     /* 228000 */     // GIR_Coverage, 11735,
     /* 228000 */     GIR_EraseRootFromParent_Done,
     /* 228001 */   // Label 4331: @228001
     /* 228001 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(228048), // Rule ID 11737 //
     /* 228006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 228014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228027 */     // MIs[0] Op3
     /* 228027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228035 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 228038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228046 */     GIR_RootConstrainSelectedInstOperands,
     /* 228047 */     // GIR_Coverage, 11737,
     /* 228047 */     GIR_EraseRootFromParent_Done,
     /* 228048 */   // Label 4332: @228048
     /* 228048 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(228095), // Rule ID 11739 //
     /* 228053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 228061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228074 */     // MIs[0] Op3
     /* 228074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 228085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228093 */     GIR_RootConstrainSelectedInstOperands,
     /* 228094 */     // GIR_Coverage, 11739,
     /* 228094 */     GIR_EraseRootFromParent_Done,
     /* 228095 */   // Label 4333: @228095
     /* 228095 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228142), // Rule ID 11741 //
     /* 228100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 228108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228121 */     // MIs[0] Op3
     /* 228121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 228132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228140 */     GIR_RootConstrainSelectedInstOperands,
     /* 228141 */     // GIR_Coverage, 11741,
     /* 228141 */     GIR_EraseRootFromParent_Done,
     /* 228142 */   // Label 4334: @228142
     /* 228142 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228189), // Rule ID 11743 //
     /* 228147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 228155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228168 */     // MIs[0] Op3
     /* 228168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 228176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 228176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 228179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228187 */     GIR_RootConstrainSelectedInstOperands,
     /* 228188 */     // GIR_Coverage, 11743,
     /* 228188 */     GIR_EraseRootFromParent_Done,
     /* 228189 */   // Label 4335: @228189
     /* 228189 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228236), // Rule ID 11744 //
     /* 228194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 228202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228215 */     // MIs[0] Op3
     /* 228215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 228223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 228223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 228226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228234 */     GIR_RootConstrainSelectedInstOperands,
     /* 228235 */     // GIR_Coverage, 11744,
     /* 228235 */     GIR_EraseRootFromParent_Done,
     /* 228236 */   // Label 4336: @228236
     /* 228236 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228283), // Rule ID 11745 //
     /* 228241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 228249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228262 */     // MIs[0] Op3
     /* 228262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 228270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 228270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 228273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228281 */     GIR_RootConstrainSelectedInstOperands,
     /* 228282 */     // GIR_Coverage, 11745,
     /* 228282 */     GIR_EraseRootFromParent_Done,
     /* 228283 */   // Label 4337: @228283
     /* 228283 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228330), // Rule ID 11746 //
     /* 228288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 228296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228309 */     // MIs[0] Op3
     /* 228309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 228317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 228317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 228320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228328 */     GIR_RootConstrainSelectedInstOperands,
     /* 228329 */     // GIR_Coverage, 11746,
     /* 228329 */     GIR_EraseRootFromParent_Done,
     /* 228330 */   // Label 4338: @228330
     /* 228330 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228377), // Rule ID 11833 //
     /* 228335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228356 */     // MIs[0] Op3
     /* 228356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2072:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 228367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228375 */     GIR_RootConstrainSelectedInstOperands,
     /* 228376 */     // GIR_Coverage, 11833,
     /* 228376 */     GIR_EraseRootFromParent_Done,
     /* 228377 */   // Label 4339: @228377
     /* 228377 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228424), // Rule ID 11835 //
     /* 228382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228403 */     // MIs[0] Op3
     /* 228403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228411 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 228414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228422 */     GIR_RootConstrainSelectedInstOperands,
     /* 228423 */     // GIR_Coverage, 11835,
     /* 228423 */     GIR_EraseRootFromParent_Done,
     /* 228424 */   // Label 4340: @228424
     /* 228424 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228471), // Rule ID 11837 //
     /* 228429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228450 */     // MIs[0] Op3
     /* 228450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 228461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228469 */     GIR_RootConstrainSelectedInstOperands,
     /* 228470 */     // GIR_Coverage, 11837,
     /* 228470 */     GIR_EraseRootFromParent_Done,
     /* 228471 */   // Label 4341: @228471
     /* 228471 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228518), // Rule ID 11839 //
     /* 228476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228497 */     // MIs[0] Op3
     /* 228497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 228508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228516 */     GIR_RootConstrainSelectedInstOperands,
     /* 228517 */     // GIR_Coverage, 11839,
     /* 228517 */     GIR_EraseRootFromParent_Done,
     /* 228518 */   // Label 4342: @228518
     /* 228518 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228565), // Rule ID 11841 //
     /* 228523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228544 */     // MIs[0] Op3
     /* 228544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 228555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228563 */     GIR_RootConstrainSelectedInstOperands,
     /* 228564 */     // GIR_Coverage, 11841,
     /* 228564 */     GIR_EraseRootFromParent_Done,
     /* 228565 */   // Label 4343: @228565
     /* 228565 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(228612), // Rule ID 11842 //
     /* 228570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228591 */     // MIs[0] Op3
     /* 228591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 228602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228610 */     GIR_RootConstrainSelectedInstOperands,
     /* 228611 */     // GIR_Coverage, 11842,
     /* 228611 */     GIR_EraseRootFromParent_Done,
     /* 228612 */   // Label 4344: @228612
     /* 228612 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(228659), // Rule ID 11843 //
     /* 228617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228638 */     // MIs[0] Op3
     /* 228638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 228649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228657 */     GIR_RootConstrainSelectedInstOperands,
     /* 228658 */     // GIR_Coverage, 11843,
     /* 228658 */     GIR_EraseRootFromParent_Done,
     /* 228659 */   // Label 4345: @228659
     /* 228659 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(228706), // Rule ID 11844 //
     /* 228664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228685 */     // MIs[0] Op3
     /* 228685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 228696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228704 */     GIR_RootConstrainSelectedInstOperands,
     /* 228705 */     // GIR_Coverage, 11844,
     /* 228705 */     GIR_EraseRootFromParent_Done,
     /* 228706 */   // Label 4346: @228706
     /* 228706 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(228753), // Rule ID 11849 //
     /* 228711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228732 */     // MIs[0] Op3
     /* 228732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 228743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228751 */     GIR_RootConstrainSelectedInstOperands,
     /* 228752 */     // GIR_Coverage, 11849,
     /* 228752 */     GIR_EraseRootFromParent_Done,
     /* 228753 */   // Label 4347: @228753
     /* 228753 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(228800), // Rule ID 11850 //
     /* 228758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228779 */     // MIs[0] Op3
     /* 228779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 228790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228798 */     GIR_RootConstrainSelectedInstOperands,
     /* 228799 */     // GIR_Coverage, 11850,
     /* 228799 */     GIR_EraseRootFromParent_Done,
     /* 228800 */   // Label 4348: @228800
     /* 228800 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228847), // Rule ID 11851 //
     /* 228805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228826 */     // MIs[0] Op3
     /* 228826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 228837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228845 */     GIR_RootConstrainSelectedInstOperands,
     /* 228846 */     // GIR_Coverage, 11851,
     /* 228846 */     GIR_EraseRootFromParent_Done,
     /* 228847 */   // Label 4349: @228847
     /* 228847 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228894), // Rule ID 11852 //
     /* 228852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228873 */     // MIs[0] Op3
     /* 228873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 228884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228892 */     GIR_RootConstrainSelectedInstOperands,
     /* 228893 */     // GIR_Coverage, 11852,
     /* 228893 */     GIR_EraseRootFromParent_Done,
     /* 228894 */   // Label 4350: @228894
     /* 228894 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228941), // Rule ID 11912 //
     /* 228899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228920 */     // MIs[0] Op3
     /* 228920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 228931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228939 */     GIR_RootConstrainSelectedInstOperands,
     /* 228940 */     // GIR_Coverage, 11912,
     /* 228940 */     GIR_EraseRootFromParent_Done,
     /* 228941 */   // Label 4351: @228941
     /* 228941 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228988), // Rule ID 11913 //
     /* 228946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228967 */     // MIs[0] Op3
     /* 228967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 228978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228986 */     GIR_RootConstrainSelectedInstOperands,
     /* 228987 */     // GIR_Coverage, 11913,
     /* 228987 */     GIR_EraseRootFromParent_Done,
     /* 228988 */   // Label 4352: @228988
     /* 228988 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(229035), // Rule ID 11914 //
     /* 228993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 229001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229014 */     // MIs[0] Op3
     /* 229014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 229025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229033 */     GIR_RootConstrainSelectedInstOperands,
     /* 229034 */     // GIR_Coverage, 11914,
     /* 229034 */     GIR_EraseRootFromParent_Done,
     /* 229035 */   // Label 4353: @229035
     /* 229035 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(229082), // Rule ID 11915 //
     /* 229040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 229048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229061 */     // MIs[0] Op3
     /* 229061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1729:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 229072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229080 */     GIR_RootConstrainSelectedInstOperands,
     /* 229081 */     // GIR_Coverage, 11915,
     /* 229081 */     GIR_EraseRootFromParent_Done,
     /* 229082 */   // Label 4354: @229082
     /* 229082 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229129), // Rule ID 11916 //
     /* 229087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 229095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229108 */     // MIs[0] Op3
     /* 229108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 229119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229127 */     GIR_RootConstrainSelectedInstOperands,
     /* 229128 */     // GIR_Coverage, 11916,
     /* 229128 */     GIR_EraseRootFromParent_Done,
     /* 229129 */   // Label 4355: @229129
     /* 229129 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229176), // Rule ID 11917 //
     /* 229134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 229142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229155 */     // MIs[0] Op3
     /* 229155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 229166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229174 */     GIR_RootConstrainSelectedInstOperands,
     /* 229175 */     // GIR_Coverage, 11917,
     /* 229175 */     GIR_EraseRootFromParent_Done,
     /* 229176 */   // Label 4356: @229176
     /* 229176 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229223), // Rule ID 11918 //
     /* 229181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 229189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229202 */     // MIs[0] Op3
     /* 229202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 229213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229221 */     GIR_RootConstrainSelectedInstOperands,
     /* 229222 */     // GIR_Coverage, 11918,
     /* 229222 */     GIR_EraseRootFromParent_Done,
     /* 229223 */   // Label 4357: @229223
     /* 229223 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229270), // Rule ID 11919 //
     /* 229228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 229236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229249 */     // MIs[0] Op3
     /* 229249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 229260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229268 */     GIR_RootConstrainSelectedInstOperands,
     /* 229269 */     // GIR_Coverage, 11919,
     /* 229269 */     GIR_EraseRootFromParent_Done,
     /* 229270 */   // Label 4358: @229270
     /* 229270 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229317), // Rule ID 11920 //
     /* 229275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 229283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229296 */     // MIs[0] Op3
     /* 229296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 229307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229315 */     GIR_RootConstrainSelectedInstOperands,
     /* 229316 */     // GIR_Coverage, 11920,
     /* 229316 */     GIR_EraseRootFromParent_Done,
     /* 229317 */   // Label 4359: @229317
     /* 229317 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229364), // Rule ID 11921 //
     /* 229322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 229330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229343 */     // MIs[0] Op3
     /* 229343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 229354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229362 */     GIR_RootConstrainSelectedInstOperands,
     /* 229363 */     // GIR_Coverage, 11921,
     /* 229363 */     GIR_EraseRootFromParent_Done,
     /* 229364 */   // Label 4360: @229364
     /* 229364 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229411), // Rule ID 11922 //
     /* 229369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 229377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229390 */     // MIs[0] Op3
     /* 229390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 229401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229409 */     GIR_RootConstrainSelectedInstOperands,
     /* 229410 */     // GIR_Coverage, 11922,
     /* 229410 */     GIR_EraseRootFromParent_Done,
     /* 229411 */   // Label 4361: @229411
     /* 229411 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229458), // Rule ID 11923 //
     /* 229416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 229424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229437 */     // MIs[0] Op3
     /* 229437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 229448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229456 */     GIR_RootConstrainSelectedInstOperands,
     /* 229457 */     // GIR_Coverage, 11923,
     /* 229457 */     GIR_EraseRootFromParent_Done,
     /* 229458 */   // Label 4362: @229458
     /* 229458 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229505), // Rule ID 11924 //
     /* 229463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229484 */     // MIs[0] Op3
     /* 229484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229487 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 229495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229503 */     GIR_RootConstrainSelectedInstOperands,
     /* 229504 */     // GIR_Coverage, 11924,
     /* 229504 */     GIR_EraseRootFromParent_Done,
     /* 229505 */   // Label 4363: @229505
     /* 229505 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229552), // Rule ID 11925 //
     /* 229510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229531 */     // MIs[0] Op3
     /* 229531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 229542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229550 */     GIR_RootConstrainSelectedInstOperands,
     /* 229551 */     // GIR_Coverage, 11925,
     /* 229551 */     GIR_EraseRootFromParent_Done,
     /* 229552 */   // Label 4364: @229552
     /* 229552 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229599), // Rule ID 11926 //
     /* 229557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229578 */     // MIs[0] Op3
     /* 229578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 229589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229597 */     GIR_RootConstrainSelectedInstOperands,
     /* 229598 */     // GIR_Coverage, 11926,
     /* 229598 */     GIR_EraseRootFromParent_Done,
     /* 229599 */   // Label 4365: @229599
     /* 229599 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229646), // Rule ID 11927 //
     /* 229604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229625 */     // MIs[0] Op3
     /* 229625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 229636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229644 */     GIR_RootConstrainSelectedInstOperands,
     /* 229645 */     // GIR_Coverage, 11927,
     /* 229645 */     GIR_EraseRootFromParent_Done,
     /* 229646 */   // Label 4366: @229646
     /* 229646 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229693), // Rule ID 11928 //
     /* 229651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229672 */     // MIs[0] Op3
     /* 229672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 229683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229691 */     GIR_RootConstrainSelectedInstOperands,
     /* 229692 */     // GIR_Coverage, 11928,
     /* 229692 */     GIR_EraseRootFromParent_Done,
     /* 229693 */   // Label 4367: @229693
     /* 229693 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229740), // Rule ID 11929 //
     /* 229698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229719 */     // MIs[0] Op3
     /* 229719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 229730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229738 */     GIR_RootConstrainSelectedInstOperands,
     /* 229739 */     // GIR_Coverage, 11929,
     /* 229739 */     GIR_EraseRootFromParent_Done,
     /* 229740 */   // Label 4368: @229740
     /* 229740 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229787), // Rule ID 11930 //
     /* 229745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229766 */     // MIs[0] Op3
     /* 229766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 229777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229785 */     GIR_RootConstrainSelectedInstOperands,
     /* 229786 */     // GIR_Coverage, 11930,
     /* 229786 */     GIR_EraseRootFromParent_Done,
     /* 229787 */   // Label 4369: @229787
     /* 229787 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229834), // Rule ID 11931 //
     /* 229792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229813 */     // MIs[0] Op3
     /* 229813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 229824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229832 */     GIR_RootConstrainSelectedInstOperands,
     /* 229833 */     // GIR_Coverage, 11931,
     /* 229833 */     GIR_EraseRootFromParent_Done,
     /* 229834 */   // Label 4370: @229834
     /* 229834 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(229881), // Rule ID 11932 //
     /* 229839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229860 */     // MIs[0] Op3
     /* 229860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 229871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229879 */     GIR_RootConstrainSelectedInstOperands,
     /* 229880 */     // GIR_Coverage, 11932,
     /* 229880 */     GIR_EraseRootFromParent_Done,
     /* 229881 */   // Label 4371: @229881
     /* 229881 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(229948), // Rule ID 2604 //
     /* 229886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 229894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 229937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229946 */     GIR_RootConstrainSelectedInstOperands,
     /* 229947 */     // GIR_Coverage, 2604,
     /* 229947 */     GIR_EraseRootFromParent_Done,
     /* 229948 */   // Label 4372: @229948
     /* 229948 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230015), // Rule ID 7804 //
     /* 229953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 230004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230013 */     GIR_RootConstrainSelectedInstOperands,
     /* 230014 */     // GIR_Coverage, 7804,
     /* 230014 */     GIR_EraseRootFromParent_Done,
     /* 230015 */   // Label 4373: @230015
     /* 230015 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230082), // Rule ID 7806 //
     /* 230020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 230028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 230071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230080 */     GIR_RootConstrainSelectedInstOperands,
     /* 230081 */     // GIR_Coverage, 7806,
     /* 230081 */     GIR_EraseRootFromParent_Done,
     /* 230082 */   // Label 4374: @230082
     /* 230082 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230149), // Rule ID 7808 //
     /* 230087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 230095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 230138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230147 */     GIR_RootConstrainSelectedInstOperands,
     /* 230148 */     // GIR_Coverage, 7808,
     /* 230148 */     GIR_EraseRootFromParent_Done,
     /* 230149 */   // Label 4375: @230149
     /* 230149 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230216), // Rule ID 7810 //
     /* 230154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 230162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 230205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230214 */     GIR_RootConstrainSelectedInstOperands,
     /* 230215 */     // GIR_Coverage, 7810,
     /* 230215 */     GIR_EraseRootFromParent_Done,
     /* 230216 */   // Label 4376: @230216
     /* 230216 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230283), // Rule ID 7840 //
     /* 230221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 230272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230281 */     GIR_RootConstrainSelectedInstOperands,
     /* 230282 */     // GIR_Coverage, 7840,
     /* 230282 */     GIR_EraseRootFromParent_Done,
     /* 230283 */   // Label 4377: @230283
     /* 230283 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230350), // Rule ID 7842 //
     /* 230288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 230339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230348 */     GIR_RootConstrainSelectedInstOperands,
     /* 230349 */     // GIR_Coverage, 7842,
     /* 230349 */     GIR_EraseRootFromParent_Done,
     /* 230350 */   // Label 4378: @230350
     /* 230350 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230417), // Rule ID 7844 //
     /* 230355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 230406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230415 */     GIR_RootConstrainSelectedInstOperands,
     /* 230416 */     // GIR_Coverage, 7844,
     /* 230416 */     GIR_EraseRootFromParent_Done,
     /* 230417 */   // Label 4379: @230417
     /* 230417 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230484), // Rule ID 7846 //
     /* 230422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 230473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230482 */     GIR_RootConstrainSelectedInstOperands,
     /* 230483 */     // GIR_Coverage, 7846,
     /* 230483 */     GIR_EraseRootFromParent_Done,
     /* 230484 */   // Label 4380: @230484
     /* 230484 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230551), // Rule ID 7852 //
     /* 230489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 230540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230549 */     GIR_RootConstrainSelectedInstOperands,
     /* 230550 */     // GIR_Coverage, 7852,
     /* 230550 */     GIR_EraseRootFromParent_Done,
     /* 230551 */   // Label 4381: @230551
     /* 230551 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230618), // Rule ID 7854 //
     /* 230556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 230607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230616 */     GIR_RootConstrainSelectedInstOperands,
     /* 230617 */     // GIR_Coverage, 7854,
     /* 230617 */     GIR_EraseRootFromParent_Done,
     /* 230618 */   // Label 4382: @230618
     /* 230618 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230685), // Rule ID 7856 //
     /* 230623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 230674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230683 */     GIR_RootConstrainSelectedInstOperands,
     /* 230684 */     // GIR_Coverage, 7856,
     /* 230684 */     GIR_EraseRootFromParent_Done,
     /* 230685 */   // Label 4383: @230685
     /* 230685 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230752), // Rule ID 7858 //
     /* 230690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 230741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230750 */     GIR_RootConstrainSelectedInstOperands,
     /* 230751 */     // GIR_Coverage, 7858,
     /* 230751 */     GIR_EraseRootFromParent_Done,
     /* 230752 */   // Label 4384: @230752
     /* 230752 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230819), // Rule ID 11613 //
     /* 230757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 230765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 230808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230817 */     GIR_RootConstrainSelectedInstOperands,
     /* 230818 */     // GIR_Coverage, 11613,
     /* 230818 */     GIR_EraseRootFromParent_Done,
     /* 230819 */   // Label 4385: @230819
     /* 230819 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230886), // Rule ID 11615 //
     /* 230824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 230875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230884 */     GIR_RootConstrainSelectedInstOperands,
     /* 230885 */     // GIR_Coverage, 11615,
     /* 230885 */     GIR_EraseRootFromParent_Done,
     /* 230886 */   // Label 4386: @230886
     /* 230886 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(230953), // Rule ID 11617 //
     /* 230891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 230942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230951 */     GIR_RootConstrainSelectedInstOperands,
     /* 230952 */     // GIR_Coverage, 11617,
     /* 230952 */     GIR_EraseRootFromParent_Done,
     /* 230953 */   // Label 4387: @230953
     /* 230953 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231020), // Rule ID 11619 //
     /* 230958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 231009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231018 */     GIR_RootConstrainSelectedInstOperands,
     /* 231019 */     // GIR_Coverage, 11619,
     /* 231019 */     GIR_EraseRootFromParent_Done,
     /* 231020 */   // Label 4388: @231020
     /* 231020 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231087), // Rule ID 11621 //
     /* 231025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 231033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 231059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 231076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231085 */     GIR_RootConstrainSelectedInstOperands,
     /* 231086 */     // GIR_Coverage, 11621,
     /* 231086 */     GIR_EraseRootFromParent_Done,
     /* 231087 */   // Label 4389: @231087
     /* 231087 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231154), // Rule ID 11627 //
     /* 231092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 231100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 231109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 231126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 231143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231152 */     GIR_RootConstrainSelectedInstOperands,
     /* 231153 */     // GIR_Coverage, 11627,
     /* 231153 */     GIR_EraseRootFromParent_Done,
     /* 231154 */   // Label 4390: @231154
     /* 231154 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231221), // Rule ID 11629 //
     /* 231159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 231167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 231176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 231193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 231210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231219 */     GIR_RootConstrainSelectedInstOperands,
     /* 231220 */     // GIR_Coverage, 11629,
     /* 231220 */     GIR_EraseRootFromParent_Done,
     /* 231221 */   // Label 4391: @231221
     /* 231221 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231288), // Rule ID 11631 //
     /* 231226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 231234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 231260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 231277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231286 */     GIR_RootConstrainSelectedInstOperands,
     /* 231287 */     // GIR_Coverage, 11631,
     /* 231287 */     GIR_EraseRootFromParent_Done,
     /* 231288 */   // Label 4392: @231288
     /* 231288 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231355), // Rule ID 11633 //
     /* 231293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 231301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 231327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 231344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231353 */     GIR_RootConstrainSelectedInstOperands,
     /* 231354 */     // GIR_Coverage, 11633,
     /* 231354 */     GIR_EraseRootFromParent_Done,
     /* 231355 */   // Label 4393: @231355
     /* 231355 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231409), // Rule ID 30 //
     /* 231360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 231368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 231399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231407 */     GIR_RootConstrainSelectedInstOperands,
     /* 231408 */     // GIR_Coverage, 30,
     /* 231408 */     GIR_EraseRootFromParent_Done,
     /* 231409 */   // Label 4394: @231409
     /* 231409 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231463), // Rule ID 31 //
     /* 231414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 231422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 231453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231461 */     GIR_RootConstrainSelectedInstOperands,
     /* 231462 */     // GIR_Coverage, 31,
     /* 231462 */     GIR_EraseRootFromParent_Done,
     /* 231463 */   // Label 4395: @231463
     /* 231463 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231517), // Rule ID 32 //
     /* 231468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 231476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 231507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231515 */     GIR_RootConstrainSelectedInstOperands,
     /* 231516 */     // GIR_Coverage, 32,
     /* 231516 */     GIR_EraseRootFromParent_Done,
     /* 231517 */   // Label 4396: @231517
     /* 231517 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231571), // Rule ID 39 //
     /* 231522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231558 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 231561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231569 */     GIR_RootConstrainSelectedInstOperands,
     /* 231570 */     // GIR_Coverage, 39,
     /* 231570 */     GIR_EraseRootFromParent_Done,
     /* 231571 */   // Label 4397: @231571
     /* 231571 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231625), // Rule ID 40 //
     /* 231576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231612 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 231615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231623 */     GIR_RootConstrainSelectedInstOperands,
     /* 231624 */     // GIR_Coverage, 40,
     /* 231624 */     GIR_EraseRootFromParent_Done,
     /* 231625 */   // Label 4398: @231625
     /* 231625 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231679), // Rule ID 41 //
     /* 231630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231666 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 231669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231677 */     GIR_RootConstrainSelectedInstOperands,
     /* 231678 */     // GIR_Coverage, 41,
     /* 231678 */     GIR_EraseRootFromParent_Done,
     /* 231679 */   // Label 4399: @231679
     /* 231679 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231733), // Rule ID 42 //
     /* 231684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231720 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 231723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231731 */     GIR_RootConstrainSelectedInstOperands,
     /* 231732 */     // GIR_Coverage, 42,
     /* 231732 */     GIR_EraseRootFromParent_Done,
     /* 231733 */   // Label 4400: @231733
     /* 231733 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231787), // Rule ID 43 //
     /* 231738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231774 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 231777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231785 */     GIR_RootConstrainSelectedInstOperands,
     /* 231786 */     // GIR_Coverage, 43,
     /* 231786 */     GIR_EraseRootFromParent_Done,
     /* 231787 */   // Label 4401: @231787
     /* 231787 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231841), // Rule ID 44 //
     /* 231792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231828 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231839 */     GIR_RootConstrainSelectedInstOperands,
     /* 231840 */     // GIR_Coverage, 44,
     /* 231840 */     GIR_EraseRootFromParent_Done,
     /* 231841 */   // Label 4402: @231841
     /* 231841 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231895), // Rule ID 45 //
     /* 231846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231882 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 231885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231893 */     GIR_RootConstrainSelectedInstOperands,
     /* 231894 */     // GIR_Coverage, 45,
     /* 231894 */     GIR_EraseRootFromParent_Done,
     /* 231895 */   // Label 4403: @231895
     /* 231895 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231949), // Rule ID 46 //
     /* 231900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231936 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 231939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231947 */     GIR_RootConstrainSelectedInstOperands,
     /* 231948 */     // GIR_Coverage, 46,
     /* 231948 */     GIR_EraseRootFromParent_Done,
     /* 231949 */   // Label 4404: @231949
     /* 231949 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(232003), // Rule ID 1591 //
     /* 231954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231990 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 231993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232001 */     GIR_RootConstrainSelectedInstOperands,
     /* 232002 */     // GIR_Coverage, 1591,
     /* 232002 */     GIR_EraseRootFromParent_Done,
     /* 232003 */   // Label 4405: @232003
     /* 232003 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(232057), // Rule ID 1592 //
     /* 232008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 232016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 232044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 232047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232055 */     GIR_RootConstrainSelectedInstOperands,
     /* 232056 */     // GIR_Coverage, 1592,
     /* 232056 */     GIR_EraseRootFromParent_Done,
     /* 232057 */   // Label 4406: @232057
     /* 232057 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(232111), // Rule ID 1593 //
     /* 232062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 232070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232098 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 232098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 232101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232109 */     GIR_RootConstrainSelectedInstOperands,
     /* 232110 */     // GIR_Coverage, 1593,
     /* 232110 */     GIR_EraseRootFromParent_Done,
     /* 232111 */   // Label 4407: @232111
     /* 232111 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232165), // Rule ID 1594 //
     /* 232116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 232124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 232155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232163 */     GIR_RootConstrainSelectedInstOperands,
     /* 232164 */     // GIR_Coverage, 1594,
     /* 232164 */     GIR_EraseRootFromParent_Done,
     /* 232165 */   // Label 4408: @232165
     /* 232165 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232219), // Rule ID 1595 //
     /* 232170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 232178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 232206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 232209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232217 */     GIR_RootConstrainSelectedInstOperands,
     /* 232218 */     // GIR_Coverage, 1595,
     /* 232218 */     GIR_EraseRootFromParent_Done,
     /* 232219 */   // Label 4409: @232219
     /* 232219 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232273), // Rule ID 1596 //
     /* 232224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 232232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232260 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 232260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 232263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232271 */     GIR_RootConstrainSelectedInstOperands,
     /* 232272 */     // GIR_Coverage, 1596,
     /* 232272 */     GIR_EraseRootFromParent_Done,
     /* 232273 */   // Label 4410: @232273
     /* 232273 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232327), // Rule ID 1597 //
     /* 232278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 232286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232314 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 232314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 232317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232325 */     GIR_RootConstrainSelectedInstOperands,
     /* 232326 */     // GIR_Coverage, 1597,
     /* 232326 */     GIR_EraseRootFromParent_Done,
     /* 232327 */   // Label 4411: @232327
     /* 232327 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232381), // Rule ID 1598 //
     /* 232332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 232335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 232340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 232371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232379 */     GIR_RootConstrainSelectedInstOperands,
     /* 232380 */     // GIR_Coverage, 1598,
     /* 232380 */     GIR_EraseRootFromParent_Done,
     /* 232381 */   // Label 4412: @232381
     /* 232381 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232435), // Rule ID 2311 //
     /* 232386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 232394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 232425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232433 */     GIR_RootConstrainSelectedInstOperands,
     /* 232434 */     // GIR_Coverage, 2311,
     /* 232434 */     GIR_EraseRootFromParent_Done,
     /* 232435 */   // Label 4413: @232435
     /* 232435 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232489), // Rule ID 2312 //
     /* 232440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 232448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 232479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232487 */     GIR_RootConstrainSelectedInstOperands,
     /* 232488 */     // GIR_Coverage, 2312,
     /* 232488 */     GIR_EraseRootFromParent_Done,
     /* 232489 */   // Label 4414: @232489
     /* 232489 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232543), // Rule ID 2313 //
     /* 232494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 232502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 232533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232541 */     GIR_RootConstrainSelectedInstOperands,
     /* 232542 */     // GIR_Coverage, 2313,
     /* 232542 */     GIR_EraseRootFromParent_Done,
     /* 232543 */   // Label 4415: @232543
     /* 232543 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232597), // Rule ID 2314 //
     /* 232548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 232556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 232587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232595 */     GIR_RootConstrainSelectedInstOperands,
     /* 232596 */     // GIR_Coverage, 2314,
     /* 232596 */     GIR_EraseRootFromParent_Done,
     /* 232597 */   // Label 4416: @232597
     /* 232597 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232651), // Rule ID 2315 //
     /* 232602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 232610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232638 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 232641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232649 */     GIR_RootConstrainSelectedInstOperands,
     /* 232650 */     // GIR_Coverage, 2315,
     /* 232650 */     GIR_EraseRootFromParent_Done,
     /* 232651 */   // Label 4417: @232651
     /* 232651 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232705), // Rule ID 2316 //
     /* 232656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 232664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 232695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232703 */     GIR_RootConstrainSelectedInstOperands,
     /* 232704 */     // GIR_Coverage, 2316,
     /* 232704 */     GIR_EraseRootFromParent_Done,
     /* 232705 */   // Label 4418: @232705
     /* 232705 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232759), // Rule ID 2317 //
     /* 232710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 232718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232746 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 232749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232757 */     GIR_RootConstrainSelectedInstOperands,
     /* 232758 */     // GIR_Coverage, 2317,
     /* 232758 */     GIR_EraseRootFromParent_Done,
     /* 232759 */   // Label 4419: @232759
     /* 232759 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232816), // Rule ID 3667 //
     /* 232764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 232803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232809 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232814 */     GIR_RootConstrainSelectedInstOperands,
     /* 232815 */     // GIR_Coverage, 3667,
     /* 232815 */     GIR_EraseRootFromParent_Done,
     /* 232816 */   // Label 4420: @232816
     /* 232816 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232873), // Rule ID 3668 //
     /* 232821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 232860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232866 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232871 */     GIR_RootConstrainSelectedInstOperands,
     /* 232872 */     // GIR_Coverage, 3668,
     /* 232872 */     GIR_EraseRootFromParent_Done,
     /* 232873 */   // Label 4421: @232873
     /* 232873 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232930), // Rule ID 3669 //
     /* 232878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232914 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 232917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232923 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232928 */     GIR_RootConstrainSelectedInstOperands,
     /* 232929 */     // GIR_Coverage, 3669,
     /* 232929 */     GIR_EraseRootFromParent_Done,
     /* 232930 */   // Label 4422: @232930
     /* 232930 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(232987), // Rule ID 3670 //
     /* 232935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232971 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 232974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232980 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232985 */     GIR_RootConstrainSelectedInstOperands,
     /* 232986 */     // GIR_Coverage, 3670,
     /* 232986 */     GIR_EraseRootFromParent_Done,
     /* 232987 */   // Label 4423: @232987
     /* 232987 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(233041), // Rule ID 3849 //
     /* 232992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 233000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233028 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233039 */     GIR_RootConstrainSelectedInstOperands,
     /* 233040 */     // GIR_Coverage, 3849,
     /* 233040 */     GIR_EraseRootFromParent_Done,
     /* 233041 */   // Label 4424: @233041
     /* 233041 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233095), // Rule ID 3850 //
     /* 233046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 233054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233082 */     // (intrinsic_wo_chain:{ *:[v2i64] } 541:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 233085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233093 */     GIR_RootConstrainSelectedInstOperands,
     /* 233094 */     // GIR_Coverage, 3850,
     /* 233094 */     GIR_EraseRootFromParent_Done,
     /* 233095 */   // Label 4425: @233095
     /* 233095 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233149), // Rule ID 3851 //
     /* 233100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 233108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 233139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233147 */     GIR_RootConstrainSelectedInstOperands,
     /* 233148 */     // GIR_Coverage, 3851,
     /* 233148 */     GIR_EraseRootFromParent_Done,
     /* 233149 */   // Label 4426: @233149
     /* 233149 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233203), // Rule ID 3852 //
     /* 233154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 233162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233190 */     // (intrinsic_wo_chain:{ *:[v16i8] } 528:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233201 */     GIR_RootConstrainSelectedInstOperands,
     /* 233202 */     // GIR_Coverage, 3852,
     /* 233202 */     GIR_EraseRootFromParent_Done,
     /* 233203 */   // Label 4427: @233203
     /* 233203 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233257), // Rule ID 3853 //
     /* 233208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 233216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 528:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233255 */     GIR_RootConstrainSelectedInstOperands,
     /* 233256 */     // GIR_Coverage, 3853,
     /* 233256 */     GIR_EraseRootFromParent_Done,
     /* 233257 */   // Label 4428: @233257
     /* 233257 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233311), // Rule ID 3854 //
     /* 233262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 233270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233298 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233309 */     GIR_RootConstrainSelectedInstOperands,
     /* 233310 */     // GIR_Coverage, 3854,
     /* 233310 */     GIR_EraseRootFromParent_Done,
     /* 233311 */   // Label 4429: @233311
     /* 233311 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233365), // Rule ID 3855 //
     /* 233316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 233324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 528:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233363 */     GIR_RootConstrainSelectedInstOperands,
     /* 233364 */     // GIR_Coverage, 3855,
     /* 233364 */     GIR_EraseRootFromParent_Done,
     /* 233365 */   // Label 4430: @233365
     /* 233365 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233419), // Rule ID 3864 //
     /* 233370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233406 */     // (intrinsic_wo_chain:{ *:[v16i8] } 526:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233417 */     GIR_RootConstrainSelectedInstOperands,
     /* 233418 */     // GIR_Coverage, 3864,
     /* 233418 */     GIR_EraseRootFromParent_Done,
     /* 233419 */   // Label 4431: @233419
     /* 233419 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233473), // Rule ID 3865 //
     /* 233424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 526:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233471 */     GIR_RootConstrainSelectedInstOperands,
     /* 233472 */     // GIR_Coverage, 3865,
     /* 233472 */     GIR_EraseRootFromParent_Done,
     /* 233473 */   // Label 4432: @233473
     /* 233473 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233527), // Rule ID 3866 //
     /* 233478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233514 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233525 */     GIR_RootConstrainSelectedInstOperands,
     /* 233526 */     // GIR_Coverage, 3866,
     /* 233526 */     GIR_EraseRootFromParent_Done,
     /* 233527 */   // Label 4433: @233527
     /* 233527 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233581), // Rule ID 3867 //
     /* 233532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233568 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233579 */     GIR_RootConstrainSelectedInstOperands,
     /* 233580 */     // GIR_Coverage, 3867,
     /* 233580 */     GIR_EraseRootFromParent_Done,
     /* 233581 */   // Label 4434: @233581
     /* 233581 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233635), // Rule ID 3868 //
     /* 233586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233622 */     // (intrinsic_wo_chain:{ *:[v16i8] } 527:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233633 */     GIR_RootConstrainSelectedInstOperands,
     /* 233634 */     // GIR_Coverage, 3868,
     /* 233634 */     GIR_EraseRootFromParent_Done,
     /* 233635 */   // Label 4435: @233635
     /* 233635 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233689), // Rule ID 3869 //
     /* 233640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233676 */     // (intrinsic_wo_chain:{ *:[v8i16] } 527:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233687 */     GIR_RootConstrainSelectedInstOperands,
     /* 233688 */     // GIR_Coverage, 3869,
     /* 233688 */     GIR_EraseRootFromParent_Done,
     /* 233689 */   // Label 4436: @233689
     /* 233689 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233743), // Rule ID 3870 //
     /* 233694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233741 */     GIR_RootConstrainSelectedInstOperands,
     /* 233742 */     // GIR_Coverage, 3870,
     /* 233742 */     GIR_EraseRootFromParent_Done,
     /* 233743 */   // Label 4437: @233743
     /* 233743 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233797), // Rule ID 3871 //
     /* 233748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 527:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233795 */     GIR_RootConstrainSelectedInstOperands,
     /* 233796 */     // GIR_Coverage, 3871,
     /* 233796 */     GIR_EraseRootFromParent_Done,
     /* 233797 */   // Label 4438: @233797
     /* 233797 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233851), // Rule ID 3872 //
     /* 233802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233849 */     GIR_RootConstrainSelectedInstOperands,
     /* 233850 */     // GIR_Coverage, 3872,
     /* 233850 */     GIR_EraseRootFromParent_Done,
     /* 233851 */   // Label 4439: @233851
     /* 233851 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233905), // Rule ID 3873 //
     /* 233856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233903 */     GIR_RootConstrainSelectedInstOperands,
     /* 233904 */     // GIR_Coverage, 3873,
     /* 233904 */     GIR_EraseRootFromParent_Done,
     /* 233905 */   // Label 4440: @233905
     /* 233905 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(233959), // Rule ID 3874 //
     /* 233910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233957 */     GIR_RootConstrainSelectedInstOperands,
     /* 233958 */     // GIR_Coverage, 3874,
     /* 233958 */     GIR_EraseRootFromParent_Done,
     /* 233959 */   // Label 4441: @233959
     /* 233959 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(234013), // Rule ID 3875 //
     /* 233964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234000 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 234003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 234005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234011 */     GIR_RootConstrainSelectedInstOperands,
     /* 234012 */     // GIR_Coverage, 3875,
     /* 234012 */     GIR_EraseRootFromParent_Done,
     /* 234013 */   // Label 4442: @234013
     /* 234013 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234067), // Rule ID 3879 //
     /* 234018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 234021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 234026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 234054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 234057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 234059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 234061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 234063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 234065 */     GIR_RootConstrainSelectedInstOperands,
     /* 234066 */     // GIR_Coverage, 3879,
     /* 234066 */     GIR_EraseRootFromParent_Done,
     /* 234067 */   // Label 4443: @234067
     /* 234067 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234121), // Rule ID 3880 //
     /* 234072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 234075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 234080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 234108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 234111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234119 */     GIR_RootConstrainSelectedInstOperands,
     /* 234120 */     // GIR_Coverage, 3880,
     /* 234120 */     GIR_EraseRootFromParent_Done,
     /* 234121 */   // Label 4444: @234121
     /* 234121 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234175), // Rule ID 3881 //
     /* 234126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 234129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 234134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234162 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 234162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 234165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234173 */     GIR_RootConstrainSelectedInstOperands,
     /* 234174 */     // GIR_Coverage, 3881,
     /* 234174 */     GIR_EraseRootFromParent_Done,
     /* 234175 */   // Label 4445: @234175
     /* 234175 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234232), // Rule ID 3898 //
     /* 234180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 234191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 234194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 234197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 234200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234216 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 234216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234230 */     GIR_RootConstrainSelectedInstOperands,
     /* 234231 */     // GIR_Coverage, 3898,
     /* 234231 */     GIR_EraseRootFromParent_Done,
     /* 234232 */   // Label 4446: @234232
     /* 234232 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234289), // Rule ID 3899 //
     /* 234237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 234248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 234251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 234254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 234257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234273 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 234273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234287 */     GIR_RootConstrainSelectedInstOperands,
     /* 234288 */     // GIR_Coverage, 3899,
     /* 234288 */     GIR_EraseRootFromParent_Done,
     /* 234289 */   // Label 4447: @234289
     /* 234289 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234346), // Rule ID 3900 //
     /* 234294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 234305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 234308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 234311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 234314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234330 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 234330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234344 */     GIR_RootConstrainSelectedInstOperands,
     /* 234345 */     // GIR_Coverage, 3900,
     /* 234345 */     GIR_EraseRootFromParent_Done,
     /* 234346 */   // Label 4448: @234346
     /* 234346 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234403), // Rule ID 3901 //
     /* 234351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 234362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 234365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 234368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 234371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234387 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 234387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234401 */     GIR_RootConstrainSelectedInstOperands,
     /* 234402 */     // GIR_Coverage, 3901,
     /* 234402 */     GIR_EraseRootFromParent_Done,
     /* 234403 */   // Label 4449: @234403
     /* 234403 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234460), // Rule ID 3906 //
     /* 234408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234444 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 234444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234458 */     GIR_RootConstrainSelectedInstOperands,
     /* 234459 */     // GIR_Coverage, 3906,
     /* 234459 */     GIR_EraseRootFromParent_Done,
     /* 234460 */   // Label 4450: @234460
     /* 234460 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234517), // Rule ID 3907 //
     /* 234465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234501 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 234501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234515 */     GIR_RootConstrainSelectedInstOperands,
     /* 234516 */     // GIR_Coverage, 3907,
     /* 234516 */     GIR_EraseRootFromParent_Done,
     /* 234517 */   // Label 4451: @234517
     /* 234517 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234574), // Rule ID 3908 //
     /* 234522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234558 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 234558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234572 */     GIR_RootConstrainSelectedInstOperands,
     /* 234573 */     // GIR_Coverage, 3908,
     /* 234573 */     GIR_EraseRootFromParent_Done,
     /* 234574 */   // Label 4452: @234574
     /* 234574 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234631), // Rule ID 3909 //
     /* 234579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234615 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 234615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234629 */     GIR_RootConstrainSelectedInstOperands,
     /* 234630 */     // GIR_Coverage, 3909,
     /* 234630 */     GIR_EraseRootFromParent_Done,
     /* 234631 */   // Label 4453: @234631
     /* 234631 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234688), // Rule ID 3914 //
     /* 234636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234672 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 234672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234686 */     GIR_RootConstrainSelectedInstOperands,
     /* 234687 */     // GIR_Coverage, 3914,
     /* 234687 */     GIR_EraseRootFromParent_Done,
     /* 234688 */   // Label 4454: @234688
     /* 234688 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234745), // Rule ID 3915 //
     /* 234693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234729 */     // (intrinsic_wo_chain:{ *:[v2f32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 234729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234743 */     GIR_RootConstrainSelectedInstOperands,
     /* 234744 */     // GIR_Coverage, 3915,
     /* 234744 */     GIR_EraseRootFromParent_Done,
     /* 234745 */   // Label 4455: @234745
     /* 234745 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234802), // Rule ID 3916 //
     /* 234750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234786 */     // (intrinsic_wo_chain:{ *:[v2f32] } 768:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 234786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234800 */     GIR_RootConstrainSelectedInstOperands,
     /* 234801 */     // GIR_Coverage, 3916,
     /* 234801 */     GIR_EraseRootFromParent_Done,
     /* 234802 */   // Label 4456: @234802
     /* 234802 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234859), // Rule ID 3917 //
     /* 234807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234843 */     // (intrinsic_wo_chain:{ *:[v2f32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 234843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234857 */     GIR_RootConstrainSelectedInstOperands,
     /* 234858 */     // GIR_Coverage, 3917,
     /* 234858 */     GIR_EraseRootFromParent_Done,
     /* 234859 */   // Label 4457: @234859
     /* 234859 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234916), // Rule ID 3918 //
     /* 234864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234900 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 234900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234914 */     GIR_RootConstrainSelectedInstOperands,
     /* 234915 */     // GIR_Coverage, 3918,
     /* 234915 */     GIR_EraseRootFromParent_Done,
     /* 234916 */   // Label 4458: @234916
     /* 234916 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(234973), // Rule ID 3919 //
     /* 234921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234957 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 234957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234971 */     GIR_RootConstrainSelectedInstOperands,
     /* 234972 */     // GIR_Coverage, 3919,
     /* 234972 */     GIR_EraseRootFromParent_Done,
     /* 234973 */   // Label 4459: @234973
     /* 234973 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(235030), // Rule ID 3920 //
     /* 234978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235014 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 235014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 235017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 235028 */     GIR_RootConstrainSelectedInstOperands,
     /* 235029 */     // GIR_Coverage, 3920,
     /* 235029 */     GIR_EraseRootFromParent_Done,
     /* 235030 */   // Label 4460: @235030
     /* 235030 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235087), // Rule ID 3921 //
     /* 235035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 235038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 235043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235071 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 235071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 235074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 235085 */     GIR_RootConstrainSelectedInstOperands,
     /* 235086 */     // GIR_Coverage, 3921,
     /* 235086 */     GIR_EraseRootFromParent_Done,
     /* 235087 */   // Label 4461: @235087
     /* 235087 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235144), // Rule ID 3922 //
     /* 235092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 235095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 235100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235128 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 235128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 235131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235142 */     GIR_RootConstrainSelectedInstOperands,
     /* 235143 */     // GIR_Coverage, 3922,
     /* 235143 */     GIR_EraseRootFromParent_Done,
     /* 235144 */   // Label 4462: @235144
     /* 235144 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235201), // Rule ID 3923 //
     /* 235149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 235152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 235157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235185 */     // (intrinsic_wo_chain:{ *:[v2f64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 235185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 235188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 235199 */     GIR_RootConstrainSelectedInstOperands,
     /* 235200 */     // GIR_Coverage, 3923,
     /* 235200 */     GIR_EraseRootFromParent_Done,
     /* 235201 */   // Label 4463: @235201
     /* 235201 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235258), // Rule ID 3924 //
     /* 235206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 235209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 235214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235242 */     // (intrinsic_wo_chain:{ *:[v2f64] } 768:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 235242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 235245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 235256 */     GIR_RootConstrainSelectedInstOperands,
     /* 235257 */     // GIR_Coverage, 3924,
     /* 235257 */     GIR_EraseRootFromParent_Done,
     /* 235258 */   // Label 4464: @235258
     /* 235258 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235315), // Rule ID 3925 //
     /* 235263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 235266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 235271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235299 */     // (intrinsic_wo_chain:{ *:[v2f64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 235299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 235302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 235313 */     GIR_RootConstrainSelectedInstOperands,
     /* 235314 */     // GIR_Coverage, 3925,
     /* 235314 */     GIR_EraseRootFromParent_Done,
     /* 235315 */   // Label 4465: @235315
     /* 235315 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235369), // Rule ID 5280 //
     /* 235320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 235323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 235328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235356 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 235356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 235359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235367 */     GIR_RootConstrainSelectedInstOperands,
     /* 235368 */     // GIR_Coverage, 5280,
     /* 235368 */     GIR_EraseRootFromParent_Done,
     /* 235369 */   // Label 4466: @235369
     /* 235369 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235423), // Rule ID 5281 //
     /* 235374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 235377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 235382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235410 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 235410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 235413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235421 */     GIR_RootConstrainSelectedInstOperands,
     /* 235422 */     // GIR_Coverage, 5281,
     /* 235422 */     GIR_EraseRootFromParent_Done,
     /* 235423 */   // Label 4467: @235423
     /* 235423 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235474), // Rule ID 5634 //
     /* 235428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 235436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 235439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 235445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235461 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 235461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 235464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 235472 */     GIR_RootConstrainSelectedInstOperands,
     /* 235473 */     // GIR_Coverage, 5634,
     /* 235473 */     GIR_EraseRootFromParent_Done,
     /* 235474 */   // Label 4468: @235474
     /* 235474 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235525), // Rule ID 5635 //
     /* 235479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235512 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 235512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 235515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 235521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 235523 */     GIR_RootConstrainSelectedInstOperands,
     /* 235524 */     // GIR_Coverage, 5635,
     /* 235524 */     GIR_EraseRootFromParent_Done,
     /* 235525 */   // Label 4469: @235525
     /* 235525 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235567), // Rule ID 2699 //
     /* 235530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1928:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 235557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235565 */     GIR_RootConstrainSelectedInstOperands,
     /* 235566 */     // GIR_Coverage, 2699,
     /* 235566 */     GIR_EraseRootFromParent_Done,
     /* 235567 */   // Label 4470: @235567
     /* 235567 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235609), // Rule ID 2700 //
     /* 235572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1928:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235607 */     GIR_RootConstrainSelectedInstOperands,
     /* 235608 */     // GIR_Coverage, 2700,
     /* 235608 */     GIR_EraseRootFromParent_Done,
     /* 235609 */   // Label 4471: @235609
     /* 235609 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235651), // Rule ID 2701 //
     /* 235614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1928:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235649 */     GIR_RootConstrainSelectedInstOperands,
     /* 235650 */     // GIR_Coverage, 2701,
     /* 235650 */     GIR_EraseRootFromParent_Done,
     /* 235651 */   // Label 4472: @235651
     /* 235651 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235693), // Rule ID 2702 //
     /* 235656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1928:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235691 */     GIR_RootConstrainSelectedInstOperands,
     /* 235692 */     // GIR_Coverage, 2702,
     /* 235692 */     GIR_EraseRootFromParent_Done,
     /* 235693 */   // Label 4473: @235693
     /* 235693 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235735), // Rule ID 2703 //
     /* 235698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235722 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1928:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235733 */     GIR_RootConstrainSelectedInstOperands,
     /* 235734 */     // GIR_Coverage, 2703,
     /* 235734 */     GIR_EraseRootFromParent_Done,
     /* 235735 */   // Label 4474: @235735
     /* 235735 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(235777), // Rule ID 2704 //
     /* 235740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1928:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235775 */     GIR_RootConstrainSelectedInstOperands,
     /* 235776 */     // GIR_Coverage, 2704,
     /* 235776 */     GIR_EraseRootFromParent_Done,
     /* 235777 */   // Label 4475: @235777
     /* 235777 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(235819), // Rule ID 2705 //
     /* 235782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1928:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235817 */     GIR_RootConstrainSelectedInstOperands,
     /* 235818 */     // GIR_Coverage, 2705,
     /* 235818 */     GIR_EraseRootFromParent_Done,
     /* 235819 */   // Label 4476: @235819
     /* 235819 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(235861), // Rule ID 2744 //
     /* 235824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 235835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 235844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 235848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235859 */     GIR_RootConstrainSelectedInstOperands,
     /* 235860 */     // GIR_Coverage, 2744,
     /* 235860 */     GIR_EraseRootFromParent_Done,
     /* 235861 */   // Label 4477: @235861
     /* 235861 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(235903), // Rule ID 2745 //
     /* 235866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 235877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 235886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 235890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235901 */     GIR_RootConstrainSelectedInstOperands,
     /* 235902 */     // GIR_Coverage, 2745,
     /* 235902 */     GIR_EraseRootFromParent_Done,
     /* 235903 */   // Label 4478: @235903
     /* 235903 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(235945), // Rule ID 2746 //
     /* 235908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 235919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 235928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 235932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235943 */     GIR_RootConstrainSelectedInstOperands,
     /* 235944 */     // GIR_Coverage, 2746,
     /* 235944 */     GIR_EraseRootFromParent_Done,
     /* 235945 */   // Label 4479: @235945
     /* 235945 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235987), // Rule ID 2747 //
     /* 235950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 235961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 235970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 235974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235985 */     GIR_RootConstrainSelectedInstOperands,
     /* 235986 */     // GIR_Coverage, 2747,
     /* 235986 */     GIR_EraseRootFromParent_Done,
     /* 235987 */   // Label 4480: @235987
     /* 235987 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(236029), // Rule ID 2748 //
     /* 235992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 236000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 236003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 236006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 236009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 236012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 236016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1274:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 236016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 236019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236027 */     GIR_RootConstrainSelectedInstOperands,
     /* 236028 */     // GIR_Coverage, 2748,
     /* 236028 */     GIR_EraseRootFromParent_Done,
     /* 236029 */   // Label 4481: @236029
     /* 236029 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(236071), // Rule ID 2787 //
     /* 236034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 236042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236058 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 236061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236069 */     GIR_RootConstrainSelectedInstOperands,
     /* 236070 */     // GIR_Coverage, 2787,
     /* 236070 */     GIR_EraseRootFromParent_Done,
     /* 236071 */   // Label 4482: @236071
     /* 236071 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(236113), // Rule ID 2789 //
     /* 236076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 236084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 236103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236111 */     GIR_RootConstrainSelectedInstOperands,
     /* 236112 */     // GIR_Coverage, 2789,
     /* 236112 */     GIR_EraseRootFromParent_Done,
     /* 236113 */   // Label 4483: @236113
     /* 236113 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236155), // Rule ID 2791 //
     /* 236118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 236126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 236145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236153 */     GIR_RootConstrainSelectedInstOperands,
     /* 236154 */     // GIR_Coverage, 2791,
     /* 236154 */     GIR_EraseRootFromParent_Done,
     /* 236155 */   // Label 4484: @236155
     /* 236155 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236197), // Rule ID 2793 //
     /* 236160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 236168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236184 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1547:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 236187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236195 */     GIR_RootConstrainSelectedInstOperands,
     /* 236196 */     // GIR_Coverage, 2793,
     /* 236196 */     GIR_EraseRootFromParent_Done,
     /* 236197 */   // Label 4485: @236197
     /* 236197 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236239), // Rule ID 2794 //
     /* 236202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 236210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236226 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1547:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 236229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236237 */     GIR_RootConstrainSelectedInstOperands,
     /* 236238 */     // GIR_Coverage, 2794,
     /* 236238 */     GIR_EraseRootFromParent_Done,
     /* 236239 */   // Label 4486: @236239
     /* 236239 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236281), // Rule ID 2795 //
     /* 236244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 236252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236268 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1547:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 236271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236279 */     GIR_RootConstrainSelectedInstOperands,
     /* 236280 */     // GIR_Coverage, 2795,
     /* 236280 */     GIR_EraseRootFromParent_Done,
     /* 236281 */   // Label 4487: @236281
     /* 236281 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236323), // Rule ID 2879 //
     /* 236286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 236294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236310 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236321 */     GIR_RootConstrainSelectedInstOperands,
     /* 236322 */     // GIR_Coverage, 2879,
     /* 236322 */     GIR_EraseRootFromParent_Done,
     /* 236323 */   // Label 4488: @236323
     /* 236323 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236365), // Rule ID 2880 //
     /* 236328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 236336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236352 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 236355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236363 */     GIR_RootConstrainSelectedInstOperands,
     /* 236364 */     // GIR_Coverage, 2880,
     /* 236364 */     GIR_EraseRootFromParent_Done,
     /* 236365 */   // Label 4489: @236365
     /* 236365 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236407), // Rule ID 2881 //
     /* 236370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 236378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 236397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236405 */     GIR_RootConstrainSelectedInstOperands,
     /* 236406 */     // GIR_Coverage, 2881,
     /* 236406 */     GIR_EraseRootFromParent_Done,
     /* 236407 */   // Label 4490: @236407
     /* 236407 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236449), // Rule ID 2882 //
     /* 236412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 236420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1406:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 236439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236447 */     GIR_RootConstrainSelectedInstOperands,
     /* 236448 */     // GIR_Coverage, 2882,
     /* 236448 */     GIR_EraseRootFromParent_Done,
     /* 236449 */   // Label 4491: @236449
     /* 236449 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(236491), // Rule ID 2883 //
     /* 236454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 236462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1412:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 236481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236489 */     GIR_RootConstrainSelectedInstOperands,
     /* 236490 */     // GIR_Coverage, 2883,
     /* 236490 */     GIR_EraseRootFromParent_Done,
     /* 236491 */   // Label 4492: @236491
     /* 236491 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(236533), // Rule ID 2884 //
     /* 236496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 236523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236531 */     GIR_RootConstrainSelectedInstOperands,
     /* 236532 */     // GIR_Coverage, 2884,
     /* 236532 */     GIR_EraseRootFromParent_Done,
     /* 236533 */   // Label 4493: @236533
     /* 236533 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(236575), // Rule ID 2885 //
     /* 236538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 236565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236573 */     GIR_RootConstrainSelectedInstOperands,
     /* 236574 */     // GIR_Coverage, 2885,
     /* 236574 */     GIR_EraseRootFromParent_Done,
     /* 236575 */   // Label 4494: @236575
     /* 236575 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(236617), // Rule ID 2886 //
     /* 236580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 236607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236615 */     GIR_RootConstrainSelectedInstOperands,
     /* 236616 */     // GIR_Coverage, 2886,
     /* 236616 */     GIR_EraseRootFromParent_Done,
     /* 236617 */   // Label 4495: @236617
     /* 236617 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(236659), // Rule ID 2897 //
     /* 236622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 236630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236646 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1398:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 236649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236657 */     GIR_RootConstrainSelectedInstOperands,
     /* 236658 */     // GIR_Coverage, 2897,
     /* 236658 */     GIR_EraseRootFromParent_Done,
     /* 236659 */   // Label 4496: @236659
     /* 236659 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(236701), // Rule ID 2899 //
     /* 236664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 236672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236688 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1396:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 236691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236699 */     GIR_RootConstrainSelectedInstOperands,
     /* 236700 */     // GIR_Coverage, 2899,
     /* 236700 */     GIR_EraseRootFromParent_Done,
     /* 236701 */   // Label 4497: @236701
     /* 236701 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(236743), // Rule ID 2907 //
     /* 236706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1433:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 236733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236741 */     GIR_RootConstrainSelectedInstOperands,
     /* 236742 */     // GIR_Coverage, 2907,
     /* 236742 */     GIR_EraseRootFromParent_Done,
     /* 236743 */   // Label 4498: @236743
     /* 236743 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(236785), // Rule ID 2908 //
     /* 236748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1433:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 236775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236783 */     GIR_RootConstrainSelectedInstOperands,
     /* 236784 */     // GIR_Coverage, 2908,
     /* 236784 */     GIR_EraseRootFromParent_Done,
     /* 236785 */   // Label 4499: @236785
     /* 236785 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(236827), // Rule ID 2909 //
     /* 236790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1433:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 236817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236825 */     GIR_RootConstrainSelectedInstOperands,
     /* 236826 */     // GIR_Coverage, 2909,
     /* 236826 */     GIR_EraseRootFromParent_Done,
     /* 236827 */   // Label 4500: @236827
     /* 236827 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(236869), // Rule ID 2913 //
     /* 236832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 236840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 236859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236867 */     GIR_RootConstrainSelectedInstOperands,
     /* 236868 */     // GIR_Coverage, 2913,
     /* 236868 */     GIR_EraseRootFromParent_Done,
     /* 236869 */   // Label 4501: @236869
     /* 236869 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(236911), // Rule ID 2958 //
     /* 236874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1716:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 236901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236909 */     GIR_RootConstrainSelectedInstOperands,
     /* 236910 */     // GIR_Coverage, 2958,
     /* 236910 */     GIR_EraseRootFromParent_Done,
     /* 236911 */   // Label 4502: @236911
     /* 236911 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236953), // Rule ID 2959 //
     /* 236916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1716:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 236943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236951 */     GIR_RootConstrainSelectedInstOperands,
     /* 236952 */     // GIR_Coverage, 2959,
     /* 236952 */     GIR_EraseRootFromParent_Done,
     /* 236953 */   // Label 4503: @236953
     /* 236953 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236995), // Rule ID 2988 //
     /* 236958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 236985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236993 */     GIR_RootConstrainSelectedInstOperands,
     /* 236994 */     // GIR_Coverage, 2988,
     /* 236994 */     GIR_EraseRootFromParent_Done,
     /* 236995 */   // Label 4504: @236995
     /* 236995 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(237037), // Rule ID 2989 //
     /* 237000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 237008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 237027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237035 */     GIR_RootConstrainSelectedInstOperands,
     /* 237036 */     // GIR_Coverage, 2989,
     /* 237036 */     GIR_EraseRootFromParent_Done,
     /* 237037 */   // Label 4505: @237037
     /* 237037 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(237079), // Rule ID 2990 //
     /* 237042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 237050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 237069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237077 */     GIR_RootConstrainSelectedInstOperands,
     /* 237078 */     // GIR_Coverage, 2990,
     /* 237078 */     GIR_EraseRootFromParent_Done,
     /* 237079 */   // Label 4506: @237079
     /* 237079 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(237121), // Rule ID 2991 //
     /* 237084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 237092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 237111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237119 */     GIR_RootConstrainSelectedInstOperands,
     /* 237120 */     // GIR_Coverage, 2991,
     /* 237120 */     GIR_EraseRootFromParent_Done,
     /* 237121 */   // Label 4507: @237121
     /* 237121 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237163), // Rule ID 2992 //
     /* 237126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 237134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 237153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237161 */     GIR_RootConstrainSelectedInstOperands,
     /* 237162 */     // GIR_Coverage, 2992,
     /* 237162 */     GIR_EraseRootFromParent_Done,
     /* 237163 */   // Label 4508: @237163
     /* 237163 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237205), // Rule ID 2993 //
     /* 237168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 237176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 237195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237203 */     GIR_RootConstrainSelectedInstOperands,
     /* 237204 */     // GIR_Coverage, 2993,
     /* 237204 */     GIR_EraseRootFromParent_Done,
     /* 237205 */   // Label 4509: @237205
     /* 237205 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237247), // Rule ID 2994 //
     /* 237210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 237218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 237237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237245 */     GIR_RootConstrainSelectedInstOperands,
     /* 237246 */     // GIR_Coverage, 2994,
     /* 237246 */     GIR_EraseRootFromParent_Done,
     /* 237247 */   // Label 4510: @237247
     /* 237247 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237289), // Rule ID 3024 //
     /* 237252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 237279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237287 */     GIR_RootConstrainSelectedInstOperands,
     /* 237288 */     // GIR_Coverage, 3024,
     /* 237288 */     GIR_EraseRootFromParent_Done,
     /* 237289 */   // Label 4511: @237289
     /* 237289 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237331), // Rule ID 3026 //
     /* 237294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 237321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237329 */     GIR_RootConstrainSelectedInstOperands,
     /* 237330 */     // GIR_Coverage, 3026,
     /* 237330 */     GIR_EraseRootFromParent_Done,
     /* 237331 */   // Label 4512: @237331
     /* 237331 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237373), // Rule ID 3028 //
     /* 237336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 237363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237371 */     GIR_RootConstrainSelectedInstOperands,
     /* 237372 */     // GIR_Coverage, 3028,
     /* 237372 */     GIR_EraseRootFromParent_Done,
     /* 237373 */   // Label 4513: @237373
     /* 237373 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237415), // Rule ID 3030 //
     /* 237378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 237405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237413 */     GIR_RootConstrainSelectedInstOperands,
     /* 237414 */     // GIR_Coverage, 3030,
     /* 237414 */     GIR_EraseRootFromParent_Done,
     /* 237415 */   // Label 4514: @237415
     /* 237415 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(237457), // Rule ID 3032 //
     /* 237420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 237447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237455 */     GIR_RootConstrainSelectedInstOperands,
     /* 237456 */     // GIR_Coverage, 3032,
     /* 237456 */     GIR_EraseRootFromParent_Done,
     /* 237457 */   // Label 4515: @237457
     /* 237457 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(237499), // Rule ID 3033 //
     /* 237462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 237489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237497 */     GIR_RootConstrainSelectedInstOperands,
     /* 237498 */     // GIR_Coverage, 3033,
     /* 237498 */     GIR_EraseRootFromParent_Done,
     /* 237499 */   // Label 4516: @237499
     /* 237499 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(237541), // Rule ID 3034 //
     /* 237504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 237531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237539 */     GIR_RootConstrainSelectedInstOperands,
     /* 237540 */     // GIR_Coverage, 3034,
     /* 237540 */     GIR_EraseRootFromParent_Done,
     /* 237541 */   // Label 4517: @237541
     /* 237541 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(237583), // Rule ID 3035 //
     /* 237546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 237554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 237573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237581 */     GIR_RootConstrainSelectedInstOperands,
     /* 237582 */     // GIR_Coverage, 3035,
     /* 237582 */     GIR_EraseRootFromParent_Done,
     /* 237583 */   // Label 4518: @237583
     /* 237583 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(237625), // Rule ID 3036 //
     /* 237588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 237615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237623 */     GIR_RootConstrainSelectedInstOperands,
     /* 237624 */     // GIR_Coverage, 3036,
     /* 237624 */     GIR_EraseRootFromParent_Done,
     /* 237625 */   // Label 4519: @237625
     /* 237625 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(237667), // Rule ID 3037 //
     /* 237630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 237657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237665 */     GIR_RootConstrainSelectedInstOperands,
     /* 237666 */     // GIR_Coverage, 3037,
     /* 237666 */     GIR_EraseRootFromParent_Done,
     /* 237667 */   // Label 4520: @237667
     /* 237667 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(237709), // Rule ID 3038 //
     /* 237672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 237699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237707 */     GIR_RootConstrainSelectedInstOperands,
     /* 237708 */     // GIR_Coverage, 3038,
     /* 237708 */     GIR_EraseRootFromParent_Done,
     /* 237709 */   // Label 4521: @237709
     /* 237709 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(237751), // Rule ID 3039 //
     /* 237714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 237741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237749 */     GIR_RootConstrainSelectedInstOperands,
     /* 237750 */     // GIR_Coverage, 3039,
     /* 237750 */     GIR_EraseRootFromParent_Done,
     /* 237751 */   // Label 4522: @237751
     /* 237751 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(237793), // Rule ID 3056 //
     /* 237756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1362:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 237783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237791 */     GIR_RootConstrainSelectedInstOperands,
     /* 237792 */     // GIR_Coverage, 3056,
     /* 237792 */     GIR_EraseRootFromParent_Done,
     /* 237793 */   // Label 4523: @237793
     /* 237793 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(237835), // Rule ID 3057 //
     /* 237798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1362:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 237825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237833 */     GIR_RootConstrainSelectedInstOperands,
     /* 237834 */     // GIR_Coverage, 3057,
     /* 237834 */     GIR_EraseRootFromParent_Done,
     /* 237835 */   // Label 4524: @237835
     /* 237835 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(237877), // Rule ID 3058 //
     /* 237840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1362:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 237867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237875 */     GIR_RootConstrainSelectedInstOperands,
     /* 237876 */     // GIR_Coverage, 3058,
     /* 237876 */     GIR_EraseRootFromParent_Done,
     /* 237877 */   // Label 4525: @237877
     /* 237877 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(237919), // Rule ID 3059 //
     /* 237882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1362:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 237909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237917 */     GIR_RootConstrainSelectedInstOperands,
     /* 237918 */     // GIR_Coverage, 3059,
     /* 237918 */     GIR_EraseRootFromParent_Done,
     /* 237919 */   // Label 4526: @237919
     /* 237919 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237961), // Rule ID 3083 //
     /* 237924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 237951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237959 */     GIR_RootConstrainSelectedInstOperands,
     /* 237960 */     // GIR_Coverage, 3083,
     /* 237960 */     GIR_EraseRootFromParent_Done,
     /* 237961 */   // Label 4527: @237961
     /* 237961 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(238003), // Rule ID 3085 //
     /* 237966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 237993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238001 */     GIR_RootConstrainSelectedInstOperands,
     /* 238002 */     // GIR_Coverage, 3085,
     /* 238002 */     GIR_EraseRootFromParent_Done,
     /* 238003 */   // Label 4528: @238003
     /* 238003 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(238045), // Rule ID 3087 //
     /* 238008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 238016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 238035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238043 */     GIR_RootConstrainSelectedInstOperands,
     /* 238044 */     // GIR_Coverage, 3087,
     /* 238044 */     GIR_EraseRootFromParent_Done,
     /* 238045 */   // Label 4529: @238045
     /* 238045 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(238087), // Rule ID 3089 //
     /* 238050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 238058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 238077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238085 */     GIR_RootConstrainSelectedInstOperands,
     /* 238086 */     // GIR_Coverage, 3089,
     /* 238086 */     GIR_EraseRootFromParent_Done,
     /* 238087 */   // Label 4530: @238087
     /* 238087 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(238129), // Rule ID 3091 //
     /* 238092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 238100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 238119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238127 */     GIR_RootConstrainSelectedInstOperands,
     /* 238128 */     // GIR_Coverage, 3091,
     /* 238128 */     GIR_EraseRootFromParent_Done,
     /* 238129 */   // Label 4531: @238129
     /* 238129 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238171), // Rule ID 3092 //
     /* 238134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 238142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 238161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238169 */     GIR_RootConstrainSelectedInstOperands,
     /* 238170 */     // GIR_Coverage, 3092,
     /* 238170 */     GIR_EraseRootFromParent_Done,
     /* 238171 */   // Label 4532: @238171
     /* 238171 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238213), // Rule ID 3093 //
     /* 238176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 238184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 238203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238211 */     GIR_RootConstrainSelectedInstOperands,
     /* 238212 */     // GIR_Coverage, 3093,
     /* 238212 */     GIR_EraseRootFromParent_Done,
     /* 238213 */   // Label 4533: @238213
     /* 238213 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238255), // Rule ID 3094 //
     /* 238218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 238226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 238245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238253 */     GIR_RootConstrainSelectedInstOperands,
     /* 238254 */     // GIR_Coverage, 3094,
     /* 238254 */     GIR_EraseRootFromParent_Done,
     /* 238255 */   // Label 4534: @238255
     /* 238255 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238297), // Rule ID 3095 //
     /* 238260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 238268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 238287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238295 */     GIR_RootConstrainSelectedInstOperands,
     /* 238296 */     // GIR_Coverage, 3095,
     /* 238296 */     GIR_EraseRootFromParent_Done,
     /* 238297 */   // Label 4535: @238297
     /* 238297 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238339), // Rule ID 3105 //
     /* 238302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 238310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 238329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238337 */     GIR_RootConstrainSelectedInstOperands,
     /* 238338 */     // GIR_Coverage, 3105,
     /* 238338 */     GIR_EraseRootFromParent_Done,
     /* 238339 */   // Label 4536: @238339
     /* 238339 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238381), // Rule ID 3106 //
     /* 238344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 238352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1261:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 238371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238379 */     GIR_RootConstrainSelectedInstOperands,
     /* 238380 */     // GIR_Coverage, 3106,
     /* 238380 */     GIR_EraseRootFromParent_Done,
     /* 238381 */   // Label 4537: @238381
     /* 238381 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238423), // Rule ID 3107 //
     /* 238386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 238394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 238413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238421 */     GIR_RootConstrainSelectedInstOperands,
     /* 238422 */     // GIR_Coverage, 3107,
     /* 238422 */     GIR_EraseRootFromParent_Done,
     /* 238423 */   // Label 4538: @238423
     /* 238423 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(238465), // Rule ID 3124 //
     /* 238428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 238445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 238452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 238455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238463 */     GIR_RootConstrainSelectedInstOperands,
     /* 238464 */     // GIR_Coverage, 3124,
     /* 238464 */     GIR_EraseRootFromParent_Done,
     /* 238465 */   // Label 4539: @238465
     /* 238465 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(238507), // Rule ID 3125 //
     /* 238470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 238487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 238494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 238497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238505 */     GIR_RootConstrainSelectedInstOperands,
     /* 238506 */     // GIR_Coverage, 3125,
     /* 238506 */     GIR_EraseRootFromParent_Done,
     /* 238507 */   // Label 4540: @238507
     /* 238507 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(238549), // Rule ID 3126 //
     /* 238512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 238536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 238539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238547 */     GIR_RootConstrainSelectedInstOperands,
     /* 238548 */     // GIR_Coverage, 3126,
     /* 238548 */     GIR_EraseRootFromParent_Done,
     /* 238549 */   // Label 4541: @238549
     /* 238549 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(238591), // Rule ID 3127 //
     /* 238554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 238578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 238581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238589 */     GIR_RootConstrainSelectedInstOperands,
     /* 238590 */     // GIR_Coverage, 3127,
     /* 238590 */     GIR_EraseRootFromParent_Done,
     /* 238591 */   // Label 4542: @238591
     /* 238591 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(238633), // Rule ID 3162 //
     /* 238596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238631 */     GIR_RootConstrainSelectedInstOperands,
     /* 238632 */     // GIR_Coverage, 3162,
     /* 238632 */     GIR_EraseRootFromParent_Done,
     /* 238633 */   // Label 4543: @238633
     /* 238633 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(238675), // Rule ID 3164 //
     /* 238638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238673 */     GIR_RootConstrainSelectedInstOperands,
     /* 238674 */     // GIR_Coverage, 3164,
     /* 238674 */     GIR_EraseRootFromParent_Done,
     /* 238675 */   // Label 4544: @238675
     /* 238675 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(238717), // Rule ID 3166 //
     /* 238680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238715 */     GIR_RootConstrainSelectedInstOperands,
     /* 238716 */     // GIR_Coverage, 3166,
     /* 238716 */     GIR_EraseRootFromParent_Done,
     /* 238717 */   // Label 4545: @238717
     /* 238717 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(238759), // Rule ID 3168 //
     /* 238722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238757 */     GIR_RootConstrainSelectedInstOperands,
     /* 238758 */     // GIR_Coverage, 3168,
     /* 238758 */     GIR_EraseRootFromParent_Done,
     /* 238759 */   // Label 4546: @238759
     /* 238759 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(238804), // Rule ID 3211 //
     /* 238764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 238791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238802 */     GIR_RootConstrainSelectedInstOperands,
     /* 238803 */     // GIR_Coverage, 3211,
     /* 238803 */     GIR_EraseRootFromParent_Done,
     /* 238804 */   // Label 4547: @238804
     /* 238804 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(238849), // Rule ID 3212 //
     /* 238809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 238836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238847 */     GIR_RootConstrainSelectedInstOperands,
     /* 238848 */     // GIR_Coverage, 3212,
     /* 238848 */     GIR_EraseRootFromParent_Done,
     /* 238849 */   // Label 4548: @238849
     /* 238849 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(238894), // Rule ID 3213 //
     /* 238854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 238881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238892 */     GIR_RootConstrainSelectedInstOperands,
     /* 238893 */     // GIR_Coverage, 3213,
     /* 238893 */     GIR_EraseRootFromParent_Done,
     /* 238894 */   // Label 4549: @238894
     /* 238894 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238939), // Rule ID 3214 //
     /* 238899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238923 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 238926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238937 */     GIR_RootConstrainSelectedInstOperands,
     /* 238938 */     // GIR_Coverage, 3214,
     /* 238938 */     GIR_EraseRootFromParent_Done,
     /* 238939 */   // Label 4550: @238939
     /* 238939 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238984), // Rule ID 3215 //
     /* 238944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 238971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238982 */     GIR_RootConstrainSelectedInstOperands,
     /* 238983 */     // GIR_Coverage, 3215,
     /* 238983 */     GIR_EraseRootFromParent_Done,
     /* 238984 */   // Label 4551: @238984
     /* 238984 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(239029), // Rule ID 3216 //
     /* 238989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 239000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239013 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239027 */     GIR_RootConstrainSelectedInstOperands,
     /* 239028 */     // GIR_Coverage, 3216,
     /* 239028 */     GIR_EraseRootFromParent_Done,
     /* 239029 */   // Label 4552: @239029
     /* 239029 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(239071), // Rule ID 3271 //
     /* 239034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 239042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 239045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 239061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239069 */     GIR_RootConstrainSelectedInstOperands,
     /* 239070 */     // GIR_Coverage, 3271,
     /* 239070 */     GIR_EraseRootFromParent_Done,
     /* 239071 */   // Label 4553: @239071
     /* 239071 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(239113), // Rule ID 3272 //
     /* 239076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 239084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 239087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 239103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239111 */     GIR_RootConstrainSelectedInstOperands,
     /* 239112 */     // GIR_Coverage, 3272,
     /* 239112 */     GIR_EraseRootFromParent_Done,
     /* 239113 */   // Label 4554: @239113
     /* 239113 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239155), // Rule ID 3273 //
     /* 239118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 239126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 239129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 239145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239153 */     GIR_RootConstrainSelectedInstOperands,
     /* 239154 */     // GIR_Coverage, 3273,
     /* 239154 */     GIR_EraseRootFromParent_Done,
     /* 239155 */   // Label 4555: @239155
     /* 239155 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239197), // Rule ID 3325 //
     /* 239160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 239168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1277:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 239187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239195 */     GIR_RootConstrainSelectedInstOperands,
     /* 239196 */     // GIR_Coverage, 3325,
     /* 239196 */     GIR_EraseRootFromParent_Done,
     /* 239197 */   // Label 4556: @239197
     /* 239197 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239239), // Rule ID 3326 //
     /* 239202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 239210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 239229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239237 */     GIR_RootConstrainSelectedInstOperands,
     /* 239238 */     // GIR_Coverage, 3326,
     /* 239238 */     GIR_EraseRootFromParent_Done,
     /* 239239 */   // Label 4557: @239239
     /* 239239 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239281), // Rule ID 3327 //
     /* 239244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 239252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 239271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239279 */     GIR_RootConstrainSelectedInstOperands,
     /* 239280 */     // GIR_Coverage, 3327,
     /* 239280 */     GIR_EraseRootFromParent_Done,
     /* 239281 */   // Label 4558: @239281
     /* 239281 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239323), // Rule ID 3328 //
     /* 239286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 239294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 239313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239321 */     GIR_RootConstrainSelectedInstOperands,
     /* 239322 */     // GIR_Coverage, 3328,
     /* 239322 */     GIR_EraseRootFromParent_Done,
     /* 239323 */   // Label 4559: @239323
     /* 239323 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239365), // Rule ID 3337 //
     /* 239328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 239336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 239355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239363 */     GIR_RootConstrainSelectedInstOperands,
     /* 239364 */     // GIR_Coverage, 3337,
     /* 239364 */     GIR_EraseRootFromParent_Done,
     /* 239365 */   // Label 4560: @239365
     /* 239365 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239407), // Rule ID 3338 //
     /* 239370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 239378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 239397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239405 */     GIR_RootConstrainSelectedInstOperands,
     /* 239406 */     // GIR_Coverage, 3338,
     /* 239406 */     GIR_EraseRootFromParent_Done,
     /* 239407 */   // Label 4561: @239407
     /* 239407 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239449), // Rule ID 3339 //
     /* 239412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 239420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 239439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239447 */     GIR_RootConstrainSelectedInstOperands,
     /* 239448 */     // GIR_Coverage, 3339,
     /* 239448 */     GIR_EraseRootFromParent_Done,
     /* 239449 */   // Label 4562: @239449
     /* 239449 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(239491), // Rule ID 3378 //
     /* 239454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 239481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239489 */     GIR_RootConstrainSelectedInstOperands,
     /* 239490 */     // GIR_Coverage, 3378,
     /* 239490 */     GIR_EraseRootFromParent_Done,
     /* 239491 */   // Label 4563: @239491
     /* 239491 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(239533), // Rule ID 3379 //
     /* 239496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239531 */     GIR_RootConstrainSelectedInstOperands,
     /* 239532 */     // GIR_Coverage, 3379,
     /* 239532 */     GIR_EraseRootFromParent_Done,
     /* 239533 */   // Label 4564: @239533
     /* 239533 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(239575), // Rule ID 3380 //
     /* 239538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239573 */     GIR_RootConstrainSelectedInstOperands,
     /* 239574 */     // GIR_Coverage, 3380,
     /* 239574 */     GIR_EraseRootFromParent_Done,
     /* 239575 */   // Label 4565: @239575
     /* 239575 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(239617), // Rule ID 3381 //
     /* 239580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239615 */     GIR_RootConstrainSelectedInstOperands,
     /* 239616 */     // GIR_Coverage, 3381,
     /* 239616 */     GIR_EraseRootFromParent_Done,
     /* 239617 */   // Label 4566: @239617
     /* 239617 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(239659), // Rule ID 3382 //
     /* 239622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239646 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239657 */     GIR_RootConstrainSelectedInstOperands,
     /* 239658 */     // GIR_Coverage, 3382,
     /* 239658 */     GIR_EraseRootFromParent_Done,
     /* 239659 */   // Label 4567: @239659
     /* 239659 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(239701), // Rule ID 3383 //
     /* 239664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239688 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239699 */     GIR_RootConstrainSelectedInstOperands,
     /* 239700 */     // GIR_Coverage, 3383,
     /* 239700 */     GIR_EraseRootFromParent_Done,
     /* 239701 */   // Label 4568: @239701
     /* 239701 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(239743), // Rule ID 3384 //
     /* 239706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239730 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239741 */     GIR_RootConstrainSelectedInstOperands,
     /* 239742 */     // GIR_Coverage, 3384,
     /* 239742 */     GIR_EraseRootFromParent_Done,
     /* 239743 */   // Label 4569: @239743
     /* 239743 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(239785), // Rule ID 3470 //
     /* 239748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 239756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 239775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239783 */     GIR_RootConstrainSelectedInstOperands,
     /* 239784 */     // GIR_Coverage, 3470,
     /* 239784 */     GIR_EraseRootFromParent_Done,
     /* 239785 */   // Label 4570: @239785
     /* 239785 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(239827), // Rule ID 3471 //
     /* 239790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 239798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 239817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 239819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239825 */     GIR_RootConstrainSelectedInstOperands,
     /* 239826 */     // GIR_Coverage, 3471,
     /* 239826 */     GIR_EraseRootFromParent_Done,
     /* 239827 */   // Label 4571: @239827
     /* 239827 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(239869), // Rule ID 3472 //
     /* 239832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 239840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 239859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239867 */     GIR_RootConstrainSelectedInstOperands,
     /* 239868 */     // GIR_Coverage, 3472,
     /* 239868 */     GIR_EraseRootFromParent_Done,
     /* 239869 */   // Label 4572: @239869
     /* 239869 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(239914), // Rule ID 3474 //
     /* 239874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 239901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239912 */     GIR_RootConstrainSelectedInstOperands,
     /* 239913 */     // GIR_Coverage, 3474,
     /* 239913 */     GIR_EraseRootFromParent_Done,
     /* 239914 */   // Label 4573: @239914
     /* 239914 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239959), // Rule ID 3475 //
     /* 239919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 239930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 239946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239957 */     GIR_RootConstrainSelectedInstOperands,
     /* 239958 */     // GIR_Coverage, 3475,
     /* 239958 */     GIR_EraseRootFromParent_Done,
     /* 239959 */   // Label 4574: @239959
     /* 239959 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(240001), // Rule ID 3476 //
     /* 239964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1555:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 239991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239999 */     GIR_RootConstrainSelectedInstOperands,
     /* 240000 */     // GIR_Coverage, 3476,
     /* 240000 */     GIR_EraseRootFromParent_Done,
     /* 240001 */   // Label 4575: @240001
     /* 240001 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(240043), // Rule ID 3477 //
     /* 240006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 240009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 240014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1555:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 240033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240041 */     GIR_RootConstrainSelectedInstOperands,
     /* 240042 */     // GIR_Coverage, 3477,
     /* 240042 */     GIR_EraseRootFromParent_Done,
     /* 240043 */   // Label 4576: @240043
     /* 240043 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(240085), // Rule ID 3481 //
     /* 240048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 240051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 240056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 240075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240083 */     GIR_RootConstrainSelectedInstOperands,
     /* 240084 */     // GIR_Coverage, 3481,
     /* 240084 */     GIR_EraseRootFromParent_Done,
     /* 240085 */   // Label 4577: @240085
     /* 240085 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(240127), // Rule ID 3526 //
     /* 240090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 240098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 240117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240125 */     GIR_RootConstrainSelectedInstOperands,
     /* 240126 */     // GIR_Coverage, 3526,
     /* 240126 */     GIR_EraseRootFromParent_Done,
     /* 240127 */   // Label 4578: @240127
     /* 240127 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240169), // Rule ID 3528 //
     /* 240132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 240140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240156 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 240159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240167 */     GIR_RootConstrainSelectedInstOperands,
     /* 240168 */     // GIR_Coverage, 3528,
     /* 240168 */     GIR_EraseRootFromParent_Done,
     /* 240169 */   // Label 4579: @240169
     /* 240169 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240211), // Rule ID 3530 //
     /* 240174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 240182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240198 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 240201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240209 */     GIR_RootConstrainSelectedInstOperands,
     /* 240210 */     // GIR_Coverage, 3530,
     /* 240210 */     GIR_EraseRootFromParent_Done,
     /* 240211 */   // Label 4580: @240211
     /* 240211 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240253), // Rule ID 3532 //
     /* 240216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 240224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 240243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240251 */     GIR_RootConstrainSelectedInstOperands,
     /* 240252 */     // GIR_Coverage, 3532,
     /* 240252 */     GIR_EraseRootFromParent_Done,
     /* 240253 */   // Label 4581: @240253
     /* 240253 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240295), // Rule ID 3659 //
     /* 240258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 240285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240293 */     GIR_RootConstrainSelectedInstOperands,
     /* 240294 */     // GIR_Coverage, 3659,
     /* 240294 */     GIR_EraseRootFromParent_Done,
     /* 240295 */   // Label 4582: @240295
     /* 240295 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240337), // Rule ID 3661 //
     /* 240300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 240327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240335 */     GIR_RootConstrainSelectedInstOperands,
     /* 240336 */     // GIR_Coverage, 3661,
     /* 240336 */     GIR_EraseRootFromParent_Done,
     /* 240337 */   // Label 4583: @240337
     /* 240337 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240379), // Rule ID 3663 //
     /* 240342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 240369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240377 */     GIR_RootConstrainSelectedInstOperands,
     /* 240378 */     // GIR_Coverage, 3663,
     /* 240378 */     GIR_EraseRootFromParent_Done,
     /* 240379 */   // Label 4584: @240379
     /* 240379 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240421), // Rule ID 3665 //
     /* 240384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 240411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240419 */     GIR_RootConstrainSelectedInstOperands,
     /* 240420 */     // GIR_Coverage, 3665,
     /* 240420 */     GIR_EraseRootFromParent_Done,
     /* 240421 */   // Label 4585: @240421
     /* 240421 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(240463), // Rule ID 7586 //
     /* 240426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 240453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240461 */     GIR_RootConstrainSelectedInstOperands,
     /* 240462 */     // GIR_Coverage, 7586,
     /* 240462 */     GIR_EraseRootFromParent_Done,
     /* 240463 */   // Label 4586: @240463
     /* 240463 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(240505), // Rule ID 7588 //
     /* 240468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 240495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240503 */     GIR_RootConstrainSelectedInstOperands,
     /* 240504 */     // GIR_Coverage, 7588,
     /* 240504 */     GIR_EraseRootFromParent_Done,
     /* 240505 */   // Label 4587: @240505
     /* 240505 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(240547), // Rule ID 7590 //
     /* 240510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 240537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240545 */     GIR_RootConstrainSelectedInstOperands,
     /* 240546 */     // GIR_Coverage, 7590,
     /* 240546 */     GIR_EraseRootFromParent_Done,
     /* 240547 */   // Label 4588: @240547
     /* 240547 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(240589), // Rule ID 7592 //
     /* 240552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 240579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240587 */     GIR_RootConstrainSelectedInstOperands,
     /* 240588 */     // GIR_Coverage, 7592,
     /* 240588 */     GIR_EraseRootFromParent_Done,
     /* 240589 */   // Label 4589: @240589
     /* 240589 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(240631), // Rule ID 7610 //
     /* 240594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 240621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240629 */     GIR_RootConstrainSelectedInstOperands,
     /* 240630 */     // GIR_Coverage, 7610,
     /* 240630 */     GIR_EraseRootFromParent_Done,
     /* 240631 */   // Label 4590: @240631
     /* 240631 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(240673), // Rule ID 7611 //
     /* 240636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 240663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240671 */     GIR_RootConstrainSelectedInstOperands,
     /* 240672 */     // GIR_Coverage, 7611,
     /* 240672 */     GIR_EraseRootFromParent_Done,
     /* 240673 */   // Label 4591: @240673
     /* 240673 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(240715), // Rule ID 7612 //
     /* 240678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 240705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240713 */     GIR_RootConstrainSelectedInstOperands,
     /* 240714 */     // GIR_Coverage, 7612,
     /* 240714 */     GIR_EraseRootFromParent_Done,
     /* 240715 */   // Label 4592: @240715
     /* 240715 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(240757), // Rule ID 7613 //
     /* 240720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 240747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240755 */     GIR_RootConstrainSelectedInstOperands,
     /* 240756 */     // GIR_Coverage, 7613,
     /* 240756 */     GIR_EraseRootFromParent_Done,
     /* 240757 */   // Label 4593: @240757
     /* 240757 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(240799), // Rule ID 7726 //
     /* 240762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1762:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 240789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240797 */     GIR_RootConstrainSelectedInstOperands,
     /* 240798 */     // GIR_Coverage, 7726,
     /* 240798 */     GIR_EraseRootFromParent_Done,
     /* 240799 */   // Label 4594: @240799
     /* 240799 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(240841), // Rule ID 7727 //
     /* 240804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 240831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240839 */     GIR_RootConstrainSelectedInstOperands,
     /* 240840 */     // GIR_Coverage, 7727,
     /* 240840 */     GIR_EraseRootFromParent_Done,
     /* 240841 */   // Label 4595: @240841
     /* 240841 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(240883), // Rule ID 7728 //
     /* 240846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 240873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240881 */     GIR_RootConstrainSelectedInstOperands,
     /* 240882 */     // GIR_Coverage, 7728,
     /* 240882 */     GIR_EraseRootFromParent_Done,
     /* 240883 */   // Label 4596: @240883
     /* 240883 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(240925), // Rule ID 7729 //
     /* 240888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 240915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240923 */     GIR_RootConstrainSelectedInstOperands,
     /* 240924 */     // GIR_Coverage, 7729,
     /* 240924 */     GIR_EraseRootFromParent_Done,
     /* 240925 */   // Label 4597: @240925
     /* 240925 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240967), // Rule ID 7730 //
     /* 240930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2000:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 240957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240965 */     GIR_RootConstrainSelectedInstOperands,
     /* 240966 */     // GIR_Coverage, 7730,
     /* 240966 */     GIR_EraseRootFromParent_Done,
     /* 240967 */   // Label 4598: @240967
     /* 240967 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(241009), // Rule ID 7731 //
     /* 240972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2000:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 240999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241007 */     GIR_RootConstrainSelectedInstOperands,
     /* 241008 */     // GIR_Coverage, 7731,
     /* 241008 */     GIR_EraseRootFromParent_Done,
     /* 241009 */   // Label 4599: @241009
     /* 241009 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(241051), // Rule ID 7732 //
     /* 241014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 241022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 241041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241049 */     GIR_RootConstrainSelectedInstOperands,
     /* 241050 */     // GIR_Coverage, 7732,
     /* 241050 */     GIR_EraseRootFromParent_Done,
     /* 241051 */   // Label 4600: @241051
     /* 241051 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(241093), // Rule ID 7733 //
     /* 241056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 241064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 241083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241091 */     GIR_RootConstrainSelectedInstOperands,
     /* 241092 */     // GIR_Coverage, 7733,
     /* 241092 */     GIR_EraseRootFromParent_Done,
     /* 241093 */   // Label 4601: @241093
     /* 241093 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241135), // Rule ID 7742 //
     /* 241098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 241106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 241125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241133 */     GIR_RootConstrainSelectedInstOperands,
     /* 241134 */     // GIR_Coverage, 7742,
     /* 241134 */     GIR_EraseRootFromParent_Done,
     /* 241135 */   // Label 4602: @241135
     /* 241135 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241177), // Rule ID 7743 //
     /* 241140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 241148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1963:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 241167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241175 */     GIR_RootConstrainSelectedInstOperands,
     /* 241176 */     // GIR_Coverage, 7743,
     /* 241176 */     GIR_EraseRootFromParent_Done,
     /* 241177 */   // Label 4603: @241177
     /* 241177 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241219), // Rule ID 7744 //
     /* 241182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 241190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 241209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241217 */     GIR_RootConstrainSelectedInstOperands,
     /* 241218 */     // GIR_Coverage, 7744,
     /* 241218 */     GIR_EraseRootFromParent_Done,
     /* 241219 */   // Label 4604: @241219
     /* 241219 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241261), // Rule ID 7745 //
     /* 241224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 241232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 241251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241259 */     GIR_RootConstrainSelectedInstOperands,
     /* 241260 */     // GIR_Coverage, 7745,
     /* 241260 */     GIR_EraseRootFromParent_Done,
     /* 241261 */   // Label 4605: @241261
     /* 241261 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241303), // Rule ID 7746 //
     /* 241266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 241274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 241293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241301 */     GIR_RootConstrainSelectedInstOperands,
     /* 241302 */     // GIR_Coverage, 7746,
     /* 241302 */     GIR_EraseRootFromParent_Done,
     /* 241303 */   // Label 4606: @241303
     /* 241303 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241345), // Rule ID 7747 //
     /* 241308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 241316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 241335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241343 */     GIR_RootConstrainSelectedInstOperands,
     /* 241344 */     // GIR_Coverage, 7747,
     /* 241344 */     GIR_EraseRootFromParent_Done,
     /* 241345 */   // Label 4607: @241345
     /* 241345 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241387), // Rule ID 7836 //
     /* 241350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 241374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 241377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241385 */     GIR_RootConstrainSelectedInstOperands,
     /* 241386 */     // GIR_Coverage, 7836,
     /* 241386 */     GIR_EraseRootFromParent_Done,
     /* 241387 */   // Label 4608: @241387
     /* 241387 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241429), // Rule ID 7837 //
     /* 241392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 241419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241427 */     GIR_RootConstrainSelectedInstOperands,
     /* 241428 */     // GIR_Coverage, 7837,
     /* 241428 */     GIR_EraseRootFromParent_Done,
     /* 241429 */   // Label 4609: @241429
     /* 241429 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(241471), // Rule ID 7838 //
     /* 241434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 241461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241469 */     GIR_RootConstrainSelectedInstOperands,
     /* 241470 */     // GIR_Coverage, 7838,
     /* 241470 */     GIR_EraseRootFromParent_Done,
     /* 241471 */   // Label 4610: @241471
     /* 241471 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(241513), // Rule ID 7839 //
     /* 241476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 241503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241511 */     GIR_RootConstrainSelectedInstOperands,
     /* 241512 */     // GIR_Coverage, 7839,
     /* 241512 */     GIR_EraseRootFromParent_Done,
     /* 241513 */   // Label 4611: @241513
     /* 241513 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(241555), // Rule ID 7848 //
     /* 241518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 241542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 241545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241553 */     GIR_RootConstrainSelectedInstOperands,
     /* 241554 */     // GIR_Coverage, 7848,
     /* 241554 */     GIR_EraseRootFromParent_Done,
     /* 241555 */   // Label 4612: @241555
     /* 241555 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(241597), // Rule ID 7849 //
     /* 241560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 241587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241595 */     GIR_RootConstrainSelectedInstOperands,
     /* 241596 */     // GIR_Coverage, 7849,
     /* 241596 */     GIR_EraseRootFromParent_Done,
     /* 241597 */   // Label 4613: @241597
     /* 241597 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(241639), // Rule ID 7850 //
     /* 241602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 241629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241637 */     GIR_RootConstrainSelectedInstOperands,
     /* 241638 */     // GIR_Coverage, 7850,
     /* 241638 */     GIR_EraseRootFromParent_Done,
     /* 241639 */   // Label 4614: @241639
     /* 241639 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(241681), // Rule ID 7851 //
     /* 241644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 241671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241679 */     GIR_RootConstrainSelectedInstOperands,
     /* 241680 */     // GIR_Coverage, 7851,
     /* 241680 */     GIR_EraseRootFromParent_Done,
     /* 241681 */   // Label 4615: @241681
     /* 241681 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(241723), // Rule ID 7930 //
     /* 241686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1693:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 241713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241721 */     GIR_RootConstrainSelectedInstOperands,
     /* 241722 */     // GIR_Coverage, 7930,
     /* 241722 */     GIR_EraseRootFromParent_Done,
     /* 241723 */   // Label 4616: @241723
     /* 241723 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(241765), // Rule ID 7931 //
     /* 241728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 241755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241763 */     GIR_RootConstrainSelectedInstOperands,
     /* 241764 */     // GIR_Coverage, 7931,
     /* 241764 */     GIR_EraseRootFromParent_Done,
     /* 241765 */   // Label 4617: @241765
     /* 241765 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(241807), // Rule ID 7932 //
     /* 241770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 241797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241805 */     GIR_RootConstrainSelectedInstOperands,
     /* 241806 */     // GIR_Coverage, 7932,
     /* 241806 */     GIR_EraseRootFromParent_Done,
     /* 241807 */   // Label 4618: @241807
     /* 241807 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(241849), // Rule ID 7933 //
     /* 241812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 241839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241847 */     GIR_RootConstrainSelectedInstOperands,
     /* 241848 */     // GIR_Coverage, 7933,
     /* 241848 */     GIR_EraseRootFromParent_Done,
     /* 241849 */   // Label 4619: @241849
     /* 241849 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(241891), // Rule ID 7934 //
     /* 241854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 241881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241889 */     GIR_RootConstrainSelectedInstOperands,
     /* 241890 */     // GIR_Coverage, 7934,
     /* 241890 */     GIR_EraseRootFromParent_Done,
     /* 241891 */   // Label 4620: @241891
     /* 241891 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(241933), // Rule ID 7935 //
     /* 241896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 241923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241931 */     GIR_RootConstrainSelectedInstOperands,
     /* 241932 */     // GIR_Coverage, 7935,
     /* 241932 */     GIR_EraseRootFromParent_Done,
     /* 241933 */   // Label 4621: @241933
     /* 241933 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241975), // Rule ID 7936 //
     /* 241938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 241965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241973 */     GIR_RootConstrainSelectedInstOperands,
     /* 241974 */     // GIR_Coverage, 7936,
     /* 241974 */     GIR_EraseRootFromParent_Done,
     /* 241975 */   // Label 4622: @241975
     /* 241975 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(242017), // Rule ID 7937 //
     /* 241980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 242007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242015 */     GIR_RootConstrainSelectedInstOperands,
     /* 242016 */     // GIR_Coverage, 7937,
     /* 242016 */     GIR_EraseRootFromParent_Done,
     /* 242017 */   // Label 4623: @242017
     /* 242017 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(242059), // Rule ID 8133 //
     /* 242022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 242030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242046 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 242049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242057 */     GIR_RootConstrainSelectedInstOperands,
     /* 242058 */     // GIR_Coverage, 8133,
     /* 242058 */     GIR_EraseRootFromParent_Done,
     /* 242059 */   // Label 4624: @242059
     /* 242059 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(242101), // Rule ID 8135 //
     /* 242064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 242072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 242091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242099 */     GIR_RootConstrainSelectedInstOperands,
     /* 242100 */     // GIR_Coverage, 8135,
     /* 242100 */     GIR_EraseRootFromParent_Done,
     /* 242101 */   // Label 4625: @242101
     /* 242101 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242143), // Rule ID 8137 //
     /* 242106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 242114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 242133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242141 */     GIR_RootConstrainSelectedInstOperands,
     /* 242142 */     // GIR_Coverage, 8137,
     /* 242142 */     GIR_EraseRootFromParent_Done,
     /* 242143 */   // Label 4626: @242143
     /* 242143 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242185), // Rule ID 8145 //
     /* 242148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 242156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242172 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 242175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242183 */     GIR_RootConstrainSelectedInstOperands,
     /* 242184 */     // GIR_Coverage, 8145,
     /* 242184 */     GIR_EraseRootFromParent_Done,
     /* 242185 */   // Label 4627: @242185
     /* 242185 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242227), // Rule ID 8147 //
     /* 242190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 242198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 242217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242225 */     GIR_RootConstrainSelectedInstOperands,
     /* 242226 */     // GIR_Coverage, 8147,
     /* 242226 */     GIR_EraseRootFromParent_Done,
     /* 242227 */   // Label 4628: @242227
     /* 242227 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242269), // Rule ID 8149 //
     /* 242232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 242240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 242259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242267 */     GIR_RootConstrainSelectedInstOperands,
     /* 242268 */     // GIR_Coverage, 8149,
     /* 242268 */     GIR_EraseRootFromParent_Done,
     /* 242269 */   // Label 4629: @242269
     /* 242269 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242311), // Rule ID 8187 //
     /* 242274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 242282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242298 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 242301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242309 */     GIR_RootConstrainSelectedInstOperands,
     /* 242310 */     // GIR_Coverage, 8187,
     /* 242310 */     GIR_EraseRootFromParent_Done,
     /* 242311 */   // Label 4630: @242311
     /* 242311 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242353), // Rule ID 8188 //
     /* 242316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 242324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242340 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 242343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242351 */     GIR_RootConstrainSelectedInstOperands,
     /* 242352 */     // GIR_Coverage, 8188,
     /* 242352 */     GIR_EraseRootFromParent_Done,
     /* 242353 */   // Label 4631: @242353
     /* 242353 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242395), // Rule ID 8189 //
     /* 242358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 242366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242382 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 242385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242393 */     GIR_RootConstrainSelectedInstOperands,
     /* 242394 */     // GIR_Coverage, 8189,
     /* 242394 */     GIR_EraseRootFromParent_Done,
     /* 242395 */   // Label 4632: @242395
     /* 242395 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242437), // Rule ID 8190 //
     /* 242400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 242427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242435 */     GIR_RootConstrainSelectedInstOperands,
     /* 242436 */     // GIR_Coverage, 8190,
     /* 242436 */     GIR_EraseRootFromParent_Done,
     /* 242437 */   // Label 4633: @242437
     /* 242437 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(242479), // Rule ID 8191 //
     /* 242442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242466 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 242469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242477 */     GIR_RootConstrainSelectedInstOperands,
     /* 242478 */     // GIR_Coverage, 8191,
     /* 242478 */     GIR_EraseRootFromParent_Done,
     /* 242479 */   // Label 4634: @242479
     /* 242479 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(242521), // Rule ID 8192 //
     /* 242484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242508 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 242511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242519 */     GIR_RootConstrainSelectedInstOperands,
     /* 242520 */     // GIR_Coverage, 8192,
     /* 242520 */     GIR_EraseRootFromParent_Done,
     /* 242521 */   // Label 4635: @242521
     /* 242521 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(242563), // Rule ID 8193 //
     /* 242526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242550 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 242553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242561 */     GIR_RootConstrainSelectedInstOperands,
     /* 242562 */     // GIR_Coverage, 8193,
     /* 242562 */     GIR_EraseRootFromParent_Done,
     /* 242563 */   // Label 4636: @242563
     /* 242563 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(242605), // Rule ID 8194 //
     /* 242568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 242595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242603 */     GIR_RootConstrainSelectedInstOperands,
     /* 242604 */     // GIR_Coverage, 8194,
     /* 242604 */     GIR_EraseRootFromParent_Done,
     /* 242605 */   // Label 4637: @242605
     /* 242605 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(242647), // Rule ID 8195 //
     /* 242610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242645 */     GIR_RootConstrainSelectedInstOperands,
     /* 242646 */     // GIR_Coverage, 8195,
     /* 242646 */     GIR_EraseRootFromParent_Done,
     /* 242647 */   // Label 4638: @242647
     /* 242647 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(242689), // Rule ID 8196 //
     /* 242652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242676 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 242679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242687 */     GIR_RootConstrainSelectedInstOperands,
     /* 242688 */     // GIR_Coverage, 8196,
     /* 242688 */     GIR_EraseRootFromParent_Done,
     /* 242689 */   // Label 4639: @242689
     /* 242689 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(242731), // Rule ID 8197 //
     /* 242694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242718 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 242721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242729 */     GIR_RootConstrainSelectedInstOperands,
     /* 242730 */     // GIR_Coverage, 8197,
     /* 242730 */     GIR_EraseRootFromParent_Done,
     /* 242731 */   // Label 4640: @242731
     /* 242731 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(242773), // Rule ID 8198 //
     /* 242736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242760 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 242763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242771 */     GIR_RootConstrainSelectedInstOperands,
     /* 242772 */     // GIR_Coverage, 8198,
     /* 242772 */     GIR_EraseRootFromParent_Done,
     /* 242773 */   // Label 4641: @242773
     /* 242773 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(242815), // Rule ID 8235 //
     /* 242778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242813 */     GIR_RootConstrainSelectedInstOperands,
     /* 242814 */     // GIR_Coverage, 8235,
     /* 242814 */     GIR_EraseRootFromParent_Done,
     /* 242815 */   // Label 4642: @242815
     /* 242815 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(242857), // Rule ID 8237 //
     /* 242820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242855 */     GIR_RootConstrainSelectedInstOperands,
     /* 242856 */     // GIR_Coverage, 8237,
     /* 242856 */     GIR_EraseRootFromParent_Done,
     /* 242857 */   // Label 4643: @242857
     /* 242857 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(242899), // Rule ID 8239 //
     /* 242862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242886 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242897 */     GIR_RootConstrainSelectedInstOperands,
     /* 242898 */     // GIR_Coverage, 8239,
     /* 242898 */     GIR_EraseRootFromParent_Done,
     /* 242899 */   // Label 4644: @242899
     /* 242899 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(242941), // Rule ID 8241 //
     /* 242904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242928 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242939 */     GIR_RootConstrainSelectedInstOperands,
     /* 242940 */     // GIR_Coverage, 8241,
     /* 242940 */     GIR_EraseRootFromParent_Done,
     /* 242941 */   // Label 4645: @242941
     /* 242941 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242983), // Rule ID 8243 //
     /* 242946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242981 */     GIR_RootConstrainSelectedInstOperands,
     /* 242982 */     // GIR_Coverage, 8243,
     /* 242982 */     GIR_EraseRootFromParent_Done,
     /* 242983 */   // Label 4646: @242983
     /* 242983 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(243025), // Rule ID 8245 //
     /* 242988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243012 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243023 */     GIR_RootConstrainSelectedInstOperands,
     /* 243024 */     // GIR_Coverage, 8245,
     /* 243024 */     GIR_EraseRootFromParent_Done,
     /* 243025 */   // Label 4647: @243025
     /* 243025 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(243067), // Rule ID 8247 //
     /* 243030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243054 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 243057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243065 */     GIR_RootConstrainSelectedInstOperands,
     /* 243066 */     // GIR_Coverage, 8247,
     /* 243066 */     GIR_EraseRootFromParent_Done,
     /* 243067 */   // Label 4648: @243067
     /* 243067 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(243109), // Rule ID 8248 //
     /* 243072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243096 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 243096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 243099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243107 */     GIR_RootConstrainSelectedInstOperands,
     /* 243108 */     // GIR_Coverage, 8248,
     /* 243108 */     GIR_EraseRootFromParent_Done,
     /* 243109 */   // Label 4649: @243109
     /* 243109 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243151), // Rule ID 8249 //
     /* 243114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243138 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 243138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 243141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243149 */     GIR_RootConstrainSelectedInstOperands,
     /* 243150 */     // GIR_Coverage, 8249,
     /* 243150 */     GIR_EraseRootFromParent_Done,
     /* 243151 */   // Label 4650: @243151
     /* 243151 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243193), // Rule ID 8250 //
     /* 243156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243180 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 243183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243191 */     GIR_RootConstrainSelectedInstOperands,
     /* 243192 */     // GIR_Coverage, 8250,
     /* 243192 */     GIR_EraseRootFromParent_Done,
     /* 243193 */   // Label 4651: @243193
     /* 243193 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243235), // Rule ID 8251 //
     /* 243198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 243222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 243225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243233 */     GIR_RootConstrainSelectedInstOperands,
     /* 243234 */     // GIR_Coverage, 8251,
     /* 243234 */     GIR_EraseRootFromParent_Done,
     /* 243235 */   // Label 4652: @243235
     /* 243235 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243277), // Rule ID 8252 //
     /* 243240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 243248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243275 */     GIR_RootConstrainSelectedInstOperands,
     /* 243276 */     // GIR_Coverage, 8252,
     /* 243276 */     GIR_EraseRootFromParent_Done,
     /* 243277 */   // Label 4653: @243277
     /* 243277 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243319), // Rule ID 8530 //
     /* 243282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 243290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 243309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243317 */     GIR_RootConstrainSelectedInstOperands,
     /* 243318 */     // GIR_Coverage, 8530,
     /* 243318 */     GIR_EraseRootFromParent_Done,
     /* 243319 */   // Label 4654: @243319
     /* 243319 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243361), // Rule ID 8532 //
     /* 243324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 243332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 243351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243359 */     GIR_RootConstrainSelectedInstOperands,
     /* 243360 */     // GIR_Coverage, 8532,
     /* 243360 */     GIR_EraseRootFromParent_Done,
     /* 243361 */   // Label 4655: @243361
     /* 243361 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243403), // Rule ID 8533 //
     /* 243366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243401 */     GIR_RootConstrainSelectedInstOperands,
     /* 243402 */     // GIR_Coverage, 8533,
     /* 243402 */     GIR_EraseRootFromParent_Done,
     /* 243403 */   // Label 4656: @243403
     /* 243403 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(243445), // Rule ID 8534 //
     /* 243408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1302:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243443 */     GIR_RootConstrainSelectedInstOperands,
     /* 243444 */     // GIR_Coverage, 8534,
     /* 243444 */     GIR_EraseRootFromParent_Done,
     /* 243445 */   // Label 4657: @243445
     /* 243445 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(243487), // Rule ID 8535 //
     /* 243450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1302:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243485 */     GIR_RootConstrainSelectedInstOperands,
     /* 243486 */     // GIR_Coverage, 8535,
     /* 243486 */     GIR_EraseRootFromParent_Done,
     /* 243487 */   // Label 4658: @243487
     /* 243487 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(243529), // Rule ID 8536 //
     /* 243492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1302:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243527 */     GIR_RootConstrainSelectedInstOperands,
     /* 243528 */     // GIR_Coverage, 8536,
     /* 243528 */     GIR_EraseRootFromParent_Done,
     /* 243529 */   // Label 4659: @243529
     /* 243529 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(243571), // Rule ID 8537 //
     /* 243534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1302:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243569 */     GIR_RootConstrainSelectedInstOperands,
     /* 243570 */     // GIR_Coverage, 8537,
     /* 243570 */     GIR_EraseRootFromParent_Done,
     /* 243571 */   // Label 4660: @243571
     /* 243571 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(243613), // Rule ID 8558 //
     /* 243576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243611 */     GIR_RootConstrainSelectedInstOperands,
     /* 243612 */     // GIR_Coverage, 8558,
     /* 243612 */     GIR_EraseRootFromParent_Done,
     /* 243613 */   // Label 4661: @243613
     /* 243613 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(243655), // Rule ID 8559 //
     /* 243618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243642 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243653 */     GIR_RootConstrainSelectedInstOperands,
     /* 243654 */     // GIR_Coverage, 8559,
     /* 243654 */     GIR_EraseRootFromParent_Done,
     /* 243655 */   // Label 4662: @243655
     /* 243655 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(243697), // Rule ID 8560 //
     /* 243660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243695 */     GIR_RootConstrainSelectedInstOperands,
     /* 243696 */     // GIR_Coverage, 8560,
     /* 243696 */     GIR_EraseRootFromParent_Done,
     /* 243697 */   // Label 4663: @243697
     /* 243697 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(243739), // Rule ID 8561 //
     /* 243702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243737 */     GIR_RootConstrainSelectedInstOperands,
     /* 243738 */     // GIR_Coverage, 8561,
     /* 243738 */     GIR_EraseRootFromParent_Done,
     /* 243739 */   // Label 4664: @243739
     /* 243739 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(243781), // Rule ID 8562 //
     /* 243744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1360:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243779 */     GIR_RootConstrainSelectedInstOperands,
     /* 243780 */     // GIR_Coverage, 8562,
     /* 243780 */     GIR_EraseRootFromParent_Done,
     /* 243781 */   // Label 4665: @243781
     /* 243781 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(243823), // Rule ID 8578 //
     /* 243786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243810 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1631:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243821 */     GIR_RootConstrainSelectedInstOperands,
     /* 243822 */     // GIR_Coverage, 8578,
     /* 243822 */     GIR_EraseRootFromParent_Done,
     /* 243823 */   // Label 4666: @243823
     /* 243823 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(243865), // Rule ID 8579 //
     /* 243828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1631:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243863 */     GIR_RootConstrainSelectedInstOperands,
     /* 243864 */     // GIR_Coverage, 8579,
     /* 243864 */     GIR_EraseRootFromParent_Done,
     /* 243865 */   // Label 4667: @243865
     /* 243865 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(243907), // Rule ID 8580 //
     /* 243870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243894 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1631:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243905 */     GIR_RootConstrainSelectedInstOperands,
     /* 243906 */     // GIR_Coverage, 8580,
     /* 243906 */     GIR_EraseRootFromParent_Done,
     /* 243907 */   // Label 4668: @243907
     /* 243907 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243949), // Rule ID 8581 //
     /* 243912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1631:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243947 */     GIR_RootConstrainSelectedInstOperands,
     /* 243948 */     // GIR_Coverage, 8581,
     /* 243948 */     GIR_EraseRootFromParent_Done,
     /* 243949 */   // Label 4669: @243949
     /* 243949 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243991), // Rule ID 8582 //
     /* 243954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1631:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243989 */     GIR_RootConstrainSelectedInstOperands,
     /* 243990 */     // GIR_Coverage, 8582,
     /* 243990 */     GIR_EraseRootFromParent_Done,
     /* 243991 */   // Label 4670: @243991
     /* 243991 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(244033), // Rule ID 8583 //
     /* 243996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 244004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 244023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244031 */     GIR_RootConstrainSelectedInstOperands,
     /* 244032 */     // GIR_Coverage, 8583,
     /* 244032 */     GIR_EraseRootFromParent_Done,
     /* 244033 */   // Label 4671: @244033
     /* 244033 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(244075), // Rule ID 8584 //
     /* 244038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 244046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 244055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 244058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 244062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 244065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244073 */     GIR_RootConstrainSelectedInstOperands,
     /* 244074 */     // GIR_Coverage, 8584,
     /* 244074 */     GIR_EraseRootFromParent_Done,
     /* 244075 */   // Label 4672: @244075
     /* 244075 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(244117), // Rule ID 8585 //
     /* 244080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 244088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 244107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244115 */     GIR_RootConstrainSelectedInstOperands,
     /* 244116 */     // GIR_Coverage, 8585,
     /* 244116 */     GIR_EraseRootFromParent_Done,
     /* 244117 */   // Label 4673: @244117
     /* 244117 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244159), // Rule ID 8586 //
     /* 244122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 244130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 244149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244157 */     GIR_RootConstrainSelectedInstOperands,
     /* 244158 */     // GIR_Coverage, 8586,
     /* 244158 */     GIR_EraseRootFromParent_Done,
     /* 244159 */   // Label 4674: @244159
     /* 244159 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244201), // Rule ID 8587 //
     /* 244164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 244172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1627:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 244191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244199 */     GIR_RootConstrainSelectedInstOperands,
     /* 244200 */     // GIR_Coverage, 8587,
     /* 244200 */     GIR_EraseRootFromParent_Done,
     /* 244201 */   // Label 4675: @244201
     /* 244201 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244243), // Rule ID 8588 //
     /* 244206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 244214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244241 */     GIR_RootConstrainSelectedInstOperands,
     /* 244242 */     // GIR_Coverage, 8588,
     /* 244242 */     GIR_EraseRootFromParent_Done,
     /* 244243 */   // Label 4676: @244243
     /* 244243 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244285), // Rule ID 8589 //
     /* 244248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 244256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 244265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 244268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 244272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244283 */     GIR_RootConstrainSelectedInstOperands,
     /* 244284 */     // GIR_Coverage, 8589,
     /* 244284 */     GIR_EraseRootFromParent_Done,
     /* 244285 */   // Label 4677: @244285
     /* 244285 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244327), // Rule ID 8590 //
     /* 244290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 244298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244314 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244325 */     GIR_RootConstrainSelectedInstOperands,
     /* 244326 */     // GIR_Coverage, 8590,
     /* 244326 */     GIR_EraseRootFromParent_Done,
     /* 244327 */   // Label 4678: @244327
     /* 244327 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244369), // Rule ID 8591 //
     /* 244332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 244340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244367 */     GIR_RootConstrainSelectedInstOperands,
     /* 244368 */     // GIR_Coverage, 8591,
     /* 244368 */     GIR_EraseRootFromParent_Done,
     /* 244369 */   // Label 4679: @244369
     /* 244369 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244411), // Rule ID 8592 //
     /* 244374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 244382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1625:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244409 */     GIR_RootConstrainSelectedInstOperands,
     /* 244410 */     // GIR_Coverage, 8592,
     /* 244410 */     GIR_EraseRootFromParent_Done,
     /* 244411 */   // Label 4680: @244411
     /* 244411 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(244453), // Rule ID 8593 //
     /* 244416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244451 */     GIR_RootConstrainSelectedInstOperands,
     /* 244452 */     // GIR_Coverage, 8593,
     /* 244452 */     GIR_EraseRootFromParent_Done,
     /* 244453 */   // Label 4681: @244453
     /* 244453 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(244495), // Rule ID 8594 //
     /* 244458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 244475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 244478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 244482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244493 */     GIR_RootConstrainSelectedInstOperands,
     /* 244494 */     // GIR_Coverage, 8594,
     /* 244494 */     GIR_EraseRootFromParent_Done,
     /* 244495 */   // Label 4682: @244495
     /* 244495 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(244537), // Rule ID 8595 //
     /* 244500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244535 */     GIR_RootConstrainSelectedInstOperands,
     /* 244536 */     // GIR_Coverage, 8595,
     /* 244536 */     GIR_EraseRootFromParent_Done,
     /* 244537 */   // Label 4683: @244537
     /* 244537 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(244579), // Rule ID 8596 //
     /* 244542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244577 */     GIR_RootConstrainSelectedInstOperands,
     /* 244578 */     // GIR_Coverage, 8596,
     /* 244578 */     GIR_EraseRootFromParent_Done,
     /* 244579 */   // Label 4684: @244579
     /* 244579 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(244621), // Rule ID 8597 //
     /* 244584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244619 */     GIR_RootConstrainSelectedInstOperands,
     /* 244620 */     // GIR_Coverage, 8597,
     /* 244620 */     GIR_EraseRootFromParent_Done,
     /* 244621 */   // Label 4685: @244621
     /* 244621 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(244663), // Rule ID 8605 //
     /* 244626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1318:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 244653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244661 */     GIR_RootConstrainSelectedInstOperands,
     /* 244662 */     // GIR_Coverage, 8605,
     /* 244662 */     GIR_EraseRootFromParent_Done,
     /* 244663 */   // Label 4686: @244663
     /* 244663 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(244705), // Rule ID 8606 //
     /* 244668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244703 */     GIR_RootConstrainSelectedInstOperands,
     /* 244704 */     // GIR_Coverage, 8606,
     /* 244704 */     GIR_EraseRootFromParent_Done,
     /* 244705 */   // Label 4687: @244705
     /* 244705 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(244747), // Rule ID 8607 //
     /* 244710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244745 */     GIR_RootConstrainSelectedInstOperands,
     /* 244746 */     // GIR_Coverage, 8607,
     /* 244746 */     GIR_EraseRootFromParent_Done,
     /* 244747 */   // Label 4688: @244747
     /* 244747 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(244789), // Rule ID 8608 //
     /* 244752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244787 */     GIR_RootConstrainSelectedInstOperands,
     /* 244788 */     // GIR_Coverage, 8608,
     /* 244788 */     GIR_EraseRootFromParent_Done,
     /* 244789 */   // Label 4689: @244789
     /* 244789 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(244831), // Rule ID 8609 //
     /* 244794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244829 */     GIR_RootConstrainSelectedInstOperands,
     /* 244830 */     // GIR_Coverage, 8609,
     /* 244830 */     GIR_EraseRootFromParent_Done,
     /* 244831 */   // Label 4690: @244831
     /* 244831 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(244873), // Rule ID 8610 //
     /* 244836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244871 */     GIR_RootConstrainSelectedInstOperands,
     /* 244872 */     // GIR_Coverage, 8610,
     /* 244872 */     GIR_EraseRootFromParent_Done,
     /* 244873 */   // Label 4691: @244873
     /* 244873 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244915), // Rule ID 8611 //
     /* 244878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244913 */     GIR_RootConstrainSelectedInstOperands,
     /* 244914 */     // GIR_Coverage, 8611,
     /* 244914 */     GIR_EraseRootFromParent_Done,
     /* 244915 */   // Label 4692: @244915
     /* 244915 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244960), // Rule ID 9307 //
     /* 244920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 244947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244958 */     GIR_RootConstrainSelectedInstOperands,
     /* 244959 */     // GIR_Coverage, 9307,
     /* 244959 */     GIR_EraseRootFromParent_Done,
     /* 244960 */   // Label 4693: @244960
     /* 244960 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(245005), // Rule ID 9308 //
     /* 244965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 244992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245003 */     GIR_RootConstrainSelectedInstOperands,
     /* 245004 */     // GIR_Coverage, 9308,
     /* 245004 */     GIR_EraseRootFromParent_Done,
     /* 245005 */   // Label 4694: @245005
     /* 245005 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(245050), // Rule ID 9309 //
     /* 245010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 245018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 245037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245048 */     GIR_RootConstrainSelectedInstOperands,
     /* 245049 */     // GIR_Coverage, 9309,
     /* 245049 */     GIR_EraseRootFromParent_Done,
     /* 245050 */   // Label 4695: @245050
     /* 245050 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(245095), // Rule ID 9310 //
     /* 245055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 245063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 245082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245093 */     GIR_RootConstrainSelectedInstOperands,
     /* 245094 */     // GIR_Coverage, 9310,
     /* 245094 */     GIR_EraseRootFromParent_Done,
     /* 245095 */   // Label 4696: @245095
     /* 245095 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245140), // Rule ID 9311 //
     /* 245100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 245108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 245127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245138 */     GIR_RootConstrainSelectedInstOperands,
     /* 245139 */     // GIR_Coverage, 9311,
     /* 245139 */     GIR_EraseRootFromParent_Done,
     /* 245140 */   // Label 4697: @245140
     /* 245140 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245185), // Rule ID 9312 //
     /* 245145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 245153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 245172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245183 */     GIR_RootConstrainSelectedInstOperands,
     /* 245184 */     // GIR_Coverage, 9312,
     /* 245184 */     GIR_EraseRootFromParent_Done,
     /* 245185 */   // Label 4698: @245185
     /* 245185 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245230), // Rule ID 9313 //
     /* 245190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 245198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245214 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1337:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 245217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245228 */     GIR_RootConstrainSelectedInstOperands,
     /* 245229 */     // GIR_Coverage, 9313,
     /* 245229 */     GIR_EraseRootFromParent_Done,
     /* 245230 */   // Label 4699: @245230
     /* 245230 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245275), // Rule ID 9314 //
     /* 245235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 245243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1337:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 245262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245273 */     GIR_RootConstrainSelectedInstOperands,
     /* 245274 */     // GIR_Coverage, 9314,
     /* 245274 */     GIR_EraseRootFromParent_Done,
     /* 245275 */   // Label 4700: @245275
     /* 245275 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245320), // Rule ID 9315 //
     /* 245280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 245288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1337:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 245307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245318 */     GIR_RootConstrainSelectedInstOperands,
     /* 245319 */     // GIR_Coverage, 9315,
     /* 245319 */     GIR_EraseRootFromParent_Done,
     /* 245320 */   // Label 4701: @245320
     /* 245320 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245365), // Rule ID 9316 //
     /* 245325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 245333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245349 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 245352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245363 */     GIR_RootConstrainSelectedInstOperands,
     /* 245364 */     // GIR_Coverage, 9316,
     /* 245364 */     GIR_EraseRootFromParent_Done,
     /* 245365 */   // Label 4702: @245365
     /* 245365 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245410), // Rule ID 9317 //
     /* 245370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 245378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245394 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 245397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245408 */     GIR_RootConstrainSelectedInstOperands,
     /* 245409 */     // GIR_Coverage, 9317,
     /* 245409 */     GIR_EraseRootFromParent_Done,
     /* 245410 */   // Label 4703: @245410
     /* 245410 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245455), // Rule ID 9318 //
     /* 245415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 245423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245439 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 245442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245453 */     GIR_RootConstrainSelectedInstOperands,
     /* 245454 */     // GIR_Coverage, 9318,
     /* 245454 */     GIR_EraseRootFromParent_Done,
     /* 245455 */   // Label 4704: @245455
     /* 245455 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(245500), // Rule ID 9319 //
     /* 245460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 245487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245498 */     GIR_RootConstrainSelectedInstOperands,
     /* 245499 */     // GIR_Coverage, 9319,
     /* 245499 */     GIR_EraseRootFromParent_Done,
     /* 245500 */   // Label 4705: @245500
     /* 245500 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(245545), // Rule ID 9320 //
     /* 245505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 245532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245543 */     GIR_RootConstrainSelectedInstOperands,
     /* 245544 */     // GIR_Coverage, 9320,
     /* 245544 */     GIR_EraseRootFromParent_Done,
     /* 245545 */   // Label 4706: @245545
     /* 245545 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(245590), // Rule ID 9321 //
     /* 245550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 245577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245588 */     GIR_RootConstrainSelectedInstOperands,
     /* 245589 */     // GIR_Coverage, 9321,
     /* 245589 */     GIR_EraseRootFromParent_Done,
     /* 245590 */   // Label 4707: @245590
     /* 245590 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(245635), // Rule ID 9322 //
     /* 245595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245619 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 245622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245633 */     GIR_RootConstrainSelectedInstOperands,
     /* 245634 */     // GIR_Coverage, 9322,
     /* 245634 */     GIR_EraseRootFromParent_Done,
     /* 245635 */   // Label 4708: @245635
     /* 245635 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(245680), // Rule ID 9323 //
     /* 245640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 245667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245678 */     GIR_RootConstrainSelectedInstOperands,
     /* 245679 */     // GIR_Coverage, 9323,
     /* 245679 */     GIR_EraseRootFromParent_Done,
     /* 245680 */   // Label 4709: @245680
     /* 245680 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(245725), // Rule ID 9324 //
     /* 245685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245709 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 245712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245723 */     GIR_RootConstrainSelectedInstOperands,
     /* 245724 */     // GIR_Coverage, 9324,
     /* 245724 */     GIR_EraseRootFromParent_Done,
     /* 245725 */   // Label 4710: @245725
     /* 245725 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(245770), // Rule ID 9325 //
     /* 245730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 245757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245768 */     GIR_RootConstrainSelectedInstOperands,
     /* 245769 */     // GIR_Coverage, 9325,
     /* 245769 */     GIR_EraseRootFromParent_Done,
     /* 245770 */   // Label 4711: @245770
     /* 245770 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(245815), // Rule ID 9326 //
     /* 245775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 245802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245813 */     GIR_RootConstrainSelectedInstOperands,
     /* 245814 */     // GIR_Coverage, 9326,
     /* 245814 */     GIR_EraseRootFromParent_Done,
     /* 245815 */   // Label 4712: @245815
     /* 245815 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(245860), // Rule ID 9327 //
     /* 245820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 245847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245858 */     GIR_RootConstrainSelectedInstOperands,
     /* 245859 */     // GIR_Coverage, 9327,
     /* 245859 */     GIR_EraseRootFromParent_Done,
     /* 245860 */   // Label 4713: @245860
     /* 245860 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(245905), // Rule ID 9328 //
     /* 245865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245889 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 245892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245903 */     GIR_RootConstrainSelectedInstOperands,
     /* 245904 */     // GIR_Coverage, 9328,
     /* 245904 */     GIR_EraseRootFromParent_Done,
     /* 245905 */   // Label 4714: @245905
     /* 245905 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245950), // Rule ID 9329 //
     /* 245910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 245937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245948 */     GIR_RootConstrainSelectedInstOperands,
     /* 245949 */     // GIR_Coverage, 9329,
     /* 245949 */     GIR_EraseRootFromParent_Done,
     /* 245950 */   // Label 4715: @245950
     /* 245950 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245995), // Rule ID 9330 //
     /* 245955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 245982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245993 */     GIR_RootConstrainSelectedInstOperands,
     /* 245994 */     // GIR_Coverage, 9330,
     /* 245994 */     GIR_EraseRootFromParent_Done,
     /* 245995 */   // Label 4716: @245995
     /* 245995 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(246037), // Rule ID 9727 //
     /* 246000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 246008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 246027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246035 */     GIR_RootConstrainSelectedInstOperands,
     /* 246036 */     // GIR_Coverage, 9727,
     /* 246036 */     GIR_EraseRootFromParent_Done,
     /* 246037 */   // Label 4717: @246037
     /* 246037 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(246079), // Rule ID 9728 //
     /* 246042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 246050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 246069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246077 */     GIR_RootConstrainSelectedInstOperands,
     /* 246078 */     // GIR_Coverage, 9728,
     /* 246078 */     GIR_EraseRootFromParent_Done,
     /* 246079 */   // Label 4718: @246079
     /* 246079 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(246121), // Rule ID 9729 //
     /* 246084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 246092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 246111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246119 */     GIR_RootConstrainSelectedInstOperands,
     /* 246120 */     // GIR_Coverage, 9729,
     /* 246120 */     GIR_EraseRootFromParent_Done,
     /* 246121 */   // Label 4719: @246121
     /* 246121 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246163), // Rule ID 10267 //
     /* 246126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 246134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 246153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246161 */     GIR_RootConstrainSelectedInstOperands,
     /* 246162 */     // GIR_Coverage, 10267,
     /* 246162 */     GIR_EraseRootFromParent_Done,
     /* 246163 */   // Label 4720: @246163
     /* 246163 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246205), // Rule ID 10268 //
     /* 246168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 246176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246192 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 246195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246203 */     GIR_RootConstrainSelectedInstOperands,
     /* 246204 */     // GIR_Coverage, 10268,
     /* 246204 */     GIR_EraseRootFromParent_Done,
     /* 246205 */   // Label 4721: @246205
     /* 246205 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246247), // Rule ID 10269 //
     /* 246210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 246218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 246237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246245 */     GIR_RootConstrainSelectedInstOperands,
     /* 246246 */     // GIR_Coverage, 10269,
     /* 246246 */     GIR_EraseRootFromParent_Done,
     /* 246247 */   // Label 4722: @246247
     /* 246247 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246289), // Rule ID 10270 //
     /* 246252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 246260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 246279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246287 */     GIR_RootConstrainSelectedInstOperands,
     /* 246288 */     // GIR_Coverage, 10270,
     /* 246288 */     GIR_EraseRootFromParent_Done,
     /* 246289 */   // Label 4723: @246289
     /* 246289 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246331), // Rule ID 10271 //
     /* 246294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 246321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246329 */     GIR_RootConstrainSelectedInstOperands,
     /* 246330 */     // GIR_Coverage, 10271,
     /* 246330 */     GIR_EraseRootFromParent_Done,
     /* 246331 */   // Label 4724: @246331
     /* 246331 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246373), // Rule ID 10272 //
     /* 246336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 246363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246371 */     GIR_RootConstrainSelectedInstOperands,
     /* 246372 */     // GIR_Coverage, 10272,
     /* 246372 */     GIR_EraseRootFromParent_Done,
     /* 246373 */   // Label 4725: @246373
     /* 246373 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246415), // Rule ID 10273 //
     /* 246378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 246405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246413 */     GIR_RootConstrainSelectedInstOperands,
     /* 246414 */     // GIR_Coverage, 10273,
     /* 246414 */     GIR_EraseRootFromParent_Done,
     /* 246415 */   // Label 4726: @246415
     /* 246415 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246457), // Rule ID 10274 //
     /* 246420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 246447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246455 */     GIR_RootConstrainSelectedInstOperands,
     /* 246456 */     // GIR_Coverage, 10274,
     /* 246456 */     GIR_EraseRootFromParent_Done,
     /* 246457 */   // Label 4727: @246457
     /* 246457 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(246499), // Rule ID 10287 //
     /* 246462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1605:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 246489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246497 */     GIR_RootConstrainSelectedInstOperands,
     /* 246498 */     // GIR_Coverage, 10287,
     /* 246498 */     GIR_EraseRootFromParent_Done,
     /* 246499 */   // Label 4728: @246499
     /* 246499 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(246541), // Rule ID 10288 //
     /* 246504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 246531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246539 */     GIR_RootConstrainSelectedInstOperands,
     /* 246540 */     // GIR_Coverage, 10288,
     /* 246540 */     GIR_EraseRootFromParent_Done,
     /* 246541 */   // Label 4729: @246541
     /* 246541 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(246583), // Rule ID 10289 //
     /* 246546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 246573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246581 */     GIR_RootConstrainSelectedInstOperands,
     /* 246582 */     // GIR_Coverage, 10289,
     /* 246582 */     GIR_EraseRootFromParent_Done,
     /* 246583 */   // Label 4730: @246583
     /* 246583 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(246625), // Rule ID 10290 //
     /* 246588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 246615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246623 */     GIR_RootConstrainSelectedInstOperands,
     /* 246624 */     // GIR_Coverage, 10290,
     /* 246624 */     GIR_EraseRootFromParent_Done,
     /* 246625 */   // Label 4731: @246625
     /* 246625 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(246667), // Rule ID 10291 //
     /* 246630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 246657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246665 */     GIR_RootConstrainSelectedInstOperands,
     /* 246666 */     // GIR_Coverage, 10291,
     /* 246666 */     GIR_EraseRootFromParent_Done,
     /* 246667 */   // Label 4732: @246667
     /* 246667 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246709), // Rule ID 10292 //
     /* 246672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 246699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246707 */     GIR_RootConstrainSelectedInstOperands,
     /* 246708 */     // GIR_Coverage, 10292,
     /* 246708 */     GIR_EraseRootFromParent_Done,
     /* 246709 */   // Label 4733: @246709
     /* 246709 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246751), // Rule ID 10319 //
     /* 246714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 246722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246738 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246749 */     GIR_RootConstrainSelectedInstOperands,
     /* 246750 */     // GIR_Coverage, 10319,
     /* 246750 */     GIR_EraseRootFromParent_Done,
     /* 246751 */   // Label 4734: @246751
     /* 246751 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246793), // Rule ID 10323 //
     /* 246756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 246764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246780 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1400:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246791 */     GIR_RootConstrainSelectedInstOperands,
     /* 246792 */     // GIR_Coverage, 10323,
     /* 246792 */     GIR_EraseRootFromParent_Done,
     /* 246793 */   // Label 4735: @246793
     /* 246793 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246835), // Rule ID 10327 //
     /* 246798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 246806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246822 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1399:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 246825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246833 */     GIR_RootConstrainSelectedInstOperands,
     /* 246834 */     // GIR_Coverage, 10327,
     /* 246834 */     GIR_EraseRootFromParent_Done,
     /* 246835 */   // Label 4736: @246835
     /* 246835 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246877), // Rule ID 10331 //
     /* 246840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 246848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1401:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 246867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246875 */     GIR_RootConstrainSelectedInstOperands,
     /* 246876 */     // GIR_Coverage, 10331,
     /* 246876 */     GIR_EraseRootFromParent_Done,
     /* 246877 */   // Label 4737: @246877
     /* 246877 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246919), // Rule ID 10335 //
     /* 246882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 246890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1713:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 246909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246917 */     GIR_RootConstrainSelectedInstOperands,
     /* 246918 */     // GIR_Coverage, 10335,
     /* 246918 */     GIR_EraseRootFromParent_Done,
     /* 246919 */   // Label 4738: @246919
     /* 246919 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246961), // Rule ID 10336 //
     /* 246924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 246932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246948 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1960:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 246951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246959 */     GIR_RootConstrainSelectedInstOperands,
     /* 246960 */     // GIR_Coverage, 10336,
     /* 246960 */     GIR_EraseRootFromParent_Done,
     /* 246961 */   // Label 4739: @246961
     /* 246961 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(247003), // Rule ID 10337 //
     /* 246966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 246974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246990 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1957:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247001 */     GIR_RootConstrainSelectedInstOperands,
     /* 247002 */     // GIR_Coverage, 10337,
     /* 247002 */     GIR_EraseRootFromParent_Done,
     /* 247003 */   // Label 4740: @247003
     /* 247003 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(247045), // Rule ID 10341 //
     /* 247008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 247016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247032 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1712:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 247035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247043 */     GIR_RootConstrainSelectedInstOperands,
     /* 247044 */     // GIR_Coverage, 10341,
     /* 247044 */     GIR_EraseRootFromParent_Done,
     /* 247045 */   // Label 4741: @247045
     /* 247045 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(247087), // Rule ID 10345 //
     /* 247050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 247058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247074 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1710:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 247077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247085 */     GIR_RootConstrainSelectedInstOperands,
     /* 247086 */     // GIR_Coverage, 10345,
     /* 247086 */     GIR_EraseRootFromParent_Done,
     /* 247087 */   // Label 4742: @247087
     /* 247087 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(247129), // Rule ID 10349 //
     /* 247092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 247100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247116 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1711:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 247119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247127 */     GIR_RootConstrainSelectedInstOperands,
     /* 247128 */     // GIR_Coverage, 10349,
     /* 247128 */     GIR_EraseRootFromParent_Done,
     /* 247129 */   // Label 4743: @247129
     /* 247129 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247171), // Rule ID 10353 //
     /* 247134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 247142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1959:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247169 */     GIR_RootConstrainSelectedInstOperands,
     /* 247170 */     // GIR_Coverage, 10353,
     /* 247170 */     GIR_EraseRootFromParent_Done,
     /* 247171 */   // Label 4744: @247171
     /* 247171 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247213), // Rule ID 10357 //
     /* 247176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 247184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1958:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 247203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247211 */     GIR_RootConstrainSelectedInstOperands,
     /* 247212 */     // GIR_Coverage, 10357,
     /* 247212 */     GIR_EraseRootFromParent_Done,
     /* 247213 */   // Label 4745: @247213
     /* 247213 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247255), // Rule ID 10367 //
     /* 247218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 247226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1415:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 247245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247253 */     GIR_RootConstrainSelectedInstOperands,
     /* 247254 */     // GIR_Coverage, 10367,
     /* 247254 */     GIR_EraseRootFromParent_Done,
     /* 247255 */   // Label 4746: @247255
     /* 247255 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247297), // Rule ID 10368 //
     /* 247260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 247268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 247287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247295 */     GIR_RootConstrainSelectedInstOperands,
     /* 247296 */     // GIR_Coverage, 10368,
     /* 247296 */     GIR_EraseRootFromParent_Done,
     /* 247297 */   // Label 4747: @247297
     /* 247297 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247339), // Rule ID 10369 //
     /* 247302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 247310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1417:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 247329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247337 */     GIR_RootConstrainSelectedInstOperands,
     /* 247338 */     // GIR_Coverage, 10369,
     /* 247338 */     GIR_EraseRootFromParent_Done,
     /* 247339 */   // Label 4748: @247339
     /* 247339 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247381), // Rule ID 10373 //
     /* 247344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 247352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1414:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 247371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247379 */     GIR_RootConstrainSelectedInstOperands,
     /* 247380 */     // GIR_Coverage, 10373,
     /* 247380 */     GIR_EraseRootFromParent_Done,
     /* 247381 */   // Label 4749: @247381
     /* 247381 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247423), // Rule ID 10377 //
     /* 247386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 247394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1416:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 247413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247421 */     GIR_RootConstrainSelectedInstOperands,
     /* 247422 */     // GIR_Coverage, 10377,
     /* 247422 */     GIR_EraseRootFromParent_Done,
     /* 247423 */   // Label 4750: @247423
     /* 247423 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247465), // Rule ID 10381 //
     /* 247428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 247436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1421:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 247455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247463 */     GIR_RootConstrainSelectedInstOperands,
     /* 247464 */     // GIR_Coverage, 10381,
     /* 247464 */     GIR_EraseRootFromParent_Done,
     /* 247465 */   // Label 4751: @247465
     /* 247465 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247507), // Rule ID 10385 //
     /* 247470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 247478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 247497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247505 */     GIR_RootConstrainSelectedInstOperands,
     /* 247506 */     // GIR_Coverage, 10385,
     /* 247506 */     GIR_EraseRootFromParent_Done,
     /* 247507 */   // Label 4752: @247507
     /* 247507 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247549), // Rule ID 10389 //
     /* 247512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 247520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1424:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247547 */     GIR_RootConstrainSelectedInstOperands,
     /* 247548 */     // GIR_Coverage, 10389,
     /* 247548 */     GIR_EraseRootFromParent_Done,
     /* 247549 */   // Label 4753: @247549
     /* 247549 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247591), // Rule ID 11388 //
     /* 247554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 247562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 247581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247589 */     GIR_RootConstrainSelectedInstOperands,
     /* 247590 */     // GIR_Coverage, 11388,
     /* 247590 */     GIR_EraseRootFromParent_Done,
     /* 247591 */   // Label 4754: @247591
     /* 247591 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247633), // Rule ID 11389 //
     /* 247596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 247604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247631 */     GIR_RootConstrainSelectedInstOperands,
     /* 247632 */     // GIR_Coverage, 11389,
     /* 247632 */     GIR_EraseRootFromParent_Done,
     /* 247633 */   // Label 4755: @247633
     /* 247633 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247675), // Rule ID 11391 //
     /* 247638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 247641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247662 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 247665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247673 */     GIR_RootConstrainSelectedInstOperands,
     /* 247674 */     // GIR_Coverage, 11391,
     /* 247674 */     GIR_EraseRootFromParent_Done,
     /* 247675 */   // Label 4756: @247675
     /* 247675 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247717), // Rule ID 11392 //
     /* 247680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 247683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 247707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247715 */     GIR_RootConstrainSelectedInstOperands,
     /* 247716 */     // GIR_Coverage, 11392,
     /* 247716 */     GIR_EraseRootFromParent_Done,
     /* 247717 */   // Label 4757: @247717
     /* 247717 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247759), // Rule ID 11446 //
     /* 247722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 247749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247757 */     GIR_RootConstrainSelectedInstOperands,
     /* 247758 */     // GIR_Coverage, 11446,
     /* 247758 */     GIR_EraseRootFromParent_Done,
     /* 247759 */   // Label 4758: @247759
     /* 247759 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247801), // Rule ID 11447 //
     /* 247764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 247791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247799 */     GIR_RootConstrainSelectedInstOperands,
     /* 247800 */     // GIR_Coverage, 11447,
     /* 247800 */     GIR_EraseRootFromParent_Done,
     /* 247801 */   // Label 4759: @247801
     /* 247801 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247843), // Rule ID 11448 //
     /* 247806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247841 */     GIR_RootConstrainSelectedInstOperands,
     /* 247842 */     // GIR_Coverage, 11448,
     /* 247842 */     GIR_EraseRootFromParent_Done,
     /* 247843 */   // Label 4760: @247843
     /* 247843 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247885), // Rule ID 11449 //
     /* 247848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 247875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247883 */     GIR_RootConstrainSelectedInstOperands,
     /* 247884 */     // GIR_Coverage, 11449,
     /* 247884 */     GIR_EraseRootFromParent_Done,
     /* 247885 */   // Label 4761: @247885
     /* 247885 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247927), // Rule ID 11502 //
     /* 247890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247925 */     GIR_RootConstrainSelectedInstOperands,
     /* 247926 */     // GIR_Coverage, 11502,
     /* 247926 */     GIR_EraseRootFromParent_Done,
     /* 247927 */   // Label 4762: @247927
     /* 247927 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247969), // Rule ID 11503 //
     /* 247932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 247959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247967 */     GIR_RootConstrainSelectedInstOperands,
     /* 247968 */     // GIR_Coverage, 11503,
     /* 247968 */     GIR_EraseRootFromParent_Done,
     /* 247969 */   // Label 4763: @247969
     /* 247969 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(248011), // Rule ID 11504 //
     /* 247974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248009 */     GIR_RootConstrainSelectedInstOperands,
     /* 248010 */     // GIR_Coverage, 11504,
     /* 248010 */     GIR_EraseRootFromParent_Done,
     /* 248011 */   // Label 4764: @248011
     /* 248011 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(248053), // Rule ID 11505 //
     /* 248016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 248024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 248043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248051 */     GIR_RootConstrainSelectedInstOperands,
     /* 248052 */     // GIR_Coverage, 11505,
     /* 248052 */     GIR_EraseRootFromParent_Done,
     /* 248053 */   // Label 4765: @248053
     /* 248053 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248095), // Rule ID 11506 //
     /* 248058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 248066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248093 */     GIR_RootConstrainSelectedInstOperands,
     /* 248094 */     // GIR_Coverage, 11506,
     /* 248094 */     GIR_EraseRootFromParent_Done,
     /* 248095 */   // Label 4766: @248095
     /* 248095 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248137), // Rule ID 11507 //
     /* 248100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 248108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 248127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248135 */     GIR_RootConstrainSelectedInstOperands,
     /* 248136 */     // GIR_Coverage, 11507,
     /* 248136 */     GIR_EraseRootFromParent_Done,
     /* 248137 */   // Label 4767: @248137
     /* 248137 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248179), // Rule ID 11508 //
     /* 248142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 248150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 248169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248177 */     GIR_RootConstrainSelectedInstOperands,
     /* 248178 */     // GIR_Coverage, 11508,
     /* 248178 */     GIR_EraseRootFromParent_Done,
     /* 248179 */   // Label 4768: @248179
     /* 248179 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248221), // Rule ID 11509 //
     /* 248184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 248192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 248211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248219 */     GIR_RootConstrainSelectedInstOperands,
     /* 248220 */     // GIR_Coverage, 11509,
     /* 248220 */     GIR_EraseRootFromParent_Done,
     /* 248221 */   // Label 4769: @248221
     /* 248221 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248263), // Rule ID 11510 //
     /* 248226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 248234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 248253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248261 */     GIR_RootConstrainSelectedInstOperands,
     /* 248262 */     // GIR_Coverage, 11510,
     /* 248262 */     GIR_EraseRootFromParent_Done,
     /* 248263 */   // Label 4770: @248263
     /* 248263 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248305), // Rule ID 11511 //
     /* 248268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 248276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 248295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248303 */     GIR_RootConstrainSelectedInstOperands,
     /* 248304 */     // GIR_Coverage, 11511,
     /* 248304 */     GIR_EraseRootFromParent_Done,
     /* 248305 */   // Label 4771: @248305
     /* 248305 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248347), // Rule ID 11512 //
     /* 248310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 248318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 248337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248345 */     GIR_RootConstrainSelectedInstOperands,
     /* 248346 */     // GIR_Coverage, 11512,
     /* 248346 */     GIR_EraseRootFromParent_Done,
     /* 248347 */   // Label 4772: @248347
     /* 248347 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248389), // Rule ID 11513 //
     /* 248352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 248360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248387 */     GIR_RootConstrainSelectedInstOperands,
     /* 248388 */     // GIR_Coverage, 11513,
     /* 248388 */     GIR_EraseRootFromParent_Done,
     /* 248389 */   // Label 4773: @248389
     /* 248389 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248431), // Rule ID 11514 //
     /* 248394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 248421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248429 */     GIR_RootConstrainSelectedInstOperands,
     /* 248430 */     // GIR_Coverage, 11514,
     /* 248430 */     GIR_EraseRootFromParent_Done,
     /* 248431 */   // Label 4774: @248431
     /* 248431 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248473), // Rule ID 11515 //
     /* 248436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 248463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248471 */     GIR_RootConstrainSelectedInstOperands,
     /* 248472 */     // GIR_Coverage, 11515,
     /* 248472 */     GIR_EraseRootFromParent_Done,
     /* 248473 */   // Label 4775: @248473
     /* 248473 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248515), // Rule ID 11516 //
     /* 248478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 248505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248513 */     GIR_RootConstrainSelectedInstOperands,
     /* 248514 */     // GIR_Coverage, 11516,
     /* 248514 */     GIR_EraseRootFromParent_Done,
     /* 248515 */   // Label 4776: @248515
     /* 248515 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248557), // Rule ID 11517 //
     /* 248520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 248547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248555 */     GIR_RootConstrainSelectedInstOperands,
     /* 248556 */     // GIR_Coverage, 11517,
     /* 248556 */     GIR_EraseRootFromParent_Done,
     /* 248557 */   // Label 4777: @248557
     /* 248557 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(248599), // Rule ID 11518 //
     /* 248562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 248589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248597 */     GIR_RootConstrainSelectedInstOperands,
     /* 248598 */     // GIR_Coverage, 11518,
     /* 248598 */     GIR_EraseRootFromParent_Done,
     /* 248599 */   // Label 4778: @248599
     /* 248599 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(248641), // Rule ID 11519 //
     /* 248604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 248631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248639 */     GIR_RootConstrainSelectedInstOperands,
     /* 248640 */     // GIR_Coverage, 11519,
     /* 248640 */     GIR_EraseRootFromParent_Done,
     /* 248641 */   // Label 4779: @248641
     /* 248641 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(248683), // Rule ID 11520 //
     /* 248646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248681 */     GIR_RootConstrainSelectedInstOperands,
     /* 248682 */     // GIR_Coverage, 11520,
     /* 248682 */     GIR_EraseRootFromParent_Done,
     /* 248683 */   // Label 4780: @248683
     /* 248683 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(248725), // Rule ID 11521 //
     /* 248688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 248715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248723 */     GIR_RootConstrainSelectedInstOperands,
     /* 248724 */     // GIR_Coverage, 11521,
     /* 248724 */     GIR_EraseRootFromParent_Done,
     /* 248725 */   // Label 4781: @248725
     /* 248725 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(248767), // Rule ID 11522 //
     /* 248730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248765 */     GIR_RootConstrainSelectedInstOperands,
     /* 248766 */     // GIR_Coverage, 11522,
     /* 248766 */     GIR_EraseRootFromParent_Done,
     /* 248767 */   // Label 4782: @248767
     /* 248767 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(248809), // Rule ID 11531 //
     /* 248772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 248799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248807 */     GIR_RootConstrainSelectedInstOperands,
     /* 248808 */     // GIR_Coverage, 11531,
     /* 248808 */     GIR_EraseRootFromParent_Done,
     /* 248809 */   // Label 4783: @248809
     /* 248809 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(248851), // Rule ID 11532 //
     /* 248814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 248841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248849 */     GIR_RootConstrainSelectedInstOperands,
     /* 248850 */     // GIR_Coverage, 11532,
     /* 248850 */     GIR_EraseRootFromParent_Done,
     /* 248851 */   // Label 4784: @248851
     /* 248851 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(248893), // Rule ID 11533 //
     /* 248856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 248883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248891 */     GIR_RootConstrainSelectedInstOperands,
     /* 248892 */     // GIR_Coverage, 11533,
     /* 248892 */     GIR_EraseRootFromParent_Done,
     /* 248893 */   // Label 4785: @248893
     /* 248893 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(248935), // Rule ID 11534 //
     /* 248898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1798:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 248925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248933 */     GIR_RootConstrainSelectedInstOperands,
     /* 248934 */     // GIR_Coverage, 11534,
     /* 248934 */     GIR_EraseRootFromParent_Done,
     /* 248935 */   // Label 4786: @248935
     /* 248935 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248977), // Rule ID 11535 //
     /* 248940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 248967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248975 */     GIR_RootConstrainSelectedInstOperands,
     /* 248976 */     // GIR_Coverage, 11535,
     /* 248976 */     GIR_EraseRootFromParent_Done,
     /* 248977 */   // Label 4787: @248977
     /* 248977 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249019), // Rule ID 11536 //
     /* 248982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 249009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249017 */     GIR_RootConstrainSelectedInstOperands,
     /* 249018 */     // GIR_Coverage, 11536,
     /* 249018 */     GIR_EraseRootFromParent_Done,
     /* 249019 */   // Label 4788: @249019
     /* 249019 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249061), // Rule ID 11537 //
     /* 249024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 249032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249059 */     GIR_RootConstrainSelectedInstOperands,
     /* 249060 */     // GIR_Coverage, 11537,
     /* 249060 */     GIR_EraseRootFromParent_Done,
     /* 249061 */   // Label 4789: @249061
     /* 249061 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249103), // Rule ID 11538 //
     /* 249066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 249074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 249093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249101 */     GIR_RootConstrainSelectedInstOperands,
     /* 249102 */     // GIR_Coverage, 11538,
     /* 249102 */     GIR_EraseRootFromParent_Done,
     /* 249103 */   // Label 4790: @249103
     /* 249103 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249145), // Rule ID 11539 //
     /* 249108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 249116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249143 */     GIR_RootConstrainSelectedInstOperands,
     /* 249144 */     // GIR_Coverage, 11539,
     /* 249144 */     GIR_EraseRootFromParent_Done,
     /* 249145 */   // Label 4791: @249145
     /* 249145 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249187), // Rule ID 11540 //
     /* 249150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 249158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 249177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249185 */     GIR_RootConstrainSelectedInstOperands,
     /* 249186 */     // GIR_Coverage, 11540,
     /* 249186 */     GIR_EraseRootFromParent_Done,
     /* 249187 */   // Label 4792: @249187
     /* 249187 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249229), // Rule ID 11541 //
     /* 249192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 249200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 249219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249227 */     GIR_RootConstrainSelectedInstOperands,
     /* 249228 */     // GIR_Coverage, 11541,
     /* 249228 */     GIR_EraseRootFromParent_Done,
     /* 249229 */   // Label 4793: @249229
     /* 249229 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249271), // Rule ID 11542 //
     /* 249234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 249242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 249261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249269 */     GIR_RootConstrainSelectedInstOperands,
     /* 249270 */     // GIR_Coverage, 11542,
     /* 249270 */     GIR_EraseRootFromParent_Done,
     /* 249271 */   // Label 4794: @249271
     /* 249271 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249313), // Rule ID 11543 //
     /* 249276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 249284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249311 */     GIR_RootConstrainSelectedInstOperands,
     /* 249312 */     // GIR_Coverage, 11543,
     /* 249312 */     GIR_EraseRootFromParent_Done,
     /* 249313 */   // Label 4795: @249313
     /* 249313 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249355), // Rule ID 11544 //
     /* 249318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 249326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 249345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249353 */     GIR_RootConstrainSelectedInstOperands,
     /* 249354 */     // GIR_Coverage, 11544,
     /* 249354 */     GIR_EraseRootFromParent_Done,
     /* 249355 */   // Label 4796: @249355
     /* 249355 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249397), // Rule ID 11545 //
     /* 249360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 249368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 249387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249395 */     GIR_RootConstrainSelectedInstOperands,
     /* 249396 */     // GIR_Coverage, 11545,
     /* 249396 */     GIR_EraseRootFromParent_Done,
     /* 249397 */   // Label 4797: @249397
     /* 249397 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249439), // Rule ID 11546 //
     /* 249402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249437 */     GIR_RootConstrainSelectedInstOperands,
     /* 249438 */     // GIR_Coverage, 11546,
     /* 249438 */     GIR_EraseRootFromParent_Done,
     /* 249439 */   // Label 4798: @249439
     /* 249439 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(249481), // Rule ID 11547 //
     /* 249444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 249471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249479 */     GIR_RootConstrainSelectedInstOperands,
     /* 249480 */     // GIR_Coverage, 11547,
     /* 249480 */     GIR_EraseRootFromParent_Done,
     /* 249481 */   // Label 4799: @249481
     /* 249481 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(249523), // Rule ID 11548 //
     /* 249486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 249513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249521 */     GIR_RootConstrainSelectedInstOperands,
     /* 249522 */     // GIR_Coverage, 11548,
     /* 249522 */     GIR_EraseRootFromParent_Done,
     /* 249523 */   // Label 4800: @249523
     /* 249523 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(249565), // Rule ID 11549 //
     /* 249528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 249555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249563 */     GIR_RootConstrainSelectedInstOperands,
     /* 249564 */     // GIR_Coverage, 11549,
     /* 249564 */     GIR_EraseRootFromParent_Done,
     /* 249565 */   // Label 4801: @249565
     /* 249565 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(249607), // Rule ID 11551 //
     /* 249570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 249597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249605 */     GIR_RootConstrainSelectedInstOperands,
     /* 249606 */     // GIR_Coverage, 11551,
     /* 249606 */     GIR_EraseRootFromParent_Done,
     /* 249607 */   // Label 4802: @249607
     /* 249607 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(249649), // Rule ID 11553 //
     /* 249612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249647 */     GIR_RootConstrainSelectedInstOperands,
     /* 249648 */     // GIR_Coverage, 11553,
     /* 249648 */     GIR_EraseRootFromParent_Done,
     /* 249649 */   // Label 4803: @249649
     /* 249649 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(249691), // Rule ID 11555 //
     /* 249654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 249681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249689 */     GIR_RootConstrainSelectedInstOperands,
     /* 249690 */     // GIR_Coverage, 11555,
     /* 249690 */     GIR_EraseRootFromParent_Done,
     /* 249691 */   // Label 4804: @249691
     /* 249691 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(249733), // Rule ID 11557 //
     /* 249696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 249723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249731 */     GIR_RootConstrainSelectedInstOperands,
     /* 249732 */     // GIR_Coverage, 11557,
     /* 249732 */     GIR_EraseRootFromParent_Done,
     /* 249733 */   // Label 4805: @249733
     /* 249733 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(249775), // Rule ID 11558 //
     /* 249738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 249765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249773 */     GIR_RootConstrainSelectedInstOperands,
     /* 249774 */     // GIR_Coverage, 11558,
     /* 249774 */     GIR_EraseRootFromParent_Done,
     /* 249775 */   // Label 4806: @249775
     /* 249775 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(249817), // Rule ID 11559 //
     /* 249780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249815 */     GIR_RootConstrainSelectedInstOperands,
     /* 249816 */     // GIR_Coverage, 11559,
     /* 249816 */     GIR_EraseRootFromParent_Done,
     /* 249817 */   // Label 4807: @249817
     /* 249817 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249859), // Rule ID 11560 //
     /* 249822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 249849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249857 */     GIR_RootConstrainSelectedInstOperands,
     /* 249858 */     // GIR_Coverage, 11560,
     /* 249858 */     GIR_EraseRootFromParent_Done,
     /* 249859 */   // Label 4808: @249859
     /* 249859 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249901), // Rule ID 11561 //
     /* 249864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1971:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 249891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249899 */     GIR_RootConstrainSelectedInstOperands,
     /* 249900 */     // GIR_Coverage, 11561,
     /* 249900 */     GIR_EraseRootFromParent_Done,
     /* 249901 */   // Label 4809: @249901
     /* 249901 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249943), // Rule ID 11562 //
     /* 249906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 249933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249941 */     GIR_RootConstrainSelectedInstOperands,
     /* 249942 */     // GIR_Coverage, 11562,
     /* 249942 */     GIR_EraseRootFromParent_Done,
     /* 249943 */   // Label 4810: @249943
     /* 249943 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249985), // Rule ID 11563 //
     /* 249948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249983 */     GIR_RootConstrainSelectedInstOperands,
     /* 249984 */     // GIR_Coverage, 11563,
     /* 249984 */     GIR_EraseRootFromParent_Done,
     /* 249985 */   // Label 4811: @249985
     /* 249985 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(250027), // Rule ID 11564 //
     /* 249990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 250017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250025 */     GIR_RootConstrainSelectedInstOperands,
     /* 250026 */     // GIR_Coverage, 11564,
     /* 250026 */     GIR_EraseRootFromParent_Done,
     /* 250027 */   // Label 4812: @250027
     /* 250027 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(250069), // Rule ID 11565 //
     /* 250032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 250040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1865:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 250059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250067 */     GIR_RootConstrainSelectedInstOperands,
     /* 250068 */     // GIR_Coverage, 11565,
     /* 250068 */     GIR_EraseRootFromParent_Done,
     /* 250069 */   // Label 4813: @250069
     /* 250069 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250111), // Rule ID 11567 //
     /* 250074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 250082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 250101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250109 */     GIR_RootConstrainSelectedInstOperands,
     /* 250110 */     // GIR_Coverage, 11567,
     /* 250110 */     GIR_EraseRootFromParent_Done,
     /* 250111 */   // Label 4814: @250111
     /* 250111 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250153), // Rule ID 11569 //
     /* 250116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 250124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 250143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250151 */     GIR_RootConstrainSelectedInstOperands,
     /* 250152 */     // GIR_Coverage, 11569,
     /* 250152 */     GIR_EraseRootFromParent_Done,
     /* 250153 */   // Label 4815: @250153
     /* 250153 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250195), // Rule ID 11571 //
     /* 250158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 250166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 250185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250193 */     GIR_RootConstrainSelectedInstOperands,
     /* 250194 */     // GIR_Coverage, 11571,
     /* 250194 */     GIR_EraseRootFromParent_Done,
     /* 250195 */   // Label 4816: @250195
     /* 250195 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250237), // Rule ID 11573 //
     /* 250200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 250208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 250227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250235 */     GIR_RootConstrainSelectedInstOperands,
     /* 250236 */     // GIR_Coverage, 11573,
     /* 250236 */     GIR_EraseRootFromParent_Done,
     /* 250237 */   // Label 4817: @250237
     /* 250237 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250279), // Rule ID 11575 //
     /* 250242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 250250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2057:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250277 */     GIR_RootConstrainSelectedInstOperands,
     /* 250278 */     // GIR_Coverage, 11575,
     /* 250278 */     GIR_EraseRootFromParent_Done,
     /* 250279 */   // Label 4818: @250279
     /* 250279 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250321), // Rule ID 11577 //
     /* 250284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 250292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 250311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250319 */     GIR_RootConstrainSelectedInstOperands,
     /* 250320 */     // GIR_Coverage, 11577,
     /* 250320 */     GIR_EraseRootFromParent_Done,
     /* 250321 */   // Label 4819: @250321
     /* 250321 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250363), // Rule ID 11579 //
     /* 250326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 250334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2057:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 250353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250361 */     GIR_RootConstrainSelectedInstOperands,
     /* 250362 */     // GIR_Coverage, 11579,
     /* 250362 */     GIR_EraseRootFromParent_Done,
     /* 250363 */   // Label 4820: @250363
     /* 250363 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250405), // Rule ID 11581 //
     /* 250368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 250395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250403 */     GIR_RootConstrainSelectedInstOperands,
     /* 250404 */     // GIR_Coverage, 11581,
     /* 250404 */     GIR_EraseRootFromParent_Done,
     /* 250405 */   // Label 4821: @250405
     /* 250405 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(250447), // Rule ID 11582 //
     /* 250410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 250437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250445 */     GIR_RootConstrainSelectedInstOperands,
     /* 250446 */     // GIR_Coverage, 11582,
     /* 250446 */     GIR_EraseRootFromParent_Done,
     /* 250447 */   // Label 4822: @250447
     /* 250447 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(250489), // Rule ID 11583 //
     /* 250452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 250479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250487 */     GIR_RootConstrainSelectedInstOperands,
     /* 250488 */     // GIR_Coverage, 11583,
     /* 250488 */     GIR_EraseRootFromParent_Done,
     /* 250489 */   // Label 4823: @250489
     /* 250489 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250531), // Rule ID 11584 //
     /* 250494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 250521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250529 */     GIR_RootConstrainSelectedInstOperands,
     /* 250530 */     // GIR_Coverage, 11584,
     /* 250530 */     GIR_EraseRootFromParent_Done,
     /* 250531 */   // Label 4824: @250531
     /* 250531 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250573), // Rule ID 11585 //
     /* 250536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1972:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 250563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250571 */     GIR_RootConstrainSelectedInstOperands,
     /* 250572 */     // GIR_Coverage, 11585,
     /* 250572 */     GIR_EraseRootFromParent_Done,
     /* 250573 */   // Label 4825: @250573
     /* 250573 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250615), // Rule ID 11586 //
     /* 250578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 250605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250613 */     GIR_RootConstrainSelectedInstOperands,
     /* 250614 */     // GIR_Coverage, 11586,
     /* 250614 */     GIR_EraseRootFromParent_Done,
     /* 250615 */   // Label 4826: @250615
     /* 250615 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250657), // Rule ID 11587 //
     /* 250620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 250647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250655 */     GIR_RootConstrainSelectedInstOperands,
     /* 250656 */     // GIR_Coverage, 11587,
     /* 250656 */     GIR_EraseRootFromParent_Done,
     /* 250657 */   // Label 4827: @250657
     /* 250657 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250699), // Rule ID 11588 //
     /* 250662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 250689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250697 */     GIR_RootConstrainSelectedInstOperands,
     /* 250698 */     // GIR_Coverage, 11588,
     /* 250698 */     GIR_EraseRootFromParent_Done,
     /* 250699 */   // Label 4828: @250699
     /* 250699 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250741), // Rule ID 11589 //
     /* 250704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 250731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250739 */     GIR_RootConstrainSelectedInstOperands,
     /* 250740 */     // GIR_Coverage, 11589,
     /* 250740 */     GIR_EraseRootFromParent_Done,
     /* 250741 */   // Label 4829: @250741
     /* 250741 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250783), // Rule ID 11590 //
     /* 250746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 250773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250781 */     GIR_RootConstrainSelectedInstOperands,
     /* 250782 */     // GIR_Coverage, 11590,
     /* 250782 */     GIR_EraseRootFromParent_Done,
     /* 250783 */   // Label 4830: @250783
     /* 250783 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250825), // Rule ID 11591 //
     /* 250788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 250815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250823 */     GIR_RootConstrainSelectedInstOperands,
     /* 250824 */     // GIR_Coverage, 11591,
     /* 250824 */     GIR_EraseRootFromParent_Done,
     /* 250825 */   // Label 4831: @250825
     /* 250825 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250867), // Rule ID 11592 //
     /* 250830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1262:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 250857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250865 */     GIR_RootConstrainSelectedInstOperands,
     /* 250866 */     // GIR_Coverage, 11592,
     /* 250866 */     GIR_EraseRootFromParent_Done,
     /* 250867 */   // Label 4832: @250867
     /* 250867 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250909), // Rule ID 11593 //
     /* 250872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1262:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 250899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250907 */     GIR_RootConstrainSelectedInstOperands,
     /* 250908 */     // GIR_Coverage, 11593,
     /* 250908 */     GIR_EraseRootFromParent_Done,
     /* 250909 */   // Label 4833: @250909
     /* 250909 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250951), // Rule ID 11594 //
     /* 250914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 250941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250949 */     GIR_RootConstrainSelectedInstOperands,
     /* 250950 */     // GIR_Coverage, 11594,
     /* 250950 */     GIR_EraseRootFromParent_Done,
     /* 250951 */   // Label 4834: @250951
     /* 250951 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250993), // Rule ID 11595 //
     /* 250956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 250983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250991 */     GIR_RootConstrainSelectedInstOperands,
     /* 250992 */     // GIR_Coverage, 11595,
     /* 250992 */     GIR_EraseRootFromParent_Done,
     /* 250993 */   // Label 4835: @250993
     /* 250993 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(251035), // Rule ID 11596 //
     /* 250998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 251006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 251025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251033 */     GIR_RootConstrainSelectedInstOperands,
     /* 251034 */     // GIR_Coverage, 11596,
     /* 251034 */     GIR_EraseRootFromParent_Done,
     /* 251035 */   // Label 4836: @251035
     /* 251035 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(251077), // Rule ID 11597 //
     /* 251040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 251048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 251067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251075 */     GIR_RootConstrainSelectedInstOperands,
     /* 251076 */     // GIR_Coverage, 11597,
     /* 251076 */     GIR_EraseRootFromParent_Done,
     /* 251077 */   // Label 4837: @251077
     /* 251077 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(251119), // Rule ID 11598 //
     /* 251082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 251090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 251109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251117 */     GIR_RootConstrainSelectedInstOperands,
     /* 251118 */     // GIR_Coverage, 11598,
     /* 251118 */     GIR_EraseRootFromParent_Done,
     /* 251119 */   // Label 4838: @251119
     /* 251119 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251161), // Rule ID 11599 //
     /* 251124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 251132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 251151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251159 */     GIR_RootConstrainSelectedInstOperands,
     /* 251160 */     // GIR_Coverage, 11599,
     /* 251160 */     GIR_EraseRootFromParent_Done,
     /* 251161 */   // Label 4839: @251161
     /* 251161 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251203), // Rule ID 11600 //
     /* 251166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 251174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 251193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251201 */     GIR_RootConstrainSelectedInstOperands,
     /* 251202 */     // GIR_Coverage, 11600,
     /* 251202 */     GIR_EraseRootFromParent_Done,
     /* 251203 */   // Label 4840: @251203
     /* 251203 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251245), // Rule ID 11601 //
     /* 251208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 251216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 251235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251243 */     GIR_RootConstrainSelectedInstOperands,
     /* 251244 */     // GIR_Coverage, 11601,
     /* 251244 */     GIR_EraseRootFromParent_Done,
     /* 251245 */   // Label 4841: @251245
     /* 251245 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251287), // Rule ID 11602 //
     /* 251250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 251258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 251277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251285 */     GIR_RootConstrainSelectedInstOperands,
     /* 251286 */     // GIR_Coverage, 11602,
     /* 251286 */     GIR_EraseRootFromParent_Done,
     /* 251287 */   // Label 4842: @251287
     /* 251287 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251329), // Rule ID 11603 //
     /* 251292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 251300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 251319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251327 */     GIR_RootConstrainSelectedInstOperands,
     /* 251328 */     // GIR_Coverage, 11603,
     /* 251328 */     GIR_EraseRootFromParent_Done,
     /* 251329 */   // Label 4843: @251329
     /* 251329 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251371), // Rule ID 11604 //
     /* 251334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 251361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251369 */     GIR_RootConstrainSelectedInstOperands,
     /* 251370 */     // GIR_Coverage, 11604,
     /* 251370 */     GIR_EraseRootFromParent_Done,
     /* 251371 */   // Label 4844: @251371
     /* 251371 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251413), // Rule ID 11605 //
     /* 251376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 251403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251411 */     GIR_RootConstrainSelectedInstOperands,
     /* 251412 */     // GIR_Coverage, 11605,
     /* 251412 */     GIR_EraseRootFromParent_Done,
     /* 251413 */   // Label 4845: @251413
     /* 251413 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251455), // Rule ID 11606 //
     /* 251418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 251445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251453 */     GIR_RootConstrainSelectedInstOperands,
     /* 251454 */     // GIR_Coverage, 11606,
     /* 251454 */     GIR_EraseRootFromParent_Done,
     /* 251455 */   // Label 4846: @251455
     /* 251455 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251497), // Rule ID 11607 //
     /* 251460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 251487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251495 */     GIR_RootConstrainSelectedInstOperands,
     /* 251496 */     // GIR_Coverage, 11607,
     /* 251496 */     GIR_EraseRootFromParent_Done,
     /* 251497 */   // Label 4847: @251497
     /* 251497 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251539), // Rule ID 11608 //
     /* 251502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 251529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251537 */     GIR_RootConstrainSelectedInstOperands,
     /* 251538 */     // GIR_Coverage, 11608,
     /* 251538 */     GIR_EraseRootFromParent_Done,
     /* 251539 */   // Label 4848: @251539
     /* 251539 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251581), // Rule ID 11609 //
     /* 251544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 251571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251579 */     GIR_RootConstrainSelectedInstOperands,
     /* 251580 */     // GIR_Coverage, 11609,
     /* 251580 */     GIR_EraseRootFromParent_Done,
     /* 251581 */   // Label 4849: @251581
     /* 251581 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251623), // Rule ID 11610 //
     /* 251586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 251613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251621 */     GIR_RootConstrainSelectedInstOperands,
     /* 251622 */     // GIR_Coverage, 11610,
     /* 251622 */     GIR_EraseRootFromParent_Done,
     /* 251623 */   // Label 4850: @251623
     /* 251623 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251665), // Rule ID 11611 //
     /* 251628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 251655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251663 */     GIR_RootConstrainSelectedInstOperands,
     /* 251664 */     // GIR_Coverage, 11611,
     /* 251664 */     GIR_EraseRootFromParent_Done,
     /* 251665 */   // Label 4851: @251665
     /* 251665 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251707), // Rule ID 11612 //
     /* 251670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 251678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 251697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251705 */     GIR_RootConstrainSelectedInstOperands,
     /* 251706 */     // GIR_Coverage, 11612,
     /* 251706 */     GIR_EraseRootFromParent_Done,
     /* 251707 */   // Label 4852: @251707
     /* 251707 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251749), // Rule ID 11623 //
     /* 251712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 251739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251747 */     GIR_RootConstrainSelectedInstOperands,
     /* 251748 */     // GIR_Coverage, 11623,
     /* 251748 */     GIR_EraseRootFromParent_Done,
     /* 251749 */   // Label 4853: @251749
     /* 251749 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251791), // Rule ID 11624 //
     /* 251754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 251781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251789 */     GIR_RootConstrainSelectedInstOperands,
     /* 251790 */     // GIR_Coverage, 11624,
     /* 251790 */     GIR_EraseRootFromParent_Done,
     /* 251791 */   // Label 4854: @251791
     /* 251791 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251833), // Rule ID 11625 //
     /* 251796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 251823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251831 */     GIR_RootConstrainSelectedInstOperands,
     /* 251832 */     // GIR_Coverage, 11625,
     /* 251832 */     GIR_EraseRootFromParent_Done,
     /* 251833 */   // Label 4855: @251833
     /* 251833 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251875), // Rule ID 11626 //
     /* 251838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 251865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251873 */     GIR_RootConstrainSelectedInstOperands,
     /* 251874 */     // GIR_Coverage, 11626,
     /* 251874 */     GIR_EraseRootFromParent_Done,
     /* 251875 */   // Label 4856: @251875
     /* 251875 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(251917), // Rule ID 11635 //
     /* 251880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1770:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 251907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251915 */     GIR_RootConstrainSelectedInstOperands,
     /* 251916 */     // GIR_Coverage, 11635,
     /* 251916 */     GIR_EraseRootFromParent_Done,
     /* 251917 */   // Label 4857: @251917
     /* 251917 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251959), // Rule ID 11636 //
     /* 251922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 251949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251957 */     GIR_RootConstrainSelectedInstOperands,
     /* 251958 */     // GIR_Coverage, 11636,
     /* 251958 */     GIR_EraseRootFromParent_Done,
     /* 251959 */   // Label 4858: @251959
     /* 251959 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252001), // Rule ID 11637 //
     /* 251964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 251991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251999 */     GIR_RootConstrainSelectedInstOperands,
     /* 252000 */     // GIR_Coverage, 11637,
     /* 252000 */     GIR_EraseRootFromParent_Done,
     /* 252001 */   // Label 4859: @252001
     /* 252001 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252043), // Rule ID 11638 //
     /* 252006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 252014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 252033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252041 */     GIR_RootConstrainSelectedInstOperands,
     /* 252042 */     // GIR_Coverage, 11638,
     /* 252042 */     GIR_EraseRootFromParent_Done,
     /* 252043 */   // Label 4860: @252043
     /* 252043 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252085), // Rule ID 11639 //
     /* 252048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 252056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2006:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 252075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252083 */     GIR_RootConstrainSelectedInstOperands,
     /* 252084 */     // GIR_Coverage, 11639,
     /* 252084 */     GIR_EraseRootFromParent_Done,
     /* 252085 */   // Label 4861: @252085
     /* 252085 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252127), // Rule ID 11640 //
     /* 252090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 252098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2006:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 252117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252125 */     GIR_RootConstrainSelectedInstOperands,
     /* 252126 */     // GIR_Coverage, 11640,
     /* 252126 */     GIR_EraseRootFromParent_Done,
     /* 252127 */   // Label 4862: @252127
     /* 252127 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252169), // Rule ID 11641 //
     /* 252132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 252140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2006:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 252159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252167 */     GIR_RootConstrainSelectedInstOperands,
     /* 252168 */     // GIR_Coverage, 11641,
     /* 252168 */     GIR_EraseRootFromParent_Done,
     /* 252169 */   // Label 4863: @252169
     /* 252169 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252211), // Rule ID 11642 //
     /* 252174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 252182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2006:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 252201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252209 */     GIR_RootConstrainSelectedInstOperands,
     /* 252210 */     // GIR_Coverage, 11642,
     /* 252210 */     GIR_EraseRootFromParent_Done,
     /* 252211 */   // Label 4864: @252211
     /* 252211 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252253), // Rule ID 11643 //
     /* 252216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 252224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 252243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252251 */     GIR_RootConstrainSelectedInstOperands,
     /* 252252 */     // GIR_Coverage, 11643,
     /* 252252 */     GIR_EraseRootFromParent_Done,
     /* 252253 */   // Label 4865: @252253
     /* 252253 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252295), // Rule ID 11644 //
     /* 252258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 252266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 252285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252293 */     GIR_RootConstrainSelectedInstOperands,
     /* 252294 */     // GIR_Coverage, 11644,
     /* 252294 */     GIR_EraseRootFromParent_Done,
     /* 252295 */   // Label 4866: @252295
     /* 252295 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252337), // Rule ID 11645 //
     /* 252300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 252308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 252327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252335 */     GIR_RootConstrainSelectedInstOperands,
     /* 252336 */     // GIR_Coverage, 11645,
     /* 252336 */     GIR_EraseRootFromParent_Done,
     /* 252337 */   // Label 4867: @252337
     /* 252337 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252379), // Rule ID 11646 //
     /* 252342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 252350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 252369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252377 */     GIR_RootConstrainSelectedInstOperands,
     /* 252378 */     // GIR_Coverage, 11646,
     /* 252378 */     GIR_EraseRootFromParent_Done,
     /* 252379 */   // Label 4868: @252379
     /* 252379 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252421), // Rule ID 11647 //
     /* 252384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 252411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252419 */     GIR_RootConstrainSelectedInstOperands,
     /* 252420 */     // GIR_Coverage, 11647,
     /* 252420 */     GIR_EraseRootFromParent_Done,
     /* 252421 */   // Label 4869: @252421
     /* 252421 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252463), // Rule ID 11648 //
     /* 252426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 252453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252461 */     GIR_RootConstrainSelectedInstOperands,
     /* 252462 */     // GIR_Coverage, 11648,
     /* 252462 */     GIR_EraseRootFromParent_Done,
     /* 252463 */   // Label 4870: @252463
     /* 252463 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252505), // Rule ID 11649 //
     /* 252468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 252495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252503 */     GIR_RootConstrainSelectedInstOperands,
     /* 252504 */     // GIR_Coverage, 11649,
     /* 252504 */     GIR_EraseRootFromParent_Done,
     /* 252505 */   // Label 4871: @252505
     /* 252505 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252547), // Rule ID 11650 //
     /* 252510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 252537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252545 */     GIR_RootConstrainSelectedInstOperands,
     /* 252546 */     // GIR_Coverage, 11650,
     /* 252546 */     GIR_EraseRootFromParent_Done,
     /* 252547 */   // Label 4872: @252547
     /* 252547 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(252589), // Rule ID 11651 //
     /* 252552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 252579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252587 */     GIR_RootConstrainSelectedInstOperands,
     /* 252588 */     // GIR_Coverage, 11651,
     /* 252588 */     GIR_EraseRootFromParent_Done,
     /* 252589 */   // Label 4873: @252589
     /* 252589 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(252631), // Rule ID 11652 //
     /* 252594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 252621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252629 */     GIR_RootConstrainSelectedInstOperands,
     /* 252630 */     // GIR_Coverage, 11652,
     /* 252630 */     GIR_EraseRootFromParent_Done,
     /* 252631 */   // Label 4874: @252631
     /* 252631 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(252673), // Rule ID 11653 //
     /* 252636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 252663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252671 */     GIR_RootConstrainSelectedInstOperands,
     /* 252672 */     // GIR_Coverage, 11653,
     /* 252672 */     GIR_EraseRootFromParent_Done,
     /* 252673 */   // Label 4875: @252673
     /* 252673 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(252715), // Rule ID 11654 //
     /* 252678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 252705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252713 */     GIR_RootConstrainSelectedInstOperands,
     /* 252714 */     // GIR_Coverage, 11654,
     /* 252714 */     GIR_EraseRootFromParent_Done,
     /* 252715 */   // Label 4876: @252715
     /* 252715 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(252757), // Rule ID 11655 //
     /* 252720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 252747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252755 */     GIR_RootConstrainSelectedInstOperands,
     /* 252756 */     // GIR_Coverage, 11655,
     /* 252756 */     GIR_EraseRootFromParent_Done,
     /* 252757 */   // Label 4877: @252757
     /* 252757 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(252799), // Rule ID 11656 //
     /* 252762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 252789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252797 */     GIR_RootConstrainSelectedInstOperands,
     /* 252798 */     // GIR_Coverage, 11656,
     /* 252798 */     GIR_EraseRootFromParent_Done,
     /* 252799 */   // Label 4878: @252799
     /* 252799 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(252841), // Rule ID 11657 //
     /* 252804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 252831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252839 */     GIR_RootConstrainSelectedInstOperands,
     /* 252840 */     // GIR_Coverage, 11657,
     /* 252840 */     GIR_EraseRootFromParent_Done,
     /* 252841 */   // Label 4879: @252841
     /* 252841 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(252883), // Rule ID 11658 //
     /* 252846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 252873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252881 */     GIR_RootConstrainSelectedInstOperands,
     /* 252882 */     // GIR_Coverage, 11658,
     /* 252882 */     GIR_EraseRootFromParent_Done,
     /* 252883 */   // Label 4880: @252883
     /* 252883 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(252925), // Rule ID 11659 //
     /* 252888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 252915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252923 */     GIR_RootConstrainSelectedInstOperands,
     /* 252924 */     // GIR_Coverage, 11659,
     /* 252924 */     GIR_EraseRootFromParent_Done,
     /* 252925 */   // Label 4881: @252925
     /* 252925 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252967), // Rule ID 11660 //
     /* 252930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 252957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252965 */     GIR_RootConstrainSelectedInstOperands,
     /* 252966 */     // GIR_Coverage, 11660,
     /* 252966 */     GIR_EraseRootFromParent_Done,
     /* 252967 */   // Label 4882: @252967
     /* 252967 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253009), // Rule ID 11661 //
     /* 252972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 252999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253007 */     GIR_RootConstrainSelectedInstOperands,
     /* 253008 */     // GIR_Coverage, 11661,
     /* 253008 */     GIR_EraseRootFromParent_Done,
     /* 253009 */   // Label 4883: @253009
     /* 253009 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253051), // Rule ID 11662 //
     /* 253014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 253022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1860:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 253041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253049 */     GIR_RootConstrainSelectedInstOperands,
     /* 253050 */     // GIR_Coverage, 11662,
     /* 253050 */     GIR_EraseRootFromParent_Done,
     /* 253051 */   // Label 4884: @253051
     /* 253051 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253093), // Rule ID 11663 //
     /* 253056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 253064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 253083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253091 */     GIR_RootConstrainSelectedInstOperands,
     /* 253092 */     // GIR_Coverage, 11663,
     /* 253092 */     GIR_EraseRootFromParent_Done,
     /* 253093 */   // Label 4885: @253093
     /* 253093 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253135), // Rule ID 11664 //
     /* 253098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 253106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253133 */     GIR_RootConstrainSelectedInstOperands,
     /* 253134 */     // GIR_Coverage, 11664,
     /* 253134 */     GIR_EraseRootFromParent_Done,
     /* 253135 */   // Label 4886: @253135
     /* 253135 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253177), // Rule ID 11665 //
     /* 253140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 253148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 253167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253175 */     GIR_RootConstrainSelectedInstOperands,
     /* 253176 */     // GIR_Coverage, 11665,
     /* 253176 */     GIR_EraseRootFromParent_Done,
     /* 253177 */   // Label 4887: @253177
     /* 253177 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253219), // Rule ID 11666 //
     /* 253182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 253190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 253209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253217 */     GIR_RootConstrainSelectedInstOperands,
     /* 253218 */     // GIR_Coverage, 11666,
     /* 253218 */     GIR_EraseRootFromParent_Done,
     /* 253219 */   // Label 4888: @253219
     /* 253219 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253261), // Rule ID 11667 //
     /* 253224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 253232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 253251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253259 */     GIR_RootConstrainSelectedInstOperands,
     /* 253260 */     // GIR_Coverage, 11667,
     /* 253260 */     GIR_EraseRootFromParent_Done,
     /* 253261 */   // Label 4889: @253261
     /* 253261 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253303), // Rule ID 11668 //
     /* 253266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 253274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 253293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253301 */     GIR_RootConstrainSelectedInstOperands,
     /* 253302 */     // GIR_Coverage, 11668,
     /* 253302 */     GIR_EraseRootFromParent_Done,
     /* 253303 */   // Label 4890: @253303
     /* 253303 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253345), // Rule ID 11669 //
     /* 253308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 253316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 253335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253343 */     GIR_RootConstrainSelectedInstOperands,
     /* 253344 */     // GIR_Coverage, 11669,
     /* 253344 */     GIR_EraseRootFromParent_Done,
     /* 253345 */   // Label 4891: @253345
     /* 253345 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253387), // Rule ID 11670 //
     /* 253350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 253358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 253377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253385 */     GIR_RootConstrainSelectedInstOperands,
     /* 253386 */     // GIR_Coverage, 11670,
     /* 253386 */     GIR_EraseRootFromParent_Done,
     /* 253387 */   // Label 4892: @253387
     /* 253387 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253429), // Rule ID 11671 //
     /* 253392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 253419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253427 */     GIR_RootConstrainSelectedInstOperands,
     /* 253428 */     // GIR_Coverage, 11671,
     /* 253428 */     GIR_EraseRootFromParent_Done,
     /* 253429 */   // Label 4893: @253429
     /* 253429 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(253471), // Rule ID 11672 //
     /* 253434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 253461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253469 */     GIR_RootConstrainSelectedInstOperands,
     /* 253470 */     // GIR_Coverage, 11672,
     /* 253470 */     GIR_EraseRootFromParent_Done,
     /* 253471 */   // Label 4894: @253471
     /* 253471 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(253513), // Rule ID 11673 //
     /* 253476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 253503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253511 */     GIR_RootConstrainSelectedInstOperands,
     /* 253512 */     // GIR_Coverage, 11673,
     /* 253512 */     GIR_EraseRootFromParent_Done,
     /* 253513 */   // Label 4895: @253513
     /* 253513 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(253555), // Rule ID 11674 //
     /* 253518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 253545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253553 */     GIR_RootConstrainSelectedInstOperands,
     /* 253554 */     // GIR_Coverage, 11674,
     /* 253554 */     GIR_EraseRootFromParent_Done,
     /* 253555 */   // Label 4896: @253555
     /* 253555 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(253597), // Rule ID 11675 //
     /* 253560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 253587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253595 */     GIR_RootConstrainSelectedInstOperands,
     /* 253596 */     // GIR_Coverage, 11675,
     /* 253596 */     GIR_EraseRootFromParent_Done,
     /* 253597 */   // Label 4897: @253597
     /* 253597 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(253639), // Rule ID 11676 //
     /* 253602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 253629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253637 */     GIR_RootConstrainSelectedInstOperands,
     /* 253638 */     // GIR_Coverage, 11676,
     /* 253638 */     GIR_EraseRootFromParent_Done,
     /* 253639 */   // Label 4898: @253639
     /* 253639 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(253681), // Rule ID 11677 //
     /* 253644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 253671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253679 */     GIR_RootConstrainSelectedInstOperands,
     /* 253680 */     // GIR_Coverage, 11677,
     /* 253680 */     GIR_EraseRootFromParent_Done,
     /* 253681 */   // Label 4899: @253681
     /* 253681 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(253723), // Rule ID 11678 //
     /* 253686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 253713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253721 */     GIR_RootConstrainSelectedInstOperands,
     /* 253722 */     // GIR_Coverage, 11678,
     /* 253722 */     GIR_EraseRootFromParent_Done,
     /* 253723 */   // Label 4900: @253723
     /* 253723 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(253765), // Rule ID 11679 //
     /* 253728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 253755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253763 */     GIR_RootConstrainSelectedInstOperands,
     /* 253764 */     // GIR_Coverage, 11679,
     /* 253764 */     GIR_EraseRootFromParent_Done,
     /* 253765 */   // Label 4901: @253765
     /* 253765 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(253807), // Rule ID 11680 //
     /* 253770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 253797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253805 */     GIR_RootConstrainSelectedInstOperands,
     /* 253806 */     // GIR_Coverage, 11680,
     /* 253806 */     GIR_EraseRootFromParent_Done,
     /* 253807 */   // Label 4902: @253807
     /* 253807 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(253849), // Rule ID 11681 //
     /* 253812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 253839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253847 */     GIR_RootConstrainSelectedInstOperands,
     /* 253848 */     // GIR_Coverage, 11681,
     /* 253848 */     GIR_EraseRootFromParent_Done,
     /* 253849 */   // Label 4903: @253849
     /* 253849 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(253891), // Rule ID 11682 //
     /* 253854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 253881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253889 */     GIR_RootConstrainSelectedInstOperands,
     /* 253890 */     // GIR_Coverage, 11682,
     /* 253890 */     GIR_EraseRootFromParent_Done,
     /* 253891 */   // Label 4904: @253891
     /* 253891 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(253933), // Rule ID 11683 //
     /* 253896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 253923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253931 */     GIR_RootConstrainSelectedInstOperands,
     /* 253932 */     // GIR_Coverage, 11683,
     /* 253932 */     GIR_EraseRootFromParent_Done,
     /* 253933 */   // Label 4905: @253933
     /* 253933 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253975), // Rule ID 11684 //
     /* 253938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 253965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253973 */     GIR_RootConstrainSelectedInstOperands,
     /* 253974 */     // GIR_Coverage, 11684,
     /* 253974 */     GIR_EraseRootFromParent_Done,
     /* 253975 */   // Label 4906: @253975
     /* 253975 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(254017), // Rule ID 11685 //
     /* 253980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 254007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254015 */     GIR_RootConstrainSelectedInstOperands,
     /* 254016 */     // GIR_Coverage, 11685,
     /* 254016 */     GIR_EraseRootFromParent_Done,
     /* 254017 */   // Label 4907: @254017
     /* 254017 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(254059), // Rule ID 11686 //
     /* 254022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 254030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 254049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254057 */     GIR_RootConstrainSelectedInstOperands,
     /* 254058 */     // GIR_Coverage, 11686,
     /* 254058 */     GIR_EraseRootFromParent_Done,
     /* 254059 */   // Label 4908: @254059
     /* 254059 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(254101), // Rule ID 11687 //
     /* 254064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 254072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 254091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254099 */     GIR_RootConstrainSelectedInstOperands,
     /* 254100 */     // GIR_Coverage, 11687,
     /* 254100 */     GIR_EraseRootFromParent_Done,
     /* 254101 */   // Label 4909: @254101
     /* 254101 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254143), // Rule ID 11688 //
     /* 254106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 254114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 254133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254141 */     GIR_RootConstrainSelectedInstOperands,
     /* 254142 */     // GIR_Coverage, 11688,
     /* 254142 */     GIR_EraseRootFromParent_Done,
     /* 254143 */   // Label 4910: @254143
     /* 254143 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254185), // Rule ID 11689 //
     /* 254148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 254156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 254175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254183 */     GIR_RootConstrainSelectedInstOperands,
     /* 254184 */     // GIR_Coverage, 11689,
     /* 254184 */     GIR_EraseRootFromParent_Done,
     /* 254185 */   // Label 4911: @254185
     /* 254185 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254227), // Rule ID 11690 //
     /* 254190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 254198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 254217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254225 */     GIR_RootConstrainSelectedInstOperands,
     /* 254226 */     // GIR_Coverage, 11690,
     /* 254226 */     GIR_EraseRootFromParent_Done,
     /* 254227 */   // Label 4912: @254227
     /* 254227 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254269), // Rule ID 11865 //
     /* 254232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 254240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 254259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254267 */     GIR_RootConstrainSelectedInstOperands,
     /* 254268 */     // GIR_Coverage, 11865,
     /* 254268 */     GIR_EraseRootFromParent_Done,
     /* 254269 */   // Label 4913: @254269
     /* 254269 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254311), // Rule ID 11867 //
     /* 254274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 254282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 254301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254309 */     GIR_RootConstrainSelectedInstOperands,
     /* 254310 */     // GIR_Coverage, 11867,
     /* 254310 */     GIR_EraseRootFromParent_Done,
     /* 254311 */   // Label 4914: @254311
     /* 254311 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254353), // Rule ID 11869 //
     /* 254316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 254324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 254343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254351 */     GIR_RootConstrainSelectedInstOperands,
     /* 254352 */     // GIR_Coverage, 11869,
     /* 254352 */     GIR_EraseRootFromParent_Done,
     /* 254353 */   // Label 4915: @254353
     /* 254353 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254395), // Rule ID 11871 //
     /* 254358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 254366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 254385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254393 */     GIR_RootConstrainSelectedInstOperands,
     /* 254394 */     // GIR_Coverage, 11871,
     /* 254394 */     GIR_EraseRootFromParent_Done,
     /* 254395 */   // Label 4916: @254395
     /* 254395 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254437), // Rule ID 11873 //
     /* 254400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 254427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254435 */     GIR_RootConstrainSelectedInstOperands,
     /* 254436 */     // GIR_Coverage, 11873,
     /* 254436 */     GIR_EraseRootFromParent_Done,
     /* 254437 */   // Label 4917: @254437
     /* 254437 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(254479), // Rule ID 11874 //
     /* 254442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 254469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254477 */     GIR_RootConstrainSelectedInstOperands,
     /* 254478 */     // GIR_Coverage, 11874,
     /* 254478 */     GIR_EraseRootFromParent_Done,
     /* 254479 */   // Label 4918: @254479
     /* 254479 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(254521), // Rule ID 11875 //
     /* 254484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 254511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254519 */     GIR_RootConstrainSelectedInstOperands,
     /* 254520 */     // GIR_Coverage, 11875,
     /* 254520 */     GIR_EraseRootFromParent_Done,
     /* 254521 */   // Label 4919: @254521
     /* 254521 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(254563), // Rule ID 11876 //
     /* 254526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 254553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254561 */     GIR_RootConstrainSelectedInstOperands,
     /* 254562 */     // GIR_Coverage, 11876,
     /* 254562 */     GIR_EraseRootFromParent_Done,
     /* 254563 */   // Label 4920: @254563
     /* 254563 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(254605), // Rule ID 11877 //
     /* 254568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 254595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254603 */     GIR_RootConstrainSelectedInstOperands,
     /* 254604 */     // GIR_Coverage, 11877,
     /* 254604 */     GIR_EraseRootFromParent_Done,
     /* 254605 */   // Label 4921: @254605
     /* 254605 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(254647), // Rule ID 11878 //
     /* 254610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 254637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254645 */     GIR_RootConstrainSelectedInstOperands,
     /* 254646 */     // GIR_Coverage, 11878,
     /* 254646 */     GIR_EraseRootFromParent_Done,
     /* 254647 */   // Label 4922: @254647
     /* 254647 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(254689), // Rule ID 11879 //
     /* 254652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 254679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254687 */     GIR_RootConstrainSelectedInstOperands,
     /* 254688 */     // GIR_Coverage, 11879,
     /* 254688 */     GIR_EraseRootFromParent_Done,
     /* 254689 */   // Label 4923: @254689
     /* 254689 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(254731), // Rule ID 11880 //
     /* 254694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 254721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254729 */     GIR_RootConstrainSelectedInstOperands,
     /* 254730 */     // GIR_Coverage, 11880,
     /* 254730 */     GIR_EraseRootFromParent_Done,
     /* 254731 */   // Label 4924: @254731
     /* 254731 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(254773), // Rule ID 11881 //
     /* 254736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 254763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254771 */     GIR_RootConstrainSelectedInstOperands,
     /* 254772 */     // GIR_Coverage, 11881,
     /* 254772 */     GIR_EraseRootFromParent_Done,
     /* 254773 */   // Label 4925: @254773
     /* 254773 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(254815), // Rule ID 11882 //
     /* 254778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 254805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254813 */     GIR_RootConstrainSelectedInstOperands,
     /* 254814 */     // GIR_Coverage, 11882,
     /* 254814 */     GIR_EraseRootFromParent_Done,
     /* 254815 */   // Label 4926: @254815
     /* 254815 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(254857), // Rule ID 11883 //
     /* 254820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 254847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254855 */     GIR_RootConstrainSelectedInstOperands,
     /* 254856 */     // GIR_Coverage, 11883,
     /* 254856 */     GIR_EraseRootFromParent_Done,
     /* 254857 */   // Label 4927: @254857
     /* 254857 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(254899), // Rule ID 11884 //
     /* 254862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 254889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254897 */     GIR_RootConstrainSelectedInstOperands,
     /* 254898 */     // GIR_Coverage, 11884,
     /* 254898 */     GIR_EraseRootFromParent_Done,
     /* 254899 */   // Label 4928: @254899
     /* 254899 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(254941), // Rule ID 11885 //
     /* 254904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 254931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254939 */     GIR_RootConstrainSelectedInstOperands,
     /* 254940 */     // GIR_Coverage, 11885,
     /* 254940 */     GIR_EraseRootFromParent_Done,
     /* 254941 */   // Label 4929: @254941
     /* 254941 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254983), // Rule ID 11886 //
     /* 254946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 254973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254981 */     GIR_RootConstrainSelectedInstOperands,
     /* 254982 */     // GIR_Coverage, 11886,
     /* 254982 */     GIR_EraseRootFromParent_Done,
     /* 254983 */   // Label 4930: @254983
     /* 254983 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(255025), // Rule ID 11887 //
     /* 254988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1705:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 255015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255023 */     GIR_RootConstrainSelectedInstOperands,
     /* 255024 */     // GIR_Coverage, 11887,
     /* 255024 */     GIR_EraseRootFromParent_Done,
     /* 255025 */   // Label 4931: @255025
     /* 255025 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(255067), // Rule ID 11942 //
     /* 255030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 255038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1673:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 255057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255065 */     GIR_RootConstrainSelectedInstOperands,
     /* 255066 */     // GIR_Coverage, 11942,
     /* 255066 */     GIR_EraseRootFromParent_Done,
     /* 255067 */   // Label 4932: @255067
     /* 255067 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(255109), // Rule ID 11943 //
     /* 255072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 255080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 255099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255107 */     GIR_RootConstrainSelectedInstOperands,
     /* 255108 */     // GIR_Coverage, 11943,
     /* 255108 */     GIR_EraseRootFromParent_Done,
     /* 255109 */   // Label 4933: @255109
     /* 255109 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255151), // Rule ID 11944 //
     /* 255114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 255122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 255141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255149 */     GIR_RootConstrainSelectedInstOperands,
     /* 255150 */     // GIR_Coverage, 11944,
     /* 255150 */     GIR_EraseRootFromParent_Done,
     /* 255151 */   // Label 4934: @255151
     /* 255151 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255193), // Rule ID 11945 //
     /* 255156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 255164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1914:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 255183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255191 */     GIR_RootConstrainSelectedInstOperands,
     /* 255192 */     // GIR_Coverage, 11945,
     /* 255192 */     GIR_EraseRootFromParent_Done,
     /* 255193 */   // Label 4935: @255193
     /* 255193 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255235), // Rule ID 11946 //
     /* 255198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 255206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1914:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 255225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255233 */     GIR_RootConstrainSelectedInstOperands,
     /* 255234 */     // GIR_Coverage, 11946,
     /* 255234 */     GIR_EraseRootFromParent_Done,
     /* 255235 */   // Label 4936: @255235
     /* 255235 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255277), // Rule ID 11947 //
     /* 255240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 255248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1914:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 255267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255275 */     GIR_RootConstrainSelectedInstOperands,
     /* 255276 */     // GIR_Coverage, 11947,
     /* 255276 */     GIR_EraseRootFromParent_Done,
     /* 255277 */   // Label 4937: @255277
     /* 255277 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255319), // Rule ID 11948 //
     /* 255282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 255290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 255309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255317 */     GIR_RootConstrainSelectedInstOperands,
     /* 255318 */     // GIR_Coverage, 11948,
     /* 255318 */     GIR_EraseRootFromParent_Done,
     /* 255319 */   // Label 4938: @255319
     /* 255319 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255361), // Rule ID 11949 //
     /* 255324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 255332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 255351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255359 */     GIR_RootConstrainSelectedInstOperands,
     /* 255360 */     // GIR_Coverage, 11949,
     /* 255360 */     GIR_EraseRootFromParent_Done,
     /* 255361 */   // Label 4939: @255361
     /* 255361 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255403), // Rule ID 11950 //
     /* 255366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 255374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 255393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255401 */     GIR_RootConstrainSelectedInstOperands,
     /* 255402 */     // GIR_Coverage, 11950,
     /* 255402 */     GIR_EraseRootFromParent_Done,
     /* 255403 */   // Label 4940: @255403
     /* 255403 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(255448), // Rule ID 11963 //
     /* 255408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 255419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 255435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255446 */     GIR_RootConstrainSelectedInstOperands,
     /* 255447 */     // GIR_Coverage, 11963,
     /* 255447 */     GIR_EraseRootFromParent_Done,
     /* 255448 */   // Label 4941: @255448
     /* 255448 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(255493), // Rule ID 11964 //
     /* 255453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 255464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255477 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 255480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255491 */     GIR_RootConstrainSelectedInstOperands,
     /* 255492 */     // GIR_Coverage, 11964,
     /* 255492 */     GIR_EraseRootFromParent_Done,
     /* 255493 */   // Label 4942: @255493
     /* 255493 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(255535), // Rule ID 11965 //
     /* 255498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255522 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 255525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255533 */     GIR_RootConstrainSelectedInstOperands,
     /* 255534 */     // GIR_Coverage, 11965,
     /* 255534 */     GIR_EraseRootFromParent_Done,
     /* 255535 */   // Label 4943: @255535
     /* 255535 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(255577), // Rule ID 11966 //
     /* 255540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1364:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 255567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255575 */     GIR_RootConstrainSelectedInstOperands,
     /* 255576 */     // GIR_Coverage, 11966,
     /* 255576 */     GIR_EraseRootFromParent_Done,
     /* 255577 */   // Label 4944: @255577
     /* 255577 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(255619), // Rule ID 11967 //
     /* 255582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1364:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 255609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255617 */     GIR_RootConstrainSelectedInstOperands,
     /* 255618 */     // GIR_Coverage, 11967,
     /* 255618 */     GIR_EraseRootFromParent_Done,
     /* 255619 */   // Label 4945: @255619
     /* 255619 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(255661), // Rule ID 11968 //
     /* 255624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1364:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 255651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255659 */     GIR_RootConstrainSelectedInstOperands,
     /* 255660 */     // GIR_Coverage, 11968,
     /* 255660 */     GIR_EraseRootFromParent_Done,
     /* 255661 */   // Label 4946: @255661
     /* 255661 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(255703), // Rule ID 11984 //
     /* 255666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 255693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255701 */     GIR_RootConstrainSelectedInstOperands,
     /* 255702 */     // GIR_Coverage, 11984,
     /* 255702 */     GIR_EraseRootFromParent_Done,
     /* 255703 */   // Label 4947: @255703
     /* 255703 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(255745), // Rule ID 11985 //
     /* 255708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 255735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255743 */     GIR_RootConstrainSelectedInstOperands,
     /* 255744 */     // GIR_Coverage, 11985,
     /* 255744 */     GIR_EraseRootFromParent_Done,
     /* 255745 */   // Label 4948: @255745
     /* 255745 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(255787), // Rule ID 11986 //
     /* 255750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255774 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 255777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255785 */     GIR_RootConstrainSelectedInstOperands,
     /* 255786 */     // GIR_Coverage, 11986,
     /* 255786 */     GIR_EraseRootFromParent_Done,
     /* 255787 */   // Label 4949: @255787
     /* 255787 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(255829), // Rule ID 11987 //
     /* 255792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 255819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255827 */     GIR_RootConstrainSelectedInstOperands,
     /* 255828 */     // GIR_Coverage, 11987,
     /* 255828 */     GIR_EraseRootFromParent_Done,
     /* 255829 */   // Label 4950: @255829
     /* 255829 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(255871), // Rule ID 11988 //
     /* 255834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255858 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 255861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255869 */     GIR_RootConstrainSelectedInstOperands,
     /* 255870 */     // GIR_Coverage, 11988,
     /* 255870 */     GIR_EraseRootFromParent_Done,
     /* 255871 */   // Label 4951: @255871
     /* 255871 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(255913), // Rule ID 11989 //
     /* 255876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255900 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 255903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255911 */     GIR_RootConstrainSelectedInstOperands,
     /* 255912 */     // GIR_Coverage, 11989,
     /* 255912 */     GIR_EraseRootFromParent_Done,
     /* 255913 */   // Label 4952: @255913
     /* 255913 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255955), // Rule ID 11990 //
     /* 255918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255942 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 255945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255953 */     GIR_RootConstrainSelectedInstOperands,
     /* 255954 */     // GIR_Coverage, 11990,
     /* 255954 */     GIR_EraseRootFromParent_Done,
     /* 255955 */   // Label 4953: @255955
     /* 255955 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255997), // Rule ID 11991 //
     /* 255960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 255987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255995 */     GIR_RootConstrainSelectedInstOperands,
     /* 255996 */     // GIR_Coverage, 11991,
     /* 255996 */     GIR_EraseRootFromParent_Done,
     /* 255997 */   // Label 4954: @255997
     /* 255997 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(256039), // Rule ID 11992 //
     /* 256002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 256010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256026 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 256029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256037 */     GIR_RootConstrainSelectedInstOperands,
     /* 256038 */     // GIR_Coverage, 11992,
     /* 256038 */     GIR_EraseRootFromParent_Done,
     /* 256039 */   // Label 4955: @256039
     /* 256039 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(256081), // Rule ID 11993 //
     /* 256044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 256052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256068 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 256071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256079 */     GIR_RootConstrainSelectedInstOperands,
     /* 256080 */     // GIR_Coverage, 11993,
     /* 256080 */     GIR_EraseRootFromParent_Done,
     /* 256081 */   // Label 4956: @256081
     /* 256081 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(256123), // Rule ID 11994 //
     /* 256086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 256094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256110 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 256113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256121 */     GIR_RootConstrainSelectedInstOperands,
     /* 256122 */     // GIR_Coverage, 11994,
     /* 256122 */     GIR_EraseRootFromParent_Done,
     /* 256123 */   // Label 4957: @256123
     /* 256123 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256165), // Rule ID 11995 //
     /* 256128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 256136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 256155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256163 */     GIR_RootConstrainSelectedInstOperands,
     /* 256164 */     // GIR_Coverage, 11995,
     /* 256164 */     GIR_EraseRootFromParent_Done,
     /* 256165 */   // Label 4958: @256165
     /* 256165 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256207), // Rule ID 12000 //
     /* 256170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 256178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256194 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 256197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256205 */     GIR_RootConstrainSelectedInstOperands,
     /* 256206 */     // GIR_Coverage, 12000,
     /* 256206 */     GIR_EraseRootFromParent_Done,
     /* 256207 */   // Label 4959: @256207
     /* 256207 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256249), // Rule ID 12001 //
     /* 256212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 256220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256236 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 256239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256247 */     GIR_RootConstrainSelectedInstOperands,
     /* 256248 */     // GIR_Coverage, 12001,
     /* 256248 */     GIR_EraseRootFromParent_Done,
     /* 256249 */   // Label 4960: @256249
     /* 256249 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256291), // Rule ID 12002 //
     /* 256254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 256262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256278 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 256281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256289 */     GIR_RootConstrainSelectedInstOperands,
     /* 256290 */     // GIR_Coverage, 12002,
     /* 256290 */     GIR_EraseRootFromParent_Done,
     /* 256291 */   // Label 4961: @256291
     /* 256291 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256333), // Rule ID 12003 //
     /* 256296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 256304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256320 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 256323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256331 */     GIR_RootConstrainSelectedInstOperands,
     /* 256332 */     // GIR_Coverage, 12003,
     /* 256332 */     GIR_EraseRootFromParent_Done,
     /* 256333 */   // Label 4962: @256333
     /* 256333 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256375), // Rule ID 12016 //
     /* 256338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256362 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1281:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256373 */     GIR_RootConstrainSelectedInstOperands,
     /* 256374 */     // GIR_Coverage, 12016,
     /* 256374 */     GIR_EraseRootFromParent_Done,
     /* 256375 */   // Label 4963: @256375
     /* 256375 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256417), // Rule ID 12018 //
     /* 256380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1281:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256415 */     GIR_RootConstrainSelectedInstOperands,
     /* 256416 */     // GIR_Coverage, 12018,
     /* 256416 */     GIR_EraseRootFromParent_Done,
     /* 256417 */   // Label 4964: @256417
     /* 256417 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(256459), // Rule ID 12020 //
     /* 256422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1281:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256457 */     GIR_RootConstrainSelectedInstOperands,
     /* 256458 */     // GIR_Coverage, 12020,
     /* 256458 */     GIR_EraseRootFromParent_Done,
     /* 256459 */   // Label 4965: @256459
     /* 256459 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(256501), // Rule ID 12022 //
     /* 256464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1281:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256499 */     GIR_RootConstrainSelectedInstOperands,
     /* 256500 */     // GIR_Coverage, 12022,
     /* 256500 */     GIR_EraseRootFromParent_Done,
     /* 256501 */   // Label 4966: @256501
     /* 256501 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(256543), // Rule ID 12234 //
     /* 256506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 256533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256541 */     GIR_RootConstrainSelectedInstOperands,
     /* 256542 */     // GIR_Coverage, 12234,
     /* 256542 */     GIR_EraseRootFromParent_Done,
     /* 256543 */   // Label 4967: @256543
     /* 256543 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(256585), // Rule ID 12236 //
     /* 256548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256583 */     GIR_RootConstrainSelectedInstOperands,
     /* 256584 */     // GIR_Coverage, 12236,
     /* 256584 */     GIR_EraseRootFromParent_Done,
     /* 256585 */   // Label 4968: @256585
     /* 256585 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(256627), // Rule ID 12238 //
     /* 256590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 256617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256625 */     GIR_RootConstrainSelectedInstOperands,
     /* 256626 */     // GIR_Coverage, 12238,
     /* 256626 */     GIR_EraseRootFromParent_Done,
     /* 256627 */   // Label 4969: @256627
     /* 256627 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(256669), // Rule ID 12240 //
     /* 256632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 256659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256667 */     GIR_RootConstrainSelectedInstOperands,
     /* 256668 */     // GIR_Coverage, 12240,
     /* 256668 */     GIR_EraseRootFromParent_Done,
     /* 256669 */   // Label 4970: @256669
     /* 256669 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(256711), // Rule ID 12242 //
     /* 256674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 256682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256698 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 256701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256709 */     GIR_RootConstrainSelectedInstOperands,
     /* 256710 */     // GIR_Coverage, 12242,
     /* 256710 */     GIR_EraseRootFromParent_Done,
     /* 256711 */   // Label 4971: @256711
     /* 256711 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(256753), // Rule ID 12244 //
     /* 256716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 256724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 256743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256751 */     GIR_RootConstrainSelectedInstOperands,
     /* 256752 */     // GIR_Coverage, 12244,
     /* 256752 */     GIR_EraseRootFromParent_Done,
     /* 256753 */   // Label 4972: @256753
     /* 256753 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(256795), // Rule ID 12407 //
     /* 256758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 256785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256793 */     GIR_RootConstrainSelectedInstOperands,
     /* 256794 */     // GIR_Coverage, 12407,
     /* 256794 */     GIR_EraseRootFromParent_Done,
     /* 256795 */   // Label 4973: @256795
     /* 256795 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(256837), // Rule ID 12408 //
     /* 256800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256835 */     GIR_RootConstrainSelectedInstOperands,
     /* 256836 */     // GIR_Coverage, 12408,
     /* 256836 */     GIR_EraseRootFromParent_Done,
     /* 256837 */   // Label 4974: @256837
     /* 256837 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(256879), // Rule ID 12409 //
     /* 256842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256877 */     GIR_RootConstrainSelectedInstOperands,
     /* 256878 */     // GIR_Coverage, 12409,
     /* 256878 */     GIR_EraseRootFromParent_Done,
     /* 256879 */   // Label 4975: @256879
     /* 256879 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(256921), // Rule ID 12410 //
     /* 256884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256919 */     GIR_RootConstrainSelectedInstOperands,
     /* 256920 */     // GIR_Coverage, 12410,
     /* 256920 */     GIR_EraseRootFromParent_Done,
     /* 256921 */   // Label 4976: @256921
     /* 256921 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256963), // Rule ID 12411 //
     /* 256926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256961 */     GIR_RootConstrainSelectedInstOperands,
     /* 256962 */     // GIR_Coverage, 12411,
     /* 256962 */     GIR_EraseRootFromParent_Done,
     /* 256963 */   // Label 4977: @256963
     /* 256963 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(257005), // Rule ID 12412 //
     /* 256968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256992 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257003 */     GIR_RootConstrainSelectedInstOperands,
     /* 257004 */     // GIR_Coverage, 12412,
     /* 257004 */     GIR_EraseRootFromParent_Done,
     /* 257005 */   // Label 4978: @257005
     /* 257005 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(257047), // Rule ID 12413 //
     /* 257010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 257013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 257018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 257024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257034 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 257037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257045 */     GIR_RootConstrainSelectedInstOperands,
     /* 257046 */     // GIR_Coverage, 12413,
     /* 257046 */     GIR_EraseRootFromParent_Done,
     /* 257047 */   // Label 4979: @257047
     /* 257047 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(257089), // Rule ID 12758 //
     /* 257052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 257060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 257079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257087 */     GIR_RootConstrainSelectedInstOperands,
     /* 257088 */     // GIR_Coverage, 12758,
     /* 257088 */     GIR_EraseRootFromParent_Done,
     /* 257089 */   // Label 4980: @257089
     /* 257089 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(257131), // Rule ID 12759 //
     /* 257094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 257102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257118 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 257121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257129 */     GIR_RootConstrainSelectedInstOperands,
     /* 257130 */     // GIR_Coverage, 12759,
     /* 257130 */     GIR_EraseRootFromParent_Done,
     /* 257131 */   // Label 4981: @257131
     /* 257131 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257173), // Rule ID 12760 //
     /* 257136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 257144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257160 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 257163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257171 */     GIR_RootConstrainSelectedInstOperands,
     /* 257172 */     // GIR_Coverage, 12760,
     /* 257172 */     GIR_EraseRootFromParent_Done,
     /* 257173 */   // Label 4982: @257173
     /* 257173 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257215), // Rule ID 12761 //
     /* 257178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 257186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 257205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257213 */     GIR_RootConstrainSelectedInstOperands,
     /* 257214 */     // GIR_Coverage, 12761,
     /* 257214 */     GIR_EraseRootFromParent_Done,
     /* 257215 */   // Label 4983: @257215
     /* 257215 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257257), // Rule ID 12762 //
     /* 257220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 257228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 257247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257255 */     GIR_RootConstrainSelectedInstOperands,
     /* 257256 */     // GIR_Coverage, 12762,
     /* 257256 */     GIR_EraseRootFromParent_Done,
     /* 257257 */   // Label 4984: @257257
     /* 257257 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257299), // Rule ID 12763 //
     /* 257262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 257270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257286 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 257289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257297 */     GIR_RootConstrainSelectedInstOperands,
     /* 257298 */     // GIR_Coverage, 12763,
     /* 257298 */     GIR_EraseRootFromParent_Done,
     /* 257299 */   // Label 4985: @257299
     /* 257299 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257341), // Rule ID 12764 //
     /* 257304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257328 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1380:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 257331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257339 */     GIR_RootConstrainSelectedInstOperands,
     /* 257340 */     // GIR_Coverage, 12764,
     /* 257340 */     GIR_EraseRootFromParent_Done,
     /* 257341 */   // Label 4986: @257341
     /* 257341 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257383), // Rule ID 12767 //
     /* 257346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 257357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 257363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 257366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257370 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 257370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 257373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257381 */     GIR_RootConstrainSelectedInstOperands,
     /* 257382 */     // GIR_Coverage, 12767,
     /* 257382 */     GIR_EraseRootFromParent_Done,
     /* 257383 */   // Label 4987: @257383
     /* 257383 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257425), // Rule ID 12770 //
     /* 257388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257412 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 257415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257423 */     GIR_RootConstrainSelectedInstOperands,
     /* 257424 */     // GIR_Coverage, 12770,
     /* 257424 */     GIR_EraseRootFromParent_Done,
     /* 257425 */   // Label 4988: @257425
     /* 257425 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257467), // Rule ID 12773 //
     /* 257430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257465 */     GIR_RootConstrainSelectedInstOperands,
     /* 257466 */     // GIR_Coverage, 12773,
     /* 257466 */     GIR_EraseRootFromParent_Done,
     /* 257467 */   // Label 4989: @257467
     /* 257467 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257509), // Rule ID 12776 //
     /* 257472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257507 */     GIR_RootConstrainSelectedInstOperands,
     /* 257508 */     // GIR_Coverage, 12776,
     /* 257508 */     GIR_EraseRootFromParent_Done,
     /* 257509 */   // Label 4990: @257509
     /* 257509 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(257551), // Rule ID 12779 //
     /* 257514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257538 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 257541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257549 */     GIR_RootConstrainSelectedInstOperands,
     /* 257550 */     // GIR_Coverage, 12779,
     /* 257550 */     GIR_EraseRootFromParent_Done,
     /* 257551 */   // Label 4991: @257551
     /* 257551 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257593), // Rule ID 12782 //
     /* 257556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257591 */     GIR_RootConstrainSelectedInstOperands,
     /* 257592 */     // GIR_Coverage, 12782,
     /* 257592 */     GIR_EraseRootFromParent_Done,
     /* 257593 */   // Label 4992: @257593
     /* 257593 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257635), // Rule ID 12785 //
     /* 257598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 257609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 257615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 257618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 257622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257633 */     GIR_RootConstrainSelectedInstOperands,
     /* 257634 */     // GIR_Coverage, 12785,
     /* 257634 */     GIR_EraseRootFromParent_Done,
     /* 257635 */   // Label 4993: @257635
     /* 257635 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257677), // Rule ID 12788 //
     /* 257640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257675 */     GIR_RootConstrainSelectedInstOperands,
     /* 257676 */     // GIR_Coverage, 12788,
     /* 257676 */     GIR_EraseRootFromParent_Done,
     /* 257677 */   // Label 4994: @257677
     /* 257677 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(257719), // Rule ID 12791 //
     /* 257682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257717 */     GIR_RootConstrainSelectedInstOperands,
     /* 257718 */     // GIR_Coverage, 12791,
     /* 257718 */     GIR_EraseRootFromParent_Done,
     /* 257719 */   // Label 4995: @257719
     /* 257719 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(257761), // Rule ID 12794 //
     /* 257724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257748 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257759 */     GIR_RootConstrainSelectedInstOperands,
     /* 257760 */     // GIR_Coverage, 12794,
     /* 257760 */     GIR_EraseRootFromParent_Done,
     /* 257761 */   // Label 4996: @257761
     /* 257761 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(257803), // Rule ID 12797 //
     /* 257766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNonStreamingSVE2_or_SME2),
     /* 257769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 257793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257801 */     GIR_RootConstrainSelectedInstOperands,
     /* 257802 */     // GIR_Coverage, 12797,
     /* 257802 */     GIR_EraseRootFromParent_Done,
     /* 257803 */   // Label 4997: @257803
     /* 257803 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(257946), // Rule ID 5636 //
     /* 257808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257829 */     // MIs[0] idx
     /* 257829 */     // No operand predicates
     /* 257829 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257843 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257846 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257850 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257855 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257858 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257862 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257865 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257870 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257875 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257906 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257942 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257944 */     GIR_RootConstrainSelectedInstOperands,
     /* 257945 */     // GIR_Coverage, 5636,
     /* 257945 */     GIR_EraseRootFromParent_Done,
     /* 257946 */   // Label 4998: @257946
     /* 257946 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258037), // Rule ID 5637 //
     /* 257951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257972 */     // MIs[0] idx
     /* 257972 */     // No operand predicates
     /* 257972 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 258026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258035 */     GIR_RootConstrainSelectedInstOperands,
     /* 258036 */     // GIR_Coverage, 5637,
     /* 258036 */     GIR_EraseRootFromParent_Done,
     /* 258037 */   // Label 4999: @258037
     /* 258037 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258128), // Rule ID 5638 //
     /* 258042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258063 */     // MIs[0] idx
     /* 258063 */     // No operand predicates
     /* 258063 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 258117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258124 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258126 */     GIR_RootConstrainSelectedInstOperands,
     /* 258127 */     // GIR_Coverage, 5638,
     /* 258127 */     GIR_EraseRootFromParent_Done,
     /* 258128 */   // Label 5000: @258128
     /* 258128 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258167), // Rule ID 5639 //
     /* 258133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258154 */     // MIs[0] idx
     /* 258154 */     // No operand predicates
     /* 258154 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 258157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258163 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258165 */     GIR_RootConstrainSelectedInstOperands,
     /* 258166 */     // GIR_Coverage, 5639,
     /* 258166 */     GIR_EraseRootFromParent_Done,
     /* 258167 */   // Label 5001: @258167
     /* 258167 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(258310), // Rule ID 5640 //
     /* 258172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258193 */     // MIs[0] idx
     /* 258193 */     // No operand predicates
     /* 258193 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258193 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 258196 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258200 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 258207 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 258210 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258214 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258219 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 258222 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258226 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 258229 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258234 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258239 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 258306 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258308 */     GIR_RootConstrainSelectedInstOperands,
     /* 258309 */     // GIR_Coverage, 5640,
     /* 258309 */     GIR_EraseRootFromParent_Done,
     /* 258310 */   // Label 5002: @258310
     /* 258310 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258401), // Rule ID 5641 //
     /* 258315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258336 */     // MIs[0] idx
     /* 258336 */     // No operand predicates
     /* 258336 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258397 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258399 */     GIR_RootConstrainSelectedInstOperands,
     /* 258400 */     // GIR_Coverage, 5641,
     /* 258400 */     GIR_EraseRootFromParent_Done,
     /* 258401 */   // Label 5003: @258401
     /* 258401 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258492), // Rule ID 5642 //
     /* 258406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258427 */     // MIs[0] idx
     /* 258427 */     // No operand predicates
     /* 258427 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258488 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258490 */     GIR_RootConstrainSelectedInstOperands,
     /* 258491 */     // GIR_Coverage, 5642,
     /* 258491 */     GIR_EraseRootFromParent_Done,
     /* 258492 */   // Label 5004: @258492
     /* 258492 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258531), // Rule ID 5643 //
     /* 258497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258518 */     // MIs[0] idx
     /* 258518 */     // No operand predicates
     /* 258518 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258527 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258529 */     GIR_RootConstrainSelectedInstOperands,
     /* 258530 */     // GIR_Coverage, 5643,
     /* 258530 */     GIR_EraseRootFromParent_Done,
     /* 258531 */   // Label 5005: @258531
     /* 258531 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258674), // Rule ID 5644 //
     /* 258536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258557 */     // MIs[0] idx
     /* 258557 */     // No operand predicates
     /* 258557 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258557 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 258560 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258564 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 258571 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 258574 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258578 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258583 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 258586 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258590 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 258593 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258598 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258603 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 258670 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258672 */     GIR_RootConstrainSelectedInstOperands,
     /* 258673 */     // GIR_Coverage, 5644,
     /* 258673 */     GIR_EraseRootFromParent_Done,
     /* 258674 */   // Label 5006: @258674
     /* 258674 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258765), // Rule ID 5645 //
     /* 258679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258700 */     // MIs[0] idx
     /* 258700 */     // No operand predicates
     /* 258700 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258761 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258763 */     GIR_RootConstrainSelectedInstOperands,
     /* 258764 */     // GIR_Coverage, 5645,
     /* 258764 */     GIR_EraseRootFromParent_Done,
     /* 258765 */   // Label 5007: @258765
     /* 258765 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258856), // Rule ID 5646 //
     /* 258770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258791 */     // MIs[0] idx
     /* 258791 */     // No operand predicates
     /* 258791 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258852 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258854 */     GIR_RootConstrainSelectedInstOperands,
     /* 258855 */     // GIR_Coverage, 5646,
     /* 258855 */     GIR_EraseRootFromParent_Done,
     /* 258856 */   // Label 5008: @258856
     /* 258856 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258895), // Rule ID 5647 //
     /* 258861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258882 */     // MIs[0] idx
     /* 258882 */     // No operand predicates
     /* 258882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258891 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258893 */     GIR_RootConstrainSelectedInstOperands,
     /* 258894 */     // GIR_Coverage, 5647,
     /* 258894 */     GIR_EraseRootFromParent_Done,
     /* 258895 */   // Label 5009: @258895
     /* 258895 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258934), // Rule ID 5648 //
     /* 258900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 258908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258921 */     // MIs[0] idx
     /* 258921 */     // No operand predicates
     /* 258921 */     // (intrinsic_wo_chain:{ *:[v16i8] } 782:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258930 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258932 */     GIR_RootConstrainSelectedInstOperands,
     /* 258933 */     // GIR_Coverage, 5648,
     /* 258933 */     GIR_EraseRootFromParent_Done,
     /* 258934 */   // Label 5010: @258934
     /* 258934 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(259025), // Rule ID 5649 //
     /* 258939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 258947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258960 */     // MIs[0] idx
     /* 258960 */     // No operand predicates
     /* 258960 */     // (intrinsic_wo_chain:{ *:[v16i8] } 780:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 259014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 259018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259021 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259023 */     GIR_RootConstrainSelectedInstOperands,
     /* 259024 */     // GIR_Coverage, 5649,
     /* 259024 */     GIR_EraseRootFromParent_Done,
     /* 259025 */   // Label 5011: @259025
     /* 259025 */   GIM_Reject,
     /* 259026 */ // Label 4151: @259026
     /* 259026 */ GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(266137),
     /* 259031 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 259034 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(259081), // Rule ID 2980 //
     /* 259039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 259047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 259050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 259066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 259069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259079 */     GIR_RootConstrainSelectedInstOperands,
     /* 259080 */     // GIR_Coverage, 2980,
     /* 259080 */     GIR_EraseRootFromParent_Done,
     /* 259081 */   // Label 5013: @259081
     /* 259081 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259128), // Rule ID 2982 //
     /* 259086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 259094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 259113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 259116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259124 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259126 */     GIR_RootConstrainSelectedInstOperands,
     /* 259127 */     // GIR_Coverage, 2982,
     /* 259127 */     GIR_EraseRootFromParent_Done,
     /* 259128 */   // Label 5014: @259128
     /* 259128 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259175), // Rule ID 2984 //
     /* 259133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 259141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 259160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 259163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259173 */     GIR_RootConstrainSelectedInstOperands,
     /* 259174 */     // GIR_Coverage, 2984,
     /* 259174 */     GIR_EraseRootFromParent_Done,
     /* 259175 */   // Label 5015: @259175
     /* 259175 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259222), // Rule ID 2986 //
     /* 259180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 259188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 259207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 259210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259218 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259220 */     GIR_RootConstrainSelectedInstOperands,
     /* 259221 */     // GIR_Coverage, 2986,
     /* 259221 */     GIR_EraseRootFromParent_Done,
     /* 259222 */   // Label 5016: @259222
     /* 259222 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259269), // Rule ID 7682 //
     /* 259227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 259235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 259238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259254 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 259254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 259257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259265 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259267 */     GIR_RootConstrainSelectedInstOperands,
     /* 259268 */     // GIR_Coverage, 7682,
     /* 259268 */     GIR_EraseRootFromParent_Done,
     /* 259269 */   // Label 5017: @259269
     /* 259269 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259316), // Rule ID 7684 //
     /* 259274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 259282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 259301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 259304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259312 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259314 */     GIR_RootConstrainSelectedInstOperands,
     /* 259315 */     // GIR_Coverage, 7684,
     /* 259315 */     GIR_EraseRootFromParent_Done,
     /* 259316 */   // Label 5018: @259316
     /* 259316 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259363), // Rule ID 7686 //
     /* 259321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 259329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 259348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 259351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259361 */     GIR_RootConstrainSelectedInstOperands,
     /* 259362 */     // GIR_Coverage, 7686,
     /* 259362 */     GIR_EraseRootFromParent_Done,
     /* 259363 */   // Label 5019: @259363
     /* 259363 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259410), // Rule ID 7688 //
     /* 259368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 259376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 259395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 259398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259408 */     GIR_RootConstrainSelectedInstOperands,
     /* 259409 */     // GIR_Coverage, 7688,
     /* 259409 */     GIR_EraseRootFromParent_Done,
     /* 259410 */   // Label 5020: @259410
     /* 259410 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259490), // Rule ID 5758 //
     /* 259415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259455 */     // MIs[1] Operand 1
     /* 259455 */     // No operand predicates
     /* 259455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259471 */     // MIs[2] Operand 1
     /* 259471 */     // No operand predicates
     /* 259471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259473 */     // (intrinsic_wo_chain:{ *:[v16i8] } 771:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 259473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 259476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259488 */     GIR_RootConstrainSelectedInstOperands,
     /* 259489 */     // GIR_Coverage, 5758,
     /* 259489 */     GIR_EraseRootFromParent_Done,
     /* 259490 */   // Label 5021: @259490
     /* 259490 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259570), // Rule ID 5759 //
     /* 259495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259535 */     // MIs[1] Operand 1
     /* 259535 */     // No operand predicates
     /* 259535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259551 */     // MIs[2] Operand 1
     /* 259551 */     // No operand predicates
     /* 259551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259553 */     // (intrinsic_wo_chain:{ *:[v8i16] } 771:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 259553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 259556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259568 */     GIR_RootConstrainSelectedInstOperands,
     /* 259569 */     // GIR_Coverage, 5759,
     /* 259569 */     GIR_EraseRootFromParent_Done,
     /* 259570 */   // Label 5022: @259570
     /* 259570 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259650), // Rule ID 5760 //
     /* 259575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259615 */     // MIs[1] Operand 1
     /* 259615 */     // No operand predicates
     /* 259615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259627 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259631 */     // MIs[2] Operand 1
     /* 259631 */     // No operand predicates
     /* 259631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 771:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 259633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 259636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259648 */     GIR_RootConstrainSelectedInstOperands,
     /* 259649 */     // GIR_Coverage, 5760,
     /* 259649 */     GIR_EraseRootFromParent_Done,
     /* 259650 */   // Label 5023: @259650
     /* 259650 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259730), // Rule ID 5761 //
     /* 259655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 259663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 259666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 259672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259695 */     // MIs[1] Operand 1
     /* 259695 */     // No operand predicates
     /* 259695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259711 */     // MIs[2] Operand 1
     /* 259711 */     // No operand predicates
     /* 259711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259713 */     // (intrinsic_wo_chain:{ *:[v2i64] } 771:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 259713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 259716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259728 */     GIR_RootConstrainSelectedInstOperands,
     /* 259729 */     // GIR_Coverage, 5761,
     /* 259729 */     GIR_EraseRootFromParent_Done,
     /* 259730 */   // Label 5024: @259730
     /* 259730 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259794), // Rule ID 3882 //
     /* 259735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 259743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259771 */     // MIs[0] imm
     /* 259771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259779 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 259782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259790 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259792 */     GIR_RootConstrainSelectedInstOperands,
     /* 259793 */     // GIR_Coverage, 3882,
     /* 259793 */     GIR_EraseRootFromParent_Done,
     /* 259794 */   // Label 5025: @259794
     /* 259794 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259858), // Rule ID 3883 //
     /* 259799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 259807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259835 */     // MIs[0] imm
     /* 259835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259843 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 259846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259854 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259856 */     GIR_RootConstrainSelectedInstOperands,
     /* 259857 */     // GIR_Coverage, 3883,
     /* 259857 */     GIR_EraseRootFromParent_Done,
     /* 259858 */   // Label 5026: @259858
     /* 259858 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259922), // Rule ID 3884 //
     /* 259863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 259871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259899 */     // MIs[0] imm
     /* 259899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 259910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259918 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259920 */     GIR_RootConstrainSelectedInstOperands,
     /* 259921 */     // GIR_Coverage, 3884,
     /* 259921 */     GIR_EraseRootFromParent_Done,
     /* 259922 */   // Label 5027: @259922
     /* 259922 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259986), // Rule ID 3885 //
     /* 259927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 259935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259963 */     // MIs[0] imm
     /* 259963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259971 */     // (intrinsic_wo_chain:{ *:[v4i32] } 550:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 259974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259982 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259984 */     GIR_RootConstrainSelectedInstOperands,
     /* 259985 */     // GIR_Coverage, 3885,
     /* 259985 */     GIR_EraseRootFromParent_Done,
     /* 259986 */   // Label 5028: @259986
     /* 259986 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(260038), // Rule ID 2852 //
     /* 259991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260015 */     // MIs[0] idx
     /* 260015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260023 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 260023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 260026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260034 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260036 */     GIR_RootConstrainSelectedInstOperands,
     /* 260037 */     // GIR_Coverage, 2852,
     /* 260037 */     GIR_EraseRootFromParent_Done,
     /* 260038 */   // Label 5029: @260038
     /* 260038 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(260090), // Rule ID 2855 //
     /* 260043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 260051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260067 */     // MIs[0] idx
     /* 260067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260075 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 260078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260086 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260088 */     GIR_RootConstrainSelectedInstOperands,
     /* 260089 */     // GIR_Coverage, 2855,
     /* 260089 */     GIR_EraseRootFromParent_Done,
     /* 260090 */   // Label 5030: @260090
     /* 260090 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(260142), // Rule ID 2858 //
     /* 260095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 260103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260119 */     // MIs[0] idx
     /* 260119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 260130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260138 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260140 */     GIR_RootConstrainSelectedInstOperands,
     /* 260141 */     // GIR_Coverage, 2858,
     /* 260141 */     GIR_EraseRootFromParent_Done,
     /* 260142 */   // Label 5031: @260142
     /* 260142 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(260194), // Rule ID 2995 //
     /* 260147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 260155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260171 */     // MIs[0] Op4
     /* 260171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 260182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260190 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260192 */     GIR_RootConstrainSelectedInstOperands,
     /* 260193 */     // GIR_Coverage, 2995,
     /* 260193 */     GIR_EraseRootFromParent_Done,
     /* 260194 */   // Label 5032: @260194
     /* 260194 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260246), // Rule ID 2996 //
     /* 260199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 260207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260223 */     // MIs[0] Op4
     /* 260223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 260234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260242 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260244 */     GIR_RootConstrainSelectedInstOperands,
     /* 260245 */     // GIR_Coverage, 2996,
     /* 260245 */     GIR_EraseRootFromParent_Done,
     /* 260246 */   // Label 5033: @260246
     /* 260246 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260298), // Rule ID 2997 //
     /* 260251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 260259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260275 */     // MIs[0] Op4
     /* 260275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 260286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260294 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260296 */     GIR_RootConstrainSelectedInstOperands,
     /* 260297 */     // GIR_Coverage, 2997,
     /* 260297 */     GIR_EraseRootFromParent_Done,
     /* 260298 */   // Label 5034: @260298
     /* 260298 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260350), // Rule ID 2998 //
     /* 260303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 260311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260327 */     // MIs[0] Op4
     /* 260327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 260338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260348 */     GIR_RootConstrainSelectedInstOperands,
     /* 260349 */     // GIR_Coverage, 2998,
     /* 260349 */     GIR_EraseRootFromParent_Done,
     /* 260350 */   // Label 5035: @260350
     /* 260350 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260402), // Rule ID 2999 //
     /* 260355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 260363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260379 */     // MIs[0] Op4
     /* 260379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 260390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260400 */     GIR_RootConstrainSelectedInstOperands,
     /* 260401 */     // GIR_Coverage, 2999,
     /* 260401 */     GIR_EraseRootFromParent_Done,
     /* 260402 */   // Label 5036: @260402
     /* 260402 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260454), // Rule ID 3002 //
     /* 260407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260431 */     // MIs[0] Op4
     /* 260431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 260442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260450 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260452 */     GIR_RootConstrainSelectedInstOperands,
     /* 260453 */     // GIR_Coverage, 3002,
     /* 260453 */     GIR_EraseRootFromParent_Done,
     /* 260454 */   // Label 5037: @260454
     /* 260454 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260506), // Rule ID 3003 //
     /* 260459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260483 */     // MIs[0] Op4
     /* 260483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 260494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260502 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260504 */     GIR_RootConstrainSelectedInstOperands,
     /* 260505 */     // GIR_Coverage, 3003,
     /* 260505 */     GIR_EraseRootFromParent_Done,
     /* 260506 */   // Label 5038: @260506
     /* 260506 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(260558), // Rule ID 3483 //
     /* 260511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 260519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260535 */     // MIs[0] Op4
     /* 260535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 260546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260554 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260556 */     GIR_RootConstrainSelectedInstOperands,
     /* 260557 */     // GIR_Coverage, 3483,
     /* 260557 */     GIR_EraseRootFromParent_Done,
     /* 260558 */   // Label 5039: @260558
     /* 260558 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260610), // Rule ID 3533 //
     /* 260563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 260571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260587 */     // MIs[0] Op4
     /* 260587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 260598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260606 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260608 */     GIR_RootConstrainSelectedInstOperands,
     /* 260609 */     // GIR_Coverage, 3533,
     /* 260609 */     GIR_EraseRootFromParent_Done,
     /* 260610 */   // Label 5040: @260610
     /* 260610 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260662), // Rule ID 7756 //
     /* 260615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260639 */     // MIs[0] Op4
     /* 260639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 260650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260658 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260660 */     GIR_RootConstrainSelectedInstOperands,
     /* 260661 */     // GIR_Coverage, 7756,
     /* 260661 */     GIR_EraseRootFromParent_Done,
     /* 260662 */   // Label 5041: @260662
     /* 260662 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260714), // Rule ID 7757 //
     /* 260667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260691 */     // MIs[0] Op4
     /* 260691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 260702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260712 */     GIR_RootConstrainSelectedInstOperands,
     /* 260713 */     // GIR_Coverage, 7757,
     /* 260713 */     GIR_EraseRootFromParent_Done,
     /* 260714 */   // Label 5042: @260714
     /* 260714 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260766), // Rule ID 8402 //
     /* 260719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260743 */     // MIs[0] idx
     /* 260743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260751 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 260751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 260754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260762 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260764 */     GIR_RootConstrainSelectedInstOperands,
     /* 260765 */     // GIR_Coverage, 8402,
     /* 260765 */     GIR_EraseRootFromParent_Done,
     /* 260766 */   // Label 5043: @260766
     /* 260766 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260818), // Rule ID 8405 //
     /* 260771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260795 */     // MIs[0] idx
     /* 260795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 260806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260814 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260816 */     GIR_RootConstrainSelectedInstOperands,
     /* 260817 */     // GIR_Coverage, 8405,
     /* 260817 */     GIR_EraseRootFromParent_Done,
     /* 260818 */   // Label 5044: @260818
     /* 260818 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260870), // Rule ID 8408 //
     /* 260823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260847 */     // MIs[0] idx
     /* 260847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260855 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1479:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 260858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260866 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260868 */     GIR_RootConstrainSelectedInstOperands,
     /* 260869 */     // GIR_Coverage, 8408,
     /* 260869 */     GIR_EraseRootFromParent_Done,
     /* 260870 */   // Label 5045: @260870
     /* 260870 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260922), // Rule ID 11390 //
     /* 260875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 260883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260899 */     // MIs[0] Op4
     /* 260899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260907 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 260910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260918 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260920 */     GIR_RootConstrainSelectedInstOperands,
     /* 260921 */     // GIR_Coverage, 11390,
     /* 260921 */     GIR_EraseRootFromParent_Done,
     /* 260922 */   // Label 5046: @260922
     /* 260922 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260974), // Rule ID 11437 //
     /* 260927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260951 */     // MIs[0] Op4
     /* 260951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 260962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260970 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260972 */     GIR_RootConstrainSelectedInstOperands,
     /* 260973 */     // GIR_Coverage, 11437,
     /* 260973 */     GIR_EraseRootFromParent_Done,
     /* 260974 */   // Label 5047: @260974
     /* 260974 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(261026), // Rule ID 11438 //
     /* 260979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261003 */     // MIs[0] Op4
     /* 261003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 261014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261024 */     GIR_RootConstrainSelectedInstOperands,
     /* 261025 */     // GIR_Coverage, 11438,
     /* 261025 */     GIR_EraseRootFromParent_Done,
     /* 261026 */   // Label 5048: @261026
     /* 261026 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261078), // Rule ID 11439 //
     /* 261031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 261039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261055 */     // MIs[0] Op4
     /* 261055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 261063 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 261063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 261066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261074 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261076 */     GIR_RootConstrainSelectedInstOperands,
     /* 261077 */     // GIR_Coverage, 11439,
     /* 261077 */     GIR_EraseRootFromParent_Done,
     /* 261078 */   // Label 5049: @261078
     /* 261078 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261130), // Rule ID 11440 //
     /* 261083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 261091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261107 */     // MIs[0] Op4
     /* 261107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 261118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261126 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261128 */     GIR_RootConstrainSelectedInstOperands,
     /* 261129 */     // GIR_Coverage, 11440,
     /* 261129 */     GIR_EraseRootFromParent_Done,
     /* 261130 */   // Label 5050: @261130
     /* 261130 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261182), // Rule ID 11441 //
     /* 261135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 261143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261159 */     // MIs[0] Op4
     /* 261159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 261170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261178 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261180 */     GIR_RootConstrainSelectedInstOperands,
     /* 261181 */     // GIR_Coverage, 11441,
     /* 261181 */     GIR_EraseRootFromParent_Done,
     /* 261182 */   // Label 5051: @261182
     /* 261182 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261234), // Rule ID 11442 //
     /* 261187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 261195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261211 */     // MIs[0] Op4
     /* 261211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 261219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 261219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 261222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261230 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261232 */     GIR_RootConstrainSelectedInstOperands,
     /* 261233 */     // GIR_Coverage, 11442,
     /* 261233 */     GIR_EraseRootFromParent_Done,
     /* 261234 */   // Label 5052: @261234
     /* 261234 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261286), // Rule ID 11443 //
     /* 261239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 261247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261263 */     // MIs[0] Op4
     /* 261263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 261274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261282 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261284 */     GIR_RootConstrainSelectedInstOperands,
     /* 261285 */     // GIR_Coverage, 11443,
     /* 261285 */     GIR_EraseRootFromParent_Done,
     /* 261286 */   // Label 5053: @261286
     /* 261286 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261338), // Rule ID 11444 //
     /* 261291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 261299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261315 */     // MIs[0] Op4
     /* 261315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 261326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261334 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261336 */     GIR_RootConstrainSelectedInstOperands,
     /* 261337 */     // GIR_Coverage, 11444,
     /* 261337 */     GIR_EraseRootFromParent_Done,
     /* 261338 */   // Label 5054: @261338
     /* 261338 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261390), // Rule ID 11445 //
     /* 261343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 261351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261367 */     // MIs[0] Op4
     /* 261367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 261375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 261375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 261378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261386 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261388 */     GIR_RootConstrainSelectedInstOperands,
     /* 261389 */     // GIR_Coverage, 11445,
     /* 261389 */     GIR_EraseRootFromParent_Done,
     /* 261390 */   // Label 5055: @261390
     /* 261390 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261442), // Rule ID 11488 //
     /* 261395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261419 */     // MIs[0] Op4
     /* 261419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 261430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261438 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261440 */     GIR_RootConstrainSelectedInstOperands,
     /* 261441 */     // GIR_Coverage, 11488,
     /* 261441 */     GIR_EraseRootFromParent_Done,
     /* 261442 */   // Label 5056: @261442
     /* 261442 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261494), // Rule ID 11489 //
     /* 261447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261471 */     // MIs[0] Op4
     /* 261471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 261482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261490 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261492 */     GIR_RootConstrainSelectedInstOperands,
     /* 261493 */     // GIR_Coverage, 11489,
     /* 261493 */     GIR_EraseRootFromParent_Done,
     /* 261494 */   // Label 5057: @261494
     /* 261494 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261546), // Rule ID 11490 //
     /* 261499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261523 */     // MIs[0] Op4
     /* 261523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261531 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 261534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261542 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261544 */     GIR_RootConstrainSelectedInstOperands,
     /* 261545 */     // GIR_Coverage, 11490,
     /* 261545 */     GIR_EraseRootFromParent_Done,
     /* 261546 */   // Label 5058: @261546
     /* 261546 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261598), // Rule ID 11491 //
     /* 261551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261575 */     // MIs[0] Op4
     /* 261575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 261586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261596 */     GIR_RootConstrainSelectedInstOperands,
     /* 261597 */     // GIR_Coverage, 11491,
     /* 261597 */     GIR_EraseRootFromParent_Done,
     /* 261598 */   // Label 5059: @261598
     /* 261598 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261650), // Rule ID 11492 //
     /* 261603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261627 */     // MIs[0] Op4
     /* 261627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261635 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 261638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261648 */     GIR_RootConstrainSelectedInstOperands,
     /* 261649 */     // GIR_Coverage, 11492,
     /* 261649 */     GIR_EraseRootFromParent_Done,
     /* 261650 */   // Label 5060: @261650
     /* 261650 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261702), // Rule ID 11493 //
     /* 261655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261679 */     // MIs[0] Op4
     /* 261679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 261690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261698 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261700 */     GIR_RootConstrainSelectedInstOperands,
     /* 261701 */     // GIR_Coverage, 11493,
     /* 261701 */     GIR_EraseRootFromParent_Done,
     /* 261702 */   // Label 5061: @261702
     /* 261702 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261754), // Rule ID 11494 //
     /* 261707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261731 */     // MIs[0] Op4
     /* 261731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 261742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261750 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261752 */     GIR_RootConstrainSelectedInstOperands,
     /* 261753 */     // GIR_Coverage, 11494,
     /* 261753 */     GIR_EraseRootFromParent_Done,
     /* 261754 */   // Label 5062: @261754
     /* 261754 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261806), // Rule ID 11495 //
     /* 261759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261783 */     // MIs[0] Op4
     /* 261783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1758:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 261794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261802 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261804 */     GIR_RootConstrainSelectedInstOperands,
     /* 261805 */     // GIR_Coverage, 11495,
     /* 261805 */     GIR_EraseRootFromParent_Done,
     /* 261806 */   // Label 5063: @261806
     /* 261806 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261858), // Rule ID 11496 //
     /* 261811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261835 */     // MIs[0] Op4
     /* 261835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 261846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261854 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261856 */     GIR_RootConstrainSelectedInstOperands,
     /* 261857 */     // GIR_Coverage, 11496,
     /* 261857 */     GIR_EraseRootFromParent_Done,
     /* 261858 */   // Label 5064: @261858
     /* 261858 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261910), // Rule ID 11497 //
     /* 261863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261887 */     // MIs[0] Op4
     /* 261887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 261898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261906 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261908 */     GIR_RootConstrainSelectedInstOperands,
     /* 261909 */     // GIR_Coverage, 11497,
     /* 261909 */     GIR_EraseRootFromParent_Done,
     /* 261910 */   // Label 5065: @261910
     /* 261910 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261962), // Rule ID 11498 //
     /* 261915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261939 */     // MIs[0] Op4
     /* 261939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 261950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261960 */     GIR_RootConstrainSelectedInstOperands,
     /* 261961 */     // GIR_Coverage, 11498,
     /* 261961 */     GIR_EraseRootFromParent_Done,
     /* 261962 */   // Label 5066: @261962
     /* 261962 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(262014), // Rule ID 11499 //
     /* 261967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261991 */     // MIs[0] Op4
     /* 261991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 262002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262010 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262012 */     GIR_RootConstrainSelectedInstOperands,
     /* 262013 */     // GIR_Coverage, 11499,
     /* 262013 */     GIR_EraseRootFromParent_Done,
     /* 262014 */   // Label 5067: @262014
     /* 262014 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(262066), // Rule ID 11500 //
     /* 262019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 262027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262043 */     // MIs[0] Op4
     /* 262043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1998:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 262054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262062 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262064 */     GIR_RootConstrainSelectedInstOperands,
     /* 262065 */     // GIR_Coverage, 11500,
     /* 262065 */     GIR_EraseRootFromParent_Done,
     /* 262066 */   // Label 5068: @262066
     /* 262066 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262118), // Rule ID 11501 //
     /* 262071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 262079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262095 */     // MIs[0] Op4
     /* 262095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262103 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1998:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 262106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262114 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262116 */     GIR_RootConstrainSelectedInstOperands,
     /* 262117 */     // GIR_Coverage, 11501,
     /* 262117 */     GIR_EraseRootFromParent_Done,
     /* 262118 */   // Label 5069: @262118
     /* 262118 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262170), // Rule ID 11523 //
     /* 262123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 262131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262147 */     // MIs[0] Op4
     /* 262147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 262158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262166 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262168 */     GIR_RootConstrainSelectedInstOperands,
     /* 262169 */     // GIR_Coverage, 11523,
     /* 262169 */     GIR_EraseRootFromParent_Done,
     /* 262170 */   // Label 5070: @262170
     /* 262170 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262222), // Rule ID 11524 //
     /* 262175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 262183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262199 */     // MIs[0] Op4
     /* 262199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 262210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262218 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262220 */     GIR_RootConstrainSelectedInstOperands,
     /* 262221 */     // GIR_Coverage, 11524,
     /* 262221 */     GIR_EraseRootFromParent_Done,
     /* 262222 */   // Label 5071: @262222
     /* 262222 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262274), // Rule ID 11525 //
     /* 262227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 262235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262251 */     // MIs[0] Op4
     /* 262251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 262262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262272 */     GIR_RootConstrainSelectedInstOperands,
     /* 262273 */     // GIR_Coverage, 11525,
     /* 262273 */     GIR_EraseRootFromParent_Done,
     /* 262274 */   // Label 5072: @262274
     /* 262274 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262326), // Rule ID 11526 //
     /* 262279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 262287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262303 */     // MIs[0] Op4
     /* 262303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 262314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262322 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262324 */     GIR_RootConstrainSelectedInstOperands,
     /* 262325 */     // GIR_Coverage, 11526,
     /* 262325 */     GIR_EraseRootFromParent_Done,
     /* 262326 */   // Label 5073: @262326
     /* 262326 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262378), // Rule ID 11527 //
     /* 262331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 262339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262355 */     // MIs[0] Op4
     /* 262355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 262366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262374 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262376 */     GIR_RootConstrainSelectedInstOperands,
     /* 262377 */     // GIR_Coverage, 11527,
     /* 262377 */     GIR_EraseRootFromParent_Done,
     /* 262378 */   // Label 5074: @262378
     /* 262378 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262430), // Rule ID 11528 //
     /* 262383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 262391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262407 */     // MIs[0] Op4
     /* 262407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 262418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262426 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262428 */     GIR_RootConstrainSelectedInstOperands,
     /* 262429 */     // GIR_Coverage, 11528,
     /* 262429 */     GIR_EraseRootFromParent_Done,
     /* 262430 */   // Label 5075: @262430
     /* 262430 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262482), // Rule ID 11529 //
     /* 262435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262459 */     // MIs[0] Op4
     /* 262459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 262470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262478 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262480 */     GIR_RootConstrainSelectedInstOperands,
     /* 262481 */     // GIR_Coverage, 11529,
     /* 262481 */     GIR_EraseRootFromParent_Done,
     /* 262482 */   // Label 5076: @262482
     /* 262482 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262534), // Rule ID 11530 //
     /* 262487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262511 */     // MIs[0] Op4
     /* 262511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 262522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262530 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262532 */     GIR_RootConstrainSelectedInstOperands,
     /* 262533 */     // GIR_Coverage, 11530,
     /* 262533 */     GIR_EraseRootFromParent_Done,
     /* 262534 */   // Label 5077: @262534
     /* 262534 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262586), // Rule ID 11996 //
     /* 262539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 262547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262563 */     // MIs[0] Op4
     /* 262563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 262574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262584 */     GIR_RootConstrainSelectedInstOperands,
     /* 262585 */     // GIR_Coverage, 11996,
     /* 262585 */     GIR_EraseRootFromParent_Done,
     /* 262586 */   // Label 5078: @262586
     /* 262586 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262638), // Rule ID 11997 //
     /* 262591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 262599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262615 */     // MIs[0] Op4
     /* 262615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262623 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 262626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262634 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262636 */     GIR_RootConstrainSelectedInstOperands,
     /* 262637 */     // GIR_Coverage, 11997,
     /* 262637 */     GIR_EraseRootFromParent_Done,
     /* 262638 */   // Label 5079: @262638
     /* 262638 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262690), // Rule ID 11998 //
     /* 262643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 262651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262667 */     // MIs[0] Op4
     /* 262667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262675 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 262678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262686 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262688 */     GIR_RootConstrainSelectedInstOperands,
     /* 262689 */     // GIR_Coverage, 11998,
     /* 262689 */     GIR_EraseRootFromParent_Done,
     /* 262690 */   // Label 5080: @262690
     /* 262690 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(262742), // Rule ID 11999 //
     /* 262695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 262703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262719 */     // MIs[0] Op4
     /* 262719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262727 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 262730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262738 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262740 */     GIR_RootConstrainSelectedInstOperands,
     /* 262741 */     // GIR_Coverage, 11999,
     /* 262741 */     GIR_EraseRootFromParent_Done,
     /* 262742 */   // Label 5081: @262742
     /* 262742 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(262794), // Rule ID 12243 //
     /* 262747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 262755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262771 */     // MIs[0] Op4
     /* 262771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262779 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1430:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 262782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262790 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262792 */     GIR_RootConstrainSelectedInstOperands,
     /* 262793 */     // GIR_Coverage, 12243,
     /* 262793 */     GIR_EraseRootFromParent_Done,
     /* 262794 */   // Label 5082: @262794
     /* 262794 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262846), // Rule ID 12245 //
     /* 262799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 262807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262823 */     // MIs[0] Op4
     /* 262823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 262834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262842 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262844 */     GIR_RootConstrainSelectedInstOperands,
     /* 262845 */     // GIR_Coverage, 12245,
     /* 262845 */     GIR_EraseRootFromParent_Done,
     /* 262846 */   // Label 5083: @262846
     /* 262846 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262893), // Rule ID 2829 //
     /* 262851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262878 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262889 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262891 */     GIR_RootConstrainSelectedInstOperands,
     /* 262892 */     // GIR_Coverage, 2829,
     /* 262892 */     GIR_EraseRootFromParent_Done,
     /* 262893 */   // Label 5084: @262893
     /* 262893 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262940), // Rule ID 2832 //
     /* 262898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262925 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262936 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262938 */     GIR_RootConstrainSelectedInstOperands,
     /* 262939 */     // GIR_Coverage, 2832,
     /* 262939 */     GIR_EraseRootFromParent_Done,
     /* 262940 */   // Label 5085: @262940
     /* 262940 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262987), // Rule ID 2835 //
     /* 262945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262985 */     GIR_RootConstrainSelectedInstOperands,
     /* 262986 */     // GIR_Coverage, 2835,
     /* 262986 */     GIR_EraseRootFromParent_Done,
     /* 262987 */   // Label 5086: @262987
     /* 262987 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(263034), // Rule ID 2838 //
     /* 262992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 263000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263019 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 263022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263030 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263032 */     GIR_RootConstrainSelectedInstOperands,
     /* 263033 */     // GIR_Coverage, 2838,
     /* 263033 */     GIR_EraseRootFromParent_Done,
     /* 263034 */   // Label 5087: @263034
     /* 263034 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(263081), // Rule ID 2841 //
     /* 263039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 263047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263066 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 263069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263079 */     GIR_RootConstrainSelectedInstOperands,
     /* 263080 */     // GIR_Coverage, 2841,
     /* 263080 */     GIR_EraseRootFromParent_Done,
     /* 263081 */   // Label 5088: @263081
     /* 263081 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263128), // Rule ID 2844 //
     /* 263086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 263094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263113 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 263116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263124 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263126 */     GIR_RootConstrainSelectedInstOperands,
     /* 263127 */     // GIR_Coverage, 2844,
     /* 263127 */     GIR_EraseRootFromParent_Done,
     /* 263128 */   // Label 5089: @263128
     /* 263128 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263175), // Rule ID 2847 //
     /* 263133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 263141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263160 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1434:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 263163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263173 */     GIR_RootConstrainSelectedInstOperands,
     /* 263174 */     // GIR_Coverage, 2847,
     /* 263174 */     GIR_EraseRootFromParent_Done,
     /* 263175 */   // Label 5090: @263175
     /* 263175 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263222), // Rule ID 2848 //
     /* 263180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 263188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1434:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 263210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263218 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263220 */     GIR_RootConstrainSelectedInstOperands,
     /* 263221 */     // GIR_Coverage, 2848,
     /* 263221 */     GIR_EraseRootFromParent_Done,
     /* 263222 */   // Label 5091: @263222
     /* 263222 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263269), // Rule ID 2849 //
     /* 263227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 263235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263254 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1434:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 263257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263265 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263267 */     GIR_RootConstrainSelectedInstOperands,
     /* 263268 */     // GIR_Coverage, 2849,
     /* 263268 */     GIR_EraseRootFromParent_Done,
     /* 263269 */   // Label 5092: @263269
     /* 263269 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263316), // Rule ID 2960 //
     /* 263274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1609:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 263304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263312 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263314 */     GIR_RootConstrainSelectedInstOperands,
     /* 263315 */     // GIR_Coverage, 2960,
     /* 263315 */     GIR_EraseRootFromParent_Done,
     /* 263316 */   // Label 5093: @263316
     /* 263316 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263363), // Rule ID 2963 //
     /* 263321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 263351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263361 */     GIR_RootConstrainSelectedInstOperands,
     /* 263362 */     // GIR_Coverage, 2963,
     /* 263362 */     GIR_EraseRootFromParent_Done,
     /* 263363 */   // Label 5094: @263363
     /* 263363 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263410), // Rule ID 2966 //
     /* 263368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 263398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263408 */     GIR_RootConstrainSelectedInstOperands,
     /* 263409 */     // GIR_Coverage, 2966,
     /* 263409 */     GIR_EraseRootFromParent_Done,
     /* 263410 */   // Label 5095: @263410
     /* 263410 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263457), // Rule ID 2969 //
     /* 263415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 263445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263455 */     GIR_RootConstrainSelectedInstOperands,
     /* 263456 */     // GIR_Coverage, 2969,
     /* 263456 */     GIR_EraseRootFromParent_Done,
     /* 263457 */   // Label 5096: @263457
     /* 263457 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263504), // Rule ID 2972 //
     /* 263462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263489 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 263492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263502 */     GIR_RootConstrainSelectedInstOperands,
     /* 263503 */     // GIR_Coverage, 2972,
     /* 263503 */     GIR_EraseRootFromParent_Done,
     /* 263504 */   // Label 5097: @263504
     /* 263504 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263551), // Rule ID 2974 //
     /* 263509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 263539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263549 */     GIR_RootConstrainSelectedInstOperands,
     /* 263550 */     // GIR_Coverage, 2974,
     /* 263550 */     GIR_EraseRootFromParent_Done,
     /* 263551 */   // Label 5098: @263551
     /* 263551 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263598), // Rule ID 2976 //
     /* 263556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263583 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 263586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263596 */     GIR_RootConstrainSelectedInstOperands,
     /* 263597 */     // GIR_Coverage, 2976,
     /* 263597 */     GIR_EraseRootFromParent_Done,
     /* 263598 */   // Label 5099: @263598
     /* 263598 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(263645), // Rule ID 2978 //
     /* 263603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 263633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263643 */     GIR_RootConstrainSelectedInstOperands,
     /* 263644 */     // GIR_Coverage, 2978,
     /* 263644 */     GIR_EraseRootFromParent_Done,
     /* 263645 */   // Label 5100: @263645
     /* 263645 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(263692), // Rule ID 7662 //
     /* 263650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 263680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263688 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263690 */     GIR_RootConstrainSelectedInstOperands,
     /* 263691 */     // GIR_Coverage, 7662,
     /* 263691 */     GIR_EraseRootFromParent_Done,
     /* 263692 */   // Label 5101: @263692
     /* 263692 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(263739), // Rule ID 7665 //
     /* 263697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 263727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263737 */     GIR_RootConstrainSelectedInstOperands,
     /* 263738 */     // GIR_Coverage, 7665,
     /* 263738 */     GIR_EraseRootFromParent_Done,
     /* 263739 */   // Label 5102: @263739
     /* 263739 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(263786), // Rule ID 7668 //
     /* 263744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 263774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263784 */     GIR_RootConstrainSelectedInstOperands,
     /* 263785 */     // GIR_Coverage, 7668,
     /* 263785 */     GIR_EraseRootFromParent_Done,
     /* 263786 */   // Label 5103: @263786
     /* 263786 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263833), // Rule ID 7671 //
     /* 263791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 263821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263831 */     GIR_RootConstrainSelectedInstOperands,
     /* 263832 */     // GIR_Coverage, 7671,
     /* 263832 */     GIR_EraseRootFromParent_Done,
     /* 263833 */   // Label 5104: @263833
     /* 263833 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263880), // Rule ID 7674 //
     /* 263838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263865 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 263868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263878 */     GIR_RootConstrainSelectedInstOperands,
     /* 263879 */     // GIR_Coverage, 7674,
     /* 263879 */     GIR_EraseRootFromParent_Done,
     /* 263880 */   // Label 5105: @263880
     /* 263880 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263927), // Rule ID 7676 //
     /* 263885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 263915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263923 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263925 */     GIR_RootConstrainSelectedInstOperands,
     /* 263926 */     // GIR_Coverage, 7676,
     /* 263926 */     GIR_EraseRootFromParent_Done,
     /* 263927 */   // Label 5106: @263927
     /* 263927 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263974), // Rule ID 7678 //
     /* 263932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 263962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263970 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263972 */     GIR_RootConstrainSelectedInstOperands,
     /* 263973 */     // GIR_Coverage, 7678,
     /* 263973 */     GIR_EraseRootFromParent_Done,
     /* 263974 */   // Label 5107: @263974
     /* 263974 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(264021), // Rule ID 7680 //
     /* 263979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 264006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 264009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264017 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264019 */     GIR_RootConstrainSelectedInstOperands,
     /* 264020 */     // GIR_Coverage, 7680,
     /* 264020 */     GIR_EraseRootFromParent_Done,
     /* 264021 */   // Label 5108: @264021
     /* 264021 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(264068), // Rule ID 8313 //
     /* 264026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264053 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 264056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264064 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264066 */     GIR_RootConstrainSelectedInstOperands,
     /* 264067 */     // GIR_Coverage, 8313,
     /* 264067 */     GIR_EraseRootFromParent_Done,
     /* 264068 */   // Label 5109: @264068
     /* 264068 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264115), // Rule ID 8316 //
     /* 264073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264100 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 264103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264113 */     GIR_RootConstrainSelectedInstOperands,
     /* 264114 */     // GIR_Coverage, 8316,
     /* 264114 */     GIR_EraseRootFromParent_Done,
     /* 264115 */   // Label 5110: @264115
     /* 264115 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264162), // Rule ID 8319 //
     /* 264120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264147 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 264150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264160 */     GIR_RootConstrainSelectedInstOperands,
     /* 264161 */     // GIR_Coverage, 8319,
     /* 264161 */     GIR_EraseRootFromParent_Done,
     /* 264162 */   // Label 5111: @264162
     /* 264162 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264209), // Rule ID 8322 //
     /* 264167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264194 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 264197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264207 */     GIR_RootConstrainSelectedInstOperands,
     /* 264208 */     // GIR_Coverage, 8322,
     /* 264208 */     GIR_EraseRootFromParent_Done,
     /* 264209 */   // Label 5112: @264209
     /* 264209 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264256), // Rule ID 8325 //
     /* 264214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264241 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 264244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264252 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264254 */     GIR_RootConstrainSelectedInstOperands,
     /* 264255 */     // GIR_Coverage, 8325,
     /* 264255 */     GIR_EraseRootFromParent_Done,
     /* 264256 */   // Label 5113: @264256
     /* 264256 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264303), // Rule ID 8328 //
     /* 264261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 264269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264288 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 264291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264301 */     GIR_RootConstrainSelectedInstOperands,
     /* 264302 */     // GIR_Coverage, 8328,
     /* 264302 */     GIR_EraseRootFromParent_Done,
     /* 264303 */   // Label 5114: @264303
     /* 264303 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264350), // Rule ID 8331 //
     /* 264308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264335 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264348 */     GIR_RootConstrainSelectedInstOperands,
     /* 264349 */     // GIR_Coverage, 8331,
     /* 264349 */     GIR_EraseRootFromParent_Done,
     /* 264350 */   // Label 5115: @264350
     /* 264350 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264397), // Rule ID 8332 //
     /* 264355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264395 */     GIR_RootConstrainSelectedInstOperands,
     /* 264396 */     // GIR_Coverage, 8332,
     /* 264396 */     GIR_EraseRootFromParent_Done,
     /* 264397 */   // Label 5116: @264397
     /* 264397 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264444), // Rule ID 8333 //
     /* 264402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264429 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264440 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264442 */     GIR_RootConstrainSelectedInstOperands,
     /* 264443 */     // GIR_Coverage, 8333,
     /* 264443 */     GIR_EraseRootFromParent_Done,
     /* 264444 */   // Label 5117: @264444
     /* 264444 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264491), // Rule ID 8334 //
     /* 264449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264489 */     GIR_RootConstrainSelectedInstOperands,
     /* 264490 */     // GIR_Coverage, 8334,
     /* 264490 */     GIR_EraseRootFromParent_Done,
     /* 264491 */   // Label 5118: @264491
     /* 264491 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264538), // Rule ID 8335 //
     /* 264496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264523 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264536 */     GIR_RootConstrainSelectedInstOperands,
     /* 264537 */     // GIR_Coverage, 8335,
     /* 264537 */     GIR_EraseRootFromParent_Done,
     /* 264538 */   // Label 5119: @264538
     /* 264538 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(264585), // Rule ID 8336 //
     /* 264543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 264573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264581 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264583 */     GIR_RootConstrainSelectedInstOperands,
     /* 264584 */     // GIR_Coverage, 8336,
     /* 264584 */     GIR_EraseRootFromParent_Done,
     /* 264585 */   // Label 5120: @264585
     /* 264585 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(264632), // Rule ID 8337 //
     /* 264590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264617 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264628 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264630 */     GIR_RootConstrainSelectedInstOperands,
     /* 264631 */     // GIR_Coverage, 8337,
     /* 264631 */     GIR_EraseRootFromParent_Done,
     /* 264632 */   // Label 5121: @264632
     /* 264632 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(264679), // Rule ID 8338 //
     /* 264637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264675 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264677 */     GIR_RootConstrainSelectedInstOperands,
     /* 264678 */     // GIR_Coverage, 8338,
     /* 264678 */     GIR_EraseRootFromParent_Done,
     /* 264679 */   // Label 5122: @264679
     /* 264679 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(264726), // Rule ID 8339 //
     /* 264684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264711 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264722 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264724 */     GIR_RootConstrainSelectedInstOperands,
     /* 264725 */     // GIR_Coverage, 8339,
     /* 264725 */     GIR_EraseRootFromParent_Done,
     /* 264726 */   // Label 5123: @264726
     /* 264726 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(264773), // Rule ID 8340 //
     /* 264731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264758 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264769 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264771 */     GIR_RootConstrainSelectedInstOperands,
     /* 264772 */     // GIR_Coverage, 8340,
     /* 264772 */     GIR_EraseRootFromParent_Done,
     /* 264773 */   // Label 5124: @264773
     /* 264773 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(264820), // Rule ID 8341 //
     /* 264778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264805 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264818 */     GIR_RootConstrainSelectedInstOperands,
     /* 264819 */     // GIR_Coverage, 8341,
     /* 264819 */     GIR_EraseRootFromParent_Done,
     /* 264820 */   // Label 5125: @264820
     /* 264820 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264867), // Rule ID 8342 //
     /* 264825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264852 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 264855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264865 */     GIR_RootConstrainSelectedInstOperands,
     /* 264866 */     // GIR_Coverage, 8342,
     /* 264866 */     GIR_EraseRootFromParent_Done,
     /* 264867 */   // Label 5126: @264867
     /* 264867 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264914), // Rule ID 8343 //
     /* 264872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264899 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 264902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264912 */     GIR_RootConstrainSelectedInstOperands,
     /* 264913 */     // GIR_Coverage, 8343,
     /* 264913 */     GIR_EraseRootFromParent_Done,
     /* 264914 */   // Label 5127: @264914
     /* 264914 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264961), // Rule ID 8344 //
     /* 264919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 264949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264959 */     GIR_RootConstrainSelectedInstOperands,
     /* 264960 */     // GIR_Coverage, 8344,
     /* 264960 */     GIR_EraseRootFromParent_Done,
     /* 264961 */   // Label 5128: @264961
     /* 264961 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(265008), // Rule ID 8345 //
     /* 264966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 264996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265004 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265006 */     GIR_RootConstrainSelectedInstOperands,
     /* 265007 */     // GIR_Coverage, 8345,
     /* 265007 */     GIR_EraseRootFromParent_Done,
     /* 265008 */   // Label 5129: @265008
     /* 265008 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(265055), // Rule ID 8346 //
     /* 265013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 265021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 265043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265051 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265053 */     GIR_RootConstrainSelectedInstOperands,
     /* 265054 */     // GIR_Coverage, 8346,
     /* 265054 */     GIR_EraseRootFromParent_Done,
     /* 265055 */   // Label 5130: @265055
     /* 265055 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265102), // Rule ID 8347 //
     /* 265060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 265068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 265090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265098 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265100 */     GIR_RootConstrainSelectedInstOperands,
     /* 265101 */     // GIR_Coverage, 8347,
     /* 265101 */     GIR_EraseRootFromParent_Done,
     /* 265102 */   // Label 5131: @265102
     /* 265102 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265149), // Rule ID 8348 //
     /* 265107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 265115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 265137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265147 */     GIR_RootConstrainSelectedInstOperands,
     /* 265148 */     // GIR_Coverage, 8348,
     /* 265148 */     GIR_EraseRootFromParent_Done,
     /* 265149 */   // Label 5132: @265149
     /* 265149 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265196), // Rule ID 8349 //
     /* 265154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 265162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265181 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 265184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265194 */     GIR_RootConstrainSelectedInstOperands,
     /* 265195 */     // GIR_Coverage, 8349,
     /* 265195 */     GIR_EraseRootFromParent_Done,
     /* 265196 */   // Label 5133: @265196
     /* 265196 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265243), // Rule ID 8350 //
     /* 265201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 265209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 265231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265241 */     GIR_RootConstrainSelectedInstOperands,
     /* 265242 */     // GIR_Coverage, 8350,
     /* 265242 */     GIR_EraseRootFromParent_Done,
     /* 265243 */   // Label 5134: @265243
     /* 265243 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265290), // Rule ID 8351 //
     /* 265248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 265256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265275 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1498:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 265278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265286 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265288 */     GIR_RootConstrainSelectedInstOperands,
     /* 265289 */     // GIR_Coverage, 8351,
     /* 265289 */     GIR_EraseRootFromParent_Done,
     /* 265290 */   // Label 5135: @265290
     /* 265290 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265337), // Rule ID 8352 //
     /* 265295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265322 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 265325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265335 */     GIR_RootConstrainSelectedInstOperands,
     /* 265336 */     // GIR_Coverage, 8352,
     /* 265336 */     GIR_EraseRootFromParent_Done,
     /* 265337 */   // Label 5136: @265337
     /* 265337 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265384), // Rule ID 8355 //
     /* 265342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 265372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265380 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265382 */     GIR_RootConstrainSelectedInstOperands,
     /* 265383 */     // GIR_Coverage, 8355,
     /* 265383 */     GIR_EraseRootFromParent_Done,
     /* 265384 */   // Label 5137: @265384
     /* 265384 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265431), // Rule ID 8358 //
     /* 265389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265416 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 265419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265429 */     GIR_RootConstrainSelectedInstOperands,
     /* 265430 */     // GIR_Coverage, 8358,
     /* 265430 */     GIR_EraseRootFromParent_Done,
     /* 265431 */   // Label 5138: @265431
     /* 265431 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265478), // Rule ID 8361 //
     /* 265436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265463 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265474 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265476 */     GIR_RootConstrainSelectedInstOperands,
     /* 265477 */     // GIR_Coverage, 8361,
     /* 265477 */     GIR_EraseRootFromParent_Done,
     /* 265478 */   // Label 5139: @265478
     /* 265478 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265525), // Rule ID 8364 //
     /* 265483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265510 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265523 */     GIR_RootConstrainSelectedInstOperands,
     /* 265524 */     // GIR_Coverage, 8364,
     /* 265524 */     GIR_EraseRootFromParent_Done,
     /* 265525 */   // Label 5140: @265525
     /* 265525 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265572), // Rule ID 8367 //
     /* 265530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265557 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 265560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265570 */     GIR_RootConstrainSelectedInstOperands,
     /* 265571 */     // GIR_Coverage, 8367,
     /* 265571 */     GIR_EraseRootFromParent_Done,
     /* 265572 */   // Label 5141: @265572
     /* 265572 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(265619), // Rule ID 8370 //
     /* 265577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265604 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265615 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265617 */     GIR_RootConstrainSelectedInstOperands,
     /* 265618 */     // GIR_Coverage, 8370,
     /* 265618 */     GIR_EraseRootFromParent_Done,
     /* 265619 */   // Label 5142: @265619
     /* 265619 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(265666), // Rule ID 8373 //
     /* 265624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265651 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265662 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265664 */     GIR_RootConstrainSelectedInstOperands,
     /* 265665 */     // GIR_Coverage, 8373,
     /* 265665 */     GIR_EraseRootFromParent_Done,
     /* 265666 */   // Label 5143: @265666
     /* 265666 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(265713), // Rule ID 8376 //
     /* 265671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265698 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265711 */     GIR_RootConstrainSelectedInstOperands,
     /* 265712 */     // GIR_Coverage, 8376,
     /* 265712 */     GIR_EraseRootFromParent_Done,
     /* 265713 */   // Label 5144: @265713
     /* 265713 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(265760), // Rule ID 8379 //
     /* 265718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265756 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265758 */     GIR_RootConstrainSelectedInstOperands,
     /* 265759 */     // GIR_Coverage, 8379,
     /* 265759 */     GIR_EraseRootFromParent_Done,
     /* 265760 */   // Label 5145: @265760
     /* 265760 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(265807), // Rule ID 8382 //
     /* 265765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265803 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265805 */     GIR_RootConstrainSelectedInstOperands,
     /* 265806 */     // GIR_Coverage, 8382,
     /* 265806 */     GIR_EraseRootFromParent_Done,
     /* 265807 */   // Label 5146: @265807
     /* 265807 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(265854), // Rule ID 8385 //
     /* 265812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265839 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 265842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265850 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265852 */     GIR_RootConstrainSelectedInstOperands,
     /* 265853 */     // GIR_Coverage, 8385,
     /* 265853 */     GIR_EraseRootFromParent_Done,
     /* 265854 */   // Label 5147: @265854
     /* 265854 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(265901), // Rule ID 8388 //
     /* 265859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265886 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265899 */     GIR_RootConstrainSelectedInstOperands,
     /* 265900 */     // GIR_Coverage, 8388,
     /* 265900 */     GIR_EraseRootFromParent_Done,
     /* 265901 */   // Label 5148: @265901
     /* 265901 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(265948), // Rule ID 8390 //
     /* 265906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265944 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265946 */     GIR_RootConstrainSelectedInstOperands,
     /* 265947 */     // GIR_Coverage, 8390,
     /* 265947 */     GIR_EraseRootFromParent_Done,
     /* 265948 */   // Label 5149: @265948
     /* 265948 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(265995), // Rule ID 8392 //
     /* 265953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265980 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265991 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265993 */     GIR_RootConstrainSelectedInstOperands,
     /* 265994 */     // GIR_Coverage, 8392,
     /* 265994 */     GIR_EraseRootFromParent_Done,
     /* 265995 */   // Label 5150: @265995
     /* 265995 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(266042), // Rule ID 8394 //
     /* 266000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 266008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266027 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 266030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266038 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266040 */     GIR_RootConstrainSelectedInstOperands,
     /* 266041 */     // GIR_Coverage, 8394,
     /* 266041 */     GIR_EraseRootFromParent_Done,
     /* 266042 */   // Label 5151: @266042
     /* 266042 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(266089), // Rule ID 8396 //
     /* 266047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 266055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266074 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 266077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266087 */     GIR_RootConstrainSelectedInstOperands,
     /* 266088 */     // GIR_Coverage, 8396,
     /* 266088 */     GIR_EraseRootFromParent_Done,
     /* 266089 */   // Label 5152: @266089
     /* 266089 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(266136), // Rule ID 8398 //
     /* 266094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 266102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266121 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 266124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266132 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266134 */     GIR_RootConstrainSelectedInstOperands,
     /* 266135 */     // GIR_Coverage, 8398,
     /* 266135 */     GIR_EraseRootFromParent_Done,
     /* 266136 */   // Label 5153: @266136
     /* 266136 */   GIM_Reject,
     /* 266137 */ // Label 5012: @266137
     /* 266137 */ GIM_Reject,
     /* 266138 */ // Label 38: @266138
     /* 266138 */ GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(266216),
     /* 266143 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 266146 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(266168), // Rule ID 78 //
     /* 266151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 266159 */     // (intrinsic_void 2176:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 266159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 266162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266166 */     GIR_RootConstrainSelectedInstOperands,
     /* 266167 */     // GIR_Coverage, 78,
     /* 266167 */     GIR_EraseRootFromParent_Done,
     /* 266168 */   // Label 5155: @266168
     /* 266168 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(266193), // Rule ID 2390 //
     /* 266173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 266181 */     // (intrinsic_void 1726:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 266181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 266184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 266187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266191 */     GIR_RootConstrainSelectedInstOperands,
     /* 266192 */     // GIR_Coverage, 2390,
     /* 266192 */     GIR_EraseRootFromParent_Done,
     /* 266193 */   // Label 5156: @266193
     /* 266193 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(266215), // Rule ID 7216 //
     /* 266198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 266203 */     // (intrinsic_void 510:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 266203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 266206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 266209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266213 */     GIR_RootConstrainSelectedInstOperands,
     /* 266214 */     // GIR_Coverage, 7216,
     /* 266214 */     GIR_EraseRootFromParent_Done,
     /* 266215 */   // Label 5157: @266215
     /* 266215 */   GIM_Reject,
     /* 266216 */ // Label 5154: @266216
     /* 266216 */ GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266816),
     /* 266221 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 266224 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266256), // Rule ID 79 //
     /* 266229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 266237 */     // MIs[0] imm
     /* 266237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 266240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 266245 */     // (intrinsic_void 2175:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 266245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 266248 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 266250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266254 */     GIR_RootConstrainSelectedInstOperands,
     /* 266255 */     // GIR_Coverage, 79,
     /* 266255 */     GIR_EraseRootFromParent_Done,
     /* 266256 */   // Label 5159: @266256
     /* 266256 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266281), // Rule ID 231 //
     /* 266261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 266266 */     // MIs[0] imm
     /* 266266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 266269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 266274 */     // (intrinsic_void 508:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 266274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 266277 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 266279 */     GIR_RootConstrainSelectedInstOperands,
     /* 266280 */     // GIR_Coverage, 231,
     /* 266280 */     GIR_EraseRootFromParent_Done,
     /* 266281 */   // Label 5160: @266281
     /* 266281 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266306), // Rule ID 232 //
     /* 266286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 266291 */     // MIs[0] imm
     /* 266291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 266294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 266299 */     // (intrinsic_void 567:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 266299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 266302 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 266304 */     GIR_RootConstrainSelectedInstOperands,
     /* 266305 */     // GIR_Coverage, 232,
     /* 266305 */     GIR_EraseRootFromParent_Done,
     /* 266306 */   // Label 5161: @266306
     /* 266306 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266338), // Rule ID 3651 //
     /* 266311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 266319 */     // MIs[0] imm
     /* 266319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 266322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 266327 */     // (intrinsic_void 1232:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 266327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 266330 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 266332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266336 */     GIR_RootConstrainSelectedInstOperands,
     /* 266337 */     // GIR_Coverage, 3651,
     /* 266337 */     GIR_EraseRootFromParent_Done,
     /* 266338 */   // Label 5162: @266338
     /* 266338 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(266378), // Rule ID 16 //
     /* 266343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 266348 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 266363 */     // MIs[1] Operand 1
     /* 266363 */     // No operand predicates
     /* 266363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266365 */     // (intrinsic_void 566:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 266365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 266368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 266371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266376 */     GIR_RootConstrainSelectedInstOperands,
     /* 266377 */     // GIR_Coverage, 16,
     /* 266377 */     GIR_EraseRootFromParent_Done,
     /* 266378 */   // Label 5163: @266378
     /* 266378 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(266418), // Rule ID 17 //
     /* 266383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 266388 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266403 */     // MIs[1] Operand 1
     /* 266403 */     // No operand predicates
     /* 266403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266405 */     // (intrinsic_void 554:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 266405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 266408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266416 */     GIR_RootConstrainSelectedInstOperands,
     /* 266417 */     // GIR_Coverage, 17,
     /* 266417 */     GIR_EraseRootFromParent_Done,
     /* 266418 */   // Label 5164: @266418
     /* 266418 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(266458), // Rule ID 18 //
     /* 266423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 266428 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266443 */     // MIs[1] Operand 1
     /* 266443 */     // No operand predicates
     /* 266443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266445 */     // (intrinsic_void 555:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 266445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 266448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266456 */     GIR_RootConstrainSelectedInstOperands,
     /* 266457 */     // GIR_Coverage, 18,
     /* 266457 */     GIR_EraseRootFromParent_Done,
     /* 266458 */   // Label 5165: @266458
     /* 266458 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(266498), // Rule ID 19 //
     /* 266463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 266468 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266483 */     // MIs[1] Operand 1
     /* 266483 */     // No operand predicates
     /* 266483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266485 */     // (intrinsic_void 570:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 266485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 266488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266496 */     GIR_RootConstrainSelectedInstOperands,
     /* 266497 */     // GIR_Coverage, 19,
     /* 266497 */     GIR_EraseRootFromParent_Done,
     /* 266498 */   // Label 5166: @266498
     /* 266498 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(266522), // Rule ID 72 //
     /* 266503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 266508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266515 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 266515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 266518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266520 */     GIR_RootConstrainSelectedInstOperands,
     /* 266521 */     // GIR_Coverage, 72,
     /* 266521 */     GIR_EraseRootFromParent_Done,
     /* 266522 */   // Label 5167: @266522
     /* 266522 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(266546), // Rule ID 74 //
     /* 266527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 266532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266539 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 266539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 266542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266544 */     GIR_RootConstrainSelectedInstOperands,
     /* 266545 */     // GIR_Coverage, 74,
     /* 266545 */     GIR_EraseRootFromParent_Done,
     /* 266546 */   // Label 5168: @266546
     /* 266546 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(266577), // Rule ID 77 //
     /* 266551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 266559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266566 */     // (intrinsic_w_chain:{ *:[i64] } 2177:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 266566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 266569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266575 */     GIR_RootConstrainSelectedInstOperands,
     /* 266576 */     // GIR_Coverage, 77,
     /* 266576 */     GIR_EraseRootFromParent_Done,
     /* 266577 */   // Label 5169: @266577
     /* 266577 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(266604), // Rule ID 80 //
     /* 266582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 266590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266597 */     // (intrinsic_w_chain:{ *:[i64] } 2178:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 266597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 266600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266602 */     GIR_RootConstrainSelectedInstOperands,
     /* 266603 */     // GIR_Coverage, 80,
     /* 266603 */     GIR_EraseRootFromParent_Done,
     /* 266604 */   // Label 5170: @266604
     /* 266604 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(266635), // Rule ID 2389 //
     /* 266609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 266617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 266620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266624 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 266624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 266627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 266629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266633 */     GIR_RootConstrainSelectedInstOperands,
     /* 266634 */     // GIR_Coverage, 2389,
     /* 266634 */     GIR_EraseRootFromParent_Done,
     /* 266635 */   // Label 5171: @266635
     /* 266635 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(266675), // Rule ID 13029 //
     /* 266640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 266648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266655 */     // (intrinsic_w_chain:{ *:[i64] } 901:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 266655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 266658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266660 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 266673 */     GIR_RootConstrainSelectedInstOperands,
     /* 266674 */     // GIR_Coverage, 13029,
     /* 266674 */     GIR_EraseRootFromParent_Done,
     /* 266675 */   // Label 5172: @266675
     /* 266675 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(266709), // Rule ID 2391 //
     /* 266680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 266688 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 266691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266695 */     // (intrinsic_void 2156:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 266695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 266698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 266700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 266703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266707 */     GIR_RootConstrainSelectedInstOperands,
     /* 266708 */     // GIR_Coverage, 2391,
     /* 266708 */     GIR_EraseRootFromParent_Done,
     /* 266709 */   // Label 5173: @266709
     /* 266709 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(266732), // Rule ID 73 //
     /* 266714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 266719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266722 */     // (intrinsic_void 790:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 266722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 266725 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 266730 */     GIR_RootConstrainSelectedInstOperands,
     /* 266731 */     // GIR_Coverage, 73,
     /* 266731 */     GIR_EraseRootFromParent_Done,
     /* 266732 */   // Label 5174: @266732
     /* 266732 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(266755), // Rule ID 75 //
     /* 266737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 266742 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266745 */     // (intrinsic_void 792:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 266745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 266748 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 266753 */     GIR_RootConstrainSelectedInstOperands,
     /* 266754 */     // GIR_Coverage, 75,
     /* 266754 */     GIR_EraseRootFromParent_Done,
     /* 266755 */   // Label 5175: @266755
     /* 266755 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(266782), // Rule ID 76 //
     /* 266760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 266765 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266768 */     // (intrinsic_void 791:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 266768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 266771 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 266776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266780 */     GIR_RootConstrainSelectedInstOperands,
     /* 266781 */     // GIR_Coverage, 76,
     /* 266781 */     GIR_EraseRootFromParent_Done,
     /* 266782 */   // Label 5176: @266782
     /* 266782 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(266815), // Rule ID 13028 //
     /* 266787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 266795 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266798 */     // (intrinsic_void 976:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 266798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 266801 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266811 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266813 */     GIR_RootConstrainSelectedInstOperands,
     /* 266814 */     // GIR_Coverage, 13028,
     /* 266814 */     GIR_EraseRootFromParent_Done,
     /* 266815 */   // Label 5177: @266815
     /* 266815 */   GIM_Reject,
     /* 266816 */ // Label 5158: @266816
     /* 266816 */ GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(267787),
     /* 266821 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 266824 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266900), // Rule ID 7182 //
     /* 266829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266841 */     // MIs[0] addr
     /* 266841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 266853 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 266860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266869 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266899 */     // GIR_Coverage, 7182,
     /* 266899 */     GIR_EraseRootFromParent_Done,
     /* 266900 */   // Label 5179: @266900
     /* 266900 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(266976), // Rule ID 7183 //
     /* 266905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266917 */     // MIs[0] addr
     /* 266917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 266929 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 266936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266975 */     // GIR_Coverage, 7183,
     /* 266975 */     GIR_EraseRootFromParent_Done,
     /* 266976 */   // Label 5180: @266976
     /* 266976 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267052), // Rule ID 7184 //
     /* 266981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266993 */     // MIs[0] addr
     /* 266993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 267005 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 267005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 267012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 267021 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 267030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 267041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267051 */     // GIR_Coverage, 7184,
     /* 267051 */     GIR_EraseRootFromParent_Done,
     /* 267052 */   // Label 5181: @267052
     /* 267052 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267094), // Rule ID 7185 //
     /* 267057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 267062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267069 */     // MIs[0] addr
     /* 267069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 267073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 267081 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 267081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 267084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 267086 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 267088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267092 */     GIR_RootConstrainSelectedInstOperands,
     /* 267093 */     // GIR_Coverage, 7185,
     /* 267093 */     GIR_EraseRootFromParent_Done,
     /* 267094 */   // Label 5182: @267094
     /* 267094 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267170), // Rule ID 7189 //
     /* 267099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 267104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267111 */     // MIs[0] addr
     /* 267111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 267115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 267123 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 267123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 267130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 267139 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 267148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 267159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267169 */     // GIR_Coverage, 7189,
     /* 267169 */     GIR_EraseRootFromParent_Done,
     /* 267170 */   // Label 5183: @267170
     /* 267170 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267246), // Rule ID 7190 //
     /* 267175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 267180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267187 */     // MIs[0] addr
     /* 267187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 267191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 267199 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 267199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 267206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 267215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 267224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 267235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267245 */     // GIR_Coverage, 7190,
     /* 267245 */     GIR_EraseRootFromParent_Done,
     /* 267246 */   // Label 5184: @267246
     /* 267246 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(267322), // Rule ID 7191 //
     /* 267251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 267256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267263 */     // MIs[0] addr
     /* 267263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 267267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 267275 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 267275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 267282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 267291 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 267300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 267311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 267316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267321 */     // GIR_Coverage, 7191,
     /* 267321 */     GIR_EraseRootFromParent_Done,
     /* 267322 */   // Label 5185: @267322
     /* 267322 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267364), // Rule ID 7192 //
     /* 267327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 267332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267339 */     // MIs[0] addr
     /* 267339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 267343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 267351 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 267351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 267354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 267356 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 267358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267362 */     GIR_RootConstrainSelectedInstOperands,
     /* 267363 */     // GIR_Coverage, 7192,
     /* 267363 */     GIR_EraseRootFromParent_Done,
     /* 267364 */   // Label 5186: @267364
     /* 267364 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267404), // Rule ID 20 //
     /* 267369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 267372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 267377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267391 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 267391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 267394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 267396 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 267398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267402 */     GIR_RootConstrainSelectedInstOperands,
     /* 267403 */     // GIR_Coverage, 20,
     /* 267403 */     GIR_EraseRootFromParent_Done,
     /* 267404 */   // Label 5187: @267404
     /* 267404 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267444), // Rule ID 2388 //
     /* 267409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 267412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 267417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 267420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 267423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267431 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 267431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 267434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 267436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 267438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267442 */     GIR_RootConstrainSelectedInstOperands,
     /* 267443 */     // GIR_Coverage, 2388,
     /* 267443 */     GIR_EraseRootFromParent_Done,
     /* 267444 */   // Label 5188: @267444
     /* 267444 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267484), // Rule ID 2495 //
     /* 267449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267471 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 267474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267482 */     GIR_RootConstrainSelectedInstOperands,
     /* 267483 */     // GIR_Coverage, 2495,
     /* 267483 */     GIR_EraseRootFromParent_Done,
     /* 267484 */   // Label 5189: @267484
     /* 267484 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267524), // Rule ID 2496 //
     /* 267489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267511 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 267514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267522 */     GIR_RootConstrainSelectedInstOperands,
     /* 267523 */     // GIR_Coverage, 2496,
     /* 267523 */     GIR_EraseRootFromParent_Done,
     /* 267524 */   // Label 5190: @267524
     /* 267524 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(267564), // Rule ID 7063 //
     /* 267529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267551 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 267554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267562 */     GIR_RootConstrainSelectedInstOperands,
     /* 267563 */     // GIR_Coverage, 7063,
     /* 267563 */     GIR_EraseRootFromParent_Done,
     /* 267564 */   // Label 5191: @267564
     /* 267564 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(267604), // Rule ID 7064 //
     /* 267569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267591 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 267594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267602 */     GIR_RootConstrainSelectedInstOperands,
     /* 267603 */     // GIR_Coverage, 7064,
     /* 267603 */     GIR_EraseRootFromParent_Done,
     /* 267604 */   // Label 5192: @267604
     /* 267604 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267640), // Rule ID 3604 //
     /* 267609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasNonStreamingSVE2_or_SME2),
     /* 267612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 267617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267627 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 267630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267638 */     GIR_RootConstrainSelectedInstOperands,
     /* 267639 */     // GIR_Coverage, 3604,
     /* 267639 */     GIR_EraseRootFromParent_Done,
     /* 267640 */   // Label 5193: @267640
     /* 267640 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267678), // Rule ID 4034 //
     /* 267645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 267648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 267653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267663 */     // (intrinsic_w_chain:{ *:[i64] } 569:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 267663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 267666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 267674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 267676 */     GIR_RootConstrainSelectedInstOperands,
     /* 267677 */     // GIR_Coverage, 4034,
     /* 267677 */     GIR_EraseRootFromParent_Done,
     /* 267678 */   // Label 5194: @267678
     /* 267678 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(267714), // Rule ID 12754 //
     /* 267683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasNonStreamingSVE2_or_SME2),
     /* 267686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 267691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267701 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 267704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267712 */     GIR_RootConstrainSelectedInstOperands,
     /* 267713 */     // GIR_Coverage, 12754,
     /* 267713 */     GIR_EraseRootFromParent_Done,
     /* 267714 */   // Label 5195: @267714
     /* 267714 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(267750), // Rule ID 12755 //
     /* 267719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasNonStreamingSVE2_or_SME2),
     /* 267722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 267727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267737 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1507:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 267740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267748 */     GIR_RootConstrainSelectedInstOperands,
     /* 267749 */     // GIR_Coverage, 12755,
     /* 267749 */     GIR_EraseRootFromParent_Done,
     /* 267750 */   // Label 5196: @267750
     /* 267750 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(267786), // Rule ID 12756 //
     /* 267755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasNonStreamingSVE2_or_SME2),
     /* 267758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 267763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267773 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1508:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 267776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267784 */     GIR_RootConstrainSelectedInstOperands,
     /* 267785 */     // GIR_Coverage, 12756,
     /* 267785 */     GIR_EraseRootFromParent_Done,
     /* 267786 */   // Label 5197: @267786
     /* 267786 */   GIM_Reject,
     /* 267787 */ // Label 5178: @267787
     /* 267787 */ GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(271955),
     /* 267792 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 267795 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(267892), // Rule ID 7200 //
     /* 267800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267848 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267859 */     // MIs[0] addr
     /* 267859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267873 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267882 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267890 */     GIR_RootConstrainSelectedInstOperands,
     /* 267891 */     // GIR_Coverage, 7200,
     /* 267891 */     GIR_EraseRootFromParent_Done,
     /* 267892 */   // Label 5199: @267892
     /* 267892 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(267989), // Rule ID 7201 //
     /* 267897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267945 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267956 */     // MIs[0] addr
     /* 267956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267970 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 267973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267979 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267987 */     GIR_RootConstrainSelectedInstOperands,
     /* 267988 */     // GIR_Coverage, 7201,
     /* 267988 */     GIR_EraseRootFromParent_Done,
     /* 267989 */   // Label 5200: @267989
     /* 267989 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268086), // Rule ID 7210 //
     /* 267994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 268025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 268037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268042 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 268053 */     // MIs[0] addr
     /* 268053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 268065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268067 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 268070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 268076 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 268084 */     GIR_RootConstrainSelectedInstOperands,
     /* 268085 */     // GIR_Coverage, 7210,
     /* 268085 */     GIR_EraseRootFromParent_Done,
     /* 268086 */   // Label 5201: @268086
     /* 268086 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268183), // Rule ID 7211 //
     /* 268091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 268122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 268134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268139 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 268150 */     // MIs[0] addr
     /* 268150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 268162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 268164 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 268167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 268173 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 268181 */     GIR_RootConstrainSelectedInstOperands,
     /* 268182 */     // GIR_Coverage, 7211,
     /* 268182 */     GIR_EraseRootFromParent_Done,
     /* 268183 */   // Label 5202: @268183
     /* 268183 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268294), // Rule ID 7203 //
     /* 268188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268224 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 268235 */     // MIs[0] addr
     /* 268235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 268247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268249 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 268280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268285 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268292 */     GIR_RootConstrainSelectedInstOperands,
     /* 268293 */     // GIR_Coverage, 7203,
     /* 268293 */     GIR_EraseRootFromParent_Done,
     /* 268294 */   // Label 5203: @268294
     /* 268294 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268405), // Rule ID 7204 //
     /* 268299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268335 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 268346 */     // MIs[0] addr
     /* 268346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 268358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268360 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268372 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 268391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268396 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268403 */     GIR_RootConstrainSelectedInstOperands,
     /* 268404 */     // GIR_Coverage, 7204,
     /* 268404 */     GIR_EraseRootFromParent_Done,
     /* 268405 */   // Label 5204: @268405
     /* 268405 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(268516), // Rule ID 7205 //
     /* 268410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268446 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268457 */     // MIs[0] addr
     /* 268457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268471 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268507 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268514 */     GIR_RootConstrainSelectedInstOperands,
     /* 268515 */     // GIR_Coverage, 7205,
     /* 268515 */     GIR_EraseRootFromParent_Done,
     /* 268516 */   // Label 5205: @268516
     /* 268516 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268627), // Rule ID 7213 //
     /* 268521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268557 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 268568 */     // MIs[0] addr
     /* 268568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 268580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268582 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 268613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268618 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268625 */     GIR_RootConstrainSelectedInstOperands,
     /* 268626 */     // GIR_Coverage, 7213,
     /* 268626 */     GIR_EraseRootFromParent_Done,
     /* 268627 */   // Label 5206: @268627
     /* 268627 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268738), // Rule ID 7214 //
     /* 268632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268668 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 268679 */     // MIs[0] addr
     /* 268679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 268691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268693 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 268724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268729 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268736 */     GIR_RootConstrainSelectedInstOperands,
     /* 268737 */     // GIR_Coverage, 7214,
     /* 268737 */     GIR_EraseRootFromParent_Done,
     /* 268738 */   // Label 5207: @268738
     /* 268738 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268849), // Rule ID 7215 //
     /* 268743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268779 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268790 */     // MIs[0] addr
     /* 268790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268804 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268840 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268847 */     GIR_RootConstrainSelectedInstOperands,
     /* 268848 */     // GIR_Coverage, 7215,
     /* 268848 */     GIR_EraseRootFromParent_Done,
     /* 268849 */   // Label 5208: @268849
     /* 268849 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268900), // Rule ID 70 //
     /* 268854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 268859 */     // MIs[0] ptr
     /* 268859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268867 */     // MIs[0] accessinfo
     /* 268867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268870 */     // MIs[0] fixed_shadow
     /* 268870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268873 */     // (intrinsic_void 194:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 268876 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268878 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268880 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268898 */     GIR_RootConstrainSelectedInstOperands,
     /* 268899 */     // GIR_Coverage, 70,
     /* 268899 */     GIR_EraseRootFromParent_Done,
     /* 268900 */   // Label 5209: @268900
     /* 268900 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268951), // Rule ID 71 //
     /* 268905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 268910 */     // MIs[0] ptr
     /* 268910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268918 */     // MIs[0] accessinfo
     /* 268918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268921 */     // MIs[0] fixed_shadow
     /* 268921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268924 */     // (intrinsic_void 196:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 268927 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268929 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268931 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268949 */     GIR_RootConstrainSelectedInstOperands,
     /* 268950 */     // GIR_Coverage, 71,
     /* 268950 */     GIR_EraseRootFromParent_Done,
     /* 268951 */   // Label 5210: @268951
     /* 268951 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(269020), // Rule ID 7202 //
     /* 268956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268988 */     // MIs[0] addr
     /* 268988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 269000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269002 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 269005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 269011 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 269018 */     GIR_RootConstrainSelectedInstOperands,
     /* 269019 */     // GIR_Coverage, 7202,
     /* 269019 */     GIR_EraseRootFromParent_Done,
     /* 269020 */   // Label 5211: @269020
     /* 269020 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(269089), // Rule ID 7212 //
     /* 269025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269057 */     // MIs[0] addr
     /* 269057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 269069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269071 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 269074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 269080 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 269087 */     GIR_RootConstrainSelectedInstOperands,
     /* 269088 */     // GIR_Coverage, 7212,
     /* 269088 */     GIR_EraseRootFromParent_Done,
     /* 269089 */   // Label 5212: @269089
     /* 269089 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(269131), // Rule ID 3628 //
     /* 269094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 269102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269108 */     // MIs[0] tile
     /* 269108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269116 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 269119 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269129 */     GIR_RootConstrainSelectedInstOperands,
     /* 269130 */     // GIR_Coverage, 3628,
     /* 269130 */     GIR_EraseRootFromParent_Done,
     /* 269131 */   // Label 5213: @269131
     /* 269131 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(269173), // Rule ID 3632 //
     /* 269136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 269144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269150 */     // MIs[0] tile
     /* 269150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269158 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 269161 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269171 */     GIR_RootConstrainSelectedInstOperands,
     /* 269172 */     // GIR_Coverage, 3632,
     /* 269172 */     GIR_EraseRootFromParent_Done,
     /* 269173 */   // Label 5214: @269173
     /* 269173 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269215), // Rule ID 3636 //
     /* 269178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 269186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269192 */     // MIs[0] tile
     /* 269192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269200 */     // (intrinsic_void 1029:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 269203 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269213 */     GIR_RootConstrainSelectedInstOperands,
     /* 269214 */     // GIR_Coverage, 3636,
     /* 269214 */     GIR_EraseRootFromParent_Done,
     /* 269215 */   // Label 5215: @269215
     /* 269215 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269257), // Rule ID 3806 //
     /* 269220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 269223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 269228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269234 */     // MIs[0] tile
     /* 269234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269242 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 269245 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269255 */     GIR_RootConstrainSelectedInstOperands,
     /* 269256 */     // GIR_Coverage, 3806,
     /* 269256 */     GIR_EraseRootFromParent_Done,
     /* 269257 */   // Label 5216: @269257
     /* 269257 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269299), // Rule ID 3810 //
     /* 269262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 269265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 269270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269276 */     // MIs[0] tile
     /* 269276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269284 */     // (intrinsic_void 885:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 269287 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269297 */     GIR_RootConstrainSelectedInstOperands,
     /* 269298 */     // GIR_Coverage, 3810,
     /* 269298 */     GIR_EraseRootFromParent_Done,
     /* 269299 */   // Label 5217: @269299
     /* 269299 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269341), // Rule ID 3814 //
     /* 269304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 269312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269318 */     // MIs[0] tile
     /* 269318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269326 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 269326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 269329 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269339 */     GIR_RootConstrainSelectedInstOperands,
     /* 269340 */     // GIR_Coverage, 3814,
     /* 269340 */     GIR_EraseRootFromParent_Done,
     /* 269341 */   // Label 5218: @269341
     /* 269341 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269383), // Rule ID 3818 //
     /* 269346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 269349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 269354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269360 */     // MIs[0] tile
     /* 269360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269368 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 269368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 269371 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269381 */     GIR_RootConstrainSelectedInstOperands,
     /* 269382 */     // GIR_Coverage, 3818,
     /* 269382 */     GIR_EraseRootFromParent_Done,
     /* 269383 */   // Label 5219: @269383
     /* 269383 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269425), // Rule ID 3822 //
     /* 269388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 269396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269402 */     // MIs[0] tile
     /* 269402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269410 */     // (intrinsic_void 926:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 269413 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269423 */     GIR_RootConstrainSelectedInstOperands,
     /* 269424 */     // GIR_Coverage, 3822,
     /* 269424 */     GIR_EraseRootFromParent_Done,
     /* 269425 */   // Label 5220: @269425
     /* 269425 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269467), // Rule ID 3826 //
     /* 269430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 269433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 269438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269444 */     // MIs[0] tile
     /* 269444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269452 */     // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 269455 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269465 */     GIR_RootConstrainSelectedInstOperands,
     /* 269466 */     // GIR_Coverage, 3826,
     /* 269466 */     GIR_EraseRootFromParent_Done,
     /* 269467 */   // Label 5221: @269467
     /* 269467 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269509), // Rule ID 12833 //
     /* 269472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269486 */     // MIs[0] tile
     /* 269486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269494 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 269497 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269507 */     GIR_RootConstrainSelectedInstOperands,
     /* 269508 */     // GIR_Coverage, 12833,
     /* 269508 */     GIR_EraseRootFromParent_Done,
     /* 269509 */   // Label 5222: @269509
     /* 269509 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269551), // Rule ID 12837 //
     /* 269514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 269522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269528 */     // MIs[0] tile
     /* 269528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269536 */     // (intrinsic_void 1077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 269539 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269549 */     GIR_RootConstrainSelectedInstOperands,
     /* 269550 */     // GIR_Coverage, 12837,
     /* 269550 */     GIR_EraseRootFromParent_Done,
     /* 269551 */   // Label 5223: @269551
     /* 269551 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269593), // Rule ID 12841 //
     /* 269556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 269564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269570 */     // MIs[0] tile
     /* 269570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269578 */     // (intrinsic_void 1085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 269581 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269591 */     GIR_RootConstrainSelectedInstOperands,
     /* 269592 */     // GIR_Coverage, 12841,
     /* 269592 */     GIR_EraseRootFromParent_Done,
     /* 269593 */   // Label 5224: @269593
     /* 269593 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(269635), // Rule ID 12845 //
     /* 269598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 269606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269612 */     // MIs[0] tile
     /* 269612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269620 */     // (intrinsic_void 1194:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 269623 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269633 */     GIR_RootConstrainSelectedInstOperands,
     /* 269634 */     // GIR_Coverage, 12845,
     /* 269634 */     GIR_EraseRootFromParent_Done,
     /* 269635 */   // Label 5225: @269635
     /* 269635 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269677), // Rule ID 12849 //
     /* 269640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 269648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269654 */     // MIs[0] tile
     /* 269654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269662 */     // (intrinsic_void 1202:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 269665 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269675 */     GIR_RootConstrainSelectedInstOperands,
     /* 269676 */     // GIR_Coverage, 12849,
     /* 269676 */     GIR_EraseRootFromParent_Done,
     /* 269677 */   // Label 5226: @269677
     /* 269677 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269719), // Rule ID 12853 //
     /* 269682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269696 */     // MIs[0] tile
     /* 269696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269704 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 269707 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269717 */     GIR_RootConstrainSelectedInstOperands,
     /* 269718 */     // GIR_Coverage, 12853,
     /* 269718 */     GIR_EraseRootFromParent_Done,
     /* 269719 */   // Label 5227: @269719
     /* 269719 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269761), // Rule ID 12857 //
     /* 269724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269738 */     // MIs[0] tile
     /* 269738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269746 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 269749 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269759 */     GIR_RootConstrainSelectedInstOperands,
     /* 269760 */     // GIR_Coverage, 12857,
     /* 269760 */     GIR_EraseRootFromParent_Done,
     /* 269761 */   // Label 5228: @269761
     /* 269761 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269803), // Rule ID 12861 //
     /* 269766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269780 */     // MIs[0] tile
     /* 269780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269788 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 269791 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269801 */     GIR_RootConstrainSelectedInstOperands,
     /* 269802 */     // GIR_Coverage, 12861,
     /* 269802 */     GIR_EraseRootFromParent_Done,
     /* 269803 */   // Label 5229: @269803
     /* 269803 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269845), // Rule ID 12865 //
     /* 269808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269822 */     // MIs[0] tile
     /* 269822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269830 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 269833 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269843 */     GIR_RootConstrainSelectedInstOperands,
     /* 269844 */     // GIR_Coverage, 12865,
     /* 269844 */     GIR_EraseRootFromParent_Done,
     /* 269845 */   // Label 5230: @269845
     /* 269845 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269887), // Rule ID 12869 //
     /* 269850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269864 */     // MIs[0] tile
     /* 269864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269872 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 269875 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269885 */     GIR_RootConstrainSelectedInstOperands,
     /* 269886 */     // GIR_Coverage, 12869,
     /* 269886 */     GIR_EraseRootFromParent_Done,
     /* 269887 */   // Label 5231: @269887
     /* 269887 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269929), // Rule ID 12873 //
     /* 269892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 269900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269906 */     // MIs[0] tile
     /* 269906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269914 */     // (intrinsic_void 1037:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 269917 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269927 */     GIR_RootConstrainSelectedInstOperands,
     /* 269928 */     // GIR_Coverage, 12873,
     /* 269928 */     GIR_EraseRootFromParent_Done,
     /* 269929 */   // Label 5232: @269929
     /* 269929 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269971), // Rule ID 12877 //
     /* 269934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 269942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269948 */     // MIs[0] tile
     /* 269948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269956 */     // (intrinsic_void 1081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 269959 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269969 */     GIR_RootConstrainSelectedInstOperands,
     /* 269970 */     // GIR_Coverage, 12877,
     /* 269970 */     GIR_EraseRootFromParent_Done,
     /* 269971 */   // Label 5233: @269971
     /* 269971 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(270013), // Rule ID 12881 //
     /* 269976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 269984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269990 */     // MIs[0] tile
     /* 269990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269998 */     // (intrinsic_void 1089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 270001 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270011 */     GIR_RootConstrainSelectedInstOperands,
     /* 270012 */     // GIR_Coverage, 12881,
     /* 270012 */     GIR_EraseRootFromParent_Done,
     /* 270013 */   // Label 5234: @270013
     /* 270013 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(270055), // Rule ID 12885 //
     /* 270018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 270021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 270026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270032 */     // MIs[0] tile
     /* 270032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270040 */     // (intrinsic_void 1164:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 270043 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270053 */     GIR_RootConstrainSelectedInstOperands,
     /* 270054 */     // GIR_Coverage, 12885,
     /* 270054 */     GIR_EraseRootFromParent_Done,
     /* 270055 */   // Label 5235: @270055
     /* 270055 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(270097), // Rule ID 12889 //
     /* 270060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 270063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 270068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270074 */     // MIs[0] tile
     /* 270074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270082 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 270085 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270095 */     GIR_RootConstrainSelectedInstOperands,
     /* 270096 */     // GIR_Coverage, 12889,
     /* 270096 */     GIR_EraseRootFromParent_Done,
     /* 270097 */   // Label 5236: @270097
     /* 270097 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270139), // Rule ID 12893 //
     /* 270102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 270105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 270110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270116 */     // MIs[0] tile
     /* 270116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270124 */     // (intrinsic_void 1198:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 270127 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270137 */     GIR_RootConstrainSelectedInstOperands,
     /* 270138 */     // GIR_Coverage, 12893,
     /* 270138 */     GIR_EraseRootFromParent_Done,
     /* 270139 */   // Label 5237: @270139
     /* 270139 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270181), // Rule ID 12897 //
     /* 270144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 270147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 270152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270158 */     // MIs[0] tile
     /* 270158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270166 */     // (intrinsic_void 1206:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 270166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 270169 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270179 */     GIR_RootConstrainSelectedInstOperands,
     /* 270180 */     // GIR_Coverage, 12897,
     /* 270180 */     GIR_EraseRootFromParent_Done,
     /* 270181 */   // Label 5238: @270181
     /* 270181 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270223), // Rule ID 13352 //
     /* 270186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 270189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 270194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270200 */     // MIs[0] tile
     /* 270200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270208 */     // (intrinsic_void 934:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 270208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 270211 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270221 */     GIR_RootConstrainSelectedInstOperands,
     /* 270222 */     // GIR_Coverage, 13352,
     /* 270222 */     GIR_EraseRootFromParent_Done,
     /* 270223 */   // Label 5239: @270223
     /* 270223 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270265), // Rule ID 13356 //
     /* 270228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 270231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 270236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 270239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270242 */     // MIs[0] tile
     /* 270242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270250 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 270250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 270253 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270263 */     GIR_RootConstrainSelectedInstOperands,
     /* 270264 */     // GIR_Coverage, 13356,
     /* 270264 */     GIR_EraseRootFromParent_Done,
     /* 270265 */   // Label 5240: @270265
     /* 270265 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270307), // Rule ID 13360 //
     /* 270270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 270273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 270278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 270284 */     // MIs[0] tile
     /* 270284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 270292 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 270292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 270295 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270305 */     GIR_RootConstrainSelectedInstOperands,
     /* 270306 */     // GIR_Coverage, 13360,
     /* 270306 */     GIR_EraseRootFromParent_Done,
     /* 270307 */   // Label 5241: @270307
     /* 270307 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270349), // Rule ID 13364 //
     /* 270312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 270315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 270320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 270323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270326 */     // MIs[0] tile
     /* 270326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270334 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 270334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 270337 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270347 */     GIR_RootConstrainSelectedInstOperands,
     /* 270348 */     // GIR_Coverage, 13364,
     /* 270348 */     GIR_EraseRootFromParent_Done,
     /* 270349 */   // Label 5242: @270349
     /* 270349 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270403), // Rule ID 8974 //
     /* 270354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270362 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 270365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270369 */     // MIs[0] base
     /* 270369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270377 */     // MIs[0] prfop
     /* 270377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270385 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 270388 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270392 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270401 */     GIR_RootConstrainSelectedInstOperands,
     /* 270402 */     // GIR_Coverage, 8974,
     /* 270402 */     GIR_EraseRootFromParent_Done,
     /* 270403 */   // Label 5243: @270403
     /* 270403 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270457), // Rule ID 8977 //
     /* 270408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270416 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 270419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270423 */     // MIs[0] base
     /* 270423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270431 */     // MIs[0] prfop
     /* 270431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270439 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 270442 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270444 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270446 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270455 */     GIR_RootConstrainSelectedInstOperands,
     /* 270456 */     // GIR_Coverage, 8977,
     /* 270456 */     GIR_EraseRootFromParent_Done,
     /* 270457 */   // Label 5244: @270457
     /* 270457 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(270511), // Rule ID 8980 //
     /* 270462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270470 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270477 */     // MIs[0] base
     /* 270477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270485 */     // MIs[0] prfop
     /* 270485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270493 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 270496 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270498 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270500 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270509 */     GIR_RootConstrainSelectedInstOperands,
     /* 270510 */     // GIR_Coverage, 8980,
     /* 270510 */     GIR_EraseRootFromParent_Done,
     /* 270511 */   // Label 5245: @270511
     /* 270511 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270565), // Rule ID 8983 //
     /* 270516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270524 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270531 */     // MIs[0] base
     /* 270531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270539 */     // MIs[0] prfop
     /* 270539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270547 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 270550 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270552 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270554 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270563 */     GIR_RootConstrainSelectedInstOperands,
     /* 270564 */     // GIR_Coverage, 8983,
     /* 270564 */     GIR_EraseRootFromParent_Done,
     /* 270565 */   // Label 5246: @270565
     /* 270565 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270619), // Rule ID 15 //
     /* 270570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 270575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 270578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270596 */     // MIs[1] Operand 1
     /* 270596 */     // No operand predicates
     /* 270596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270602 */     // (intrinsic_w_chain:{ *:[i64] } 1242:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 270602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 270605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 270610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270617 */     GIR_RootConstrainSelectedInstOperands,
     /* 270618 */     // GIR_Coverage, 15,
     /* 270618 */     GIR_EraseRootFromParent_Done,
     /* 270619 */   // Label 5247: @270619
     /* 270619 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270687), // Rule ID 68 //
     /* 270624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 270629 */     // MIs[0] Operand 1
     /* 270629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 270637 */     // MIs[0] ptr
     /* 270637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270645 */     // MIs[0] accessinfo
     /* 270645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270648 */     // (intrinsic_void 193:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270652 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 270662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 270665 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270667 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270685 */     GIR_RootConstrainSelectedInstOperands,
     /* 270686 */     // GIR_Coverage, 68,
     /* 270686 */     GIR_EraseRootFromParent_Done,
     /* 270687 */   // Label 5248: @270687
     /* 270687 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(270755), // Rule ID 69 //
     /* 270692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 270697 */     // MIs[0] Operand 1
     /* 270697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 270705 */     // MIs[0] ptr
     /* 270705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270713 */     // MIs[0] accessinfo
     /* 270713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270716 */     // (intrinsic_void 195:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270720 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 270730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 270733 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270735 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270753 */     GIR_RootConstrainSelectedInstOperands,
     /* 270754 */     // GIR_Coverage, 69,
     /* 270754 */     GIR_EraseRootFromParent_Done,
     /* 270755 */   // Label 5249: @270755
     /* 270755 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270835), // Rule ID 7196 //
     /* 270760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270779 */     // MIs[0] addr
     /* 270779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 270791 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270803 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 270822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270827 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270833 */     GIR_RootConstrainSelectedInstOperands,
     /* 270834 */     // GIR_Coverage, 7196,
     /* 270834 */     GIR_EraseRootFromParent_Done,
     /* 270835 */   // Label 5250: @270835
     /* 270835 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(270915), // Rule ID 7197 //
     /* 270840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270859 */     // MIs[0] addr
     /* 270859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270871 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270907 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270913 */     GIR_RootConstrainSelectedInstOperands,
     /* 270914 */     // GIR_Coverage, 7197,
     /* 270914 */     GIR_EraseRootFromParent_Done,
     /* 270915 */   // Label 5251: @270915
     /* 270915 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(270995), // Rule ID 7198 //
     /* 270920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270939 */     // MIs[0] addr
     /* 270939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270951 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270963 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270987 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270993 */     GIR_RootConstrainSelectedInstOperands,
     /* 270994 */     // GIR_Coverage, 7198,
     /* 270994 */     GIR_EraseRootFromParent_Done,
     /* 270995 */   // Label 5252: @270995
     /* 270995 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271046), // Rule ID 7199 //
     /* 271000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 271005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 271008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271019 */     // MIs[0] addr
     /* 271019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 271031 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 271031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 271034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 271036 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 271038 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 271040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271044 */     GIR_RootConstrainSelectedInstOperands,
     /* 271045 */     // GIR_Coverage, 7199,
     /* 271045 */     GIR_EraseRootFromParent_Done,
     /* 271046 */   // Label 5253: @271046
     /* 271046 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271126), // Rule ID 7206 //
     /* 271051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 271056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 271059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271070 */     // MIs[0] addr
     /* 271070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 271082 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 271082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 271100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 271113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 271115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271118 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 271120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271124 */     GIR_RootConstrainSelectedInstOperands,
     /* 271125 */     // GIR_Coverage, 7206,
     /* 271125 */     GIR_EraseRootFromParent_Done,
     /* 271126 */   // Label 5254: @271126
     /* 271126 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271206), // Rule ID 7207 //
     /* 271131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 271136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 271139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271150 */     // MIs[0] addr
     /* 271150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 271162 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 271162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 271180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 271193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 271195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271198 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 271200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271204 */     GIR_RootConstrainSelectedInstOperands,
     /* 271205 */     // GIR_Coverage, 7207,
     /* 271205 */     GIR_EraseRootFromParent_Done,
     /* 271206 */   // Label 5255: @271206
     /* 271206 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271286), // Rule ID 7208 //
     /* 271211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 271216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 271219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271230 */     // MIs[0] addr
     /* 271230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 271242 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 271242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 271260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 271273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 271275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271278 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 271280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271284 */     GIR_RootConstrainSelectedInstOperands,
     /* 271285 */     // GIR_Coverage, 7208,
     /* 271285 */     GIR_EraseRootFromParent_Done,
     /* 271286 */   // Label 5256: @271286
     /* 271286 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271337), // Rule ID 7209 //
     /* 271291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 271296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 271299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271310 */     // MIs[0] addr
     /* 271310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 271322 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 271322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 271325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 271327 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 271329 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 271331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271335 */     GIR_RootConstrainSelectedInstOperands,
     /* 271336 */     // GIR_Coverage, 7209,
     /* 271336 */     GIR_EraseRootFromParent_Done,
     /* 271337 */   // Label 5257: @271337
     /* 271337 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271386), // Rule ID 2488 //
     /* 271342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 271353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 271359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271371 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 271371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 271374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271384 */     GIR_RootConstrainSelectedInstOperands,
     /* 271385 */     // GIR_Coverage, 2488,
     /* 271385 */     GIR_EraseRootFromParent_Done,
     /* 271386 */   // Label 5258: @271386
     /* 271386 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271435), // Rule ID 2489 //
     /* 271391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 271402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 271408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271420 */     // (intrinsic_w_chain:{ *:[v16i8] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 271420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 271423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271433 */     GIR_RootConstrainSelectedInstOperands,
     /* 271434 */     // GIR_Coverage, 2489,
     /* 271434 */     GIR_EraseRootFromParent_Done,
     /* 271435 */   // Label 5259: @271435
     /* 271435 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(271484), // Rule ID 2490 //
     /* 271440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 271451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271469 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 271469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 271472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271482 */     GIR_RootConstrainSelectedInstOperands,
     /* 271483 */     // GIR_Coverage, 2490,
     /* 271483 */     GIR_EraseRootFromParent_Done,
     /* 271484 */   // Label 5260: @271484
     /* 271484 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271537), // Rule ID 8860 //
     /* 271489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271511 */     // MIs[0] base
     /* 271511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271519 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271526 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271535 */     GIR_RootConstrainSelectedInstOperands,
     /* 271536 */     // GIR_Coverage, 8860,
     /* 271536 */     GIR_EraseRootFromParent_Done,
     /* 271537 */   // Label 5261: @271537
     /* 271537 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271590), // Rule ID 8863 //
     /* 271542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271564 */     // MIs[0] base
     /* 271564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271572 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271579 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271588 */     GIR_RootConstrainSelectedInstOperands,
     /* 271589 */     // GIR_Coverage, 8863,
     /* 271589 */     GIR_EraseRootFromParent_Done,
     /* 271590 */   // Label 5262: @271590
     /* 271590 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271643), // Rule ID 8872 //
     /* 271595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271617 */     // MIs[0] base
     /* 271617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271625 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271632 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271641 */     GIR_RootConstrainSelectedInstOperands,
     /* 271642 */     // GIR_Coverage, 8872,
     /* 271642 */     GIR_EraseRootFromParent_Done,
     /* 271643 */   // Label 5263: @271643
     /* 271643 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271696), // Rule ID 8875 //
     /* 271648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271670 */     // MIs[0] base
     /* 271670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271678 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271685 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271694 */     GIR_RootConstrainSelectedInstOperands,
     /* 271695 */     // GIR_Coverage, 8875,
     /* 271695 */     GIR_EraseRootFromParent_Done,
     /* 271696 */   // Label 5264: @271696
     /* 271696 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271742), // Rule ID 137 //
     /* 271701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 271704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 271709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 271712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271719 */     // MIs[0] Rn
     /* 271719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271731 */     // (intrinsic_w_chain:{ *:[i64] } 568:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 271734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271740 */     GIR_RootConstrainSelectedInstOperands,
     /* 271741 */     // GIR_Coverage, 137,
     /* 271741 */     GIR_EraseRootFromParent_Done,
     /* 271742 */   // Label 5265: @271742
     /* 271742 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271795), // Rule ID 8866 //
     /* 271747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271755 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271769 */     // MIs[0] base
     /* 271769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271777 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271784 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271793 */     GIR_RootConstrainSelectedInstOperands,
     /* 271794 */     // GIR_Coverage, 8866,
     /* 271794 */     GIR_EraseRootFromParent_Done,
     /* 271795 */   // Label 5266: @271795
     /* 271795 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271848), // Rule ID 8869 //
     /* 271800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271808 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271822 */     // MIs[0] base
     /* 271822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271830 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271837 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271846 */     GIR_RootConstrainSelectedInstOperands,
     /* 271847 */     // GIR_Coverage, 8869,
     /* 271847 */     GIR_EraseRootFromParent_Done,
     /* 271848 */   // Label 5267: @271848
     /* 271848 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271901), // Rule ID 8878 //
     /* 271853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271861 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271875 */     // MIs[0] base
     /* 271875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271883 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271890 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271899 */     GIR_RootConstrainSelectedInstOperands,
     /* 271900 */     // GIR_Coverage, 8878,
     /* 271900 */     GIR_EraseRootFromParent_Done,
     /* 271901 */   // Label 5268: @271901
     /* 271901 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(271954), // Rule ID 8881 //
     /* 271906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271914 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271928 */     // MIs[0] base
     /* 271928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271936 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271943 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271952 */     GIR_RootConstrainSelectedInstOperands,
     /* 271953 */     // GIR_Coverage, 8881,
     /* 271953 */     GIR_EraseRootFromParent_Done,
     /* 271954 */   // Label 5269: @271954
     /* 271954 */   GIM_Reject,
     /* 271955 */ // Label 5198: @271955
     /* 271955 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(274660),
     /* 271960 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 271963 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272034), // Rule ID 3435 //
     /* 271968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271976 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272005 */     // MIs[1] Operand 1
     /* 272005 */     // No operand predicates
     /* 272005 */     // MIs[0] prfop
     /* 272005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272015 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 272015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 272018 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 272032 */     GIR_RootConstrainSelectedInstOperands,
     /* 272033 */     // GIR_Coverage, 3435,
     /* 272033 */     GIR_EraseRootFromParent_Done,
     /* 272034 */   // Label 5271: @272034
     /* 272034 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272105), // Rule ID 3448 //
     /* 272039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 272047 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272076 */     // MIs[1] Operand 1
     /* 272076 */     // No operand predicates
     /* 272076 */     // MIs[0] prfop
     /* 272076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272086 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 272086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 272089 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 272103 */     GIR_RootConstrainSelectedInstOperands,
     /* 272104 */     // GIR_Coverage, 3448,
     /* 272104 */     GIR_EraseRootFromParent_Done,
     /* 272105 */   // Label 5272: @272105
     /* 272105 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272164), // Rule ID 3640 //
     /* 272110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 272113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 272118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 272121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 272124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 272127 */     // MIs[0] tile
     /* 272127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 272135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272147 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 272147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 272150 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272152 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 272154 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 272156 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 272158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272162 */     GIR_RootConstrainSelectedInstOperands,
     /* 272163 */     // GIR_Coverage, 3640,
     /* 272163 */     GIR_EraseRootFromParent_Done,
     /* 272164 */   // Label 5273: @272164
     /* 272164 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272223), // Rule ID 3641 //
     /* 272169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 272172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 272177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 272180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 272183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 272186 */     // MIs[0] tile
     /* 272186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272206 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 272206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 272209 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272211 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 272213 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 272215 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 272217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272221 */     GIR_RootConstrainSelectedInstOperands,
     /* 272222 */     // GIR_Coverage, 3641,
     /* 272222 */     GIR_EraseRootFromParent_Done,
     /* 272223 */   // Label 5274: @272223
     /* 272223 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272282), // Rule ID 12814 //
     /* 272228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 272231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 272236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 272239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 272242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 272245 */     // MIs[0] tile
     /* 272245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 272253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272265 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 272265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 272268 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272270 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 272272 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 272274 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 272276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272280 */     GIR_RootConstrainSelectedInstOperands,
     /* 272281 */     // GIR_Coverage, 12814,
     /* 272281 */     GIR_EraseRootFromParent_Done,
     /* 272282 */   // Label 5275: @272282
     /* 272282 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272341), // Rule ID 12815 //
     /* 272287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 272290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 272295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 272298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 272301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 272304 */     // MIs[0] tile
     /* 272304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272324 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 272324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 272327 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272329 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 272331 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 272333 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 272335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272339 */     GIR_RootConstrainSelectedInstOperands,
     /* 272340 */     // GIR_Coverage, 12815,
     /* 272340 */     GIR_EraseRootFromParent_Done,
     /* 272341 */   // Label 5276: @272341
     /* 272341 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272401), // Rule ID 3433 //
     /* 272346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 272354 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272364 */     // MIs[0] Rn
     /* 272364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272376 */     // MIs[0] prfop
     /* 272376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272384 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 272387 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272399 */     GIR_RootConstrainSelectedInstOperands,
     /* 272400 */     // GIR_Coverage, 3433,
     /* 272400 */     GIR_EraseRootFromParent_Done,
     /* 272401 */   // Label 5277: @272401
     /* 272401 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272461), // Rule ID 3434 //
     /* 272406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272414 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272424 */     // MIs[0] Rn
     /* 272424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272436 */     // MIs[0] prfop
     /* 272436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272444 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 272447 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272459 */     GIR_RootConstrainSelectedInstOperands,
     /* 272460 */     // GIR_Coverage, 3434,
     /* 272460 */     GIR_EraseRootFromParent_Done,
     /* 272461 */   // Label 5278: @272461
     /* 272461 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272521), // Rule ID 3445 //
     /* 272466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 272474 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272484 */     // MIs[0] Rn
     /* 272484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272496 */     // MIs[0] prfop
     /* 272496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272504 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 272507 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272519 */     GIR_RootConstrainSelectedInstOperands,
     /* 272520 */     // GIR_Coverage, 3445,
     /* 272520 */     GIR_EraseRootFromParent_Done,
     /* 272521 */   // Label 5279: @272521
     /* 272521 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272581), // Rule ID 3446 //
     /* 272526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272534 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272544 */     // MIs[0] Rn
     /* 272544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272556 */     // MIs[0] prfop
     /* 272556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272564 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 272567 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272579 */     GIR_RootConstrainSelectedInstOperands,
     /* 272580 */     // GIR_Coverage, 3446,
     /* 272580 */     GIR_EraseRootFromParent_Done,
     /* 272581 */   // Label 5280: @272581
     /* 272581 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272641), // Rule ID 3447 //
     /* 272586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 272594 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272604 */     // MIs[0] Rn
     /* 272604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272616 */     // MIs[0] prfop
     /* 272616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272624 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 272624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 272627 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272639 */     GIR_RootConstrainSelectedInstOperands,
     /* 272640 */     // GIR_Coverage, 3447,
     /* 272640 */     GIR_EraseRootFromParent_Done,
     /* 272641 */   // Label 5281: @272641
     /* 272641 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272701), // Rule ID 8986 //
     /* 272646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272654 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272664 */     // MIs[0] Rn
     /* 272664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272676 */     // MIs[0] prfop
     /* 272676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272684 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 272687 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272699 */     GIR_RootConstrainSelectedInstOperands,
     /* 272700 */     // GIR_Coverage, 8986,
     /* 272700 */     GIR_EraseRootFromParent_Done,
     /* 272701 */   // Label 5282: @272701
     /* 272701 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272761), // Rule ID 8987 //
     /* 272706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272714 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272724 */     // MIs[0] Rn
     /* 272724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272736 */     // MIs[0] prfop
     /* 272736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272744 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 272747 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272759 */     GIR_RootConstrainSelectedInstOperands,
     /* 272760 */     // GIR_Coverage, 8987,
     /* 272760 */     GIR_EraseRootFromParent_Done,
     /* 272761 */   // Label 5283: @272761
     /* 272761 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272821), // Rule ID 8988 //
     /* 272766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272774 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272784 */     // MIs[0] Rn
     /* 272784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272796 */     // MIs[0] prfop
     /* 272796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272804 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 272807 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272819 */     GIR_RootConstrainSelectedInstOperands,
     /* 272820 */     // GIR_Coverage, 8988,
     /* 272820 */     GIR_EraseRootFromParent_Done,
     /* 272821 */   // Label 5284: @272821
     /* 272821 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272881), // Rule ID 8989 //
     /* 272826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272834 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272844 */     // MIs[0] Rn
     /* 272844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272856 */     // MIs[0] prfop
     /* 272856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272864 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 272867 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272879 */     GIR_RootConstrainSelectedInstOperands,
     /* 272880 */     // GIR_Coverage, 8989,
     /* 272880 */     GIR_EraseRootFromParent_Done,
     /* 272881 */   // Label 5285: @272881
     /* 272881 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272941), // Rule ID 8990 //
     /* 272886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272894 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272904 */     // MIs[0] Rn
     /* 272904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272916 */     // MIs[0] prfop
     /* 272916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272924 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 272927 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272939 */     GIR_RootConstrainSelectedInstOperands,
     /* 272940 */     // GIR_Coverage, 8990,
     /* 272940 */     GIR_EraseRootFromParent_Done,
     /* 272941 */   // Label 5286: @272941
     /* 272941 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(273001), // Rule ID 8991 //
     /* 272946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272954 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272964 */     // MIs[0] Rn
     /* 272964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272976 */     // MIs[0] prfop
     /* 272976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272984 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 272987 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272999 */     GIR_RootConstrainSelectedInstOperands,
     /* 273000 */     // GIR_Coverage, 8991,
     /* 273000 */     GIR_EraseRootFromParent_Done,
     /* 273001 */   // Label 5287: @273001
     /* 273001 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273061), // Rule ID 8992 //
     /* 273006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 273014 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273024 */     // MIs[0] Rn
     /* 273024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273036 */     // MIs[0] prfop
     /* 273036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273044 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 273044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 273047 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273059 */     GIR_RootConstrainSelectedInstOperands,
     /* 273060 */     // GIR_Coverage, 8992,
     /* 273060 */     GIR_EraseRootFromParent_Done,
     /* 273061 */   // Label 5288: @273061
     /* 273061 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273121), // Rule ID 8993 //
     /* 273066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 273074 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273084 */     // MIs[0] Rn
     /* 273084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273096 */     // MIs[0] prfop
     /* 273096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273104 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 273104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 273107 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273119 */     GIR_RootConstrainSelectedInstOperands,
     /* 273120 */     // GIR_Coverage, 8993,
     /* 273120 */     GIR_EraseRootFromParent_Done,
     /* 273121 */   // Label 5289: @273121
     /* 273121 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273181), // Rule ID 8994 //
     /* 273126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 273134 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273144 */     // MIs[0] Rn
     /* 273144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273156 */     // MIs[0] prfop
     /* 273156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273164 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 273164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 273167 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273179 */     GIR_RootConstrainSelectedInstOperands,
     /* 273180 */     // GIR_Coverage, 8994,
     /* 273180 */     GIR_EraseRootFromParent_Done,
     /* 273181 */   // Label 5290: @273181
     /* 273181 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273241), // Rule ID 8995 //
     /* 273186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 273194 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273204 */     // MIs[0] Rn
     /* 273204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273216 */     // MIs[0] prfop
     /* 273216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273224 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 273224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 273227 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273239 */     GIR_RootConstrainSelectedInstOperands,
     /* 273240 */     // GIR_Coverage, 8995,
     /* 273240 */     GIR_EraseRootFromParent_Done,
     /* 273241 */   // Label 5291: @273241
     /* 273241 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273301), // Rule ID 8996 //
     /* 273246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 273254 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273264 */     // MIs[0] Rn
     /* 273264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273276 */     // MIs[0] prfop
     /* 273276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273284 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 273284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 273287 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273299 */     GIR_RootConstrainSelectedInstOperands,
     /* 273300 */     // GIR_Coverage, 8996,
     /* 273300 */     GIR_EraseRootFromParent_Done,
     /* 273301 */   // Label 5292: @273301
     /* 273301 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273361), // Rule ID 8997 //
     /* 273306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 273314 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273324 */     // MIs[0] Rn
     /* 273324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273336 */     // MIs[0] prfop
     /* 273336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273344 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 273344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 273347 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273359 */     GIR_RootConstrainSelectedInstOperands,
     /* 273360 */     // GIR_Coverage, 8997,
     /* 273360 */     GIR_EraseRootFromParent_Done,
     /* 273361 */   // Label 5293: @273361
     /* 273361 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273421), // Rule ID 8998 //
     /* 273366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 273374 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273384 */     // MIs[0] Rn
     /* 273384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273396 */     // MIs[0] prfop
     /* 273396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273404 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 273404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 273407 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273419 */     GIR_RootConstrainSelectedInstOperands,
     /* 273420 */     // GIR_Coverage, 8998,
     /* 273420 */     GIR_EraseRootFromParent_Done,
     /* 273421 */   // Label 5294: @273421
     /* 273421 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273481), // Rule ID 8999 //
     /* 273426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 273434 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273444 */     // MIs[0] Rn
     /* 273444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273456 */     // MIs[0] prfop
     /* 273456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273464 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 273464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 273467 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273479 */     GIR_RootConstrainSelectedInstOperands,
     /* 273480 */     // GIR_Coverage, 8999,
     /* 273480 */     GIR_EraseRootFromParent_Done,
     /* 273481 */   // Label 5295: @273481
     /* 273481 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273541), // Rule ID 9000 //
     /* 273486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 273494 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273504 */     // MIs[0] Rn
     /* 273504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273516 */     // MIs[0] prfop
     /* 273516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273524 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 273524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 273527 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273539 */     GIR_RootConstrainSelectedInstOperands,
     /* 273540 */     // GIR_Coverage, 9000,
     /* 273540 */     GIR_EraseRootFromParent_Done,
     /* 273541 */   // Label 5296: @273541
     /* 273541 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(273599), // Rule ID 2378 //
     /* 273546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 273554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273582 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 273585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273597 */     GIR_RootConstrainSelectedInstOperands,
     /* 273598 */     // GIR_Coverage, 2378,
     /* 273598 */     GIR_EraseRootFromParent_Done,
     /* 273599 */   // Label 5297: @273599
     /* 273599 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273657), // Rule ID 2379 //
     /* 273604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 273612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273640 */     // (intrinsic_w_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 273643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273655 */     GIR_RootConstrainSelectedInstOperands,
     /* 273656 */     // GIR_Coverage, 2379,
     /* 273656 */     GIR_EraseRootFromParent_Done,
     /* 273657 */   // Label 5298: @273657
     /* 273657 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273715), // Rule ID 2380 //
     /* 273662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 273670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273698 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 273701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273713 */     GIR_RootConstrainSelectedInstOperands,
     /* 273714 */     // GIR_Coverage, 2380,
     /* 273714 */     GIR_EraseRootFromParent_Done,
     /* 273715 */   // Label 5299: @273715
     /* 273715 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273773), // Rule ID 2381 //
     /* 273720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 273728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273756 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 273759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273771 */     GIR_RootConstrainSelectedInstOperands,
     /* 273772 */     // GIR_Coverage, 2381,
     /* 273772 */     GIR_EraseRootFromParent_Done,
     /* 273773 */   // Label 5300: @273773
     /* 273773 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273831), // Rule ID 2382 //
     /* 273778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 273786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273814 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 273817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273829 */     GIR_RootConstrainSelectedInstOperands,
     /* 273830 */     // GIR_Coverage, 2382,
     /* 273830 */     GIR_EraseRootFromParent_Done,
     /* 273831 */   // Label 5301: @273831
     /* 273831 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273889), // Rule ID 2383 //
     /* 273836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 273844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273872 */     // (intrinsic_w_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 273875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273887 */     GIR_RootConstrainSelectedInstOperands,
     /* 273888 */     // GIR_Coverage, 2383,
     /* 273888 */     GIR_EraseRootFromParent_Done,
     /* 273889 */   // Label 5302: @273889
     /* 273889 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273947), // Rule ID 2384 //
     /* 273894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273930 */     // (intrinsic_w_chain:{ *:[v4f16] } 625:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 273933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273945 */     GIR_RootConstrainSelectedInstOperands,
     /* 273946 */     // GIR_Coverage, 2384,
     /* 273946 */     GIR_EraseRootFromParent_Done,
     /* 273947 */   // Label 5303: @273947
     /* 273947 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(274005), // Rule ID 2385 //
     /* 273952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273988 */     // (intrinsic_w_chain:{ *:[v8f16] } 625:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 273991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274003 */     GIR_RootConstrainSelectedInstOperands,
     /* 274004 */     // GIR_Coverage, 2385,
     /* 274004 */     GIR_EraseRootFromParent_Done,
     /* 274005 */   // Label 5304: @274005
     /* 274005 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(274063), // Rule ID 2386 //
     /* 274010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 274018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 274030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274046 */     // (intrinsic_w_chain:{ *:[v2f32] } 627:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 274046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 274049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274061 */     GIR_RootConstrainSelectedInstOperands,
     /* 274062 */     // GIR_Coverage, 2386,
     /* 274062 */     GIR_EraseRootFromParent_Done,
     /* 274063 */   // Label 5305: @274063
     /* 274063 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274121), // Rule ID 2387 //
     /* 274068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 274076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274104 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 274104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 274107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274119 */     GIR_RootConstrainSelectedInstOperands,
     /* 274120 */     // GIR_Coverage, 2387,
     /* 274120 */     GIR_EraseRootFromParent_Done,
     /* 274121 */   // Label 5306: @274121
     /* 274121 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274179), // Rule ID 2491 //
     /* 274126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 274129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 274134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 274137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 274140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 274143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274162 */     // (intrinsic_w_chain:{ *:[v16i8] } 624:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 274162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 274165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274167 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 274169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274177 */     GIR_RootConstrainSelectedInstOperands,
     /* 274178 */     // GIR_Coverage, 2491,
     /* 274178 */     GIR_EraseRootFromParent_Done,
     /* 274179 */   // Label 5307: @274179
     /* 274179 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(274235), // Rule ID 13373 //
     /* 274184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 274189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 274198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274210 */     // MIs[0] addr
     /* 274210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 274214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274218 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 274218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 274221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 274223 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 274225 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 274227 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 274229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274233 */     GIR_RootConstrainSelectedInstOperands,
     /* 274234 */     // GIR_Coverage, 13373,
     /* 274234 */     GIR_EraseRootFromParent_Done,
     /* 274235 */   // Label 5308: @274235
     /* 274235 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274291), // Rule ID 13374 //
     /* 274240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 274245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 274254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 274258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274266 */     // MIs[0] addr
     /* 274266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 274270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 274274 */     // (intrinsic_w_chain:{ *:[i32] } 1250:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 274274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 274277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 274279 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 274281 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 274283 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 274285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274289 */     GIR_RootConstrainSelectedInstOperands,
     /* 274290 */     // GIR_Coverage, 13374,
     /* 274290 */     GIR_EraseRootFromParent_Done,
     /* 274291 */   // Label 5309: @274291
     /* 274291 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274337), // Rule ID 3480 //
     /* 274296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 274299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 274304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 274307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274320 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 274323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274335 */     GIR_RootConstrainSelectedInstOperands,
     /* 274336 */     // GIR_Coverage, 3480,
     /* 274336 */     GIR_EraseRootFromParent_Done,
     /* 274337 */   // Label 5310: @274337
     /* 274337 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(274383), // Rule ID 3608 //
     /* 274342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 274350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 274353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274366 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 274369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274381 */     GIR_RootConstrainSelectedInstOperands,
     /* 274382 */     // GIR_Coverage, 3608,
     /* 274382 */     GIR_EraseRootFromParent_Done,
     /* 274383 */   // Label 5311: @274383
     /* 274383 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(274429), // Rule ID 12801 //
     /* 274388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 274396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 274399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274412 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 274415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274427 */     GIR_RootConstrainSelectedInstOperands,
     /* 274428 */     // GIR_Coverage, 12801,
     /* 274428 */     GIR_EraseRootFromParent_Done,
     /* 274429 */   // Label 5312: @274429
     /* 274429 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274475), // Rule ID 12805 //
     /* 274434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 274442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274458 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 274461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274473 */     GIR_RootConstrainSelectedInstOperands,
     /* 274474 */     // GIR_Coverage, 12805,
     /* 274474 */     GIR_EraseRootFromParent_Done,
     /* 274475 */   // Label 5313: @274475
     /* 274475 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274521), // Rule ID 12806 //
     /* 274480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 274488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274504 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 274507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274519 */     GIR_RootConstrainSelectedInstOperands,
     /* 274520 */     // GIR_Coverage, 12806,
     /* 274520 */     GIR_EraseRootFromParent_Done,
     /* 274521 */   // Label 5314: @274521
     /* 274521 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274567), // Rule ID 12807 //
     /* 274526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 274534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274550 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 274553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274565 */     GIR_RootConstrainSelectedInstOperands,
     /* 274566 */     // GIR_Coverage, 12807,
     /* 274566 */     GIR_EraseRootFromParent_Done,
     /* 274567 */   // Label 5315: @274567
     /* 274567 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274613), // Rule ID 12808 //
     /* 274572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 274580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274596 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 274599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274611 */     GIR_RootConstrainSelectedInstOperands,
     /* 274612 */     // GIR_Coverage, 12808,
     /* 274612 */     GIR_EraseRootFromParent_Done,
     /* 274613 */   // Label 5316: @274613
     /* 274613 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274659), // Rule ID 12809 //
     /* 274618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 274621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 274626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274642 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 274645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274657 */     GIR_RootConstrainSelectedInstOperands,
     /* 274658 */     // GIR_Coverage, 12809,
     /* 274658 */     GIR_EraseRootFromParent_Done,
     /* 274659 */   // Label 5317: @274659
     /* 274659 */   GIM_Reject,
     /* 274660 */ // Label 5270: @274660
     /* 274660 */ GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(277653),
     /* 274665 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 274668 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274736), // Rule ID 2518 //
     /* 274673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 274681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274709 */     // MIs[0] Idx
     /* 274709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274717 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 274720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274728 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274734 */     GIR_RootConstrainSelectedInstOperands,
     /* 274735 */     // GIR_Coverage, 2518,
     /* 274735 */     GIR_EraseRootFromParent_Done,
     /* 274736 */   // Label 5319: @274736
     /* 274736 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274804), // Rule ID 2519 //
     /* 274741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 274749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274777 */     // MIs[0] Idx
     /* 274777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274785 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 274788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274796 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274802 */     GIR_RootConstrainSelectedInstOperands,
     /* 274803 */     // GIR_Coverage, 2519,
     /* 274803 */     GIR_EraseRootFromParent_Done,
     /* 274804 */   // Label 5320: @274804
     /* 274804 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274872), // Rule ID 2520 //
     /* 274809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274845 */     // MIs[0] Idx
     /* 274845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274853 */     // (intrinsic_w_chain:{ *:[v2f32] } 628:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 274856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274870 */     GIR_RootConstrainSelectedInstOperands,
     /* 274871 */     // GIR_Coverage, 2520,
     /* 274871 */     GIR_EraseRootFromParent_Done,
     /* 274872 */   // Label 5321: @274872
     /* 274872 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(274940), // Rule ID 2521 //
     /* 274877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274913 */     // MIs[0] Idx
     /* 274913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274921 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 274924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274932 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274938 */     GIR_RootConstrainSelectedInstOperands,
     /* 274939 */     // GIR_Coverage, 2521,
     /* 274939 */     GIR_EraseRootFromParent_Done,
     /* 274940 */   // Label 5322: @274940
     /* 274940 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275008), // Rule ID 2522 //
     /* 274945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274981 */     // MIs[0] Idx
     /* 274981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274989 */     // (intrinsic_w_chain:{ *:[v4f16] } 626:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 274992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275000 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275006 */     GIR_RootConstrainSelectedInstOperands,
     /* 275007 */     // GIR_Coverage, 2522,
     /* 275007 */     GIR_EraseRootFromParent_Done,
     /* 275008 */   // Label 5323: @275008
     /* 275008 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275076), // Rule ID 2523 //
     /* 275013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 275016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 275021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275049 */     // MIs[0] Idx
     /* 275049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 275057 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 275057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 275060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275068 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275074 */     GIR_RootConstrainSelectedInstOperands,
     /* 275075 */     // GIR_Coverage, 2523,
     /* 275075 */     GIR_EraseRootFromParent_Done,
     /* 275076 */   // Label 5324: @275076
     /* 275076 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275144), // Rule ID 7065 //
     /* 275081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 275089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 275117 */     // MIs[0] Idx
     /* 275117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 275125 */     // (intrinsic_w_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 275125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 275128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275136 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275142 */     GIR_RootConstrainSelectedInstOperands,
     /* 275143 */     // GIR_Coverage, 7065,
     /* 275143 */     GIR_EraseRootFromParent_Done,
     /* 275144 */   // Label 5325: @275144
     /* 275144 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275212), // Rule ID 7066 //
     /* 275149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 275157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 275185 */     // MIs[0] Idx
     /* 275185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 275193 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 275193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 275196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275204 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275210 */     GIR_RootConstrainSelectedInstOperands,
     /* 275211 */     // GIR_Coverage, 7066,
     /* 275211 */     GIR_EraseRootFromParent_Done,
     /* 275212 */   // Label 5326: @275212
     /* 275212 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275280), // Rule ID 7067 //
     /* 275217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 275225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 275253 */     // MIs[0] Idx
     /* 275253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 275261 */     // (intrinsic_w_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 275261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 275264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275272 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275278 */     GIR_RootConstrainSelectedInstOperands,
     /* 275279 */     // GIR_Coverage, 7067,
     /* 275279 */     GIR_EraseRootFromParent_Done,
     /* 275280 */   // Label 5327: @275280
     /* 275280 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275348), // Rule ID 7068 //
     /* 275285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 275293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 275321 */     // MIs[0] Idx
     /* 275321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 275329 */     // (intrinsic_w_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 275329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 275332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275340 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 275342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275346 */     GIR_RootConstrainSelectedInstOperands,
     /* 275347 */     // GIR_Coverage, 7068,
     /* 275347 */     GIR_EraseRootFromParent_Done,
     /* 275348 */   // Label 5328: @275348
     /* 275348 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275408), // Rule ID 3620 //
     /* 275353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275373 */     // MIs[0] tile
     /* 275373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275389 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 275392 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275400 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275406 */     GIR_RootConstrainSelectedInstOperands,
     /* 275407 */     // GIR_Coverage, 3620,
     /* 275407 */     GIR_EraseRootFromParent_Done,
     /* 275408 */   // Label 5329: @275408
     /* 275408 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275468), // Rule ID 3621 //
     /* 275413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 275416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 275421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275433 */     // MIs[0] tile
     /* 275433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275449 */     // (intrinsic_void 890:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 275452 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275460 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275466 */     GIR_RootConstrainSelectedInstOperands,
     /* 275467 */     // GIR_Coverage, 3621,
     /* 275467 */     GIR_EraseRootFromParent_Done,
     /* 275468 */   // Label 5330: @275468
     /* 275468 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275528), // Rule ID 3622 //
     /* 275473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275493 */     // MIs[0] tile
     /* 275493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275509 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 275512 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275520 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275526 */     GIR_RootConstrainSelectedInstOperands,
     /* 275527 */     // GIR_Coverage, 3622,
     /* 275527 */     GIR_EraseRootFromParent_Done,
     /* 275528 */   // Label 5331: @275528
     /* 275528 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275588), // Rule ID 3623 //
     /* 275533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 275536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 275541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275553 */     // MIs[0] tile
     /* 275553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275569 */     // (intrinsic_void 889:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 275572 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275580 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275586 */     GIR_RootConstrainSelectedInstOperands,
     /* 275587 */     // GIR_Coverage, 3623,
     /* 275587 */     GIR_EraseRootFromParent_Done,
     /* 275588 */   // Label 5332: @275588
     /* 275588 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275648), // Rule ID 3624 //
     /* 275593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16),
     /* 275596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275613 */     // MIs[0] tile
     /* 275613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275629 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 275632 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275640 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275646 */     GIR_RootConstrainSelectedInstOperands,
     /* 275647 */     // GIR_Coverage, 3624,
     /* 275647 */     GIR_EraseRootFromParent_Done,
     /* 275648 */   // Label 5333: @275648
     /* 275648 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275708), // Rule ID 3625 //
     /* 275653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275673 */     // MIs[0] tile
     /* 275673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275689 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 275692 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275700 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275706 */     GIR_RootConstrainSelectedInstOperands,
     /* 275707 */     // GIR_Coverage, 3625,
     /* 275707 */     GIR_EraseRootFromParent_Done,
     /* 275708 */   // Label 5334: @275708
     /* 275708 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275768), // Rule ID 3626 //
     /* 275713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275733 */     // MIs[0] tile
     /* 275733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275749 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 275752 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275760 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275766 */     GIR_RootConstrainSelectedInstOperands,
     /* 275767 */     // GIR_Coverage, 3626,
     /* 275767 */     GIR_EraseRootFromParent_Done,
     /* 275768 */   // Label 5335: @275768
     /* 275768 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275828), // Rule ID 3627 //
     /* 275773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 275781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275793 */     // MIs[0] tile
     /* 275793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275809 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 275812 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275826 */     GIR_RootConstrainSelectedInstOperands,
     /* 275827 */     // GIR_Coverage, 3627,
     /* 275827 */     GIR_EraseRootFromParent_Done,
     /* 275828 */   // Label 5336: @275828
     /* 275828 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275888), // Rule ID 3721 //
     /* 275833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 275841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275853 */     // MIs[0] tile
     /* 275853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275869 */     // (intrinsic_void 1042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275872 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275880 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275886 */     GIR_RootConstrainSelectedInstOperands,
     /* 275887 */     // GIR_Coverage, 3721,
     /* 275887 */     GIR_EraseRootFromParent_Done,
     /* 275888 */   // Label 5337: @275888
     /* 275888 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275948), // Rule ID 3722 //
     /* 275893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 275901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275913 */     // MIs[0] tile
     /* 275913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275929 */     // (intrinsic_void 809:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 275932 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275940 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275946 */     GIR_RootConstrainSelectedInstOperands,
     /* 275947 */     // GIR_Coverage, 3722,
     /* 275947 */     GIR_EraseRootFromParent_Done,
     /* 275948 */   // Label 5338: @275948
     /* 275948 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(276008), // Rule ID 12816 //
     /* 275953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275973 */     // MIs[0] tile
     /* 275973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275989 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 275992 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276000 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276006 */     GIR_RootConstrainSelectedInstOperands,
     /* 276007 */     // GIR_Coverage, 12816,
     /* 276007 */     GIR_EraseRootFromParent_Done,
     /* 276008 */   // Label 5339: @276008
     /* 276008 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276068), // Rule ID 12817 //
     /* 276013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 276016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 276021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 276024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 276027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 276030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 276033 */     // MIs[0] tile
     /* 276033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276049 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 276049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 276052 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276060 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276066 */     GIR_RootConstrainSelectedInstOperands,
     /* 276067 */     // GIR_Coverage, 12817,
     /* 276067 */     GIR_EraseRootFromParent_Done,
     /* 276068 */   // Label 5340: @276068
     /* 276068 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276128), // Rule ID 12818 //
     /* 276073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 276081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276093 */     // MIs[0] tile
     /* 276093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276109 */     // (intrinsic_void 943:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 276109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 276112 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276120 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276126 */     GIR_RootConstrainSelectedInstOperands,
     /* 276127 */     // GIR_Coverage, 12818,
     /* 276127 */     GIR_EraseRootFromParent_Done,
     /* 276128 */   // Label 5341: @276128
     /* 276128 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276188), // Rule ID 12819 //
     /* 276133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 276141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276153 */     // MIs[0] tile
     /* 276153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276169 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 276172 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276180 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276186 */     GIR_RootConstrainSelectedInstOperands,
     /* 276187 */     // GIR_Coverage, 12819,
     /* 276187 */     GIR_EraseRootFromParent_Done,
     /* 276188 */   // Label 5342: @276188
     /* 276188 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276248), // Rule ID 12820 //
     /* 276193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 276201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276213 */     // MIs[0] tile
     /* 276213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276229 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 276232 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276246 */     GIR_RootConstrainSelectedInstOperands,
     /* 276247 */     // GIR_Coverage, 12820,
     /* 276247 */     GIR_EraseRootFromParent_Done,
     /* 276248 */   // Label 5343: @276248
     /* 276248 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276308), // Rule ID 12821 //
     /* 276253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 276261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276273 */     // MIs[0] tile
     /* 276273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276289 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 276292 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276300 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276306 */     GIR_RootConstrainSelectedInstOperands,
     /* 276307 */     // GIR_Coverage, 12821,
     /* 276307 */     GIR_EraseRootFromParent_Done,
     /* 276308 */   // Label 5344: @276308
     /* 276308 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(276368), // Rule ID 12822 //
     /* 276313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 276321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276333 */     // MIs[0] tile
     /* 276333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276349 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 276352 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276366 */     GIR_RootConstrainSelectedInstOperands,
     /* 276367 */     // GIR_Coverage, 12822,
     /* 276367 */     GIR_EraseRootFromParent_Done,
     /* 276368 */   // Label 5345: @276368
     /* 276368 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276428), // Rule ID 12823 //
     /* 276373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 276381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276393 */     // MIs[0] tile
     /* 276393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276409 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 276412 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276420 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276426 */     GIR_RootConstrainSelectedInstOperands,
     /* 276427 */     // GIR_Coverage, 12823,
     /* 276427 */     GIR_EraseRootFromParent_Done,
     /* 276428 */   // Label 5346: @276428
     /* 276428 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276488), // Rule ID 12824 //
     /* 276433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276453 */     // MIs[0] tile
     /* 276453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276469 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 276472 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276480 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276486 */     GIR_RootConstrainSelectedInstOperands,
     /* 276487 */     // GIR_Coverage, 12824,
     /* 276487 */     GIR_EraseRootFromParent_Done,
     /* 276488 */   // Label 5347: @276488
     /* 276488 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276548), // Rule ID 12825 //
     /* 276493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276513 */     // MIs[0] tile
     /* 276513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276529 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 276532 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276540 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276546 */     GIR_RootConstrainSelectedInstOperands,
     /* 276547 */     // GIR_Coverage, 12825,
     /* 276547 */     GIR_EraseRootFromParent_Done,
     /* 276548 */   // Label 5348: @276548
     /* 276548 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276608), // Rule ID 12826 //
     /* 276553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 276561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276573 */     // MIs[0] tile
     /* 276573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276589 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 276592 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276600 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276606 */     GIR_RootConstrainSelectedInstOperands,
     /* 276607 */     // GIR_Coverage, 12826,
     /* 276607 */     GIR_EraseRootFromParent_Done,
     /* 276608 */   // Label 5349: @276608
     /* 276608 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276668), // Rule ID 12827 //
     /* 276613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 276621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276633 */     // MIs[0] tile
     /* 276633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276649 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 276652 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276660 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276666 */     GIR_RootConstrainSelectedInstOperands,
     /* 276667 */     // GIR_Coverage, 12827,
     /* 276667 */     GIR_EraseRootFromParent_Done,
     /* 276668 */   // Label 5350: @276668
     /* 276668 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(276728), // Rule ID 12828 //
     /* 276673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 276681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276693 */     // MIs[0] tile
     /* 276693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276709 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 276712 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276720 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276726 */     GIR_RootConstrainSelectedInstOperands,
     /* 276727 */     // GIR_Coverage, 12828,
     /* 276727 */     GIR_EraseRootFromParent_Done,
     /* 276728 */   // Label 5351: @276728
     /* 276728 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276788), // Rule ID 12829 //
     /* 276733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 276741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276753 */     // MIs[0] tile
     /* 276753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276769 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 276772 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276780 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276786 */     GIR_RootConstrainSelectedInstOperands,
     /* 276787 */     // GIR_Coverage, 12829,
     /* 276787 */     GIR_EraseRootFromParent_Done,
     /* 276788 */   // Label 5352: @276788
     /* 276788 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276848), // Rule ID 12830 //
     /* 276793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 276801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276813 */     // MIs[0] tile
     /* 276813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276829 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 276832 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276840 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276846 */     GIR_RootConstrainSelectedInstOperands,
     /* 276847 */     // GIR_Coverage, 12830,
     /* 276847 */     GIR_EraseRootFromParent_Done,
     /* 276848 */   // Label 5353: @276848
     /* 276848 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276908), // Rule ID 12831 //
     /* 276853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276873 */     // MIs[0] tile
     /* 276873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276889 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 276892 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276900 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276906 */     GIR_RootConstrainSelectedInstOperands,
     /* 276907 */     // GIR_Coverage, 12831,
     /* 276907 */     GIR_EraseRootFromParent_Done,
     /* 276908 */   // Label 5354: @276908
     /* 276908 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(276968), // Rule ID 12832 //
     /* 276913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276933 */     // MIs[0] tile
     /* 276933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276949 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 276952 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276960 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276966 */     GIR_RootConstrainSelectedInstOperands,
     /* 276967 */     // GIR_Coverage, 12832,
     /* 276967 */     GIR_EraseRootFromParent_Done,
     /* 276968 */   // Label 5355: @276968
     /* 276968 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(277028), // Rule ID 13206 //
     /* 276973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 276981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 276984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 276987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 276990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 276993 */     // MIs[0] tile
     /* 276993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277009 */     // (intrinsic_void 810:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 277009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 277012 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277020 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277026 */     GIR_RootConstrainSelectedInstOperands,
     /* 277027 */     // GIR_Coverage, 13206,
     /* 277027 */     GIR_EraseRootFromParent_Done,
     /* 277028 */   // Label 5356: @277028
     /* 277028 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(277088), // Rule ID 13207 //
     /* 277033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 277041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277053 */     // MIs[0] tile
     /* 277053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277069 */     // (intrinsic_void 1044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 277072 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277080 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277086 */     GIR_RootConstrainSelectedInstOperands,
     /* 277087 */     // GIR_Coverage, 13207,
     /* 277087 */     GIR_EraseRootFromParent_Done,
     /* 277088 */   // Label 5357: @277088
     /* 277088 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277148), // Rule ID 13208 //
     /* 277093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 277101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277113 */     // MIs[0] tile
     /* 277113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277129 */     // (intrinsic_void 1177:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 277132 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277140 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277146 */     GIR_RootConstrainSelectedInstOperands,
     /* 277147 */     // GIR_Coverage, 13208,
     /* 277147 */     GIR_EraseRootFromParent_Done,
     /* 277148 */   // Label 5358: @277148
     /* 277148 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(277208), // Rule ID 13209 //
     /* 277153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 277161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277173 */     // MIs[0] tile
     /* 277173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277189 */     // (intrinsic_void 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 277192 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277200 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277206 */     GIR_RootConstrainSelectedInstOperands,
     /* 277207 */     // GIR_Coverage, 13209,
     /* 277207 */     GIR_EraseRootFromParent_Done,
     /* 277208 */   // Label 5359: @277208
     /* 277208 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(277268), // Rule ID 13320 //
     /* 277213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16),
     /* 277216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 277221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277233 */     // MIs[0] tile
     /* 277233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 277241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277249 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 277252 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277260 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277266 */     GIR_RootConstrainSelectedInstOperands,
     /* 277267 */     // GIR_Coverage, 13320,
     /* 277267 */     GIR_EraseRootFromParent_Done,
     /* 277268 */   // Label 5360: @277268
     /* 277268 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(277316), // Rule ID 3607 //
     /* 277273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 277281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 277284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277297 */     // MIs[0] Op4
     /* 277297 */     // No operand predicates
     /* 277297 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 277300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277314 */     GIR_RootConstrainSelectedInstOperands,
     /* 277315 */     // GIR_Coverage, 3607,
     /* 277315 */     GIR_EraseRootFromParent_Done,
     /* 277316 */   // Label 5361: @277316
     /* 277316 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(277364), // Rule ID 3609 //
     /* 277321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 277329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277345 */     // MIs[0] Op4
     /* 277345 */     // No operand predicates
     /* 277345 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 277348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277356 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277362 */     GIR_RootConstrainSelectedInstOperands,
     /* 277363 */     // GIR_Coverage, 3609,
     /* 277363 */     GIR_EraseRootFromParent_Done,
     /* 277364 */   // Label 5362: @277364
     /* 277364 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(277412), // Rule ID 3610 //
     /* 277369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 277372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 277377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 277380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277393 */     // MIs[0] Op4
     /* 277393 */     // No operand predicates
     /* 277393 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1514:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 277396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277404 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277410 */     GIR_RootConstrainSelectedInstOperands,
     /* 277411 */     // GIR_Coverage, 3610,
     /* 277411 */     GIR_EraseRootFromParent_Done,
     /* 277412 */   // Label 5363: @277412
     /* 277412 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(277460), // Rule ID 3611 //
     /* 277417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 277420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 277425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277441 */     // MIs[0] Op4
     /* 277441 */     // No operand predicates
     /* 277441 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 277444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277452 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277458 */     GIR_RootConstrainSelectedInstOperands,
     /* 277459 */     // GIR_Coverage, 3611,
     /* 277459 */     GIR_EraseRootFromParent_Done,
     /* 277460 */   // Label 5364: @277460
     /* 277460 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(277508), // Rule ID 12800 //
     /* 277465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 277473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 277476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277489 */     // MIs[0] Op4
     /* 277489 */     // No operand predicates
     /* 277489 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1526:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 277492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277506 */     GIR_RootConstrainSelectedInstOperands,
     /* 277507 */     // GIR_Coverage, 12800,
     /* 277507 */     GIR_EraseRootFromParent_Done,
     /* 277508 */   // Label 5365: @277508
     /* 277508 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(277556), // Rule ID 12802 //
     /* 277513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 277521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277537 */     // MIs[0] Op4
     /* 277537 */     // No operand predicates
     /* 277537 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 277540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277548 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277554 */     GIR_RootConstrainSelectedInstOperands,
     /* 277555 */     // GIR_Coverage, 12802,
     /* 277555 */     GIR_EraseRootFromParent_Done,
     /* 277556 */   // Label 5366: @277556
     /* 277556 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(277604), // Rule ID 12803 //
     /* 277561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 277569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277585 */     // MIs[0] Op4
     /* 277585 */     // No operand predicates
     /* 277585 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1522:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 277588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277596 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277602 */     GIR_RootConstrainSelectedInstOperands,
     /* 277603 */     // GIR_Coverage, 12803,
     /* 277603 */     GIR_EraseRootFromParent_Done,
     /* 277604 */   // Label 5367: @277604
     /* 277604 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277652), // Rule ID 12804 //
     /* 277609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 277617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277633 */     // MIs[0] Op4
     /* 277633 */     // No operand predicates
     /* 277633 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1524:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 277636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277644 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277650 */     GIR_RootConstrainSelectedInstOperands,
     /* 277651 */     // GIR_Coverage, 12804,
     /* 277651 */     GIR_EraseRootFromParent_Done,
     /* 277652 */   // Label 5368: @277652
     /* 277652 */   GIM_Reject,
     /* 277653 */ // Label 5318: @277653
     /* 277653 */ GIM_Reject,
     /* 277654 */ // Label 39: @277654
     /* 277654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5373*/ GIMT_Encode4(277943),
     /* 277665 */ /*GILLT_s64*//*Label 5369*/ GIMT_Encode4(277697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277677 */ /*GILLT_v2s64*//*Label 5370*/ GIMT_Encode4(277757), GIMT_Encode4(0),
     /* 277685 */ /*GILLT_v4s32*//*Label 5371*/ GIMT_Encode4(277819), GIMT_Encode4(0),
     /* 277693 */ /*GILLT_v8s16*//*Label 5372*/ GIMT_Encode4(277881),
     /* 277697 */ // Label 5369: @277697
     /* 277697 */ GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(277756), // Rule ID 6577 //
     /* 277702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277713 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 277713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277755 */   // GIR_Coverage, 6577,
     /* 277755 */   GIR_EraseRootFromParent_Done,
     /* 277756 */ // Label 5374: @277756
     /* 277756 */ GIM_Reject,
     /* 277757 */ // Label 5370: @277757
     /* 277757 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(277818),
     /* 277762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277769 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(277796), // Rule ID 6439 //
     /* 277774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 277781 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 277781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 277784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277794 */     GIR_RootConstrainSelectedInstOperands,
     /* 277795 */     // GIR_Coverage, 6439,
     /* 277795 */     GIR_EraseRootFromParent_Done,
     /* 277796 */   // Label 5376: @277796
     /* 277796 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(277817), // Rule ID 6432 //
     /* 277801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277805 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 277805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 277808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277815 */     GIR_RootConstrainSelectedInstOperands,
     /* 277816 */     // GIR_Coverage, 6432,
     /* 277816 */     GIR_EraseRootFromParent_Done,
     /* 277817 */   // Label 5377: @277817
     /* 277817 */   GIM_Reject,
     /* 277818 */ // Label 5375: @277818
     /* 277818 */ GIM_Reject,
     /* 277819 */ // Label 5371: @277819
     /* 277819 */ GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(277880),
     /* 277824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277831 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(277858), // Rule ID 6436 //
     /* 277836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 277843 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 277843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 277846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277856 */     GIR_RootConstrainSelectedInstOperands,
     /* 277857 */     // GIR_Coverage, 6436,
     /* 277857 */     GIR_EraseRootFromParent_Done,
     /* 277858 */   // Label 5379: @277858
     /* 277858 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(277879), // Rule ID 6429 //
     /* 277863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277867 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 277867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 277870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277877 */     GIR_RootConstrainSelectedInstOperands,
     /* 277878 */     // GIR_Coverage, 6429,
     /* 277878 */     GIR_EraseRootFromParent_Done,
     /* 277879 */   // Label 5380: @277879
     /* 277879 */   GIM_Reject,
     /* 277880 */ // Label 5378: @277880
     /* 277880 */ GIM_Reject,
     /* 277881 */ // Label 5372: @277881
     /* 277881 */ GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(277942),
     /* 277886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 277889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277893 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(277920), // Rule ID 6433 //
     /* 277898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 277905 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 277905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 277908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277918 */     GIR_RootConstrainSelectedInstOperands,
     /* 277919 */     // GIR_Coverage, 6433,
     /* 277919 */     GIR_EraseRootFromParent_Done,
     /* 277920 */   // Label 5382: @277920
     /* 277920 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277941), // Rule ID 6426 //
     /* 277925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277929 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 277929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 277932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277939 */     GIR_RootConstrainSelectedInstOperands,
     /* 277940 */     // GIR_Coverage, 6426,
     /* 277940 */     GIR_EraseRootFromParent_Done,
     /* 277941 */   // Label 5383: @277941
     /* 277941 */   GIM_Reject,
     /* 277942 */ // Label 5381: @277942
     /* 277942 */ GIM_Reject,
     /* 277943 */ // Label 5373: @277943
     /* 277943 */ GIM_Reject,
     /* 277944 */ // Label 40: @277944
     /* 277944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5388*/ GIMT_Encode4(279380),
     /* 277955 */ /*GILLT_s32*//*Label 5384*/ GIMT_Encode4(277987), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277967 */ /*GILLT_v2s32*//*Label 5385*/ GIMT_Encode4(278026), GIMT_Encode4(0),
     /* 277975 */ /*GILLT_v4s16*//*Label 5386*/ GIMT_Encode4(278382), GIMT_Encode4(0),
     /* 277983 */ /*GILLT_v8s8*//*Label 5387*/ GIMT_Encode4(278881),
     /* 277987 */ // Label 5384: @277987
     /* 277987 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(278025), // Rule ID 6598 //
     /* 277992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 277995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 278003 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 278003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278008 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 278014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 278019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 278024 */   // GIR_Coverage, 6598,
     /* 278024 */   GIR_EraseRootFromParent_Done,
     /* 278025 */ // Label 5389: @278025
     /* 278025 */ GIM_Reject,
     /* 278026 */ // Label 5385: @278026
     /* 278026 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(278381),
     /* 278031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278038 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(278116), // Rule ID 5478 //
     /* 278043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 278071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278080 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278088 */     // MIs[1] Operand 2
     /* 278088 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 278099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278101 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 278101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 278104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278114 */     GIR_RootConstrainSelectedInstOperands,
     /* 278115 */     // GIR_Coverage, 5478,
     /* 278115 */     GIR_EraseRootFromParent_Done,
     /* 278116 */   // Label 5391: @278116
     /* 278116 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(278187), // Rule ID 5474 //
     /* 278121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 278149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278159 */     // MIs[1] Operand 2
     /* 278159 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 278170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278172 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 278172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 278175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278185 */     GIR_RootConstrainSelectedInstOperands,
     /* 278186 */     // GIR_Coverage, 5474,
     /* 278186 */     GIR_EraseRootFromParent_Done,
     /* 278187 */   // Label 5392: @278187
     /* 278187 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(278258), // Rule ID 5476 //
     /* 278192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 278220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278230 */     // MIs[1] Operand 2
     /* 278230 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 278241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278243 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 278243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 278246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278256 */     GIR_RootConstrainSelectedInstOperands,
     /* 278257 */     // GIR_Coverage, 5476,
     /* 278257 */     GIR_EraseRootFromParent_Done,
     /* 278258 */   // Label 5393: @278258
     /* 278258 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(278311), // Rule ID 2166 //
     /* 278263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278283 */     // MIs[1] imm
     /* 278283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 278295 */     // MIs[2] Operand 1
     /* 278295 */     // No operand predicates
     /* 278295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278297 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 278300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278309 */     GIR_RootConstrainSelectedInstOperands,
     /* 278310 */     // GIR_Coverage, 2166,
     /* 278310 */     GIR_EraseRootFromParent_Done,
     /* 278311 */   // Label 5394: @278311
     /* 278311 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(278361), // Rule ID 6414 //
     /* 278316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278333 */     // MIs[1] imm
     /* 278333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 278345 */     // MIs[2] Operand 1
     /* 278345 */     // No operand predicates
     /* 278345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278347 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 278347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 278350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278359 */     GIR_RootConstrainSelectedInstOperands,
     /* 278360 */     // GIR_Coverage, 6414,
     /* 278360 */     GIR_EraseRootFromParent_Done,
     /* 278361 */   // Label 5395: @278361
     /* 278361 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(278380), // Rule ID 1103 //
     /* 278366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278373 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 278373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 278378 */     GIR_RootConstrainSelectedInstOperands,
     /* 278379 */     // GIR_Coverage, 1103,
     /* 278379 */     GIR_Done,
     /* 278380 */   // Label 5396: @278380
     /* 278380 */   GIM_Reject,
     /* 278381 */ // Label 5390: @278381
     /* 278381 */ GIM_Reject,
     /* 278382 */ // Label 5386: @278382
     /* 278382 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(278880),
     /* 278387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278394 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(278472), // Rule ID 5472 //
     /* 278399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278436 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278444 */     // MIs[1] Operand 2
     /* 278444 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278457 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278470 */     GIR_RootConstrainSelectedInstOperands,
     /* 278471 */     // GIR_Coverage, 5472,
     /* 278471 */     GIR_EraseRootFromParent_Done,
     /* 278472 */   // Label 5398: @278472
     /* 278472 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(278543), // Rule ID 5468 //
     /* 278477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278515 */     // MIs[1] Operand 2
     /* 278515 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278528 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 278531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278541 */     GIR_RootConstrainSelectedInstOperands,
     /* 278542 */     // GIR_Coverage, 5468,
     /* 278542 */     GIR_EraseRootFromParent_Done,
     /* 278543 */   // Label 5399: @278543
     /* 278543 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(278614), // Rule ID 5470 //
     /* 278548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278586 */     // MIs[1] Operand 2
     /* 278586 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278599 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278612 */     GIR_RootConstrainSelectedInstOperands,
     /* 278613 */     // GIR_Coverage, 5470,
     /* 278613 */     GIR_EraseRootFromParent_Done,
     /* 278614 */   // Label 5400: @278614
     /* 278614 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(278706), // Rule ID 5594 //
     /* 278619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278627 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278667 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278674 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 278674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 278681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278704 */     GIR_RootConstrainSelectedInstOperands,
     /* 278705 */     // GIR_Coverage, 5594,
     /* 278705 */     GIR_EraseRootFromParent_Done,
     /* 278706 */   // Label 5401: @278706
     /* 278706 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(278759), // Rule ID 2165 //
     /* 278711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278731 */     // MIs[1] imm
     /* 278731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278743 */     // MIs[2] Operand 1
     /* 278743 */     // No operand predicates
     /* 278743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278745 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278757 */     GIR_RootConstrainSelectedInstOperands,
     /* 278758 */     // GIR_Coverage, 2165,
     /* 278758 */     GIR_EraseRootFromParent_Done,
     /* 278759 */   // Label 5402: @278759
     /* 278759 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(278809), // Rule ID 6413 //
     /* 278764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278781 */     // MIs[1] imm
     /* 278781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278789 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278793 */     // MIs[2] Operand 1
     /* 278793 */     // No operand predicates
     /* 278793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278795 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 278795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278807 */     GIR_RootConstrainSelectedInstOperands,
     /* 278808 */     // GIR_Coverage, 6413,
     /* 278808 */     GIR_EraseRootFromParent_Done,
     /* 278809 */   // Label 5403: @278809
     /* 278809 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(278860), // Rule ID 5622 //
     /* 278814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278822 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278845 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 278845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 278848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278858 */     GIR_RootConstrainSelectedInstOperands,
     /* 278859 */     // GIR_Coverage, 5622,
     /* 278859 */     GIR_EraseRootFromParent_Done,
     /* 278860 */   // Label 5404: @278860
     /* 278860 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(278879), // Rule ID 1102 //
     /* 278865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278872 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 278872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278877 */     GIR_RootConstrainSelectedInstOperands,
     /* 278878 */     // GIR_Coverage, 1102,
     /* 278878 */     GIR_Done,
     /* 278879 */   // Label 5405: @278879
     /* 278879 */   GIM_Reject,
     /* 278880 */ // Label 5397: @278880
     /* 278880 */ GIM_Reject,
     /* 278881 */ // Label 5387: @278881
     /* 278881 */ GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(279379),
     /* 278886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278893 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(278971), // Rule ID 5466 //
     /* 278898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278935 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278943 */     // MIs[1] Operand 2
     /* 278943 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278956 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278969 */     GIR_RootConstrainSelectedInstOperands,
     /* 278970 */     // GIR_Coverage, 5466,
     /* 278970 */     GIR_EraseRootFromParent_Done,
     /* 278971 */   // Label 5407: @278971
     /* 278971 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(279042), // Rule ID 5462 //
     /* 278976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279014 */     // MIs[1] Operand 2
     /* 279014 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 279025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279027 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 279030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 279036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 279040 */     GIR_RootConstrainSelectedInstOperands,
     /* 279041 */     // GIR_Coverage, 5462,
     /* 279041 */     GIR_EraseRootFromParent_Done,
     /* 279042 */   // Label 5408: @279042
     /* 279042 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(279113), // Rule ID 5464 //
     /* 279047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279085 */     // MIs[1] Operand 2
     /* 279085 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 279096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279098 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 279101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 279107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 279111 */     GIR_RootConstrainSelectedInstOperands,
     /* 279112 */     // GIR_Coverage, 5464,
     /* 279112 */     GIR_EraseRootFromParent_Done,
     /* 279113 */   // Label 5409: @279113
     /* 279113 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(279205), // Rule ID 5567 //
     /* 279118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 279126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 279145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 279158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 279162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279166 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279173 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 279173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 279176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 279180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 279189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 279193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 279198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279203 */     GIR_RootConstrainSelectedInstOperands,
     /* 279204 */     // GIR_Coverage, 5567,
     /* 279204 */     GIR_EraseRootFromParent_Done,
     /* 279205 */   // Label 5410: @279205
     /* 279205 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(279258), // Rule ID 2164 //
     /* 279210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 279221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279230 */     // MIs[1] imm
     /* 279230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 279242 */     // MIs[2] Operand 1
     /* 279242 */     // No operand predicates
     /* 279242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279244 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 279244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 279247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 279256 */     GIR_RootConstrainSelectedInstOperands,
     /* 279257 */     // GIR_Coverage, 2164,
     /* 279257 */     GIR_EraseRootFromParent_Done,
     /* 279258 */   // Label 5411: @279258
     /* 279258 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(279308), // Rule ID 6412 //
     /* 279263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279280 */     // MIs[1] imm
     /* 279280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279288 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 279292 */     // MIs[2] Operand 1
     /* 279292 */     // No operand predicates
     /* 279292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279294 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 279294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 279297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 279306 */     GIR_RootConstrainSelectedInstOperands,
     /* 279307 */     // GIR_Coverage, 6412,
     /* 279307 */     GIR_EraseRootFromParent_Done,
     /* 279308 */   // Label 5412: @279308
     /* 279308 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(279359), // Rule ID 5621 //
     /* 279313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 279321 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279344 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 279344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 279347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 279353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 279357 */     GIR_RootConstrainSelectedInstOperands,
     /* 279358 */     // GIR_Coverage, 5621,
     /* 279358 */     GIR_EraseRootFromParent_Done,
     /* 279359 */   // Label 5413: @279359
     /* 279359 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(279378), // Rule ID 1101 //
     /* 279364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279371 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 279371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 279376 */     GIR_RootConstrainSelectedInstOperands,
     /* 279377 */     // GIR_Coverage, 1101,
     /* 279377 */     GIR_Done,
     /* 279378 */   // Label 5414: @279378
     /* 279378 */   GIM_Reject,
     /* 279379 */ // Label 5406: @279379
     /* 279379 */ GIM_Reject,
     /* 279380 */ // Label 5388: @279380
     /* 279380 */ GIM_Reject,
     /* 279381 */ // Label 41: @279381
     /* 279381 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5417*/ GIMT_Encode4(279500),
     /* 279392 */ /*GILLT_s32*//*Label 5415*/ GIMT_Encode4(279400),
     /* 279396 */ /*GILLT_s64*//*Label 5416*/ GIMT_Encode4(279420),
     /* 279400 */ // Label 5415: @279400
     /* 279400 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(279419), // Rule ID 81 //
     /* 279405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279409 */   // MIs[0] Operand 1
     /* 279409 */   // No operand predicates
     /* 279409 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 279409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279414 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279417 */   GIR_RootConstrainSelectedInstOperands,
     /* 279418 */   // GIR_Coverage, 81,
     /* 279418 */   GIR_EraseRootFromParent_Done,
     /* 279419 */ // Label 5418: @279419
     /* 279419 */ GIM_Reject,
     /* 279420 */ // Label 5416: @279420
     /* 279420 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(279480), // Rule ID 3938 //
     /* 279425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 279428 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 279432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279436 */   // MIs[0] Operand 1
     /* 279436 */   // No operand predicates
     /* 279436 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 279436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279448 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 279453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 279458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 279469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279479 */   // GIR_Coverage, 3938,
     /* 279479 */   GIR_EraseRootFromParent_Done,
     /* 279480 */ // Label 5419: @279480
     /* 279480 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(279499), // Rule ID 82 //
     /* 279485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 279489 */   // MIs[0] Operand 1
     /* 279489 */   // No operand predicates
     /* 279489 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 279489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 279492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279494 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279497 */   GIR_RootConstrainSelectedInstOperands,
     /* 279498 */   // GIR_Coverage, 82,
     /* 279498 */   GIR_EraseRootFromParent_Done,
     /* 279499 */ // Label 5420: @279499
     /* 279499 */ GIM_Reject,
     /* 279500 */ // Label 5417: @279500
     /* 279500 */ GIM_Reject,
     /* 279501 */ // Label 42: @279501
     /* 279501 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5424*/ GIMT_Encode4(279741),
     /* 279512 */ /*GILLT_s16*//*Label 5421*/ GIMT_Encode4(279524),
     /* 279516 */ /*GILLT_s32*//*Label 5422*/ GIMT_Encode4(279576),
     /* 279520 */ /*GILLT_s64*//*Label 5423*/ GIMT_Encode4(279689),
     /* 279524 */ // Label 5421: @279524
     /* 279524 */ GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(279547), // Rule ID 510 //
     /* 279529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279532 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279540 */   // MIs[0] Operand 1
     /* 279540 */   // No operand predicates
     /* 279540 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 279540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 279543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279545 */   GIR_RootConstrainSelectedInstOperands,
     /* 279546 */   // GIR_Coverage, 510,
     /* 279546 */   GIR_EraseRootFromParent_Done,
     /* 279547 */ // Label 5425: @279547
     /* 279547 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(279575), // Rule ID 692 //
     /* 279552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279555 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279563 */   // MIs[0] Operand 1
     /* 279563 */   // No operand predicates
     /* 279563 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 279563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 279566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279568 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 279573 */   GIR_RootConstrainSelectedInstOperands,
     /* 279574 */   // GIR_Coverage, 692,
     /* 279574 */   GIR_EraseRootFromParent_Done,
     /* 279575 */ // Label 5426: @279575
     /* 279575 */ GIM_Reject,
     /* 279576 */ // Label 5422: @279576
     /* 279576 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(279599), // Rule ID 511 //
     /* 279581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279584 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279592 */   // MIs[0] Operand 1
     /* 279592 */   // No operand predicates
     /* 279592 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 279592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 279595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279597 */   GIR_RootConstrainSelectedInstOperands,
     /* 279598 */   // GIR_Coverage, 511,
     /* 279598 */   GIR_EraseRootFromParent_Done,
     /* 279599 */ // Label 5427: @279599
     /* 279599 */ GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(279627), // Rule ID 693 //
     /* 279604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279607 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279615 */   // MIs[0] Operand 1
     /* 279615 */   // No operand predicates
     /* 279615 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 279615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 279618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279620 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 279625 */   GIR_RootConstrainSelectedInstOperands,
     /* 279626 */   // GIR_Coverage, 693,
     /* 279626 */   GIR_EraseRootFromParent_Done,
     /* 279627 */ // Label 5428: @279627
     /* 279627 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(279688), // Rule ID 6101 //
     /* 279632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279635 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 279639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279643 */   // MIs[0] Operand 1
     /* 279643 */   // No operand predicates
     /* 279643 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 279643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 279650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279655 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 279660 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 279663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279670 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 279677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279687 */   // GIR_Coverage, 6101,
     /* 279687 */   GIR_EraseRootFromParent_Done,
     /* 279688 */ // Label 5429: @279688
     /* 279688 */ GIM_Reject,
     /* 279689 */ // Label 5423: @279689
     /* 279689 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(279712), // Rule ID 512 //
     /* 279694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279697 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279705 */   // MIs[0] Operand 1
     /* 279705 */   // No operand predicates
     /* 279705 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 279705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 279708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279710 */   GIR_RootConstrainSelectedInstOperands,
     /* 279711 */   // GIR_Coverage, 512,
     /* 279711 */   GIR_EraseRootFromParent_Done,
     /* 279712 */ // Label 5430: @279712
     /* 279712 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(279740), // Rule ID 694 //
     /* 279717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279720 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279728 */   // MIs[0] Operand 1
     /* 279728 */   // No operand predicates
     /* 279728 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 279728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 279731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279733 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 279738 */   GIR_RootConstrainSelectedInstOperands,
     /* 279739 */   // GIR_Coverage, 694,
     /* 279739 */   GIR_EraseRootFromParent_Done,
     /* 279740 */ // Label 5431: @279740
     /* 279740 */ GIM_Reject,
     /* 279741 */ // Label 5424: @279741
     /* 279741 */ GIM_Reject,
     /* 279742 */ // Label 43: @279742
     /* 279742 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5437*/ GIMT_Encode4(281639),
     /* 279753 */ /*GILLT_s32*//*Label 5432*/ GIMT_Encode4(279789),
     /* 279757 */ /*GILLT_s64*//*Label 5433*/ GIMT_Encode4(281230), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279769 */ /*GILLT_v2s64*//*Label 5434*/ GIMT_Encode4(281453), GIMT_Encode4(0),
     /* 279777 */ /*GILLT_v4s32*//*Label 5435*/ GIMT_Encode4(281515), GIMT_Encode4(0),
     /* 279785 */ /*GILLT_v8s16*//*Label 5436*/ GIMT_Encode4(281577),
     /* 279789 */ // Label 5432: @279789
     /* 279789 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(279909), // Rule ID 13375 //
     /* 279794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279801 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279809 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279812 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279828 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279828 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279831 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 279835 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279840 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279846 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279849 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279853 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279872 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279878 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279907 */   GIR_RootConstrainSelectedInstOperands,
     /* 279908 */   // GIR_Coverage, 13375,
     /* 279908 */   GIR_EraseRootFromParent_Done,
     /* 279909 */ // Label 5438: @279909
     /* 279909 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(280029), // Rule ID 13377 //
     /* 279914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279921 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279929 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279932 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279937 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279941 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279948 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279948 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279951 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 279955 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279960 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279966 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279969 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279973 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279992 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279995 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279998 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280027 */   GIR_RootConstrainSelectedInstOperands,
     /* 280028 */   // GIR_Coverage, 13377,
     /* 280028 */   GIR_EraseRootFromParent_Done,
     /* 280029 */ // Label 5439: @280029
     /* 280029 */ GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(280149), // Rule ID 13379 //
     /* 280034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280041 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280049 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280052 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 280057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280068 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280068 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280071 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 280075 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280080 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280086 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280089 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280093 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280100 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280103 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280107 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280112 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280115 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280118 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280147 */   GIR_RootConstrainSelectedInstOperands,
     /* 280148 */   // GIR_Coverage, 13379,
     /* 280148 */   GIR_EraseRootFromParent_Done,
     /* 280149 */ // Label 5440: @280149
     /* 280149 */ GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(280269), // Rule ID 13381 //
     /* 280154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280169 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280172 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 280177 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280188 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280188 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280191 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 280195 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280200 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280206 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280209 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280213 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280232 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280235 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280238 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280267 */   GIR_RootConstrainSelectedInstOperands,
     /* 280268 */   // GIR_Coverage, 13381,
     /* 280268 */   GIR_EraseRootFromParent_Done,
     /* 280269 */ // Label 5441: @280269
     /* 280269 */ GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(280389), // Rule ID 13397 //
     /* 280274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280281 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280289 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280292 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 280301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280308 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280308 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280311 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 280315 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280320 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280352 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280355 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280358 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280366 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280387 */   GIR_RootConstrainSelectedInstOperands,
     /* 280388 */   // GIR_Coverage, 13397,
     /* 280388 */   GIR_EraseRootFromParent_Done,
     /* 280389 */ // Label 5442: @280389
     /* 280389 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(280509), // Rule ID 13399 //
     /* 280394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280401 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280409 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280412 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280421 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280426 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280428 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280428 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280431 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 280435 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280440 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280446 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280449 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280453 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280472 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280475 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280478 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280507 */   GIR_RootConstrainSelectedInstOperands,
     /* 280508 */   // GIR_Coverage, 13399,
     /* 280508 */   GIR_EraseRootFromParent_Done,
     /* 280509 */ // Label 5443: @280509
     /* 280509 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(280629), // Rule ID 13401 //
     /* 280514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280521 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280529 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280532 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280537 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280548 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280548 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280551 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 280555 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280560 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280566 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280569 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280573 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280598 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280627 */   GIR_RootConstrainSelectedInstOperands,
     /* 280628 */   // GIR_Coverage, 13401,
     /* 280628 */   GIR_EraseRootFromParent_Done,
     /* 280629 */ // Label 5444: @280629
     /* 280629 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(280749), // Rule ID 13403 //
     /* 280634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280641 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280649 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280652 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280657 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280661 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280668 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280668 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280671 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 280675 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280680 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280686 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280689 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280693 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280715 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280718 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280747 */   GIR_RootConstrainSelectedInstOperands,
     /* 280748 */   // GIR_Coverage, 13403,
     /* 280748 */   GIR_EraseRootFromParent_Done,
     /* 280749 */ // Label 5445: @280749
     /* 280749 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(280869), // Rule ID 13407 //
     /* 280754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280761 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280769 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280772 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280777 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 280781 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280788 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280788 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280791 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 280795 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280800 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280806 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280809 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280813 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280832 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280835 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280838 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280846 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280851 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280867 */   GIR_RootConstrainSelectedInstOperands,
     /* 280868 */   // GIR_Coverage, 13407,
     /* 280868 */   GIR_EraseRootFromParent_Done,
     /* 280869 */ // Label 5446: @280869
     /* 280869 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(280989), // Rule ID 13409 //
     /* 280874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280881 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280889 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280892 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280901 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280908 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280908 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280911 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 280915 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280920 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280926 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280929 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280933 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280952 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280955 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280958 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280961 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280966 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280987 */   GIR_RootConstrainSelectedInstOperands,
     /* 280988 */   // GIR_Coverage, 13409,
     /* 280988 */   GIR_EraseRootFromParent_Done,
     /* 280989 */ // Label 5447: @280989
     /* 280989 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(281109), // Rule ID 13411 //
     /* 280994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281001 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281009 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281012 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 281017 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281021 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281026 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281028 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281028 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281031 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 281035 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281040 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281075 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281078 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 281081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281091 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281107 */   GIR_RootConstrainSelectedInstOperands,
     /* 281108 */   // GIR_Coverage, 13411,
     /* 281108 */   GIR_EraseRootFromParent_Done,
     /* 281109 */ // Label 5448: @281109
     /* 281109 */ GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(281229), // Rule ID 13413 //
     /* 281114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281121 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281129 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281132 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 281137 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281141 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281146 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281148 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281148 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281151 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 281155 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281160 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281166 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281169 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281173 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281192 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281195 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281198 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 281201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281206 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281211 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281227 */   GIR_RootConstrainSelectedInstOperands,
     /* 281228 */   // GIR_Coverage, 13413,
     /* 281228 */   GIR_EraseRootFromParent_Done,
     /* 281229 */ // Label 5449: @281229
     /* 281229 */ GIM_Reject,
     /* 281230 */ // Label 5433: @281230
     /* 281230 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(281452),
     /* 281235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281242 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(281296), // Rule ID 5707 //
     /* 281247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 281280 */     // MIs[2] Operand 1
     /* 281280 */     // No operand predicates
     /* 281280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281282 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 281282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 281285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281294 */     GIR_RootConstrainSelectedInstOperands,
     /* 281295 */     // GIR_Coverage, 5707,
     /* 281295 */     GIR_EraseRootFromParent_Done,
     /* 281296 */   // Label 5451: @281296
     /* 281296 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281375), // Rule ID 11357 //
     /* 281301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 281332 */     // MIs[2] Operand 1
     /* 281332 */     // No operand predicates
     /* 281332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281334 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 281334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 281337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 281365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281373 */     GIR_RootConstrainSelectedInstOperands,
     /* 281374 */     // GIR_Coverage, 11357,
     /* 281374 */     GIR_EraseRootFromParent_Done,
     /* 281375 */   // Label 5452: @281375
     /* 281375 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(281451), // Rule ID 6579 //
     /* 281380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281384 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 281384 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281387 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281391 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 281401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 281420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 281438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 281449 */     GIR_RootConstrainSelectedInstOperands,
     /* 281450 */     // GIR_Coverage, 6579,
     /* 281450 */     GIR_EraseRootFromParent_Done,
     /* 281451 */   // Label 5453: @281451
     /* 281451 */   GIM_Reject,
     /* 281452 */ // Label 5450: @281452
     /* 281452 */ GIM_Reject,
     /* 281453 */ // Label 5434: @281453
     /* 281453 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(281514),
     /* 281458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281465 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(281492), // Rule ID 6441 //
     /* 281470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 281477 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 281477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 281480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281490 */     GIR_RootConstrainSelectedInstOperands,
     /* 281491 */     // GIR_Coverage, 6441,
     /* 281491 */     GIR_EraseRootFromParent_Done,
     /* 281492 */   // Label 5455: @281492
     /* 281492 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(281513), // Rule ID 6430 //
     /* 281497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281501 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 281501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 281504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281511 */     GIR_RootConstrainSelectedInstOperands,
     /* 281512 */     // GIR_Coverage, 6430,
     /* 281512 */     GIR_EraseRootFromParent_Done,
     /* 281513 */   // Label 5456: @281513
     /* 281513 */   GIM_Reject,
     /* 281514 */ // Label 5454: @281514
     /* 281514 */ GIM_Reject,
     /* 281515 */ // Label 5435: @281515
     /* 281515 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(281576),
     /* 281520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281527 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(281554), // Rule ID 6438 //
     /* 281532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 281539 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 281539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 281542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281552 */     GIR_RootConstrainSelectedInstOperands,
     /* 281553 */     // GIR_Coverage, 6438,
     /* 281553 */     GIR_EraseRootFromParent_Done,
     /* 281554 */   // Label 5458: @281554
     /* 281554 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(281575), // Rule ID 6427 //
     /* 281559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281563 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 281563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 281566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281573 */     GIR_RootConstrainSelectedInstOperands,
     /* 281574 */     // GIR_Coverage, 6427,
     /* 281574 */     GIR_EraseRootFromParent_Done,
     /* 281575 */   // Label 5459: @281575
     /* 281575 */   GIM_Reject,
     /* 281576 */ // Label 5457: @281576
     /* 281576 */ GIM_Reject,
     /* 281577 */ // Label 5436: @281577
     /* 281577 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(281638),
     /* 281582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281589 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(281616), // Rule ID 6435 //
     /* 281594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 281601 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 281601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 281604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281614 */     GIR_RootConstrainSelectedInstOperands,
     /* 281615 */     // GIR_Coverage, 6435,
     /* 281615 */     GIR_EraseRootFromParent_Done,
     /* 281616 */   // Label 5461: @281616
     /* 281616 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(281637), // Rule ID 6424 //
     /* 281621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281625 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 281625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 281628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281635 */     GIR_RootConstrainSelectedInstOperands,
     /* 281636 */     // GIR_Coverage, 6424,
     /* 281636 */     GIR_EraseRootFromParent_Done,
     /* 281637 */   // Label 5462: @281637
     /* 281637 */   GIM_Reject,
     /* 281638 */ // Label 5460: @281638
     /* 281638 */ GIM_Reject,
     /* 281639 */ // Label 5437: @281639
     /* 281639 */ GIM_Reject,
     /* 281640 */ // Label 44: @281640
     /* 281640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5468*/ GIMT_Encode4(283293),
     /* 281651 */ /*GILLT_s32*//*Label 5463*/ GIMT_Encode4(281731),
     /* 281655 */ /*GILLT_s64*//*Label 5464*/ GIMT_Encode4(282225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281707 */ /*GILLT_nxv2s64*//*Label 5465*/ GIMT_Encode4(282867), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281719 */ /*GILLT_nxv4s32*//*Label 5466*/ GIMT_Encode4(283076), GIMT_Encode4(0),
     /* 281727 */ /*GILLT_nxv8s16*//*Label 5467*/ GIMT_Encode4(283220),
     /* 281731 */ // Label 5463: @281731
     /* 281731 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(282224),
     /* 281736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281743 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281808), // Rule ID 5702 //
     /* 281748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281781 */     // MIs[2] Operand 1
     /* 281781 */     // No operand predicates
     /* 281781 */     // MIs[0] Operand 2
     /* 281781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281794 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281806 */     GIR_RootConstrainSelectedInstOperands,
     /* 281807 */     // GIR_Coverage, 5702,
     /* 281807 */     GIR_EraseRootFromParent_Done,
     /* 281808 */   // Label 5470: @281808
     /* 281808 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281873), // Rule ID 5704 //
     /* 281813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281846 */     // MIs[2] Operand 1
     /* 281846 */     // No operand predicates
     /* 281846 */     // MIs[0] Operand 2
     /* 281846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281859 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281871 */     GIR_RootConstrainSelectedInstOperands,
     /* 281872 */     // GIR_Coverage, 5704,
     /* 281872 */     GIR_EraseRootFromParent_Done,
     /* 281873 */   // Label 5471: @281873
     /* 281873 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(281938), // Rule ID 5706 //
     /* 281878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281911 */     // MIs[2] Operand 1
     /* 281911 */     // No operand predicates
     /* 281911 */     // MIs[0] Operand 2
     /* 281911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281924 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281936 */     GIR_RootConstrainSelectedInstOperands,
     /* 281937 */     // GIR_Coverage, 5706,
     /* 281937 */     GIR_EraseRootFromParent_Done,
     /* 281938 */   // Label 5472: @281938
     /* 281938 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(282028), // Rule ID 11353 //
     /* 281943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281974 */     // MIs[2] Operand 1
     /* 281974 */     // No operand predicates
     /* 281974 */     // MIs[0] Operand 2
     /* 281974 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281987 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 281987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281999 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 282026 */     GIR_RootConstrainSelectedInstOperands,
     /* 282027 */     // GIR_Coverage, 11353,
     /* 282027 */     GIR_EraseRootFromParent_Done,
     /* 282028 */   // Label 5473: @282028
     /* 282028 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282118), // Rule ID 11355 //
     /* 282033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282064 */     // MIs[2] Operand 1
     /* 282064 */     // No operand predicates
     /* 282064 */     // MIs[0] Operand 2
     /* 282064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282077 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 282077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 282080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 282116 */     GIR_RootConstrainSelectedInstOperands,
     /* 282117 */     // GIR_Coverage, 11355,
     /* 282117 */     GIR_EraseRootFromParent_Done,
     /* 282118 */   // Label 5474: @282118
     /* 282118 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282153), // Rule ID 6584 //
     /* 282123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282127 */     // MIs[0] Operand 2
     /* 282127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282138 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 282138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 282141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 282151 */     GIR_RootConstrainSelectedInstOperands,
     /* 282152 */     // GIR_Coverage, 6584,
     /* 282152 */     GIR_EraseRootFromParent_Done,
     /* 282153 */   // Label 5475: @282153
     /* 282153 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282188), // Rule ID 6585 //
     /* 282158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282162 */     // MIs[0] Operand 2
     /* 282162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282173 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 282173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 282176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 282186 */     GIR_RootConstrainSelectedInstOperands,
     /* 282187 */     // GIR_Coverage, 6585,
     /* 282187 */     GIR_EraseRootFromParent_Done,
     /* 282188 */   // Label 5476: @282188
     /* 282188 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(282223), // Rule ID 6586 //
     /* 282193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282197 */     // MIs[0] Operand 2
     /* 282197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 282208 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 282208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 282211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282221 */     GIR_RootConstrainSelectedInstOperands,
     /* 282222 */     // GIR_Coverage, 6586,
     /* 282222 */     GIR_EraseRootFromParent_Done,
     /* 282223 */   // Label 5477: @282223
     /* 282223 */   GIM_Reject,
     /* 282224 */ // Label 5469: @282224
     /* 282224 */ GIM_Reject,
     /* 282225 */ // Label 5464: @282225
     /* 282225 */ GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282866),
     /* 282230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 282233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282237 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(282314), // Rule ID 5708 //
     /* 282242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282283 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282287 */     // MIs[3] Operand 1
     /* 282287 */     // No operand predicates
     /* 282287 */     // MIs[0] Operand 2
     /* 282287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282300 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 282300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 282309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282312 */     GIR_RootConstrainSelectedInstOperands,
     /* 282313 */     // GIR_Coverage, 5708,
     /* 282313 */     GIR_EraseRootFromParent_Done,
     /* 282314 */   // Label 5479: @282314
     /* 282314 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(282391), // Rule ID 5709 //
     /* 282319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282364 */     // MIs[3] Operand 1
     /* 282364 */     // No operand predicates
     /* 282364 */     // MIs[0] Operand 2
     /* 282364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282377 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 282386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282389 */     GIR_RootConstrainSelectedInstOperands,
     /* 282390 */     // GIR_Coverage, 5709,
     /* 282390 */     GIR_EraseRootFromParent_Done,
     /* 282391 */   // Label 5480: @282391
     /* 282391 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(282493), // Rule ID 11354 //
     /* 282396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282435 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282439 */     // MIs[3] Operand 1
     /* 282439 */     // No operand predicates
     /* 282439 */     // MIs[0] Operand 2
     /* 282439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282452 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 282452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282491 */     GIR_RootConstrainSelectedInstOperands,
     /* 282492 */     // GIR_Coverage, 11354,
     /* 282492 */     GIR_EraseRootFromParent_Done,
     /* 282493 */   // Label 5481: @282493
     /* 282493 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(282595), // Rule ID 11356 //
     /* 282498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282537 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282541 */     // MIs[3] Operand 1
     /* 282541 */     // No operand predicates
     /* 282541 */     // MIs[0] Operand 2
     /* 282541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282554 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 282554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 282557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282566 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282593 */     GIR_RootConstrainSelectedInstOperands,
     /* 282594 */     // GIR_Coverage, 11356,
     /* 282594 */     GIR_EraseRootFromParent_Done,
     /* 282595 */   // Label 5482: @282595
     /* 282595 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(282660), // Rule ID 5703 //
     /* 282600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282633 */     // MIs[2] Operand 1
     /* 282633 */     // No operand predicates
     /* 282633 */     // MIs[0] Operand 2
     /* 282633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282646 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 282646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282658 */     GIR_RootConstrainSelectedInstOperands,
     /* 282659 */     // GIR_Coverage, 5703,
     /* 282659 */     GIR_EraseRootFromParent_Done,
     /* 282660 */   // Label 5483: @282660
     /* 282660 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282725), // Rule ID 5705 //
     /* 282665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282698 */     // MIs[2] Operand 1
     /* 282698 */     // No operand predicates
     /* 282698 */     // MIs[0] Operand 2
     /* 282698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282711 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282723 */     GIR_RootConstrainSelectedInstOperands,
     /* 282724 */     // GIR_Coverage, 5705,
     /* 282724 */     GIR_EraseRootFromParent_Done,
     /* 282725 */   // Label 5484: @282725
     /* 282725 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282760), // Rule ID 6580 //
     /* 282730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282734 */     // MIs[0] Operand 2
     /* 282734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282745 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 282745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 282758 */     GIR_RootConstrainSelectedInstOperands,
     /* 282759 */     // GIR_Coverage, 6580,
     /* 282759 */     GIR_EraseRootFromParent_Done,
     /* 282760 */   // Label 5485: @282760
     /* 282760 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282795), // Rule ID 6581 //
     /* 282765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282769 */     // MIs[0] Operand 2
     /* 282769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282780 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 282780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282785 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 282793 */     GIR_RootConstrainSelectedInstOperands,
     /* 282794 */     // GIR_Coverage, 6581,
     /* 282794 */     GIR_EraseRootFromParent_Done,
     /* 282795 */   // Label 5486: @282795
     /* 282795 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(282830), // Rule ID 6582 //
     /* 282800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282804 */     // MIs[0] Operand 2
     /* 282804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282815 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 282815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 282828 */     GIR_RootConstrainSelectedInstOperands,
     /* 282829 */     // GIR_Coverage, 6582,
     /* 282829 */     GIR_EraseRootFromParent_Done,
     /* 282830 */   // Label 5487: @282830
     /* 282830 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(282865), // Rule ID 6583 //
     /* 282835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282839 */     // MIs[0] Operand 2
     /* 282839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 282850 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 282850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282863 */     GIR_RootConstrainSelectedInstOperands,
     /* 282864 */     // GIR_Coverage, 6583,
     /* 282864 */     GIR_EraseRootFromParent_Done,
     /* 282865 */   // Label 5488: @282865
     /* 282865 */   GIM_Reject,
     /* 282866 */ // Label 5478: @282866
     /* 282866 */ GIM_Reject,
     /* 282867 */ // Label 5465: @282867
     /* 282867 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(283075),
     /* 282872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282879 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(282944), // Rule ID 10625 //
     /* 282884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282887 */     // MIs[0] Operand 2
     /* 282887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282898 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282910 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 282932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282942 */     GIR_RootConstrainSelectedInstOperands,
     /* 282943 */     // GIR_Coverage, 10625,
     /* 282943 */     GIR_EraseRootFromParent_Done,
     /* 282944 */   // Label 5490: @282944
     /* 282944 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(283009), // Rule ID 10626 //
     /* 282949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282952 */     // MIs[0] Operand 2
     /* 282952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282963 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282975 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 282997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 283007 */     GIR_RootConstrainSelectedInstOperands,
     /* 283008 */     // GIR_Coverage, 10626,
     /* 283008 */     GIR_EraseRootFromParent_Done,
     /* 283009 */   // Label 5491: @283009
     /* 283009 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(283074), // Rule ID 10627 //
     /* 283014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283017 */     // MIs[0] Operand 2
     /* 283017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283028 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 283028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 283031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 283035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 283043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 283048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 283062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 283064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 283072 */     GIR_RootConstrainSelectedInstOperands,
     /* 283073 */     // GIR_Coverage, 10627,
     /* 283073 */     GIR_EraseRootFromParent_Done,
     /* 283074 */   // Label 5492: @283074
     /* 283074 */   GIM_Reject,
     /* 283075 */ // Label 5489: @283075
     /* 283075 */ GIM_Reject,
     /* 283076 */ // Label 5466: @283076
     /* 283076 */ GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(283219),
     /* 283081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283088 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(283153), // Rule ID 10628 //
     /* 283093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283096 */     // MIs[0] Operand 2
     /* 283096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283107 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 283107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 283110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 283114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 283122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 283127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 283141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 283143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 283151 */     GIR_RootConstrainSelectedInstOperands,
     /* 283152 */     // GIR_Coverage, 10628,
     /* 283152 */     GIR_EraseRootFromParent_Done,
     /* 283153 */   // Label 5494: @283153
     /* 283153 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283218), // Rule ID 10629 //
     /* 283158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283161 */     // MIs[0] Operand 2
     /* 283161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283172 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 283172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 283175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 283179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 283187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 283192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 283206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 283208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 283216 */     GIR_RootConstrainSelectedInstOperands,
     /* 283217 */     // GIR_Coverage, 10629,
     /* 283217 */     GIR_EraseRootFromParent_Done,
     /* 283218 */   // Label 5495: @283218
     /* 283218 */   GIM_Reject,
     /* 283219 */ // Label 5493: @283219
     /* 283219 */ GIM_Reject,
     /* 283220 */ // Label 5467: @283220
     /* 283220 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283292), // Rule ID 10630 //
     /* 283225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283235 */   // MIs[0] Operand 2
     /* 283235 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283246 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 283246 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 283249 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 283253 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283258 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 283261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 283266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 283280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 283282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283288 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 283290 */   GIR_RootConstrainSelectedInstOperands,
     /* 283291 */   // GIR_Coverage, 10630,
     /* 283291 */   GIR_EraseRootFromParent_Done,
     /* 283292 */ // Label 5496: @283292
     /* 283292 */ GIM_Reject,
     /* 283293 */ // Label 5468: @283293
     /* 283293 */ GIM_Reject,
     /* 283294 */ // Label 45: @283294
     /* 283294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5501*/ GIMT_Encode4(286072),
     /* 283305 */ /*GILLT_s32*//*Label 5497*/ GIMT_Encode4(283341), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283321 */ /*GILLT_v2s64*//*Label 5498*/ GIMT_Encode4(285142), GIMT_Encode4(0),
     /* 283329 */ /*GILLT_v4s32*//*Label 5499*/ GIMT_Encode4(285452), GIMT_Encode4(0),
     /* 283337 */ /*GILLT_v8s16*//*Label 5500*/ GIMT_Encode4(285762),
     /* 283341 */ // Label 5497: @283341
     /* 283341 */ GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(283491), // Rule ID 13384 //
     /* 283346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283353 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283361 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283364 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283380 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283380 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283383 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 283387 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283392 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283398 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283401 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283405 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283424 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283427 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283430 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283433 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283438 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283443 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283460 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283490 */   // GIR_Coverage, 13384,
     /* 283490 */   GIR_EraseRootFromParent_Done,
     /* 283491 */ // Label 5502: @283491
     /* 283491 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(283641), // Rule ID 13386 //
     /* 283496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283503 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283511 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283514 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283528 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283530 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283530 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283533 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 283537 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283542 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283548 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283551 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283555 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283574 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283580 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283583 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283588 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283593 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283640 */   // GIR_Coverage, 13386,
     /* 283640 */   GIR_EraseRootFromParent_Done,
     /* 283641 */ // Label 5503: @283641
     /* 283641 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(283791), // Rule ID 13388 //
     /* 283646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283653 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283661 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283664 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283669 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283680 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283680 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283683 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 283687 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283692 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283724 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283727 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283730 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283733 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283738 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283743 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283760 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283790 */   // GIR_Coverage, 13388,
     /* 283790 */   GIR_EraseRootFromParent_Done,
     /* 283791 */ // Label 5504: @283791
     /* 283791 */ GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(283941), // Rule ID 13390 //
     /* 283796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283803 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283811 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283814 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283819 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283830 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283830 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283833 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 283837 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283842 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283848 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283851 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283855 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283874 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283877 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283880 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283883 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283888 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283893 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283910 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283940 */   // GIR_Coverage, 13390,
     /* 283940 */   GIR_EraseRootFromParent_Done,
     /* 283941 */ // Label 5505: @283941
     /* 283941 */ GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(284091), // Rule ID 13417 //
     /* 283946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283953 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283961 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283964 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283973 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283980 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283980 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283983 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 283987 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283992 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283998 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284001 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284005 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284024 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284027 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284030 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284033 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284038 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284043 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284060 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284090 */   // GIR_Coverage, 13417,
     /* 284090 */   GIR_EraseRootFromParent_Done,
     /* 284091 */ // Label 5506: @284091
     /* 284091 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284241), // Rule ID 13419 //
     /* 284096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284103 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284111 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284114 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 284119 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284123 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284130 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284130 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284133 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 284137 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284142 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284148 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284151 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284155 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284174 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284177 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284180 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284183 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284188 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284193 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284210 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284240 */   // GIR_Coverage, 13419,
     /* 284240 */   GIR_EraseRootFromParent_Done,
     /* 284241 */ // Label 5507: @284241
     /* 284241 */ GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284391), // Rule ID 13421 //
     /* 284246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284253 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284261 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284264 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 284269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284278 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284280 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284280 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284283 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 284287 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284292 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284298 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284301 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284305 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284324 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284327 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284330 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284333 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284338 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284343 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284360 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284390 */   // GIR_Coverage, 13421,
     /* 284390 */   GIR_EraseRootFromParent_Done,
     /* 284391 */ // Label 5508: @284391
     /* 284391 */ GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284541), // Rule ID 13423 //
     /* 284396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284403 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284411 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284414 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 284419 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284430 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284430 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284433 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 284437 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284442 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284448 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284451 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284455 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284474 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284477 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284480 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284483 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284488 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284493 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284510 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284540 */   // GIR_Coverage, 13423,
     /* 284540 */   GIR_EraseRootFromParent_Done,
     /* 284541 */ // Label 5509: @284541
     /* 284541 */ GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284691), // Rule ID 13427 //
     /* 284546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284553 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284561 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284564 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284569 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284580 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284580 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284583 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 284587 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284592 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284598 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284601 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284605 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284612 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284615 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284619 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284624 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284627 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284630 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284633 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284638 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284643 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284660 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284690 */   // GIR_Coverage, 13427,
     /* 284690 */   GIR_EraseRootFromParent_Done,
     /* 284691 */ // Label 5510: @284691
     /* 284691 */ GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(284841), // Rule ID 13429 //
     /* 284696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284703 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284711 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284714 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284723 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284730 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284730 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284733 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 284737 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284742 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284748 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284751 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284755 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284762 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284765 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284769 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284774 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284777 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284780 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284783 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284788 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284793 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284810 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284840 */   // GIR_Coverage, 13429,
     /* 284840 */   GIR_EraseRootFromParent_Done,
     /* 284841 */ // Label 5511: @284841
     /* 284841 */ GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(284991), // Rule ID 13431 //
     /* 284846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284853 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284861 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284864 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284869 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284880 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284880 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284883 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 284887 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284892 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284898 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284901 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284905 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284924 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284927 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284930 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284933 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284938 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284943 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284960 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284990 */   // GIR_Coverage, 13431,
     /* 284990 */   GIR_EraseRootFromParent_Done,
     /* 284991 */ // Label 5512: @284991
     /* 284991 */ GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(285141), // Rule ID 13433 //
     /* 284996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285003 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285011 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285014 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 285019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285030 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285030 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285033 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 285037 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285042 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285048 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285051 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285055 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285074 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285077 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285080 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 285083 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285088 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285093 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285110 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285140 */   // GIR_Coverage, 13433,
     /* 285140 */   GIR_EraseRootFromParent_Done,
     /* 285141 */ // Label 5513: @285141
     /* 285141 */ GIM_Reject,
     /* 285142 */ // Label 5498: @285142
     /* 285142 */ GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(285451),
     /* 285147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285154 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(285219), // Rule ID 706 //
     /* 285159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285170 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285173 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285182 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 285186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285202 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 285202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 285205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285217 */     GIR_RootConstrainSelectedInstOperands,
     /* 285218 */     // GIR_Coverage, 706,
     /* 285218 */     GIR_EraseRootFromParent_Done,
     /* 285219 */   // Label 5515: @285219
     /* 285219 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(285284), // Rule ID 1715 //
     /* 285224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285235 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285238 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 285251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285267 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 285267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 285270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285282 */     GIR_RootConstrainSelectedInstOperands,
     /* 285283 */     // GIR_Coverage, 1715,
     /* 285283 */     GIR_EraseRootFromParent_Done,
     /* 285284 */   // Label 5516: @285284
     /* 285284 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(285343), // Rule ID 704 //
     /* 285289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285300 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285303 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 285316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285328 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 285328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 285331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285341 */     GIR_RootConstrainSelectedInstOperands,
     /* 285342 */     // GIR_Coverage, 704,
     /* 285342 */     GIR_EraseRootFromParent_Done,
     /* 285343 */   // Label 5517: @285343
     /* 285343 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(285402), // Rule ID 1713 //
     /* 285348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 285375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285387 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 285387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 285390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285400 */     GIR_RootConstrainSelectedInstOperands,
     /* 285401 */     // GIR_Coverage, 1713,
     /* 285401 */     GIR_EraseRootFromParent_Done,
     /* 285402 */   // Label 5518: @285402
     /* 285402 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(285429), // Rule ID 6440 //
     /* 285407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285414 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 285414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 285417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285427 */     GIR_RootConstrainSelectedInstOperands,
     /* 285428 */     // GIR_Coverage, 6440,
     /* 285428 */     GIR_EraseRootFromParent_Done,
     /* 285429 */   // Label 5519: @285429
     /* 285429 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(285450), // Rule ID 6431 //
     /* 285434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285438 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 285438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 285441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285448 */     GIR_RootConstrainSelectedInstOperands,
     /* 285449 */     // GIR_Coverage, 6431,
     /* 285449 */     GIR_EraseRootFromParent_Done,
     /* 285450 */   // Label 5520: @285450
     /* 285450 */   GIM_Reject,
     /* 285451 */ // Label 5514: @285451
     /* 285451 */ GIM_Reject,
     /* 285452 */ // Label 5499: @285452
     /* 285452 */ GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(285761),
     /* 285457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285464 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(285529), // Rule ID 702 //
     /* 285469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285480 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285483 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285512 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 285515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285527 */     GIR_RootConstrainSelectedInstOperands,
     /* 285528 */     // GIR_Coverage, 702,
     /* 285528 */     GIR_EraseRootFromParent_Done,
     /* 285529 */   // Label 5522: @285529
     /* 285529 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(285594), // Rule ID 1711 //
     /* 285534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285545 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285548 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285557 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285577 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 285580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285592 */     GIR_RootConstrainSelectedInstOperands,
     /* 285593 */     // GIR_Coverage, 1711,
     /* 285593 */     GIR_EraseRootFromParent_Done,
     /* 285594 */   // Label 5523: @285594
     /* 285594 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(285653), // Rule ID 700 //
     /* 285599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285610 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285613 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285622 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285638 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 285641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285651 */     GIR_RootConstrainSelectedInstOperands,
     /* 285652 */     // GIR_Coverage, 700,
     /* 285652 */     GIR_EraseRootFromParent_Done,
     /* 285653 */   // Label 5524: @285653
     /* 285653 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(285712), // Rule ID 1709 //
     /* 285658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285669 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285672 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285681 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285697 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 285700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285710 */     GIR_RootConstrainSelectedInstOperands,
     /* 285711 */     // GIR_Coverage, 1709,
     /* 285711 */     GIR_EraseRootFromParent_Done,
     /* 285712 */   // Label 5525: @285712
     /* 285712 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(285739), // Rule ID 6437 //
     /* 285717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285724 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 285724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 285727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285737 */     GIR_RootConstrainSelectedInstOperands,
     /* 285738 */     // GIR_Coverage, 6437,
     /* 285738 */     GIR_EraseRootFromParent_Done,
     /* 285739 */   // Label 5526: @285739
     /* 285739 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(285760), // Rule ID 6428 //
     /* 285744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285748 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 285748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 285751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285758 */     GIR_RootConstrainSelectedInstOperands,
     /* 285759 */     // GIR_Coverage, 6428,
     /* 285759 */     GIR_EraseRootFromParent_Done,
     /* 285760 */   // Label 5527: @285760
     /* 285760 */   GIM_Reject,
     /* 285761 */ // Label 5521: @285761
     /* 285761 */ GIM_Reject,
     /* 285762 */ // Label 5500: @285762
     /* 285762 */ GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(286071),
     /* 285767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285774 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(285839), // Rule ID 698 //
     /* 285779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285790 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285793 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285802 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285822 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 285825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285837 */     GIR_RootConstrainSelectedInstOperands,
     /* 285838 */     // GIR_Coverage, 698,
     /* 285838 */     GIR_EraseRootFromParent_Done,
     /* 285839 */   // Label 5529: @285839
     /* 285839 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(285904), // Rule ID 1707 //
     /* 285844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285855 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285858 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285887 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 285890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285902 */     GIR_RootConstrainSelectedInstOperands,
     /* 285903 */     // GIR_Coverage, 1707,
     /* 285903 */     GIR_EraseRootFromParent_Done,
     /* 285904 */   // Label 5530: @285904
     /* 285904 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(285963), // Rule ID 696 //
     /* 285909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285920 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285923 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285932 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285948 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 285951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285961 */     GIR_RootConstrainSelectedInstOperands,
     /* 285962 */     // GIR_Coverage, 696,
     /* 285962 */     GIR_EraseRootFromParent_Done,
     /* 285963 */   // Label 5531: @285963
     /* 285963 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(286022), // Rule ID 1705 //
     /* 285968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285979 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285982 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285991 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286007 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 286007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 286010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 286020 */     GIR_RootConstrainSelectedInstOperands,
     /* 286021 */     // GIR_Coverage, 1705,
     /* 286021 */     GIR_EraseRootFromParent_Done,
     /* 286022 */   // Label 5532: @286022
     /* 286022 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(286049), // Rule ID 6434 //
     /* 286027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 286034 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 286034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 286037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 286044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286047 */     GIR_RootConstrainSelectedInstOperands,
     /* 286048 */     // GIR_Coverage, 6434,
     /* 286048 */     GIR_EraseRootFromParent_Done,
     /* 286049 */   // Label 5533: @286049
     /* 286049 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(286070), // Rule ID 6425 //
     /* 286054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286058 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 286058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 286061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286068 */     GIR_RootConstrainSelectedInstOperands,
     /* 286069 */     // GIR_Coverage, 6425,
     /* 286069 */     GIR_EraseRootFromParent_Done,
     /* 286070 */   // Label 5534: @286070
     /* 286070 */   GIM_Reject,
     /* 286071 */ // Label 5528: @286071
     /* 286071 */ GIM_Reject,
     /* 286072 */ // Label 5501: @286072
     /* 286072 */ GIM_Reject,
     /* 286073 */ // Label 46: @286073
     /* 286073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5540*/ GIMT_Encode4(286897),
     /* 286084 */ /*GILLT_s32*//*Label 5535*/ GIMT_Encode4(286120),
     /* 286088 */ /*GILLT_s64*//*Label 5536*/ GIMT_Encode4(286297), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286100 */ /*GILLT_v2s64*//*Label 5537*/ GIMT_Encode4(286470), GIMT_Encode4(0),
     /* 286108 */ /*GILLT_v4s32*//*Label 5538*/ GIMT_Encode4(286615), GIMT_Encode4(0),
     /* 286116 */ /*GILLT_v8s16*//*Label 5539*/ GIMT_Encode4(286756),
     /* 286120 */ // Label 5535: @286120
     /* 286120 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(286296),
     /* 286125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286139 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286176), // Rule ID 3968 //
     /* 286144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286163 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 286166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286174 */     GIR_RootConstrainSelectedInstOperands,
     /* 286175 */     // GIR_Coverage, 3968,
     /* 286175 */     GIR_EraseRootFromParent_Done,
     /* 286176 */   // Label 5542: @286176
     /* 286176 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286213), // Rule ID 3969 //
     /* 286181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286200 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 286203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286211 */     GIR_RootConstrainSelectedInstOperands,
     /* 286212 */     // GIR_Coverage, 3969,
     /* 286212 */     GIR_EraseRootFromParent_Done,
     /* 286213 */   // Label 5543: @286213
     /* 286213 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(286250), // Rule ID 3967 //
     /* 286218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286237 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 286240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286248 */     GIR_RootConstrainSelectedInstOperands,
     /* 286249 */     // GIR_Coverage, 3967,
     /* 286249 */     GIR_EraseRootFromParent_Done,
     /* 286250 */   // Label 5544: @286250
     /* 286250 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(286295), // Rule ID 3966 //
     /* 286255 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 286286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286293 */     GIR_RootConstrainSelectedInstOperands,
     /* 286294 */     // GIR_Coverage, 3966,
     /* 286294 */     GIR_EraseRootFromParent_Done,
     /* 286295 */   // Label 5545: @286295
     /* 286295 */   GIM_Reject,
     /* 286296 */ // Label 5541: @286296
     /* 286296 */ GIM_Reject,
     /* 286297 */ // Label 5536: @286297
     /* 286297 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(286469),
     /* 286302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286316 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(286384), // Rule ID 3970 //
     /* 286321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286340 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286382 */     GIR_RootConstrainSelectedInstOperands,
     /* 286383 */     // GIR_Coverage, 3970,
     /* 286383 */     GIR_EraseRootFromParent_Done,
     /* 286384 */   // Label 5547: @286384
     /* 286384 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(286452), // Rule ID 3971 //
     /* 286389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286408 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286450 */     GIR_RootConstrainSelectedInstOperands,
     /* 286451 */     // GIR_Coverage, 3971,
     /* 286451 */     GIR_EraseRootFromParent_Done,
     /* 286452 */   // Label 5548: @286452
     /* 286452 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(286468), // Rule ID 120 //
     /* 286457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286461 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286466 */     GIR_RootConstrainSelectedInstOperands,
     /* 286467 */     // GIR_Coverage, 120,
     /* 286467 */     GIR_Done,
     /* 286468 */   // Label 5549: @286468
     /* 286468 */   GIM_Reject,
     /* 286469 */ // Label 5546: @286469
     /* 286469 */ GIM_Reject,
     /* 286470 */ // Label 5537: @286470
     /* 286470 */ GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(286614),
     /* 286475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286485 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(286549), // Rule ID 6423 //
     /* 286490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286527 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286531 */     // MIs[3] Operand 1
     /* 286531 */     // No operand predicates
     /* 286531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286533 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 286536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286542 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286547 */     GIR_RootConstrainSelectedInstOperands,
     /* 286548 */     // GIR_Coverage, 6423,
     /* 286548 */     GIR_EraseRootFromParent_Done,
     /* 286549 */   // Label 5551: @286549
     /* 286549 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(286613), // Rule ID 6420 //
     /* 286554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286591 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286595 */     // MIs[3] Operand 1
     /* 286595 */     // No operand predicates
     /* 286595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286597 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 286600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286606 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286611 */     GIR_RootConstrainSelectedInstOperands,
     /* 286612 */     // GIR_Coverage, 6420,
     /* 286612 */     GIR_EraseRootFromParent_Done,
     /* 286613 */   // Label 5552: @286613
     /* 286613 */   GIM_Reject,
     /* 286614 */ // Label 5550: @286614
     /* 286614 */ GIM_Reject,
     /* 286615 */ // Label 5538: @286615
     /* 286615 */ GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(286755),
     /* 286620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286630 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(286692), // Rule ID 6422 //
     /* 286635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286672 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286676 */     // MIs[3] Operand 1
     /* 286676 */     // No operand predicates
     /* 286676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286678 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 286681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286690 */     GIR_RootConstrainSelectedInstOperands,
     /* 286691 */     // GIR_Coverage, 6422,
     /* 286691 */     GIR_EraseRootFromParent_Done,
     /* 286692 */   // Label 5554: @286692
     /* 286692 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(286754), // Rule ID 6419 //
     /* 286697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286738 */     // MIs[3] Operand 1
     /* 286738 */     // No operand predicates
     /* 286738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286740 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 286743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286752 */     GIR_RootConstrainSelectedInstOperands,
     /* 286753 */     // GIR_Coverage, 6419,
     /* 286753 */     GIR_EraseRootFromParent_Done,
     /* 286754 */   // Label 5555: @286754
     /* 286754 */   GIM_Reject,
     /* 286755 */ // Label 5553: @286755
     /* 286755 */ GIM_Reject,
     /* 286756 */ // Label 5539: @286756
     /* 286756 */ GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(286896),
     /* 286761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286771 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(286833), // Rule ID 6421 //
     /* 286776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286817 */     // MIs[3] Operand 1
     /* 286817 */     // No operand predicates
     /* 286817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286819 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 286822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286831 */     GIR_RootConstrainSelectedInstOperands,
     /* 286832 */     // GIR_Coverage, 6421,
     /* 286832 */     GIR_EraseRootFromParent_Done,
     /* 286833 */   // Label 5557: @286833
     /* 286833 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(286895), // Rule ID 6418 //
     /* 286838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286875 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286879 */     // MIs[3] Operand 1
     /* 286879 */     // No operand predicates
     /* 286879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286881 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 286884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286893 */     GIR_RootConstrainSelectedInstOperands,
     /* 286894 */     // GIR_Coverage, 6418,
     /* 286894 */     GIR_EraseRootFromParent_Done,
     /* 286895 */   // Label 5558: @286895
     /* 286895 */   GIM_Reject,
     /* 286896 */ // Label 5556: @286896
     /* 286896 */ GIM_Reject,
     /* 286897 */ // Label 5540: @286897
     /* 286897 */ GIM_Reject,
     /* 286898 */ // Label 47: @286898
     /* 286898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5561*/ GIMT_Encode4(287441),
     /* 286909 */ /*GILLT_s32*//*Label 5559*/ GIMT_Encode4(286917),
     /* 286913 */ /*GILLT_s64*//*Label 5560*/ GIMT_Encode4(287183),
     /* 286917 */ // Label 5559: @286917
     /* 286917 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(287182),
     /* 286922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286932 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(286971), // Rule ID 4046 //
     /* 286937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286949 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top16Zero),
     /* 286954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286960 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }<<P:Predicate_top16Zero>>:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286969 */     GIR_RootConstrainSelectedInstOperands,
     /* 286970 */     // GIR_Coverage, 4046,
     /* 286970 */     GIR_EraseRootFromParent_Done,
     /* 286971 */   // Label 5563: @286971
     /* 286971 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(287009), // Rule ID 4057 //
     /* 286976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286992 */     // MIs[1] Operand 1
     /* 286992 */     // No operand predicates
     /* 286992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286994 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 286994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 286997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287007 */     GIR_RootConstrainSelectedInstOperands,
     /* 287008 */     // GIR_Coverage, 4057,
     /* 287008 */     GIR_EraseRootFromParent_Done,
     /* 287009 */   // Label 5564: @287009
     /* 287009 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(287050), // Rule ID 3974 //
     /* 287014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287037 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 287040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287048 */     GIR_RootConstrainSelectedInstOperands,
     /* 287049 */     // GIR_Coverage, 3974,
     /* 287049 */     GIR_EraseRootFromParent_Done,
     /* 287050 */   // Label 5565: @287050
     /* 287050 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(287091), // Rule ID 3975 //
     /* 287055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287078 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 287081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287089 */     GIR_RootConstrainSelectedInstOperands,
     /* 287090 */     // GIR_Coverage, 3975,
     /* 287090 */     GIR_EraseRootFromParent_Done,
     /* 287091 */   // Label 5566: @287091
     /* 287091 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(287132), // Rule ID 3973 //
     /* 287096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287119 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 287122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287130 */     GIR_RootConstrainSelectedInstOperands,
     /* 287131 */     // GIR_Coverage, 3973,
     /* 287131 */     GIR_EraseRootFromParent_Done,
     /* 287132 */   // Label 5567: @287132
     /* 287132 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(287181), // Rule ID 3972 //
     /* 287137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287141 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287153 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 287172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287179 */     GIR_RootConstrainSelectedInstOperands,
     /* 287180 */     // GIR_Coverage, 3972,
     /* 287180 */     GIR_EraseRootFromParent_Done,
     /* 287181 */   // Label 5568: @287181
     /* 287181 */   GIM_Reject,
     /* 287182 */ // Label 5562: @287182
     /* 287182 */ GIM_Reject,
     /* 287183 */ // Label 5560: @287183
     /* 287183 */ GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(287440),
     /* 287188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287198 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(287237), // Rule ID 4047 //
     /* 287203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 287211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287215 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /* 287220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 287224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287226 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 287226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 287229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287235 */     GIR_RootConstrainSelectedInstOperands,
     /* 287236 */     // GIR_Coverage, 4047,
     /* 287236 */     GIR_EraseRootFromParent_Done,
     /* 287237 */   // Label 5570: @287237
     /* 287237 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(287275), // Rule ID 4058 //
     /* 287242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287258 */     // MIs[1] Operand 1
     /* 287258 */     // No operand predicates
     /* 287258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287260 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 287260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 287263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 287273 */     GIR_RootConstrainSelectedInstOperands,
     /* 287274 */     // GIR_Coverage, 4058,
     /* 287274 */     GIR_EraseRootFromParent_Done,
     /* 287275 */   // Label 5571: @287275
     /* 287275 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(287347), // Rule ID 3976 //
     /* 287280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287303 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287345 */     GIR_RootConstrainSelectedInstOperands,
     /* 287346 */     // GIR_Coverage, 3976,
     /* 287346 */     GIR_EraseRootFromParent_Done,
     /* 287347 */   // Label 5572: @287347
     /* 287347 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(287419), // Rule ID 3977 //
     /* 287352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287375 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287387 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287417 */     GIR_RootConstrainSelectedInstOperands,
     /* 287418 */     // GIR_Coverage, 3977,
     /* 287418 */     GIR_EraseRootFromParent_Done,
     /* 287419 */   // Label 5573: @287419
     /* 287419 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(287439), // Rule ID 121 //
     /* 287424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287432 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287437 */     GIR_RootConstrainSelectedInstOperands,
     /* 287438 */     // GIR_Coverage, 121,
     /* 287438 */     GIR_Done,
     /* 287439 */   // Label 5574: @287439
     /* 287439 */   GIM_Reject,
     /* 287440 */ // Label 5569: @287440
     /* 287440 */ GIM_Reject,
     /* 287441 */ // Label 5561: @287441
     /* 287441 */ GIM_Reject,
     /* 287442 */ // Label 48: @287442
     /* 287442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5577*/ GIMT_Encode4(288266),
     /* 287453 */ /*GILLT_s32*//*Label 5575*/ GIMT_Encode4(287461),
     /* 287457 */ /*GILLT_s64*//*Label 5576*/ GIMT_Encode4(287816),
     /* 287461 */ // Label 5575: @287461
     /* 287461 */ GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(287815),
     /* 287466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287476 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(287540), // Rule ID 6593 //
     /* 287481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287498 */     // MIs[1] Operand 2
     /* 287498 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287517 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287521 */     // MIs[2] Operand 1
     /* 287521 */     // No operand predicates
     /* 287521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287523 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287538 */     GIR_RootConstrainSelectedInstOperands,
     /* 287539 */     // GIR_Coverage, 6593,
     /* 287539 */     GIR_EraseRootFromParent_Done,
     /* 287540 */   // Label 5579: @287540
     /* 287540 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(287604), // Rule ID 6595 //
     /* 287545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287562 */     // MIs[1] Operand 2
     /* 287562 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287585 */     // MIs[2] Operand 1
     /* 287585 */     // No operand predicates
     /* 287585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287587 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287602 */     GIR_RootConstrainSelectedInstOperands,
     /* 287603 */     // GIR_Coverage, 6595,
     /* 287603 */     GIR_EraseRootFromParent_Done,
     /* 287604 */   // Label 5580: @287604
     /* 287604 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(287642), // Rule ID 4055 //
     /* 287609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287625 */     // MIs[1] Operand 1
     /* 287625 */     // No operand predicates
     /* 287625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287627 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287640 */     GIR_RootConstrainSelectedInstOperands,
     /* 287641 */     // GIR_Coverage, 4055,
     /* 287641 */     GIR_EraseRootFromParent_Done,
     /* 287642 */   // Label 5581: @287642
     /* 287642 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(287683), // Rule ID 2442 //
     /* 287647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287670 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287681 */     GIR_RootConstrainSelectedInstOperands,
     /* 287682 */     // GIR_Coverage, 2442,
     /* 287682 */     GIR_EraseRootFromParent_Done,
     /* 287683 */   // Label 5582: @287683
     /* 287683 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(287724), // Rule ID 2443 //
     /* 287688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287711 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287722 */     GIR_RootConstrainSelectedInstOperands,
     /* 287723 */     // GIR_Coverage, 2443,
     /* 287723 */     GIR_EraseRootFromParent_Done,
     /* 287724 */   // Label 5583: @287724
     /* 287724 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(287765), // Rule ID 2441 //
     /* 287729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287752 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287763 */     GIR_RootConstrainSelectedInstOperands,
     /* 287764 */     // GIR_Coverage, 2441,
     /* 287764 */     GIR_EraseRootFromParent_Done,
     /* 287765 */   // Label 5584: @287765
     /* 287765 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(287814), // Rule ID 2440 //
     /* 287770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287774 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287786 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287812 */     GIR_RootConstrainSelectedInstOperands,
     /* 287813 */     // GIR_Coverage, 2440,
     /* 287813 */     GIR_EraseRootFromParent_Done,
     /* 287814 */   // Label 5585: @287814
     /* 287814 */   GIM_Reject,
     /* 287815 */ // Label 5578: @287815
     /* 287815 */ GIM_Reject,
     /* 287816 */ // Label 5576: @287816
     /* 287816 */ GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(288265),
     /* 287821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287831 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(287895), // Rule ID 6594 //
     /* 287836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287853 */     // MIs[1] Operand 2
     /* 287853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287876 */     // MIs[2] Operand 1
     /* 287876 */     // No operand predicates
     /* 287876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287878 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287893 */     GIR_RootConstrainSelectedInstOperands,
     /* 287894 */     // GIR_Coverage, 6594,
     /* 287894 */     GIR_EraseRootFromParent_Done,
     /* 287895 */   // Label 5587: @287895
     /* 287895 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(287959), // Rule ID 6596 //
     /* 287900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287917 */     // MIs[1] Operand 2
     /* 287917 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287936 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287940 */     // MIs[2] Operand 1
     /* 287940 */     // No operand predicates
     /* 287940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287942 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287957 */     GIR_RootConstrainSelectedInstOperands,
     /* 287958 */     // GIR_Coverage, 6596,
     /* 287958 */     GIR_EraseRootFromParent_Done,
     /* 287959 */   // Label 5588: @287959
     /* 287959 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(288062), // Rule ID 6597 //
     /* 287964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287993 */     // MIs[2] Operand 1
     /* 287993 */     // No operand predicates
     /* 287993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287995 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 287998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 288049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 288057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 288060 */     GIR_RootConstrainSelectedInstOperands,
     /* 288061 */     // GIR_Coverage, 6597,
     /* 288061 */     GIR_EraseRootFromParent_Done,
     /* 288062 */   // Label 5589: @288062
     /* 288062 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(288100), // Rule ID 4056 //
     /* 288067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288083 */     // MIs[1] Operand 1
     /* 288083 */     // No operand predicates
     /* 288083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288085 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 288085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 288088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 288098 */     GIR_RootConstrainSelectedInstOperands,
     /* 288099 */     // GIR_Coverage, 4056,
     /* 288099 */     GIR_EraseRootFromParent_Done,
     /* 288100 */   // Label 5590: @288100
     /* 288100 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(288172), // Rule ID 2444 //
     /* 288105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288128 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 288163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288170 */     GIR_RootConstrainSelectedInstOperands,
     /* 288171 */     // GIR_Coverage, 2444,
     /* 288171 */     GIR_EraseRootFromParent_Done,
     /* 288172 */   // Label 5591: @288172
     /* 288172 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(288244), // Rule ID 2445 //
     /* 288177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288200 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 288235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288242 */     GIR_RootConstrainSelectedInstOperands,
     /* 288243 */     // GIR_Coverage, 2445,
     /* 288243 */     GIR_EraseRootFromParent_Done,
     /* 288244 */   // Label 5592: @288244
     /* 288244 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(288264), // Rule ID 119 //
     /* 288249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288257 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 288262 */     GIR_RootConstrainSelectedInstOperands,
     /* 288263 */     // GIR_Coverage, 119,
     /* 288263 */     GIR_Done,
     /* 288264 */   // Label 5593: @288264
     /* 288264 */   GIM_Reject,
     /* 288265 */ // Label 5586: @288265
     /* 288265 */ GIM_Reject,
     /* 288266 */ // Label 5577: @288266
     /* 288266 */ GIM_Reject,
     /* 288267 */ // Label 49: @288267
     /* 288267 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5596*/ GIMT_Encode4(288396),
     /* 288278 */ /*GILLT_s32*//*Label 5594*/ GIMT_Encode4(288286),
     /* 288282 */ /*GILLT_s64*//*Label 5595*/ GIMT_Encode4(288341),
     /* 288286 */ // Label 5594: @288286
     /* 288286 */ GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288340), // Rule ID 192 //
     /* 288291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 288297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288320 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288324 */   // MIs[1] Operand 1
     /* 288324 */   // No operand predicates
     /* 288324 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288326 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 288326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 288329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288331 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288333 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288335 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288338 */   GIR_RootConstrainSelectedInstOperands,
     /* 288339 */   // GIR_Coverage, 192,
     /* 288339 */   GIR_EraseRootFromParent_Done,
     /* 288340 */ // Label 5597: @288340
     /* 288340 */ GIM_Reject,
     /* 288341 */ // Label 5595: @288341
     /* 288341 */ GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(288395), // Rule ID 193 //
     /* 288346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288375 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288379 */   // MIs[1] Operand 1
     /* 288379 */   // No operand predicates
     /* 288379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288381 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 288381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288386 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288388 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288390 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288393 */   GIR_RootConstrainSelectedInstOperands,
     /* 288394 */   // GIR_Coverage, 193,
     /* 288394 */   GIR_EraseRootFromParent_Done,
     /* 288395 */ // Label 5598: @288395
     /* 288395 */ GIM_Reject,
     /* 288396 */ // Label 5596: @288396
     /* 288396 */ GIM_Reject,
     /* 288397 */ // Label 50: @288397
     /* 288397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5601*/ GIMT_Encode4(288938),
     /* 288408 */ /*GILLT_s32*//*Label 5599*/ GIMT_Encode4(288416),
     /* 288412 */ /*GILLT_s64*//*Label 5600*/ GIMT_Encode4(288681),
     /* 288416 */ // Label 5599: @288416
     /* 288416 */ GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(288680),
     /* 288421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288431 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(288470), // Rule ID 188 //
     /* 288436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 288457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288459 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 288459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 288462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288468 */     GIR_RootConstrainSelectedInstOperands,
     /* 288469 */     // GIR_Coverage, 188,
     /* 288469 */     GIR_EraseRootFromParent_Done,
     /* 288470 */   // Label 5603: @288470
     /* 288470 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(288507), // Rule ID 4051 //
     /* 288475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288491 */     // MIs[1] Operand 1
     /* 288491 */     // No operand predicates
     /* 288491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288493 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 288493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 288496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288505 */     GIR_RootConstrainSelectedInstOperands,
     /* 288506 */     // GIR_Coverage, 4051,
     /* 288506 */     GIR_EraseRootFromParent_Done,
     /* 288507 */   // Label 5604: @288507
     /* 288507 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(288548), // Rule ID 3980 //
     /* 288512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288535 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288546 */     GIR_RootConstrainSelectedInstOperands,
     /* 288547 */     // GIR_Coverage, 3980,
     /* 288547 */     GIR_EraseRootFromParent_Done,
     /* 288548 */   // Label 5605: @288548
     /* 288548 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(288589), // Rule ID 3981 //
     /* 288553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288576 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288587 */     GIR_RootConstrainSelectedInstOperands,
     /* 288588 */     // GIR_Coverage, 3981,
     /* 288588 */     GIR_EraseRootFromParent_Done,
     /* 288589 */   // Label 5606: @288589
     /* 288589 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(288630), // Rule ID 3979 //
     /* 288594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288617 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288628 */     GIR_RootConstrainSelectedInstOperands,
     /* 288629 */     // GIR_Coverage, 3979,
     /* 288629 */     GIR_EraseRootFromParent_Done,
     /* 288630 */   // Label 5607: @288630
     /* 288630 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(288679), // Rule ID 3978 //
     /* 288635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288639 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288677 */     GIR_RootConstrainSelectedInstOperands,
     /* 288678 */     // GIR_Coverage, 3978,
     /* 288678 */     GIR_EraseRootFromParent_Done,
     /* 288679 */   // Label 5608: @288679
     /* 288679 */   GIM_Reject,
     /* 288680 */ // Label 5602: @288680
     /* 288680 */ GIM_Reject,
     /* 288681 */ // Label 5600: @288681
     /* 288681 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(288937),
     /* 288686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288696 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(288735), // Rule ID 191 //
     /* 288701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 288722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288724 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 288724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 288727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288733 */     GIR_RootConstrainSelectedInstOperands,
     /* 288734 */     // GIR_Coverage, 191,
     /* 288734 */     GIR_EraseRootFromParent_Done,
     /* 288735 */   // Label 5610: @288735
     /* 288735 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(288772), // Rule ID 4052 //
     /* 288740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288756 */     // MIs[1] Operand 1
     /* 288756 */     // No operand predicates
     /* 288756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288758 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 288758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288770 */     GIR_RootConstrainSelectedInstOperands,
     /* 288771 */     // GIR_Coverage, 4052,
     /* 288771 */     GIR_EraseRootFromParent_Done,
     /* 288772 */   // Label 5611: @288772
     /* 288772 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(288844), // Rule ID 3982 //
     /* 288777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288800 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288812 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288842 */     GIR_RootConstrainSelectedInstOperands,
     /* 288843 */     // GIR_Coverage, 3982,
     /* 288843 */     GIR_EraseRootFromParent_Done,
     /* 288844 */   // Label 5612: @288844
     /* 288844 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(288916), // Rule ID 3983 //
     /* 288849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288872 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288914 */     GIR_RootConstrainSelectedInstOperands,
     /* 288915 */     // GIR_Coverage, 3983,
     /* 288915 */     GIR_EraseRootFromParent_Done,
     /* 288916 */   // Label 5613: @288916
     /* 288916 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(288936), // Rule ID 122 //
     /* 288921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288929 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288934 */     GIR_RootConstrainSelectedInstOperands,
     /* 288935 */     // GIR_Coverage, 122,
     /* 288935 */     GIR_Done,
     /* 288936 */   // Label 5614: @288936
     /* 288936 */   GIM_Reject,
     /* 288937 */ // Label 5609: @288937
     /* 288937 */ GIM_Reject,
     /* 288938 */ // Label 5601: @288938
     /* 288938 */ GIM_Reject,
     /* 288939 */ // Label 51: @288939
     /* 288939 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5623*/ GIMT_Encode4(296715),
     /* 288950 */ /*GILLT_s64*//*Label 5615*/ GIMT_Encode4(288986), GIMT_Encode4(0),
     /* 288958 */ /*GILLT_v2s32*//*Label 5616*/ GIMT_Encode4(289379),
     /* 288962 */ /*GILLT_v2s64*//*Label 5617*/ GIMT_Encode4(290427),
     /* 288966 */ /*GILLT_v4s16*//*Label 5618*/ GIMT_Encode4(291475),
     /* 288970 */ /*GILLT_v4s32*//*Label 5619*/ GIMT_Encode4(292523),
     /* 288974 */ /*GILLT_v8s8*//*Label 5620*/ GIMT_Encode4(293571),
     /* 288978 */ /*GILLT_v8s16*//*Label 5621*/ GIMT_Encode4(294619),
     /* 288982 */ /*GILLT_v16s8*//*Label 5622*/ GIMT_Encode4(295667),
     /* 288986 */ // Label 5615: @288986
     /* 288986 */ GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(289378),
     /* 288991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289001 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(289037), // Rule ID 5290 //
     /* 289006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289009 */     // MIs[0] Operand 1
     /* 289009 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289018 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289024 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289028 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 289031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289035 */     GIR_RootConstrainSelectedInstOperands,
     /* 289036 */     // GIR_Coverage, 5290,
     /* 289036 */     GIR_EraseRootFromParent_Done,
     /* 289037 */   // Label 5625: @289037
     /* 289037 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(289073), // Rule ID 5291 //
     /* 289042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289045 */     // MIs[0] Operand 1
     /* 289045 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289054 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289060 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289064 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 289067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289071 */     GIR_RootConstrainSelectedInstOperands,
     /* 289072 */     // GIR_Coverage, 5291,
     /* 289072 */     GIR_EraseRootFromParent_Done,
     /* 289073 */   // Label 5626: @289073
     /* 289073 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(289109), // Rule ID 2512 //
     /* 289078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289081 */     // MIs[0] Operand 1
     /* 289081 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289100 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 289103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289107 */     GIR_RootConstrainSelectedInstOperands,
     /* 289108 */     // GIR_Coverage, 2512,
     /* 289108 */     GIR_EraseRootFromParent_Done,
     /* 289109 */   // Label 5627: @289109
     /* 289109 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(289145), // Rule ID 5287 //
     /* 289114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289117 */     // MIs[0] Operand 1
     /* 289117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289126 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289132 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289136 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 289139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289143 */     GIR_RootConstrainSelectedInstOperands,
     /* 289144 */     // GIR_Coverage, 5287,
     /* 289144 */     GIR_EraseRootFromParent_Done,
     /* 289145 */   // Label 5628: @289145
     /* 289145 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(289181), // Rule ID 5288 //
     /* 289150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289153 */     // MIs[0] Operand 1
     /* 289153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289162 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289172 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 289175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289179 */     GIR_RootConstrainSelectedInstOperands,
     /* 289180 */     // GIR_Coverage, 5288,
     /* 289180 */     GIR_EraseRootFromParent_Done,
     /* 289181 */   // Label 5629: @289181
     /* 289181 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(289217), // Rule ID 5289 //
     /* 289186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289189 */     // MIs[0] Operand 1
     /* 289189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289198 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289204 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289208 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 289208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 289211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289215 */     GIR_RootConstrainSelectedInstOperands,
     /* 289216 */     // GIR_Coverage, 5289,
     /* 289216 */     GIR_EraseRootFromParent_Done,
     /* 289217 */   // Label 5630: @289217
     /* 289217 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(289249), // Rule ID 1612 //
     /* 289222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289225 */     // MIs[0] Operand 1
     /* 289225 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289238 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 289238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 289241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289247 */     GIR_RootConstrainSelectedInstOperands,
     /* 289248 */     // GIR_Coverage, 1612,
     /* 289248 */     GIR_EraseRootFromParent_Done,
     /* 289249 */   // Label 5631: @289249
     /* 289249 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(289281), // Rule ID 1613 //
     /* 289254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289257 */     // MIs[0] Operand 1
     /* 289257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289270 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 289270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 289273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289279 */     GIR_RootConstrainSelectedInstOperands,
     /* 289280 */     // GIR_Coverage, 1613,
     /* 289280 */     GIR_EraseRootFromParent_Done,
     /* 289281 */   // Label 5632: @289281
     /* 289281 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(289313), // Rule ID 1614 //
     /* 289286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289289 */     // MIs[0] Operand 1
     /* 289289 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289302 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 289302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 289305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289311 */     GIR_RootConstrainSelectedInstOperands,
     /* 289312 */     // GIR_Coverage, 1614,
     /* 289312 */     GIR_EraseRootFromParent_Done,
     /* 289313 */   // Label 5633: @289313
     /* 289313 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(289345), // Rule ID 1615 //
     /* 289318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289321 */     // MIs[0] Operand 1
     /* 289321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289334 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 289334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 289337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289343 */     GIR_RootConstrainSelectedInstOperands,
     /* 289344 */     // GIR_Coverage, 1615,
     /* 289344 */     GIR_EraseRootFromParent_Done,
     /* 289345 */   // Label 5634: @289345
     /* 289345 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(289377), // Rule ID 1616 //
     /* 289350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289353 */     // MIs[0] Operand 1
     /* 289353 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289366 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 289366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 289369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289375 */     GIR_RootConstrainSelectedInstOperands,
     /* 289376 */     // GIR_Coverage, 1616,
     /* 289376 */     GIR_EraseRootFromParent_Done,
     /* 289377 */   // Label 5635: @289377
     /* 289377 */   GIM_Reject,
     /* 289378 */ // Label 5624: @289378
     /* 289378 */ GIM_Reject,
     /* 289379 */ // Label 5616: @289379
     /* 289379 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(290426),
     /* 289384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 289387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 289390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289394 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(289434), // Rule ID 758 //
     /* 289399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289402 */     // MIs[0] Operand 1
     /* 289402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289425 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289432 */     GIR_RootConstrainSelectedInstOperands,
     /* 289433 */     // GIR_Coverage, 758,
     /* 289433 */     GIR_EraseRootFromParent_Done,
     /* 289434 */   // Label 5637: @289434
     /* 289434 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(289474), // Rule ID 765 //
     /* 289439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289442 */     // MIs[0] Operand 1
     /* 289442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289465 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289472 */     GIR_RootConstrainSelectedInstOperands,
     /* 289473 */     // GIR_Coverage, 765,
     /* 289473 */     GIR_EraseRootFromParent_Done,
     /* 289474 */   // Label 5638: @289474
     /* 289474 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(289511), // Rule ID 5224 //
     /* 289479 */     // MIs[0] Operand 1
     /* 289479 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289502 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289509 */     GIR_RootConstrainSelectedInstOperands,
     /* 289510 */     // GIR_Coverage, 5224,
     /* 289510 */     GIR_EraseRootFromParent_Done,
     /* 289511 */   // Label 5639: @289511
     /* 289511 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(289548), // Rule ID 5231 //
     /* 289516 */     // MIs[0] Operand 1
     /* 289516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289525 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289531 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289539 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289546 */     GIR_RootConstrainSelectedInstOperands,
     /* 289547 */     // GIR_Coverage, 5231,
     /* 289547 */     GIR_EraseRootFromParent_Done,
     /* 289548 */   // Label 5640: @289548
     /* 289548 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(289585), // Rule ID 5238 //
     /* 289553 */     // MIs[0] Operand 1
     /* 289553 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289576 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289583 */     GIR_RootConstrainSelectedInstOperands,
     /* 289584 */     // GIR_Coverage, 5238,
     /* 289584 */     GIR_EraseRootFromParent_Done,
     /* 289585 */   // Label 5641: @289585
     /* 289585 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(289622), // Rule ID 5245 //
     /* 289590 */     // MIs[0] Operand 1
     /* 289590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289613 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289620 */     GIR_RootConstrainSelectedInstOperands,
     /* 289621 */     // GIR_Coverage, 5245,
     /* 289621 */     GIR_EraseRootFromParent_Done,
     /* 289622 */   // Label 5642: @289622
     /* 289622 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(289659), // Rule ID 5252 //
     /* 289627 */     // MIs[0] Operand 1
     /* 289627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289650 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289657 */     GIR_RootConstrainSelectedInstOperands,
     /* 289658 */     // GIR_Coverage, 5252,
     /* 289658 */     GIR_EraseRootFromParent_Done,
     /* 289659 */   // Label 5643: @289659
     /* 289659 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(289699), // Rule ID 730 //
     /* 289664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289667 */     // MIs[0] Operand 1
     /* 289667 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289680 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289686 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289690 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289697 */     GIR_RootConstrainSelectedInstOperands,
     /* 289698 */     // GIR_Coverage, 730,
     /* 289698 */     GIR_EraseRootFromParent_Done,
     /* 289699 */   // Label 5644: @289699
     /* 289699 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(289739), // Rule ID 741 //
     /* 289704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289707 */     // MIs[0] Operand 1
     /* 289707 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289720 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289726 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289730 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289737 */     GIR_RootConstrainSelectedInstOperands,
     /* 289738 */     // GIR_Coverage, 741,
     /* 289738 */     GIR_EraseRootFromParent_Done,
     /* 289739 */   // Label 5645: @289739
     /* 289739 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(289779), // Rule ID 742 //
     /* 289744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289747 */     // MIs[0] Operand 1
     /* 289747 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289770 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289777 */     GIR_RootConstrainSelectedInstOperands,
     /* 289778 */     // GIR_Coverage, 742,
     /* 289778 */     GIR_EraseRootFromParent_Done,
     /* 289779 */   // Label 5646: @289779
     /* 289779 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(289819), // Rule ID 751 //
     /* 289784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289787 */     // MIs[0] Operand 1
     /* 289787 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289800 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289810 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289817 */     GIR_RootConstrainSelectedInstOperands,
     /* 289818 */     // GIR_Coverage, 751,
     /* 289818 */     GIR_EraseRootFromParent_Done,
     /* 289819 */   // Label 5647: @289819
     /* 289819 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(289856), // Rule ID 5189 //
     /* 289824 */     // MIs[0] Operand 1
     /* 289824 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289837 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289843 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289847 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289854 */     GIR_RootConstrainSelectedInstOperands,
     /* 289855 */     // GIR_Coverage, 5189,
     /* 289855 */     GIR_EraseRootFromParent_Done,
     /* 289856 */   // Label 5648: @289856
     /* 289856 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(289893), // Rule ID 5196 //
     /* 289861 */     // MIs[0] Operand 1
     /* 289861 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289874 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289880 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289884 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289891 */     GIR_RootConstrainSelectedInstOperands,
     /* 289892 */     // GIR_Coverage, 5196,
     /* 289892 */     GIR_EraseRootFromParent_Done,
     /* 289893 */   // Label 5649: @289893
     /* 289893 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(289930), // Rule ID 5203 //
     /* 289898 */     // MIs[0] Operand 1
     /* 289898 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289911 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289917 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289921 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289928 */     GIR_RootConstrainSelectedInstOperands,
     /* 289929 */     // GIR_Coverage, 5203,
     /* 289929 */     GIR_EraseRootFromParent_Done,
     /* 289930 */   // Label 5650: @289930
     /* 289930 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(289967), // Rule ID 5210 //
     /* 289935 */     // MIs[0] Operand 1
     /* 289935 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289954 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289958 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289965 */     GIR_RootConstrainSelectedInstOperands,
     /* 289966 */     // GIR_Coverage, 5210,
     /* 289966 */     GIR_EraseRootFromParent_Done,
     /* 289967 */   // Label 5651: @289967
     /* 289967 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(290004), // Rule ID 5217 //
     /* 289972 */     // MIs[0] Operand 1
     /* 289972 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289985 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289991 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289995 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290002 */     GIR_RootConstrainSelectedInstOperands,
     /* 290003 */     // GIR_Coverage, 5217,
     /* 290003 */     GIR_EraseRootFromParent_Done,
     /* 290004 */   // Label 5652: @290004
     /* 290004 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(290036), // Rule ID 1129 //
     /* 290009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290012 */     // MIs[0] Operand 1
     /* 290012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290025 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 290028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290034 */     GIR_RootConstrainSelectedInstOperands,
     /* 290035 */     // GIR_Coverage, 1129,
     /* 290035 */     GIR_EraseRootFromParent_Done,
     /* 290036 */   // Label 5653: @290036
     /* 290036 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(290068), // Rule ID 1136 //
     /* 290041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290044 */     // MIs[0] Operand 1
     /* 290044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290057 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 290060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290066 */     GIR_RootConstrainSelectedInstOperands,
     /* 290067 */     // GIR_Coverage, 1136,
     /* 290067 */     GIR_EraseRootFromParent_Done,
     /* 290068 */   // Label 5654: @290068
     /* 290068 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(290100), // Rule ID 1143 //
     /* 290073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290076 */     // MIs[0] Operand 1
     /* 290076 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290089 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 290092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290098 */     GIR_RootConstrainSelectedInstOperands,
     /* 290099 */     // GIR_Coverage, 1143,
     /* 290099 */     GIR_EraseRootFromParent_Done,
     /* 290100 */   // Label 5655: @290100
     /* 290100 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(290132), // Rule ID 1150 //
     /* 290105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290108 */     // MIs[0] Operand 1
     /* 290108 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290121 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 290124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290130 */     GIR_RootConstrainSelectedInstOperands,
     /* 290131 */     // GIR_Coverage, 1150,
     /* 290131 */     GIR_EraseRootFromParent_Done,
     /* 290132 */   // Label 5656: @290132
     /* 290132 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(290164), // Rule ID 1157 //
     /* 290137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290140 */     // MIs[0] Operand 1
     /* 290140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290153 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 290156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290162 */     GIR_RootConstrainSelectedInstOperands,
     /* 290163 */     // GIR_Coverage, 1157,
     /* 290163 */     GIR_EraseRootFromParent_Done,
     /* 290164 */   // Label 5657: @290164
     /* 290164 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(290193), // Rule ID 5126 //
     /* 290169 */     // MIs[0] Operand 1
     /* 290169 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290182 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 290185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290191 */     GIR_RootConstrainSelectedInstOperands,
     /* 290192 */     // GIR_Coverage, 5126,
     /* 290192 */     GIR_EraseRootFromParent_Done,
     /* 290193 */   // Label 5658: @290193
     /* 290193 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290222), // Rule ID 5133 //
     /* 290198 */     // MIs[0] Operand 1
     /* 290198 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290211 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 290214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290220 */     GIR_RootConstrainSelectedInstOperands,
     /* 290221 */     // GIR_Coverage, 5133,
     /* 290221 */     GIR_EraseRootFromParent_Done,
     /* 290222 */   // Label 5659: @290222
     /* 290222 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(290251), // Rule ID 5140 //
     /* 290227 */     // MIs[0] Operand 1
     /* 290227 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290240 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 290243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290249 */     GIR_RootConstrainSelectedInstOperands,
     /* 290250 */     // GIR_Coverage, 5140,
     /* 290250 */     GIR_EraseRootFromParent_Done,
     /* 290251 */   // Label 5660: @290251
     /* 290251 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(290280), // Rule ID 5147 //
     /* 290256 */     // MIs[0] Operand 1
     /* 290256 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290269 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 290272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290278 */     GIR_RootConstrainSelectedInstOperands,
     /* 290279 */     // GIR_Coverage, 5147,
     /* 290279 */     GIR_EraseRootFromParent_Done,
     /* 290280 */   // Label 5661: @290280
     /* 290280 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(290309), // Rule ID 5154 //
     /* 290285 */     // MIs[0] Operand 1
     /* 290285 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290298 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 290298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 290301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290307 */     GIR_RootConstrainSelectedInstOperands,
     /* 290308 */     // GIR_Coverage, 5154,
     /* 290308 */     GIR_EraseRootFromParent_Done,
     /* 290309 */   // Label 5662: @290309
     /* 290309 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(290338), // Rule ID 5161 //
     /* 290314 */     // MIs[0] Operand 1
     /* 290314 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290327 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 290330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290336 */     GIR_RootConstrainSelectedInstOperands,
     /* 290337 */     // GIR_Coverage, 5161,
     /* 290337 */     GIR_EraseRootFromParent_Done,
     /* 290338 */   // Label 5663: @290338
     /* 290338 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(290367), // Rule ID 5168 //
     /* 290343 */     // MIs[0] Operand 1
     /* 290343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290356 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 290359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290365 */     GIR_RootConstrainSelectedInstOperands,
     /* 290366 */     // GIR_Coverage, 5168,
     /* 290366 */     GIR_EraseRootFromParent_Done,
     /* 290367 */   // Label 5664: @290367
     /* 290367 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(290396), // Rule ID 5175 //
     /* 290372 */     // MIs[0] Operand 1
     /* 290372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290385 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 290388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290394 */     GIR_RootConstrainSelectedInstOperands,
     /* 290395 */     // GIR_Coverage, 5175,
     /* 290395 */     GIR_EraseRootFromParent_Done,
     /* 290396 */   // Label 5665: @290396
     /* 290396 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(290425), // Rule ID 5182 //
     /* 290401 */     // MIs[0] Operand 1
     /* 290401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290414 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 290417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290423 */     GIR_RootConstrainSelectedInstOperands,
     /* 290424 */     // GIR_Coverage, 5182,
     /* 290424 */     GIR_EraseRootFromParent_Done,
     /* 290425 */   // Label 5666: @290425
     /* 290425 */   GIM_Reject,
     /* 290426 */ // Label 5636: @290426
     /* 290426 */ GIM_Reject,
     /* 290427 */ // Label 5617: @290427
     /* 290427 */ GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(291474),
     /* 290432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 290438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290442 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(290482), // Rule ID 760 //
     /* 290447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290450 */     // MIs[0] Operand 1
     /* 290450 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290465 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290473 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290480 */     GIR_RootConstrainSelectedInstOperands,
     /* 290481 */     // GIR_Coverage, 760,
     /* 290481 */     GIR_EraseRootFromParent_Done,
     /* 290482 */   // Label 5668: @290482
     /* 290482 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(290522), // Rule ID 767 //
     /* 290487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290490 */     // MIs[0] Operand 1
     /* 290490 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290513 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290520 */     GIR_RootConstrainSelectedInstOperands,
     /* 290521 */     // GIR_Coverage, 767,
     /* 290521 */     GIR_EraseRootFromParent_Done,
     /* 290522 */   // Label 5669: @290522
     /* 290522 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(290559), // Rule ID 5226 //
     /* 290527 */     // MIs[0] Operand 1
     /* 290527 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290536 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290542 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290550 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290557 */     GIR_RootConstrainSelectedInstOperands,
     /* 290558 */     // GIR_Coverage, 5226,
     /* 290558 */     GIR_EraseRootFromParent_Done,
     /* 290559 */   // Label 5670: @290559
     /* 290559 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(290596), // Rule ID 5233 //
     /* 290564 */     // MIs[0] Operand 1
     /* 290564 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290573 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290579 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290587 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290594 */     GIR_RootConstrainSelectedInstOperands,
     /* 290595 */     // GIR_Coverage, 5233,
     /* 290595 */     GIR_EraseRootFromParent_Done,
     /* 290596 */   // Label 5671: @290596
     /* 290596 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(290633), // Rule ID 5240 //
     /* 290601 */     // MIs[0] Operand 1
     /* 290601 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290610 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290616 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290624 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290631 */     GIR_RootConstrainSelectedInstOperands,
     /* 290632 */     // GIR_Coverage, 5240,
     /* 290632 */     GIR_EraseRootFromParent_Done,
     /* 290633 */   // Label 5672: @290633
     /* 290633 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(290670), // Rule ID 5247 //
     /* 290638 */     // MIs[0] Operand 1
     /* 290638 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290653 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290661 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290668 */     GIR_RootConstrainSelectedInstOperands,
     /* 290669 */     // GIR_Coverage, 5247,
     /* 290669 */     GIR_EraseRootFromParent_Done,
     /* 290670 */   // Label 5673: @290670
     /* 290670 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(290707), // Rule ID 5254 //
     /* 290675 */     // MIs[0] Operand 1
     /* 290675 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290684 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290698 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290705 */     GIR_RootConstrainSelectedInstOperands,
     /* 290706 */     // GIR_Coverage, 5254,
     /* 290706 */     GIR_EraseRootFromParent_Done,
     /* 290707 */   // Label 5674: @290707
     /* 290707 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(290747), // Rule ID 732 //
     /* 290712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290715 */     // MIs[0] Operand 1
     /* 290715 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290728 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290734 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290738 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290745 */     GIR_RootConstrainSelectedInstOperands,
     /* 290746 */     // GIR_Coverage, 732,
     /* 290746 */     GIR_EraseRootFromParent_Done,
     /* 290747 */   // Label 5675: @290747
     /* 290747 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(290787), // Rule ID 745 //
     /* 290752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290755 */     // MIs[0] Operand 1
     /* 290755 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290768 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290774 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290778 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290785 */     GIR_RootConstrainSelectedInstOperands,
     /* 290786 */     // GIR_Coverage, 745,
     /* 290786 */     GIR_EraseRootFromParent_Done,
     /* 290787 */   // Label 5676: @290787
     /* 290787 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(290827), // Rule ID 746 //
     /* 290792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290795 */     // MIs[0] Operand 1
     /* 290795 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290808 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290818 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290825 */     GIR_RootConstrainSelectedInstOperands,
     /* 290826 */     // GIR_Coverage, 746,
     /* 290826 */     GIR_EraseRootFromParent_Done,
     /* 290827 */   // Label 5677: @290827
     /* 290827 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(290867), // Rule ID 753 //
     /* 290832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290835 */     // MIs[0] Operand 1
     /* 290835 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290858 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290865 */     GIR_RootConstrainSelectedInstOperands,
     /* 290866 */     // GIR_Coverage, 753,
     /* 290866 */     GIR_EraseRootFromParent_Done,
     /* 290867 */   // Label 5678: @290867
     /* 290867 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(290904), // Rule ID 5191 //
     /* 290872 */     // MIs[0] Operand 1
     /* 290872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290885 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290891 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290895 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290902 */     GIR_RootConstrainSelectedInstOperands,
     /* 290903 */     // GIR_Coverage, 5191,
     /* 290903 */     GIR_EraseRootFromParent_Done,
     /* 290904 */   // Label 5679: @290904
     /* 290904 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(290941), // Rule ID 5198 //
     /* 290909 */     // MIs[0] Operand 1
     /* 290909 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290922 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290928 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290932 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290939 */     GIR_RootConstrainSelectedInstOperands,
     /* 290940 */     // GIR_Coverage, 5198,
     /* 290940 */     GIR_EraseRootFromParent_Done,
     /* 290941 */   // Label 5680: @290941
     /* 290941 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(290978), // Rule ID 5205 //
     /* 290946 */     // MIs[0] Operand 1
     /* 290946 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290959 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290965 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290969 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290976 */     GIR_RootConstrainSelectedInstOperands,
     /* 290977 */     // GIR_Coverage, 5205,
     /* 290977 */     GIR_EraseRootFromParent_Done,
     /* 290978 */   // Label 5681: @290978
     /* 290978 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(291015), // Rule ID 5212 //
     /* 290983 */     // MIs[0] Operand 1
     /* 290983 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290996 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291002 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291006 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 291006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 291009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291013 */     GIR_RootConstrainSelectedInstOperands,
     /* 291014 */     // GIR_Coverage, 5212,
     /* 291014 */     GIR_EraseRootFromParent_Done,
     /* 291015 */   // Label 5682: @291015
     /* 291015 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(291052), // Rule ID 5219 //
     /* 291020 */     // MIs[0] Operand 1
     /* 291020 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291043 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 291043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 291046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291050 */     GIR_RootConstrainSelectedInstOperands,
     /* 291051 */     // GIR_Coverage, 5219,
     /* 291051 */     GIR_EraseRootFromParent_Done,
     /* 291052 */   // Label 5683: @291052
     /* 291052 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(291084), // Rule ID 1131 //
     /* 291057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291060 */     // MIs[0] Operand 1
     /* 291060 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291073 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 291076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291082 */     GIR_RootConstrainSelectedInstOperands,
     /* 291083 */     // GIR_Coverage, 1131,
     /* 291083 */     GIR_EraseRootFromParent_Done,
     /* 291084 */   // Label 5684: @291084
     /* 291084 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(291116), // Rule ID 1138 //
     /* 291089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291092 */     // MIs[0] Operand 1
     /* 291092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291105 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 291108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291114 */     GIR_RootConstrainSelectedInstOperands,
     /* 291115 */     // GIR_Coverage, 1138,
     /* 291115 */     GIR_EraseRootFromParent_Done,
     /* 291116 */   // Label 5685: @291116
     /* 291116 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(291148), // Rule ID 1145 //
     /* 291121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291124 */     // MIs[0] Operand 1
     /* 291124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291137 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 291140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291146 */     GIR_RootConstrainSelectedInstOperands,
     /* 291147 */     // GIR_Coverage, 1145,
     /* 291147 */     GIR_EraseRootFromParent_Done,
     /* 291148 */   // Label 5686: @291148
     /* 291148 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(291180), // Rule ID 1152 //
     /* 291153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291156 */     // MIs[0] Operand 1
     /* 291156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291169 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 291172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291178 */     GIR_RootConstrainSelectedInstOperands,
     /* 291179 */     // GIR_Coverage, 1152,
     /* 291179 */     GIR_EraseRootFromParent_Done,
     /* 291180 */   // Label 5687: @291180
     /* 291180 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(291212), // Rule ID 1159 //
     /* 291185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291188 */     // MIs[0] Operand 1
     /* 291188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291201 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 291204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291210 */     GIR_RootConstrainSelectedInstOperands,
     /* 291211 */     // GIR_Coverage, 1159,
     /* 291211 */     GIR_EraseRootFromParent_Done,
     /* 291212 */   // Label 5688: @291212
     /* 291212 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291241), // Rule ID 5128 //
     /* 291217 */     // MIs[0] Operand 1
     /* 291217 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291230 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 291233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291239 */     GIR_RootConstrainSelectedInstOperands,
     /* 291240 */     // GIR_Coverage, 5128,
     /* 291240 */     GIR_EraseRootFromParent_Done,
     /* 291241 */   // Label 5689: @291241
     /* 291241 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(291270), // Rule ID 5135 //
     /* 291246 */     // MIs[0] Operand 1
     /* 291246 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291259 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 291262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291268 */     GIR_RootConstrainSelectedInstOperands,
     /* 291269 */     // GIR_Coverage, 5135,
     /* 291269 */     GIR_EraseRootFromParent_Done,
     /* 291270 */   // Label 5690: @291270
     /* 291270 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(291299), // Rule ID 5142 //
     /* 291275 */     // MIs[0] Operand 1
     /* 291275 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291288 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 291291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291297 */     GIR_RootConstrainSelectedInstOperands,
     /* 291298 */     // GIR_Coverage, 5142,
     /* 291298 */     GIR_EraseRootFromParent_Done,
     /* 291299 */   // Label 5691: @291299
     /* 291299 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(291328), // Rule ID 5149 //
     /* 291304 */     // MIs[0] Operand 1
     /* 291304 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291317 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 291320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291326 */     GIR_RootConstrainSelectedInstOperands,
     /* 291327 */     // GIR_Coverage, 5149,
     /* 291327 */     GIR_EraseRootFromParent_Done,
     /* 291328 */   // Label 5692: @291328
     /* 291328 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(291357), // Rule ID 5156 //
     /* 291333 */     // MIs[0] Operand 1
     /* 291333 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291346 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 291346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 291349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291355 */     GIR_RootConstrainSelectedInstOperands,
     /* 291356 */     // GIR_Coverage, 5156,
     /* 291356 */     GIR_EraseRootFromParent_Done,
     /* 291357 */   // Label 5693: @291357
     /* 291357 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(291386), // Rule ID 5163 //
     /* 291362 */     // MIs[0] Operand 1
     /* 291362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291375 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 291378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291384 */     GIR_RootConstrainSelectedInstOperands,
     /* 291385 */     // GIR_Coverage, 5163,
     /* 291385 */     GIR_EraseRootFromParent_Done,
     /* 291386 */   // Label 5694: @291386
     /* 291386 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(291415), // Rule ID 5170 //
     /* 291391 */     // MIs[0] Operand 1
     /* 291391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291404 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 291407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291413 */     GIR_RootConstrainSelectedInstOperands,
     /* 291414 */     // GIR_Coverage, 5170,
     /* 291414 */     GIR_EraseRootFromParent_Done,
     /* 291415 */   // Label 5695: @291415
     /* 291415 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(291444), // Rule ID 5177 //
     /* 291420 */     // MIs[0] Operand 1
     /* 291420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291433 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 291436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291442 */     GIR_RootConstrainSelectedInstOperands,
     /* 291443 */     // GIR_Coverage, 5177,
     /* 291443 */     GIR_EraseRootFromParent_Done,
     /* 291444 */   // Label 5696: @291444
     /* 291444 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(291473), // Rule ID 5184 //
     /* 291449 */     // MIs[0] Operand 1
     /* 291449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291462 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 291465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291471 */     GIR_RootConstrainSelectedInstOperands,
     /* 291472 */     // GIR_Coverage, 5184,
     /* 291472 */     GIR_EraseRootFromParent_Done,
     /* 291473 */   // Label 5697: @291473
     /* 291473 */   GIM_Reject,
     /* 291474 */ // Label 5667: @291474
     /* 291474 */ GIM_Reject,
     /* 291475 */ // Label 5618: @291475
     /* 291475 */ GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(292522),
     /* 291480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291490 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(291530), // Rule ID 756 //
     /* 291495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291498 */     // MIs[0] Operand 1
     /* 291498 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291513 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291521 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291528 */     GIR_RootConstrainSelectedInstOperands,
     /* 291529 */     // GIR_Coverage, 756,
     /* 291529 */     GIR_EraseRootFromParent_Done,
     /* 291530 */   // Label 5699: @291530
     /* 291530 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(291570), // Rule ID 763 //
     /* 291535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291538 */     // MIs[0] Operand 1
     /* 291538 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291561 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291568 */     GIR_RootConstrainSelectedInstOperands,
     /* 291569 */     // GIR_Coverage, 763,
     /* 291569 */     GIR_EraseRootFromParent_Done,
     /* 291570 */   // Label 5700: @291570
     /* 291570 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(291607), // Rule ID 5222 //
     /* 291575 */     // MIs[0] Operand 1
     /* 291575 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291584 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291590 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291598 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291605 */     GIR_RootConstrainSelectedInstOperands,
     /* 291606 */     // GIR_Coverage, 5222,
     /* 291606 */     GIR_EraseRootFromParent_Done,
     /* 291607 */   // Label 5701: @291607
     /* 291607 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(291644), // Rule ID 5229 //
     /* 291612 */     // MIs[0] Operand 1
     /* 291612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291621 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291627 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291635 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291642 */     GIR_RootConstrainSelectedInstOperands,
     /* 291643 */     // GIR_Coverage, 5229,
     /* 291643 */     GIR_EraseRootFromParent_Done,
     /* 291644 */   // Label 5702: @291644
     /* 291644 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(291681), // Rule ID 5236 //
     /* 291649 */     // MIs[0] Operand 1
     /* 291649 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291658 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291664 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291672 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291679 */     GIR_RootConstrainSelectedInstOperands,
     /* 291680 */     // GIR_Coverage, 5236,
     /* 291680 */     GIR_EraseRootFromParent_Done,
     /* 291681 */   // Label 5703: @291681
     /* 291681 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(291718), // Rule ID 5243 //
     /* 291686 */     // MIs[0] Operand 1
     /* 291686 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291709 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291716 */     GIR_RootConstrainSelectedInstOperands,
     /* 291717 */     // GIR_Coverage, 5243,
     /* 291717 */     GIR_EraseRootFromParent_Done,
     /* 291718 */   // Label 5704: @291718
     /* 291718 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(291755), // Rule ID 5250 //
     /* 291723 */     // MIs[0] Operand 1
     /* 291723 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291732 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291738 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291746 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291753 */     GIR_RootConstrainSelectedInstOperands,
     /* 291754 */     // GIR_Coverage, 5250,
     /* 291754 */     GIR_EraseRootFromParent_Done,
     /* 291755 */   // Label 5705: @291755
     /* 291755 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(291795), // Rule ID 728 //
     /* 291760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291763 */     // MIs[0] Operand 1
     /* 291763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291786 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291793 */     GIR_RootConstrainSelectedInstOperands,
     /* 291794 */     // GIR_Coverage, 728,
     /* 291794 */     GIR_EraseRootFromParent_Done,
     /* 291795 */   // Label 5706: @291795
     /* 291795 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(291835), // Rule ID 737 //
     /* 291800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291803 */     // MIs[0] Operand 1
     /* 291803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291816 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291822 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291826 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291833 */     GIR_RootConstrainSelectedInstOperands,
     /* 291834 */     // GIR_Coverage, 737,
     /* 291834 */     GIR_EraseRootFromParent_Done,
     /* 291835 */   // Label 5707: @291835
     /* 291835 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(291875), // Rule ID 738 //
     /* 291840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291843 */     // MIs[0] Operand 1
     /* 291843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291866 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291873 */     GIR_RootConstrainSelectedInstOperands,
     /* 291874 */     // GIR_Coverage, 738,
     /* 291874 */     GIR_EraseRootFromParent_Done,
     /* 291875 */   // Label 5708: @291875
     /* 291875 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(291915), // Rule ID 749 //
     /* 291880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291883 */     // MIs[0] Operand 1
     /* 291883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291896 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291902 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291906 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291913 */     GIR_RootConstrainSelectedInstOperands,
     /* 291914 */     // GIR_Coverage, 749,
     /* 291914 */     GIR_EraseRootFromParent_Done,
     /* 291915 */   // Label 5709: @291915
     /* 291915 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(291952), // Rule ID 5187 //
     /* 291920 */     // MIs[0] Operand 1
     /* 291920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291933 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291939 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291943 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291950 */     GIR_RootConstrainSelectedInstOperands,
     /* 291951 */     // GIR_Coverage, 5187,
     /* 291951 */     GIR_EraseRootFromParent_Done,
     /* 291952 */   // Label 5710: @291952
     /* 291952 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(291989), // Rule ID 5194 //
     /* 291957 */     // MIs[0] Operand 1
     /* 291957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291970 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291976 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291980 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291987 */     GIR_RootConstrainSelectedInstOperands,
     /* 291988 */     // GIR_Coverage, 5194,
     /* 291988 */     GIR_EraseRootFromParent_Done,
     /* 291989 */   // Label 5711: @291989
     /* 291989 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(292026), // Rule ID 5201 //
     /* 291994 */     // MIs[0] Operand 1
     /* 291994 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292013 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292017 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 292017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 292020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292024 */     GIR_RootConstrainSelectedInstOperands,
     /* 292025 */     // GIR_Coverage, 5201,
     /* 292025 */     GIR_EraseRootFromParent_Done,
     /* 292026 */   // Label 5712: @292026
     /* 292026 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(292063), // Rule ID 5208 //
     /* 292031 */     // MIs[0] Operand 1
     /* 292031 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292054 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 292054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 292057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292061 */     GIR_RootConstrainSelectedInstOperands,
     /* 292062 */     // GIR_Coverage, 5208,
     /* 292062 */     GIR_EraseRootFromParent_Done,
     /* 292063 */   // Label 5713: @292063
     /* 292063 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(292100), // Rule ID 5215 //
     /* 292068 */     // MIs[0] Operand 1
     /* 292068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292091 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 292091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 292094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292098 */     GIR_RootConstrainSelectedInstOperands,
     /* 292099 */     // GIR_Coverage, 5215,
     /* 292099 */     GIR_EraseRootFromParent_Done,
     /* 292100 */   // Label 5714: @292100
     /* 292100 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(292132), // Rule ID 1127 //
     /* 292105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292108 */     // MIs[0] Operand 1
     /* 292108 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292121 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 292124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292130 */     GIR_RootConstrainSelectedInstOperands,
     /* 292131 */     // GIR_Coverage, 1127,
     /* 292131 */     GIR_EraseRootFromParent_Done,
     /* 292132 */   // Label 5715: @292132
     /* 292132 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(292164), // Rule ID 1134 //
     /* 292137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292140 */     // MIs[0] Operand 1
     /* 292140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292153 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 292156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292162 */     GIR_RootConstrainSelectedInstOperands,
     /* 292163 */     // GIR_Coverage, 1134,
     /* 292163 */     GIR_EraseRootFromParent_Done,
     /* 292164 */   // Label 5716: @292164
     /* 292164 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(292196), // Rule ID 1141 //
     /* 292169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292172 */     // MIs[0] Operand 1
     /* 292172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292185 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292194 */     GIR_RootConstrainSelectedInstOperands,
     /* 292195 */     // GIR_Coverage, 1141,
     /* 292195 */     GIR_EraseRootFromParent_Done,
     /* 292196 */   // Label 5717: @292196
     /* 292196 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292228), // Rule ID 1148 //
     /* 292201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292204 */     // MIs[0] Operand 1
     /* 292204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292217 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 292220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292226 */     GIR_RootConstrainSelectedInstOperands,
     /* 292227 */     // GIR_Coverage, 1148,
     /* 292227 */     GIR_EraseRootFromParent_Done,
     /* 292228 */   // Label 5718: @292228
     /* 292228 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(292260), // Rule ID 1155 //
     /* 292233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292236 */     // MIs[0] Operand 1
     /* 292236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292249 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292258 */     GIR_RootConstrainSelectedInstOperands,
     /* 292259 */     // GIR_Coverage, 1155,
     /* 292259 */     GIR_EraseRootFromParent_Done,
     /* 292260 */   // Label 5719: @292260
     /* 292260 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(292289), // Rule ID 5124 //
     /* 292265 */     // MIs[0] Operand 1
     /* 292265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292278 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 292281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292287 */     GIR_RootConstrainSelectedInstOperands,
     /* 292288 */     // GIR_Coverage, 5124,
     /* 292288 */     GIR_EraseRootFromParent_Done,
     /* 292289 */   // Label 5720: @292289
     /* 292289 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(292318), // Rule ID 5131 //
     /* 292294 */     // MIs[0] Operand 1
     /* 292294 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292307 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 292310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292316 */     GIR_RootConstrainSelectedInstOperands,
     /* 292317 */     // GIR_Coverage, 5131,
     /* 292317 */     GIR_EraseRootFromParent_Done,
     /* 292318 */   // Label 5721: @292318
     /* 292318 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(292347), // Rule ID 5138 //
     /* 292323 */     // MIs[0] Operand 1
     /* 292323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292336 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 292339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292345 */     GIR_RootConstrainSelectedInstOperands,
     /* 292346 */     // GIR_Coverage, 5138,
     /* 292346 */     GIR_EraseRootFromParent_Done,
     /* 292347 */   // Label 5722: @292347
     /* 292347 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(292376), // Rule ID 5145 //
     /* 292352 */     // MIs[0] Operand 1
     /* 292352 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292365 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 292368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292374 */     GIR_RootConstrainSelectedInstOperands,
     /* 292375 */     // GIR_Coverage, 5145,
     /* 292375 */     GIR_EraseRootFromParent_Done,
     /* 292376 */   // Label 5723: @292376
     /* 292376 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(292405), // Rule ID 5152 //
     /* 292381 */     // MIs[0] Operand 1
     /* 292381 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292394 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292403 */     GIR_RootConstrainSelectedInstOperands,
     /* 292404 */     // GIR_Coverage, 5152,
     /* 292404 */     GIR_EraseRootFromParent_Done,
     /* 292405 */   // Label 5724: @292405
     /* 292405 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(292434), // Rule ID 5159 //
     /* 292410 */     // MIs[0] Operand 1
     /* 292410 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292423 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 292426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292432 */     GIR_RootConstrainSelectedInstOperands,
     /* 292433 */     // GIR_Coverage, 5159,
     /* 292433 */     GIR_EraseRootFromParent_Done,
     /* 292434 */   // Label 5725: @292434
     /* 292434 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(292463), // Rule ID 5166 //
     /* 292439 */     // MIs[0] Operand 1
     /* 292439 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292452 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 292455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292461 */     GIR_RootConstrainSelectedInstOperands,
     /* 292462 */     // GIR_Coverage, 5166,
     /* 292462 */     GIR_EraseRootFromParent_Done,
     /* 292463 */   // Label 5726: @292463
     /* 292463 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(292492), // Rule ID 5173 //
     /* 292468 */     // MIs[0] Operand 1
     /* 292468 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292481 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 292484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292490 */     GIR_RootConstrainSelectedInstOperands,
     /* 292491 */     // GIR_Coverage, 5173,
     /* 292491 */     GIR_EraseRootFromParent_Done,
     /* 292492 */   // Label 5727: @292492
     /* 292492 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(292521), // Rule ID 5180 //
     /* 292497 */     // MIs[0] Operand 1
     /* 292497 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292510 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292519 */     GIR_RootConstrainSelectedInstOperands,
     /* 292520 */     // GIR_Coverage, 5180,
     /* 292520 */     GIR_EraseRootFromParent_Done,
     /* 292521 */   // Label 5728: @292521
     /* 292521 */   GIM_Reject,
     /* 292522 */ // Label 5698: @292522
     /* 292522 */ GIM_Reject,
     /* 292523 */ // Label 5619: @292523
     /* 292523 */ GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(293570),
     /* 292528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292538 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(292578), // Rule ID 759 //
     /* 292543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292546 */     // MIs[0] Operand 1
     /* 292546 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292569 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292576 */     GIR_RootConstrainSelectedInstOperands,
     /* 292577 */     // GIR_Coverage, 759,
     /* 292577 */     GIR_EraseRootFromParent_Done,
     /* 292578 */   // Label 5730: @292578
     /* 292578 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(292618), // Rule ID 766 //
     /* 292583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292586 */     // MIs[0] Operand 1
     /* 292586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292609 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292616 */     GIR_RootConstrainSelectedInstOperands,
     /* 292617 */     // GIR_Coverage, 766,
     /* 292617 */     GIR_EraseRootFromParent_Done,
     /* 292618 */   // Label 5731: @292618
     /* 292618 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(292655), // Rule ID 5225 //
     /* 292623 */     // MIs[0] Operand 1
     /* 292623 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292632 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292638 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292646 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292653 */     GIR_RootConstrainSelectedInstOperands,
     /* 292654 */     // GIR_Coverage, 5225,
     /* 292654 */     GIR_EraseRootFromParent_Done,
     /* 292655 */   // Label 5732: @292655
     /* 292655 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(292692), // Rule ID 5232 //
     /* 292660 */     // MIs[0] Operand 1
     /* 292660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292669 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292675 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292683 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292690 */     GIR_RootConstrainSelectedInstOperands,
     /* 292691 */     // GIR_Coverage, 5232,
     /* 292691 */     GIR_EraseRootFromParent_Done,
     /* 292692 */   // Label 5733: @292692
     /* 292692 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(292729), // Rule ID 5239 //
     /* 292697 */     // MIs[0] Operand 1
     /* 292697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292706 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292712 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292720 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292727 */     GIR_RootConstrainSelectedInstOperands,
     /* 292728 */     // GIR_Coverage, 5239,
     /* 292728 */     GIR_EraseRootFromParent_Done,
     /* 292729 */   // Label 5734: @292729
     /* 292729 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(292766), // Rule ID 5246 //
     /* 292734 */     // MIs[0] Operand 1
     /* 292734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292757 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292764 */     GIR_RootConstrainSelectedInstOperands,
     /* 292765 */     // GIR_Coverage, 5246,
     /* 292765 */     GIR_EraseRootFromParent_Done,
     /* 292766 */   // Label 5735: @292766
     /* 292766 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(292803), // Rule ID 5253 //
     /* 292771 */     // MIs[0] Operand 1
     /* 292771 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292794 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292801 */     GIR_RootConstrainSelectedInstOperands,
     /* 292802 */     // GIR_Coverage, 5253,
     /* 292802 */     GIR_EraseRootFromParent_Done,
     /* 292803 */   // Label 5736: @292803
     /* 292803 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(292843), // Rule ID 731 //
     /* 292808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292811 */     // MIs[0] Operand 1
     /* 292811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292824 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292830 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292834 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292841 */     GIR_RootConstrainSelectedInstOperands,
     /* 292842 */     // GIR_Coverage, 731,
     /* 292842 */     GIR_EraseRootFromParent_Done,
     /* 292843 */   // Label 5737: @292843
     /* 292843 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(292883), // Rule ID 743 //
     /* 292848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292851 */     // MIs[0] Operand 1
     /* 292851 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292864 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292870 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292874 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292881 */     GIR_RootConstrainSelectedInstOperands,
     /* 292882 */     // GIR_Coverage, 743,
     /* 292882 */     GIR_EraseRootFromParent_Done,
     /* 292883 */   // Label 5738: @292883
     /* 292883 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(292923), // Rule ID 744 //
     /* 292888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292891 */     // MIs[0] Operand 1
     /* 292891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292904 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292910 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292914 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292921 */     GIR_RootConstrainSelectedInstOperands,
     /* 292922 */     // GIR_Coverage, 744,
     /* 292922 */     GIR_EraseRootFromParent_Done,
     /* 292923 */   // Label 5739: @292923
     /* 292923 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(292963), // Rule ID 752 //
     /* 292928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292931 */     // MIs[0] Operand 1
     /* 292931 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292944 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292950 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292954 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292961 */     GIR_RootConstrainSelectedInstOperands,
     /* 292962 */     // GIR_Coverage, 752,
     /* 292962 */     GIR_EraseRootFromParent_Done,
     /* 292963 */   // Label 5740: @292963
     /* 292963 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(293000), // Rule ID 5190 //
     /* 292968 */     // MIs[0] Operand 1
     /* 292968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292981 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292987 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292991 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292998 */     GIR_RootConstrainSelectedInstOperands,
     /* 292999 */     // GIR_Coverage, 5190,
     /* 292999 */     GIR_EraseRootFromParent_Done,
     /* 293000 */   // Label 5741: @293000
     /* 293000 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(293037), // Rule ID 5197 //
     /* 293005 */     // MIs[0] Operand 1
     /* 293005 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293018 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293024 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293028 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 293028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 293031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293035 */     GIR_RootConstrainSelectedInstOperands,
     /* 293036 */     // GIR_Coverage, 5197,
     /* 293036 */     GIR_EraseRootFromParent_Done,
     /* 293037 */   // Label 5742: @293037
     /* 293037 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(293074), // Rule ID 5204 //
     /* 293042 */     // MIs[0] Operand 1
     /* 293042 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293055 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293061 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293065 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 293065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 293068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293072 */     GIR_RootConstrainSelectedInstOperands,
     /* 293073 */     // GIR_Coverage, 5204,
     /* 293073 */     GIR_EraseRootFromParent_Done,
     /* 293074 */   // Label 5743: @293074
     /* 293074 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(293111), // Rule ID 5211 //
     /* 293079 */     // MIs[0] Operand 1
     /* 293079 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293092 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293098 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293102 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 293102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 293105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293109 */     GIR_RootConstrainSelectedInstOperands,
     /* 293110 */     // GIR_Coverage, 5211,
     /* 293110 */     GIR_EraseRootFromParent_Done,
     /* 293111 */   // Label 5744: @293111
     /* 293111 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(293148), // Rule ID 5218 //
     /* 293116 */     // MIs[0] Operand 1
     /* 293116 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293139 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 293139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 293142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293146 */     GIR_RootConstrainSelectedInstOperands,
     /* 293147 */     // GIR_Coverage, 5218,
     /* 293147 */     GIR_EraseRootFromParent_Done,
     /* 293148 */   // Label 5745: @293148
     /* 293148 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(293180), // Rule ID 1130 //
     /* 293153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293156 */     // MIs[0] Operand 1
     /* 293156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293169 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 293172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293178 */     GIR_RootConstrainSelectedInstOperands,
     /* 293179 */     // GIR_Coverage, 1130,
     /* 293179 */     GIR_EraseRootFromParent_Done,
     /* 293180 */   // Label 5746: @293180
     /* 293180 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293212), // Rule ID 1137 //
     /* 293185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293188 */     // MIs[0] Operand 1
     /* 293188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293201 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293210 */     GIR_RootConstrainSelectedInstOperands,
     /* 293211 */     // GIR_Coverage, 1137,
     /* 293211 */     GIR_EraseRootFromParent_Done,
     /* 293212 */   // Label 5747: @293212
     /* 293212 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293244), // Rule ID 1144 //
     /* 293217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293220 */     // MIs[0] Operand 1
     /* 293220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293233 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 293236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293242 */     GIR_RootConstrainSelectedInstOperands,
     /* 293243 */     // GIR_Coverage, 1144,
     /* 293243 */     GIR_EraseRootFromParent_Done,
     /* 293244 */   // Label 5748: @293244
     /* 293244 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(293276), // Rule ID 1151 //
     /* 293249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293252 */     // MIs[0] Operand 1
     /* 293252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293265 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293274 */     GIR_RootConstrainSelectedInstOperands,
     /* 293275 */     // GIR_Coverage, 1151,
     /* 293275 */     GIR_EraseRootFromParent_Done,
     /* 293276 */   // Label 5749: @293276
     /* 293276 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(293308), // Rule ID 1158 //
     /* 293281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293284 */     // MIs[0] Operand 1
     /* 293284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293297 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293306 */     GIR_RootConstrainSelectedInstOperands,
     /* 293307 */     // GIR_Coverage, 1158,
     /* 293307 */     GIR_EraseRootFromParent_Done,
     /* 293308 */   // Label 5750: @293308
     /* 293308 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(293337), // Rule ID 5127 //
     /* 293313 */     // MIs[0] Operand 1
     /* 293313 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293326 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 293329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293335 */     GIR_RootConstrainSelectedInstOperands,
     /* 293336 */     // GIR_Coverage, 5127,
     /* 293336 */     GIR_EraseRootFromParent_Done,
     /* 293337 */   // Label 5751: @293337
     /* 293337 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(293366), // Rule ID 5134 //
     /* 293342 */     // MIs[0] Operand 1
     /* 293342 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293355 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 293358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293364 */     GIR_RootConstrainSelectedInstOperands,
     /* 293365 */     // GIR_Coverage, 5134,
     /* 293365 */     GIR_EraseRootFromParent_Done,
     /* 293366 */   // Label 5752: @293366
     /* 293366 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(293395), // Rule ID 5141 //
     /* 293371 */     // MIs[0] Operand 1
     /* 293371 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293384 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293393 */     GIR_RootConstrainSelectedInstOperands,
     /* 293394 */     // GIR_Coverage, 5141,
     /* 293394 */     GIR_EraseRootFromParent_Done,
     /* 293395 */   // Label 5753: @293395
     /* 293395 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(293424), // Rule ID 5148 //
     /* 293400 */     // MIs[0] Operand 1
     /* 293400 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293413 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293422 */     GIR_RootConstrainSelectedInstOperands,
     /* 293423 */     // GIR_Coverage, 5148,
     /* 293423 */     GIR_EraseRootFromParent_Done,
     /* 293424 */   // Label 5754: @293424
     /* 293424 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(293453), // Rule ID 5155 //
     /* 293429 */     // MIs[0] Operand 1
     /* 293429 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293442 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293451 */     GIR_RootConstrainSelectedInstOperands,
     /* 293452 */     // GIR_Coverage, 5155,
     /* 293452 */     GIR_EraseRootFromParent_Done,
     /* 293453 */   // Label 5755: @293453
     /* 293453 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(293482), // Rule ID 5162 //
     /* 293458 */     // MIs[0] Operand 1
     /* 293458 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293471 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 293474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293480 */     GIR_RootConstrainSelectedInstOperands,
     /* 293481 */     // GIR_Coverage, 5162,
     /* 293481 */     GIR_EraseRootFromParent_Done,
     /* 293482 */   // Label 5756: @293482
     /* 293482 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(293511), // Rule ID 5169 //
     /* 293487 */     // MIs[0] Operand 1
     /* 293487 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293500 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293509 */     GIR_RootConstrainSelectedInstOperands,
     /* 293510 */     // GIR_Coverage, 5169,
     /* 293510 */     GIR_EraseRootFromParent_Done,
     /* 293511 */   // Label 5757: @293511
     /* 293511 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(293540), // Rule ID 5176 //
     /* 293516 */     // MIs[0] Operand 1
     /* 293516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293529 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293538 */     GIR_RootConstrainSelectedInstOperands,
     /* 293539 */     // GIR_Coverage, 5176,
     /* 293539 */     GIR_EraseRootFromParent_Done,
     /* 293540 */   // Label 5758: @293540
     /* 293540 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(293569), // Rule ID 5183 //
     /* 293545 */     // MIs[0] Operand 1
     /* 293545 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293558 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293567 */     GIR_RootConstrainSelectedInstOperands,
     /* 293568 */     // GIR_Coverage, 5183,
     /* 293568 */     GIR_EraseRootFromParent_Done,
     /* 293569 */   // Label 5759: @293569
     /* 293569 */   GIM_Reject,
     /* 293570 */ // Label 5729: @293570
     /* 293570 */ GIM_Reject,
     /* 293571 */ // Label 5620: @293571
     /* 293571 */ GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(294618),
     /* 293576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 293579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 293582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293586 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(293626), // Rule ID 754 //
     /* 293591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293594 */     // MIs[0] Operand 1
     /* 293594 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293603 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293609 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293617 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293624 */     GIR_RootConstrainSelectedInstOperands,
     /* 293625 */     // GIR_Coverage, 754,
     /* 293625 */     GIR_EraseRootFromParent_Done,
     /* 293626 */   // Label 5761: @293626
     /* 293626 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(293666), // Rule ID 761 //
     /* 293631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293634 */     // MIs[0] Operand 1
     /* 293634 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293643 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293649 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293657 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293664 */     GIR_RootConstrainSelectedInstOperands,
     /* 293665 */     // GIR_Coverage, 761,
     /* 293665 */     GIR_EraseRootFromParent_Done,
     /* 293666 */   // Label 5762: @293666
     /* 293666 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(293703), // Rule ID 5220 //
     /* 293671 */     // MIs[0] Operand 1
     /* 293671 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293680 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293686 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293694 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293701 */     GIR_RootConstrainSelectedInstOperands,
     /* 293702 */     // GIR_Coverage, 5220,
     /* 293702 */     GIR_EraseRootFromParent_Done,
     /* 293703 */   // Label 5763: @293703
     /* 293703 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(293740), // Rule ID 5227 //
     /* 293708 */     // MIs[0] Operand 1
     /* 293708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293717 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293731 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293738 */     GIR_RootConstrainSelectedInstOperands,
     /* 293739 */     // GIR_Coverage, 5227,
     /* 293739 */     GIR_EraseRootFromParent_Done,
     /* 293740 */   // Label 5764: @293740
     /* 293740 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(293777), // Rule ID 5234 //
     /* 293745 */     // MIs[0] Operand 1
     /* 293745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293754 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293760 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293768 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293775 */     GIR_RootConstrainSelectedInstOperands,
     /* 293776 */     // GIR_Coverage, 5234,
     /* 293776 */     GIR_EraseRootFromParent_Done,
     /* 293777 */   // Label 5765: @293777
     /* 293777 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(293814), // Rule ID 5241 //
     /* 293782 */     // MIs[0] Operand 1
     /* 293782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293805 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293812 */     GIR_RootConstrainSelectedInstOperands,
     /* 293813 */     // GIR_Coverage, 5241,
     /* 293813 */     GIR_EraseRootFromParent_Done,
     /* 293814 */   // Label 5766: @293814
     /* 293814 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(293851), // Rule ID 5248 //
     /* 293819 */     // MIs[0] Operand 1
     /* 293819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293842 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293849 */     GIR_RootConstrainSelectedInstOperands,
     /* 293850 */     // GIR_Coverage, 5248,
     /* 293850 */     GIR_EraseRootFromParent_Done,
     /* 293851 */   // Label 5767: @293851
     /* 293851 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293891), // Rule ID 726 //
     /* 293856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293859 */     // MIs[0] Operand 1
     /* 293859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293882 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293889 */     GIR_RootConstrainSelectedInstOperands,
     /* 293890 */     // GIR_Coverage, 726,
     /* 293890 */     GIR_EraseRootFromParent_Done,
     /* 293891 */   // Label 5768: @293891
     /* 293891 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(293931), // Rule ID 733 //
     /* 293896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293899 */     // MIs[0] Operand 1
     /* 293899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293922 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293929 */     GIR_RootConstrainSelectedInstOperands,
     /* 293930 */     // GIR_Coverage, 733,
     /* 293930 */     GIR_EraseRootFromParent_Done,
     /* 293931 */   // Label 5769: @293931
     /* 293931 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(293971), // Rule ID 734 //
     /* 293936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293939 */     // MIs[0] Operand 1
     /* 293939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293962 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293969 */     GIR_RootConstrainSelectedInstOperands,
     /* 293970 */     // GIR_Coverage, 734,
     /* 293970 */     GIR_EraseRootFromParent_Done,
     /* 293971 */   // Label 5770: @293971
     /* 293971 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(294011), // Rule ID 747 //
     /* 293976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293979 */     // MIs[0] Operand 1
     /* 293979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293998 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294002 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 294005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294009 */     GIR_RootConstrainSelectedInstOperands,
     /* 294010 */     // GIR_Coverage, 747,
     /* 294010 */     GIR_EraseRootFromParent_Done,
     /* 294011 */   // Label 5771: @294011
     /* 294011 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(294048), // Rule ID 5185 //
     /* 294016 */     // MIs[0] Operand 1
     /* 294016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294029 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294035 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294039 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 294042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294046 */     GIR_RootConstrainSelectedInstOperands,
     /* 294047 */     // GIR_Coverage, 5185,
     /* 294047 */     GIR_EraseRootFromParent_Done,
     /* 294048 */   // Label 5772: @294048
     /* 294048 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(294085), // Rule ID 5192 //
     /* 294053 */     // MIs[0] Operand 1
     /* 294053 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294076 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 294079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294083 */     GIR_RootConstrainSelectedInstOperands,
     /* 294084 */     // GIR_Coverage, 5192,
     /* 294084 */     GIR_EraseRootFromParent_Done,
     /* 294085 */   // Label 5773: @294085
     /* 294085 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(294122), // Rule ID 5199 //
     /* 294090 */     // MIs[0] Operand 1
     /* 294090 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294103 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294109 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294113 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 294116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294120 */     GIR_RootConstrainSelectedInstOperands,
     /* 294121 */     // GIR_Coverage, 5199,
     /* 294121 */     GIR_EraseRootFromParent_Done,
     /* 294122 */   // Label 5774: @294122
     /* 294122 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(294159), // Rule ID 5206 //
     /* 294127 */     // MIs[0] Operand 1
     /* 294127 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294150 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 294153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294157 */     GIR_RootConstrainSelectedInstOperands,
     /* 294158 */     // GIR_Coverage, 5206,
     /* 294158 */     GIR_EraseRootFromParent_Done,
     /* 294159 */   // Label 5775: @294159
     /* 294159 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294196), // Rule ID 5213 //
     /* 294164 */     // MIs[0] Operand 1
     /* 294164 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294187 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 294187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 294190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294194 */     GIR_RootConstrainSelectedInstOperands,
     /* 294195 */     // GIR_Coverage, 5213,
     /* 294195 */     GIR_EraseRootFromParent_Done,
     /* 294196 */   // Label 5776: @294196
     /* 294196 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294228), // Rule ID 1125 //
     /* 294201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294204 */     // MIs[0] Operand 1
     /* 294204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294217 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 294220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294226 */     GIR_RootConstrainSelectedInstOperands,
     /* 294227 */     // GIR_Coverage, 1125,
     /* 294227 */     GIR_EraseRootFromParent_Done,
     /* 294228 */   // Label 5777: @294228
     /* 294228 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294260), // Rule ID 1132 //
     /* 294233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294236 */     // MIs[0] Operand 1
     /* 294236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294249 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294258 */     GIR_RootConstrainSelectedInstOperands,
     /* 294259 */     // GIR_Coverage, 1132,
     /* 294259 */     GIR_EraseRootFromParent_Done,
     /* 294260 */   // Label 5778: @294260
     /* 294260 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(294292), // Rule ID 1139 //
     /* 294265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294268 */     // MIs[0] Operand 1
     /* 294268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294281 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294290 */     GIR_RootConstrainSelectedInstOperands,
     /* 294291 */     // GIR_Coverage, 1139,
     /* 294291 */     GIR_EraseRootFromParent_Done,
     /* 294292 */   // Label 5779: @294292
     /* 294292 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(294324), // Rule ID 1146 //
     /* 294297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294300 */     // MIs[0] Operand 1
     /* 294300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294313 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294322 */     GIR_RootConstrainSelectedInstOperands,
     /* 294323 */     // GIR_Coverage, 1146,
     /* 294323 */     GIR_EraseRootFromParent_Done,
     /* 294324 */   // Label 5780: @294324
     /* 294324 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(294356), // Rule ID 1153 //
     /* 294329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294332 */     // MIs[0] Operand 1
     /* 294332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294345 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294354 */     GIR_RootConstrainSelectedInstOperands,
     /* 294355 */     // GIR_Coverage, 1153,
     /* 294355 */     GIR_EraseRootFromParent_Done,
     /* 294356 */   // Label 5781: @294356
     /* 294356 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(294385), // Rule ID 5122 //
     /* 294361 */     // MIs[0] Operand 1
     /* 294361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294374 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 294377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294383 */     GIR_RootConstrainSelectedInstOperands,
     /* 294384 */     // GIR_Coverage, 5122,
     /* 294384 */     GIR_EraseRootFromParent_Done,
     /* 294385 */   // Label 5782: @294385
     /* 294385 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(294414), // Rule ID 5129 //
     /* 294390 */     // MIs[0] Operand 1
     /* 294390 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294403 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294412 */     GIR_RootConstrainSelectedInstOperands,
     /* 294413 */     // GIR_Coverage, 5129,
     /* 294413 */     GIR_EraseRootFromParent_Done,
     /* 294414 */   // Label 5783: @294414
     /* 294414 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(294443), // Rule ID 5136 //
     /* 294419 */     // MIs[0] Operand 1
     /* 294419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294432 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294441 */     GIR_RootConstrainSelectedInstOperands,
     /* 294442 */     // GIR_Coverage, 5136,
     /* 294442 */     GIR_EraseRootFromParent_Done,
     /* 294443 */   // Label 5784: @294443
     /* 294443 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(294472), // Rule ID 5143 //
     /* 294448 */     // MIs[0] Operand 1
     /* 294448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294461 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294470 */     GIR_RootConstrainSelectedInstOperands,
     /* 294471 */     // GIR_Coverage, 5143,
     /* 294471 */     GIR_EraseRootFromParent_Done,
     /* 294472 */   // Label 5785: @294472
     /* 294472 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294501), // Rule ID 5150 //
     /* 294477 */     // MIs[0] Operand 1
     /* 294477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294490 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294499 */     GIR_RootConstrainSelectedInstOperands,
     /* 294500 */     // GIR_Coverage, 5150,
     /* 294500 */     GIR_EraseRootFromParent_Done,
     /* 294501 */   // Label 5786: @294501
     /* 294501 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294530), // Rule ID 5157 //
     /* 294506 */     // MIs[0] Operand 1
     /* 294506 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294519 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294528 */     GIR_RootConstrainSelectedInstOperands,
     /* 294529 */     // GIR_Coverage, 5157,
     /* 294529 */     GIR_EraseRootFromParent_Done,
     /* 294530 */   // Label 5787: @294530
     /* 294530 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294559), // Rule ID 5164 //
     /* 294535 */     // MIs[0] Operand 1
     /* 294535 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294548 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294557 */     GIR_RootConstrainSelectedInstOperands,
     /* 294558 */     // GIR_Coverage, 5164,
     /* 294558 */     GIR_EraseRootFromParent_Done,
     /* 294559 */   // Label 5788: @294559
     /* 294559 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294588), // Rule ID 5171 //
     /* 294564 */     // MIs[0] Operand 1
     /* 294564 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294577 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294586 */     GIR_RootConstrainSelectedInstOperands,
     /* 294587 */     // GIR_Coverage, 5171,
     /* 294587 */     GIR_EraseRootFromParent_Done,
     /* 294588 */   // Label 5789: @294588
     /* 294588 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294617), // Rule ID 5178 //
     /* 294593 */     // MIs[0] Operand 1
     /* 294593 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294606 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294615 */     GIR_RootConstrainSelectedInstOperands,
     /* 294616 */     // GIR_Coverage, 5178,
     /* 294616 */     GIR_EraseRootFromParent_Done,
     /* 294617 */   // Label 5790: @294617
     /* 294617 */   GIM_Reject,
     /* 294618 */ // Label 5760: @294618
     /* 294618 */ GIM_Reject,
     /* 294619 */ // Label 5621: @294619
     /* 294619 */ GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(295666),
     /* 294624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294634 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(294674), // Rule ID 757 //
     /* 294639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294642 */     // MIs[0] Operand 1
     /* 294642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294665 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294672 */     GIR_RootConstrainSelectedInstOperands,
     /* 294673 */     // GIR_Coverage, 757,
     /* 294673 */     GIR_EraseRootFromParent_Done,
     /* 294674 */   // Label 5792: @294674
     /* 294674 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(294714), // Rule ID 764 //
     /* 294679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294682 */     // MIs[0] Operand 1
     /* 294682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294705 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294712 */     GIR_RootConstrainSelectedInstOperands,
     /* 294713 */     // GIR_Coverage, 764,
     /* 294713 */     GIR_EraseRootFromParent_Done,
     /* 294714 */   // Label 5793: @294714
     /* 294714 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(294751), // Rule ID 5223 //
     /* 294719 */     // MIs[0] Operand 1
     /* 294719 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294728 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294734 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294742 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294749 */     GIR_RootConstrainSelectedInstOperands,
     /* 294750 */     // GIR_Coverage, 5223,
     /* 294750 */     GIR_EraseRootFromParent_Done,
     /* 294751 */   // Label 5794: @294751
     /* 294751 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294788), // Rule ID 5230 //
     /* 294756 */     // MIs[0] Operand 1
     /* 294756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294765 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294771 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294779 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294786 */     GIR_RootConstrainSelectedInstOperands,
     /* 294787 */     // GIR_Coverage, 5230,
     /* 294787 */     GIR_EraseRootFromParent_Done,
     /* 294788 */   // Label 5795: @294788
     /* 294788 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(294825), // Rule ID 5237 //
     /* 294793 */     // MIs[0] Operand 1
     /* 294793 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294808 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294816 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294823 */     GIR_RootConstrainSelectedInstOperands,
     /* 294824 */     // GIR_Coverage, 5237,
     /* 294824 */     GIR_EraseRootFromParent_Done,
     /* 294825 */   // Label 5796: @294825
     /* 294825 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(294862), // Rule ID 5244 //
     /* 294830 */     // MIs[0] Operand 1
     /* 294830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294839 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294845 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294853 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294860 */     GIR_RootConstrainSelectedInstOperands,
     /* 294861 */     // GIR_Coverage, 5244,
     /* 294861 */     GIR_EraseRootFromParent_Done,
     /* 294862 */   // Label 5797: @294862
     /* 294862 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(294899), // Rule ID 5251 //
     /* 294867 */     // MIs[0] Operand 1
     /* 294867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294890 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294897 */     GIR_RootConstrainSelectedInstOperands,
     /* 294898 */     // GIR_Coverage, 5251,
     /* 294898 */     GIR_EraseRootFromParent_Done,
     /* 294899 */   // Label 5798: @294899
     /* 294899 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(294939), // Rule ID 729 //
     /* 294904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294907 */     // MIs[0] Operand 1
     /* 294907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294920 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294926 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294930 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294937 */     GIR_RootConstrainSelectedInstOperands,
     /* 294938 */     // GIR_Coverage, 729,
     /* 294938 */     GIR_EraseRootFromParent_Done,
     /* 294939 */   // Label 5799: @294939
     /* 294939 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(294979), // Rule ID 739 //
     /* 294944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294947 */     // MIs[0] Operand 1
     /* 294947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294966 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294970 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294977 */     GIR_RootConstrainSelectedInstOperands,
     /* 294978 */     // GIR_Coverage, 739,
     /* 294978 */     GIR_EraseRootFromParent_Done,
     /* 294979 */   // Label 5800: @294979
     /* 294979 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(295019), // Rule ID 740 //
     /* 294984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294987 */     // MIs[0] Operand 1
     /* 294987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295000 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295006 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295010 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 295013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295017 */     GIR_RootConstrainSelectedInstOperands,
     /* 295018 */     // GIR_Coverage, 740,
     /* 295018 */     GIR_EraseRootFromParent_Done,
     /* 295019 */   // Label 5801: @295019
     /* 295019 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(295059), // Rule ID 750 //
     /* 295024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295027 */     // MIs[0] Operand 1
     /* 295027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295050 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 295053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295057 */     GIR_RootConstrainSelectedInstOperands,
     /* 295058 */     // GIR_Coverage, 750,
     /* 295058 */     GIR_EraseRootFromParent_Done,
     /* 295059 */   // Label 5802: @295059
     /* 295059 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(295096), // Rule ID 5188 //
     /* 295064 */     // MIs[0] Operand 1
     /* 295064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295077 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295083 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295087 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 295090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295094 */     GIR_RootConstrainSelectedInstOperands,
     /* 295095 */     // GIR_Coverage, 5188,
     /* 295095 */     GIR_EraseRootFromParent_Done,
     /* 295096 */   // Label 5803: @295096
     /* 295096 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(295133), // Rule ID 5195 //
     /* 295101 */     // MIs[0] Operand 1
     /* 295101 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295114 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295120 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295124 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 295127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295131 */     GIR_RootConstrainSelectedInstOperands,
     /* 295132 */     // GIR_Coverage, 5195,
     /* 295132 */     GIR_EraseRootFromParent_Done,
     /* 295133 */   // Label 5804: @295133
     /* 295133 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(295170), // Rule ID 5202 //
     /* 295138 */     // MIs[0] Operand 1
     /* 295138 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295161 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 295164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295168 */     GIR_RootConstrainSelectedInstOperands,
     /* 295169 */     // GIR_Coverage, 5202,
     /* 295169 */     GIR_EraseRootFromParent_Done,
     /* 295170 */   // Label 5805: @295170
     /* 295170 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295207), // Rule ID 5209 //
     /* 295175 */     // MIs[0] Operand 1
     /* 295175 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295188 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295194 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295198 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 295201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295205 */     GIR_RootConstrainSelectedInstOperands,
     /* 295206 */     // GIR_Coverage, 5209,
     /* 295206 */     GIR_EraseRootFromParent_Done,
     /* 295207 */   // Label 5806: @295207
     /* 295207 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295244), // Rule ID 5216 //
     /* 295212 */     // MIs[0] Operand 1
     /* 295212 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295235 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 295235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 295238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295242 */     GIR_RootConstrainSelectedInstOperands,
     /* 295243 */     // GIR_Coverage, 5216,
     /* 295243 */     GIR_EraseRootFromParent_Done,
     /* 295244 */   // Label 5807: @295244
     /* 295244 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(295276), // Rule ID 1128 //
     /* 295249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295252 */     // MIs[0] Operand 1
     /* 295252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295265 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 295268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295274 */     GIR_RootConstrainSelectedInstOperands,
     /* 295275 */     // GIR_Coverage, 1128,
     /* 295275 */     GIR_EraseRootFromParent_Done,
     /* 295276 */   // Label 5808: @295276
     /* 295276 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(295308), // Rule ID 1135 //
     /* 295281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295284 */     // MIs[0] Operand 1
     /* 295284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295297 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295306 */     GIR_RootConstrainSelectedInstOperands,
     /* 295307 */     // GIR_Coverage, 1135,
     /* 295307 */     GIR_EraseRootFromParent_Done,
     /* 295308 */   // Label 5809: @295308
     /* 295308 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(295340), // Rule ID 1142 //
     /* 295313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295316 */     // MIs[0] Operand 1
     /* 295316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295329 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295338 */     GIR_RootConstrainSelectedInstOperands,
     /* 295339 */     // GIR_Coverage, 1142,
     /* 295339 */     GIR_EraseRootFromParent_Done,
     /* 295340 */   // Label 5810: @295340
     /* 295340 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(295372), // Rule ID 1149 //
     /* 295345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295348 */     // MIs[0] Operand 1
     /* 295348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295361 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295370 */     GIR_RootConstrainSelectedInstOperands,
     /* 295371 */     // GIR_Coverage, 1149,
     /* 295371 */     GIR_EraseRootFromParent_Done,
     /* 295372 */   // Label 5811: @295372
     /* 295372 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(295404), // Rule ID 1156 //
     /* 295377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295380 */     // MIs[0] Operand 1
     /* 295380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295393 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295402 */     GIR_RootConstrainSelectedInstOperands,
     /* 295403 */     // GIR_Coverage, 1156,
     /* 295403 */     GIR_EraseRootFromParent_Done,
     /* 295404 */   // Label 5812: @295404
     /* 295404 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(295433), // Rule ID 5125 //
     /* 295409 */     // MIs[0] Operand 1
     /* 295409 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295422 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 295425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295431 */     GIR_RootConstrainSelectedInstOperands,
     /* 295432 */     // GIR_Coverage, 5125,
     /* 295432 */     GIR_EraseRootFromParent_Done,
     /* 295433 */   // Label 5813: @295433
     /* 295433 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(295462), // Rule ID 5132 //
     /* 295438 */     // MIs[0] Operand 1
     /* 295438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295451 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295460 */     GIR_RootConstrainSelectedInstOperands,
     /* 295461 */     // GIR_Coverage, 5132,
     /* 295461 */     GIR_EraseRootFromParent_Done,
     /* 295462 */   // Label 5814: @295462
     /* 295462 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(295491), // Rule ID 5139 //
     /* 295467 */     // MIs[0] Operand 1
     /* 295467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295480 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295489 */     GIR_RootConstrainSelectedInstOperands,
     /* 295490 */     // GIR_Coverage, 5139,
     /* 295490 */     GIR_EraseRootFromParent_Done,
     /* 295491 */   // Label 5815: @295491
     /* 295491 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(295520), // Rule ID 5146 //
     /* 295496 */     // MIs[0] Operand 1
     /* 295496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295509 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295518 */     GIR_RootConstrainSelectedInstOperands,
     /* 295519 */     // GIR_Coverage, 5146,
     /* 295519 */     GIR_EraseRootFromParent_Done,
     /* 295520 */   // Label 5816: @295520
     /* 295520 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(295549), // Rule ID 5153 //
     /* 295525 */     // MIs[0] Operand 1
     /* 295525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295538 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295547 */     GIR_RootConstrainSelectedInstOperands,
     /* 295548 */     // GIR_Coverage, 5153,
     /* 295548 */     GIR_EraseRootFromParent_Done,
     /* 295549 */   // Label 5817: @295549
     /* 295549 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(295578), // Rule ID 5160 //
     /* 295554 */     // MIs[0] Operand 1
     /* 295554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295567 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295576 */     GIR_RootConstrainSelectedInstOperands,
     /* 295577 */     // GIR_Coverage, 5160,
     /* 295577 */     GIR_EraseRootFromParent_Done,
     /* 295578 */   // Label 5818: @295578
     /* 295578 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(295607), // Rule ID 5167 //
     /* 295583 */     // MIs[0] Operand 1
     /* 295583 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295596 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295605 */     GIR_RootConstrainSelectedInstOperands,
     /* 295606 */     // GIR_Coverage, 5167,
     /* 295606 */     GIR_EraseRootFromParent_Done,
     /* 295607 */   // Label 5819: @295607
     /* 295607 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(295636), // Rule ID 5174 //
     /* 295612 */     // MIs[0] Operand 1
     /* 295612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295625 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295634 */     GIR_RootConstrainSelectedInstOperands,
     /* 295635 */     // GIR_Coverage, 5174,
     /* 295635 */     GIR_EraseRootFromParent_Done,
     /* 295636 */   // Label 5820: @295636
     /* 295636 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(295665), // Rule ID 5181 //
     /* 295641 */     // MIs[0] Operand 1
     /* 295641 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295654 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295663 */     GIR_RootConstrainSelectedInstOperands,
     /* 295664 */     // GIR_Coverage, 5181,
     /* 295664 */     GIR_EraseRootFromParent_Done,
     /* 295665 */   // Label 5821: @295665
     /* 295665 */   GIM_Reject,
     /* 295666 */ // Label 5791: @295666
     /* 295666 */ GIM_Reject,
     /* 295667 */ // Label 5622: @295667
     /* 295667 */ GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(296714),
     /* 295672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 295675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 295678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295682 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(295722), // Rule ID 755 //
     /* 295687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295690 */     // MIs[0] Operand 1
     /* 295690 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295713 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295720 */     GIR_RootConstrainSelectedInstOperands,
     /* 295721 */     // GIR_Coverage, 755,
     /* 295721 */     GIR_EraseRootFromParent_Done,
     /* 295722 */   // Label 5823: @295722
     /* 295722 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(295762), // Rule ID 762 //
     /* 295727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295730 */     // MIs[0] Operand 1
     /* 295730 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295753 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295760 */     GIR_RootConstrainSelectedInstOperands,
     /* 295761 */     // GIR_Coverage, 762,
     /* 295761 */     GIR_EraseRootFromParent_Done,
     /* 295762 */   // Label 5824: @295762
     /* 295762 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(295799), // Rule ID 5221 //
     /* 295767 */     // MIs[0] Operand 1
     /* 295767 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295790 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295797 */     GIR_RootConstrainSelectedInstOperands,
     /* 295798 */     // GIR_Coverage, 5221,
     /* 295798 */     GIR_EraseRootFromParent_Done,
     /* 295799 */   // Label 5825: @295799
     /* 295799 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(295836), // Rule ID 5228 //
     /* 295804 */     // MIs[0] Operand 1
     /* 295804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295827 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295834 */     GIR_RootConstrainSelectedInstOperands,
     /* 295835 */     // GIR_Coverage, 5228,
     /* 295835 */     GIR_EraseRootFromParent_Done,
     /* 295836 */   // Label 5826: @295836
     /* 295836 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(295873), // Rule ID 5235 //
     /* 295841 */     // MIs[0] Operand 1
     /* 295841 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295850 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295856 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295864 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295871 */     GIR_RootConstrainSelectedInstOperands,
     /* 295872 */     // GIR_Coverage, 5235,
     /* 295872 */     GIR_EraseRootFromParent_Done,
     /* 295873 */   // Label 5827: @295873
     /* 295873 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(295910), // Rule ID 5242 //
     /* 295878 */     // MIs[0] Operand 1
     /* 295878 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295901 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295908 */     GIR_RootConstrainSelectedInstOperands,
     /* 295909 */     // GIR_Coverage, 5242,
     /* 295909 */     GIR_EraseRootFromParent_Done,
     /* 295910 */   // Label 5828: @295910
     /* 295910 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(295947), // Rule ID 5249 //
     /* 295915 */     // MIs[0] Operand 1
     /* 295915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295924 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295930 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295938 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295945 */     GIR_RootConstrainSelectedInstOperands,
     /* 295946 */     // GIR_Coverage, 5249,
     /* 295946 */     GIR_EraseRootFromParent_Done,
     /* 295947 */   // Label 5829: @295947
     /* 295947 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(295987), // Rule ID 727 //
     /* 295952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295955 */     // MIs[0] Operand 1
     /* 295955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295978 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295985 */     GIR_RootConstrainSelectedInstOperands,
     /* 295986 */     // GIR_Coverage, 727,
     /* 295986 */     GIR_EraseRootFromParent_Done,
     /* 295987 */   // Label 5830: @295987
     /* 295987 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(296027), // Rule ID 735 //
     /* 295992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295995 */     // MIs[0] Operand 1
     /* 295995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296018 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 296021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296025 */     GIR_RootConstrainSelectedInstOperands,
     /* 296026 */     // GIR_Coverage, 735,
     /* 296026 */     GIR_EraseRootFromParent_Done,
     /* 296027 */   // Label 5831: @296027
     /* 296027 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(296067), // Rule ID 736 //
     /* 296032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296035 */     // MIs[0] Operand 1
     /* 296035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296054 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 296056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296058 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 296061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296065 */     GIR_RootConstrainSelectedInstOperands,
     /* 296066 */     // GIR_Coverage, 736,
     /* 296066 */     GIR_EraseRootFromParent_Done,
     /* 296067 */   // Label 5832: @296067
     /* 296067 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(296107), // Rule ID 748 //
     /* 296072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296075 */     // MIs[0] Operand 1
     /* 296075 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296098 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 296101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296105 */     GIR_RootConstrainSelectedInstOperands,
     /* 296106 */     // GIR_Coverage, 748,
     /* 296106 */     GIR_EraseRootFromParent_Done,
     /* 296107 */   // Label 5833: @296107
     /* 296107 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(296144), // Rule ID 5186 //
     /* 296112 */     // MIs[0] Operand 1
     /* 296112 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296125 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296135 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 296138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296142 */     GIR_RootConstrainSelectedInstOperands,
     /* 296143 */     // GIR_Coverage, 5186,
     /* 296143 */     GIR_EraseRootFromParent_Done,
     /* 296144 */   // Label 5834: @296144
     /* 296144 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296181), // Rule ID 5193 //
     /* 296149 */     // MIs[0] Operand 1
     /* 296149 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296162 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296168 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296172 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 296175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296179 */     GIR_RootConstrainSelectedInstOperands,
     /* 296180 */     // GIR_Coverage, 5193,
     /* 296180 */     GIR_EraseRootFromParent_Done,
     /* 296181 */   // Label 5835: @296181
     /* 296181 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296218), // Rule ID 5200 //
     /* 296186 */     // MIs[0] Operand 1
     /* 296186 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296199 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296205 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296209 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 296212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296216 */     GIR_RootConstrainSelectedInstOperands,
     /* 296217 */     // GIR_Coverage, 5200,
     /* 296217 */     GIR_EraseRootFromParent_Done,
     /* 296218 */   // Label 5836: @296218
     /* 296218 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(296255), // Rule ID 5207 //
     /* 296223 */     // MIs[0] Operand 1
     /* 296223 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296236 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296242 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296246 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 296249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296253 */     GIR_RootConstrainSelectedInstOperands,
     /* 296254 */     // GIR_Coverage, 5207,
     /* 296254 */     GIR_EraseRootFromParent_Done,
     /* 296255 */   // Label 5837: @296255
     /* 296255 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(296292), // Rule ID 5214 //
     /* 296260 */     // MIs[0] Operand 1
     /* 296260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296283 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 296283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 296286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296290 */     GIR_RootConstrainSelectedInstOperands,
     /* 296291 */     // GIR_Coverage, 5214,
     /* 296291 */     GIR_EraseRootFromParent_Done,
     /* 296292 */   // Label 5838: @296292
     /* 296292 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(296324), // Rule ID 1126 //
     /* 296297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296300 */     // MIs[0] Operand 1
     /* 296300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296313 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 296316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296322 */     GIR_RootConstrainSelectedInstOperands,
     /* 296323 */     // GIR_Coverage, 1126,
     /* 296323 */     GIR_EraseRootFromParent_Done,
     /* 296324 */   // Label 5839: @296324
     /* 296324 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(296356), // Rule ID 1133 //
     /* 296329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296332 */     // MIs[0] Operand 1
     /* 296332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296345 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296354 */     GIR_RootConstrainSelectedInstOperands,
     /* 296355 */     // GIR_Coverage, 1133,
     /* 296355 */     GIR_EraseRootFromParent_Done,
     /* 296356 */   // Label 5840: @296356
     /* 296356 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(296388), // Rule ID 1140 //
     /* 296361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296364 */     // MIs[0] Operand 1
     /* 296364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296377 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296386 */     GIR_RootConstrainSelectedInstOperands,
     /* 296387 */     // GIR_Coverage, 1140,
     /* 296387 */     GIR_EraseRootFromParent_Done,
     /* 296388 */   // Label 5841: @296388
     /* 296388 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(296420), // Rule ID 1147 //
     /* 296393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296396 */     // MIs[0] Operand 1
     /* 296396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296409 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296418 */     GIR_RootConstrainSelectedInstOperands,
     /* 296419 */     // GIR_Coverage, 1147,
     /* 296419 */     GIR_EraseRootFromParent_Done,
     /* 296420 */   // Label 5842: @296420
     /* 296420 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(296452), // Rule ID 1154 //
     /* 296425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296428 */     // MIs[0] Operand 1
     /* 296428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296441 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296450 */     GIR_RootConstrainSelectedInstOperands,
     /* 296451 */     // GIR_Coverage, 1154,
     /* 296451 */     GIR_EraseRootFromParent_Done,
     /* 296452 */   // Label 5843: @296452
     /* 296452 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(296481), // Rule ID 5123 //
     /* 296457 */     // MIs[0] Operand 1
     /* 296457 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296470 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 296473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296479 */     GIR_RootConstrainSelectedInstOperands,
     /* 296480 */     // GIR_Coverage, 5123,
     /* 296480 */     GIR_EraseRootFromParent_Done,
     /* 296481 */   // Label 5844: @296481
     /* 296481 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(296510), // Rule ID 5130 //
     /* 296486 */     // MIs[0] Operand 1
     /* 296486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296499 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296508 */     GIR_RootConstrainSelectedInstOperands,
     /* 296509 */     // GIR_Coverage, 5130,
     /* 296509 */     GIR_EraseRootFromParent_Done,
     /* 296510 */   // Label 5845: @296510
     /* 296510 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(296539), // Rule ID 5137 //
     /* 296515 */     // MIs[0] Operand 1
     /* 296515 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296528 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296537 */     GIR_RootConstrainSelectedInstOperands,
     /* 296538 */     // GIR_Coverage, 5137,
     /* 296538 */     GIR_EraseRootFromParent_Done,
     /* 296539 */   // Label 5846: @296539
     /* 296539 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(296568), // Rule ID 5144 //
     /* 296544 */     // MIs[0] Operand 1
     /* 296544 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296557 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296566 */     GIR_RootConstrainSelectedInstOperands,
     /* 296567 */     // GIR_Coverage, 5144,
     /* 296567 */     GIR_EraseRootFromParent_Done,
     /* 296568 */   // Label 5847: @296568
     /* 296568 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(296597), // Rule ID 5151 //
     /* 296573 */     // MIs[0] Operand 1
     /* 296573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296586 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296595 */     GIR_RootConstrainSelectedInstOperands,
     /* 296596 */     // GIR_Coverage, 5151,
     /* 296596 */     GIR_EraseRootFromParent_Done,
     /* 296597 */   // Label 5848: @296597
     /* 296597 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(296626), // Rule ID 5158 //
     /* 296602 */     // MIs[0] Operand 1
     /* 296602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296615 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296624 */     GIR_RootConstrainSelectedInstOperands,
     /* 296625 */     // GIR_Coverage, 5158,
     /* 296625 */     GIR_EraseRootFromParent_Done,
     /* 296626 */   // Label 5849: @296626
     /* 296626 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(296655), // Rule ID 5165 //
     /* 296631 */     // MIs[0] Operand 1
     /* 296631 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296644 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296653 */     GIR_RootConstrainSelectedInstOperands,
     /* 296654 */     // GIR_Coverage, 5165,
     /* 296654 */     GIR_EraseRootFromParent_Done,
     /* 296655 */   // Label 5850: @296655
     /* 296655 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(296684), // Rule ID 5172 //
     /* 296660 */     // MIs[0] Operand 1
     /* 296660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296673 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296682 */     GIR_RootConstrainSelectedInstOperands,
     /* 296683 */     // GIR_Coverage, 5172,
     /* 296683 */     GIR_EraseRootFromParent_Done,
     /* 296684 */   // Label 5851: @296684
     /* 296684 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(296713), // Rule ID 5179 //
     /* 296689 */     // MIs[0] Operand 1
     /* 296689 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296702 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296711 */     GIR_RootConstrainSelectedInstOperands,
     /* 296712 */     // GIR_Coverage, 5179,
     /* 296712 */     GIR_EraseRootFromParent_Done,
     /* 296713 */   // Label 5852: @296713
     /* 296713 */   GIM_Reject,
     /* 296714 */ // Label 5822: @296714
     /* 296714 */ GIM_Reject,
     /* 296715 */ // Label 5623: @296715
     /* 296715 */ GIM_Reject,
     /* 296716 */ // Label 52: @296716
     /* 296716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5865*/ GIMT_Encode4(297760),
     /* 296727 */ /*GILLT_nxv1s1*//*Label 5853*/ GIMT_Encode4(296775),
     /* 296731 */ /*GILLT_nxv2s1*//*Label 5854*/ GIMT_Encode4(296804),
     /* 296735 */ /*GILLT_nxv2s16*//*Label 5855*/ GIMT_Encode4(296833),
     /* 296739 */ /*GILLT_nxv2s32*//*Label 5856*/ GIMT_Encode4(296918),
     /* 296743 */ /*GILLT_nxv2s64*//*Label 5857*/ GIMT_Encode4(297003),
     /* 296747 */ /*GILLT_nxv4s1*//*Label 5858*/ GIMT_Encode4(297169),
     /* 296751 */ /*GILLT_nxv4s16*//*Label 5859*/ GIMT_Encode4(297198),
     /* 296755 */ /*GILLT_nxv4s32*//*Label 5860*/ GIMT_Encode4(297283),
     /* 296759 */ /*GILLT_nxv8s1*//*Label 5861*/ GIMT_Encode4(297449),
     /* 296763 */ /*GILLT_nxv8s16*//*Label 5862*/ GIMT_Encode4(297478),
     /* 296767 */ /*GILLT_nxv16s1*//*Label 5863*/ GIMT_Encode4(297644),
     /* 296771 */ /*GILLT_nxv16s8*//*Label 5864*/ GIMT_Encode4(297673),
     /* 296775 */ // Label 5853: @296775
     /* 296775 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(296803), // Rule ID 8572 //
     /* 296780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 296786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 296789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 296792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296796 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 296796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296801 */   GIR_RootConstrainSelectedInstOperands,
     /* 296802 */   // GIR_Coverage, 8572,
     /* 296802 */   GIR_Done,
     /* 296803 */ // Label 5866: @296803
     /* 296803 */ GIM_Reject,
     /* 296804 */ // Label 5854: @296804
     /* 296804 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(296832), // Rule ID 8571 //
     /* 296809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 296818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 296821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296825 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 296825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296830 */   GIR_RootConstrainSelectedInstOperands,
     /* 296831 */   // GIR_Coverage, 8571,
     /* 296831 */   GIR_Done,
     /* 296832 */ // Label 5867: @296832
     /* 296832 */ GIM_Reject,
     /* 296833 */ // Label 5855: @296833
     /* 296833 */ GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(296917),
     /* 296838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 296844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 296847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296851 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(296901), // Rule ID 3180 //
     /* 296856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296879 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296883 */     // MIs[2] Operand 1
     /* 296883 */     // No operand predicates
     /* 296883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296885 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296890 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296892 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296894 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296899 */     GIR_RootConstrainSelectedInstOperands,
     /* 296900 */     // GIR_Coverage, 3180,
     /* 296900 */     GIR_EraseRootFromParent_Done,
     /* 296901 */   // Label 5869: @296901
     /* 296901 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(296916), // Rule ID 2741 //
     /* 296906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296909 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 296909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296914 */     GIR_RootConstrainSelectedInstOperands,
     /* 296915 */     // GIR_Coverage, 2741,
     /* 296915 */     GIR_Done,
     /* 296916 */   // Label 5870: @296916
     /* 296916 */   GIM_Reject,
     /* 296917 */ // Label 5868: @296917
     /* 296917 */ GIM_Reject,
     /* 296918 */ // Label 5856: @296918
     /* 296918 */ GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(297002),
     /* 296923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 296929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 296932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296936 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(296986), // Rule ID 3182 //
     /* 296941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296964 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296968 */     // MIs[2] Operand 1
     /* 296968 */     // No operand predicates
     /* 296968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296970 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296975 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296977 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296979 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296984 */     GIR_RootConstrainSelectedInstOperands,
     /* 296985 */     // GIR_Coverage, 3182,
     /* 296985 */     GIR_EraseRootFromParent_Done,
     /* 296986 */   // Label 5872: @296986
     /* 296986 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(297001), // Rule ID 2742 //
     /* 296991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296994 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 296994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296999 */     GIR_RootConstrainSelectedInstOperands,
     /* 297000 */     // GIR_Coverage, 2742,
     /* 297000 */     GIR_Done,
     /* 297001 */   // Label 5873: @297001
     /* 297001 */   GIM_Reject,
     /* 297002 */ // Label 5871: @297002
     /* 297002 */ GIM_Reject,
     /* 297003 */ // Label 5857: @297003
     /* 297003 */ GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(297168),
     /* 297008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 297011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 297014 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(297071), // Rule ID 3183 //
     /* 297019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 297025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297049 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 297053 */     // MIs[2] Operand 1
     /* 297053 */     // No operand predicates
     /* 297053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297055 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 297055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 297058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297060 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297062 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297064 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 297069 */     GIR_RootConstrainSelectedInstOperands,
     /* 297070 */     // GIR_Coverage, 3183,
     /* 297070 */     GIR_EraseRootFromParent_Done,
     /* 297071 */   // Label 5875: @297071
     /* 297071 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(297123), // Rule ID 7593 //
     /* 297076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 297095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 297099 */     // MIs[0] Op2
     /* 297099 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297106 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 297106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 297109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297121 */     GIR_RootConstrainSelectedInstOperands,
     /* 297122 */     // GIR_Coverage, 7593,
     /* 297122 */     GIR_EraseRootFromParent_Done,
     /* 297123 */   // Label 5876: @297123
     /* 297123 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(297145), // Rule ID 2737 //
     /* 297128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 297134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297138 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 297138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 297143 */     GIR_RootConstrainSelectedInstOperands,
     /* 297144 */     // GIR_Coverage, 2737,
     /* 297144 */     GIR_Done,
     /* 297145 */   // Label 5877: @297145
     /* 297145 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(297167), // Rule ID 2743 //
     /* 297150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 297156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297160 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 297160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 297165 */     GIR_RootConstrainSelectedInstOperands,
     /* 297166 */     // GIR_Coverage, 2743,
     /* 297166 */     GIR_Done,
     /* 297167 */   // Label 5878: @297167
     /* 297167 */   GIM_Reject,
     /* 297168 */ // Label 5874: @297168
     /* 297168 */ GIM_Reject,
     /* 297169 */ // Label 5858: @297169
     /* 297169 */ GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(297197), // Rule ID 8570 //
     /* 297174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 297180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 297183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 297186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297190 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 297190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297195 */   GIR_RootConstrainSelectedInstOperands,
     /* 297196 */   // GIR_Coverage, 8570,
     /* 297196 */   GIR_Done,
     /* 297197 */ // Label 5879: @297197
     /* 297197 */ GIM_Reject,
     /* 297198 */ // Label 5859: @297198
     /* 297198 */ GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(297282),
     /* 297203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 297206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 297209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 297212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297216 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(297266), // Rule ID 3179 //
     /* 297221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297244 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 297248 */     // MIs[2] Operand 1
     /* 297248 */     // No operand predicates
     /* 297248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297250 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 297250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 297253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297255 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297257 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297259 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 297264 */     GIR_RootConstrainSelectedInstOperands,
     /* 297265 */     // GIR_Coverage, 3179,
     /* 297265 */     GIR_EraseRootFromParent_Done,
     /* 297266 */   // Label 5881: @297266
     /* 297266 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(297281), // Rule ID 2739 //
     /* 297271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297274 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 297274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297279 */     GIR_RootConstrainSelectedInstOperands,
     /* 297280 */     // GIR_Coverage, 2739,
     /* 297280 */     GIR_Done,
     /* 297281 */   // Label 5882: @297281
     /* 297281 */   GIM_Reject,
     /* 297282 */ // Label 5880: @297282
     /* 297282 */ GIM_Reject,
     /* 297283 */ // Label 5860: @297283
     /* 297283 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(297448),
     /* 297288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 297291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 297294 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(297351), // Rule ID 3181 //
     /* 297299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297329 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 297333 */     // MIs[2] Operand 1
     /* 297333 */     // No operand predicates
     /* 297333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297335 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 297335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 297338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297340 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297342 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297344 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 297349 */     GIR_RootConstrainSelectedInstOperands,
     /* 297350 */     // GIR_Coverage, 3181,
     /* 297350 */     GIR_EraseRootFromParent_Done,
     /* 297351 */   // Label 5884: @297351
     /* 297351 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(297403), // Rule ID 7591 //
     /* 297356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 297375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 297379 */     // MIs[0] Op2
     /* 297379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297386 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 297389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297401 */     GIR_RootConstrainSelectedInstOperands,
     /* 297402 */     // GIR_Coverage, 7591,
     /* 297402 */     GIR_EraseRootFromParent_Done,
     /* 297403 */   // Label 5885: @297403
     /* 297403 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(297425), // Rule ID 2736 //
     /* 297408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297418 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297423 */     GIR_RootConstrainSelectedInstOperands,
     /* 297424 */     // GIR_Coverage, 2736,
     /* 297424 */     GIR_Done,
     /* 297425 */   // Label 5886: @297425
     /* 297425 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(297447), // Rule ID 2740 //
     /* 297430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297440 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 297440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297445 */     GIR_RootConstrainSelectedInstOperands,
     /* 297446 */     // GIR_Coverage, 2740,
     /* 297446 */     GIR_Done,
     /* 297447 */   // Label 5887: @297447
     /* 297447 */   GIM_Reject,
     /* 297448 */ // Label 5883: @297448
     /* 297448 */ GIM_Reject,
     /* 297449 */ // Label 5861: @297449
     /* 297449 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(297477), // Rule ID 8569 //
     /* 297454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 297463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 297466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297470 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 297470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297475 */   GIR_RootConstrainSelectedInstOperands,
     /* 297476 */   // GIR_Coverage, 8569,
     /* 297476 */   GIR_Done,
     /* 297477 */ // Label 5888: @297477
     /* 297477 */ GIM_Reject,
     /* 297478 */ // Label 5862: @297478
     /* 297478 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(297643),
     /* 297483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297489 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(297546), // Rule ID 3178 //
     /* 297494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297524 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 297528 */     // MIs[2] Operand 1
     /* 297528 */     // No operand predicates
     /* 297528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297530 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 297530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 297533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297535 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297537 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297539 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 297544 */     GIR_RootConstrainSelectedInstOperands,
     /* 297545 */     // GIR_Coverage, 3178,
     /* 297545 */     GIR_EraseRootFromParent_Done,
     /* 297546 */   // Label 5890: @297546
     /* 297546 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(297598), // Rule ID 7589 //
     /* 297551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297574 */     // MIs[0] Op2
     /* 297574 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297581 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 297584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297596 */     GIR_RootConstrainSelectedInstOperands,
     /* 297597 */     // GIR_Coverage, 7589,
     /* 297597 */     GIR_EraseRootFromParent_Done,
     /* 297598 */   // Label 5891: @297598
     /* 297598 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(297620), // Rule ID 2735 //
     /* 297603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297613 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297618 */     GIR_RootConstrainSelectedInstOperands,
     /* 297619 */     // GIR_Coverage, 2735,
     /* 297619 */     GIR_Done,
     /* 297620 */   // Label 5892: @297620
     /* 297620 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(297642), // Rule ID 2738 //
     /* 297625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297635 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 297635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297640 */     GIR_RootConstrainSelectedInstOperands,
     /* 297641 */     // GIR_Coverage, 2738,
     /* 297641 */     GIR_Done,
     /* 297642 */   // Label 5893: @297642
     /* 297642 */   GIM_Reject,
     /* 297643 */ // Label 5889: @297643
     /* 297643 */ GIM_Reject,
     /* 297644 */ // Label 5863: @297644
     /* 297644 */ GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(297672), // Rule ID 8568 //
     /* 297649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 297658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 297661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297665 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 297665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297670 */   GIR_RootConstrainSelectedInstOperands,
     /* 297671 */   // GIR_Coverage, 8568,
     /* 297671 */   GIR_Done,
     /* 297672 */ // Label 5894: @297672
     /* 297672 */ GIM_Reject,
     /* 297673 */ // Label 5864: @297673
     /* 297673 */ GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(297759),
     /* 297678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297684 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(297736), // Rule ID 7587 //
     /* 297689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297712 */     // MIs[0] Op2
     /* 297712 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297719 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 297722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297734 */     GIR_RootConstrainSelectedInstOperands,
     /* 297735 */     // GIR_Coverage, 7587,
     /* 297735 */     GIR_EraseRootFromParent_Done,
     /* 297736 */   // Label 5896: @297736
     /* 297736 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(297758), // Rule ID 2734 //
     /* 297741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 297747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297751 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 297756 */     GIR_RootConstrainSelectedInstOperands,
     /* 297757 */     // GIR_Coverage, 2734,
     /* 297757 */     GIR_Done,
     /* 297758 */   // Label 5897: @297758
     /* 297758 */   GIM_Reject,
     /* 297759 */ // Label 5895: @297759
     /* 297759 */ GIM_Reject,
     /* 297760 */ // Label 5865: @297760
     /* 297760 */ GIM_Reject,
     /* 297761 */ // Label 53: @297761
     /* 297761 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5902*/ GIMT_Encode4(298244),
     /* 297772 */ /*GILLT_s64*//*Label 5898*/ GIMT_Encode4(297808), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297792 */ /*GILLT_v4s32*//*Label 5899*/ GIMT_Encode4(297839), GIMT_Encode4(0),
     /* 297800 */ /*GILLT_v8s16*//*Label 5900*/ GIMT_Encode4(297974),
     /* 297804 */ /*GILLT_v16s8*//*Label 5901*/ GIMT_Encode4(298109),
     /* 297808 */ // Label 5898: @297808
     /* 297808 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(297838), // Rule ID 128 //
     /* 297813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297831 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 297836 */   GIR_RootConstrainSelectedInstOperands,
     /* 297837 */   // GIR_Coverage, 128,
     /* 297837 */   GIR_Done,
     /* 297838 */ // Label 5903: @297838
     /* 297838 */ GIM_Reject,
     /* 297839 */ // Label 5899: @297839
     /* 297839 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(297973), // Rule ID 6607 //
     /* 297844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297862 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297862 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297865 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 297869 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297874 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297878 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297884 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297887 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297891 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297896 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297902 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297907 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297924 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297930 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297935 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 297947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297952 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297955 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 297963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297971 */   GIR_RootConstrainSelectedInstOperands,
     /* 297972 */   // GIR_Coverage, 6607,
     /* 297972 */   GIR_EraseRootFromParent_Done,
     /* 297973 */ // Label 5904: @297973
     /* 297973 */ GIM_Reject,
     /* 297974 */ // Label 5900: @297974
     /* 297974 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(298108), // Rule ID 6606 //
     /* 297979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297997 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 297997 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298000 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 298004 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298009 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298013 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298019 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298022 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298026 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298031 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298037 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298042 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298047 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298050 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298054 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298059 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298065 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298070 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 298082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298087 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298090 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 298098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298106 */   GIR_RootConstrainSelectedInstOperands,
     /* 298107 */   // GIR_Coverage, 6606,
     /* 298107 */   GIR_EraseRootFromParent_Done,
     /* 298108 */ // Label 5905: @298108
     /* 298108 */ GIM_Reject,
     /* 298109 */ // Label 5901: @298109
     /* 298109 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(298243), // Rule ID 6605 //
     /* 298114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298132 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 298132 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298135 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 298139 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298144 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298148 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298154 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298157 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298161 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298166 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298172 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298177 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298194 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298200 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298205 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 298217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298222 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298225 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 298233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298241 */   GIR_RootConstrainSelectedInstOperands,
     /* 298242 */   // GIR_Coverage, 6605,
     /* 298242 */   GIR_EraseRootFromParent_Done,
     /* 298243 */ // Label 5906: @298243
     /* 298243 */ GIM_Reject,
     /* 298244 */ // Label 5902: @298244
     /* 298244 */ GIM_Reject,
     /* 298245 */ // Label 54: @298245
     /* 298245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5911*/ GIMT_Encode4(298728),
     /* 298256 */ /*GILLT_s64*//*Label 5907*/ GIMT_Encode4(298292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298276 */ /*GILLT_v4s32*//*Label 5908*/ GIMT_Encode4(298323), GIMT_Encode4(0),
     /* 298284 */ /*GILLT_v8s16*//*Label 5909*/ GIMT_Encode4(298458),
     /* 298288 */ /*GILLT_v16s8*//*Label 5910*/ GIMT_Encode4(298593),
     /* 298292 */ // Label 5907: @298292
     /* 298292 */ GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(298322), // Rule ID 127 //
     /* 298297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 298307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 298311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 298315 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 298315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 298320 */   GIR_RootConstrainSelectedInstOperands,
     /* 298321 */   // GIR_Coverage, 127,
     /* 298321 */   GIR_Done,
     /* 298322 */ // Label 5912: @298322
     /* 298322 */ GIM_Reject,
     /* 298323 */ // Label 5908: @298323
     /* 298323 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(298457), // Rule ID 6604 //
     /* 298328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298346 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 298346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 298353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298358 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298362 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298368 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298371 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298375 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298380 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298386 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298391 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298396 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298399 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298403 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298408 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298414 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298419 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 298431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298439 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 298447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298455 */   GIR_RootConstrainSelectedInstOperands,
     /* 298456 */   // GIR_Coverage, 6604,
     /* 298456 */   GIR_EraseRootFromParent_Done,
     /* 298457 */ // Label 5913: @298457
     /* 298457 */ GIM_Reject,
     /* 298458 */ // Label 5909: @298458
     /* 298458 */ GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(298592), // Rule ID 6603 //
     /* 298463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298481 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 298481 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298484 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 298488 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298493 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298497 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298503 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298506 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298510 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298515 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298521 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298526 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298531 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298534 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298538 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298543 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298549 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298554 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 298566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298574 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 298582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298590 */   GIR_RootConstrainSelectedInstOperands,
     /* 298591 */   // GIR_Coverage, 6603,
     /* 298591 */   GIR_EraseRootFromParent_Done,
     /* 298592 */ // Label 5914: @298592
     /* 298592 */ GIM_Reject,
     /* 298593 */ // Label 5910: @298593
     /* 298593 */ GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(298727), // Rule ID 6602 //
     /* 298598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298616 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 298616 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298619 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 298623 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298628 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298632 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298638 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298641 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298645 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298650 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298656 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298661 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298666 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298669 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298673 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298678 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298684 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298689 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 298701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298709 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 298717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298725 */   GIR_RootConstrainSelectedInstOperands,
     /* 298726 */   // GIR_Coverage, 6602,
     /* 298726 */   GIR_EraseRootFromParent_Done,
     /* 298727 */ // Label 5915: @298727
     /* 298727 */ GIM_Reject,
     /* 298728 */ // Label 5911: @298728
     /* 298728 */ GIM_Reject,
     /* 298729 */ // Label 55: @298729
     /* 298729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5928*/ GIMT_Encode4(299200),
     /* 298740 */ /*GILLT_s64*//*Label 5916*/ GIMT_Encode4(298824), GIMT_Encode4(0),
     /* 298748 */ /*GILLT_v2s32*//*Label 5917*/ GIMT_Encode4(298858),
     /* 298752 */ /*GILLT_v2s64*//*Label 5918*/ GIMT_Encode4(298892),
     /* 298756 */ /*GILLT_v4s16*//*Label 5919*/ GIMT_Encode4(298926),
     /* 298760 */ /*GILLT_v4s32*//*Label 5920*/ GIMT_Encode4(298960),
     /* 298764 */ /*GILLT_v8s8*//*Label 5921*/ GIMT_Encode4(298994),
     /* 298768 */ /*GILLT_v8s16*//*Label 5922*/ GIMT_Encode4(299028),
     /* 298772 */ /*GILLT_v16s8*//*Label 5923*/ GIMT_Encode4(299062), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298792 */ /*GILLT_nxv2s64*//*Label 5924*/ GIMT_Encode4(299096), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298804 */ /*GILLT_nxv4s32*//*Label 5925*/ GIMT_Encode4(299122), GIMT_Encode4(0),
     /* 298812 */ /*GILLT_nxv8s16*//*Label 5926*/ GIMT_Encode4(299148), GIMT_Encode4(0),
     /* 298820 */ /*GILLT_nxv16s8*//*Label 5927*/ GIMT_Encode4(299174),
     /* 298824 */ // Label 5916: @298824
     /* 298824 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298857), // Rule ID 1649 //
     /* 298829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298850 */   // (uaddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 298855 */   GIR_RootConstrainSelectedInstOperands,
     /* 298856 */   // GIR_Coverage, 1649,
     /* 298856 */   GIR_Done,
     /* 298857 */ // Label 5929: @298857
     /* 298857 */ GIM_Reject,
     /* 298858 */ // Label 5917: @298858
     /* 298858 */ GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(298891), // Rule ID 1547 //
     /* 298863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298884 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 298889 */   GIR_RootConstrainSelectedInstOperands,
     /* 298890 */   // GIR_Coverage, 1547,
     /* 298890 */   GIR_Done,
     /* 298891 */ // Label 5930: @298891
     /* 298891 */ GIM_Reject,
     /* 298892 */ // Label 5918: @298892
     /* 298892 */ GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(298925), // Rule ID 1549 //
     /* 298897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298918 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 298923 */   GIR_RootConstrainSelectedInstOperands,
     /* 298924 */   // GIR_Coverage, 1549,
     /* 298924 */   GIR_Done,
     /* 298925 */ // Label 5931: @298925
     /* 298925 */ GIM_Reject,
     /* 298926 */ // Label 5919: @298926
     /* 298926 */ GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(298959), // Rule ID 1545 //
     /* 298931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298952 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 298957 */   GIR_RootConstrainSelectedInstOperands,
     /* 298958 */   // GIR_Coverage, 1545,
     /* 298958 */   GIR_Done,
     /* 298959 */ // Label 5932: @298959
     /* 298959 */ GIM_Reject,
     /* 298960 */ // Label 5920: @298960
     /* 298960 */ GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(298993), // Rule ID 1548 //
     /* 298965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298986 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 298986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 298991 */   GIR_RootConstrainSelectedInstOperands,
     /* 298992 */   // GIR_Coverage, 1548,
     /* 298992 */   GIR_Done,
     /* 298993 */ // Label 5933: @298993
     /* 298993 */ GIM_Reject,
     /* 298994 */ // Label 5921: @298994
     /* 298994 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(299027), // Rule ID 1543 //
     /* 298999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 299005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 299008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299020 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 299020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 299025 */   GIR_RootConstrainSelectedInstOperands,
     /* 299026 */   // GIR_Coverage, 1543,
     /* 299026 */   GIR_Done,
     /* 299027 */ // Label 5934: @299027
     /* 299027 */ GIM_Reject,
     /* 299028 */ // Label 5922: @299028
     /* 299028 */ GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(299061), // Rule ID 1546 //
     /* 299033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299054 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 299054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 299059 */   GIR_RootConstrainSelectedInstOperands,
     /* 299060 */   // GIR_Coverage, 1546,
     /* 299060 */   GIR_Done,
     /* 299061 */ // Label 5935: @299061
     /* 299061 */ GIM_Reject,
     /* 299062 */ // Label 5923: @299062
     /* 299062 */ GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(299095), // Rule ID 1544 //
     /* 299067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299088 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 299088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 299093 */   GIR_RootConstrainSelectedInstOperands,
     /* 299094 */   // GIR_Coverage, 1544,
     /* 299094 */   GIR_Done,
     /* 299095 */ // Label 5936: @299095
     /* 299095 */ GIM_Reject,
     /* 299096 */ // Label 5924: @299096
     /* 299096 */ GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(299121), // Rule ID 7545 //
     /* 299101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 299107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 299110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299114 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 299114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 299119 */   GIR_RootConstrainSelectedInstOperands,
     /* 299120 */   // GIR_Coverage, 7545,
     /* 299120 */   GIR_Done,
     /* 299121 */ // Label 5937: @299121
     /* 299121 */ GIM_Reject,
     /* 299122 */ // Label 5925: @299122
     /* 299122 */ GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(299147), // Rule ID 7544 //
     /* 299127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299140 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 299140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 299145 */   GIR_RootConstrainSelectedInstOperands,
     /* 299146 */   // GIR_Coverage, 7544,
     /* 299146 */   GIR_Done,
     /* 299147 */ // Label 5938: @299147
     /* 299147 */ GIM_Reject,
     /* 299148 */ // Label 5926: @299148
     /* 299148 */ GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(299173), // Rule ID 7543 //
     /* 299153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299166 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 299166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 299171 */   GIR_RootConstrainSelectedInstOperands,
     /* 299172 */   // GIR_Coverage, 7543,
     /* 299172 */   GIR_Done,
     /* 299173 */ // Label 5939: @299173
     /* 299173 */ GIM_Reject,
     /* 299174 */ // Label 5927: @299174
     /* 299174 */ GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(299199), // Rule ID 7542 //
     /* 299179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299192 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 299192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 299197 */   GIR_RootConstrainSelectedInstOperands,
     /* 299198 */   // GIR_Coverage, 7542,
     /* 299198 */   GIR_Done,
     /* 299199 */ // Label 5940: @299199
     /* 299199 */ GIM_Reject,
     /* 299200 */ // Label 5928: @299200
     /* 299200 */ GIM_Reject,
     /* 299201 */ // Label 56: @299201
     /* 299201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5953*/ GIMT_Encode4(301576),
     /* 299212 */ /*GILLT_s64*//*Label 5941*/ GIMT_Encode4(299296), GIMT_Encode4(0),
     /* 299220 */ /*GILLT_v2s32*//*Label 5942*/ GIMT_Encode4(299330),
     /* 299224 */ /*GILLT_v2s64*//*Label 5943*/ GIMT_Encode4(299364),
     /* 299228 */ /*GILLT_v4s16*//*Label 5944*/ GIMT_Encode4(300350),
     /* 299232 */ /*GILLT_v4s32*//*Label 5945*/ GIMT_Encode4(300384),
     /* 299236 */ /*GILLT_v8s8*//*Label 5946*/ GIMT_Encode4(301370),
     /* 299240 */ /*GILLT_v8s16*//*Label 5947*/ GIMT_Encode4(301404),
     /* 299244 */ /*GILLT_v16s8*//*Label 5948*/ GIMT_Encode4(301438), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299264 */ /*GILLT_nxv2s64*//*Label 5949*/ GIMT_Encode4(301472), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299276 */ /*GILLT_nxv4s32*//*Label 5950*/ GIMT_Encode4(301498), GIMT_Encode4(0),
     /* 299284 */ /*GILLT_nxv8s16*//*Label 5951*/ GIMT_Encode4(301524), GIMT_Encode4(0),
     /* 299292 */ /*GILLT_nxv16s8*//*Label 5952*/ GIMT_Encode4(301550),
     /* 299296 */ // Label 5941: @299296
     /* 299296 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299329), // Rule ID 1640 //
     /* 299301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299322 */   // (saddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 299322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 299327 */   GIR_RootConstrainSelectedInstOperands,
     /* 299328 */   // GIR_Coverage, 1640,
     /* 299328 */   GIR_Done,
     /* 299329 */ // Label 5954: @299329
     /* 299329 */ GIM_Reject,
     /* 299330 */ // Label 5942: @299330
     /* 299330 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299363), // Rule ID 1424 //
     /* 299335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299356 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 299361 */   GIR_RootConstrainSelectedInstOperands,
     /* 299362 */   // GIR_Coverage, 1424,
     /* 299362 */   GIR_Done,
     /* 299363 */ // Label 5955: @299363
     /* 299363 */ GIM_Reject,
     /* 299364 */ // Label 5943: @299364
     /* 299364 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(300349),
     /* 299369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 299375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299379 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299501), // Rule ID 13764 //
     /* 299384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299395 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299398 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299407 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299439 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299452 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299456 */     // MIs[4] Operand 1
     /* 299456 */     // No operand predicates
     /* 299456 */     // MIs[2] Operand 2
     /* 299456 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299471 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299480 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299499 */     GIR_RootConstrainSelectedInstOperands,
     /* 299500 */     // GIR_Coverage, 13764,
     /* 299500 */     GIR_EraseRootFromParent_Done,
     /* 299501 */   // Label 5957: @299501
     /* 299501 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299623), // Rule ID 2064 //
     /* 299506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299557 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299561 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299570 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299574 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299578 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299582 */     // MIs[4] Operand 1
     /* 299582 */     // No operand predicates
     /* 299582 */     // MIs[2] Operand 2
     /* 299582 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299593 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299602 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299621 */     GIR_RootConstrainSelectedInstOperands,
     /* 299622 */     // GIR_Coverage, 2064,
     /* 299622 */     GIR_EraseRootFromParent_Done,
     /* 299623 */   // Label 5958: @299623
     /* 299623 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(299742), // Rule ID 13762 //
     /* 299628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299688 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299693 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299697 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299701 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299705 */     // MIs[4] Operand 1
     /* 299705 */     // No operand predicates
     /* 299705 */     // MIs[2] Operand 2
     /* 299705 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299720 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299722 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299740 */     GIR_RootConstrainSelectedInstOperands,
     /* 299741 */     // GIR_Coverage, 13762,
     /* 299741 */     GIR_EraseRootFromParent_Done,
     /* 299742 */   // Label 5959: @299742
     /* 299742 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(299861), // Rule ID 2062 //
     /* 299747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299774 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299807 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299811 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299820 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299824 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299828 */     // MIs[4] Operand 1
     /* 299828 */     // No operand predicates
     /* 299828 */     // MIs[2] Operand 2
     /* 299828 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299841 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299859 */     GIR_RootConstrainSelectedInstOperands,
     /* 299860 */     // GIR_Coverage, 2062,
     /* 299860 */     GIR_EraseRootFromParent_Done,
     /* 299861 */   // Label 5960: @299861
     /* 299861 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(299932), // Rule ID 13662 //
     /* 299866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299877 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299880 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299889 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299913 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299930 */     GIR_RootConstrainSelectedInstOperands,
     /* 299931 */     // GIR_Coverage, 13662,
     /* 299931 */     GIR_EraseRootFromParent_Done,
     /* 299932 */   // Label 5961: @299932
     /* 299932 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(300003), // Rule ID 1749 //
     /* 299937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299952 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299955 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299964 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299984 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300001 */     GIR_RootConstrainSelectedInstOperands,
     /* 300002 */     // GIR_Coverage, 1749,
     /* 300002 */     GIR_EraseRootFromParent_Done,
     /* 300003 */   // Label 5962: @300003
     /* 300003 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300099), // Rule ID 13763 //
     /* 300008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300019 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300022 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300031 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300073 */     // MIs[3] Operand 1
     /* 300073 */     // No operand predicates
     /* 300073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300079 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 300082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300097 */     GIR_RootConstrainSelectedInstOperands,
     /* 300098 */     // GIR_Coverage, 13763,
     /* 300098 */     GIR_EraseRootFromParent_Done,
     /* 300099 */   // Label 5963: @300099
     /* 300099 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(300195), // Rule ID 2063 //
     /* 300104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300119 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300122 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300169 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300173 */     // MIs[3] Operand 1
     /* 300173 */     // No operand predicates
     /* 300173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300175 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 300178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300193 */     GIR_RootConstrainSelectedInstOperands,
     /* 300194 */     // GIR_Coverage, 2063,
     /* 300194 */     GIR_EraseRootFromParent_Done,
     /* 300195 */   // Label 5964: @300195
     /* 300195 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(300260), // Rule ID 13661 //
     /* 300200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300211 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300214 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300243 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 300246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300258 */     GIR_RootConstrainSelectedInstOperands,
     /* 300259 */     // GIR_Coverage, 13661,
     /* 300259 */     GIR_EraseRootFromParent_Done,
     /* 300260 */   // Label 5965: @300260
     /* 300260 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(300325), // Rule ID 1748 //
     /* 300265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300280 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300283 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300292 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300308 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 300311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300323 */     GIR_RootConstrainSelectedInstOperands,
     /* 300324 */     // GIR_Coverage, 1748,
     /* 300324 */     GIR_EraseRootFromParent_Done,
     /* 300325 */   // Label 5966: @300325
     /* 300325 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(300348), // Rule ID 1426 //
     /* 300330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300341 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 300341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 300346 */     GIR_RootConstrainSelectedInstOperands,
     /* 300347 */     // GIR_Coverage, 1426,
     /* 300347 */     GIR_Done,
     /* 300348 */   // Label 5967: @300348
     /* 300348 */   GIM_Reject,
     /* 300349 */ // Label 5956: @300349
     /* 300349 */ GIM_Reject,
     /* 300350 */ // Label 5944: @300350
     /* 300350 */ GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(300383), // Rule ID 1422 //
     /* 300355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300376 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 300381 */   GIR_RootConstrainSelectedInstOperands,
     /* 300382 */   // GIR_Coverage, 1422,
     /* 300382 */   GIR_Done,
     /* 300383 */ // Label 5968: @300383
     /* 300383 */ GIM_Reject,
     /* 300384 */ // Label 5945: @300384
     /* 300384 */ GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(301369),
     /* 300389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300399 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(300521), // Rule ID 13761 //
     /* 300404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300415 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300418 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300451 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300455 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300472 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300476 */     // MIs[4] Operand 1
     /* 300476 */     // No operand predicates
     /* 300476 */     // MIs[2] Operand 2
     /* 300476 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300491 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300500 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300519 */     GIR_RootConstrainSelectedInstOperands,
     /* 300520 */     // GIR_Coverage, 13761,
     /* 300520 */     GIR_EraseRootFromParent_Done,
     /* 300521 */   // Label 5970: @300521
     /* 300521 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(300643), // Rule ID 2061 //
     /* 300526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300541 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300544 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300553 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300577 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300581 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300585 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300590 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300594 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300598 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300602 */     // MIs[4] Operand 1
     /* 300602 */     // No operand predicates
     /* 300602 */     // MIs[2] Operand 2
     /* 300602 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300613 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300622 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300641 */     GIR_RootConstrainSelectedInstOperands,
     /* 300642 */     // GIR_Coverage, 2061,
     /* 300642 */     GIR_EraseRootFromParent_Done,
     /* 300643 */   // Label 5971: @300643
     /* 300643 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(300762), // Rule ID 13759 //
     /* 300648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300659 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300662 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300671 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300713 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300717 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300721 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300725 */     // MIs[4] Operand 1
     /* 300725 */     // No operand predicates
     /* 300725 */     // MIs[2] Operand 2
     /* 300725 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300740 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300742 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300760 */     GIR_RootConstrainSelectedInstOperands,
     /* 300761 */     // GIR_Coverage, 13759,
     /* 300761 */     GIR_EraseRootFromParent_Done,
     /* 300762 */   // Label 5972: @300762
     /* 300762 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(300881), // Rule ID 2059 //
     /* 300767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300782 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300785 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300844 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300848 */     // MIs[4] Operand 1
     /* 300848 */     // No operand predicates
     /* 300848 */     // MIs[2] Operand 2
     /* 300848 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300859 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300861 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300879 */     GIR_RootConstrainSelectedInstOperands,
     /* 300880 */     // GIR_Coverage, 2059,
     /* 300880 */     GIR_EraseRootFromParent_Done,
     /* 300881 */   // Label 5973: @300881
     /* 300881 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(300952), // Rule ID 13660 //
     /* 300886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300897 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300900 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300909 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300933 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300950 */     GIR_RootConstrainSelectedInstOperands,
     /* 300951 */     // GIR_Coverage, 13660,
     /* 300951 */     GIR_EraseRootFromParent_Done,
     /* 300952 */   // Label 5974: @300952
     /* 300952 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(301023), // Rule ID 1747 //
     /* 300957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300972 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300975 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 301004 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 301007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 301016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 301021 */     GIR_RootConstrainSelectedInstOperands,
     /* 301022 */     // GIR_Coverage, 1747,
     /* 301022 */     GIR_EraseRootFromParent_Done,
     /* 301023 */   // Label 5975: @301023
     /* 301023 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(301119), // Rule ID 13760 //
     /* 301028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301039 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301042 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301089 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301093 */     // MIs[3] Operand 1
     /* 301093 */     // No operand predicates
     /* 301093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301099 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 301102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 301106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301117 */     GIR_RootConstrainSelectedInstOperands,
     /* 301118 */     // GIR_Coverage, 13760,
     /* 301118 */     GIR_EraseRootFromParent_Done,
     /* 301119 */   // Label 5976: @301119
     /* 301119 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(301215), // Rule ID 2060 //
     /* 301124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301139 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301142 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301151 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301193 */     // MIs[3] Operand 1
     /* 301193 */     // No operand predicates
     /* 301193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301195 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 301198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301213 */     GIR_RootConstrainSelectedInstOperands,
     /* 301214 */     // GIR_Coverage, 2060,
     /* 301214 */     GIR_EraseRootFromParent_Done,
     /* 301215 */   // Label 5977: @301215
     /* 301215 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(301280), // Rule ID 13659 //
     /* 301220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301231 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301234 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301243 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301263 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 301266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 301270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 301278 */     GIR_RootConstrainSelectedInstOperands,
     /* 301279 */     // GIR_Coverage, 13659,
     /* 301279 */     GIR_EraseRootFromParent_Done,
     /* 301280 */   // Label 5978: @301280
     /* 301280 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(301345), // Rule ID 1746 //
     /* 301285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301300 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301303 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301328 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 301331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 301343 */     GIR_RootConstrainSelectedInstOperands,
     /* 301344 */     // GIR_Coverage, 1746,
     /* 301344 */     GIR_EraseRootFromParent_Done,
     /* 301345 */   // Label 5979: @301345
     /* 301345 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(301368), // Rule ID 1425 //
     /* 301350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301361 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 301366 */     GIR_RootConstrainSelectedInstOperands,
     /* 301367 */     // GIR_Coverage, 1425,
     /* 301367 */     GIR_Done,
     /* 301368 */   // Label 5980: @301368
     /* 301368 */   GIM_Reject,
     /* 301369 */ // Label 5969: @301369
     /* 301369 */ GIM_Reject,
     /* 301370 */ // Label 5946: @301370
     /* 301370 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(301403), // Rule ID 1420 //
     /* 301375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301396 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 301401 */   GIR_RootConstrainSelectedInstOperands,
     /* 301402 */   // GIR_Coverage, 1420,
     /* 301402 */   GIR_Done,
     /* 301403 */ // Label 5981: @301403
     /* 301403 */ GIM_Reject,
     /* 301404 */ // Label 5947: @301404
     /* 301404 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(301437), // Rule ID 1423 //
     /* 301409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301430 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 301435 */   GIR_RootConstrainSelectedInstOperands,
     /* 301436 */   // GIR_Coverage, 1423,
     /* 301436 */   GIR_Done,
     /* 301437 */ // Label 5982: @301437
     /* 301437 */ GIM_Reject,
     /* 301438 */ // Label 5948: @301438
     /* 301438 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(301471), // Rule ID 1421 //
     /* 301443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301464 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 301469 */   GIR_RootConstrainSelectedInstOperands,
     /* 301470 */   // GIR_Coverage, 1421,
     /* 301470 */   GIR_Done,
     /* 301471 */ // Label 5983: @301471
     /* 301471 */ GIM_Reject,
     /* 301472 */ // Label 5949: @301472
     /* 301472 */ GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(301497), // Rule ID 7541 //
     /* 301477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301490 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301495 */   GIR_RootConstrainSelectedInstOperands,
     /* 301496 */   // GIR_Coverage, 7541,
     /* 301496 */   GIR_Done,
     /* 301497 */ // Label 5984: @301497
     /* 301497 */ GIM_Reject,
     /* 301498 */ // Label 5950: @301498
     /* 301498 */ GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(301523), // Rule ID 7540 //
     /* 301503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301516 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301521 */   GIR_RootConstrainSelectedInstOperands,
     /* 301522 */   // GIR_Coverage, 7540,
     /* 301522 */   GIR_Done,
     /* 301523 */ // Label 5985: @301523
     /* 301523 */ GIM_Reject,
     /* 301524 */ // Label 5951: @301524
     /* 301524 */ GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(301549), // Rule ID 7539 //
     /* 301529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301542 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301547 */   GIR_RootConstrainSelectedInstOperands,
     /* 301548 */   // GIR_Coverage, 7539,
     /* 301548 */   GIR_Done,
     /* 301549 */ // Label 5986: @301549
     /* 301549 */ GIM_Reject,
     /* 301550 */ // Label 5952: @301550
     /* 301550 */ GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(301575), // Rule ID 7538 //
     /* 301555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301568 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301573 */   GIR_RootConstrainSelectedInstOperands,
     /* 301574 */   // GIR_Coverage, 7538,
     /* 301574 */   GIR_Done,
     /* 301575 */ // Label 5987: @301575
     /* 301575 */ GIM_Reject,
     /* 301576 */ // Label 5953: @301576
     /* 301576 */ GIM_Reject,
     /* 301577 */ // Label 57: @301577
     /* 301577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6000*/ GIMT_Encode4(302048),
     /* 301588 */ /*GILLT_s64*//*Label 5988*/ GIMT_Encode4(301672), GIMT_Encode4(0),
     /* 301596 */ /*GILLT_v2s32*//*Label 5989*/ GIMT_Encode4(301706),
     /* 301600 */ /*GILLT_v2s64*//*Label 5990*/ GIMT_Encode4(301740),
     /* 301604 */ /*GILLT_v4s16*//*Label 5991*/ GIMT_Encode4(301774),
     /* 301608 */ /*GILLT_v4s32*//*Label 5992*/ GIMT_Encode4(301808),
     /* 301612 */ /*GILLT_v8s8*//*Label 5993*/ GIMT_Encode4(301842),
     /* 301616 */ /*GILLT_v8s16*//*Label 5994*/ GIMT_Encode4(301876),
     /* 301620 */ /*GILLT_v16s8*//*Label 5995*/ GIMT_Encode4(301910), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301640 */ /*GILLT_nxv2s64*//*Label 5996*/ GIMT_Encode4(301944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301652 */ /*GILLT_nxv4s32*//*Label 5997*/ GIMT_Encode4(301970), GIMT_Encode4(0),
     /* 301660 */ /*GILLT_nxv8s16*//*Label 5998*/ GIMT_Encode4(301996), GIMT_Encode4(0),
     /* 301668 */ /*GILLT_nxv16s8*//*Label 5999*/ GIMT_Encode4(302022),
     /* 301672 */ // Label 5988: @301672
     /* 301672 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(301705), // Rule ID 1652 //
     /* 301677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301698 */   // (usubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 301703 */   GIR_RootConstrainSelectedInstOperands,
     /* 301704 */   // GIR_Coverage, 1652,
     /* 301704 */   GIR_Done,
     /* 301705 */ // Label 6001: @301705
     /* 301705 */ GIM_Reject,
     /* 301706 */ // Label 5989: @301706
     /* 301706 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(301739), // Rule ID 1568 //
     /* 301711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301732 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301737 */   GIR_RootConstrainSelectedInstOperands,
     /* 301738 */   // GIR_Coverage, 1568,
     /* 301738 */   GIR_Done,
     /* 301739 */ // Label 6002: @301739
     /* 301739 */ GIM_Reject,
     /* 301740 */ // Label 5990: @301740
     /* 301740 */ GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(301773), // Rule ID 1570 //
     /* 301745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301766 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 301766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301771 */   GIR_RootConstrainSelectedInstOperands,
     /* 301772 */   // GIR_Coverage, 1570,
     /* 301772 */   GIR_Done,
     /* 301773 */ // Label 6003: @301773
     /* 301773 */ GIM_Reject,
     /* 301774 */ // Label 5991: @301774
     /* 301774 */ GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(301807), // Rule ID 1566 //
     /* 301779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301800 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301805 */   GIR_RootConstrainSelectedInstOperands,
     /* 301806 */   // GIR_Coverage, 1566,
     /* 301806 */   GIR_Done,
     /* 301807 */ // Label 6004: @301807
     /* 301807 */ GIM_Reject,
     /* 301808 */ // Label 5992: @301808
     /* 301808 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301841), // Rule ID 1569 //
     /* 301813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301834 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301839 */   GIR_RootConstrainSelectedInstOperands,
     /* 301840 */   // GIR_Coverage, 1569,
     /* 301840 */   GIR_Done,
     /* 301841 */ // Label 6005: @301841
     /* 301841 */ GIM_Reject,
     /* 301842 */ // Label 5993: @301842
     /* 301842 */ GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(301875), // Rule ID 1564 //
     /* 301847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301868 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301873 */   GIR_RootConstrainSelectedInstOperands,
     /* 301874 */   // GIR_Coverage, 1564,
     /* 301874 */   GIR_Done,
     /* 301875 */ // Label 6006: @301875
     /* 301875 */ GIM_Reject,
     /* 301876 */ // Label 5994: @301876
     /* 301876 */ GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(301909), // Rule ID 1567 //
     /* 301881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301902 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301907 */   GIR_RootConstrainSelectedInstOperands,
     /* 301908 */   // GIR_Coverage, 1567,
     /* 301908 */   GIR_Done,
     /* 301909 */ // Label 6007: @301909
     /* 301909 */ GIM_Reject,
     /* 301910 */ // Label 5995: @301910
     /* 301910 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(301943), // Rule ID 1565 //
     /* 301915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301936 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301941 */   GIR_RootConstrainSelectedInstOperands,
     /* 301942 */   // GIR_Coverage, 1565,
     /* 301942 */   GIR_Done,
     /* 301943 */ // Label 6008: @301943
     /* 301943 */ GIM_Reject,
     /* 301944 */ // Label 5996: @301944
     /* 301944 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301969), // Rule ID 7553 //
     /* 301949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301962 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301967 */   GIR_RootConstrainSelectedInstOperands,
     /* 301968 */   // GIR_Coverage, 7553,
     /* 301968 */   GIR_Done,
     /* 301969 */ // Label 6009: @301969
     /* 301969 */ GIM_Reject,
     /* 301970 */ // Label 5997: @301970
     /* 301970 */ GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(301995), // Rule ID 7552 //
     /* 301975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301988 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301993 */   GIR_RootConstrainSelectedInstOperands,
     /* 301994 */   // GIR_Coverage, 7552,
     /* 301994 */   GIR_Done,
     /* 301995 */ // Label 6010: @301995
     /* 301995 */ GIM_Reject,
     /* 301996 */ // Label 5998: @301996
     /* 301996 */ GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(302021), // Rule ID 7551 //
     /* 302001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 302007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 302010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302014 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 302014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 302019 */   GIR_RootConstrainSelectedInstOperands,
     /* 302020 */   // GIR_Coverage, 7551,
     /* 302020 */   GIR_Done,
     /* 302021 */ // Label 6011: @302021
     /* 302021 */ GIM_Reject,
     /* 302022 */ // Label 5999: @302022
     /* 302022 */ GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(302047), // Rule ID 7550 //
     /* 302027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 302033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 302036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302040 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 302040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 302045 */   GIR_RootConstrainSelectedInstOperands,
     /* 302046 */   // GIR_Coverage, 7550,
     /* 302046 */   GIR_Done,
     /* 302047 */ // Label 6012: @302047
     /* 302047 */ GIM_Reject,
     /* 302048 */ // Label 6000: @302048
     /* 302048 */ GIM_Reject,
     /* 302049 */ // Label 58: @302049
     /* 302049 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6025*/ GIMT_Encode4(303438),
     /* 302060 */ /*GILLT_s64*//*Label 6013*/ GIMT_Encode4(302144), GIMT_Encode4(0),
     /* 302068 */ /*GILLT_v2s32*//*Label 6014*/ GIMT_Encode4(302178),
     /* 302072 */ /*GILLT_v2s64*//*Label 6015*/ GIMT_Encode4(302212),
     /* 302076 */ /*GILLT_v4s16*//*Label 6016*/ GIMT_Encode4(302705),
     /* 302080 */ /*GILLT_v4s32*//*Label 6017*/ GIMT_Encode4(302739),
     /* 302084 */ /*GILLT_v8s8*//*Label 6018*/ GIMT_Encode4(303232),
     /* 302088 */ /*GILLT_v8s16*//*Label 6019*/ GIMT_Encode4(303266),
     /* 302092 */ /*GILLT_v16s8*//*Label 6020*/ GIMT_Encode4(303300), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302112 */ /*GILLT_nxv2s64*//*Label 6021*/ GIMT_Encode4(303334), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302124 */ /*GILLT_nxv4s32*//*Label 6022*/ GIMT_Encode4(303360), GIMT_Encode4(0),
     /* 302132 */ /*GILLT_nxv8s16*//*Label 6023*/ GIMT_Encode4(303386), GIMT_Encode4(0),
     /* 302140 */ /*GILLT_nxv16s8*//*Label 6024*/ GIMT_Encode4(303412),
     /* 302144 */ // Label 6013: @302144
     /* 302144 */ GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(302177), // Rule ID 1645 //
     /* 302149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302170 */   // (ssubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 302170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 302175 */   GIR_RootConstrainSelectedInstOperands,
     /* 302176 */   // GIR_Coverage, 1645,
     /* 302176 */   GIR_Done,
     /* 302177 */ // Label 6026: @302177
     /* 302177 */ GIM_Reject,
     /* 302178 */ // Label 6014: @302178
     /* 302178 */ GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(302211), // Rule ID 1453 //
     /* 302183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302204 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 302204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 302209 */   GIR_RootConstrainSelectedInstOperands,
     /* 302210 */   // GIR_Coverage, 1453,
     /* 302210 */   GIR_Done,
     /* 302211 */ // Label 6027: @302211
     /* 302211 */ GIM_Reject,
     /* 302212 */ // Label 6015: @302212
     /* 302212 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(302704),
     /* 302217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302231 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(302349), // Rule ID 2071 //
     /* 302236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302247 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302250 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302308 */     // MIs[4] Operand 1
     /* 302308 */     // No operand predicates
     /* 302308 */     // MIs[2] Operand 2
     /* 302308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 302319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302328 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 302331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302347 */     GIR_RootConstrainSelectedInstOperands,
     /* 302348 */     // GIR_Coverage, 2071,
     /* 302348 */     GIR_EraseRootFromParent_Done,
     /* 302349 */   // Label 6029: @302349
     /* 302349 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302464), // Rule ID 2069 //
     /* 302354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302365 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302368 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302377 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302410 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302414 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302419 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302423 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302427 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302431 */     // MIs[4] Operand 1
     /* 302431 */     // No operand predicates
     /* 302431 */     // MIs[2] Operand 2
     /* 302431 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302442 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302444 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302462 */     GIR_RootConstrainSelectedInstOperands,
     /* 302463 */     // GIR_Coverage, 2069,
     /* 302463 */     GIR_EraseRootFromParent_Done,
     /* 302464 */   // Label 6030: @302464
     /* 302464 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302531), // Rule ID 1753 //
     /* 302469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302480 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302483 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302512 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 302515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302529 */     GIR_RootConstrainSelectedInstOperands,
     /* 302530 */     // GIR_Coverage, 1753,
     /* 302530 */     GIR_EraseRootFromParent_Done,
     /* 302531 */   // Label 6031: @302531
     /* 302531 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302623), // Rule ID 2070 //
     /* 302536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302547 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302550 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302597 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302601 */     // MIs[3] Operand 1
     /* 302601 */     // No operand predicates
     /* 302601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302603 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302621 */     GIR_RootConstrainSelectedInstOperands,
     /* 302622 */     // GIR_Coverage, 2070,
     /* 302622 */     GIR_EraseRootFromParent_Done,
     /* 302623 */   // Label 6032: @302623
     /* 302623 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(302684), // Rule ID 1752 //
     /* 302628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302667 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 302667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 302670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302682 */     GIR_RootConstrainSelectedInstOperands,
     /* 302683 */     // GIR_Coverage, 1752,
     /* 302683 */     GIR_EraseRootFromParent_Done,
     /* 302684 */   // Label 6033: @302684
     /* 302684 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(302703), // Rule ID 1455 //
     /* 302689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302696 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 302696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 302701 */     GIR_RootConstrainSelectedInstOperands,
     /* 302702 */     // GIR_Coverage, 1455,
     /* 302702 */     GIR_Done,
     /* 302703 */   // Label 6034: @302703
     /* 302703 */   GIM_Reject,
     /* 302704 */ // Label 6028: @302704
     /* 302704 */ GIM_Reject,
     /* 302705 */ // Label 6016: @302705
     /* 302705 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302738), // Rule ID 1451 //
     /* 302710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302731 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 302736 */   GIR_RootConstrainSelectedInstOperands,
     /* 302737 */   // GIR_Coverage, 1451,
     /* 302737 */   GIR_Done,
     /* 302738 */ // Label 6035: @302738
     /* 302738 */ GIM_Reject,
     /* 302739 */ // Label 6017: @302739
     /* 302739 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(303231),
     /* 302744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302758 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(302876), // Rule ID 2068 //
     /* 302763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302786 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302814 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302823 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302827 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302831 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302835 */     // MIs[4] Operand 1
     /* 302835 */     // No operand predicates
     /* 302835 */     // MIs[2] Operand 2
     /* 302835 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 302846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302855 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 302858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302874 */     GIR_RootConstrainSelectedInstOperands,
     /* 302875 */     // GIR_Coverage, 2068,
     /* 302875 */     GIR_EraseRootFromParent_Done,
     /* 302876 */   // Label 6037: @302876
     /* 302876 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302991), // Rule ID 2066 //
     /* 302881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302892 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302895 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302937 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302954 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302958 */     // MIs[4] Operand 1
     /* 302958 */     // No operand predicates
     /* 302958 */     // MIs[2] Operand 2
     /* 302958 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302969 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302971 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302989 */     GIR_RootConstrainSelectedInstOperands,
     /* 302990 */     // GIR_Coverage, 2066,
     /* 302990 */     GIR_EraseRootFromParent_Done,
     /* 302991 */   // Label 6038: @302991
     /* 302991 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(303058), // Rule ID 1751 //
     /* 302996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 303007 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 303010 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 303015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303019 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 303023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 303032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 303039 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 303039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 303042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 303046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 303056 */     GIR_RootConstrainSelectedInstOperands,
     /* 303057 */     // GIR_Coverage, 1751,
     /* 303057 */     GIR_EraseRootFromParent_Done,
     /* 303058 */   // Label 6039: @303058
     /* 303058 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(303150), // Rule ID 2067 //
     /* 303063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 303074 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 303077 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 303082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303086 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 303090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 303099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303124 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303128 */     // MIs[3] Operand 1
     /* 303128 */     // No operand predicates
     /* 303128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303130 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 303130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 303133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 303137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 303141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303148 */     GIR_RootConstrainSelectedInstOperands,
     /* 303149 */     // GIR_Coverage, 2067,
     /* 303149 */     GIR_EraseRootFromParent_Done,
     /* 303150 */   // Label 6040: @303150
     /* 303150 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(303211), // Rule ID 1750 //
     /* 303155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 303166 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 303169 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 303174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303178 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 303182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303194 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 303194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 303197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 303201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 303205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 303209 */     GIR_RootConstrainSelectedInstOperands,
     /* 303210 */     // GIR_Coverage, 1750,
     /* 303210 */     GIR_EraseRootFromParent_Done,
     /* 303211 */   // Label 6041: @303211
     /* 303211 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(303230), // Rule ID 1454 //
     /* 303216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303223 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 303223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 303228 */     GIR_RootConstrainSelectedInstOperands,
     /* 303229 */     // GIR_Coverage, 1454,
     /* 303229 */     GIR_Done,
     /* 303230 */   // Label 6042: @303230
     /* 303230 */   GIM_Reject,
     /* 303231 */ // Label 6036: @303231
     /* 303231 */ GIM_Reject,
     /* 303232 */ // Label 6018: @303232
     /* 303232 */ GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(303265), // Rule ID 1449 //
     /* 303237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 303243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 303246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303258 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 303258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 303263 */   GIR_RootConstrainSelectedInstOperands,
     /* 303264 */   // GIR_Coverage, 1449,
     /* 303264 */   GIR_Done,
     /* 303265 */ // Label 6043: @303265
     /* 303265 */ GIM_Reject,
     /* 303266 */ // Label 6019: @303266
     /* 303266 */ GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(303299), // Rule ID 1452 //
     /* 303271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303292 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 303292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 303297 */   GIR_RootConstrainSelectedInstOperands,
     /* 303298 */   // GIR_Coverage, 1452,
     /* 303298 */   GIR_Done,
     /* 303299 */ // Label 6044: @303299
     /* 303299 */ GIM_Reject,
     /* 303300 */ // Label 6020: @303300
     /* 303300 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(303333), // Rule ID 1450 //
     /* 303305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 303311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 303314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303326 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 303326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 303331 */   GIR_RootConstrainSelectedInstOperands,
     /* 303332 */   // GIR_Coverage, 1450,
     /* 303332 */   GIR_Done,
     /* 303333 */ // Label 6045: @303333
     /* 303333 */ GIM_Reject,
     /* 303334 */ // Label 6021: @303334
     /* 303334 */ GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(303359), // Rule ID 7549 //
     /* 303339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303352 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 303352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 303357 */   GIR_RootConstrainSelectedInstOperands,
     /* 303358 */   // GIR_Coverage, 7549,
     /* 303358 */   GIR_Done,
     /* 303359 */ // Label 6046: @303359
     /* 303359 */ GIM_Reject,
     /* 303360 */ // Label 6022: @303360
     /* 303360 */ GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(303385), // Rule ID 7548 //
     /* 303365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303378 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 303378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 303383 */   GIR_RootConstrainSelectedInstOperands,
     /* 303384 */   // GIR_Coverage, 7548,
     /* 303384 */   GIR_Done,
     /* 303385 */ // Label 6047: @303385
     /* 303385 */ GIM_Reject,
     /* 303386 */ // Label 6023: @303386
     /* 303386 */ GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(303411), // Rule ID 7547 //
     /* 303391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303404 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 303404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 303409 */   GIR_RootConstrainSelectedInstOperands,
     /* 303410 */   // GIR_Coverage, 7547,
     /* 303410 */   GIR_Done,
     /* 303411 */ // Label 6048: @303411
     /* 303411 */ GIM_Reject,
     /* 303412 */ // Label 6024: @303412
     /* 303412 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(303437), // Rule ID 7546 //
     /* 303417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 303423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 303426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303430 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 303430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 303435 */   GIR_RootConstrainSelectedInstOperands,
     /* 303436 */   // GIR_Coverage, 7546,
     /* 303436 */   GIR_Done,
     /* 303437 */ // Label 6049: @303437
     /* 303437 */ GIM_Reject,
     /* 303438 */ // Label 6025: @303438
     /* 303438 */ GIM_Reject,
     /* 303439 */ // Label 59: @303439
     /* 303439 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6061*/ GIMT_Encode4(305236),
     /* 303450 */ /*GILLT_s16*//*Label 6050*/ GIMT_Encode4(303534),
     /* 303454 */ /*GILLT_s32*//*Label 6051*/ GIMT_Encode4(303760),
     /* 303458 */ /*GILLT_s64*//*Label 6052*/ GIMT_Encode4(304114), GIMT_Encode4(0),
     /* 303466 */ /*GILLT_v2s32*//*Label 6053*/ GIMT_Encode4(304286),
     /* 303470 */ /*GILLT_v2s64*//*Label 6054*/ GIMT_Encode4(304324),
     /* 303474 */ /*GILLT_v4s16*//*Label 6055*/ GIMT_Encode4(304500),
     /* 303478 */ /*GILLT_v4s32*//*Label 6056*/ GIMT_Encode4(304538), GIMT_Encode4(0),
     /* 303486 */ /*GILLT_v8s16*//*Label 6057*/ GIMT_Encode4(304714), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303510 */ /*GILLT_nxv2s64*//*Label 6058*/ GIMT_Encode4(305158), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303522 */ /*GILLT_nxv4s32*//*Label 6059*/ GIMT_Encode4(305184), GIMT_Encode4(0),
     /* 303530 */ /*GILLT_nxv8s16*//*Label 6060*/ GIMT_Encode4(305210),
     /* 303534 */ // Label 6050: @303534
     /* 303534 */ GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303759),
     /* 303539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303549 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303640), // Rule ID 6995 //
     /* 303554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303591 */     // MIs[2] Rn
     /* 303591 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303602 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303638 */     GIR_RootConstrainSelectedInstOperands,
     /* 303639 */     // GIR_Coverage, 6995,
     /* 303639 */     GIR_EraseRootFromParent_Done,
     /* 303640 */   // Label 6063: @303640
     /* 303640 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303731), // Rule ID 14203 //
     /* 303645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303666 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303682 */     // MIs[2] Rn
     /* 303682 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303687 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303693 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303729 */     GIR_RootConstrainSelectedInstOperands,
     /* 303730 */     // GIR_Coverage, 14203,
     /* 303730 */     GIR_EraseRootFromParent_Done,
     /* 303731 */   // Label 6064: @303731
     /* 303731 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303758), // Rule ID 588 //
     /* 303736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303747 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 303752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303756 */     GIR_RootConstrainSelectedInstOperands,
     /* 303757 */     // GIR_Coverage, 588,
     /* 303757 */     GIR_Done,
     /* 303758 */   // Label 6065: @303758
     /* 303758 */   GIM_Reject,
     /* 303759 */ // Label 6062: @303759
     /* 303759 */ GIM_Reject,
     /* 303760 */ // Label 6051: @303760
     /* 303760 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(304113),
     /* 303765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303775 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(303866), // Rule ID 6993 //
     /* 303780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303817 */     // MIs[2] Rn
     /* 303817 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303822 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303828 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303840 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303864 */     GIR_RootConstrainSelectedInstOperands,
     /* 303865 */     // GIR_Coverage, 6993,
     /* 303865 */     GIR_EraseRootFromParent_Done,
     /* 303866 */   // Label 6067: @303866
     /* 303866 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303930), // Rule ID 13368 //
     /* 303871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303908 */     // MIs[2] Rn
     /* 303908 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303913 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303919 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303928 */     GIR_RootConstrainSelectedInstOperands,
     /* 303929 */     // GIR_Coverage, 13368,
     /* 303929 */     GIR_EraseRootFromParent_Done,
     /* 303930 */   // Label 6068: @303930
     /* 303930 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(304021), // Rule ID 14201 //
     /* 303935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303972 */     // MIs[2] Rn
     /* 303972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303983 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 304014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304019 */     GIR_RootConstrainSelectedInstOperands,
     /* 304020 */     // GIR_Coverage, 14201,
     /* 304020 */     GIR_EraseRootFromParent_Done,
     /* 304021 */   // Label 6069: @304021
     /* 304021 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(304085), // Rule ID 16341 //
     /* 304026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304047 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 304051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304063 */     // MIs[2] Rn
     /* 304063 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304068 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304074 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 304074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 304077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304083 */     GIR_RootConstrainSelectedInstOperands,
     /* 304084 */     // GIR_Coverage, 16341,
     /* 304084 */     GIR_EraseRootFromParent_Done,
     /* 304085 */   // Label 6070: @304085
     /* 304085 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(304112), // Rule ID 590 //
     /* 304090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304101 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 304101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 304106 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304110 */     GIR_RootConstrainSelectedInstOperands,
     /* 304111 */     // GIR_Coverage, 590,
     /* 304111 */     GIR_Done,
     /* 304112 */   // Label 6071: @304112
     /* 304112 */   GIM_Reject,
     /* 304113 */ // Label 6066: @304113
     /* 304113 */ GIM_Reject,
     /* 304114 */ // Label 6052: @304114
     /* 304114 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(304285),
     /* 304119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 304125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304129 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(304193), // Rule ID 6991 //
     /* 304134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304155 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304171 */     // MIs[2] Rn
     /* 304171 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 304180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304182 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 304182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 304185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304191 */     GIR_RootConstrainSelectedInstOperands,
     /* 304192 */     // GIR_Coverage, 6991,
     /* 304192 */     GIR_EraseRootFromParent_Done,
     /* 304193 */   // Label 6073: @304193
     /* 304193 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(304257), // Rule ID 14199 //
     /* 304198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304219 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 304223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304235 */     // MIs[2] Rn
     /* 304235 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304240 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304246 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 304246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 304249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304255 */     GIR_RootConstrainSelectedInstOperands,
     /* 304256 */     // GIR_Coverage, 14199,
     /* 304256 */     GIR_EraseRootFromParent_Done,
     /* 304257 */   // Label 6074: @304257
     /* 304257 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(304284), // Rule ID 592 //
     /* 304262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304273 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 304273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 304278 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304282 */     GIR_RootConstrainSelectedInstOperands,
     /* 304283 */     // GIR_Coverage, 592,
     /* 304283 */     GIR_Done,
     /* 304284 */   // Label 6075: @304284
     /* 304284 */   GIM_Reject,
     /* 304285 */ // Label 6072: @304285
     /* 304285 */ GIM_Reject,
     /* 304286 */ // Label 6053: @304286
     /* 304286 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(304323), // Rule ID 1207 //
     /* 304291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 304300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304312 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 304312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 304317 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304321 */   GIR_RootConstrainSelectedInstOperands,
     /* 304322 */   // GIR_Coverage, 1207,
     /* 304322 */   GIR_Done,
     /* 304323 */ // Label 6076: @304323
     /* 304323 */ GIM_Reject,
     /* 304324 */ // Label 6054: @304324
     /* 304324 */ GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(304499),
     /* 304329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304339 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(304405), // Rule ID 7013 //
     /* 304344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 304352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 304378 */     // MIs[2] Rn
     /* 304378 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304383 */     // MIs[2] Rm
     /* 304383 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304390 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304403 */     GIR_RootConstrainSelectedInstOperands,
     /* 304404 */     // GIR_Coverage, 7013,
     /* 304404 */     GIR_EraseRootFromParent_Done,
     /* 304405 */   // Label 6078: @304405
     /* 304405 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(304471), // Rule ID 14211 //
     /* 304410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 304418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 304444 */     // MIs[2] Rn
     /* 304444 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304449 */     // MIs[2] Rm
     /* 304449 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304456 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304469 */     GIR_RootConstrainSelectedInstOperands,
     /* 304470 */     // GIR_Coverage, 14211,
     /* 304470 */     GIR_EraseRootFromParent_Done,
     /* 304471 */   // Label 6079: @304471
     /* 304471 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(304498), // Rule ID 1211 //
     /* 304476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304487 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 304492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304496 */     GIR_RootConstrainSelectedInstOperands,
     /* 304497 */     // GIR_Coverage, 1211,
     /* 304497 */     GIR_Done,
     /* 304498 */   // Label 6080: @304498
     /* 304498 */   GIM_Reject,
     /* 304499 */ // Label 6077: @304499
     /* 304499 */ GIM_Reject,
     /* 304500 */ // Label 6055: @304500
     /* 304500 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(304537), // Rule ID 1203 //
     /* 304505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304526 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 304531 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304535 */   GIR_RootConstrainSelectedInstOperands,
     /* 304536 */   // GIR_Coverage, 1203,
     /* 304536 */   GIR_Done,
     /* 304537 */ // Label 6081: @304537
     /* 304537 */ GIM_Reject,
     /* 304538 */ // Label 6056: @304538
     /* 304538 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(304713),
     /* 304543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304553 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(304619), // Rule ID 7014 //
     /* 304558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304592 */     // MIs[2] Rn
     /* 304592 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304597 */     // MIs[2] Rm
     /* 304597 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304604 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304617 */     GIR_RootConstrainSelectedInstOperands,
     /* 304618 */     // GIR_Coverage, 7014,
     /* 304618 */     GIR_EraseRootFromParent_Done,
     /* 304619 */   // Label 6083: @304619
     /* 304619 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(304685), // Rule ID 14212 //
     /* 304624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304658 */     // MIs[2] Rn
     /* 304658 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304663 */     // MIs[2] Rm
     /* 304663 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304670 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304683 */     GIR_RootConstrainSelectedInstOperands,
     /* 304684 */     // GIR_Coverage, 14212,
     /* 304684 */     GIR_EraseRootFromParent_Done,
     /* 304685 */   // Label 6084: @304685
     /* 304685 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(304712), // Rule ID 1209 //
     /* 304690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304701 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304706 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304710 */     GIR_RootConstrainSelectedInstOperands,
     /* 304711 */     // GIR_Coverage, 1209,
     /* 304711 */     GIR_Done,
     /* 304712 */   // Label 6085: @304712
     /* 304712 */   GIM_Reject,
     /* 304713 */ // Label 6082: @304713
     /* 304713 */ GIM_Reject,
     /* 304714 */ // Label 6057: @304714
     /* 304714 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(305157),
     /* 304719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304729 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(304798), // Rule ID 7015 //
     /* 304734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304771 */     // MIs[2] Rn
     /* 304771 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304776 */     // MIs[2] Rm
     /* 304776 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304783 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304796 */     GIR_RootConstrainSelectedInstOperands,
     /* 304797 */     // GIR_Coverage, 7015,
     /* 304797 */     GIR_EraseRootFromParent_Done,
     /* 304798 */   // Label 6087: @304798
     /* 304798 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(304867), // Rule ID 14213 //
     /* 304803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304840 */     // MIs[2] Rn
     /* 304840 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304845 */     // MIs[2] Rm
     /* 304845 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304852 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304865 */     GIR_RootConstrainSelectedInstOperands,
     /* 304866 */     // GIR_Coverage, 14213,
     /* 304866 */     GIR_EraseRootFromParent_Done,
     /* 304867 */   // Label 6088: @304867
     /* 304867 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(304894), // Rule ID 1205 //
     /* 304872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304883 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 304888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304892 */     GIR_RootConstrainSelectedInstOperands,
     /* 304893 */     // GIR_Coverage, 1205,
     /* 304893 */     GIR_Done,
     /* 304894 */   // Label 6089: @304894
     /* 304894 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(305156), // Rule ID 7090 //
     /* 304899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304910 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304910 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304913 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304917 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304922 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304928 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304931 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304935 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304940 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304946 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304949 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304953 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304958 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304961 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304966 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304969 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304973 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304978 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304984 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304989 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304994 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304997 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305001 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305006 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 305009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305011 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 305014 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305018 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305023 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305029 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305034 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305039 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 305042 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305046 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305051 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305056 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 305059 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 305063 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305068 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305071 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 305074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 305079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 305083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305088 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 305122 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 305125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 305128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 305146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 305154 */     GIR_RootConstrainSelectedInstOperands,
     /* 305155 */     // GIR_Coverage, 7090,
     /* 305155 */     GIR_EraseRootFromParent_Done,
     /* 305156 */   // Label 6090: @305156
     /* 305156 */   GIM_Reject,
     /* 305157 */ // Label 6086: @305157
     /* 305157 */ GIM_Reject,
     /* 305158 */ // Label 6058: @305158
     /* 305158 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(305183), // Rule ID 2824 //
     /* 305163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 305169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 305172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305176 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 305176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 305181 */   GIR_RootConstrainSelectedInstOperands,
     /* 305182 */   // GIR_Coverage, 2824,
     /* 305182 */   GIR_Done,
     /* 305183 */ // Label 6091: @305183
     /* 305183 */ GIM_Reject,
     /* 305184 */ // Label 6059: @305184
     /* 305184 */ GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(305209), // Rule ID 2822 //
     /* 305189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 305195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 305198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305202 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 305202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 305207 */   GIR_RootConstrainSelectedInstOperands,
     /* 305208 */   // GIR_Coverage, 2822,
     /* 305208 */   GIR_Done,
     /* 305209 */ // Label 6092: @305209
     /* 305209 */ GIM_Reject,
     /* 305210 */ // Label 6060: @305210
     /* 305210 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(305235), // Rule ID 2820 //
     /* 305215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 305221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 305224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305228 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 305228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 305233 */   GIR_RootConstrainSelectedInstOperands,
     /* 305234 */   // GIR_Coverage, 2820,
     /* 305234 */   GIR_Done,
     /* 305235 */ // Label 6093: @305235
     /* 305235 */ GIM_Reject,
     /* 305236 */ // Label 6061: @305236
     /* 305236 */ GIM_Reject,
     /* 305237 */ // Label 60: @305237
     /* 305237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6105*/ GIMT_Encode4(305974),
     /* 305248 */ /*GILLT_s16*//*Label 6094*/ GIMT_Encode4(305332),
     /* 305252 */ /*GILLT_s32*//*Label 6095*/ GIMT_Encode4(305370),
     /* 305256 */ /*GILLT_s64*//*Label 6096*/ GIMT_Encode4(305408), GIMT_Encode4(0),
     /* 305264 */ /*GILLT_v2s32*//*Label 6097*/ GIMT_Encode4(305446),
     /* 305268 */ /*GILLT_v2s64*//*Label 6098*/ GIMT_Encode4(305484),
     /* 305272 */ /*GILLT_v4s16*//*Label 6099*/ GIMT_Encode4(305522),
     /* 305276 */ /*GILLT_v4s32*//*Label 6100*/ GIMT_Encode4(305560), GIMT_Encode4(0),
     /* 305284 */ /*GILLT_v8s16*//*Label 6101*/ GIMT_Encode4(305598), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305308 */ /*GILLT_nxv2s64*//*Label 6102*/ GIMT_Encode4(305896), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305320 */ /*GILLT_nxv4s32*//*Label 6103*/ GIMT_Encode4(305922), GIMT_Encode4(0),
     /* 305328 */ /*GILLT_nxv8s16*//*Label 6104*/ GIMT_Encode4(305948),
     /* 305332 */ // Label 6094: @305332
     /* 305332 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(305369), // Rule ID 636 //
     /* 305337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 305346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305358 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 305358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 305363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305367 */   GIR_RootConstrainSelectedInstOperands,
     /* 305368 */   // GIR_Coverage, 636,
     /* 305368 */   GIR_Done,
     /* 305369 */ // Label 6106: @305369
     /* 305369 */ GIM_Reject,
     /* 305370 */ // Label 6095: @305370
     /* 305370 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(305407), // Rule ID 638 //
     /* 305375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 305384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305396 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 305401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305405 */   GIR_RootConstrainSelectedInstOperands,
     /* 305406 */   // GIR_Coverage, 638,
     /* 305406 */   GIR_Done,
     /* 305407 */ // Label 6107: @305407
     /* 305407 */ GIM_Reject,
     /* 305408 */ // Label 6096: @305408
     /* 305408 */ GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(305445), // Rule ID 640 //
     /* 305413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305434 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 305439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305443 */   GIR_RootConstrainSelectedInstOperands,
     /* 305444 */   // GIR_Coverage, 640,
     /* 305444 */   GIR_Done,
     /* 305445 */ // Label 6108: @305445
     /* 305445 */ GIM_Reject,
     /* 305446 */ // Label 6097: @305446
     /* 305446 */ GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(305483), // Rule ID 1347 //
     /* 305451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 305460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305472 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 305472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 305477 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305481 */   GIR_RootConstrainSelectedInstOperands,
     /* 305482 */   // GIR_Coverage, 1347,
     /* 305482 */   GIR_Done,
     /* 305483 */ // Label 6109: @305483
     /* 305483 */ GIM_Reject,
     /* 305484 */ // Label 6098: @305484
     /* 305484 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(305521), // Rule ID 1351 //
     /* 305489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 305498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305510 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 305510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 305515 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305519 */   GIR_RootConstrainSelectedInstOperands,
     /* 305520 */   // GIR_Coverage, 1351,
     /* 305520 */   GIR_Done,
     /* 305521 */ // Label 6110: @305521
     /* 305521 */ GIM_Reject,
     /* 305522 */ // Label 6099: @305522
     /* 305522 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(305559), // Rule ID 1343 //
     /* 305527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 305536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305548 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 305553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305557 */   GIR_RootConstrainSelectedInstOperands,
     /* 305558 */   // GIR_Coverage, 1343,
     /* 305558 */   GIR_Done,
     /* 305559 */ // Label 6111: @305559
     /* 305559 */ GIM_Reject,
     /* 305560 */ // Label 6100: @305560
     /* 305560 */ GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(305597), // Rule ID 1349 //
     /* 305565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 305574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305586 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305591 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305595 */   GIR_RootConstrainSelectedInstOperands,
     /* 305596 */   // GIR_Coverage, 1349,
     /* 305596 */   GIR_Done,
     /* 305597 */ // Label 6112: @305597
     /* 305597 */ GIM_Reject,
     /* 305598 */ // Label 6101: @305598
     /* 305598 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(305895),
     /* 305603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305621 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(305640), // Rule ID 1345 //
     /* 305626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305629 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 305634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305638 */     GIR_RootConstrainSelectedInstOperands,
     /* 305639 */     // GIR_Coverage, 1345,
     /* 305639 */     GIR_Done,
     /* 305640 */   // Label 6114: @305640
     /* 305640 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(305894), // Rule ID 7096 //
     /* 305645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 305648 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 305648 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 305651 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305655 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305660 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 305664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 305666 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 305669 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305673 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305678 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 305682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 305684 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 305687 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305691 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305696 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 305699 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 305702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 305704 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 305707 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305711 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305716 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305722 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305727 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305732 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 305735 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305739 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305744 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 305747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305749 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 305752 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305756 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305761 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305767 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305772 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305777 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 305780 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305784 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305789 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305794 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 305797 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305801 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305806 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305809 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 305812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305814 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 305817 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 305821 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305826 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 305860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 305863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 305866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 305884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 305892 */     GIR_RootConstrainSelectedInstOperands,
     /* 305893 */     // GIR_Coverage, 7096,
     /* 305893 */     GIR_EraseRootFromParent_Done,
     /* 305894 */   // Label 6115: @305894
     /* 305894 */   GIM_Reject,
     /* 305895 */ // Label 6113: @305895
     /* 305895 */ GIM_Reject,
     /* 305896 */ // Label 6102: @305896
     /* 305896 */ GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(305921), // Rule ID 8296 //
     /* 305901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 305907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 305910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305914 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 305914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 305919 */   GIR_RootConstrainSelectedInstOperands,
     /* 305920 */   // GIR_Coverage, 8296,
     /* 305920 */   GIR_Done,
     /* 305921 */ // Label 6116: @305921
     /* 305921 */ GIM_Reject,
     /* 305922 */ // Label 6103: @305922
     /* 305922 */ GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(305947), // Rule ID 8294 //
     /* 305927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 305933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 305936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305940 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 305940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 305945 */   GIR_RootConstrainSelectedInstOperands,
     /* 305946 */   // GIR_Coverage, 8294,
     /* 305946 */   GIR_Done,
     /* 305947 */ // Label 6117: @305947
     /* 305947 */ GIM_Reject,
     /* 305948 */ // Label 6104: @305948
     /* 305948 */ GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(305973), // Rule ID 8292 //
     /* 305953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 305959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 305962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305966 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 305966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 305971 */   GIR_RootConstrainSelectedInstOperands,
     /* 305972 */   // GIR_Coverage, 8292,
     /* 305972 */   GIR_Done,
     /* 305973 */ // Label 6118: @305973
     /* 305973 */ GIM_Reject,
     /* 305974 */ // Label 6105: @305974
     /* 305974 */ GIM_Reject,
     /* 305975 */ // Label 61: @305975
     /* 305975 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6130*/ GIMT_Encode4(310590),
     /* 305986 */ /*GILLT_s16*//*Label 6119*/ GIMT_Encode4(306070),
     /* 305990 */ /*GILLT_s32*//*Label 6120*/ GIMT_Encode4(306712),
     /* 305994 */ /*GILLT_s64*//*Label 6121*/ GIMT_Encode4(307342), GIMT_Encode4(0),
     /* 306002 */ /*GILLT_v2s32*//*Label 6122*/ GIMT_Encode4(307972),
     /* 306006 */ /*GILLT_v2s64*//*Label 6123*/ GIMT_Encode4(308502),
     /* 306010 */ /*GILLT_v4s16*//*Label 6124*/ GIMT_Encode4(308860),
     /* 306014 */ /*GILLT_v4s32*//*Label 6125*/ GIMT_Encode4(309202), GIMT_Encode4(0),
     /* 306022 */ /*GILLT_v8s16*//*Label 6126*/ GIMT_Encode4(309560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 306046 */ /*GILLT_nxv2s64*//*Label 6127*/ GIMT_Encode4(309992), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 306058 */ /*GILLT_nxv4s32*//*Label 6128*/ GIMT_Encode4(310306), GIMT_Encode4(0),
     /* 306066 */ /*GILLT_nxv8s16*//*Label 6129*/ GIMT_Encode4(310448),
     /* 306070 */ // Label 6119: @306070
     /* 306070 */ GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(306711),
     /* 306075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306085 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(306198), // Rule ID 6315 //
     /* 306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306147 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306151 */     // MIs[3] Operand 1
     /* 306151 */     // No operand predicates
     /* 306151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306153 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306196 */     GIR_RootConstrainSelectedInstOperands,
     /* 306197 */     // GIR_Coverage, 6315,
     /* 306197 */     GIR_EraseRootFromParent_Done,
     /* 306198 */   // Label 6132: @306198
     /* 306198 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(306311), // Rule ID 14180 //
     /* 306203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306239 */     // MIs[2] Operand 1
     /* 306239 */     // No operand predicates
     /* 306239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306251 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306255 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306260 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306266 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306309 */     GIR_RootConstrainSelectedInstOperands,
     /* 306310 */     // GIR_Coverage, 14180,
     /* 306310 */     GIR_EraseRootFromParent_Done,
     /* 306311 */   // Label 6133: @306311
     /* 306311 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306390), // Rule ID 14114 //
     /* 306316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306350 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 306350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306362 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306388 */     GIR_RootConstrainSelectedInstOperands,
     /* 306389 */     // GIR_Coverage, 14114,
     /* 306389 */     GIR_EraseRootFromParent_Done,
     /* 306390 */   // Label 6134: @306390
     /* 306390 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306469), // Rule ID 4872 //
     /* 306395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306423 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306429 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 306429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306441 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306467 */     GIR_RootConstrainSelectedInstOperands,
     /* 306468 */     // GIR_Coverage, 4872,
     /* 306468 */     GIR_EraseRootFromParent_Done,
     /* 306469 */   // Label 6135: @306469
     /* 306469 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306532), // Rule ID 13718 //
     /* 306474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306510 */     // MIs[2] Operand 1
     /* 306510 */     // No operand predicates
     /* 306510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306516 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306530 */     GIR_RootConstrainSelectedInstOperands,
     /* 306531 */     // GIR_Coverage, 13718,
     /* 306531 */     GIR_EraseRootFromParent_Done,
     /* 306532 */   // Label 6136: @306532
     /* 306532 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306595), // Rule ID 2016 //
     /* 306537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306573 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306577 */     // MIs[2] Operand 1
     /* 306577 */     // No operand predicates
     /* 306577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306579 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306593 */     GIR_RootConstrainSelectedInstOperands,
     /* 306594 */     // GIR_Coverage, 2016,
     /* 306594 */     GIR_EraseRootFromParent_Done,
     /* 306595 */   // Label 6137: @306595
     /* 306595 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306639), // Rule ID 4877 //
     /* 306600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306626 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306635 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306637 */     GIR_RootConstrainSelectedInstOperands,
     /* 306638 */     // GIR_Coverage, 4877,
     /* 306638 */     GIR_EraseRootFromParent_Done,
     /* 306639 */   // Label 6138: @306639
     /* 306639 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306683), // Rule ID 14119 //
     /* 306644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306670 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306679 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306681 */     GIR_RootConstrainSelectedInstOperands,
     /* 306682 */     // GIR_Coverage, 14119,
     /* 306682 */     GIR_EraseRootFromParent_Done,
     /* 306683 */   // Label 6139: @306683
     /* 306683 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306710), // Rule ID 624 //
     /* 306688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306699 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306704 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306708 */     GIR_RootConstrainSelectedInstOperands,
     /* 306709 */     // GIR_Coverage, 624,
     /* 306709 */     GIR_Done,
     /* 306710 */   // Label 6140: @306710
     /* 306710 */   GIM_Reject,
     /* 306711 */ // Label 6131: @306711
     /* 306711 */ GIM_Reject,
     /* 306712 */ // Label 6120: @306712
     /* 306712 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(307341),
     /* 306717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306727 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306840), // Rule ID 6317 //
     /* 306732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306789 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306793 */     // MIs[3] Operand 1
     /* 306793 */     // No operand predicates
     /* 306793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306795 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306838 */     GIR_RootConstrainSelectedInstOperands,
     /* 306839 */     // GIR_Coverage, 6317,
     /* 306839 */     GIR_EraseRootFromParent_Done,
     /* 306840 */   // Label 6142: @306840
     /* 306840 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306953), // Rule ID 14182 //
     /* 306845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306881 */     // MIs[2] Operand 1
     /* 306881 */     // No operand predicates
     /* 306881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306902 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306908 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306951 */     GIR_RootConstrainSelectedInstOperands,
     /* 306952 */     // GIR_Coverage, 14182,
     /* 306952 */     GIR_EraseRootFromParent_Done,
     /* 306953 */   // Label 6143: @306953
     /* 306953 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307029), // Rule ID 14116 //
     /* 306958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306979 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306989 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307001 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 307007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 307020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307027 */     GIR_RootConstrainSelectedInstOperands,
     /* 307028 */     // GIR_Coverage, 14116,
     /* 307028 */     GIR_EraseRootFromParent_Done,
     /* 307029 */   // Label 6144: @307029
     /* 307029 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(307105), // Rule ID 4874 //
     /* 307034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307059 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307065 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 307065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 307083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 307096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307103 */     GIR_RootConstrainSelectedInstOperands,
     /* 307104 */     // GIR_Coverage, 4874,
     /* 307104 */     GIR_EraseRootFromParent_Done,
     /* 307105 */   // Label 6145: @307105
     /* 307105 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(307168), // Rule ID 13720 //
     /* 307110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307146 */     // MIs[2] Operand 1
     /* 307146 */     // No operand predicates
     /* 307146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307152 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 307155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307166 */     GIR_RootConstrainSelectedInstOperands,
     /* 307167 */     // GIR_Coverage, 13720,
     /* 307167 */     GIR_EraseRootFromParent_Done,
     /* 307168 */   // Label 6146: @307168
     /* 307168 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(307231), // Rule ID 2018 //
     /* 307173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307213 */     // MIs[2] Operand 1
     /* 307213 */     // No operand predicates
     /* 307213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307215 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 307218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307229 */     GIR_RootConstrainSelectedInstOperands,
     /* 307230 */     // GIR_Coverage, 2018,
     /* 307230 */     GIR_EraseRootFromParent_Done,
     /* 307231 */   // Label 6147: @307231
     /* 307231 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307272), // Rule ID 4878 //
     /* 307236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307259 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 307259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 307262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307268 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 307270 */     GIR_RootConstrainSelectedInstOperands,
     /* 307271 */     // GIR_Coverage, 4878,
     /* 307271 */     GIR_EraseRootFromParent_Done,
     /* 307272 */   // Label 6148: @307272
     /* 307272 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(307313), // Rule ID 14120 //
     /* 307277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307300 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 307300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 307303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307309 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 307311 */     GIR_RootConstrainSelectedInstOperands,
     /* 307312 */     // GIR_Coverage, 14120,
     /* 307312 */     GIR_EraseRootFromParent_Done,
     /* 307313 */   // Label 6149: @307313
     /* 307313 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307340), // Rule ID 626 //
     /* 307318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307329 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 307329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 307334 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307338 */     GIR_RootConstrainSelectedInstOperands,
     /* 307339 */     // GIR_Coverage, 626,
     /* 307339 */     GIR_Done,
     /* 307340 */   // Label 6150: @307340
     /* 307340 */   GIM_Reject,
     /* 307341 */ // Label 6141: @307341
     /* 307341 */ GIM_Reject,
     /* 307342 */ // Label 6121: @307342
     /* 307342 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307971),
     /* 307347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 307353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307357 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307470), // Rule ID 6319 //
     /* 307362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 307394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307423 */     // MIs[3] Operand 1
     /* 307423 */     // No operand predicates
     /* 307423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307425 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307468 */     GIR_RootConstrainSelectedInstOperands,
     /* 307469 */     // GIR_Coverage, 6319,
     /* 307469 */     GIR_EraseRootFromParent_Done,
     /* 307470 */   // Label 6152: @307470
     /* 307470 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307583), // Rule ID 14184 //
     /* 307475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307511 */     // MIs[2] Operand 1
     /* 307511 */     // No operand predicates
     /* 307511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307532 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307538 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307581 */     GIR_RootConstrainSelectedInstOperands,
     /* 307582 */     // GIR_Coverage, 14184,
     /* 307582 */     GIR_EraseRootFromParent_Done,
     /* 307583 */   // Label 6153: @307583
     /* 307583 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307659), // Rule ID 14118 //
     /* 307588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307609 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307619 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307657 */     GIR_RootConstrainSelectedInstOperands,
     /* 307658 */     // GIR_Coverage, 14118,
     /* 307658 */     GIR_EraseRootFromParent_Done,
     /* 307659 */   // Label 6154: @307659
     /* 307659 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307735), // Rule ID 4876 //
     /* 307664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307689 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307695 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307707 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307733 */     GIR_RootConstrainSelectedInstOperands,
     /* 307734 */     // GIR_Coverage, 4876,
     /* 307734 */     GIR_EraseRootFromParent_Done,
     /* 307735 */   // Label 6155: @307735
     /* 307735 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307798), // Rule ID 13722 //
     /* 307740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307776 */     // MIs[2] Operand 1
     /* 307776 */     // No operand predicates
     /* 307776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307782 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307796 */     GIR_RootConstrainSelectedInstOperands,
     /* 307797 */     // GIR_Coverage, 13722,
     /* 307797 */     GIR_EraseRootFromParent_Done,
     /* 307798 */   // Label 6156: @307798
     /* 307798 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307861), // Rule ID 2020 //
     /* 307803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307843 */     // MIs[2] Operand 1
     /* 307843 */     // No operand predicates
     /* 307843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307845 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307859 */     GIR_RootConstrainSelectedInstOperands,
     /* 307860 */     // GIR_Coverage, 2020,
     /* 307860 */     GIR_EraseRootFromParent_Done,
     /* 307861 */   // Label 6157: @307861
     /* 307861 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307902), // Rule ID 4879 //
     /* 307866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307889 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307898 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 307900 */     GIR_RootConstrainSelectedInstOperands,
     /* 307901 */     // GIR_Coverage, 4879,
     /* 307901 */     GIR_EraseRootFromParent_Done,
     /* 307902 */   // Label 6158: @307902
     /* 307902 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307943), // Rule ID 14121 //
     /* 307907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307930 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307939 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 307941 */     GIR_RootConstrainSelectedInstOperands,
     /* 307942 */     // GIR_Coverage, 14121,
     /* 307942 */     GIR_EraseRootFromParent_Done,
     /* 307943 */   // Label 6159: @307943
     /* 307943 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307970), // Rule ID 628 //
     /* 307948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307959 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 307959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307964 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307968 */     GIR_RootConstrainSelectedInstOperands,
     /* 307969 */     // GIR_Coverage, 628,
     /* 307969 */     GIR_Done,
     /* 307970 */   // Label 6160: @307970
     /* 307970 */   GIM_Reject,
     /* 307971 */ // Label 6151: @307971
     /* 307971 */ GIM_Reject,
     /* 307972 */ // Label 6122: @307972
     /* 307972 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(308501),
     /* 307977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 307983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307987 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(308073), // Rule ID 13711 //
     /* 307992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308040 */     // MIs[3] Operand 1
     /* 308040 */     // No operand predicates
     /* 308040 */     // MIs[1] Operand 2
     /* 308040 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308057 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308071 */     GIR_RootConstrainSelectedInstOperands,
     /* 308072 */     // GIR_Coverage, 13711,
     /* 308072 */     GIR_EraseRootFromParent_Done,
     /* 308073 */   // Label 6162: @308073
     /* 308073 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(308159), // Rule ID 2009 //
     /* 308078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308126 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308130 */     // MIs[3] Operand 1
     /* 308130 */     // No operand predicates
     /* 308130 */     // MIs[1] Operand 2
     /* 308130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308143 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308157 */     GIR_RootConstrainSelectedInstOperands,
     /* 308158 */     // GIR_Coverage, 2009,
     /* 308158 */     GIR_EraseRootFromParent_Done,
     /* 308159 */   // Label 6163: @308159
     /* 308159 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308222), // Rule ID 13712 //
     /* 308164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308196 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308200 */     // MIs[2] Operand 1
     /* 308200 */     // No operand predicates
     /* 308200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308206 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308220 */     GIR_RootConstrainSelectedInstOperands,
     /* 308221 */     // GIR_Coverage, 13712,
     /* 308221 */     GIR_EraseRootFromParent_Done,
     /* 308222 */   // Label 6164: @308222
     /* 308222 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(308285), // Rule ID 2010 //
     /* 308227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308263 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308267 */     // MIs[2] Operand 1
     /* 308267 */     // No operand predicates
     /* 308267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308269 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308283 */     GIR_RootConstrainSelectedInstOperands,
     /* 308284 */     // GIR_Coverage, 2010,
     /* 308284 */     GIR_EraseRootFromParent_Done,
     /* 308285 */   // Label 6165: @308285
     /* 308285 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(308379), // Rule ID 14186 //
     /* 308290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308313 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308377 */     GIR_RootConstrainSelectedInstOperands,
     /* 308378 */     // GIR_Coverage, 14186,
     /* 308378 */     GIR_EraseRootFromParent_Done,
     /* 308379 */   // Label 6166: @308379
     /* 308379 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308473), // Rule ID 6321 //
     /* 308384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308407 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308471 */     GIR_RootConstrainSelectedInstOperands,
     /* 308472 */     // GIR_Coverage, 6321,
     /* 308472 */     GIR_EraseRootFromParent_Done,
     /* 308473 */   // Label 6167: @308473
     /* 308473 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308500), // Rule ID 1327 //
     /* 308478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308489 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 308489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 308494 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308498 */     GIR_RootConstrainSelectedInstOperands,
     /* 308499 */     // GIR_Coverage, 1327,
     /* 308499 */     GIR_Done,
     /* 308500 */   // Label 6168: @308500
     /* 308500 */   GIM_Reject,
     /* 308501 */ // Label 6161: @308501
     /* 308501 */ GIM_Reject,
     /* 308502 */ // Label 6123: @308502
     /* 308502 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308859),
     /* 308507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308517 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308580), // Rule ID 13716 //
     /* 308522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308558 */     // MIs[2] Operand 1
     /* 308558 */     // No operand predicates
     /* 308558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308564 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308578 */     GIR_RootConstrainSelectedInstOperands,
     /* 308579 */     // GIR_Coverage, 13716,
     /* 308579 */     GIR_EraseRootFromParent_Done,
     /* 308580 */   // Label 6170: @308580
     /* 308580 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308643), // Rule ID 2014 //
     /* 308585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308625 */     // MIs[2] Operand 1
     /* 308625 */     // No operand predicates
     /* 308625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308627 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308641 */     GIR_RootConstrainSelectedInstOperands,
     /* 308642 */     // GIR_Coverage, 2014,
     /* 308642 */     GIR_EraseRootFromParent_Done,
     /* 308643 */   // Label 6171: @308643
     /* 308643 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308737), // Rule ID 14190 //
     /* 308648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308671 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308735 */     GIR_RootConstrainSelectedInstOperands,
     /* 308736 */     // GIR_Coverage, 14190,
     /* 308736 */     GIR_EraseRootFromParent_Done,
     /* 308737 */   // Label 6172: @308737
     /* 308737 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308831), // Rule ID 6325 //
     /* 308742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308765 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308829 */     GIR_RootConstrainSelectedInstOperands,
     /* 308830 */     // GIR_Coverage, 6325,
     /* 308830 */     GIR_EraseRootFromParent_Done,
     /* 308831 */   // Label 6173: @308831
     /* 308831 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308858), // Rule ID 1331 //
     /* 308836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308847 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 308852 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308856 */     GIR_RootConstrainSelectedInstOperands,
     /* 308857 */     // GIR_Coverage, 1331,
     /* 308857 */     GIR_Done,
     /* 308858 */   // Label 6174: @308858
     /* 308858 */   GIM_Reject,
     /* 308859 */ // Label 6169: @308859
     /* 308859 */ GIM_Reject,
     /* 308860 */ // Label 6124: @308860
     /* 308860 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(309201),
     /* 308865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308875 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308961), // Rule ID 13705 //
     /* 308880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308924 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308928 */     // MIs[3] Operand 1
     /* 308928 */     // No operand predicates
     /* 308928 */     // MIs[1] Operand 2
     /* 308928 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308945 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308959 */     GIR_RootConstrainSelectedInstOperands,
     /* 308960 */     // GIR_Coverage, 13705,
     /* 308960 */     GIR_EraseRootFromParent_Done,
     /* 308961 */   // Label 6176: @308961
     /* 308961 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(309047), // Rule ID 2003 //
     /* 308966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309018 */     // MIs[3] Operand 1
     /* 309018 */     // No operand predicates
     /* 309018 */     // MIs[1] Operand 2
     /* 309018 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 309029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309031 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 309034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309045 */     GIR_RootConstrainSelectedInstOperands,
     /* 309046 */     // GIR_Coverage, 2003,
     /* 309046 */     GIR_EraseRootFromParent_Done,
     /* 309047 */   // Label 6177: @309047
     /* 309047 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(309110), // Rule ID 13706 //
     /* 309052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309088 */     // MIs[2] Operand 1
     /* 309088 */     // No operand predicates
     /* 309088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309094 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 309097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309108 */     GIR_RootConstrainSelectedInstOperands,
     /* 309109 */     // GIR_Coverage, 13706,
     /* 309109 */     GIR_EraseRootFromParent_Done,
     /* 309110 */   // Label 6178: @309110
     /* 309110 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(309173), // Rule ID 2004 //
     /* 309115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309155 */     // MIs[2] Operand 1
     /* 309155 */     // No operand predicates
     /* 309155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309157 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 309160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309171 */     GIR_RootConstrainSelectedInstOperands,
     /* 309172 */     // GIR_Coverage, 2004,
     /* 309172 */     GIR_EraseRootFromParent_Done,
     /* 309173 */   // Label 6179: @309173
     /* 309173 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309200), // Rule ID 1323 //
     /* 309178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309189 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 309189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 309194 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309198 */     GIR_RootConstrainSelectedInstOperands,
     /* 309199 */     // GIR_Coverage, 1323,
     /* 309199 */     GIR_Done,
     /* 309200 */   // Label 6180: @309200
     /* 309200 */   GIM_Reject,
     /* 309201 */ // Label 6175: @309201
     /* 309201 */ GIM_Reject,
     /* 309202 */ // Label 6125: @309202
     /* 309202 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309559),
     /* 309207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 309213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309217 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(309280), // Rule ID 13714 //
     /* 309222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 309233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 309258 */     // MIs[2] Operand 1
     /* 309258 */     // No operand predicates
     /* 309258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309264 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309278 */     GIR_RootConstrainSelectedInstOperands,
     /* 309279 */     // GIR_Coverage, 13714,
     /* 309279 */     GIR_EraseRootFromParent_Done,
     /* 309280 */   // Label 6182: @309280
     /* 309280 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(309343), // Rule ID 2012 //
     /* 309285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 309300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 309325 */     // MIs[2] Operand 1
     /* 309325 */     // No operand predicates
     /* 309325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309327 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309341 */     GIR_RootConstrainSelectedInstOperands,
     /* 309342 */     // GIR_Coverage, 2012,
     /* 309342 */     GIR_EraseRootFromParent_Done,
     /* 309343 */   // Label 6183: @309343
     /* 309343 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309437), // Rule ID 14188 //
     /* 309348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 309356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309371 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 309371 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 309374 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309378 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309404 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309435 */     GIR_RootConstrainSelectedInstOperands,
     /* 309436 */     // GIR_Coverage, 14188,
     /* 309436 */     GIR_EraseRootFromParent_Done,
     /* 309437 */   // Label 6184: @309437
     /* 309437 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(309531), // Rule ID 6323 //
     /* 309442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 309454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309465 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 309465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 309468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309529 */     GIR_RootConstrainSelectedInstOperands,
     /* 309530 */     // GIR_Coverage, 6323,
     /* 309530 */     GIR_EraseRootFromParent_Done,
     /* 309531 */   // Label 6185: @309531
     /* 309531 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(309558), // Rule ID 1329 //
     /* 309536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309547 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309552 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309556 */     GIR_RootConstrainSelectedInstOperands,
     /* 309557 */     // GIR_Coverage, 1329,
     /* 309557 */     GIR_Done,
     /* 309558 */   // Label 6186: @309558
     /* 309558 */   GIM_Reject,
     /* 309559 */ // Label 6181: @309559
     /* 309559 */ GIM_Reject,
     /* 309560 */ // Label 6126: @309560
     /* 309560 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(309991),
     /* 309565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309575 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(309638), // Rule ID 13708 //
     /* 309580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309612 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309616 */     // MIs[2] Operand 1
     /* 309616 */     // No operand predicates
     /* 309616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309622 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309636 */     GIR_RootConstrainSelectedInstOperands,
     /* 309637 */     // GIR_Coverage, 13708,
     /* 309637 */     GIR_EraseRootFromParent_Done,
     /* 309638 */   // Label 6188: @309638
     /* 309638 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(309701), // Rule ID 2006 //
     /* 309643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309683 */     // MIs[2] Operand 1
     /* 309683 */     // No operand predicates
     /* 309683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309685 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309699 */     GIR_RootConstrainSelectedInstOperands,
     /* 309700 */     // GIR_Coverage, 2006,
     /* 309700 */     GIR_EraseRootFromParent_Done,
     /* 309701 */   // Label 6189: @309701
     /* 309701 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(309728), // Rule ID 1325 //
     /* 309706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309717 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 309722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309726 */     GIR_RootConstrainSelectedInstOperands,
     /* 309727 */     // GIR_Coverage, 1325,
     /* 309727 */     GIR_Done,
     /* 309728 */   // Label 6190: @309728
     /* 309728 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(309990), // Rule ID 7094 //
     /* 309733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309744 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309744 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309747 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309751 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309756 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309762 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309765 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309769 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309774 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309780 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309783 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309787 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309792 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309795 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309800 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309803 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309807 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309812 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309818 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309823 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309828 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309831 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309835 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309840 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309845 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309848 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309852 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309857 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309863 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309868 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309873 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309876 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309880 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309885 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309890 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309893 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309897 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309902 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309905 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309922 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309953 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309988 */     GIR_RootConstrainSelectedInstOperands,
     /* 309989 */     // GIR_Coverage, 7094,
     /* 309989 */     GIR_EraseRootFromParent_Done,
     /* 309990 */   // Label 6191: @309990
     /* 309990 */   GIM_Reject,
     /* 309991 */ // Label 6187: @309991
     /* 309991 */ GIM_Reject,
     /* 309992 */ // Label 6127: @309992
     /* 309992 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(310305),
     /* 309997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 310000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 310003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 310007 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(310062), // Rule ID 13941 //
     /* 310012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310023 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310026 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 310035 */     // MIs[1] idx
     /* 310035 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310038 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 310043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310045 */     // (fmul:{ *:[nxv2f64] } (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx), nxv2f64:{ *:[nxv2f64] }:$Op1)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 310045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 310052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310060 */     GIR_RootConstrainSelectedInstOperands,
     /* 310061 */     // GIR_Coverage, 13941,
     /* 310061 */     GIR_EraseRootFromParent_Done,
     /* 310062 */   // Label 6193: @310062
     /* 310062 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(310117), // Rule ID 2867 //
     /* 310067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310078 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310081 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 310090 */     // MIs[1] idx
     /* 310090 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310093 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 310098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310100 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 310100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 310107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310115 */     GIR_RootConstrainSelectedInstOperands,
     /* 310116 */     // GIR_Coverage, 2867,
     /* 310116 */     GIR_EraseRootFromParent_Done,
     /* 310117 */   // Label 6194: @310117
     /* 310117 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(310160), // Rule ID 15309 //
     /* 310122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN1),
     /* 310133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 310137 */     // MIs[1] R
     /* 310137 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310144 */     // (fmul:{ *:[nxv2f64] } (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R), nxv2f64:{ *:[nxv2f64] }:$L)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 0:{ *:[i32] })
     /* 310144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310149 */     GIR_RootToRootCopy, /*OpIdx*/2, // L
     /* 310151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 310155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310158 */     GIR_RootConstrainSelectedInstOperands,
     /* 310159 */     // GIR_Coverage, 15309,
     /* 310159 */     GIR_EraseRootFromParent_Done,
     /* 310160 */   // Label 6195: @310160
     /* 310160 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(310203), // Rule ID 15310 //
     /* 310165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN2),
     /* 310176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 310180 */     // MIs[1] R
     /* 310180 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310187 */     // (fmul:{ *:[nxv2f64] } (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R), nxv2f64:{ *:[nxv2f64] }:$L)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 1:{ *:[i32] })
     /* 310187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310192 */     GIR_RootToRootCopy, /*OpIdx*/2, // L
     /* 310194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 310198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 310201 */     GIR_RootConstrainSelectedInstOperands,
     /* 310202 */     // GIR_Coverage, 15310,
     /* 310202 */     GIR_EraseRootFromParent_Done,
     /* 310203 */   // Label 6196: @310203
     /* 310203 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310246), // Rule ID 8409 //
     /* 310208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN1),
     /* 310219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 310223 */     // MIs[1] R
     /* 310223 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310230 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$L, (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 0:{ *:[i32] })
     /* 310230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310235 */     GIR_RootToRootCopy, /*OpIdx*/1, // L
     /* 310237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 310241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310244 */     GIR_RootConstrainSelectedInstOperands,
     /* 310245 */     // GIR_Coverage, 8409,
     /* 310245 */     GIR_EraseRootFromParent_Done,
     /* 310246 */   // Label 6197: @310246
     /* 310246 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310289), // Rule ID 8412 //
     /* 310251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN2),
     /* 310262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 310266 */     // MIs[1] R
     /* 310266 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310273 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$L, (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 1:{ *:[i32] })
     /* 310273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 310276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310278 */     GIR_RootToRootCopy, /*OpIdx*/1, // L
     /* 310280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 310284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 310287 */     GIR_RootConstrainSelectedInstOperands,
     /* 310288 */     // GIR_Coverage, 8412,
     /* 310288 */     GIR_EraseRootFromParent_Done,
     /* 310289 */   // Label 6198: @310289
     /* 310289 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310304), // Rule ID 8304 //
     /* 310294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310297 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 310297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 310302 */     GIR_RootConstrainSelectedInstOperands,
     /* 310303 */     // GIR_Coverage, 8304,
     /* 310303 */     GIR_Done,
     /* 310304 */   // Label 6199: @310304
     /* 310304 */   GIM_Reject,
     /* 310305 */ // Label 6192: @310305
     /* 310305 */ GIM_Reject,
     /* 310306 */ // Label 6128: @310306
     /* 310306 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310447),
     /* 310311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 310314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 310317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 310321 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310376), // Rule ID 13940 //
     /* 310326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310337 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310340 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 310349 */     // MIs[1] idx
     /* 310349 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310352 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 310357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310359 */     // (fmul:{ *:[nxv4f32] } (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx), nxv4f32:{ *:[nxv4f32] }:$Op1)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 310359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 310362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 310366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310374 */     GIR_RootConstrainSelectedInstOperands,
     /* 310375 */     // GIR_Coverage, 13940,
     /* 310375 */     GIR_EraseRootFromParent_Done,
     /* 310376 */   // Label 6201: @310376
     /* 310376 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310431), // Rule ID 2863 //
     /* 310381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310392 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310395 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 310404 */     // MIs[1] idx
     /* 310404 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310407 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 310412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310414 */     // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx))  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 310414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 310417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 310421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310429 */     GIR_RootConstrainSelectedInstOperands,
     /* 310430 */     // GIR_Coverage, 2863,
     /* 310430 */     GIR_EraseRootFromParent_Done,
     /* 310431 */   // Label 6202: @310431
     /* 310431 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310446), // Rule ID 8301 //
     /* 310436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310439 */     // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 310439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 310444 */     GIR_RootConstrainSelectedInstOperands,
     /* 310445 */     // GIR_Coverage, 8301,
     /* 310445 */     GIR_Done,
     /* 310446 */   // Label 6203: @310446
     /* 310446 */   GIM_Reject,
     /* 310447 */ // Label 6200: @310447
     /* 310447 */ GIM_Reject,
     /* 310448 */ // Label 6129: @310448
     /* 310448 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310589),
     /* 310453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 310456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 310463 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310518), // Rule ID 13939 //
     /* 310468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310479 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310482 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310491 */     // MIs[1] idx
     /* 310491 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310494 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 310499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310501 */     // (fmul:{ *:[nxv8f16] } (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx), nxv8f16:{ *:[nxv8f16] }:$Op1)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 310501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 310504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 310508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310516 */     GIR_RootConstrainSelectedInstOperands,
     /* 310517 */     // GIR_Coverage, 13939,
     /* 310517 */     GIR_EraseRootFromParent_Done,
     /* 310518 */   // Label 6205: @310518
     /* 310518 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310573), // Rule ID 2859 //
     /* 310523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310546 */     // MIs[1] idx
     /* 310546 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310549 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 310554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310556 */     // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx))  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 310556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 310559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 310563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310571 */     GIR_RootConstrainSelectedInstOperands,
     /* 310572 */     // GIR_Coverage, 2859,
     /* 310572 */     GIR_EraseRootFromParent_Done,
     /* 310573 */   // Label 6206: @310573
     /* 310573 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(310588), // Rule ID 8298 //
     /* 310578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310581 */     // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 310581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 310586 */     GIR_RootConstrainSelectedInstOperands,
     /* 310587 */     // GIR_Coverage, 8298,
     /* 310587 */     GIR_Done,
     /* 310588 */   // Label 6207: @310588
     /* 310588 */   GIM_Reject,
     /* 310589 */ // Label 6204: @310589
     /* 310589 */ GIM_Reject,
     /* 310590 */ // Label 6130: @310590
     /* 310590 */ GIM_Reject,
     /* 310591 */ // Label 62: @310591
     /* 310591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6216*/ GIMT_Encode4(326863),
     /* 310602 */ /*GILLT_s16*//*Label 6208*/ GIMT_Encode4(310642),
     /* 310606 */ /*GILLT_s32*//*Label 6209*/ GIMT_Encode4(313646),
     /* 310610 */ /*GILLT_s64*//*Label 6210*/ GIMT_Encode4(316794), GIMT_Encode4(0),
     /* 310618 */ /*GILLT_v2s32*//*Label 6211*/ GIMT_Encode4(319942),
     /* 310622 */ /*GILLT_v2s64*//*Label 6212*/ GIMT_Encode4(321463),
     /* 310626 */ /*GILLT_v4s16*//*Label 6213*/ GIMT_Encode4(322984),
     /* 310630 */ /*GILLT_v4s32*//*Label 6214*/ GIMT_Encode4(324163), GIMT_Encode4(0),
     /* 310638 */ /*GILLT_v8s16*//*Label 6215*/ GIMT_Encode4(325684),
     /* 310642 */ // Label 6208: @310642
     /* 310642 */ GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(313645),
     /* 310647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 310653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 310656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310660 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(310810), // Rule ID 4934 //
     /* 310665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310689 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310714 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 310722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310730 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310737 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310749 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310755 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310777 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 310808 */     GIR_RootConstrainSelectedInstOperands,
     /* 310809 */     // GIR_Coverage, 4934,
     /* 310809 */     GIR_EraseRootFromParent_Done,
     /* 310810 */   // Label 6218: @310810
     /* 310810 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(310957), // Rule ID 4898 //
     /* 310815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 310859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310867 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310871 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310876 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310886 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310898 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310926 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310955 */     GIR_RootConstrainSelectedInstOperands,
     /* 310956 */     // GIR_Coverage, 4898,
     /* 310956 */     GIR_EraseRootFromParent_Done,
     /* 310957 */   // Label 6219: @310957
     /* 310957 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(311104), // Rule ID 14127 //
     /* 310962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310998 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311010 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311014 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311018 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311023 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311033 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 311036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311045 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311073 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311102 */     GIR_RootConstrainSelectedInstOperands,
     /* 311103 */     // GIR_Coverage, 14127,
     /* 311103 */     GIR_EraseRootFromParent_Done,
     /* 311104 */   // Label 6220: @311104
     /* 311104 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(311235), // Rule ID 6153 //
     /* 311109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311161 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311165 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311178 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311182 */     // MIs[4] Operand 1
     /* 311182 */     // No operand predicates
     /* 311182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311188 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311200 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311233 */     GIR_RootConstrainSelectedInstOperands,
     /* 311234 */     // GIR_Coverage, 6153,
     /* 311234 */     GIR_EraseRootFromParent_Done,
     /* 311235 */   // Label 6221: @311235
     /* 311235 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(311366), // Rule ID 6185 //
     /* 311240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311276 */     // MIs[2] Operand 1
     /* 311276 */     // No operand predicates
     /* 311276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 311288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 311292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311296 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311300 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311304 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311309 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311317 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311319 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311331 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311364 */     GIR_RootConstrainSelectedInstOperands,
     /* 311365 */     // GIR_Coverage, 6185,
     /* 311365 */     GIR_EraseRootFromParent_Done,
     /* 311366 */   // Label 6222: @311366
     /* 311366 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(311497), // Rule ID 6249 //
     /* 311371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311407 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311444 */     // MIs[4] Operand 1
     /* 311444 */     // No operand predicates
     /* 311444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311448 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311450 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311462 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311495 */     GIR_RootConstrainSelectedInstOperands,
     /* 311496 */     // GIR_Coverage, 6249,
     /* 311496 */     GIR_EraseRootFromParent_Done,
     /* 311497 */   // Label 6223: @311497
     /* 311497 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(311628), // Rule ID 6217 //
     /* 311502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311550 */     // MIs[3] Operand 1
     /* 311550 */     // No operand predicates
     /* 311550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 311554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311562 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311566 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311571 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311581 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311593 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311626 */     GIR_RootConstrainSelectedInstOperands,
     /* 311627 */     // GIR_Coverage, 6217,
     /* 311627 */     GIR_EraseRootFromParent_Done,
     /* 311628 */   // Label 6224: @311628
     /* 311628 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(311763), // Rule ID 2463 //
     /* 311633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311657 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311692 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 311695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311704 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311732 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311761 */     GIR_RootConstrainSelectedInstOperands,
     /* 311762 */     // GIR_Coverage, 2463,
     /* 311762 */     GIR_EraseRootFromParent_Done,
     /* 311763 */   // Label 6225: @311763
     /* 311763 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(311882), // Rule ID 6121 //
     /* 311768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311829 */     // MIs[3] Operand 1
     /* 311829 */     // No operand predicates
     /* 311829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311835 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311880 */     GIR_RootConstrainSelectedInstOperands,
     /* 311881 */     // GIR_Coverage, 6121,
     /* 311881 */     GIR_EraseRootFromParent_Done,
     /* 311882 */   // Label 6226: @311882
     /* 311882 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312001), // Rule ID 2538 //
     /* 311887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311923 */     // MIs[2] Operand 1
     /* 311923 */     // No operand predicates
     /* 311923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311935 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311944 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311954 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311966 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311999 */     GIR_RootConstrainSelectedInstOperands,
     /* 312000 */     // GIR_Coverage, 2538,
     /* 312000 */     GIR_EraseRootFromParent_Done,
     /* 312001 */   // Label 6227: @312001
     /* 312001 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312101), // Rule ID 4896 //
     /* 312006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312057 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312069 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312099 */     GIR_RootConstrainSelectedInstOperands,
     /* 312100 */     // GIR_Coverage, 4896,
     /* 312100 */     GIR_EraseRootFromParent_Done,
     /* 312101 */   // Label 6228: @312101
     /* 312101 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312201), // Rule ID 4932 //
     /* 312106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312157 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 312188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312199 */     GIR_RootConstrainSelectedInstOperands,
     /* 312200 */     // GIR_Coverage, 4932,
     /* 312200 */     GIR_EraseRootFromParent_Done,
     /* 312201 */   // Label 6229: @312201
     /* 312201 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(312298), // Rule ID 14123 //
     /* 312206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312242 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312256 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312268 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312296 */     GIR_RootConstrainSelectedInstOperands,
     /* 312297 */     // GIR_Coverage, 14123,
     /* 312297 */     GIR_EraseRootFromParent_Done,
     /* 312298 */   // Label 6230: @312298
     /* 312298 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(312398), // Rule ID 14125 //
     /* 312303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312344 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312354 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312396 */     GIR_RootConstrainSelectedInstOperands,
     /* 312397 */     // GIR_Coverage, 14125,
     /* 312397 */     GIR_EraseRootFromParent_Done,
     /* 312398 */   // Label 6231: @312398
     /* 312398 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(312498), // Rule ID 4930 //
     /* 312403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312454 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 312485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312496 */     GIR_RootConstrainSelectedInstOperands,
     /* 312497 */     // GIR_Coverage, 4930,
     /* 312497 */     GIR_EraseRootFromParent_Done,
     /* 312498 */   // Label 6232: @312498
     /* 312498 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(312595), // Rule ID 4894 //
     /* 312503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312543 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312553 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312593 */     GIR_RootConstrainSelectedInstOperands,
     /* 312594 */     // GIR_Coverage, 4894,
     /* 312594 */     GIR_EraseRootFromParent_Done,
     /* 312595 */   // Label 6233: @312595
     /* 312595 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(312679), // Rule ID 6183 //
     /* 312600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312632 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312636 */     // MIs[2] Operand 1
     /* 312636 */     // No operand predicates
     /* 312636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 312648 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312659 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 312670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312677 */     GIR_RootConstrainSelectedInstOperands,
     /* 312678 */     // GIR_Coverage, 6183,
     /* 312678 */     GIR_EraseRootFromParent_Done,
     /* 312679 */   // Label 6234: @312679
     /* 312679 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(312760), // Rule ID 6215 //
     /* 312684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312732 */     // MIs[3] Operand 1
     /* 312732 */     // No operand predicates
     /* 312732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312742 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312758 */     GIR_RootConstrainSelectedInstOperands,
     /* 312759 */     // GIR_Coverage, 6215,
     /* 312759 */     GIR_EraseRootFromParent_Done,
     /* 312760 */   // Label 6235: @312760
     /* 312760 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(312844), // Rule ID 6247 //
     /* 312765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312818 */     // MIs[3] Operand 1
     /* 312818 */     // No operand predicates
     /* 312818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312824 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312842 */     GIR_RootConstrainSelectedInstOperands,
     /* 312843 */     // GIR_Coverage, 6247,
     /* 312843 */     GIR_EraseRootFromParent_Done,
     /* 312844 */   // Label 6236: @312844
     /* 312844 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(312925), // Rule ID 6151 //
     /* 312849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312901 */     // MIs[3] Operand 1
     /* 312901 */     // No operand predicates
     /* 312901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312907 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312923 */     GIR_RootConstrainSelectedInstOperands,
     /* 312924 */     // GIR_Coverage, 6151,
     /* 312924 */     GIR_EraseRootFromParent_Done,
     /* 312925 */   // Label 6237: @312925
     /* 312925 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313010), // Rule ID 2461 //
     /* 312930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312954 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312968 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313008 */     GIR_RootConstrainSelectedInstOperands,
     /* 313009 */     // GIR_Coverage, 2461,
     /* 313009 */     GIR_EraseRootFromParent_Done,
     /* 313010 */   // Label 6238: @313010
     /* 313010 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313095), // Rule ID 2459 //
     /* 313015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313053 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 313053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 313071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 313084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313093 */     GIR_RootConstrainSelectedInstOperands,
     /* 313094 */     // GIR_Coverage, 2459,
     /* 313094 */     GIR_EraseRootFromParent_Done,
     /* 313095 */   // Label 6239: @313095
     /* 313095 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(313164), // Rule ID 2536 //
     /* 313100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 313124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313132 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 313136 */     // MIs[2] Operand 1
     /* 313136 */     // No operand predicates
     /* 313136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313146 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 313146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 313149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313162 */     GIR_RootConstrainSelectedInstOperands,
     /* 313163 */     // GIR_Coverage, 2536,
     /* 313163 */     GIR_EraseRootFromParent_Done,
     /* 313164 */   // Label 6240: @313164
     /* 313164 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(313233), // Rule ID 6119 //
     /* 313169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 313197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 313209 */     // MIs[2] Operand 1
     /* 313209 */     // No operand predicates
     /* 313209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313215 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 313215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 313218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313231 */     GIR_RootConstrainSelectedInstOperands,
     /* 313232 */     // GIR_Coverage, 6119,
     /* 313232 */     GIR_EraseRootFromParent_Done,
     /* 313233 */   // Label 6241: @313233
     /* 313233 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(313298), // Rule ID 4950 //
     /* 313238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313281 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 313284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313296 */     GIR_RootConstrainSelectedInstOperands,
     /* 313297 */     // GIR_Coverage, 4950,
     /* 313297 */     GIR_EraseRootFromParent_Done,
     /* 313298 */   // Label 6242: @313298
     /* 313298 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(313363), // Rule ID 14143 //
     /* 313303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313346 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 313349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 313357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313361 */     GIR_RootConstrainSelectedInstOperands,
     /* 313362 */     // GIR_Coverage, 14143,
     /* 313362 */     GIR_EraseRootFromParent_Done,
     /* 313363 */   // Label 6243: @313363
     /* 313363 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(313413), // Rule ID 4947 //
     /* 313368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313398 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313411 */     GIR_RootConstrainSelectedInstOperands,
     /* 313412 */     // GIR_Coverage, 4947,
     /* 313412 */     GIR_EraseRootFromParent_Done,
     /* 313413 */   // Label 6244: @313413
     /* 313413 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(313463), // Rule ID 13554 //
     /* 313418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313448 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313461 */     GIR_RootConstrainSelectedInstOperands,
     /* 313462 */     // GIR_Coverage, 13554,
     /* 313462 */     GIR_EraseRootFromParent_Done,
     /* 313463 */   // Label 6245: @313463
     /* 313463 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(313513), // Rule ID 648 //
     /* 313468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313498 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313511 */     GIR_RootConstrainSelectedInstOperands,
     /* 313512 */     // GIR_Coverage, 648,
     /* 313512 */     GIR_EraseRootFromParent_Done,
     /* 313513 */   // Label 6246: @313513
     /* 313513 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(313563), // Rule ID 14140 //
     /* 313518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313548 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 313559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313561 */     GIR_RootConstrainSelectedInstOperands,
     /* 313562 */     // GIR_Coverage, 14140,
     /* 313562 */     GIR_EraseRootFromParent_Done,
     /* 313563 */   // Label 6247: @313563
     /* 313563 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(313613), // Rule ID 660 //
     /* 313568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 313583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313598 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 313601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 313611 */     GIR_RootConstrainSelectedInstOperands,
     /* 313612 */     // GIR_Coverage, 660,
     /* 313612 */     GIR_EraseRootFromParent_Done,
     /* 313613 */   // Label 6248: @313613
     /* 313613 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(313644), // Rule ID 642 //
     /* 313618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313633 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 313638 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313642 */     GIR_RootConstrainSelectedInstOperands,
     /* 313643 */     // GIR_Coverage, 642,
     /* 313643 */     GIR_Done,
     /* 313644 */   // Label 6249: @313644
     /* 313644 */   GIM_Reject,
     /* 313645 */ // Label 6217: @313645
     /* 313645 */ GIM_Reject,
     /* 313646 */ // Label 6209: @313646
     /* 313646 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(316793),
     /* 313651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 313660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313664 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(313814), // Rule ID 4940 //
     /* 313669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313693 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313718 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 313726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313730 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313741 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313753 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 313812 */     GIR_RootConstrainSelectedInstOperands,
     /* 313813 */     // GIR_Coverage, 4940,
     /* 313813 */     GIR_EraseRootFromParent_Done,
     /* 313814 */   // Label 6251: @313814
     /* 313814 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(313961), // Rule ID 4904 //
     /* 313819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313843 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313875 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313880 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313890 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313890 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313893 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313897 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313902 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313930 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313959 */     GIR_RootConstrainSelectedInstOperands,
     /* 313960 */     // GIR_Coverage, 4904,
     /* 313960 */     GIR_EraseRootFromParent_Done,
     /* 313961 */   // Label 6252: @313961
     /* 313961 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(314108), // Rule ID 14133 //
     /* 313966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314002 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314027 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314037 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314049 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314106 */     GIR_RootConstrainSelectedInstOperands,
     /* 314107 */     // GIR_Coverage, 14133,
     /* 314107 */     GIR_EraseRootFromParent_Done,
     /* 314108 */   // Label 6253: @314108
     /* 314108 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(314239), // Rule ID 6169 //
     /* 314113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314161 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314165 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314178 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314182 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314186 */     // MIs[4] Operand 1
     /* 314186 */     // No operand predicates
     /* 314186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314190 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314192 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314204 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 314234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 314237 */     GIR_RootConstrainSelectedInstOperands,
     /* 314238 */     // GIR_Coverage, 6169,
     /* 314238 */     GIR_EraseRootFromParent_Done,
     /* 314239 */   // Label 6254: @314239
     /* 314239 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(314370), // Rule ID 6201 //
     /* 314244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314280 */     // MIs[2] Operand 1
     /* 314280 */     // No operand predicates
     /* 314280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314288 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 314292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 314296 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314300 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314304 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 314308 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314313 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 314317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314321 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314323 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314368 */     GIR_RootConstrainSelectedInstOperands,
     /* 314369 */     // GIR_Coverage, 6201,
     /* 314369 */     GIR_EraseRootFromParent_Done,
     /* 314370 */   // Label 6255: @314370
     /* 314370 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(314501), // Rule ID 6265 //
     /* 314375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314423 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314431 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314440 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314444 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314448 */     // MIs[4] Operand 1
     /* 314448 */     // No operand predicates
     /* 314448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314452 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314454 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 314496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 314499 */     GIR_RootConstrainSelectedInstOperands,
     /* 314500 */     // GIR_Coverage, 6265,
     /* 314500 */     GIR_EraseRootFromParent_Done,
     /* 314501 */   // Label 6256: @314501
     /* 314501 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(314632), // Rule ID 6233 //
     /* 314506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314554 */     // MIs[3] Operand 1
     /* 314554 */     // No operand predicates
     /* 314554 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 314558 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314562 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314566 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 314570 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314575 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 314579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314585 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314597 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314630 */     GIR_RootConstrainSelectedInstOperands,
     /* 314631 */     // GIR_Coverage, 6233,
     /* 314631 */     GIR_EraseRootFromParent_Done,
     /* 314632 */   // Label 6257: @314632
     /* 314632 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(314767), // Rule ID 2469 //
     /* 314637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314686 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314696 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314708 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314765 */     GIR_RootConstrainSelectedInstOperands,
     /* 314766 */     // GIR_Coverage, 2469,
     /* 314766 */     GIR_EraseRootFromParent_Done,
     /* 314767 */   // Label 6258: @314767
     /* 314767 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(314886), // Rule ID 6137 //
     /* 314772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314796 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314833 */     // MIs[3] Operand 1
     /* 314833 */     // No operand predicates
     /* 314833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314839 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314851 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314884 */     GIR_RootConstrainSelectedInstOperands,
     /* 314885 */     // GIR_Coverage, 6137,
     /* 314885 */     GIR_EraseRootFromParent_Done,
     /* 314886 */   // Label 6259: @314886
     /* 314886 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315005), // Rule ID 2554 //
     /* 314891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314927 */     // MIs[2] Operand 1
     /* 314927 */     // No operand predicates
     /* 314927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314943 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314948 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314958 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314970 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315003 */     GIR_RootConstrainSelectedInstOperands,
     /* 315004 */     // GIR_Coverage, 2554,
     /* 315004 */     GIR_EraseRootFromParent_Done,
     /* 315005 */   // Label 6260: @315005
     /* 315005 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(315105), // Rule ID 4902 //
     /* 315010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315061 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315073 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315103 */     GIR_RootConstrainSelectedInstOperands,
     /* 315104 */     // GIR_Coverage, 4902,
     /* 315104 */     GIR_EraseRootFromParent_Done,
     /* 315105 */   // Label 6261: @315105
     /* 315105 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(315205), // Rule ID 4938 //
     /* 315110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315134 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315161 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315203 */     GIR_RootConstrainSelectedInstOperands,
     /* 315204 */     // GIR_Coverage, 4938,
     /* 315204 */     GIR_EraseRootFromParent_Done,
     /* 315205 */   // Label 6262: @315205
     /* 315205 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315302), // Rule ID 14129 //
     /* 315210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315260 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315272 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315300 */     GIR_RootConstrainSelectedInstOperands,
     /* 315301 */     // GIR_Coverage, 14129,
     /* 315301 */     GIR_EraseRootFromParent_Done,
     /* 315302 */   // Label 6263: @315302
     /* 315302 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(315402), // Rule ID 14131 //
     /* 315307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315348 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315358 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315370 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315400 */     GIR_RootConstrainSelectedInstOperands,
     /* 315401 */     // GIR_Coverage, 14131,
     /* 315401 */     GIR_EraseRootFromParent_Done,
     /* 315402 */   // Label 6264: @315402
     /* 315402 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(315502), // Rule ID 4936 //
     /* 315407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315435 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315458 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315470 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315500 */     GIR_RootConstrainSelectedInstOperands,
     /* 315501 */     // GIR_Coverage, 4936,
     /* 315501 */     GIR_EraseRootFromParent_Done,
     /* 315502 */   // Label 6265: @315502
     /* 315502 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(315599), // Rule ID 4900 //
     /* 315507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315557 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315569 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315597 */     GIR_RootConstrainSelectedInstOperands,
     /* 315598 */     // GIR_Coverage, 4900,
     /* 315598 */     GIR_EraseRootFromParent_Done,
     /* 315599 */   // Label 6266: @315599
     /* 315599 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(315677), // Rule ID 6287 //
     /* 315604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 315641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315645 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315649 */     // MIs[3] Operand 1
     /* 315649 */     // No operand predicates
     /* 315649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315659 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315675 */     GIR_RootConstrainSelectedInstOperands,
     /* 315676 */     // GIR_Coverage, 6287,
     /* 315676 */     GIR_EraseRootFromParent_Done,
     /* 315677 */   // Label 6267: @315677
     /* 315677 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(315761), // Rule ID 6199 //
     /* 315682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315718 */     // MIs[2] Operand 1
     /* 315718 */     // No operand predicates
     /* 315718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 315730 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315741 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 315752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315759 */     GIR_RootConstrainSelectedInstOperands,
     /* 315760 */     // GIR_Coverage, 6199,
     /* 315760 */     GIR_EraseRootFromParent_Done,
     /* 315761 */   // Label 6268: @315761
     /* 315761 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(315842), // Rule ID 6231 //
     /* 315766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315814 */     // MIs[3] Operand 1
     /* 315814 */     // No operand predicates
     /* 315814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315824 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315840 */     GIR_RootConstrainSelectedInstOperands,
     /* 315841 */     // GIR_Coverage, 6231,
     /* 315841 */     GIR_EraseRootFromParent_Done,
     /* 315842 */   // Label 6269: @315842
     /* 315842 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(315926), // Rule ID 6263 //
     /* 315847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315896 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315900 */     // MIs[3] Operand 1
     /* 315900 */     // No operand predicates
     /* 315900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315906 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315924 */     GIR_RootConstrainSelectedInstOperands,
     /* 315925 */     // GIR_Coverage, 6263,
     /* 315925 */     GIR_EraseRootFromParent_Done,
     /* 315926 */   // Label 6270: @315926
     /* 315926 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316004), // Rule ID 6309 //
     /* 315931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 315972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315976 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315980 */     // MIs[3] Operand 1
     /* 315980 */     // No operand predicates
     /* 315980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315986 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316002 */     GIR_RootConstrainSelectedInstOperands,
     /* 316003 */     // GIR_Coverage, 6309,
     /* 316003 */     GIR_EraseRootFromParent_Done,
     /* 316004 */   // Label 6271: @316004
     /* 316004 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316085), // Rule ID 6167 //
     /* 316009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316057 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316061 */     // MIs[3] Operand 1
     /* 316061 */     // No operand predicates
     /* 316061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316067 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 316070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316083 */     GIR_RootConstrainSelectedInstOperands,
     /* 316084 */     // GIR_Coverage, 6167,
     /* 316084 */     GIR_EraseRootFromParent_Done,
     /* 316085 */   // Label 6272: @316085
     /* 316085 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(316170), // Rule ID 2467 //
     /* 316090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316128 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316140 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 316146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 316159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316168 */     GIR_RootConstrainSelectedInstOperands,
     /* 316169 */     // GIR_Coverage, 2467,
     /* 316169 */     GIR_EraseRootFromParent_Done,
     /* 316170 */   // Label 6273: @316170
     /* 316170 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(316255), // Rule ID 2465 //
     /* 316175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316213 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 316213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 316231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 316244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316253 */     GIR_RootConstrainSelectedInstOperands,
     /* 316254 */     // GIR_Coverage, 2465,
     /* 316254 */     GIR_EraseRootFromParent_Done,
     /* 316255 */   // Label 6274: @316255
     /* 316255 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(316324), // Rule ID 2552 //
     /* 316260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316296 */     // MIs[2] Operand 1
     /* 316296 */     // No operand predicates
     /* 316296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316306 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 316309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316322 */     GIR_RootConstrainSelectedInstOperands,
     /* 316323 */     // GIR_Coverage, 2552,
     /* 316323 */     GIR_EraseRootFromParent_Done,
     /* 316324 */   // Label 6275: @316324
     /* 316324 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(316393), // Rule ID 6135 //
     /* 316329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316369 */     // MIs[2] Operand 1
     /* 316369 */     // No operand predicates
     /* 316369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316375 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 316378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316391 */     GIR_RootConstrainSelectedInstOperands,
     /* 316392 */     // GIR_Coverage, 6135,
     /* 316392 */     GIR_EraseRootFromParent_Done,
     /* 316393 */   // Label 6276: @316393
     /* 316393 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(316455), // Rule ID 4951 //
     /* 316398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 316431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316438 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 316441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316453 */     GIR_RootConstrainSelectedInstOperands,
     /* 316454 */     // GIR_Coverage, 4951,
     /* 316454 */     GIR_EraseRootFromParent_Done,
     /* 316455 */   // Label 6277: @316455
     /* 316455 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(316517), // Rule ID 14144 //
     /* 316460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 316493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316500 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 316503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 316511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316515 */     GIR_RootConstrainSelectedInstOperands,
     /* 316516 */     // GIR_Coverage, 14144,
     /* 316516 */     GIR_EraseRootFromParent_Done,
     /* 316517 */   // Label 6278: @316517
     /* 316517 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(316564), // Rule ID 4948 //
     /* 316522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316549 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316562 */     GIR_RootConstrainSelectedInstOperands,
     /* 316563 */     // GIR_Coverage, 4948,
     /* 316563 */     GIR_EraseRootFromParent_Done,
     /* 316564 */   // Label 6279: @316564
     /* 316564 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(316614), // Rule ID 13556 //
     /* 316569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316599 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316612 */     GIR_RootConstrainSelectedInstOperands,
     /* 316613 */     // GIR_Coverage, 13556,
     /* 316613 */     GIR_EraseRootFromParent_Done,
     /* 316614 */   // Label 6280: @316614
     /* 316614 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(316664), // Rule ID 650 //
     /* 316619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316649 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316662 */     GIR_RootConstrainSelectedInstOperands,
     /* 316663 */     // GIR_Coverage, 650,
     /* 316663 */     GIR_EraseRootFromParent_Done,
     /* 316664 */   // Label 6281: @316664
     /* 316664 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(316711), // Rule ID 14141 //
     /* 316669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316696 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 316707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316709 */     GIR_RootConstrainSelectedInstOperands,
     /* 316710 */     // GIR_Coverage, 14141,
     /* 316710 */     GIR_EraseRootFromParent_Done,
     /* 316711 */   // Label 6282: @316711
     /* 316711 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(316761), // Rule ID 662 //
     /* 316716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 316731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316746 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 316749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 316759 */     GIR_RootConstrainSelectedInstOperands,
     /* 316760 */     // GIR_Coverage, 662,
     /* 316760 */     GIR_EraseRootFromParent_Done,
     /* 316761 */   // Label 6283: @316761
     /* 316761 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(316792), // Rule ID 644 //
     /* 316766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316781 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 316786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316790 */     GIR_RootConstrainSelectedInstOperands,
     /* 316791 */     // GIR_Coverage, 644,
     /* 316791 */     GIR_Done,
     /* 316792 */   // Label 6284: @316792
     /* 316792 */   GIM_Reject,
     /* 316793 */ // Label 6250: @316793
     /* 316793 */ GIM_Reject,
     /* 316794 */ // Label 6210: @316794
     /* 316794 */ GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(319941),
     /* 316799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 316808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316812 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(316962), // Rule ID 4946 //
     /* 316817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 316874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316889 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316901 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316907 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316912 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316929 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 316960 */     GIR_RootConstrainSelectedInstOperands,
     /* 316961 */     // GIR_Coverage, 4946,
     /* 316961 */     GIR_EraseRootFromParent_Done,
     /* 316962 */   // Label 6286: @316962
     /* 316962 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(317109), // Rule ID 4910 //
     /* 316967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317019 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317028 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 317032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317038 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 317041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317050 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 317105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317107 */     GIR_RootConstrainSelectedInstOperands,
     /* 317108 */     // GIR_Coverage, 4910,
     /* 317108 */     GIR_EraseRootFromParent_Done,
     /* 317109 */   // Label 6287: @317109
     /* 317109 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(317256), // Rule ID 14139 //
     /* 317114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317150 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317175 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 317179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317185 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 317188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317197 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 317252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317254 */     GIR_RootConstrainSelectedInstOperands,
     /* 317255 */     // GIR_Coverage, 14139,
     /* 317255 */     GIR_EraseRootFromParent_Done,
     /* 317256 */   // Label 6288: @317256
     /* 317256 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(317387), // Rule ID 6173 //
     /* 317261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 317326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317330 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317334 */     // MIs[4] Operand 1
     /* 317334 */     // No operand predicates
     /* 317334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317338 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317340 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 317382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 317385 */     GIR_RootConstrainSelectedInstOperands,
     /* 317386 */     // GIR_Coverage, 6173,
     /* 317386 */     GIR_EraseRootFromParent_Done,
     /* 317387 */   // Label 6289: @317387
     /* 317387 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(317518), // Rule ID 6205 //
     /* 317392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317428 */     // MIs[2] Operand 1
     /* 317428 */     // No operand predicates
     /* 317428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 317440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 317444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 317456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317461 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 317465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317471 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317516 */     GIR_RootConstrainSelectedInstOperands,
     /* 317517 */     // GIR_Coverage, 6205,
     /* 317517 */     GIR_EraseRootFromParent_Done,
     /* 317518 */   // Label 6290: @317518
     /* 317518 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(317649), // Rule ID 6269 //
     /* 317523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317559 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317571 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317575 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 317588 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317592 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317596 */     // MIs[4] Operand 1
     /* 317596 */     // No operand predicates
     /* 317596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317602 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 317644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 317647 */     GIR_RootConstrainSelectedInstOperands,
     /* 317648 */     // GIR_Coverage, 6269,
     /* 317648 */     GIR_EraseRootFromParent_Done,
     /* 317649 */   // Label 6291: @317649
     /* 317649 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(317780), // Rule ID 6237 //
     /* 317654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317702 */     // MIs[3] Operand 1
     /* 317702 */     // No operand predicates
     /* 317702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 317706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317710 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 317718 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317723 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 317727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317733 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317778 */     GIR_RootConstrainSelectedInstOperands,
     /* 317779 */     // GIR_Coverage, 6237,
     /* 317779 */     GIR_EraseRootFromParent_Done,
     /* 317780 */   // Label 6292: @317780
     /* 317780 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(317915), // Rule ID 2475 //
     /* 317785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317809 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317834 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317844 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 317847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317856 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 317911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317913 */     GIR_RootConstrainSelectedInstOperands,
     /* 317914 */     // GIR_Coverage, 2475,
     /* 317914 */     GIR_EraseRootFromParent_Done,
     /* 317915 */   // Label 6293: @317915
     /* 317915 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318034), // Rule ID 6141 //
     /* 317920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317944 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317977 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317981 */     // MIs[3] Operand 1
     /* 317981 */     // No operand predicates
     /* 317981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317987 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317999 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318032 */     GIR_RootConstrainSelectedInstOperands,
     /* 318033 */     // GIR_Coverage, 6141,
     /* 318033 */     GIR_EraseRootFromParent_Done,
     /* 318034 */   // Label 6294: @318034
     /* 318034 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318153), // Rule ID 2558 //
     /* 318039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318075 */     // MIs[2] Operand 1
     /* 318075 */     // No operand predicates
     /* 318075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 318091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318096 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 318100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318106 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318118 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318151 */     GIR_RootConstrainSelectedInstOperands,
     /* 318152 */     // GIR_Coverage, 2558,
     /* 318152 */     GIR_EraseRootFromParent_Done,
     /* 318153 */   // Label 6295: @318153
     /* 318153 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318253), // Rule ID 4908 //
     /* 318158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318182 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318209 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318251 */     GIR_RootConstrainSelectedInstOperands,
     /* 318252 */     // GIR_Coverage, 4908,
     /* 318252 */     GIR_EraseRootFromParent_Done,
     /* 318253 */   // Label 6296: @318253
     /* 318253 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318353), // Rule ID 4944 //
     /* 318258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318309 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318351 */     GIR_RootConstrainSelectedInstOperands,
     /* 318352 */     // GIR_Coverage, 4944,
     /* 318352 */     GIR_EraseRootFromParent_Done,
     /* 318353 */   // Label 6297: @318353
     /* 318353 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(318450), // Rule ID 14135 //
     /* 318358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318408 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318448 */     GIR_RootConstrainSelectedInstOperands,
     /* 318449 */     // GIR_Coverage, 14135,
     /* 318449 */     GIR_EraseRootFromParent_Done,
     /* 318450 */   // Label 6298: @318450
     /* 318450 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(318550), // Rule ID 14137 //
     /* 318455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318496 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318506 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318518 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318548 */     GIR_RootConstrainSelectedInstOperands,
     /* 318549 */     // GIR_Coverage, 14137,
     /* 318549 */     GIR_EraseRootFromParent_Done,
     /* 318550 */   // Label 6299: @318550
     /* 318550 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(318650), // Rule ID 4942 //
     /* 318555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318606 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318648 */     GIR_RootConstrainSelectedInstOperands,
     /* 318649 */     // GIR_Coverage, 4942,
     /* 318649 */     GIR_EraseRootFromParent_Done,
     /* 318650 */   // Label 6300: @318650
     /* 318650 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(318747), // Rule ID 4906 //
     /* 318655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318705 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318717 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318745 */     GIR_RootConstrainSelectedInstOperands,
     /* 318746 */     // GIR_Coverage, 4906,
     /* 318746 */     GIR_EraseRootFromParent_Done,
     /* 318747 */   // Label 6301: @318747
     /* 318747 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(318825), // Rule ID 6291 //
     /* 318752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318793 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318797 */     // MIs[3] Operand 1
     /* 318797 */     // No operand predicates
     /* 318797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318807 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318823 */     GIR_RootConstrainSelectedInstOperands,
     /* 318824 */     // GIR_Coverage, 6291,
     /* 318824 */     GIR_EraseRootFromParent_Done,
     /* 318825 */   // Label 6302: @318825
     /* 318825 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(318909), // Rule ID 6203 //
     /* 318830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318866 */     // MIs[2] Operand 1
     /* 318866 */     // No operand predicates
     /* 318866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 318878 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318889 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 318900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318907 */     GIR_RootConstrainSelectedInstOperands,
     /* 318908 */     // GIR_Coverage, 6203,
     /* 318908 */     GIR_EraseRootFromParent_Done,
     /* 318909 */   // Label 6303: @318909
     /* 318909 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(318990), // Rule ID 6235 //
     /* 318914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318958 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318962 */     // MIs[3] Operand 1
     /* 318962 */     // No operand predicates
     /* 318962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318972 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318988 */     GIR_RootConstrainSelectedInstOperands,
     /* 318989 */     // GIR_Coverage, 6235,
     /* 318989 */     GIR_EraseRootFromParent_Done,
     /* 318990 */   // Label 6304: @318990
     /* 318990 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319074), // Rule ID 6267 //
     /* 318995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319048 */     // MIs[3] Operand 1
     /* 319048 */     // No operand predicates
     /* 319048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319054 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 319057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319072 */     GIR_RootConstrainSelectedInstOperands,
     /* 319073 */     // GIR_Coverage, 6267,
     /* 319073 */     GIR_EraseRootFromParent_Done,
     /* 319074 */   // Label 6305: @319074
     /* 319074 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319152), // Rule ID 6313 //
     /* 319079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319124 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319128 */     // MIs[3] Operand 1
     /* 319128 */     // No operand predicates
     /* 319128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319134 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 319137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319150 */     GIR_RootConstrainSelectedInstOperands,
     /* 319151 */     // GIR_Coverage, 6313,
     /* 319151 */     GIR_EraseRootFromParent_Done,
     /* 319152 */   // Label 6306: @319152
     /* 319152 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319233), // Rule ID 6171 //
     /* 319157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319209 */     // MIs[3] Operand 1
     /* 319209 */     // No operand predicates
     /* 319209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319215 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 319218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319231 */     GIR_RootConstrainSelectedInstOperands,
     /* 319232 */     // GIR_Coverage, 6171,
     /* 319232 */     GIR_EraseRootFromParent_Done,
     /* 319233 */   // Label 6307: @319233
     /* 319233 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319318), // Rule ID 2473 //
     /* 319238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319262 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319276 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 319294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319316 */     GIR_RootConstrainSelectedInstOperands,
     /* 319317 */     // GIR_Coverage, 2473,
     /* 319317 */     GIR_EraseRootFromParent_Done,
     /* 319318 */   // Label 6308: @319318
     /* 319318 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319403), // Rule ID 2471 //
     /* 319323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319351 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319361 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 319361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 319379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319401 */     GIR_RootConstrainSelectedInstOperands,
     /* 319402 */     // GIR_Coverage, 2471,
     /* 319402 */     GIR_EraseRootFromParent_Done,
     /* 319403 */   // Label 6309: @319403
     /* 319403 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(319472), // Rule ID 2556 //
     /* 319408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319444 */     // MIs[2] Operand 1
     /* 319444 */     // No operand predicates
     /* 319444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319454 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 319457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319470 */     GIR_RootConstrainSelectedInstOperands,
     /* 319471 */     // GIR_Coverage, 2556,
     /* 319471 */     GIR_EraseRootFromParent_Done,
     /* 319472 */   // Label 6310: @319472
     /* 319472 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319541), // Rule ID 6139 //
     /* 319477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319517 */     // MIs[2] Operand 1
     /* 319517 */     // No operand predicates
     /* 319517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319523 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 319526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319539 */     GIR_RootConstrainSelectedInstOperands,
     /* 319540 */     // GIR_Coverage, 6139,
     /* 319540 */     GIR_EraseRootFromParent_Done,
     /* 319541 */   // Label 6311: @319541
     /* 319541 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(319603), // Rule ID 4952 //
     /* 319546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 319571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319586 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 319589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 319601 */     GIR_RootConstrainSelectedInstOperands,
     /* 319602 */     // GIR_Coverage, 4952,
     /* 319602 */     GIR_EraseRootFromParent_Done,
     /* 319603 */   // Label 6312: @319603
     /* 319603 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(319665), // Rule ID 14145 //
     /* 319608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 319633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319648 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 319651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 319663 */     GIR_RootConstrainSelectedInstOperands,
     /* 319664 */     // GIR_Coverage, 14145,
     /* 319664 */     GIR_EraseRootFromParent_Done,
     /* 319665 */   // Label 6313: @319665
     /* 319665 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(319712), // Rule ID 4949 //
     /* 319670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319697 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319710 */     GIR_RootConstrainSelectedInstOperands,
     /* 319711 */     // GIR_Coverage, 4949,
     /* 319711 */     GIR_EraseRootFromParent_Done,
     /* 319712 */   // Label 6314: @319712
     /* 319712 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(319762), // Rule ID 13558 //
     /* 319717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319747 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319760 */     GIR_RootConstrainSelectedInstOperands,
     /* 319761 */     // GIR_Coverage, 13558,
     /* 319761 */     GIR_EraseRootFromParent_Done,
     /* 319762 */   // Label 6315: @319762
     /* 319762 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(319812), // Rule ID 652 //
     /* 319767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319797 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319810 */     GIR_RootConstrainSelectedInstOperands,
     /* 319811 */     // GIR_Coverage, 652,
     /* 319811 */     GIR_EraseRootFromParent_Done,
     /* 319812 */   // Label 6316: @319812
     /* 319812 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(319859), // Rule ID 14142 //
     /* 319817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319844 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319857 */     GIR_RootConstrainSelectedInstOperands,
     /* 319858 */     // GIR_Coverage, 14142,
     /* 319858 */     GIR_EraseRootFromParent_Done,
     /* 319859 */   // Label 6317: @319859
     /* 319859 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(319909), // Rule ID 664 //
     /* 319864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 319879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319894 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 319897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 319907 */     GIR_RootConstrainSelectedInstOperands,
     /* 319908 */     // GIR_Coverage, 664,
     /* 319908 */     GIR_EraseRootFromParent_Done,
     /* 319909 */   // Label 6318: @319909
     /* 319909 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(319940), // Rule ID 646 //
     /* 319914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319929 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319934 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319938 */     GIR_RootConstrainSelectedInstOperands,
     /* 319939 */     // GIR_Coverage, 646,
     /* 319939 */     GIR_Done,
     /* 319940 */   // Label 6319: @319940
     /* 319940 */   GIM_Reject,
     /* 319941 */ // Label 6285: @319941
     /* 319941 */ GIM_Reject,
     /* 319942 */ // Label 6211: @319942
     /* 319942 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(321462),
     /* 319947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 319956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319960 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320038), // Rule ID 6271 //
     /* 319965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320010 */     // MIs[3] Operand 1
     /* 320010 */     // No operand predicates
     /* 320010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320020 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320036 */     GIR_RootConstrainSelectedInstOperands,
     /* 320037 */     // GIR_Coverage, 6271,
     /* 320037 */     GIR_EraseRootFromParent_Done,
     /* 320038 */   // Label 6321: @320038
     /* 320038 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320122), // Rule ID 6187 //
     /* 320043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320075 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320079 */     // MIs[2] Operand 1
     /* 320079 */     // No operand predicates
     /* 320079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 320083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320087 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320102 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 320113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320120 */     GIR_RootConstrainSelectedInstOperands,
     /* 320121 */     // GIR_Coverage, 6187,
     /* 320121 */     GIR_EraseRootFromParent_Done,
     /* 320122 */   // Label 6322: @320122
     /* 320122 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320203), // Rule ID 6219 //
     /* 320127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320171 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320175 */     // MIs[3] Operand 1
     /* 320175 */     // No operand predicates
     /* 320175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320185 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320201 */     GIR_RootConstrainSelectedInstOperands,
     /* 320202 */     // GIR_Coverage, 6219,
     /* 320202 */     GIR_EraseRootFromParent_Done,
     /* 320203 */   // Label 6323: @320203
     /* 320203 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320287), // Rule ID 6251 //
     /* 320208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320261 */     // MIs[3] Operand 1
     /* 320261 */     // No operand predicates
     /* 320261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320267 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320285 */     GIR_RootConstrainSelectedInstOperands,
     /* 320286 */     // GIR_Coverage, 6251,
     /* 320286 */     GIR_EraseRootFromParent_Done,
     /* 320287 */   // Label 6324: @320287
     /* 320287 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320365), // Rule ID 6293 //
     /* 320292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320337 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320341 */     // MIs[3] Operand 1
     /* 320341 */     // No operand predicates
     /* 320341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320347 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320363 */     GIR_RootConstrainSelectedInstOperands,
     /* 320364 */     // GIR_Coverage, 6293,
     /* 320364 */     GIR_EraseRootFromParent_Done,
     /* 320365 */   // Label 6325: @320365
     /* 320365 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(320446), // Rule ID 6155 //
     /* 320370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320422 */     // MIs[3] Operand 1
     /* 320422 */     // No operand predicates
     /* 320422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320428 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320444 */     GIR_RootConstrainSelectedInstOperands,
     /* 320445 */     // GIR_Coverage, 6155,
     /* 320445 */     GIR_EraseRootFromParent_Done,
     /* 320446 */   // Label 6326: @320446
     /* 320446 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(320515), // Rule ID 2540 //
     /* 320451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320487 */     // MIs[2] Operand 1
     /* 320487 */     // No operand predicates
     /* 320487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320497 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320513 */     GIR_RootConstrainSelectedInstOperands,
     /* 320514 */     // GIR_Coverage, 2540,
     /* 320514 */     GIR_EraseRootFromParent_Done,
     /* 320515 */   // Label 6327: @320515
     /* 320515 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(320584), // Rule ID 6123 //
     /* 320520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320560 */     // MIs[2] Operand 1
     /* 320560 */     // No operand predicates
     /* 320560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320566 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320582 */     GIR_RootConstrainSelectedInstOperands,
     /* 320583 */     // GIR_Coverage, 6123,
     /* 320583 */     GIR_EraseRootFromParent_Done,
     /* 320584 */   // Label 6328: @320584
     /* 320584 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(320677), // Rule ID 6275 //
     /* 320589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320628 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320675 */     GIR_RootConstrainSelectedInstOperands,
     /* 320676 */     // GIR_Coverage, 6275,
     /* 320676 */     GIR_EraseRootFromParent_Done,
     /* 320677 */   // Label 6329: @320677
     /* 320677 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(320776), // Rule ID 6189 //
     /* 320682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320725 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320774 */     GIR_RootConstrainSelectedInstOperands,
     /* 320775 */     // GIR_Coverage, 6189,
     /* 320775 */     GIR_EraseRootFromParent_Done,
     /* 320776 */   // Label 6330: @320776
     /* 320776 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(320872), // Rule ID 6221 //
     /* 320781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320823 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320870 */     GIR_RootConstrainSelectedInstOperands,
     /* 320871 */     // GIR_Coverage, 6221,
     /* 320871 */     GIR_EraseRootFromParent_Done,
     /* 320872 */   // Label 6331: @320872
     /* 320872 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(320971), // Rule ID 6253 //
     /* 320877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320920 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320969 */     GIR_RootConstrainSelectedInstOperands,
     /* 320970 */     // GIR_Coverage, 6253,
     /* 320970 */     GIR_EraseRootFromParent_Done,
     /* 320971 */   // Label 6332: @320971
     /* 320971 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321064), // Rule ID 6297 //
     /* 320976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 321004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321015 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 321050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321062 */     GIR_RootConstrainSelectedInstOperands,
     /* 321063 */     // GIR_Coverage, 6297,
     /* 321063 */     GIR_EraseRootFromParent_Done,
     /* 321064 */   // Label 6333: @321064
     /* 321064 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321160), // Rule ID 6157 //
     /* 321069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 321100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321111 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 321146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321158 */     GIR_RootConstrainSelectedInstOperands,
     /* 321159 */     // GIR_Coverage, 6157,
     /* 321159 */     GIR_EraseRootFromParent_Done,
     /* 321160 */   // Label 6334: @321160
     /* 321160 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321244), // Rule ID 2542 //
     /* 321165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321195 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321214 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 321230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321242 */     GIR_RootConstrainSelectedInstOperands,
     /* 321243 */     // GIR_Coverage, 2542,
     /* 321243 */     GIR_EraseRootFromParent_Done,
     /* 321244 */   // Label 6335: @321244
     /* 321244 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321294), // Rule ID 13588 //
     /* 321249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321279 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 321282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321292 */     GIR_RootConstrainSelectedInstOperands,
     /* 321293 */     // GIR_Coverage, 13588,
     /* 321293 */     GIR_EraseRootFromParent_Done,
     /* 321294 */   // Label 6336: @321294
     /* 321294 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321378), // Rule ID 6125 //
     /* 321299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321329 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 321364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321376 */     GIR_RootConstrainSelectedInstOperands,
     /* 321377 */     // GIR_Coverage, 6125,
     /* 321377 */     GIR_EraseRootFromParent_Done,
     /* 321378 */   // Label 6337: @321378
     /* 321378 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(321428), // Rule ID 1312 //
     /* 321383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321413 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 321416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321426 */     GIR_RootConstrainSelectedInstOperands,
     /* 321427 */     // GIR_Coverage, 1312,
     /* 321427 */     GIR_EraseRootFromParent_Done,
     /* 321428 */   // Label 6338: @321428
     /* 321428 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(321461), // Rule ID 1302 //
     /* 321433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321448 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 321451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321459 */     GIR_RootConstrainSelectedInstOperands,
     /* 321460 */     // GIR_Coverage, 1302,
     /* 321460 */     GIR_EraseRootFromParent_Done,
     /* 321461 */   // Label 6339: @321461
     /* 321461 */   GIM_Reject,
     /* 321462 */ // Label 6320: @321462
     /* 321462 */ GIM_Reject,
     /* 321463 */ // Label 6212: @321463
     /* 321463 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(322983),
     /* 321468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 321477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321481 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(321559), // Rule ID 6283 //
     /* 321486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321527 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321531 */     // MIs[3] Operand 1
     /* 321531 */     // No operand predicates
     /* 321531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321541 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321557 */     GIR_RootConstrainSelectedInstOperands,
     /* 321558 */     // GIR_Coverage, 6283,
     /* 321558 */     GIR_EraseRootFromParent_Done,
     /* 321559 */   // Label 6341: @321559
     /* 321559 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(321643), // Rule ID 6195 //
     /* 321564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321596 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321600 */     // MIs[2] Operand 1
     /* 321600 */     // No operand predicates
     /* 321600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321623 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321641 */     GIR_RootConstrainSelectedInstOperands,
     /* 321642 */     // GIR_Coverage, 6195,
     /* 321642 */     GIR_EraseRootFromParent_Done,
     /* 321643 */   // Label 6342: @321643
     /* 321643 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(321724), // Rule ID 6227 //
     /* 321648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321696 */     // MIs[3] Operand 1
     /* 321696 */     // No operand predicates
     /* 321696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321706 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321722 */     GIR_RootConstrainSelectedInstOperands,
     /* 321723 */     // GIR_Coverage, 6227,
     /* 321723 */     GIR_EraseRootFromParent_Done,
     /* 321724 */   // Label 6343: @321724
     /* 321724 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(321808), // Rule ID 6259 //
     /* 321729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321778 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321782 */     // MIs[3] Operand 1
     /* 321782 */     // No operand predicates
     /* 321782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321788 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321806 */     GIR_RootConstrainSelectedInstOperands,
     /* 321807 */     // GIR_Coverage, 6259,
     /* 321807 */     GIR_EraseRootFromParent_Done,
     /* 321808 */   // Label 6344: @321808
     /* 321808 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(321886), // Rule ID 6305 //
     /* 321813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321858 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321862 */     // MIs[3] Operand 1
     /* 321862 */     // No operand predicates
     /* 321862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321868 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321884 */     GIR_RootConstrainSelectedInstOperands,
     /* 321885 */     // GIR_Coverage, 6305,
     /* 321885 */     GIR_EraseRootFromParent_Done,
     /* 321886 */   // Label 6345: @321886
     /* 321886 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(321967), // Rule ID 6163 //
     /* 321891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321943 */     // MIs[3] Operand 1
     /* 321943 */     // No operand predicates
     /* 321943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321949 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321965 */     GIR_RootConstrainSelectedInstOperands,
     /* 321966 */     // GIR_Coverage, 6163,
     /* 321966 */     GIR_EraseRootFromParent_Done,
     /* 321967 */   // Label 6346: @321967
     /* 321967 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322036), // Rule ID 2548 //
     /* 321972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 322008 */     // MIs[2] Operand 1
     /* 322008 */     // No operand predicates
     /* 322008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322018 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322034 */     GIR_RootConstrainSelectedInstOperands,
     /* 322035 */     // GIR_Coverage, 2548,
     /* 322035 */     GIR_EraseRootFromParent_Done,
     /* 322036 */   // Label 6347: @322036
     /* 322036 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322105), // Rule ID 6131 //
     /* 322041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 322056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322077 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 322081 */     // MIs[2] Operand 1
     /* 322081 */     // No operand predicates
     /* 322081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322087 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322103 */     GIR_RootConstrainSelectedInstOperands,
     /* 322104 */     // GIR_Coverage, 6131,
     /* 322104 */     GIR_EraseRootFromParent_Done,
     /* 322105 */   // Label 6348: @322105
     /* 322105 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322198), // Rule ID 6285 //
     /* 322110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322149 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322196 */     GIR_RootConstrainSelectedInstOperands,
     /* 322197 */     // GIR_Coverage, 6285,
     /* 322197 */     GIR_EraseRootFromParent_Done,
     /* 322198 */   // Label 6349: @322198
     /* 322198 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322297), // Rule ID 6197 //
     /* 322203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322246 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 322289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322295 */     GIR_RootConstrainSelectedInstOperands,
     /* 322296 */     // GIR_Coverage, 6197,
     /* 322296 */     GIR_EraseRootFromParent_Done,
     /* 322297 */   // Label 6350: @322297
     /* 322297 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(322393), // Rule ID 6229 //
     /* 322302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322344 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322391 */     GIR_RootConstrainSelectedInstOperands,
     /* 322392 */     // GIR_Coverage, 6229,
     /* 322392 */     GIR_EraseRootFromParent_Done,
     /* 322393 */   // Label 6351: @322393
     /* 322393 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(322492), // Rule ID 6261 //
     /* 322398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322441 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322490 */     GIR_RootConstrainSelectedInstOperands,
     /* 322491 */     // GIR_Coverage, 6261,
     /* 322491 */     GIR_EraseRootFromParent_Done,
     /* 322492 */   // Label 6352: @322492
     /* 322492 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(322585), // Rule ID 6307 //
     /* 322497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322536 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322583 */     GIR_RootConstrainSelectedInstOperands,
     /* 322584 */     // GIR_Coverage, 6307,
     /* 322584 */     GIR_EraseRootFromParent_Done,
     /* 322585 */   // Label 6353: @322585
     /* 322585 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(322681), // Rule ID 6165 //
     /* 322590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322632 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322651 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322679 */     GIR_RootConstrainSelectedInstOperands,
     /* 322680 */     // GIR_Coverage, 6165,
     /* 322680 */     GIR_EraseRootFromParent_Done,
     /* 322681 */   // Label 6354: @322681
     /* 322681 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(322765), // Rule ID 2550 //
     /* 322686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322716 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322763 */     GIR_RootConstrainSelectedInstOperands,
     /* 322764 */     // GIR_Coverage, 2550,
     /* 322764 */     GIR_EraseRootFromParent_Done,
     /* 322765 */   // Label 6355: @322765
     /* 322765 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(322815), // Rule ID 13592 //
     /* 322770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322800 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 322803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322813 */     GIR_RootConstrainSelectedInstOperands,
     /* 322814 */     // GIR_Coverage, 13592,
     /* 322814 */     GIR_EraseRootFromParent_Done,
     /* 322815 */   // Label 6356: @322815
     /* 322815 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(322899), // Rule ID 6133 //
     /* 322820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322850 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322897 */     GIR_RootConstrainSelectedInstOperands,
     /* 322898 */     // GIR_Coverage, 6133,
     /* 322898 */     GIR_EraseRootFromParent_Done,
     /* 322899 */   // Label 6357: @322899
     /* 322899 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(322949), // Rule ID 1316 //
     /* 322904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322934 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 322937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322947 */     GIR_RootConstrainSelectedInstOperands,
     /* 322948 */     // GIR_Coverage, 1316,
     /* 322948 */     GIR_EraseRootFromParent_Done,
     /* 322949 */   // Label 6358: @322949
     /* 322949 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(322982), // Rule ID 1306 //
     /* 322954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322969 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 322972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 322980 */     GIR_RootConstrainSelectedInstOperands,
     /* 322981 */     // GIR_Coverage, 1306,
     /* 322981 */     GIR_EraseRootFromParent_Done,
     /* 322982 */   // Label 6359: @322982
     /* 322982 */   GIM_Reject,
     /* 322983 */ // Label 6340: @322983
     /* 322983 */ GIM_Reject,
     /* 322984 */ // Label 6213: @322984
     /* 322984 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(324162),
     /* 322989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 322998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323002 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323086), // Rule ID 6179 //
     /* 323007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323043 */     // MIs[2] Operand 1
     /* 323043 */     // No operand predicates
     /* 323043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323066 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323084 */     GIR_RootConstrainSelectedInstOperands,
     /* 323085 */     // GIR_Coverage, 6179,
     /* 323085 */     GIR_EraseRootFromParent_Done,
     /* 323086 */   // Label 6361: @323086
     /* 323086 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323167), // Rule ID 6211 //
     /* 323091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323135 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323139 */     // MIs[3] Operand 1
     /* 323139 */     // No operand predicates
     /* 323139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323149 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323165 */     GIR_RootConstrainSelectedInstOperands,
     /* 323166 */     // GIR_Coverage, 6211,
     /* 323166 */     GIR_EraseRootFromParent_Done,
     /* 323167 */   // Label 6362: @323167
     /* 323167 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323251), // Rule ID 6243 //
     /* 323172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323225 */     // MIs[3] Operand 1
     /* 323225 */     // No operand predicates
     /* 323225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323231 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323249 */     GIR_RootConstrainSelectedInstOperands,
     /* 323250 */     // GIR_Coverage, 6243,
     /* 323250 */     GIR_EraseRootFromParent_Done,
     /* 323251 */   // Label 6363: @323251
     /* 323251 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323332), // Rule ID 6147 //
     /* 323256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323308 */     // MIs[3] Operand 1
     /* 323308 */     // No operand predicates
     /* 323308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323314 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323330 */     GIR_RootConstrainSelectedInstOperands,
     /* 323331 */     // GIR_Coverage, 6147,
     /* 323331 */     GIR_EraseRootFromParent_Done,
     /* 323332 */   // Label 6364: @323332
     /* 323332 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323401), // Rule ID 2532 //
     /* 323337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323373 */     // MIs[2] Operand 1
     /* 323373 */     // No operand predicates
     /* 323373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323383 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323399 */     GIR_RootConstrainSelectedInstOperands,
     /* 323400 */     // GIR_Coverage, 2532,
     /* 323400 */     GIR_EraseRootFromParent_Done,
     /* 323401 */   // Label 6365: @323401
     /* 323401 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(323470), // Rule ID 6115 //
     /* 323406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323446 */     // MIs[2] Operand 1
     /* 323446 */     // No operand predicates
     /* 323446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323452 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323468 */     GIR_RootConstrainSelectedInstOperands,
     /* 323469 */     // GIR_Coverage, 6115,
     /* 323469 */     GIR_EraseRootFromParent_Done,
     /* 323470 */   // Label 6366: @323470
     /* 323470 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(323569), // Rule ID 6181 //
     /* 323475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323518 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323567 */     GIR_RootConstrainSelectedInstOperands,
     /* 323568 */     // GIR_Coverage, 6181,
     /* 323568 */     GIR_EraseRootFromParent_Done,
     /* 323569 */   // Label 6367: @323569
     /* 323569 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(323665), // Rule ID 6213 //
     /* 323574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323616 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323663 */     GIR_RootConstrainSelectedInstOperands,
     /* 323664 */     // GIR_Coverage, 6213,
     /* 323664 */     GIR_EraseRootFromParent_Done,
     /* 323665 */   // Label 6368: @323665
     /* 323665 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(323764), // Rule ID 6245 //
     /* 323670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323713 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323762 */     GIR_RootConstrainSelectedInstOperands,
     /* 323763 */     // GIR_Coverage, 6245,
     /* 323763 */     GIR_EraseRootFromParent_Done,
     /* 323764 */   // Label 6369: @323764
     /* 323764 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(323860), // Rule ID 6149 //
     /* 323769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323811 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323858 */     GIR_RootConstrainSelectedInstOperands,
     /* 323859 */     // GIR_Coverage, 6149,
     /* 323859 */     GIR_EraseRootFromParent_Done,
     /* 323860 */   // Label 6370: @323860
     /* 323860 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(323944), // Rule ID 2534 //
     /* 323865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323895 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323942 */     GIR_RootConstrainSelectedInstOperands,
     /* 323943 */     // GIR_Coverage, 2534,
     /* 323943 */     GIR_EraseRootFromParent_Done,
     /* 323944 */   // Label 6371: @323944
     /* 323944 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(323994), // Rule ID 13584 //
     /* 323949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323979 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323992 */     GIR_RootConstrainSelectedInstOperands,
     /* 323993 */     // GIR_Coverage, 13584,
     /* 323993 */     GIR_EraseRootFromParent_Done,
     /* 323994 */   // Label 6372: @323994
     /* 323994 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(324078), // Rule ID 6117 //
     /* 323999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324029 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 324064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324076 */     GIR_RootConstrainSelectedInstOperands,
     /* 324077 */     // GIR_Coverage, 6117,
     /* 324077 */     GIR_EraseRootFromParent_Done,
     /* 324078 */   // Label 6373: @324078
     /* 324078 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324128), // Rule ID 1308 //
     /* 324083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324113 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 324116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324126 */     GIR_RootConstrainSelectedInstOperands,
     /* 324127 */     // GIR_Coverage, 1308,
     /* 324127 */     GIR_EraseRootFromParent_Done,
     /* 324128 */   // Label 6374: @324128
     /* 324128 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324161), // Rule ID 1298 //
     /* 324133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324148 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 324151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324159 */     GIR_RootConstrainSelectedInstOperands,
     /* 324160 */     // GIR_Coverage, 1298,
     /* 324160 */     GIR_EraseRootFromParent_Done,
     /* 324161 */   // Label 6375: @324161
     /* 324161 */   GIM_Reject,
     /* 324162 */ // Label 6360: @324162
     /* 324162 */ GIM_Reject,
     /* 324163 */ // Label 6214: @324163
     /* 324163 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(325683),
     /* 324168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 324177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324181 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324259), // Rule ID 6277 //
     /* 324186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 324223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324231 */     // MIs[3] Operand 1
     /* 324231 */     // No operand predicates
     /* 324231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324241 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324257 */     GIR_RootConstrainSelectedInstOperands,
     /* 324258 */     // GIR_Coverage, 6277,
     /* 324258 */     GIR_EraseRootFromParent_Done,
     /* 324259 */   // Label 6377: @324259
     /* 324259 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324343), // Rule ID 6191 //
     /* 324264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324296 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324300 */     // MIs[2] Operand 1
     /* 324300 */     // No operand predicates
     /* 324300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324312 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324323 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 324334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324341 */     GIR_RootConstrainSelectedInstOperands,
     /* 324342 */     // GIR_Coverage, 6191,
     /* 324342 */     GIR_EraseRootFromParent_Done,
     /* 324343 */   // Label 6378: @324343
     /* 324343 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(324424), // Rule ID 6223 //
     /* 324348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324392 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324396 */     // MIs[3] Operand 1
     /* 324396 */     // No operand predicates
     /* 324396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324406 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324422 */     GIR_RootConstrainSelectedInstOperands,
     /* 324423 */     // GIR_Coverage, 6223,
     /* 324423 */     GIR_EraseRootFromParent_Done,
     /* 324424 */   // Label 6379: @324424
     /* 324424 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(324508), // Rule ID 6255 //
     /* 324429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324482 */     // MIs[3] Operand 1
     /* 324482 */     // No operand predicates
     /* 324482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324488 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324506 */     GIR_RootConstrainSelectedInstOperands,
     /* 324507 */     // GIR_Coverage, 6255,
     /* 324507 */     GIR_EraseRootFromParent_Done,
     /* 324508 */   // Label 6380: @324508
     /* 324508 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324586), // Rule ID 6299 //
     /* 324513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 324554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324558 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324562 */     // MIs[3] Operand 1
     /* 324562 */     // No operand predicates
     /* 324562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324568 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324584 */     GIR_RootConstrainSelectedInstOperands,
     /* 324585 */     // GIR_Coverage, 6299,
     /* 324585 */     GIR_EraseRootFromParent_Done,
     /* 324586 */   // Label 6381: @324586
     /* 324586 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(324667), // Rule ID 6159 //
     /* 324591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324639 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324643 */     // MIs[3] Operand 1
     /* 324643 */     // No operand predicates
     /* 324643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324649 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324665 */     GIR_RootConstrainSelectedInstOperands,
     /* 324666 */     // GIR_Coverage, 6159,
     /* 324666 */     GIR_EraseRootFromParent_Done,
     /* 324667 */   // Label 6382: @324667
     /* 324667 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(324736), // Rule ID 2544 //
     /* 324672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324704 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324708 */     // MIs[2] Operand 1
     /* 324708 */     // No operand predicates
     /* 324708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324718 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324734 */     GIR_RootConstrainSelectedInstOperands,
     /* 324735 */     // GIR_Coverage, 2544,
     /* 324735 */     GIR_EraseRootFromParent_Done,
     /* 324736 */   // Label 6383: @324736
     /* 324736 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(324805), // Rule ID 6127 //
     /* 324741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324781 */     // MIs[2] Operand 1
     /* 324781 */     // No operand predicates
     /* 324781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324787 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324803 */     GIR_RootConstrainSelectedInstOperands,
     /* 324804 */     // GIR_Coverage, 6127,
     /* 324804 */     GIR_EraseRootFromParent_Done,
     /* 324805 */   // Label 6384: @324805
     /* 324805 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(324898), // Rule ID 6281 //
     /* 324810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324849 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324896 */     GIR_RootConstrainSelectedInstOperands,
     /* 324897 */     // GIR_Coverage, 6281,
     /* 324897 */     GIR_EraseRootFromParent_Done,
     /* 324898 */   // Label 6385: @324898
     /* 324898 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(324997), // Rule ID 6193 //
     /* 324903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324946 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 324989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324995 */     GIR_RootConstrainSelectedInstOperands,
     /* 324996 */     // GIR_Coverage, 6193,
     /* 324996 */     GIR_EraseRootFromParent_Done,
     /* 324997 */   // Label 6386: @324997
     /* 324997 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(325093), // Rule ID 6225 //
     /* 325002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 325029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325044 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 325079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325091 */     GIR_RootConstrainSelectedInstOperands,
     /* 325092 */     // GIR_Coverage, 6225,
     /* 325092 */     GIR_EraseRootFromParent_Done,
     /* 325093 */   // Label 6387: @325093
     /* 325093 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(325192), // Rule ID 6257 //
     /* 325098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 325130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325141 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 325176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325190 */     GIR_RootConstrainSelectedInstOperands,
     /* 325191 */     // GIR_Coverage, 6257,
     /* 325191 */     GIR_EraseRootFromParent_Done,
     /* 325192 */   // Label 6388: @325192
     /* 325192 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(325285), // Rule ID 6303 //
     /* 325197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 325213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 325225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325236 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325248 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 325271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325283 */     GIR_RootConstrainSelectedInstOperands,
     /* 325284 */     // GIR_Coverage, 6303,
     /* 325284 */     GIR_EraseRootFromParent_Done,
     /* 325285 */   // Label 6389: @325285
     /* 325285 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(325381), // Rule ID 6161 //
     /* 325290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 325321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325332 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 325367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325379 */     GIR_RootConstrainSelectedInstOperands,
     /* 325380 */     // GIR_Coverage, 6161,
     /* 325380 */     GIR_EraseRootFromParent_Done,
     /* 325381 */   // Label 6390: @325381
     /* 325381 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(325465), // Rule ID 2546 //
     /* 325386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 325401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325416 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 325451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325463 */     GIR_RootConstrainSelectedInstOperands,
     /* 325464 */     // GIR_Coverage, 2546,
     /* 325464 */     GIR_EraseRootFromParent_Done,
     /* 325465 */   // Label 6391: @325465
     /* 325465 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(325515), // Rule ID 13590 //
     /* 325470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325500 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 325503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325513 */     GIR_RootConstrainSelectedInstOperands,
     /* 325514 */     // GIR_Coverage, 13590,
     /* 325514 */     GIR_EraseRootFromParent_Done,
     /* 325515 */   // Label 6392: @325515
     /* 325515 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(325599), // Rule ID 6129 //
     /* 325520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 325539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325550 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325569 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 325585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325597 */     GIR_RootConstrainSelectedInstOperands,
     /* 325598 */     // GIR_Coverage, 6129,
     /* 325598 */     GIR_EraseRootFromParent_Done,
     /* 325599 */   // Label 6393: @325599
     /* 325599 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(325649), // Rule ID 1314 //
     /* 325604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325634 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 325637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325647 */     GIR_RootConstrainSelectedInstOperands,
     /* 325648 */     // GIR_Coverage, 1314,
     /* 325648 */     GIR_EraseRootFromParent_Done,
     /* 325649 */   // Label 6394: @325649
     /* 325649 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(325682), // Rule ID 1304 //
     /* 325654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325669 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 325672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 325680 */     GIR_RootConstrainSelectedInstOperands,
     /* 325681 */     // GIR_Coverage, 1304,
     /* 325681 */     GIR_EraseRootFromParent_Done,
     /* 325682 */   // Label 6395: @325682
     /* 325682 */   GIM_Reject,
     /* 325683 */ // Label 6376: @325683
     /* 325683 */ GIM_Reject,
     /* 325684 */ // Label 6215: @325684
     /* 325684 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(326862),
     /* 325689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 325698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325702 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(325786), // Rule ID 6175 //
     /* 325707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325743 */     // MIs[2] Operand 1
     /* 325743 */     // No operand predicates
     /* 325743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325755 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325766 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 325777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325784 */     GIR_RootConstrainSelectedInstOperands,
     /* 325785 */     // GIR_Coverage, 6175,
     /* 325785 */     GIR_EraseRootFromParent_Done,
     /* 325786 */   // Label 6397: @325786
     /* 325786 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325867), // Rule ID 6207 //
     /* 325791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325839 */     // MIs[3] Operand 1
     /* 325839 */     // No operand predicates
     /* 325839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325849 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325865 */     GIR_RootConstrainSelectedInstOperands,
     /* 325866 */     // GIR_Coverage, 6207,
     /* 325866 */     GIR_EraseRootFromParent_Done,
     /* 325867 */   // Label 6398: @325867
     /* 325867 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(325951), // Rule ID 6239 //
     /* 325872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325925 */     // MIs[3] Operand 1
     /* 325925 */     // No operand predicates
     /* 325925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325931 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325949 */     GIR_RootConstrainSelectedInstOperands,
     /* 325950 */     // GIR_Coverage, 6239,
     /* 325950 */     GIR_EraseRootFromParent_Done,
     /* 325951 */   // Label 6399: @325951
     /* 325951 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(326032), // Rule ID 6143 //
     /* 325956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 326000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 326008 */     // MIs[3] Operand 1
     /* 326008 */     // No operand predicates
     /* 326008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326014 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 326014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 326030 */     GIR_RootConstrainSelectedInstOperands,
     /* 326031 */     // GIR_Coverage, 6143,
     /* 326031 */     GIR_EraseRootFromParent_Done,
     /* 326032 */   // Label 6400: @326032
     /* 326032 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(326101), // Rule ID 2528 //
     /* 326037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 326048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 326056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 326061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 326073 */     // MIs[2] Operand 1
     /* 326073 */     // No operand predicates
     /* 326073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326083 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 326083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 326099 */     GIR_RootConstrainSelectedInstOperands,
     /* 326100 */     // GIR_Coverage, 2528,
     /* 326100 */     GIR_EraseRootFromParent_Done,
     /* 326101 */   // Label 6401: @326101
     /* 326101 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(326170), // Rule ID 6111 //
     /* 326106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 326121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 326129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 326134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 326146 */     // MIs[2] Operand 1
     /* 326146 */     // No operand predicates
     /* 326146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326152 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 326152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 326168 */     GIR_RootConstrainSelectedInstOperands,
     /* 326169 */     // GIR_Coverage, 6111,
     /* 326169 */     GIR_EraseRootFromParent_Done,
     /* 326170 */   // Label 6402: @326170
     /* 326170 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(326269), // Rule ID 6177 //
     /* 326175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 326186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326218 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 326261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326267 */     GIR_RootConstrainSelectedInstOperands,
     /* 326268 */     // GIR_Coverage, 6177,
     /* 326268 */     GIR_EraseRootFromParent_Done,
     /* 326269 */   // Label 6403: @326269
     /* 326269 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(326365), // Rule ID 6209 //
     /* 326274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 326297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326316 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326363 */     GIR_RootConstrainSelectedInstOperands,
     /* 326364 */     // GIR_Coverage, 6209,
     /* 326364 */     GIR_EraseRootFromParent_Done,
     /* 326365 */   // Label 6404: @326365
     /* 326365 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(326464), // Rule ID 6241 //
     /* 326370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 326398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326413 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326462 */     GIR_RootConstrainSelectedInstOperands,
     /* 326463 */     // GIR_Coverage, 6241,
     /* 326463 */     GIR_EraseRootFromParent_Done,
     /* 326464 */   // Label 6405: @326464
     /* 326464 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(326560), // Rule ID 6145 //
     /* 326469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 326496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326511 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326558 */     GIR_RootConstrainSelectedInstOperands,
     /* 326559 */     // GIR_Coverage, 6145,
     /* 326559 */     GIR_EraseRootFromParent_Done,
     /* 326560 */   // Label 6406: @326560
     /* 326560 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(326644), // Rule ID 2530 //
     /* 326565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 326576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326595 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326642 */     GIR_RootConstrainSelectedInstOperands,
     /* 326643 */     // GIR_Coverage, 2530,
     /* 326643 */     GIR_EraseRootFromParent_Done,
     /* 326644 */   // Label 6407: @326644
     /* 326644 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(326694), // Rule ID 13586 //
     /* 326649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326679 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 326682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326692 */     GIR_RootConstrainSelectedInstOperands,
     /* 326693 */     // GIR_Coverage, 13586,
     /* 326693 */     GIR_EraseRootFromParent_Done,
     /* 326694 */   // Label 6408: @326694
     /* 326694 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(326778), // Rule ID 6113 //
     /* 326699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 326714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326729 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326776 */     GIR_RootConstrainSelectedInstOperands,
     /* 326777 */     // GIR_Coverage, 6113,
     /* 326777 */     GIR_EraseRootFromParent_Done,
     /* 326778 */   // Label 6409: @326778
     /* 326778 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(326828), // Rule ID 1310 //
     /* 326783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326813 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 326816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326826 */     GIR_RootConstrainSelectedInstOperands,
     /* 326827 */     // GIR_Coverage, 1310,
     /* 326827 */     GIR_EraseRootFromParent_Done,
     /* 326828 */   // Label 6410: @326828
     /* 326828 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(326861), // Rule ID 1300 //
     /* 326833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326848 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 326851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 326859 */     GIR_RootConstrainSelectedInstOperands,
     /* 326860 */     // GIR_Coverage, 1300,
     /* 326860 */     GIR_EraseRootFromParent_Done,
     /* 326861 */   // Label 6411: @326861
     /* 326861 */   GIM_Reject,
     /* 326862 */ // Label 6396: @326862
     /* 326862 */ GIM_Reject,
     /* 326863 */ // Label 6216: @326863
     /* 326863 */ GIM_Reject,
     /* 326864 */ // Label 63: @326864
     /* 326864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6420*/ GIMT_Encode4(327479),
     /* 326875 */ /*GILLT_s16*//*Label 6412*/ GIMT_Encode4(326915),
     /* 326879 */ /*GILLT_s32*//*Label 6413*/ GIMT_Encode4(326953),
     /* 326883 */ /*GILLT_s64*//*Label 6414*/ GIMT_Encode4(326991), GIMT_Encode4(0),
     /* 326891 */ /*GILLT_v2s32*//*Label 6415*/ GIMT_Encode4(327029),
     /* 326895 */ /*GILLT_v2s64*//*Label 6416*/ GIMT_Encode4(327067),
     /* 326899 */ /*GILLT_v4s16*//*Label 6417*/ GIMT_Encode4(327105),
     /* 326903 */ /*GILLT_v4s32*//*Label 6418*/ GIMT_Encode4(327143), GIMT_Encode4(0),
     /* 326911 */ /*GILLT_v8s16*//*Label 6419*/ GIMT_Encode4(327181),
     /* 326915 */ // Label 6412: @326915
     /* 326915 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326952), // Rule ID 594 //
     /* 326920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326941 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 326946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326950 */   GIR_RootConstrainSelectedInstOperands,
     /* 326951 */   // GIR_Coverage, 594,
     /* 326951 */   GIR_Done,
     /* 326952 */ // Label 6421: @326952
     /* 326952 */ GIM_Reject,
     /* 326953 */ // Label 6413: @326953
     /* 326953 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(326990), // Rule ID 596 //
     /* 326958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326979 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 326984 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326988 */   GIR_RootConstrainSelectedInstOperands,
     /* 326989 */   // GIR_Coverage, 596,
     /* 326989 */   GIR_Done,
     /* 326990 */ // Label 6422: @326990
     /* 326990 */ GIM_Reject,
     /* 326991 */ // Label 6414: @326991
     /* 326991 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327028), // Rule ID 598 //
     /* 326996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327017 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 327017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 327022 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327026 */   GIR_RootConstrainSelectedInstOperands,
     /* 327027 */   // GIR_Coverage, 598,
     /* 327027 */   GIR_Done,
     /* 327028 */ // Label 6423: @327028
     /* 327028 */ GIM_Reject,
     /* 327029 */ // Label 6415: @327029
     /* 327029 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327066), // Rule ID 1232 //
     /* 327034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327055 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 327055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 327060 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327064 */   GIR_RootConstrainSelectedInstOperands,
     /* 327065 */   // GIR_Coverage, 1232,
     /* 327065 */   GIR_Done,
     /* 327066 */ // Label 6424: @327066
     /* 327066 */ GIM_Reject,
     /* 327067 */ // Label 6416: @327067
     /* 327067 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(327104), // Rule ID 1236 //
     /* 327072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327093 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 327093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 327098 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327102 */   GIR_RootConstrainSelectedInstOperands,
     /* 327103 */   // GIR_Coverage, 1236,
     /* 327103 */   GIR_Done,
     /* 327104 */ // Label 6425: @327104
     /* 327104 */ GIM_Reject,
     /* 327105 */ // Label 6417: @327105
     /* 327105 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327142), // Rule ID 1228 //
     /* 327110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327131 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 327131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 327136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327140 */   GIR_RootConstrainSelectedInstOperands,
     /* 327141 */   // GIR_Coverage, 1228,
     /* 327141 */   GIR_Done,
     /* 327142 */ // Label 6426: @327142
     /* 327142 */ GIM_Reject,
     /* 327143 */ // Label 6418: @327143
     /* 327143 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327180), // Rule ID 1234 //
     /* 327148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327169 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 327169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 327174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327178 */   GIR_RootConstrainSelectedInstOperands,
     /* 327179 */   // GIR_Coverage, 1234,
     /* 327179 */   GIR_Done,
     /* 327180 */ // Label 6427: @327180
     /* 327180 */ GIM_Reject,
     /* 327181 */ // Label 6419: @327181
     /* 327181 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327478),
     /* 327186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327204 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(327223), // Rule ID 1230 //
     /* 327209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 327212 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 327212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 327217 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327221 */     GIR_RootConstrainSelectedInstOperands,
     /* 327222 */     // GIR_Coverage, 1230,
     /* 327222 */     GIR_Done,
     /* 327223 */   // Label 6429: @327223
     /* 327223 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(327477), // Rule ID 7092 //
     /* 327228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 327231 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 327231 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 327234 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 327238 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327243 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 327247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 327249 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 327252 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 327256 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327261 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 327265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 327267 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 327270 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 327274 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327279 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 327282 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 327285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 327287 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 327290 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327294 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327299 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327305 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327310 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327315 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 327318 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 327322 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327327 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 327330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 327332 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 327335 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327339 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327344 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327350 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327355 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327360 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 327363 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 327367 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327372 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 327375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 327377 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 327380 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 327384 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327389 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 327392 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 327395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 327397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 327400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 327404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327409 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 327412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 327417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 327431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 327446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 327449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 327467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 327475 */     GIR_RootConstrainSelectedInstOperands,
     /* 327476 */     // GIR_Coverage, 7092,
     /* 327476 */     GIR_EraseRootFromParent_Done,
     /* 327477 */   // Label 6430: @327477
     /* 327477 */   GIM_Reject,
     /* 327478 */ // Label 6428: @327478
     /* 327478 */ GIM_Reject,
     /* 327479 */ // Label 6420: @327479
     /* 327479 */ GIM_Reject,
     /* 327480 */ // Label 64: @327480
     /* 327480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6439*/ GIMT_Encode4(330986),
     /* 327491 */ /*GILLT_s16*//*Label 6431*/ GIMT_Encode4(327531),
     /* 327495 */ /*GILLT_s32*//*Label 6432*/ GIMT_Encode4(328699),
     /* 327499 */ /*GILLT_s64*//*Label 6433*/ GIMT_Encode4(329722), GIMT_Encode4(0),
     /* 327507 */ /*GILLT_v2s32*//*Label 6434*/ GIMT_Encode4(330745),
     /* 327511 */ /*GILLT_v2s64*//*Label 6435*/ GIMT_Encode4(330772),
     /* 327515 */ /*GILLT_v4s16*//*Label 6436*/ GIMT_Encode4(330799),
     /* 327519 */ /*GILLT_v4s32*//*Label 6437*/ GIMT_Encode4(330879), GIMT_Encode4(0),
     /* 327527 */ /*GILLT_v8s16*//*Label 6438*/ GIMT_Encode4(330906),
     /* 327531 */ // Label 6431: @327531
     /* 327531 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328698),
     /* 327536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327543 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(327701), // Rule ID 4916 //
     /* 327548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327617 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327628 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 327631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327640 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327646 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327651 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327668 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327699 */     GIR_RootConstrainSelectedInstOperands,
     /* 327700 */     // GIR_Coverage, 4916,
     /* 327700 */     GIR_EraseRootFromParent_Done,
     /* 327701 */   // Label 6441: @327701
     /* 327701 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(327859), // Rule ID 4915 //
     /* 327706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327725 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327750 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327770 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327775 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327786 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 327789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327798 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327826 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327857 */     GIR_RootConstrainSelectedInstOperands,
     /* 327858 */     // GIR_Coverage, 4915,
     /* 327858 */     GIR_EraseRootFromParent_Done,
     /* 327859 */   // Label 6442: @327859
     /* 327859 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(327970), // Rule ID 4914 //
     /* 327864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327924 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327936 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327968 */     GIR_RootConstrainSelectedInstOperands,
     /* 327969 */     // GIR_Coverage, 4914,
     /* 327969 */     GIR_EraseRootFromParent_Done,
     /* 327970 */   // Label 6443: @327970
     /* 327970 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328081), // Rule ID 4912 //
     /* 327975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327994 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328024 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328035 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 328035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 328038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 328053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328079 */     GIR_RootConstrainSelectedInstOperands,
     /* 328080 */     // GIR_Coverage, 4912,
     /* 328080 */     GIR_EraseRootFromParent_Done,
     /* 328081 */   // Label 6444: @328081
     /* 328081 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(328192), // Rule ID 4913 //
     /* 328086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328105 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 328109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328130 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328146 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 328146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 328149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 328164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328190 */     GIR_RootConstrainSelectedInstOperands,
     /* 328191 */     // GIR_Coverage, 4913,
     /* 328191 */     GIR_EraseRootFromParent_Done,
     /* 328192 */   // Label 6445: @328192
     /* 328192 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(328303), // Rule ID 4911 //
     /* 328197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 328220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328257 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 328257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 328260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 328275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328301 */     GIR_RootConstrainSelectedInstOperands,
     /* 328302 */     // GIR_Coverage, 4911,
     /* 328302 */     GIR_EraseRootFromParent_Done,
     /* 328303 */   // Label 6446: @328303
     /* 328303 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(328367), // Rule ID 654 //
     /* 328308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328327 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 328331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328348 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 328348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328365 */     GIR_RootConstrainSelectedInstOperands,
     /* 328366 */     // GIR_Coverage, 654,
     /* 328366 */     GIR_EraseRootFromParent_Done,
     /* 328367 */   // Label 6447: @328367
     /* 328367 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(328431), // Rule ID 653 //
     /* 328372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328391 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 328395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328412 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 328412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328429 */     GIR_RootConstrainSelectedInstOperands,
     /* 328430 */     // GIR_Coverage, 653,
     /* 328430 */     GIR_EraseRootFromParent_Done,
     /* 328431 */   // Label 6448: @328431
     /* 328431 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(328482), // Rule ID 630 //
     /* 328436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328467 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 328467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 328470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328480 */     GIR_RootConstrainSelectedInstOperands,
     /* 328481 */     // GIR_Coverage, 630,
     /* 328481 */     GIR_EraseRootFromParent_Done,
     /* 328482 */   // Label 6449: @328482
     /* 328482 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(328533), // Rule ID 629 //
     /* 328487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328518 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 328518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 328521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328531 */     GIR_RootConstrainSelectedInstOperands,
     /* 328532 */     // GIR_Coverage, 629,
     /* 328532 */     GIR_EraseRootFromParent_Done,
     /* 328533 */   // Label 6450: @328533
     /* 328533 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(328552), // Rule ID 528 //
     /* 328538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328545 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 328545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 328550 */     GIR_RootConstrainSelectedInstOperands,
     /* 328551 */     // GIR_Coverage, 528,
     /* 328551 */     GIR_Done,
     /* 328552 */   // Label 6451: @328552
     /* 328552 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(328697), // Rule ID 6443 //
     /* 328557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328561 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 328561 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 328564 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328568 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 328575 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 328578 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 328582 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328587 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 328590 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328594 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 328597 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328602 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328607 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 328615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328624 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 328627 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 328639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328644 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 328647 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 328652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 328686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328696 */     // GIR_Coverage, 6443,
     /* 328696 */     GIR_EraseRootFromParent_Done,
     /* 328697 */   // Label 6452: @328697
     /* 328697 */   GIM_Reject,
     /* 328698 */ // Label 6440: @328698
     /* 328698 */ GIM_Reject,
     /* 328699 */ // Label 6432: @328699
     /* 328699 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329721),
     /* 328704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328711 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(328869), // Rule ID 4922 //
     /* 328716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328760 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328785 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328796 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328808 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328836 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328867 */     GIR_RootConstrainSelectedInstOperands,
     /* 328868 */     // GIR_Coverage, 4922,
     /* 328868 */     GIR_EraseRootFromParent_Done,
     /* 328869 */   // Label 6454: @328869
     /* 328869 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329027), // Rule ID 4921 //
     /* 328874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328893 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328918 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328934 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328938 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328943 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328954 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328966 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328994 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 329000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329025 */     GIR_RootConstrainSelectedInstOperands,
     /* 329026 */     // GIR_Coverage, 4921,
     /* 329026 */     GIR_EraseRootFromParent_Done,
     /* 329027 */   // Label 6455: @329027
     /* 329027 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(329138), // Rule ID 4920 //
     /* 329032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329076 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329092 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 329095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 329110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329136 */     GIR_RootConstrainSelectedInstOperands,
     /* 329137 */     // GIR_Coverage, 4920,
     /* 329137 */     GIR_EraseRootFromParent_Done,
     /* 329138 */   // Label 6456: @329138
     /* 329138 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(329249), // Rule ID 4918 //
     /* 329143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329162 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329203 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 329203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 329206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329215 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 329221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329247 */     GIR_RootConstrainSelectedInstOperands,
     /* 329248 */     // GIR_Coverage, 4918,
     /* 329248 */     GIR_EraseRootFromParent_Done,
     /* 329249 */   // Label 6457: @329249
     /* 329249 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(329360), // Rule ID 4919 //
     /* 329254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329314 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 329317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 329332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329358 */     GIR_RootConstrainSelectedInstOperands,
     /* 329359 */     // GIR_Coverage, 4919,
     /* 329359 */     GIR_EraseRootFromParent_Done,
     /* 329360 */   // Label 6458: @329360
     /* 329360 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(329471), // Rule ID 4917 //
     /* 329365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329384 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329425 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 329425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 329428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329437 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 329443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329469 */     GIR_RootConstrainSelectedInstOperands,
     /* 329470 */     // GIR_Coverage, 4917,
     /* 329470 */     GIR_EraseRootFromParent_Done,
     /* 329471 */   // Label 6459: @329471
     /* 329471 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(329535), // Rule ID 656 //
     /* 329476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329516 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329533 */     GIR_RootConstrainSelectedInstOperands,
     /* 329534 */     // GIR_Coverage, 656,
     /* 329534 */     GIR_EraseRootFromParent_Done,
     /* 329535 */   // Label 6460: @329535
     /* 329535 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329599), // Rule ID 655 //
     /* 329540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329580 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329597 */     GIR_RootConstrainSelectedInstOperands,
     /* 329598 */     // GIR_Coverage, 655,
     /* 329598 */     GIR_EraseRootFromParent_Done,
     /* 329599 */   // Label 6461: @329599
     /* 329599 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(329650), // Rule ID 632 //
     /* 329604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 329615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329635 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 329635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 329638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329648 */     GIR_RootConstrainSelectedInstOperands,
     /* 329649 */     // GIR_Coverage, 632,
     /* 329649 */     GIR_EraseRootFromParent_Done,
     /* 329650 */   // Label 6462: @329650
     /* 329650 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(329701), // Rule ID 631 //
     /* 329655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 329666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329686 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 329686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 329689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329699 */     GIR_RootConstrainSelectedInstOperands,
     /* 329700 */     // GIR_Coverage, 631,
     /* 329700 */     GIR_EraseRootFromParent_Done,
     /* 329701 */   // Label 6463: @329701
     /* 329701 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(329720), // Rule ID 529 //
     /* 329706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329713 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 329713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 329718 */     GIR_RootConstrainSelectedInstOperands,
     /* 329719 */     // GIR_Coverage, 529,
     /* 329719 */     GIR_Done,
     /* 329720 */   // Label 6464: @329720
     /* 329720 */   GIM_Reject,
     /* 329721 */ // Label 6453: @329721
     /* 329721 */ GIM_Reject,
     /* 329722 */ // Label 6433: @329722
     /* 329722 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(330744),
     /* 329727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329734 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(329892), // Rule ID 4928 //
     /* 329739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329758 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329783 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329795 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329799 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 329803 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329808 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 329812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329819 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 329822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329831 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329859 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329890 */     GIR_RootConstrainSelectedInstOperands,
     /* 329891 */     // GIR_Coverage, 4928,
     /* 329891 */     GIR_EraseRootFromParent_Done,
     /* 329892 */   // Label 6466: @329892
     /* 329892 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(330050), // Rule ID 4927 //
     /* 329897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329957 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 329961 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329966 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 329970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329977 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 329980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329989 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330017 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 330044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330048 */     GIR_RootConstrainSelectedInstOperands,
     /* 330049 */     // GIR_Coverage, 4927,
     /* 330049 */     GIR_EraseRootFromParent_Done,
     /* 330050 */   // Label 6467: @330050
     /* 330050 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(330161), // Rule ID 4926 //
     /* 330055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 330066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330074 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330115 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330127 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330159 */     GIR_RootConstrainSelectedInstOperands,
     /* 330160 */     // GIR_Coverage, 4926,
     /* 330160 */     GIR_EraseRootFromParent_Done,
     /* 330161 */   // Label 6468: @330161
     /* 330161 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(330272), // Rule ID 4924 //
     /* 330166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 330177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330185 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330226 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 330226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 330244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330270 */     GIR_RootConstrainSelectedInstOperands,
     /* 330271 */     // GIR_Coverage, 4924,
     /* 330271 */     GIR_EraseRootFromParent_Done,
     /* 330272 */   // Label 6469: @330272
     /* 330272 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(330383), // Rule ID 4925 //
     /* 330277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 330288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330321 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330337 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330349 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330381 */     GIR_RootConstrainSelectedInstOperands,
     /* 330382 */     // GIR_Coverage, 4925,
     /* 330382 */     GIR_EraseRootFromParent_Done,
     /* 330383 */   // Label 6470: @330383
     /* 330383 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(330494), // Rule ID 4923 //
     /* 330388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 330399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330407 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330448 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 330448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 330466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330492 */     GIR_RootConstrainSelectedInstOperands,
     /* 330493 */     // GIR_Coverage, 4923,
     /* 330493 */     GIR_EraseRootFromParent_Done,
     /* 330494 */   // Label 6471: @330494
     /* 330494 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(330558), // Rule ID 658 //
     /* 330499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 330510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330518 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330539 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330556 */     GIR_RootConstrainSelectedInstOperands,
     /* 330557 */     // GIR_Coverage, 658,
     /* 330557 */     GIR_EraseRootFromParent_Done,
     /* 330558 */   // Label 6472: @330558
     /* 330558 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(330622), // Rule ID 657 //
     /* 330563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 330574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330582 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330603 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330620 */     GIR_RootConstrainSelectedInstOperands,
     /* 330621 */     // GIR_Coverage, 657,
     /* 330621 */     GIR_EraseRootFromParent_Done,
     /* 330622 */   // Label 6473: @330622
     /* 330622 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(330673), // Rule ID 634 //
     /* 330627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 330638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330658 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 330658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 330661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330671 */     GIR_RootConstrainSelectedInstOperands,
     /* 330672 */     // GIR_Coverage, 634,
     /* 330672 */     GIR_EraseRootFromParent_Done,
     /* 330673 */   // Label 6474: @330673
     /* 330673 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(330724), // Rule ID 633 //
     /* 330678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 330689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330709 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 330709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 330712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330722 */     GIR_RootConstrainSelectedInstOperands,
     /* 330723 */     // GIR_Coverage, 633,
     /* 330723 */     GIR_EraseRootFromParent_Done,
     /* 330724 */   // Label 6475: @330724
     /* 330724 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(330743), // Rule ID 530 //
     /* 330729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330736 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 330736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 330741 */     GIR_RootConstrainSelectedInstOperands,
     /* 330742 */     // GIR_Coverage, 530,
     /* 330742 */     GIR_Done,
     /* 330743 */   // Label 6476: @330743
     /* 330743 */   GIM_Reject,
     /* 330744 */ // Label 6465: @330744
     /* 330744 */ GIM_Reject,
     /* 330745 */ // Label 6434: @330745
     /* 330745 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(330771), // Rule ID 864 //
     /* 330750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330764 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 330764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 330769 */   GIR_RootConstrainSelectedInstOperands,
     /* 330770 */   // GIR_Coverage, 864,
     /* 330770 */   GIR_Done,
     /* 330771 */ // Label 6477: @330771
     /* 330771 */ GIM_Reject,
     /* 330772 */ // Label 6435: @330772
     /* 330772 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(330798), // Rule ID 866 //
     /* 330777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330791 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 330791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 330796 */   GIR_RootConstrainSelectedInstOperands,
     /* 330797 */   // GIR_Coverage, 866,
     /* 330797 */   GIR_Done,
     /* 330798 */ // Label 6478: @330798
     /* 330798 */ GIM_Reject,
     /* 330799 */ // Label 6436: @330799
     /* 330799 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(330878),
     /* 330804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330815 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(330830), // Rule ID 862 //
     /* 330820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330823 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 330823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 330828 */     GIR_RootConstrainSelectedInstOperands,
     /* 330829 */     // GIR_Coverage, 862,
     /* 330829 */     GIR_Done,
     /* 330830 */   // Label 6480: @330830
     /* 330830 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(330877), // Rule ID 6446 //
     /* 330835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330838 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 330838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 330845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330850 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 330860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 330868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330875 */     GIR_RootConstrainSelectedInstOperands,
     /* 330876 */     // GIR_Coverage, 6446,
     /* 330876 */     GIR_EraseRootFromParent_Done,
     /* 330877 */   // Label 6481: @330877
     /* 330877 */   GIM_Reject,
     /* 330878 */ // Label 6479: @330878
     /* 330878 */ GIM_Reject,
     /* 330879 */ // Label 6437: @330879
     /* 330879 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(330905), // Rule ID 865 //
     /* 330884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330898 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 330898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 330903 */   GIR_RootConstrainSelectedInstOperands,
     /* 330904 */   // GIR_Coverage, 865,
     /* 330904 */   GIR_Done,
     /* 330905 */ // Label 6482: @330905
     /* 330905 */ GIM_Reject,
     /* 330906 */ // Label 6438: @330906
     /* 330906 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(330985),
     /* 330911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330922 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(330937), // Rule ID 863 //
     /* 330927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330930 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 330930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 330935 */     GIR_RootConstrainSelectedInstOperands,
     /* 330936 */     // GIR_Coverage, 863,
     /* 330936 */     GIR_Done,
     /* 330937 */   // Label 6484: @330937
     /* 330937 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(330984), // Rule ID 6447 //
     /* 330942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330945 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 330945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 330952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330957 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 330967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 330975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330982 */     GIR_RootConstrainSelectedInstOperands,
     /* 330983 */     // GIR_Coverage, 6447,
     /* 330983 */     GIR_EraseRootFromParent_Done,
     /* 330984 */   // Label 6485: @330984
     /* 330984 */   GIM_Reject,
     /* 330985 */ // Label 6483: @330985
     /* 330985 */ GIM_Reject,
     /* 330986 */ // Label 6439: @330986
     /* 330986 */ GIM_Reject,
     /* 330987 */ // Label 65: @330987
     /* 330987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6490*/ GIMT_Encode4(331234),
     /* 330998 */ /*GILLT_s32*//*Label 6486*/ GIMT_Encode4(331026),
     /* 331002 */ /*GILLT_s64*//*Label 6487*/ GIMT_Encode4(331057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 331014 */ /*GILLT_v2s64*//*Label 6488*/ GIMT_Encode4(331118), GIMT_Encode4(0),
     /* 331022 */ /*GILLT_v4s32*//*Label 6489*/ GIMT_Encode4(331176),
     /* 331026 */ // Label 6486: @331026
     /* 331026 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(331056), // Rule ID 520 //
     /* 331031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331045 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 331045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 331050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331054 */   GIR_RootConstrainSelectedInstOperands,
     /* 331055 */   // GIR_Coverage, 520,
     /* 331055 */   GIR_Done,
     /* 331056 */ // Label 6491: @331056
     /* 331056 */ GIM_Reject,
     /* 331057 */ // Label 6487: @331057
     /* 331057 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(331087), // Rule ID 518 //
     /* 331062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331076 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 331076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 331081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331085 */   GIR_RootConstrainSelectedInstOperands,
     /* 331086 */   // GIR_Coverage, 518,
     /* 331086 */   GIR_Done,
     /* 331087 */ // Label 6492: @331087
     /* 331087 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(331117), // Rule ID 522 //
     /* 331092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331106 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 331106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 331111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331115 */   GIR_RootConstrainSelectedInstOperands,
     /* 331116 */   // GIR_Coverage, 522,
     /* 331116 */   GIR_Done,
     /* 331117 */ // Label 6493: @331117
     /* 331117 */ GIM_Reject,
     /* 331118 */ // Label 6488: @331118
     /* 331118 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(331175),
     /* 331123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331130 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(331154), // Rule ID 4971 //
     /* 331135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 331142 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 331142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 331145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331152 */     GIR_RootConstrainSelectedInstOperands,
     /* 331153 */     // GIR_Coverage, 4971,
     /* 331153 */     GIR_EraseRootFromParent_Done,
     /* 331154 */   // Label 6495: @331154
     /* 331154 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(331174), // Rule ID 4969 //
     /* 331159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331163 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 331163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 331168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331172 */     GIR_RootConstrainSelectedInstOperands,
     /* 331173 */     // GIR_Coverage, 4969,
     /* 331173 */     GIR_Done,
     /* 331174 */   // Label 6496: @331174
     /* 331174 */   GIM_Reject,
     /* 331175 */ // Label 6494: @331175
     /* 331175 */ GIM_Reject,
     /* 331176 */ // Label 6489: @331176
     /* 331176 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(331233),
     /* 331181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331188 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(331212), // Rule ID 4975 //
     /* 331193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 331200 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 331200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 331203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331210 */     GIR_RootConstrainSelectedInstOperands,
     /* 331211 */     // GIR_Coverage, 4975,
     /* 331211 */     GIR_EraseRootFromParent_Done,
     /* 331212 */   // Label 6498: @331212
     /* 331212 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(331232), // Rule ID 4973 //
     /* 331217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331221 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 331221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 331226 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331230 */     GIR_RootConstrainSelectedInstOperands,
     /* 331231 */     // GIR_Coverage, 4973,
     /* 331231 */     GIR_Done,
     /* 331232 */   // Label 6499: @331232
     /* 331232 */   GIM_Reject,
     /* 331233 */ // Label 6497: @331233
     /* 331233 */ GIM_Reject,
     /* 331234 */ // Label 6490: @331234
     /* 331234 */ GIM_Reject,
     /* 331235 */ // Label 66: @331235
     /* 331235 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6504*/ GIMT_Encode4(331422),
     /* 331246 */ /*GILLT_s16*//*Label 6500*/ GIMT_Encode4(331274),
     /* 331250 */ /*GILLT_s32*//*Label 6501*/ GIMT_Encode4(331335), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 331262 */ /*GILLT_v2s32*//*Label 6502*/ GIMT_Encode4(331366), GIMT_Encode4(0),
     /* 331270 */ /*GILLT_v4s16*//*Label 6503*/ GIMT_Encode4(331394),
     /* 331274 */ // Label 6500: @331274
     /* 331274 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(331304), // Rule ID 514 //
     /* 331279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331293 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 331293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 331298 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331302 */   GIR_RootConstrainSelectedInstOperands,
     /* 331303 */   // GIR_Coverage, 514,
     /* 331303 */   GIR_Done,
     /* 331304 */ // Label 6505: @331304
     /* 331304 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(331334), // Rule ID 524 //
     /* 331309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331323 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 331323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 331328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331332 */   GIR_RootConstrainSelectedInstOperands,
     /* 331333 */   // GIR_Coverage, 524,
     /* 331333 */   GIR_Done,
     /* 331334 */ // Label 6506: @331334
     /* 331334 */ GIM_Reject,
     /* 331335 */ // Label 6501: @331335
     /* 331335 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(331365), // Rule ID 516 //
     /* 331340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331354 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 331354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 331359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331363 */   GIR_RootConstrainSelectedInstOperands,
     /* 331364 */   // GIR_Coverage, 516,
     /* 331364 */   GIR_Done,
     /* 331365 */ // Label 6507: @331365
     /* 331365 */ GIM_Reject,
     /* 331366 */ // Label 6502: @331366
     /* 331366 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(331393), // Rule ID 4979 //
     /* 331371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331382 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 331382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 331387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331391 */   GIR_RootConstrainSelectedInstOperands,
     /* 331392 */   // GIR_Coverage, 4979,
     /* 331392 */   GIR_Done,
     /* 331393 */ // Label 6508: @331393
     /* 331393 */ GIM_Reject,
     /* 331394 */ // Label 6503: @331394
     /* 331394 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(331421), // Rule ID 4981 //
     /* 331399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331410 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 331410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 331415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331419 */   GIR_RootConstrainSelectedInstOperands,
     /* 331420 */   // GIR_Coverage, 4981,
     /* 331420 */   GIR_Done,
     /* 331421 */ // Label 6509: @331421
     /* 331421 */ GIM_Reject,
     /* 331422 */ // Label 6504: @331422
     /* 331422 */ GIM_Reject,
     /* 331423 */ // Label 67: @331423
     /* 331423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6517*/ GIMT_Encode4(332399),
     /* 331434 */ /*GILLT_s32*//*Label 6510*/ GIMT_Encode4(331470),
     /* 331438 */ /*GILLT_s64*//*Label 6511*/ GIMT_Encode4(331857), GIMT_Encode4(0),
     /* 331446 */ /*GILLT_v2s32*//*Label 6512*/ GIMT_Encode4(332244),
     /* 331450 */ /*GILLT_v2s64*//*Label 6513*/ GIMT_Encode4(332275),
     /* 331454 */ /*GILLT_v4s16*//*Label 6514*/ GIMT_Encode4(332306),
     /* 331458 */ /*GILLT_v4s32*//*Label 6515*/ GIMT_Encode4(332337), GIMT_Encode4(0),
     /* 331466 */ /*GILLT_v8s16*//*Label 6516*/ GIMT_Encode4(332368),
     /* 331470 */ // Label 6510: @331470
     /* 331470 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(331507), // Rule ID 4718 //
     /* 331475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331490 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331496 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 331499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331501 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331505 */   GIR_RootConstrainSelectedInstOperands,
     /* 331506 */   // GIR_Coverage, 4718,
     /* 331506 */   GIR_EraseRootFromParent_Done,
     /* 331507 */ // Label 6518: @331507
     /* 331507 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(331544), // Rule ID 4720 //
     /* 331512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331527 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331533 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 331536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331538 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331542 */   GIR_RootConstrainSelectedInstOperands,
     /* 331543 */   // GIR_Coverage, 4720,
     /* 331543 */   GIR_EraseRootFromParent_Done,
     /* 331544 */ // Label 6519: @331544
     /* 331544 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(331581), // Rule ID 4738 //
     /* 331549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331570 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 331573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331579 */   GIR_RootConstrainSelectedInstOperands,
     /* 331580 */   // GIR_Coverage, 4738,
     /* 331580 */   GIR_EraseRootFromParent_Done,
     /* 331581 */ // Label 6520: @331581
     /* 331581 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(331618), // Rule ID 4740 //
     /* 331586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331607 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 331610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331612 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331616 */   GIR_RootConstrainSelectedInstOperands,
     /* 331617 */   // GIR_Coverage, 4740,
     /* 331617 */   GIR_EraseRootFromParent_Done,
     /* 331618 */ // Label 6521: @331618
     /* 331618 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(331655), // Rule ID 4778 //
     /* 331623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331638 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331644 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 331647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331649 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331653 */   GIR_RootConstrainSelectedInstOperands,
     /* 331654 */   // GIR_Coverage, 4778,
     /* 331654 */   GIR_EraseRootFromParent_Done,
     /* 331655 */ // Label 6522: @331655
     /* 331655 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(331692), // Rule ID 4780 //
     /* 331660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331681 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 331684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331686 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331690 */   GIR_RootConstrainSelectedInstOperands,
     /* 331691 */   // GIR_Coverage, 4780,
     /* 331691 */   GIR_EraseRootFromParent_Done,
     /* 331692 */ // Label 6523: @331692
     /* 331692 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(331729), // Rule ID 4758 //
     /* 331697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331718 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 331721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331727 */   GIR_RootConstrainSelectedInstOperands,
     /* 331728 */   // GIR_Coverage, 4758,
     /* 331728 */   GIR_EraseRootFromParent_Done,
     /* 331729 */ // Label 6524: @331729
     /* 331729 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(331766), // Rule ID 4760 //
     /* 331734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331749 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331755 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 331758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331764 */   GIR_RootConstrainSelectedInstOperands,
     /* 331765 */   // GIR_Coverage, 4760,
     /* 331765 */   GIR_EraseRootFromParent_Done,
     /* 331766 */ // Label 6525: @331766
     /* 331766 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(331796), // Rule ID 399 //
     /* 331771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331785 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 331785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 331790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331794 */   GIR_RootConstrainSelectedInstOperands,
     /* 331795 */   // GIR_Coverage, 399,
     /* 331795 */   GIR_Done,
     /* 331796 */ // Label 6526: @331796
     /* 331796 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(331826), // Rule ID 403 //
     /* 331801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331815 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 331815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 331820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331824 */   GIR_RootConstrainSelectedInstOperands,
     /* 331825 */   // GIR_Coverage, 403,
     /* 331825 */   GIR_Done,
     /* 331826 */ // Label 6527: @331826
     /* 331826 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(331856), // Rule ID 407 //
     /* 331831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331845 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 331845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 331850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331854 */   GIR_RootConstrainSelectedInstOperands,
     /* 331855 */   // GIR_Coverage, 407,
     /* 331855 */   GIR_Done,
     /* 331856 */ // Label 6528: @331856
     /* 331856 */ GIM_Reject,
     /* 331857 */ // Label 6511: @331857
     /* 331857 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(331894), // Rule ID 4719 //
     /* 331862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331869 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331877 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331883 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 331886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331888 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331892 */   GIR_RootConstrainSelectedInstOperands,
     /* 331893 */   // GIR_Coverage, 4719,
     /* 331893 */   GIR_EraseRootFromParent_Done,
     /* 331894 */ // Label 6529: @331894
     /* 331894 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(331931), // Rule ID 4721 //
     /* 331899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331920 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 331923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331925 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331929 */   GIR_RootConstrainSelectedInstOperands,
     /* 331930 */   // GIR_Coverage, 4721,
     /* 331930 */   GIR_EraseRootFromParent_Done,
     /* 331931 */ // Label 6530: @331931
     /* 331931 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(331968), // Rule ID 4739 //
     /* 331936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331957 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 331960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331962 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331966 */   GIR_RootConstrainSelectedInstOperands,
     /* 331967 */   // GIR_Coverage, 4739,
     /* 331967 */   GIR_EraseRootFromParent_Done,
     /* 331968 */ // Label 6531: @331968
     /* 331968 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(332005), // Rule ID 4741 //
     /* 331973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331994 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 331997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331999 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332003 */   GIR_RootConstrainSelectedInstOperands,
     /* 332004 */   // GIR_Coverage, 4741,
     /* 332004 */   GIR_EraseRootFromParent_Done,
     /* 332005 */ // Label 6532: @332005
     /* 332005 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(332042), // Rule ID 4779 //
     /* 332010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332031 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 332034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332040 */   GIR_RootConstrainSelectedInstOperands,
     /* 332041 */   // GIR_Coverage, 4779,
     /* 332041 */   GIR_EraseRootFromParent_Done,
     /* 332042 */ // Label 6533: @332042
     /* 332042 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(332079), // Rule ID 4781 //
     /* 332047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332062 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332068 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 332071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332077 */   GIR_RootConstrainSelectedInstOperands,
     /* 332078 */   // GIR_Coverage, 4781,
     /* 332078 */   GIR_EraseRootFromParent_Done,
     /* 332079 */ // Label 6534: @332079
     /* 332079 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(332116), // Rule ID 4759 //
     /* 332084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332105 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 332108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332114 */   GIR_RootConstrainSelectedInstOperands,
     /* 332115 */   // GIR_Coverage, 4759,
     /* 332115 */   GIR_EraseRootFromParent_Done,
     /* 332116 */ // Label 6535: @332116
     /* 332116 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(332153), // Rule ID 4761 //
     /* 332121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332142 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 332145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332151 */   GIR_RootConstrainSelectedInstOperands,
     /* 332152 */   // GIR_Coverage, 4761,
     /* 332152 */   GIR_EraseRootFromParent_Done,
     /* 332153 */ // Label 6536: @332153
     /* 332153 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(332183), // Rule ID 401 //
     /* 332158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332172 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 332172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 332177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332181 */   GIR_RootConstrainSelectedInstOperands,
     /* 332182 */   // GIR_Coverage, 401,
     /* 332182 */   GIR_Done,
     /* 332183 */ // Label 6537: @332183
     /* 332183 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(332213), // Rule ID 405 //
     /* 332188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332202 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 332202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 332207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332211 */   GIR_RootConstrainSelectedInstOperands,
     /* 332212 */   // GIR_Coverage, 405,
     /* 332212 */   GIR_Done,
     /* 332213 */ // Label 6538: @332213
     /* 332213 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(332243), // Rule ID 409 //
     /* 332218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332232 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 332232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 332237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332241 */   GIR_RootConstrainSelectedInstOperands,
     /* 332242 */   // GIR_Coverage, 409,
     /* 332242 */   GIR_Done,
     /* 332243 */ // Label 6539: @332243
     /* 332243 */ GIM_Reject,
     /* 332244 */ // Label 6512: @332244
     /* 332244 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(332274), // Rule ID 847 //
     /* 332249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332263 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 332263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 332268 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332272 */   GIR_RootConstrainSelectedInstOperands,
     /* 332273 */   // GIR_Coverage, 847,
     /* 332273 */   GIR_Done,
     /* 332274 */ // Label 6540: @332274
     /* 332274 */ GIM_Reject,
     /* 332275 */ // Label 6513: @332275
     /* 332275 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(332305), // Rule ID 851 //
     /* 332280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332294 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 332294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 332299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332303 */   GIR_RootConstrainSelectedInstOperands,
     /* 332304 */   // GIR_Coverage, 851,
     /* 332304 */   GIR_Done,
     /* 332305 */ // Label 6541: @332305
     /* 332305 */ GIM_Reject,
     /* 332306 */ // Label 6514: @332306
     /* 332306 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(332336), // Rule ID 843 //
     /* 332311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332325 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 332325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 332330 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332334 */   GIR_RootConstrainSelectedInstOperands,
     /* 332335 */   // GIR_Coverage, 843,
     /* 332335 */   GIR_Done,
     /* 332336 */ // Label 6542: @332336
     /* 332336 */ GIM_Reject,
     /* 332337 */ // Label 6515: @332337
     /* 332337 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(332367), // Rule ID 849 //
     /* 332342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332356 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 332356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 332361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332365 */   GIR_RootConstrainSelectedInstOperands,
     /* 332366 */   // GIR_Coverage, 849,
     /* 332366 */   GIR_Done,
     /* 332367 */ // Label 6543: @332367
     /* 332367 */ GIM_Reject,
     /* 332368 */ // Label 6516: @332368
     /* 332368 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(332398), // Rule ID 845 //
     /* 332373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332387 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 332387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 332392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332396 */   GIR_RootConstrainSelectedInstOperands,
     /* 332397 */   // GIR_Coverage, 845,
     /* 332397 */   GIR_Done,
     /* 332398 */ // Label 6544: @332398
     /* 332398 */ GIM_Reject,
     /* 332399 */ // Label 6517: @332399
     /* 332399 */ GIM_Reject,
     /* 332400 */ // Label 68: @332400
     /* 332400 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6552*/ GIMT_Encode4(333376),
     /* 332411 */ /*GILLT_s32*//*Label 6545*/ GIMT_Encode4(332447),
     /* 332415 */ /*GILLT_s64*//*Label 6546*/ GIMT_Encode4(332834), GIMT_Encode4(0),
     /* 332423 */ /*GILLT_v2s32*//*Label 6547*/ GIMT_Encode4(333221),
     /* 332427 */ /*GILLT_v2s64*//*Label 6548*/ GIMT_Encode4(333252),
     /* 332431 */ /*GILLT_v4s16*//*Label 6549*/ GIMT_Encode4(333283),
     /* 332435 */ /*GILLT_v4s32*//*Label 6550*/ GIMT_Encode4(333314), GIMT_Encode4(0),
     /* 332443 */ /*GILLT_v8s16*//*Label 6551*/ GIMT_Encode4(333345),
     /* 332447 */ // Label 6545: @332447
     /* 332447 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(332484), // Rule ID 4728 //
     /* 332452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332473 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 332476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332482 */   GIR_RootConstrainSelectedInstOperands,
     /* 332483 */   // GIR_Coverage, 4728,
     /* 332483 */   GIR_EraseRootFromParent_Done,
     /* 332484 */ // Label 6553: @332484
     /* 332484 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(332521), // Rule ID 4730 //
     /* 332489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332504 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332510 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 332513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332515 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332519 */   GIR_RootConstrainSelectedInstOperands,
     /* 332520 */   // GIR_Coverage, 4730,
     /* 332520 */   GIR_EraseRootFromParent_Done,
     /* 332521 */ // Label 6554: @332521
     /* 332521 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(332558), // Rule ID 4748 //
     /* 332526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332541 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332547 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 332550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332552 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332556 */   GIR_RootConstrainSelectedInstOperands,
     /* 332557 */   // GIR_Coverage, 4748,
     /* 332557 */   GIR_EraseRootFromParent_Done,
     /* 332558 */ // Label 6555: @332558
     /* 332558 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(332595), // Rule ID 4750 //
     /* 332563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332578 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332584 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 332587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332589 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332593 */   GIR_RootConstrainSelectedInstOperands,
     /* 332594 */   // GIR_Coverage, 4750,
     /* 332594 */   GIR_EraseRootFromParent_Done,
     /* 332595 */ // Label 6556: @332595
     /* 332595 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(332632), // Rule ID 4788 //
     /* 332600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332615 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332621 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 332624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332626 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332630 */   GIR_RootConstrainSelectedInstOperands,
     /* 332631 */   // GIR_Coverage, 4788,
     /* 332631 */   GIR_EraseRootFromParent_Done,
     /* 332632 */ // Label 6557: @332632
     /* 332632 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(332669), // Rule ID 4790 //
     /* 332637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332652 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332658 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 332661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332663 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332667 */   GIR_RootConstrainSelectedInstOperands,
     /* 332668 */   // GIR_Coverage, 4790,
     /* 332668 */   GIR_EraseRootFromParent_Done,
     /* 332669 */ // Label 6558: @332669
     /* 332669 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(332706), // Rule ID 4768 //
     /* 332674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332695 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 332698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332700 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332704 */   GIR_RootConstrainSelectedInstOperands,
     /* 332705 */   // GIR_Coverage, 4768,
     /* 332705 */   GIR_EraseRootFromParent_Done,
     /* 332706 */ // Label 6559: @332706
     /* 332706 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(332743), // Rule ID 4770 //
     /* 332711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332726 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332730 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332732 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 332735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332737 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332741 */   GIR_RootConstrainSelectedInstOperands,
     /* 332742 */   // GIR_Coverage, 4770,
     /* 332742 */   GIR_EraseRootFromParent_Done,
     /* 332743 */ // Label 6560: @332743
     /* 332743 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(332773), // Rule ID 411 //
     /* 332748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332762 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 332762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 332767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332771 */   GIR_RootConstrainSelectedInstOperands,
     /* 332772 */   // GIR_Coverage, 411,
     /* 332772 */   GIR_Done,
     /* 332773 */ // Label 6561: @332773
     /* 332773 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(332803), // Rule ID 415 //
     /* 332778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332792 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 332792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 332797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332801 */   GIR_RootConstrainSelectedInstOperands,
     /* 332802 */   // GIR_Coverage, 415,
     /* 332802 */   GIR_Done,
     /* 332803 */ // Label 6562: @332803
     /* 332803 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(332833), // Rule ID 419 //
     /* 332808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332822 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 332822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 332827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332831 */   GIR_RootConstrainSelectedInstOperands,
     /* 332832 */   // GIR_Coverage, 419,
     /* 332832 */   GIR_Done,
     /* 332833 */ // Label 6563: @332833
     /* 332833 */ GIM_Reject,
     /* 332834 */ // Label 6546: @332834
     /* 332834 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(332871), // Rule ID 4729 //
     /* 332839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332846 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332854 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332858 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332860 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 332863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332865 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332869 */   GIR_RootConstrainSelectedInstOperands,
     /* 332870 */   // GIR_Coverage, 4729,
     /* 332870 */   GIR_EraseRootFromParent_Done,
     /* 332871 */ // Label 6564: @332871
     /* 332871 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(332908), // Rule ID 4731 //
     /* 332876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332897 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 332900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332902 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332906 */   GIR_RootConstrainSelectedInstOperands,
     /* 332907 */   // GIR_Coverage, 4731,
     /* 332907 */   GIR_EraseRootFromParent_Done,
     /* 332908 */ // Label 6565: @332908
     /* 332908 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(332945), // Rule ID 4749 //
     /* 332913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332934 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 332937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332943 */   GIR_RootConstrainSelectedInstOperands,
     /* 332944 */   // GIR_Coverage, 4749,
     /* 332944 */   GIR_EraseRootFromParent_Done,
     /* 332945 */ // Label 6566: @332945
     /* 332945 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(332982), // Rule ID 4751 //
     /* 332950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332971 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 332974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332976 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332980 */   GIR_RootConstrainSelectedInstOperands,
     /* 332981 */   // GIR_Coverage, 4751,
     /* 332981 */   GIR_EraseRootFromParent_Done,
     /* 332982 */ // Label 6567: @332982
     /* 332982 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(333019), // Rule ID 4789 //
     /* 332987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332994 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332998 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 333002 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333006 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333008 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 333008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 333011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333013 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333017 */   GIR_RootConstrainSelectedInstOperands,
     /* 333018 */   // GIR_Coverage, 4789,
     /* 333018 */   GIR_EraseRootFromParent_Done,
     /* 333019 */ // Label 6568: @333019
     /* 333019 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(333056), // Rule ID 4791 //
     /* 333024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333031 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 333039 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333045 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 333045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 333048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333054 */   GIR_RootConstrainSelectedInstOperands,
     /* 333055 */   // GIR_Coverage, 4791,
     /* 333055 */   GIR_EraseRootFromParent_Done,
     /* 333056 */ // Label 6569: @333056
     /* 333056 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(333093), // Rule ID 4769 //
     /* 333061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 333076 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333082 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 333082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 333085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333087 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333091 */   GIR_RootConstrainSelectedInstOperands,
     /* 333092 */   // GIR_Coverage, 4769,
     /* 333092 */   GIR_EraseRootFromParent_Done,
     /* 333093 */ // Label 6570: @333093
     /* 333093 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(333130), // Rule ID 4771 //
     /* 333098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 333113 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333119 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 333119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 333122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333128 */   GIR_RootConstrainSelectedInstOperands,
     /* 333129 */   // GIR_Coverage, 4771,
     /* 333129 */   GIR_EraseRootFromParent_Done,
     /* 333130 */ // Label 6571: @333130
     /* 333130 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(333160), // Rule ID 413 //
     /* 333135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 333138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 333141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333149 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 333149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 333154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333158 */   GIR_RootConstrainSelectedInstOperands,
     /* 333159 */   // GIR_Coverage, 413,
     /* 333159 */   GIR_Done,
     /* 333160 */ // Label 6572: @333160
     /* 333160 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(333190), // Rule ID 417 //
     /* 333165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333179 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 333179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 333184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333188 */   GIR_RootConstrainSelectedInstOperands,
     /* 333189 */   // GIR_Coverage, 417,
     /* 333189 */   GIR_Done,
     /* 333190 */ // Label 6573: @333190
     /* 333190 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(333220), // Rule ID 421 //
     /* 333195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333209 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 333209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 333214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333218 */   GIR_RootConstrainSelectedInstOperands,
     /* 333219 */   // GIR_Coverage, 421,
     /* 333219 */   GIR_Done,
     /* 333220 */ // Label 6574: @333220
     /* 333220 */ GIM_Reject,
     /* 333221 */ // Label 6547: @333221
     /* 333221 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(333251), // Rule ID 857 //
     /* 333226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 333229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 333232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333240 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 333240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 333245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333249 */   GIR_RootConstrainSelectedInstOperands,
     /* 333250 */   // GIR_Coverage, 857,
     /* 333250 */   GIR_Done,
     /* 333251 */ // Label 6575: @333251
     /* 333251 */ GIM_Reject,
     /* 333252 */ // Label 6548: @333252
     /* 333252 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(333282), // Rule ID 861 //
     /* 333257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 333260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333271 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 333271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 333276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333280 */   GIR_RootConstrainSelectedInstOperands,
     /* 333281 */   // GIR_Coverage, 861,
     /* 333281 */   GIR_Done,
     /* 333282 */ // Label 6576: @333282
     /* 333282 */ GIM_Reject,
     /* 333283 */ // Label 6549: @333283
     /* 333283 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(333313), // Rule ID 853 //
     /* 333288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 333291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 333294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333302 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 333302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 333307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333311 */   GIR_RootConstrainSelectedInstOperands,
     /* 333312 */   // GIR_Coverage, 853,
     /* 333312 */   GIR_Done,
     /* 333313 */ // Label 6577: @333313
     /* 333313 */ GIM_Reject,
     /* 333314 */ // Label 6550: @333314
     /* 333314 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(333344), // Rule ID 859 //
     /* 333319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 333322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333333 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 333333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 333338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333342 */   GIR_RootConstrainSelectedInstOperands,
     /* 333343 */   // GIR_Coverage, 859,
     /* 333343 */   GIR_Done,
     /* 333344 */ // Label 6578: @333344
     /* 333344 */ GIM_Reject,
     /* 333345 */ // Label 6551: @333345
     /* 333345 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(333375), // Rule ID 855 //
     /* 333350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 333353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 333356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333364 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 333364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 333369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333373 */   GIR_RootConstrainSelectedInstOperands,
     /* 333374 */   // GIR_Coverage, 855,
     /* 333374 */   GIR_Done,
     /* 333375 */ // Label 6579: @333375
     /* 333375 */ GIM_Reject,
     /* 333376 */ // Label 6552: @333376
     /* 333376 */ GIM_Reject,
     /* 333377 */ // Label 69: @333377
     /* 333377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6588*/ GIMT_Encode4(338004),
     /* 333388 */ /*GILLT_s16*//*Label 6580*/ GIMT_Encode4(333428),
     /* 333392 */ /*GILLT_s32*//*Label 6581*/ GIMT_Encode4(333869),
     /* 333396 */ /*GILLT_s64*//*Label 6582*/ GIMT_Encode4(335865), GIMT_Encode4(0),
     /* 333404 */ /*GILLT_v2s32*//*Label 6583*/ GIMT_Encode4(337849),
     /* 333408 */ /*GILLT_v2s64*//*Label 6584*/ GIMT_Encode4(337880),
     /* 333412 */ /*GILLT_v4s16*//*Label 6585*/ GIMT_Encode4(337911),
     /* 333416 */ /*GILLT_v4s32*//*Label 6586*/ GIMT_Encode4(337942), GIMT_Encode4(0),
     /* 333424 */ /*GILLT_v8s16*//*Label 6587*/ GIMT_Encode4(337973),
     /* 333428 */ // Label 6580: @333428
     /* 333428 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(333531), // Rule ID 5371 //
     /* 333433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 333436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 333451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333463 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 333467 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 333471 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333476 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 333480 */   // MIs[1] Operand 2
     /* 333480 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 333491 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333493 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 333493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333505 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 333511 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 333524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333529 */   GIR_RootConstrainSelectedInstOperands,
     /* 333530 */   // GIR_Coverage, 5371,
     /* 333530 */   GIR_EraseRootFromParent_Done,
     /* 333531 */ // Label 6589: @333531
     /* 333531 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(333611), // Rule ID 2451 //
     /* 333536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333554 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333558 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333562 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333567 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333573 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333585 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 333604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333609 */   GIR_RootConstrainSelectedInstOperands,
     /* 333610 */   // GIR_Coverage, 2451,
     /* 333610 */   GIR_EraseRootFromParent_Done,
     /* 333611 */ // Label 6590: @333611
     /* 333611 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(333691), // Rule ID 2455 //
     /* 333616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333647 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333653 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 333653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333665 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 333671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 333684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333689 */   GIR_RootConstrainSelectedInstOperands,
     /* 333690 */   // GIR_Coverage, 2455,
     /* 333690 */   GIR_EraseRootFromParent_Done,
     /* 333691 */ // Label 6591: @333691
     /* 333691 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(333748), // Rule ID 5362 //
     /* 333696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 333699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333706 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 333714 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333720 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 333720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 333727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 333741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333746 */   GIR_RootConstrainSelectedInstOperands,
     /* 333747 */   // GIR_Coverage, 5362,
     /* 333747 */   GIR_EraseRootFromParent_Done,
     /* 333748 */ // Label 6592: @333748
     /* 333748 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(333778), // Rule ID 447 //
     /* 333753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 333756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333767 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 333767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 333772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333776 */   GIR_RootConstrainSelectedInstOperands,
     /* 333777 */   // GIR_Coverage, 447,
     /* 333777 */   GIR_Done,
     /* 333778 */ // Label 6593: @333778
     /* 333778 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(333808), // Rule ID 453 //
     /* 333783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 333786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333797 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 333797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 333802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333806 */   GIR_RootConstrainSelectedInstOperands,
     /* 333807 */   // GIR_Coverage, 453,
     /* 333807 */   GIR_Done,
     /* 333808 */ // Label 6594: @333808
     /* 333808 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(333838), // Rule ID 495 //
     /* 333813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333827 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 333827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 333832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333836 */   GIR_RootConstrainSelectedInstOperands,
     /* 333837 */   // GIR_Coverage, 495,
     /* 333837 */   GIR_Done,
     /* 333838 */ // Label 6595: @333838
     /* 333838 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(333868), // Rule ID 499 //
     /* 333843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333857 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 333857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 333862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333866 */   GIR_RootConstrainSelectedInstOperands,
     /* 333867 */   // GIR_Coverage, 499,
     /* 333867 */   GIR_Done,
     /* 333868 */ // Label 6596: @333868
     /* 333868 */ GIM_Reject,
     /* 333869 */ // Label 6581: @333869
     /* 333869 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(334107), // Rule ID 6448 //
     /* 333874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333892 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333895 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333902 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333908 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 333915 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333915 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333918 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 333922 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333942 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333949 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333952 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333956 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333963 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333966 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333970 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333975 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333978 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333981 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333984 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333989 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333994 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333999 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334002 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334006 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334011 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334014 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334019 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334022 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334026 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334031 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334038 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334043 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334048 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334051 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334055 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334060 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334063 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334080 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334105 */   GIR_RootConstrainSelectedInstOperands,
     /* 334106 */   // GIR_Coverage, 6448,
     /* 334106 */   GIR_EraseRootFromParent_Done,
     /* 334107 */ // Label 6597: @334107
     /* 334107 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(334345), // Rule ID 6449 //
     /* 334112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334130 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334133 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334140 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334146 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 334153 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334153 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 334156 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 334160 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334180 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334187 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334190 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334194 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334201 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334204 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334208 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334213 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334216 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334219 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334222 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334227 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334232 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334237 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334240 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334244 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334249 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334252 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334257 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334260 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334264 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334269 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334276 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334281 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334286 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334289 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334293 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334298 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334301 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334318 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334343 */   GIR_RootConstrainSelectedInstOperands,
     /* 334344 */   // GIR_Coverage, 6449,
     /* 334344 */   GIR_EraseRootFromParent_Done,
     /* 334345 */ // Label 6598: @334345
     /* 334345 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(334534), // Rule ID 6452 //
     /* 334350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334368 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334371 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334378 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334384 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 334391 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334391 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334394 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 334398 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334418 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334425 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334428 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334432 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334439 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334442 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334446 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334451 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334454 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334457 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334460 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334465 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334470 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334475 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334478 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334482 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334487 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334490 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334507 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334532 */   GIR_RootConstrainSelectedInstOperands,
     /* 334533 */   // GIR_Coverage, 6452,
     /* 334533 */   GIR_EraseRootFromParent_Done,
     /* 334534 */ // Label 6599: @334534
     /* 334534 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(334723), // Rule ID 6453 //
     /* 334539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334557 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334560 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334573 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 334580 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334580 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334583 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 334587 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334607 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334614 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334617 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334621 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334628 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334631 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334635 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334640 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334643 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334646 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334654 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334659 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334676 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334679 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334696 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334721 */   GIR_RootConstrainSelectedInstOperands,
     /* 334722 */   // GIR_Coverage, 6453,
     /* 334722 */   GIR_EraseRootFromParent_Done,
     /* 334723 */ // Label 6600: @334723
     /* 334723 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(334956), // Rule ID 6450 //
     /* 334728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334746 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334749 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334756 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334762 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 334769 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334769 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 334772 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 334776 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334791 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334798 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334801 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334805 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334812 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334815 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334819 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334824 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334827 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334830 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334833 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334838 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334843 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334848 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334851 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334855 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334860 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334863 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334868 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334871 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334875 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334880 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334887 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334892 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334897 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334900 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334904 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334909 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334912 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334929 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334941 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334954 */   GIR_RootConstrainSelectedInstOperands,
     /* 334955 */   // GIR_Coverage, 6450,
     /* 334955 */   GIR_EraseRootFromParent_Done,
     /* 334956 */ // Label 6601: @334956
     /* 334956 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(335189), // Rule ID 6451 //
     /* 334961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334979 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334982 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334995 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 335002 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 335002 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 335005 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 335009 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335024 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335031 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335034 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335038 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335045 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335048 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335052 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335057 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335060 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335063 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 335066 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335071 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335076 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 335081 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335084 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 335088 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335093 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335096 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335101 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335104 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335108 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335113 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335120 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335125 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335142 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335145 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335162 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 335169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335187 */   GIR_RootConstrainSelectedInstOperands,
     /* 335188 */   // GIR_Coverage, 6451,
     /* 335188 */   GIR_EraseRootFromParent_Done,
     /* 335189 */ // Label 6602: @335189
     /* 335189 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(335373), // Rule ID 6454 //
     /* 335194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335212 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335215 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335222 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335228 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 335235 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 335235 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 335238 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 335242 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335257 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335264 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335267 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335271 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335278 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335281 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335285 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335290 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335293 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335296 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 335299 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335304 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335309 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335326 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335329 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335346 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 335353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335371 */   GIR_RootConstrainSelectedInstOperands,
     /* 335372 */   // GIR_Coverage, 6454,
     /* 335372 */   GIR_EraseRootFromParent_Done,
     /* 335373 */ // Label 6603: @335373
     /* 335373 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(335557), // Rule ID 6455 //
     /* 335378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335396 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335399 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335406 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335410 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335412 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 335419 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 335419 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 335422 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 335426 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335441 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335448 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335451 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335455 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335474 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335477 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335480 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 335483 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335488 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335493 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335498 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335501 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335505 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335510 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335513 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335530 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 335537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335555 */   GIR_RootConstrainSelectedInstOperands,
     /* 335556 */   // GIR_Coverage, 6455,
     /* 335556 */   GIR_EraseRootFromParent_Done,
     /* 335557 */ // Label 6604: @335557
     /* 335557 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(335637), // Rule ID 2457 //
     /* 335562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335580 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335584 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335588 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335593 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335597 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335599 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335611 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 335630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335635 */   GIR_RootConstrainSelectedInstOperands,
     /* 335636 */   // GIR_Coverage, 2457,
     /* 335636 */   GIR_EraseRootFromParent_Done,
     /* 335637 */ // Label 6605: @335637
     /* 335637 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(335717), // Rule ID 5367 //
     /* 335642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335673 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335679 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335691 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335715 */   GIR_RootConstrainSelectedInstOperands,
     /* 335716 */   // GIR_Coverage, 5367,
     /* 335716 */   GIR_EraseRootFromParent_Done,
     /* 335717 */ // Label 6606: @335717
     /* 335717 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(335774), // Rule ID 5350 //
     /* 335722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 335740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335746 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 335746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 335753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335772 */   GIR_RootConstrainSelectedInstOperands,
     /* 335773 */   // GIR_Coverage, 5350,
     /* 335773 */   GIR_EraseRootFromParent_Done,
     /* 335774 */ // Label 6607: @335774
     /* 335774 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(335804), // Rule ID 449 //
     /* 335779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335793 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 335793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 335798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335802 */   GIR_RootConstrainSelectedInstOperands,
     /* 335803 */   // GIR_Coverage, 449,
     /* 335803 */   GIR_Done,
     /* 335804 */ // Label 6608: @335804
     /* 335804 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(335834), // Rule ID 455 //
     /* 335809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335823 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 335823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 335828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335832 */   GIR_RootConstrainSelectedInstOperands,
     /* 335833 */   // GIR_Coverage, 455,
     /* 335833 */   GIR_Done,
     /* 335834 */ // Label 6609: @335834
     /* 335834 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(335864), // Rule ID 501 //
     /* 335839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335853 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 335853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 335858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335862 */   GIR_RootConstrainSelectedInstOperands,
     /* 335863 */   // GIR_Coverage, 501,
     /* 335863 */   GIR_Done,
     /* 335864 */ // Label 6610: @335864
     /* 335864 */ GIM_Reject,
     /* 335865 */ // Label 6582: @335865
     /* 335865 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(336051), // Rule ID 6460 //
     /* 335870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335880 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335888 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335895 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335901 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335908 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335908 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335911 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335915 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335935 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335942 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335945 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335949 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335956 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335959 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335963 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335968 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335971 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335974 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335977 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335982 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335987 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335992 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335995 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335999 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336004 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336007 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336024 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336049 */   GIR_RootConstrainSelectedInstOperands,
     /* 336050 */   // GIR_Coverage, 6460,
     /* 336050 */   GIR_EraseRootFromParent_Done,
     /* 336051 */ // Label 6611: @336051
     /* 336051 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(336237), // Rule ID 6461 //
     /* 336056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336074 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336077 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336081 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336087 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336094 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336094 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336097 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336101 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 336121 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336128 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336131 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336135 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336142 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336145 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336149 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336154 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336157 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336160 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 336163 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336168 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336173 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336190 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336193 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336210 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336235 */   GIR_RootConstrainSelectedInstOperands,
     /* 336236 */   // GIR_Coverage, 6461,
     /* 336236 */   GIR_EraseRootFromParent_Done,
     /* 336237 */ // Label 6612: @336237
     /* 336237 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(336475), // Rule ID 6456 //
     /* 336242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336260 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336263 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336270 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336276 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 336283 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336283 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336286 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 336290 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 336310 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336317 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336320 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336324 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336331 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336334 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336338 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336343 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336346 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336349 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336352 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336357 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336362 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336367 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336370 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336374 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336379 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336382 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336387 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336390 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336394 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336399 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336406 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336411 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336416 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336419 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336423 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336428 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336431 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336448 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336473 */   GIR_RootConstrainSelectedInstOperands,
     /* 336474 */   // GIR_Coverage, 6456,
     /* 336474 */   GIR_EraseRootFromParent_Done,
     /* 336475 */ // Label 6613: @336475
     /* 336475 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(336713), // Rule ID 6457 //
     /* 336480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336498 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336501 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336508 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336514 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 336521 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336521 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336524 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 336528 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 336548 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336555 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336558 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336562 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336569 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336572 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336576 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336581 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336584 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336587 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336590 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336595 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336600 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336605 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336608 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336612 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336617 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336620 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336625 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336628 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336632 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336637 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336644 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336666 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336669 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336686 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336711 */   GIR_RootConstrainSelectedInstOperands,
     /* 336712 */   // GIR_Coverage, 6457,
     /* 336712 */   GIR_EraseRootFromParent_Done,
     /* 336713 */ // Label 6614: @336713
     /* 336713 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(336894), // Rule ID 6462 //
     /* 336718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336736 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336739 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336743 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336749 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 336756 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336756 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336759 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 336763 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336778 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336785 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336788 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336792 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336811 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336814 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336817 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 336820 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336825 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336830 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336847 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336850 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336867 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336892 */   GIR_RootConstrainSelectedInstOperands,
     /* 336893 */   // GIR_Coverage, 6462,
     /* 336893 */   GIR_EraseRootFromParent_Done,
     /* 336894 */ // Label 6615: @336894
     /* 336894 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(337075), // Rule ID 6463 //
     /* 336899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336937 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336937 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336940 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336944 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336959 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336966 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336969 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336973 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336980 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336983 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336987 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336992 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336995 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336998 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 337001 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337006 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337011 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337016 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337019 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 337023 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337028 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337031 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337048 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337073 */   GIR_RootConstrainSelectedInstOperands,
     /* 337074 */   // GIR_Coverage, 6463,
     /* 337074 */   GIR_EraseRootFromParent_Done,
     /* 337075 */ // Label 6616: @337075
     /* 337075 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(337308), // Rule ID 6458 //
     /* 337080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 337083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 337098 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337101 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337108 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337114 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 337121 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 337121 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 337124 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 337128 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337143 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 337150 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 337153 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337157 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 337164 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 337167 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337171 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337176 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 337179 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 337182 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 337185 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337190 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337195 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337200 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337203 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 337207 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337212 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337215 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 337218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 337220 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 337223 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337227 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337232 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337239 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337244 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337249 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337252 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 337256 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337261 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337264 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337281 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337306 */   GIR_RootConstrainSelectedInstOperands,
     /* 337307 */   // GIR_Coverage, 6458,
     /* 337307 */   GIR_EraseRootFromParent_Done,
     /* 337308 */ // Label 6617: @337308
     /* 337308 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(337541), // Rule ID 6459 //
     /* 337313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 337316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 337331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337334 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337341 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337347 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 337354 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 337354 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 337357 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 337361 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337376 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 337383 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 337386 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337390 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 337397 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 337400 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337404 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337409 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 337412 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 337415 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 337418 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337423 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337428 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337433 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337436 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 337440 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337445 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337448 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 337451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 337453 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 337456 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337460 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337465 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337472 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337477 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337482 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337485 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 337489 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337494 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337497 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337514 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337521 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337539 */   GIR_RootConstrainSelectedInstOperands,
     /* 337540 */   // GIR_Coverage, 6459,
     /* 337540 */   GIR_EraseRootFromParent_Done,
     /* 337541 */ // Label 6618: @337541
     /* 337541 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337621), // Rule ID 2453 //
     /* 337546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337568 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337572 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337577 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337583 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337595 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 337614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337619 */   GIR_RootConstrainSelectedInstOperands,
     /* 337620 */   // GIR_Coverage, 2453,
     /* 337620 */   GIR_EraseRootFromParent_Done,
     /* 337621 */ // Label 6619: @337621
     /* 337621 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337701), // Rule ID 5369 //
     /* 337626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337648 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337652 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337657 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337663 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337675 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337699 */   GIR_RootConstrainSelectedInstOperands,
     /* 337700 */   // GIR_Coverage, 5369,
     /* 337700 */   GIR_EraseRootFromParent_Done,
     /* 337701 */ // Label 6620: @337701
     /* 337701 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337758), // Rule ID 5346 //
     /* 337706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 337724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 337728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337730 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 337730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 337737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337756 */   GIR_RootConstrainSelectedInstOperands,
     /* 337757 */   // GIR_Coverage, 5346,
     /* 337757 */   GIR_EraseRootFromParent_Done,
     /* 337758 */ // Label 6621: @337758
     /* 337758 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337788), // Rule ID 451 //
     /* 337763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337777 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 337777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 337782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337786 */   GIR_RootConstrainSelectedInstOperands,
     /* 337787 */   // GIR_Coverage, 451,
     /* 337787 */   GIR_Done,
     /* 337788 */ // Label 6622: @337788
     /* 337788 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337818), // Rule ID 457 //
     /* 337793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337807 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 337807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 337812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337816 */   GIR_RootConstrainSelectedInstOperands,
     /* 337817 */   // GIR_Coverage, 457,
     /* 337817 */   GIR_Done,
     /* 337818 */ // Label 6623: @337818
     /* 337818 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337848), // Rule ID 497 //
     /* 337823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337837 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 337837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 337842 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337846 */   GIR_RootConstrainSelectedInstOperands,
     /* 337847 */   // GIR_Coverage, 497,
     /* 337847 */   GIR_Done,
     /* 337848 */ // Label 6624: @337848
     /* 337848 */ GIM_Reject,
     /* 337849 */ // Label 6583: @337849
     /* 337849 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337879), // Rule ID 1021 //
     /* 337854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337868 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 337868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 337873 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337877 */   GIR_RootConstrainSelectedInstOperands,
     /* 337878 */   // GIR_Coverage, 1021,
     /* 337878 */   GIR_Done,
     /* 337879 */ // Label 6625: @337879
     /* 337879 */ GIM_Reject,
     /* 337880 */ // Label 6584: @337880
     /* 337880 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(337910), // Rule ID 1025 //
     /* 337885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337899 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 337899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 337904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337908 */   GIR_RootConstrainSelectedInstOperands,
     /* 337909 */   // GIR_Coverage, 1025,
     /* 337909 */   GIR_Done,
     /* 337910 */ // Label 6626: @337910
     /* 337910 */ GIM_Reject,
     /* 337911 */ // Label 6585: @337911
     /* 337911 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(337941), // Rule ID 1017 //
     /* 337916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 337922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337930 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 337930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 337935 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337939 */   GIR_RootConstrainSelectedInstOperands,
     /* 337940 */   // GIR_Coverage, 1017,
     /* 337940 */   GIR_Done,
     /* 337941 */ // Label 6627: @337941
     /* 337941 */ GIM_Reject,
     /* 337942 */ // Label 6586: @337942
     /* 337942 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(337972), // Rule ID 1023 //
     /* 337947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337961 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 337961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 337966 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337970 */   GIR_RootConstrainSelectedInstOperands,
     /* 337971 */   // GIR_Coverage, 1023,
     /* 337971 */   GIR_Done,
     /* 337972 */ // Label 6628: @337972
     /* 337972 */ GIM_Reject,
     /* 337973 */ // Label 6587: @337973
     /* 337973 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(338003), // Rule ID 1019 //
     /* 337978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337992 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 337992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 337997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338001 */   GIR_RootConstrainSelectedInstOperands,
     /* 338002 */   // GIR_Coverage, 1019,
     /* 338002 */   GIR_Done,
     /* 338003 */ // Label 6629: @338003
     /* 338003 */ GIM_Reject,
     /* 338004 */ // Label 6588: @338004
     /* 338004 */ GIM_Reject,
     /* 338005 */ // Label 70: @338005
     /* 338005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6638*/ GIMT_Encode4(342010),
     /* 338016 */ /*GILLT_s16*//*Label 6630*/ GIMT_Encode4(338056),
     /* 338020 */ /*GILLT_s32*//*Label 6631*/ GIMT_Encode4(338501),
     /* 338024 */ /*GILLT_s64*//*Label 6632*/ GIMT_Encode4(339909), GIMT_Encode4(0),
     /* 338032 */ /*GILLT_v2s32*//*Label 6633*/ GIMT_Encode4(341855),
     /* 338036 */ /*GILLT_v2s64*//*Label 6634*/ GIMT_Encode4(341886),
     /* 338040 */ /*GILLT_v4s16*//*Label 6635*/ GIMT_Encode4(341917),
     /* 338044 */ /*GILLT_v4s32*//*Label 6636*/ GIMT_Encode4(341948), GIMT_Encode4(0),
     /* 338052 */ /*GILLT_v8s16*//*Label 6637*/ GIMT_Encode4(341979),
     /* 338056 */ // Label 6630: @338056
     /* 338056 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(338163), // Rule ID 5372 //
     /* 338061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 338064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 338079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 338087 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338091 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338095 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 338099 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 338103 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338108 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 338112 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 338123 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338125 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 338125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338137 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 338143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 338156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338161 */   GIR_RootConstrainSelectedInstOperands,
     /* 338162 */   // GIR_Coverage, 5372,
     /* 338162 */   GIR_EraseRootFromParent_Done,
     /* 338163 */ // Label 6639: @338163
     /* 338163 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(338243), // Rule ID 4817 //
     /* 338168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338199 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338205 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338217 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 338236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338241 */   GIR_RootConstrainSelectedInstOperands,
     /* 338242 */   // GIR_Coverage, 4817,
     /* 338242 */   GIR_EraseRootFromParent_Done,
     /* 338243 */ // Label 6640: @338243
     /* 338243 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(338323), // Rule ID 4821 //
     /* 338248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 338270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338279 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338285 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 338285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338297 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 338303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 338316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338321 */   GIR_RootConstrainSelectedInstOperands,
     /* 338322 */   // GIR_Coverage, 4821,
     /* 338322 */   GIR_EraseRootFromParent_Done,
     /* 338323 */ // Label 6641: @338323
     /* 338323 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(338380), // Rule ID 5366 //
     /* 338328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 338331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 338346 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338352 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 338352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 338359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 338373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338378 */   GIR_RootConstrainSelectedInstOperands,
     /* 338379 */   // GIR_Coverage, 5366,
     /* 338379 */   GIR_EraseRootFromParent_Done,
     /* 338380 */ // Label 6642: @338380
     /* 338380 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(338410), // Rule ID 471 //
     /* 338385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 338388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338399 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 338399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 338404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338408 */   GIR_RootConstrainSelectedInstOperands,
     /* 338409 */   // GIR_Coverage, 471,
     /* 338409 */   GIR_Done,
     /* 338410 */ // Label 6643: @338410
     /* 338410 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(338440), // Rule ID 477 //
     /* 338415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 338418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 338429 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 338429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 338434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338438 */   GIR_RootConstrainSelectedInstOperands,
     /* 338439 */   // GIR_Coverage, 477,
     /* 338439 */   GIR_Done,
     /* 338440 */ // Label 6644: @338440
     /* 338440 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(338470), // Rule ID 503 //
     /* 338445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338459 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 338459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 338464 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338468 */   GIR_RootConstrainSelectedInstOperands,
     /* 338469 */   // GIR_Coverage, 503,
     /* 338469 */   GIR_Done,
     /* 338470 */ // Label 6645: @338470
     /* 338470 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(338500), // Rule ID 507 //
     /* 338475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338489 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 338489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 338494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338498 */   GIR_RootConstrainSelectedInstOperands,
     /* 338499 */   // GIR_Coverage, 507,
     /* 338499 */   GIR_Done,
     /* 338500 */ // Label 6646: @338500
     /* 338500 */ GIM_Reject,
     /* 338501 */ // Label 6631: @338501
     /* 338501 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(338641), // Rule ID 5373 //
     /* 338506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338524 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338527 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338534 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338540 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 338547 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338547 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338550 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 338554 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338574 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338581 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338584 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338588 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338610 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338613 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338639 */   GIR_RootConstrainSelectedInstOperands,
     /* 338640 */   // GIR_Coverage, 5373,
     /* 338640 */   GIR_EraseRootFromParent_Done,
     /* 338641 */ // Label 6647: @338641
     /* 338641 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(338781), // Rule ID 5374 //
     /* 338646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338664 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338667 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338674 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338680 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 338687 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338687 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338690 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 338694 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338714 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338721 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338724 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338728 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338747 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338750 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338753 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338779 */   GIR_RootConstrainSelectedInstOperands,
     /* 338780 */   // GIR_Coverage, 5374,
     /* 338780 */   GIR_EraseRootFromParent_Done,
     /* 338781 */ // Label 6648: @338781
     /* 338781 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(338921), // Rule ID 5377 //
     /* 338786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338804 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338807 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338814 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338820 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338827 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338827 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338830 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338834 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338854 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338861 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338864 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338868 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338887 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338890 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338893 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338896 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338901 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338919 */   GIR_RootConstrainSelectedInstOperands,
     /* 338920 */   // GIR_Coverage, 5377,
     /* 338920 */   GIR_EraseRootFromParent_Done,
     /* 338921 */ // Label 6649: @338921
     /* 338921 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(339061), // Rule ID 5378 //
     /* 338926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338936 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338940 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338944 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338947 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338954 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338960 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338967 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338967 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338970 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338974 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338994 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339027 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339030 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339033 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339046 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339059 */   GIR_RootConstrainSelectedInstOperands,
     /* 339060 */   // GIR_Coverage, 5378,
     /* 339060 */   GIR_EraseRootFromParent_Done,
     /* 339061 */ // Label 6650: @339061
     /* 339061 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(339196), // Rule ID 5375 //
     /* 339066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339084 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339087 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339094 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339098 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339100 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 339107 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 339107 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339110 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 339114 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339129 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339136 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339139 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339143 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339162 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339165 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339168 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339171 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339194 */   GIR_RootConstrainSelectedInstOperands,
     /* 339195 */   // GIR_Coverage, 5375,
     /* 339195 */   GIR_EraseRootFromParent_Done,
     /* 339196 */ // Label 6651: @339196
     /* 339196 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(339331), // Rule ID 5376 //
     /* 339201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339219 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339222 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339229 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339235 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 339242 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 339242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 339249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339264 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339303 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339329 */   GIR_RootConstrainSelectedInstOperands,
     /* 339330 */   // GIR_Coverage, 5376,
     /* 339330 */   GIR_EraseRootFromParent_Done,
     /* 339331 */ // Label 6652: @339331
     /* 339331 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(339466), // Rule ID 5379 //
     /* 339336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339357 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339364 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339370 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339377 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 339377 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339380 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339384 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339399 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339406 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339409 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339413 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339441 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339464 */   GIR_RootConstrainSelectedInstOperands,
     /* 339465 */   // GIR_Coverage, 5379,
     /* 339465 */   GIR_EraseRootFromParent_Done,
     /* 339466 */ // Label 6653: @339466
     /* 339466 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(339601), // Rule ID 5380 //
     /* 339471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339489 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339492 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339499 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339505 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339512 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 339512 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339515 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339519 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339534 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339541 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339544 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339548 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339567 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339570 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339573 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339599 */   GIR_RootConstrainSelectedInstOperands,
     /* 339600 */   // GIR_Coverage, 5380,
     /* 339600 */   GIR_EraseRootFromParent_Done,
     /* 339601 */ // Label 6654: @339601
     /* 339601 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(339681), // Rule ID 4823 //
     /* 339606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339624 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339632 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339637 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339643 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339655 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339661 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 339674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339679 */   GIR_RootConstrainSelectedInstOperands,
     /* 339680 */   // GIR_Coverage, 4823,
     /* 339680 */   GIR_EraseRootFromParent_Done,
     /* 339681 */ // Label 6655: @339681
     /* 339681 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(339761), // Rule ID 5368 //
     /* 339686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339712 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339717 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339723 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 339723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339735 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 339741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339759 */   GIR_RootConstrainSelectedInstOperands,
     /* 339760 */   // GIR_Coverage, 5368,
     /* 339760 */   GIR_EraseRootFromParent_Done,
     /* 339761 */ // Label 6656: @339761
     /* 339761 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(339818), // Rule ID 5358 //
     /* 339766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 339784 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 339788 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339790 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 339790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 339797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339802 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339816 */   GIR_RootConstrainSelectedInstOperands,
     /* 339817 */   // GIR_Coverage, 5358,
     /* 339817 */   GIR_EraseRootFromParent_Done,
     /* 339818 */ // Label 6657: @339818
     /* 339818 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(339848), // Rule ID 473 //
     /* 339823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339837 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 339837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 339842 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339846 */   GIR_RootConstrainSelectedInstOperands,
     /* 339847 */   // GIR_Coverage, 473,
     /* 339847 */   GIR_Done,
     /* 339848 */ // Label 6658: @339848
     /* 339848 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(339878), // Rule ID 479 //
     /* 339853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339867 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 339867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 339872 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339876 */   GIR_RootConstrainSelectedInstOperands,
     /* 339877 */   // GIR_Coverage, 479,
     /* 339877 */   GIR_Done,
     /* 339878 */ // Label 6659: @339878
     /* 339878 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(339908), // Rule ID 509 //
     /* 339883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339897 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 339897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 339902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339906 */   GIR_RootConstrainSelectedInstOperands,
     /* 339907 */   // GIR_Coverage, 509,
     /* 339907 */   GIR_Done,
     /* 339908 */ // Label 6660: @339908
     /* 339908 */ GIM_Reject,
     /* 339909 */ // Label 6632: @339909
     /* 339909 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(340046), // Rule ID 5389 //
     /* 339914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339932 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339939 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339945 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 339952 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339952 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339955 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 339959 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339979 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340044 */   GIR_RootConstrainSelectedInstOperands,
     /* 340045 */   // GIR_Coverage, 5389,
     /* 340045 */   GIR_EraseRootFromParent_Done,
     /* 340046 */ // Label 6661: @340046
     /* 340046 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(340183), // Rule ID 5390 //
     /* 340051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340069 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340076 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340082 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 340089 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 340089 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340092 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 340096 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340116 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340123 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340126 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340130 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340149 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340152 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340155 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340181 */   GIR_RootConstrainSelectedInstOperands,
     /* 340182 */   // GIR_Coverage, 5390,
     /* 340182 */   GIR_EraseRootFromParent_Done,
     /* 340183 */ // Label 6662: @340183
     /* 340183 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(340323), // Rule ID 5381 //
     /* 340188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340206 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340209 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340216 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340222 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 340229 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 340229 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340232 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 340236 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340256 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340263 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340266 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340270 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340289 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340292 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340295 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340321 */   GIR_RootConstrainSelectedInstOperands,
     /* 340322 */   // GIR_Coverage, 5381,
     /* 340322 */   GIR_EraseRootFromParent_Done,
     /* 340323 */ // Label 6663: @340323
     /* 340323 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(340463), // Rule ID 5382 //
     /* 340328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340346 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340349 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340356 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340362 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 340369 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 340369 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340372 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 340376 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340396 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340429 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340435 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340448 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340461 */   GIR_RootConstrainSelectedInstOperands,
     /* 340462 */   // GIR_Coverage, 5382,
     /* 340462 */   GIR_EraseRootFromParent_Done,
     /* 340463 */ // Label 6664: @340463
     /* 340463 */ GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(340603), // Rule ID 5385 //
     /* 340468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340486 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340489 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340496 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340502 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340509 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 340509 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340512 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340516 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340536 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340543 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340546 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340550 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340569 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340572 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340575 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340578 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340583 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340601 */   GIR_RootConstrainSelectedInstOperands,
     /* 340602 */   // GIR_Coverage, 5385,
     /* 340602 */   GIR_EraseRootFromParent_Done,
     /* 340603 */ // Label 6665: @340603
     /* 340603 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(340743), // Rule ID 5386 //
     /* 340608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340626 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340629 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340636 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340642 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340649 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 340649 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340652 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340656 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340676 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340683 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340686 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340690 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340709 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340715 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340723 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340728 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340741 */   GIR_RootConstrainSelectedInstOperands,
     /* 340742 */   // GIR_Coverage, 5386,
     /* 340742 */   GIR_EraseRootFromParent_Done,
     /* 340743 */ // Label 6666: @340743
     /* 340743 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(340875), // Rule ID 5391 //
     /* 340748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340766 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340773 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340779 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 340786 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 340786 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340789 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 340793 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340808 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340841 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340844 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340847 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340873 */   GIR_RootConstrainSelectedInstOperands,
     /* 340874 */   // GIR_Coverage, 5391,
     /* 340874 */   GIR_EraseRootFromParent_Done,
     /* 340875 */ // Label 6667: @340875
     /* 340875 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(341007), // Rule ID 5392 //
     /* 340880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340898 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340905 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340911 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 340918 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 340918 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340921 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 340925 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340940 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340947 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340950 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340954 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340973 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340976 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340979 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341005 */   GIR_RootConstrainSelectedInstOperands,
     /* 341006 */   // GIR_Coverage, 5392,
     /* 341006 */   GIR_EraseRootFromParent_Done,
     /* 341007 */ // Label 6668: @341007
     /* 341007 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(341142), // Rule ID 5383 //
     /* 341012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341022 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 341030 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341033 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341040 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 341044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341046 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341053 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 341053 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 341056 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341060 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341075 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 341080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 341082 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341085 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341089 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341111 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341114 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 341117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341140 */   GIR_RootConstrainSelectedInstOperands,
     /* 341141 */   // GIR_Coverage, 5383,
     /* 341141 */   GIR_EraseRootFromParent_Done,
     /* 341142 */ // Label 6669: @341142
     /* 341142 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(341277), // Rule ID 5384 //
     /* 341147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 341165 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341168 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341175 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 341179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341181 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341188 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 341188 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 341191 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341195 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341210 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 341215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 341217 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341220 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341224 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341243 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341246 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341249 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 341252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341257 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341262 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341275 */   GIR_RootConstrainSelectedInstOperands,
     /* 341276 */   // GIR_Coverage, 5384,
     /* 341276 */   GIR_EraseRootFromParent_Done,
     /* 341277 */ // Label 6670: @341277
     /* 341277 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(341412), // Rule ID 5387 //
     /* 341282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 341300 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341303 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 341314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341323 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 341323 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 341326 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341330 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341345 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 341350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 341352 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341355 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341359 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341378 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341381 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341384 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 341387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341410 */   GIR_RootConstrainSelectedInstOperands,
     /* 341411 */   // GIR_Coverage, 5387,
     /* 341411 */   GIR_EraseRootFromParent_Done,
     /* 341412 */ // Label 6671: @341412
     /* 341412 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(341547), // Rule ID 5388 //
     /* 341417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 341435 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341438 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341445 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 341449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341451 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341458 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 341458 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 341461 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341465 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341480 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 341485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 341487 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341490 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341494 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341513 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341516 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 341522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341545 */   GIR_RootConstrainSelectedInstOperands,
     /* 341546 */   // GIR_Coverage, 5388,
     /* 341546 */   GIR_EraseRootFromParent_Done,
     /* 341547 */ // Label 6672: @341547
     /* 341547 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(341627), // Rule ID 4819 //
     /* 341552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 341555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341570 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341574 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341578 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341583 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 341587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341589 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 341589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341601 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 341607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 341620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341625 */   GIR_RootConstrainSelectedInstOperands,
     /* 341626 */   // GIR_Coverage, 4819,
     /* 341626 */   GIR_EraseRootFromParent_Done,
     /* 341627 */ // Label 6673: @341627
     /* 341627 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(341707), // Rule ID 5370 //
     /* 341632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341650 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341654 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341663 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 341667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341669 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 341669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341681 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 341687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341692 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341705 */   GIR_RootConstrainSelectedInstOperands,
     /* 341706 */   // GIR_Coverage, 5370,
     /* 341706 */   GIR_EraseRootFromParent_Done,
     /* 341707 */ // Label 6674: @341707
     /* 341707 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(341764), // Rule ID 5354 //
     /* 341712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 341730 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341734 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341736 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 341736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 341743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341748 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341762 */   GIR_RootConstrainSelectedInstOperands,
     /* 341763 */   // GIR_Coverage, 5354,
     /* 341763 */   GIR_EraseRootFromParent_Done,
     /* 341764 */ // Label 6675: @341764
     /* 341764 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(341794), // Rule ID 475 //
     /* 341769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341783 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 341783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 341788 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341792 */   GIR_RootConstrainSelectedInstOperands,
     /* 341793 */   // GIR_Coverage, 475,
     /* 341793 */   GIR_Done,
     /* 341794 */ // Label 6676: @341794
     /* 341794 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(341824), // Rule ID 481 //
     /* 341799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341813 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 341813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 341818 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341822 */   GIR_RootConstrainSelectedInstOperands,
     /* 341823 */   // GIR_Coverage, 481,
     /* 341823 */   GIR_Done,
     /* 341824 */ // Label 6677: @341824
     /* 341824 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(341854), // Rule ID 505 //
     /* 341829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 341832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341843 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 341843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 341848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341852 */   GIR_RootConstrainSelectedInstOperands,
     /* 341853 */   // GIR_Coverage, 505,
     /* 341853 */   GIR_Done,
     /* 341854 */ // Label 6678: @341854
     /* 341854 */ GIM_Reject,
     /* 341855 */ // Label 6633: @341855
     /* 341855 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(341885), // Rule ID 1082 //
     /* 341860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341874 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 341874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 341879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341883 */   GIR_RootConstrainSelectedInstOperands,
     /* 341884 */   // GIR_Coverage, 1082,
     /* 341884 */   GIR_Done,
     /* 341885 */ // Label 6679: @341885
     /* 341885 */ GIM_Reject,
     /* 341886 */ // Label 6634: @341886
     /* 341886 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(341916), // Rule ID 1086 //
     /* 341891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341905 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 341905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 341910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341914 */   GIR_RootConstrainSelectedInstOperands,
     /* 341915 */   // GIR_Coverage, 1086,
     /* 341915 */   GIR_Done,
     /* 341916 */ // Label 6680: @341916
     /* 341916 */ GIM_Reject,
     /* 341917 */ // Label 6635: @341917
     /* 341917 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(341947), // Rule ID 1078 //
     /* 341922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341936 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 341936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 341941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341945 */   GIR_RootConstrainSelectedInstOperands,
     /* 341946 */   // GIR_Coverage, 1078,
     /* 341946 */   GIR_Done,
     /* 341947 */ // Label 6681: @341947
     /* 341947 */ GIM_Reject,
     /* 341948 */ // Label 6636: @341948
     /* 341948 */ GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(341978), // Rule ID 1084 //
     /* 341953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341967 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 341967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 341972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341976 */   GIR_RootConstrainSelectedInstOperands,
     /* 341977 */   // GIR_Coverage, 1084,
     /* 341977 */   GIR_Done,
     /* 341978 */ // Label 6682: @341978
     /* 341978 */ GIM_Reject,
     /* 341979 */ // Label 6637: @341979
     /* 341979 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(342009), // Rule ID 1080 //
     /* 341984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341998 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 341998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 342003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342007 */   GIR_RootConstrainSelectedInstOperands,
     /* 342008 */   // GIR_Coverage, 1080,
     /* 342008 */   GIR_Done,
     /* 342009 */ // Label 6683: @342009
     /* 342009 */ GIM_Reject,
     /* 342010 */ // Label 6638: @342010
     /* 342010 */ GIM_Reject,
     /* 342011 */ // Label 71: @342011
     /* 342011 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6691*/ GIMT_Encode4(342330),
     /* 342022 */ /*GILLT_s32*//*Label 6684*/ GIMT_Encode4(342058),
     /* 342026 */ /*GILLT_s64*//*Label 6685*/ GIMT_Encode4(342131), GIMT_Encode4(0),
     /* 342034 */ /*GILLT_v2s32*//*Label 6686*/ GIMT_Encode4(342204),
     /* 342038 */ /*GILLT_v2s64*//*Label 6687*/ GIMT_Encode4(342228),
     /* 342042 */ /*GILLT_v4s16*//*Label 6688*/ GIMT_Encode4(342252),
     /* 342046 */ /*GILLT_v4s32*//*Label 6689*/ GIMT_Encode4(342279), GIMT_Encode4(0),
     /* 342054 */ /*GILLT_v8s16*//*Label 6690*/ GIMT_Encode4(342303),
     /* 342058 */ // Label 6684: @342058
     /* 342058 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(342084), // Rule ID 4652 //
     /* 342063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342073 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 342073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 342078 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342082 */   GIR_RootConstrainSelectedInstOperands,
     /* 342083 */   // GIR_Coverage, 4652,
     /* 342083 */   GIR_Done,
     /* 342084 */ // Label 6692: @342084
     /* 342084 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(342107), // Rule ID 4654 //
     /* 342089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342096 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 342096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 342101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342105 */   GIR_RootConstrainSelectedInstOperands,
     /* 342106 */   // GIR_Coverage, 4654,
     /* 342106 */   GIR_Done,
     /* 342107 */ // Label 6693: @342107
     /* 342107 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(342130), // Rule ID 4656 //
     /* 342112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342119 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 342119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 342124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342128 */   GIR_RootConstrainSelectedInstOperands,
     /* 342129 */   // GIR_Coverage, 4656,
     /* 342129 */   GIR_Done,
     /* 342130 */ // Label 6694: @342130
     /* 342130 */ GIM_Reject,
     /* 342131 */ // Label 6685: @342131
     /* 342131 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(342157), // Rule ID 4653 //
     /* 342136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342146 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 342146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 342151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342155 */   GIR_RootConstrainSelectedInstOperands,
     /* 342156 */   // GIR_Coverage, 4653,
     /* 342156 */   GIR_Done,
     /* 342157 */ // Label 6695: @342157
     /* 342157 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(342180), // Rule ID 4655 //
     /* 342162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342169 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 342169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 342174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342178 */   GIR_RootConstrainSelectedInstOperands,
     /* 342179 */   // GIR_Coverage, 4655,
     /* 342179 */   GIR_Done,
     /* 342180 */ // Label 6696: @342180
     /* 342180 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(342203), // Rule ID 4657 //
     /* 342185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342192 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 342192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 342197 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342201 */   GIR_RootConstrainSelectedInstOperands,
     /* 342202 */   // GIR_Coverage, 4657,
     /* 342202 */   GIR_Done,
     /* 342203 */ // Label 6697: @342203
     /* 342203 */ GIM_Reject,
     /* 342204 */ // Label 6686: @342204
     /* 342204 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(342227), // Rule ID 4993 //
     /* 342209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342216 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 342216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 342221 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342225 */   GIR_RootConstrainSelectedInstOperands,
     /* 342226 */   // GIR_Coverage, 4993,
     /* 342226 */   GIR_Done,
     /* 342227 */ // Label 6698: @342227
     /* 342227 */ GIM_Reject,
     /* 342228 */ // Label 6687: @342228
     /* 342228 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(342251), // Rule ID 4995 //
     /* 342233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342240 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 342240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 342245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342249 */   GIR_RootConstrainSelectedInstOperands,
     /* 342250 */   // GIR_Coverage, 4995,
     /* 342250 */   GIR_Done,
     /* 342251 */ // Label 6699: @342251
     /* 342251 */ GIM_Reject,
     /* 342252 */ // Label 6688: @342252
     /* 342252 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(342278), // Rule ID 4988 //
     /* 342257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342267 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 342267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 342272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342276 */   GIR_RootConstrainSelectedInstOperands,
     /* 342277 */   // GIR_Coverage, 4988,
     /* 342277 */   GIR_Done,
     /* 342278 */ // Label 6700: @342278
     /* 342278 */ GIM_Reject,
     /* 342279 */ // Label 6689: @342279
     /* 342279 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(342302), // Rule ID 4994 //
     /* 342284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342291 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 342291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 342296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342300 */   GIR_RootConstrainSelectedInstOperands,
     /* 342301 */   // GIR_Coverage, 4994,
     /* 342301 */   GIR_Done,
     /* 342302 */ // Label 6701: @342302
     /* 342302 */ GIM_Reject,
     /* 342303 */ // Label 6690: @342303
     /* 342303 */ GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(342329), // Rule ID 4989 //
     /* 342308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342318 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 342318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 342323 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342327 */   GIR_RootConstrainSelectedInstOperands,
     /* 342328 */   // GIR_Coverage, 4989,
     /* 342328 */   GIR_Done,
     /* 342329 */ // Label 6702: @342329
     /* 342329 */ GIM_Reject,
     /* 342330 */ // Label 6691: @342330
     /* 342330 */ GIM_Reject,
     /* 342331 */ // Label 72: @342331
     /* 342331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6710*/ GIMT_Encode4(342650),
     /* 342342 */ /*GILLT_s32*//*Label 6703*/ GIMT_Encode4(342378),
     /* 342346 */ /*GILLT_s64*//*Label 6704*/ GIMT_Encode4(342451), GIMT_Encode4(0),
     /* 342354 */ /*GILLT_v2s32*//*Label 6705*/ GIMT_Encode4(342524),
     /* 342358 */ /*GILLT_v2s64*//*Label 6706*/ GIMT_Encode4(342548),
     /* 342362 */ /*GILLT_v4s16*//*Label 6707*/ GIMT_Encode4(342572),
     /* 342366 */ /*GILLT_v4s32*//*Label 6708*/ GIMT_Encode4(342599), GIMT_Encode4(0),
     /* 342374 */ /*GILLT_v8s16*//*Label 6709*/ GIMT_Encode4(342623),
     /* 342378 */ // Label 6703: @342378
     /* 342378 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(342404), // Rule ID 4676 //
     /* 342383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342393 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 342393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 342398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342402 */   GIR_RootConstrainSelectedInstOperands,
     /* 342403 */   // GIR_Coverage, 4676,
     /* 342403 */   GIR_Done,
     /* 342404 */ // Label 6711: @342404
     /* 342404 */ GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(342427), // Rule ID 4678 //
     /* 342409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342416 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 342416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 342421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342425 */   GIR_RootConstrainSelectedInstOperands,
     /* 342426 */   // GIR_Coverage, 4678,
     /* 342426 */   GIR_Done,
     /* 342427 */ // Label 6712: @342427
     /* 342427 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(342450), // Rule ID 4680 //
     /* 342432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342439 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 342439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 342444 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342448 */   GIR_RootConstrainSelectedInstOperands,
     /* 342449 */   // GIR_Coverage, 4680,
     /* 342449 */   GIR_Done,
     /* 342450 */ // Label 6713: @342450
     /* 342450 */ GIM_Reject,
     /* 342451 */ // Label 6704: @342451
     /* 342451 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(342477), // Rule ID 4677 //
     /* 342456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342466 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 342466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 342471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342475 */   GIR_RootConstrainSelectedInstOperands,
     /* 342476 */   // GIR_Coverage, 4677,
     /* 342476 */   GIR_Done,
     /* 342477 */ // Label 6714: @342477
     /* 342477 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(342500), // Rule ID 4679 //
     /* 342482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342489 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 342489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 342494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342498 */   GIR_RootConstrainSelectedInstOperands,
     /* 342499 */   // GIR_Coverage, 4679,
     /* 342499 */   GIR_Done,
     /* 342500 */ // Label 6715: @342500
     /* 342500 */ GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(342523), // Rule ID 4681 //
     /* 342505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342512 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 342512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 342517 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342521 */   GIR_RootConstrainSelectedInstOperands,
     /* 342522 */   // GIR_Coverage, 4681,
     /* 342522 */   GIR_Done,
     /* 342523 */ // Label 6716: @342523
     /* 342523 */ GIM_Reject,
     /* 342524 */ // Label 6705: @342524
     /* 342524 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(342547), // Rule ID 5003 //
     /* 342529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342536 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 342536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 342541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342545 */   GIR_RootConstrainSelectedInstOperands,
     /* 342546 */   // GIR_Coverage, 5003,
     /* 342546 */   GIR_Done,
     /* 342547 */ // Label 6717: @342547
     /* 342547 */ GIM_Reject,
     /* 342548 */ // Label 6706: @342548
     /* 342548 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(342571), // Rule ID 5005 //
     /* 342553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342560 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 342560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 342565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342569 */   GIR_RootConstrainSelectedInstOperands,
     /* 342570 */   // GIR_Coverage, 5005,
     /* 342570 */   GIR_Done,
     /* 342571 */ // Label 6718: @342571
     /* 342571 */ GIM_Reject,
     /* 342572 */ // Label 6707: @342572
     /* 342572 */ GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(342598), // Rule ID 4998 //
     /* 342577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342587 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 342587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 342592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342596 */   GIR_RootConstrainSelectedInstOperands,
     /* 342597 */   // GIR_Coverage, 4998,
     /* 342597 */   GIR_Done,
     /* 342598 */ // Label 6719: @342598
     /* 342598 */ GIM_Reject,
     /* 342599 */ // Label 6708: @342599
     /* 342599 */ GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(342622), // Rule ID 5004 //
     /* 342604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342611 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 342611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 342616 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342620 */   GIR_RootConstrainSelectedInstOperands,
     /* 342621 */   // GIR_Coverage, 5004,
     /* 342621 */   GIR_Done,
     /* 342622 */ // Label 6720: @342622
     /* 342622 */ GIM_Reject,
     /* 342623 */ // Label 6709: @342623
     /* 342623 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(342649), // Rule ID 4999 //
     /* 342628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342638 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 342638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 342643 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342647 */   GIR_RootConstrainSelectedInstOperands,
     /* 342648 */   // GIR_Coverage, 4999,
     /* 342648 */   GIR_Done,
     /* 342649 */ // Label 6721: @342649
     /* 342649 */ GIM_Reject,
     /* 342650 */ // Label 6710: @342650
     /* 342650 */ GIM_Reject,
     /* 342651 */ // Label 73: @342651
     /* 342651 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6730*/ GIMT_Encode4(343507),
     /* 342662 */ /*GILLT_s16*//*Label 6722*/ GIMT_Encode4(342702),
     /* 342666 */ /*GILLT_s32*//*Label 6723*/ GIMT_Encode4(342921),
     /* 342670 */ /*GILLT_s64*//*Label 6724*/ GIMT_Encode4(342995), GIMT_Encode4(0),
     /* 342678 */ /*GILLT_v2s32*//*Label 6725*/ GIMT_Encode4(343069),
     /* 342682 */ /*GILLT_v2s64*//*Label 6726*/ GIMT_Encode4(343143),
     /* 342686 */ /*GILLT_v4s16*//*Label 6727*/ GIMT_Encode4(343217),
     /* 342690 */ /*GILLT_v4s32*//*Label 6728*/ GIMT_Encode4(343325), GIMT_Encode4(0),
     /* 342698 */ /*GILLT_v8s16*//*Label 6729*/ GIMT_Encode4(343399),
     /* 342702 */ // Label 6722: @342702
     /* 342702 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(342920),
     /* 342707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342714 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(342755), // Rule ID 5256 //
     /* 342719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342740 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 342740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 342743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342753 */     GIR_RootConstrainSelectedInstOperands,
     /* 342754 */     // GIR_Coverage, 5256,
     /* 342754 */     GIR_EraseRootFromParent_Done,
     /* 342755 */   // Label 6732: @342755
     /* 342755 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(342774), // Rule ID 525 //
     /* 342760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342767 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 342767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 342772 */     GIR_RootConstrainSelectedInstOperands,
     /* 342773 */     // GIR_Coverage, 525,
     /* 342773 */     GIR_Done,
     /* 342774 */   // Label 6733: @342774
     /* 342774 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(342919), // Rule ID 6442 //
     /* 342779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342783 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 342783 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 342786 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342790 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 342797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 342800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342809 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 342812 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 342816 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 342819 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342824 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342829 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 342837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342846 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 342849 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 342857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 342861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 342869 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 342874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 342908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342918 */     // GIR_Coverage, 6442,
     /* 342918 */     GIR_EraseRootFromParent_Done,
     /* 342919 */   // Label 6734: @342919
     /* 342919 */   GIM_Reject,
     /* 342920 */ // Label 6731: @342920
     /* 342920 */ GIM_Reject,
     /* 342921 */ // Label 6723: @342921
     /* 342921 */ GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(342994),
     /* 342926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342933 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(342974), // Rule ID 5257 //
     /* 342938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 342953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 342957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342959 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 342959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 342962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342972 */     GIR_RootConstrainSelectedInstOperands,
     /* 342973 */     // GIR_Coverage, 5257,
     /* 342973 */     GIR_EraseRootFromParent_Done,
     /* 342974 */   // Label 6736: @342974
     /* 342974 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(342993), // Rule ID 526 //
     /* 342979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342986 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 342986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 342991 */     GIR_RootConstrainSelectedInstOperands,
     /* 342992 */     // GIR_Coverage, 526,
     /* 342992 */     GIR_Done,
     /* 342993 */   // Label 6737: @342993
     /* 342993 */   GIM_Reject,
     /* 342994 */ // Label 6735: @342994
     /* 342994 */ GIM_Reject,
     /* 342995 */ // Label 6724: @342995
     /* 342995 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(343068),
     /* 343000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343007 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(343048), // Rule ID 5258 //
     /* 343012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 343027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343033 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 343033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 343036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343046 */     GIR_RootConstrainSelectedInstOperands,
     /* 343047 */     // GIR_Coverage, 5258,
     /* 343047 */     GIR_EraseRootFromParent_Done,
     /* 343048 */   // Label 6739: @343048
     /* 343048 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(343067), // Rule ID 527 //
     /* 343053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343060 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 343060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 343065 */     GIR_RootConstrainSelectedInstOperands,
     /* 343066 */     // GIR_Coverage, 527,
     /* 343066 */     GIR_Done,
     /* 343067 */   // Label 6740: @343067
     /* 343067 */   GIM_Reject,
     /* 343068 */ // Label 6738: @343068
     /* 343068 */ GIM_Reject,
     /* 343069 */ // Label 6725: @343069
     /* 343069 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(343142),
     /* 343074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343081 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(343122), // Rule ID 5070 //
     /* 343086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343107 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 343107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 343110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343120 */     GIR_RootConstrainSelectedInstOperands,
     /* 343121 */     // GIR_Coverage, 5070,
     /* 343121 */     GIR_EraseRootFromParent_Done,
     /* 343122 */   // Label 6742: @343122
     /* 343122 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(343141), // Rule ID 772 //
     /* 343127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343134 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 343134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 343139 */     GIR_RootConstrainSelectedInstOperands,
     /* 343140 */     // GIR_Coverage, 772,
     /* 343140 */     GIR_Done,
     /* 343141 */   // Label 6743: @343141
     /* 343141 */   GIM_Reject,
     /* 343142 */ // Label 6741: @343142
     /* 343142 */ GIM_Reject,
     /* 343143 */ // Label 6726: @343143
     /* 343143 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(343216),
     /* 343148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343155 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(343196), // Rule ID 5072 //
     /* 343160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343181 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 343181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 343184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343194 */     GIR_RootConstrainSelectedInstOperands,
     /* 343195 */     // GIR_Coverage, 5072,
     /* 343195 */     GIR_EraseRootFromParent_Done,
     /* 343196 */   // Label 6745: @343196
     /* 343196 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(343215), // Rule ID 774 //
     /* 343201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343208 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 343208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 343213 */     GIR_RootConstrainSelectedInstOperands,
     /* 343214 */     // GIR_Coverage, 774,
     /* 343214 */     GIR_Done,
     /* 343215 */   // Label 6746: @343215
     /* 343215 */   GIM_Reject,
     /* 343216 */ // Label 6744: @343216
     /* 343216 */ GIM_Reject,
     /* 343217 */ // Label 6727: @343217
     /* 343217 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(343324),
     /* 343222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343229 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(343270), // Rule ID 5073 //
     /* 343234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343255 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 343255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 343258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343268 */     GIR_RootConstrainSelectedInstOperands,
     /* 343269 */     // GIR_Coverage, 5073,
     /* 343269 */     GIR_EraseRootFromParent_Done,
     /* 343270 */   // Label 6748: @343270
     /* 343270 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(343289), // Rule ID 770 //
     /* 343275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343282 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 343282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 343287 */     GIR_RootConstrainSelectedInstOperands,
     /* 343288 */     // GIR_Coverage, 770,
     /* 343288 */     GIR_Done,
     /* 343289 */   // Label 6749: @343289
     /* 343289 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(343323), // Rule ID 6444 //
     /* 343294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343301 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 343301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 343304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343308 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 343318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 343321 */     GIR_RootConstrainSelectedInstOperands,
     /* 343322 */     // GIR_Coverage, 6444,
     /* 343322 */     GIR_EraseRootFromParent_Done,
     /* 343323 */   // Label 6750: @343323
     /* 343323 */   GIM_Reject,
     /* 343324 */ // Label 6747: @343324
     /* 343324 */ GIM_Reject,
     /* 343325 */ // Label 6728: @343325
     /* 343325 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(343398),
     /* 343330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343337 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(343378), // Rule ID 5071 //
     /* 343342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343363 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 343363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 343366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343376 */     GIR_RootConstrainSelectedInstOperands,
     /* 343377 */     // GIR_Coverage, 5071,
     /* 343377 */     GIR_EraseRootFromParent_Done,
     /* 343378 */   // Label 6752: @343378
     /* 343378 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(343397), // Rule ID 773 //
     /* 343383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343390 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 343390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 343395 */     GIR_RootConstrainSelectedInstOperands,
     /* 343396 */     // GIR_Coverage, 773,
     /* 343396 */     GIR_Done,
     /* 343397 */   // Label 6753: @343397
     /* 343397 */   GIM_Reject,
     /* 343398 */ // Label 6751: @343398
     /* 343398 */ GIM_Reject,
     /* 343399 */ // Label 6729: @343399
     /* 343399 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(343506),
     /* 343404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343411 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(343452), // Rule ID 5074 //
     /* 343416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343437 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 343437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 343440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343450 */     GIR_RootConstrainSelectedInstOperands,
     /* 343451 */     // GIR_Coverage, 5074,
     /* 343451 */     GIR_EraseRootFromParent_Done,
     /* 343452 */   // Label 6755: @343452
     /* 343452 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(343471), // Rule ID 771 //
     /* 343457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343464 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 343464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 343469 */     GIR_RootConstrainSelectedInstOperands,
     /* 343470 */     // GIR_Coverage, 771,
     /* 343470 */     GIR_Done,
     /* 343471 */   // Label 6756: @343471
     /* 343471 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(343505), // Rule ID 6445 //
     /* 343476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343483 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 343483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 343486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343490 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 343500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 343503 */     GIR_RootConstrainSelectedInstOperands,
     /* 343504 */     // GIR_Coverage, 6445,
     /* 343504 */     GIR_EraseRootFromParent_Done,
     /* 343505 */   // Label 6757: @343505
     /* 343505 */   GIM_Reject,
     /* 343506 */ // Label 6754: @343506
     /* 343506 */ GIM_Reject,
     /* 343507 */ // Label 6730: @343507
     /* 343507 */ GIM_Reject,
     /* 343508 */ // Label 74: @343508
     /* 343508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6766*/ GIMT_Encode4(343789),
     /* 343519 */ /*GILLT_s16*//*Label 6758*/ GIMT_Encode4(343559),
     /* 343523 */ /*GILLT_s32*//*Label 6759*/ GIMT_Encode4(343586),
     /* 343527 */ /*GILLT_s64*//*Label 6760*/ GIMT_Encode4(343610), GIMT_Encode4(0),
     /* 343535 */ /*GILLT_v2s32*//*Label 6761*/ GIMT_Encode4(343634),
     /* 343539 */ /*GILLT_v2s64*//*Label 6762*/ GIMT_Encode4(343665),
     /* 343543 */ /*GILLT_v4s16*//*Label 6763*/ GIMT_Encode4(343696),
     /* 343547 */ /*GILLT_v4s32*//*Label 6764*/ GIMT_Encode4(343727), GIMT_Encode4(0),
     /* 343555 */ /*GILLT_v8s16*//*Label 6765*/ GIMT_Encode4(343758),
     /* 343559 */ // Label 6758: @343559
     /* 343559 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(343585), // Rule ID 4892 //
     /* 343564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343574 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 343574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343579 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343581 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343583 */   GIR_RootConstrainSelectedInstOperands,
     /* 343584 */   // GIR_Coverage, 4892,
     /* 343584 */   GIR_EraseRootFromParent_Done,
     /* 343585 */ // Label 6767: @343585
     /* 343585 */ GIM_Reject,
     /* 343586 */ // Label 6759: @343586
     /* 343586 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(343609), // Rule ID 4889 //
     /* 343591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343598 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 343598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343603 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343605 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343607 */   GIR_RootConstrainSelectedInstOperands,
     /* 343608 */   // GIR_Coverage, 4889,
     /* 343608 */   GIR_EraseRootFromParent_Done,
     /* 343609 */ // Label 6768: @343609
     /* 343609 */ GIM_Reject,
     /* 343610 */ // Label 6760: @343610
     /* 343610 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(343633), // Rule ID 4886 //
     /* 343615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343622 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 343622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343627 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343629 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343631 */   GIR_RootConstrainSelectedInstOperands,
     /* 343632 */   // GIR_Coverage, 4886,
     /* 343632 */   GIR_EraseRootFromParent_Done,
     /* 343633 */ // Label 6769: @343633
     /* 343633 */ GIM_Reject,
     /* 343634 */ // Label 6761: @343634
     /* 343634 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(343664), // Rule ID 5083 //
     /* 343639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343653 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 343653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343658 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343660 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343662 */   GIR_RootConstrainSelectedInstOperands,
     /* 343663 */   // GIR_Coverage, 5083,
     /* 343663 */   GIR_EraseRootFromParent_Done,
     /* 343664 */ // Label 6770: @343664
     /* 343664 */ GIM_Reject,
     /* 343665 */ // Label 6762: @343665
     /* 343665 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(343695), // Rule ID 5077 //
     /* 343670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343684 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 343684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343691 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343693 */   GIR_RootConstrainSelectedInstOperands,
     /* 343694 */   // GIR_Coverage, 5077,
     /* 343694 */   GIR_EraseRootFromParent_Done,
     /* 343695 */ // Label 6771: @343695
     /* 343695 */ GIM_Reject,
     /* 343696 */ // Label 6763: @343696
     /* 343696 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(343726), // Rule ID 5089 //
     /* 343701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343715 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 343715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343722 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343724 */   GIR_RootConstrainSelectedInstOperands,
     /* 343725 */   // GIR_Coverage, 5089,
     /* 343725 */   GIR_EraseRootFromParent_Done,
     /* 343726 */ // Label 6772: @343726
     /* 343726 */ GIM_Reject,
     /* 343727 */ // Label 6764: @343727
     /* 343727 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(343757), // Rule ID 5080 //
     /* 343732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343746 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 343746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343751 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343755 */   GIR_RootConstrainSelectedInstOperands,
     /* 343756 */   // GIR_Coverage, 5080,
     /* 343756 */   GIR_EraseRootFromParent_Done,
     /* 343757 */ // Label 6773: @343757
     /* 343757 */ GIM_Reject,
     /* 343758 */ // Label 6765: @343758
     /* 343758 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(343788), // Rule ID 5086 //
     /* 343763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343777 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 343777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343782 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343784 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343786 */   GIR_RootConstrainSelectedInstOperands,
     /* 343787 */   // GIR_Coverage, 5086,
     /* 343787 */   GIR_EraseRootFromParent_Done,
     /* 343788 */ // Label 6774: @343788
     /* 343788 */ GIM_Reject,
     /* 343789 */ // Label 6766: @343789
     /* 343789 */ GIM_Reject,
     /* 343790 */ // Label 75: @343790
     /* 343790 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6783*/ GIMT_Encode4(344167),
     /* 343801 */ /*GILLT_s16*//*Label 6775*/ GIMT_Encode4(343841),
     /* 343805 */ /*GILLT_s32*//*Label 6776*/ GIMT_Encode4(343879),
     /* 343809 */ /*GILLT_s64*//*Label 6777*/ GIMT_Encode4(343917), GIMT_Encode4(0),
     /* 343817 */ /*GILLT_v2s32*//*Label 6778*/ GIMT_Encode4(343977),
     /* 343821 */ /*GILLT_v2s64*//*Label 6779*/ GIMT_Encode4(344015),
     /* 343825 */ /*GILLT_v4s16*//*Label 6780*/ GIMT_Encode4(344053),
     /* 343829 */ /*GILLT_v4s32*//*Label 6781*/ GIMT_Encode4(344091), GIMT_Encode4(0),
     /* 343837 */ /*GILLT_v8s16*//*Label 6782*/ GIMT_Encode4(344129),
     /* 343841 */ // Label 6775: @343841
     /* 343841 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(343878), // Rule ID 612 //
     /* 343846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343867 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343872 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343876 */   GIR_RootConstrainSelectedInstOperands,
     /* 343877 */   // GIR_Coverage, 612,
     /* 343877 */   GIR_Done,
     /* 343878 */ // Label 6784: @343878
     /* 343878 */ GIM_Reject,
     /* 343879 */ // Label 6776: @343879
     /* 343879 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(343916), // Rule ID 614 //
     /* 343884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343905 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343914 */   GIR_RootConstrainSelectedInstOperands,
     /* 343915 */   // GIR_Coverage, 614,
     /* 343915 */   GIR_Done,
     /* 343916 */ // Label 6785: @343916
     /* 343916 */ GIM_Reject,
     /* 343917 */ // Label 6777: @343917
     /* 343917 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(343976),
     /* 343922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343940 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(343959), // Rule ID 616 //
     /* 343945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343948 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343957 */     GIR_RootConstrainSelectedInstOperands,
     /* 343958 */     // GIR_Coverage, 616,
     /* 343958 */     GIR_Done,
     /* 343959 */   // Label 6787: @343959
     /* 343959 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(343975), // Rule ID 4883 //
     /* 343964 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343969 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343973 */     GIR_RootConstrainSelectedInstOperands,
     /* 343974 */     // GIR_Coverage, 4883,
     /* 343974 */     GIR_Done,
     /* 343975 */   // Label 6788: @343975
     /* 343975 */   GIM_Reject,
     /* 343976 */ // Label 6786: @343976
     /* 343976 */ GIM_Reject,
     /* 343977 */ // Label 6778: @343977
     /* 343977 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(344014), // Rule ID 1277 //
     /* 343982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344003 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 344008 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344012 */   GIR_RootConstrainSelectedInstOperands,
     /* 344013 */   // GIR_Coverage, 1277,
     /* 344013 */   GIR_Done,
     /* 344014 */ // Label 6789: @344014
     /* 344014 */ GIM_Reject,
     /* 344015 */ // Label 6779: @344015
     /* 344015 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(344052), // Rule ID 1281 //
     /* 344020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344041 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 344046 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344050 */   GIR_RootConstrainSelectedInstOperands,
     /* 344051 */   // GIR_Coverage, 1281,
     /* 344051 */   GIR_Done,
     /* 344052 */ // Label 6790: @344052
     /* 344052 */ GIM_Reject,
     /* 344053 */ // Label 6780: @344053
     /* 344053 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(344090), // Rule ID 1273 //
     /* 344058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344079 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 344084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344088 */   GIR_RootConstrainSelectedInstOperands,
     /* 344089 */   // GIR_Coverage, 1273,
     /* 344089 */   GIR_Done,
     /* 344090 */ // Label 6791: @344090
     /* 344090 */ GIM_Reject,
     /* 344091 */ // Label 6781: @344091
     /* 344091 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(344128), // Rule ID 1279 //
     /* 344096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344117 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 344122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344126 */   GIR_RootConstrainSelectedInstOperands,
     /* 344127 */   // GIR_Coverage, 1279,
     /* 344127 */   GIR_Done,
     /* 344128 */ // Label 6792: @344128
     /* 344128 */ GIM_Reject,
     /* 344129 */ // Label 6782: @344129
     /* 344129 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(344166), // Rule ID 1275 //
     /* 344134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344155 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 344160 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344164 */   GIR_RootConstrainSelectedInstOperands,
     /* 344165 */   // GIR_Coverage, 1275,
     /* 344165 */   GIR_Done,
     /* 344166 */ // Label 6793: @344166
     /* 344166 */ GIM_Reject,
     /* 344167 */ // Label 6783: @344167
     /* 344167 */ GIM_Reject,
     /* 344168 */ // Label 76: @344168
     /* 344168 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6802*/ GIMT_Encode4(344545),
     /* 344179 */ /*GILLT_s16*//*Label 6794*/ GIMT_Encode4(344219),
     /* 344183 */ /*GILLT_s32*//*Label 6795*/ GIMT_Encode4(344257),
     /* 344187 */ /*GILLT_s64*//*Label 6796*/ GIMT_Encode4(344295), GIMT_Encode4(0),
     /* 344195 */ /*GILLT_v2s32*//*Label 6797*/ GIMT_Encode4(344355),
     /* 344199 */ /*GILLT_v2s64*//*Label 6798*/ GIMT_Encode4(344393),
     /* 344203 */ /*GILLT_v4s16*//*Label 6799*/ GIMT_Encode4(344431),
     /* 344207 */ /*GILLT_v4s32*//*Label 6800*/ GIMT_Encode4(344469), GIMT_Encode4(0),
     /* 344215 */ /*GILLT_v8s16*//*Label 6801*/ GIMT_Encode4(344507),
     /* 344219 */ // Label 6794: @344219
     /* 344219 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(344256), // Rule ID 600 //
     /* 344224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344245 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 344250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344254 */   GIR_RootConstrainSelectedInstOperands,
     /* 344255 */   // GIR_Coverage, 600,
     /* 344255 */   GIR_Done,
     /* 344256 */ // Label 6803: @344256
     /* 344256 */ GIM_Reject,
     /* 344257 */ // Label 6795: @344257
     /* 344257 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(344294), // Rule ID 602 //
     /* 344262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344283 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 344288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344292 */   GIR_RootConstrainSelectedInstOperands,
     /* 344293 */   // GIR_Coverage, 602,
     /* 344293 */   GIR_Done,
     /* 344294 */ // Label 6804: @344294
     /* 344294 */ GIM_Reject,
     /* 344295 */ // Label 6796: @344295
     /* 344295 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(344354),
     /* 344300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344318 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(344337), // Rule ID 604 //
     /* 344323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344326 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 344326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 344331 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344335 */     GIR_RootConstrainSelectedInstOperands,
     /* 344336 */     // GIR_Coverage, 604,
     /* 344336 */     GIR_Done,
     /* 344337 */   // Label 6806: @344337
     /* 344337 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(344353), // Rule ID 4882 //
     /* 344342 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 344342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 344347 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344351 */     GIR_RootConstrainSelectedInstOperands,
     /* 344352 */     // GIR_Coverage, 4882,
     /* 344352 */     GIR_Done,
     /* 344353 */   // Label 6807: @344353
     /* 344353 */   GIM_Reject,
     /* 344354 */ // Label 6805: @344354
     /* 344354 */ GIM_Reject,
     /* 344355 */ // Label 6797: @344355
     /* 344355 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(344392), // Rule ID 1247 //
     /* 344360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344381 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 344386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344390 */   GIR_RootConstrainSelectedInstOperands,
     /* 344391 */   // GIR_Coverage, 1247,
     /* 344391 */   GIR_Done,
     /* 344392 */ // Label 6808: @344392
     /* 344392 */ GIM_Reject,
     /* 344393 */ // Label 6798: @344393
     /* 344393 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(344430), // Rule ID 1251 //
     /* 344398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344419 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 344424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344428 */   GIR_RootConstrainSelectedInstOperands,
     /* 344429 */   // GIR_Coverage, 1251,
     /* 344429 */   GIR_Done,
     /* 344430 */ // Label 6809: @344430
     /* 344430 */ GIM_Reject,
     /* 344431 */ // Label 6799: @344431
     /* 344431 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(344468), // Rule ID 1243 //
     /* 344436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344457 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 344462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344466 */   GIR_RootConstrainSelectedInstOperands,
     /* 344467 */   // GIR_Coverage, 1243,
     /* 344467 */   GIR_Done,
     /* 344468 */ // Label 6810: @344468
     /* 344468 */ GIM_Reject,
     /* 344469 */ // Label 6800: @344469
     /* 344469 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(344506), // Rule ID 1249 //
     /* 344474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344495 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 344500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344504 */   GIR_RootConstrainSelectedInstOperands,
     /* 344505 */   // GIR_Coverage, 1249,
     /* 344505 */   GIR_Done,
     /* 344506 */ // Label 6811: @344506
     /* 344506 */ GIM_Reject,
     /* 344507 */ // Label 6801: @344507
     /* 344507 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(344544), // Rule ID 1245 //
     /* 344512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344533 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 344538 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344542 */   GIR_RootConstrainSelectedInstOperands,
     /* 344543 */   // GIR_Coverage, 1245,
     /* 344543 */   GIR_Done,
     /* 344544 */ // Label 6812: @344544
     /* 344544 */ GIM_Reject,
     /* 344545 */ // Label 6802: @344545
     /* 344545 */ GIM_Reject,
     /* 344546 */ // Label 77: @344546
     /* 344546 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6821*/ GIMT_Encode4(344895),
     /* 344557 */ /*GILLT_s16*//*Label 6813*/ GIMT_Encode4(344597),
     /* 344561 */ /*GILLT_s32*//*Label 6814*/ GIMT_Encode4(344635),
     /* 344565 */ /*GILLT_s64*//*Label 6815*/ GIMT_Encode4(344670), GIMT_Encode4(0),
     /* 344573 */ /*GILLT_v2s32*//*Label 6816*/ GIMT_Encode4(344705),
     /* 344577 */ /*GILLT_v2s64*//*Label 6817*/ GIMT_Encode4(344743),
     /* 344581 */ /*GILLT_v4s16*//*Label 6818*/ GIMT_Encode4(344781),
     /* 344585 */ /*GILLT_v4s32*//*Label 6819*/ GIMT_Encode4(344819), GIMT_Encode4(0),
     /* 344593 */ /*GILLT_v8s16*//*Label 6820*/ GIMT_Encode4(344857),
     /* 344597 */ // Label 6813: @344597
     /* 344597 */ GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(344634), // Rule ID 4890 //
     /* 344602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344623 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 344623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 344628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344632 */   GIR_RootConstrainSelectedInstOperands,
     /* 344633 */   // GIR_Coverage, 4890,
     /* 344633 */   GIR_Done,
     /* 344634 */ // Label 6822: @344634
     /* 344634 */ GIM_Reject,
     /* 344635 */ // Label 6814: @344635
     /* 344635 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(344669), // Rule ID 4887 //
     /* 344640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344658 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 344658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 344663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344667 */   GIR_RootConstrainSelectedInstOperands,
     /* 344668 */   // GIR_Coverage, 4887,
     /* 344668 */   GIR_Done,
     /* 344669 */ // Label 6823: @344669
     /* 344669 */ GIM_Reject,
     /* 344670 */ // Label 6815: @344670
     /* 344670 */ GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(344704), // Rule ID 4884 //
     /* 344675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344693 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 344693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 344698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344702 */   GIR_RootConstrainSelectedInstOperands,
     /* 344703 */   // GIR_Coverage, 4884,
     /* 344703 */   GIR_Done,
     /* 344704 */ // Label 6824: @344704
     /* 344704 */ GIM_Reject,
     /* 344705 */ // Label 6816: @344705
     /* 344705 */ GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(344742), // Rule ID 5081 //
     /* 344710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344731 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 344736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344740 */   GIR_RootConstrainSelectedInstOperands,
     /* 344741 */   // GIR_Coverage, 5081,
     /* 344741 */   GIR_Done,
     /* 344742 */ // Label 6825: @344742
     /* 344742 */ GIM_Reject,
     /* 344743 */ // Label 6817: @344743
     /* 344743 */ GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(344780), // Rule ID 5075 //
     /* 344748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344769 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 344774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344778 */   GIR_RootConstrainSelectedInstOperands,
     /* 344779 */   // GIR_Coverage, 5075,
     /* 344779 */   GIR_Done,
     /* 344780 */ // Label 6826: @344780
     /* 344780 */ GIM_Reject,
     /* 344781 */ // Label 6818: @344781
     /* 344781 */ GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(344818), // Rule ID 5087 //
     /* 344786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344807 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 344812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344816 */   GIR_RootConstrainSelectedInstOperands,
     /* 344817 */   // GIR_Coverage, 5087,
     /* 344817 */   GIR_Done,
     /* 344818 */ // Label 6827: @344818
     /* 344818 */ GIM_Reject,
     /* 344819 */ // Label 6819: @344819
     /* 344819 */ GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(344856), // Rule ID 5078 //
     /* 344824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344845 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 344850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344854 */   GIR_RootConstrainSelectedInstOperands,
     /* 344855 */   // GIR_Coverage, 5078,
     /* 344855 */   GIR_Done,
     /* 344856 */ // Label 6828: @344856
     /* 344856 */ GIM_Reject,
     /* 344857 */ // Label 6820: @344857
     /* 344857 */ GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(344894), // Rule ID 5084 //
     /* 344862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344883 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 344888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344892 */   GIR_RootConstrainSelectedInstOperands,
     /* 344893 */   // GIR_Coverage, 5084,
     /* 344893 */   GIR_Done,
     /* 344894 */ // Label 6829: @344894
     /* 344894 */ GIM_Reject,
     /* 344895 */ // Label 6821: @344895
     /* 344895 */ GIM_Reject,
     /* 344896 */ // Label 78: @344896
     /* 344896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6838*/ GIMT_Encode4(345245),
     /* 344907 */ /*GILLT_s16*//*Label 6830*/ GIMT_Encode4(344947),
     /* 344911 */ /*GILLT_s32*//*Label 6831*/ GIMT_Encode4(344985),
     /* 344915 */ /*GILLT_s64*//*Label 6832*/ GIMT_Encode4(345020), GIMT_Encode4(0),
     /* 344923 */ /*GILLT_v2s32*//*Label 6833*/ GIMT_Encode4(345055),
     /* 344927 */ /*GILLT_v2s64*//*Label 6834*/ GIMT_Encode4(345093),
     /* 344931 */ /*GILLT_v4s16*//*Label 6835*/ GIMT_Encode4(345131),
     /* 344935 */ /*GILLT_v4s32*//*Label 6836*/ GIMT_Encode4(345169), GIMT_Encode4(0),
     /* 344943 */ /*GILLT_v8s16*//*Label 6837*/ GIMT_Encode4(345207),
     /* 344947 */ // Label 6830: @344947
     /* 344947 */ GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(344984), // Rule ID 4891 //
     /* 344952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344973 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 344973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 344978 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344982 */   GIR_RootConstrainSelectedInstOperands,
     /* 344983 */   // GIR_Coverage, 4891,
     /* 344983 */   GIR_Done,
     /* 344984 */ // Label 6839: @344984
     /* 344984 */ GIM_Reject,
     /* 344985 */ // Label 6831: @344985
     /* 344985 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(345019), // Rule ID 4888 //
     /* 344990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345008 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 345008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 345013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345017 */   GIR_RootConstrainSelectedInstOperands,
     /* 345018 */   // GIR_Coverage, 4888,
     /* 345018 */   GIR_Done,
     /* 345019 */ // Label 6840: @345019
     /* 345019 */ GIM_Reject,
     /* 345020 */ // Label 6832: @345020
     /* 345020 */ GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(345054), // Rule ID 4885 //
     /* 345025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345043 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 345043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 345048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345052 */   GIR_RootConstrainSelectedInstOperands,
     /* 345053 */   // GIR_Coverage, 4885,
     /* 345053 */   GIR_Done,
     /* 345054 */ // Label 6841: @345054
     /* 345054 */ GIM_Reject,
     /* 345055 */ // Label 6833: @345055
     /* 345055 */ GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(345092), // Rule ID 5082 //
     /* 345060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345081 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 345086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345090 */   GIR_RootConstrainSelectedInstOperands,
     /* 345091 */   // GIR_Coverage, 5082,
     /* 345091 */   GIR_Done,
     /* 345092 */ // Label 6842: @345092
     /* 345092 */ GIM_Reject,
     /* 345093 */ // Label 6834: @345093
     /* 345093 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(345130), // Rule ID 5076 //
     /* 345098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345119 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 345124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345128 */   GIR_RootConstrainSelectedInstOperands,
     /* 345129 */   // GIR_Coverage, 5076,
     /* 345129 */   GIR_Done,
     /* 345130 */ // Label 6843: @345130
     /* 345130 */ GIM_Reject,
     /* 345131 */ // Label 6835: @345131
     /* 345131 */ GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(345168), // Rule ID 5088 //
     /* 345136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345157 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 345162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345166 */   GIR_RootConstrainSelectedInstOperands,
     /* 345167 */   // GIR_Coverage, 5088,
     /* 345167 */   GIR_Done,
     /* 345168 */ // Label 6844: @345168
     /* 345168 */ GIM_Reject,
     /* 345169 */ // Label 6836: @345169
     /* 345169 */ GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(345206), // Rule ID 5079 //
     /* 345174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345195 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 345200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345204 */   GIR_RootConstrainSelectedInstOperands,
     /* 345205 */   // GIR_Coverage, 5079,
     /* 345205 */   GIR_Done,
     /* 345206 */ // Label 6845: @345206
     /* 345206 */ GIM_Reject,
     /* 345207 */ // Label 6837: @345207
     /* 345207 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(345244), // Rule ID 5085 //
     /* 345212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345233 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 345238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345242 */   GIR_RootConstrainSelectedInstOperands,
     /* 345243 */   // GIR_Coverage, 5085,
     /* 345243 */   GIR_Done,
     /* 345244 */ // Label 6846: @345244
     /* 345244 */ GIM_Reject,
     /* 345245 */ // Label 6838: @345245
     /* 345245 */ GIM_Reject,
     /* 345246 */ // Label 79: @345246
     /* 345246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6855*/ GIMT_Encode4(345948),
     /* 345257 */ /*GILLT_s16*//*Label 6847*/ GIMT_Encode4(345297),
     /* 345261 */ /*GILLT_s32*//*Label 6848*/ GIMT_Encode4(345335),
     /* 345265 */ /*GILLT_s64*//*Label 6849*/ GIMT_Encode4(345373), GIMT_Encode4(0),
     /* 345273 */ /*GILLT_v2s32*//*Label 6850*/ GIMT_Encode4(345433),
     /* 345277 */ /*GILLT_v2s64*//*Label 6851*/ GIMT_Encode4(345536),
     /* 345281 */ /*GILLT_v4s16*//*Label 6852*/ GIMT_Encode4(345639),
     /* 345285 */ /*GILLT_v4s32*//*Label 6853*/ GIMT_Encode4(345742), GIMT_Encode4(0),
     /* 345293 */ /*GILLT_v8s16*//*Label 6854*/ GIMT_Encode4(345845),
     /* 345297 */ // Label 6847: @345297
     /* 345297 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(345334), // Rule ID 618 //
     /* 345302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 345305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 345308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345323 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 345323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 345328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345332 */   GIR_RootConstrainSelectedInstOperands,
     /* 345333 */   // GIR_Coverage, 618,
     /* 345333 */   GIR_Done,
     /* 345334 */ // Label 6856: @345334
     /* 345334 */ GIM_Reject,
     /* 345335 */ // Label 6848: @345335
     /* 345335 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(345372), // Rule ID 620 //
     /* 345340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345361 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 345361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 345366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345370 */   GIR_RootConstrainSelectedInstOperands,
     /* 345371 */   // GIR_Coverage, 620,
     /* 345371 */   GIR_Done,
     /* 345372 */ // Label 6857: @345372
     /* 345372 */ GIM_Reject,
     /* 345373 */ // Label 6849: @345373
     /* 345373 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(345432),
     /* 345378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345396 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(345415), // Rule ID 622 //
     /* 345401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345404 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 345404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 345409 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345413 */     GIR_RootConstrainSelectedInstOperands,
     /* 345414 */     // GIR_Coverage, 622,
     /* 345414 */     GIR_Done,
     /* 345415 */   // Label 6859: @345415
     /* 345415 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(345431), // Rule ID 4881 //
     /* 345420 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 345420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 345425 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345429 */     GIR_RootConstrainSelectedInstOperands,
     /* 345430 */     // GIR_Coverage, 4881,
     /* 345430 */     GIR_Done,
     /* 345431 */   // Label 6860: @345431
     /* 345431 */   GIM_Reject,
     /* 345432 */ // Label 6858: @345432
     /* 345432 */ GIM_Reject,
     /* 345433 */ // Label 6850: @345433
     /* 345433 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(345535),
     /* 345438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345448 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(345507), // Rule ID 2370 //
     /* 345453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345492 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 345495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345505 */     GIR_RootConstrainSelectedInstOperands,
     /* 345506 */     // GIR_Coverage, 2370,
     /* 345506 */     GIR_EraseRootFromParent_Done,
     /* 345507 */   // Label 6862: @345507
     /* 345507 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(345534), // Rule ID 1292 //
     /* 345512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345523 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 345528 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345532 */     GIR_RootConstrainSelectedInstOperands,
     /* 345533 */     // GIR_Coverage, 1292,
     /* 345533 */     GIR_Done,
     /* 345534 */   // Label 6863: @345534
     /* 345534 */   GIM_Reject,
     /* 345535 */ // Label 6861: @345535
     /* 345535 */ GIM_Reject,
     /* 345536 */ // Label 6851: @345536
     /* 345536 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(345638),
     /* 345541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345551 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(345610), // Rule ID 2376 //
     /* 345556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345595 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 345598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345608 */     GIR_RootConstrainSelectedInstOperands,
     /* 345609 */     // GIR_Coverage, 2376,
     /* 345609 */     GIR_EraseRootFromParent_Done,
     /* 345610 */   // Label 6865: @345610
     /* 345610 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(345637), // Rule ID 1296 //
     /* 345615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345626 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 345631 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345635 */     GIR_RootConstrainSelectedInstOperands,
     /* 345636 */     // GIR_Coverage, 1296,
     /* 345636 */     GIR_Done,
     /* 345637 */   // Label 6866: @345637
     /* 345637 */   GIM_Reject,
     /* 345638 */ // Label 6864: @345638
     /* 345638 */ GIM_Reject,
     /* 345639 */ // Label 6852: @345639
     /* 345639 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(345741),
     /* 345644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345654 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(345713), // Rule ID 2364 //
     /* 345659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345698 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 345701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345711 */     GIR_RootConstrainSelectedInstOperands,
     /* 345712 */     // GIR_Coverage, 2364,
     /* 345712 */     GIR_EraseRootFromParent_Done,
     /* 345713 */   // Label 6868: @345713
     /* 345713 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(345740), // Rule ID 1288 //
     /* 345718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345729 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 345734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345738 */     GIR_RootConstrainSelectedInstOperands,
     /* 345739 */     // GIR_Coverage, 1288,
     /* 345739 */     GIR_Done,
     /* 345740 */   // Label 6869: @345740
     /* 345740 */   GIM_Reject,
     /* 345741 */ // Label 6867: @345741
     /* 345741 */ GIM_Reject,
     /* 345742 */ // Label 6853: @345742
     /* 345742 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(345844),
     /* 345747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345757 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(345816), // Rule ID 2373 //
     /* 345762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345801 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 345804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345814 */     GIR_RootConstrainSelectedInstOperands,
     /* 345815 */     // GIR_Coverage, 2373,
     /* 345815 */     GIR_EraseRootFromParent_Done,
     /* 345816 */   // Label 6871: @345816
     /* 345816 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(345843), // Rule ID 1294 //
     /* 345821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345832 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 345837 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345841 */     GIR_RootConstrainSelectedInstOperands,
     /* 345842 */     // GIR_Coverage, 1294,
     /* 345842 */     GIR_Done,
     /* 345843 */   // Label 6872: @345843
     /* 345843 */   GIM_Reject,
     /* 345844 */ // Label 6870: @345844
     /* 345844 */ GIM_Reject,
     /* 345845 */ // Label 6854: @345845
     /* 345845 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(345947),
     /* 345850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345860 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(345919), // Rule ID 2367 //
     /* 345865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345904 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 345907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345917 */     GIR_RootConstrainSelectedInstOperands,
     /* 345918 */     // GIR_Coverage, 2367,
     /* 345918 */     GIR_EraseRootFromParent_Done,
     /* 345919 */   // Label 6874: @345919
     /* 345919 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(345946), // Rule ID 1290 //
     /* 345924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345935 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 345940 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345944 */     GIR_RootConstrainSelectedInstOperands,
     /* 345945 */     // GIR_Coverage, 1290,
     /* 345945 */     GIR_Done,
     /* 345946 */   // Label 6875: @345946
     /* 345946 */   GIM_Reject,
     /* 345947 */ // Label 6873: @345947
     /* 345947 */ GIM_Reject,
     /* 345948 */ // Label 6855: @345948
     /* 345948 */ GIM_Reject,
     /* 345949 */ // Label 80: @345949
     /* 345949 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6884*/ GIMT_Encode4(346651),
     /* 345960 */ /*GILLT_s16*//*Label 6876*/ GIMT_Encode4(346000),
     /* 345964 */ /*GILLT_s32*//*Label 6877*/ GIMT_Encode4(346038),
     /* 345968 */ /*GILLT_s64*//*Label 6878*/ GIMT_Encode4(346076), GIMT_Encode4(0),
     /* 345976 */ /*GILLT_v2s32*//*Label 6879*/ GIMT_Encode4(346136),
     /* 345980 */ /*GILLT_v2s64*//*Label 6880*/ GIMT_Encode4(346239),
     /* 345984 */ /*GILLT_v4s16*//*Label 6881*/ GIMT_Encode4(346342),
     /* 345988 */ /*GILLT_v4s32*//*Label 6882*/ GIMT_Encode4(346445), GIMT_Encode4(0),
     /* 345996 */ /*GILLT_v8s16*//*Label 6883*/ GIMT_Encode4(346548),
     /* 346000 */ // Label 6876: @346000
     /* 346000 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(346037), // Rule ID 606 //
     /* 346005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 346011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346026 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 346026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 346031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346035 */   GIR_RootConstrainSelectedInstOperands,
     /* 346036 */   // GIR_Coverage, 606,
     /* 346036 */   GIR_Done,
     /* 346037 */ // Label 6885: @346037
     /* 346037 */ GIM_Reject,
     /* 346038 */ // Label 6877: @346038
     /* 346038 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(346075), // Rule ID 608 //
     /* 346043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 346046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346064 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 346064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 346069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346073 */   GIR_RootConstrainSelectedInstOperands,
     /* 346074 */   // GIR_Coverage, 608,
     /* 346074 */   GIR_Done,
     /* 346075 */ // Label 6886: @346075
     /* 346075 */ GIM_Reject,
     /* 346076 */ // Label 6878: @346076
     /* 346076 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(346135),
     /* 346081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346099 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(346118), // Rule ID 610 //
     /* 346104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 346107 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 346107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 346112 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346116 */     GIR_RootConstrainSelectedInstOperands,
     /* 346117 */     // GIR_Coverage, 610,
     /* 346117 */     GIR_Done,
     /* 346118 */   // Label 6888: @346118
     /* 346118 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(346134), // Rule ID 4880 //
     /* 346123 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 346123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 346128 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346132 */     GIR_RootConstrainSelectedInstOperands,
     /* 346133 */     // GIR_Coverage, 4880,
     /* 346133 */     GIR_Done,
     /* 346134 */   // Label 6889: @346134
     /* 346134 */   GIM_Reject,
     /* 346135 */ // Label 6887: @346135
     /* 346135 */ GIM_Reject,
     /* 346136 */ // Label 6879: @346136
     /* 346136 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(346238),
     /* 346141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346151 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(346210), // Rule ID 2355 //
     /* 346156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346195 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 346195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 346198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346208 */     GIR_RootConstrainSelectedInstOperands,
     /* 346209 */     // GIR_Coverage, 2355,
     /* 346209 */     GIR_EraseRootFromParent_Done,
     /* 346210 */   // Label 6891: @346210
     /* 346210 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(346237), // Rule ID 1262 //
     /* 346215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346226 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 346226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 346231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346235 */     GIR_RootConstrainSelectedInstOperands,
     /* 346236 */     // GIR_Coverage, 1262,
     /* 346236 */     GIR_Done,
     /* 346237 */   // Label 6892: @346237
     /* 346237 */   GIM_Reject,
     /* 346238 */ // Label 6890: @346238
     /* 346238 */ GIM_Reject,
     /* 346239 */ // Label 6880: @346239
     /* 346239 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(346341),
     /* 346244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 346250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346254 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(346313), // Rule ID 2361 //
     /* 346259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346298 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 346298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 346301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346311 */     GIR_RootConstrainSelectedInstOperands,
     /* 346312 */     // GIR_Coverage, 2361,
     /* 346312 */     GIR_EraseRootFromParent_Done,
     /* 346313 */   // Label 6894: @346313
     /* 346313 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(346340), // Rule ID 1266 //
     /* 346318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346329 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 346329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 346334 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346338 */     GIR_RootConstrainSelectedInstOperands,
     /* 346339 */     // GIR_Coverage, 1266,
     /* 346339 */     GIR_Done,
     /* 346340 */   // Label 6895: @346340
     /* 346340 */   GIM_Reject,
     /* 346341 */ // Label 6893: @346341
     /* 346341 */ GIM_Reject,
     /* 346342 */ // Label 6881: @346342
     /* 346342 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(346444),
     /* 346347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346357 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(346416), // Rule ID 2349 //
     /* 346362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346401 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 346401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 346404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346414 */     GIR_RootConstrainSelectedInstOperands,
     /* 346415 */     // GIR_Coverage, 2349,
     /* 346415 */     GIR_EraseRootFromParent_Done,
     /* 346416 */   // Label 6897: @346416
     /* 346416 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(346443), // Rule ID 1258 //
     /* 346421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 346424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346432 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 346432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 346437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346441 */     GIR_RootConstrainSelectedInstOperands,
     /* 346442 */     // GIR_Coverage, 1258,
     /* 346442 */     GIR_Done,
     /* 346443 */   // Label 6898: @346443
     /* 346443 */   GIM_Reject,
     /* 346444 */ // Label 6896: @346444
     /* 346444 */ GIM_Reject,
     /* 346445 */ // Label 6882: @346445
     /* 346445 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(346547),
     /* 346450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346460 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(346519), // Rule ID 2358 //
     /* 346465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346504 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 346504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 346507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346517 */     GIR_RootConstrainSelectedInstOperands,
     /* 346518 */     // GIR_Coverage, 2358,
     /* 346518 */     GIR_EraseRootFromParent_Done,
     /* 346519 */   // Label 6900: @346519
     /* 346519 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(346546), // Rule ID 1264 //
     /* 346524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346535 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 346535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 346540 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346544 */     GIR_RootConstrainSelectedInstOperands,
     /* 346545 */     // GIR_Coverage, 1264,
     /* 346545 */     GIR_Done,
     /* 346546 */   // Label 6901: @346546
     /* 346546 */   GIM_Reject,
     /* 346547 */ // Label 6899: @346547
     /* 346547 */ GIM_Reject,
     /* 346548 */ // Label 6883: @346548
     /* 346548 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(346650),
     /* 346553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346563 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(346622), // Rule ID 2352 //
     /* 346568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346607 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 346607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 346610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346620 */     GIR_RootConstrainSelectedInstOperands,
     /* 346621 */     // GIR_Coverage, 2352,
     /* 346621 */     GIR_EraseRootFromParent_Done,
     /* 346622 */   // Label 6903: @346622
     /* 346622 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(346649), // Rule ID 1260 //
     /* 346627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 346630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346638 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 346638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 346643 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346647 */     GIR_RootConstrainSelectedInstOperands,
     /* 346648 */     // GIR_Coverage, 1260,
     /* 346648 */     GIR_Done,
     /* 346649 */   // Label 6904: @346649
     /* 346649 */   GIM_Reject,
     /* 346650 */ // Label 6902: @346650
     /* 346650 */ GIM_Reject,
     /* 346651 */ // Label 6884: @346651
     /* 346651 */ GIM_Reject,
     /* 346652 */ // Label 81: @346652
     /* 346652 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(347151),
     /* 346657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 346664 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(346755), // Rule ID 7072 //
     /* 346669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346676 */     // MIs[0] Rn
     /* 346676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 346704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 346712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346733 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 346737 */     // MIs[3] Operand 1
     /* 346737 */     // No operand predicates
     /* 346737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346739 */     // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, (shl:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)))  =>  (SUBPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)
     /* 346739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBPT_shift),
     /* 346742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 346753 */     GIR_RootConstrainSelectedInstOperands,
     /* 346754 */     // GIR_Coverage, 7072,
     /* 346754 */     GIR_EraseRootFromParent_Done,
     /* 346755 */   // Label 6906: @346755
     /* 346755 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(346919),
     /* 346760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346772 */     GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(346845), // Rule ID 15248 //
     /* 346777 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346780 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346784 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 346788 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346792 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346796 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346800 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346804 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346808 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346812 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 0,
     /* 346816 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346821 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346826 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346828 */       // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64:{ *:[i64] }:$Rn))  =>  (MSUBPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 346828 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBPT),
     /* 346831 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346833 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 346837 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 346841 */       GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 346843 */       GIR_RootConstrainSelectedInstOperands,
     /* 346844 */       // GIR_Coverage, 15248,
     /* 346844 */       GIR_EraseRootFromParent_Done,
     /* 346845 */     // Label 6908: @346845
     /* 346845 */     GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(346918), // Rule ID 7074 //
     /* 346850 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346853 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346857 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 346861 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346865 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346874 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346878 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346882 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346886 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346890 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 0,
     /* 346894 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346899 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346901 */       // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm)))  =>  (MSUBPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 346901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBPT),
     /* 346904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346906 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346910 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 346914 */       GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 346916 */       GIR_RootConstrainSelectedInstOperands,
     /* 346917 */       // GIR_Coverage, 7074,
     /* 346917 */       GIR_EraseRootFromParent_Done,
     /* 346918 */     // Label 6909: @346918
     /* 346918 */     GIM_Reject,
     /* 346919 */   // Label 6907: @346919
     /* 346919 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(347047),
     /* 346924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346936 */     GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(346987), // Rule ID 7071 //
     /* 346941 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346944 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346948 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346952 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346956 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346960 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 346964 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346969 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346971 */       // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rm))  =>  (SUBPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, 0:{ *:[i64] })
     /* 346971 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBPT_shift),
     /* 346974 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346976 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346978 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 346982 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346985 */       GIR_RootConstrainSelectedInstOperands,
     /* 346986 */       // GIR_Coverage, 7071,
     /* 346986 */       GIR_EraseRootFromParent_Done,
     /* 346987 */     // Label 6911: @346987
     /* 346987 */     GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(347046), // Rule ID 7070 //
     /* 346992 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346995 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346999 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 347003 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 347007 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347011 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347016 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347020 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347024 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 347028 */       // MIs[2] Operand 1
     /* 347028 */       // No operand predicates
     /* 347028 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347030 */       // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (shl:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm))  =>  (ADDPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)
     /* 347030 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPT_shift),
     /* 347033 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347035 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347037 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 347041 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 347044 */       GIR_RootConstrainSelectedInstOperands,
     /* 347045 */       // GIR_Coverage, 7070,
     /* 347045 */       GIR_EraseRootFromParent_Done,
     /* 347046 */     // Label 6912: @347046
     /* 347046 */     GIM_Reject,
     /* 347047 */   // Label 6910: @347047
     /* 347047 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(347112), // Rule ID 7073 //
     /* 347052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 347055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347059 */     // MIs[0] Ra
     /* 347059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 347063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 347075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 347079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347095 */     // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MADDPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 347095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDPT),
     /* 347098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 347108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 347110 */     GIR_RootConstrainSelectedInstOperands,
     /* 347111 */     // GIR_Coverage, 7073,
     /* 347111 */     GIR_EraseRootFromParent_Done,
     /* 347112 */   // Label 6913: @347112
     /* 347112 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(347150), // Rule ID 7069 //
     /* 347117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 347120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347124 */     // MIs[0] Rn
     /* 347124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 347128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347136 */     // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (ADDPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, 0:{ *:[i64] })
     /* 347136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPT_shift),
     /* 347139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 347145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347148 */     GIR_RootConstrainSelectedInstOperands,
     /* 347149 */     // GIR_Coverage, 7069,
     /* 347149 */     GIR_EraseRootFromParent_Done,
     /* 347150 */   // Label 6914: @347150
     /* 347150 */   GIM_Reject,
     /* 347151 */ // Label 6905: @347151
     /* 347151 */ GIM_Reject,
     /* 347152 */ // Label 82: @347152
     /* 347152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6923*/ GIMT_Encode4(347555),
     /* 347163 */ /*GILLT_s32*//*Label 6915*/ GIMT_Encode4(347203),
     /* 347167 */ /*GILLT_s64*//*Label 6916*/ GIMT_Encode4(347277), GIMT_Encode4(0),
     /* 347175 */ /*GILLT_v2s32*//*Label 6917*/ GIMT_Encode4(347351), GIMT_Encode4(0),
     /* 347183 */ /*GILLT_v4s16*//*Label 6918*/ GIMT_Encode4(347385),
     /* 347187 */ /*GILLT_v4s32*//*Label 6919*/ GIMT_Encode4(347419),
     /* 347191 */ /*GILLT_v8s8*//*Label 6920*/ GIMT_Encode4(347453),
     /* 347195 */ /*GILLT_v8s16*//*Label 6921*/ GIMT_Encode4(347487),
     /* 347199 */ /*GILLT_v16s8*//*Label 6922*/ GIMT_Encode4(347521),
     /* 347203 */ // Label 6915: @347203
     /* 347203 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(347276),
     /* 347208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347222 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(347256), // Rule ID 2332 //
     /* 347227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 347242 */     // MIs[1] Operand 1
     /* 347242 */     // No operand predicates
     /* 347242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347244 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 347244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 347247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347254 */     GIR_RootConstrainSelectedInstOperands,
     /* 347255 */     // GIR_Coverage, 2332,
     /* 347255 */     GIR_EraseRootFromParent_Done,
     /* 347256 */   // Label 6925: @347256
     /* 347256 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(347275), // Rule ID 2331 //
     /* 347261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347268 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 347268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 347273 */     GIR_RootConstrainSelectedInstOperands,
     /* 347274 */     // GIR_Coverage, 2331,
     /* 347274 */     GIR_Done,
     /* 347275 */   // Label 6926: @347275
     /* 347275 */   GIM_Reject,
     /* 347276 */ // Label 6924: @347276
     /* 347276 */ GIM_Reject,
     /* 347277 */ // Label 6916: @347277
     /* 347277 */ GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(347350),
     /* 347282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 347288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347296 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(347330), // Rule ID 2334 //
     /* 347301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 347316 */     // MIs[1] Operand 1
     /* 347316 */     // No operand predicates
     /* 347316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347318 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 347321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347328 */     GIR_RootConstrainSelectedInstOperands,
     /* 347329 */     // GIR_Coverage, 2334,
     /* 347329 */     GIR_EraseRootFromParent_Done,
     /* 347330 */   // Label 6928: @347330
     /* 347330 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(347349), // Rule ID 2333 //
     /* 347335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347342 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 347347 */     GIR_RootConstrainSelectedInstOperands,
     /* 347348 */     // GIR_Coverage, 2333,
     /* 347348 */     GIR_Done,
     /* 347349 */   // Label 6929: @347349
     /* 347349 */   GIM_Reject,
     /* 347350 */ // Label 6927: @347350
     /* 347350 */ GIM_Reject,
     /* 347351 */ // Label 6917: @347351
     /* 347351 */ GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(347384), // Rule ID 1418 //
     /* 347356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347377 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 347382 */   GIR_RootConstrainSelectedInstOperands,
     /* 347383 */   // GIR_Coverage, 1418,
     /* 347383 */   GIR_Done,
     /* 347384 */ // Label 6930: @347384
     /* 347384 */ GIM_Reject,
     /* 347385 */ // Label 6918: @347385
     /* 347385 */ GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(347418), // Rule ID 1416 //
     /* 347390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347411 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 347416 */   GIR_RootConstrainSelectedInstOperands,
     /* 347417 */   // GIR_Coverage, 1416,
     /* 347417 */   GIR_Done,
     /* 347418 */ // Label 6931: @347418
     /* 347418 */ GIM_Reject,
     /* 347419 */ // Label 6919: @347419
     /* 347419 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(347452), // Rule ID 1419 //
     /* 347424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347445 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 347450 */   GIR_RootConstrainSelectedInstOperands,
     /* 347451 */   // GIR_Coverage, 1419,
     /* 347451 */   GIR_Done,
     /* 347452 */ // Label 6932: @347452
     /* 347452 */ GIM_Reject,
     /* 347453 */ // Label 6920: @347453
     /* 347453 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(347486), // Rule ID 1414 //
     /* 347458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347479 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 347484 */   GIR_RootConstrainSelectedInstOperands,
     /* 347485 */   // GIR_Coverage, 1414,
     /* 347485 */   GIR_Done,
     /* 347486 */ // Label 6933: @347486
     /* 347486 */ GIM_Reject,
     /* 347487 */ // Label 6921: @347487
     /* 347487 */ GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(347520), // Rule ID 1417 //
     /* 347492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347513 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 347518 */   GIR_RootConstrainSelectedInstOperands,
     /* 347519 */   // GIR_Coverage, 1417,
     /* 347519 */   GIR_Done,
     /* 347520 */ // Label 6934: @347520
     /* 347520 */ GIM_Reject,
     /* 347521 */ // Label 6922: @347521
     /* 347521 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(347554), // Rule ID 1415 //
     /* 347526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347547 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 347552 */   GIR_RootConstrainSelectedInstOperands,
     /* 347553 */   // GIR_Coverage, 1415,
     /* 347553 */   GIR_Done,
     /* 347554 */ // Label 6935: @347554
     /* 347554 */ GIM_Reject,
     /* 347555 */ // Label 6923: @347555
     /* 347555 */ GIM_Reject,
     /* 347556 */ // Label 83: @347556
     /* 347556 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6944*/ GIMT_Encode4(347959),
     /* 347567 */ /*GILLT_s32*//*Label 6936*/ GIMT_Encode4(347607),
     /* 347571 */ /*GILLT_s64*//*Label 6937*/ GIMT_Encode4(347681), GIMT_Encode4(0),
     /* 347579 */ /*GILLT_v2s32*//*Label 6938*/ GIMT_Encode4(347755), GIMT_Encode4(0),
     /* 347587 */ /*GILLT_v4s16*//*Label 6939*/ GIMT_Encode4(347789),
     /* 347591 */ /*GILLT_v4s32*//*Label 6940*/ GIMT_Encode4(347823),
     /* 347595 */ /*GILLT_v8s8*//*Label 6941*/ GIMT_Encode4(347857),
     /* 347599 */ /*GILLT_v8s16*//*Label 6942*/ GIMT_Encode4(347891),
     /* 347603 */ /*GILLT_v16s8*//*Label 6943*/ GIMT_Encode4(347925),
     /* 347607 */ // Label 6936: @347607
     /* 347607 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(347680),
     /* 347612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347626 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(347660), // Rule ID 2328 //
     /* 347631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 347646 */     // MIs[1] Operand 1
     /* 347646 */     // No operand predicates
     /* 347646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347648 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 347648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 347651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347658 */     GIR_RootConstrainSelectedInstOperands,
     /* 347659 */     // GIR_Coverage, 2328,
     /* 347659 */     GIR_EraseRootFromParent_Done,
     /* 347660 */   // Label 6946: @347660
     /* 347660 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(347679), // Rule ID 2327 //
     /* 347665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347672 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 347672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 347677 */     GIR_RootConstrainSelectedInstOperands,
     /* 347678 */     // GIR_Coverage, 2327,
     /* 347678 */     GIR_Done,
     /* 347679 */   // Label 6947: @347679
     /* 347679 */   GIM_Reject,
     /* 347680 */ // Label 6945: @347680
     /* 347680 */ GIM_Reject,
     /* 347681 */ // Label 6937: @347681
     /* 347681 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(347754),
     /* 347686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 347692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347700 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(347734), // Rule ID 2330 //
     /* 347705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 347720 */     // MIs[1] Operand 1
     /* 347720 */     // No operand predicates
     /* 347720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347722 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 347725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347732 */     GIR_RootConstrainSelectedInstOperands,
     /* 347733 */     // GIR_Coverage, 2330,
     /* 347733 */     GIR_EraseRootFromParent_Done,
     /* 347734 */   // Label 6949: @347734
     /* 347734 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(347753), // Rule ID 2329 //
     /* 347739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347746 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 347751 */     GIR_RootConstrainSelectedInstOperands,
     /* 347752 */     // GIR_Coverage, 2329,
     /* 347752 */     GIR_Done,
     /* 347753 */   // Label 6950: @347753
     /* 347753 */   GIM_Reject,
     /* 347754 */ // Label 6948: @347754
     /* 347754 */ GIM_Reject,
     /* 347755 */ // Label 6938: @347755
     /* 347755 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(347788), // Rule ID 1406 //
     /* 347760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347781 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 347786 */   GIR_RootConstrainSelectedInstOperands,
     /* 347787 */   // GIR_Coverage, 1406,
     /* 347787 */   GIR_Done,
     /* 347788 */ // Label 6951: @347788
     /* 347788 */ GIM_Reject,
     /* 347789 */ // Label 6939: @347789
     /* 347789 */ GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(347822), // Rule ID 1404 //
     /* 347794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347815 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 347820 */   GIR_RootConstrainSelectedInstOperands,
     /* 347821 */   // GIR_Coverage, 1404,
     /* 347821 */   GIR_Done,
     /* 347822 */ // Label 6952: @347822
     /* 347822 */ GIM_Reject,
     /* 347823 */ // Label 6940: @347823
     /* 347823 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(347856), // Rule ID 1407 //
     /* 347828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347849 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 347854 */   GIR_RootConstrainSelectedInstOperands,
     /* 347855 */   // GIR_Coverage, 1407,
     /* 347855 */   GIR_Done,
     /* 347856 */ // Label 6953: @347856
     /* 347856 */ GIM_Reject,
     /* 347857 */ // Label 6941: @347857
     /* 347857 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(347890), // Rule ID 1402 //
     /* 347862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347883 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 347888 */   GIR_RootConstrainSelectedInstOperands,
     /* 347889 */   // GIR_Coverage, 1402,
     /* 347889 */   GIR_Done,
     /* 347890 */ // Label 6954: @347890
     /* 347890 */ GIM_Reject,
     /* 347891 */ // Label 6942: @347891
     /* 347891 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(347924), // Rule ID 1405 //
     /* 347896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347917 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 347922 */   GIR_RootConstrainSelectedInstOperands,
     /* 347923 */   // GIR_Coverage, 1405,
     /* 347923 */   GIR_Done,
     /* 347924 */ // Label 6955: @347924
     /* 347924 */ GIM_Reject,
     /* 347925 */ // Label 6943: @347925
     /* 347925 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(347958), // Rule ID 1403 //
     /* 347930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347951 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 347956 */   GIR_RootConstrainSelectedInstOperands,
     /* 347957 */   // GIR_Coverage, 1403,
     /* 347957 */   GIR_Done,
     /* 347958 */ // Label 6956: @347958
     /* 347958 */ GIM_Reject,
     /* 347959 */ // Label 6944: @347959
     /* 347959 */ GIM_Reject,
     /* 347960 */ // Label 84: @347960
     /* 347960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6965*/ GIMT_Encode4(348363),
     /* 347971 */ /*GILLT_s32*//*Label 6957*/ GIMT_Encode4(348011),
     /* 347975 */ /*GILLT_s64*//*Label 6958*/ GIMT_Encode4(348085), GIMT_Encode4(0),
     /* 347983 */ /*GILLT_v2s32*//*Label 6959*/ GIMT_Encode4(348159), GIMT_Encode4(0),
     /* 347991 */ /*GILLT_v4s16*//*Label 6960*/ GIMT_Encode4(348193),
     /* 347995 */ /*GILLT_v4s32*//*Label 6961*/ GIMT_Encode4(348227),
     /* 347999 */ /*GILLT_v8s8*//*Label 6962*/ GIMT_Encode4(348261),
     /* 348003 */ /*GILLT_v8s16*//*Label 6963*/ GIMT_Encode4(348295),
     /* 348007 */ /*GILLT_v16s8*//*Label 6964*/ GIMT_Encode4(348329),
     /* 348011 */ // Label 6957: @348011
     /* 348011 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(348084),
     /* 348016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348030 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(348064), // Rule ID 2340 //
     /* 348035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 348050 */     // MIs[1] Operand 1
     /* 348050 */     // No operand predicates
     /* 348050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348052 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 348052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 348055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348062 */     GIR_RootConstrainSelectedInstOperands,
     /* 348063 */     // GIR_Coverage, 2340,
     /* 348063 */     GIR_EraseRootFromParent_Done,
     /* 348064 */   // Label 6967: @348064
     /* 348064 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(348083), // Rule ID 2339 //
     /* 348069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348076 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 348076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 348081 */     GIR_RootConstrainSelectedInstOperands,
     /* 348082 */     // GIR_Coverage, 2339,
     /* 348082 */     GIR_Done,
     /* 348083 */   // Label 6968: @348083
     /* 348083 */   GIM_Reject,
     /* 348084 */ // Label 6966: @348084
     /* 348084 */ GIM_Reject,
     /* 348085 */ // Label 6958: @348085
     /* 348085 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(348158),
     /* 348090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 348096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348104 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(348138), // Rule ID 2342 //
     /* 348109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 348124 */     // MIs[1] Operand 1
     /* 348124 */     // No operand predicates
     /* 348124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348126 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 348126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 348129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348136 */     GIR_RootConstrainSelectedInstOperands,
     /* 348137 */     // GIR_Coverage, 2342,
     /* 348137 */     GIR_EraseRootFromParent_Done,
     /* 348138 */   // Label 6970: @348138
     /* 348138 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(348157), // Rule ID 2341 //
     /* 348143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348150 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 348150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 348155 */     GIR_RootConstrainSelectedInstOperands,
     /* 348156 */     // GIR_Coverage, 2341,
     /* 348156 */     GIR_Done,
     /* 348157 */   // Label 6971: @348157
     /* 348157 */   GIM_Reject,
     /* 348158 */ // Label 6969: @348158
     /* 348158 */ GIM_Reject,
     /* 348159 */ // Label 6959: @348159
     /* 348159 */ GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(348192), // Rule ID 1541 //
     /* 348164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 348173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348185 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 348185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 348190 */   GIR_RootConstrainSelectedInstOperands,
     /* 348191 */   // GIR_Coverage, 1541,
     /* 348191 */   GIR_Done,
     /* 348192 */ // Label 6972: @348192
     /* 348192 */ GIM_Reject,
     /* 348193 */ // Label 6960: @348193
     /* 348193 */ GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(348226), // Rule ID 1539 //
     /* 348198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 348207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348219 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 348219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 348224 */   GIR_RootConstrainSelectedInstOperands,
     /* 348225 */   // GIR_Coverage, 1539,
     /* 348225 */   GIR_Done,
     /* 348226 */ // Label 6973: @348226
     /* 348226 */ GIM_Reject,
     /* 348227 */ // Label 6961: @348227
     /* 348227 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(348260), // Rule ID 1542 //
     /* 348232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 348241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348253 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 348253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 348258 */   GIR_RootConstrainSelectedInstOperands,
     /* 348259 */   // GIR_Coverage, 1542,
     /* 348259 */   GIR_Done,
     /* 348260 */ // Label 6974: @348260
     /* 348260 */ GIM_Reject,
     /* 348261 */ // Label 6962: @348261
     /* 348261 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(348294), // Rule ID 1537 //
     /* 348266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 348275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348287 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 348287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 348292 */   GIR_RootConstrainSelectedInstOperands,
     /* 348293 */   // GIR_Coverage, 1537,
     /* 348293 */   GIR_Done,
     /* 348294 */ // Label 6975: @348294
     /* 348294 */ GIM_Reject,
     /* 348295 */ // Label 6963: @348295
     /* 348295 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(348328), // Rule ID 1540 //
     /* 348300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 348309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348321 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 348321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 348326 */   GIR_RootConstrainSelectedInstOperands,
     /* 348327 */   // GIR_Coverage, 1540,
     /* 348327 */   GIR_Done,
     /* 348328 */ // Label 6976: @348328
     /* 348328 */ GIM_Reject,
     /* 348329 */ // Label 6964: @348329
     /* 348329 */ GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(348362), // Rule ID 1538 //
     /* 348334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 348343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348355 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 348355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 348360 */   GIR_RootConstrainSelectedInstOperands,
     /* 348361 */   // GIR_Coverage, 1538,
     /* 348361 */   GIR_Done,
     /* 348362 */ // Label 6977: @348362
     /* 348362 */ GIM_Reject,
     /* 348363 */ // Label 6965: @348363
     /* 348363 */ GIM_Reject,
     /* 348364 */ // Label 85: @348364
     /* 348364 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6986*/ GIMT_Encode4(348767),
     /* 348375 */ /*GILLT_s32*//*Label 6978*/ GIMT_Encode4(348415),
     /* 348379 */ /*GILLT_s64*//*Label 6979*/ GIMT_Encode4(348489), GIMT_Encode4(0),
     /* 348387 */ /*GILLT_v2s32*//*Label 6980*/ GIMT_Encode4(348563), GIMT_Encode4(0),
     /* 348395 */ /*GILLT_v4s16*//*Label 6981*/ GIMT_Encode4(348597),
     /* 348399 */ /*GILLT_v4s32*//*Label 6982*/ GIMT_Encode4(348631),
     /* 348403 */ /*GILLT_v8s8*//*Label 6983*/ GIMT_Encode4(348665),
     /* 348407 */ /*GILLT_v8s16*//*Label 6984*/ GIMT_Encode4(348699),
     /* 348411 */ /*GILLT_v16s8*//*Label 6985*/ GIMT_Encode4(348733),
     /* 348415 */ // Label 6978: @348415
     /* 348415 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(348488),
     /* 348420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348434 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(348468), // Rule ID 2336 //
     /* 348439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 348454 */     // MIs[1] Operand 1
     /* 348454 */     // No operand predicates
     /* 348454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348456 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 348456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 348459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348466 */     GIR_RootConstrainSelectedInstOperands,
     /* 348467 */     // GIR_Coverage, 2336,
     /* 348467 */     GIR_EraseRootFromParent_Done,
     /* 348468 */   // Label 6988: @348468
     /* 348468 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(348487), // Rule ID 2335 //
     /* 348473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348480 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 348480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 348485 */     GIR_RootConstrainSelectedInstOperands,
     /* 348486 */     // GIR_Coverage, 2335,
     /* 348486 */     GIR_Done,
     /* 348487 */   // Label 6989: @348487
     /* 348487 */   GIM_Reject,
     /* 348488 */ // Label 6987: @348488
     /* 348488 */ GIM_Reject,
     /* 348489 */ // Label 6979: @348489
     /* 348489 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(348562),
     /* 348494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 348500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348508 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(348542), // Rule ID 2338 //
     /* 348513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 348528 */     // MIs[1] Operand 1
     /* 348528 */     // No operand predicates
     /* 348528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348530 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 348530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 348533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348540 */     GIR_RootConstrainSelectedInstOperands,
     /* 348541 */     // GIR_Coverage, 2338,
     /* 348541 */     GIR_EraseRootFromParent_Done,
     /* 348542 */   // Label 6991: @348542
     /* 348542 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(348561), // Rule ID 2337 //
     /* 348547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348554 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 348554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 348559 */     GIR_RootConstrainSelectedInstOperands,
     /* 348560 */     // GIR_Coverage, 2337,
     /* 348560 */     GIR_Done,
     /* 348561 */   // Label 6992: @348561
     /* 348561 */   GIM_Reject,
     /* 348562 */ // Label 6990: @348562
     /* 348562 */ GIM_Reject,
     /* 348563 */ // Label 6980: @348563
     /* 348563 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(348596), // Rule ID 1529 //
     /* 348568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 348577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348589 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 348589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 348594 */   GIR_RootConstrainSelectedInstOperands,
     /* 348595 */   // GIR_Coverage, 1529,
     /* 348595 */   GIR_Done,
     /* 348596 */ // Label 6993: @348596
     /* 348596 */ GIM_Reject,
     /* 348597 */ // Label 6981: @348597
     /* 348597 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(348630), // Rule ID 1527 //
     /* 348602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 348611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348623 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 348623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 348628 */   GIR_RootConstrainSelectedInstOperands,
     /* 348629 */   // GIR_Coverage, 1527,
     /* 348629 */   GIR_Done,
     /* 348630 */ // Label 6994: @348630
     /* 348630 */ GIM_Reject,
     /* 348631 */ // Label 6982: @348631
     /* 348631 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(348664), // Rule ID 1530 //
     /* 348636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 348645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348657 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 348657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 348662 */   GIR_RootConstrainSelectedInstOperands,
     /* 348663 */   // GIR_Coverage, 1530,
     /* 348663 */   GIR_Done,
     /* 348664 */ // Label 6995: @348664
     /* 348664 */ GIM_Reject,
     /* 348665 */ // Label 6983: @348665
     /* 348665 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(348698), // Rule ID 1525 //
     /* 348670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 348679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348691 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 348691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 348696 */   GIR_RootConstrainSelectedInstOperands,
     /* 348697 */   // GIR_Coverage, 1525,
     /* 348697 */   GIR_Done,
     /* 348698 */ // Label 6996: @348698
     /* 348698 */ GIM_Reject,
     /* 348699 */ // Label 6984: @348699
     /* 348699 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(348732), // Rule ID 1528 //
     /* 348704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 348713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348725 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 348725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 348730 */   GIR_RootConstrainSelectedInstOperands,
     /* 348731 */   // GIR_Coverage, 1528,
     /* 348731 */   GIR_Done,
     /* 348732 */ // Label 6997: @348732
     /* 348732 */ GIM_Reject,
     /* 348733 */ // Label 6985: @348733
     /* 348733 */ GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(348766), // Rule ID 1526 //
     /* 348738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 348747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348759 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 348759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 348764 */   GIR_RootConstrainSelectedInstOperands,
     /* 348765 */   // GIR_Coverage, 1526,
     /* 348765 */   GIR_Done,
     /* 348766 */ // Label 6998: @348766
     /* 348766 */ GIM_Reject,
     /* 348767 */ // Label 6986: @348767
     /* 348767 */ GIM_Reject,
     /* 348768 */ // Label 86: @348768
     /* 348768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7008*/ GIMT_Encode4(349582),
     /* 348779 */ /*GILLT_s32*//*Label 6999*/ GIMT_Encode4(348819),
     /* 348783 */ /*GILLT_s64*//*Label 7000*/ GIMT_Encode4(348846), GIMT_Encode4(0),
     /* 348791 */ /*GILLT_v2s32*//*Label 7001*/ GIMT_Encode4(348925),
     /* 348795 */ /*GILLT_v2s64*//*Label 7002*/ GIMT_Encode4(348952),
     /* 348799 */ /*GILLT_v4s16*//*Label 7003*/ GIMT_Encode4(349135),
     /* 348803 */ /*GILLT_v4s32*//*Label 7004*/ GIMT_Encode4(349162),
     /* 348807 */ /*GILLT_v8s8*//*Label 7005*/ GIMT_Encode4(349345),
     /* 348811 */ /*GILLT_v8s16*//*Label 7006*/ GIMT_Encode4(349372),
     /* 348815 */ /*GILLT_v16s8*//*Label 7007*/ GIMT_Encode4(349555),
     /* 348819 */ // Label 6999: @348819
     /* 348819 */ GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(348845), // Rule ID 2321 //
     /* 348824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348838 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 348838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 348843 */   GIR_RootConstrainSelectedInstOperands,
     /* 348844 */   // GIR_Coverage, 2321,
     /* 348844 */   GIR_Done,
     /* 348845 */ // Label 7009: @348845
     /* 348845 */ GIM_Reject,
     /* 348846 */ // Label 7000: @348846
     /* 348846 */ GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(348924),
     /* 348851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348854 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(348877), // Rule ID 1656 //
     /* 348859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348870 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 348870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 348875 */     GIR_RootConstrainSelectedInstOperands,
     /* 348876 */     // GIR_Coverage, 1656,
     /* 348876 */     GIR_Done,
     /* 348877 */   // Label 7011: @348877
     /* 348877 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(348900), // Rule ID 2322 //
     /* 348882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348893 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 348893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 348898 */     GIR_RootConstrainSelectedInstOperands,
     /* 348899 */     // GIR_Coverage, 2322,
     /* 348899 */     GIR_Done,
     /* 348900 */   // Label 7012: @348900
     /* 348900 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(348923), // Rule ID 2514 //
     /* 348905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 348908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348916 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 348916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 348921 */     GIR_RootConstrainSelectedInstOperands,
     /* 348922 */     // GIR_Coverage, 2514,
     /* 348922 */     GIR_Done,
     /* 348923 */   // Label 7013: @348923
     /* 348923 */   GIM_Reject,
     /* 348924 */ // Label 7010: @348924
     /* 348924 */ GIM_Reject,
     /* 348925 */ // Label 7001: @348925
     /* 348925 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(348951), // Rule ID 711 //
     /* 348930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348944 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 348944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 348949 */   GIR_RootConstrainSelectedInstOperands,
     /* 348950 */   // GIR_Coverage, 711,
     /* 348950 */   GIR_Done,
     /* 348951 */ // Label 7014: @348951
     /* 348951 */ GIM_Reject,
     /* 348952 */ // Label 7002: @348952
     /* 348952 */ GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(349134),
     /* 348957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348964 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(349042), // Rule ID 4958 //
     /* 348969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 348985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349005 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 349018 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 349025 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 349025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 349028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 349035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 349040 */     GIR_RootConstrainSelectedInstOperands,
     /* 349041 */     // GIR_Coverage, 4958,
     /* 349041 */     GIR_EraseRootFromParent_Done,
     /* 349042 */   // Label 7016: @349042
     /* 349042 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(349114), // Rule ID 4957 //
     /* 349047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 349059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 349063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349092 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349099 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 349099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 349102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 349108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 349112 */     GIR_RootConstrainSelectedInstOperands,
     /* 349113 */     // GIR_Coverage, 4957,
     /* 349113 */     GIR_EraseRootFromParent_Done,
     /* 349114 */   // Label 7017: @349114
     /* 349114 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(349133), // Rule ID 713 //
     /* 349119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349126 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 349126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 349131 */     GIR_RootConstrainSelectedInstOperands,
     /* 349132 */     // GIR_Coverage, 713,
     /* 349132 */     GIR_Done,
     /* 349133 */   // Label 7018: @349133
     /* 349133 */   GIM_Reject,
     /* 349134 */ // Label 7015: @349134
     /* 349134 */ GIM_Reject,
     /* 349135 */ // Label 7003: @349135
     /* 349135 */ GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(349161), // Rule ID 709 //
     /* 349140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349154 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 349154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 349159 */   GIR_RootConstrainSelectedInstOperands,
     /* 349160 */   // GIR_Coverage, 709,
     /* 349160 */   GIR_Done,
     /* 349161 */ // Label 7019: @349161
     /* 349161 */ GIM_Reject,
     /* 349162 */ // Label 7004: @349162
     /* 349162 */ GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(349344),
     /* 349167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349174 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(349252), // Rule ID 4956 //
     /* 349179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 349195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 349228 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 349235 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 349235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 349238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 349245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 349250 */     GIR_RootConstrainSelectedInstOperands,
     /* 349251 */     // GIR_Coverage, 4956,
     /* 349251 */     GIR_EraseRootFromParent_Done,
     /* 349252 */   // Label 7021: @349252
     /* 349252 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(349324), // Rule ID 4955 //
     /* 349257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 349273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349302 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349309 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 349309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 349312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 349318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 349322 */     GIR_RootConstrainSelectedInstOperands,
     /* 349323 */     // GIR_Coverage, 4955,
     /* 349323 */     GIR_EraseRootFromParent_Done,
     /* 349324 */   // Label 7022: @349324
     /* 349324 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(349343), // Rule ID 712 //
     /* 349329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349336 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 349336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 349341 */     GIR_RootConstrainSelectedInstOperands,
     /* 349342 */     // GIR_Coverage, 712,
     /* 349342 */     GIR_Done,
     /* 349343 */   // Label 7023: @349343
     /* 349343 */   GIM_Reject,
     /* 349344 */ // Label 7020: @349344
     /* 349344 */ GIM_Reject,
     /* 349345 */ // Label 7005: @349345
     /* 349345 */ GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(349371), // Rule ID 707 //
     /* 349350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349364 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 349364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 349369 */   GIR_RootConstrainSelectedInstOperands,
     /* 349370 */   // GIR_Coverage, 707,
     /* 349370 */   GIR_Done,
     /* 349371 */ // Label 7024: @349371
     /* 349371 */ GIM_Reject,
     /* 349372 */ // Label 7006: @349372
     /* 349372 */ GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(349554),
     /* 349377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349384 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(349462), // Rule ID 4954 //
     /* 349389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 349405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349425 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 349438 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 349445 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 349445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 349448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 349455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 349460 */     GIR_RootConstrainSelectedInstOperands,
     /* 349461 */     // GIR_Coverage, 4954,
     /* 349461 */     GIR_EraseRootFromParent_Done,
     /* 349462 */   // Label 7026: @349462
     /* 349462 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(349534), // Rule ID 4953 //
     /* 349467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 349483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349519 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 349519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 349522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 349528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 349532 */     GIR_RootConstrainSelectedInstOperands,
     /* 349533 */     // GIR_Coverage, 4953,
     /* 349533 */     GIR_EraseRootFromParent_Done,
     /* 349534 */   // Label 7027: @349534
     /* 349534 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(349553), // Rule ID 710 //
     /* 349539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349546 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 349546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 349551 */     GIR_RootConstrainSelectedInstOperands,
     /* 349552 */     // GIR_Coverage, 710,
     /* 349552 */     GIR_Done,
     /* 349553 */   // Label 7028: @349553
     /* 349553 */   GIM_Reject,
     /* 349554 */ // Label 7025: @349554
     /* 349554 */ GIM_Reject,
     /* 349555 */ // Label 7007: @349555
     /* 349555 */ GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(349581), // Rule ID 708 //
     /* 349560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 349566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349574 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 349574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 349579 */   GIR_RootConstrainSelectedInstOperands,
     /* 349580 */   // GIR_Coverage, 708,
     /* 349580 */   GIR_Done,
     /* 349581 */ // Label 7029: @349581
     /* 349581 */ GIM_Reject,
     /* 349582 */ // Label 7008: @349582
     /* 349582 */ GIM_Reject,
     /* 349583 */ // Label 87: @349583
     /* 349583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7032*/ GIMT_Encode4(349748),
     /* 349594 */ /*GILLT_s32*//*Label 7030*/ GIMT_Encode4(349602),
     /* 349598 */ /*GILLT_s64*//*Label 7031*/ GIMT_Encode4(349675),
     /* 349602 */ // Label 7030: @349602
     /* 349602 */ GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(349628), // Rule ID 4799 //
     /* 349607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 349613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349617 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 349617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 349622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349626 */   GIR_RootConstrainSelectedInstOperands,
     /* 349627 */   // GIR_Coverage, 4799,
     /* 349627 */   GIR_Done,
     /* 349628 */ // Label 7033: @349628
     /* 349628 */ GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(349651), // Rule ID 4805 //
     /* 349633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 349636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349640 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 349640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 349645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349649 */   GIR_RootConstrainSelectedInstOperands,
     /* 349650 */   // GIR_Coverage, 4805,
     /* 349650 */   GIR_Done,
     /* 349651 */ // Label 7034: @349651
     /* 349651 */ GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(349674), // Rule ID 4807 //
     /* 349656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 349659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349663 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 349663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 349668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349672 */   GIR_RootConstrainSelectedInstOperands,
     /* 349673 */   // GIR_Coverage, 4807,
     /* 349673 */   GIR_Done,
     /* 349674 */ // Label 7035: @349674
     /* 349674 */ GIM_Reject,
     /* 349675 */ // Label 7031: @349675
     /* 349675 */ GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(349701), // Rule ID 4801 //
     /* 349680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 349686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349690 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 349690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 349695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349699 */   GIR_RootConstrainSelectedInstOperands,
     /* 349700 */   // GIR_Coverage, 4801,
     /* 349700 */   GIR_Done,
     /* 349701 */ // Label 7036: @349701
     /* 349701 */ GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(349724), // Rule ID 4809 //
     /* 349706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 349709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349713 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 349713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 349718 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349722 */   GIR_RootConstrainSelectedInstOperands,
     /* 349723 */   // GIR_Coverage, 4809,
     /* 349723 */   GIR_Done,
     /* 349724 */ // Label 7037: @349724
     /* 349724 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(349747), // Rule ID 4811 //
     /* 349729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 349732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349736 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 349736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 349741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349745 */   GIR_RootConstrainSelectedInstOperands,
     /* 349746 */   // GIR_Coverage, 4811,
     /* 349746 */   GIR_Done,
     /* 349747 */ // Label 7038: @349747
     /* 349747 */ GIM_Reject,
     /* 349748 */ // Label 7032: @349748
     /* 349748 */ GIM_Reject,
     /* 349749 */ // Label 88: @349749
     /* 349749 */ GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(349847),
     /* 349754 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 349757 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7043*/ GIMT_Encode4(349846),
     /* 349768 */   /*GILLT_s16*//*Label 7040*/ GIMT_Encode4(349780),
     /* 349772 */   /*GILLT_s32*//*Label 7041*/ GIMT_Encode4(349804),
     /* 349776 */   /*GILLT_s64*//*Label 7042*/ GIMT_Encode4(349825),
     /* 349780 */   // Label 7040: @349780
     /* 349780 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(349803), // Rule ID 4803 //
     /* 349785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349792 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 349792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 349797 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349801 */     GIR_RootConstrainSelectedInstOperands,
     /* 349802 */     // GIR_Coverage, 4803,
     /* 349802 */     GIR_Done,
     /* 349803 */   // Label 7044: @349803
     /* 349803 */   GIM_Reject,
     /* 349804 */   // Label 7041: @349804
     /* 349804 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(349824), // Rule ID 4813 //
     /* 349809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349813 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 349813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 349818 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349822 */     GIR_RootConstrainSelectedInstOperands,
     /* 349823 */     // GIR_Coverage, 4813,
     /* 349823 */     GIR_Done,
     /* 349824 */   // Label 7045: @349824
     /* 349824 */   GIM_Reject,
     /* 349825 */   // Label 7042: @349825
     /* 349825 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(349845), // Rule ID 4815 //
     /* 349830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349834 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 349834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 349839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349843 */     GIR_RootConstrainSelectedInstOperands,
     /* 349844 */     // GIR_Coverage, 4815,
     /* 349844 */     GIR_Done,
     /* 349845 */   // Label 7046: @349845
     /* 349845 */   GIM_Reject,
     /* 349846 */   // Label 7043: @349846
     /* 349846 */   GIM_Reject,
     /* 349847 */ // Label 7039: @349847
     /* 349847 */ GIM_Reject,
     /* 349848 */ // Label 89: @349848
     /* 349848 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(349863), // Rule ID 229 //
     /* 349853 */   // MIs[0] addr
     /* 349853 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 349856 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 349856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 349861 */   GIR_RootConstrainSelectedInstOperands,
     /* 349862 */   // GIR_Coverage, 229,
     /* 349862 */   GIR_Done,
     /* 349863 */ // Label 7047: @349863
     /* 349863 */ GIM_Reject,
     /* 349864 */ // Label 90: @349864
     /* 349864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7059*/ GIMT_Encode4(355235),
     /* 349875 */ /*GILLT_s64*//*Label 7048*/ GIMT_Encode4(349947), GIMT_Encode4(0),
     /* 349883 */ /*GILLT_v2s32*//*Label 7049*/ GIMT_Encode4(350349), GIMT_Encode4(0),
     /* 349891 */ /*GILLT_v4s16*//*Label 7050*/ GIMT_Encode4(350751), GIMT_Encode4(0),
     /* 349899 */ /*GILLT_v8s8*//*Label 7051*/ GIMT_Encode4(351153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 349911 */ /*GILLT_nxv1s1*//*Label 7052*/ GIMT_Encode4(351333),
     /* 349915 */ /*GILLT_nxv2s1*//*Label 7053*/ GIMT_Encode4(353596),
     /* 349919 */ /*GILLT_nxv2s16*//*Label 7054*/ GIMT_Encode4(354451),
     /* 349923 */ /*GILLT_nxv2s32*//*Label 7055*/ GIMT_Encode4(354738), GIMT_Encode4(0),
     /* 349931 */ /*GILLT_nxv4s1*//*Label 7056*/ GIMT_Encode4(354808),
     /* 349935 */ /*GILLT_nxv4s16*//*Label 7057*/ GIMT_Encode4(355095), GIMT_Encode4(0),
     /* 349943 */ /*GILLT_nxv8s1*//*Label 7058*/ GIMT_Encode4(355165),
     /* 349947 */ // Label 7048: @349947
     /* 349947 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(350348),
     /* 349952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 349955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349959 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(350011), // Rule ID 5628 //
     /* 349964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349976 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349983 */     // MIs[0] Operand 2
     /* 349983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349996 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 349996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 349999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350009 */     GIR_RootConstrainSelectedInstOperands,
     /* 350010 */     // GIR_Coverage, 5628,
     /* 350010 */     GIR_EraseRootFromParent_Done,
     /* 350011 */   // Label 7061: @350011
     /* 350011 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350063), // Rule ID 5631 //
     /* 350016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350028 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350035 */     // MIs[0] Operand 2
     /* 350035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350048 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 350048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 350051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350061 */     GIR_RootConstrainSelectedInstOperands,
     /* 350062 */     // GIR_Coverage, 5631,
     /* 350062 */     GIR_EraseRootFromParent_Done,
     /* 350063 */   // Label 7062: @350063
     /* 350063 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350131), // Rule ID 5507 //
     /* 350068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350072 */     // MIs[0] Operand 2
     /* 350072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350083 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350113 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350130 */     // GIR_Coverage, 5507,
     /* 350130 */     GIR_EraseRootFromParent_Done,
     /* 350131 */   // Label 7063: @350131
     /* 350131 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350199), // Rule ID 5512 //
     /* 350136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350140 */     // MIs[0] Operand 2
     /* 350140 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350151 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350181 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350198 */     // GIR_Coverage, 5512,
     /* 350198 */     GIR_EraseRootFromParent_Done,
     /* 350199 */   // Label 7064: @350199
     /* 350199 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350241), // Rule ID 6969 //
     /* 350204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350208 */     // MIs[0] Operand 2
     /* 350208 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350219 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 350219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350224 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350240 */     // GIR_Coverage, 6969,
     /* 350240 */     GIR_EraseRootFromParent_Done,
     /* 350241 */   // Label 7065: @350241
     /* 350241 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350283), // Rule ID 6970 //
     /* 350246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350250 */     // MIs[0] Operand 2
     /* 350250 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350261 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 350261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350266 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350282 */     // GIR_Coverage, 6970,
     /* 350282 */     GIR_EraseRootFromParent_Done,
     /* 350283 */   // Label 7066: @350283
     /* 350283 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350347), // Rule ID 6974 //
     /* 350288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350292 */     // MIs[0] Operand 2
     /* 350292 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350303 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 350303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 350310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350319 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 350322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350329 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350346 */     // GIR_Coverage, 6974,
     /* 350346 */     GIR_EraseRootFromParent_Done,
     /* 350347 */   // Label 7067: @350347
     /* 350347 */   GIM_Reject,
     /* 350348 */ // Label 7060: @350348
     /* 350348 */ GIM_Reject,
     /* 350349 */ // Label 7049: @350349
     /* 350349 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350750),
     /* 350354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350361 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350413), // Rule ID 5627 //
     /* 350366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350378 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350385 */     // MIs[0] Operand 2
     /* 350385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350398 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 350398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 350401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350411 */     GIR_RootConstrainSelectedInstOperands,
     /* 350412 */     // GIR_Coverage, 5627,
     /* 350412 */     GIR_EraseRootFromParent_Done,
     /* 350413 */   // Label 7069: @350413
     /* 350413 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350465), // Rule ID 5630 //
     /* 350418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350430 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350437 */     // MIs[0] Operand 2
     /* 350437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350450 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 350450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 350453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350463 */     GIR_RootConstrainSelectedInstOperands,
     /* 350464 */     // GIR_Coverage, 5630,
     /* 350464 */     GIR_EraseRootFromParent_Done,
     /* 350465 */   // Label 7070: @350465
     /* 350465 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350533), // Rule ID 5497 //
     /* 350470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350474 */     // MIs[0] Operand 2
     /* 350474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350485 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350505 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350532 */     // GIR_Coverage, 5497,
     /* 350532 */     GIR_EraseRootFromParent_Done,
     /* 350533 */   // Label 7071: @350533
     /* 350533 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350601), // Rule ID 5502 //
     /* 350538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350542 */     // MIs[0] Operand 2
     /* 350542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350553 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350583 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350600 */     // GIR_Coverage, 5502,
     /* 350600 */     GIR_EraseRootFromParent_Done,
     /* 350601 */   // Label 7072: @350601
     /* 350601 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350643), // Rule ID 6966 //
     /* 350606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350610 */     // MIs[0] Operand 2
     /* 350610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350621 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 350621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350626 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350642 */     // GIR_Coverage, 6966,
     /* 350642 */     GIR_EraseRootFromParent_Done,
     /* 350643 */   // Label 7073: @350643
     /* 350643 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(350685), // Rule ID 6968 //
     /* 350648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350652 */     // MIs[0] Operand 2
     /* 350652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350663 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 350663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350668 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350684 */     // GIR_Coverage, 6968,
     /* 350684 */     GIR_EraseRootFromParent_Done,
     /* 350685 */   // Label 7074: @350685
     /* 350685 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(350749), // Rule ID 6973 //
     /* 350690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350694 */     // MIs[0] Operand 2
     /* 350694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350705 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 350705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 350712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 350724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350731 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350748 */     // GIR_Coverage, 6973,
     /* 350748 */     GIR_EraseRootFromParent_Done,
     /* 350749 */   // Label 7075: @350749
     /* 350749 */   GIM_Reject,
     /* 350750 */ // Label 7068: @350750
     /* 350750 */ GIM_Reject,
     /* 350751 */ // Label 7050: @350751
     /* 350751 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(351152),
     /* 350756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350763 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(350815), // Rule ID 5626 //
     /* 350768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350780 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350787 */     // MIs[0] Operand 2
     /* 350787 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350800 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 350800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 350803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350813 */     GIR_RootConstrainSelectedInstOperands,
     /* 350814 */     // GIR_Coverage, 5626,
     /* 350814 */     GIR_EraseRootFromParent_Done,
     /* 350815 */   // Label 7077: @350815
     /* 350815 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(350867), // Rule ID 5629 //
     /* 350820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350832 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350839 */     // MIs[0] Operand 2
     /* 350839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350852 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 350852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 350855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350865 */     GIR_RootConstrainSelectedInstOperands,
     /* 350866 */     // GIR_Coverage, 5629,
     /* 350866 */     GIR_EraseRootFromParent_Done,
     /* 350867 */   // Label 7078: @350867
     /* 350867 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(350935), // Rule ID 5487 //
     /* 350872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350876 */     // MIs[0] Operand 2
     /* 350876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350887 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350934 */     // GIR_Coverage, 5487,
     /* 350934 */     GIR_EraseRootFromParent_Done,
     /* 350935 */   // Label 7079: @350935
     /* 350935 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351003), // Rule ID 5492 //
     /* 350940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350944 */     // MIs[0] Operand 2
     /* 350944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350955 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350975 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351002 */     // GIR_Coverage, 5492,
     /* 351002 */     GIR_EraseRootFromParent_Done,
     /* 351003 */   // Label 7080: @351003
     /* 351003 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351045), // Rule ID 6964 //
     /* 351008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351012 */     // MIs[0] Operand 2
     /* 351012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351023 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 351023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351028 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 351034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351044 */     // GIR_Coverage, 6964,
     /* 351044 */     GIR_EraseRootFromParent_Done,
     /* 351045 */   // Label 7081: @351045
     /* 351045 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351087), // Rule ID 6967 //
     /* 351050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351054 */     // MIs[0] Operand 2
     /* 351054 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351065 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 351065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351070 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 351076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351086 */     // GIR_Coverage, 6967,
     /* 351086 */     GIR_EraseRootFromParent_Done,
     /* 351087 */   // Label 7082: @351087
     /* 351087 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351151), // Rule ID 6972 //
     /* 351092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351096 */     // MIs[0] Operand 2
     /* 351096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351107 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 351107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 351114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 351123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 351126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351150 */     // GIR_Coverage, 6972,
     /* 351150 */     GIR_EraseRootFromParent_Done,
     /* 351151 */   // Label 7083: @351151
     /* 351151 */   GIM_Reject,
     /* 351152 */ // Label 7076: @351152
     /* 351152 */ GIM_Reject,
     /* 351153 */ // Label 7051: @351153
     /* 351153 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351332),
     /* 351158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351169 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351233), // Rule ID 5482 //
     /* 351174 */     // MIs[0] Operand 2
     /* 351174 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351185 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 351185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 351192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 351201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 351205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 351208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351215 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351232 */     // GIR_Coverage, 5482,
     /* 351232 */     GIR_EraseRootFromParent_Done,
     /* 351233 */   // Label 7085: @351233
     /* 351233 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351271), // Rule ID 6965 //
     /* 351238 */     // MIs[0] Operand 2
     /* 351238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351249 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 351249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351254 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 351260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351270 */     // GIR_Coverage, 6965,
     /* 351270 */     GIR_EraseRootFromParent_Done,
     /* 351271 */   // Label 7086: @351271
     /* 351271 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351331), // Rule ID 6971 //
     /* 351276 */     // MIs[0] Operand 2
     /* 351276 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351287 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 351287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 351294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 351303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 351306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351313 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351330 */     // GIR_Coverage, 6971,
     /* 351330 */     GIR_EraseRootFromParent_Done,
     /* 351331 */   // Label 7087: @351331
     /* 351331 */   GIM_Reject,
     /* 351332 */ // Label 7084: @351332
     /* 351332 */ GIM_Reject,
     /* 351333 */ // Label 7052: @351333
     /* 351333 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351368), // Rule ID 9094 //
     /* 351338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 351344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351348 */   // MIs[0] Operand 2
     /* 351348 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351359 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 351359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351364 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351366 */   GIR_RootConstrainSelectedInstOperands,
     /* 351367 */   // GIR_Coverage, 9094,
     /* 351367 */   GIR_EraseRootFromParent_Done,
     /* 351368 */ // Label 7088: @351368
     /* 351368 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351403), // Rule ID 9095 //
     /* 351373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 351379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351383 */   // MIs[0] Operand 2
     /* 351383 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351394 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 351394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351399 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351401 */   GIR_RootConstrainSelectedInstOperands,
     /* 351402 */   // GIR_Coverage, 9095,
     /* 351402 */   GIR_EraseRootFromParent_Done,
     /* 351403 */ // Label 7089: @351403
     /* 351403 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351457), // Rule ID 9102 //
     /* 351408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351418 */   // MIs[0] Operand 2
     /* 351418 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351429 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351455 */   GIR_RootConstrainSelectedInstOperands,
     /* 351456 */   // GIR_Coverage, 9102,
     /* 351456 */   GIR_EraseRootFromParent_Done,
     /* 351457 */ // Label 7090: @351457
     /* 351457 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351511), // Rule ID 9103 //
     /* 351462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351472 */   // MIs[0] Operand 2
     /* 351472 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351483 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351509 */   GIR_RootConstrainSelectedInstOperands,
     /* 351510 */   // GIR_Coverage, 9103,
     /* 351510 */   GIR_EraseRootFromParent_Done,
     /* 351511 */ // Label 7091: @351511
     /* 351511 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351565), // Rule ID 9104 //
     /* 351516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351526 */   // MIs[0] Operand 2
     /* 351526 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351537 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351563 */   GIR_RootConstrainSelectedInstOperands,
     /* 351564 */   // GIR_Coverage, 9104,
     /* 351564 */   GIR_EraseRootFromParent_Done,
     /* 351565 */ // Label 7092: @351565
     /* 351565 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351619), // Rule ID 9105 //
     /* 351570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351580 */   // MIs[0] Operand 2
     /* 351580 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 351591 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351617 */   GIR_RootConstrainSelectedInstOperands,
     /* 351618 */   // GIR_Coverage, 9105,
     /* 351618 */   GIR_EraseRootFromParent_Done,
     /* 351619 */ // Label 7093: @351619
     /* 351619 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351690), // Rule ID 9114 //
     /* 351624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351634 */   // MIs[0] Operand 2
     /* 351634 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351645 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351645 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351648 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351652 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351657 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351675 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351688 */   GIR_RootConstrainSelectedInstOperands,
     /* 351689 */   // GIR_Coverage, 9114,
     /* 351689 */   GIR_EraseRootFromParent_Done,
     /* 351690 */ // Label 7094: @351690
     /* 351690 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(351761), // Rule ID 9115 //
     /* 351695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351705 */   // MIs[0] Operand 2
     /* 351705 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351716 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351746 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351759 */   GIR_RootConstrainSelectedInstOperands,
     /* 351760 */   // GIR_Coverage, 9115,
     /* 351760 */   GIR_EraseRootFromParent_Done,
     /* 351761 */ // Label 7095: @351761
     /* 351761 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351832), // Rule ID 9116 //
     /* 351766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351776 */   // MIs[0] Operand 2
     /* 351776 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351787 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351787 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351790 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351794 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351799 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351817 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351830 */   GIR_RootConstrainSelectedInstOperands,
     /* 351831 */   // GIR_Coverage, 9116,
     /* 351831 */   GIR_EraseRootFromParent_Done,
     /* 351832 */ // Label 7096: @351832
     /* 351832 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(351903), // Rule ID 9117 //
     /* 351837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351847 */   // MIs[0] Operand 2
     /* 351847 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 351858 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351858 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351861 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351865 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351870 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351888 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351901 */   GIR_RootConstrainSelectedInstOperands,
     /* 351902 */   // GIR_Coverage, 9117,
     /* 351902 */   GIR_EraseRootFromParent_Done,
     /* 351903 */ // Label 7097: @351903
     /* 351903 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(351974), // Rule ID 9118 //
     /* 351908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351918 */   // MIs[0] Operand 2
     /* 351918 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351929 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351929 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351932 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351936 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351941 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351959 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351972 */   GIR_RootConstrainSelectedInstOperands,
     /* 351973 */   // GIR_Coverage, 9118,
     /* 351973 */   GIR_EraseRootFromParent_Done,
     /* 351974 */ // Label 7098: @351974
     /* 351974 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352045), // Rule ID 9119 //
     /* 351979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351989 */   // MIs[0] Operand 2
     /* 351989 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 352000 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 352000 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352003 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352007 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352012 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352030 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352043 */   GIR_RootConstrainSelectedInstOperands,
     /* 352044 */   // GIR_Coverage, 9119,
     /* 352044 */   GIR_EraseRootFromParent_Done,
     /* 352045 */ // Label 7099: @352045
     /* 352045 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352116), // Rule ID 9120 //
     /* 352050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352060 */   // MIs[0] Operand 2
     /* 352060 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352071 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 352071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352101 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352114 */   GIR_RootConstrainSelectedInstOperands,
     /* 352115 */   // GIR_Coverage, 9120,
     /* 352115 */   GIR_EraseRootFromParent_Done,
     /* 352116 */ // Label 7100: @352116
     /* 352116 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352187), // Rule ID 9121 //
     /* 352121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352131 */   // MIs[0] Operand 2
     /* 352131 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 352142 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 352142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352172 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352185 */   GIR_RootConstrainSelectedInstOperands,
     /* 352186 */   // GIR_Coverage, 9121,
     /* 352186 */   GIR_EraseRootFromParent_Done,
     /* 352187 */ // Label 7101: @352187
     /* 352187 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352275), // Rule ID 9130 //
     /* 352192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352202 */   // MIs[0] Operand 2
     /* 352202 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352213 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352213 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352216 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352220 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352225 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352231 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352234 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352238 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352243 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352273 */   GIR_RootConstrainSelectedInstOperands,
     /* 352274 */   // GIR_Coverage, 9130,
     /* 352274 */   GIR_EraseRootFromParent_Done,
     /* 352275 */ // Label 7102: @352275
     /* 352275 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(352363), // Rule ID 9131 //
     /* 352280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352290 */   // MIs[0] Operand 2
     /* 352290 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 352301 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352313 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352331 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352361 */   GIR_RootConstrainSelectedInstOperands,
     /* 352362 */   // GIR_Coverage, 9131,
     /* 352362 */   GIR_EraseRootFromParent_Done,
     /* 352363 */ // Label 7103: @352363
     /* 352363 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352451), // Rule ID 9132 //
     /* 352368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352378 */   // MIs[0] Operand 2
     /* 352378 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352389 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352389 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352392 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352396 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352401 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352419 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352449 */   GIR_RootConstrainSelectedInstOperands,
     /* 352450 */   // GIR_Coverage, 9132,
     /* 352450 */   GIR_EraseRootFromParent_Done,
     /* 352451 */ // Label 7104: @352451
     /* 352451 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352539), // Rule ID 9133 //
     /* 352456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352466 */   // MIs[0] Operand 2
     /* 352466 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 352477 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352477 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352480 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352484 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352489 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352495 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352498 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352502 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352507 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352537 */   GIR_RootConstrainSelectedInstOperands,
     /* 352538 */   // GIR_Coverage, 9133,
     /* 352538 */   GIR_EraseRootFromParent_Done,
     /* 352539 */ // Label 7105: @352539
     /* 352539 */ GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352627), // Rule ID 9134 //
     /* 352544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352554 */   // MIs[0] Operand 2
     /* 352554 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352565 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352565 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352568 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352572 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352577 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352583 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352586 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352590 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352595 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352612 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352625 */   GIR_RootConstrainSelectedInstOperands,
     /* 352626 */   // GIR_Coverage, 9134,
     /* 352626 */   GIR_EraseRootFromParent_Done,
     /* 352627 */ // Label 7106: @352627
     /* 352627 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352715), // Rule ID 9135 //
     /* 352632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352642 */   // MIs[0] Operand 2
     /* 352642 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 352653 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352653 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352656 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352660 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352665 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352683 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352700 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352713 */   GIR_RootConstrainSelectedInstOperands,
     /* 352714 */   // GIR_Coverage, 9135,
     /* 352714 */   GIR_EraseRootFromParent_Done,
     /* 352715 */ // Label 7107: @352715
     /* 352715 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352803), // Rule ID 9136 //
     /* 352720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352730 */   // MIs[0] Operand 2
     /* 352730 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352741 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352741 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352744 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352748 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352753 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352759 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352762 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352766 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352771 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352801 */   GIR_RootConstrainSelectedInstOperands,
     /* 352802 */   // GIR_Coverage, 9136,
     /* 352802 */   GIR_EraseRootFromParent_Done,
     /* 352803 */ // Label 7108: @352803
     /* 352803 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(352891), // Rule ID 9137 //
     /* 352808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352818 */   // MIs[0] Operand 2
     /* 352818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 352829 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352829 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352832 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352836 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352841 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352859 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352876 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352889 */   GIR_RootConstrainSelectedInstOperands,
     /* 352890 */   // GIR_Coverage, 9137,
     /* 352890 */   GIR_EraseRootFromParent_Done,
     /* 352891 */ // Label 7109: @352891
     /* 352891 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352979), // Rule ID 9138 //
     /* 352896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352906 */   // MIs[0] Operand 2
     /* 352906 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352917 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352917 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352920 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352924 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352929 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352935 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352938 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352942 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352947 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352964 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352977 */   GIR_RootConstrainSelectedInstOperands,
     /* 352978 */   // GIR_Coverage, 9138,
     /* 352978 */   GIR_EraseRootFromParent_Done,
     /* 352979 */ // Label 7110: @352979
     /* 352979 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353067), // Rule ID 9139 //
     /* 352984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352994 */   // MIs[0] Operand 2
     /* 352994 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 353005 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353005 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353008 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353012 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353017 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353023 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353026 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353030 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353035 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353065 */   GIR_RootConstrainSelectedInstOperands,
     /* 353066 */   // GIR_Coverage, 9139,
     /* 353066 */   GIR_EraseRootFromParent_Done,
     /* 353067 */ // Label 7111: @353067
     /* 353067 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353155), // Rule ID 9140 //
     /* 353072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353082 */   // MIs[0] Operand 2
     /* 353082 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 353093 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353105 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353123 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353153 */   GIR_RootConstrainSelectedInstOperands,
     /* 353154 */   // GIR_Coverage, 9140,
     /* 353154 */   GIR_EraseRootFromParent_Done,
     /* 353155 */ // Label 7112: @353155
     /* 353155 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353243), // Rule ID 9141 //
     /* 353160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353170 */   // MIs[0] Operand 2
     /* 353170 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 353181 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353181 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353184 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353188 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353193 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353199 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353202 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353206 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353211 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353241 */   GIR_RootConstrainSelectedInstOperands,
     /* 353242 */   // GIR_Coverage, 9141,
     /* 353242 */   GIR_EraseRootFromParent_Done,
     /* 353243 */ // Label 7113: @353243
     /* 353243 */ GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353331), // Rule ID 9142 //
     /* 353248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353258 */   // MIs[0] Operand 2
     /* 353258 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 353269 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353269 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353272 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353276 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353281 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353299 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353329 */   GIR_RootConstrainSelectedInstOperands,
     /* 353330 */   // GIR_Coverage, 9142,
     /* 353330 */   GIR_EraseRootFromParent_Done,
     /* 353331 */ // Label 7114: @353331
     /* 353331 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353419), // Rule ID 9143 //
     /* 353336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353346 */   // MIs[0] Operand 2
     /* 353346 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 353357 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353357 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353360 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353364 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353369 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353375 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353378 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353382 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353387 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353404 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353417 */   GIR_RootConstrainSelectedInstOperands,
     /* 353418 */   // GIR_Coverage, 9143,
     /* 353418 */   GIR_EraseRootFromParent_Done,
     /* 353419 */ // Label 7115: @353419
     /* 353419 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353507), // Rule ID 9144 //
     /* 353424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353434 */   // MIs[0] Operand 2
     /* 353434 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 353445 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353445 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353448 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353452 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353457 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353475 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353492 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353505 */   GIR_RootConstrainSelectedInstOperands,
     /* 353506 */   // GIR_Coverage, 9144,
     /* 353506 */   GIR_EraseRootFromParent_Done,
     /* 353507 */ // Label 7116: @353507
     /* 353507 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353595), // Rule ID 9145 //
     /* 353512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353522 */   // MIs[0] Operand 2
     /* 353522 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 353533 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353545 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353551 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353554 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353558 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353563 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353580 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353593 */   GIR_RootConstrainSelectedInstOperands,
     /* 353594 */   // GIR_Coverage, 9145,
     /* 353594 */   GIR_EraseRootFromParent_Done,
     /* 353595 */ // Label 7117: @353595
     /* 353595 */ GIM_Reject,
     /* 353596 */ // Label 7053: @353596
     /* 353596 */ GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353631), // Rule ID 9096 //
     /* 353601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 353607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353611 */   // MIs[0] Operand 2
     /* 353611 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353622 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 353622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353627 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353629 */   GIR_RootConstrainSelectedInstOperands,
     /* 353630 */   // GIR_Coverage, 9096,
     /* 353630 */   GIR_EraseRootFromParent_Done,
     /* 353631 */ // Label 7118: @353631
     /* 353631 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353666), // Rule ID 9097 //
     /* 353636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 353642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353646 */   // MIs[0] Operand 2
     /* 353646 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353657 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 353657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353662 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353664 */   GIR_RootConstrainSelectedInstOperands,
     /* 353665 */   // GIR_Coverage, 9097,
     /* 353665 */   GIR_EraseRootFromParent_Done,
     /* 353666 */ // Label 7119: @353666
     /* 353666 */ GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353720), // Rule ID 9106 //
     /* 353671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353681 */   // MIs[0] Operand 2
     /* 353681 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353692 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353704 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353718 */   GIR_RootConstrainSelectedInstOperands,
     /* 353719 */   // GIR_Coverage, 9106,
     /* 353719 */   GIR_EraseRootFromParent_Done,
     /* 353720 */ // Label 7120: @353720
     /* 353720 */ GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(353774), // Rule ID 9107 //
     /* 353725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353735 */   // MIs[0] Operand 2
     /* 353735 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353746 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353772 */   GIR_RootConstrainSelectedInstOperands,
     /* 353773 */   // GIR_Coverage, 9107,
     /* 353773 */   GIR_EraseRootFromParent_Done,
     /* 353774 */ // Label 7121: @353774
     /* 353774 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353828), // Rule ID 9108 //
     /* 353779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353789 */   // MIs[0] Operand 2
     /* 353789 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353800 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353812 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353826 */   GIR_RootConstrainSelectedInstOperands,
     /* 353827 */   // GIR_Coverage, 9108,
     /* 353827 */   GIR_EraseRootFromParent_Done,
     /* 353828 */ // Label 7122: @353828
     /* 353828 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(353882), // Rule ID 9109 //
     /* 353833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353843 */   // MIs[0] Operand 2
     /* 353843 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 353854 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353880 */   GIR_RootConstrainSelectedInstOperands,
     /* 353881 */   // GIR_Coverage, 9109,
     /* 353881 */   GIR_EraseRootFromParent_Done,
     /* 353882 */ // Label 7123: @353882
     /* 353882 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353953), // Rule ID 9122 //
     /* 353887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353897 */   // MIs[0] Operand 2
     /* 353897 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353908 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353908 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353911 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353915 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353920 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353938 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353951 */   GIR_RootConstrainSelectedInstOperands,
     /* 353952 */   // GIR_Coverage, 9122,
     /* 353952 */   GIR_EraseRootFromParent_Done,
     /* 353953 */ // Label 7124: @353953
     /* 353953 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(354024), // Rule ID 9123 //
     /* 353958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353968 */   // MIs[0] Operand 2
     /* 353968 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353979 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353982 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353986 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353991 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354009 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354022 */   GIR_RootConstrainSelectedInstOperands,
     /* 354023 */   // GIR_Coverage, 9123,
     /* 354023 */   GIR_EraseRootFromParent_Done,
     /* 354024 */ // Label 7125: @354024
     /* 354024 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(354095), // Rule ID 9124 //
     /* 354029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354039 */   // MIs[0] Operand 2
     /* 354039 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354050 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354050 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354053 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354057 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354062 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354080 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354093 */   GIR_RootConstrainSelectedInstOperands,
     /* 354094 */   // GIR_Coverage, 9124,
     /* 354094 */   GIR_EraseRootFromParent_Done,
     /* 354095 */ // Label 7126: @354095
     /* 354095 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(354166), // Rule ID 9125 //
     /* 354100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354110 */   // MIs[0] Operand 2
     /* 354110 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 354121 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354133 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354151 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354164 */   GIR_RootConstrainSelectedInstOperands,
     /* 354165 */   // GIR_Coverage, 9125,
     /* 354165 */   GIR_EraseRootFromParent_Done,
     /* 354166 */ // Label 7127: @354166
     /* 354166 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(354237), // Rule ID 9126 //
     /* 354171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354181 */   // MIs[0] Operand 2
     /* 354181 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 354192 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354192 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354195 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354199 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354204 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354222 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354235 */   GIR_RootConstrainSelectedInstOperands,
     /* 354236 */   // GIR_Coverage, 9126,
     /* 354236 */   GIR_EraseRootFromParent_Done,
     /* 354237 */ // Label 7128: @354237
     /* 354237 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(354308), // Rule ID 9127 //
     /* 354242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354252 */   // MIs[0] Operand 2
     /* 354252 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 354263 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354263 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354266 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354270 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354275 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354306 */   GIR_RootConstrainSelectedInstOperands,
     /* 354307 */   // GIR_Coverage, 9127,
     /* 354307 */   GIR_EraseRootFromParent_Done,
     /* 354308 */ // Label 7129: @354308
     /* 354308 */ GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(354379), // Rule ID 9128 //
     /* 354313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354323 */   // MIs[0] Operand 2
     /* 354323 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 354334 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354334 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354337 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354341 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354346 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354364 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354377 */   GIR_RootConstrainSelectedInstOperands,
     /* 354378 */   // GIR_Coverage, 9128,
     /* 354378 */   GIR_EraseRootFromParent_Done,
     /* 354379 */ // Label 7130: @354379
     /* 354379 */ GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(354450), // Rule ID 9129 //
     /* 354384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354394 */   // MIs[0] Operand 2
     /* 354394 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 354405 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354405 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354408 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354412 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354417 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354448 */   GIR_RootConstrainSelectedInstOperands,
     /* 354449 */   // GIR_Coverage, 9129,
     /* 354449 */   GIR_EraseRootFromParent_Done,
     /* 354450 */ // Label 7131: @354450
     /* 354450 */ GIM_Reject,
     /* 354451 */ // Label 7054: @354451
     /* 354451 */ GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354486), // Rule ID 9146 //
     /* 354456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 354462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354466 */   // MIs[0] Operand 2
     /* 354466 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354477 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 354477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354482 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354484 */   GIR_RootConstrainSelectedInstOperands,
     /* 354485 */   // GIR_Coverage, 9146,
     /* 354485 */   GIR_EraseRootFromParent_Done,
     /* 354486 */ // Label 7132: @354486
     /* 354486 */ GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354521), // Rule ID 9147 //
     /* 354491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 354497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354501 */   // MIs[0] Operand 2
     /* 354501 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354512 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 354512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354517 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354519 */   GIR_RootConstrainSelectedInstOperands,
     /* 354520 */   // GIR_Coverage, 9147,
     /* 354520 */   GIR_EraseRootFromParent_Done,
     /* 354521 */ // Label 7133: @354521
     /* 354521 */ GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(354575), // Rule ID 9152 //
     /* 354526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354536 */   // MIs[0] Operand 2
     /* 354536 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354547 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354547 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354550 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 354554 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354559 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354573 */   GIR_RootConstrainSelectedInstOperands,
     /* 354574 */   // GIR_Coverage, 9152,
     /* 354574 */   GIR_EraseRootFromParent_Done,
     /* 354575 */ // Label 7134: @354575
     /* 354575 */ GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(354629), // Rule ID 9153 //
     /* 354580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354590 */   // MIs[0] Operand 2
     /* 354590 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354601 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 354608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354613 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354627 */   GIR_RootConstrainSelectedInstOperands,
     /* 354628 */   // GIR_Coverage, 9153,
     /* 354628 */   GIR_EraseRootFromParent_Done,
     /* 354629 */ // Label 7135: @354629
     /* 354629 */ GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354683), // Rule ID 9154 //
     /* 354634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354644 */   // MIs[0] Operand 2
     /* 354644 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354655 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 354662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354667 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354681 */   GIR_RootConstrainSelectedInstOperands,
     /* 354682 */   // GIR_Coverage, 9154,
     /* 354682 */   GIR_EraseRootFromParent_Done,
     /* 354683 */ // Label 7136: @354683
     /* 354683 */ GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(354737), // Rule ID 9155 //
     /* 354688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354698 */   // MIs[0] Operand 2
     /* 354698 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 354709 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 354716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354735 */   GIR_RootConstrainSelectedInstOperands,
     /* 354736 */   // GIR_Coverage, 9155,
     /* 354736 */   GIR_EraseRootFromParent_Done,
     /* 354737 */ // Label 7137: @354737
     /* 354737 */ GIM_Reject,
     /* 354738 */ // Label 7055: @354738
     /* 354738 */ GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354807),
     /* 354743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354750 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354778), // Rule ID 9150 //
     /* 354755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354758 */     // MIs[0] Operand 2
     /* 354758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354769 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 354769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354776 */     GIR_RootConstrainSelectedInstOperands,
     /* 354777 */     // GIR_Coverage, 9150,
     /* 354777 */     GIR_EraseRootFromParent_Done,
     /* 354778 */   // Label 7139: @354778
     /* 354778 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354806), // Rule ID 9151 //
     /* 354783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354786 */     // MIs[0] Operand 2
     /* 354786 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354797 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 354797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354804 */     GIR_RootConstrainSelectedInstOperands,
     /* 354805 */     // GIR_Coverage, 9151,
     /* 354805 */     GIR_EraseRootFromParent_Done,
     /* 354806 */   // Label 7140: @354806
     /* 354806 */   GIM_Reject,
     /* 354807 */ // Label 7138: @354807
     /* 354807 */ GIM_Reject,
     /* 354808 */ // Label 7056: @354808
     /* 354808 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354843), // Rule ID 9098 //
     /* 354813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 354819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354823 */   // MIs[0] Operand 2
     /* 354823 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354834 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 354834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354839 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354841 */   GIR_RootConstrainSelectedInstOperands,
     /* 354842 */   // GIR_Coverage, 9098,
     /* 354842 */   GIR_EraseRootFromParent_Done,
     /* 354843 */ // Label 7141: @354843
     /* 354843 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354878), // Rule ID 9099 //
     /* 354848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 354854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354858 */   // MIs[0] Operand 2
     /* 354858 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354869 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 354869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354874 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354876 */   GIR_RootConstrainSelectedInstOperands,
     /* 354877 */   // GIR_Coverage, 9099,
     /* 354877 */   GIR_EraseRootFromParent_Done,
     /* 354878 */ // Label 7142: @354878
     /* 354878 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354932), // Rule ID 9110 //
     /* 354883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354893 */   // MIs[0] Operand 2
     /* 354893 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354904 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354916 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354930 */   GIR_RootConstrainSelectedInstOperands,
     /* 354931 */   // GIR_Coverage, 9110,
     /* 354931 */   GIR_EraseRootFromParent_Done,
     /* 354932 */ // Label 7143: @354932
     /* 354932 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(354986), // Rule ID 9111 //
     /* 354937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354947 */   // MIs[0] Operand 2
     /* 354947 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354958 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354970 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354984 */   GIR_RootConstrainSelectedInstOperands,
     /* 354985 */   // GIR_Coverage, 9111,
     /* 354985 */   GIR_EraseRootFromParent_Done,
     /* 354986 */ // Label 7144: @354986
     /* 354986 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(355040), // Rule ID 9112 //
     /* 354991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 355001 */   // MIs[0] Operand 2
     /* 355001 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 355012 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 355012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 355019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 355028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 355033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 355035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355038 */   GIR_RootConstrainSelectedInstOperands,
     /* 355039 */   // GIR_Coverage, 9112,
     /* 355039 */   GIR_EraseRootFromParent_Done,
     /* 355040 */ // Label 7145: @355040
     /* 355040 */ GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(355094), // Rule ID 9113 //
     /* 355045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 355051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 355055 */   // MIs[0] Operand 2
     /* 355055 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 355066 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 355066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 355073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 355082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 355087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 355089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355092 */   GIR_RootConstrainSelectedInstOperands,
     /* 355093 */   // GIR_Coverage, 9113,
     /* 355093 */   GIR_EraseRootFromParent_Done,
     /* 355094 */ // Label 7146: @355094
     /* 355094 */ GIM_Reject,
     /* 355095 */ // Label 7057: @355095
     /* 355095 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(355164),
     /* 355100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 355103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355107 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(355135), // Rule ID 9148 //
     /* 355112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355115 */     // MIs[0] Operand 2
     /* 355115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 355126 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 355126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 355129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 355133 */     GIR_RootConstrainSelectedInstOperands,
     /* 355134 */     // GIR_Coverage, 9148,
     /* 355134 */     GIR_EraseRootFromParent_Done,
     /* 355135 */   // Label 7148: @355135
     /* 355135 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(355163), // Rule ID 9149 //
     /* 355140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355143 */     // MIs[0] Operand 2
     /* 355143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 355154 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 355154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 355157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 355161 */     GIR_RootConstrainSelectedInstOperands,
     /* 355162 */     // GIR_Coverage, 9149,
     /* 355162 */     GIR_EraseRootFromParent_Done,
     /* 355163 */   // Label 7149: @355163
     /* 355163 */   GIM_Reject,
     /* 355164 */ // Label 7147: @355164
     /* 355164 */ GIM_Reject,
     /* 355165 */ // Label 7058: @355165
     /* 355165 */ GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355234),
     /* 355170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 355173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 355177 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355205), // Rule ID 9100 //
     /* 355182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355185 */     // MIs[0] Operand 2
     /* 355185 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 355196 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 355196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 355199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 355201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 355203 */     GIR_RootConstrainSelectedInstOperands,
     /* 355204 */     // GIR_Coverage, 9100,
     /* 355204 */     GIR_EraseRootFromParent_Done,
     /* 355205 */   // Label 7151: @355205
     /* 355205 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(355233), // Rule ID 9101 //
     /* 355210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355213 */     // MIs[0] Operand 2
     /* 355213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 355224 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 355224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 355227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 355229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 355231 */     GIR_RootConstrainSelectedInstOperands,
     /* 355232 */     // GIR_Coverage, 9101,
     /* 355232 */     GIR_EraseRootFromParent_Done,
     /* 355233 */   // Label 7152: @355233
     /* 355233 */   GIM_Reject,
     /* 355234 */ // Label 7150: @355234
     /* 355234 */ GIM_Reject,
     /* 355235 */ // Label 7059: @355235
     /* 355235 */ GIM_Reject,
     /* 355236 */ // Label 91: @355236
     /* 355236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7168*/ GIMT_Encode4(388157),
     /* 355247 */ /*GILLT_s64*//*Label 7153*/ GIMT_Encode4(355331), GIMT_Encode4(0),
     /* 355255 */ /*GILLT_v2s32*//*Label 7154*/ GIMT_Encode4(356041),
     /* 355259 */ /*GILLT_v2s64*//*Label 7155*/ GIMT_Encode4(359572),
     /* 355263 */ /*GILLT_v4s16*//*Label 7156*/ GIMT_Encode4(362813),
     /* 355267 */ /*GILLT_v4s32*//*Label 7157*/ GIMT_Encode4(366453),
     /* 355271 */ /*GILLT_v8s8*//*Label 7158*/ GIMT_Encode4(369521),
     /* 355275 */ /*GILLT_v8s16*//*Label 7159*/ GIMT_Encode4(372734),
     /* 355279 */ /*GILLT_v16s8*//*Label 7160*/ GIMT_Encode4(376153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355291 */ /*GILLT_nxv2s16*//*Label 7161*/ GIMT_Encode4(379357),
     /* 355295 */ /*GILLT_nxv2s32*//*Label 7162*/ GIMT_Encode4(379482),
     /* 355299 */ /*GILLT_nxv2s64*//*Label 7163*/ GIMT_Encode4(379607), GIMT_Encode4(0),
     /* 355307 */ /*GILLT_nxv4s16*//*Label 7164*/ GIMT_Encode4(381585),
     /* 355311 */ /*GILLT_nxv4s32*//*Label 7165*/ GIMT_Encode4(381737), GIMT_Encode4(0),
     /* 355319 */ /*GILLT_nxv8s16*//*Label 7166*/ GIMT_Encode4(383769), GIMT_Encode4(0),
     /* 355327 */ /*GILLT_nxv16s8*//*Label 7167*/ GIMT_Encode4(386037),
     /* 355331 */ // Label 7153: @355331
     /* 355331 */ GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(356040),
     /* 355336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 355342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355349 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(355479), // Rule ID 5784 //
     /* 355354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355387 */     // MIs[2] Operand 1
     /* 355387 */     // No operand predicates
     /* 355387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355395 */     // MIs[3] Operand 1
     /* 355395 */     // No operand predicates
     /* 355395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355397 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 355400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355416 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355441 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355478 */     // GIR_Coverage, 5784,
     /* 355478 */     GIR_EraseRootFromParent_Done,
     /* 355479 */   // Label 7170: @355479
     /* 355479 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(355640), // Rule ID 5785 //
     /* 355484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355517 */     // MIs[2] Operand 1
     /* 355517 */     // No operand predicates
     /* 355517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355525 */     // MIs[3] Operand 1
     /* 355525 */     // No operand predicates
     /* 355525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355527 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355539 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355542 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355546 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355554 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355622 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355639 */     // GIR_Coverage, 5785,
     /* 355639 */     GIR_EraseRootFromParent_Done,
     /* 355640 */   // Label 7171: @355640
     /* 355640 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(355770), // Rule ID 5824 //
     /* 355645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355678 */     // MIs[2] Operand 1
     /* 355678 */     // No operand predicates
     /* 355678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355686 */     // MIs[3] Operand 1
     /* 355686 */     // No operand predicates
     /* 355686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355688 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 355691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355700 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355707 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355752 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355769 */     // GIR_Coverage, 5824,
     /* 355769 */     GIR_EraseRootFromParent_Done,
     /* 355770 */   // Label 7172: @355770
     /* 355770 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(355931), // Rule ID 5825 //
     /* 355775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355808 */     // MIs[2] Operand 1
     /* 355808 */     // No operand predicates
     /* 355808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355816 */     // MIs[3] Operand 1
     /* 355816 */     // No operand predicates
     /* 355816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355818 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355818 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355821 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355825 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355830 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355833 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355837 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355840 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355845 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355869 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355930 */     // GIR_Coverage, 5825,
     /* 355930 */     GIR_EraseRootFromParent_Done,
     /* 355931 */   // Label 7173: @355931
     /* 355931 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(355967), // Rule ID 6745 //
     /* 355936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355954 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 355954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 355961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355966 */     // GIR_Coverage, 6745,
     /* 355966 */     GIR_EraseRootFromParent_Done,
     /* 355967 */   // Label 7174: @355967
     /* 355967 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(356003), // Rule ID 6747 //
     /* 355972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355990 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 355990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 355997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356002 */     // GIR_Coverage, 6747,
     /* 356002 */     GIR_EraseRootFromParent_Done,
     /* 356003 */   // Label 7175: @356003
     /* 356003 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(356039), // Rule ID 6749 //
     /* 356008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356026 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 356026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356029 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 356031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 356033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356038 */     // GIR_Coverage, 6749,
     /* 356038 */     GIR_EraseRootFromParent_Done,
     /* 356039 */   // Label 7176: @356039
     /* 356039 */   GIM_Reject,
     /* 356040 */ // Label 7169: @356040
     /* 356040 */ GIM_Reject,
     /* 356041 */ // Label 7154: @356041
     /* 356041 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(359571),
     /* 356046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356059 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(356168), // Rule ID 4341 //
     /* 356064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356068 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356074 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356084 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356108 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356167 */     // GIR_Coverage, 4341,
     /* 356167 */     GIR_EraseRootFromParent_Done,
     /* 356168 */   // Label 7178: @356168
     /* 356168 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(356277), // Rule ID 4342 //
     /* 356173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356193 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356196 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356200 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356217 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356244 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356276 */     // GIR_Coverage, 4342,
     /* 356276 */     GIR_EraseRootFromParent_Done,
     /* 356277 */   // Label 7179: @356277
     /* 356277 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(356386), // Rule ID 4449 //
     /* 356282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356286 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356292 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356302 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356309 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356326 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356385 */     // GIR_Coverage, 4449,
     /* 356385 */     GIR_EraseRootFromParent_Done,
     /* 356386 */   // Label 7180: @356386
     /* 356386 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(356495), // Rule ID 4450 //
     /* 356391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356411 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356418 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356435 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356494 */     // GIR_Coverage, 4450,
     /* 356494 */     GIR_EraseRootFromParent_Done,
     /* 356495 */   // Label 7181: @356495
     /* 356495 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(356600), // Rule ID 4347 //
     /* 356500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356516 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356523 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356540 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356567 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356599 */     // GIR_Coverage, 4347,
     /* 356599 */     GIR_EraseRootFromParent_Done,
     /* 356600 */   // Label 7182: @356600
     /* 356600 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(356705), // Rule ID 4349 //
     /* 356605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356621 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356628 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356645 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356672 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356704 */     // GIR_Coverage, 4349,
     /* 356704 */     GIR_EraseRootFromParent_Done,
     /* 356705 */   // Label 7183: @356705
     /* 356705 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(356810), // Rule ID 4455 //
     /* 356710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356726 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356733 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356750 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356809 */     // GIR_Coverage, 4455,
     /* 356809 */     GIR_EraseRootFromParent_Done,
     /* 356810 */   // Label 7184: @356810
     /* 356810 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(356915), // Rule ID 4457 //
     /* 356815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356831 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356838 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356855 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356882 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356914 */     // GIR_Coverage, 4457,
     /* 356914 */     GIR_EraseRootFromParent_Done,
     /* 356915 */   // Label 7185: @356915
     /* 356915 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357019), // Rule ID 4339 //
     /* 356920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356924 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356930 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356940 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356947 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356964 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357018 */     // GIR_Coverage, 4339,
     /* 357018 */     GIR_EraseRootFromParent_Done,
     /* 357019 */   // Label 7186: @357019
     /* 357019 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(357123), // Rule ID 4340 //
     /* 357024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357028 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357044 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357051 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357068 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357090 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357122 */     // GIR_Coverage, 4340,
     /* 357122 */     GIR_EraseRootFromParent_Done,
     /* 357123 */   // Label 7187: @357123
     /* 357123 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(357227), // Rule ID 4447 //
     /* 357128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357172 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357226 */     // GIR_Coverage, 4447,
     /* 357226 */     GIR_EraseRootFromParent_Done,
     /* 357227 */   // Label 7188: @357227
     /* 357227 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(357331), // Rule ID 4448 //
     /* 357232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357236 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357242 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357252 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357259 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357276 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357330 */     // GIR_Coverage, 4448,
     /* 357330 */     GIR_EraseRootFromParent_Done,
     /* 357331 */   // Label 7189: @357331
     /* 357331 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(357431), // Rule ID 4343 //
     /* 357336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357376 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357398 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357430 */     // GIR_Coverage, 4343,
     /* 357430 */     GIR_EraseRootFromParent_Done,
     /* 357431 */   // Label 7190: @357431
     /* 357431 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(357531), // Rule ID 4345 //
     /* 357436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357452 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357459 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357476 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357498 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357530 */     // GIR_Coverage, 4345,
     /* 357530 */     GIR_EraseRootFromParent_Done,
     /* 357531 */   // Label 7191: @357531
     /* 357531 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(357631), // Rule ID 4451 //
     /* 357536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357552 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357559 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357576 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357598 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357630 */     // GIR_Coverage, 4451,
     /* 357630 */     GIR_EraseRootFromParent_Done,
     /* 357631 */   // Label 7192: @357631
     /* 357631 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(357731), // Rule ID 4453 //
     /* 357636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357652 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357659 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357676 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357698 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357730 */     // GIR_Coverage, 4453,
     /* 357730 */     GIR_EraseRootFromParent_Done,
     /* 357731 */   // Label 7193: @357731
     /* 357731 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(357851), // Rule ID 6523 //
     /* 357736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357758 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357762 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357769 */     // MIs[2] Rn
     /* 357769 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 357773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357784 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 357787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 357805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357813 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357833 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357850 */     // GIR_Coverage, 6523,
     /* 357850 */     GIR_EraseRootFromParent_Done,
     /* 357851 */   // Label 7194: @357851
     /* 357851 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(357971), // Rule ID 6525 //
     /* 357856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357875 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357878 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357882 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357889 */     // MIs[2] Rn
     /* 357889 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 357893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357904 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357904 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 357907 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357911 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 357925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357970 */     // GIR_Coverage, 6525,
     /* 357970 */     GIR_EraseRootFromParent_Done,
     /* 357971 */   // Label 7195: @357971
     /* 357971 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(358101), // Rule ID 5776 //
     /* 357976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358009 */     // MIs[2] Operand 1
     /* 358009 */     // No operand predicates
     /* 358009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358017 */     // MIs[3] Operand 1
     /* 358017 */     // No operand predicates
     /* 358017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358019 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358031 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358038 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 358069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 358076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358083 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358100 */     // GIR_Coverage, 5776,
     /* 358100 */     GIR_EraseRootFromParent_Done,
     /* 358101 */   // Label 7196: @358101
     /* 358101 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(358262), // Rule ID 5777 //
     /* 358106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358139 */     // MIs[2] Operand 1
     /* 358139 */     // No operand predicates
     /* 358139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358147 */     // MIs[3] Operand 1
     /* 358147 */     // No operand predicates
     /* 358147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358149 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 358152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358161 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358168 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 358171 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358176 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358193 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 358231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 358237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358261 */     // GIR_Coverage, 5777,
     /* 358261 */     GIR_EraseRootFromParent_Done,
     /* 358262 */   // Label 7197: @358262
     /* 358262 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(358392), // Rule ID 5816 //
     /* 358267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358300 */     // MIs[2] Operand 1
     /* 358300 */     // No operand predicates
     /* 358300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358308 */     // MIs[3] Operand 1
     /* 358308 */     // No operand predicates
     /* 358308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358310 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358322 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358329 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 358360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 358367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358374 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358391 */     // GIR_Coverage, 5816,
     /* 358391 */     GIR_EraseRootFromParent_Done,
     /* 358392 */   // Label 7198: @358392
     /* 358392 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(358553), // Rule ID 5817 //
     /* 358397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358430 */     // MIs[2] Operand 1
     /* 358430 */     // No operand predicates
     /* 358430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358438 */     // MIs[3] Operand 1
     /* 358438 */     // No operand predicates
     /* 358438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358440 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358440 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 358443 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358447 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358452 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358455 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358459 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 358462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358467 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358484 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 358522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 358528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358552 */     // GIR_Coverage, 5817,
     /* 358552 */     GIR_EraseRootFromParent_Done,
     /* 358553 */   // Label 7199: @358553
     /* 358553 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(358619), // Rule ID 5723 //
     /* 358558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358576 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 358576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 358579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 358600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358618 */     // GIR_Coverage, 5723,
     /* 358618 */     GIR_EraseRootFromParent_Done,
     /* 358619 */   // Label 7200: @358619
     /* 358619 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(358685), // Rule ID 5739 //
     /* 358624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358642 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 358642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 358645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 358666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358684 */     // GIR_Coverage, 5739,
     /* 358684 */     GIR_EraseRootFromParent_Done,
     /* 358685 */   // Label 7201: @358685
     /* 358685 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(358820), // Rule ID 5747 //
     /* 358690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 358702 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 358706 */     // MIs[1] Operand 1
     /* 358706 */     // No operand predicates
     /* 358706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358718 */     // MIs[2] Operand 1
     /* 358718 */     // No operand predicates
     /* 358718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358720 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 358720 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 358723 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358727 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358746 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 358749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 358778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 358789 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 358795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358802 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358819 */     // GIR_Coverage, 5747,
     /* 358819 */     GIR_EraseRootFromParent_Done,
     /* 358820 */   // Label 7202: @358820
     /* 358820 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(358952), // Rule ID 6532 //
     /* 358825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 358844 */     // MIs[1] Rn
     /* 358844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 358848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358865 */     // MIs[2] Operand 1
     /* 358865 */     // No operand predicates
     /* 358865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358867 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 358867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 358886 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 358906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358911 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 358917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358921 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358934 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358951 */     // GIR_Coverage, 6532,
     /* 358951 */     GIR_EraseRootFromParent_Done,
     /* 358952 */   // Label 7203: @358952
     /* 358952 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(359084), // Rule ID 6533 //
     /* 358957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358969 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 358976 */     // MIs[1] Rn
     /* 358976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 358980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358993 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358997 */     // MIs[2] Operand 1
     /* 358997 */     // No operand predicates
     /* 358997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358999 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 358999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 359014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 359018 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 359021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 359038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 359049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359066 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359083 */     // GIR_Coverage, 6533,
     /* 359083 */     GIR_EraseRootFromParent_Done,
     /* 359084 */   // Label 7204: @359084
     /* 359084 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(359267), // Rule ID 5827 //
     /* 359089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 359097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 359101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359114 */     // MIs[2] Operand 1
     /* 359114 */     // No operand predicates
     /* 359114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359116 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 359116 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 359119 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359123 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359130 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 359133 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359137 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359142 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359145 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 359149 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 359152 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359157 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359162 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359167 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 359170 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359174 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 359184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359193 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 359196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 359200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 359203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 359225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 359236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359249 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359266 */     // GIR_Coverage, 5827,
     /* 359266 */     GIR_EraseRootFromParent_Done,
     /* 359267 */   // Label 7205: @359267
     /* 359267 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(359445), // Rule ID 5750 //
     /* 359272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 359292 */     // MIs[1] Operand 1
     /* 359292 */     // No operand predicates
     /* 359292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359294 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 359294 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359297 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359301 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359308 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359311 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359315 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359320 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359323 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359327 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 359330 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359335 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359340 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359345 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 359348 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359352 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 359362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359371 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 359374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 359381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 359403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359408 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 359414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359444 */     // GIR_Coverage, 5750,
     /* 359444 */     GIR_EraseRootFromParent_Done,
     /* 359445 */   // Label 7206: @359445
     /* 359445 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(359570), // Rule ID 5753 //
     /* 359450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 359470 */     // MIs[1] Operand 1
     /* 359470 */     // No operand predicates
     /* 359470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359472 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 359472 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 359475 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359479 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 359489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359498 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 359501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359505 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 359508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359518 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 359530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359535 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 359541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359552 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359569 */     // GIR_Coverage, 5753,
     /* 359569 */     GIR_EraseRootFromParent_Done,
     /* 359570 */   // Label 7207: @359570
     /* 359570 */   GIM_Reject,
     /* 359571 */ // Label 7177: @359571
     /* 359571 */ GIM_Reject,
     /* 359572 */ // Label 7155: @359572
     /* 359572 */ GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(362812),
     /* 359577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359590 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(359699), // Rule ID 4365 //
     /* 359595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359622 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359639 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359698 */     // GIR_Coverage, 4365,
     /* 359698 */     GIR_EraseRootFromParent_Done,
     /* 359699 */   // Label 7209: @359699
     /* 359699 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(359808), // Rule ID 4366 //
     /* 359704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359724 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359731 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359748 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359775 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359807 */     // GIR_Coverage, 4366,
     /* 359807 */     GIR_EraseRootFromParent_Done,
     /* 359808 */   // Label 7210: @359808
     /* 359808 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(359917), // Rule ID 4473 //
     /* 359813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359817 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359823 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359833 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359840 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359857 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359884 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359916 */     // GIR_Coverage, 4473,
     /* 359916 */     GIR_EraseRootFromParent_Done,
     /* 359917 */   // Label 7211: @359917
     /* 359917 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(360026), // Rule ID 4474 //
     /* 359922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359926 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359932 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359942 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359949 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359966 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359993 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360025 */     // GIR_Coverage, 4474,
     /* 360025 */     GIR_EraseRootFromParent_Done,
     /* 360026 */   // Label 7212: @360026
     /* 360026 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(360131), // Rule ID 4371 //
     /* 360031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360047 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360054 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 360071 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 360071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 360078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360098 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360130 */     // GIR_Coverage, 4371,
     /* 360130 */     GIR_EraseRootFromParent_Done,
     /* 360131 */   // Label 7213: @360131
     /* 360131 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(360236), // Rule ID 4373 //
     /* 360136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360152 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360159 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 360176 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 360176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 360183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360203 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360235 */     // GIR_Coverage, 4373,
     /* 360235 */     GIR_EraseRootFromParent_Done,
     /* 360236 */   // Label 7214: @360236
     /* 360236 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(360341), // Rule ID 4479 //
     /* 360241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360257 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360264 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 360281 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 360281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 360288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360308 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360340 */     // GIR_Coverage, 4479,
     /* 360340 */     GIR_EraseRootFromParent_Done,
     /* 360341 */   // Label 7215: @360341
     /* 360341 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(360446), // Rule ID 4481 //
     /* 360346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360362 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360369 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 360386 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 360386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 360393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360445 */     // GIR_Coverage, 4481,
     /* 360445 */     GIR_EraseRootFromParent_Done,
     /* 360446 */   // Label 7216: @360446
     /* 360446 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(360550), // Rule ID 4363 //
     /* 360451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360471 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360478 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360495 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360549 */     // GIR_Coverage, 4363,
     /* 360549 */     GIR_EraseRootFromParent_Done,
     /* 360550 */   // Label 7217: @360550
     /* 360550 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(360654), // Rule ID 4364 //
     /* 360555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360575 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360582 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360599 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360621 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360653 */     // GIR_Coverage, 4364,
     /* 360653 */     GIR_EraseRootFromParent_Done,
     /* 360654 */   // Label 7218: @360654
     /* 360654 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(360758), // Rule ID 4471 //
     /* 360659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360679 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360686 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360703 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360757 */     // GIR_Coverage, 4471,
     /* 360757 */     GIR_EraseRootFromParent_Done,
     /* 360758 */   // Label 7219: @360758
     /* 360758 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(360862), // Rule ID 4472 //
     /* 360763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360783 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360807 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360861 */     // GIR_Coverage, 4472,
     /* 360861 */     GIR_EraseRootFromParent_Done,
     /* 360862 */   // Label 7220: @360862
     /* 360862 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(360962), // Rule ID 4367 //
     /* 360867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360883 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360890 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360907 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360929 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360961 */     // GIR_Coverage, 4367,
     /* 360961 */     GIR_EraseRootFromParent_Done,
     /* 360962 */   // Label 7221: @360962
     /* 360962 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(361062), // Rule ID 4369 //
     /* 360967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360983 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 361007 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 361007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 361014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361061 */     // GIR_Coverage, 4369,
     /* 361061 */     GIR_EraseRootFromParent_Done,
     /* 361062 */   // Label 7222: @361062
     /* 361062 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(361162), // Rule ID 4475 //
     /* 361067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361083 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361090 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 361107 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 361107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 361114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361129 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361161 */     // GIR_Coverage, 4475,
     /* 361161 */     GIR_EraseRootFromParent_Done,
     /* 361162 */   // Label 7223: @361162
     /* 361162 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(361262), // Rule ID 4477 //
     /* 361167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361183 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361190 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 361207 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 361207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 361214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361229 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361261 */     // GIR_Coverage, 4477,
     /* 361261 */     GIR_EraseRootFromParent_Done,
     /* 361262 */   // Label 7224: @361262
     /* 361262 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(361375), // Rule ID 5782 //
     /* 361267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361304 */     // MIs[3] Operand 1
     /* 361304 */     // No operand predicates
     /* 361304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361310 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 361313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 361317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361322 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 361329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 361356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361374 */     // GIR_Coverage, 5782,
     /* 361374 */     GIR_EraseRootFromParent_Done,
     /* 361375 */   // Label 7225: @361375
     /* 361375 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(361488), // Rule ID 5822 //
     /* 361380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361417 */     // MIs[3] Operand 1
     /* 361417 */     // No operand predicates
     /* 361417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361423 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 361426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 361430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 361442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361487 */     // GIR_Coverage, 5822,
     /* 361487 */     GIR_EraseRootFromParent_Done,
     /* 361488 */   // Label 7226: @361488
     /* 361488 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(361566), // Rule ID 1945 //
     /* 361493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361533 */     // MIs[2] Operand 1
     /* 361533 */     // No operand predicates
     /* 361533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361545 */     // MIs[3] Operand 1
     /* 361545 */     // No operand predicates
     /* 361545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361547 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 361547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 361564 */     GIR_RootConstrainSelectedInstOperands,
     /* 361565 */     // GIR_Coverage, 1945,
     /* 361565 */     GIR_EraseRootFromParent_Done,
     /* 361566 */   // Label 7227: @361566
     /* 361566 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(361661), // Rule ID 7518 //
     /* 361571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 361574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 361586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361598 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 361601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361605 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 361612 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 361615 */     // MIs[2] Rn
     /* 361615 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 361619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361632 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361636 */     // MIs[3] Operand 1
     /* 361636 */     // No operand predicates
     /* 361636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361638 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15866>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 361638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 361641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 361659 */     GIR_RootConstrainSelectedInstOperands,
     /* 361660 */     // GIR_Coverage, 7518,
     /* 361660 */     GIR_EraseRootFromParent_Done,
     /* 361661 */   // Label 7228: @361661
     /* 361661 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(361750), // Rule ID 5779 //
     /* 361666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 361678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361694 */     // MIs[2] Operand 1
     /* 361694 */     // No operand predicates
     /* 361694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361702 */     // MIs[3] Operand 1
     /* 361702 */     // No operand predicates
     /* 361702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361704 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 361704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361716 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 361722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361748 */     GIR_RootConstrainSelectedInstOperands,
     /* 361749 */     // GIR_Coverage, 5779,
     /* 361749 */     GIR_EraseRootFromParent_Done,
     /* 361750 */   // Label 7229: @361750
     /* 361750 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(361839), // Rule ID 5819 //
     /* 361755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 361767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361783 */     // MIs[2] Operand 1
     /* 361783 */     // No operand predicates
     /* 361783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361791 */     // MIs[3] Operand 1
     /* 361791 */     // No operand predicates
     /* 361791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361793 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 361793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361805 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 361811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361837 */     GIR_RootConstrainSelectedInstOperands,
     /* 361838 */     // GIR_Coverage, 5819,
     /* 361838 */     GIR_EraseRootFromParent_Done,
     /* 361839 */   // Label 7230: @361839
     /* 361839 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(361906), // Rule ID 5781 //
     /* 361844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361877 */     // MIs[2] Operand 1
     /* 361877 */     // No operand predicates
     /* 361877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361885 */     // MIs[3] Operand 1
     /* 361885 */     // No operand predicates
     /* 361885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361887 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 361887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361904 */     GIR_RootConstrainSelectedInstOperands,
     /* 361905 */     // GIR_Coverage, 5781,
     /* 361905 */     GIR_EraseRootFromParent_Done,
     /* 361906 */   // Label 7231: @361906
     /* 361906 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(362004), // Rule ID 5783 //
     /* 361911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361944 */     // MIs[2] Operand 1
     /* 361944 */     // No operand predicates
     /* 361944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361952 */     // MIs[3] Operand 1
     /* 361952 */     // No operand predicates
     /* 361952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361954 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 361954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 361969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 362002 */     GIR_RootConstrainSelectedInstOperands,
     /* 362003 */     // GIR_Coverage, 5783,
     /* 362003 */     GIR_EraseRootFromParent_Done,
     /* 362004 */   // Label 7232: @362004
     /* 362004 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362071), // Rule ID 5821 //
     /* 362009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362042 */     // MIs[2] Operand 1
     /* 362042 */     // No operand predicates
     /* 362042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362050 */     // MIs[3] Operand 1
     /* 362050 */     // No operand predicates
     /* 362050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362052 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 362052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 362059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 362062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 362069 */     GIR_RootConstrainSelectedInstOperands,
     /* 362070 */     // GIR_Coverage, 5821,
     /* 362070 */     GIR_EraseRootFromParent_Done,
     /* 362071 */   // Label 7233: @362071
     /* 362071 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(362169), // Rule ID 5823 //
     /* 362076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362109 */     // MIs[2] Operand 1
     /* 362109 */     // No operand predicates
     /* 362109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362117 */     // MIs[3] Operand 1
     /* 362117 */     // No operand predicates
     /* 362117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362119 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 362119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 362122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 362134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 362158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 362161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 362167 */     GIR_RootConstrainSelectedInstOperands,
     /* 362168 */     // GIR_Coverage, 5823,
     /* 362168 */     GIR_EraseRootFromParent_Done,
     /* 362169 */   // Label 7234: @362169
     /* 362169 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(362235), // Rule ID 5727 //
     /* 362174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362192 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 362192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 362195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 362219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362234 */     // GIR_Coverage, 5727,
     /* 362234 */     GIR_EraseRootFromParent_Done,
     /* 362235 */   // Label 7235: @362235
     /* 362235 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(362301), // Rule ID 5741 //
     /* 362240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362258 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 362258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 362261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 362285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362300 */     // GIR_Coverage, 5741,
     /* 362300 */     GIR_EraseRootFromParent_Done,
     /* 362301 */   // Label 7236: @362301
     /* 362301 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(362370), // Rule ID 6514 //
     /* 362306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362325 */     // MIs[1] Rn
     /* 362325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362346 */     // MIs[2] Operand 1
     /* 362346 */     // No operand predicates
     /* 362346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362348 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 362348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 362351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362368 */     GIR_RootConstrainSelectedInstOperands,
     /* 362369 */     // GIR_Coverage, 6514,
     /* 362369 */     GIR_EraseRootFromParent_Done,
     /* 362370 */   // Label 7237: @362370
     /* 362370 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(362439), // Rule ID 6515 //
     /* 362375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362394 */     // MIs[1] Rn
     /* 362394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362411 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362415 */     // MIs[2] Operand 1
     /* 362415 */     // No operand predicates
     /* 362415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362417 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 362417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 362420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362437 */     GIR_RootConstrainSelectedInstOperands,
     /* 362438 */     // GIR_Coverage, 6515,
     /* 362438 */     GIR_EraseRootFromParent_Done,
     /* 362439 */   // Label 7238: @362439
     /* 362439 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(362521), // Rule ID 7517 //
     /* 362444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 362447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362459 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 362462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362466 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 362473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 362476 */     // MIs[1] Rn
     /* 362476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362497 */     // MIs[2] Operand 1
     /* 362497 */     // No operand predicates
     /* 362497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362499 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15866>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 362499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 362502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362519 */     GIR_RootConstrainSelectedInstOperands,
     /* 362520 */     // GIR_Coverage, 7517,
     /* 362520 */     GIR_EraseRootFromParent_Done,
     /* 362521 */   // Label 7239: @362521
     /* 362521 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(362570), // Rule ID 5748 //
     /* 362526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 362534 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 362538 */     // MIs[1] Operand 1
     /* 362538 */     // No operand predicates
     /* 362538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362546 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362550 */     // MIs[2] Operand 1
     /* 362550 */     // No operand predicates
     /* 362550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362552 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 362552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 362555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 362562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362568 */     GIR_RootConstrainSelectedInstOperands,
     /* 362569 */     // GIR_Coverage, 5748,
     /* 362569 */     GIR_EraseRootFromParent_Done,
     /* 362570 */   // Label 7240: @362570
     /* 362570 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(362671), // Rule ID 5828 //
     /* 362575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 362583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362600 */     // MIs[2] Operand 1
     /* 362600 */     // No operand predicates
     /* 362600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362602 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 362635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 362660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 362663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362669 */     GIR_RootConstrainSelectedInstOperands,
     /* 362670 */     // GIR_Coverage, 5828,
     /* 362670 */     GIR_EraseRootFromParent_Done,
     /* 362671 */   // Label 7241: @362671
     /* 362671 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(362715), // Rule ID 1941 //
     /* 362676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 362691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362699 */     // MIs[1] Operand 1
     /* 362699 */     // No operand predicates
     /* 362699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362701 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 362701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 362704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362713 */     GIR_RootConstrainSelectedInstOperands,
     /* 362714 */     // GIR_Coverage, 1941,
     /* 362714 */     GIR_EraseRootFromParent_Done,
     /* 362715 */   // Label 7242: @362715
     /* 362715 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(362811), // Rule ID 5752 //
     /* 362720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 362732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362740 */     // MIs[1] Operand 1
     /* 362740 */     // No operand predicates
     /* 362740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362742 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 362745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 362759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 362775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 362803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362809 */     GIR_RootConstrainSelectedInstOperands,
     /* 362810 */     // GIR_Coverage, 5752,
     /* 362810 */     GIR_EraseRootFromParent_Done,
     /* 362811 */   // Label 7243: @362811
     /* 362811 */   GIM_Reject,
     /* 362812 */ // Label 7208: @362812
     /* 362812 */ GIM_Reject,
     /* 362813 */ // Label 7156: @362813
     /* 362813 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(366452),
     /* 362818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362821 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(362947), // Rule ID 4305 //
     /* 362826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362856 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362859 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362863 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362870 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362887 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362914 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362946 */     // GIR_Coverage, 4305,
     /* 362946 */     GIR_EraseRootFromParent_Done,
     /* 362947 */   // Label 7245: @362947
     /* 362947 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363073), // Rule ID 4306 //
     /* 362952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362966 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362972 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362982 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362985 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362989 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362996 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363013 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363072 */     // GIR_Coverage, 4306,
     /* 363072 */     GIR_EraseRootFromParent_Done,
     /* 363073 */   // Label 7246: @363073
     /* 363073 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363192), // Rule ID 4413 //
     /* 363078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363092 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363098 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363108 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363115 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363132 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363159 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363191 */     // GIR_Coverage, 4413,
     /* 363191 */     GIR_EraseRootFromParent_Done,
     /* 363192 */   // Label 7247: @363192
     /* 363192 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363311), // Rule ID 4414 //
     /* 363197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363227 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363251 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363278 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363310 */     // GIR_Coverage, 4414,
     /* 363310 */     GIR_EraseRootFromParent_Done,
     /* 363311 */   // Label 7248: @363311
     /* 363311 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363433), // Rule ID 4311 //
     /* 363316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363342 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363345 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363349 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363356 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363373 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363400 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363432 */     // GIR_Coverage, 4311,
     /* 363432 */     GIR_EraseRootFromParent_Done,
     /* 363433 */   // Label 7249: @363433
     /* 363433 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(363555), // Rule ID 4313 //
     /* 363438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363467 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363471 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363478 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363495 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363522 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363554 */     // GIR_Coverage, 4313,
     /* 363554 */     GIR_EraseRootFromParent_Done,
     /* 363555 */   // Label 7250: @363555
     /* 363555 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(363670), // Rule ID 4419 //
     /* 363560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363593 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363610 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363637 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363669 */     // GIR_Coverage, 4419,
     /* 363669 */     GIR_EraseRootFromParent_Done,
     /* 363670 */   // Label 7251: @363670
     /* 363670 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(363785), // Rule ID 4421 //
     /* 363675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363701 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363708 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363725 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363752 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363784 */     // GIR_Coverage, 4421,
     /* 363784 */     GIR_EraseRootFromParent_Done,
     /* 363785 */   // Label 7252: @363785
     /* 363785 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(363906), // Rule ID 4303 //
     /* 363790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363820 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363823 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363827 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363834 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363851 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363873 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363905 */     // GIR_Coverage, 4303,
     /* 363905 */     GIR_EraseRootFromParent_Done,
     /* 363906 */   // Label 7253: @363906
     /* 363906 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(364027), // Rule ID 4304 //
     /* 363911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363941 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363944 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363948 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363972 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364026 */     // GIR_Coverage, 4304,
     /* 364026 */     GIR_EraseRootFromParent_Done,
     /* 364027 */   // Label 7254: @364027
     /* 364027 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(364141), // Rule ID 4411 //
     /* 364032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364046 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364052 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364062 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364069 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364086 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364108 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364140 */     // GIR_Coverage, 4411,
     /* 364140 */     GIR_EraseRootFromParent_Done,
     /* 364141 */   // Label 7255: @364141
     /* 364141 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(364255), // Rule ID 4412 //
     /* 364146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364176 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364183 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364200 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364222 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364254 */     // GIR_Coverage, 4412,
     /* 364254 */     GIR_EraseRootFromParent_Done,
     /* 364255 */   // Label 7256: @364255
     /* 364255 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(364372), // Rule ID 4307 //
     /* 364260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364286 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364289 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364293 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 364300 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364317 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364339 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364371 */     // GIR_Coverage, 4307,
     /* 364371 */     GIR_EraseRootFromParent_Done,
     /* 364372 */   // Label 7257: @364372
     /* 364372 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364489), // Rule ID 4309 //
     /* 364377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364406 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364410 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 364417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364434 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364456 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364488 */     // GIR_Coverage, 4309,
     /* 364488 */     GIR_EraseRootFromParent_Done,
     /* 364489 */   // Label 7258: @364489
     /* 364489 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364599), // Rule ID 4415 //
     /* 364494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364520 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364527 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364544 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364598 */     // GIR_Coverage, 4415,
     /* 364598 */     GIR_EraseRootFromParent_Done,
     /* 364599 */   // Label 7259: @364599
     /* 364599 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(364709), // Rule ID 4417 //
     /* 364604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364630 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364637 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364654 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364676 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364708 */     // GIR_Coverage, 4417,
     /* 364708 */     GIR_EraseRootFromParent_Done,
     /* 364709 */   // Label 7260: @364709
     /* 364709 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(364839), // Rule ID 6527 //
     /* 364714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364746 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364750 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364757 */     // MIs[2] Rn
     /* 364757 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 364761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364772 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 364775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 364793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 364808 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364838 */     // GIR_Coverage, 6527,
     /* 364838 */     GIR_EraseRootFromParent_Done,
     /* 364839 */   // Label 7261: @364839
     /* 364839 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(364979), // Rule ID 5768 //
     /* 364844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364887 */     // MIs[2] Operand 1
     /* 364887 */     // No operand predicates
     /* 364887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364895 */     // MIs[3] Operand 1
     /* 364895 */     // No operand predicates
     /* 364895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364897 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 364897 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364900 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364904 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364909 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364912 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364916 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 364947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 364954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364978 */     // GIR_Coverage, 5768,
     /* 364978 */     GIR_EraseRootFromParent_Done,
     /* 364979 */   // Label 7262: @364979
     /* 364979 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(365150), // Rule ID 5769 //
     /* 364984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 365010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365027 */     // MIs[2] Operand 1
     /* 365027 */     // No operand predicates
     /* 365027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365035 */     // MIs[3] Operand 1
     /* 365035 */     // No operand predicates
     /* 365035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365037 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 365037 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 365040 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365044 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365049 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 365052 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365056 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 365059 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365064 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365081 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365084 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365088 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 365108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 365119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 365125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365132 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365149 */     // GIR_Coverage, 5769,
     /* 365149 */     GIR_EraseRootFromParent_Done,
     /* 365150 */   // Label 7263: @365150
     /* 365150 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(365290), // Rule ID 5808 //
     /* 365155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365198 */     // MIs[2] Operand 1
     /* 365198 */     // No operand predicates
     /* 365198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365206 */     // MIs[3] Operand 1
     /* 365206 */     // No operand predicates
     /* 365206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365208 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 365208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 365211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365220 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365227 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 365247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 365258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 365265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365289 */     // GIR_Coverage, 5808,
     /* 365289 */     GIR_EraseRootFromParent_Done,
     /* 365290 */   // Label 7264: @365290
     /* 365290 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(365461), // Rule ID 5809 //
     /* 365295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 365321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365338 */     // MIs[2] Operand 1
     /* 365338 */     // No operand predicates
     /* 365338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365346 */     // MIs[3] Operand 1
     /* 365346 */     // No operand predicates
     /* 365346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365348 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 365348 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 365351 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365355 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365360 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 365363 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365367 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 365370 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365375 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365399 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 365419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365424 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 365430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 365436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365443 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365460 */     // GIR_Coverage, 5809,
     /* 365460 */     GIR_EraseRootFromParent_Done,
     /* 365461 */   // Label 7265: @365461
     /* 365461 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(365540), // Rule ID 5721 //
     /* 365466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365494 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 365494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 365510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365539 */     // GIR_Coverage, 5721,
     /* 365539 */     GIR_EraseRootFromParent_Done,
     /* 365540 */   // Label 7266: @365540
     /* 365540 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(365616), // Rule ID 5729 //
     /* 365545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365573 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 365573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 365576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 365600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365615 */     // GIR_Coverage, 5729,
     /* 365615 */     GIR_EraseRootFromParent_Done,
     /* 365616 */   // Label 7267: @365616
     /* 365616 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(365692), // Rule ID 5733 //
     /* 365621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365649 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 365649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 365652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 365676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365691 */     // GIR_Coverage, 5733,
     /* 365691 */     GIR_EraseRootFromParent_Done,
     /* 365692 */   // Label 7268: @365692
     /* 365692 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(365837), // Rule ID 5745 //
     /* 365697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365719 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365723 */     // MIs[1] Operand 1
     /* 365723 */     // No operand predicates
     /* 365723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365735 */     // MIs[2] Operand 1
     /* 365735 */     // No operand predicates
     /* 365735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365737 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 365737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 365740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 365754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365763 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 365766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365770 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365773 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365778 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 365795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365800 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 365806 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 365812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365819 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365836 */     // GIR_Coverage, 5745,
     /* 365836 */     GIR_EraseRootFromParent_Done,
     /* 365837 */   // Label 7269: @365837
     /* 365837 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(365986), // Rule ID 6531 //
     /* 365842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365867 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 365871 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 365878 */     // MIs[1] Rn
     /* 365878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 365882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 365887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365899 */     // MIs[2] Operand 1
     /* 365899 */     // No operand predicates
     /* 365899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365901 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 365901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365913 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 365920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 365940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 365951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365968 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365985 */     // GIR_Coverage, 6531,
     /* 365985 */     GIR_EraseRootFromParent_Done,
     /* 365986 */   // Label 7270: @365986
     /* 365986 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(366128), // Rule ID 6534 //
     /* 365991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366013 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366020 */     // MIs[1] Rn
     /* 366020 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366041 */     // MIs[2] Operand 1
     /* 366041 */     // No operand predicates
     /* 366041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366043 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 366043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366055 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 366058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 366062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 366065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 366082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 366093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366127 */     // GIR_Coverage, 6534,
     /* 366127 */     GIR_EraseRootFromParent_Done,
     /* 366128 */   // Label 7271: @366128
     /* 366128 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(366316), // Rule ID 5743 //
     /* 366133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 366136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366163 */     // MIs[1] Operand 1
     /* 366163 */     // No operand predicates
     /* 366163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366165 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 366165 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 366168 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366172 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 366179 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 366182 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366186 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366191 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 366194 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366198 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 366201 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366206 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366211 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366216 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 366219 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366223 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 366230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 366233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366242 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 366245 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366249 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 366252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366257 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 366274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 366285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 366288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366298 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366315 */     // GIR_Coverage, 5743,
     /* 366315 */     GIR_EraseRootFromParent_Done,
     /* 366316 */   // Label 7272: @366316
     /* 366316 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(366451), // Rule ID 5754 //
     /* 366321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366351 */     // MIs[1] Operand 1
     /* 366351 */     // No operand predicates
     /* 366351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366353 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 366353 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 366356 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366360 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 366367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 366370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366379 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 366382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366386 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 366389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 366411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 366422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366433 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366450 */     // GIR_Coverage, 5754,
     /* 366450 */     GIR_EraseRootFromParent_Done,
     /* 366451 */   // Label 7273: @366451
     /* 366451 */   GIM_Reject,
     /* 366452 */ // Label 7244: @366452
     /* 366452 */ GIM_Reject,
     /* 366453 */ // Label 7157: @366453
     /* 366453 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(369520),
     /* 366458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366471 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(366580), // Rule ID 4329 //
     /* 366476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366496 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366503 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366520 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366579 */     // GIR_Coverage, 4329,
     /* 366579 */     GIR_EraseRootFromParent_Done,
     /* 366580 */   // Label 7275: @366580
     /* 366580 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(366689), // Rule ID 4330 //
     /* 366585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366589 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366595 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366605 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366612 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366629 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366688 */     // GIR_Coverage, 4330,
     /* 366688 */     GIR_EraseRootFromParent_Done,
     /* 366689 */   // Label 7276: @366689
     /* 366689 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(366798), // Rule ID 4437 //
     /* 366694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366714 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366721 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366738 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366797 */     // GIR_Coverage, 4437,
     /* 366797 */     GIR_EraseRootFromParent_Done,
     /* 366798 */   // Label 7277: @366798
     /* 366798 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(366907), // Rule ID 4438 //
     /* 366803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366823 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366830 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366847 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366906 */     // GIR_Coverage, 4438,
     /* 366906 */     GIR_EraseRootFromParent_Done,
     /* 366907 */   // Label 7278: @366907
     /* 366907 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(367012), // Rule ID 4335 //
     /* 366912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366952 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367011 */     // GIR_Coverage, 4335,
     /* 367011 */     GIR_EraseRootFromParent_Done,
     /* 367012 */   // Label 7279: @367012
     /* 367012 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(367117), // Rule ID 4337 //
     /* 367017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367040 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 367057 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 367057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 367064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367084 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367116 */     // GIR_Coverage, 4337,
     /* 367116 */     GIR_EraseRootFromParent_Done,
     /* 367117 */   // Label 7280: @367117
     /* 367117 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(367222), // Rule ID 4443 //
     /* 367122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367138 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367145 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 367162 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 367162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 367169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367221 */     // GIR_Coverage, 4443,
     /* 367221 */     GIR_EraseRootFromParent_Done,
     /* 367222 */   // Label 7281: @367222
     /* 367222 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(367327), // Rule ID 4445 //
     /* 367227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367250 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 367267 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 367267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 367274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367326 */     // GIR_Coverage, 4445,
     /* 367326 */     GIR_EraseRootFromParent_Done,
     /* 367327 */   // Label 7282: @367327
     /* 367327 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(367431), // Rule ID 4327 //
     /* 367332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367376 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367398 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367430 */     // GIR_Coverage, 4327,
     /* 367430 */     GIR_EraseRootFromParent_Done,
     /* 367431 */   // Label 7283: @367431
     /* 367431 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(367535), // Rule ID 4328 //
     /* 367436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367456 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367463 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367480 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367534 */     // GIR_Coverage, 4328,
     /* 367534 */     GIR_EraseRootFromParent_Done,
     /* 367535 */   // Label 7284: @367535
     /* 367535 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(367639), // Rule ID 4435 //
     /* 367540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367584 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367638 */     // GIR_Coverage, 4435,
     /* 367638 */     GIR_EraseRootFromParent_Done,
     /* 367639 */   // Label 7285: @367639
     /* 367639 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(367743), // Rule ID 4436 //
     /* 367644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367654 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367664 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367671 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367688 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367742 */     // GIR_Coverage, 4436,
     /* 367742 */     GIR_EraseRootFromParent_Done,
     /* 367743 */   // Label 7286: @367743
     /* 367743 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(367843), // Rule ID 4331 //
     /* 367748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367788 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367842 */     // GIR_Coverage, 4331,
     /* 367842 */     GIR_EraseRootFromParent_Done,
     /* 367843 */   // Label 7287: @367843
     /* 367843 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(367943), // Rule ID 4333 //
     /* 367848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367888 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367910 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367942 */     // GIR_Coverage, 4333,
     /* 367942 */     GIR_EraseRootFromParent_Done,
     /* 367943 */   // Label 7288: @367943
     /* 367943 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(368043), // Rule ID 4439 //
     /* 367948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367964 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367971 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367988 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368042 */     // GIR_Coverage, 4439,
     /* 368042 */     GIR_EraseRootFromParent_Done,
     /* 368043 */   // Label 7289: @368043
     /* 368043 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(368143), // Rule ID 4441 //
     /* 368048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 368088 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 368088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 368095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368142 */     // GIR_Coverage, 4441,
     /* 368142 */     GIR_EraseRootFromParent_Done,
     /* 368143 */   // Label 7290: @368143
     /* 368143 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(368256), // Rule ID 5774 //
     /* 368148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368185 */     // MIs[3] Operand 1
     /* 368185 */     // No operand predicates
     /* 368185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368191 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 368191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 368194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 368198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 368207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 368210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368255 */     // GIR_Coverage, 5774,
     /* 368255 */     GIR_EraseRootFromParent_Done,
     /* 368256 */   // Label 7291: @368256
     /* 368256 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(368369), // Rule ID 5814 //
     /* 368261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368298 */     // MIs[3] Operand 1
     /* 368298 */     // No operand predicates
     /* 368298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368304 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 368304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 368307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 368311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 368320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 368323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368368 */     // GIR_Coverage, 5814,
     /* 368368 */     GIR_EraseRootFromParent_Done,
     /* 368369 */   // Label 7292: @368369
     /* 368369 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(368447), // Rule ID 1944 //
     /* 368374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368414 */     // MIs[2] Operand 1
     /* 368414 */     // No operand predicates
     /* 368414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368422 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368426 */     // MIs[3] Operand 1
     /* 368426 */     // No operand predicates
     /* 368426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368428 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 368428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 368435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 368445 */     GIR_RootConstrainSelectedInstOperands,
     /* 368446 */     // GIR_Coverage, 1944,
     /* 368446 */     GIR_EraseRootFromParent_Done,
     /* 368447 */   // Label 7293: @368447
     /* 368447 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(368536), // Rule ID 5771 //
     /* 368452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368476 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368480 */     // MIs[2] Operand 1
     /* 368480 */     // No operand predicates
     /* 368480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368488 */     // MIs[3] Operand 1
     /* 368488 */     // No operand predicates
     /* 368488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368490 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 368490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368502 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 368508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368534 */     GIR_RootConstrainSelectedInstOperands,
     /* 368535 */     // GIR_Coverage, 5771,
     /* 368535 */     GIR_EraseRootFromParent_Done,
     /* 368536 */   // Label 7294: @368536
     /* 368536 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(368625), // Rule ID 5811 //
     /* 368541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368569 */     // MIs[2] Operand 1
     /* 368569 */     // No operand predicates
     /* 368569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368577 */     // MIs[3] Operand 1
     /* 368577 */     // No operand predicates
     /* 368577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368579 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 368579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368591 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 368597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368623 */     GIR_RootConstrainSelectedInstOperands,
     /* 368624 */     // GIR_Coverage, 5811,
     /* 368624 */     GIR_EraseRootFromParent_Done,
     /* 368625 */   // Label 7295: @368625
     /* 368625 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(368692), // Rule ID 5773 //
     /* 368630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368663 */     // MIs[2] Operand 1
     /* 368663 */     // No operand predicates
     /* 368663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368671 */     // MIs[3] Operand 1
     /* 368671 */     // No operand predicates
     /* 368671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368673 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 368673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368690 */     GIR_RootConstrainSelectedInstOperands,
     /* 368691 */     // GIR_Coverage, 5773,
     /* 368691 */     GIR_EraseRootFromParent_Done,
     /* 368692 */   // Label 7296: @368692
     /* 368692 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(368790), // Rule ID 5775 //
     /* 368697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368730 */     // MIs[2] Operand 1
     /* 368730 */     // No operand predicates
     /* 368730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368738 */     // MIs[3] Operand 1
     /* 368738 */     // No operand predicates
     /* 368738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368740 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 368740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368777 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368788 */     GIR_RootConstrainSelectedInstOperands,
     /* 368789 */     // GIR_Coverage, 5775,
     /* 368789 */     GIR_EraseRootFromParent_Done,
     /* 368790 */   // Label 7297: @368790
     /* 368790 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(368857), // Rule ID 5813 //
     /* 368795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368828 */     // MIs[2] Operand 1
     /* 368828 */     // No operand predicates
     /* 368828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368836 */     // MIs[3] Operand 1
     /* 368836 */     // No operand predicates
     /* 368836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368838 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 368838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368855 */     GIR_RootConstrainSelectedInstOperands,
     /* 368856 */     // GIR_Coverage, 5813,
     /* 368856 */     GIR_EraseRootFromParent_Done,
     /* 368857 */   // Label 7298: @368857
     /* 368857 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(368955), // Rule ID 5815 //
     /* 368862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368895 */     // MIs[2] Operand 1
     /* 368895 */     // No operand predicates
     /* 368895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368903 */     // MIs[3] Operand 1
     /* 368903 */     // No operand predicates
     /* 368903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368905 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 368905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368953 */     GIR_RootConstrainSelectedInstOperands,
     /* 368954 */     // GIR_Coverage, 5815,
     /* 368954 */     GIR_EraseRootFromParent_Done,
     /* 368955 */   // Label 7299: @368955
     /* 368955 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(369021), // Rule ID 5725 //
     /* 368960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368978 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 368978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 369005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369020 */     // GIR_Coverage, 5725,
     /* 369020 */     GIR_EraseRootFromParent_Done,
     /* 369021 */   // Label 7300: @369021
     /* 369021 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(369087), // Rule ID 5737 //
     /* 369026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369044 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 369044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 369071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369086 */     // GIR_Coverage, 5737,
     /* 369086 */     GIR_EraseRootFromParent_Done,
     /* 369087 */   // Label 7301: @369087
     /* 369087 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(369140), // Rule ID 5746 //
     /* 369092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369104 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 369108 */     // MIs[1] Operand 1
     /* 369108 */     // No operand predicates
     /* 369108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369120 */     // MIs[2] Operand 1
     /* 369120 */     // No operand predicates
     /* 369120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369122 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 369122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 369125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 369132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 369138 */     GIR_RootConstrainSelectedInstOperands,
     /* 369139 */     // GIR_Coverage, 5746,
     /* 369139 */     GIR_EraseRootFromParent_Done,
     /* 369140 */   // Label 7302: @369140
     /* 369140 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(369209), // Rule ID 6512 //
     /* 369145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369164 */     // MIs[1] Rn
     /* 369164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369181 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369185 */     // MIs[2] Operand 1
     /* 369185 */     // No operand predicates
     /* 369185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369187 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 369187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 369190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 369194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369207 */     GIR_RootConstrainSelectedInstOperands,
     /* 369208 */     // GIR_Coverage, 6512,
     /* 369208 */     GIR_EraseRootFromParent_Done,
     /* 369209 */   // Label 7303: @369209
     /* 369209 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(369278), // Rule ID 6513 //
     /* 369214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369233 */     // MIs[1] Rn
     /* 369233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369254 */     // MIs[2] Operand 1
     /* 369254 */     // No operand predicates
     /* 369254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369256 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 369256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 369259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 369263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369276 */     GIR_RootConstrainSelectedInstOperands,
     /* 369277 */     // GIR_Coverage, 6513,
     /* 369277 */     GIR_EraseRootFromParent_Done,
     /* 369278 */   // Label 7304: @369278
     /* 369278 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(369379), // Rule ID 5826 //
     /* 369283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 369291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369308 */     // MIs[2] Operand 1
     /* 369308 */     // No operand predicates
     /* 369308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369310 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369336 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 369343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 369364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 369368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 369371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369377 */     GIR_RootConstrainSelectedInstOperands,
     /* 369378 */     // GIR_Coverage, 5826,
     /* 369378 */     GIR_EraseRootFromParent_Done,
     /* 369379 */   // Label 7305: @369379
     /* 369379 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(369423), // Rule ID 1940 //
     /* 369384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369407 */     // MIs[1] Operand 1
     /* 369407 */     // No operand predicates
     /* 369407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369409 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 369409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 369412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 369416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 369419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369421 */     GIR_RootConstrainSelectedInstOperands,
     /* 369422 */     // GIR_Coverage, 1940,
     /* 369422 */     GIR_EraseRootFromParent_Done,
     /* 369423 */   // Label 7306: @369423
     /* 369423 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(369519), // Rule ID 5751 //
     /* 369428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369448 */     // MIs[1] Operand 1
     /* 369448 */     // No operand predicates
     /* 369448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369450 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 369504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 369511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369517 */     GIR_RootConstrainSelectedInstOperands,
     /* 369518 */     // GIR_Coverage, 5751,
     /* 369518 */     GIR_EraseRootFromParent_Done,
     /* 369519 */   // Label 7307: @369519
     /* 369519 */   GIM_Reject,
     /* 369520 */ // Label 7274: @369520
     /* 369520 */ GIM_Reject,
     /* 369521 */ // Label 7158: @369521
     /* 369521 */ GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(372733),
     /* 369526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369529 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(369648), // Rule ID 4233 //
     /* 369534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369548 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369554 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369564 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369571 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369588 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369615 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369647 */     // GIR_Coverage, 4233,
     /* 369647 */     GIR_EraseRootFromParent_Done,
     /* 369648 */   // Label 7309: @369648
     /* 369648 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(369767), // Rule ID 4234 //
     /* 369653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369683 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369690 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369707 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369766 */     // GIR_Coverage, 4234,
     /* 369766 */     GIR_EraseRootFromParent_Done,
     /* 369767 */   // Label 7310: @369767
     /* 369767 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(369893), // Rule ID 4269 //
     /* 369772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369802 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369805 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369809 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369833 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369892 */     // GIR_Coverage, 4269,
     /* 369892 */     GIR_EraseRootFromParent_Done,
     /* 369893 */   // Label 7311: @369893
     /* 369893 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(370019), // Rule ID 4270 //
     /* 369898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369931 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369935 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369959 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370018 */     // GIR_Coverage, 4270,
     /* 370018 */     GIR_EraseRootFromParent_Done,
     /* 370019 */   // Label 7312: @370019
     /* 370019 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(370134), // Rule ID 4239 //
     /* 370024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370050 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370057 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 370074 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 370074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 370081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370101 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370133 */     // GIR_Coverage, 4239,
     /* 370133 */     GIR_EraseRootFromParent_Done,
     /* 370134 */   // Label 7313: @370134
     /* 370134 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(370249), // Rule ID 4241 //
     /* 370139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370165 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370168 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370172 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 370189 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 370189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 370196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370216 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370248 */     // GIR_Coverage, 4241,
     /* 370248 */     GIR_EraseRootFromParent_Done,
     /* 370249 */   // Label 7314: @370249
     /* 370249 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(370371), // Rule ID 4275 //
     /* 370254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370280 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370283 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370287 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370294 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 370311 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 370311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 370318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370338 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370370 */     // GIR_Coverage, 4275,
     /* 370370 */     GIR_EraseRootFromParent_Done,
     /* 370371 */   // Label 7315: @370371
     /* 370371 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(370493), // Rule ID 4277 //
     /* 370376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370402 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370405 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370409 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370416 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 370433 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 370433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 370440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370460 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370492 */     // GIR_Coverage, 4277,
     /* 370492 */     GIR_EraseRootFromParent_Done,
     /* 370493 */   // Label 7316: @370493
     /* 370493 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(370607), // Rule ID 4231 //
     /* 370498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370528 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370552 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370606 */     // GIR_Coverage, 4231,
     /* 370606 */     GIR_EraseRootFromParent_Done,
     /* 370607 */   // Label 7317: @370607
     /* 370607 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(370721), // Rule ID 4232 //
     /* 370612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370626 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370632 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370642 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370649 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370666 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370688 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370720 */     // GIR_Coverage, 4232,
     /* 370720 */     GIR_EraseRootFromParent_Done,
     /* 370721 */   // Label 7318: @370721
     /* 370721 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(370842), // Rule ID 4267 //
     /* 370726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370740 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370746 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370759 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370763 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370770 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370787 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370841 */     // GIR_Coverage, 4267,
     /* 370841 */     GIR_EraseRootFromParent_Done,
     /* 370842 */   // Label 7319: @370842
     /* 370842 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(370963), // Rule ID 4268 //
     /* 370847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370861 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370867 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370877 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370880 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370884 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370891 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370908 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370930 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370962 */     // GIR_Coverage, 4268,
     /* 370962 */     GIR_EraseRootFromParent_Done,
     /* 370963 */   // Label 7320: @370963
     /* 370963 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(371073), // Rule ID 4235 //
     /* 370968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371001 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 371018 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 371018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 371021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 371025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 371062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371072 */     // GIR_Coverage, 4235,
     /* 371072 */     GIR_EraseRootFromParent_Done,
     /* 371073 */   // Label 7321: @371073
     /* 371073 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(371183), // Rule ID 4237 //
     /* 371078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371104 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371111 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 371128 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 371128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 371131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 371135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 371172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371182 */     // GIR_Coverage, 4237,
     /* 371182 */     GIR_EraseRootFromParent_Done,
     /* 371183 */   // Label 7322: @371183
     /* 371183 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(371300), // Rule ID 4271 //
     /* 371188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371214 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371217 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371221 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 371228 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 371245 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 371245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 371248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 371252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371267 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 371289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371299 */     // GIR_Coverage, 4271,
     /* 371299 */     GIR_EraseRootFromParent_Done,
     /* 371300 */   // Label 7323: @371300
     /* 371300 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(371417), // Rule ID 4273 //
     /* 371305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371334 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371338 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 371345 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 371362 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 371362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 371365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 371369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371384 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 371406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371416 */     // GIR_Coverage, 4273,
     /* 371416 */     GIR_EraseRootFromParent_Done,
     /* 371417 */   // Label 7324: @371417
     /* 371417 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(371557), // Rule ID 5792 //
     /* 371422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371465 */     // MIs[2] Operand 1
     /* 371465 */     // No operand predicates
     /* 371465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371473 */     // MIs[3] Operand 1
     /* 371473 */     // No operand predicates
     /* 371473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371475 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371487 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371494 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371539 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371556 */     // GIR_Coverage, 5792,
     /* 371556 */     GIR_EraseRootFromParent_Done,
     /* 371557 */   // Label 7325: @371557
     /* 371557 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(371728), // Rule ID 5793 //
     /* 371562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371605 */     // MIs[2] Operand 1
     /* 371605 */     // No operand predicates
     /* 371605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371613 */     // MIs[3] Operand 1
     /* 371613 */     // No operand predicates
     /* 371613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371615 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371615 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 371618 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371622 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371627 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 371630 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371634 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 371637 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371642 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371659 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371666 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371710 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371727 */     // GIR_Coverage, 5793,
     /* 371727 */     GIR_EraseRootFromParent_Done,
     /* 371728 */   // Label 7326: @371728
     /* 371728 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(371868), // Rule ID 5800 //
     /* 371733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371776 */     // MIs[2] Operand 1
     /* 371776 */     // No operand predicates
     /* 371776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371784 */     // MIs[3] Operand 1
     /* 371784 */     // No operand predicates
     /* 371784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371786 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371798 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371805 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371867 */     // GIR_Coverage, 5800,
     /* 371867 */     GIR_EraseRootFromParent_Done,
     /* 371868 */   // Label 7327: @371868
     /* 371868 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(372039), // Rule ID 5801 //
     /* 371873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371916 */     // MIs[2] Operand 1
     /* 371916 */     // No operand predicates
     /* 371916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371924 */     // MIs[3] Operand 1
     /* 371924 */     // No operand predicates
     /* 371924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371926 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 371929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371938 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 371941 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371945 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 371948 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371953 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371970 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 372008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 372014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372038 */     // GIR_Coverage, 5801,
     /* 372038 */     GIR_EraseRootFromParent_Done,
     /* 372039 */   // Label 7328: @372039
     /* 372039 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(372118), // Rule ID 5716 //
     /* 372044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372072 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 372072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 372088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 372107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372117 */     // GIR_Coverage, 5716,
     /* 372117 */     GIR_EraseRootFromParent_Done,
     /* 372118 */   // Label 7329: @372118
     /* 372118 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(372260), // Rule ID 6529 //
     /* 372123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 372126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372152 */     // MIs[1] Rn
     /* 372152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372173 */     // MIs[2] Operand 1
     /* 372173 */     // No operand predicates
     /* 372173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372175 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 372175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372187 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 372190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 372194 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 372214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 372225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372229 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372242 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372259 */     // GIR_Coverage, 6529,
     /* 372259 */     GIR_EraseRootFromParent_Done,
     /* 372260 */   // Label 7330: @372260
     /* 372260 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(372409), // Rule ID 6530 //
     /* 372265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372290 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372294 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 372301 */     // MIs[1] Rn
     /* 372301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372318 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372322 */     // MIs[2] Operand 1
     /* 372322 */     // No operand predicates
     /* 372322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372324 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 372324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372336 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 372339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 372343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 372363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 372374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372378 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372408 */     // GIR_Coverage, 6530,
     /* 372408 */     GIR_EraseRootFromParent_Done,
     /* 372409 */   // Label 7331: @372409
     /* 372409 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(372544), // Rule ID 5755 //
     /* 372414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372444 */     // MIs[1] Operand 1
     /* 372444 */     // No operand predicates
     /* 372444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372446 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 372446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 372449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 372463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372472 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 372475 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372479 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 372504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 372515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372526 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372543 */     // GIR_Coverage, 5755,
     /* 372543 */     GIR_EraseRootFromParent_Done,
     /* 372544 */   // Label 7332: @372544
     /* 372544 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(372732), // Rule ID 5756 //
     /* 372549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 372552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 372567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372579 */     // MIs[1] Operand 1
     /* 372579 */     // No operand predicates
     /* 372579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372581 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 372581 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 372584 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372588 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372595 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 372598 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372602 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372607 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372610 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372614 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 372617 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372622 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372627 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 372632 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 372635 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372639 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 372649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372658 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 372661 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372665 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 372690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 372701 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 372704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372714 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372731 */     // GIR_Coverage, 5756,
     /* 372731 */     GIR_EraseRootFromParent_Done,
     /* 372732 */   // Label 7333: @372732
     /* 372732 */   GIM_Reject,
     /* 372733 */ // Label 7308: @372733
     /* 372733 */ GIM_Reject,
     /* 372734 */ // Label 7159: @372734
     /* 372734 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(376152),
     /* 372739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372742 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(372868), // Rule ID 4293 //
     /* 372747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372761 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372767 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372777 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372780 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372784 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372791 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372808 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372835 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372867 */     // GIR_Coverage, 4293,
     /* 372867 */     GIR_EraseRootFromParent_Done,
     /* 372868 */   // Label 7335: @372868
     /* 372868 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(372994), // Rule ID 4294 //
     /* 372873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372903 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372906 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372910 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372917 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372934 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372961 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372993 */     // GIR_Coverage, 4294,
     /* 372993 */     GIR_EraseRootFromParent_Done,
     /* 372994 */   // Label 7336: @372994
     /* 372994 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(373113), // Rule ID 4401 //
     /* 372999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373013 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373019 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373029 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373036 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 373053 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 373060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373080 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373112 */     // GIR_Coverage, 4401,
     /* 373112 */     GIR_EraseRootFromParent_Done,
     /* 373113 */   // Label 7337: @373113
     /* 373113 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(373232), // Rule ID 4402 //
     /* 373118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 373172 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 373179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373199 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373231 */     // GIR_Coverage, 4402,
     /* 373231 */     GIR_EraseRootFromParent_Done,
     /* 373232 */   // Label 7338: @373232
     /* 373232 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(373354), // Rule ID 4299 //
     /* 373237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373263 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373266 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373270 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373277 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 373294 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 373301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373321 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373353 */     // GIR_Coverage, 4299,
     /* 373353 */     GIR_EraseRootFromParent_Done,
     /* 373354 */   // Label 7339: @373354
     /* 373354 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(373476), // Rule ID 4301 //
     /* 373359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373385 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373388 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373392 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373399 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 373416 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 373423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373443 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373475 */     // GIR_Coverage, 4301,
     /* 373475 */     GIR_EraseRootFromParent_Done,
     /* 373476 */   // Label 7340: @373476
     /* 373476 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(373591), // Rule ID 4407 //
     /* 373481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373507 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373514 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 373531 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 373538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373558 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373590 */     // GIR_Coverage, 4407,
     /* 373590 */     GIR_EraseRootFromParent_Done,
     /* 373591 */   // Label 7341: @373591
     /* 373591 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(373706), // Rule ID 4409 //
     /* 373596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373622 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373629 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 373646 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 373653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373673 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373705 */     // GIR_Coverage, 4409,
     /* 373705 */     GIR_EraseRootFromParent_Done,
     /* 373706 */   // Label 7342: @373706
     /* 373706 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(373827), // Rule ID 4291 //
     /* 373711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373725 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373731 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373741 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373744 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373748 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373755 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 373772 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 373772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 373779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373794 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373826 */     // GIR_Coverage, 4291,
     /* 373826 */     GIR_EraseRootFromParent_Done,
     /* 373827 */   // Label 7343: @373827
     /* 373827 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(373948), // Rule ID 4292 //
     /* 373832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373846 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373852 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373862 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373865 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373869 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373893 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373947 */     // GIR_Coverage, 4292,
     /* 373947 */     GIR_EraseRootFromParent_Done,
     /* 373948 */   // Label 7344: @373948
     /* 373948 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(374062), // Rule ID 4399 //
     /* 373953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373967 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373973 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373983 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 374007 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 374007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 374014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374061 */     // GIR_Coverage, 4399,
     /* 374061 */     GIR_EraseRootFromParent_Done,
     /* 374062 */   // Label 7345: @374062
     /* 374062 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(374176), // Rule ID 4400 //
     /* 374067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374097 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374104 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 374121 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 374121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 374128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374143 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374175 */     // GIR_Coverage, 4400,
     /* 374175 */     GIR_EraseRootFromParent_Done,
     /* 374176 */   // Label 7346: @374176
     /* 374176 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(374293), // Rule ID 4295 //
     /* 374181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374210 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374214 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 374221 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 374238 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 374238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 374245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374260 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374292 */     // GIR_Coverage, 4295,
     /* 374292 */     GIR_EraseRootFromParent_Done,
     /* 374293 */   // Label 7347: @374293
     /* 374293 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(374410), // Rule ID 4297 //
     /* 374298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374324 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374327 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374331 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 374338 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 374355 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 374355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 374362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374377 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374409 */     // GIR_Coverage, 4297,
     /* 374409 */     GIR_EraseRootFromParent_Done,
     /* 374410 */   // Label 7348: @374410
     /* 374410 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(374520), // Rule ID 4403 //
     /* 374415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 374465 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 374465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 374472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374487 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374519 */     // GIR_Coverage, 4403,
     /* 374519 */     GIR_EraseRootFromParent_Done,
     /* 374520 */   // Label 7349: @374520
     /* 374520 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(374630), // Rule ID 4405 //
     /* 374525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 374575 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 374575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 374582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374597 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374629 */     // GIR_Coverage, 4405,
     /* 374629 */     GIR_EraseRootFromParent_Done,
     /* 374630 */   // Label 7350: @374630
     /* 374630 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(374753), // Rule ID 5766 //
     /* 374635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374682 */     // MIs[3] Operand 1
     /* 374682 */     // No operand predicates
     /* 374682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374688 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 374688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 374691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 374695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374700 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 374707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374752 */     // GIR_Coverage, 5766,
     /* 374752 */     GIR_EraseRootFromParent_Done,
     /* 374753 */   // Label 7351: @374753
     /* 374753 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(374876), // Rule ID 5806 //
     /* 374758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374805 */     // MIs[3] Operand 1
     /* 374805 */     // No operand predicates
     /* 374805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374811 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 374811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 374814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 374818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 374830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374875 */     // GIR_Coverage, 5806,
     /* 374875 */     GIR_EraseRootFromParent_Done,
     /* 374876 */   // Label 7352: @374876
     /* 374876 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(374964), // Rule ID 1943 //
     /* 374881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374931 */     // MIs[2] Operand 1
     /* 374931 */     // No operand predicates
     /* 374931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374943 */     // MIs[3] Operand 1
     /* 374943 */     // No operand predicates
     /* 374943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374945 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 374945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 374962 */     GIR_RootConstrainSelectedInstOperands,
     /* 374963 */     // GIR_Coverage, 1943,
     /* 374963 */     GIR_EraseRootFromParent_Done,
     /* 374964 */   // Label 7353: @374964
     /* 374964 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(375063), // Rule ID 5763 //
     /* 374969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 374991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375007 */     // MIs[2] Operand 1
     /* 375007 */     // No operand predicates
     /* 375007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375015 */     // MIs[3] Operand 1
     /* 375015 */     // No operand predicates
     /* 375015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375017 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 375017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375061 */     GIR_RootConstrainSelectedInstOperands,
     /* 375062 */     // GIR_Coverage, 5763,
     /* 375062 */     GIR_EraseRootFromParent_Done,
     /* 375063 */   // Label 7354: @375063
     /* 375063 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(375162), // Rule ID 5803 //
     /* 375068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 375090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375102 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375106 */     // MIs[2] Operand 1
     /* 375106 */     // No operand predicates
     /* 375106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375114 */     // MIs[3] Operand 1
     /* 375114 */     // No operand predicates
     /* 375114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375116 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 375116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375128 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375160 */     GIR_RootConstrainSelectedInstOperands,
     /* 375161 */     // GIR_Coverage, 5803,
     /* 375161 */     GIR_EraseRootFromParent_Done,
     /* 375162 */   // Label 7355: @375162
     /* 375162 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(375239), // Rule ID 5765 //
     /* 375167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375210 */     // MIs[2] Operand 1
     /* 375210 */     // No operand predicates
     /* 375210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375218 */     // MIs[3] Operand 1
     /* 375218 */     // No operand predicates
     /* 375218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375220 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375237 */     GIR_RootConstrainSelectedInstOperands,
     /* 375238 */     // GIR_Coverage, 5765,
     /* 375238 */     GIR_EraseRootFromParent_Done,
     /* 375239 */   // Label 7356: @375239
     /* 375239 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(375347), // Rule ID 5767 //
     /* 375244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375287 */     // MIs[2] Operand 1
     /* 375287 */     // No operand predicates
     /* 375287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375295 */     // MIs[3] Operand 1
     /* 375295 */     // No operand predicates
     /* 375295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375297 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375334 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375345 */     GIR_RootConstrainSelectedInstOperands,
     /* 375346 */     // GIR_Coverage, 5767,
     /* 375346 */     GIR_EraseRootFromParent_Done,
     /* 375347 */   // Label 7357: @375347
     /* 375347 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(375424), // Rule ID 5805 //
     /* 375352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375395 */     // MIs[2] Operand 1
     /* 375395 */     // No operand predicates
     /* 375395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375403 */     // MIs[3] Operand 1
     /* 375403 */     // No operand predicates
     /* 375403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375405 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375422 */     GIR_RootConstrainSelectedInstOperands,
     /* 375423 */     // GIR_Coverage, 5805,
     /* 375423 */     GIR_EraseRootFromParent_Done,
     /* 375424 */   // Label 7358: @375424
     /* 375424 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(375532), // Rule ID 5807 //
     /* 375429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375472 */     // MIs[2] Operand 1
     /* 375472 */     // No operand predicates
     /* 375472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375480 */     // MIs[3] Operand 1
     /* 375480 */     // No operand predicates
     /* 375480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375482 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375530 */     GIR_RootConstrainSelectedInstOperands,
     /* 375531 */     // GIR_Coverage, 5807,
     /* 375531 */     GIR_EraseRootFromParent_Done,
     /* 375532 */   // Label 7359: @375532
     /* 375532 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(375611), // Rule ID 5719 //
     /* 375537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 375559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375565 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 375565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 375581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 375600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375610 */     // GIR_Coverage, 5719,
     /* 375610 */     GIR_EraseRootFromParent_Done,
     /* 375611 */   // Label 7360: @375611
     /* 375611 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(375687), // Rule ID 5731 //
     /* 375616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375644 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 375644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 375671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375686 */     // GIR_Coverage, 5731,
     /* 375686 */     GIR_EraseRootFromParent_Done,
     /* 375687 */   // Label 7361: @375687
     /* 375687 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(375763), // Rule ID 5735 //
     /* 375692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375720 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 375720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 375747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375762 */     // GIR_Coverage, 5735,
     /* 375762 */     GIR_EraseRootFromParent_Done,
     /* 375763 */   // Label 7362: @375763
     /* 375763 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(375826), // Rule ID 5744 //
     /* 375768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 375790 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 375794 */     // MIs[1] Operand 1
     /* 375794 */     // No operand predicates
     /* 375794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375806 */     // MIs[2] Operand 1
     /* 375806 */     // No operand predicates
     /* 375806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375808 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 375808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 375811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 375818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 375824 */     GIR_RootConstrainSelectedInstOperands,
     /* 375825 */     // GIR_Coverage, 5744,
     /* 375825 */     GIR_EraseRootFromParent_Done,
     /* 375826 */   // Label 7363: @375826
     /* 375826 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(375912), // Rule ID 6511 //
     /* 375831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375856 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375860 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 375867 */     // MIs[1] Rn
     /* 375867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375888 */     // MIs[2] Operand 1
     /* 375888 */     // No operand predicates
     /* 375888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375890 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 375893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375910 */     GIR_RootConstrainSelectedInstOperands,
     /* 375911 */     // GIR_Coverage, 6511,
     /* 375911 */     GIR_EraseRootFromParent_Done,
     /* 375912 */   // Label 7364: @375912
     /* 375912 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(375991), // Rule ID 6516 //
     /* 375917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375946 */     // MIs[1] Rn
     /* 375946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375963 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375967 */     // MIs[2] Operand 1
     /* 375967 */     // No operand predicates
     /* 375967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375969 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 375972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375989 */     GIR_RootConstrainSelectedInstOperands,
     /* 375990 */     // GIR_Coverage, 6516,
     /* 375990 */     GIR_EraseRootFromParent_Done,
     /* 375991 */   // Label 7365: @375991
     /* 375991 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(376045), // Rule ID 1939 //
     /* 375996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376029 */     // MIs[1] Operand 1
     /* 376029 */     // No operand predicates
     /* 376029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376031 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 376031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 376034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 376041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376043 */     GIR_RootConstrainSelectedInstOperands,
     /* 376044 */     // GIR_Coverage, 1939,
     /* 376044 */     GIR_EraseRootFromParent_Done,
     /* 376045 */   // Label 7366: @376045
     /* 376045 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(376151), // Rule ID 5749 //
     /* 376050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376080 */     // MIs[1] Operand 1
     /* 376080 */     // No operand predicates
     /* 376080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376082 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 376085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 376099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 376136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 376143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376149 */     GIR_RootConstrainSelectedInstOperands,
     /* 376150 */     // GIR_Coverage, 5749,
     /* 376150 */     GIR_EraseRootFromParent_Done,
     /* 376151 */   // Label 7367: @376151
     /* 376151 */   GIM_Reject,
     /* 376152 */ // Label 7334: @376152
     /* 376152 */ GIM_Reject,
     /* 376153 */ // Label 7160: @376153
     /* 376153 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(379356),
     /* 376158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376161 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(376280), // Rule ID 4221 //
     /* 376166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376180 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376186 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376196 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376203 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376220 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376247 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376279 */     // GIR_Coverage, 4221,
     /* 376279 */     GIR_EraseRootFromParent_Done,
     /* 376280 */   // Label 7369: @376280
     /* 376280 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(376399), // Rule ID 4222 //
     /* 376285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376299 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376305 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376315 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376322 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376339 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376398 */     // GIR_Coverage, 4222,
     /* 376398 */     GIR_EraseRootFromParent_Done,
     /* 376399 */   // Label 7370: @376399
     /* 376399 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(376525), // Rule ID 4257 //
     /* 376404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376434 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376437 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376441 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376465 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376524 */     // GIR_Coverage, 4257,
     /* 376524 */     GIR_EraseRootFromParent_Done,
     /* 376525 */   // Label 7371: @376525
     /* 376525 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(376651), // Rule ID 4258 //
     /* 376530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376563 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376567 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376574 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376591 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376650 */     // GIR_Coverage, 4258,
     /* 376650 */     GIR_EraseRootFromParent_Done,
     /* 376651 */   // Label 7372: @376651
     /* 376651 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(376766), // Rule ID 4227 //
     /* 376656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376682 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376689 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376706 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376733 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376765 */     // GIR_Coverage, 4227,
     /* 376765 */     GIR_EraseRootFromParent_Done,
     /* 376766 */   // Label 7373: @376766
     /* 376766 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(376881), // Rule ID 4229 //
     /* 376771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376797 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376804 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376821 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376848 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376880 */     // GIR_Coverage, 4229,
     /* 376880 */     GIR_EraseRootFromParent_Done,
     /* 376881 */   // Label 7374: @376881
     /* 376881 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(377003), // Rule ID 4263 //
     /* 376886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376912 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376915 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376919 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376926 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376943 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376970 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377002 */     // GIR_Coverage, 4263,
     /* 377002 */     GIR_EraseRootFromParent_Done,
     /* 377003 */   // Label 7375: @377003
     /* 377003 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(377125), // Rule ID 4265 //
     /* 377008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377034 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377037 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377041 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 377065 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 377065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 377072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377092 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377124 */     // GIR_Coverage, 4265,
     /* 377124 */     GIR_EraseRootFromParent_Done,
     /* 377125 */   // Label 7376: @377125
     /* 377125 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(377239), // Rule ID 4219 //
     /* 377130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377160 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377184 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377206 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377238 */     // GIR_Coverage, 4219,
     /* 377238 */     GIR_EraseRootFromParent_Done,
     /* 377239 */   // Label 7377: @377239
     /* 377239 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(377353), // Rule ID 4220 //
     /* 377244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377258 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377264 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377274 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377281 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377298 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377352 */     // GIR_Coverage, 4220,
     /* 377352 */     GIR_EraseRootFromParent_Done,
     /* 377353 */   // Label 7378: @377353
     /* 377353 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(377474), // Rule ID 4255 //
     /* 377358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377388 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377391 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377395 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377419 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377473 */     // GIR_Coverage, 4255,
     /* 377473 */     GIR_EraseRootFromParent_Done,
     /* 377474 */   // Label 7379: @377474
     /* 377474 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(377595), // Rule ID 4256 //
     /* 377479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377512 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377516 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377523 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377540 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377562 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377594 */     // GIR_Coverage, 4256,
     /* 377594 */     GIR_EraseRootFromParent_Done,
     /* 377595 */   // Label 7380: @377595
     /* 377595 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(377705), // Rule ID 4223 //
     /* 377600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377626 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377633 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377650 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377672 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377704 */     // GIR_Coverage, 4223,
     /* 377704 */     GIR_EraseRootFromParent_Done,
     /* 377705 */   // Label 7381: @377705
     /* 377705 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(377815), // Rule ID 4225 //
     /* 377710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377736 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377760 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377782 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377814 */     // GIR_Coverage, 4225,
     /* 377814 */     GIR_EraseRootFromParent_Done,
     /* 377815 */   // Label 7382: @377815
     /* 377815 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(377932), // Rule ID 4259 //
     /* 377820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377846 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377849 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377853 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377877 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377899 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377931 */     // GIR_Coverage, 4259,
     /* 377931 */     GIR_EraseRootFromParent_Done,
     /* 377932 */   // Label 7383: @377932
     /* 377932 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(378049), // Rule ID 4261 //
     /* 377937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377963 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377966 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377970 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377977 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377994 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 378001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378016 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 378038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 378048 */     // GIR_Coverage, 4261,
     /* 378048 */     GIR_EraseRootFromParent_Done,
     /* 378049 */   // Label 7384: @378049
     /* 378049 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(378172), // Rule ID 5790 //
     /* 378054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378101 */     // MIs[3] Operand 1
     /* 378101 */     // No operand predicates
     /* 378101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378107 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 378107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 378110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 378114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 378123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 378126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 378156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 378171 */     // GIR_Coverage, 5790,
     /* 378171 */     GIR_EraseRootFromParent_Done,
     /* 378172 */   // Label 7385: @378172
     /* 378172 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(378295), // Rule ID 5798 //
     /* 378177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378224 */     // MIs[3] Operand 1
     /* 378224 */     // No operand predicates
     /* 378224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378230 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 378230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 378233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 378237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378242 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 378246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 378249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 378279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 378294 */     // GIR_Coverage, 5798,
     /* 378294 */     GIR_EraseRootFromParent_Done,
     /* 378295 */   // Label 7386: @378295
     /* 378295 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(378383), // Rule ID 1942 //
     /* 378300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378346 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378350 */     // MIs[2] Operand 1
     /* 378350 */     // No operand predicates
     /* 378350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378362 */     // MIs[3] Operand 1
     /* 378362 */     // No operand predicates
     /* 378362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378364 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 378364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 378371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 378381 */     GIR_RootConstrainSelectedInstOperands,
     /* 378382 */     // GIR_Coverage, 1942,
     /* 378382 */     GIR_EraseRootFromParent_Done,
     /* 378383 */   // Label 7387: @378383
     /* 378383 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(378482), // Rule ID 5787 //
     /* 378388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 378410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378426 */     // MIs[2] Operand 1
     /* 378426 */     // No operand predicates
     /* 378426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378434 */     // MIs[3] Operand 1
     /* 378434 */     // No operand predicates
     /* 378434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378436 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 378436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 378454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378480 */     GIR_RootConstrainSelectedInstOperands,
     /* 378481 */     // GIR_Coverage, 5787,
     /* 378481 */     GIR_EraseRootFromParent_Done,
     /* 378482 */   // Label 7388: @378482
     /* 378482 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(378581), // Rule ID 5795 //
     /* 378487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 378509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378525 */     // MIs[2] Operand 1
     /* 378525 */     // No operand predicates
     /* 378525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378533 */     // MIs[3] Operand 1
     /* 378533 */     // No operand predicates
     /* 378533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378535 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 378535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378547 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 378553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378579 */     GIR_RootConstrainSelectedInstOperands,
     /* 378580 */     // GIR_Coverage, 5795,
     /* 378580 */     GIR_EraseRootFromParent_Done,
     /* 378581 */   // Label 7389: @378581
     /* 378581 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(378658), // Rule ID 5789 //
     /* 378586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378629 */     // MIs[2] Operand 1
     /* 378629 */     // No operand predicates
     /* 378629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378637 */     // MIs[3] Operand 1
     /* 378637 */     // No operand predicates
     /* 378637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378639 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 378639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378656 */     GIR_RootConstrainSelectedInstOperands,
     /* 378657 */     // GIR_Coverage, 5789,
     /* 378657 */     GIR_EraseRootFromParent_Done,
     /* 378658 */   // Label 7390: @378658
     /* 378658 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(378766), // Rule ID 5791 //
     /* 378663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 378689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378706 */     // MIs[2] Operand 1
     /* 378706 */     // No operand predicates
     /* 378706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378714 */     // MIs[3] Operand 1
     /* 378714 */     // No operand predicates
     /* 378714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378716 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 378716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378764 */     GIR_RootConstrainSelectedInstOperands,
     /* 378765 */     // GIR_Coverage, 5791,
     /* 378765 */     GIR_EraseRootFromParent_Done,
     /* 378766 */   // Label 7391: @378766
     /* 378766 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(378843), // Rule ID 5797 //
     /* 378771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378814 */     // MIs[2] Operand 1
     /* 378814 */     // No operand predicates
     /* 378814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378822 */     // MIs[3] Operand 1
     /* 378822 */     // No operand predicates
     /* 378822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378824 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 378824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378841 */     GIR_RootConstrainSelectedInstOperands,
     /* 378842 */     // GIR_Coverage, 5797,
     /* 378842 */     GIR_EraseRootFromParent_Done,
     /* 378843 */   // Label 7392: @378843
     /* 378843 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(378951), // Rule ID 5799 //
     /* 378848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 378874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378891 */     // MIs[2] Operand 1
     /* 378891 */     // No operand predicates
     /* 378891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378899 */     // MIs[3] Operand 1
     /* 378899 */     // No operand predicates
     /* 378899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378901 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 378901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378949 */     GIR_RootConstrainSelectedInstOperands,
     /* 378950 */     // GIR_Coverage, 5799,
     /* 378950 */     GIR_EraseRootFromParent_Done,
     /* 378951 */   // Label 7393: @378951
     /* 378951 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(379030), // Rule ID 5714 //
     /* 378956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 378978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378984 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 378984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 379000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379029 */     // GIR_Coverage, 5714,
     /* 379029 */     GIR_EraseRootFromParent_Done,
     /* 379030 */   // Label 7394: @379030
     /* 379030 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(379109), // Rule ID 6509 //
     /* 379035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 379038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 379064 */     // MIs[1] Rn
     /* 379064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 379068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 379073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 379077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 379085 */     // MIs[2] Operand 1
     /* 379085 */     // No operand predicates
     /* 379085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379087 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 379087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 379090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 379094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379107 */     GIR_RootConstrainSelectedInstOperands,
     /* 379108 */     // GIR_Coverage, 6509,
     /* 379108 */     GIR_EraseRootFromParent_Done,
     /* 379109 */   // Label 7395: @379109
     /* 379109 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(379195), // Rule ID 6510 //
     /* 379114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379136 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379139 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 379143 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 379150 */     // MIs[1] Rn
     /* 379150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 379154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 379159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 379163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 379171 */     // MIs[2] Operand 1
     /* 379171 */     // No operand predicates
     /* 379171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379173 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 379173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 379176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 379180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379193 */     GIR_RootConstrainSelectedInstOperands,
     /* 379194 */     // GIR_Coverage, 6510,
     /* 379194 */     GIR_EraseRootFromParent_Done,
     /* 379195 */   // Label 7396: @379195
     /* 379195 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(379249), // Rule ID 1938 //
     /* 379200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 379221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 379225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 379233 */     // MIs[1] Operand 1
     /* 379233 */     // No operand predicates
     /* 379233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379235 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 379235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 379238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 379242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 379245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379247 */     GIR_RootConstrainSelectedInstOperands,
     /* 379248 */     // GIR_Coverage, 1938,
     /* 379248 */     GIR_EraseRootFromParent_Done,
     /* 379249 */   // Label 7397: @379249
     /* 379249 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(379355), // Rule ID 5757 //
     /* 379254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 379257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 379272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 379276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 379284 */     // MIs[1] Operand 1
     /* 379284 */     // No operand predicates
     /* 379284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379286 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 379289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379312 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 379319 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 379322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 379337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 379340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 379347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379353 */     GIR_RootConstrainSelectedInstOperands,
     /* 379354 */     // GIR_Coverage, 5757,
     /* 379354 */     GIR_EraseRootFromParent_Done,
     /* 379355 */   // Label 7398: @379355
     /* 379355 */   GIM_Reject,
     /* 379356 */ // Label 7368: @379356
     /* 379356 */ GIM_Reject,
     /* 379357 */ // Label 7161: @379357
     /* 379357 */ GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(379481), // Rule ID 11317 //
     /* 379362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 379368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 379371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379386 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 379386 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379389 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379393 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379398 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379416 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379419 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379424 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379427 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379431 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379436 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379453 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379456 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379459 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379462 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 379470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379472 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379477 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379479 */   GIR_RootConstrainSelectedInstOperands,
     /* 379480 */   // GIR_Coverage, 11317,
     /* 379480 */   GIR_EraseRootFromParent_Done,
     /* 379481 */ // Label 7399: @379481
     /* 379481 */ GIM_Reject,
     /* 379482 */ // Label 7162: @379482
     /* 379482 */ GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(379606), // Rule ID 11320 //
     /* 379487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 379493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379511 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 379511 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379514 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379518 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379523 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379541 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379544 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379549 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379552 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379556 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379561 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379578 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379581 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379584 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379587 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 379595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379597 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379602 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379604 */   GIR_RootConstrainSelectedInstOperands,
     /* 379605 */   // GIR_Coverage, 11320,
     /* 379605 */   GIR_EraseRootFromParent_Done,
     /* 379606 */ // Label 7400: @379606
     /* 379606 */ GIM_Reject,
     /* 379607 */ // Label 7163: @379607
     /* 379607 */ GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(381584),
     /* 379612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 379615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 379618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379625 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(379734), // Rule ID 4389 //
     /* 379630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379650 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379657 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379674 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379701 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379733 */     // GIR_Coverage, 4389,
     /* 379733 */     GIR_EraseRootFromParent_Done,
     /* 379734 */   // Label 7402: @379734
     /* 379734 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(379843), // Rule ID 4390 //
     /* 379739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379759 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379766 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 379783 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 379790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379842 */     // GIR_Coverage, 4390,
     /* 379842 */     GIR_EraseRootFromParent_Done,
     /* 379843 */   // Label 7403: @379843
     /* 379843 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(379952), // Rule ID 4497 //
     /* 379848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379868 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379875 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379892 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379919 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379951 */     // GIR_Coverage, 4497,
     /* 379951 */     GIR_EraseRootFromParent_Done,
     /* 379952 */   // Label 7404: @379952
     /* 379952 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(380061), // Rule ID 4498 //
     /* 379957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379961 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379977 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379984 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 380001 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 380008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380028 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380060 */     // GIR_Coverage, 4498,
     /* 380060 */     GIR_EraseRootFromParent_Done,
     /* 380061 */   // Label 7405: @380061
     /* 380061 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(380166), // Rule ID 4395 //
     /* 380066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380082 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380089 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 380106 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 380113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380165 */     // GIR_Coverage, 4395,
     /* 380165 */     GIR_EraseRootFromParent_Done,
     /* 380166 */   // Label 7406: @380166
     /* 380166 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(380271), // Rule ID 4397 //
     /* 380171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380187 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380194 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 380211 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 380218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380238 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380270 */     // GIR_Coverage, 4397,
     /* 380270 */     GIR_EraseRootFromParent_Done,
     /* 380271 */   // Label 7407: @380271
     /* 380271 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(380376), // Rule ID 4503 //
     /* 380276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380292 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380299 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 380316 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 380323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380375 */     // GIR_Coverage, 4503,
     /* 380375 */     GIR_EraseRootFromParent_Done,
     /* 380376 */   // Label 7408: @380376
     /* 380376 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(380481), // Rule ID 4505 //
     /* 380381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380404 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 380421 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 380428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380480 */     // GIR_Coverage, 4505,
     /* 380480 */     GIR_EraseRootFromParent_Done,
     /* 380481 */   // Label 7409: @380481
     /* 380481 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(380585), // Rule ID 4387 //
     /* 380486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380506 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380530 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380552 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380584 */     // GIR_Coverage, 4387,
     /* 380584 */     GIR_EraseRootFromParent_Done,
     /* 380585 */   // Label 7410: @380585
     /* 380585 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(380689), // Rule ID 4388 //
     /* 380590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380634 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380688 */     // GIR_Coverage, 4388,
     /* 380688 */     GIR_EraseRootFromParent_Done,
     /* 380689 */   // Label 7411: @380689
     /* 380689 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(380793), // Rule ID 4495 //
     /* 380694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380714 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380721 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380738 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380792 */     // GIR_Coverage, 4495,
     /* 380792 */     GIR_EraseRootFromParent_Done,
     /* 380793 */   // Label 7412: @380793
     /* 380793 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(380897), // Rule ID 4496 //
     /* 380798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380808 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380818 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380825 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380842 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380864 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380896 */     // GIR_Coverage, 4496,
     /* 380896 */     GIR_EraseRootFromParent_Done,
     /* 380897 */   // Label 7413: @380897
     /* 380897 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(380997), // Rule ID 4391 //
     /* 380902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380918 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380942 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380964 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380996 */     // GIR_Coverage, 4391,
     /* 380996 */     GIR_EraseRootFromParent_Done,
     /* 380997 */   // Label 7414: @380997
     /* 380997 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(381097), // Rule ID 4393 //
     /* 381002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 381042 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 381042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 381049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 381086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381096 */     // GIR_Coverage, 4393,
     /* 381096 */     GIR_EraseRootFromParent_Done,
     /* 381097 */   // Label 7415: @381097
     /* 381097 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(381197), // Rule ID 4499 //
     /* 381102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381118 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381125 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 381142 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 381142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 381149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381164 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 381186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381196 */     // GIR_Coverage, 4499,
     /* 381196 */     GIR_EraseRootFromParent_Done,
     /* 381197 */   // Label 7416: @381197
     /* 381197 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(381297), // Rule ID 4501 //
     /* 381202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 381242 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 381242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 381249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 381286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381296 */     // GIR_Coverage, 4501,
     /* 381296 */     GIR_EraseRootFromParent_Done,
     /* 381297 */   // Label 7417: @381297
     /* 381297 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(381361), // Rule ID 11375 //
     /* 381302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 381325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381337 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 381341 */     // MIs[3] Operand 1
     /* 381341 */     // No operand predicates
     /* 381341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381347 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 381347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 381350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 381356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 381359 */     GIR_RootConstrainSelectedInstOperands,
     /* 381360 */     // GIR_Coverage, 11375,
     /* 381360 */     GIR_EraseRootFromParent_Done,
     /* 381361 */   // Label 7418: @381361
     /* 381361 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(381472), // Rule ID 11316 //
     /* 381366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381377 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 381377 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381380 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 381384 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381389 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 381393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381395 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381398 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 381402 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381407 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381410 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 381422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381427 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 381439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381453 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 381461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381463 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381470 */     GIR_RootConstrainSelectedInstOperands,
     /* 381471 */     // GIR_Coverage, 11316,
     /* 381471 */     GIR_EraseRootFromParent_Done,
     /* 381472 */   // Label 7419: @381472
     /* 381472 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(381583), // Rule ID 11322 //
     /* 381477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381488 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 381488 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381491 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 381495 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381500 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 381504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 381513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381518 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381521 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 381533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381538 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 381550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381564 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 381572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381574 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381581 */     GIR_RootConstrainSelectedInstOperands,
     /* 381582 */     // GIR_Coverage, 11322,
     /* 381582 */     GIR_EraseRootFromParent_Done,
     /* 381583 */   // Label 7420: @381583
     /* 381583 */   GIM_Reject,
     /* 381584 */ // Label 7401: @381584
     /* 381584 */ GIM_Reject,
     /* 381585 */ // Label 7164: @381585
     /* 381585 */ GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(381736), // Rule ID 11318 //
     /* 381590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 381596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381610 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381614 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 381614 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381617 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381621 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381626 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381632 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381637 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381642 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381645 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381649 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381654 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381659 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381662 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381666 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381671 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381674 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381679 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381682 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381686 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381691 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381708 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381711 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381714 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381717 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 381725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381727 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381732 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381734 */   GIR_RootConstrainSelectedInstOperands,
     /* 381735 */   // GIR_Coverage, 11318,
     /* 381735 */   GIR_EraseRootFromParent_Done,
     /* 381736 */ // Label 7421: @381736
     /* 381736 */ GIM_Reject,
     /* 381737 */ // Label 7165: @381737
     /* 381737 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(383768),
     /* 381742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 381745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381755 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(381864), // Rule ID 4353 //
     /* 381760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381780 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381787 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 381804 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 381811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381863 */     // GIR_Coverage, 4353,
     /* 381863 */     GIR_EraseRootFromParent_Done,
     /* 381864 */   // Label 7423: @381864
     /* 381864 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(381973), // Rule ID 4354 //
     /* 381869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381873 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381879 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381889 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381896 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381913 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381972 */     // GIR_Coverage, 4354,
     /* 381972 */     GIR_EraseRootFromParent_Done,
     /* 381973 */   // Label 7424: @381973
     /* 381973 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(382082), // Rule ID 4461 //
     /* 381978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381998 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382005 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 382022 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 382029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382081 */     // GIR_Coverage, 4461,
     /* 382081 */     GIR_EraseRootFromParent_Done,
     /* 382082 */   // Label 7425: @382082
     /* 382082 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(382191), // Rule ID 4462 //
     /* 382087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 382131 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 382138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382190 */     // GIR_Coverage, 4462,
     /* 382190 */     GIR_EraseRootFromParent_Done,
     /* 382191 */   // Label 7426: @382191
     /* 382191 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(382296), // Rule ID 4359 //
     /* 382196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382212 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382219 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 382236 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 382243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382263 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382295 */     // GIR_Coverage, 4359,
     /* 382295 */     GIR_EraseRootFromParent_Done,
     /* 382296 */   // Label 7427: @382296
     /* 382296 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(382401), // Rule ID 4361 //
     /* 382301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382324 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 382341 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 382348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382368 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382400 */     // GIR_Coverage, 4361,
     /* 382400 */     GIR_EraseRootFromParent_Done,
     /* 382401 */   // Label 7428: @382401
     /* 382401 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(382506), // Rule ID 4467 //
     /* 382406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382422 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382429 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 382446 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 382453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382473 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382505 */     // GIR_Coverage, 4467,
     /* 382505 */     GIR_EraseRootFromParent_Done,
     /* 382506 */   // Label 7429: @382506
     /* 382506 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(382611), // Rule ID 4469 //
     /* 382511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 382551 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 382558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382578 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382610 */     // GIR_Coverage, 4469,
     /* 382610 */     GIR_EraseRootFromParent_Done,
     /* 382611 */   // Label 7430: @382611
     /* 382611 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(382715), // Rule ID 4351 //
     /* 382616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382636 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382660 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382714 */     // GIR_Coverage, 4351,
     /* 382714 */     GIR_EraseRootFromParent_Done,
     /* 382715 */   // Label 7431: @382715
     /* 382715 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(382819), // Rule ID 4352 //
     /* 382720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382724 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382730 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382740 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382747 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382764 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382786 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382818 */     // GIR_Coverage, 4352,
     /* 382818 */     GIR_EraseRootFromParent_Done,
     /* 382819 */   // Label 7432: @382819
     /* 382819 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(382923), // Rule ID 4459 //
     /* 382824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382844 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382851 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382868 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382922 */     // GIR_Coverage, 4459,
     /* 382922 */     GIR_EraseRootFromParent_Done,
     /* 382923 */   // Label 7433: @382923
     /* 382923 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(383027), // Rule ID 4460 //
     /* 382928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382972 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383026 */     // GIR_Coverage, 4460,
     /* 383026 */     GIR_EraseRootFromParent_Done,
     /* 383027 */   // Label 7434: @383027
     /* 383027 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(383127), // Rule ID 4355 //
     /* 383032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 383072 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 383072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 383079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383126 */     // GIR_Coverage, 4355,
     /* 383126 */     GIR_EraseRootFromParent_Done,
     /* 383127 */   // Label 7435: @383127
     /* 383127 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(383227), // Rule ID 4357 //
     /* 383132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 383172 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 383172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 383179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383226 */     // GIR_Coverage, 4357,
     /* 383226 */     GIR_EraseRootFromParent_Done,
     /* 383227 */   // Label 7436: @383227
     /* 383227 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(383327), // Rule ID 4463 //
     /* 383232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383248 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 383272 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 383272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 383279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383326 */     // GIR_Coverage, 4463,
     /* 383326 */     GIR_EraseRootFromParent_Done,
     /* 383327 */   // Label 7437: @383327
     /* 383327 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(383427), // Rule ID 4465 //
     /* 383332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383348 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 383372 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 383372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 383379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383394 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383426 */     // GIR_Coverage, 4465,
     /* 383426 */     GIR_EraseRootFromParent_Done,
     /* 383427 */   // Label 7438: @383427
     /* 383427 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(383491), // Rule ID 11373 //
     /* 383432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 383455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383467 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 383471 */     // MIs[3] Operand 1
     /* 383471 */     // No operand predicates
     /* 383471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383477 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 383477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 383480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 383486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 383489 */     GIR_RootConstrainSelectedInstOperands,
     /* 383490 */     // GIR_Coverage, 11373,
     /* 383490 */     GIR_EraseRootFromParent_Done,
     /* 383491 */   // Label 7439: @383491
     /* 383491 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(383629), // Rule ID 11315 //
     /* 383496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383507 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 383507 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383510 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383514 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383519 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383525 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383530 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383535 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383538 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 383542 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383547 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 383559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383564 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383567 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 383579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 383596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383610 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 383618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383620 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383627 */     GIR_RootConstrainSelectedInstOperands,
     /* 383628 */     // GIR_Coverage, 11315,
     /* 383628 */     GIR_EraseRootFromParent_Done,
     /* 383629 */   // Label 7440: @383629
     /* 383629 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(383767), // Rule ID 11321 //
     /* 383634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383645 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 383645 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383648 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383652 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383657 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383663 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383668 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383673 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383676 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 383680 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383685 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 383697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383702 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383705 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 383717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383722 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 383734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383748 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 383756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383758 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383765 */     GIR_RootConstrainSelectedInstOperands,
     /* 383766 */     // GIR_Coverage, 11321,
     /* 383766 */     GIR_EraseRootFromParent_Done,
     /* 383767 */   // Label 7441: @383767
     /* 383767 */   GIM_Reject,
     /* 383768 */ // Label 7422: @383768
     /* 383768 */ GIM_Reject,
     /* 383769 */ // Label 7166: @383769
     /* 383769 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(386036),
     /* 383774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383777 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(383903), // Rule ID 4317 //
     /* 383782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383812 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383815 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383819 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383826 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383843 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383902 */     // GIR_Coverage, 4317,
     /* 383902 */     GIR_EraseRootFromParent_Done,
     /* 383903 */   // Label 7443: @383903
     /* 383903 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(384029), // Rule ID 4318 //
     /* 383908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383922 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383928 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383938 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383941 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383945 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383952 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383969 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383996 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384028 */     // GIR_Coverage, 4318,
     /* 384028 */     GIR_EraseRootFromParent_Done,
     /* 384029 */   // Label 7444: @384029
     /* 384029 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(384148), // Rule ID 4425 //
     /* 384034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 384088 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 384095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384147 */     // GIR_Coverage, 4425,
     /* 384147 */     GIR_EraseRootFromParent_Done,
     /* 384148 */   // Label 7445: @384148
     /* 384148 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(384267), // Rule ID 4426 //
     /* 384153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384183 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384190 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 384207 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 384214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384266 */     // GIR_Coverage, 4426,
     /* 384266 */     GIR_EraseRootFromParent_Done,
     /* 384267 */   // Label 7446: @384267
     /* 384267 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(384389), // Rule ID 4323 //
     /* 384272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384305 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384312 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 384329 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 384336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384356 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384388 */     // GIR_Coverage, 4323,
     /* 384388 */     GIR_EraseRootFromParent_Done,
     /* 384389 */   // Label 7447: @384389
     /* 384389 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(384511), // Rule ID 4325 //
     /* 384394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384420 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384423 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384427 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 384451 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 384458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384510 */     // GIR_Coverage, 4325,
     /* 384510 */     GIR_EraseRootFromParent_Done,
     /* 384511 */   // Label 7448: @384511
     /* 384511 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(384626), // Rule ID 4431 //
     /* 384516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384542 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384549 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 384566 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 384573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384593 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384625 */     // GIR_Coverage, 4431,
     /* 384625 */     GIR_EraseRootFromParent_Done,
     /* 384626 */   // Label 7449: @384626
     /* 384626 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(384741), // Rule ID 4433 //
     /* 384631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384657 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384664 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 384681 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 384688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384740 */     // GIR_Coverage, 4433,
     /* 384740 */     GIR_EraseRootFromParent_Done,
     /* 384741 */   // Label 7450: @384741
     /* 384741 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(384862), // Rule ID 4315 //
     /* 384746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384779 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384783 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 384807 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 384807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 384814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384861 */     // GIR_Coverage, 4315,
     /* 384861 */     GIR_EraseRootFromParent_Done,
     /* 384862 */   // Label 7451: @384862
     /* 384862 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(384983), // Rule ID 4316 //
     /* 384867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384900 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384904 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 384928 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 384928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 384935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384982 */     // GIR_Coverage, 4316,
     /* 384982 */     GIR_EraseRootFromParent_Done,
     /* 384983 */   // Label 7452: @384983
     /* 384983 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(385097), // Rule ID 4423 //
     /* 384988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385002 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385008 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 385042 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 385042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 385049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385096 */     // GIR_Coverage, 4423,
     /* 385096 */     GIR_EraseRootFromParent_Done,
     /* 385097 */   // Label 7453: @385097
     /* 385097 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(385211), // Rule ID 4424 //
     /* 385102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385116 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385122 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385132 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 385156 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 385156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 385163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385178 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385210 */     // GIR_Coverage, 4424,
     /* 385210 */     GIR_EraseRootFromParent_Done,
     /* 385211 */   // Label 7454: @385211
     /* 385211 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(385328), // Rule ID 4319 //
     /* 385216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385242 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385245 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385249 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 385273 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 385273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 385280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385327 */     // GIR_Coverage, 4319,
     /* 385327 */     GIR_EraseRootFromParent_Done,
     /* 385328 */   // Label 7455: @385328
     /* 385328 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(385445), // Rule ID 4321 //
     /* 385333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385362 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385366 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385373 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 385390 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 385390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 385397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385444 */     // GIR_Coverage, 4321,
     /* 385444 */     GIR_EraseRootFromParent_Done,
     /* 385445 */   // Label 7456: @385445
     /* 385445 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(385555), // Rule ID 4427 //
     /* 385450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385476 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385483 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 385500 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 385500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 385507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385522 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385554 */     // GIR_Coverage, 4427,
     /* 385554 */     GIR_EraseRootFromParent_Done,
     /* 385555 */   // Label 7457: @385555
     /* 385555 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(385665), // Rule ID 4429 //
     /* 385560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385593 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 385610 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 385610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 385617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385632 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385664 */     // GIR_Coverage, 4429,
     /* 385664 */     GIR_EraseRootFromParent_Done,
     /* 385665 */   // Label 7458: @385665
     /* 385665 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(385739), // Rule ID 11371 //
     /* 385670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385715 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 385719 */     // MIs[3] Operand 1
     /* 385719 */     // No operand predicates
     /* 385719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385725 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 385725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 385728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 385734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 385737 */     GIR_RootConstrainSelectedInstOperands,
     /* 385738 */     // GIR_Coverage, 11371,
     /* 385738 */     GIR_EraseRootFromParent_Done,
     /* 385739 */   // Label 7459: @385739
     /* 385739 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(385887), // Rule ID 11314 //
     /* 385744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385765 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 385765 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385768 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385772 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385777 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385783 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385788 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385793 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385796 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 385800 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385805 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385810 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385813 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 385817 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385822 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385825 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 385837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385842 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 385854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385868 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 385876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385878 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385885 */     GIR_RootConstrainSelectedInstOperands,
     /* 385886 */     // GIR_Coverage, 11314,
     /* 385886 */     GIR_EraseRootFromParent_Done,
     /* 385887 */   // Label 7460: @385887
     /* 385887 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386035), // Rule ID 11319 //
     /* 385892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385913 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 385913 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385916 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385920 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385925 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385931 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385936 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385941 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385944 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 385948 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385953 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 385965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385970 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385973 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385981 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 385985 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385990 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 386002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 386010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 386013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 386016 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 386024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 386026 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 386033 */     GIR_RootConstrainSelectedInstOperands,
     /* 386034 */     // GIR_Coverage, 11319,
     /* 386034 */     GIR_EraseRootFromParent_Done,
     /* 386035 */   // Label 7461: @386035
     /* 386035 */   GIM_Reject,
     /* 386036 */ // Label 7442: @386036
     /* 386036 */ GIM_Reject,
     /* 386037 */ // Label 7167: @386037
     /* 386037 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(388156),
     /* 386042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386045 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386164), // Rule ID 4245 //
     /* 386050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386080 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386087 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386104 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386163 */     // GIR_Coverage, 4245,
     /* 386163 */     GIR_EraseRootFromParent_Done,
     /* 386164 */   // Label 7463: @386164
     /* 386164 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386283), // Rule ID 4246 //
     /* 386169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386183 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386189 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386206 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386223 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386250 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386282 */     // GIR_Coverage, 4246,
     /* 386282 */     GIR_EraseRootFromParent_Done,
     /* 386283 */   // Label 7464: @386283
     /* 386283 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(386409), // Rule ID 4281 //
     /* 386288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386302 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386308 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386318 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386321 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386325 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386332 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386349 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386376 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386408 */     // GIR_Coverage, 4281,
     /* 386408 */     GIR_EraseRootFromParent_Done,
     /* 386409 */   // Label 7465: @386409
     /* 386409 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(386535), // Rule ID 4282 //
     /* 386414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386428 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386434 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386444 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386447 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386451 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386458 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386475 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386534 */     // GIR_Coverage, 4282,
     /* 386534 */     GIR_EraseRootFromParent_Done,
     /* 386535 */   // Label 7466: @386535
     /* 386535 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(386650), // Rule ID 4251 //
     /* 386540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386566 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386573 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386590 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386649 */     // GIR_Coverage, 4251,
     /* 386649 */     GIR_EraseRootFromParent_Done,
     /* 386650 */   // Label 7467: @386650
     /* 386650 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(386765), // Rule ID 4253 //
     /* 386655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386705 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386764 */     // GIR_Coverage, 4253,
     /* 386764 */     GIR_EraseRootFromParent_Done,
     /* 386765 */   // Label 7468: @386765
     /* 386765 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(386887), // Rule ID 4287 //
     /* 386770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386796 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386799 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386803 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386827 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386854 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386886 */     // GIR_Coverage, 4287,
     /* 386886 */     GIR_EraseRootFromParent_Done,
     /* 386887 */   // Label 7469: @386887
     /* 386887 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387009), // Rule ID 4289 //
     /* 386892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386918 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386921 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386925 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386932 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386949 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386976 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387008 */     // GIR_Coverage, 4289,
     /* 387008 */     GIR_EraseRootFromParent_Done,
     /* 387009 */   // Label 7470: @387009
     /* 387009 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387123), // Rule ID 4243 //
     /* 387014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387028 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 387034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 387036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387044 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387051 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387068 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387090 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387122 */     // GIR_Coverage, 4243,
     /* 387122 */     GIR_EraseRootFromParent_Done,
     /* 387123 */   // Label 7471: @387123
     /* 387123 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387237), // Rule ID 4244 //
     /* 387128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387142 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 387148 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 387150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387158 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387165 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387182 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387204 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387236 */     // GIR_Coverage, 4244,
     /* 387236 */     GIR_EraseRootFromParent_Done,
     /* 387237 */   // Label 7472: @387237
     /* 387237 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387358), // Rule ID 4279 //
     /* 387242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 387262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 387264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387272 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387275 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387279 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387303 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387325 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387357 */     // GIR_Coverage, 4279,
     /* 387357 */     GIR_EraseRootFromParent_Done,
     /* 387358 */   // Label 7473: @387358
     /* 387358 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387479), // Rule ID 4280 //
     /* 387363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 387383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 387385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387393 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387396 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387400 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387407 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387424 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387446 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387478 */     // GIR_Coverage, 4280,
     /* 387478 */     GIR_EraseRootFromParent_Done,
     /* 387479 */   // Label 7474: @387479
     /* 387479 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387589), // Rule ID 4247 //
     /* 387484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387510 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387517 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387534 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387588 */     // GIR_Coverage, 4247,
     /* 387588 */     GIR_EraseRootFromParent_Done,
     /* 387589 */   // Label 7475: @387589
     /* 387589 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387699), // Rule ID 4249 //
     /* 387594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387620 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387627 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387644 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387698 */     // GIR_Coverage, 4249,
     /* 387698 */     GIR_EraseRootFromParent_Done,
     /* 387699 */   // Label 7476: @387699
     /* 387699 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(387816), // Rule ID 4283 //
     /* 387704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387730 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387733 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387737 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387744 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387761 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387815 */     // GIR_Coverage, 4283,
     /* 387815 */     GIR_EraseRootFromParent_Done,
     /* 387816 */   // Label 7477: @387816
     /* 387816 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(387933), // Rule ID 4285 //
     /* 387821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387847 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387850 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387854 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387861 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387878 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387900 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387932 */     // GIR_Coverage, 4285,
     /* 387932 */     GIR_EraseRootFromParent_Done,
     /* 387933 */   // Label 7478: @387933
     /* 387933 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(388007), // Rule ID 11369 //
     /* 387938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 387987 */     // MIs[3] Operand 1
     /* 387987 */     // No operand predicates
     /* 387987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387993 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 387993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 387996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 387998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 388002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 388005 */     GIR_RootConstrainSelectedInstOperands,
     /* 388006 */     // GIR_Coverage, 11369,
     /* 388006 */     GIR_EraseRootFromParent_Done,
     /* 388007 */   // Label 7479: @388007
     /* 388007 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(388155), // Rule ID 11313 //
     /* 388012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 388021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388033 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 388033 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 388036 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388040 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388045 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 388051 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388056 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388061 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 388064 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 388068 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388073 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 388076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 388078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 388081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 388085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 388093 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 388096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 388098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 388101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 388105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388110 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 388113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 388122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388130 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 388133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 388136 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 388144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388146 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 388153 */     GIR_RootConstrainSelectedInstOperands,
     /* 388154 */     // GIR_Coverage, 11313,
     /* 388154 */     GIR_EraseRootFromParent_Done,
     /* 388155 */   // Label 7480: @388155
     /* 388155 */   GIM_Reject,
     /* 388156 */ // Label 7462: @388156
     /* 388156 */ GIM_Reject,
     /* 388157 */ // Label 7168: @388157
     /* 388157 */ GIM_Reject,
     /* 388158 */ // Label 92: @388158
     /* 388158 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7484*/ GIMT_Encode4(391075),
     /* 388169 */ /*GILLT_s16*//*Label 7481*/ GIMT_Encode4(388181),
     /* 388173 */ /*GILLT_s32*//*Label 7482*/ GIMT_Encode4(388815),
     /* 388177 */ /*GILLT_s64*//*Label 7483*/ GIMT_Encode4(390408),
     /* 388181 */ // Label 7481: @388181
     /* 388181 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(388225), // Rule ID 11362 //
     /* 388186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388199 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388203 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 388203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388208 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 388214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388224 */   // GIR_Coverage, 11362,
     /* 388224 */   GIR_EraseRootFromParent_Done,
     /* 388225 */ // Label 7485: @388225
     /* 388225 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388269), // Rule ID 11363 //
     /* 388230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388243 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388247 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 388247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388252 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 388258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388268 */   // GIR_Coverage, 11363,
     /* 388268 */   GIR_EraseRootFromParent_Done,
     /* 388269 */ // Label 7486: @388269
     /* 388269 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388313), // Rule ID 11364 //
     /* 388274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388287 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388291 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 388291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388296 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 388302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388312 */   // GIR_Coverage, 11364,
     /* 388312 */   GIR_EraseRootFromParent_Done,
     /* 388313 */ // Label 7487: @388313
     /* 388313 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388358), // Rule ID 5851 //
     /* 388318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388332 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388336 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 388336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388341 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 388347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388357 */   // GIR_Coverage, 5851,
     /* 388357 */   GIR_EraseRootFromParent_Done,
     /* 388358 */ // Label 7488: @388358
     /* 388358 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388403), // Rule ID 5854 //
     /* 388363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388377 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388385 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388389 */   // MIs[1] Operand 1
     /* 388389 */   // No operand predicates
     /* 388389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388391 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 388394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388396 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388398 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388401 */   GIR_RootConstrainSelectedInstOperands,
     /* 388402 */   // GIR_Coverage, 5854,
     /* 388402 */   GIR_EraseRootFromParent_Done,
     /* 388403 */ // Label 7489: @388403
     /* 388403 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388479), // Rule ID 11337 //
     /* 388408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388429 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388433 */   // MIs[1] Operand 1
     /* 388433 */   // No operand predicates
     /* 388433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388435 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 388435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388447 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388451 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388461 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388478 */   // GIR_Coverage, 11337,
     /* 388478 */   GIR_EraseRootFromParent_Done,
     /* 388479 */ // Label 7490: @388479
     /* 388479 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388555), // Rule ID 11338 //
     /* 388484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388505 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388509 */   // MIs[1] Operand 1
     /* 388509 */   // No operand predicates
     /* 388509 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388511 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 388511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388527 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388537 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388554 */   // GIR_Coverage, 11338,
     /* 388554 */   GIR_EraseRootFromParent_Done,
     /* 388555 */ // Label 7491: @388555
     /* 388555 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388631), // Rule ID 11339 //
     /* 388560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388581 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388585 */   // MIs[1] Operand 1
     /* 388585 */   // No operand predicates
     /* 388585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388587 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 388587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388603 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388613 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388630 */   // GIR_Coverage, 11339,
     /* 388630 */   GIR_EraseRootFromParent_Done,
     /* 388631 */ // Label 7492: @388631
     /* 388631 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(388692), // Rule ID 11327 //
     /* 388636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388653 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 388653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 388660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388665 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388675 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388688 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388690 */   GIR_RootConstrainSelectedInstOperands,
     /* 388691 */   // GIR_Coverage, 11327,
     /* 388691 */   GIR_EraseRootFromParent_Done,
     /* 388692 */ // Label 7493: @388692
     /* 388692 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388753), // Rule ID 11328 //
     /* 388697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388714 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 388714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388726 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388736 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388749 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388751 */   GIR_RootConstrainSelectedInstOperands,
     /* 388752 */   // GIR_Coverage, 11328,
     /* 388752 */   GIR_EraseRootFromParent_Done,
     /* 388753 */ // Label 7494: @388753
     /* 388753 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388814), // Rule ID 11329 //
     /* 388758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388775 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 388775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388787 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388793 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388797 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388810 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388812 */   GIR_RootConstrainSelectedInstOperands,
     /* 388813 */   // GIR_Coverage, 11329,
     /* 388813 */   GIR_EraseRootFromParent_Done,
     /* 388814 */ // Label 7495: @388814
     /* 388814 */ GIM_Reject,
     /* 388815 */ // Label 7482: @388815
     /* 388815 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(388860), // Rule ID 7038 //
     /* 388820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388834 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388838 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 388838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388843 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 388849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388859 */   // GIR_Coverage, 7038,
     /* 388859 */   GIR_EraseRootFromParent_Done,
     /* 388860 */ // Label 7496: @388860
     /* 388860 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(388905), // Rule ID 7039 //
     /* 388865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388879 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388883 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 388883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388888 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 388894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388904 */   // GIR_Coverage, 7039,
     /* 388904 */   GIR_EraseRootFromParent_Done,
     /* 388905 */ // Label 7497: @388905
     /* 388905 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(388949), // Rule ID 11358 //
     /* 388910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388923 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388927 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 388927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388932 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388948 */   // GIR_Coverage, 11358,
     /* 388948 */   GIR_EraseRootFromParent_Done,
     /* 388949 */ // Label 7498: @388949
     /* 388949 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(388993), // Rule ID 11359 //
     /* 388954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388967 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388971 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 388971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388976 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388992 */   // GIR_Coverage, 11359,
     /* 388992 */   GIR_EraseRootFromParent_Done,
     /* 388993 */ // Label 7499: @388993
     /* 388993 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(389037), // Rule ID 11360 //
     /* 388998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389011 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389015 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 389015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389020 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 389026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389036 */   // GIR_Coverage, 11360,
     /* 389036 */   GIR_EraseRootFromParent_Done,
     /* 389037 */ // Label 7500: @389037
     /* 389037 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(389081), // Rule ID 11365 //
     /* 389042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389055 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389059 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 389059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389064 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 389070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389080 */   // GIR_Coverage, 11365,
     /* 389080 */   GIR_EraseRootFromParent_Done,
     /* 389081 */ // Label 7501: @389081
     /* 389081 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(389125), // Rule ID 11366 //
     /* 389086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 389092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389099 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389103 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 389103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389108 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 389114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389124 */   // GIR_Coverage, 11366,
     /* 389124 */   GIR_EraseRootFromParent_Done,
     /* 389125 */ // Label 7502: @389125
     /* 389125 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(389170), // Rule ID 5850 //
     /* 389130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389144 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389148 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 389148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389153 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 389159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389169 */   // GIR_Coverage, 5850,
     /* 389169 */   GIR_EraseRootFromParent_Done,
     /* 389170 */ // Label 7503: @389170
     /* 389170 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(389243), // Rule ID 11343 //
     /* 389175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 389181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389196 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 389200 */   // MIs[1] Operand 1
     /* 389200 */   // No operand predicates
     /* 389200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389202 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 389202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389214 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 389220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 389233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389238 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389241 */   GIR_RootConstrainSelectedInstOperands,
     /* 389242 */   // GIR_Coverage, 11343,
     /* 389242 */   GIR_EraseRootFromParent_Done,
     /* 389243 */ // Label 7504: @389243
     /* 389243 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(389316), // Rule ID 11344 //
     /* 389248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389269 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 389273 */   // MIs[1] Operand 1
     /* 389273 */   // No operand predicates
     /* 389273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389275 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 389275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 389278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389287 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 389293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 389306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389311 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389314 */   GIR_RootConstrainSelectedInstOperands,
     /* 389315 */   // GIR_Coverage, 11344,
     /* 389315 */   GIR_EraseRootFromParent_Done,
     /* 389316 */ // Label 7505: @389316
     /* 389316 */ GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(389389), // Rule ID 11345 //
     /* 389321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389342 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389346 */   // MIs[1] Operand 1
     /* 389346 */   // No operand predicates
     /* 389346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389348 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 389348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 389351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389360 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 389366 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 389379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389384 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389387 */   GIR_RootConstrainSelectedInstOperands,
     /* 389388 */   // GIR_Coverage, 11345,
     /* 389388 */   GIR_EraseRootFromParent_Done,
     /* 389389 */ // Label 7506: @389389
     /* 389389 */ GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(389437), // Rule ID 1930 //
     /* 389394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389419 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389423 */   // MIs[1] Operand 1
     /* 389423 */   // No operand predicates
     /* 389423 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389425 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 389428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389430 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389432 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389435 */   GIR_RootConstrainSelectedInstOperands,
     /* 389436 */   // GIR_Coverage, 1930,
     /* 389436 */   GIR_EraseRootFromParent_Done,
     /* 389437 */ // Label 7507: @389437
     /* 389437 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(389485), // Rule ID 1931 //
     /* 389442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389467 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389471 */   // MIs[1] Operand 1
     /* 389471 */   // No operand predicates
     /* 389471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389473 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 389476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389478 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389480 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389483 */   GIR_RootConstrainSelectedInstOperands,
     /* 389484 */   // GIR_Coverage, 1931,
     /* 389484 */   GIR_EraseRootFromParent_Done,
     /* 389485 */ // Label 7508: @389485
     /* 389485 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(389533), // Rule ID 1932 //
     /* 389490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389515 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389519 */   // MIs[1] Operand 1
     /* 389519 */   // No operand predicates
     /* 389519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389521 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 389524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389526 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389528 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389531 */   GIR_RootConstrainSelectedInstOperands,
     /* 389532 */   // GIR_Coverage, 1932,
     /* 389532 */   GIR_EraseRootFromParent_Done,
     /* 389533 */ // Label 7509: @389533
     /* 389533 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(389581), // Rule ID 1934 //
     /* 389538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389563 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 389567 */   // MIs[1] Operand 1
     /* 389567 */   // No operand predicates
     /* 389567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389569 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 389572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389574 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389576 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389579 */   GIR_RootConstrainSelectedInstOperands,
     /* 389580 */   // GIR_Coverage, 1934,
     /* 389580 */   GIR_EraseRootFromParent_Done,
     /* 389581 */ // Label 7510: @389581
     /* 389581 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(389629), // Rule ID 1935 //
     /* 389586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389611 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 389615 */   // MIs[1] Operand 1
     /* 389615 */   // No operand predicates
     /* 389615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389617 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 389620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389624 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389627 */   GIR_RootConstrainSelectedInstOperands,
     /* 389628 */   // GIR_Coverage, 1935,
     /* 389628 */   GIR_EraseRootFromParent_Done,
     /* 389629 */ // Label 7511: @389629
     /* 389629 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389677), // Rule ID 1936 //
     /* 389634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389659 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389663 */   // MIs[1] Operand 1
     /* 389663 */   // No operand predicates
     /* 389663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389665 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 389668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389670 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389672 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389675 */   GIR_RootConstrainSelectedInstOperands,
     /* 389676 */   // GIR_Coverage, 1936,
     /* 389676 */   GIR_EraseRootFromParent_Done,
     /* 389677 */ // Label 7512: @389677
     /* 389677 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389722), // Rule ID 5853 //
     /* 389682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389704 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389708 */   // MIs[1] Operand 1
     /* 389708 */   // No operand predicates
     /* 389708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389710 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 389713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389715 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389717 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389720 */   GIR_RootConstrainSelectedInstOperands,
     /* 389721 */   // GIR_Coverage, 5853,
     /* 389721 */   GIR_EraseRootFromParent_Done,
     /* 389722 */ // Label 7513: @389722
     /* 389722 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389798), // Rule ID 11333 //
     /* 389727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 389733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389748 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 389752 */   // MIs[1] Operand 1
     /* 389752 */   // No operand predicates
     /* 389752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389754 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 389754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 389761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389766 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389770 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389780 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389797 */   // GIR_Coverage, 11333,
     /* 389797 */   GIR_EraseRootFromParent_Done,
     /* 389798 */ // Label 7514: @389798
     /* 389798 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389874), // Rule ID 11334 //
     /* 389803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389824 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389828 */   // MIs[1] Operand 1
     /* 389828 */   // No operand predicates
     /* 389828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389830 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 389830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389842 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389846 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389856 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389873 */   // GIR_Coverage, 11334,
     /* 389873 */   GIR_EraseRootFromParent_Done,
     /* 389874 */ // Label 7515: @389874
     /* 389874 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389950), // Rule ID 11335 //
     /* 389879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389900 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389904 */   // MIs[1] Operand 1
     /* 389904 */   // No operand predicates
     /* 389904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389906 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 389906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389918 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389922 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389932 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389949 */   // GIR_Coverage, 11335,
     /* 389949 */   GIR_EraseRootFromParent_Done,
     /* 389950 */ // Label 7516: @389950
     /* 389950 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(390026), // Rule ID 11340 //
     /* 389955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389976 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389980 */   // MIs[1] Operand 1
     /* 389980 */   // No operand predicates
     /* 389980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389982 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 389982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389994 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389998 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390008 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 390015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390025 */   // GIR_Coverage, 11340,
     /* 390025 */   GIR_EraseRootFromParent_Done,
     /* 390026 */ // Label 7517: @390026
     /* 390026 */ GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(390102), // Rule ID 11341 //
     /* 390031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 390037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390052 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390056 */   // MIs[1] Operand 1
     /* 390056 */   // No operand predicates
     /* 390056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390058 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 390058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390070 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 390074 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390084 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 390091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390101 */   // GIR_Coverage, 11341,
     /* 390101 */   GIR_EraseRootFromParent_Done,
     /* 390102 */ // Label 7518: @390102
     /* 390102 */ GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(390163), // Rule ID 11323 //
     /* 390107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 390113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390124 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 390124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 390131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390136 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390146 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 390154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390159 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390161 */   GIR_RootConstrainSelectedInstOperands,
     /* 390162 */   // GIR_Coverage, 11323,
     /* 390162 */   GIR_EraseRootFromParent_Done,
     /* 390163 */ // Label 7519: @390163
     /* 390163 */ GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(390224), // Rule ID 11324 //
     /* 390168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390185 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 390185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 390192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390197 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390207 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 390215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390220 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390222 */   GIR_RootConstrainSelectedInstOperands,
     /* 390223 */   // GIR_Coverage, 11324,
     /* 390223 */   GIR_EraseRootFromParent_Done,
     /* 390224 */ // Label 7520: @390224
     /* 390224 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(390285), // Rule ID 11325 //
     /* 390229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390246 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 390246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 390253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390258 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390264 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390268 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 390276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390278 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390281 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390283 */   GIR_RootConstrainSelectedInstOperands,
     /* 390284 */   // GIR_Coverage, 11325,
     /* 390284 */   GIR_EraseRootFromParent_Done,
     /* 390285 */ // Label 7521: @390285
     /* 390285 */ GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(390346), // Rule ID 11330 //
     /* 390290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390307 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 390307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 390314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390319 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390329 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 390337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 390339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390342 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390344 */   GIR_RootConstrainSelectedInstOperands,
     /* 390345 */   // GIR_Coverage, 11330,
     /* 390345 */   GIR_EraseRootFromParent_Done,
     /* 390346 */ // Label 7522: @390346
     /* 390346 */ GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(390407), // Rule ID 11331 //
     /* 390351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 390357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390368 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 390368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 390375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390380 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390386 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390390 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 390398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 390400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390403 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390405 */   GIR_RootConstrainSelectedInstOperands,
     /* 390406 */   // GIR_Coverage, 11331,
     /* 390406 */   GIR_EraseRootFromParent_Done,
     /* 390407 */ // Label 7523: @390407
     /* 390407 */ GIM_Reject,
     /* 390408 */ // Label 7483: @390408
     /* 390408 */ GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(390453), // Rule ID 7037 //
     /* 390413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390427 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390431 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 390431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390436 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 390442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390452 */   // GIR_Coverage, 7037,
     /* 390452 */   GIR_EraseRootFromParent_Done,
     /* 390453 */ // Label 7524: @390453
     /* 390453 */ GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(390497), // Rule ID 11361 //
     /* 390458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390471 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390475 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 390475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390480 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 390486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390496 */   // GIR_Coverage, 11361,
     /* 390496 */   GIR_EraseRootFromParent_Done,
     /* 390497 */ // Label 7525: @390497
     /* 390497 */ GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(390541), // Rule ID 11367 //
     /* 390502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390515 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390519 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 390519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390524 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 390530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390540 */   // GIR_Coverage, 11367,
     /* 390540 */   GIR_EraseRootFromParent_Done,
     /* 390541 */ // Label 7526: @390541
     /* 390541 */ GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(390586), // Rule ID 5849 //
     /* 390546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390560 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390564 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 390564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390569 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 390575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390585 */   // GIR_Coverage, 5849,
     /* 390585 */   GIR_EraseRootFromParent_Done,
     /* 390586 */ // Label 7527: @390586
     /* 390586 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(390659), // Rule ID 11346 //
     /* 390591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390612 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390616 */   // MIs[1] Operand 1
     /* 390616 */   // No operand predicates
     /* 390616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390618 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 390618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 390621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390630 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 390636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390641 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 390649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390654 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 390657 */   GIR_RootConstrainSelectedInstOperands,
     /* 390658 */   // GIR_Coverage, 11346,
     /* 390658 */   GIR_EraseRootFromParent_Done,
     /* 390659 */ // Label 7528: @390659
     /* 390659 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(390707), // Rule ID 1933 //
     /* 390664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 390667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390689 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 390693 */   // MIs[1] Operand 1
     /* 390693 */   // No operand predicates
     /* 390693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390695 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 390695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 390698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390700 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390705 */   GIR_RootConstrainSelectedInstOperands,
     /* 390706 */   // GIR_Coverage, 1933,
     /* 390706 */   GIR_EraseRootFromParent_Done,
     /* 390707 */ // Label 7529: @390707
     /* 390707 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(390755), // Rule ID 1937 //
     /* 390712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390737 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390741 */   // MIs[1] Operand 1
     /* 390741 */   // No operand predicates
     /* 390741 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390743 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 390743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 390746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390748 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390753 */   GIR_RootConstrainSelectedInstOperands,
     /* 390754 */   // GIR_Coverage, 1937,
     /* 390754 */   GIR_EraseRootFromParent_Done,
     /* 390755 */ // Label 7530: @390755
     /* 390755 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390800), // Rule ID 5852 //
     /* 390760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390782 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390786 */   // MIs[1] Operand 1
     /* 390786 */   // No operand predicates
     /* 390786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390788 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 390788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 390791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390795 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390798 */   GIR_RootConstrainSelectedInstOperands,
     /* 390799 */   // GIR_Coverage, 5852,
     /* 390799 */   GIR_EraseRootFromParent_Done,
     /* 390800 */ // Label 7531: @390800
     /* 390800 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390876), // Rule ID 11336 //
     /* 390805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390826 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390830 */   // MIs[1] Operand 1
     /* 390830 */   // No operand predicates
     /* 390830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390832 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 390832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390844 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 390848 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390858 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390875 */   // GIR_Coverage, 11336,
     /* 390875 */   GIR_EraseRootFromParent_Done,
     /* 390876 */ // Label 7532: @390876
     /* 390876 */ GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390952), // Rule ID 11342 //
     /* 390881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390902 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390906 */   // MIs[1] Operand 1
     /* 390906 */   // No operand predicates
     /* 390906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390908 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 390908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390920 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 390924 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390934 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390951 */   // GIR_Coverage, 11342,
     /* 390951 */   GIR_EraseRootFromParent_Done,
     /* 390952 */ // Label 7533: @390952
     /* 390952 */ GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(391013), // Rule ID 11326 //
     /* 390957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390974 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 390974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 390981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390986 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390992 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390996 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 391004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391009 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 391011 */   GIR_RootConstrainSelectedInstOperands,
     /* 391012 */   // GIR_Coverage, 11326,
     /* 391012 */   GIR_EraseRootFromParent_Done,
     /* 391013 */ // Label 7534: @391013
     /* 391013 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(391074), // Rule ID 11332 //
     /* 391018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 391024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 391027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391035 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 391035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 391038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 391042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391047 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 391053 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 391057 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 391060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 391065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 391067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391070 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 391072 */   GIR_RootConstrainSelectedInstOperands,
     /* 391073 */   // GIR_Coverage, 11332,
     /* 391073 */   GIR_EraseRootFromParent_Done,
     /* 391074 */ // Label 7535: @391074
     /* 391074 */ GIM_Reject,
     /* 391075 */ // Label 7484: @391075
     /* 391075 */ GIM_Reject,
     /* 391076 */ // Label 93: @391076
     /* 391076 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7543*/ GIMT_Encode4(393395),
     /* 391087 */ /*GILLT_nxv2s16*//*Label 7536*/ GIMT_Encode4(391127),
     /* 391091 */ /*GILLT_nxv2s32*//*Label 7537*/ GIMT_Encode4(391486),
     /* 391095 */ /*GILLT_nxv2s64*//*Label 7538*/ GIMT_Encode4(391788), GIMT_Encode4(0),
     /* 391103 */ /*GILLT_nxv4s16*//*Label 7539*/ GIMT_Encode4(392163),
     /* 391107 */ /*GILLT_nxv4s32*//*Label 7540*/ GIMT_Encode4(392465), GIMT_Encode4(0),
     /* 391115 */ /*GILLT_nxv8s16*//*Label 7541*/ GIMT_Encode4(392840), GIMT_Encode4(0),
     /* 391123 */ /*GILLT_nxv16s8*//*Label 7542*/ GIMT_Encode4(393251),
     /* 391127 */ // Label 7536: @391127
     /* 391127 */ GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(391485),
     /* 391132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391139 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(391203), // Rule ID 6083 //
     /* 391144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391155 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391159 */     // MIs[1] Operand 1
     /* 391159 */     // No operand predicates
     /* 391159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391161 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391173 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391202 */     // GIR_Coverage, 6083,
     /* 391202 */     GIR_EraseRootFromParent_Done,
     /* 391203 */   // Label 7545: @391203
     /* 391203 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(391260), // Rule ID 2675 //
     /* 391208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 391223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391244 */     // MIs[2] Operand 1
     /* 391244 */     // No operand predicates
     /* 391244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391246 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391258 */     GIR_RootConstrainSelectedInstOperands,
     /* 391259 */     // GIR_Coverage, 2675,
     /* 391259 */     GIR_EraseRootFromParent_Done,
     /* 391260 */   // Label 7546: @391260
     /* 391260 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(391317), // Rule ID 2677 //
     /* 391265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 391280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391301 */     // MIs[2] Operand 1
     /* 391301 */     // No operand predicates
     /* 391301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391303 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391315 */     GIR_RootConstrainSelectedInstOperands,
     /* 391316 */     // GIR_Coverage, 2677,
     /* 391316 */     GIR_EraseRootFromParent_Done,
     /* 391317 */   // Label 7547: @391317
     /* 391317 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(391374), // Rule ID 8464 //
     /* 391322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391358 */     // MIs[2] Operand 1
     /* 391358 */     // No operand predicates
     /* 391358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391360 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391372 */     GIR_RootConstrainSelectedInstOperands,
     /* 391373 */     // GIR_Coverage, 8464,
     /* 391373 */     GIR_EraseRootFromParent_Done,
     /* 391374 */   // Label 7548: @391374
     /* 391374 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(391408), // Rule ID 8507 //
     /* 391379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391390 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 391394 */     // MIs[1] Operand 1
     /* 391394 */     // No operand predicates
     /* 391394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391396 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 391396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 391399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391401 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 391406 */     GIR_RootConstrainSelectedInstOperands,
     /* 391407 */     // GIR_Coverage, 8507,
     /* 391407 */     GIR_EraseRootFromParent_Done,
     /* 391408 */   // Label 7549: @391408
     /* 391408 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(391484), // Rule ID 8485 //
     /* 391413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391420 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391482 */     GIR_RootConstrainSelectedInstOperands,
     /* 391483 */     // GIR_Coverage, 8485,
     /* 391483 */     GIR_EraseRootFromParent_Done,
     /* 391484 */   // Label 7550: @391484
     /* 391484 */   GIM_Reject,
     /* 391485 */ // Label 7544: @391485
     /* 391485 */ GIM_Reject,
     /* 391486 */ // Label 7537: @391486
     /* 391486 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391787),
     /* 391491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391498 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391562), // Rule ID 6081 //
     /* 391503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391514 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391518 */     // MIs[1] Operand 1
     /* 391518 */     // No operand predicates
     /* 391518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391520 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391561 */     // GIR_Coverage, 6081,
     /* 391561 */     GIR_EraseRootFromParent_Done,
     /* 391562 */   // Label 7552: @391562
     /* 391562 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391619), // Rule ID 8473 //
     /* 391567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391603 */     // MIs[2] Operand 1
     /* 391603 */     // No operand predicates
     /* 391603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391605 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391617 */     GIR_RootConstrainSelectedInstOperands,
     /* 391618 */     // GIR_Coverage, 8473,
     /* 391618 */     GIR_EraseRootFromParent_Done,
     /* 391619 */   // Label 7553: @391619
     /* 391619 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391676), // Rule ID 8482 //
     /* 391624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 391639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391660 */     // MIs[2] Operand 1
     /* 391660 */     // No operand predicates
     /* 391660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391662 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391674 */     GIR_RootConstrainSelectedInstOperands,
     /* 391675 */     // GIR_Coverage, 8482,
     /* 391675 */     GIR_EraseRootFromParent_Done,
     /* 391676 */   // Label 7554: @391676
     /* 391676 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391710), // Rule ID 8509 //
     /* 391681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391692 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 391696 */     // MIs[1] Operand 1
     /* 391696 */     // No operand predicates
     /* 391696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391698 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 391698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 391701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391703 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 391708 */     GIR_RootConstrainSelectedInstOperands,
     /* 391709 */     // GIR_Coverage, 8509,
     /* 391709 */     GIR_EraseRootFromParent_Done,
     /* 391710 */   // Label 7555: @391710
     /* 391710 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391786), // Rule ID 8487 //
     /* 391715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391722 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391784 */     GIR_RootConstrainSelectedInstOperands,
     /* 391785 */     // GIR_Coverage, 8487,
     /* 391785 */     GIR_EraseRootFromParent_Done,
     /* 391786 */   // Label 7556: @391786
     /* 391786 */   GIM_Reject,
     /* 391787 */ // Label 7551: @391787
     /* 391787 */ GIM_Reject,
     /* 391788 */ // Label 7538: @391788
     /* 391788 */ GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(392162),
     /* 391793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391800 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(391854), // Rule ID 6076 //
     /* 391805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391812 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391853 */     // GIR_Coverage, 6076,
     /* 391853 */     GIR_EraseRootFromParent_Done,
     /* 391854 */   // Label 7558: @391854
     /* 391854 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(391918), // Rule ID 6080 //
     /* 391859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391870 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391874 */     // MIs[1] Operand 1
     /* 391874 */     // No operand predicates
     /* 391874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391876 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391888 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391917 */     // GIR_Coverage, 6080,
     /* 391917 */     GIR_EraseRootFromParent_Done,
     /* 391918 */   // Label 7559: @391918
     /* 391918 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(391975), // Rule ID 2672 //
     /* 391923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 391938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391959 */     // MIs[2] Operand 1
     /* 391959 */     // No operand predicates
     /* 391959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391961 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391973 */     GIR_RootConstrainSelectedInstOperands,
     /* 391974 */     // GIR_Coverage, 2672,
     /* 391974 */     GIR_EraseRootFromParent_Done,
     /* 391975 */   // Label 7560: @391975
     /* 391975 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(392032), // Rule ID 8479 //
     /* 391980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 391995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 392016 */     // MIs[2] Operand 1
     /* 392016 */     // No operand predicates
     /* 392016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392018 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 392018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 392021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392030 */     GIR_RootConstrainSelectedInstOperands,
     /* 392031 */     // GIR_Coverage, 8479,
     /* 392031 */     GIR_EraseRootFromParent_Done,
     /* 392032 */   // Label 7561: @392032
     /* 392032 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(392066), // Rule ID 8510 //
     /* 392037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392048 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 392052 */     // MIs[1] Operand 1
     /* 392052 */     // No operand predicates
     /* 392052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392054 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 392054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 392057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392059 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 392064 */     GIR_RootConstrainSelectedInstOperands,
     /* 392065 */     // GIR_Coverage, 8510,
     /* 392065 */     GIR_EraseRootFromParent_Done,
     /* 392066 */   // Label 7562: @392066
     /* 392066 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(392085), // Rule ID 2395 //
     /* 392071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392078 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 392083 */     GIR_RootConstrainSelectedInstOperands,
     /* 392084 */     // GIR_Coverage, 2395,
     /* 392084 */     GIR_Done,
     /* 392085 */   // Label 7563: @392085
     /* 392085 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(392161), // Rule ID 8488 //
     /* 392090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392097 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392097 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392100 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392104 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 392151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392159 */     GIR_RootConstrainSelectedInstOperands,
     /* 392160 */     // GIR_Coverage, 8488,
     /* 392160 */     GIR_EraseRootFromParent_Done,
     /* 392161 */   // Label 7564: @392161
     /* 392161 */   GIM_Reject,
     /* 392162 */ // Label 7557: @392162
     /* 392162 */ GIM_Reject,
     /* 392163 */ // Label 7539: @392163
     /* 392163 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(392464),
     /* 392168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392175 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(392239), // Rule ID 6084 //
     /* 392180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392191 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 392195 */     // MIs[1] Operand 1
     /* 392195 */     // No operand predicates
     /* 392195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392197 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392238 */     // GIR_Coverage, 6084,
     /* 392238 */     GIR_EraseRootFromParent_Done,
     /* 392239 */   // Label 7566: @392239
     /* 392239 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(392296), // Rule ID 2676 //
     /* 392244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 392259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 392280 */     // MIs[2] Operand 1
     /* 392280 */     // No operand predicates
     /* 392280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392282 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 392282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392294 */     GIR_RootConstrainSelectedInstOperands,
     /* 392295 */     // GIR_Coverage, 2676,
     /* 392295 */     GIR_EraseRootFromParent_Done,
     /* 392296 */   // Label 7567: @392296
     /* 392296 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(392353), // Rule ID 8467 //
     /* 392301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 392316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 392337 */     // MIs[2] Operand 1
     /* 392337 */     // No operand predicates
     /* 392337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392339 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 392339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392351 */     GIR_RootConstrainSelectedInstOperands,
     /* 392352 */     // GIR_Coverage, 8467,
     /* 392352 */     GIR_EraseRootFromParent_Done,
     /* 392353 */   // Label 7568: @392353
     /* 392353 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(392387), // Rule ID 8506 //
     /* 392358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392369 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 392373 */     // MIs[1] Operand 1
     /* 392373 */     // No operand predicates
     /* 392373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392375 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 392375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 392378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392380 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 392385 */     GIR_RootConstrainSelectedInstOperands,
     /* 392386 */     // GIR_Coverage, 8506,
     /* 392386 */     GIR_EraseRootFromParent_Done,
     /* 392387 */   // Label 7569: @392387
     /* 392387 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(392463), // Rule ID 8484 //
     /* 392392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392399 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392461 */     GIR_RootConstrainSelectedInstOperands,
     /* 392462 */     // GIR_Coverage, 8484,
     /* 392462 */     GIR_EraseRootFromParent_Done,
     /* 392463 */   // Label 7570: @392463
     /* 392463 */   GIM_Reject,
     /* 392464 */ // Label 7565: @392464
     /* 392464 */ GIM_Reject,
     /* 392465 */ // Label 7540: @392465
     /* 392465 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(392839),
     /* 392470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392477 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(392531), // Rule ID 6077 //
     /* 392482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 392489 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392530 */     // GIR_Coverage, 6077,
     /* 392530 */     GIR_EraseRootFromParent_Done,
     /* 392531 */   // Label 7572: @392531
     /* 392531 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(392595), // Rule ID 6082 //
     /* 392536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392547 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 392551 */     // MIs[1] Operand 1
     /* 392551 */     // No operand predicates
     /* 392551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392553 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392594 */     // GIR_Coverage, 6082,
     /* 392594 */     GIR_EraseRootFromParent_Done,
     /* 392595 */   // Label 7573: @392595
     /* 392595 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(392652), // Rule ID 2669 //
     /* 392600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392632 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 392636 */     // MIs[2] Operand 1
     /* 392636 */     // No operand predicates
     /* 392636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392638 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 392638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392650 */     GIR_RootConstrainSelectedInstOperands,
     /* 392651 */     // GIR_Coverage, 2669,
     /* 392651 */     GIR_EraseRootFromParent_Done,
     /* 392652 */   // Label 7574: @392652
     /* 392652 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(392709), // Rule ID 8476 //
     /* 392657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 392693 */     // MIs[2] Operand 1
     /* 392693 */     // No operand predicates
     /* 392693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392695 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 392695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392707 */     GIR_RootConstrainSelectedInstOperands,
     /* 392708 */     // GIR_Coverage, 8476,
     /* 392708 */     GIR_EraseRootFromParent_Done,
     /* 392709 */   // Label 7575: @392709
     /* 392709 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(392743), // Rule ID 8508 //
     /* 392714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392725 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 392729 */     // MIs[1] Operand 1
     /* 392729 */     // No operand predicates
     /* 392729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392731 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 392731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 392734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392736 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 392741 */     GIR_RootConstrainSelectedInstOperands,
     /* 392742 */     // GIR_Coverage, 8508,
     /* 392742 */     GIR_EraseRootFromParent_Done,
     /* 392743 */   // Label 7576: @392743
     /* 392743 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(392762), // Rule ID 2394 //
     /* 392748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 392755 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 392755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 392760 */     GIR_RootConstrainSelectedInstOperands,
     /* 392761 */     // GIR_Coverage, 2394,
     /* 392761 */     GIR_Done,
     /* 392762 */   // Label 7577: @392762
     /* 392762 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(392838), // Rule ID 8486 //
     /* 392767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392774 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392800 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 392810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392836 */     GIR_RootConstrainSelectedInstOperands,
     /* 392837 */     // GIR_Coverage, 8486,
     /* 392837 */     GIR_EraseRootFromParent_Done,
     /* 392838 */   // Label 7578: @392838
     /* 392838 */   GIM_Reject,
     /* 392839 */ // Label 7571: @392839
     /* 392839 */ GIM_Reject,
     /* 392840 */ // Label 7541: @392840
     /* 392840 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(392901), // Rule ID 6078 //
     /* 392845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392855 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 392859 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392871 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392890 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392900 */   // GIR_Coverage, 6078,
     /* 392900 */   GIR_EraseRootFromParent_Done,
     /* 392901 */ // Label 7579: @392901
     /* 392901 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(392972), // Rule ID 6085 //
     /* 392906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392916 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392924 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 392928 */   // MIs[1] Operand 1
     /* 392928 */   // No operand predicates
     /* 392928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392930 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392942 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392961 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392971 */   // GIR_Coverage, 6085,
     /* 392971 */   GIR_EraseRootFromParent_Done,
     /* 392972 */ // Label 7580: @392972
     /* 392972 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(393036), // Rule ID 2666 //
     /* 392977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392995 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 392999 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393003 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393008 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393012 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393016 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 393020 */   // MIs[2] Operand 1
     /* 393020 */   // No operand predicates
     /* 393020 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393022 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 393022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 393025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 393027 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 393031 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 393034 */   GIR_RootConstrainSelectedInstOperands,
     /* 393035 */   // GIR_Coverage, 2666,
     /* 393035 */   GIR_EraseRootFromParent_Done,
     /* 393036 */ // Label 7581: @393036
     /* 393036 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(393100), // Rule ID 8470 //
     /* 393041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 393059 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 393063 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393067 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393080 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 393084 */   // MIs[2] Operand 1
     /* 393084 */   // No operand predicates
     /* 393084 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393086 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 393086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 393089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 393091 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 393095 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 393098 */   GIR_RootConstrainSelectedInstOperands,
     /* 393099 */   // GIR_Coverage, 8470,
     /* 393099 */   GIR_EraseRootFromParent_Done,
     /* 393100 */ // Label 7582: @393100
     /* 393100 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(393141), // Rule ID 8505 //
     /* 393105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 393123 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 393127 */   // MIs[1] Operand 1
     /* 393127 */   // No operand predicates
     /* 393127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393129 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 393129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 393132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 393134 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 393139 */   GIR_RootConstrainSelectedInstOperands,
     /* 393140 */   // GIR_Coverage, 8505,
     /* 393140 */   GIR_EraseRootFromParent_Done,
     /* 393141 */ // Label 7583: @393141
     /* 393141 */ GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(393167), // Rule ID 2393 //
     /* 393146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 393160 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 393160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 393165 */   GIR_RootConstrainSelectedInstOperands,
     /* 393166 */   // GIR_Coverage, 2393,
     /* 393166 */   GIR_Done,
     /* 393167 */ // Label 7584: @393167
     /* 393167 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(393250), // Rule ID 8483 //
     /* 393172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393186 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393186 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 393189 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393193 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 393203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393212 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 393219 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 393222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 393240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 393242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393248 */   GIR_RootConstrainSelectedInstOperands,
     /* 393249 */   // GIR_Coverage, 8483,
     /* 393249 */   GIR_EraseRootFromParent_Done,
     /* 393250 */ // Label 7585: @393250
     /* 393250 */ GIM_Reject,
     /* 393251 */ // Label 7542: @393251
     /* 393251 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(393394),
     /* 393256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393263 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(393317), // Rule ID 6079 //
     /* 393268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 393275 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 393275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 393282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 393306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393316 */     // GIR_Coverage, 6079,
     /* 393316 */     GIR_EraseRootFromParent_Done,
     /* 393317 */   // Label 7587: @393317
     /* 393317 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(393374), // Rule ID 2663 //
     /* 393322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 393333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 393337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 393346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 393358 */     // MIs[2] Operand 1
     /* 393358 */     // No operand predicates
     /* 393358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393360 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 393360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 393363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 393365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 393369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 393372 */     GIR_RootConstrainSelectedInstOperands,
     /* 393373 */     // GIR_Coverage, 2663,
     /* 393373 */     GIR_EraseRootFromParent_Done,
     /* 393374 */   // Label 7588: @393374
     /* 393374 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(393393), // Rule ID 2392 //
     /* 393379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 393382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 393386 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 393386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 393391 */     GIR_RootConstrainSelectedInstOperands,
     /* 393392 */     // GIR_Coverage, 2392,
     /* 393392 */     GIR_Done,
     /* 393393 */   // Label 7589: @393393
     /* 393393 */   GIM_Reject,
     /* 393394 */ // Label 7586: @393394
     /* 393394 */ GIM_Reject,
     /* 393395 */ // Label 7543: @393395
     /* 393395 */ GIM_Reject,
     /* 393396 */ // Label 94: @393396
     /* 393396 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7592*/ GIMT_Encode4(393547),
     /* 393407 */ /*GILLT_s32*//*Label 7590*/ GIMT_Encode4(393415),
     /* 393411 */ /*GILLT_s64*//*Label 7591*/ GIMT_Encode4(393481),
     /* 393415 */ // Label 7590: @393415
     /* 393415 */ GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(393480),
     /* 393420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393431 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(393446), // Rule ID 2325 //
     /* 393436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393439 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 393444 */     GIR_RootConstrainSelectedInstOperands,
     /* 393445 */     // GIR_Coverage, 2325,
     /* 393445 */     GIR_Done,
     /* 393446 */   // Label 7594: @393446
     /* 393446 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(393479), // Rule ID 4038 //
     /* 393451 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 393451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 393454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 393458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 393472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393477 */     GIR_RootConstrainSelectedInstOperands,
     /* 393478 */     // GIR_Coverage, 4038,
     /* 393478 */     GIR_EraseRootFromParent_Done,
     /* 393479 */   // Label 7595: @393479
     /* 393479 */   GIM_Reject,
     /* 393480 */ // Label 7593: @393480
     /* 393480 */ GIM_Reject,
     /* 393481 */ // Label 7591: @393481
     /* 393481 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(393546),
     /* 393486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393497 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(393512), // Rule ID 2326 //
     /* 393502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393505 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 393510 */     GIR_RootConstrainSelectedInstOperands,
     /* 393511 */     // GIR_Coverage, 2326,
     /* 393511 */     GIR_Done,
     /* 393512 */   // Label 7597: @393512
     /* 393512 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(393545), // Rule ID 4039 //
     /* 393517 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 393517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 393524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 393538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393543 */     GIR_RootConstrainSelectedInstOperands,
     /* 393544 */     // GIR_Coverage, 4039,
     /* 393544 */     GIR_EraseRootFromParent_Done,
     /* 393545 */   // Label 7598: @393545
     /* 393545 */   GIM_Reject,
     /* 393546 */ // Label 7596: @393546
     /* 393546 */ GIM_Reject,
     /* 393547 */ // Label 7592: @393547
     /* 393547 */ GIM_Reject,
     /* 393548 */ // Label 95: @393548
     /* 393548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7607*/ GIMT_Encode4(394221),
     /* 393559 */ /*GILLT_s32*//*Label 7599*/ GIMT_Encode4(393599),
     /* 393563 */ /*GILLT_s64*//*Label 7600*/ GIMT_Encode4(393829), GIMT_Encode4(0),
     /* 393571 */ /*GILLT_v2s32*//*Label 7601*/ GIMT_Encode4(394059), GIMT_Encode4(0),
     /* 393579 */ /*GILLT_v4s16*//*Label 7602*/ GIMT_Encode4(394086),
     /* 393583 */ /*GILLT_v4s32*//*Label 7603*/ GIMT_Encode4(394113),
     /* 393587 */ /*GILLT_v8s8*//*Label 7604*/ GIMT_Encode4(394140),
     /* 393591 */ /*GILLT_v8s16*//*Label 7605*/ GIMT_Encode4(394167),
     /* 393595 */ /*GILLT_v16s8*//*Label 7606*/ GIMT_Encode4(394194),
     /* 393599 */ // Label 7599: @393599
     /* 393599 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(393828),
     /* 393604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393611 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(393711), // Rule ID 4040 //
     /* 393616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 393632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 393660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 393664 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393668 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 393672 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393676 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393681 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 393685 */     // MIs[3] Rn
     /* 393685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 393690 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393698 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393700 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 393703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 393709 */     GIR_RootConstrainSelectedInstOperands,
     /* 393710 */     // GIR_Coverage, 4040,
     /* 393710 */     GIR_EraseRootFromParent_Done,
     /* 393711 */   // Label 7609: @393711
     /* 393711 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(393811), // Rule ID 14064 //
     /* 393716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 393732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 393760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 393764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 393773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393777 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393781 */     // MIs[4] Rn
     /* 393781 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 393786 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 393790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393798 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393800 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 393803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393809 */     GIR_RootConstrainSelectedInstOperands,
     /* 393810 */     // GIR_Coverage, 14064,
     /* 393810 */     GIR_EraseRootFromParent_Done,
     /* 393811 */   // Label 7610: @393811
     /* 393811 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(393827), // Rule ID 184 //
     /* 393816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393820 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 393825 */     GIR_RootConstrainSelectedInstOperands,
     /* 393826 */     // GIR_Coverage, 184,
     /* 393826 */     GIR_Done,
     /* 393827 */   // Label 7611: @393827
     /* 393827 */   GIM_Reject,
     /* 393828 */ // Label 7608: @393828
     /* 393828 */ GIM_Reject,
     /* 393829 */ // Label 7600: @393829
     /* 393829 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(394058),
     /* 393834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393841 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(393941), // Rule ID 4041 //
     /* 393846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 393874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 393890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 393894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393898 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 393902 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393906 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393911 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 393915 */     // MIs[3] Rn
     /* 393915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 393920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393924 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393930 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 393933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 393939 */     GIR_RootConstrainSelectedInstOperands,
     /* 393940 */     // GIR_Coverage, 4041,
     /* 393940 */     GIR_EraseRootFromParent_Done,
     /* 393941 */   // Label 7613: @393941
     /* 393941 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(394041), // Rule ID 14065 //
     /* 393946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 393974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 393990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 393994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393999 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 394003 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 394007 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 394011 */     // MIs[4] Rn
     /* 394011 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 394016 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 394020 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394024 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 394030 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 394033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 394039 */     GIR_RootConstrainSelectedInstOperands,
     /* 394040 */     // GIR_Coverage, 14065,
     /* 394040 */     GIR_EraseRootFromParent_Done,
     /* 394041 */   // Label 7614: @394041
     /* 394041 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(394057), // Rule ID 185 //
     /* 394046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394050 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 394055 */     GIR_RootConstrainSelectedInstOperands,
     /* 394056 */     // GIR_Coverage, 185,
     /* 394056 */     GIR_Done,
     /* 394057 */   // Label 7615: @394057
     /* 394057 */   GIM_Reject,
     /* 394058 */ // Label 7612: @394058
     /* 394058 */ GIM_Reject,
     /* 394059 */ // Label 7601: @394059
     /* 394059 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(394085), // Rule ID 724 //
     /* 394064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394078 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 394078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 394083 */   GIR_RootConstrainSelectedInstOperands,
     /* 394084 */   // GIR_Coverage, 724,
     /* 394084 */   GIR_Done,
     /* 394085 */ // Label 7616: @394085
     /* 394085 */ GIM_Reject,
     /* 394086 */ // Label 7602: @394086
     /* 394086 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(394112), // Rule ID 722 //
     /* 394091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394105 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 394110 */   GIR_RootConstrainSelectedInstOperands,
     /* 394111 */   // GIR_Coverage, 722,
     /* 394111 */   GIR_Done,
     /* 394112 */ // Label 7617: @394112
     /* 394112 */ GIM_Reject,
     /* 394113 */ // Label 7603: @394113
     /* 394113 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(394139), // Rule ID 725 //
     /* 394118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394132 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 394137 */   GIR_RootConstrainSelectedInstOperands,
     /* 394138 */   // GIR_Coverage, 725,
     /* 394138 */   GIR_Done,
     /* 394139 */ // Label 7618: @394139
     /* 394139 */ GIM_Reject,
     /* 394140 */ // Label 7604: @394140
     /* 394140 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(394166), // Rule ID 720 //
     /* 394145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394159 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 394164 */   GIR_RootConstrainSelectedInstOperands,
     /* 394165 */   // GIR_Coverage, 720,
     /* 394165 */   GIR_Done,
     /* 394166 */ // Label 7619: @394166
     /* 394166 */ GIM_Reject,
     /* 394167 */ // Label 7605: @394167
     /* 394167 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(394193), // Rule ID 723 //
     /* 394172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394186 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 394191 */   GIR_RootConstrainSelectedInstOperands,
     /* 394192 */   // GIR_Coverage, 723,
     /* 394192 */   GIR_Done,
     /* 394193 */ // Label 7620: @394193
     /* 394193 */ GIM_Reject,
     /* 394194 */ // Label 7606: @394194
     /* 394194 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(394220), // Rule ID 721 //
     /* 394199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394213 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 394218 */   GIR_RootConstrainSelectedInstOperands,
     /* 394219 */   // GIR_Coverage, 721,
     /* 394219 */   GIR_Done,
     /* 394220 */ // Label 7621: @394220
     /* 394220 */ GIM_Reject,
     /* 394221 */ // Label 7607: @394221
     /* 394221 */ GIM_Reject,
     /* 394222 */ // Label 96: @394222
     /* 394222 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7626*/ GIMT_Encode4(394381),
     /* 394233 */ /*GILLT_s32*//*Label 7622*/ GIMT_Encode4(394273),
     /* 394237 */ /*GILLT_s64*//*Label 7623*/ GIMT_Encode4(394300), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 394261 */ /*GILLT_v8s8*//*Label 7624*/ GIMT_Encode4(394327), GIMT_Encode4(0),
     /* 394269 */ /*GILLT_v16s8*//*Label 7625*/ GIMT_Encode4(394354),
     /* 394273 */ // Label 7622: @394273
     /* 394273 */ GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(394299), // Rule ID 2323 //
     /* 394278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 394281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394292 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 394297 */   GIR_RootConstrainSelectedInstOperands,
     /* 394298 */   // GIR_Coverage, 2323,
     /* 394298 */   GIR_Done,
     /* 394299 */ // Label 7627: @394299
     /* 394299 */ GIM_Reject,
     /* 394300 */ // Label 7623: @394300
     /* 394300 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(394326), // Rule ID 2324 //
     /* 394305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 394308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394319 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 394324 */   GIR_RootConstrainSelectedInstOperands,
     /* 394325 */   // GIR_Coverage, 2324,
     /* 394325 */   GIR_Done,
     /* 394326 */ // Label 7628: @394326
     /* 394326 */ GIM_Reject,
     /* 394327 */ // Label 7624: @394327
     /* 394327 */ GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(394353), // Rule ID 768 //
     /* 394332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394346 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 394351 */   GIR_RootConstrainSelectedInstOperands,
     /* 394352 */   // GIR_Coverage, 768,
     /* 394352 */   GIR_Done,
     /* 394353 */ // Label 7629: @394353
     /* 394353 */ GIM_Reject,
     /* 394354 */ // Label 7625: @394354
     /* 394354 */ GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(394380), // Rule ID 769 //
     /* 394359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394373 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 394378 */   GIR_RootConstrainSelectedInstOperands,
     /* 394379 */   // GIR_Coverage, 769,
     /* 394379 */   GIR_Done,
     /* 394380 */ // Label 7630: @394380
     /* 394380 */ GIM_Reject,
     /* 394381 */ // Label 7626: @394381
     /* 394381 */ GIM_Reject,
     /* 394382 */ // Label 97: @394382
     /* 394382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7638*/ GIMT_Encode4(394695),
     /* 394393 */ /*GILLT_s32*//*Label 7631*/ GIMT_Encode4(394429),
     /* 394397 */ /*GILLT_s64*//*Label 7632*/ GIMT_Encode4(394502), GIMT_Encode4(0),
     /* 394405 */ /*GILLT_v2s32*//*Label 7633*/ GIMT_Encode4(394575),
     /* 394409 */ /*GILLT_v2s64*//*Label 7634*/ GIMT_Encode4(394599),
     /* 394413 */ /*GILLT_v4s16*//*Label 7635*/ GIMT_Encode4(394623),
     /* 394417 */ /*GILLT_v4s32*//*Label 7636*/ GIMT_Encode4(394647), GIMT_Encode4(0),
     /* 394425 */ /*GILLT_v8s16*//*Label 7637*/ GIMT_Encode4(394671),
     /* 394429 */ // Label 7631: @394429
     /* 394429 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(394501),
     /* 394434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394441 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(394484), // Rule ID 4044 //
     /* 394446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 394454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 394471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394473 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 394476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394482 */     GIR_RootConstrainSelectedInstOperands,
     /* 394483 */     // GIR_Coverage, 4044,
     /* 394483 */     GIR_EraseRootFromParent_Done,
     /* 394484 */   // Label 7640: @394484
     /* 394484 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(394500), // Rule ID 189 //
     /* 394489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394493 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 394498 */     GIR_RootConstrainSelectedInstOperands,
     /* 394499 */     // GIR_Coverage, 189,
     /* 394499 */     GIR_Done,
     /* 394500 */   // Label 7641: @394500
     /* 394500 */   GIM_Reject,
     /* 394501 */ // Label 7639: @394501
     /* 394501 */ GIM_Reject,
     /* 394502 */ // Label 7632: @394502
     /* 394502 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(394574),
     /* 394507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394514 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(394557), // Rule ID 4045 //
     /* 394519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 394527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 394531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394540 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 394544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394546 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 394549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394555 */     GIR_RootConstrainSelectedInstOperands,
     /* 394556 */     // GIR_Coverage, 4045,
     /* 394556 */     GIR_EraseRootFromParent_Done,
     /* 394557 */   // Label 7643: @394557
     /* 394557 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(394573), // Rule ID 190 //
     /* 394562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394566 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 394571 */     GIR_RootConstrainSelectedInstOperands,
     /* 394572 */     // GIR_Coverage, 190,
     /* 394572 */     GIR_Done,
     /* 394573 */   // Label 7644: @394573
     /* 394573 */   GIM_Reject,
     /* 394574 */ // Label 7642: @394574
     /* 394574 */ GIM_Reject,
     /* 394575 */ // Label 7633: @394575
     /* 394575 */ GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(394598), // Rule ID 5057 //
     /* 394580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394591 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 394591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 394596 */   GIR_RootConstrainSelectedInstOperands,
     /* 394597 */   // GIR_Coverage, 5057,
     /* 394597 */   GIR_Done,
     /* 394598 */ // Label 7645: @394598
     /* 394598 */ GIM_Reject,
     /* 394599 */ // Label 7634: @394599
     /* 394599 */ GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(394622), // Rule ID 5059 //
     /* 394604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394615 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 394615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 394620 */   GIR_RootConstrainSelectedInstOperands,
     /* 394621 */   // GIR_Coverage, 5059,
     /* 394621 */   GIR_Done,
     /* 394622 */ // Label 7646: @394622
     /* 394622 */ GIM_Reject,
     /* 394623 */ // Label 7635: @394623
     /* 394623 */ GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(394646), // Rule ID 5055 //
     /* 394628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394639 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 394644 */   GIR_RootConstrainSelectedInstOperands,
     /* 394645 */   // GIR_Coverage, 5055,
     /* 394645 */   GIR_Done,
     /* 394646 */ // Label 7647: @394646
     /* 394646 */ GIM_Reject,
     /* 394647 */ // Label 7636: @394647
     /* 394647 */ GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(394670), // Rule ID 5058 //
     /* 394652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394663 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 394668 */   GIR_RootConstrainSelectedInstOperands,
     /* 394669 */   // GIR_Coverage, 5058,
     /* 394669 */   GIR_Done,
     /* 394670 */ // Label 7648: @394670
     /* 394670 */ GIM_Reject,
     /* 394671 */ // Label 7637: @394671
     /* 394671 */ GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(394694), // Rule ID 5056 //
     /* 394676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394687 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 394692 */   GIR_RootConstrainSelectedInstOperands,
     /* 394693 */   // GIR_Coverage, 5056,
     /* 394693 */   GIR_Done,
     /* 394694 */ // Label 7649: @394694
     /* 394694 */ GIM_Reject,
     /* 394695 */ // Label 7638: @394695
     /* 394695 */ GIM_Reject,
     /* 394696 */ // Label 98: @394696
     /* 394696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7654*/ GIMT_Encode4(394849),
     /* 394707 */ /*GILLT_s32*//*Label 7650*/ GIMT_Encode4(394747),
     /* 394711 */ /*GILLT_s64*//*Label 7651*/ GIMT_Encode4(394771), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 394735 */ /*GILLT_v8s8*//*Label 7652*/ GIMT_Encode4(394795), GIMT_Encode4(0),
     /* 394743 */ /*GILLT_v16s8*//*Label 7653*/ GIMT_Encode4(394822),
     /* 394747 */ // Label 7650: @394747
     /* 394747 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(394770), // Rule ID 186 //
     /* 394752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394763 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 394768 */   GIR_RootConstrainSelectedInstOperands,
     /* 394769 */   // GIR_Coverage, 186,
     /* 394769 */   GIR_Done,
     /* 394770 */ // Label 7655: @394770
     /* 394770 */ GIM_Reject,
     /* 394771 */ // Label 7651: @394771
     /* 394771 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(394794), // Rule ID 187 //
     /* 394776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394787 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 394792 */   GIR_RootConstrainSelectedInstOperands,
     /* 394793 */   // GIR_Coverage, 187,
     /* 394793 */   GIR_Done,
     /* 394794 */ // Label 7656: @394794
     /* 394794 */ GIM_Reject,
     /* 394795 */ // Label 7652: @394795
     /* 394795 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(394821), // Rule ID 978 //
     /* 394800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394814 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 394819 */   GIR_RootConstrainSelectedInstOperands,
     /* 394820 */   // GIR_Coverage, 978,
     /* 394820 */   GIR_Done,
     /* 394821 */ // Label 7657: @394821
     /* 394821 */ GIM_Reject,
     /* 394822 */ // Label 7653: @394822
     /* 394822 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(394848), // Rule ID 979 //
     /* 394827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394841 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 394846 */   GIR_RootConstrainSelectedInstOperands,
     /* 394847 */   // GIR_Coverage, 979,
     /* 394847 */   GIR_Done,
     /* 394848 */ // Label 7658: @394848
     /* 394848 */ GIM_Reject,
     /* 394849 */ // Label 7654: @394849
     /* 394849 */ GIM_Reject,
     /* 394850 */ // Label 99: @394850
     /* 394850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7667*/ GIMT_Encode4(395340),
     /* 394861 */ /*GILLT_s16*//*Label 7659*/ GIMT_Encode4(394901),
     /* 394865 */ /*GILLT_s32*//*Label 7660*/ GIMT_Encode4(394932),
     /* 394869 */ /*GILLT_s64*//*Label 7661*/ GIMT_Encode4(394963), GIMT_Encode4(0),
     /* 394877 */ /*GILLT_v2s32*//*Label 7662*/ GIMT_Encode4(394994),
     /* 394881 */ /*GILLT_v2s64*//*Label 7663*/ GIMT_Encode4(395025),
     /* 394885 */ /*GILLT_v4s16*//*Label 7664*/ GIMT_Encode4(395056),
     /* 394889 */ /*GILLT_v4s32*//*Label 7665*/ GIMT_Encode4(395087), GIMT_Encode4(0),
     /* 394897 */ /*GILLT_v8s16*//*Label 7666*/ GIMT_Encode4(395118),
     /* 394901 */ // Label 7659: @394901
     /* 394901 */ GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(394931), // Rule ID 556 //
     /* 394906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394920 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 394925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394929 */   GIR_RootConstrainSelectedInstOperands,
     /* 394930 */   // GIR_Coverage, 556,
     /* 394930 */   GIR_Done,
     /* 394931 */ // Label 7668: @394931
     /* 394931 */ GIM_Reject,
     /* 394932 */ // Label 7660: @394932
     /* 394932 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(394962), // Rule ID 558 //
     /* 394937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394951 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 394956 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394960 */   GIR_RootConstrainSelectedInstOperands,
     /* 394961 */   // GIR_Coverage, 558,
     /* 394961 */   GIR_Done,
     /* 394962 */ // Label 7669: @394962
     /* 394962 */ GIM_Reject,
     /* 394963 */ // Label 7661: @394963
     /* 394963 */ GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(394993), // Rule ID 560 //
     /* 394968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394982 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 394987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394991 */   GIR_RootConstrainSelectedInstOperands,
     /* 394992 */   // GIR_Coverage, 560,
     /* 394992 */   GIR_Done,
     /* 394993 */ // Label 7670: @394993
     /* 394993 */ GIM_Reject,
     /* 394994 */ // Label 7662: @394994
     /* 394994 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(395024), // Rule ID 917 //
     /* 394999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395013 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 395018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395022 */   GIR_RootConstrainSelectedInstOperands,
     /* 395023 */   // GIR_Coverage, 917,
     /* 395023 */   GIR_Done,
     /* 395024 */ // Label 7671: @395024
     /* 395024 */ GIM_Reject,
     /* 395025 */ // Label 7663: @395025
     /* 395025 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(395055), // Rule ID 921 //
     /* 395030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395044 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 395049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395053 */   GIR_RootConstrainSelectedInstOperands,
     /* 395054 */   // GIR_Coverage, 921,
     /* 395054 */   GIR_Done,
     /* 395055 */ // Label 7672: @395055
     /* 395055 */ GIM_Reject,
     /* 395056 */ // Label 7664: @395056
     /* 395056 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(395086), // Rule ID 913 //
     /* 395061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395075 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 395080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395084 */   GIR_RootConstrainSelectedInstOperands,
     /* 395085 */   // GIR_Coverage, 913,
     /* 395085 */   GIR_Done,
     /* 395086 */ // Label 7673: @395086
     /* 395086 */ GIM_Reject,
     /* 395087 */ // Label 7665: @395087
     /* 395087 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(395117), // Rule ID 919 //
     /* 395092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395106 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 395111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395115 */   GIR_RootConstrainSelectedInstOperands,
     /* 395116 */   // GIR_Coverage, 919,
     /* 395116 */   GIR_Done,
     /* 395117 */ // Label 7674: @395117
     /* 395117 */ GIM_Reject,
     /* 395118 */ // Label 7666: @395118
     /* 395118 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(395339),
     /* 395123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395134 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(395153), // Rule ID 915 //
     /* 395139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395142 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 395147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395151 */     GIR_RootConstrainSelectedInstOperands,
     /* 395152 */     // GIR_Coverage, 915,
     /* 395152 */     GIR_Done,
     /* 395153 */   // Label 7676: @395153
     /* 395153 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(395338), // Rule ID 7076 //
     /* 395158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395161 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395161 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395164 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395168 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395173 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395179 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395182 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 395186 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395191 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395196 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395199 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395203 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395208 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395214 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395219 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395224 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395227 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395231 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395236 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395241 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395244 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 395248 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395253 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395258 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395261 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395265 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395270 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395301 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395336 */     GIR_RootConstrainSelectedInstOperands,
     /* 395337 */     // GIR_Coverage, 7076,
     /* 395337 */     GIR_EraseRootFromParent_Done,
     /* 395338 */   // Label 7677: @395338
     /* 395338 */   GIM_Reject,
     /* 395339 */ // Label 7675: @395339
     /* 395339 */ GIM_Reject,
     /* 395340 */ // Label 7667: @395340
     /* 395340 */ GIM_Reject,
     /* 395341 */ // Label 100: @395341
     /* 395341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7686*/ GIMT_Encode4(395640),
     /* 395352 */ /*GILLT_s16*//*Label 7678*/ GIMT_Encode4(395392),
     /* 395356 */ /*GILLT_s32*//*Label 7679*/ GIMT_Encode4(395423),
     /* 395360 */ /*GILLT_s64*//*Label 7680*/ GIMT_Encode4(395454), GIMT_Encode4(0),
     /* 395368 */ /*GILLT_v2s32*//*Label 7681*/ GIMT_Encode4(395485),
     /* 395372 */ /*GILLT_v2s64*//*Label 7682*/ GIMT_Encode4(395516),
     /* 395376 */ /*GILLT_v4s16*//*Label 7683*/ GIMT_Encode4(395547),
     /* 395380 */ /*GILLT_v4s32*//*Label 7684*/ GIMT_Encode4(395578), GIMT_Encode4(0),
     /* 395388 */ /*GILLT_v8s16*//*Label 7685*/ GIMT_Encode4(395609),
     /* 395392 */ // Label 7678: @395392
     /* 395392 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(395422), // Rule ID 574 //
     /* 395397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395411 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 395416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395420 */   GIR_RootConstrainSelectedInstOperands,
     /* 395421 */   // GIR_Coverage, 574,
     /* 395421 */   GIR_Done,
     /* 395422 */ // Label 7687: @395422
     /* 395422 */ GIM_Reject,
     /* 395423 */ // Label 7679: @395423
     /* 395423 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(395453), // Rule ID 576 //
     /* 395428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395442 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 395447 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395451 */   GIR_RootConstrainSelectedInstOperands,
     /* 395452 */   // GIR_Coverage, 576,
     /* 395452 */   GIR_Done,
     /* 395453 */ // Label 7688: @395453
     /* 395453 */ GIM_Reject,
     /* 395454 */ // Label 7680: @395454
     /* 395454 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(395484), // Rule ID 578 //
     /* 395459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395473 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 395478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395482 */   GIR_RootConstrainSelectedInstOperands,
     /* 395483 */   // GIR_Coverage, 578,
     /* 395483 */   GIR_Done,
     /* 395484 */ // Label 7689: @395484
     /* 395484 */ GIM_Reject,
     /* 395485 */ // Label 7681: @395485
     /* 395485 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(395515), // Rule ID 964 //
     /* 395490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395504 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 395509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395513 */   GIR_RootConstrainSelectedInstOperands,
     /* 395514 */   // GIR_Coverage, 964,
     /* 395514 */   GIR_Done,
     /* 395515 */ // Label 7690: @395515
     /* 395515 */ GIM_Reject,
     /* 395516 */ // Label 7682: @395516
     /* 395516 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(395546), // Rule ID 968 //
     /* 395521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395535 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 395540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395544 */   GIR_RootConstrainSelectedInstOperands,
     /* 395545 */   // GIR_Coverage, 968,
     /* 395545 */   GIR_Done,
     /* 395546 */ // Label 7691: @395546
     /* 395546 */ GIM_Reject,
     /* 395547 */ // Label 7683: @395547
     /* 395547 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(395577), // Rule ID 960 //
     /* 395552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395566 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 395571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395575 */   GIR_RootConstrainSelectedInstOperands,
     /* 395576 */   // GIR_Coverage, 960,
     /* 395576 */   GIR_Done,
     /* 395577 */ // Label 7692: @395577
     /* 395577 */ GIM_Reject,
     /* 395578 */ // Label 7684: @395578
     /* 395578 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(395608), // Rule ID 966 //
     /* 395583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395597 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 395602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395606 */   GIR_RootConstrainSelectedInstOperands,
     /* 395607 */   // GIR_Coverage, 966,
     /* 395607 */   GIR_Done,
     /* 395608 */ // Label 7693: @395608
     /* 395608 */ GIM_Reject,
     /* 395609 */ // Label 7685: @395609
     /* 395609 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(395639), // Rule ID 962 //
     /* 395614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395628 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 395633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395637 */   GIR_RootConstrainSelectedInstOperands,
     /* 395638 */   // GIR_Coverage, 962,
     /* 395638 */   GIR_Done,
     /* 395639 */ // Label 7694: @395639
     /* 395639 */ GIM_Reject,
     /* 395640 */ // Label 7686: @395640
     /* 395640 */ GIM_Reject,
     /* 395641 */ // Label 101: @395641
     /* 395641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7703*/ GIMT_Encode4(396131),
     /* 395652 */ /*GILLT_s16*//*Label 7695*/ GIMT_Encode4(395692),
     /* 395656 */ /*GILLT_s32*//*Label 7696*/ GIMT_Encode4(395723),
     /* 395660 */ /*GILLT_s64*//*Label 7697*/ GIMT_Encode4(395754), GIMT_Encode4(0),
     /* 395668 */ /*GILLT_v2s32*//*Label 7698*/ GIMT_Encode4(395785),
     /* 395672 */ /*GILLT_v2s64*//*Label 7699*/ GIMT_Encode4(395816),
     /* 395676 */ /*GILLT_v4s16*//*Label 7700*/ GIMT_Encode4(395847),
     /* 395680 */ /*GILLT_v4s32*//*Label 7701*/ GIMT_Encode4(395878), GIMT_Encode4(0),
     /* 395688 */ /*GILLT_v8s16*//*Label 7702*/ GIMT_Encode4(395909),
     /* 395692 */ // Label 7695: @395692
     /* 395692 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(395722), // Rule ID 544 //
     /* 395697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395711 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 395716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395720 */   GIR_RootConstrainSelectedInstOperands,
     /* 395721 */   // GIR_Coverage, 544,
     /* 395721 */   GIR_Done,
     /* 395722 */ // Label 7704: @395722
     /* 395722 */ GIM_Reject,
     /* 395723 */ // Label 7696: @395723
     /* 395723 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(395753), // Rule ID 546 //
     /* 395728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395742 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 395747 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395751 */   GIR_RootConstrainSelectedInstOperands,
     /* 395752 */   // GIR_Coverage, 546,
     /* 395752 */   GIR_Done,
     /* 395753 */ // Label 7705: @395753
     /* 395753 */ GIM_Reject,
     /* 395754 */ // Label 7697: @395754
     /* 395754 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(395784), // Rule ID 548 //
     /* 395759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395773 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 395778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395782 */   GIR_RootConstrainSelectedInstOperands,
     /* 395783 */   // GIR_Coverage, 548,
     /* 395783 */   GIR_Done,
     /* 395784 */ // Label 7706: @395784
     /* 395784 */ GIM_Reject,
     /* 395785 */ // Label 7698: @395785
     /* 395785 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(395815), // Rule ID 897 //
     /* 395790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395804 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 395809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395813 */   GIR_RootConstrainSelectedInstOperands,
     /* 395814 */   // GIR_Coverage, 897,
     /* 395814 */   GIR_Done,
     /* 395815 */ // Label 7707: @395815
     /* 395815 */ GIM_Reject,
     /* 395816 */ // Label 7699: @395816
     /* 395816 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(395846), // Rule ID 901 //
     /* 395821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395835 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 395840 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395844 */   GIR_RootConstrainSelectedInstOperands,
     /* 395845 */   // GIR_Coverage, 901,
     /* 395845 */   GIR_Done,
     /* 395846 */ // Label 7708: @395846
     /* 395846 */ GIM_Reject,
     /* 395847 */ // Label 7700: @395847
     /* 395847 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(395877), // Rule ID 893 //
     /* 395852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395866 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 395871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395875 */   GIR_RootConstrainSelectedInstOperands,
     /* 395876 */   // GIR_Coverage, 893,
     /* 395876 */   GIR_Done,
     /* 395877 */ // Label 7709: @395877
     /* 395877 */ GIM_Reject,
     /* 395878 */ // Label 7701: @395878
     /* 395878 */ GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(395908), // Rule ID 899 //
     /* 395883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395897 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 395902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395906 */   GIR_RootConstrainSelectedInstOperands,
     /* 395907 */   // GIR_Coverage, 899,
     /* 395907 */   GIR_Done,
     /* 395908 */ // Label 7710: @395908
     /* 395908 */ GIM_Reject,
     /* 395909 */ // Label 7702: @395909
     /* 395909 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(396130),
     /* 395914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395925 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(395944), // Rule ID 895 //
     /* 395930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395933 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 395938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395942 */     GIR_RootConstrainSelectedInstOperands,
     /* 395943 */     // GIR_Coverage, 895,
     /* 395943 */     GIR_Done,
     /* 395944 */   // Label 7712: @395944
     /* 395944 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(396129), // Rule ID 7078 //
     /* 395949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395952 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395952 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395955 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395959 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395964 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395970 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395973 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 395977 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395982 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395987 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395990 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395994 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395999 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396005 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396010 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396015 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396018 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396022 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396027 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396032 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396035 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 396039 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396044 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396061 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 396127 */     GIR_RootConstrainSelectedInstOperands,
     /* 396128 */     // GIR_Coverage, 7078,
     /* 396128 */     GIR_EraseRootFromParent_Done,
     /* 396129 */   // Label 7713: @396129
     /* 396129 */   GIM_Reject,
     /* 396130 */ // Label 7711: @396130
     /* 396130 */ GIM_Reject,
     /* 396131 */ // Label 7703: @396131
     /* 396131 */ GIM_Reject,
     /* 396132 */ // Label 102: @396132
     /* 396132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7722*/ GIMT_Encode4(396622),
     /* 396143 */ /*GILLT_s16*//*Label 7714*/ GIMT_Encode4(396183),
     /* 396147 */ /*GILLT_s32*//*Label 7715*/ GIMT_Encode4(396214),
     /* 396151 */ /*GILLT_s64*//*Label 7716*/ GIMT_Encode4(396245), GIMT_Encode4(0),
     /* 396159 */ /*GILLT_v2s32*//*Label 7717*/ GIMT_Encode4(396276),
     /* 396163 */ /*GILLT_v2s64*//*Label 7718*/ GIMT_Encode4(396307),
     /* 396167 */ /*GILLT_v4s16*//*Label 7719*/ GIMT_Encode4(396338),
     /* 396171 */ /*GILLT_v4s32*//*Label 7720*/ GIMT_Encode4(396369), GIMT_Encode4(0),
     /* 396179 */ /*GILLT_v8s16*//*Label 7721*/ GIMT_Encode4(396400),
     /* 396183 */ // Label 7714: @396183
     /* 396183 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(396213), // Rule ID 562 //
     /* 396188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396202 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 396207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396211 */   GIR_RootConstrainSelectedInstOperands,
     /* 396212 */   // GIR_Coverage, 562,
     /* 396212 */   GIR_Done,
     /* 396213 */ // Label 7723: @396213
     /* 396213 */ GIM_Reject,
     /* 396214 */ // Label 7715: @396214
     /* 396214 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(396244), // Rule ID 564 //
     /* 396219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396233 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 396238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396242 */   GIR_RootConstrainSelectedInstOperands,
     /* 396243 */   // GIR_Coverage, 564,
     /* 396243 */   GIR_Done,
     /* 396244 */ // Label 7724: @396244
     /* 396244 */ GIM_Reject,
     /* 396245 */ // Label 7716: @396245
     /* 396245 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(396275), // Rule ID 566 //
     /* 396250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396264 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 396264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 396269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396273 */   GIR_RootConstrainSelectedInstOperands,
     /* 396274 */   // GIR_Coverage, 566,
     /* 396274 */   GIR_Done,
     /* 396275 */ // Label 7725: @396275
     /* 396275 */ GIM_Reject,
     /* 396276 */ // Label 7717: @396276
     /* 396276 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(396306), // Rule ID 927 //
     /* 396281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396295 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 396300 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396304 */   GIR_RootConstrainSelectedInstOperands,
     /* 396305 */   // GIR_Coverage, 927,
     /* 396305 */   GIR_Done,
     /* 396306 */ // Label 7726: @396306
     /* 396306 */ GIM_Reject,
     /* 396307 */ // Label 7718: @396307
     /* 396307 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(396337), // Rule ID 931 //
     /* 396312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396326 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 396331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396335 */   GIR_RootConstrainSelectedInstOperands,
     /* 396336 */   // GIR_Coverage, 931,
     /* 396336 */   GIR_Done,
     /* 396337 */ // Label 7727: @396337
     /* 396337 */ GIM_Reject,
     /* 396338 */ // Label 7719: @396338
     /* 396338 */ GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(396368), // Rule ID 923 //
     /* 396343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396357 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 396362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396366 */   GIR_RootConstrainSelectedInstOperands,
     /* 396367 */   // GIR_Coverage, 923,
     /* 396367 */   GIR_Done,
     /* 396368 */ // Label 7728: @396368
     /* 396368 */ GIM_Reject,
     /* 396369 */ // Label 7720: @396369
     /* 396369 */ GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(396399), // Rule ID 929 //
     /* 396374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396388 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396397 */   GIR_RootConstrainSelectedInstOperands,
     /* 396398 */   // GIR_Coverage, 929,
     /* 396398 */   GIR_Done,
     /* 396399 */ // Label 7729: @396399
     /* 396399 */ GIM_Reject,
     /* 396400 */ // Label 7721: @396400
     /* 396400 */ GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(396621),
     /* 396405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396416 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(396435), // Rule ID 925 //
     /* 396421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396424 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 396429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396433 */     GIR_RootConstrainSelectedInstOperands,
     /* 396434 */     // GIR_Coverage, 925,
     /* 396434 */     GIR_Done,
     /* 396435 */   // Label 7731: @396435
     /* 396435 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(396620), // Rule ID 7086 //
     /* 396440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396443 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 396443 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 396446 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396450 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396455 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 396461 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396464 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396468 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396473 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396478 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396481 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396485 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396490 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396496 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396501 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396506 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396509 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396513 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396518 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396523 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396526 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396530 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396535 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396552 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 396618 */     GIR_RootConstrainSelectedInstOperands,
     /* 396619 */     // GIR_Coverage, 7086,
     /* 396619 */     GIR_EraseRootFromParent_Done,
     /* 396620 */   // Label 7732: @396620
     /* 396620 */   GIM_Reject,
     /* 396621 */ // Label 7730: @396621
     /* 396621 */ GIM_Reject,
     /* 396622 */ // Label 7722: @396622
     /* 396622 */ GIM_Reject,
     /* 396623 */ // Label 103: @396623
     /* 396623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7741*/ GIMT_Encode4(397113),
     /* 396634 */ /*GILLT_s16*//*Label 7733*/ GIMT_Encode4(396674),
     /* 396638 */ /*GILLT_s32*//*Label 7734*/ GIMT_Encode4(396705),
     /* 396642 */ /*GILLT_s64*//*Label 7735*/ GIMT_Encode4(396736), GIMT_Encode4(0),
     /* 396650 */ /*GILLT_v2s32*//*Label 7736*/ GIMT_Encode4(396767),
     /* 396654 */ /*GILLT_v2s64*//*Label 7737*/ GIMT_Encode4(396798),
     /* 396658 */ /*GILLT_v4s16*//*Label 7738*/ GIMT_Encode4(396829),
     /* 396662 */ /*GILLT_v4s32*//*Label 7739*/ GIMT_Encode4(396860), GIMT_Encode4(0),
     /* 396670 */ /*GILLT_v8s16*//*Label 7740*/ GIMT_Encode4(396891),
     /* 396674 */ // Label 7733: @396674
     /* 396674 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(396704), // Rule ID 538 //
     /* 396679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396693 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 396698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396702 */   GIR_RootConstrainSelectedInstOperands,
     /* 396703 */   // GIR_Coverage, 538,
     /* 396703 */   GIR_Done,
     /* 396704 */ // Label 7742: @396704
     /* 396704 */ GIM_Reject,
     /* 396705 */ // Label 7734: @396705
     /* 396705 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(396735), // Rule ID 540 //
     /* 396710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396724 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 396729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396733 */   GIR_RootConstrainSelectedInstOperands,
     /* 396734 */   // GIR_Coverage, 540,
     /* 396734 */   GIR_Done,
     /* 396735 */ // Label 7743: @396735
     /* 396735 */ GIM_Reject,
     /* 396736 */ // Label 7735: @396736
     /* 396736 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(396766), // Rule ID 542 //
     /* 396741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396755 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 396755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 396760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396764 */   GIR_RootConstrainSelectedInstOperands,
     /* 396765 */   // GIR_Coverage, 542,
     /* 396765 */   GIR_Done,
     /* 396766 */ // Label 7744: @396766
     /* 396766 */ GIM_Reject,
     /* 396767 */ // Label 7736: @396767
     /* 396767 */ GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(396797), // Rule ID 887 //
     /* 396772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396786 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 396791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396795 */   GIR_RootConstrainSelectedInstOperands,
     /* 396796 */   // GIR_Coverage, 887,
     /* 396796 */   GIR_Done,
     /* 396797 */ // Label 7745: @396797
     /* 396797 */ GIM_Reject,
     /* 396798 */ // Label 7737: @396798
     /* 396798 */ GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(396828), // Rule ID 891 //
     /* 396803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396817 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 396822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396826 */   GIR_RootConstrainSelectedInstOperands,
     /* 396827 */   // GIR_Coverage, 891,
     /* 396827 */   GIR_Done,
     /* 396828 */ // Label 7746: @396828
     /* 396828 */ GIM_Reject,
     /* 396829 */ // Label 7738: @396829
     /* 396829 */ GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(396859), // Rule ID 883 //
     /* 396834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396848 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 396853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396857 */   GIR_RootConstrainSelectedInstOperands,
     /* 396858 */   // GIR_Coverage, 883,
     /* 396858 */   GIR_Done,
     /* 396859 */ // Label 7747: @396859
     /* 396859 */ GIM_Reject,
     /* 396860 */ // Label 7739: @396860
     /* 396860 */ GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(396890), // Rule ID 889 //
     /* 396865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396879 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 396884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396888 */   GIR_RootConstrainSelectedInstOperands,
     /* 396889 */   // GIR_Coverage, 889,
     /* 396889 */   GIR_Done,
     /* 396890 */ // Label 7748: @396890
     /* 396890 */ GIM_Reject,
     /* 396891 */ // Label 7740: @396891
     /* 396891 */ GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(397112),
     /* 396896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396907 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(396926), // Rule ID 885 //
     /* 396912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396915 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 396920 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396924 */     GIR_RootConstrainSelectedInstOperands,
     /* 396925 */     // GIR_Coverage, 885,
     /* 396925 */     GIR_Done,
     /* 396926 */   // Label 7750: @396926
     /* 396926 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(397111), // Rule ID 7080 //
     /* 396931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396934 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 396934 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 396937 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396941 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396946 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 396952 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396955 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 396959 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396964 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396969 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396972 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396976 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396981 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396987 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396992 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396997 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 397000 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397004 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397009 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 397012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 397014 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 397017 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 397021 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397026 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 397029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 397031 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 397034 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 397038 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397043 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 397046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 397048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 397051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 397065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 397080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 397083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 397101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 397109 */     GIR_RootConstrainSelectedInstOperands,
     /* 397110 */     // GIR_Coverage, 7080,
     /* 397110 */     GIR_EraseRootFromParent_Done,
     /* 397111 */   // Label 7751: @397111
     /* 397111 */   GIM_Reject,
     /* 397112 */ // Label 7749: @397112
     /* 397112 */ GIM_Reject,
     /* 397113 */ // Label 7741: @397113
     /* 397113 */ GIM_Reject,
     /* 397114 */ // Label 104: @397114
     /* 397114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7760*/ GIMT_Encode4(398239),
     /* 397125 */ /*GILLT_s16*//*Label 7752*/ GIMT_Encode4(397165),
     /* 397129 */ /*GILLT_s32*//*Label 7753*/ GIMT_Encode4(397391),
     /* 397133 */ /*GILLT_s64*//*Label 7754*/ GIMT_Encode4(397617), GIMT_Encode4(0),
     /* 397141 */ /*GILLT_v2s32*//*Label 7755*/ GIMT_Encode4(397789),
     /* 397145 */ /*GILLT_v2s64*//*Label 7756*/ GIMT_Encode4(397827),
     /* 397149 */ /*GILLT_v4s16*//*Label 7757*/ GIMT_Encode4(397865),
     /* 397153 */ /*GILLT_v4s32*//*Label 7758*/ GIMT_Encode4(397903), GIMT_Encode4(0),
     /* 397161 */ /*GILLT_v8s16*//*Label 7759*/ GIMT_Encode4(397941),
     /* 397165 */ // Label 7752: @397165
     /* 397165 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(397390),
     /* 397170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 397176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397180 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(397271), // Rule ID 6994 //
     /* 397185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397222 */     // MIs[2] Rn
     /* 397222 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397227 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 397231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397233 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 397233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397245 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 397264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397269 */     GIR_RootConstrainSelectedInstOperands,
     /* 397270 */     // GIR_Coverage, 6994,
     /* 397270 */     GIR_EraseRootFromParent_Done,
     /* 397271 */   // Label 7762: @397271
     /* 397271 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(397362), // Rule ID 14202 //
     /* 397276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 397301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397313 */     // MIs[2] Rn
     /* 397313 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397318 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 397322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397324 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 397324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397336 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 397355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397360 */     GIR_RootConstrainSelectedInstOperands,
     /* 397361 */     // GIR_Coverage, 14202,
     /* 397361 */     GIR_EraseRootFromParent_Done,
     /* 397362 */   // Label 7763: @397362
     /* 397362 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(397389), // Rule ID 587 //
     /* 397367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397378 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 397378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 397383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397387 */     GIR_RootConstrainSelectedInstOperands,
     /* 397388 */     // GIR_Coverage, 587,
     /* 397388 */     GIR_Done,
     /* 397389 */   // Label 7764: @397389
     /* 397389 */   GIM_Reject,
     /* 397390 */ // Label 7761: @397390
     /* 397390 */ GIM_Reject,
     /* 397391 */ // Label 7753: @397391
     /* 397391 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(397616),
     /* 397396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397406 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(397497), // Rule ID 6992 //
     /* 397411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397448 */     // MIs[2] Rn
     /* 397448 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 397457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397459 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 397459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397471 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397495 */     GIR_RootConstrainSelectedInstOperands,
     /* 397496 */     // GIR_Coverage, 6992,
     /* 397496 */     GIR_EraseRootFromParent_Done,
     /* 397497 */   // Label 7766: @397497
     /* 397497 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(397588), // Rule ID 14200 //
     /* 397502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 397527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397539 */     // MIs[2] Rn
     /* 397539 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397544 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 397548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397550 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 397550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397562 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397586 */     GIR_RootConstrainSelectedInstOperands,
     /* 397587 */     // GIR_Coverage, 14200,
     /* 397587 */     GIR_EraseRootFromParent_Done,
     /* 397588 */   // Label 7767: @397588
     /* 397588 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(397615), // Rule ID 589 //
     /* 397593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397604 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 397604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 397609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397613 */     GIR_RootConstrainSelectedInstOperands,
     /* 397614 */     // GIR_Coverage, 589,
     /* 397614 */     GIR_Done,
     /* 397615 */   // Label 7768: @397615
     /* 397615 */   GIM_Reject,
     /* 397616 */ // Label 7765: @397616
     /* 397616 */ GIM_Reject,
     /* 397617 */ // Label 7754: @397617
     /* 397617 */ GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(397788),
     /* 397622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397632 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(397696), // Rule ID 6990 //
     /* 397637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397658 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397674 */     // MIs[2] Rn
     /* 397674 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397679 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 397683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397685 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 397685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397694 */     GIR_RootConstrainSelectedInstOperands,
     /* 397695 */     // GIR_Coverage, 6990,
     /* 397695 */     GIR_EraseRootFromParent_Done,
     /* 397696 */   // Label 7770: @397696
     /* 397696 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(397760), // Rule ID 14198 //
     /* 397701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 397726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397738 */     // MIs[2] Rn
     /* 397738 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397743 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 397747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397749 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 397749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397758 */     GIR_RootConstrainSelectedInstOperands,
     /* 397759 */     // GIR_Coverage, 14198,
     /* 397759 */     GIR_EraseRootFromParent_Done,
     /* 397760 */   // Label 7771: @397760
     /* 397760 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(397787), // Rule ID 591 //
     /* 397765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397776 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 397776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 397781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397785 */     GIR_RootConstrainSelectedInstOperands,
     /* 397786 */     // GIR_Coverage, 591,
     /* 397786 */     GIR_Done,
     /* 397787 */   // Label 7772: @397787
     /* 397787 */   GIM_Reject,
     /* 397788 */ // Label 7769: @397788
     /* 397788 */ GIM_Reject,
     /* 397789 */ // Label 7755: @397789
     /* 397789 */ GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(397826), // Rule ID 1206 //
     /* 397794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397815 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 397820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397824 */   GIR_RootConstrainSelectedInstOperands,
     /* 397825 */   // GIR_Coverage, 1206,
     /* 397825 */   GIR_Done,
     /* 397826 */ // Label 7773: @397826
     /* 397826 */ GIM_Reject,
     /* 397827 */ // Label 7756: @397827
     /* 397827 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(397864), // Rule ID 1210 //
     /* 397832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397853 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 397858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397862 */   GIR_RootConstrainSelectedInstOperands,
     /* 397863 */   // GIR_Coverage, 1210,
     /* 397863 */   GIR_Done,
     /* 397864 */ // Label 7774: @397864
     /* 397864 */ GIM_Reject,
     /* 397865 */ // Label 7757: @397865
     /* 397865 */ GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(397902), // Rule ID 1202 //
     /* 397870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397891 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 397896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397900 */   GIR_RootConstrainSelectedInstOperands,
     /* 397901 */   // GIR_Coverage, 1202,
     /* 397901 */   GIR_Done,
     /* 397902 */ // Label 7775: @397902
     /* 397902 */ GIM_Reject,
     /* 397903 */ // Label 7758: @397903
     /* 397903 */ GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(397940), // Rule ID 1208 //
     /* 397908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397929 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 397934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397938 */   GIR_RootConstrainSelectedInstOperands,
     /* 397939 */   // GIR_Coverage, 1208,
     /* 397939 */   GIR_Done,
     /* 397940 */ // Label 7776: @397940
     /* 397940 */ GIM_Reject,
     /* 397941 */ // Label 7759: @397941
     /* 397941 */ GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(398238),
     /* 397946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397964 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397983), // Rule ID 1204 //
     /* 397969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397972 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 397977 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397981 */     GIR_RootConstrainSelectedInstOperands,
     /* 397982 */     // GIR_Coverage, 1204,
     /* 397982 */     GIR_Done,
     /* 397983 */   // Label 7778: @397983
     /* 397983 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(398237), // Rule ID 7089 //
     /* 397988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 397991 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 397991 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 397994 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397998 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398003 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 398007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 398009 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 398012 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 398016 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398021 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 398027 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 398030 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 398034 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398039 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 398042 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 398045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 398047 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 398050 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398054 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398059 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398065 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398070 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398075 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 398078 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398082 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398087 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 398090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 398092 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 398095 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398099 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398104 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398110 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398115 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398120 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 398123 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398127 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398132 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 398135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 398137 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 398140 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 398144 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398149 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 398152 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 398155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 398157 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 398160 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 398164 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398169 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 398172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 398174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 398177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 398206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 398227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 398235 */     GIR_RootConstrainSelectedInstOperands,
     /* 398236 */     // GIR_Coverage, 7089,
     /* 398236 */     GIR_EraseRootFromParent_Done,
     /* 398237 */   // Label 7779: @398237
     /* 398237 */   GIM_Reject,
     /* 398238 */ // Label 7777: @398238
     /* 398238 */ GIM_Reject,
     /* 398239 */ // Label 7760: @398239
     /* 398239 */ GIM_Reject,
     /* 398240 */ // Label 105: @398240
     /* 398240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7788*/ GIMT_Encode4(398855),
     /* 398251 */ /*GILLT_s16*//*Label 7780*/ GIMT_Encode4(398291),
     /* 398255 */ /*GILLT_s32*//*Label 7781*/ GIMT_Encode4(398329),
     /* 398259 */ /*GILLT_s64*//*Label 7782*/ GIMT_Encode4(398367), GIMT_Encode4(0),
     /* 398267 */ /*GILLT_v2s32*//*Label 7783*/ GIMT_Encode4(398405),
     /* 398271 */ /*GILLT_v2s64*//*Label 7784*/ GIMT_Encode4(398443),
     /* 398275 */ /*GILLT_v4s16*//*Label 7785*/ GIMT_Encode4(398481),
     /* 398279 */ /*GILLT_v4s32*//*Label 7786*/ GIMT_Encode4(398519), GIMT_Encode4(0),
     /* 398287 */ /*GILLT_v8s16*//*Label 7787*/ GIMT_Encode4(398557),
     /* 398291 */ // Label 7780: @398291
     /* 398291 */ GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398328), // Rule ID 635 //
     /* 398296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 398299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 398302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 398305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398317 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 398317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 398322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398326 */   GIR_RootConstrainSelectedInstOperands,
     /* 398327 */   // GIR_Coverage, 635,
     /* 398327 */   GIR_Done,
     /* 398328 */ // Label 7789: @398328
     /* 398328 */ GIM_Reject,
     /* 398329 */ // Label 7781: @398329
     /* 398329 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398366), // Rule ID 637 //
     /* 398334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 398343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398355 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 398355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 398360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398364 */   GIR_RootConstrainSelectedInstOperands,
     /* 398365 */   // GIR_Coverage, 637,
     /* 398365 */   GIR_Done,
     /* 398366 */ // Label 7790: @398366
     /* 398366 */ GIM_Reject,
     /* 398367 */ // Label 7782: @398367
     /* 398367 */ GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398404), // Rule ID 639 //
     /* 398372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398393 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 398393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 398398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398402 */   GIR_RootConstrainSelectedInstOperands,
     /* 398403 */   // GIR_Coverage, 639,
     /* 398403 */   GIR_Done,
     /* 398404 */ // Label 7791: @398404
     /* 398404 */ GIM_Reject,
     /* 398405 */ // Label 7783: @398405
     /* 398405 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398442), // Rule ID 1346 //
     /* 398410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398431 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 398436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398440 */   GIR_RootConstrainSelectedInstOperands,
     /* 398441 */   // GIR_Coverage, 1346,
     /* 398441 */   GIR_Done,
     /* 398442 */ // Label 7792: @398442
     /* 398442 */ GIM_Reject,
     /* 398443 */ // Label 7784: @398443
     /* 398443 */ GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398480), // Rule ID 1350 //
     /* 398448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398469 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 398474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398478 */   GIR_RootConstrainSelectedInstOperands,
     /* 398479 */   // GIR_Coverage, 1350,
     /* 398479 */   GIR_Done,
     /* 398480 */ // Label 7793: @398480
     /* 398480 */ GIM_Reject,
     /* 398481 */ // Label 7785: @398481
     /* 398481 */ GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398518), // Rule ID 1342 //
     /* 398486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398507 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 398512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398516 */   GIR_RootConstrainSelectedInstOperands,
     /* 398517 */   // GIR_Coverage, 1342,
     /* 398517 */   GIR_Done,
     /* 398518 */ // Label 7794: @398518
     /* 398518 */ GIM_Reject,
     /* 398519 */ // Label 7786: @398519
     /* 398519 */ GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398556), // Rule ID 1348 //
     /* 398524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398545 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 398545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398554 */   GIR_RootConstrainSelectedInstOperands,
     /* 398555 */   // GIR_Coverage, 1348,
     /* 398555 */   GIR_Done,
     /* 398556 */ // Label 7795: @398556
     /* 398556 */ GIM_Reject,
     /* 398557 */ // Label 7787: @398557
     /* 398557 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398854),
     /* 398562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398580 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398599), // Rule ID 1344 //
     /* 398585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398588 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 398588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 398593 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398597 */     GIR_RootConstrainSelectedInstOperands,
     /* 398598 */     // GIR_Coverage, 1344,
     /* 398598 */     GIR_Done,
     /* 398599 */   // Label 7797: @398599
     /* 398599 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(398853), // Rule ID 7095 //
     /* 398604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 398607 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 398607 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 398610 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 398614 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398619 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 398623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 398625 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 398628 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 398632 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398637 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 398643 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 398646 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398650 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398655 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 398658 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 398661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 398663 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 398666 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398670 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398675 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398681 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398686 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398691 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 398694 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398698 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398703 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 398706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 398708 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 398711 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398715 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398720 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398726 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398731 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398736 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 398739 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398743 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398748 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 398751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 398753 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 398756 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398760 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398765 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 398768 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 398771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 398773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 398776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 398780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398785 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 398788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 398790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 398793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 398822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 398843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 398851 */     GIR_RootConstrainSelectedInstOperands,
     /* 398852 */     // GIR_Coverage, 7095,
     /* 398852 */     GIR_EraseRootFromParent_Done,
     /* 398853 */   // Label 7798: @398853
     /* 398853 */   GIM_Reject,
     /* 398854 */ // Label 7796: @398854
     /* 398854 */ GIM_Reject,
     /* 398855 */ // Label 7788: @398855
     /* 398855 */ GIM_Reject,
     /* 398856 */ // Label 106: @398856
     /* 398856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7807*/ GIMT_Encode4(402577),
     /* 398867 */ /*GILLT_s16*//*Label 7799*/ GIMT_Encode4(398907),
     /* 398871 */ /*GILLT_s32*//*Label 7800*/ GIMT_Encode4(399461),
     /* 398875 */ /*GILLT_s64*//*Label 7801*/ GIMT_Encode4(400009), GIMT_Encode4(0),
     /* 398883 */ /*GILLT_v2s32*//*Label 7802*/ GIMT_Encode4(400557),
     /* 398887 */ /*GILLT_v2s64*//*Label 7803*/ GIMT_Encode4(401087),
     /* 398891 */ /*GILLT_v4s16*//*Label 7804*/ GIMT_Encode4(401445),
     /* 398895 */ /*GILLT_v4s32*//*Label 7805*/ GIMT_Encode4(401787), GIMT_Encode4(0),
     /* 398903 */ /*GILLT_v8s16*//*Label 7806*/ GIMT_Encode4(402145),
     /* 398907 */ // Label 7799: @398907
     /* 398907 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399460),
     /* 398912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 398915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 398918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398922 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399035), // Rule ID 6314 //
     /* 398927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398984 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398988 */     // MIs[3] Operand 1
     /* 398988 */     // No operand predicates
     /* 398988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398990 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 398990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 399008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 399021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399033 */     GIR_RootConstrainSelectedInstOperands,
     /* 399034 */     // GIR_Coverage, 6314,
     /* 399034 */     GIR_EraseRootFromParent_Done,
     /* 399035 */   // Label 7809: @399035
     /* 399035 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399148), // Rule ID 14179 //
     /* 399040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399076 */     // MIs[2] Operand 1
     /* 399076 */     // No operand predicates
     /* 399076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399088 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 399092 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399097 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 399101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399103 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 399103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399115 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 399121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 399134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399146 */     GIR_RootConstrainSelectedInstOperands,
     /* 399147 */     // GIR_Coverage, 14179,
     /* 399147 */     GIR_EraseRootFromParent_Done,
     /* 399148 */   // Label 7810: @399148
     /* 399148 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399227), // Rule ID 14113 //
     /* 399153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399187 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 399187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 399205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 399218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399225 */     GIR_RootConstrainSelectedInstOperands,
     /* 399226 */     // GIR_Coverage, 14113,
     /* 399226 */     GIR_EraseRootFromParent_Done,
     /* 399227 */   // Label 7811: @399227
     /* 399227 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399306), // Rule ID 4871 //
     /* 399232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399266 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 399266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 399284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 399297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399304 */     GIR_RootConstrainSelectedInstOperands,
     /* 399305 */     // GIR_Coverage, 4871,
     /* 399305 */     GIR_EraseRootFromParent_Done,
     /* 399306 */   // Label 7812: @399306
     /* 399306 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(399369), // Rule ID 13717 //
     /* 399311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399347 */     // MIs[2] Operand 1
     /* 399347 */     // No operand predicates
     /* 399347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399353 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 399356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399367 */     GIR_RootConstrainSelectedInstOperands,
     /* 399368 */     // GIR_Coverage, 13717,
     /* 399368 */     GIR_EraseRootFromParent_Done,
     /* 399369 */   // Label 7813: @399369
     /* 399369 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(399432), // Rule ID 2015 //
     /* 399374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399414 */     // MIs[2] Operand 1
     /* 399414 */     // No operand predicates
     /* 399414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399416 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 399419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399430 */     GIR_RootConstrainSelectedInstOperands,
     /* 399431 */     // GIR_Coverage, 2015,
     /* 399431 */     GIR_EraseRootFromParent_Done,
     /* 399432 */   // Label 7814: @399432
     /* 399432 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(399459), // Rule ID 623 //
     /* 399437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399448 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 399448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 399453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399457 */     GIR_RootConstrainSelectedInstOperands,
     /* 399458 */     // GIR_Coverage, 623,
     /* 399458 */     GIR_Done,
     /* 399459 */   // Label 7815: @399459
     /* 399459 */   GIM_Reject,
     /* 399460 */ // Label 7808: @399460
     /* 399460 */ GIM_Reject,
     /* 399461 */ // Label 7800: @399461
     /* 399461 */ GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(400008),
     /* 399466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399476 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(399589), // Rule ID 6316 //
     /* 399481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399542 */     // MIs[3] Operand 1
     /* 399542 */     // No operand predicates
     /* 399542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399544 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 399544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 399562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399587 */     GIR_RootConstrainSelectedInstOperands,
     /* 399588 */     // GIR_Coverage, 6316,
     /* 399588 */     GIR_EraseRootFromParent_Done,
     /* 399589 */   // Label 7817: @399589
     /* 399589 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(399702), // Rule ID 14181 //
     /* 399594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399630 */     // MIs[2] Operand 1
     /* 399630 */     // No operand predicates
     /* 399630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 399646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399651 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 399655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399657 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 399657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 399675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399700 */     GIR_RootConstrainSelectedInstOperands,
     /* 399701 */     // GIR_Coverage, 14181,
     /* 399701 */     GIR_EraseRootFromParent_Done,
     /* 399702 */   // Label 7818: @399702
     /* 399702 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(399778), // Rule ID 14115 //
     /* 399707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399728 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399738 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 399738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399750 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 399756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 399769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399776 */     GIR_RootConstrainSelectedInstOperands,
     /* 399777 */     // GIR_Coverage, 14115,
     /* 399777 */     GIR_EraseRootFromParent_Done,
     /* 399778 */   // Label 7819: @399778
     /* 399778 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(399854), // Rule ID 4873 //
     /* 399783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399808 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399814 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 399814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399826 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 399832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 399845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399852 */     GIR_RootConstrainSelectedInstOperands,
     /* 399853 */     // GIR_Coverage, 4873,
     /* 399853 */     GIR_EraseRootFromParent_Done,
     /* 399854 */   // Label 7820: @399854
     /* 399854 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(399917), // Rule ID 13719 //
     /* 399859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399891 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399895 */     // MIs[2] Operand 1
     /* 399895 */     // No operand predicates
     /* 399895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399901 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399915 */     GIR_RootConstrainSelectedInstOperands,
     /* 399916 */     // GIR_Coverage, 13719,
     /* 399916 */     GIR_EraseRootFromParent_Done,
     /* 399917 */   // Label 7821: @399917
     /* 399917 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(399980), // Rule ID 2017 //
     /* 399922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399962 */     // MIs[2] Operand 1
     /* 399962 */     // No operand predicates
     /* 399962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399964 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399978 */     GIR_RootConstrainSelectedInstOperands,
     /* 399979 */     // GIR_Coverage, 2017,
     /* 399979 */     GIR_EraseRootFromParent_Done,
     /* 399980 */   // Label 7822: @399980
     /* 399980 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(400007), // Rule ID 625 //
     /* 399985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399996 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 400001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400005 */     GIR_RootConstrainSelectedInstOperands,
     /* 400006 */     // GIR_Coverage, 625,
     /* 400006 */     GIR_Done,
     /* 400007 */   // Label 7823: @400007
     /* 400007 */   GIM_Reject,
     /* 400008 */ // Label 7816: @400008
     /* 400008 */ GIM_Reject,
     /* 400009 */ // Label 7801: @400009
     /* 400009 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(400556),
     /* 400014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400024 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(400137), // Rule ID 6318 //
     /* 400029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400053 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400090 */     // MIs[3] Operand 1
     /* 400090 */     // No operand predicates
     /* 400090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400092 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 400092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 400095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400135 */     GIR_RootConstrainSelectedInstOperands,
     /* 400136 */     // GIR_Coverage, 6318,
     /* 400136 */     GIR_EraseRootFromParent_Done,
     /* 400137 */   // Label 7825: @400137
     /* 400137 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(400250), // Rule ID 14183 //
     /* 400142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400178 */     // MIs[2] Operand 1
     /* 400178 */     // No operand predicates
     /* 400178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400194 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400199 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 400203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400205 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 400205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 400208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400248 */     GIR_RootConstrainSelectedInstOperands,
     /* 400249 */     // GIR_Coverage, 14183,
     /* 400249 */     GIR_EraseRootFromParent_Done,
     /* 400250 */   // Label 7826: @400250
     /* 400250 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400326), // Rule ID 14117 //
     /* 400255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400276 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400286 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 400286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 400289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 400317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400324 */     GIR_RootConstrainSelectedInstOperands,
     /* 400325 */     // GIR_Coverage, 14117,
     /* 400325 */     GIR_EraseRootFromParent_Done,
     /* 400326 */   // Label 7827: @400326
     /* 400326 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(400402), // Rule ID 4875 //
     /* 400331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400356 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400362 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 400362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 400365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 400393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400400 */     GIR_RootConstrainSelectedInstOperands,
     /* 400401 */     // GIR_Coverage, 4875,
     /* 400401 */     GIR_EraseRootFromParent_Done,
     /* 400402 */   // Label 7828: @400402
     /* 400402 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(400465), // Rule ID 13721 //
     /* 400407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400439 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400443 */     // MIs[2] Operand 1
     /* 400443 */     // No operand predicates
     /* 400443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400449 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400463 */     GIR_RootConstrainSelectedInstOperands,
     /* 400464 */     // GIR_Coverage, 13721,
     /* 400464 */     GIR_EraseRootFromParent_Done,
     /* 400465 */   // Label 7829: @400465
     /* 400465 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(400528), // Rule ID 2019 //
     /* 400470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400510 */     // MIs[2] Operand 1
     /* 400510 */     // No operand predicates
     /* 400510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400512 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400526 */     GIR_RootConstrainSelectedInstOperands,
     /* 400527 */     // GIR_Coverage, 2019,
     /* 400527 */     GIR_EraseRootFromParent_Done,
     /* 400528 */   // Label 7830: @400528
     /* 400528 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(400555), // Rule ID 627 //
     /* 400533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400544 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 400549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400553 */     GIR_RootConstrainSelectedInstOperands,
     /* 400554 */     // GIR_Coverage, 627,
     /* 400554 */     GIR_Done,
     /* 400555 */   // Label 7831: @400555
     /* 400555 */   GIM_Reject,
     /* 400556 */ // Label 7824: @400556
     /* 400556 */ GIM_Reject,
     /* 400557 */ // Label 7802: @400557
     /* 400557 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(401086),
     /* 400562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400572 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(400658), // Rule ID 13709 //
     /* 400577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400625 */     // MIs[3] Operand 1
     /* 400625 */     // No operand predicates
     /* 400625 */     // MIs[1] Operand 2
     /* 400625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400642 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400656 */     GIR_RootConstrainSelectedInstOperands,
     /* 400657 */     // GIR_Coverage, 13709,
     /* 400657 */     GIR_EraseRootFromParent_Done,
     /* 400658 */   // Label 7833: @400658
     /* 400658 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(400744), // Rule ID 2007 //
     /* 400663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400715 */     // MIs[3] Operand 1
     /* 400715 */     // No operand predicates
     /* 400715 */     // MIs[1] Operand 2
     /* 400715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400728 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400742 */     GIR_RootConstrainSelectedInstOperands,
     /* 400743 */     // GIR_Coverage, 2007,
     /* 400743 */     GIR_EraseRootFromParent_Done,
     /* 400744 */   // Label 7834: @400744
     /* 400744 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(400807), // Rule ID 13710 //
     /* 400749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400785 */     // MIs[2] Operand 1
     /* 400785 */     // No operand predicates
     /* 400785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400791 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400805 */     GIR_RootConstrainSelectedInstOperands,
     /* 400806 */     // GIR_Coverage, 13710,
     /* 400806 */     GIR_EraseRootFromParent_Done,
     /* 400807 */   // Label 7835: @400807
     /* 400807 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(400870), // Rule ID 2008 //
     /* 400812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400852 */     // MIs[2] Operand 1
     /* 400852 */     // No operand predicates
     /* 400852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400854 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400868 */     GIR_RootConstrainSelectedInstOperands,
     /* 400869 */     // GIR_Coverage, 2008,
     /* 400869 */     GIR_EraseRootFromParent_Done,
     /* 400870 */   // Label 7836: @400870
     /* 400870 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(400964), // Rule ID 14185 //
     /* 400875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400898 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400924 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400962 */     GIR_RootConstrainSelectedInstOperands,
     /* 400963 */     // GIR_Coverage, 14185,
     /* 400963 */     GIR_EraseRootFromParent_Done,
     /* 400964 */   // Label 7837: @400964
     /* 400964 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(401058), // Rule ID 6320 //
     /* 400969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400992 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 401046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401056 */     GIR_RootConstrainSelectedInstOperands,
     /* 401057 */     // GIR_Coverage, 6320,
     /* 401057 */     GIR_EraseRootFromParent_Done,
     /* 401058 */   // Label 7838: @401058
     /* 401058 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(401085), // Rule ID 1326 //
     /* 401063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401074 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 401079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401083 */     GIR_RootConstrainSelectedInstOperands,
     /* 401084 */     // GIR_Coverage, 1326,
     /* 401084 */     GIR_Done,
     /* 401085 */   // Label 7839: @401085
     /* 401085 */   GIM_Reject,
     /* 401086 */ // Label 7832: @401086
     /* 401086 */ GIM_Reject,
     /* 401087 */ // Label 7803: @401087
     /* 401087 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(401444),
     /* 401092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401102 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(401165), // Rule ID 13715 //
     /* 401107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 401118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 401143 */     // MIs[2] Operand 1
     /* 401143 */     // No operand predicates
     /* 401143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401149 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 401152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401163 */     GIR_RootConstrainSelectedInstOperands,
     /* 401164 */     // GIR_Coverage, 13715,
     /* 401164 */     GIR_EraseRootFromParent_Done,
     /* 401165 */   // Label 7841: @401165
     /* 401165 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(401228), // Rule ID 2013 //
     /* 401170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 401185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 401210 */     // MIs[2] Operand 1
     /* 401210 */     // No operand predicates
     /* 401210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401212 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 401215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401226 */     GIR_RootConstrainSelectedInstOperands,
     /* 401227 */     // GIR_Coverage, 2013,
     /* 401227 */     GIR_EraseRootFromParent_Done,
     /* 401228 */   // Label 7842: @401228
     /* 401228 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(401322), // Rule ID 14189 //
     /* 401233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 401241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 401245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401256 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401282 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 401310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401320 */     GIR_RootConstrainSelectedInstOperands,
     /* 401321 */     // GIR_Coverage, 14189,
     /* 401321 */     GIR_EraseRootFromParent_Done,
     /* 401322 */   // Label 7843: @401322
     /* 401322 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(401416), // Rule ID 6324 //
     /* 401327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 401339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 401343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401350 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 401404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401414 */     GIR_RootConstrainSelectedInstOperands,
     /* 401415 */     // GIR_Coverage, 6324,
     /* 401415 */     GIR_EraseRootFromParent_Done,
     /* 401416 */   // Label 7844: @401416
     /* 401416 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(401443), // Rule ID 1330 //
     /* 401421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401432 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 401437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401441 */     GIR_RootConstrainSelectedInstOperands,
     /* 401442 */     // GIR_Coverage, 1330,
     /* 401442 */     GIR_Done,
     /* 401443 */   // Label 7845: @401443
     /* 401443 */   GIM_Reject,
     /* 401444 */ // Label 7840: @401444
     /* 401444 */ GIM_Reject,
     /* 401445 */ // Label 7804: @401445
     /* 401445 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(401786),
     /* 401450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401460 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(401546), // Rule ID 13703 //
     /* 401465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401509 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401513 */     // MIs[3] Operand 1
     /* 401513 */     // No operand predicates
     /* 401513 */     // MIs[1] Operand 2
     /* 401513 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401530 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401544 */     GIR_RootConstrainSelectedInstOperands,
     /* 401545 */     // GIR_Coverage, 13703,
     /* 401545 */     GIR_EraseRootFromParent_Done,
     /* 401546 */   // Label 7847: @401546
     /* 401546 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401632), // Rule ID 2001 //
     /* 401551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401603 */     // MIs[3] Operand 1
     /* 401603 */     // No operand predicates
     /* 401603 */     // MIs[1] Operand 2
     /* 401603 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401616 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401630 */     GIR_RootConstrainSelectedInstOperands,
     /* 401631 */     // GIR_Coverage, 2001,
     /* 401631 */     GIR_EraseRootFromParent_Done,
     /* 401632 */   // Label 7848: @401632
     /* 401632 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(401695), // Rule ID 13704 //
     /* 401637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401669 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401673 */     // MIs[2] Operand 1
     /* 401673 */     // No operand predicates
     /* 401673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401679 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401693 */     GIR_RootConstrainSelectedInstOperands,
     /* 401694 */     // GIR_Coverage, 13704,
     /* 401694 */     GIR_EraseRootFromParent_Done,
     /* 401695 */   // Label 7849: @401695
     /* 401695 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(401758), // Rule ID 2002 //
     /* 401700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401736 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401740 */     // MIs[2] Operand 1
     /* 401740 */     // No operand predicates
     /* 401740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401742 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401756 */     GIR_RootConstrainSelectedInstOperands,
     /* 401757 */     // GIR_Coverage, 2002,
     /* 401757 */     GIR_EraseRootFromParent_Done,
     /* 401758 */   // Label 7850: @401758
     /* 401758 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(401785), // Rule ID 1322 //
     /* 401763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401774 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 401779 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401783 */     GIR_RootConstrainSelectedInstOperands,
     /* 401784 */     // GIR_Coverage, 1322,
     /* 401784 */     GIR_Done,
     /* 401785 */   // Label 7851: @401785
     /* 401785 */   GIM_Reject,
     /* 401786 */ // Label 7846: @401786
     /* 401786 */ GIM_Reject,
     /* 401787 */ // Label 7805: @401787
     /* 401787 */ GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(402144),
     /* 401792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401802 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(401865), // Rule ID 13713 //
     /* 401807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 401818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401843 */     // MIs[2] Operand 1
     /* 401843 */     // No operand predicates
     /* 401843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401849 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401863 */     GIR_RootConstrainSelectedInstOperands,
     /* 401864 */     // GIR_Coverage, 13713,
     /* 401864 */     GIR_EraseRootFromParent_Done,
     /* 401865 */   // Label 7853: @401865
     /* 401865 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(401928), // Rule ID 2011 //
     /* 401870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 401885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401910 */     // MIs[2] Operand 1
     /* 401910 */     // No operand predicates
     /* 401910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401912 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401926 */     GIR_RootConstrainSelectedInstOperands,
     /* 401927 */     // GIR_Coverage, 2011,
     /* 401927 */     GIR_EraseRootFromParent_Done,
     /* 401928 */   // Label 7854: @401928
     /* 401928 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(402022), // Rule ID 14187 //
     /* 401933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 401941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 401945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401956 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 402010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402020 */     GIR_RootConstrainSelectedInstOperands,
     /* 402021 */     // GIR_Coverage, 14187,
     /* 402021 */     GIR_EraseRootFromParent_Done,
     /* 402022 */   // Label 7855: @402022
     /* 402022 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(402116), // Rule ID 6322 //
     /* 402027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 402039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 402043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402050 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 402050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 402053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 402057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 402064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 402067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 402071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 402079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 402086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 402104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402114 */     GIR_RootConstrainSelectedInstOperands,
     /* 402115 */     // GIR_Coverage, 6322,
     /* 402115 */     GIR_EraseRootFromParent_Done,
     /* 402116 */   // Label 7856: @402116
     /* 402116 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(402143), // Rule ID 1328 //
     /* 402121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402132 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 402137 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402141 */     GIR_RootConstrainSelectedInstOperands,
     /* 402142 */     // GIR_Coverage, 1328,
     /* 402142 */     GIR_Done,
     /* 402143 */   // Label 7857: @402143
     /* 402143 */   GIM_Reject,
     /* 402144 */ // Label 7852: @402144
     /* 402144 */ GIM_Reject,
     /* 402145 */ // Label 7806: @402145
     /* 402145 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(402576),
     /* 402150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402160 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(402223), // Rule ID 13707 //
     /* 402165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 402176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402201 */     // MIs[2] Operand 1
     /* 402201 */     // No operand predicates
     /* 402201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402207 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 402207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 402210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402221 */     GIR_RootConstrainSelectedInstOperands,
     /* 402222 */     // GIR_Coverage, 13707,
     /* 402222 */     GIR_EraseRootFromParent_Done,
     /* 402223 */   // Label 7859: @402223
     /* 402223 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(402286), // Rule ID 2005 //
     /* 402228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 402243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402268 */     // MIs[2] Operand 1
     /* 402268 */     // No operand predicates
     /* 402268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402270 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 402270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 402273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402284 */     GIR_RootConstrainSelectedInstOperands,
     /* 402285 */     // GIR_Coverage, 2005,
     /* 402285 */     GIR_EraseRootFromParent_Done,
     /* 402286 */   // Label 7860: @402286
     /* 402286 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(402313), // Rule ID 1324 //
     /* 402291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402302 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 402307 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402311 */     GIR_RootConstrainSelectedInstOperands,
     /* 402312 */     // GIR_Coverage, 1324,
     /* 402312 */     GIR_Done,
     /* 402313 */   // Label 7861: @402313
     /* 402313 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402575), // Rule ID 7093 //
     /* 402318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 402321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402329 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 402329 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 402332 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402336 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402341 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 402345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 402347 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 402350 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402354 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402359 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 402363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 402365 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 402368 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 402372 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402377 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 402380 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 402383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 402385 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 402388 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402392 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402397 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 402403 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402408 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402413 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 402416 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402420 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402425 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 402428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 402430 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 402433 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402437 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402442 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 402448 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402458 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 402461 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402465 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402470 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 402473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 402475 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 402478 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 402482 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402487 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 402490 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 402493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 402495 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 402498 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 402502 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402507 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 402510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 402512 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 402515 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 402519 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 402526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 402533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402538 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 402541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 402544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 402547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 402565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 402573 */     GIR_RootConstrainSelectedInstOperands,
     /* 402574 */     // GIR_Coverage, 7093,
     /* 402574 */     GIR_EraseRootFromParent_Done,
     /* 402575 */   // Label 7862: @402575
     /* 402575 */   GIM_Reject,
     /* 402576 */ // Label 7858: @402576
     /* 402576 */ GIM_Reject,
     /* 402577 */ // Label 7807: @402577
     /* 402577 */ GIM_Reject,
     /* 402578 */ // Label 107: @402578
     /* 402578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7871*/ GIMT_Encode4(403193),
     /* 402589 */ /*GILLT_s16*//*Label 7863*/ GIMT_Encode4(402629),
     /* 402593 */ /*GILLT_s32*//*Label 7864*/ GIMT_Encode4(402667),
     /* 402597 */ /*GILLT_s64*//*Label 7865*/ GIMT_Encode4(402705), GIMT_Encode4(0),
     /* 402605 */ /*GILLT_v2s32*//*Label 7866*/ GIMT_Encode4(402743),
     /* 402609 */ /*GILLT_v2s64*//*Label 7867*/ GIMT_Encode4(402781),
     /* 402613 */ /*GILLT_v4s16*//*Label 7868*/ GIMT_Encode4(402819),
     /* 402617 */ /*GILLT_v4s32*//*Label 7869*/ GIMT_Encode4(402857), GIMT_Encode4(0),
     /* 402625 */ /*GILLT_v8s16*//*Label 7870*/ GIMT_Encode4(402895),
     /* 402629 */ // Label 7863: @402629
     /* 402629 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(402666), // Rule ID 593 //
     /* 402634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 402640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 402643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402655 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 402655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 402660 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402664 */   GIR_RootConstrainSelectedInstOperands,
     /* 402665 */   // GIR_Coverage, 593,
     /* 402665 */   GIR_Done,
     /* 402666 */ // Label 7872: @402666
     /* 402666 */ GIM_Reject,
     /* 402667 */ // Label 7864: @402667
     /* 402667 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(402704), // Rule ID 595 //
     /* 402672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 402681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402693 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 402693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 402698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402702 */   GIR_RootConstrainSelectedInstOperands,
     /* 402703 */   // GIR_Coverage, 595,
     /* 402703 */   GIR_Done,
     /* 402704 */ // Label 7873: @402704
     /* 402704 */ GIM_Reject,
     /* 402705 */ // Label 7865: @402705
     /* 402705 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(402742), // Rule ID 597 //
     /* 402710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402731 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 402731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 402736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402740 */   GIR_RootConstrainSelectedInstOperands,
     /* 402741 */   // GIR_Coverage, 597,
     /* 402741 */   GIR_Done,
     /* 402742 */ // Label 7874: @402742
     /* 402742 */ GIM_Reject,
     /* 402743 */ // Label 7866: @402743
     /* 402743 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(402780), // Rule ID 1231 //
     /* 402748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 402757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402769 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 402774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402778 */   GIR_RootConstrainSelectedInstOperands,
     /* 402779 */   // GIR_Coverage, 1231,
     /* 402779 */   GIR_Done,
     /* 402780 */ // Label 7875: @402780
     /* 402780 */ GIM_Reject,
     /* 402781 */ // Label 7867: @402781
     /* 402781 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(402818), // Rule ID 1235 //
     /* 402786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402807 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 402812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402816 */   GIR_RootConstrainSelectedInstOperands,
     /* 402817 */   // GIR_Coverage, 1235,
     /* 402817 */   GIR_Done,
     /* 402818 */ // Label 7876: @402818
     /* 402818 */ GIM_Reject,
     /* 402819 */ // Label 7868: @402819
     /* 402819 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(402856), // Rule ID 1227 //
     /* 402824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402845 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 402850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402854 */   GIR_RootConstrainSelectedInstOperands,
     /* 402855 */   // GIR_Coverage, 1227,
     /* 402855 */   GIR_Done,
     /* 402856 */ // Label 7877: @402856
     /* 402856 */ GIM_Reject,
     /* 402857 */ // Label 7869: @402857
     /* 402857 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(402894), // Rule ID 1233 //
     /* 402862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402883 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 402888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402892 */   GIR_RootConstrainSelectedInstOperands,
     /* 402893 */   // GIR_Coverage, 1233,
     /* 402893 */   GIR_Done,
     /* 402894 */ // Label 7878: @402894
     /* 402894 */ GIM_Reject,
     /* 402895 */ // Label 7870: @402895
     /* 402895 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(403192),
     /* 402900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402918 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(402937), // Rule ID 1229 //
     /* 402923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402926 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 402931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402935 */     GIR_RootConstrainSelectedInstOperands,
     /* 402936 */     // GIR_Coverage, 1229,
     /* 402936 */     GIR_Done,
     /* 402937 */   // Label 7880: @402937
     /* 402937 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(403191), // Rule ID 7091 //
     /* 402942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 402945 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 402945 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 402948 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402952 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402957 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 402961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 402963 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 402966 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402970 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402975 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 402979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 402981 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 402984 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 402988 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402993 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 402996 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 402999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 403001 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 403004 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403008 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403013 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 403019 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403024 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403029 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 403032 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 403036 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403041 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 403044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 403046 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 403049 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403053 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403058 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 403064 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403069 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403074 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 403077 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 403081 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403086 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 403089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 403091 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 403094 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 403098 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403103 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 403106 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 403109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 403111 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 403114 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 403118 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403123 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 403126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 403128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 403131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 403135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 403142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 403145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 403149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 403157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 403160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 403163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 403181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 403189 */     GIR_RootConstrainSelectedInstOperands,
     /* 403190 */     // GIR_Coverage, 7091,
     /* 403190 */     GIR_EraseRootFromParent_Done,
     /* 403191 */   // Label 7881: @403191
     /* 403191 */   GIM_Reject,
     /* 403192 */ // Label 7879: @403192
     /* 403192 */ GIM_Reject,
     /* 403193 */ // Label 7871: @403193
     /* 403193 */ GIM_Reject,
     /* 403194 */ // Label 108: @403194
     /* 403194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7890*/ GIMT_Encode4(418800),
     /* 403205 */ /*GILLT_s16*//*Label 7882*/ GIMT_Encode4(403245),
     /* 403209 */ /*GILLT_s32*//*Label 7883*/ GIMT_Encode4(406019),
     /* 403213 */ /*GILLT_s64*//*Label 7884*/ GIMT_Encode4(408949), GIMT_Encode4(0),
     /* 403221 */ /*GILLT_v2s32*//*Label 7885*/ GIMT_Encode4(411879),
     /* 403225 */ /*GILLT_v2s64*//*Label 7886*/ GIMT_Encode4(413400),
     /* 403229 */ /*GILLT_v4s16*//*Label 7887*/ GIMT_Encode4(414921),
     /* 403233 */ /*GILLT_v4s32*//*Label 7888*/ GIMT_Encode4(416100), GIMT_Encode4(0),
     /* 403241 */ /*GILLT_v8s16*//*Label 7889*/ GIMT_Encode4(417621),
     /* 403245 */ // Label 7882: @403245
     /* 403245 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(406018),
     /* 403250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 403253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 403256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 403259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403263 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(403413), // Rule ID 4933 //
     /* 403268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403329 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403340 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403352 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403380 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403411 */     GIR_RootConstrainSelectedInstOperands,
     /* 403412 */     // GIR_Coverage, 4933,
     /* 403412 */     GIR_EraseRootFromParent_Done,
     /* 403413 */   // Label 7892: @403413
     /* 403413 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(403560), // Rule ID 4897 //
     /* 403418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403470 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403474 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403479 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403489 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403501 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403512 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403558 */     GIR_RootConstrainSelectedInstOperands,
     /* 403559 */     // GIR_Coverage, 4897,
     /* 403559 */     GIR_EraseRootFromParent_Done,
     /* 403560 */   // Label 7893: @403560
     /* 403560 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(403707), // Rule ID 14126 //
     /* 403565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403601 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403621 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403626 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403636 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403648 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403654 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403676 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403705 */     GIR_RootConstrainSelectedInstOperands,
     /* 403706 */     // GIR_Coverage, 14126,
     /* 403706 */     GIR_EraseRootFromParent_Done,
     /* 403707 */   // Label 7894: @403707
     /* 403707 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(403838), // Rule ID 6152 //
     /* 403712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403781 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403785 */     // MIs[4] Operand 1
     /* 403785 */     // No operand predicates
     /* 403785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403789 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403791 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403803 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403836 */     GIR_RootConstrainSelectedInstOperands,
     /* 403837 */     // GIR_Coverage, 6152,
     /* 403837 */     GIR_EraseRootFromParent_Done,
     /* 403838 */   // Label 7895: @403838
     /* 403838 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(403969), // Rule ID 6184 //
     /* 403843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403879 */     // MIs[2] Operand 1
     /* 403879 */     // No operand predicates
     /* 403879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403891 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 403895 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403899 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403903 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403907 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403912 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403920 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403922 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403934 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403967 */     GIR_RootConstrainSelectedInstOperands,
     /* 403968 */     // GIR_Coverage, 6184,
     /* 403968 */     GIR_EraseRootFromParent_Done,
     /* 403969 */   // Label 7896: @403969
     /* 403969 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(404100), // Rule ID 6248 //
     /* 403974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404010 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 404039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404043 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404047 */     // MIs[4] Operand 1
     /* 404047 */     // No operand predicates
     /* 404047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404051 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404053 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 404095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 404098 */     GIR_RootConstrainSelectedInstOperands,
     /* 404099 */     // GIR_Coverage, 6248,
     /* 404099 */     GIR_EraseRootFromParent_Done,
     /* 404100 */   // Label 7897: @404100
     /* 404100 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(404231), // Rule ID 6216 //
     /* 404105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404153 */     // MIs[3] Operand 1
     /* 404153 */     // No operand predicates
     /* 404153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 404157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404161 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 404169 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404174 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 404178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404182 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404184 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404196 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404229 */     GIR_RootConstrainSelectedInstOperands,
     /* 404230 */     // GIR_Coverage, 6216,
     /* 404230 */     GIR_EraseRootFromParent_Done,
     /* 404231 */   // Label 7898: @404231
     /* 404231 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(404366), // Rule ID 2462 //
     /* 404236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404285 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404295 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 404298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404307 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404364 */     GIR_RootConstrainSelectedInstOperands,
     /* 404365 */     // GIR_Coverage, 2462,
     /* 404365 */     GIR_EraseRootFromParent_Done,
     /* 404366 */   // Label 7899: @404366
     /* 404366 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(404485), // Rule ID 6120 //
     /* 404371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404395 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404428 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404432 */     // MIs[3] Operand 1
     /* 404432 */     // No operand predicates
     /* 404432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404438 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404450 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404483 */     GIR_RootConstrainSelectedInstOperands,
     /* 404484 */     // GIR_Coverage, 6120,
     /* 404484 */     GIR_EraseRootFromParent_Done,
     /* 404485 */   // Label 7900: @404485
     /* 404485 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(404604), // Rule ID 2537 //
     /* 404490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404526 */     // MIs[2] Operand 1
     /* 404526 */     // No operand predicates
     /* 404526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404538 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404547 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404557 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404569 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404602 */     GIR_RootConstrainSelectedInstOperands,
     /* 404603 */     // GIR_Coverage, 2537,
     /* 404603 */     GIR_EraseRootFromParent_Done,
     /* 404604 */   // Label 7901: @404604
     /* 404604 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(404704), // Rule ID 4895 //
     /* 404609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404633 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404660 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404672 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404702 */     GIR_RootConstrainSelectedInstOperands,
     /* 404703 */     // GIR_Coverage, 4895,
     /* 404703 */     GIR_EraseRootFromParent_Done,
     /* 404704 */   // Label 7902: @404704
     /* 404704 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(404804), // Rule ID 4931 //
     /* 404709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404760 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404772 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 404791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404802 */     GIR_RootConstrainSelectedInstOperands,
     /* 404803 */     // GIR_Coverage, 4931,
     /* 404803 */     GIR_EraseRootFromParent_Done,
     /* 404804 */   // Label 7903: @404804
     /* 404804 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(404901), // Rule ID 14122 //
     /* 404809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404845 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404859 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404871 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404899 */     GIR_RootConstrainSelectedInstOperands,
     /* 404900 */     // GIR_Coverage, 14122,
     /* 404900 */     GIR_EraseRootFromParent_Done,
     /* 404901 */   // Label 7904: @404901
     /* 404901 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(405001), // Rule ID 14124 //
     /* 404906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404957 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404999 */     GIR_RootConstrainSelectedInstOperands,
     /* 405000 */     // GIR_Coverage, 14124,
     /* 405000 */     GIR_EraseRootFromParent_Done,
     /* 405001 */   // Label 7905: @405001
     /* 405001 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(405101), // Rule ID 4929 //
     /* 405006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 405042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405057 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 405057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405069 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 405075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 405088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 405099 */     GIR_RootConstrainSelectedInstOperands,
     /* 405100 */     // GIR_Coverage, 4929,
     /* 405100 */     GIR_EraseRootFromParent_Done,
     /* 405101 */   // Label 7906: @405101
     /* 405101 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(405198), // Rule ID 4893 //
     /* 405106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405146 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405156 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 405156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 405174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 405187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405196 */     GIR_RootConstrainSelectedInstOperands,
     /* 405197 */     // GIR_Coverage, 4893,
     /* 405197 */     GIR_EraseRootFromParent_Done,
     /* 405198 */   // Label 7907: @405198
     /* 405198 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(405282), // Rule ID 6182 //
     /* 405203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405239 */     // MIs[2] Operand 1
     /* 405239 */     // No operand predicates
     /* 405239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 405251 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405262 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 405273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405280 */     GIR_RootConstrainSelectedInstOperands,
     /* 405281 */     // GIR_Coverage, 6182,
     /* 405281 */     GIR_EraseRootFromParent_Done,
     /* 405282 */   // Label 7908: @405282
     /* 405282 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(405363), // Rule ID 6214 //
     /* 405287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405335 */     // MIs[3] Operand 1
     /* 405335 */     // No operand predicates
     /* 405335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405345 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405361 */     GIR_RootConstrainSelectedInstOperands,
     /* 405362 */     // GIR_Coverage, 6214,
     /* 405362 */     GIR_EraseRootFromParent_Done,
     /* 405363 */   // Label 7909: @405363
     /* 405363 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(405447), // Rule ID 6246 //
     /* 405368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405417 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405421 */     // MIs[3] Operand 1
     /* 405421 */     // No operand predicates
     /* 405421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405427 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405445 */     GIR_RootConstrainSelectedInstOperands,
     /* 405446 */     // GIR_Coverage, 6246,
     /* 405446 */     GIR_EraseRootFromParent_Done,
     /* 405447 */   // Label 7910: @405447
     /* 405447 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(405528), // Rule ID 6150 //
     /* 405452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405504 */     // MIs[3] Operand 1
     /* 405504 */     // No operand predicates
     /* 405504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405510 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405526 */     GIR_RootConstrainSelectedInstOperands,
     /* 405527 */     // GIR_Coverage, 6150,
     /* 405527 */     GIR_EraseRootFromParent_Done,
     /* 405528 */   // Label 7911: @405528
     /* 405528 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(405613), // Rule ID 2460 //
     /* 405533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405557 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405571 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405583 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 405589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 405602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405611 */     GIR_RootConstrainSelectedInstOperands,
     /* 405612 */     // GIR_Coverage, 2460,
     /* 405612 */     GIR_EraseRootFromParent_Done,
     /* 405613 */   // Label 7912: @405613
     /* 405613 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(405698), // Rule ID 2458 //
     /* 405618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405646 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405656 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 405656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405668 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 405674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 405687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405696 */     GIR_RootConstrainSelectedInstOperands,
     /* 405697 */     // GIR_Coverage, 2458,
     /* 405697 */     GIR_EraseRootFromParent_Done,
     /* 405698 */   // Label 7913: @405698
     /* 405698 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(405767), // Rule ID 2535 //
     /* 405703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405739 */     // MIs[2] Operand 1
     /* 405739 */     // No operand predicates
     /* 405739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405749 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 405752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405765 */     GIR_RootConstrainSelectedInstOperands,
     /* 405766 */     // GIR_Coverage, 2535,
     /* 405766 */     GIR_EraseRootFromParent_Done,
     /* 405767 */   // Label 7914: @405767
     /* 405767 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(405836), // Rule ID 6118 //
     /* 405772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405812 */     // MIs[2] Operand 1
     /* 405812 */     // No operand predicates
     /* 405812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405818 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 405821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405834 */     GIR_RootConstrainSelectedInstOperands,
     /* 405835 */     // GIR_Coverage, 6118,
     /* 405835 */     GIR_EraseRootFromParent_Done,
     /* 405836 */   // Label 7915: @405836
     /* 405836 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(405886), // Rule ID 13553 //
     /* 405841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405871 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 405874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405884 */     GIR_RootConstrainSelectedInstOperands,
     /* 405885 */     // GIR_Coverage, 13553,
     /* 405885 */     GIR_EraseRootFromParent_Done,
     /* 405886 */   // Label 7916: @405886
     /* 405886 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(405936), // Rule ID 647 //
     /* 405891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405921 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 405924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405934 */     GIR_RootConstrainSelectedInstOperands,
     /* 405935 */     // GIR_Coverage, 647,
     /* 405935 */     GIR_EraseRootFromParent_Done,
     /* 405936 */   // Label 7917: @405936
     /* 405936 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(405986), // Rule ID 659 //
     /* 405941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 405956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405971 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 405974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 405984 */     GIR_RootConstrainSelectedInstOperands,
     /* 405985 */     // GIR_Coverage, 659,
     /* 405985 */     GIR_EraseRootFromParent_Done,
     /* 405986 */   // Label 7918: @405986
     /* 405986 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(406017), // Rule ID 641 //
     /* 405991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 406002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 406006 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 406006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 406011 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406015 */     GIR_RootConstrainSelectedInstOperands,
     /* 406016 */     // GIR_Coverage, 641,
     /* 406016 */     GIR_Done,
     /* 406017 */   // Label 7919: @406017
     /* 406017 */   GIM_Reject,
     /* 406018 */ // Label 7891: @406018
     /* 406018 */ GIM_Reject,
     /* 406019 */ // Label 7883: @406019
     /* 406019 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(408948),
     /* 406024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 406027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 406030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 406033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406037 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(406187), // Rule ID 4939 //
     /* 406042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406091 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 406099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406103 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 406107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406114 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 406117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406126 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 406185 */     GIR_RootConstrainSelectedInstOperands,
     /* 406186 */     // GIR_Coverage, 4939,
     /* 406186 */     GIR_EraseRootFromParent_Done,
     /* 406187 */   // Label 7921: @406187
     /* 406187 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(406334), // Rule ID 4903 //
     /* 406192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406216 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406248 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406253 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406263 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 406266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406275 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406303 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406332 */     GIR_RootConstrainSelectedInstOperands,
     /* 406333 */     // GIR_Coverage, 4903,
     /* 406333 */     GIR_EraseRootFromParent_Done,
     /* 406334 */   // Label 7922: @406334
     /* 406334 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(406481), // Rule ID 14132 //
     /* 406339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406375 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406400 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406410 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 406413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406422 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406450 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406479 */     GIR_RootConstrainSelectedInstOperands,
     /* 406480 */     // GIR_Coverage, 14132,
     /* 406480 */     GIR_EraseRootFromParent_Done,
     /* 406481 */   // Label 7923: @406481
     /* 406481 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(406612), // Rule ID 6168 //
     /* 406486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406510 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406538 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406547 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406551 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406555 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406559 */     // MIs[4] Operand 1
     /* 406559 */     // No operand predicates
     /* 406559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406563 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406565 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406577 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406610 */     GIR_RootConstrainSelectedInstOperands,
     /* 406611 */     // GIR_Coverage, 6168,
     /* 406611 */     GIR_EraseRootFromParent_Done,
     /* 406612 */   // Label 7924: @406612
     /* 406612 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(406743), // Rule ID 6200 //
     /* 406617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406649 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406653 */     // MIs[2] Operand 1
     /* 406653 */     // No operand predicates
     /* 406653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 406665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 406669 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406673 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406677 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406681 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406686 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406694 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406696 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406708 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406741 */     GIR_RootConstrainSelectedInstOperands,
     /* 406742 */     // GIR_Coverage, 6200,
     /* 406742 */     GIR_EraseRootFromParent_Done,
     /* 406743 */   // Label 7925: @406743
     /* 406743 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(406874), // Rule ID 6264 //
     /* 406748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406804 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406817 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406821 */     // MIs[4] Operand 1
     /* 406821 */     // No operand predicates
     /* 406821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406827 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406872 */     GIR_RootConstrainSelectedInstOperands,
     /* 406873 */     // GIR_Coverage, 6264,
     /* 406873 */     GIR_EraseRootFromParent_Done,
     /* 406874 */   // Label 7926: @406874
     /* 406874 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(407005), // Rule ID 6232 //
     /* 406879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406923 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406927 */     // MIs[3] Operand 1
     /* 406927 */     // No operand predicates
     /* 406927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 406931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406943 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406948 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406956 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406958 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406970 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407003 */     GIR_RootConstrainSelectedInstOperands,
     /* 407004 */     // GIR_Coverage, 6232,
     /* 407004 */     GIR_EraseRootFromParent_Done,
     /* 407005 */   // Label 7927: @407005
     /* 407005 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(407140), // Rule ID 2468 //
     /* 407010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407059 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407069 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 407072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407081 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407109 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407138 */     GIR_RootConstrainSelectedInstOperands,
     /* 407139 */     // GIR_Coverage, 2468,
     /* 407139 */     GIR_EraseRootFromParent_Done,
     /* 407140 */   // Label 7928: @407140
     /* 407140 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(407259), // Rule ID 6136 //
     /* 407145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407202 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407206 */     // MIs[3] Operand 1
     /* 407206 */     // No operand predicates
     /* 407206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407212 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407224 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407257 */     GIR_RootConstrainSelectedInstOperands,
     /* 407258 */     // GIR_Coverage, 6136,
     /* 407258 */     GIR_EraseRootFromParent_Done,
     /* 407259 */   // Label 7929: @407259
     /* 407259 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(407378), // Rule ID 2553 //
     /* 407264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407296 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407300 */     // MIs[2] Operand 1
     /* 407300 */     // No operand predicates
     /* 407300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407312 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407316 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407321 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407331 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407343 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407376 */     GIR_RootConstrainSelectedInstOperands,
     /* 407377 */     // GIR_Coverage, 2553,
     /* 407377 */     GIR_EraseRootFromParent_Done,
     /* 407378 */   // Label 7930: @407378
     /* 407378 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(407478), // Rule ID 4901 //
     /* 407383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407407 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407434 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407446 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407476 */     GIR_RootConstrainSelectedInstOperands,
     /* 407477 */     // GIR_Coverage, 4901,
     /* 407477 */     GIR_EraseRootFromParent_Done,
     /* 407478 */   // Label 7931: @407478
     /* 407478 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(407578), // Rule ID 4937 //
     /* 407483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407534 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407546 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407576 */     GIR_RootConstrainSelectedInstOperands,
     /* 407577 */     // GIR_Coverage, 4937,
     /* 407577 */     GIR_EraseRootFromParent_Done,
     /* 407578 */   // Label 7932: @407578
     /* 407578 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(407675), // Rule ID 14128 //
     /* 407583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407619 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407633 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407645 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407673 */     GIR_RootConstrainSelectedInstOperands,
     /* 407674 */     // GIR_Coverage, 14128,
     /* 407674 */     GIR_EraseRootFromParent_Done,
     /* 407675 */   // Label 7933: @407675
     /* 407675 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(407775), // Rule ID 14130 //
     /* 407680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407721 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407731 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407743 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407773 */     GIR_RootConstrainSelectedInstOperands,
     /* 407774 */     // GIR_Coverage, 14130,
     /* 407774 */     GIR_EraseRootFromParent_Done,
     /* 407775 */   // Label 7934: @407775
     /* 407775 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(407875), // Rule ID 4935 //
     /* 407780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407808 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407831 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407843 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407873 */     GIR_RootConstrainSelectedInstOperands,
     /* 407874 */     // GIR_Coverage, 4935,
     /* 407874 */     GIR_EraseRootFromParent_Done,
     /* 407875 */   // Label 7935: @407875
     /* 407875 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(407972), // Rule ID 4899 //
     /* 407880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407930 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407970 */     GIR_RootConstrainSelectedInstOperands,
     /* 407971 */     // GIR_Coverage, 4899,
     /* 407971 */     GIR_EraseRootFromParent_Done,
     /* 407972 */   // Label 7936: @407972
     /* 407972 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(408050), // Rule ID 6286 //
     /* 407977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408018 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408022 */     // MIs[3] Operand 1
     /* 408022 */     // No operand predicates
     /* 408022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408032 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408048 */     GIR_RootConstrainSelectedInstOperands,
     /* 408049 */     // GIR_Coverage, 6286,
     /* 408049 */     GIR_EraseRootFromParent_Done,
     /* 408050 */   // Label 7937: @408050
     /* 408050 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(408134), // Rule ID 6198 //
     /* 408055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408091 */     // MIs[2] Operand 1
     /* 408091 */     // No operand predicates
     /* 408091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 408103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408114 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 408125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408132 */     GIR_RootConstrainSelectedInstOperands,
     /* 408133 */     // GIR_Coverage, 6198,
     /* 408133 */     GIR_EraseRootFromParent_Done,
     /* 408134 */   // Label 7938: @408134
     /* 408134 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(408215), // Rule ID 6230 //
     /* 408139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408183 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408187 */     // MIs[3] Operand 1
     /* 408187 */     // No operand predicates
     /* 408187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408197 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408213 */     GIR_RootConstrainSelectedInstOperands,
     /* 408214 */     // GIR_Coverage, 6230,
     /* 408214 */     GIR_EraseRootFromParent_Done,
     /* 408215 */   // Label 7939: @408215
     /* 408215 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(408299), // Rule ID 6262 //
     /* 408220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408269 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408273 */     // MIs[3] Operand 1
     /* 408273 */     // No operand predicates
     /* 408273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408279 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 408290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408297 */     GIR_RootConstrainSelectedInstOperands,
     /* 408298 */     // GIR_Coverage, 6262,
     /* 408298 */     GIR_EraseRootFromParent_Done,
     /* 408299 */   // Label 7940: @408299
     /* 408299 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(408377), // Rule ID 6308 //
     /* 408304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408349 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408353 */     // MIs[3] Operand 1
     /* 408353 */     // No operand predicates
     /* 408353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408359 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408375 */     GIR_RootConstrainSelectedInstOperands,
     /* 408376 */     // GIR_Coverage, 6308,
     /* 408376 */     GIR_EraseRootFromParent_Done,
     /* 408377 */   // Label 7941: @408377
     /* 408377 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(408458), // Rule ID 6166 //
     /* 408382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408430 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408434 */     // MIs[3] Operand 1
     /* 408434 */     // No operand predicates
     /* 408434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408440 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408456 */     GIR_RootConstrainSelectedInstOperands,
     /* 408457 */     // GIR_Coverage, 6166,
     /* 408457 */     GIR_EraseRootFromParent_Done,
     /* 408458 */   // Label 7942: @408458
     /* 408458 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(408543), // Rule ID 2466 //
     /* 408463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408501 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408513 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 408519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408541 */     GIR_RootConstrainSelectedInstOperands,
     /* 408542 */     // GIR_Coverage, 2466,
     /* 408542 */     GIR_EraseRootFromParent_Done,
     /* 408543 */   // Label 7943: @408543
     /* 408543 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(408628), // Rule ID 2464 //
     /* 408548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408576 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408586 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 408586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 408604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408626 */     GIR_RootConstrainSelectedInstOperands,
     /* 408627 */     // GIR_Coverage, 2464,
     /* 408627 */     GIR_EraseRootFromParent_Done,
     /* 408628 */   // Label 7944: @408628
     /* 408628 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(408697), // Rule ID 2551 //
     /* 408633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408669 */     // MIs[2] Operand 1
     /* 408669 */     // No operand predicates
     /* 408669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408679 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 408682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408695 */     GIR_RootConstrainSelectedInstOperands,
     /* 408696 */     // GIR_Coverage, 2551,
     /* 408696 */     GIR_EraseRootFromParent_Done,
     /* 408697 */   // Label 7945: @408697
     /* 408697 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(408766), // Rule ID 6134 //
     /* 408702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408738 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408742 */     // MIs[2] Operand 1
     /* 408742 */     // No operand predicates
     /* 408742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408748 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 408751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408764 */     GIR_RootConstrainSelectedInstOperands,
     /* 408765 */     // GIR_Coverage, 6134,
     /* 408765 */     GIR_EraseRootFromParent_Done,
     /* 408766 */   // Label 7946: @408766
     /* 408766 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(408816), // Rule ID 13555 //
     /* 408771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408801 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 408804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408814 */     GIR_RootConstrainSelectedInstOperands,
     /* 408815 */     // GIR_Coverage, 13555,
     /* 408815 */     GIR_EraseRootFromParent_Done,
     /* 408816 */   // Label 7947: @408816
     /* 408816 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(408866), // Rule ID 649 //
     /* 408821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408851 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 408854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408864 */     GIR_RootConstrainSelectedInstOperands,
     /* 408865 */     // GIR_Coverage, 649,
     /* 408865 */     GIR_EraseRootFromParent_Done,
     /* 408866 */   // Label 7948: @408866
     /* 408866 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(408916), // Rule ID 661 //
     /* 408871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408901 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 408904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 408914 */     GIR_RootConstrainSelectedInstOperands,
     /* 408915 */     // GIR_Coverage, 661,
     /* 408915 */     GIR_EraseRootFromParent_Done,
     /* 408916 */   // Label 7949: @408916
     /* 408916 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(408947), // Rule ID 643 //
     /* 408921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408936 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408941 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408945 */     GIR_RootConstrainSelectedInstOperands,
     /* 408946 */     // GIR_Coverage, 643,
     /* 408946 */     GIR_Done,
     /* 408947 */   // Label 7950: @408947
     /* 408947 */   GIM_Reject,
     /* 408948 */ // Label 7920: @408948
     /* 408948 */ GIM_Reject,
     /* 408949 */ // Label 7884: @408949
     /* 408949 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(411878),
     /* 408954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 408957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 408960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 408963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408967 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(409117), // Rule ID 4945 //
     /* 408972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408996 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409021 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 409029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 409037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409044 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 409047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409056 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 409111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 409115 */     GIR_RootConstrainSelectedInstOperands,
     /* 409116 */     // GIR_Coverage, 4945,
     /* 409116 */     GIR_EraseRootFromParent_Done,
     /* 409117 */   // Label 7952: @409117
     /* 409117 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(409264), // Rule ID 4909 //
     /* 409122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409178 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409183 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 409187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409193 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 409196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409205 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409233 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 409260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409262 */     GIR_RootConstrainSelectedInstOperands,
     /* 409263 */     // GIR_Coverage, 4909,
     /* 409263 */     GIR_EraseRootFromParent_Done,
     /* 409264 */   // Label 7953: @409264
     /* 409264 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(409411), // Rule ID 14138 //
     /* 409269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409305 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409317 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409321 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409325 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409330 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 409334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409340 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 409343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409352 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409380 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 409407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409409 */     GIR_RootConstrainSelectedInstOperands,
     /* 409410 */     // GIR_Coverage, 14138,
     /* 409410 */     GIR_EraseRootFromParent_Done,
     /* 409411 */   // Label 7954: @409411
     /* 409411 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(409542), // Rule ID 6172 //
     /* 409416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409440 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409472 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409477 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 409481 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409485 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409489 */     // MIs[4] Operand 1
     /* 409489 */     // No operand predicates
     /* 409489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409493 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409495 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409507 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 409537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 409540 */     GIR_RootConstrainSelectedInstOperands,
     /* 409541 */     // GIR_Coverage, 6172,
     /* 409541 */     GIR_EraseRootFromParent_Done,
     /* 409542 */   // Label 7955: @409542
     /* 409542 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(409673), // Rule ID 6204 //
     /* 409547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409583 */     // MIs[2] Operand 1
     /* 409583 */     // No operand predicates
     /* 409583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409591 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 409595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 409599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409607 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 409611 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409616 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 409620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409626 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409638 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409671 */     GIR_RootConstrainSelectedInstOperands,
     /* 409672 */     // GIR_Coverage, 6204,
     /* 409672 */     GIR_EraseRootFromParent_Done,
     /* 409673 */   // Label 7956: @409673
     /* 409673 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(409804), // Rule ID 6268 //
     /* 409678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409714 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 409743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409747 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409751 */     // MIs[4] Operand 1
     /* 409751 */     // No operand predicates
     /* 409751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409757 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 409799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 409802 */     GIR_RootConstrainSelectedInstOperands,
     /* 409803 */     // GIR_Coverage, 6268,
     /* 409803 */     GIR_EraseRootFromParent_Done,
     /* 409804 */   // Label 7957: @409804
     /* 409804 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(409935), // Rule ID 6236 //
     /* 409809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409857 */     // MIs[3] Operand 1
     /* 409857 */     // No operand predicates
     /* 409857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 409861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409869 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 409873 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409878 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 409882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409886 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409888 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409900 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409933 */     GIR_RootConstrainSelectedInstOperands,
     /* 409934 */     // GIR_Coverage, 6236,
     /* 409934 */     GIR_EraseRootFromParent_Done,
     /* 409935 */   // Label 7958: @409935
     /* 409935 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(410070), // Rule ID 2474 //
     /* 409940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409964 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409989 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409999 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 410002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410011 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 410066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410068 */     GIR_RootConstrainSelectedInstOperands,
     /* 410069 */     // GIR_Coverage, 2474,
     /* 410069 */     GIR_EraseRootFromParent_Done,
     /* 410070 */   // Label 7959: @410070
     /* 410070 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(410189), // Rule ID 6140 //
     /* 410075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410132 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410136 */     // MIs[3] Operand 1
     /* 410136 */     // No operand predicates
     /* 410136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410142 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410187 */     GIR_RootConstrainSelectedInstOperands,
     /* 410188 */     // GIR_Coverage, 6140,
     /* 410188 */     GIR_EraseRootFromParent_Done,
     /* 410189 */   // Label 7960: @410189
     /* 410189 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(410308), // Rule ID 2557 //
     /* 410194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410230 */     // MIs[2] Operand 1
     /* 410230 */     // No operand predicates
     /* 410230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 410246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410251 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 410255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410261 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410273 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410306 */     GIR_RootConstrainSelectedInstOperands,
     /* 410307 */     // GIR_Coverage, 2557,
     /* 410307 */     GIR_EraseRootFromParent_Done,
     /* 410308 */   // Label 7961: @410308
     /* 410308 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(410408), // Rule ID 4907 //
     /* 410313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410337 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410364 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410376 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410406 */     GIR_RootConstrainSelectedInstOperands,
     /* 410407 */     // GIR_Coverage, 4907,
     /* 410407 */     GIR_EraseRootFromParent_Done,
     /* 410408 */   // Label 7962: @410408
     /* 410408 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(410508), // Rule ID 4943 //
     /* 410413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410437 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 410449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410464 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410476 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 410502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 410506 */     GIR_RootConstrainSelectedInstOperands,
     /* 410507 */     // GIR_Coverage, 4943,
     /* 410507 */     GIR_EraseRootFromParent_Done,
     /* 410508 */   // Label 7963: @410508
     /* 410508 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(410605), // Rule ID 14134 //
     /* 410513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410549 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410563 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410603 */     GIR_RootConstrainSelectedInstOperands,
     /* 410604 */     // GIR_Coverage, 14134,
     /* 410604 */     GIR_EraseRootFromParent_Done,
     /* 410605 */   // Label 7964: @410605
     /* 410605 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(410705), // Rule ID 14136 //
     /* 410610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410651 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410661 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410673 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410703 */     GIR_RootConstrainSelectedInstOperands,
     /* 410704 */     // GIR_Coverage, 14136,
     /* 410704 */     GIR_EraseRootFromParent_Done,
     /* 410705 */   // Label 7965: @410705
     /* 410705 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(410805), // Rule ID 4941 //
     /* 410710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 410746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410761 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 410803 */     GIR_RootConstrainSelectedInstOperands,
     /* 410804 */     // GIR_Coverage, 4941,
     /* 410804 */     GIR_EraseRootFromParent_Done,
     /* 410805 */   // Label 7966: @410805
     /* 410805 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(410902), // Rule ID 4905 //
     /* 410810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410860 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410872 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410900 */     GIR_RootConstrainSelectedInstOperands,
     /* 410901 */     // GIR_Coverage, 4905,
     /* 410901 */     GIR_EraseRootFromParent_Done,
     /* 410902 */   // Label 7967: @410902
     /* 410902 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(410980), // Rule ID 6290 //
     /* 410907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410948 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410952 */     // MIs[3] Operand 1
     /* 410952 */     // No operand predicates
     /* 410952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410962 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410978 */     GIR_RootConstrainSelectedInstOperands,
     /* 410979 */     // GIR_Coverage, 6290,
     /* 410979 */     GIR_EraseRootFromParent_Done,
     /* 410980 */   // Label 7968: @410980
     /* 410980 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411064), // Rule ID 6202 //
     /* 410985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411017 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411021 */     // MIs[2] Operand 1
     /* 411021 */     // No operand predicates
     /* 411021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 411033 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411044 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 411047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411062 */     GIR_RootConstrainSelectedInstOperands,
     /* 411063 */     // GIR_Coverage, 6202,
     /* 411063 */     GIR_EraseRootFromParent_Done,
     /* 411064 */   // Label 7969: @411064
     /* 411064 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411145), // Rule ID 6234 //
     /* 411069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411113 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411117 */     // MIs[3] Operand 1
     /* 411117 */     // No operand predicates
     /* 411117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411127 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 411130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411143 */     GIR_RootConstrainSelectedInstOperands,
     /* 411144 */     // GIR_Coverage, 6234,
     /* 411144 */     GIR_EraseRootFromParent_Done,
     /* 411145 */   // Label 7970: @411145
     /* 411145 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411229), // Rule ID 6266 //
     /* 411150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411203 */     // MIs[3] Operand 1
     /* 411203 */     // No operand predicates
     /* 411203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411209 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 411212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411227 */     GIR_RootConstrainSelectedInstOperands,
     /* 411228 */     // GIR_Coverage, 6266,
     /* 411228 */     GIR_EraseRootFromParent_Done,
     /* 411229 */   // Label 7971: @411229
     /* 411229 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(411307), // Rule ID 6312 //
     /* 411234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411279 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411283 */     // MIs[3] Operand 1
     /* 411283 */     // No operand predicates
     /* 411283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411289 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 411292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411305 */     GIR_RootConstrainSelectedInstOperands,
     /* 411306 */     // GIR_Coverage, 6312,
     /* 411306 */     GIR_EraseRootFromParent_Done,
     /* 411307 */   // Label 7972: @411307
     /* 411307 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(411388), // Rule ID 6170 //
     /* 411312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411364 */     // MIs[3] Operand 1
     /* 411364 */     // No operand predicates
     /* 411364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411370 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 411373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411386 */     GIR_RootConstrainSelectedInstOperands,
     /* 411387 */     // GIR_Coverage, 6170,
     /* 411387 */     GIR_EraseRootFromParent_Done,
     /* 411388 */   // Label 7973: @411388
     /* 411388 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(411473), // Rule ID 2472 //
     /* 411393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 411421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411431 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 411434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 411438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 411449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 411469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411471 */     GIR_RootConstrainSelectedInstOperands,
     /* 411472 */     // GIR_Coverage, 2472,
     /* 411472 */     GIR_EraseRootFromParent_Done,
     /* 411473 */   // Label 7974: @411473
     /* 411473 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(411558), // Rule ID 2470 //
     /* 411478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411506 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 411510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411516 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 411516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 411519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 411523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411528 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 411534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411556 */     GIR_RootConstrainSelectedInstOperands,
     /* 411557 */     // GIR_Coverage, 2470,
     /* 411557 */     GIR_EraseRootFromParent_Done,
     /* 411558 */   // Label 7975: @411558
     /* 411558 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(411627), // Rule ID 2555 //
     /* 411563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411599 */     // MIs[2] Operand 1
     /* 411599 */     // No operand predicates
     /* 411599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411609 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 411612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411625 */     GIR_RootConstrainSelectedInstOperands,
     /* 411626 */     // GIR_Coverage, 2555,
     /* 411626 */     GIR_EraseRootFromParent_Done,
     /* 411627 */   // Label 7976: @411627
     /* 411627 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(411696), // Rule ID 6138 //
     /* 411632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411672 */     // MIs[2] Operand 1
     /* 411672 */     // No operand predicates
     /* 411672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411678 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 411681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411694 */     GIR_RootConstrainSelectedInstOperands,
     /* 411695 */     // GIR_Coverage, 6138,
     /* 411695 */     GIR_EraseRootFromParent_Done,
     /* 411696 */   // Label 7977: @411696
     /* 411696 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(411746), // Rule ID 13557 //
     /* 411701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411731 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 411734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411744 */     GIR_RootConstrainSelectedInstOperands,
     /* 411745 */     // GIR_Coverage, 13557,
     /* 411745 */     GIR_EraseRootFromParent_Done,
     /* 411746 */   // Label 7978: @411746
     /* 411746 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(411796), // Rule ID 651 //
     /* 411751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411781 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 411784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411794 */     GIR_RootConstrainSelectedInstOperands,
     /* 411795 */     // GIR_Coverage, 651,
     /* 411795 */     GIR_EraseRootFromParent_Done,
     /* 411796 */   // Label 7979: @411796
     /* 411796 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(411846), // Rule ID 663 //
     /* 411801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 411816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411831 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 411834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 411840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 411844 */     GIR_RootConstrainSelectedInstOperands,
     /* 411845 */     // GIR_Coverage, 663,
     /* 411845 */     GIR_EraseRootFromParent_Done,
     /* 411846 */   // Label 7980: @411846
     /* 411846 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(411877), // Rule ID 645 //
     /* 411851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411866 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411871 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 411875 */     GIR_RootConstrainSelectedInstOperands,
     /* 411876 */     // GIR_Coverage, 645,
     /* 411876 */     GIR_Done,
     /* 411877 */   // Label 7981: @411877
     /* 411877 */   GIM_Reject,
     /* 411878 */ // Label 7951: @411878
     /* 411878 */ GIM_Reject,
     /* 411879 */ // Label 7885: @411879
     /* 411879 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(413399),
     /* 411884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 411893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411897 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(411975), // Rule ID 6270 //
     /* 411902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411943 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411947 */     // MIs[3] Operand 1
     /* 411947 */     // No operand predicates
     /* 411947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411957 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411973 */     GIR_RootConstrainSelectedInstOperands,
     /* 411974 */     // GIR_Coverage, 6270,
     /* 411974 */     GIR_EraseRootFromParent_Done,
     /* 411975 */   // Label 7983: @411975
     /* 411975 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412059), // Rule ID 6186 //
     /* 411980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412016 */     // MIs[2] Operand 1
     /* 412016 */     // No operand predicates
     /* 412016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 412020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412039 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 412050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412057 */     GIR_RootConstrainSelectedInstOperands,
     /* 412058 */     // GIR_Coverage, 6186,
     /* 412058 */     GIR_EraseRootFromParent_Done,
     /* 412059 */   // Label 7984: @412059
     /* 412059 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412140), // Rule ID 6218 //
     /* 412064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412108 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412112 */     // MIs[3] Operand 1
     /* 412112 */     // No operand predicates
     /* 412112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412122 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412138 */     GIR_RootConstrainSelectedInstOperands,
     /* 412139 */     // GIR_Coverage, 6218,
     /* 412139 */     GIR_EraseRootFromParent_Done,
     /* 412140 */   // Label 7985: @412140
     /* 412140 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412224), // Rule ID 6250 //
     /* 412145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412194 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412198 */     // MIs[3] Operand 1
     /* 412198 */     // No operand predicates
     /* 412198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412204 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412222 */     GIR_RootConstrainSelectedInstOperands,
     /* 412223 */     // GIR_Coverage, 6250,
     /* 412223 */     GIR_EraseRootFromParent_Done,
     /* 412224 */   // Label 7986: @412224
     /* 412224 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412302), // Rule ID 6292 //
     /* 412229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 412270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412274 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412278 */     // MIs[3] Operand 1
     /* 412278 */     // No operand predicates
     /* 412278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412284 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412300 */     GIR_RootConstrainSelectedInstOperands,
     /* 412301 */     // GIR_Coverage, 6292,
     /* 412301 */     GIR_EraseRootFromParent_Done,
     /* 412302 */   // Label 7987: @412302
     /* 412302 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(412383), // Rule ID 6154 //
     /* 412307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412355 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412359 */     // MIs[3] Operand 1
     /* 412359 */     // No operand predicates
     /* 412359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412365 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412381 */     GIR_RootConstrainSelectedInstOperands,
     /* 412382 */     // GIR_Coverage, 6154,
     /* 412382 */     GIR_EraseRootFromParent_Done,
     /* 412383 */   // Label 7988: @412383
     /* 412383 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(412452), // Rule ID 2539 //
     /* 412388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412424 */     // MIs[2] Operand 1
     /* 412424 */     // No operand predicates
     /* 412424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412434 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412450 */     GIR_RootConstrainSelectedInstOperands,
     /* 412451 */     // GIR_Coverage, 2539,
     /* 412451 */     GIR_EraseRootFromParent_Done,
     /* 412452 */   // Label 7989: @412452
     /* 412452 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(412521), // Rule ID 6122 //
     /* 412457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412497 */     // MIs[2] Operand 1
     /* 412497 */     // No operand predicates
     /* 412497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412503 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412519 */     GIR_RootConstrainSelectedInstOperands,
     /* 412520 */     // GIR_Coverage, 6122,
     /* 412520 */     GIR_EraseRootFromParent_Done,
     /* 412521 */   // Label 7990: @412521
     /* 412521 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(412614), // Rule ID 6274 //
     /* 412526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412565 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412612 */     GIR_RootConstrainSelectedInstOperands,
     /* 412613 */     // GIR_Coverage, 6274,
     /* 412613 */     GIR_EraseRootFromParent_Done,
     /* 412614 */   // Label 7991: @412614
     /* 412614 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(412713), // Rule ID 6188 //
     /* 412619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412662 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412711 */     GIR_RootConstrainSelectedInstOperands,
     /* 412712 */     // GIR_Coverage, 6188,
     /* 412712 */     GIR_EraseRootFromParent_Done,
     /* 412713 */   // Label 7992: @412713
     /* 412713 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(412809), // Rule ID 6220 //
     /* 412718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412760 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412807 */     GIR_RootConstrainSelectedInstOperands,
     /* 412808 */     // GIR_Coverage, 6220,
     /* 412808 */     GIR_EraseRootFromParent_Done,
     /* 412809 */   // Label 7993: @412809
     /* 412809 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(412908), // Rule ID 6252 //
     /* 412814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412857 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412906 */     GIR_RootConstrainSelectedInstOperands,
     /* 412907 */     // GIR_Coverage, 6252,
     /* 412907 */     GIR_EraseRootFromParent_Done,
     /* 412908 */   // Label 7994: @412908
     /* 412908 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413001), // Rule ID 6296 //
     /* 412913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412952 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412999 */     GIR_RootConstrainSelectedInstOperands,
     /* 413000 */     // GIR_Coverage, 6296,
     /* 413000 */     GIR_EraseRootFromParent_Done,
     /* 413001 */   // Label 7995: @413001
     /* 413001 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413097), // Rule ID 6156 //
     /* 413006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413048 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 413083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413095 */     GIR_RootConstrainSelectedInstOperands,
     /* 413096 */     // GIR_Coverage, 6156,
     /* 413096 */     GIR_EraseRootFromParent_Done,
     /* 413097 */   // Label 7996: @413097
     /* 413097 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413181), // Rule ID 2541 //
     /* 413102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413132 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413151 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 413167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413179 */     GIR_RootConstrainSelectedInstOperands,
     /* 413180 */     // GIR_Coverage, 2541,
     /* 413180 */     GIR_EraseRootFromParent_Done,
     /* 413181 */   // Label 7997: @413181
     /* 413181 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(413231), // Rule ID 13587 //
     /* 413186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413216 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 413219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413229 */     GIR_RootConstrainSelectedInstOperands,
     /* 413230 */     // GIR_Coverage, 13587,
     /* 413230 */     GIR_EraseRootFromParent_Done,
     /* 413231 */   // Label 7998: @413231
     /* 413231 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(413315), // Rule ID 6124 //
     /* 413236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413266 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413285 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 413301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413313 */     GIR_RootConstrainSelectedInstOperands,
     /* 413314 */     // GIR_Coverage, 6124,
     /* 413314 */     GIR_EraseRootFromParent_Done,
     /* 413315 */   // Label 7999: @413315
     /* 413315 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(413365), // Rule ID 1311 //
     /* 413320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413350 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 413353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413363 */     GIR_RootConstrainSelectedInstOperands,
     /* 413364 */     // GIR_Coverage, 1311,
     /* 413364 */     GIR_EraseRootFromParent_Done,
     /* 413365 */   // Label 8000: @413365
     /* 413365 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(413398), // Rule ID 1301 //
     /* 413370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413385 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 413388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413396 */     GIR_RootConstrainSelectedInstOperands,
     /* 413397 */     // GIR_Coverage, 1301,
     /* 413397 */     GIR_EraseRootFromParent_Done,
     /* 413398 */   // Label 8001: @413398
     /* 413398 */   GIM_Reject,
     /* 413399 */ // Label 7982: @413399
     /* 413399 */ GIM_Reject,
     /* 413400 */ // Label 7886: @413400
     /* 413400 */ GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414920),
     /* 413405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 413414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413418 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(413496), // Rule ID 6282 //
     /* 413423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413464 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413468 */     // MIs[3] Operand 1
     /* 413468 */     // No operand predicates
     /* 413468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413478 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413494 */     GIR_RootConstrainSelectedInstOperands,
     /* 413495 */     // GIR_Coverage, 6282,
     /* 413495 */     GIR_EraseRootFromParent_Done,
     /* 413496 */   // Label 8003: @413496
     /* 413496 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(413580), // Rule ID 6194 //
     /* 413501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413537 */     // MIs[2] Operand 1
     /* 413537 */     // No operand predicates
     /* 413537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413560 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413578 */     GIR_RootConstrainSelectedInstOperands,
     /* 413579 */     // GIR_Coverage, 6194,
     /* 413579 */     GIR_EraseRootFromParent_Done,
     /* 413580 */   // Label 8004: @413580
     /* 413580 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(413661), // Rule ID 6226 //
     /* 413585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413629 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413633 */     // MIs[3] Operand 1
     /* 413633 */     // No operand predicates
     /* 413633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413643 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413659 */     GIR_RootConstrainSelectedInstOperands,
     /* 413660 */     // GIR_Coverage, 6226,
     /* 413660 */     GIR_EraseRootFromParent_Done,
     /* 413661 */   // Label 8005: @413661
     /* 413661 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(413745), // Rule ID 6258 //
     /* 413666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413715 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413719 */     // MIs[3] Operand 1
     /* 413719 */     // No operand predicates
     /* 413719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413725 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413743 */     GIR_RootConstrainSelectedInstOperands,
     /* 413744 */     // GIR_Coverage, 6258,
     /* 413744 */     GIR_EraseRootFromParent_Done,
     /* 413745 */   // Label 8006: @413745
     /* 413745 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(413823), // Rule ID 6304 //
     /* 413750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413795 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413799 */     // MIs[3] Operand 1
     /* 413799 */     // No operand predicates
     /* 413799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413805 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413821 */     GIR_RootConstrainSelectedInstOperands,
     /* 413822 */     // GIR_Coverage, 6304,
     /* 413822 */     GIR_EraseRootFromParent_Done,
     /* 413823 */   // Label 8007: @413823
     /* 413823 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(413904), // Rule ID 6162 //
     /* 413828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413880 */     // MIs[3] Operand 1
     /* 413880 */     // No operand predicates
     /* 413880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413886 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413902 */     GIR_RootConstrainSelectedInstOperands,
     /* 413903 */     // GIR_Coverage, 6162,
     /* 413903 */     GIR_EraseRootFromParent_Done,
     /* 413904 */   // Label 8008: @413904
     /* 413904 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(413973), // Rule ID 2547 //
     /* 413909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413941 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413945 */     // MIs[2] Operand 1
     /* 413945 */     // No operand predicates
     /* 413945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413955 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413971 */     GIR_RootConstrainSelectedInstOperands,
     /* 413972 */     // GIR_Coverage, 2547,
     /* 413972 */     GIR_EraseRootFromParent_Done,
     /* 413973 */   // Label 8009: @413973
     /* 413973 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414042), // Rule ID 6130 //
     /* 413978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 414018 */     // MIs[2] Operand 1
     /* 414018 */     // No operand predicates
     /* 414018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414024 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 414027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414040 */     GIR_RootConstrainSelectedInstOperands,
     /* 414041 */     // GIR_Coverage, 6130,
     /* 414041 */     GIR_EraseRootFromParent_Done,
     /* 414042 */   // Label 8010: @414042
     /* 414042 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414135), // Rule ID 6284 //
     /* 414047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414086 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414105 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414133 */     GIR_RootConstrainSelectedInstOperands,
     /* 414134 */     // GIR_Coverage, 6284,
     /* 414134 */     GIR_EraseRootFromParent_Done,
     /* 414135 */   // Label 8011: @414135
     /* 414135 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(414234), // Rule ID 6196 //
     /* 414140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414183 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 414226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414232 */     GIR_RootConstrainSelectedInstOperands,
     /* 414233 */     // GIR_Coverage, 6196,
     /* 414233 */     GIR_EraseRootFromParent_Done,
     /* 414234 */   // Label 8012: @414234
     /* 414234 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(414330), // Rule ID 6228 //
     /* 414239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414281 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414328 */     GIR_RootConstrainSelectedInstOperands,
     /* 414329 */     // GIR_Coverage, 6228,
     /* 414329 */     GIR_EraseRootFromParent_Done,
     /* 414330 */   // Label 8013: @414330
     /* 414330 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(414429), // Rule ID 6260 //
     /* 414335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414378 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414427 */     GIR_RootConstrainSelectedInstOperands,
     /* 414428 */     // GIR_Coverage, 6260,
     /* 414428 */     GIR_EraseRootFromParent_Done,
     /* 414429 */   // Label 8014: @414429
     /* 414429 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(414522), // Rule ID 6306 //
     /* 414434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414473 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414485 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414520 */     GIR_RootConstrainSelectedInstOperands,
     /* 414521 */     // GIR_Coverage, 6306,
     /* 414521 */     GIR_EraseRootFromParent_Done,
     /* 414522 */   // Label 8015: @414522
     /* 414522 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(414618), // Rule ID 6164 //
     /* 414527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414569 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414616 */     GIR_RootConstrainSelectedInstOperands,
     /* 414617 */     // GIR_Coverage, 6164,
     /* 414617 */     GIR_EraseRootFromParent_Done,
     /* 414618 */   // Label 8016: @414618
     /* 414618 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(414702), // Rule ID 2549 //
     /* 414623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414653 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 414688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414700 */     GIR_RootConstrainSelectedInstOperands,
     /* 414701 */     // GIR_Coverage, 2549,
     /* 414701 */     GIR_EraseRootFromParent_Done,
     /* 414702 */   // Label 8017: @414702
     /* 414702 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(414752), // Rule ID 13591 //
     /* 414707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414737 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 414740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414750 */     GIR_RootConstrainSelectedInstOperands,
     /* 414751 */     // GIR_Coverage, 13591,
     /* 414751 */     GIR_EraseRootFromParent_Done,
     /* 414752 */   // Label 8018: @414752
     /* 414752 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(414836), // Rule ID 6132 //
     /* 414757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414787 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 414822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414834 */     GIR_RootConstrainSelectedInstOperands,
     /* 414835 */     // GIR_Coverage, 6132,
     /* 414835 */     GIR_EraseRootFromParent_Done,
     /* 414836 */   // Label 8019: @414836
     /* 414836 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(414886), // Rule ID 1315 //
     /* 414841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414871 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 414874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414884 */     GIR_RootConstrainSelectedInstOperands,
     /* 414885 */     // GIR_Coverage, 1315,
     /* 414885 */     GIR_EraseRootFromParent_Done,
     /* 414886 */   // Label 8020: @414886
     /* 414886 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(414919), // Rule ID 1305 //
     /* 414891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414906 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 414909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414917 */     GIR_RootConstrainSelectedInstOperands,
     /* 414918 */     // GIR_Coverage, 1305,
     /* 414918 */     GIR_EraseRootFromParent_Done,
     /* 414919 */   // Label 8021: @414919
     /* 414919 */   GIM_Reject,
     /* 414920 */ // Label 8002: @414920
     /* 414920 */ GIM_Reject,
     /* 414921 */ // Label 7887: @414921
     /* 414921 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(416099),
     /* 414926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 414935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414939 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415023), // Rule ID 6178 //
     /* 414944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414980 */     // MIs[2] Operand 1
     /* 414980 */     // No operand predicates
     /* 414980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414992 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415003 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 415014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415021 */     GIR_RootConstrainSelectedInstOperands,
     /* 415022 */     // GIR_Coverage, 6178,
     /* 415022 */     GIR_EraseRootFromParent_Done,
     /* 415023 */   // Label 8023: @415023
     /* 415023 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(415104), // Rule ID 6210 //
     /* 415028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415076 */     // MIs[3] Operand 1
     /* 415076 */     // No operand predicates
     /* 415076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415086 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415102 */     GIR_RootConstrainSelectedInstOperands,
     /* 415103 */     // GIR_Coverage, 6210,
     /* 415103 */     GIR_EraseRootFromParent_Done,
     /* 415104 */   // Label 8024: @415104
     /* 415104 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(415188), // Rule ID 6242 //
     /* 415109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415158 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415162 */     // MIs[3] Operand 1
     /* 415162 */     // No operand predicates
     /* 415162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415168 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415186 */     GIR_RootConstrainSelectedInstOperands,
     /* 415187 */     // GIR_Coverage, 6242,
     /* 415187 */     GIR_EraseRootFromParent_Done,
     /* 415188 */   // Label 8025: @415188
     /* 415188 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(415269), // Rule ID 6146 //
     /* 415193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415245 */     // MIs[3] Operand 1
     /* 415245 */     // No operand predicates
     /* 415245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415251 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415267 */     GIR_RootConstrainSelectedInstOperands,
     /* 415268 */     // GIR_Coverage, 6146,
     /* 415268 */     GIR_EraseRootFromParent_Done,
     /* 415269 */   // Label 8026: @415269
     /* 415269 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(415338), // Rule ID 2531 //
     /* 415274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415310 */     // MIs[2] Operand 1
     /* 415310 */     // No operand predicates
     /* 415310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415320 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415336 */     GIR_RootConstrainSelectedInstOperands,
     /* 415337 */     // GIR_Coverage, 2531,
     /* 415337 */     GIR_EraseRootFromParent_Done,
     /* 415338 */   // Label 8027: @415338
     /* 415338 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(415407), // Rule ID 6114 //
     /* 415343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415383 */     // MIs[2] Operand 1
     /* 415383 */     // No operand predicates
     /* 415383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415389 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415405 */     GIR_RootConstrainSelectedInstOperands,
     /* 415406 */     // GIR_Coverage, 6114,
     /* 415406 */     GIR_EraseRootFromParent_Done,
     /* 415407 */   // Label 8028: @415407
     /* 415407 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(415506), // Rule ID 6180 //
     /* 415412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415455 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415504 */     GIR_RootConstrainSelectedInstOperands,
     /* 415505 */     // GIR_Coverage, 6180,
     /* 415505 */     GIR_EraseRootFromParent_Done,
     /* 415506 */   // Label 8029: @415506
     /* 415506 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(415602), // Rule ID 6212 //
     /* 415511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415553 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415572 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415600 */     GIR_RootConstrainSelectedInstOperands,
     /* 415601 */     // GIR_Coverage, 6212,
     /* 415601 */     GIR_EraseRootFromParent_Done,
     /* 415602 */   // Label 8030: @415602
     /* 415602 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(415701), // Rule ID 6244 //
     /* 415607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415650 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415662 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415669 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415699 */     GIR_RootConstrainSelectedInstOperands,
     /* 415700 */     // GIR_Coverage, 6244,
     /* 415700 */     GIR_EraseRootFromParent_Done,
     /* 415701 */   // Label 8031: @415701
     /* 415701 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(415797), // Rule ID 6148 //
     /* 415706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415748 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415767 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415795 */     GIR_RootConstrainSelectedInstOperands,
     /* 415796 */     // GIR_Coverage, 6148,
     /* 415796 */     GIR_EraseRootFromParent_Done,
     /* 415797 */   // Label 8032: @415797
     /* 415797 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(415881), // Rule ID 2533 //
     /* 415802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415832 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415879 */     GIR_RootConstrainSelectedInstOperands,
     /* 415880 */     // GIR_Coverage, 2533,
     /* 415880 */     GIR_EraseRootFromParent_Done,
     /* 415881 */   // Label 8033: @415881
     /* 415881 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(415931), // Rule ID 13583 //
     /* 415886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415916 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 415919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415929 */     GIR_RootConstrainSelectedInstOperands,
     /* 415930 */     // GIR_Coverage, 13583,
     /* 415930 */     GIR_EraseRootFromParent_Done,
     /* 415931 */   // Label 8034: @415931
     /* 415931 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(416015), // Rule ID 6116 //
     /* 415936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415966 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 416001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416013 */     GIR_RootConstrainSelectedInstOperands,
     /* 416014 */     // GIR_Coverage, 6116,
     /* 416014 */     GIR_EraseRootFromParent_Done,
     /* 416015 */   // Label 8035: @416015
     /* 416015 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(416065), // Rule ID 1307 //
     /* 416020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416050 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 416050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 416053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416063 */     GIR_RootConstrainSelectedInstOperands,
     /* 416064 */     // GIR_Coverage, 1307,
     /* 416064 */     GIR_EraseRootFromParent_Done,
     /* 416065 */   // Label 8036: @416065
     /* 416065 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(416098), // Rule ID 1297 //
     /* 416070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416085 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 416085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 416088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 416096 */     GIR_RootConstrainSelectedInstOperands,
     /* 416097 */     // GIR_Coverage, 1297,
     /* 416097 */     GIR_EraseRootFromParent_Done,
     /* 416098 */   // Label 8037: @416098
     /* 416098 */   GIM_Reject,
     /* 416099 */ // Label 8022: @416099
     /* 416099 */ GIM_Reject,
     /* 416100 */ // Label 7888: @416100
     /* 416100 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(417620),
     /* 416105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 416111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 416114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416118 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(416196), // Rule ID 6276 //
     /* 416123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 416160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416164 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416168 */     // MIs[3] Operand 1
     /* 416168 */     // No operand predicates
     /* 416168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416178 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416194 */     GIR_RootConstrainSelectedInstOperands,
     /* 416195 */     // GIR_Coverage, 6276,
     /* 416195 */     GIR_EraseRootFromParent_Done,
     /* 416196 */   // Label 8039: @416196
     /* 416196 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(416280), // Rule ID 6190 //
     /* 416201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416237 */     // MIs[2] Operand 1
     /* 416237 */     // No operand predicates
     /* 416237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 416241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416249 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416260 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 416271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416278 */     GIR_RootConstrainSelectedInstOperands,
     /* 416279 */     // GIR_Coverage, 6190,
     /* 416279 */     GIR_EraseRootFromParent_Done,
     /* 416280 */   // Label 8040: @416280
     /* 416280 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(416361), // Rule ID 6222 //
     /* 416285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416329 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416333 */     // MIs[3] Operand 1
     /* 416333 */     // No operand predicates
     /* 416333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416343 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416359 */     GIR_RootConstrainSelectedInstOperands,
     /* 416360 */     // GIR_Coverage, 6222,
     /* 416360 */     GIR_EraseRootFromParent_Done,
     /* 416361 */   // Label 8041: @416361
     /* 416361 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(416445), // Rule ID 6254 //
     /* 416366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416415 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416419 */     // MIs[3] Operand 1
     /* 416419 */     // No operand predicates
     /* 416419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416425 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416443 */     GIR_RootConstrainSelectedInstOperands,
     /* 416444 */     // GIR_Coverage, 6254,
     /* 416444 */     GIR_EraseRootFromParent_Done,
     /* 416445 */   // Label 8042: @416445
     /* 416445 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(416523), // Rule ID 6298 //
     /* 416450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 416491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416499 */     // MIs[3] Operand 1
     /* 416499 */     // No operand predicates
     /* 416499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416505 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416521 */     GIR_RootConstrainSelectedInstOperands,
     /* 416522 */     // GIR_Coverage, 6298,
     /* 416522 */     GIR_EraseRootFromParent_Done,
     /* 416523 */   // Label 8043: @416523
     /* 416523 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(416604), // Rule ID 6158 //
     /* 416528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416576 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416580 */     // MIs[3] Operand 1
     /* 416580 */     // No operand predicates
     /* 416580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416586 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416602 */     GIR_RootConstrainSelectedInstOperands,
     /* 416603 */     // GIR_Coverage, 6158,
     /* 416603 */     GIR_EraseRootFromParent_Done,
     /* 416604 */   // Label 8044: @416604
     /* 416604 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(416673), // Rule ID 2543 //
     /* 416609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416645 */     // MIs[2] Operand 1
     /* 416645 */     // No operand predicates
     /* 416645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416655 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416671 */     GIR_RootConstrainSelectedInstOperands,
     /* 416672 */     // GIR_Coverage, 2543,
     /* 416672 */     GIR_EraseRootFromParent_Done,
     /* 416673 */   // Label 8045: @416673
     /* 416673 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(416742), // Rule ID 6126 //
     /* 416678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416718 */     // MIs[2] Operand 1
     /* 416718 */     // No operand predicates
     /* 416718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416724 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416740 */     GIR_RootConstrainSelectedInstOperands,
     /* 416741 */     // GIR_Coverage, 6126,
     /* 416741 */     GIR_EraseRootFromParent_Done,
     /* 416742 */   // Label 8046: @416742
     /* 416742 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(416835), // Rule ID 6280 //
     /* 416747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416786 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416805 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416833 */     GIR_RootConstrainSelectedInstOperands,
     /* 416834 */     // GIR_Coverage, 6280,
     /* 416834 */     GIR_EraseRootFromParent_Done,
     /* 416835 */   // Label 8047: @416835
     /* 416835 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(416934), // Rule ID 6192 //
     /* 416840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416883 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 416926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416932 */     GIR_RootConstrainSelectedInstOperands,
     /* 416933 */     // GIR_Coverage, 6192,
     /* 416933 */     GIR_EraseRootFromParent_Done,
     /* 416934 */   // Label 8048: @416934
     /* 416934 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(417030), // Rule ID 6224 //
     /* 416939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416981 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417000 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 417016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417028 */     GIR_RootConstrainSelectedInstOperands,
     /* 417029 */     // GIR_Coverage, 6224,
     /* 417029 */     GIR_EraseRootFromParent_Done,
     /* 417030 */   // Label 8049: @417030
     /* 417030 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(417129), // Rule ID 6256 //
     /* 417035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 417063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 417067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417078 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 417113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417127 */     GIR_RootConstrainSelectedInstOperands,
     /* 417128 */     // GIR_Coverage, 6256,
     /* 417128 */     GIR_EraseRootFromParent_Done,
     /* 417129 */   // Label 8050: @417129
     /* 417129 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(417222), // Rule ID 6302 //
     /* 417134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 417150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 417162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417173 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 417208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417220 */     GIR_RootConstrainSelectedInstOperands,
     /* 417221 */     // GIR_Coverage, 6302,
     /* 417221 */     GIR_EraseRootFromParent_Done,
     /* 417222 */   // Label 8051: @417222
     /* 417222 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(417318), // Rule ID 6160 //
     /* 417227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 417254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 417258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417269 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 417304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417316 */     GIR_RootConstrainSelectedInstOperands,
     /* 417317 */     // GIR_Coverage, 6160,
     /* 417317 */     GIR_EraseRootFromParent_Done,
     /* 417318 */   // Label 8052: @417318
     /* 417318 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(417402), // Rule ID 2545 //
     /* 417323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 417338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417353 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 417388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417400 */     GIR_RootConstrainSelectedInstOperands,
     /* 417401 */     // GIR_Coverage, 2545,
     /* 417401 */     GIR_EraseRootFromParent_Done,
     /* 417402 */   // Label 8053: @417402
     /* 417402 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(417452), // Rule ID 13589 //
     /* 417407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417437 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 417440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417450 */     GIR_RootConstrainSelectedInstOperands,
     /* 417451 */     // GIR_Coverage, 13589,
     /* 417451 */     GIR_EraseRootFromParent_Done,
     /* 417452 */   // Label 8054: @417452
     /* 417452 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(417536), // Rule ID 6128 //
     /* 417457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 417476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417487 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 417522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417534 */     GIR_RootConstrainSelectedInstOperands,
     /* 417535 */     // GIR_Coverage, 6128,
     /* 417535 */     GIR_EraseRootFromParent_Done,
     /* 417536 */   // Label 8055: @417536
     /* 417536 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(417586), // Rule ID 1313 //
     /* 417541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417571 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 417574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417584 */     GIR_RootConstrainSelectedInstOperands,
     /* 417585 */     // GIR_Coverage, 1313,
     /* 417585 */     GIR_EraseRootFromParent_Done,
     /* 417586 */   // Label 8056: @417586
     /* 417586 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(417619), // Rule ID 1303 //
     /* 417591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417606 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 417609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 417617 */     GIR_RootConstrainSelectedInstOperands,
     /* 417618 */     // GIR_Coverage, 1303,
     /* 417618 */     GIR_EraseRootFromParent_Done,
     /* 417619 */   // Label 8057: @417619
     /* 417619 */   GIM_Reject,
     /* 417620 */ // Label 8038: @417620
     /* 417620 */ GIM_Reject,
     /* 417621 */ // Label 7889: @417621
     /* 417621 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(418799),
     /* 417626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 417635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417639 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(417723), // Rule ID 6174 //
     /* 417644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 417663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 417672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417680 */     // MIs[2] Operand 1
     /* 417680 */     // No operand predicates
     /* 417680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 417684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417692 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417703 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 417714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 417721 */     GIR_RootConstrainSelectedInstOperands,
     /* 417722 */     // GIR_Coverage, 6174,
     /* 417722 */     GIR_EraseRootFromParent_Done,
     /* 417723 */   // Label 8059: @417723
     /* 417723 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(417804), // Rule ID 6206 //
     /* 417728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417772 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417776 */     // MIs[3] Operand 1
     /* 417776 */     // No operand predicates
     /* 417776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417786 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417802 */     GIR_RootConstrainSelectedInstOperands,
     /* 417803 */     // GIR_Coverage, 6206,
     /* 417803 */     GIR_EraseRootFromParent_Done,
     /* 417804 */   // Label 8060: @417804
     /* 417804 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(417888), // Rule ID 6238 //
     /* 417809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417858 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417862 */     // MIs[3] Operand 1
     /* 417862 */     // No operand predicates
     /* 417862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417868 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417886 */     GIR_RootConstrainSelectedInstOperands,
     /* 417887 */     // GIR_Coverage, 6238,
     /* 417887 */     GIR_EraseRootFromParent_Done,
     /* 417888 */   // Label 8061: @417888
     /* 417888 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(417969), // Rule ID 6142 //
     /* 417893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417945 */     // MIs[3] Operand 1
     /* 417945 */     // No operand predicates
     /* 417945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417951 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417967 */     GIR_RootConstrainSelectedInstOperands,
     /* 417968 */     // GIR_Coverage, 6142,
     /* 417968 */     GIR_EraseRootFromParent_Done,
     /* 417969 */   // Label 8062: @417969
     /* 417969 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(418038), // Rule ID 2527 //
     /* 417974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 417993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 418002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 418006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 418010 */     // MIs[2] Operand 1
     /* 418010 */     // No operand predicates
     /* 418010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418020 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 418020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 418036 */     GIR_RootConstrainSelectedInstOperands,
     /* 418037 */     // GIR_Coverage, 2527,
     /* 418037 */     GIR_EraseRootFromParent_Done,
     /* 418038 */   // Label 8063: @418038
     /* 418038 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(418107), // Rule ID 6110 //
     /* 418043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 418058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 418066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 418071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 418075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 418079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 418083 */     // MIs[2] Operand 1
     /* 418083 */     // No operand predicates
     /* 418083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418089 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 418089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 418105 */     GIR_RootConstrainSelectedInstOperands,
     /* 418106 */     // GIR_Coverage, 6110,
     /* 418106 */     GIR_EraseRootFromParent_Done,
     /* 418107 */   // Label 8064: @418107
     /* 418107 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(418206), // Rule ID 6176 //
     /* 418112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 418123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418155 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418167 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 418198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418204 */     GIR_RootConstrainSelectedInstOperands,
     /* 418205 */     // GIR_Coverage, 6176,
     /* 418205 */     GIR_EraseRootFromParent_Done,
     /* 418206 */   // Label 8065: @418206
     /* 418206 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(418302), // Rule ID 6208 //
     /* 418211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 418230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 418234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418253 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 418272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418300 */     GIR_RootConstrainSelectedInstOperands,
     /* 418301 */     // GIR_Coverage, 6208,
     /* 418301 */     GIR_EraseRootFromParent_Done,
     /* 418302 */   // Label 8066: @418302
     /* 418302 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(418401), // Rule ID 6240 //
     /* 418307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 418335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418350 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 418369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418399 */     GIR_RootConstrainSelectedInstOperands,
     /* 418400 */     // GIR_Coverage, 6240,
     /* 418400 */     GIR_EraseRootFromParent_Done,
     /* 418401 */   // Label 8067: @418401
     /* 418401 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(418497), // Rule ID 6144 //
     /* 418406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 418429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 418433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418448 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 418467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418495 */     GIR_RootConstrainSelectedInstOperands,
     /* 418496 */     // GIR_Coverage, 6144,
     /* 418496 */     GIR_EraseRootFromParent_Done,
     /* 418497 */   // Label 8068: @418497
     /* 418497 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(418581), // Rule ID 2529 //
     /* 418502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 418513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418532 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418579 */     GIR_RootConstrainSelectedInstOperands,
     /* 418580 */     // GIR_Coverage, 2529,
     /* 418580 */     GIR_EraseRootFromParent_Done,
     /* 418581 */   // Label 8069: @418581
     /* 418581 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(418631), // Rule ID 13585 //
     /* 418586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418616 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 418619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418629 */     GIR_RootConstrainSelectedInstOperands,
     /* 418630 */     // GIR_Coverage, 13585,
     /* 418630 */     GIR_EraseRootFromParent_Done,
     /* 418631 */   // Label 8070: @418631
     /* 418631 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(418715), // Rule ID 6112 //
     /* 418636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 418651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418666 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418713 */     GIR_RootConstrainSelectedInstOperands,
     /* 418714 */     // GIR_Coverage, 6112,
     /* 418714 */     GIR_EraseRootFromParent_Done,
     /* 418715 */   // Label 8071: @418715
     /* 418715 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(418765), // Rule ID 1309 //
     /* 418720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418750 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 418753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418763 */     GIR_RootConstrainSelectedInstOperands,
     /* 418764 */     // GIR_Coverage, 1309,
     /* 418764 */     GIR_EraseRootFromParent_Done,
     /* 418765 */   // Label 8072: @418765
     /* 418765 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(418798), // Rule ID 1299 //
     /* 418770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418785 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 418788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 418796 */     GIR_RootConstrainSelectedInstOperands,
     /* 418797 */     // GIR_Coverage, 1299,
     /* 418797 */     GIR_EraseRootFromParent_Done,
     /* 418798 */   // Label 8073: @418798
     /* 418798 */   GIM_Reject,
     /* 418799 */ // Label 8058: @418799
     /* 418799 */ GIM_Reject,
     /* 418800 */ // Label 7890: @418800
     /* 418800 */ GIM_Reject,
     /* 418801 */ // Label 109: @418801
     /* 418801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8082*/ GIMT_Encode4(419100),
     /* 418812 */ /*GILLT_s16*//*Label 8074*/ GIMT_Encode4(418852),
     /* 418816 */ /*GILLT_s32*//*Label 8075*/ GIMT_Encode4(418883),
     /* 418820 */ /*GILLT_s64*//*Label 8076*/ GIMT_Encode4(418914), GIMT_Encode4(0),
     /* 418828 */ /*GILLT_v2s32*//*Label 8077*/ GIMT_Encode4(418945),
     /* 418832 */ /*GILLT_v2s64*//*Label 8078*/ GIMT_Encode4(418976),
     /* 418836 */ /*GILLT_v4s16*//*Label 8079*/ GIMT_Encode4(419007),
     /* 418840 */ /*GILLT_v4s32*//*Label 8080*/ GIMT_Encode4(419038), GIMT_Encode4(0),
     /* 418848 */ /*GILLT_v8s16*//*Label 8081*/ GIMT_Encode4(419069),
     /* 418852 */ // Label 8074: @418852
     /* 418852 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(418882), // Rule ID 573 //
     /* 418857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 418860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 418863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418871 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 418871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 418876 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418880 */   GIR_RootConstrainSelectedInstOperands,
     /* 418881 */   // GIR_Coverage, 573,
     /* 418881 */   GIR_Done,
     /* 418882 */ // Label 8083: @418882
     /* 418882 */ GIM_Reject,
     /* 418883 */ // Label 8075: @418883
     /* 418883 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(418913), // Rule ID 575 //
     /* 418888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 418891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 418894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418902 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 418902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 418907 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418911 */   GIR_RootConstrainSelectedInstOperands,
     /* 418912 */   // GIR_Coverage, 575,
     /* 418912 */   GIR_Done,
     /* 418913 */ // Label 8084: @418913
     /* 418913 */ GIM_Reject,
     /* 418914 */ // Label 8076: @418914
     /* 418914 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(418944), // Rule ID 577 //
     /* 418919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 418922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 418925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418933 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 418933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 418938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418942 */   GIR_RootConstrainSelectedInstOperands,
     /* 418943 */   // GIR_Coverage, 577,
     /* 418943 */   GIR_Done,
     /* 418944 */ // Label 8085: @418944
     /* 418944 */ GIM_Reject,
     /* 418945 */ // Label 8077: @418945
     /* 418945 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(418975), // Rule ID 963 //
     /* 418950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418964 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 418969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418973 */   GIR_RootConstrainSelectedInstOperands,
     /* 418974 */   // GIR_Coverage, 963,
     /* 418974 */   GIR_Done,
     /* 418975 */ // Label 8086: @418975
     /* 418975 */ GIM_Reject,
     /* 418976 */ // Label 8078: @418976
     /* 418976 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(419006), // Rule ID 967 //
     /* 418981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418995 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 419000 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419004 */   GIR_RootConstrainSelectedInstOperands,
     /* 419005 */   // GIR_Coverage, 967,
     /* 419005 */   GIR_Done,
     /* 419006 */ // Label 8087: @419006
     /* 419006 */ GIM_Reject,
     /* 419007 */ // Label 8079: @419007
     /* 419007 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(419037), // Rule ID 959 //
     /* 419012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419026 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 419031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419035 */   GIR_RootConstrainSelectedInstOperands,
     /* 419036 */   // GIR_Coverage, 959,
     /* 419036 */   GIR_Done,
     /* 419037 */ // Label 8088: @419037
     /* 419037 */ GIM_Reject,
     /* 419038 */ // Label 8080: @419038
     /* 419038 */ GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(419068), // Rule ID 965 //
     /* 419043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419057 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 419062 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419066 */   GIR_RootConstrainSelectedInstOperands,
     /* 419067 */   // GIR_Coverage, 965,
     /* 419067 */   GIR_Done,
     /* 419068 */ // Label 8089: @419068
     /* 419068 */ GIM_Reject,
     /* 419069 */ // Label 8081: @419069
     /* 419069 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(419099), // Rule ID 961 //
     /* 419074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419088 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 419093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419097 */   GIR_RootConstrainSelectedInstOperands,
     /* 419098 */   // GIR_Coverage, 961,
     /* 419098 */   GIR_Done,
     /* 419099 */ // Label 8090: @419099
     /* 419099 */ GIM_Reject,
     /* 419100 */ // Label 8082: @419100
     /* 419100 */ GIM_Reject,
     /* 419101 */ // Label 110: @419101
     /* 419101 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(419114), // Rule ID 6599 //
     /* 419106 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 419106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 419109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 419112 */   GIR_RootConstrainSelectedInstOperands,
     /* 419113 */   // GIR_Coverage, 6599,
     /* 419113 */   GIR_EraseRootFromParent_Done,
     /* 419114 */ // Label 8091: @419114
     /* 419114 */ GIM_Reject,
     /* 419115 */ // Label 111: @419115
     /* 419115 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(419135), // Rule ID 6600 //
     /* 419120 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 419120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 419123 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 419133 */   GIR_RootConstrainSelectedInstOperands,
     /* 419134 */   // GIR_Coverage, 6600,
     /* 419134 */   GIR_EraseRootFromParent_Done,
     /* 419135 */ // Label 8092: @419135
     /* 419135 */ GIM_Reject,
     /* 419136 */ // Label 112: @419136
     /* 419136 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(419160), // Rule ID 6601 //
     /* 419141 */   // MIs[0] kind
     /* 419141 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 419144 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 419149 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 419149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 419152 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 419158 */   GIR_RootConstrainSelectedInstOperands,
     /* 419159 */   // GIR_Coverage, 6601,
     /* 419159 */   GIR_EraseRootFromParent_Done,
     /* 419160 */ // Label 8093: @419160
     /* 419160 */ GIM_Reject,
     /* 419161 */ // Label 113: @419161
     /* 419161 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8097*/ GIMT_Encode4(419470),
     /* 419172 */ /*GILLT_s16*//*Label 8094*/ GIMT_Encode4(419184),
     /* 419176 */ /*GILLT_s32*//*Label 8095*/ GIMT_Encode4(419337),
     /* 419180 */ /*GILLT_s64*//*Label 8096*/ GIMT_Encode4(419442),
     /* 419184 */ // Label 8094: @419184
     /* 419184 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(419285), // Rule ID 5654 //
     /* 419189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 419192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419203 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 419203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 419206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 419210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419215 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419219 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 419225 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 419228 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 419232 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419237 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 419240 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 419246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419258 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 419265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 419278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 419283 */   GIR_RootConstrainSelectedInstOperands,
     /* 419284 */   // GIR_Coverage, 5654,
     /* 419284 */   GIR_EraseRootFromParent_Done,
     /* 419285 */ // Label 8098: @419285
     /* 419285 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(419336), // Rule ID 5655 //
     /* 419290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 419293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419304 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 419304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 419311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419316 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419320 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 419329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 419334 */   GIR_RootConstrainSelectedInstOperands,
     /* 419335 */   // GIR_Coverage, 5655,
     /* 419335 */   GIR_EraseRootFromParent_Done,
     /* 419336 */ // Label 8099: @419336
     /* 419336 */ GIM_Reject,
     /* 419337 */ // Label 8095: @419337
     /* 419337 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(419414), // Rule ID 5656 //
     /* 419342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419353 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 419353 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 419356 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 419360 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419365 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419369 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 419375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419387 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 419394 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 419407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 419412 */   GIR_RootConstrainSelectedInstOperands,
     /* 419413 */   // GIR_Coverage, 5656,
     /* 419413 */   GIR_EraseRootFromParent_Done,
     /* 419414 */ // Label 8100: @419414
     /* 419414 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(419441), // Rule ID 5657 //
     /* 419419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419430 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 419435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419439 */   GIR_RootConstrainSelectedInstOperands,
     /* 419440 */   // GIR_Coverage, 5657,
     /* 419440 */   GIR_Done,
     /* 419441 */ // Label 8101: @419441
     /* 419441 */ GIM_Reject,
     /* 419442 */ // Label 8096: @419442
     /* 419442 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(419469), // Rule ID 5658 //
     /* 419447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419458 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 419463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419467 */   GIR_RootConstrainSelectedInstOperands,
     /* 419468 */   // GIR_Coverage, 5658,
     /* 419468 */   GIR_Done,
     /* 419469 */ // Label 8102: @419469
     /* 419469 */ GIM_Reject,
     /* 419470 */ // Label 8097: @419470
     /* 419470 */ GIM_Reject,
     /* 419471 */ // Label 114: @419471
     /* 419471 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8106*/ GIMT_Encode4(419641),
     /* 419482 */ /*GILLT_s16*//*Label 8103*/ GIMT_Encode4(419494),
     /* 419486 */ /*GILLT_s32*//*Label 8104*/ GIMT_Encode4(419555),
     /* 419490 */ /*GILLT_s64*//*Label 8105*/ GIMT_Encode4(419613),
     /* 419494 */ // Label 8103: @419494
     /* 419494 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(419524), // Rule ID 1946 //
     /* 419499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419513 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 419518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419522 */   GIR_RootConstrainSelectedInstOperands,
     /* 419523 */   // GIR_Coverage, 1946,
     /* 419523 */   GIR_Done,
     /* 419524 */ // Label 8107: @419524
     /* 419524 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(419554), // Rule ID 1948 //
     /* 419529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419543 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 419548 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419552 */   GIR_RootConstrainSelectedInstOperands,
     /* 419553 */   // GIR_Coverage, 1948,
     /* 419553 */   GIR_Done,
     /* 419554 */ // Label 8108: @419554
     /* 419554 */ GIM_Reject,
     /* 419555 */ // Label 8104: @419555
     /* 419555 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(419585), // Rule ID 1950 //
     /* 419560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419574 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 419579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419583 */   GIR_RootConstrainSelectedInstOperands,
     /* 419584 */   // GIR_Coverage, 1950,
     /* 419584 */   GIR_Done,
     /* 419585 */ // Label 8109: @419585
     /* 419585 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(419612), // Rule ID 5664 //
     /* 419590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419601 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 419606 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419610 */   GIR_RootConstrainSelectedInstOperands,
     /* 419611 */   // GIR_Coverage, 5664,
     /* 419611 */   GIR_Done,
     /* 419612 */ // Label 8110: @419612
     /* 419612 */ GIM_Reject,
     /* 419613 */ // Label 8105: @419613
     /* 419613 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(419640), // Rule ID 5666 //
     /* 419618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419629 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 419634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419638 */   GIR_RootConstrainSelectedInstOperands,
     /* 419639 */   // GIR_Coverage, 5666,
     /* 419639 */   GIR_Done,
     /* 419640 */ // Label 8111: @419640
     /* 419640 */ GIM_Reject,
     /* 419641 */ // Label 8106: @419641
     /* 419641 */ GIM_Reject,
     /* 419642 */ // Label 115: @419642
     /* 419642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8115*/ GIMT_Encode4(419812),
     /* 419653 */ /*GILLT_s16*//*Label 8112*/ GIMT_Encode4(419665),
     /* 419657 */ /*GILLT_s32*//*Label 8113*/ GIMT_Encode4(419726),
     /* 419661 */ /*GILLT_s64*//*Label 8114*/ GIMT_Encode4(419784),
     /* 419665 */ // Label 8112: @419665
     /* 419665 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(419695), // Rule ID 1958 //
     /* 419670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419684 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 419689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419693 */   GIR_RootConstrainSelectedInstOperands,
     /* 419694 */   // GIR_Coverage, 1958,
     /* 419694 */   GIR_Done,
     /* 419695 */ // Label 8116: @419695
     /* 419695 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(419725), // Rule ID 1960 //
     /* 419700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419714 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 419719 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419723 */   GIR_RootConstrainSelectedInstOperands,
     /* 419724 */   // GIR_Coverage, 1960,
     /* 419724 */   GIR_Done,
     /* 419725 */ // Label 8117: @419725
     /* 419725 */ GIM_Reject,
     /* 419726 */ // Label 8113: @419726
     /* 419726 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(419756), // Rule ID 1962 //
     /* 419731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419745 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 419750 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419754 */   GIR_RootConstrainSelectedInstOperands,
     /* 419755 */   // GIR_Coverage, 1962,
     /* 419755 */   GIR_Done,
     /* 419756 */ // Label 8118: @419756
     /* 419756 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(419783), // Rule ID 5672 //
     /* 419761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419772 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 419777 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419781 */   GIR_RootConstrainSelectedInstOperands,
     /* 419782 */   // GIR_Coverage, 5672,
     /* 419782 */   GIR_Done,
     /* 419783 */ // Label 8119: @419783
     /* 419783 */ GIM_Reject,
     /* 419784 */ // Label 8114: @419784
     /* 419784 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(419811), // Rule ID 5674 //
     /* 419789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419800 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 419805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419809 */   GIR_RootConstrainSelectedInstOperands,
     /* 419810 */   // GIR_Coverage, 5674,
     /* 419810 */   GIR_Done,
     /* 419811 */ // Label 8120: @419811
     /* 419811 */ GIM_Reject,
     /* 419812 */ // Label 8115: @419812
     /* 419812 */ GIM_Reject,
     /* 419813 */ // Label 116: @419813
     /* 419813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8124*/ GIMT_Encode4(419983),
     /* 419824 */ /*GILLT_s16*//*Label 8121*/ GIMT_Encode4(419836),
     /* 419828 */ /*GILLT_s32*//*Label 8122*/ GIMT_Encode4(419897),
     /* 419832 */ /*GILLT_s64*//*Label 8123*/ GIMT_Encode4(419955),
     /* 419836 */ // Label 8121: @419836
     /* 419836 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(419866), // Rule ID 1952 //
     /* 419841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419855 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 419860 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419864 */   GIR_RootConstrainSelectedInstOperands,
     /* 419865 */   // GIR_Coverage, 1952,
     /* 419865 */   GIR_Done,
     /* 419866 */ // Label 8125: @419866
     /* 419866 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(419896), // Rule ID 1954 //
     /* 419871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419885 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 419890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419894 */   GIR_RootConstrainSelectedInstOperands,
     /* 419895 */   // GIR_Coverage, 1954,
     /* 419895 */   GIR_Done,
     /* 419896 */ // Label 8126: @419896
     /* 419896 */ GIM_Reject,
     /* 419897 */ // Label 8122: @419897
     /* 419897 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(419927), // Rule ID 1956 //
     /* 419902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419916 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 419921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419925 */   GIR_RootConstrainSelectedInstOperands,
     /* 419926 */   // GIR_Coverage, 1956,
     /* 419926 */   GIR_Done,
     /* 419927 */ // Label 8127: @419927
     /* 419927 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(419954), // Rule ID 5668 //
     /* 419932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419943 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 419948 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419952 */   GIR_RootConstrainSelectedInstOperands,
     /* 419953 */   // GIR_Coverage, 5668,
     /* 419953 */   GIR_Done,
     /* 419954 */ // Label 8128: @419954
     /* 419954 */ GIM_Reject,
     /* 419955 */ // Label 8123: @419955
     /* 419955 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(419982), // Rule ID 5670 //
     /* 419960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419971 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 419976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419980 */   GIR_RootConstrainSelectedInstOperands,
     /* 419981 */   // GIR_Coverage, 5670,
     /* 419981 */   GIR_Done,
     /* 419982 */ // Label 8129: @419982
     /* 419982 */ GIM_Reject,
     /* 419983 */ // Label 8124: @419983
     /* 419983 */ GIM_Reject,
     /* 419984 */ // Label 117: @419984
     /* 419984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8133*/ GIMT_Encode4(420154),
     /* 419995 */ /*GILLT_s16*//*Label 8130*/ GIMT_Encode4(420007),
     /* 419999 */ /*GILLT_s32*//*Label 8131*/ GIMT_Encode4(420068),
     /* 420003 */ /*GILLT_s64*//*Label 8132*/ GIMT_Encode4(420126),
     /* 420007 */ // Label 8130: @420007
     /* 420007 */ GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(420037), // Rule ID 1964 //
     /* 420012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 420015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420026 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 420026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 420031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 420035 */   GIR_RootConstrainSelectedInstOperands,
     /* 420036 */   // GIR_Coverage, 1964,
     /* 420036 */   GIR_Done,
     /* 420037 */ // Label 8134: @420037
     /* 420037 */ GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(420067), // Rule ID 1966 //
     /* 420042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 420045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420056 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 420056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 420061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 420065 */   GIR_RootConstrainSelectedInstOperands,
     /* 420066 */   // GIR_Coverage, 1966,
     /* 420066 */   GIR_Done,
     /* 420067 */ // Label 8135: @420067
     /* 420067 */ GIM_Reject,
     /* 420068 */ // Label 8131: @420068
     /* 420068 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(420098), // Rule ID 1968 //
     /* 420073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 420076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420087 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 420087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 420092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 420096 */   GIR_RootConstrainSelectedInstOperands,
     /* 420097 */   // GIR_Coverage, 1968,
     /* 420097 */   GIR_Done,
     /* 420098 */ // Label 8136: @420098
     /* 420098 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(420125), // Rule ID 5676 //
     /* 420103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420114 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 420114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 420119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 420123 */   GIR_RootConstrainSelectedInstOperands,
     /* 420124 */   // GIR_Coverage, 5676,
     /* 420124 */   GIR_Done,
     /* 420125 */ // Label 8137: @420125
     /* 420125 */ GIM_Reject,
     /* 420126 */ // Label 8132: @420126
     /* 420126 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(420153), // Rule ID 5678 //
     /* 420131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 420134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420142 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 420142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 420147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 420151 */   GIR_RootConstrainSelectedInstOperands,
     /* 420152 */   // GIR_Coverage, 5678,
     /* 420152 */   GIR_Done,
     /* 420153 */ // Label 8138: @420153
     /* 420153 */ GIM_Reject,
     /* 420154 */ // Label 8133: @420154
     /* 420154 */ GIM_Reject,
     /* 420155 */ // Label 118: @420155
     /* 420155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8143*/ GIMT_Encode4(421283),
     /* 420166 */ /*GILLT_s8*//*Label 8139*/ GIMT_Encode4(420182),
     /* 420170 */ /*GILLT_s16*//*Label 8140*/ GIMT_Encode4(420229),
     /* 420174 */ /*GILLT_s32*//*Label 8141*/ GIMT_Encode4(420644),
     /* 420178 */ /*GILLT_s64*//*Label 8142*/ GIMT_Encode4(421097),
     /* 420182 */ // Label 8139: @420182
     /* 420182 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(420205), // Rule ID 5963 //
     /* 420187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420198 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 420198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 420203 */   GIR_RootConstrainSelectedInstOperands,
     /* 420204 */   // GIR_Coverage, 5963,
     /* 420204 */   GIR_Done,
     /* 420205 */ // Label 8144: @420205
     /* 420205 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(420228), // Rule ID 5964 //
     /* 420210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420221 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 420221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 420226 */   GIR_RootConstrainSelectedInstOperands,
     /* 420227 */   // GIR_Coverage, 5964,
     /* 420227 */   GIR_Done,
     /* 420228 */ // Label 8145: @420228
     /* 420228 */ GIM_Reject,
     /* 420229 */ // Label 8140: @420229
     /* 420229 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(420279), // Rule ID 5910 //
     /* 420234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420249 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420252 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420257 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 420261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420268 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 420271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420273 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420277 */   GIR_RootConstrainSelectedInstOperands,
     /* 420278 */   // GIR_Coverage, 5910,
     /* 420278 */   GIR_EraseRootFromParent_Done,
     /* 420279 */ // Label 8146: @420279
     /* 420279 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(420329), // Rule ID 5912 //
     /* 420284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420299 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420302 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 420311 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420316 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420318 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 420321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420327 */   GIR_RootConstrainSelectedInstOperands,
     /* 420328 */   // GIR_Coverage, 5912,
     /* 420328 */   GIR_EraseRootFromParent_Done,
     /* 420329 */ // Label 8147: @420329
     /* 420329 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(420379), // Rule ID 5920 //
     /* 420334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420349 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420352 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 420361 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420368 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 420371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420373 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420377 */   GIR_RootConstrainSelectedInstOperands,
     /* 420378 */   // GIR_Coverage, 5920,
     /* 420378 */   GIR_EraseRootFromParent_Done,
     /* 420379 */ // Label 8148: @420379
     /* 420379 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(420429), // Rule ID 5922 //
     /* 420384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420399 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420402 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420407 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 420411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420418 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 420421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420423 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420427 */   GIR_RootConstrainSelectedInstOperands,
     /* 420428 */   // GIR_Coverage, 5922,
     /* 420428 */   GIR_EraseRootFromParent_Done,
     /* 420429 */ // Label 8149: @420429
     /* 420429 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(420471), // Rule ID 5919 //
     /* 420434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420460 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 420463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420469 */   GIR_RootConstrainSelectedInstOperands,
     /* 420470 */   // GIR_Coverage, 5919,
     /* 420470 */   GIR_EraseRootFromParent_Done,
     /* 420471 */ // Label 8150: @420471
     /* 420471 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(420513), // Rule ID 5921 //
     /* 420476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420502 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 420505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420507 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420511 */   GIR_RootConstrainSelectedInstOperands,
     /* 420512 */   // GIR_Coverage, 5921,
     /* 420512 */   GIR_EraseRootFromParent_Done,
     /* 420513 */ // Label 8151: @420513
     /* 420513 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(420555), // Rule ID 5909 //
     /* 420518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420533 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420544 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 420547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420549 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420553 */   GIR_RootConstrainSelectedInstOperands,
     /* 420554 */   // GIR_Coverage, 5909,
     /* 420554 */   GIR_EraseRootFromParent_Done,
     /* 420555 */ // Label 8152: @420555
     /* 420555 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(420597), // Rule ID 5911 //
     /* 420560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420575 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420579 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420584 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420586 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 420589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420591 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420595 */   GIR_RootConstrainSelectedInstOperands,
     /* 420596 */   // GIR_Coverage, 5911,
     /* 420596 */   GIR_EraseRootFromParent_Done,
     /* 420597 */ // Label 8153: @420597
     /* 420597 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(420620), // Rule ID 5965 //
     /* 420602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420613 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 420613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 420618 */   GIR_RootConstrainSelectedInstOperands,
     /* 420619 */   // GIR_Coverage, 5965,
     /* 420619 */   GIR_Done,
     /* 420620 */ // Label 8154: @420620
     /* 420620 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(420643), // Rule ID 5966 //
     /* 420625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420636 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 420636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 420641 */   GIR_RootConstrainSelectedInstOperands,
     /* 420642 */   // GIR_Coverage, 5966,
     /* 420642 */   GIR_Done,
     /* 420643 */ // Label 8155: @420643
     /* 420643 */ GIM_Reject,
     /* 420644 */ // Label 8141: @420644
     /* 420644 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(420694), // Rule ID 5914 //
     /* 420649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420664 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420667 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420676 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420683 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 420686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420692 */   GIR_RootConstrainSelectedInstOperands,
     /* 420693 */   // GIR_Coverage, 5914,
     /* 420693 */   GIR_EraseRootFromParent_Done,
     /* 420694 */ // Label 8156: @420694
     /* 420694 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(420744), // Rule ID 5916 //
     /* 420699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420706 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420714 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420717 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420733 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 420736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420738 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420742 */   GIR_RootConstrainSelectedInstOperands,
     /* 420743 */   // GIR_Coverage, 5916,
     /* 420743 */   GIR_EraseRootFromParent_Done,
     /* 420744 */ // Label 8157: @420744
     /* 420744 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(420794), // Rule ID 5924 //
     /* 420749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420764 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420767 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420772 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420783 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 420786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420788 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420792 */   GIR_RootConstrainSelectedInstOperands,
     /* 420793 */   // GIR_Coverage, 5924,
     /* 420793 */   GIR_EraseRootFromParent_Done,
     /* 420794 */ // Label 8158: @420794
     /* 420794 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(420844), // Rule ID 5926 //
     /* 420799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420814 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420817 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420833 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 420836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420838 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420842 */   GIR_RootConstrainSelectedInstOperands,
     /* 420843 */   // GIR_Coverage, 5926,
     /* 420843 */   GIR_EraseRootFromParent_Done,
     /* 420844 */ // Label 8159: @420844
     /* 420844 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(420886), // Rule ID 5923 //
     /* 420849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420864 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420875 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 420878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420880 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420884 */   GIR_RootConstrainSelectedInstOperands,
     /* 420885 */   // GIR_Coverage, 5923,
     /* 420885 */   GIR_EraseRootFromParent_Done,
     /* 420886 */ // Label 8160: @420886
     /* 420886 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(420928), // Rule ID 5925 //
     /* 420891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420917 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 420920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420922 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420926 */   GIR_RootConstrainSelectedInstOperands,
     /* 420927 */   // GIR_Coverage, 5925,
     /* 420927 */   GIR_EraseRootFromParent_Done,
     /* 420928 */ // Label 8161: @420928
     /* 420928 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(420970), // Rule ID 5913 //
     /* 420933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420959 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 420962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420964 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420968 */   GIR_RootConstrainSelectedInstOperands,
     /* 420969 */   // GIR_Coverage, 5913,
     /* 420969 */   GIR_EraseRootFromParent_Done,
     /* 420970 */ // Label 8162: @420970
     /* 420970 */ GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(421012), // Rule ID 5915 //
     /* 420975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420990 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420994 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421001 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 421001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 421004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421006 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421010 */   GIR_RootConstrainSelectedInstOperands,
     /* 421011 */   // GIR_Coverage, 5915,
     /* 421011 */   GIR_EraseRootFromParent_Done,
     /* 421012 */ // Label 8163: @421012
     /* 421012 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(421073), // Rule ID 5967 //
     /* 421017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421028 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 421035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421044 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421055 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421072 */   // GIR_Coverage, 5967,
     /* 421072 */   GIR_EraseRootFromParent_Done,
     /* 421073 */ // Label 8164: @421073
     /* 421073 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(421096), // Rule ID 5968 //
     /* 421078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421089 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 421094 */   GIR_RootConstrainSelectedInstOperands,
     /* 421095 */   // GIR_Coverage, 5968,
     /* 421095 */   GIR_Done,
     /* 421096 */ // Label 8165: @421096
     /* 421096 */ GIM_Reject,
     /* 421097 */ // Label 8142: @421097
     /* 421097 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(421282),
     /* 421102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 421105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421109 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(421152), // Rule ID 5918 //
     /* 421114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 421122 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 421125 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 421130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 421134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421141 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 421141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 421144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 421150 */     GIR_RootConstrainSelectedInstOperands,
     /* 421151 */     // GIR_Coverage, 5918,
     /* 421151 */     GIR_EraseRootFromParent_Done,
     /* 421152 */   // Label 8167: @421152
     /* 421152 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(421195), // Rule ID 5928 //
     /* 421157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 421165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 421168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 421173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 421177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421184 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 421184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 421187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 421193 */     GIR_RootConstrainSelectedInstOperands,
     /* 421194 */     // GIR_Coverage, 5928,
     /* 421194 */     GIR_EraseRootFromParent_Done,
     /* 421195 */   // Label 8168: @421195
     /* 421195 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(421230), // Rule ID 5927 //
     /* 421200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 421208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421219 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 421219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 421222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421228 */     GIR_RootConstrainSelectedInstOperands,
     /* 421229 */     // GIR_Coverage, 5927,
     /* 421229 */     GIR_EraseRootFromParent_Done,
     /* 421230 */   // Label 8169: @421230
     /* 421230 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(421265), // Rule ID 5917 //
     /* 421235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 421243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421254 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 421254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 421257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421263 */     GIR_RootConstrainSelectedInstOperands,
     /* 421264 */     // GIR_Coverage, 5917,
     /* 421264 */     GIR_EraseRootFromParent_Done,
     /* 421265 */   // Label 8170: @421265
     /* 421265 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(421281), // Rule ID 5969 //
     /* 421270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421274 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 421274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 421279 */     GIR_RootConstrainSelectedInstOperands,
     /* 421280 */     // GIR_Coverage, 5969,
     /* 421280 */     GIR_Done,
     /* 421281 */   // Label 8171: @421281
     /* 421281 */   GIM_Reject,
     /* 421282 */ // Label 8166: @421282
     /* 421282 */ GIM_Reject,
     /* 421283 */ // Label 8143: @421283
     /* 421283 */ GIM_Reject,
     /* 421284 */ // Label 119: @421284
     /* 421284 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8175*/ GIMT_Encode4(421486),
     /* 421295 */ /*GILLT_s8*//*Label 8172*/ GIMT_Encode4(421307),
     /* 421299 */ /*GILLT_s16*//*Label 8173*/ GIMT_Encode4(421354),
     /* 421303 */ /*GILLT_s32*//*Label 8174*/ GIMT_Encode4(421401),
     /* 421307 */ // Label 8172: @421307
     /* 421307 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(421330), // Rule ID 6060 //
     /* 421312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421323 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 421328 */   GIR_RootConstrainSelectedInstOperands,
     /* 421329 */   // GIR_Coverage, 6060,
     /* 421329 */   GIR_Done,
     /* 421330 */ // Label 8176: @421330
     /* 421330 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(421353), // Rule ID 6061 //
     /* 421335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421346 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 421351 */   GIR_RootConstrainSelectedInstOperands,
     /* 421352 */   // GIR_Coverage, 6061,
     /* 421352 */   GIR_Done,
     /* 421353 */ // Label 8177: @421353
     /* 421353 */ GIM_Reject,
     /* 421354 */ // Label 8173: @421354
     /* 421354 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(421377), // Rule ID 6062 //
     /* 421359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421370 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 421375 */   GIR_RootConstrainSelectedInstOperands,
     /* 421376 */   // GIR_Coverage, 6062,
     /* 421376 */   GIR_Done,
     /* 421377 */ // Label 8178: @421377
     /* 421377 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(421400), // Rule ID 6063 //
     /* 421382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421393 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 421398 */   GIR_RootConstrainSelectedInstOperands,
     /* 421399 */   // GIR_Coverage, 6063,
     /* 421399 */   GIR_Done,
     /* 421400 */ // Label 8179: @421400
     /* 421400 */ GIM_Reject,
     /* 421401 */ // Label 8174: @421401
     /* 421401 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(421424), // Rule ID 6064 //
     /* 421406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421417 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 421422 */   GIR_RootConstrainSelectedInstOperands,
     /* 421423 */   // GIR_Coverage, 6064,
     /* 421423 */   GIR_Done,
     /* 421424 */ // Label 8180: @421424
     /* 421424 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(421485), // Rule ID 6065 //
     /* 421429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421440 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 421447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421456 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421467 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421484 */   // GIR_Coverage, 6065,
     /* 421484 */   GIR_EraseRootFromParent_Done,
     /* 421485 */ // Label 8181: @421485
     /* 421485 */ GIM_Reject,
     /* 421486 */ // Label 8175: @421486
     /* 421486 */ GIM_Reject,
     /* 421487 */ // Label 120: @421487
     /* 421487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8185*/ GIMT_Encode4(421689),
     /* 421498 */ /*GILLT_s8*//*Label 8182*/ GIMT_Encode4(421510),
     /* 421502 */ /*GILLT_s16*//*Label 8183*/ GIMT_Encode4(421557),
     /* 421506 */ /*GILLT_s32*//*Label 8184*/ GIMT_Encode4(421604),
     /* 421510 */ // Label 8182: @421510
     /* 421510 */ GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(421533), // Rule ID 6054 //
     /* 421515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421526 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 421531 */   GIR_RootConstrainSelectedInstOperands,
     /* 421532 */   // GIR_Coverage, 6054,
     /* 421532 */   GIR_Done,
     /* 421533 */ // Label 8186: @421533
     /* 421533 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(421556), // Rule ID 6055 //
     /* 421538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421549 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 421554 */   GIR_RootConstrainSelectedInstOperands,
     /* 421555 */   // GIR_Coverage, 6055,
     /* 421555 */   GIR_Done,
     /* 421556 */ // Label 8187: @421556
     /* 421556 */ GIM_Reject,
     /* 421557 */ // Label 8183: @421557
     /* 421557 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(421580), // Rule ID 6056 //
     /* 421562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421573 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 421578 */   GIR_RootConstrainSelectedInstOperands,
     /* 421579 */   // GIR_Coverage, 6056,
     /* 421579 */   GIR_Done,
     /* 421580 */ // Label 8188: @421580
     /* 421580 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(421603), // Rule ID 6057 //
     /* 421585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421596 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 421601 */   GIR_RootConstrainSelectedInstOperands,
     /* 421602 */   // GIR_Coverage, 6057,
     /* 421602 */   GIR_Done,
     /* 421603 */ // Label 8189: @421603
     /* 421603 */ GIM_Reject,
     /* 421604 */ // Label 8184: @421604
     /* 421604 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(421627), // Rule ID 6058 //
     /* 421609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421620 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 421625 */   GIR_RootConstrainSelectedInstOperands,
     /* 421626 */   // GIR_Coverage, 6058,
     /* 421626 */   GIR_Done,
     /* 421627 */ // Label 8190: @421627
     /* 421627 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(421688), // Rule ID 6059 //
     /* 421632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421643 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 421650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421659 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421670 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421687 */   // GIR_Coverage, 6059,
     /* 421687 */   GIR_EraseRootFromParent_Done,
     /* 421688 */ // Label 8191: @421688
     /* 421688 */ GIM_Reject,
     /* 421689 */ // Label 8185: @421689
     /* 421689 */ GIM_Reject,
     /* 421690 */ // Label 121: @421690
     /* 421690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8195*/ GIMT_Encode4(421892),
     /* 421701 */ /*GILLT_s8*//*Label 8192*/ GIMT_Encode4(421713),
     /* 421705 */ /*GILLT_s16*//*Label 8193*/ GIMT_Encode4(421760),
     /* 421709 */ /*GILLT_s32*//*Label 8194*/ GIMT_Encode4(421807),
     /* 421713 */ // Label 8192: @421713
     /* 421713 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(421736), // Rule ID 6048 //
     /* 421718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421729 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 421734 */   GIR_RootConstrainSelectedInstOperands,
     /* 421735 */   // GIR_Coverage, 6048,
     /* 421735 */   GIR_Done,
     /* 421736 */ // Label 8196: @421736
     /* 421736 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(421759), // Rule ID 6049 //
     /* 421741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421752 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 421757 */   GIR_RootConstrainSelectedInstOperands,
     /* 421758 */   // GIR_Coverage, 6049,
     /* 421758 */   GIR_Done,
     /* 421759 */ // Label 8197: @421759
     /* 421759 */ GIM_Reject,
     /* 421760 */ // Label 8193: @421760
     /* 421760 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(421783), // Rule ID 6050 //
     /* 421765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421776 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 421781 */   GIR_RootConstrainSelectedInstOperands,
     /* 421782 */   // GIR_Coverage, 6050,
     /* 421782 */   GIR_Done,
     /* 421783 */ // Label 8198: @421783
     /* 421783 */ GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(421806), // Rule ID 6051 //
     /* 421788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421799 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 421804 */   GIR_RootConstrainSelectedInstOperands,
     /* 421805 */   // GIR_Coverage, 6051,
     /* 421805 */   GIR_Done,
     /* 421806 */ // Label 8199: @421806
     /* 421806 */ GIM_Reject,
     /* 421807 */ // Label 8194: @421807
     /* 421807 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(421830), // Rule ID 6052 //
     /* 421812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421823 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 421828 */   GIR_RootConstrainSelectedInstOperands,
     /* 421829 */   // GIR_Coverage, 6052,
     /* 421829 */   GIR_Done,
     /* 421830 */ // Label 8200: @421830
     /* 421830 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(421891), // Rule ID 6053 //
     /* 421835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421846 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 421853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421873 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421890 */   // GIR_Coverage, 6053,
     /* 421890 */   GIR_EraseRootFromParent_Done,
     /* 421891 */ // Label 8201: @421891
     /* 421891 */ GIM_Reject,
     /* 421892 */ // Label 8195: @421892
     /* 421892 */ GIM_Reject,
     /* 421893 */ // Label 122: @421893
     /* 421893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8205*/ GIMT_Encode4(422095),
     /* 421904 */ /*GILLT_s8*//*Label 8202*/ GIMT_Encode4(421916),
     /* 421908 */ /*GILLT_s16*//*Label 8203*/ GIMT_Encode4(421963),
     /* 421912 */ /*GILLT_s32*//*Label 8204*/ GIMT_Encode4(422010),
     /* 421916 */ // Label 8202: @421916
     /* 421916 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(421939), // Rule ID 6042 //
     /* 421921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421932 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 421937 */   GIR_RootConstrainSelectedInstOperands,
     /* 421938 */   // GIR_Coverage, 6042,
     /* 421938 */   GIR_Done,
     /* 421939 */ // Label 8206: @421939
     /* 421939 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(421962), // Rule ID 6043 //
     /* 421944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421955 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 421960 */   GIR_RootConstrainSelectedInstOperands,
     /* 421961 */   // GIR_Coverage, 6043,
     /* 421961 */   GIR_Done,
     /* 421962 */ // Label 8207: @421962
     /* 421962 */ GIM_Reject,
     /* 421963 */ // Label 8203: @421963
     /* 421963 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(421986), // Rule ID 6044 //
     /* 421968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421979 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 421984 */   GIR_RootConstrainSelectedInstOperands,
     /* 421985 */   // GIR_Coverage, 6044,
     /* 421985 */   GIR_Done,
     /* 421986 */ // Label 8208: @421986
     /* 421986 */ GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(422009), // Rule ID 6045 //
     /* 421991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422002 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 422002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 422007 */   GIR_RootConstrainSelectedInstOperands,
     /* 422008 */   // GIR_Coverage, 6045,
     /* 422008 */   GIR_Done,
     /* 422009 */ // Label 8209: @422009
     /* 422009 */ GIM_Reject,
     /* 422010 */ // Label 8204: @422010
     /* 422010 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(422033), // Rule ID 6046 //
     /* 422015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422026 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 422026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 422031 */   GIR_RootConstrainSelectedInstOperands,
     /* 422032 */   // GIR_Coverage, 6046,
     /* 422032 */   GIR_Done,
     /* 422033 */ // Label 8210: @422033
     /* 422033 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(422094), // Rule ID 6047 //
     /* 422038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 422041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422049 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 422049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 422052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 422056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422061 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 422071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 422074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 422076 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 422083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422093 */   // GIR_Coverage, 6047,
     /* 422093 */   GIR_EraseRootFromParent_Done,
     /* 422094 */ // Label 8211: @422094
     /* 422094 */ GIM_Reject,
     /* 422095 */ // Label 8205: @422095
     /* 422095 */ GIM_Reject,
     /* 422096 */ // Label 123: @422096
     /* 422096 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(422235),
     /* 422101 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 422104 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 422108 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(422142), // Rule ID 261 //
     /* 422113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 422120 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 422120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 422123 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 422125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 422135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 422140 */     GIR_RootConstrainSelectedInstOperands,
     /* 422141 */     // GIR_Coverage, 261,
     /* 422141 */     GIR_EraseRootFromParent_Done,
     /* 422142 */   // Label 8213: @422142
     /* 422142 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(422176), // Rule ID 262 //
     /* 422147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 422154 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 422154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 422157 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 422159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 422169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 422174 */     GIR_RootConstrainSelectedInstOperands,
     /* 422175 */     // GIR_Coverage, 262,
     /* 422175 */     GIR_EraseRootFromParent_Done,
     /* 422176 */   // Label 8214: @422176
     /* 422176 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(422205), // Rule ID 277 //
     /* 422181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 422188 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 422188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 422191 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 422193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 422203 */     GIR_RootConstrainSelectedInstOperands,
     /* 422204 */     // GIR_Coverage, 277,
     /* 422204 */     GIR_EraseRootFromParent_Done,
     /* 422205 */   // Label 8215: @422205
     /* 422205 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(422234), // Rule ID 298 //
     /* 422210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 422217 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 422217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 422220 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 422222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 422232 */     GIR_RootConstrainSelectedInstOperands,
     /* 422233 */     // GIR_Coverage, 298,
     /* 422233 */     GIR_EraseRootFromParent_Done,
     /* 422234 */   // Label 8216: @422234
     /* 422234 */   GIM_Reject,
     /* 422235 */ // Label 8212: @422235
     /* 422235 */ GIM_Reject,
     /* 422236 */ // Label 124: @422236
     /* 422236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8229*/ GIMT_Encode4(423223),
     /* 422247 */ /*GILLT_s64*//*Label 8217*/ GIMT_Encode4(422331), GIMT_Encode4(0),
     /* 422255 */ /*GILLT_v2s32*//*Label 8218*/ GIMT_Encode4(422369),
     /* 422259 */ /*GILLT_v2s64*//*Label 8219*/ GIMT_Encode4(422407),
     /* 422263 */ /*GILLT_v4s16*//*Label 8220*/ GIMT_Encode4(422445),
     /* 422267 */ /*GILLT_v4s32*//*Label 8221*/ GIMT_Encode4(422483),
     /* 422271 */ /*GILLT_v8s8*//*Label 8222*/ GIMT_Encode4(422521),
     /* 422275 */ /*GILLT_v8s16*//*Label 8223*/ GIMT_Encode4(422559),
     /* 422279 */ /*GILLT_v16s8*//*Label 8224*/ GIMT_Encode4(422597), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422299 */ /*GILLT_nxv2s64*//*Label 8225*/ GIMT_Encode4(422635), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422311 */ /*GILLT_nxv4s32*//*Label 8226*/ GIMT_Encode4(422782), GIMT_Encode4(0),
     /* 422319 */ /*GILLT_nxv8s16*//*Label 8227*/ GIMT_Encode4(422929), GIMT_Encode4(0),
     /* 422327 */ /*GILLT_nxv16s8*//*Label 8228*/ GIMT_Encode4(423076),
     /* 422331 */ // Label 8217: @422331
     /* 422331 */ GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(422368), // Rule ID 5117 //
     /* 422336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 422339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 422345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422357 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422361 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 422361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422366 */   GIR_RootConstrainSelectedInstOperands,
     /* 422367 */   // GIR_Coverage, 5117,
     /* 422367 */   GIR_Done,
     /* 422368 */ // Label 8230: @422368
     /* 422368 */ GIM_Reject,
     /* 422369 */ // Label 8218: @422369
     /* 422369 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(422406), // Rule ID 5116 //
     /* 422374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 422377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 422380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 422383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422399 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 422399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422404 */   GIR_RootConstrainSelectedInstOperands,
     /* 422405 */   // GIR_Coverage, 5116,
     /* 422405 */   GIR_Done,
     /* 422406 */ // Label 8231: @422406
     /* 422406 */ GIM_Reject,
     /* 422407 */ // Label 8219: @422407
     /* 422407 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(422444), // Rule ID 5121 //
     /* 422412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 422415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 422418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 422421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422437 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 422437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422442 */   GIR_RootConstrainSelectedInstOperands,
     /* 422443 */   // GIR_Coverage, 5121,
     /* 422443 */   GIR_Done,
     /* 422444 */ // Label 8232: @422444
     /* 422444 */ GIM_Reject,
     /* 422445 */ // Label 8220: @422445
     /* 422445 */ GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(422482), // Rule ID 5115 //
     /* 422450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 422453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 422456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 422459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422475 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 422475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422480 */   GIR_RootConstrainSelectedInstOperands,
     /* 422481 */   // GIR_Coverage, 5115,
     /* 422481 */   GIR_Done,
     /* 422482 */ // Label 8233: @422482
     /* 422482 */ GIM_Reject,
     /* 422483 */ // Label 8221: @422483
     /* 422483 */ GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(422520), // Rule ID 5120 //
     /* 422488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 422494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 422497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422509 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422513 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 422513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422518 */   GIR_RootConstrainSelectedInstOperands,
     /* 422519 */   // GIR_Coverage, 5120,
     /* 422519 */   GIR_Done,
     /* 422520 */ // Label 8234: @422520
     /* 422520 */ GIM_Reject,
     /* 422521 */ // Label 8222: @422521
     /* 422521 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(422558), // Rule ID 5114 //
     /* 422526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 422529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 422532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 422535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422551 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 422551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422556 */   GIR_RootConstrainSelectedInstOperands,
     /* 422557 */   // GIR_Coverage, 5114,
     /* 422557 */   GIR_Done,
     /* 422558 */ // Label 8235: @422558
     /* 422558 */ GIM_Reject,
     /* 422559 */ // Label 8223: @422559
     /* 422559 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(422596), // Rule ID 5119 //
     /* 422564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 422570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 422573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422589 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 422589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422594 */   GIR_RootConstrainSelectedInstOperands,
     /* 422595 */   // GIR_Coverage, 5119,
     /* 422595 */   GIR_Done,
     /* 422596 */ // Label 8236: @422596
     /* 422596 */ GIM_Reject,
     /* 422597 */ // Label 8224: @422597
     /* 422597 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(422634), // Rule ID 5118 //
     /* 422602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 422608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 422611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422623 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422627 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 422627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422632 */   GIR_RootConstrainSelectedInstOperands,
     /* 422633 */   // GIR_Coverage, 5118,
     /* 422633 */   GIR_Done,
     /* 422634 */ // Label 8237: @422634
     /* 422634 */ GIM_Reject,
     /* 422635 */ // Label 8225: @422635
     /* 422635 */ GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(422781),
     /* 422640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 422649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422653 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(422706), // Rule ID 12070 //
     /* 422658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422681 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422687 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422691 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422704 */     GIR_RootConstrainSelectedInstOperands,
     /* 422705 */     // GIR_Coverage, 12070,
     /* 422705 */     GIR_EraseRootFromParent_Done,
     /* 422706 */   // Label 8239: @422706
     /* 422706 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(422759), // Rule ID 12097 //
     /* 422711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422734 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422744 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422757 */     GIR_RootConstrainSelectedInstOperands,
     /* 422758 */     // GIR_Coverage, 12097,
     /* 422758 */     GIR_EraseRootFromParent_Done,
     /* 422759 */   // Label 8240: @422759
     /* 422759 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(422780), // Rule ID 12046 //
     /* 422764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422767 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422778 */     GIR_RootConstrainSelectedInstOperands,
     /* 422779 */     // GIR_Coverage, 12046,
     /* 422779 */     GIR_EraseRootFromParent_Done,
     /* 422780 */   // Label 8241: @422780
     /* 422780 */   GIM_Reject,
     /* 422781 */ // Label 8238: @422781
     /* 422781 */ GIM_Reject,
     /* 422782 */ // Label 8226: @422782
     /* 422782 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(422928),
     /* 422787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 422796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422800 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(422853), // Rule ID 12068 //
     /* 422805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422828 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422838 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422851 */     GIR_RootConstrainSelectedInstOperands,
     /* 422852 */     // GIR_Coverage, 12068,
     /* 422852 */     GIR_EraseRootFromParent_Done,
     /* 422853 */   // Label 8243: @422853
     /* 422853 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(422906), // Rule ID 12094 //
     /* 422858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422881 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422891 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422904 */     GIR_RootConstrainSelectedInstOperands,
     /* 422905 */     // GIR_Coverage, 12094,
     /* 422905 */     GIR_EraseRootFromParent_Done,
     /* 422906 */   // Label 8244: @422906
     /* 422906 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(422927), // Rule ID 12044 //
     /* 422911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422914 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422925 */     GIR_RootConstrainSelectedInstOperands,
     /* 422926 */     // GIR_Coverage, 12044,
     /* 422926 */     GIR_EraseRootFromParent_Done,
     /* 422927 */   // Label 8245: @422927
     /* 422927 */   GIM_Reject,
     /* 422928 */ // Label 8242: @422928
     /* 422928 */ GIM_Reject,
     /* 422929 */ // Label 8227: @422929
     /* 422929 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(423075),
     /* 422934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 422937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 422940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 422943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422947 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(423000), // Rule ID 12066 //
     /* 422952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 422967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 422971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422975 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422981 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422985 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 422985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422998 */     GIR_RootConstrainSelectedInstOperands,
     /* 422999 */     // GIR_Coverage, 12066,
     /* 422999 */     GIR_EraseRootFromParent_Done,
     /* 423000 */   // Label 8247: @423000
     /* 423000 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(423053), // Rule ID 12091 //
     /* 423005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 423008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 423016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 423020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 423024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 423034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 423036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 423038 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 423038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 423041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 423043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 423045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 423049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 423051 */     GIR_RootConstrainSelectedInstOperands,
     /* 423052 */     // GIR_Coverage, 12091,
     /* 423052 */     GIR_EraseRootFromParent_Done,
     /* 423053 */   // Label 8248: @423053
     /* 423053 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(423074), // Rule ID 12042 //
     /* 423058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 423061 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 423061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 423064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 423066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 423068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 423070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 423072 */     GIR_RootConstrainSelectedInstOperands,
     /* 423073 */     // GIR_Coverage, 12042,
     /* 423073 */     GIR_EraseRootFromParent_Done,
     /* 423074 */   // Label 8249: @423074
     /* 423074 */   GIM_Reject,
     /* 423075 */ // Label 8246: @423075
     /* 423075 */ GIM_Reject,
     /* 423076 */ // Label 8228: @423076
     /* 423076 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(423222),
     /* 423081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 423084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 423087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 423090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 423094 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(423147), // Rule ID 12064 //
     /* 423099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 423102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 423110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 423114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 423118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423122 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 423128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 423130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 423132 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 423132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 423135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 423137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 423141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 423143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 423145 */     GIR_RootConstrainSelectedInstOperands,
     /* 423146 */     // GIR_Coverage, 12064,
     /* 423146 */     GIR_EraseRootFromParent_Done,
     /* 423147 */   // Label 8251: @423147
     /* 423147 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(423200), // Rule ID 12088 //
     /* 423152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 423155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 423163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 423167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 423171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423175 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 423181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 423183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 423185 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 423185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 423188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 423190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 423192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 423196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 423198 */     GIR_RootConstrainSelectedInstOperands,
     /* 423199 */     // GIR_Coverage, 12088,
     /* 423199 */     GIR_EraseRootFromParent_Done,
     /* 423200 */   // Label 8252: @423200
     /* 423200 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(423221), // Rule ID 12040 //
     /* 423205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 423208 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 423208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 423211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 423213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 423215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 423217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 423219 */     GIR_RootConstrainSelectedInstOperands,
     /* 423220 */     // GIR_Coverage, 12040,
     /* 423220 */     GIR_EraseRootFromParent_Done,
     /* 423221 */   // Label 8253: @423221
     /* 423221 */   GIM_Reject,
     /* 423222 */ // Label 8250: @423222
     /* 423222 */ GIM_Reject,
     /* 423223 */ // Label 8229: @423223
     /* 423223 */ GIM_Reject,
     /* 423224 */ // Label 125: @423224
     /* 423224 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8262*/ GIMT_Encode4(425206),
     /* 423235 */ /*GILLT_s64*//*Label 8254*/ GIMT_Encode4(423271), GIMT_Encode4(0),
     /* 423243 */ /*GILLT_v2s32*//*Label 8255*/ GIMT_Encode4(423466),
     /* 423247 */ /*GILLT_v2s64*//*Label 8256*/ GIMT_Encode4(423713),
     /* 423251 */ /*GILLT_v4s16*//*Label 8257*/ GIMT_Encode4(423960),
     /* 423255 */ /*GILLT_v4s32*//*Label 8258*/ GIMT_Encode4(424236),
     /* 423259 */ /*GILLT_v8s8*//*Label 8259*/ GIMT_Encode4(424483),
     /* 423263 */ /*GILLT_v8s16*//*Label 8260*/ GIMT_Encode4(424708),
     /* 423267 */ /*GILLT_v16s8*//*Label 8261*/ GIMT_Encode4(424984),
     /* 423271 */ // Label 8254: @423271
     /* 423271 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(423465),
     /* 423276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423283 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(423330), // Rule ID 6495 //
     /* 423288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423303 */     // MIs[1] Rn
     /* 423303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423314 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 423317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423328 */     GIR_RootConstrainSelectedInstOperands,
     /* 423329 */     // GIR_Coverage, 6495,
     /* 423329 */     GIR_EraseRootFromParent_Done,
     /* 423330 */   // Label 8264: @423330
     /* 423330 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(423377), // Rule ID 6506 //
     /* 423335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423343 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423350 */     // MIs[1] Rn
     /* 423350 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423361 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 423364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423375 */     GIR_RootConstrainSelectedInstOperands,
     /* 423376 */     // GIR_Coverage, 6506,
     /* 423376 */     GIR_EraseRootFromParent_Done,
     /* 423377 */   // Label 8265: @423377
     /* 423377 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(423424), // Rule ID 13454 //
     /* 423382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423397 */     // MIs[1] Rn
     /* 423397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423408 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 423411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423422 */     GIR_RootConstrainSelectedInstOperands,
     /* 423423 */     // GIR_Coverage, 13454,
     /* 423423 */     GIR_EraseRootFromParent_Done,
     /* 423424 */   // Label 8266: @423424
     /* 423424 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(423444), // Rule ID 5680 //
     /* 423429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 423433 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 423433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423443 */     // GIR_Coverage, 5680,
     /* 423443 */     GIR_Done,
     /* 423444 */   // Label 8267: @423444
     /* 423444 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(423464), // Rule ID 5681 //
     /* 423449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423453 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 423453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423463 */     // GIR_Coverage, 5681,
     /* 423463 */     GIR_Done,
     /* 423464 */   // Label 8268: @423464
     /* 423464 */   GIM_Reject,
     /* 423465 */ // Label 8263: @423465
     /* 423465 */ GIM_Reject,
     /* 423466 */ // Label 8255: @423466
     /* 423466 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(423712),
     /* 423471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423478 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(423525), // Rule ID 6492 //
     /* 423483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423498 */     // MIs[1] Rn
     /* 423498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423509 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423523 */     GIR_RootConstrainSelectedInstOperands,
     /* 423524 */     // GIR_Coverage, 6492,
     /* 423524 */     GIR_EraseRootFromParent_Done,
     /* 423525 */   // Label 8270: @423525
     /* 423525 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(423572), // Rule ID 6503 //
     /* 423530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423545 */     // MIs[1] Rn
     /* 423545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423556 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423570 */     GIR_RootConstrainSelectedInstOperands,
     /* 423571 */     // GIR_Coverage, 6503,
     /* 423571 */     GIR_EraseRootFromParent_Done,
     /* 423572 */   // Label 8271: @423572
     /* 423572 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(423619), // Rule ID 13451 //
     /* 423577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423592 */     // MIs[1] Rn
     /* 423592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423603 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423617 */     GIR_RootConstrainSelectedInstOperands,
     /* 423618 */     // GIR_Coverage, 13451,
     /* 423618 */     GIR_EraseRootFromParent_Done,
     /* 423619 */   // Label 8272: @423619
     /* 423619 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(423638), // Rule ID 1920 //
     /* 423624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423631 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 423631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 423636 */     GIR_RootConstrainSelectedInstOperands,
     /* 423637 */     // GIR_Coverage, 1920,
     /* 423637 */     GIR_Done,
     /* 423638 */   // Label 8273: @423638
     /* 423638 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(423711), // Rule ID 5682 //
     /* 423643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423647 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 423650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 423664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 423683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 423701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423709 */     GIR_RootConstrainSelectedInstOperands,
     /* 423710 */     // GIR_Coverage, 5682,
     /* 423710 */     GIR_EraseRootFromParent_Done,
     /* 423711 */   // Label 8274: @423711
     /* 423711 */   GIM_Reject,
     /* 423712 */ // Label 8269: @423712
     /* 423712 */ GIM_Reject,
     /* 423713 */ // Label 8256: @423713
     /* 423713 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(423959),
     /* 423718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423725 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(423772), // Rule ID 6494 //
     /* 423730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423745 */     // MIs[1] Rn
     /* 423745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423756 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423770 */     GIR_RootConstrainSelectedInstOperands,
     /* 423771 */     // GIR_Coverage, 6494,
     /* 423771 */     GIR_EraseRootFromParent_Done,
     /* 423772 */   // Label 8276: @423772
     /* 423772 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(423819), // Rule ID 6505 //
     /* 423777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423792 */     // MIs[1] Rn
     /* 423792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423803 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423817 */     GIR_RootConstrainSelectedInstOperands,
     /* 423818 */     // GIR_Coverage, 6505,
     /* 423818 */     GIR_EraseRootFromParent_Done,
     /* 423819 */   // Label 8277: @423819
     /* 423819 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(423866), // Rule ID 13453 //
     /* 423824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423839 */     // MIs[1] Rn
     /* 423839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423850 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423864 */     GIR_RootConstrainSelectedInstOperands,
     /* 423865 */     // GIR_Coverage, 13453,
     /* 423865 */     GIR_EraseRootFromParent_Done,
     /* 423866 */   // Label 8278: @423866
     /* 423866 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(423885), // Rule ID 1922 //
     /* 423871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 423878 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 423878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 423883 */     GIR_RootConstrainSelectedInstOperands,
     /* 423884 */     // GIR_Coverage, 1922,
     /* 423884 */     GIR_Done,
     /* 423885 */   // Label 8279: @423885
     /* 423885 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(423958), // Rule ID 5684 //
     /* 423890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423894 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 423897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 423911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 423930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423956 */     GIR_RootConstrainSelectedInstOperands,
     /* 423957 */     // GIR_Coverage, 5684,
     /* 423957 */     GIR_EraseRootFromParent_Done,
     /* 423958 */   // Label 8280: @423958
     /* 423958 */   GIM_Reject,
     /* 423959 */ // Label 8275: @423959
     /* 423959 */ GIM_Reject,
     /* 423960 */ // Label 8257: @423960
     /* 423960 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(424021), // Rule ID 6490 //
     /* 423965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423980 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423983 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423987 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 423994 */   // MIs[1] Rn
     /* 423994 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423998 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424003 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424005 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 424008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424010 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424019 */   GIR_RootConstrainSelectedInstOperands,
     /* 424020 */   // GIR_Coverage, 6490,
     /* 424020 */   GIR_EraseRootFromParent_Done,
     /* 424021 */ // Label 8281: @424021
     /* 424021 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(424075), // Rule ID 6507 //
     /* 424026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424041 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424048 */   // MIs[1] Rn
     /* 424048 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424059 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 424062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424073 */   GIR_RootConstrainSelectedInstOperands,
     /* 424074 */   // GIR_Coverage, 6507,
     /* 424074 */   GIR_EraseRootFromParent_Done,
     /* 424075 */ // Label 8282: @424075
     /* 424075 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(424129), // Rule ID 13449 //
     /* 424080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424095 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424102 */   // MIs[1] Rn
     /* 424102 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424106 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424111 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424113 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 424116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424118 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424127 */   GIR_RootConstrainSelectedInstOperands,
     /* 424128 */   // GIR_Coverage, 13449,
     /* 424128 */   GIR_EraseRootFromParent_Done,
     /* 424129 */ // Label 8283: @424129
     /* 424129 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(424155), // Rule ID 1918 //
     /* 424134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424148 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 424148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 424153 */   GIR_RootConstrainSelectedInstOperands,
     /* 424154 */   // GIR_Coverage, 1918,
     /* 424154 */   GIR_Done,
     /* 424155 */ // Label 8284: @424155
     /* 424155 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(424235), // Rule ID 5685 //
     /* 424160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424171 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 424174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 424188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424197 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424204 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 424207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 424225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424233 */   GIR_RootConstrainSelectedInstOperands,
     /* 424234 */   // GIR_Coverage, 5685,
     /* 424234 */   GIR_EraseRootFromParent_Done,
     /* 424235 */ // Label 8285: @424235
     /* 424235 */ GIM_Reject,
     /* 424236 */ // Label 8258: @424236
     /* 424236 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(424482),
     /* 424241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424248 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(424295), // Rule ID 6493 //
     /* 424253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424268 */     // MIs[1] Rn
     /* 424268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424279 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 424282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424293 */     GIR_RootConstrainSelectedInstOperands,
     /* 424294 */     // GIR_Coverage, 6493,
     /* 424294 */     GIR_EraseRootFromParent_Done,
     /* 424295 */   // Label 8287: @424295
     /* 424295 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(424342), // Rule ID 6504 //
     /* 424300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424315 */     // MIs[1] Rn
     /* 424315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424326 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 424329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424340 */     GIR_RootConstrainSelectedInstOperands,
     /* 424341 */     // GIR_Coverage, 6504,
     /* 424341 */     GIR_EraseRootFromParent_Done,
     /* 424342 */   // Label 8288: @424342
     /* 424342 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(424389), // Rule ID 13452 //
     /* 424347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424355 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424362 */     // MIs[1] Rn
     /* 424362 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424373 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 424376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424387 */     GIR_RootConstrainSelectedInstOperands,
     /* 424388 */     // GIR_Coverage, 13452,
     /* 424388 */     GIR_EraseRootFromParent_Done,
     /* 424389 */   // Label 8289: @424389
     /* 424389 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(424408), // Rule ID 1921 //
     /* 424394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424401 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 424401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 424406 */     GIR_RootConstrainSelectedInstOperands,
     /* 424407 */     // GIR_Coverage, 1921,
     /* 424407 */     GIR_Done,
     /* 424408 */   // Label 8290: @424408
     /* 424408 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(424481), // Rule ID 5683 //
     /* 424413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424417 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 424420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 424434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 424453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424479 */     GIR_RootConstrainSelectedInstOperands,
     /* 424480 */     // GIR_Coverage, 5683,
     /* 424480 */     GIR_EraseRootFromParent_Done,
     /* 424481 */   // Label 8291: @424481
     /* 424481 */   GIM_Reject,
     /* 424482 */ // Label 8286: @424482
     /* 424482 */ GIM_Reject,
     /* 424483 */ // Label 8259: @424483
     /* 424483 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(424540), // Rule ID 13447 //
     /* 424488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424503 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424510 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 424514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424516 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 424523 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 424526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 424533 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424538 */   GIR_RootConstrainSelectedInstOperands,
     /* 424539 */   // GIR_Coverage, 13447,
     /* 424539 */   GIR_EraseRootFromParent_Done,
     /* 424540 */ // Label 8292: @424540
     /* 424540 */ GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(424601), // Rule ID 6488 //
     /* 424545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424560 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424563 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424567 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 424574 */   // MIs[1] Rn
     /* 424574 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424578 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424585 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 424588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424590 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424599 */   GIR_RootConstrainSelectedInstOperands,
     /* 424600 */   // GIR_Coverage, 6488,
     /* 424600 */   GIR_EraseRootFromParent_Done,
     /* 424601 */ // Label 8293: @424601
     /* 424601 */ GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(424627), // Rule ID 1916 //
     /* 424606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424620 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 424620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 424625 */   GIR_RootConstrainSelectedInstOperands,
     /* 424626 */   // GIR_Coverage, 1916,
     /* 424626 */   GIR_Done,
     /* 424627 */ // Label 8294: @424627
     /* 424627 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(424707), // Rule ID 5687 //
     /* 424632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424643 */   // (AArch64dup:{ *:[v8i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv8i8lane:{ *:[v8i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 424646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 424660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424669 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424672 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424676 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 424679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 424697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424705 */   GIR_RootConstrainSelectedInstOperands,
     /* 424706 */   // GIR_Coverage, 5687,
     /* 424706 */   GIR_EraseRootFromParent_Done,
     /* 424707 */ // Label 8295: @424707
     /* 424707 */ GIM_Reject,
     /* 424708 */ // Label 8260: @424708
     /* 424708 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(424769), // Rule ID 6491 //
     /* 424713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424728 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424731 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424735 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 424742 */   // MIs[1] Rn
     /* 424742 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424746 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424753 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424758 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424767 */   GIR_RootConstrainSelectedInstOperands,
     /* 424768 */   // GIR_Coverage, 6491,
     /* 424768 */   GIR_EraseRootFromParent_Done,
     /* 424769 */ // Label 8296: @424769
     /* 424769 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(424823), // Rule ID 6508 //
     /* 424774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424796 */   // MIs[1] Rn
     /* 424796 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424800 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424807 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424812 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424821 */   GIR_RootConstrainSelectedInstOperands,
     /* 424822 */   // GIR_Coverage, 6508,
     /* 424822 */   GIR_EraseRootFromParent_Done,
     /* 424823 */ // Label 8297: @424823
     /* 424823 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(424877), // Rule ID 13450 //
     /* 424828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424843 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424850 */   // MIs[1] Rn
     /* 424850 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424861 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424866 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424875 */   GIR_RootConstrainSelectedInstOperands,
     /* 424876 */   // GIR_Coverage, 13450,
     /* 424876 */   GIR_EraseRootFromParent_Done,
     /* 424877 */ // Label 8298: @424877
     /* 424877 */ GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(424903), // Rule ID 1919 //
     /* 424882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424896 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 424896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 424901 */   GIR_RootConstrainSelectedInstOperands,
     /* 424902 */   // GIR_Coverage, 1919,
     /* 424902 */   GIR_Done,
     /* 424903 */ // Label 8299: @424903
     /* 424903 */ GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(424983), // Rule ID 5686 //
     /* 424908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424919 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424919 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 424922 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424926 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 424936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424945 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424948 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424952 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 424955 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 424973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424981 */   GIR_RootConstrainSelectedInstOperands,
     /* 424982 */   // GIR_Coverage, 5686,
     /* 424982 */   GIR_EraseRootFromParent_Done,
     /* 424983 */ // Label 8300: @424983
     /* 424983 */ GIM_Reject,
     /* 424984 */ // Label 8261: @424984
     /* 424984 */ GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(425045), // Rule ID 6489 //
     /* 424989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425004 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425007 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425011 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 425018 */   // MIs[1] Rn
     /* 425018 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425029 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 425032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425034 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425043 */   GIR_RootConstrainSelectedInstOperands,
     /* 425044 */   // GIR_Coverage, 6489,
     /* 425044 */   GIR_EraseRootFromParent_Done,
     /* 425045 */ // Label 8301: @425045
     /* 425045 */ GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(425099), // Rule ID 13448 //
     /* 425050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 425053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425065 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425072 */   // MIs[1] Rn
     /* 425072 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425076 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425083 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 425086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425088 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425097 */   GIR_RootConstrainSelectedInstOperands,
     /* 425098 */   // GIR_Coverage, 13448,
     /* 425098 */   GIR_EraseRootFromParent_Done,
     /* 425099 */ // Label 8302: @425099
     /* 425099 */ GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(425125), // Rule ID 1917 //
     /* 425104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 425118 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 425118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 425123 */   GIR_RootConstrainSelectedInstOperands,
     /* 425124 */   // GIR_Coverage, 1917,
     /* 425124 */   GIR_Done,
     /* 425125 */ // Label 8303: @425125
     /* 425125 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(425205), // Rule ID 5688 //
     /* 425130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 425133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 425141 */   // (AArch64dup:{ *:[v16i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv16i8lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 425141 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 425144 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 425148 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 425155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 425158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 425162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425167 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 425170 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 425174 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 425177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 425192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 425195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 425200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425203 */   GIR_RootConstrainSelectedInstOperands,
     /* 425204 */   // GIR_Coverage, 5688,
     /* 425204 */   GIR_EraseRootFromParent_Done,
     /* 425205 */ // Label 8304: @425205
     /* 425205 */ GIM_Reject,
     /* 425206 */ // Label 8262: @425206
     /* 425206 */ GIM_Reject,
     /* 425207 */ // Label 126: @425207
     /* 425207 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8307*/ GIMT_Encode4(425461),
     /* 425218 */ /*GILLT_v4s16*//*Label 8305*/ GIMT_Encode4(425234), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 425230 */ /*GILLT_v8s16*//*Label 8306*/ GIMT_Encode4(425320),
     /* 425234 */ // Label 8305: @425234
     /* 425234 */ GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(425319),
     /* 425239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425253 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(425287), // Rule ID 1926 //
     /* 425258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425273 */     // MIs[1] Operand 1
     /* 425273 */     // No operand predicates
     /* 425273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425275 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 425278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425285 */     GIR_RootConstrainSelectedInstOperands,
     /* 425286 */     // GIR_Coverage, 1926,
     /* 425286 */     GIR_EraseRootFromParent_Done,
     /* 425287 */   // Label 8309: @425287
     /* 425287 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(425318), // Rule ID 5689 //
     /* 425292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425304 */     // MIs[1] Operand 1
     /* 425304 */     // No operand predicates
     /* 425304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425306 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 425306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 425309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425316 */     GIR_RootConstrainSelectedInstOperands,
     /* 425317 */     // GIR_Coverage, 5689,
     /* 425317 */     GIR_EraseRootFromParent_Done,
     /* 425318 */   // Label 8310: @425318
     /* 425318 */   GIM_Reject,
     /* 425319 */ // Label 8308: @425319
     /* 425319 */ GIM_Reject,
     /* 425320 */ // Label 8306: @425320
     /* 425320 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(425460),
     /* 425325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425335 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(425386), // Rule ID 6499 //
     /* 425340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425355 */     // MIs[1] Rn
     /* 425355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425370 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 425373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425384 */     GIR_RootConstrainSelectedInstOperands,
     /* 425385 */     // GIR_Coverage, 6499,
     /* 425385 */     GIR_EraseRootFromParent_Done,
     /* 425386 */   // Label 8312: @425386
     /* 425386 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(425424), // Rule ID 1927 //
     /* 425391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425410 */     // MIs[1] Operand 1
     /* 425410 */     // No operand predicates
     /* 425410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425412 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 425415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425422 */     GIR_RootConstrainSelectedInstOperands,
     /* 425423 */     // GIR_Coverage, 1927,
     /* 425423 */     GIR_EraseRootFromParent_Done,
     /* 425424 */   // Label 8313: @425424
     /* 425424 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(425459), // Rule ID 5690 //
     /* 425429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425445 */     // MIs[1] Operand 1
     /* 425445 */     // No operand predicates
     /* 425445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425447 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 425447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 425450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425457 */     GIR_RootConstrainSelectedInstOperands,
     /* 425458 */     // GIR_Coverage, 5690,
     /* 425458 */     GIR_EraseRootFromParent_Done,
     /* 425459 */   // Label 8314: @425459
     /* 425459 */   GIM_Reject,
     /* 425460 */ // Label 8311: @425460
     /* 425460 */ GIM_Reject,
     /* 425461 */ // Label 8307: @425461
     /* 425461 */ GIM_Reject,
     /* 425462 */ // Label 127: @425462
     /* 425462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8317*/ GIMT_Encode4(425716),
     /* 425473 */ /*GILLT_v2s32*//*Label 8315*/ GIMT_Encode4(425489), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 425485 */ /*GILLT_v4s32*//*Label 8316*/ GIMT_Encode4(425575),
     /* 425489 */ // Label 8315: @425489
     /* 425489 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(425574),
     /* 425494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425508 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(425542), // Rule ID 1924 //
     /* 425513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425528 */     // MIs[1] Operand 1
     /* 425528 */     // No operand predicates
     /* 425528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425530 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 425533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425540 */     GIR_RootConstrainSelectedInstOperands,
     /* 425541 */     // GIR_Coverage, 1924,
     /* 425541 */     GIR_EraseRootFromParent_Done,
     /* 425542 */   // Label 8319: @425542
     /* 425542 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(425573), // Rule ID 5691 //
     /* 425547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425559 */     // MIs[1] Operand 1
     /* 425559 */     // No operand predicates
     /* 425559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425561 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 425561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 425564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425571 */     GIR_RootConstrainSelectedInstOperands,
     /* 425572 */     // GIR_Coverage, 5691,
     /* 425572 */     GIR_EraseRootFromParent_Done,
     /* 425573 */   // Label 8320: @425573
     /* 425573 */   GIM_Reject,
     /* 425574 */ // Label 8318: @425574
     /* 425574 */ GIM_Reject,
     /* 425575 */ // Label 8316: @425575
     /* 425575 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(425715),
     /* 425580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425590 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(425641), // Rule ID 6501 //
     /* 425595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425610 */     // MIs[1] Rn
     /* 425610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425625 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 425628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425639 */     GIR_RootConstrainSelectedInstOperands,
     /* 425640 */     // GIR_Coverage, 6501,
     /* 425640 */     GIR_EraseRootFromParent_Done,
     /* 425641 */   // Label 8322: @425641
     /* 425641 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(425679), // Rule ID 1925 //
     /* 425646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425665 */     // MIs[1] Operand 1
     /* 425665 */     // No operand predicates
     /* 425665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425667 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 425670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425677 */     GIR_RootConstrainSelectedInstOperands,
     /* 425678 */     // GIR_Coverage, 1925,
     /* 425678 */     GIR_EraseRootFromParent_Done,
     /* 425679 */   // Label 8323: @425679
     /* 425679 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(425714), // Rule ID 5692 //
     /* 425684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425700 */     // MIs[1] Operand 1
     /* 425700 */     // No operand predicates
     /* 425700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425702 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 425702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 425705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425712 */     GIR_RootConstrainSelectedInstOperands,
     /* 425713 */     // GIR_Coverage, 5692,
     /* 425713 */     GIR_EraseRootFromParent_Done,
     /* 425714 */   // Label 8324: @425714
     /* 425714 */   GIM_Reject,
     /* 425715 */ // Label 8321: @425715
     /* 425715 */ GIM_Reject,
     /* 425716 */ // Label 8317: @425716
     /* 425716 */ GIM_Reject,
     /* 425717 */ // Label 128: @425717
     /* 425717 */ GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(425862),
     /* 425722 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 425725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425735 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(425786), // Rule ID 6502 //
     /* 425740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425748 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425755 */     // MIs[1] Rn
     /* 425755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425770 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 425773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425784 */     GIR_RootConstrainSelectedInstOperands,
     /* 425785 */     // GIR_Coverage, 6502,
     /* 425785 */     GIR_EraseRootFromParent_Done,
     /* 425786 */   // Label 8326: @425786
     /* 425786 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(425861),
     /* 425791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425795 */     GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(425829), // Rule ID 1923 //
     /* 425800 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425803 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425807 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425811 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 425815 */       // MIs[1] Operand 1
     /* 425815 */       // No operand predicates
     /* 425815 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425817 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425817 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 425820 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425822 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425824 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425827 */       GIR_RootConstrainSelectedInstOperands,
     /* 425828 */       // GIR_Coverage, 1923,
     /* 425828 */       GIR_EraseRootFromParent_Done,
     /* 425829 */     // Label 8328: @425829
     /* 425829 */     GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(425860), // Rule ID 5693 //
     /* 425834 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425838 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425842 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 425846 */       // MIs[1] Operand 1
     /* 425846 */       // No operand predicates
     /* 425846 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425848 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 425848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 425851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425853 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425855 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425858 */       GIR_RootConstrainSelectedInstOperands,
     /* 425859 */       // GIR_Coverage, 5693,
     /* 425859 */       GIR_EraseRootFromParent_Done,
     /* 425860 */     // Label 8329: @425860
     /* 425860 */     GIM_Reject,
     /* 425861 */   // Label 8327: @425861
     /* 425861 */   GIM_Reject,
     /* 425862 */ // Label 8325: @425862
     /* 425862 */ GIM_Reject,
     /* 425863 */ // Label 129: @425863
     /* 425863 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8332*/ GIMT_Encode4(426041),
     /* 425874 */ /*GILLT_v8s8*//*Label 8330*/ GIMT_Encode4(425886), GIMT_Encode4(0),
     /* 425882 */ /*GILLT_v16s8*//*Label 8331*/ GIMT_Encode4(425935),
     /* 425886 */ // Label 8330: @425886
     /* 425886 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(425934), // Rule ID 1928 //
     /* 425891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425916 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 425920 */   // MIs[1] Operand 1
     /* 425920 */   // No operand predicates
     /* 425920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425922 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 425925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425927 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425929 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425932 */   GIR_RootConstrainSelectedInstOperands,
     /* 425933 */   // GIR_Coverage, 1928,
     /* 425933 */   GIR_EraseRootFromParent_Done,
     /* 425934 */ // Label 8333: @425934
     /* 425934 */ GIM_Reject,
     /* 425935 */ // Label 8331: @425935
     /* 425935 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(426040),
     /* 425940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425950 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(426001), // Rule ID 6497 //
     /* 425955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425963 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425970 */     // MIs[1] Rn
     /* 425970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425985 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 425988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425999 */     GIR_RootConstrainSelectedInstOperands,
     /* 426000 */     // GIR_Coverage, 6497,
     /* 426000 */     GIR_EraseRootFromParent_Done,
     /* 426001 */   // Label 8335: @426001
     /* 426001 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(426039), // Rule ID 1929 //
     /* 426006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 426025 */     // MIs[1] Operand 1
     /* 426025 */     // No operand predicates
     /* 426025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426027 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 426027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 426030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 426037 */     GIR_RootConstrainSelectedInstOperands,
     /* 426038 */     // GIR_Coverage, 1929,
     /* 426038 */     GIR_EraseRootFromParent_Done,
     /* 426039 */   // Label 8336: @426039
     /* 426039 */   GIM_Reject,
     /* 426040 */ // Label 8334: @426040
     /* 426040 */ GIM_Reject,
     /* 426041 */ // Label 8332: @426041
     /* 426041 */ GIM_Reject,
     /* 426042 */ // Label 130: @426042
     /* 426042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8346*/ GIMT_Encode4(427691),
     /* 426053 */ /*GILLT_s64*//*Label 8337*/ GIMT_Encode4(426137), GIMT_Encode4(0),
     /* 426061 */ /*GILLT_v2s32*//*Label 8338*/ GIMT_Encode4(426458),
     /* 426065 */ /*GILLT_v2s64*//*Label 8339*/ GIMT_Encode4(426779),
     /* 426069 */ /*GILLT_v4s16*//*Label 8340*/ GIMT_Encode4(426862),
     /* 426073 */ /*GILLT_v4s32*//*Label 8341*/ GIMT_Encode4(427183),
     /* 426077 */ /*GILLT_v8s8*//*Label 8342*/ GIMT_Encode4(427266),
     /* 426081 */ /*GILLT_v8s16*//*Label 8343*/ GIMT_Encode4(427475),
     /* 426085 */ /*GILLT_v16s8*//*Label 8344*/ GIMT_Encode4(427558), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 426133 */ /*GILLT_nxv16s8*//*Label 8345*/ GIMT_Encode4(427644),
     /* 426137 */ // Label 8337: @426137
     /* 426137 */ GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(426457),
     /* 426142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426152 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(426267), // Rule ID 5508 //
     /* 426157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426174 */     // MIs[1] Operand 2
     /* 426174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426193 */     // MIs[2] Rn
     /* 426193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426198 */     // MIs[2] Operand 2
     /* 426198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 426209 */     // MIs[0] imm
     /* 426209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426217 */     // MIs[3] Operand 1
     /* 426217 */     // No operand predicates
     /* 426217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426219 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426249 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426266 */     // GIR_Coverage, 5508,
     /* 426266 */     GIR_EraseRootFromParent_Done,
     /* 426267 */   // Label 8348: @426267
     /* 426267 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(426382), // Rule ID 5513 //
     /* 426272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426289 */     // MIs[1] Operand 2
     /* 426289 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426308 */     // MIs[2] Rn
     /* 426308 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426313 */     // MIs[2] Operand 2
     /* 426313 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 426324 */     // MIs[0] imm
     /* 426324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426332 */     // MIs[3] Operand 1
     /* 426332 */     // No operand predicates
     /* 426332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426334 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426364 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426381 */     // GIR_Coverage, 5513,
     /* 426381 */     GIR_EraseRootFromParent_Done,
     /* 426382 */   // Label 8349: @426382
     /* 426382 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(426419), // Rule ID 5505 //
     /* 426387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426395 */     // MIs[0] imm
     /* 426395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426403 */     // MIs[1] Operand 1
     /* 426403 */     // No operand predicates
     /* 426403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426405 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426417 */     GIR_RootConstrainSelectedInstOperands,
     /* 426418 */     // GIR_Coverage, 5505,
     /* 426418 */     GIR_EraseRootFromParent_Done,
     /* 426419 */   // Label 8350: @426419
     /* 426419 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(426456), // Rule ID 5510 //
     /* 426424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426432 */     // MIs[0] imm
     /* 426432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426440 */     // MIs[1] Operand 1
     /* 426440 */     // No operand predicates
     /* 426440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426442 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426454 */     GIR_RootConstrainSelectedInstOperands,
     /* 426455 */     // GIR_Coverage, 5510,
     /* 426455 */     GIR_EraseRootFromParent_Done,
     /* 426456 */   // Label 8351: @426456
     /* 426456 */   GIM_Reject,
     /* 426457 */ // Label 8347: @426457
     /* 426457 */ GIM_Reject,
     /* 426458 */ // Label 8338: @426458
     /* 426458 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(426778),
     /* 426463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426473 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(426588), // Rule ID 5498 //
     /* 426478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426495 */     // MIs[1] Operand 2
     /* 426495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426514 */     // MIs[2] Rn
     /* 426514 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426519 */     // MIs[2] Operand 2
     /* 426519 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 426530 */     // MIs[0] imm
     /* 426530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426538 */     // MIs[3] Operand 1
     /* 426538 */     // No operand predicates
     /* 426538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426540 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426570 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426587 */     // GIR_Coverage, 5498,
     /* 426587 */     GIR_EraseRootFromParent_Done,
     /* 426588 */   // Label 8353: @426588
     /* 426588 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(426703), // Rule ID 5503 //
     /* 426593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426610 */     // MIs[1] Operand 2
     /* 426610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426629 */     // MIs[2] Rn
     /* 426629 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426634 */     // MIs[2] Operand 2
     /* 426634 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 426645 */     // MIs[0] imm
     /* 426645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426653 */     // MIs[3] Operand 1
     /* 426653 */     // No operand predicates
     /* 426653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426655 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426702 */     // GIR_Coverage, 5503,
     /* 426702 */     GIR_EraseRootFromParent_Done,
     /* 426703 */   // Label 8354: @426703
     /* 426703 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(426740), // Rule ID 5495 //
     /* 426708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426716 */     // MIs[0] imm
     /* 426716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426724 */     // MIs[1] Operand 1
     /* 426724 */     // No operand predicates
     /* 426724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426726 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426738 */     GIR_RootConstrainSelectedInstOperands,
     /* 426739 */     // GIR_Coverage, 5495,
     /* 426739 */     GIR_EraseRootFromParent_Done,
     /* 426740 */   // Label 8355: @426740
     /* 426740 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(426777), // Rule ID 5500 //
     /* 426745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426753 */     // MIs[0] imm
     /* 426753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426761 */     // MIs[1] Operand 1
     /* 426761 */     // No operand predicates
     /* 426761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426763 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426775 */     GIR_RootConstrainSelectedInstOperands,
     /* 426776 */     // GIR_Coverage, 5500,
     /* 426776 */     GIR_EraseRootFromParent_Done,
     /* 426777 */   // Label 8356: @426777
     /* 426777 */   GIM_Reject,
     /* 426778 */ // Label 8352: @426778
     /* 426778 */ GIM_Reject,
     /* 426779 */ // Label 8339: @426779
     /* 426779 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(426861),
     /* 426784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426802 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(426831), // Rule ID 5506 //
     /* 426807 */     // MIs[0] imm
     /* 426807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426815 */     // MIs[1] Operand 1
     /* 426815 */     // No operand predicates
     /* 426815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426817 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426829 */     GIR_RootConstrainSelectedInstOperands,
     /* 426830 */     // GIR_Coverage, 5506,
     /* 426830 */     GIR_EraseRootFromParent_Done,
     /* 426831 */   // Label 8358: @426831
     /* 426831 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(426860), // Rule ID 5511 //
     /* 426836 */     // MIs[0] imm
     /* 426836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426844 */     // MIs[1] Operand 1
     /* 426844 */     // No operand predicates
     /* 426844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426846 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426858 */     GIR_RootConstrainSelectedInstOperands,
     /* 426859 */     // GIR_Coverage, 5511,
     /* 426859 */     GIR_EraseRootFromParent_Done,
     /* 426860 */   // Label 8359: @426860
     /* 426860 */   GIM_Reject,
     /* 426861 */ // Label 8357: @426861
     /* 426861 */ GIM_Reject,
     /* 426862 */ // Label 8340: @426862
     /* 426862 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(427182),
     /* 426867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426877 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(426992), // Rule ID 5488 //
     /* 426882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426899 */     // MIs[1] Operand 2
     /* 426899 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426918 */     // MIs[2] Rn
     /* 426918 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426923 */     // MIs[2] Operand 2
     /* 426923 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 426934 */     // MIs[0] imm
     /* 426934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426942 */     // MIs[3] Operand 1
     /* 426942 */     // No operand predicates
     /* 426942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426944 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426974 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426991 */     // GIR_Coverage, 5488,
     /* 426991 */     GIR_EraseRootFromParent_Done,
     /* 426992 */   // Label 8361: @426992
     /* 426992 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(427107), // Rule ID 5493 //
     /* 426997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 427005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427014 */     // MIs[1] Operand 2
     /* 427014 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 427025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 427033 */     // MIs[2] Rn
     /* 427033 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 427038 */     // MIs[2] Operand 2
     /* 427038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 427049 */     // MIs[0] imm
     /* 427049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 427053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427057 */     // MIs[3] Operand 1
     /* 427057 */     // No operand predicates
     /* 427057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427059 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 427059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 427062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 427071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 427082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 427084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 427087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 427089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 427096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427106 */     // GIR_Coverage, 5493,
     /* 427106 */     GIR_EraseRootFromParent_Done,
     /* 427107 */   // Label 8362: @427107
     /* 427107 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(427144), // Rule ID 5485 //
     /* 427112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427120 */     // MIs[0] imm
     /* 427120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427128 */     // MIs[1] Operand 1
     /* 427128 */     // No operand predicates
     /* 427128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427130 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427142 */     GIR_RootConstrainSelectedInstOperands,
     /* 427143 */     // GIR_Coverage, 5485,
     /* 427143 */     GIR_EraseRootFromParent_Done,
     /* 427144 */   // Label 8363: @427144
     /* 427144 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(427181), // Rule ID 5490 //
     /* 427149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427157 */     // MIs[0] imm
     /* 427157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427165 */     // MIs[1] Operand 1
     /* 427165 */     // No operand predicates
     /* 427165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427167 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427179 */     GIR_RootConstrainSelectedInstOperands,
     /* 427180 */     // GIR_Coverage, 5490,
     /* 427180 */     GIR_EraseRootFromParent_Done,
     /* 427181 */   // Label 8364: @427181
     /* 427181 */   GIM_Reject,
     /* 427182 */ // Label 8360: @427182
     /* 427182 */ GIM_Reject,
     /* 427183 */ // Label 8341: @427183
     /* 427183 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(427265),
     /* 427188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427206 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(427235), // Rule ID 5496 //
     /* 427211 */     // MIs[0] imm
     /* 427211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427219 */     // MIs[1] Operand 1
     /* 427219 */     // No operand predicates
     /* 427219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427221 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427233 */     GIR_RootConstrainSelectedInstOperands,
     /* 427234 */     // GIR_Coverage, 5496,
     /* 427234 */     GIR_EraseRootFromParent_Done,
     /* 427235 */   // Label 8366: @427235
     /* 427235 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(427264), // Rule ID 5501 //
     /* 427240 */     // MIs[0] imm
     /* 427240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427248 */     // MIs[1] Operand 1
     /* 427248 */     // No operand predicates
     /* 427248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427250 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427262 */     GIR_RootConstrainSelectedInstOperands,
     /* 427263 */     // GIR_Coverage, 5501,
     /* 427263 */     GIR_EraseRootFromParent_Done,
     /* 427264 */   // Label 8367: @427264
     /* 427264 */   GIM_Reject,
     /* 427265 */ // Label 8365: @427265
     /* 427265 */ GIM_Reject,
     /* 427266 */ // Label 8342: @427266
     /* 427266 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(427474),
     /* 427271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 427277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427281 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(427396), // Rule ID 5483 //
     /* 427286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 427294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427303 */     // MIs[1] Operand 2
     /* 427303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 427314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 427322 */     // MIs[2] Rn
     /* 427322 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 427327 */     // MIs[2] Operand 2
     /* 427327 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 427338 */     // MIs[0] imm
     /* 427338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 427342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427346 */     // MIs[3] Operand 1
     /* 427346 */     // No operand predicates
     /* 427346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427348 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 427348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 427351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 427360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 427371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 427373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 427376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 427378 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 427385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427395 */     // GIR_Coverage, 5483,
     /* 427395 */     GIR_EraseRootFromParent_Done,
     /* 427396 */   // Label 8369: @427396
     /* 427396 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(427436), // Rule ID 1872 //
     /* 427401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427412 */     // MIs[0] imm
     /* 427412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427420 */     // MIs[1] Operand 1
     /* 427420 */     // No operand predicates
     /* 427420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427422 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427434 */     GIR_RootConstrainSelectedInstOperands,
     /* 427435 */     // GIR_Coverage, 1872,
     /* 427435 */     GIR_EraseRootFromParent_Done,
     /* 427436 */   // Label 8370: @427436
     /* 427436 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(427473), // Rule ID 5480 //
     /* 427441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427449 */     // MIs[0] imm
     /* 427449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427457 */     // MIs[1] Operand 1
     /* 427457 */     // No operand predicates
     /* 427457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427459 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427471 */     GIR_RootConstrainSelectedInstOperands,
     /* 427472 */     // GIR_Coverage, 5480,
     /* 427472 */     GIR_EraseRootFromParent_Done,
     /* 427473 */   // Label 8371: @427473
     /* 427473 */   GIM_Reject,
     /* 427474 */ // Label 8368: @427474
     /* 427474 */ GIM_Reject,
     /* 427475 */ // Label 8343: @427475
     /* 427475 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(427557),
     /* 427480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427498 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(427527), // Rule ID 5486 //
     /* 427503 */     // MIs[0] imm
     /* 427503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427511 */     // MIs[1] Operand 1
     /* 427511 */     // No operand predicates
     /* 427511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427513 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427525 */     GIR_RootConstrainSelectedInstOperands,
     /* 427526 */     // GIR_Coverage, 5486,
     /* 427526 */     GIR_EraseRootFromParent_Done,
     /* 427527 */   // Label 8373: @427527
     /* 427527 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(427556), // Rule ID 5491 //
     /* 427532 */     // MIs[0] imm
     /* 427532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427540 */     // MIs[1] Operand 1
     /* 427540 */     // No operand predicates
     /* 427540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427542 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427554 */     GIR_RootConstrainSelectedInstOperands,
     /* 427555 */     // GIR_Coverage, 5491,
     /* 427555 */     GIR_EraseRootFromParent_Done,
     /* 427556 */   // Label 8374: @427556
     /* 427556 */   GIM_Reject,
     /* 427557 */ // Label 8372: @427557
     /* 427557 */ GIM_Reject,
     /* 427558 */ // Label 8344: @427558
     /* 427558 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(427643),
     /* 427563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 427569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427581 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(427613), // Rule ID 1873 //
     /* 427586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427589 */     // MIs[0] imm
     /* 427589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427597 */     // MIs[1] Operand 1
     /* 427597 */     // No operand predicates
     /* 427597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427599 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427611 */     GIR_RootConstrainSelectedInstOperands,
     /* 427612 */     // GIR_Coverage, 1873,
     /* 427612 */     GIR_EraseRootFromParent_Done,
     /* 427613 */   // Label 8376: @427613
     /* 427613 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(427642), // Rule ID 5481 //
     /* 427618 */     // MIs[0] imm
     /* 427618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427626 */     // MIs[1] Operand 1
     /* 427626 */     // No operand predicates
     /* 427626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427628 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427640 */     GIR_RootConstrainSelectedInstOperands,
     /* 427641 */     // GIR_Coverage, 5481,
     /* 427641 */     GIR_EraseRootFromParent_Done,
     /* 427642 */   // Label 8377: @427642
     /* 427642 */   GIM_Reject,
     /* 427643 */ // Label 8375: @427643
     /* 427643 */ GIM_Reject,
     /* 427644 */ // Label 8345: @427644
     /* 427644 */ GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(427690), // Rule ID 2733 //
     /* 427649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 427652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 427655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 427658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 427662 */   // MIs[0] Op3
     /* 427662 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427670 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 427674 */   // MIs[1] Operand 1
     /* 427674 */   // No operand predicates
     /* 427674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427676 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 427676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 427679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 427681 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 427683 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 427685 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 427688 */   GIR_RootConstrainSelectedInstOperands,
     /* 427689 */   // GIR_Coverage, 2733,
     /* 427689 */   GIR_EraseRootFromParent_Done,
     /* 427690 */ // Label 8378: @427690
     /* 427690 */ GIM_Reject,
     /* 427691 */ // Label 8346: @427691
     /* 427691 */ GIM_Reject,
     /* 427692 */ // Label 131: @427692
     /* 427692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8386*/ GIMT_Encode4(428250),
     /* 427703 */ /*GILLT_s32*//*Label 8379*/ GIMT_Encode4(427739),
     /* 427707 */ /*GILLT_s64*//*Label 8380*/ GIMT_Encode4(427777), GIMT_Encode4(0),
     /* 427715 */ /*GILLT_v2s32*//*Label 8381*/ GIMT_Encode4(427875),
     /* 427719 */ /*GILLT_v2s64*//*Label 8382*/ GIMT_Encode4(427950),
     /* 427723 */ /*GILLT_v4s16*//*Label 8383*/ GIMT_Encode4(428025),
     /* 427727 */ /*GILLT_v4s32*//*Label 8384*/ GIMT_Encode4(428100), GIMT_Encode4(0),
     /* 427735 */ /*GILLT_v8s16*//*Label 8385*/ GIMT_Encode4(428175),
     /* 427739 */ // Label 8379: @427739
     /* 427739 */ GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(427776), // Rule ID 1626 //
     /* 427744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 427753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427765 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 427765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 427770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427774 */   GIR_RootConstrainSelectedInstOperands,
     /* 427775 */   // GIR_Coverage, 1626,
     /* 427775 */   GIR_Done,
     /* 427776 */ // Label 8387: @427776
     /* 427776 */ GIM_Reject,
     /* 427777 */ // Label 8380: @427777
     /* 427777 */ GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(427874),
     /* 427782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 427788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427796 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(427827), // Rule ID 2513 //
     /* 427801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427808 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427814 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427818 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 427821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427825 */     GIR_RootConstrainSelectedInstOperands,
     /* 427826 */     // GIR_Coverage, 2513,
     /* 427826 */     GIR_EraseRootFromParent_Done,
     /* 427827 */   // Label 8389: @427827
     /* 427827 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(427850), // Rule ID 1625 //
     /* 427832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427839 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 427839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 427844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427848 */     GIR_RootConstrainSelectedInstOperands,
     /* 427849 */     // GIR_Coverage, 1625,
     /* 427849 */     GIR_Done,
     /* 427850 */   // Label 8390: @427850
     /* 427850 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(427873), // Rule ID 5260 //
     /* 427855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427862 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 427862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 427867 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427871 */     GIR_RootConstrainSelectedInstOperands,
     /* 427872 */     // GIR_Coverage, 5260,
     /* 427872 */     GIR_Done,
     /* 427873 */   // Label 8391: @427873
     /* 427873 */   GIM_Reject,
     /* 427874 */ // Label 8388: @427874
     /* 427874 */ GIM_Reject,
     /* 427875 */ // Label 8381: @427875
     /* 427875 */ GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(427949),
     /* 427880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 427886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427894 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(427925), // Rule ID 777 //
     /* 427899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427906 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427912 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427916 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 427919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427923 */     GIR_RootConstrainSelectedInstOperands,
     /* 427924 */     // GIR_Coverage, 777,
     /* 427924 */     GIR_EraseRootFromParent_Done,
     /* 427925 */   // Label 8393: @427925
     /* 427925 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(427948), // Rule ID 1214 //
     /* 427930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427937 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 427942 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427946 */     GIR_RootConstrainSelectedInstOperands,
     /* 427947 */     // GIR_Coverage, 1214,
     /* 427947 */     GIR_Done,
     /* 427948 */   // Label 8394: @427948
     /* 427948 */   GIM_Reject,
     /* 427949 */ // Label 8392: @427949
     /* 427949 */ GIM_Reject,
     /* 427950 */ // Label 8382: @427950
     /* 427950 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(428024),
     /* 427955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427969 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(428000), // Rule ID 779 //
     /* 427974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427981 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427987 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427991 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 427994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427998 */     GIR_RootConstrainSelectedInstOperands,
     /* 427999 */     // GIR_Coverage, 779,
     /* 427999 */     GIR_EraseRootFromParent_Done,
     /* 428000 */   // Label 8396: @428000
     /* 428000 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(428023), // Rule ID 1216 //
     /* 428005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428012 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 428017 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428021 */     GIR_RootConstrainSelectedInstOperands,
     /* 428022 */     // GIR_Coverage, 1216,
     /* 428022 */     GIR_Done,
     /* 428023 */   // Label 8397: @428023
     /* 428023 */   GIM_Reject,
     /* 428024 */ // Label 8395: @428024
     /* 428024 */ GIM_Reject,
     /* 428025 */ // Label 8383: @428025
     /* 428025 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(428099),
     /* 428030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 428036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428044 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(428075), // Rule ID 775 //
     /* 428049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428066 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 428069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428073 */     GIR_RootConstrainSelectedInstOperands,
     /* 428074 */     // GIR_Coverage, 775,
     /* 428074 */     GIR_EraseRootFromParent_Done,
     /* 428075 */   // Label 8399: @428075
     /* 428075 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(428098), // Rule ID 1212 //
     /* 428080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428087 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 428092 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428096 */     GIR_RootConstrainSelectedInstOperands,
     /* 428097 */     // GIR_Coverage, 1212,
     /* 428097 */     GIR_Done,
     /* 428098 */   // Label 8400: @428098
     /* 428098 */   GIM_Reject,
     /* 428099 */ // Label 8398: @428099
     /* 428099 */ GIM_Reject,
     /* 428100 */ // Label 8384: @428100
     /* 428100 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(428174),
     /* 428105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 428111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428119 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(428150), // Rule ID 778 //
     /* 428124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428131 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428137 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428141 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 428144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428148 */     GIR_RootConstrainSelectedInstOperands,
     /* 428149 */     // GIR_Coverage, 778,
     /* 428149 */     GIR_EraseRootFromParent_Done,
     /* 428150 */   // Label 8402: @428150
     /* 428150 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(428173), // Rule ID 1215 //
     /* 428155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428162 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 428167 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428171 */     GIR_RootConstrainSelectedInstOperands,
     /* 428172 */     // GIR_Coverage, 1215,
     /* 428172 */     GIR_Done,
     /* 428173 */   // Label 8403: @428173
     /* 428173 */   GIM_Reject,
     /* 428174 */ // Label 8401: @428174
     /* 428174 */ GIM_Reject,
     /* 428175 */ // Label 8385: @428175
     /* 428175 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(428249),
     /* 428180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 428186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428194 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(428225), // Rule ID 776 //
     /* 428199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428206 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428212 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428216 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 428219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428223 */     GIR_RootConstrainSelectedInstOperands,
     /* 428224 */     // GIR_Coverage, 776,
     /* 428224 */     GIR_EraseRootFromParent_Done,
     /* 428225 */   // Label 8405: @428225
     /* 428225 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(428248), // Rule ID 1213 //
     /* 428230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428237 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 428242 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428246 */     GIR_RootConstrainSelectedInstOperands,
     /* 428247 */     // GIR_Coverage, 1213,
     /* 428247 */     GIR_Done,
     /* 428248 */   // Label 8406: @428248
     /* 428248 */   GIM_Reject,
     /* 428249 */ // Label 8404: @428249
     /* 428249 */ GIM_Reject,
     /* 428250 */ // Label 8386: @428250
     /* 428250 */ GIM_Reject,
     /* 428251 */ // Label 132: @428251
     /* 428251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8414*/ GIMT_Encode4(429342),
     /* 428262 */ /*GILLT_s32*//*Label 8407*/ GIMT_Encode4(428298),
     /* 428266 */ /*GILLT_s64*//*Label 8408*/ GIMT_Encode4(428336), GIMT_Encode4(0),
     /* 428274 */ /*GILLT_v2s32*//*Label 8409*/ GIMT_Encode4(428477),
     /* 428278 */ /*GILLT_v2s64*//*Label 8410*/ GIMT_Encode4(428650),
     /* 428282 */ /*GILLT_v4s16*//*Label 8411*/ GIMT_Encode4(428823),
     /* 428286 */ /*GILLT_v4s32*//*Label 8412*/ GIMT_Encode4(428996), GIMT_Encode4(0),
     /* 428294 */ /*GILLT_v8s16*//*Label 8413*/ GIMT_Encode4(429169),
     /* 428298 */ // Label 8407: @428298
     /* 428298 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(428335), // Rule ID 1628 //
     /* 428303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 428309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 428312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428324 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 428324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 428329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428333 */   GIR_RootConstrainSelectedInstOperands,
     /* 428334 */   // GIR_Coverage, 1628,
     /* 428334 */   GIR_Done,
     /* 428335 */ // Label 8415: @428335
     /* 428335 */ GIM_Reject,
     /* 428336 */ // Label 8408: @428336
     /* 428336 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(428476),
     /* 428341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 428344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 428347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428351 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(428386), // Rule ID 5294 //
     /* 428356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428377 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 428377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 428380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428384 */     GIR_RootConstrainSelectedInstOperands,
     /* 428385 */     // GIR_Coverage, 5294,
     /* 428385 */     GIR_EraseRootFromParent_Done,
     /* 428386 */   // Label 8417: @428386
     /* 428386 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(428421), // Rule ID 5292 //
     /* 428391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428412 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 428412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 428415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428419 */     GIR_RootConstrainSelectedInstOperands,
     /* 428420 */     // GIR_Coverage, 5292,
     /* 428420 */     GIR_EraseRootFromParent_Done,
     /* 428421 */   // Label 8418: @428421
     /* 428421 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(428448), // Rule ID 1627 //
     /* 428426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428437 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 428437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 428442 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428446 */     GIR_RootConstrainSelectedInstOperands,
     /* 428447 */     // GIR_Coverage, 1627,
     /* 428447 */     GIR_Done,
     /* 428448 */   // Label 8419: @428448
     /* 428448 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(428475), // Rule ID 5261 //
     /* 428453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428464 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 428464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 428469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428473 */     GIR_RootConstrainSelectedInstOperands,
     /* 428474 */     // GIR_Coverage, 5261,
     /* 428474 */     GIR_Done,
     /* 428475 */   // Label 8420: @428475
     /* 428475 */   GIM_Reject,
     /* 428476 */ // Label 8416: @428476
     /* 428476 */ GIM_Reject,
     /* 428477 */ // Label 8409: @428477
     /* 428477 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(428649),
     /* 428482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 428488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428492 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(428551), // Rule ID 1176 //
     /* 428497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428536 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 428539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428549 */     GIR_RootConstrainSelectedInstOperands,
     /* 428550 */     // GIR_Coverage, 1176,
     /* 428550 */     GIR_EraseRootFromParent_Done,
     /* 428551 */   // Label 8422: @428551
     /* 428551 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(428586), // Rule ID 792 //
     /* 428556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428577 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 428580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428584 */     GIR_RootConstrainSelectedInstOperands,
     /* 428585 */     // GIR_Coverage, 792,
     /* 428585 */     GIR_EraseRootFromParent_Done,
     /* 428586 */   // Label 8423: @428586
     /* 428586 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(428621), // Rule ID 782 //
     /* 428591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428602 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428608 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428612 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 428615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428619 */     GIR_RootConstrainSelectedInstOperands,
     /* 428620 */     // GIR_Coverage, 782,
     /* 428620 */     GIR_EraseRootFromParent_Done,
     /* 428621 */   // Label 8424: @428621
     /* 428621 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(428648), // Rule ID 1219 //
     /* 428626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428637 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 428642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428646 */     GIR_RootConstrainSelectedInstOperands,
     /* 428647 */     // GIR_Coverage, 1219,
     /* 428647 */     GIR_Done,
     /* 428648 */   // Label 8425: @428648
     /* 428648 */   GIM_Reject,
     /* 428649 */ // Label 8421: @428649
     /* 428649 */ GIM_Reject,
     /* 428650 */ // Label 8410: @428650
     /* 428650 */ GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(428822),
     /* 428655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 428661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428665 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(428724), // Rule ID 1180 //
     /* 428670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428709 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 428712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428722 */     GIR_RootConstrainSelectedInstOperands,
     /* 428723 */     // GIR_Coverage, 1180,
     /* 428723 */     GIR_EraseRootFromParent_Done,
     /* 428724 */   // Label 8427: @428724
     /* 428724 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(428759), // Rule ID 794 //
     /* 428729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428750 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 428753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428757 */     GIR_RootConstrainSelectedInstOperands,
     /* 428758 */     // GIR_Coverage, 794,
     /* 428758 */     GIR_EraseRootFromParent_Done,
     /* 428759 */   // Label 8428: @428759
     /* 428759 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(428794), // Rule ID 784 //
     /* 428764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428781 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428785 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 428788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428792 */     GIR_RootConstrainSelectedInstOperands,
     /* 428793 */     // GIR_Coverage, 784,
     /* 428793 */     GIR_EraseRootFromParent_Done,
     /* 428794 */   // Label 8429: @428794
     /* 428794 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(428821), // Rule ID 1221 //
     /* 428799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428810 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 428815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428819 */     GIR_RootConstrainSelectedInstOperands,
     /* 428820 */     // GIR_Coverage, 1221,
     /* 428820 */     GIR_Done,
     /* 428821 */   // Label 8430: @428821
     /* 428821 */   GIM_Reject,
     /* 428822 */ // Label 8426: @428822
     /* 428822 */ GIM_Reject,
     /* 428823 */ // Label 8411: @428823
     /* 428823 */ GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(428995),
     /* 428828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 428834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428838 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(428897), // Rule ID 1172 //
     /* 428843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428882 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 428885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428895 */     GIR_RootConstrainSelectedInstOperands,
     /* 428896 */     // GIR_Coverage, 1172,
     /* 428896 */     GIR_EraseRootFromParent_Done,
     /* 428897 */   // Label 8432: @428897
     /* 428897 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(428932), // Rule ID 790 //
     /* 428902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428909 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428915 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428923 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 428926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428930 */     GIR_RootConstrainSelectedInstOperands,
     /* 428931 */     // GIR_Coverage, 790,
     /* 428931 */     GIR_EraseRootFromParent_Done,
     /* 428932 */   // Label 8433: @428932
     /* 428932 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(428967), // Rule ID 780 //
     /* 428937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428954 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428958 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 428961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428965 */     GIR_RootConstrainSelectedInstOperands,
     /* 428966 */     // GIR_Coverage, 780,
     /* 428966 */     GIR_EraseRootFromParent_Done,
     /* 428967 */   // Label 8434: @428967
     /* 428967 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(428994), // Rule ID 1217 //
     /* 428972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428983 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 428988 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428992 */     GIR_RootConstrainSelectedInstOperands,
     /* 428993 */     // GIR_Coverage, 1217,
     /* 428993 */     GIR_Done,
     /* 428994 */   // Label 8435: @428994
     /* 428994 */   GIM_Reject,
     /* 428995 */ // Label 8431: @428995
     /* 428995 */ GIM_Reject,
     /* 428996 */ // Label 8412: @428996
     /* 428996 */ GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(429168),
     /* 429001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 429007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429011 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(429070), // Rule ID 1178 //
     /* 429016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429055 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 429055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 429058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429068 */     GIR_RootConstrainSelectedInstOperands,
     /* 429069 */     // GIR_Coverage, 1178,
     /* 429069 */     GIR_EraseRootFromParent_Done,
     /* 429070 */   // Label 8437: @429070
     /* 429070 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(429105), // Rule ID 793 //
     /* 429075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429082 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429088 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429096 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 429096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 429099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429103 */     GIR_RootConstrainSelectedInstOperands,
     /* 429104 */     // GIR_Coverage, 793,
     /* 429104 */     GIR_EraseRootFromParent_Done,
     /* 429105 */   // Label 8438: @429105
     /* 429105 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(429140), // Rule ID 783 //
     /* 429110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429121 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429127 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429131 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 429131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 429134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429138 */     GIR_RootConstrainSelectedInstOperands,
     /* 429139 */     // GIR_Coverage, 783,
     /* 429139 */     GIR_EraseRootFromParent_Done,
     /* 429140 */   // Label 8439: @429140
     /* 429140 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(429167), // Rule ID 1220 //
     /* 429145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429156 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 429156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 429161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429165 */     GIR_RootConstrainSelectedInstOperands,
     /* 429166 */     // GIR_Coverage, 1220,
     /* 429166 */     GIR_Done,
     /* 429167 */   // Label 8440: @429167
     /* 429167 */   GIM_Reject,
     /* 429168 */ // Label 8436: @429168
     /* 429168 */ GIM_Reject,
     /* 429169 */ // Label 8413: @429169
     /* 429169 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(429341),
     /* 429174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 429180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429184 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(429243), // Rule ID 1174 //
     /* 429189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429228 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 429228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 429231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429241 */     GIR_RootConstrainSelectedInstOperands,
     /* 429242 */     // GIR_Coverage, 1174,
     /* 429242 */     GIR_EraseRootFromParent_Done,
     /* 429243 */   // Label 8442: @429243
     /* 429243 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(429278), // Rule ID 791 //
     /* 429248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429255 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429261 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429269 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 429269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 429272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429276 */     GIR_RootConstrainSelectedInstOperands,
     /* 429277 */     // GIR_Coverage, 791,
     /* 429277 */     GIR_EraseRootFromParent_Done,
     /* 429278 */   // Label 8443: @429278
     /* 429278 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(429313), // Rule ID 781 //
     /* 429283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429294 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429300 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429304 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 429304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 429307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429311 */     GIR_RootConstrainSelectedInstOperands,
     /* 429312 */     // GIR_Coverage, 781,
     /* 429312 */     GIR_EraseRootFromParent_Done,
     /* 429313 */   // Label 8444: @429313
     /* 429313 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(429340), // Rule ID 1218 //
     /* 429318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429329 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 429329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 429334 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429338 */     GIR_RootConstrainSelectedInstOperands,
     /* 429339 */     // GIR_Coverage, 1218,
     /* 429339 */     GIR_Done,
     /* 429340 */   // Label 8445: @429340
     /* 429340 */   GIM_Reject,
     /* 429341 */ // Label 8441: @429341
     /* 429341 */ GIM_Reject,
     /* 429342 */ // Label 8414: @429342
     /* 429342 */ GIM_Reject,
     /* 429343 */ // Label 133: @429343
     /* 429343 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8453*/ GIMT_Encode4(430434),
     /* 429354 */ /*GILLT_s32*//*Label 8446*/ GIMT_Encode4(429390),
     /* 429358 */ /*GILLT_s64*//*Label 8447*/ GIMT_Encode4(429428), GIMT_Encode4(0),
     /* 429366 */ /*GILLT_v2s32*//*Label 8448*/ GIMT_Encode4(429569),
     /* 429370 */ /*GILLT_v2s64*//*Label 8449*/ GIMT_Encode4(429742),
     /* 429374 */ /*GILLT_v4s16*//*Label 8450*/ GIMT_Encode4(429915),
     /* 429378 */ /*GILLT_v4s32*//*Label 8451*/ GIMT_Encode4(430088), GIMT_Encode4(0),
     /* 429386 */ /*GILLT_v8s16*//*Label 8452*/ GIMT_Encode4(430261),
     /* 429390 */ // Label 8446: @429390
     /* 429390 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(429427), // Rule ID 1630 //
     /* 429395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 429401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 429404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429416 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 429416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 429421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429425 */   GIR_RootConstrainSelectedInstOperands,
     /* 429426 */   // GIR_Coverage, 1630,
     /* 429426 */   GIR_Done,
     /* 429427 */ // Label 8454: @429427
     /* 429427 */ GIM_Reject,
     /* 429428 */ // Label 8447: @429428
     /* 429428 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(429568),
     /* 429433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 429439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429443 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(429478), // Rule ID 5295 //
     /* 429448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429469 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 429469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 429472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429476 */     GIR_RootConstrainSelectedInstOperands,
     /* 429477 */     // GIR_Coverage, 5295,
     /* 429477 */     GIR_EraseRootFromParent_Done,
     /* 429478 */   // Label 8456: @429478
     /* 429478 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(429513), // Rule ID 5293 //
     /* 429483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429494 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429500 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429504 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 429504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 429507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429511 */     GIR_RootConstrainSelectedInstOperands,
     /* 429512 */     // GIR_Coverage, 5293,
     /* 429512 */     GIR_EraseRootFromParent_Done,
     /* 429513 */   // Label 8457: @429513
     /* 429513 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(429540), // Rule ID 1629 //
     /* 429518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429529 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 429529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 429534 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429538 */     GIR_RootConstrainSelectedInstOperands,
     /* 429539 */     // GIR_Coverage, 1629,
     /* 429539 */     GIR_Done,
     /* 429540 */   // Label 8458: @429540
     /* 429540 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(429567), // Rule ID 5262 //
     /* 429545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429556 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 429556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 429561 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429565 */     GIR_RootConstrainSelectedInstOperands,
     /* 429566 */     // GIR_Coverage, 5262,
     /* 429566 */     GIR_Done,
     /* 429567 */   // Label 8459: @429567
     /* 429567 */   GIM_Reject,
     /* 429568 */ // Label 8455: @429568
     /* 429568 */ GIM_Reject,
     /* 429569 */ // Label 8448: @429569
     /* 429569 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(429741),
     /* 429574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 429580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429584 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(429643), // Rule ID 1186 //
     /* 429589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429628 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 429628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 429631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429641 */     GIR_RootConstrainSelectedInstOperands,
     /* 429642 */     // GIR_Coverage, 1186,
     /* 429642 */     GIR_EraseRootFromParent_Done,
     /* 429643 */   // Label 8461: @429643
     /* 429643 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(429678), // Rule ID 797 //
     /* 429648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429669 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 429669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 429672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429676 */     GIR_RootConstrainSelectedInstOperands,
     /* 429677 */     // GIR_Coverage, 797,
     /* 429677 */     GIR_EraseRootFromParent_Done,
     /* 429678 */   // Label 8462: @429678
     /* 429678 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(429713), // Rule ID 787 //
     /* 429683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429694 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429700 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429704 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 429704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 429707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429711 */     GIR_RootConstrainSelectedInstOperands,
     /* 429712 */     // GIR_Coverage, 787,
     /* 429712 */     GIR_EraseRootFromParent_Done,
     /* 429713 */   // Label 8463: @429713
     /* 429713 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(429740), // Rule ID 1224 //
     /* 429718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429729 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 429729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 429734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429738 */     GIR_RootConstrainSelectedInstOperands,
     /* 429739 */     // GIR_Coverage, 1224,
     /* 429739 */     GIR_Done,
     /* 429740 */   // Label 8464: @429740
     /* 429740 */   GIM_Reject,
     /* 429741 */ // Label 8460: @429741
     /* 429741 */ GIM_Reject,
     /* 429742 */ // Label 8449: @429742
     /* 429742 */ GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(429914),
     /* 429747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 429753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429757 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(429816), // Rule ID 1190 //
     /* 429762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429801 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 429801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 429804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429814 */     GIR_RootConstrainSelectedInstOperands,
     /* 429815 */     // GIR_Coverage, 1190,
     /* 429815 */     GIR_EraseRootFromParent_Done,
     /* 429816 */   // Label 8466: @429816
     /* 429816 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(429851), // Rule ID 799 //
     /* 429821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429842 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 429842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 429845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429849 */     GIR_RootConstrainSelectedInstOperands,
     /* 429850 */     // GIR_Coverage, 799,
     /* 429850 */     GIR_EraseRootFromParent_Done,
     /* 429851 */   // Label 8467: @429851
     /* 429851 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(429886), // Rule ID 789 //
     /* 429856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429877 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 429877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 429880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429884 */     GIR_RootConstrainSelectedInstOperands,
     /* 429885 */     // GIR_Coverage, 789,
     /* 429885 */     GIR_EraseRootFromParent_Done,
     /* 429886 */   // Label 8468: @429886
     /* 429886 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(429913), // Rule ID 1226 //
     /* 429891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429902 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 429902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 429907 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429911 */     GIR_RootConstrainSelectedInstOperands,
     /* 429912 */     // GIR_Coverage, 1226,
     /* 429912 */     GIR_Done,
     /* 429913 */   // Label 8469: @429913
     /* 429913 */   GIM_Reject,
     /* 429914 */ // Label 8465: @429914
     /* 429914 */ GIM_Reject,
     /* 429915 */ // Label 8450: @429915
     /* 429915 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(430087),
     /* 429920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 429926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429930 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(429989), // Rule ID 1182 //
     /* 429935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429974 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 429974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 429977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429987 */     GIR_RootConstrainSelectedInstOperands,
     /* 429988 */     // GIR_Coverage, 1182,
     /* 429988 */     GIR_EraseRootFromParent_Done,
     /* 429989 */   // Label 8471: @429989
     /* 429989 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(430024), // Rule ID 795 //
     /* 429994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430001 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430007 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430015 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 430015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 430018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430022 */     GIR_RootConstrainSelectedInstOperands,
     /* 430023 */     // GIR_Coverage, 795,
     /* 430023 */     GIR_EraseRootFromParent_Done,
     /* 430024 */   // Label 8472: @430024
     /* 430024 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(430059), // Rule ID 785 //
     /* 430029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430050 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 430050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 430053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430057 */     GIR_RootConstrainSelectedInstOperands,
     /* 430058 */     // GIR_Coverage, 785,
     /* 430058 */     GIR_EraseRootFromParent_Done,
     /* 430059 */   // Label 8473: @430059
     /* 430059 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(430086), // Rule ID 1222 //
     /* 430064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430075 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 430075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 430080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430084 */     GIR_RootConstrainSelectedInstOperands,
     /* 430085 */     // GIR_Coverage, 1222,
     /* 430085 */     GIR_Done,
     /* 430086 */   // Label 8474: @430086
     /* 430086 */   GIM_Reject,
     /* 430087 */ // Label 8470: @430087
     /* 430087 */ GIM_Reject,
     /* 430088 */ // Label 8451: @430088
     /* 430088 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(430260),
     /* 430093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 430099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430103 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(430162), // Rule ID 1188 //
     /* 430108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 430119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 430132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 430136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430147 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 430147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 430150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 430156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430160 */     GIR_RootConstrainSelectedInstOperands,
     /* 430161 */     // GIR_Coverage, 1188,
     /* 430161 */     GIR_EraseRootFromParent_Done,
     /* 430162 */   // Label 8476: @430162
     /* 430162 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(430197), // Rule ID 798 //
     /* 430167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430180 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430188 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 430188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 430191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430195 */     GIR_RootConstrainSelectedInstOperands,
     /* 430196 */     // GIR_Coverage, 798,
     /* 430196 */     GIR_EraseRootFromParent_Done,
     /* 430197 */   // Label 8477: @430197
     /* 430197 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(430232), // Rule ID 788 //
     /* 430202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430213 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430219 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430223 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 430223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 430226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430230 */     GIR_RootConstrainSelectedInstOperands,
     /* 430231 */     // GIR_Coverage, 788,
     /* 430231 */     GIR_EraseRootFromParent_Done,
     /* 430232 */   // Label 8478: @430232
     /* 430232 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(430259), // Rule ID 1225 //
     /* 430237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430248 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 430248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 430253 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430257 */     GIR_RootConstrainSelectedInstOperands,
     /* 430258 */     // GIR_Coverage, 1225,
     /* 430258 */     GIR_Done,
     /* 430259 */   // Label 8479: @430259
     /* 430259 */   GIM_Reject,
     /* 430260 */ // Label 8475: @430260
     /* 430260 */ GIM_Reject,
     /* 430261 */ // Label 8452: @430261
     /* 430261 */ GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(430433),
     /* 430266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 430272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430276 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(430335), // Rule ID 1184 //
     /* 430281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 430292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 430305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 430309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430320 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 430320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 430323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 430329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430333 */     GIR_RootConstrainSelectedInstOperands,
     /* 430334 */     // GIR_Coverage, 1184,
     /* 430334 */     GIR_EraseRootFromParent_Done,
     /* 430335 */   // Label 8481: @430335
     /* 430335 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(430370), // Rule ID 796 //
     /* 430340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430347 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430353 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430361 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 430361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 430364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430368 */     GIR_RootConstrainSelectedInstOperands,
     /* 430369 */     // GIR_Coverage, 796,
     /* 430369 */     GIR_EraseRootFromParent_Done,
     /* 430370 */   // Label 8482: @430370
     /* 430370 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(430405), // Rule ID 786 //
     /* 430375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430396 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 430396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 430399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430403 */     GIR_RootConstrainSelectedInstOperands,
     /* 430404 */     // GIR_Coverage, 786,
     /* 430404 */     GIR_EraseRootFromParent_Done,
     /* 430405 */   // Label 8483: @430405
     /* 430405 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(430432), // Rule ID 1223 //
     /* 430410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430421 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 430421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 430426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430430 */     GIR_RootConstrainSelectedInstOperands,
     /* 430431 */     // GIR_Coverage, 1223,
     /* 430431 */     GIR_Done,
     /* 430432 */   // Label 8484: @430432
     /* 430432 */   GIM_Reject,
     /* 430433 */ // Label 8480: @430433
     /* 430433 */ GIM_Reject,
     /* 430434 */ // Label 8453: @430434
     /* 430434 */ GIM_Reject,
     /* 430435 */ // Label 134: @430435
     /* 430435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8489*/ GIMT_Encode4(430588),
     /* 430446 */ /*GILLT_s32*//*Label 8485*/ GIMT_Encode4(430486),
     /* 430450 */ /*GILLT_s64*//*Label 8486*/ GIMT_Encode4(430510), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430474 */ /*GILLT_v8s8*//*Label 8487*/ GIMT_Encode4(430534), GIMT_Encode4(0),
     /* 430482 */ /*GILLT_v16s8*//*Label 8488*/ GIMT_Encode4(430561),
     /* 430486 */ // Label 8485: @430486
     /* 430486 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(430509), // Rule ID 4048 //
     /* 430491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 430494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 430498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 430502 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 430502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 430507 */   GIR_RootConstrainSelectedInstOperands,
     /* 430508 */   // GIR_Coverage, 4048,
     /* 430508 */   GIR_Done,
     /* 430509 */ // Label 8490: @430509
     /* 430509 */ GIM_Reject,
     /* 430510 */ // Label 8486: @430510
     /* 430510 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(430533), // Rule ID 4049 //
     /* 430515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 430518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 430522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 430526 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 430526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 430531 */   GIR_RootConstrainSelectedInstOperands,
     /* 430532 */   // GIR_Coverage, 4049,
     /* 430532 */   GIR_Done,
     /* 430533 */ // Label 8491: @430533
     /* 430533 */ GIM_Reject,
     /* 430534 */ // Label 8487: @430534
     /* 430534 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(430560), // Rule ID 980 //
     /* 430539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430553 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 430558 */   GIR_RootConstrainSelectedInstOperands,
     /* 430559 */   // GIR_Coverage, 980,
     /* 430559 */   GIR_Done,
     /* 430560 */ // Label 8492: @430560
     /* 430560 */ GIM_Reject,
     /* 430561 */ // Label 8488: @430561
     /* 430561 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(430587), // Rule ID 981 //
     /* 430566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430580 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 430580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 430585 */   GIR_RootConstrainSelectedInstOperands,
     /* 430586 */   // GIR_Coverage, 981,
     /* 430586 */   GIR_Done,
     /* 430587 */ // Label 8493: @430587
     /* 430587 */ GIM_Reject,
     /* 430588 */ // Label 8489: @430588
     /* 430588 */ GIM_Reject,
     /* 430589 */ // Label 135: @430589
     /* 430589 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8498*/ GIMT_Encode4(430764),
     /* 430600 */ /*GILLT_v4s16*//*Label 8494*/ GIMT_Encode4(430620), GIMT_Encode4(0),
     /* 430608 */ /*GILLT_v8s8*//*Label 8495*/ GIMT_Encode4(430665),
     /* 430612 */ /*GILLT_v8s16*//*Label 8496*/ GIMT_Encode4(430692),
     /* 430616 */ /*GILLT_v16s8*//*Label 8497*/ GIMT_Encode4(430737),
     /* 430620 */ // Label 8494: @430620
     /* 430620 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(430664),
     /* 430625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430636 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(430651), // Rule ID 984 //
     /* 430641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430644 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 430644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 430649 */     GIR_RootConstrainSelectedInstOperands,
     /* 430650 */     // GIR_Coverage, 984,
     /* 430650 */     GIR_Done,
     /* 430651 */   // Label 8500: @430651
     /* 430651 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(430663), // Rule ID 5031 //
     /* 430656 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 430656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 430661 */     GIR_RootConstrainSelectedInstOperands,
     /* 430662 */     // GIR_Coverage, 5031,
     /* 430662 */     GIR_Done,
     /* 430663 */   // Label 8501: @430663
     /* 430663 */   GIM_Reject,
     /* 430664 */ // Label 8499: @430664
     /* 430664 */ GIM_Reject,
     /* 430665 */ // Label 8495: @430665
     /* 430665 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(430691), // Rule ID 982 //
     /* 430670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430684 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 430689 */   GIR_RootConstrainSelectedInstOperands,
     /* 430690 */   // GIR_Coverage, 982,
     /* 430690 */   GIR_Done,
     /* 430691 */ // Label 8502: @430691
     /* 430691 */ GIM_Reject,
     /* 430692 */ // Label 8496: @430692
     /* 430692 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(430736),
     /* 430697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430708 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(430723), // Rule ID 985 //
     /* 430713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430716 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 430716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 430721 */     GIR_RootConstrainSelectedInstOperands,
     /* 430722 */     // GIR_Coverage, 985,
     /* 430722 */     GIR_Done,
     /* 430723 */   // Label 8504: @430723
     /* 430723 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(430735), // Rule ID 5033 //
     /* 430728 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 430728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 430733 */     GIR_RootConstrainSelectedInstOperands,
     /* 430734 */     // GIR_Coverage, 5033,
     /* 430734 */     GIR_Done,
     /* 430735 */   // Label 8505: @430735
     /* 430735 */   GIM_Reject,
     /* 430736 */ // Label 8503: @430736
     /* 430736 */ GIM_Reject,
     /* 430737 */ // Label 8497: @430737
     /* 430737 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(430763), // Rule ID 983 //
     /* 430742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430756 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 430756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 430761 */   GIR_RootConstrainSelectedInstOperands,
     /* 430762 */   // GIR_Coverage, 983,
     /* 430762 */   GIR_Done,
     /* 430763 */ // Label 8506: @430763
     /* 430763 */ GIM_Reject,
     /* 430764 */ // Label 8498: @430764
     /* 430764 */ GIM_Reject,
     /* 430765 */ // Label 136: @430765
     /* 430765 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8513*/ GIMT_Encode4(431038),
     /* 430776 */ /*GILLT_v2s32*//*Label 8507*/ GIMT_Encode4(430804), GIMT_Encode4(0),
     /* 430784 */ /*GILLT_v4s16*//*Label 8508*/ GIMT_Encode4(430849),
     /* 430788 */ /*GILLT_v4s32*//*Label 8509*/ GIMT_Encode4(430894),
     /* 430792 */ /*GILLT_v8s8*//*Label 8510*/ GIMT_Encode4(430939),
     /* 430796 */ /*GILLT_v8s16*//*Label 8511*/ GIMT_Encode4(430966),
     /* 430800 */ /*GILLT_v16s8*//*Label 8512*/ GIMT_Encode4(431011),
     /* 430804 */ // Label 8507: @430804
     /* 430804 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(430848),
     /* 430809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430820 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(430835), // Rule ID 990 //
     /* 430825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430828 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 430828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 430833 */     GIR_RootConstrainSelectedInstOperands,
     /* 430834 */     // GIR_Coverage, 990,
     /* 430834 */     GIR_Done,
     /* 430835 */   // Label 8515: @430835
     /* 430835 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(430847), // Rule ID 5035 //
     /* 430840 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 430840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 430845 */     GIR_RootConstrainSelectedInstOperands,
     /* 430846 */     // GIR_Coverage, 5035,
     /* 430846 */     GIR_Done,
     /* 430847 */   // Label 8516: @430847
     /* 430847 */   GIM_Reject,
     /* 430848 */ // Label 8514: @430848
     /* 430848 */ GIM_Reject,
     /* 430849 */ // Label 8508: @430849
     /* 430849 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(430893),
     /* 430854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430865 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(430880), // Rule ID 988 //
     /* 430870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430873 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 430873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 430878 */     GIR_RootConstrainSelectedInstOperands,
     /* 430879 */     // GIR_Coverage, 988,
     /* 430879 */     GIR_Done,
     /* 430880 */   // Label 8518: @430880
     /* 430880 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(430892), // Rule ID 5032 //
     /* 430885 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 430885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 430890 */     GIR_RootConstrainSelectedInstOperands,
     /* 430891 */     // GIR_Coverage, 5032,
     /* 430891 */     GIR_Done,
     /* 430892 */   // Label 8519: @430892
     /* 430892 */   GIM_Reject,
     /* 430893 */ // Label 8517: @430893
     /* 430893 */ GIM_Reject,
     /* 430894 */ // Label 8509: @430894
     /* 430894 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(430938),
     /* 430899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430910 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(430925), // Rule ID 991 //
     /* 430915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430918 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 430918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 430923 */     GIR_RootConstrainSelectedInstOperands,
     /* 430924 */     // GIR_Coverage, 991,
     /* 430924 */     GIR_Done,
     /* 430925 */   // Label 8521: @430925
     /* 430925 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(430937), // Rule ID 5036 //
     /* 430930 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 430930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 430935 */     GIR_RootConstrainSelectedInstOperands,
     /* 430936 */     // GIR_Coverage, 5036,
     /* 430936 */     GIR_Done,
     /* 430937 */   // Label 8522: @430937
     /* 430937 */   GIM_Reject,
     /* 430938 */ // Label 8520: @430938
     /* 430938 */ GIM_Reject,
     /* 430939 */ // Label 8510: @430939
     /* 430939 */ GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(430965), // Rule ID 986 //
     /* 430944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430958 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 430963 */   GIR_RootConstrainSelectedInstOperands,
     /* 430964 */   // GIR_Coverage, 986,
     /* 430964 */   GIR_Done,
     /* 430965 */ // Label 8523: @430965
     /* 430965 */ GIM_Reject,
     /* 430966 */ // Label 8511: @430966
     /* 430966 */ GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(431010),
     /* 430971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430982 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(430997), // Rule ID 989 //
     /* 430987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430990 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 430990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 430995 */     GIR_RootConstrainSelectedInstOperands,
     /* 430996 */     // GIR_Coverage, 989,
     /* 430996 */     GIR_Done,
     /* 430997 */   // Label 8525: @430997
     /* 430997 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(431009), // Rule ID 5034 //
     /* 431002 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 431002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 431007 */     GIR_RootConstrainSelectedInstOperands,
     /* 431008 */     // GIR_Coverage, 5034,
     /* 431008 */     GIR_Done,
     /* 431009 */   // Label 8526: @431009
     /* 431009 */   GIM_Reject,
     /* 431010 */ // Label 8524: @431010
     /* 431010 */ GIM_Reject,
     /* 431011 */ // Label 8512: @431011
     /* 431011 */ GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(431037), // Rule ID 987 //
     /* 431016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431030 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 431030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 431035 */   GIR_RootConstrainSelectedInstOperands,
     /* 431036 */   // GIR_Coverage, 987,
     /* 431036 */   GIR_Done,
     /* 431037 */ // Label 8527: @431037
     /* 431037 */ GIM_Reject,
     /* 431038 */ // Label 8513: @431038
     /* 431038 */ GIM_Reject,
     /* 431039 */ // Label 137: @431039
     /* 431039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8534*/ GIMT_Encode4(431244),
     /* 431050 */ /*GILLT_s64*//*Label 8528*/ GIMT_Encode4(431082), GIMT_Encode4(0),
     /* 431058 */ /*GILLT_v2s32*//*Label 8529*/ GIMT_Encode4(431109),
     /* 431062 */ /*GILLT_v2s64*//*Label 8530*/ GIMT_Encode4(431136),
     /* 431066 */ /*GILLT_v4s16*//*Label 8531*/ GIMT_Encode4(431163),
     /* 431070 */ /*GILLT_v4s32*//*Label 8532*/ GIMT_Encode4(431190), GIMT_Encode4(0),
     /* 431078 */ /*GILLT_v8s16*//*Label 8533*/ GIMT_Encode4(431217),
     /* 431082 */ // Label 8528: @431082
     /* 431082 */ GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(431108), // Rule ID 1012 //
     /* 431087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431101 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 431101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 431106 */   GIR_RootConstrainSelectedInstOperands,
     /* 431107 */   // GIR_Coverage, 1012,
     /* 431107 */   GIR_Done,
     /* 431108 */ // Label 8535: @431108
     /* 431108 */ GIM_Reject,
     /* 431109 */ // Label 8529: @431109
     /* 431109 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(431135), // Rule ID 1008 //
     /* 431114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431128 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 431128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 431133 */   GIR_RootConstrainSelectedInstOperands,
     /* 431134 */   // GIR_Coverage, 1008,
     /* 431134 */   GIR_Done,
     /* 431135 */ // Label 8536: @431135
     /* 431135 */ GIM_Reject,
     /* 431136 */ // Label 8530: @431136
     /* 431136 */ GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(431162), // Rule ID 1014 //
     /* 431141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431155 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 431155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 431160 */   GIR_RootConstrainSelectedInstOperands,
     /* 431161 */   // GIR_Coverage, 1014,
     /* 431161 */   GIR_Done,
     /* 431162 */ // Label 8537: @431162
     /* 431162 */ GIM_Reject,
     /* 431163 */ // Label 8531: @431163
     /* 431163 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(431189), // Rule ID 1004 //
     /* 431168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431182 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 431182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 431187 */   GIR_RootConstrainSelectedInstOperands,
     /* 431188 */   // GIR_Coverage, 1004,
     /* 431188 */   GIR_Done,
     /* 431189 */ // Label 8538: @431189
     /* 431189 */ GIM_Reject,
     /* 431190 */ // Label 8532: @431190
     /* 431190 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(431216), // Rule ID 1010 //
     /* 431195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431209 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 431209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 431214 */   GIR_RootConstrainSelectedInstOperands,
     /* 431215 */   // GIR_Coverage, 1010,
     /* 431215 */   GIR_Done,
     /* 431216 */ // Label 8539: @431216
     /* 431216 */ GIM_Reject,
     /* 431217 */ // Label 8533: @431217
     /* 431217 */ GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(431243), // Rule ID 1006 //
     /* 431222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431236 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 431236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 431241 */   GIR_RootConstrainSelectedInstOperands,
     /* 431242 */   // GIR_Coverage, 1006,
     /* 431242 */   GIR_Done,
     /* 431243 */ // Label 8540: @431243
     /* 431243 */ GIM_Reject,
     /* 431244 */ // Label 8534: @431244
     /* 431244 */ GIM_Reject,
     /* 431245 */ // Label 138: @431245
     /* 431245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8543*/ GIMT_Encode4(431643),
     /* 431256 */ /*GILLT_v2s64*//*Label 8541*/ GIMT_Encode4(431268), GIMT_Encode4(0),
     /* 431264 */ /*GILLT_v4s32*//*Label 8542*/ GIMT_Encode4(431406),
     /* 431268 */ // Label 8541: @431268
     /* 431268 */ GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(431327), // Rule ID 5944 //
     /* 431273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431284 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 431284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 431287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 431291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 431316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431326 */   // GIR_Coverage, 5944,
     /* 431326 */   GIR_EraseRootFromParent_Done,
     /* 431327 */ // Label 8544: @431327
     /* 431327 */ GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(431405), // Rule ID 6066 //
     /* 431332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431343 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 431343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 431346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 431350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431355 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 431361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 431364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 431368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 431378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 431386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 431389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431404 */   // GIR_Coverage, 6066,
     /* 431404 */   GIR_EraseRootFromParent_Done,
     /* 431405 */ // Label 8545: @431405
     /* 431405 */ GIM_Reject,
     /* 431406 */ // Label 8542: @431406
     /* 431406 */ GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(431465), // Rule ID 5940 //
     /* 431411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431422 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 431422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 431425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 431429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 431454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431464 */   // GIR_Coverage, 5940,
     /* 431464 */   GIR_EraseRootFromParent_Done,
     /* 431465 */ // Label 8546: @431465
     /* 431465 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(431524), // Rule ID 5941 //
     /* 431470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431481 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 431481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 431488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 431513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431523 */   // GIR_Coverage, 5941,
     /* 431523 */   GIR_EraseRootFromParent_Done,
     /* 431524 */ // Label 8547: @431524
     /* 431524 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(431583), // Rule ID 5942 //
     /* 431529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431540 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 431540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 431543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 431547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431552 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 431572 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431582 */   // GIR_Coverage, 5942,
     /* 431582 */   GIR_EraseRootFromParent_Done,
     /* 431583 */ // Label 8548: @431583
     /* 431583 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(431642), // Rule ID 5943 //
     /* 431588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431599 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 431599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 431606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 431631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431641 */   // GIR_Coverage, 5943,
     /* 431641 */   GIR_EraseRootFromParent_Done,
     /* 431642 */ // Label 8549: @431642
     /* 431642 */ GIM_Reject,
     /* 431643 */ // Label 8543: @431643
     /* 431643 */ GIM_Reject,
     /* 431644 */ // Label 139: @431644
     /* 431644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8554*/ GIMT_Encode4(432013),
     /* 431655 */ /*GILLT_v2s32*//*Label 8550*/ GIMT_Encode4(431715), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431667 */ /*GILLT_v4s32*//*Label 8551*/ GIMT_Encode4(431835), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431699 */ /*GILLT_nxv2s64*//*Label 8552*/ GIMT_Encode4(431955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431711 */ /*GILLT_nxv4s32*//*Label 8553*/ GIMT_Encode4(431984),
     /* 431715 */ // Label 8550: @431715
     /* 431715 */ GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(431834),
     /* 431720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 431729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431741 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(431814), // Rule ID 26 //
     /* 431746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 431753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 431757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431790 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431794 */     // MIs[3] Operand 1
     /* 431794 */     // No operand predicates
     /* 431794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431796 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 431799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 431803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431812 */     GIR_RootConstrainSelectedInstOperands,
     /* 431813 */     // GIR_Coverage, 26,
     /* 431813 */     GIR_EraseRootFromParent_Done,
     /* 431814 */   // Label 8556: @431814
     /* 431814 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(431833), // Rule ID 22 //
     /* 431819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431826 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 431831 */     GIR_RootConstrainSelectedInstOperands,
     /* 431832 */     // GIR_Coverage, 22,
     /* 431832 */     GIR_Done,
     /* 431833 */   // Label 8557: @431833
     /* 431833 */   GIM_Reject,
     /* 431834 */ // Label 8555: @431834
     /* 431834 */ GIM_Reject,
     /* 431835 */ // Label 8551: @431835
     /* 431835 */ GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(431954),
     /* 431840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431846 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 431849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431861 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(431934), // Rule ID 27 //
     /* 431866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 431873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 431877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431914 */     // MIs[3] Operand 1
     /* 431914 */     // No operand predicates
     /* 431914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431916 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 431919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 431923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431932 */     GIR_RootConstrainSelectedInstOperands,
     /* 431933 */     // GIR_Coverage, 27,
     /* 431933 */     GIR_EraseRootFromParent_Done,
     /* 431934 */   // Label 8559: @431934
     /* 431934 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(431953), // Rule ID 23 //
     /* 431939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431946 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 431951 */     GIR_RootConstrainSelectedInstOperands,
     /* 431952 */     // GIR_Coverage, 23,
     /* 431952 */     GIR_Done,
     /* 431953 */   // Label 8560: @431953
     /* 431953 */   GIM_Reject,
     /* 431954 */ // Label 8558: @431954
     /* 431954 */ GIM_Reject,
     /* 431955 */ // Label 8552: @431955
     /* 431955 */ GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(431983), // Rule ID 3001 //
     /* 431960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 431972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431976 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 431976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 431981 */   GIR_RootConstrainSelectedInstOperands,
     /* 431982 */   // GIR_Coverage, 3001,
     /* 431982 */   GIR_Done,
     /* 431983 */ // Label 8561: @431983
     /* 431983 */ GIM_Reject,
     /* 431984 */ // Label 8553: @431984
     /* 431984 */ GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(432012), // Rule ID 3000 //
     /* 431989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 432001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432005 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 432005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 432010 */   GIR_RootConstrainSelectedInstOperands,
     /* 432011 */   // GIR_Coverage, 3000,
     /* 432011 */   GIR_Done,
     /* 432012 */ // Label 8562: @432012
     /* 432012 */ GIM_Reject,
     /* 432013 */ // Label 8554: @432013
     /* 432013 */ GIM_Reject,
     /* 432014 */ // Label 140: @432014
     /* 432014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8566*/ GIMT_Encode4(432130),
     /* 432025 */ /*GILLT_s16*//*Label 8563*/ GIMT_Encode4(432037),
     /* 432029 */ /*GILLT_s32*//*Label 8564*/ GIMT_Encode4(432068),
     /* 432033 */ /*GILLT_s64*//*Label 8565*/ GIMT_Encode4(432099),
     /* 432037 */ // Label 8563: @432037
     /* 432037 */ GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(432067), // Rule ID 1662 //
     /* 432042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 432045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 432048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432056 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 432056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 432061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 432065 */   GIR_RootConstrainSelectedInstOperands,
     /* 432066 */   // GIR_Coverage, 1662,
     /* 432066 */   GIR_Done,
     /* 432067 */ // Label 8567: @432067
     /* 432067 */ GIM_Reject,
     /* 432068 */ // Label 8564: @432068
     /* 432068 */ GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(432098), // Rule ID 1661 //
     /* 432073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 432076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 432079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432087 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 432087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 432092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 432096 */   GIR_RootConstrainSelectedInstOperands,
     /* 432097 */   // GIR_Coverage, 1661,
     /* 432097 */   GIR_Done,
     /* 432098 */ // Label 8568: @432098
     /* 432098 */ GIM_Reject,
     /* 432099 */ // Label 8565: @432099
     /* 432099 */ GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(432129), // Rule ID 1660 //
     /* 432104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 432107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 432110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432118 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 432118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 432123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 432127 */   GIR_RootConstrainSelectedInstOperands,
     /* 432128 */   // GIR_Coverage, 1660,
     /* 432128 */   GIR_Done,
     /* 432129 */ // Label 8569: @432129
     /* 432129 */ GIM_Reject,
     /* 432130 */ // Label 8566: @432130
     /* 432130 */ GIM_Reject,
     /* 432131 */ // Label 141: @432131
     /* 432131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8573*/ GIMT_Encode4(433363),
     /* 432142 */ /*GILLT_v2s64*//*Label 8570*/ GIMT_Encode4(432162), GIMT_Encode4(0),
     /* 432150 */ /*GILLT_v4s32*//*Label 8571*/ GIMT_Encode4(432723), GIMT_Encode4(0),
     /* 432158 */ /*GILLT_v8s16*//*Label 8572*/ GIMT_Encode4(433284),
     /* 432162 */ // Label 8570: @432162
     /* 432162 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(432722),
     /* 432167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 432173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432177 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(432269), // Rule ID 2058 //
     /* 432182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432230 */     // MIs[3] Operand 1
     /* 432230 */     // No operand predicates
     /* 432230 */     // MIs[1] Operand 2
     /* 432230 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 432241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432250 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 432253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432267 */     GIR_RootConstrainSelectedInstOperands,
     /* 432268 */     // GIR_Coverage, 2058,
     /* 432268 */     GIR_EraseRootFromParent_Done,
     /* 432269 */   // Label 8575: @432269
     /* 432269 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(432361), // Rule ID 13758 //
     /* 432274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432322 */     // MIs[3] Operand 1
     /* 432322 */     // No operand predicates
     /* 432322 */     // MIs[1] Operand 2
     /* 432322 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 432333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432342 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 432345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432359 */     GIR_RootConstrainSelectedInstOperands,
     /* 432360 */     // GIR_Coverage, 13758,
     /* 432360 */     GIR_EraseRootFromParent_Done,
     /* 432361 */   // Label 8576: @432361
     /* 432361 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(432447), // Rule ID 13756 //
     /* 432366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432414 */     // MIs[3] Operand 1
     /* 432414 */     // No operand predicates
     /* 432414 */     // MIs[1] Operand 2
     /* 432414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432431 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432445 */     GIR_RootConstrainSelectedInstOperands,
     /* 432446 */     // GIR_Coverage, 13756,
     /* 432446 */     GIR_EraseRootFromParent_Done,
     /* 432447 */   // Label 8577: @432447
     /* 432447 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(432533), // Rule ID 2056 //
     /* 432452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432504 */     // MIs[3] Operand 1
     /* 432504 */     // No operand predicates
     /* 432504 */     // MIs[1] Operand 2
     /* 432504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432517 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432531 */     GIR_RootConstrainSelectedInstOperands,
     /* 432532 */     // GIR_Coverage, 2056,
     /* 432532 */     GIR_EraseRootFromParent_Done,
     /* 432533 */   // Label 8578: @432533
     /* 432533 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(432572), // Rule ID 1745 //
     /* 432538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432555 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 432558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 432570 */     GIR_RootConstrainSelectedInstOperands,
     /* 432571 */     // GIR_Coverage, 1745,
     /* 432571 */     GIR_EraseRootFromParent_Done,
     /* 432572 */   // Label 8579: @432572
     /* 432572 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(432635), // Rule ID 13757 //
     /* 432577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432613 */     // MIs[2] Operand 1
     /* 432613 */     // No operand predicates
     /* 432613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432619 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432633 */     GIR_RootConstrainSelectedInstOperands,
     /* 432634 */     // GIR_Coverage, 13757,
     /* 432634 */     GIR_EraseRootFromParent_Done,
     /* 432635 */   // Label 8580: @432635
     /* 432635 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(432698), // Rule ID 2057 //
     /* 432640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432680 */     // MIs[2] Operand 1
     /* 432680 */     // No operand predicates
     /* 432680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432682 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432696 */     GIR_RootConstrainSelectedInstOperands,
     /* 432697 */     // GIR_Coverage, 2057,
     /* 432697 */     GIR_EraseRootFromParent_Done,
     /* 432698 */   // Label 8581: @432698
     /* 432698 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(432721), // Rule ID 1744 //
     /* 432703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432714 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 432714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 432719 */     GIR_RootConstrainSelectedInstOperands,
     /* 432720 */     // GIR_Coverage, 1744,
     /* 432720 */     GIR_Done,
     /* 432721 */   // Label 8582: @432721
     /* 432721 */   GIM_Reject,
     /* 432722 */ // Label 8574: @432722
     /* 432722 */ GIM_Reject,
     /* 432723 */ // Label 8571: @432723
     /* 432723 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(433283),
     /* 432728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432738 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(432830), // Rule ID 2055 //
     /* 432743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432791 */     // MIs[3] Operand 1
     /* 432791 */     // No operand predicates
     /* 432791 */     // MIs[1] Operand 2
     /* 432791 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 432802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432811 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 432814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432828 */     GIR_RootConstrainSelectedInstOperands,
     /* 432829 */     // GIR_Coverage, 2055,
     /* 432829 */     GIR_EraseRootFromParent_Done,
     /* 432830 */   // Label 8584: @432830
     /* 432830 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(432922), // Rule ID 13755 //
     /* 432835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432879 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432883 */     // MIs[3] Operand 1
     /* 432883 */     // No operand predicates
     /* 432883 */     // MIs[1] Operand 2
     /* 432883 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 432894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432903 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 432906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432920 */     GIR_RootConstrainSelectedInstOperands,
     /* 432921 */     // GIR_Coverage, 13755,
     /* 432921 */     GIR_EraseRootFromParent_Done,
     /* 432922 */   // Label 8585: @432922
     /* 432922 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(433008), // Rule ID 13753 //
     /* 432927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432971 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432975 */     // MIs[3] Operand 1
     /* 432975 */     // No operand predicates
     /* 432975 */     // MIs[1] Operand 2
     /* 432975 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432992 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 432995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433006 */     GIR_RootConstrainSelectedInstOperands,
     /* 433007 */     // GIR_Coverage, 13753,
     /* 433007 */     GIR_EraseRootFromParent_Done,
     /* 433008 */   // Label 8586: @433008
     /* 433008 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(433094), // Rule ID 2053 //
     /* 433013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 433053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433061 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 433065 */     // MIs[3] Operand 1
     /* 433065 */     // No operand predicates
     /* 433065 */     // MIs[1] Operand 2
     /* 433065 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 433076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433078 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 433081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433092 */     GIR_RootConstrainSelectedInstOperands,
     /* 433093 */     // GIR_Coverage, 2053,
     /* 433093 */     GIR_EraseRootFromParent_Done,
     /* 433094 */   // Label 8587: @433094
     /* 433094 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(433133), // Rule ID 1743 //
     /* 433099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 433109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 433116 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 433116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 433119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 433131 */     GIR_RootConstrainSelectedInstOperands,
     /* 433132 */     // GIR_Coverage, 1743,
     /* 433132 */     GIR_EraseRootFromParent_Done,
     /* 433133 */   // Label 8588: @433133
     /* 433133 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(433196), // Rule ID 13754 //
     /* 433138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 433162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 433174 */     // MIs[2] Operand 1
     /* 433174 */     // No operand predicates
     /* 433174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433180 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 433183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433194 */     GIR_RootConstrainSelectedInstOperands,
     /* 433195 */     // GIR_Coverage, 13754,
     /* 433195 */     GIR_EraseRootFromParent_Done,
     /* 433196 */   // Label 8589: @433196
     /* 433196 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(433259), // Rule ID 2054 //
     /* 433201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 433229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 433241 */     // MIs[2] Operand 1
     /* 433241 */     // No operand predicates
     /* 433241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433243 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 433246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433257 */     GIR_RootConstrainSelectedInstOperands,
     /* 433258 */     // GIR_Coverage, 2054,
     /* 433258 */     GIR_EraseRootFromParent_Done,
     /* 433259 */   // Label 8590: @433259
     /* 433259 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(433282), // Rule ID 1742 //
     /* 433264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433275 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 433275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 433280 */     GIR_RootConstrainSelectedInstOperands,
     /* 433281 */     // GIR_Coverage, 1742,
     /* 433281 */     GIR_Done,
     /* 433282 */   // Label 8591: @433282
     /* 433282 */   GIM_Reject,
     /* 433283 */ // Label 8583: @433283
     /* 433283 */ GIM_Reject,
     /* 433284 */ // Label 8572: @433284
     /* 433284 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(433362),
     /* 433289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433299 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(433338), // Rule ID 1741 //
     /* 433304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 433314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 433321 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 433324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 433336 */     GIR_RootConstrainSelectedInstOperands,
     /* 433337 */     // GIR_Coverage, 1741,
     /* 433337 */     GIR_EraseRootFromParent_Done,
     /* 433338 */   // Label 8593: @433338
     /* 433338 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(433361), // Rule ID 1740 //
     /* 433343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433354 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 433359 */     GIR_RootConstrainSelectedInstOperands,
     /* 433360 */     // GIR_Coverage, 1740,
     /* 433360 */     GIR_Done,
     /* 433361 */   // Label 8594: @433361
     /* 433361 */   GIM_Reject,
     /* 433362 */ // Label 8592: @433362
     /* 433362 */ GIM_Reject,
     /* 433363 */ // Label 8573: @433363
     /* 433363 */ GIM_Reject,
     /* 433364 */ // Label 142: @433364
     /* 433364 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8613*/ GIMT_Encode4(434143),
     /* 433375 */ /*GILLT_v2s32*//*Label 8595*/ GIMT_Encode4(433451),
     /* 433379 */ /*GILLT_v2s64*//*Label 8596*/ GIMT_Encode4(433506),
     /* 433383 */ /*GILLT_v4s16*//*Label 8597*/ GIMT_Encode4(433561),
     /* 433387 */ /*GILLT_v4s32*//*Label 8598*/ GIMT_Encode4(433616),
     /* 433391 */ /*GILLT_v8s8*//*Label 8599*/ GIMT_Encode4(433671),
     /* 433395 */ /*GILLT_v8s16*//*Label 8600*/ GIMT_Encode4(433705),
     /* 433399 */ /*GILLT_v16s8*//*Label 8601*/ GIMT_Encode4(433760), GIMT_Encode4(0),
     /* 433407 */ /*GILLT_nxv2s1*//*Label 8602*/ GIMT_Encode4(433794),
     /* 433411 */ /*GILLT_nxv2s16*//*Label 8603*/ GIMT_Encode4(433820),
     /* 433415 */ /*GILLT_nxv2s32*//*Label 8604*/ GIMT_Encode4(433846),
     /* 433419 */ /*GILLT_nxv2s64*//*Label 8605*/ GIMT_Encode4(433872),
     /* 433423 */ /*GILLT_nxv4s1*//*Label 8606*/ GIMT_Encode4(433919),
     /* 433427 */ /*GILLT_nxv4s16*//*Label 8607*/ GIMT_Encode4(433945),
     /* 433431 */ /*GILLT_nxv4s32*//*Label 8608*/ GIMT_Encode4(433971),
     /* 433435 */ /*GILLT_nxv8s1*//*Label 8609*/ GIMT_Encode4(434018),
     /* 433439 */ /*GILLT_nxv8s16*//*Label 8610*/ GIMT_Encode4(434044),
     /* 433443 */ /*GILLT_nxv16s1*//*Label 8611*/ GIMT_Encode4(434091),
     /* 433447 */ /*GILLT_nxv16s8*//*Label 8612*/ GIMT_Encode4(434117),
     /* 433451 */ // Label 8595: @433451
     /* 433451 */ GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(433505),
     /* 433456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433474 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(433489), // Rule ID 1878 //
     /* 433479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433482 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 433482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 433487 */     GIR_RootConstrainSelectedInstOperands,
     /* 433488 */     // GIR_Coverage, 1878,
     /* 433488 */     GIR_Done,
     /* 433489 */   // Label 8615: @433489
     /* 433489 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(433504), // Rule ID 2505 //
     /* 433494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433497 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 433497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 433502 */     GIR_RootConstrainSelectedInstOperands,
     /* 433503 */     // GIR_Coverage, 2505,
     /* 433503 */     GIR_Done,
     /* 433504 */   // Label 8616: @433504
     /* 433504 */   GIM_Reject,
     /* 433505 */ // Label 8614: @433505
     /* 433505 */ GIM_Reject,
     /* 433506 */ // Label 8596: @433506
     /* 433506 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(433560),
     /* 433511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 433514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 433517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433529 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(433544), // Rule ID 1880 //
     /* 433534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433537 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 433537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 433542 */     GIR_RootConstrainSelectedInstOperands,
     /* 433543 */     // GIR_Coverage, 1880,
     /* 433543 */     GIR_Done,
     /* 433544 */   // Label 8618: @433544
     /* 433544 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(433559), // Rule ID 2507 //
     /* 433549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433552 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 433552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 433557 */     GIR_RootConstrainSelectedInstOperands,
     /* 433558 */     // GIR_Coverage, 2507,
     /* 433558 */     GIR_Done,
     /* 433559 */   // Label 8619: @433559
     /* 433559 */   GIM_Reject,
     /* 433560 */ // Label 8617: @433560
     /* 433560 */ GIM_Reject,
     /* 433561 */ // Label 8597: @433561
     /* 433561 */ GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(433615),
     /* 433566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 433572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433584 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(433599), // Rule ID 1876 //
     /* 433589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433592 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 433592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 433597 */     GIR_RootConstrainSelectedInstOperands,
     /* 433598 */     // GIR_Coverage, 1876,
     /* 433598 */     GIR_Done,
     /* 433599 */   // Label 8621: @433599
     /* 433599 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(433614), // Rule ID 2503 //
     /* 433604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433607 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 433607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 433612 */     GIR_RootConstrainSelectedInstOperands,
     /* 433613 */     // GIR_Coverage, 2503,
     /* 433613 */     GIR_Done,
     /* 433614 */   // Label 8622: @433614
     /* 433614 */   GIM_Reject,
     /* 433615 */ // Label 8620: @433615
     /* 433615 */ GIM_Reject,
     /* 433616 */ // Label 8598: @433616
     /* 433616 */ GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(433670),
     /* 433621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 433627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433639 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(433654), // Rule ID 1879 //
     /* 433644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433647 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 433647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 433652 */     GIR_RootConstrainSelectedInstOperands,
     /* 433653 */     // GIR_Coverage, 1879,
     /* 433653 */     GIR_Done,
     /* 433654 */   // Label 8624: @433654
     /* 433654 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(433669), // Rule ID 2506 //
     /* 433659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433662 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 433662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 433667 */     GIR_RootConstrainSelectedInstOperands,
     /* 433668 */     // GIR_Coverage, 2506,
     /* 433668 */     GIR_Done,
     /* 433669 */   // Label 8625: @433669
     /* 433669 */   GIM_Reject,
     /* 433670 */ // Label 8623: @433670
     /* 433670 */ GIM_Reject,
     /* 433671 */ // Label 8599: @433671
     /* 433671 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(433704), // Rule ID 1874 //
     /* 433676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433697 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 433702 */   GIR_RootConstrainSelectedInstOperands,
     /* 433703 */   // GIR_Coverage, 1874,
     /* 433703 */   GIR_Done,
     /* 433704 */ // Label 8626: @433704
     /* 433704 */ GIM_Reject,
     /* 433705 */ // Label 8600: @433705
     /* 433705 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(433759),
     /* 433710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 433716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433728 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(433743), // Rule ID 1877 //
     /* 433733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433736 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 433736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 433741 */     GIR_RootConstrainSelectedInstOperands,
     /* 433742 */     // GIR_Coverage, 1877,
     /* 433742 */     GIR_Done,
     /* 433743 */   // Label 8628: @433743
     /* 433743 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(433758), // Rule ID 2504 //
     /* 433748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433751 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 433751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 433756 */     GIR_RootConstrainSelectedInstOperands,
     /* 433757 */     // GIR_Coverage, 2504,
     /* 433757 */     GIR_Done,
     /* 433758 */   // Label 8629: @433758
     /* 433758 */   GIM_Reject,
     /* 433759 */ // Label 8627: @433759
     /* 433759 */ GIM_Reject,
     /* 433760 */ // Label 8601: @433760
     /* 433760 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(433793), // Rule ID 1875 //
     /* 433765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433786 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 433791 */   GIR_RootConstrainSelectedInstOperands,
     /* 433792 */   // GIR_Coverage, 1875,
     /* 433792 */   GIR_Done,
     /* 433793 */ // Label 8630: @433793
     /* 433793 */ GIM_Reject,
     /* 433794 */ // Label 8602: @433794
     /* 433794 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(433819), // Rule ID 9090 //
     /* 433799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 433805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 433808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433812 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 433812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 433817 */   GIR_RootConstrainSelectedInstOperands,
     /* 433818 */   // GIR_Coverage, 9090,
     /* 433818 */   GIR_Done,
     /* 433819 */ // Label 8631: @433819
     /* 433819 */ GIM_Reject,
     /* 433820 */ // Label 8603: @433820
     /* 433820 */ GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(433845), // Rule ID 9066 //
     /* 433825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 433831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 433834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433838 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 433838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433843 */   GIR_RootConstrainSelectedInstOperands,
     /* 433844 */   // GIR_Coverage, 9066,
     /* 433844 */   GIR_Done,
     /* 433845 */ // Label 8632: @433845
     /* 433845 */ GIM_Reject,
     /* 433846 */ // Label 8604: @433846
     /* 433846 */ GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(433871), // Rule ID 9067 //
     /* 433851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 433857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 433860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433864 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 433864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433869 */   GIR_RootConstrainSelectedInstOperands,
     /* 433870 */   // GIR_Coverage, 9067,
     /* 433870 */   GIR_Done,
     /* 433871 */ // Label 8633: @433871
     /* 433871 */ GIM_Reject,
     /* 433872 */ // Label 8605: @433872
     /* 433872 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(433918),
     /* 433877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 433883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433887 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(433902), // Rule ID 9062 //
     /* 433892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433895 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 433895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433900 */     GIR_RootConstrainSelectedInstOperands,
     /* 433901 */     // GIR_Coverage, 9062,
     /* 433901 */     GIR_Done,
     /* 433902 */   // Label 8635: @433902
     /* 433902 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(433917), // Rule ID 9068 //
     /* 433907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433910 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 433910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433915 */     GIR_RootConstrainSelectedInstOperands,
     /* 433916 */     // GIR_Coverage, 9068,
     /* 433916 */     GIR_Done,
     /* 433917 */   // Label 8636: @433917
     /* 433917 */   GIM_Reject,
     /* 433918 */ // Label 8634: @433918
     /* 433918 */ GIM_Reject,
     /* 433919 */ // Label 8606: @433919
     /* 433919 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(433944), // Rule ID 9089 //
     /* 433924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 433930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 433933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433937 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 433937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 433942 */   GIR_RootConstrainSelectedInstOperands,
     /* 433943 */   // GIR_Coverage, 9089,
     /* 433943 */   GIR_Done,
     /* 433944 */ // Label 8637: @433944
     /* 433944 */ GIM_Reject,
     /* 433945 */ // Label 8607: @433945
     /* 433945 */ GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(433970), // Rule ID 9064 //
     /* 433950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 433956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 433959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433963 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 433963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 433968 */   GIR_RootConstrainSelectedInstOperands,
     /* 433969 */   // GIR_Coverage, 9064,
     /* 433969 */   GIR_Done,
     /* 433970 */ // Label 8638: @433970
     /* 433970 */ GIM_Reject,
     /* 433971 */ // Label 8608: @433971
     /* 433971 */ GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(434017),
     /* 433976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 433982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433986 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(434001), // Rule ID 9061 //
     /* 433991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433994 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 433994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 433999 */     GIR_RootConstrainSelectedInstOperands,
     /* 434000 */     // GIR_Coverage, 9061,
     /* 434000 */     GIR_Done,
     /* 434001 */   // Label 8640: @434001
     /* 434001 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(434016), // Rule ID 9065 //
     /* 434006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434009 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 434009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 434014 */     GIR_RootConstrainSelectedInstOperands,
     /* 434015 */     // GIR_Coverage, 9065,
     /* 434015 */     GIR_Done,
     /* 434016 */   // Label 8641: @434016
     /* 434016 */   GIM_Reject,
     /* 434017 */ // Label 8639: @434017
     /* 434017 */ GIM_Reject,
     /* 434018 */ // Label 8609: @434018
     /* 434018 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(434043), // Rule ID 9088 //
     /* 434023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 434029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 434032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434036 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 434036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 434041 */   GIR_RootConstrainSelectedInstOperands,
     /* 434042 */   // GIR_Coverage, 9088,
     /* 434042 */   GIR_Done,
     /* 434043 */ // Label 8642: @434043
     /* 434043 */ GIM_Reject,
     /* 434044 */ // Label 8610: @434044
     /* 434044 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(434090),
     /* 434049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 434052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 434055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434059 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(434074), // Rule ID 9060 //
     /* 434064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434067 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 434067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 434072 */     GIR_RootConstrainSelectedInstOperands,
     /* 434073 */     // GIR_Coverage, 9060,
     /* 434073 */     GIR_Done,
     /* 434074 */   // Label 8644: @434074
     /* 434074 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(434089), // Rule ID 9063 //
     /* 434079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434082 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 434082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 434087 */     GIR_RootConstrainSelectedInstOperands,
     /* 434088 */     // GIR_Coverage, 9063,
     /* 434088 */     GIR_Done,
     /* 434089 */   // Label 8645: @434089
     /* 434089 */   GIM_Reject,
     /* 434090 */ // Label 8643: @434090
     /* 434090 */ GIM_Reject,
     /* 434091 */ // Label 8611: @434091
     /* 434091 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(434116), // Rule ID 2418 //
     /* 434096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 434102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 434105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434109 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 434109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 434114 */   GIR_RootConstrainSelectedInstOperands,
     /* 434115 */   // GIR_Coverage, 2418,
     /* 434115 */   GIR_Done,
     /* 434116 */ // Label 8646: @434116
     /* 434116 */ GIM_Reject,
     /* 434117 */ // Label 8612: @434117
     /* 434117 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(434142), // Rule ID 9059 //
     /* 434122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 434128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 434131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434135 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 434135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 434140 */   GIR_RootConstrainSelectedInstOperands,
     /* 434141 */   // GIR_Coverage, 9059,
     /* 434141 */   GIR_Done,
     /* 434142 */ // Label 8647: @434142
     /* 434142 */ GIM_Reject,
     /* 434143 */ // Label 8613: @434143
     /* 434143 */ GIM_Reject,
     /* 434144 */ // Label 143: @434144
     /* 434144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8666*/ GIMT_Encode4(434923),
     /* 434155 */ /*GILLT_v2s32*//*Label 8648*/ GIMT_Encode4(434231),
     /* 434159 */ /*GILLT_v2s64*//*Label 8649*/ GIMT_Encode4(434286),
     /* 434163 */ /*GILLT_v4s16*//*Label 8650*/ GIMT_Encode4(434341),
     /* 434167 */ /*GILLT_v4s32*//*Label 8651*/ GIMT_Encode4(434396),
     /* 434171 */ /*GILLT_v8s8*//*Label 8652*/ GIMT_Encode4(434451),
     /* 434175 */ /*GILLT_v8s16*//*Label 8653*/ GIMT_Encode4(434485),
     /* 434179 */ /*GILLT_v16s8*//*Label 8654*/ GIMT_Encode4(434540), GIMT_Encode4(0),
     /* 434187 */ /*GILLT_nxv2s1*//*Label 8655*/ GIMT_Encode4(434574),
     /* 434191 */ /*GILLT_nxv2s16*//*Label 8656*/ GIMT_Encode4(434600),
     /* 434195 */ /*GILLT_nxv2s32*//*Label 8657*/ GIMT_Encode4(434626),
     /* 434199 */ /*GILLT_nxv2s64*//*Label 8658*/ GIMT_Encode4(434652),
     /* 434203 */ /*GILLT_nxv4s1*//*Label 8659*/ GIMT_Encode4(434699),
     /* 434207 */ /*GILLT_nxv4s16*//*Label 8660*/ GIMT_Encode4(434725),
     /* 434211 */ /*GILLT_nxv4s32*//*Label 8661*/ GIMT_Encode4(434751),
     /* 434215 */ /*GILLT_nxv8s1*//*Label 8662*/ GIMT_Encode4(434798),
     /* 434219 */ /*GILLT_nxv8s16*//*Label 8663*/ GIMT_Encode4(434824),
     /* 434223 */ /*GILLT_nxv16s1*//*Label 8664*/ GIMT_Encode4(434871),
     /* 434227 */ /*GILLT_nxv16s8*//*Label 8665*/ GIMT_Encode4(434897),
     /* 434231 */ // Label 8648: @434231
     /* 434231 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(434285),
     /* 434236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 434242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434254 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(434269), // Rule ID 1885 //
     /* 434259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434262 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 434262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 434267 */     GIR_RootConstrainSelectedInstOperands,
     /* 434268 */     // GIR_Coverage, 1885,
     /* 434268 */     GIR_Done,
     /* 434269 */   // Label 8668: @434269
     /* 434269 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(434284), // Rule ID 5517 //
     /* 434274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434277 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 434277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 434282 */     GIR_RootConstrainSelectedInstOperands,
     /* 434283 */     // GIR_Coverage, 5517,
     /* 434283 */     GIR_Done,
     /* 434284 */   // Label 8669: @434284
     /* 434284 */   GIM_Reject,
     /* 434285 */ // Label 8667: @434285
     /* 434285 */ GIM_Reject,
     /* 434286 */ // Label 8649: @434286
     /* 434286 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(434340),
     /* 434291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 434294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 434297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434309 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(434324), // Rule ID 1887 //
     /* 434314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434317 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 434317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 434322 */     GIR_RootConstrainSelectedInstOperands,
     /* 434323 */     // GIR_Coverage, 1887,
     /* 434323 */     GIR_Done,
     /* 434324 */   // Label 8671: @434324
     /* 434324 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(434339), // Rule ID 5519 //
     /* 434329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434332 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 434332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 434337 */     GIR_RootConstrainSelectedInstOperands,
     /* 434338 */     // GIR_Coverage, 5519,
     /* 434338 */     GIR_Done,
     /* 434339 */   // Label 8672: @434339
     /* 434339 */   GIM_Reject,
     /* 434340 */ // Label 8670: @434340
     /* 434340 */ GIM_Reject,
     /* 434341 */ // Label 8650: @434341
     /* 434341 */ GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(434395),
     /* 434346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 434352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434364 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(434379), // Rule ID 1883 //
     /* 434369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434372 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 434372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 434377 */     GIR_RootConstrainSelectedInstOperands,
     /* 434378 */     // GIR_Coverage, 1883,
     /* 434378 */     GIR_Done,
     /* 434379 */   // Label 8674: @434379
     /* 434379 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(434394), // Rule ID 5515 //
     /* 434384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434387 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 434387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 434392 */     GIR_RootConstrainSelectedInstOperands,
     /* 434393 */     // GIR_Coverage, 5515,
     /* 434393 */     GIR_Done,
     /* 434394 */   // Label 8675: @434394
     /* 434394 */   GIM_Reject,
     /* 434395 */ // Label 8673: @434395
     /* 434395 */ GIM_Reject,
     /* 434396 */ // Label 8651: @434396
     /* 434396 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(434450),
     /* 434401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 434407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434419 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(434434), // Rule ID 1886 //
     /* 434424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434427 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 434432 */     GIR_RootConstrainSelectedInstOperands,
     /* 434433 */     // GIR_Coverage, 1886,
     /* 434433 */     GIR_Done,
     /* 434434 */   // Label 8677: @434434
     /* 434434 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(434449), // Rule ID 5518 //
     /* 434439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434442 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 434442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 434447 */     GIR_RootConstrainSelectedInstOperands,
     /* 434448 */     // GIR_Coverage, 5518,
     /* 434448 */     GIR_Done,
     /* 434449 */   // Label 8678: @434449
     /* 434449 */   GIM_Reject,
     /* 434450 */ // Label 8676: @434450
     /* 434450 */ GIM_Reject,
     /* 434451 */ // Label 8652: @434451
     /* 434451 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(434484), // Rule ID 1881 //
     /* 434456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434477 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 434482 */   GIR_RootConstrainSelectedInstOperands,
     /* 434483 */   // GIR_Coverage, 1881,
     /* 434483 */   GIR_Done,
     /* 434484 */ // Label 8679: @434484
     /* 434484 */ GIM_Reject,
     /* 434485 */ // Label 8653: @434485
     /* 434485 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(434539),
     /* 434490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 434496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434508 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(434523), // Rule ID 1884 //
     /* 434513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434516 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 434521 */     GIR_RootConstrainSelectedInstOperands,
     /* 434522 */     // GIR_Coverage, 1884,
     /* 434522 */     GIR_Done,
     /* 434523 */   // Label 8681: @434523
     /* 434523 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(434538), // Rule ID 5516 //
     /* 434528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434531 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 434531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 434536 */     GIR_RootConstrainSelectedInstOperands,
     /* 434537 */     // GIR_Coverage, 5516,
     /* 434537 */     GIR_Done,
     /* 434538 */   // Label 8682: @434538
     /* 434538 */   GIM_Reject,
     /* 434539 */ // Label 8680: @434539
     /* 434539 */ GIM_Reject,
     /* 434540 */ // Label 8654: @434540
     /* 434540 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(434573), // Rule ID 1882 //
     /* 434545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434566 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 434571 */   GIR_RootConstrainSelectedInstOperands,
     /* 434572 */   // GIR_Coverage, 1882,
     /* 434572 */   GIR_Done,
     /* 434573 */ // Label 8683: @434573
     /* 434573 */ GIM_Reject,
     /* 434574 */ // Label 8655: @434574
     /* 434574 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(434599), // Rule ID 9093 //
     /* 434579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 434585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 434588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434592 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 434592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 434597 */   GIR_RootConstrainSelectedInstOperands,
     /* 434598 */   // GIR_Coverage, 9093,
     /* 434598 */   GIR_Done,
     /* 434599 */ // Label 8684: @434599
     /* 434599 */ GIM_Reject,
     /* 434600 */ // Label 8656: @434600
     /* 434600 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(434625), // Rule ID 9076 //
     /* 434605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 434611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 434614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434618 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 434618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434623 */   GIR_RootConstrainSelectedInstOperands,
     /* 434624 */   // GIR_Coverage, 9076,
     /* 434624 */   GIR_Done,
     /* 434625 */ // Label 8685: @434625
     /* 434625 */ GIM_Reject,
     /* 434626 */ // Label 8657: @434626
     /* 434626 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(434651), // Rule ID 9077 //
     /* 434631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 434637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 434640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434644 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 434644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434649 */   GIR_RootConstrainSelectedInstOperands,
     /* 434650 */   // GIR_Coverage, 9077,
     /* 434650 */   GIR_Done,
     /* 434651 */ // Label 8686: @434651
     /* 434651 */ GIM_Reject,
     /* 434652 */ // Label 8658: @434652
     /* 434652 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(434698),
     /* 434657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 434660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 434663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434667 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(434682), // Rule ID 9072 //
     /* 434672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434675 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 434675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434680 */     GIR_RootConstrainSelectedInstOperands,
     /* 434681 */     // GIR_Coverage, 9072,
     /* 434681 */     GIR_Done,
     /* 434682 */   // Label 8688: @434682
     /* 434682 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(434697), // Rule ID 9078 //
     /* 434687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434690 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 434690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434695 */     GIR_RootConstrainSelectedInstOperands,
     /* 434696 */     // GIR_Coverage, 9078,
     /* 434696 */     GIR_Done,
     /* 434697 */   // Label 8689: @434697
     /* 434697 */   GIM_Reject,
     /* 434698 */ // Label 8687: @434698
     /* 434698 */ GIM_Reject,
     /* 434699 */ // Label 8659: @434699
     /* 434699 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(434724), // Rule ID 9092 //
     /* 434704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 434710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 434713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434717 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 434717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 434722 */   GIR_RootConstrainSelectedInstOperands,
     /* 434723 */   // GIR_Coverage, 9092,
     /* 434723 */   GIR_Done,
     /* 434724 */ // Label 8690: @434724
     /* 434724 */ GIM_Reject,
     /* 434725 */ // Label 8660: @434725
     /* 434725 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(434750), // Rule ID 9074 //
     /* 434730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 434736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 434739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434743 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 434743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434748 */   GIR_RootConstrainSelectedInstOperands,
     /* 434749 */   // GIR_Coverage, 9074,
     /* 434749 */   GIR_Done,
     /* 434750 */ // Label 8691: @434750
     /* 434750 */ GIM_Reject,
     /* 434751 */ // Label 8661: @434751
     /* 434751 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(434797),
     /* 434756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 434759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 434762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434766 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(434781), // Rule ID 9071 //
     /* 434771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434774 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 434774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434779 */     GIR_RootConstrainSelectedInstOperands,
     /* 434780 */     // GIR_Coverage, 9071,
     /* 434780 */     GIR_Done,
     /* 434781 */   // Label 8693: @434781
     /* 434781 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(434796), // Rule ID 9075 //
     /* 434786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434789 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 434789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434794 */     GIR_RootConstrainSelectedInstOperands,
     /* 434795 */     // GIR_Coverage, 9075,
     /* 434795 */     GIR_Done,
     /* 434796 */   // Label 8694: @434796
     /* 434796 */   GIM_Reject,
     /* 434797 */ // Label 8692: @434797
     /* 434797 */ GIM_Reject,
     /* 434798 */ // Label 8662: @434798
     /* 434798 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(434823), // Rule ID 9091 //
     /* 434803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 434809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 434812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434816 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 434816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 434821 */   GIR_RootConstrainSelectedInstOperands,
     /* 434822 */   // GIR_Coverage, 9091,
     /* 434822 */   GIR_Done,
     /* 434823 */ // Label 8695: @434823
     /* 434823 */ GIM_Reject,
     /* 434824 */ // Label 8663: @434824
     /* 434824 */ GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(434870),
     /* 434829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 434832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 434835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434839 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(434854), // Rule ID 9070 //
     /* 434844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434847 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 434847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 434852 */     GIR_RootConstrainSelectedInstOperands,
     /* 434853 */     // GIR_Coverage, 9070,
     /* 434853 */     GIR_Done,
     /* 434854 */   // Label 8697: @434854
     /* 434854 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(434869), // Rule ID 9073 //
     /* 434859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434862 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 434862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 434867 */     GIR_RootConstrainSelectedInstOperands,
     /* 434868 */     // GIR_Coverage, 9073,
     /* 434868 */     GIR_Done,
     /* 434869 */   // Label 8698: @434869
     /* 434869 */   GIM_Reject,
     /* 434870 */ // Label 8696: @434870
     /* 434870 */ GIM_Reject,
     /* 434871 */ // Label 8664: @434871
     /* 434871 */ GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(434896), // Rule ID 2422 //
     /* 434876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 434882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 434885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434889 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 434889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 434894 */   GIR_RootConstrainSelectedInstOperands,
     /* 434895 */   // GIR_Coverage, 2422,
     /* 434895 */   GIR_Done,
     /* 434896 */ // Label 8699: @434896
     /* 434896 */ GIM_Reject,
     /* 434897 */ // Label 8665: @434897
     /* 434897 */ GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(434922), // Rule ID 9069 //
     /* 434902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 434908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 434911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434915 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 434915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 434920 */   GIR_RootConstrainSelectedInstOperands,
     /* 434921 */   // GIR_Coverage, 9069,
     /* 434921 */   GIR_Done,
     /* 434922 */ // Label 8700: @434922
     /* 434922 */ GIM_Reject,
     /* 434923 */ // Label 8666: @434923
     /* 434923 */ GIM_Reject,
     /* 434924 */ // Label 144: @434924
     /* 434924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8707*/ GIMT_Encode4(435129),
     /* 434935 */ /*GILLT_s64*//*Label 8701*/ GIMT_Encode4(434967), GIMT_Encode4(0),
     /* 434943 */ /*GILLT_v2s32*//*Label 8702*/ GIMT_Encode4(434994),
     /* 434947 */ /*GILLT_v2s64*//*Label 8703*/ GIMT_Encode4(435021),
     /* 434951 */ /*GILLT_v4s16*//*Label 8704*/ GIMT_Encode4(435048),
     /* 434955 */ /*GILLT_v4s32*//*Label 8705*/ GIMT_Encode4(435075), GIMT_Encode4(0),
     /* 434963 */ /*GILLT_v8s16*//*Label 8706*/ GIMT_Encode4(435102),
     /* 434967 */ // Label 8701: @434967
     /* 434967 */ GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(434993), // Rule ID 1073 //
     /* 434972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434986 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 434986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 434991 */   GIR_RootConstrainSelectedInstOperands,
     /* 434992 */   // GIR_Coverage, 1073,
     /* 434992 */   GIR_Done,
     /* 434993 */ // Label 8708: @434993
     /* 434993 */ GIM_Reject,
     /* 434994 */ // Label 8702: @434994
     /* 434994 */ GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(435020), // Rule ID 1069 //
     /* 434999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435013 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 435013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 435018 */   GIR_RootConstrainSelectedInstOperands,
     /* 435019 */   // GIR_Coverage, 1069,
     /* 435019 */   GIR_Done,
     /* 435020 */ // Label 8709: @435020
     /* 435020 */ GIM_Reject,
     /* 435021 */ // Label 8703: @435021
     /* 435021 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(435047), // Rule ID 1075 //
     /* 435026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435040 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 435040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 435045 */   GIR_RootConstrainSelectedInstOperands,
     /* 435046 */   // GIR_Coverage, 1075,
     /* 435046 */   GIR_Done,
     /* 435047 */ // Label 8710: @435047
     /* 435047 */ GIM_Reject,
     /* 435048 */ // Label 8704: @435048
     /* 435048 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(435074), // Rule ID 1065 //
     /* 435053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435067 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 435067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 435072 */   GIR_RootConstrainSelectedInstOperands,
     /* 435073 */   // GIR_Coverage, 1065,
     /* 435073 */   GIR_Done,
     /* 435074 */ // Label 8711: @435074
     /* 435074 */ GIM_Reject,
     /* 435075 */ // Label 8705: @435075
     /* 435075 */ GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(435101), // Rule ID 1071 //
     /* 435080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435094 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 435094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 435099 */   GIR_RootConstrainSelectedInstOperands,
     /* 435100 */   // GIR_Coverage, 1071,
     /* 435100 */   GIR_Done,
     /* 435101 */ // Label 8712: @435101
     /* 435101 */ GIM_Reject,
     /* 435102 */ // Label 8706: @435102
     /* 435102 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(435128), // Rule ID 1067 //
     /* 435107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435121 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 435121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 435126 */   GIR_RootConstrainSelectedInstOperands,
     /* 435127 */   // GIR_Coverage, 1067,
     /* 435127 */   GIR_Done,
     /* 435128 */ // Label 8713: @435128
     /* 435128 */ GIM_Reject,
     /* 435129 */ // Label 8707: @435129
     /* 435129 */ GIM_Reject,
     /* 435130 */ // Label 145: @435130
     /* 435130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8716*/ GIMT_Encode4(435996),
     /* 435141 */ /*GILLT_v2s64*//*Label 8714*/ GIMT_Encode4(435153), GIMT_Encode4(0),
     /* 435149 */ /*GILLT_v4s32*//*Label 8715*/ GIMT_Encode4(435447),
     /* 435153 */ // Label 8714: @435153
     /* 435153 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(435235), // Rule ID 5930 //
     /* 435158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 435173 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 435176 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 435181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 435185 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435192 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 435192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 435199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435204 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 435208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435234 */   // GIR_Coverage, 5930,
     /* 435234 */   GIR_EraseRootFromParent_Done,
     /* 435235 */ // Label 8717: @435235
     /* 435235 */ GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(435309), // Rule ID 5929 //
     /* 435240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435247 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 435255 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435259 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435266 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 435266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 435273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 435282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435308 */   // GIR_Coverage, 5929,
     /* 435308 */   GIR_EraseRootFromParent_Done,
     /* 435309 */ // Label 8718: @435309
     /* 435309 */ GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(435368), // Rule ID 5939 //
     /* 435314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435325 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 435325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 435328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 435332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435337 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 435357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435367 */   // GIR_Coverage, 5939,
     /* 435367 */   GIR_EraseRootFromParent_Done,
     /* 435368 */ // Label 8719: @435368
     /* 435368 */ GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(435446), // Rule ID 6067 //
     /* 435373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435384 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 435384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 435387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 435391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435396 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 435402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 435405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 435409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 435419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 435427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 435430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435445 */   // GIR_Coverage, 6067,
     /* 435445 */   GIR_EraseRootFromParent_Done,
     /* 435446 */ // Label 8720: @435446
     /* 435446 */ GIM_Reject,
     /* 435447 */ // Label 8715: @435447
     /* 435447 */ GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(435529), // Rule ID 5932 //
     /* 435452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 435467 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 435470 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 435475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435486 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 435486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 435502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435528 */   // GIR_Coverage, 5932,
     /* 435528 */   GIR_EraseRootFromParent_Done,
     /* 435529 */ // Label 8721: @435529
     /* 435529 */ GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(435611), // Rule ID 5934 //
     /* 435534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 435549 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 435552 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 435557 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435568 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 435568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 435584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435610 */   // GIR_Coverage, 5934,
     /* 435610 */   GIR_EraseRootFromParent_Done,
     /* 435611 */ // Label 8722: @435611
     /* 435611 */ GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(435685), // Rule ID 5931 //
     /* 435616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435623 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 435631 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435642 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 435642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435654 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 435658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435684 */   // GIR_Coverage, 5931,
     /* 435684 */   GIR_EraseRootFromParent_Done,
     /* 435685 */ // Label 8723: @435685
     /* 435685 */ GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(435759), // Rule ID 5933 //
     /* 435690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 435705 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435709 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435716 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 435716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435728 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 435732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435758 */   // GIR_Coverage, 5933,
     /* 435758 */   GIR_EraseRootFromParent_Done,
     /* 435759 */ // Label 8724: @435759
     /* 435759 */ GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(435818), // Rule ID 5935 //
     /* 435764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435775 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 435775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435817 */   // GIR_Coverage, 5935,
     /* 435817 */   GIR_EraseRootFromParent_Done,
     /* 435818 */ // Label 8725: @435818
     /* 435818 */ GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(435877), // Rule ID 5936 //
     /* 435823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435834 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 435834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 435841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435876 */   // GIR_Coverage, 5936,
     /* 435876 */   GIR_EraseRootFromParent_Done,
     /* 435877 */ // Label 8726: @435877
     /* 435877 */ GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(435936), // Rule ID 5937 //
     /* 435882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435893 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 435893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435935 */   // GIR_Coverage, 5937,
     /* 435935 */   GIR_EraseRootFromParent_Done,
     /* 435936 */ // Label 8727: @435936
     /* 435936 */ GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(435995), // Rule ID 5938 //
     /* 435941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435952 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 435952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 435959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435994 */   // GIR_Coverage, 5938,
     /* 435994 */   GIR_EraseRootFromParent_Done,
     /* 435995 */ // Label 8728: @435995
     /* 435995 */ GIM_Reject,
     /* 435996 */ // Label 8716: @435996
     /* 435996 */ GIM_Reject,
     /* 435997 */ // Label 146: @435997
     /* 435997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8733*/ GIMT_Encode4(436366),
     /* 436008 */ /*GILLT_v2s32*//*Label 8729*/ GIMT_Encode4(436068), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 436020 */ /*GILLT_v4s32*//*Label 8730*/ GIMT_Encode4(436188), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 436052 */ /*GILLT_nxv2s64*//*Label 8731*/ GIMT_Encode4(436308), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 436064 */ /*GILLT_nxv4s32*//*Label 8732*/ GIMT_Encode4(436337),
     /* 436068 */ // Label 8729: @436068
     /* 436068 */ GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(436187),
     /* 436073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 436082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436094 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(436167), // Rule ID 28 //
     /* 436099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 436102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 436106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 436110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436147 */     // MIs[3] Operand 1
     /* 436147 */     // No operand predicates
     /* 436147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436149 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 436152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 436154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 436156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436165 */     GIR_RootConstrainSelectedInstOperands,
     /* 436166 */     // GIR_Coverage, 28,
     /* 436166 */     GIR_EraseRootFromParent_Done,
     /* 436167 */   // Label 8735: @436167
     /* 436167 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(436186), // Rule ID 24 //
     /* 436172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 436175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436179 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 436184 */     GIR_RootConstrainSelectedInstOperands,
     /* 436185 */     // GIR_Coverage, 24,
     /* 436185 */     GIR_Done,
     /* 436186 */   // Label 8736: @436186
     /* 436186 */   GIM_Reject,
     /* 436187 */ // Label 8734: @436187
     /* 436187 */ GIM_Reject,
     /* 436188 */ // Label 8730: @436188
     /* 436188 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(436307),
     /* 436193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 436199 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 436202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436214 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(436287), // Rule ID 29 //
     /* 436219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 436222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 436226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 436230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436263 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436267 */     // MIs[3] Operand 1
     /* 436267 */     // No operand predicates
     /* 436267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436269 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 436272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 436274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 436276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436285 */     GIR_RootConstrainSelectedInstOperands,
     /* 436286 */     // GIR_Coverage, 29,
     /* 436286 */     GIR_EraseRootFromParent_Done,
     /* 436287 */   // Label 8738: @436287
     /* 436287 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(436306), // Rule ID 25 //
     /* 436292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 436295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436299 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 436304 */     GIR_RootConstrainSelectedInstOperands,
     /* 436305 */     // GIR_Coverage, 25,
     /* 436305 */     GIR_Done,
     /* 436306 */   // Label 8739: @436306
     /* 436306 */   GIM_Reject,
     /* 436307 */ // Label 8737: @436307
     /* 436307 */ GIM_Reject,
     /* 436308 */ // Label 8731: @436308
     /* 436308 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(436336), // Rule ID 7751 //
     /* 436313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 436319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 436325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436329 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 436329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 436334 */   GIR_RootConstrainSelectedInstOperands,
     /* 436335 */   // GIR_Coverage, 7751,
     /* 436335 */   GIR_Done,
     /* 436336 */ // Label 8740: @436336
     /* 436336 */ GIM_Reject,
     /* 436337 */ // Label 8732: @436337
     /* 436337 */ GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(436365), // Rule ID 7750 //
     /* 436342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 436348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 436354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436358 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 436358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 436363 */   GIR_RootConstrainSelectedInstOperands,
     /* 436364 */   // GIR_Coverage, 7750,
     /* 436364 */   GIR_Done,
     /* 436365 */ // Label 8741: @436365
     /* 436365 */ GIM_Reject,
     /* 436366 */ // Label 8733: @436366
     /* 436366 */ GIM_Reject,
     /* 436367 */ // Label 147: @436367
     /* 436367 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8745*/ GIMT_Encode4(436483),
     /* 436378 */ /*GILLT_s16*//*Label 8742*/ GIMT_Encode4(436390),
     /* 436382 */ /*GILLT_s32*//*Label 8743*/ GIMT_Encode4(436421),
     /* 436386 */ /*GILLT_s64*//*Label 8744*/ GIMT_Encode4(436452),
     /* 436390 */ // Label 8742: @436390
     /* 436390 */ GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(436420), // Rule ID 1673 //
     /* 436395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 436398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 436401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 436405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 436409 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 436409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 436414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436418 */   GIR_RootConstrainSelectedInstOperands,
     /* 436419 */   // GIR_Coverage, 1673,
     /* 436419 */   GIR_Done,
     /* 436420 */ // Label 8746: @436420
     /* 436420 */ GIM_Reject,
     /* 436421 */ // Label 8743: @436421
     /* 436421 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(436451), // Rule ID 1672 //
     /* 436426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 436429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 436432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 436436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 436440 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 436440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 436445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436449 */   GIR_RootConstrainSelectedInstOperands,
     /* 436450 */   // GIR_Coverage, 1672,
     /* 436450 */   GIR_Done,
     /* 436451 */ // Label 8747: @436451
     /* 436451 */ GIM_Reject,
     /* 436452 */ // Label 8744: @436452
     /* 436452 */ GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(436482), // Rule ID 1671 //
     /* 436457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 436460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436471 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 436471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 436476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436480 */   GIR_RootConstrainSelectedInstOperands,
     /* 436481 */   // GIR_Coverage, 1671,
     /* 436481 */   GIR_Done,
     /* 436482 */ // Label 8748: @436482
     /* 436482 */ GIM_Reject,
     /* 436483 */ // Label 8745: @436483
     /* 436483 */ GIM_Reject,
     /* 436484 */ // Label 148: @436484
     /* 436484 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8752*/ GIMT_Encode4(437716),
     /* 436495 */ /*GILLT_v2s64*//*Label 8749*/ GIMT_Encode4(436515), GIMT_Encode4(0),
     /* 436503 */ /*GILLT_v4s32*//*Label 8750*/ GIMT_Encode4(437076), GIMT_Encode4(0),
     /* 436511 */ /*GILLT_v8s16*//*Label 8751*/ GIMT_Encode4(437637),
     /* 436515 */ // Label 8749: @436515
     /* 436515 */ GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(437075),
     /* 436520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436530 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(436622), // Rule ID 2110 //
     /* 436535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436583 */     // MIs[3] Operand 1
     /* 436583 */     // No operand predicates
     /* 436583 */     // MIs[1] Operand 2
     /* 436583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 436594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436603 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 436606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436620 */     GIR_RootConstrainSelectedInstOperands,
     /* 436621 */     // GIR_Coverage, 2110,
     /* 436621 */     GIR_EraseRootFromParent_Done,
     /* 436622 */   // Label 8754: @436622
     /* 436622 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(436714), // Rule ID 13794 //
     /* 436627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436675 */     // MIs[3] Operand 1
     /* 436675 */     // No operand predicates
     /* 436675 */     // MIs[1] Operand 2
     /* 436675 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 436686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436695 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 436698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436712 */     GIR_RootConstrainSelectedInstOperands,
     /* 436713 */     // GIR_Coverage, 13794,
     /* 436713 */     GIR_EraseRootFromParent_Done,
     /* 436714 */   // Label 8755: @436714
     /* 436714 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(436800), // Rule ID 13792 //
     /* 436719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436767 */     // MIs[3] Operand 1
     /* 436767 */     // No operand predicates
     /* 436767 */     // MIs[1] Operand 2
     /* 436767 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436784 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436798 */     GIR_RootConstrainSelectedInstOperands,
     /* 436799 */     // GIR_Coverage, 13792,
     /* 436799 */     GIR_EraseRootFromParent_Done,
     /* 436800 */   // Label 8756: @436800
     /* 436800 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(436886), // Rule ID 2108 //
     /* 436805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436857 */     // MIs[3] Operand 1
     /* 436857 */     // No operand predicates
     /* 436857 */     // MIs[1] Operand 2
     /* 436857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436870 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436884 */     GIR_RootConstrainSelectedInstOperands,
     /* 436885 */     // GIR_Coverage, 2108,
     /* 436885 */     GIR_EraseRootFromParent_Done,
     /* 436886 */   // Label 8757: @436886
     /* 436886 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(436925), // Rule ID 1835 //
     /* 436891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436908 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 436911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 436923 */     GIR_RootConstrainSelectedInstOperands,
     /* 436924 */     // GIR_Coverage, 1835,
     /* 436924 */     GIR_EraseRootFromParent_Done,
     /* 436925 */   // Label 8758: @436925
     /* 436925 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(436988), // Rule ID 13793 //
     /* 436930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436966 */     // MIs[2] Operand 1
     /* 436966 */     // No operand predicates
     /* 436966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436972 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436986 */     GIR_RootConstrainSelectedInstOperands,
     /* 436987 */     // GIR_Coverage, 13793,
     /* 436987 */     GIR_EraseRootFromParent_Done,
     /* 436988 */   // Label 8759: @436988
     /* 436988 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(437051), // Rule ID 2109 //
     /* 436993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 437008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 437016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 437025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437029 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 437033 */     // MIs[2] Operand 1
     /* 437033 */     // No operand predicates
     /* 437033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437035 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 437038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 437046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 437049 */     GIR_RootConstrainSelectedInstOperands,
     /* 437050 */     // GIR_Coverage, 2109,
     /* 437050 */     GIR_EraseRootFromParent_Done,
     /* 437051 */   // Label 8760: @437051
     /* 437051 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(437074), // Rule ID 1834 //
     /* 437056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437067 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 437072 */     GIR_RootConstrainSelectedInstOperands,
     /* 437073 */     // GIR_Coverage, 1834,
     /* 437073 */     GIR_Done,
     /* 437074 */   // Label 8761: @437074
     /* 437074 */   GIM_Reject,
     /* 437075 */ // Label 8753: @437075
     /* 437075 */ GIM_Reject,
     /* 437076 */ // Label 8750: @437076
     /* 437076 */ GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(437636),
     /* 437081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437091 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(437183), // Rule ID 2107 //
     /* 437096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 437107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 437127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437140 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437144 */     // MIs[3] Operand 1
     /* 437144 */     // No operand predicates
     /* 437144 */     // MIs[1] Operand 2
     /* 437144 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 437155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437164 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 437167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 437178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 437181 */     GIR_RootConstrainSelectedInstOperands,
     /* 437182 */     // GIR_Coverage, 2107,
     /* 437182 */     GIR_EraseRootFromParent_Done,
     /* 437183 */   // Label 8763: @437183
     /* 437183 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(437275), // Rule ID 13791 //
     /* 437188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 437199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 437219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437232 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437236 */     // MIs[3] Operand 1
     /* 437236 */     // No operand predicates
     /* 437236 */     // MIs[1] Operand 2
     /* 437236 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 437247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437256 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 437259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 437270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 437273 */     GIR_RootConstrainSelectedInstOperands,
     /* 437274 */     // GIR_Coverage, 13791,
     /* 437274 */     GIR_EraseRootFromParent_Done,
     /* 437275 */   // Label 8764: @437275
     /* 437275 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(437361), // Rule ID 13789 //
     /* 437280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 437291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 437311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437328 */     // MIs[3] Operand 1
     /* 437328 */     // No operand predicates
     /* 437328 */     // MIs[1] Operand 2
     /* 437328 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 437339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437345 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 437352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 437356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 437359 */     GIR_RootConstrainSelectedInstOperands,
     /* 437360 */     // GIR_Coverage, 13789,
     /* 437360 */     GIR_EraseRootFromParent_Done,
     /* 437361 */   // Label 8765: @437361
     /* 437361 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(437447), // Rule ID 2105 //
     /* 437366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 437381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 437401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437414 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437418 */     // MIs[3] Operand 1
     /* 437418 */     // No operand predicates
     /* 437418 */     // MIs[1] Operand 2
     /* 437418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 437429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437431 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 437442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 437445 */     GIR_RootConstrainSelectedInstOperands,
     /* 437446 */     // GIR_Coverage, 2105,
     /* 437446 */     GIR_EraseRootFromParent_Done,
     /* 437447 */   // Label 8766: @437447
     /* 437447 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(437486), // Rule ID 1833 //
     /* 437452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437469 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 437472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 437484 */     GIR_RootConstrainSelectedInstOperands,
     /* 437485 */     // GIR_Coverage, 1833,
     /* 437485 */     GIR_EraseRootFromParent_Done,
     /* 437486 */   // Label 8767: @437486
     /* 437486 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(437549), // Rule ID 13790 //
     /* 437491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 437510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 437519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437527 */     // MIs[2] Operand 1
     /* 437527 */     // No operand predicates
     /* 437527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437533 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 437540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 437544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 437547 */     GIR_RootConstrainSelectedInstOperands,
     /* 437548 */     // GIR_Coverage, 13790,
     /* 437548 */     GIR_EraseRootFromParent_Done,
     /* 437549 */   // Label 8768: @437549
     /* 437549 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(437612), // Rule ID 2106 //
     /* 437554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 437577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 437586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437594 */     // MIs[2] Operand 1
     /* 437594 */     // No operand predicates
     /* 437594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437596 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 437607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 437610 */     GIR_RootConstrainSelectedInstOperands,
     /* 437611 */     // GIR_Coverage, 2106,
     /* 437611 */     GIR_EraseRootFromParent_Done,
     /* 437612 */   // Label 8769: @437612
     /* 437612 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(437635), // Rule ID 1832 //
     /* 437617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437628 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 437633 */     GIR_RootConstrainSelectedInstOperands,
     /* 437634 */     // GIR_Coverage, 1832,
     /* 437634 */     GIR_Done,
     /* 437635 */   // Label 8770: @437635
     /* 437635 */   GIM_Reject,
     /* 437636 */ // Label 8762: @437636
     /* 437636 */ GIM_Reject,
     /* 437637 */ // Label 8751: @437637
     /* 437637 */ GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(437715),
     /* 437642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437652 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(437691), // Rule ID 1831 //
     /* 437657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 437667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 437674 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 437677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 437689 */     GIR_RootConstrainSelectedInstOperands,
     /* 437690 */     // GIR_Coverage, 1831,
     /* 437690 */     GIR_EraseRootFromParent_Done,
     /* 437691 */   // Label 8772: @437691
     /* 437691 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(437714), // Rule ID 1830 //
     /* 437696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437707 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 437712 */     GIR_RootConstrainSelectedInstOperands,
     /* 437713 */     // GIR_Coverage, 1830,
     /* 437713 */     GIR_Done,
     /* 437714 */   // Label 8773: @437714
     /* 437714 */   GIM_Reject,
     /* 437715 */ // Label 8771: @437715
     /* 437715 */ GIM_Reject,
     /* 437716 */ // Label 8752: @437716
     /* 437716 */ GIM_Reject,
     /* 437717 */ // Label 149: @437717
     /* 437717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8792*/ GIMT_Encode4(438496),
     /* 437728 */ /*GILLT_v2s32*//*Label 8774*/ GIMT_Encode4(437804),
     /* 437732 */ /*GILLT_v2s64*//*Label 8775*/ GIMT_Encode4(437859),
     /* 437736 */ /*GILLT_v4s16*//*Label 8776*/ GIMT_Encode4(437914),
     /* 437740 */ /*GILLT_v4s32*//*Label 8777*/ GIMT_Encode4(437969),
     /* 437744 */ /*GILLT_v8s8*//*Label 8778*/ GIMT_Encode4(438024),
     /* 437748 */ /*GILLT_v8s16*//*Label 8779*/ GIMT_Encode4(438058),
     /* 437752 */ /*GILLT_v16s8*//*Label 8780*/ GIMT_Encode4(438113), GIMT_Encode4(0),
     /* 437760 */ /*GILLT_nxv2s1*//*Label 8781*/ GIMT_Encode4(438147),
     /* 437764 */ /*GILLT_nxv2s16*//*Label 8782*/ GIMT_Encode4(438173),
     /* 437768 */ /*GILLT_nxv2s32*//*Label 8783*/ GIMT_Encode4(438199),
     /* 437772 */ /*GILLT_nxv2s64*//*Label 8784*/ GIMT_Encode4(438225),
     /* 437776 */ /*GILLT_nxv4s1*//*Label 8785*/ GIMT_Encode4(438272),
     /* 437780 */ /*GILLT_nxv4s16*//*Label 8786*/ GIMT_Encode4(438298),
     /* 437784 */ /*GILLT_nxv4s32*//*Label 8787*/ GIMT_Encode4(438324),
     /* 437788 */ /*GILLT_nxv8s1*//*Label 8788*/ GIMT_Encode4(438371),
     /* 437792 */ /*GILLT_nxv8s16*//*Label 8789*/ GIMT_Encode4(438397),
     /* 437796 */ /*GILLT_nxv16s1*//*Label 8790*/ GIMT_Encode4(438444),
     /* 437800 */ /*GILLT_nxv16s8*//*Label 8791*/ GIMT_Encode4(438470),
     /* 437804 */ // Label 8774: @437804
     /* 437804 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(437858),
     /* 437809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437827 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(437842), // Rule ID 1892 //
     /* 437832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437835 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 437840 */     GIR_RootConstrainSelectedInstOperands,
     /* 437841 */     // GIR_Coverage, 1892,
     /* 437841 */     GIR_Done,
     /* 437842 */   // Label 8794: @437842
     /* 437842 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(437857), // Rule ID 5522 //
     /* 437847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437850 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 437855 */     GIR_RootConstrainSelectedInstOperands,
     /* 437856 */     // GIR_Coverage, 5522,
     /* 437856 */     GIR_Done,
     /* 437857 */   // Label 8795: @437857
     /* 437857 */   GIM_Reject,
     /* 437858 */ // Label 8793: @437858
     /* 437858 */ GIM_Reject,
     /* 437859 */ // Label 8775: @437859
     /* 437859 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(437913),
     /* 437864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437882 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(437897), // Rule ID 1894 //
     /* 437887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437890 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 437895 */     GIR_RootConstrainSelectedInstOperands,
     /* 437896 */     // GIR_Coverage, 1894,
     /* 437896 */     GIR_Done,
     /* 437897 */   // Label 8797: @437897
     /* 437897 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(437912), // Rule ID 5524 //
     /* 437902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437905 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 437910 */     GIR_RootConstrainSelectedInstOperands,
     /* 437911 */     // GIR_Coverage, 5524,
     /* 437911 */     GIR_Done,
     /* 437912 */   // Label 8798: @437912
     /* 437912 */   GIM_Reject,
     /* 437913 */ // Label 8796: @437913
     /* 437913 */ GIM_Reject,
     /* 437914 */ // Label 8776: @437914
     /* 437914 */ GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(437968),
     /* 437919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437937 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(437952), // Rule ID 1890 //
     /* 437942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437945 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 437950 */     GIR_RootConstrainSelectedInstOperands,
     /* 437951 */     // GIR_Coverage, 1890,
     /* 437951 */     GIR_Done,
     /* 437952 */   // Label 8800: @437952
     /* 437952 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(437967), // Rule ID 5520 //
     /* 437957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437960 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 437965 */     GIR_RootConstrainSelectedInstOperands,
     /* 437966 */     // GIR_Coverage, 5520,
     /* 437966 */     GIR_Done,
     /* 437967 */   // Label 8801: @437967
     /* 437967 */   GIM_Reject,
     /* 437968 */ // Label 8799: @437968
     /* 437968 */ GIM_Reject,
     /* 437969 */ // Label 8777: @437969
     /* 437969 */ GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(438023),
     /* 437974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437992 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(438007), // Rule ID 1893 //
     /* 437997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438000 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 438005 */     GIR_RootConstrainSelectedInstOperands,
     /* 438006 */     // GIR_Coverage, 1893,
     /* 438006 */     GIR_Done,
     /* 438007 */   // Label 8803: @438007
     /* 438007 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(438022), // Rule ID 5523 //
     /* 438012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438015 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 438020 */     GIR_RootConstrainSelectedInstOperands,
     /* 438021 */     // GIR_Coverage, 5523,
     /* 438021 */     GIR_Done,
     /* 438022 */   // Label 8804: @438022
     /* 438022 */   GIM_Reject,
     /* 438023 */ // Label 8802: @438023
     /* 438023 */ GIM_Reject,
     /* 438024 */ // Label 8778: @438024
     /* 438024 */ GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(438057), // Rule ID 1888 //
     /* 438029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438050 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 438055 */   GIR_RootConstrainSelectedInstOperands,
     /* 438056 */   // GIR_Coverage, 1888,
     /* 438056 */   GIR_Done,
     /* 438057 */ // Label 8805: @438057
     /* 438057 */ GIM_Reject,
     /* 438058 */ // Label 8779: @438058
     /* 438058 */ GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(438112),
     /* 438063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438081 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(438096), // Rule ID 1891 //
     /* 438086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438089 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 438094 */     GIR_RootConstrainSelectedInstOperands,
     /* 438095 */     // GIR_Coverage, 1891,
     /* 438095 */     GIR_Done,
     /* 438096 */   // Label 8807: @438096
     /* 438096 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(438111), // Rule ID 5521 //
     /* 438101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438104 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 438109 */     GIR_RootConstrainSelectedInstOperands,
     /* 438110 */     // GIR_Coverage, 5521,
     /* 438110 */     GIR_Done,
     /* 438111 */   // Label 8808: @438111
     /* 438111 */   GIM_Reject,
     /* 438112 */ // Label 8806: @438112
     /* 438112 */ GIM_Reject,
     /* 438113 */ // Label 8780: @438113
     /* 438113 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(438146), // Rule ID 1889 //
     /* 438118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438139 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 438144 */   GIR_RootConstrainSelectedInstOperands,
     /* 438145 */   // GIR_Coverage, 1889,
     /* 438145 */   GIR_Done,
     /* 438146 */ // Label 8809: @438146
     /* 438146 */ GIM_Reject,
     /* 438147 */ // Label 8781: @438147
     /* 438147 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(438172), // Rule ID 9084 //
     /* 438152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438165 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 438170 */   GIR_RootConstrainSelectedInstOperands,
     /* 438171 */   // GIR_Coverage, 9084,
     /* 438171 */   GIR_Done,
     /* 438172 */ // Label 8810: @438172
     /* 438172 */ GIM_Reject,
     /* 438173 */ // Label 8782: @438173
     /* 438173 */ GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(438198), // Rule ID 9046 //
     /* 438178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438191 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 438196 */   GIR_RootConstrainSelectedInstOperands,
     /* 438197 */   // GIR_Coverage, 9046,
     /* 438197 */   GIR_Done,
     /* 438198 */ // Label 8811: @438198
     /* 438198 */ GIM_Reject,
     /* 438199 */ // Label 8783: @438199
     /* 438199 */ GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(438224), // Rule ID 9047 //
     /* 438204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438217 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 438222 */   GIR_RootConstrainSelectedInstOperands,
     /* 438223 */   // GIR_Coverage, 9047,
     /* 438223 */   GIR_Done,
     /* 438224 */ // Label 8812: @438224
     /* 438224 */ GIM_Reject,
     /* 438225 */ // Label 8784: @438225
     /* 438225 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(438271),
     /* 438230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438240 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(438255), // Rule ID 9042 //
     /* 438245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438248 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 438253 */     GIR_RootConstrainSelectedInstOperands,
     /* 438254 */     // GIR_Coverage, 9042,
     /* 438254 */     GIR_Done,
     /* 438255 */   // Label 8814: @438255
     /* 438255 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(438270), // Rule ID 9048 //
     /* 438260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438263 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 438268 */     GIR_RootConstrainSelectedInstOperands,
     /* 438269 */     // GIR_Coverage, 9048,
     /* 438269 */     GIR_Done,
     /* 438270 */   // Label 8815: @438270
     /* 438270 */   GIM_Reject,
     /* 438271 */ // Label 8813: @438271
     /* 438271 */ GIM_Reject,
     /* 438272 */ // Label 8785: @438272
     /* 438272 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(438297), // Rule ID 9083 //
     /* 438277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438290 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 438295 */   GIR_RootConstrainSelectedInstOperands,
     /* 438296 */   // GIR_Coverage, 9083,
     /* 438296 */   GIR_Done,
     /* 438297 */ // Label 8816: @438297
     /* 438297 */ GIM_Reject,
     /* 438298 */ // Label 8786: @438298
     /* 438298 */ GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(438323), // Rule ID 9044 //
     /* 438303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438316 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 438321 */   GIR_RootConstrainSelectedInstOperands,
     /* 438322 */   // GIR_Coverage, 9044,
     /* 438322 */   GIR_Done,
     /* 438323 */ // Label 8817: @438323
     /* 438323 */ GIM_Reject,
     /* 438324 */ // Label 8787: @438324
     /* 438324 */ GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(438370),
     /* 438329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438339 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(438354), // Rule ID 9041 //
     /* 438344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438347 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 438352 */     GIR_RootConstrainSelectedInstOperands,
     /* 438353 */     // GIR_Coverage, 9041,
     /* 438353 */     GIR_Done,
     /* 438354 */   // Label 8819: @438354
     /* 438354 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(438369), // Rule ID 9045 //
     /* 438359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438362 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 438367 */     GIR_RootConstrainSelectedInstOperands,
     /* 438368 */     // GIR_Coverage, 9045,
     /* 438368 */     GIR_Done,
     /* 438369 */   // Label 8820: @438369
     /* 438369 */   GIM_Reject,
     /* 438370 */ // Label 8818: @438370
     /* 438370 */ GIM_Reject,
     /* 438371 */ // Label 8788: @438371
     /* 438371 */ GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(438396), // Rule ID 9082 //
     /* 438376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438389 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 438394 */   GIR_RootConstrainSelectedInstOperands,
     /* 438395 */   // GIR_Coverage, 9082,
     /* 438395 */   GIR_Done,
     /* 438396 */ // Label 8821: @438396
     /* 438396 */ GIM_Reject,
     /* 438397 */ // Label 8789: @438397
     /* 438397 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(438443),
     /* 438402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438412 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(438427), // Rule ID 9040 //
     /* 438417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438420 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 438425 */     GIR_RootConstrainSelectedInstOperands,
     /* 438426 */     // GIR_Coverage, 9040,
     /* 438426 */     GIR_Done,
     /* 438427 */   // Label 8823: @438427
     /* 438427 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(438442), // Rule ID 9043 //
     /* 438432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438435 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 438440 */     GIR_RootConstrainSelectedInstOperands,
     /* 438441 */     // GIR_Coverage, 9043,
     /* 438441 */     GIR_Done,
     /* 438442 */   // Label 8824: @438442
     /* 438442 */   GIM_Reject,
     /* 438443 */ // Label 8822: @438443
     /* 438443 */ GIM_Reject,
     /* 438444 */ // Label 8790: @438444
     /* 438444 */ GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(438469), // Rule ID 2410 //
     /* 438449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438462 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 438467 */   GIR_RootConstrainSelectedInstOperands,
     /* 438468 */   // GIR_Coverage, 2410,
     /* 438468 */   GIR_Done,
     /* 438469 */ // Label 8825: @438469
     /* 438469 */ GIM_Reject,
     /* 438470 */ // Label 8791: @438470
     /* 438470 */ GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(438495), // Rule ID 9039 //
     /* 438475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438488 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 438493 */   GIR_RootConstrainSelectedInstOperands,
     /* 438494 */   // GIR_Coverage, 9039,
     /* 438494 */   GIR_Done,
     /* 438495 */ // Label 8826: @438495
     /* 438495 */ GIM_Reject,
     /* 438496 */ // Label 8792: @438496
     /* 438496 */ GIM_Reject,
     /* 438497 */ // Label 150: @438497
     /* 438497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8845*/ GIMT_Encode4(439276),
     /* 438508 */ /*GILLT_v2s32*//*Label 8827*/ GIMT_Encode4(438584),
     /* 438512 */ /*GILLT_v2s64*//*Label 8828*/ GIMT_Encode4(438639),
     /* 438516 */ /*GILLT_v4s16*//*Label 8829*/ GIMT_Encode4(438694),
     /* 438520 */ /*GILLT_v4s32*//*Label 8830*/ GIMT_Encode4(438749),
     /* 438524 */ /*GILLT_v8s8*//*Label 8831*/ GIMT_Encode4(438804),
     /* 438528 */ /*GILLT_v8s16*//*Label 8832*/ GIMT_Encode4(438838),
     /* 438532 */ /*GILLT_v16s8*//*Label 8833*/ GIMT_Encode4(438893), GIMT_Encode4(0),
     /* 438540 */ /*GILLT_nxv2s1*//*Label 8834*/ GIMT_Encode4(438927),
     /* 438544 */ /*GILLT_nxv2s16*//*Label 8835*/ GIMT_Encode4(438953),
     /* 438548 */ /*GILLT_nxv2s32*//*Label 8836*/ GIMT_Encode4(438979),
     /* 438552 */ /*GILLT_nxv2s64*//*Label 8837*/ GIMT_Encode4(439005),
     /* 438556 */ /*GILLT_nxv4s1*//*Label 8838*/ GIMT_Encode4(439052),
     /* 438560 */ /*GILLT_nxv4s16*//*Label 8839*/ GIMT_Encode4(439078),
     /* 438564 */ /*GILLT_nxv4s32*//*Label 8840*/ GIMT_Encode4(439104),
     /* 438568 */ /*GILLT_nxv8s1*//*Label 8841*/ GIMT_Encode4(439151),
     /* 438572 */ /*GILLT_nxv8s16*//*Label 8842*/ GIMT_Encode4(439177),
     /* 438576 */ /*GILLT_nxv16s1*//*Label 8843*/ GIMT_Encode4(439224),
     /* 438580 */ /*GILLT_nxv16s8*//*Label 8844*/ GIMT_Encode4(439250),
     /* 438584 */ // Label 8827: @438584
     /* 438584 */ GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(438638),
     /* 438589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438607 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(438622), // Rule ID 1899 //
     /* 438612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438615 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 438620 */     GIR_RootConstrainSelectedInstOperands,
     /* 438621 */     // GIR_Coverage, 1899,
     /* 438621 */     GIR_Done,
     /* 438622 */   // Label 8847: @438622
     /* 438622 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(438637), // Rule ID 5527 //
     /* 438627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438630 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 438635 */     GIR_RootConstrainSelectedInstOperands,
     /* 438636 */     // GIR_Coverage, 5527,
     /* 438636 */     GIR_Done,
     /* 438637 */   // Label 8848: @438637
     /* 438637 */   GIM_Reject,
     /* 438638 */ // Label 8846: @438638
     /* 438638 */ GIM_Reject,
     /* 438639 */ // Label 8828: @438639
     /* 438639 */ GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(438693),
     /* 438644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438662 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(438677), // Rule ID 1901 //
     /* 438667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438670 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 438675 */     GIR_RootConstrainSelectedInstOperands,
     /* 438676 */     // GIR_Coverage, 1901,
     /* 438676 */     GIR_Done,
     /* 438677 */   // Label 8850: @438677
     /* 438677 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(438692), // Rule ID 5529 //
     /* 438682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438685 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 438690 */     GIR_RootConstrainSelectedInstOperands,
     /* 438691 */     // GIR_Coverage, 5529,
     /* 438691 */     GIR_Done,
     /* 438692 */   // Label 8851: @438692
     /* 438692 */   GIM_Reject,
     /* 438693 */ // Label 8849: @438693
     /* 438693 */ GIM_Reject,
     /* 438694 */ // Label 8829: @438694
     /* 438694 */ GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(438748),
     /* 438699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438717 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(438732), // Rule ID 1897 //
     /* 438722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438725 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 438730 */     GIR_RootConstrainSelectedInstOperands,
     /* 438731 */     // GIR_Coverage, 1897,
     /* 438731 */     GIR_Done,
     /* 438732 */   // Label 8853: @438732
     /* 438732 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(438747), // Rule ID 5525 //
     /* 438737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438740 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 438745 */     GIR_RootConstrainSelectedInstOperands,
     /* 438746 */     // GIR_Coverage, 5525,
     /* 438746 */     GIR_Done,
     /* 438747 */   // Label 8854: @438747
     /* 438747 */   GIM_Reject,
     /* 438748 */ // Label 8852: @438748
     /* 438748 */ GIM_Reject,
     /* 438749 */ // Label 8830: @438749
     /* 438749 */ GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(438803),
     /* 438754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438772 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(438787), // Rule ID 1900 //
     /* 438777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438780 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 438785 */     GIR_RootConstrainSelectedInstOperands,
     /* 438786 */     // GIR_Coverage, 1900,
     /* 438786 */     GIR_Done,
     /* 438787 */   // Label 8856: @438787
     /* 438787 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(438802), // Rule ID 5528 //
     /* 438792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438795 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 438800 */     GIR_RootConstrainSelectedInstOperands,
     /* 438801 */     // GIR_Coverage, 5528,
     /* 438801 */     GIR_Done,
     /* 438802 */   // Label 8857: @438802
     /* 438802 */   GIM_Reject,
     /* 438803 */ // Label 8855: @438803
     /* 438803 */ GIM_Reject,
     /* 438804 */ // Label 8831: @438804
     /* 438804 */ GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(438837), // Rule ID 1895 //
     /* 438809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438830 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 438835 */   GIR_RootConstrainSelectedInstOperands,
     /* 438836 */   // GIR_Coverage, 1895,
     /* 438836 */   GIR_Done,
     /* 438837 */ // Label 8858: @438837
     /* 438837 */ GIM_Reject,
     /* 438838 */ // Label 8832: @438838
     /* 438838 */ GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(438892),
     /* 438843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438861 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(438876), // Rule ID 1898 //
     /* 438866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438869 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 438874 */     GIR_RootConstrainSelectedInstOperands,
     /* 438875 */     // GIR_Coverage, 1898,
     /* 438875 */     GIR_Done,
     /* 438876 */   // Label 8860: @438876
     /* 438876 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(438891), // Rule ID 5526 //
     /* 438881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438884 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 438889 */     GIR_RootConstrainSelectedInstOperands,
     /* 438890 */     // GIR_Coverage, 5526,
     /* 438890 */     GIR_Done,
     /* 438891 */   // Label 8861: @438891
     /* 438891 */   GIM_Reject,
     /* 438892 */ // Label 8859: @438892
     /* 438892 */ GIM_Reject,
     /* 438893 */ // Label 8833: @438893
     /* 438893 */ GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(438926), // Rule ID 1896 //
     /* 438898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438919 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 438924 */   GIR_RootConstrainSelectedInstOperands,
     /* 438925 */   // GIR_Coverage, 1896,
     /* 438925 */   GIR_Done,
     /* 438926 */ // Label 8862: @438926
     /* 438926 */ GIM_Reject,
     /* 438927 */ // Label 8834: @438927
     /* 438927 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(438952), // Rule ID 9087 //
     /* 438932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438945 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 438950 */   GIR_RootConstrainSelectedInstOperands,
     /* 438951 */   // GIR_Coverage, 9087,
     /* 438951 */   GIR_Done,
     /* 438952 */ // Label 8863: @438952
     /* 438952 */ GIM_Reject,
     /* 438953 */ // Label 8835: @438953
     /* 438953 */ GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(438978), // Rule ID 9056 //
     /* 438958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438971 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 438976 */   GIR_RootConstrainSelectedInstOperands,
     /* 438977 */   // GIR_Coverage, 9056,
     /* 438977 */   GIR_Done,
     /* 438978 */ // Label 8864: @438978
     /* 438978 */ GIM_Reject,
     /* 438979 */ // Label 8836: @438979
     /* 438979 */ GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(439004), // Rule ID 9057 //
     /* 438984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438997 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 439002 */   GIR_RootConstrainSelectedInstOperands,
     /* 439003 */   // GIR_Coverage, 9057,
     /* 439003 */   GIR_Done,
     /* 439004 */ // Label 8865: @439004
     /* 439004 */ GIM_Reject,
     /* 439005 */ // Label 8837: @439005
     /* 439005 */ GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(439051),
     /* 439010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 439013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 439016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439020 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(439035), // Rule ID 9052 //
     /* 439025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439028 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 439028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 439033 */     GIR_RootConstrainSelectedInstOperands,
     /* 439034 */     // GIR_Coverage, 9052,
     /* 439034 */     GIR_Done,
     /* 439035 */   // Label 8867: @439035
     /* 439035 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(439050), // Rule ID 9058 //
     /* 439040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439043 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 439043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 439048 */     GIR_RootConstrainSelectedInstOperands,
     /* 439049 */     // GIR_Coverage, 9058,
     /* 439049 */     GIR_Done,
     /* 439050 */   // Label 8868: @439050
     /* 439050 */   GIM_Reject,
     /* 439051 */ // Label 8866: @439051
     /* 439051 */ GIM_Reject,
     /* 439052 */ // Label 8838: @439052
     /* 439052 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(439077), // Rule ID 9086 //
     /* 439057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 439063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 439066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439070 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 439070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 439075 */   GIR_RootConstrainSelectedInstOperands,
     /* 439076 */   // GIR_Coverage, 9086,
     /* 439076 */   GIR_Done,
     /* 439077 */ // Label 8869: @439077
     /* 439077 */ GIM_Reject,
     /* 439078 */ // Label 8839: @439078
     /* 439078 */ GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(439103), // Rule ID 9054 //
     /* 439083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 439089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 439092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439096 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 439096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 439101 */   GIR_RootConstrainSelectedInstOperands,
     /* 439102 */   // GIR_Coverage, 9054,
     /* 439102 */   GIR_Done,
     /* 439103 */ // Label 8870: @439103
     /* 439103 */ GIM_Reject,
     /* 439104 */ // Label 8840: @439104
     /* 439104 */ GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(439150),
     /* 439109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 439112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 439115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439119 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(439134), // Rule ID 9051 //
     /* 439124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439127 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 439127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 439132 */     GIR_RootConstrainSelectedInstOperands,
     /* 439133 */     // GIR_Coverage, 9051,
     /* 439133 */     GIR_Done,
     /* 439134 */   // Label 8872: @439134
     /* 439134 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(439149), // Rule ID 9055 //
     /* 439139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439142 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 439142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 439147 */     GIR_RootConstrainSelectedInstOperands,
     /* 439148 */     // GIR_Coverage, 9055,
     /* 439148 */     GIR_Done,
     /* 439149 */   // Label 8873: @439149
     /* 439149 */   GIM_Reject,
     /* 439150 */ // Label 8871: @439150
     /* 439150 */ GIM_Reject,
     /* 439151 */ // Label 8841: @439151
     /* 439151 */ GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(439176), // Rule ID 9085 //
     /* 439156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 439162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 439165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439169 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 439169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 439174 */   GIR_RootConstrainSelectedInstOperands,
     /* 439175 */   // GIR_Coverage, 9085,
     /* 439175 */   GIR_Done,
     /* 439176 */ // Label 8874: @439176
     /* 439176 */ GIM_Reject,
     /* 439177 */ // Label 8842: @439177
     /* 439177 */ GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(439223),
     /* 439182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 439185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 439188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439192 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(439207), // Rule ID 9050 //
     /* 439197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439200 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 439200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 439205 */     GIR_RootConstrainSelectedInstOperands,
     /* 439206 */     // GIR_Coverage, 9050,
     /* 439206 */     GIR_Done,
     /* 439207 */   // Label 8876: @439207
     /* 439207 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(439222), // Rule ID 9053 //
     /* 439212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439215 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 439215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 439220 */     GIR_RootConstrainSelectedInstOperands,
     /* 439221 */     // GIR_Coverage, 9053,
     /* 439221 */     GIR_Done,
     /* 439222 */   // Label 8877: @439222
     /* 439222 */   GIM_Reject,
     /* 439223 */ // Label 8875: @439223
     /* 439223 */ GIM_Reject,
     /* 439224 */ // Label 8843: @439224
     /* 439224 */ GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(439249), // Rule ID 2414 //
     /* 439229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 439235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 439238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439242 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 439242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 439247 */   GIR_RootConstrainSelectedInstOperands,
     /* 439248 */   // GIR_Coverage, 2414,
     /* 439248 */   GIR_Done,
     /* 439249 */ // Label 8878: @439249
     /* 439249 */ GIM_Reject,
     /* 439250 */ // Label 8844: @439250
     /* 439250 */ GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(439275), // Rule ID 9049 //
     /* 439255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 439261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 439264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439268 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 439268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 439273 */   GIR_RootConstrainSelectedInstOperands,
     /* 439274 */   // GIR_Coverage, 9049,
     /* 439274 */   GIR_Done,
     /* 439275 */ // Label 8879: @439275
     /* 439275 */ GIM_Reject,
     /* 439276 */ // Label 8845: @439276
     /* 439276 */ GIM_Reject,
     /* 439277 */ // Label 151: @439277
     /* 439277 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8888*/ GIMT_Encode4(439974),
     /* 439288 */ /*GILLT_s64*//*Label 8880*/ GIMT_Encode4(439324), GIMT_Encode4(0),
     /* 439296 */ /*GILLT_v2s32*//*Label 8881*/ GIMT_Encode4(439435),
     /* 439300 */ /*GILLT_v2s64*//*Label 8882*/ GIMT_Encode4(439512),
     /* 439304 */ /*GILLT_v4s16*//*Label 8883*/ GIMT_Encode4(439589),
     /* 439308 */ /*GILLT_v4s32*//*Label 8884*/ GIMT_Encode4(439666),
     /* 439312 */ /*GILLT_v8s8*//*Label 8885*/ GIMT_Encode4(439743),
     /* 439316 */ /*GILLT_v8s16*//*Label 8886*/ GIMT_Encode4(439820),
     /* 439320 */ /*GILLT_v16s8*//*Label 8887*/ GIMT_Encode4(439897),
     /* 439324 */ // Label 8880: @439324
     /* 439324 */ GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(439434),
     /* 439329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 439332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439340 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(439365), // Rule ID 5299 //
     /* 439345 */     // MIs[0] Operand 2
     /* 439345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 439356 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 439356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 439359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439363 */     GIR_RootConstrainSelectedInstOperands,
     /* 439364 */     // GIR_Coverage, 5299,
     /* 439364 */     GIR_EraseRootFromParent_Done,
     /* 439365 */   // Label 8890: @439365
     /* 439365 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(439399), // Rule ID 2124 //
     /* 439370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439373 */     // MIs[0] imm
     /* 439373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439385 */     // MIs[1] Operand 1
     /* 439385 */     // No operand predicates
     /* 439385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439387 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 439390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439397 */     GIR_RootConstrainSelectedInstOperands,
     /* 439398 */     // GIR_Coverage, 2124,
     /* 439398 */     GIR_EraseRootFromParent_Done,
     /* 439399 */   // Label 8891: @439399
     /* 439399 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(439433), // Rule ID 6363 //
     /* 439404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439407 */     // MIs[0] imm
     /* 439407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439419 */     // MIs[1] Operand 1
     /* 439419 */     // No operand predicates
     /* 439419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439421 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 439421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 439424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439431 */     GIR_RootConstrainSelectedInstOperands,
     /* 439432 */     // GIR_Coverage, 6363,
     /* 439432 */     GIR_EraseRootFromParent_Done,
     /* 439433 */   // Label 8892: @439433
     /* 439433 */   GIM_Reject,
     /* 439434 */ // Label 8889: @439434
     /* 439434 */ GIM_Reject,
     /* 439435 */ // Label 8881: @439435
     /* 439435 */ GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(439511),
     /* 439440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439451 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(439476), // Rule ID 4961 //
     /* 439456 */     // MIs[0] Operand 2
     /* 439456 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 439467 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 439467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 439470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439474 */     GIR_RootConstrainSelectedInstOperands,
     /* 439475 */     // GIR_Coverage, 4961,
     /* 439475 */     GIR_EraseRootFromParent_Done,
     /* 439476 */   // Label 8894: @439476
     /* 439476 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(439510), // Rule ID 2231 //
     /* 439481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439484 */     // MIs[0] imm
     /* 439484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439496 */     // MIs[1] Operand 1
     /* 439496 */     // No operand predicates
     /* 439496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439498 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 439501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439508 */     GIR_RootConstrainSelectedInstOperands,
     /* 439509 */     // GIR_Coverage, 2231,
     /* 439509 */     GIR_EraseRootFromParent_Done,
     /* 439510 */   // Label 8895: @439510
     /* 439510 */   GIM_Reject,
     /* 439511 */ // Label 8893: @439511
     /* 439511 */ GIM_Reject,
     /* 439512 */ // Label 8882: @439512
     /* 439512 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(439588),
     /* 439517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439528 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(439553), // Rule ID 4965 //
     /* 439533 */     // MIs[0] Operand 2
     /* 439533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 439544 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 439544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 439547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439551 */     GIR_RootConstrainSelectedInstOperands,
     /* 439552 */     // GIR_Coverage, 4965,
     /* 439552 */     GIR_EraseRootFromParent_Done,
     /* 439553 */   // Label 8897: @439553
     /* 439553 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(439587), // Rule ID 2233 //
     /* 439558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439561 */     // MIs[0] imm
     /* 439561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439573 */     // MIs[1] Operand 1
     /* 439573 */     // No operand predicates
     /* 439573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439575 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 439578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439585 */     GIR_RootConstrainSelectedInstOperands,
     /* 439586 */     // GIR_Coverage, 2233,
     /* 439586 */     GIR_EraseRootFromParent_Done,
     /* 439587 */   // Label 8898: @439587
     /* 439587 */   GIM_Reject,
     /* 439588 */ // Label 8896: @439588
     /* 439588 */ GIM_Reject,
     /* 439589 */ // Label 8883: @439589
     /* 439589 */ GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(439665),
     /* 439594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439605 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(439630), // Rule ID 4960 //
     /* 439610 */     // MIs[0] Operand 2
     /* 439610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 439621 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 439621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 439624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439628 */     GIR_RootConstrainSelectedInstOperands,
     /* 439629 */     // GIR_Coverage, 4960,
     /* 439629 */     GIR_EraseRootFromParent_Done,
     /* 439630 */   // Label 8900: @439630
     /* 439630 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(439664), // Rule ID 2229 //
     /* 439635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439638 */     // MIs[0] imm
     /* 439638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439650 */     // MIs[1] Operand 1
     /* 439650 */     // No operand predicates
     /* 439650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439652 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 439655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439662 */     GIR_RootConstrainSelectedInstOperands,
     /* 439663 */     // GIR_Coverage, 2229,
     /* 439663 */     GIR_EraseRootFromParent_Done,
     /* 439664 */   // Label 8901: @439664
     /* 439664 */   GIM_Reject,
     /* 439665 */ // Label 8899: @439665
     /* 439665 */ GIM_Reject,
     /* 439666 */ // Label 8884: @439666
     /* 439666 */ GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(439742),
     /* 439671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439682 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(439707), // Rule ID 4964 //
     /* 439687 */     // MIs[0] Operand 2
     /* 439687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 439698 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 439698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 439701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439705 */     GIR_RootConstrainSelectedInstOperands,
     /* 439706 */     // GIR_Coverage, 4964,
     /* 439706 */     GIR_EraseRootFromParent_Done,
     /* 439707 */   // Label 8903: @439707
     /* 439707 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(439741), // Rule ID 2232 //
     /* 439712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439715 */     // MIs[0] imm
     /* 439715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439727 */     // MIs[1] Operand 1
     /* 439727 */     // No operand predicates
     /* 439727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439729 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 439732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439739 */     GIR_RootConstrainSelectedInstOperands,
     /* 439740 */     // GIR_Coverage, 2232,
     /* 439740 */     GIR_EraseRootFromParent_Done,
     /* 439741 */   // Label 8904: @439741
     /* 439741 */   GIM_Reject,
     /* 439742 */ // Label 8902: @439742
     /* 439742 */ GIM_Reject,
     /* 439743 */ // Label 8885: @439743
     /* 439743 */ GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(439819),
     /* 439748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439759 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(439784), // Rule ID 4959 //
     /* 439764 */     // MIs[0] Operand 2
     /* 439764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 439775 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 439775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 439778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439782 */     GIR_RootConstrainSelectedInstOperands,
     /* 439783 */     // GIR_Coverage, 4959,
     /* 439783 */     GIR_EraseRootFromParent_Done,
     /* 439784 */   // Label 8906: @439784
     /* 439784 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(439818), // Rule ID 2227 //
     /* 439789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439792 */     // MIs[0] imm
     /* 439792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439804 */     // MIs[1] Operand 1
     /* 439804 */     // No operand predicates
     /* 439804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439806 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 439809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439816 */     GIR_RootConstrainSelectedInstOperands,
     /* 439817 */     // GIR_Coverage, 2227,
     /* 439817 */     GIR_EraseRootFromParent_Done,
     /* 439818 */   // Label 8907: @439818
     /* 439818 */   GIM_Reject,
     /* 439819 */ // Label 8905: @439819
     /* 439819 */ GIM_Reject,
     /* 439820 */ // Label 8886: @439820
     /* 439820 */ GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(439896),
     /* 439825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439836 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(439861), // Rule ID 4963 //
     /* 439841 */     // MIs[0] Operand 2
     /* 439841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 439852 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 439852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 439855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439859 */     GIR_RootConstrainSelectedInstOperands,
     /* 439860 */     // GIR_Coverage, 4963,
     /* 439860 */     GIR_EraseRootFromParent_Done,
     /* 439861 */   // Label 8909: @439861
     /* 439861 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(439895), // Rule ID 2230 //
     /* 439866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439869 */     // MIs[0] imm
     /* 439869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439881 */     // MIs[1] Operand 1
     /* 439881 */     // No operand predicates
     /* 439881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439883 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 439886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439893 */     GIR_RootConstrainSelectedInstOperands,
     /* 439894 */     // GIR_Coverage, 2230,
     /* 439894 */     GIR_EraseRootFromParent_Done,
     /* 439895 */   // Label 8910: @439895
     /* 439895 */   GIM_Reject,
     /* 439896 */ // Label 8908: @439896
     /* 439896 */ GIM_Reject,
     /* 439897 */ // Label 8887: @439897
     /* 439897 */ GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(439973),
     /* 439902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439913 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(439938), // Rule ID 4962 //
     /* 439918 */     // MIs[0] Operand 2
     /* 439918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 439929 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 439929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 439932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439936 */     GIR_RootConstrainSelectedInstOperands,
     /* 439937 */     // GIR_Coverage, 4962,
     /* 439937 */     GIR_EraseRootFromParent_Done,
     /* 439938 */   // Label 8912: @439938
     /* 439938 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(439972), // Rule ID 2228 //
     /* 439943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439946 */     // MIs[0] imm
     /* 439946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439958 */     // MIs[1] Operand 1
     /* 439958 */     // No operand predicates
     /* 439958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439960 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 439963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439970 */     GIR_RootConstrainSelectedInstOperands,
     /* 439971 */     // GIR_Coverage, 2228,
     /* 439971 */     GIR_EraseRootFromParent_Done,
     /* 439972 */   // Label 8913: @439972
     /* 439972 */   GIM_Reject,
     /* 439973 */ // Label 8911: @439973
     /* 439973 */ GIM_Reject,
     /* 439974 */ // Label 8888: @439974
     /* 439974 */ GIM_Reject,
     /* 439975 */ // Label 152: @439975
     /* 439975 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8922*/ GIMT_Encode4(440430),
     /* 439986 */ /*GILLT_s64*//*Label 8914*/ GIMT_Encode4(440022), GIMT_Encode4(0),
     /* 439994 */ /*GILLT_v2s32*//*Label 8915*/ GIMT_Encode4(440108),
     /* 439998 */ /*GILLT_v2s64*//*Label 8916*/ GIMT_Encode4(440154),
     /* 440002 */ /*GILLT_v4s16*//*Label 8917*/ GIMT_Encode4(440200),
     /* 440006 */ /*GILLT_v4s32*//*Label 8918*/ GIMT_Encode4(440246),
     /* 440010 */ /*GILLT_v8s8*//*Label 8919*/ GIMT_Encode4(440292),
     /* 440014 */ /*GILLT_v8s16*//*Label 8920*/ GIMT_Encode4(440338),
     /* 440018 */ /*GILLT_v16s8*//*Label 8921*/ GIMT_Encode4(440384),
     /* 440022 */ // Label 8914: @440022
     /* 440022 */ GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(440107),
     /* 440027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 440030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440038 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(440072), // Rule ID 2133 //
     /* 440043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440046 */     // MIs[0] imm
     /* 440046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 440058 */     // MIs[1] Operand 1
     /* 440058 */     // No operand predicates
     /* 440058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440060 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 440063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440070 */     GIR_RootConstrainSelectedInstOperands,
     /* 440071 */     // GIR_Coverage, 2133,
     /* 440071 */     GIR_EraseRootFromParent_Done,
     /* 440072 */   // Label 8924: @440072
     /* 440072 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(440106), // Rule ID 6366 //
     /* 440077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440080 */     // MIs[0] imm
     /* 440080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 440092 */     // MIs[1] Operand 1
     /* 440092 */     // No operand predicates
     /* 440092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440094 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 440094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 440097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440104 */     GIR_RootConstrainSelectedInstOperands,
     /* 440105 */     // GIR_Coverage, 6366,
     /* 440105 */     GIR_EraseRootFromParent_Done,
     /* 440106 */   // Label 8925: @440106
     /* 440106 */   GIM_Reject,
     /* 440107 */ // Label 8923: @440107
     /* 440107 */ GIM_Reject,
     /* 440108 */ // Label 8915: @440108
     /* 440108 */ GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(440153), // Rule ID 2290 //
     /* 440113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 440119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440127 */   // MIs[0] imm
     /* 440127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440135 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 440139 */   // MIs[1] Operand 1
     /* 440139 */   // No operand predicates
     /* 440139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440141 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 440144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440146 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440148 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440151 */   GIR_RootConstrainSelectedInstOperands,
     /* 440152 */   // GIR_Coverage, 2290,
     /* 440152 */   GIR_EraseRootFromParent_Done,
     /* 440153 */ // Label 8926: @440153
     /* 440153 */ GIM_Reject,
     /* 440154 */ // Label 8916: @440154
     /* 440154 */ GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(440199), // Rule ID 2292 //
     /* 440159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 440165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440173 */   // MIs[0] imm
     /* 440173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440181 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 440185 */   // MIs[1] Operand 1
     /* 440185 */   // No operand predicates
     /* 440185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440187 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 440190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440192 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440194 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440197 */   GIR_RootConstrainSelectedInstOperands,
     /* 440198 */   // GIR_Coverage, 2292,
     /* 440198 */   GIR_EraseRootFromParent_Done,
     /* 440199 */ // Label 8927: @440199
     /* 440199 */ GIM_Reject,
     /* 440200 */ // Label 8917: @440200
     /* 440200 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(440245), // Rule ID 2288 //
     /* 440205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 440211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440219 */   // MIs[0] imm
     /* 440219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440227 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 440231 */   // MIs[1] Operand 1
     /* 440231 */   // No operand predicates
     /* 440231 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440233 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 440236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440238 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440240 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440243 */   GIR_RootConstrainSelectedInstOperands,
     /* 440244 */   // GIR_Coverage, 2288,
     /* 440244 */   GIR_EraseRootFromParent_Done,
     /* 440245 */ // Label 8928: @440245
     /* 440245 */ GIM_Reject,
     /* 440246 */ // Label 8918: @440246
     /* 440246 */ GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(440291), // Rule ID 2291 //
     /* 440251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 440257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440265 */   // MIs[0] imm
     /* 440265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440273 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 440277 */   // MIs[1] Operand 1
     /* 440277 */   // No operand predicates
     /* 440277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440279 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 440282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440284 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440286 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440289 */   GIR_RootConstrainSelectedInstOperands,
     /* 440290 */   // GIR_Coverage, 2291,
     /* 440290 */   GIR_EraseRootFromParent_Done,
     /* 440291 */ // Label 8929: @440291
     /* 440291 */ GIM_Reject,
     /* 440292 */ // Label 8919: @440292
     /* 440292 */ GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(440337), // Rule ID 2286 //
     /* 440297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 440303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440311 */   // MIs[0] imm
     /* 440311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440319 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 440323 */   // MIs[1] Operand 1
     /* 440323 */   // No operand predicates
     /* 440323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440325 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 440328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440330 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440332 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440335 */   GIR_RootConstrainSelectedInstOperands,
     /* 440336 */   // GIR_Coverage, 2286,
     /* 440336 */   GIR_EraseRootFromParent_Done,
     /* 440337 */ // Label 8930: @440337
     /* 440337 */ GIM_Reject,
     /* 440338 */ // Label 8920: @440338
     /* 440338 */ GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(440383), // Rule ID 2289 //
     /* 440343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 440349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440357 */   // MIs[0] imm
     /* 440357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440365 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 440369 */   // MIs[1] Operand 1
     /* 440369 */   // No operand predicates
     /* 440369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440371 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 440374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440376 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440378 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440381 */   GIR_RootConstrainSelectedInstOperands,
     /* 440382 */   // GIR_Coverage, 2289,
     /* 440382 */   GIR_EraseRootFromParent_Done,
     /* 440383 */ // Label 8931: @440383
     /* 440383 */ GIM_Reject,
     /* 440384 */ // Label 8921: @440384
     /* 440384 */ GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(440429), // Rule ID 2287 //
     /* 440389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440403 */   // MIs[0] imm
     /* 440403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440411 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 440415 */   // MIs[1] Operand 1
     /* 440415 */   // No operand predicates
     /* 440415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440417 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 440420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440422 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440424 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440427 */   GIR_RootConstrainSelectedInstOperands,
     /* 440428 */   // GIR_Coverage, 2287,
     /* 440428 */   GIR_EraseRootFromParent_Done,
     /* 440429 */ // Label 8932: @440429
     /* 440429 */ GIM_Reject,
     /* 440430 */ // Label 8922: @440430
     /* 440430 */ GIM_Reject,
     /* 440431 */ // Label 153: @440431
     /* 440431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8951*/ GIMT_Encode4(441210),
     /* 440442 */ /*GILLT_v2s32*//*Label 8933*/ GIMT_Encode4(440518),
     /* 440446 */ /*GILLT_v2s64*//*Label 8934*/ GIMT_Encode4(440573),
     /* 440450 */ /*GILLT_v4s16*//*Label 8935*/ GIMT_Encode4(440628),
     /* 440454 */ /*GILLT_v4s32*//*Label 8936*/ GIMT_Encode4(440683),
     /* 440458 */ /*GILLT_v8s8*//*Label 8937*/ GIMT_Encode4(440738),
     /* 440462 */ /*GILLT_v8s16*//*Label 8938*/ GIMT_Encode4(440772),
     /* 440466 */ /*GILLT_v16s8*//*Label 8939*/ GIMT_Encode4(440827), GIMT_Encode4(0),
     /* 440474 */ /*GILLT_nxv2s1*//*Label 8940*/ GIMT_Encode4(440861),
     /* 440478 */ /*GILLT_nxv2s16*//*Label 8941*/ GIMT_Encode4(440887),
     /* 440482 */ /*GILLT_nxv2s32*//*Label 8942*/ GIMT_Encode4(440913),
     /* 440486 */ /*GILLT_nxv2s64*//*Label 8943*/ GIMT_Encode4(440939),
     /* 440490 */ /*GILLT_nxv4s1*//*Label 8944*/ GIMT_Encode4(440986),
     /* 440494 */ /*GILLT_nxv4s16*//*Label 8945*/ GIMT_Encode4(441012),
     /* 440498 */ /*GILLT_nxv4s32*//*Label 8946*/ GIMT_Encode4(441038),
     /* 440502 */ /*GILLT_nxv8s1*//*Label 8947*/ GIMT_Encode4(441085),
     /* 440506 */ /*GILLT_nxv8s16*//*Label 8948*/ GIMT_Encode4(441111),
     /* 440510 */ /*GILLT_nxv16s1*//*Label 8949*/ GIMT_Encode4(441158),
     /* 440514 */ /*GILLT_nxv16s8*//*Label 8950*/ GIMT_Encode4(441184),
     /* 440518 */ // Label 8933: @440518
     /* 440518 */ GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(440572),
     /* 440523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 440526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 440529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440541 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(440556), // Rule ID 1906 //
     /* 440546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440549 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 440549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 440554 */     GIR_RootConstrainSelectedInstOperands,
     /* 440555 */     // GIR_Coverage, 1906,
     /* 440555 */     GIR_Done,
     /* 440556 */   // Label 8953: @440556
     /* 440556 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(440571), // Rule ID 5532 //
     /* 440561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440564 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 440564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 440569 */     GIR_RootConstrainSelectedInstOperands,
     /* 440570 */     // GIR_Coverage, 5532,
     /* 440570 */     GIR_Done,
     /* 440571 */   // Label 8954: @440571
     /* 440571 */   GIM_Reject,
     /* 440572 */ // Label 8952: @440572
     /* 440572 */ GIM_Reject,
     /* 440573 */ // Label 8934: @440573
     /* 440573 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(440627),
     /* 440578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 440581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 440584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440596 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(440611), // Rule ID 1908 //
     /* 440601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440604 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 440604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 440609 */     GIR_RootConstrainSelectedInstOperands,
     /* 440610 */     // GIR_Coverage, 1908,
     /* 440610 */     GIR_Done,
     /* 440611 */   // Label 8956: @440611
     /* 440611 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(440626), // Rule ID 5534 //
     /* 440616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440619 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 440619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 440624 */     GIR_RootConstrainSelectedInstOperands,
     /* 440625 */     // GIR_Coverage, 5534,
     /* 440625 */     GIR_Done,
     /* 440626 */   // Label 8957: @440626
     /* 440626 */   GIM_Reject,
     /* 440627 */ // Label 8955: @440627
     /* 440627 */ GIM_Reject,
     /* 440628 */ // Label 8935: @440628
     /* 440628 */ GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(440682),
     /* 440633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 440636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 440639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440651 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(440666), // Rule ID 1904 //
     /* 440656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440659 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 440659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 440664 */     GIR_RootConstrainSelectedInstOperands,
     /* 440665 */     // GIR_Coverage, 1904,
     /* 440665 */     GIR_Done,
     /* 440666 */   // Label 8959: @440666
     /* 440666 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(440681), // Rule ID 5530 //
     /* 440671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440674 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 440674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 440679 */     GIR_RootConstrainSelectedInstOperands,
     /* 440680 */     // GIR_Coverage, 5530,
     /* 440680 */     GIR_Done,
     /* 440681 */   // Label 8960: @440681
     /* 440681 */   GIM_Reject,
     /* 440682 */ // Label 8958: @440682
     /* 440682 */ GIM_Reject,
     /* 440683 */ // Label 8936: @440683
     /* 440683 */ GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(440737),
     /* 440688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 440691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 440694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440706 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(440721), // Rule ID 1907 //
     /* 440711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440714 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 440714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 440719 */     GIR_RootConstrainSelectedInstOperands,
     /* 440720 */     // GIR_Coverage, 1907,
     /* 440720 */     GIR_Done,
     /* 440721 */   // Label 8962: @440721
     /* 440721 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(440736), // Rule ID 5533 //
     /* 440726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440729 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 440729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 440734 */     GIR_RootConstrainSelectedInstOperands,
     /* 440735 */     // GIR_Coverage, 5533,
     /* 440735 */     GIR_Done,
     /* 440736 */   // Label 8963: @440736
     /* 440736 */   GIM_Reject,
     /* 440737 */ // Label 8961: @440737
     /* 440737 */ GIM_Reject,
     /* 440738 */ // Label 8937: @440738
     /* 440738 */ GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(440771), // Rule ID 1902 //
     /* 440743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 440749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 440752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440764 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 440764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 440769 */   GIR_RootConstrainSelectedInstOperands,
     /* 440770 */   // GIR_Coverage, 1902,
     /* 440770 */   GIR_Done,
     /* 440771 */ // Label 8964: @440771
     /* 440771 */ GIM_Reject,
     /* 440772 */ // Label 8938: @440772
     /* 440772 */ GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(440826),
     /* 440777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 440780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 440783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440795 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(440810), // Rule ID 1905 //
     /* 440800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440803 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 440803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 440808 */     GIR_RootConstrainSelectedInstOperands,
     /* 440809 */     // GIR_Coverage, 1905,
     /* 440809 */     GIR_Done,
     /* 440810 */   // Label 8966: @440810
     /* 440810 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(440825), // Rule ID 5531 //
     /* 440815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440818 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 440818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 440823 */     GIR_RootConstrainSelectedInstOperands,
     /* 440824 */     // GIR_Coverage, 5531,
     /* 440824 */     GIR_Done,
     /* 440825 */   // Label 8967: @440825
     /* 440825 */   GIM_Reject,
     /* 440826 */ // Label 8965: @440826
     /* 440826 */ GIM_Reject,
     /* 440827 */ // Label 8939: @440827
     /* 440827 */ GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(440860), // Rule ID 1903 //
     /* 440832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 440841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440853 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 440853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 440858 */   GIR_RootConstrainSelectedInstOperands,
     /* 440859 */   // GIR_Coverage, 1903,
     /* 440859 */   GIR_Done,
     /* 440860 */ // Label 8968: @440860
     /* 440860 */ GIM_Reject,
     /* 440861 */ // Label 8940: @440861
     /* 440861 */ GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(440886), // Rule ID 3367 //
     /* 440866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 440872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 440875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440879 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 440879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 440884 */   GIR_RootConstrainSelectedInstOperands,
     /* 440885 */   // GIR_Coverage, 3367,
     /* 440885 */   GIR_Done,
     /* 440886 */ // Label 8969: @440886
     /* 440886 */ GIM_Reject,
     /* 440887 */ // Label 8941: @440887
     /* 440887 */ GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(440912), // Rule ID 2894 //
     /* 440892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 440898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 440901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440905 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 440905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440910 */   GIR_RootConstrainSelectedInstOperands,
     /* 440911 */   // GIR_Coverage, 2894,
     /* 440911 */   GIR_Done,
     /* 440912 */ // Label 8970: @440912
     /* 440912 */ GIM_Reject,
     /* 440913 */ // Label 8942: @440913
     /* 440913 */ GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(440938), // Rule ID 2895 //
     /* 440918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 440924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 440927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440931 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 440931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440936 */   GIR_RootConstrainSelectedInstOperands,
     /* 440937 */   // GIR_Coverage, 2895,
     /* 440937 */   GIR_Done,
     /* 440938 */ // Label 8971: @440938
     /* 440938 */ GIM_Reject,
     /* 440939 */ // Label 8943: @440939
     /* 440939 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(440985),
     /* 440944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 440947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 440950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440954 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(440969), // Rule ID 2890 //
     /* 440959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440962 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 440962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440967 */     GIR_RootConstrainSelectedInstOperands,
     /* 440968 */     // GIR_Coverage, 2890,
     /* 440968 */     GIR_Done,
     /* 440969 */   // Label 8973: @440969
     /* 440969 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(440984), // Rule ID 2896 //
     /* 440974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440977 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 440977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440982 */     GIR_RootConstrainSelectedInstOperands,
     /* 440983 */     // GIR_Coverage, 2896,
     /* 440983 */     GIR_Done,
     /* 440984 */   // Label 8974: @440984
     /* 440984 */   GIM_Reject,
     /* 440985 */ // Label 8972: @440985
     /* 440985 */ GIM_Reject,
     /* 440986 */ // Label 8944: @440986
     /* 440986 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(441011), // Rule ID 3366 //
     /* 440991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 440997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 441000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441004 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 441004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 441009 */   GIR_RootConstrainSelectedInstOperands,
     /* 441010 */   // GIR_Coverage, 3366,
     /* 441010 */   GIR_Done,
     /* 441011 */ // Label 8975: @441011
     /* 441011 */ GIM_Reject,
     /* 441012 */ // Label 8945: @441012
     /* 441012 */ GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(441037), // Rule ID 2892 //
     /* 441017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 441023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 441026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441030 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 441030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 441035 */   GIR_RootConstrainSelectedInstOperands,
     /* 441036 */   // GIR_Coverage, 2892,
     /* 441036 */   GIR_Done,
     /* 441037 */ // Label 8976: @441037
     /* 441037 */ GIM_Reject,
     /* 441038 */ // Label 8946: @441038
     /* 441038 */ GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(441084),
     /* 441043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 441046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 441049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441053 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(441068), // Rule ID 2889 //
     /* 441058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441061 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 441061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 441066 */     GIR_RootConstrainSelectedInstOperands,
     /* 441067 */     // GIR_Coverage, 2889,
     /* 441067 */     GIR_Done,
     /* 441068 */   // Label 8978: @441068
     /* 441068 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(441083), // Rule ID 2893 //
     /* 441073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441076 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 441076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 441081 */     GIR_RootConstrainSelectedInstOperands,
     /* 441082 */     // GIR_Coverage, 2893,
     /* 441082 */     GIR_Done,
     /* 441083 */   // Label 8979: @441083
     /* 441083 */   GIM_Reject,
     /* 441084 */ // Label 8977: @441084
     /* 441084 */ GIM_Reject,
     /* 441085 */ // Label 8947: @441085
     /* 441085 */ GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(441110), // Rule ID 3365 //
     /* 441090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 441096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 441099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441103 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 441103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 441108 */   GIR_RootConstrainSelectedInstOperands,
     /* 441109 */   // GIR_Coverage, 3365,
     /* 441109 */   GIR_Done,
     /* 441110 */ // Label 8980: @441110
     /* 441110 */ GIM_Reject,
     /* 441111 */ // Label 8948: @441111
     /* 441111 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(441157),
     /* 441116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 441119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 441122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441126 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(441141), // Rule ID 2888 //
     /* 441131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441134 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 441134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 441139 */     GIR_RootConstrainSelectedInstOperands,
     /* 441140 */     // GIR_Coverage, 2888,
     /* 441140 */     GIR_Done,
     /* 441141 */   // Label 8982: @441141
     /* 441141 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(441156), // Rule ID 2891 //
     /* 441146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441149 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 441149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 441154 */     GIR_RootConstrainSelectedInstOperands,
     /* 441155 */     // GIR_Coverage, 2891,
     /* 441155 */     GIR_Done,
     /* 441156 */   // Label 8983: @441156
     /* 441156 */   GIM_Reject,
     /* 441157 */ // Label 8981: @441157
     /* 441157 */ GIM_Reject,
     /* 441158 */ // Label 8949: @441158
     /* 441158 */ GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(441183), // Rule ID 2402 //
     /* 441163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 441169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 441172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441176 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 441176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 441181 */   GIR_RootConstrainSelectedInstOperands,
     /* 441182 */   // GIR_Coverage, 2402,
     /* 441182 */   GIR_Done,
     /* 441183 */ // Label 8984: @441183
     /* 441183 */ GIM_Reject,
     /* 441184 */ // Label 8950: @441184
     /* 441184 */ GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(441209), // Rule ID 2887 //
     /* 441189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 441195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 441198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441202 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 441202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 441207 */   GIR_RootConstrainSelectedInstOperands,
     /* 441208 */   // GIR_Coverage, 2887,
     /* 441208 */   GIR_Done,
     /* 441209 */ // Label 8985: @441209
     /* 441209 */ GIM_Reject,
     /* 441210 */ // Label 8951: @441210
     /* 441210 */ GIM_Reject,
     /* 441211 */ // Label 154: @441211
     /* 441211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 9004*/ GIMT_Encode4(441990),
     /* 441222 */ /*GILLT_v2s32*//*Label 8986*/ GIMT_Encode4(441298),
     /* 441226 */ /*GILLT_v2s64*//*Label 8987*/ GIMT_Encode4(441353),
     /* 441230 */ /*GILLT_v4s16*//*Label 8988*/ GIMT_Encode4(441408),
     /* 441234 */ /*GILLT_v4s32*//*Label 8989*/ GIMT_Encode4(441463),
     /* 441238 */ /*GILLT_v8s8*//*Label 8990*/ GIMT_Encode4(441518),
     /* 441242 */ /*GILLT_v8s16*//*Label 8991*/ GIMT_Encode4(441552),
     /* 441246 */ /*GILLT_v16s8*//*Label 8992*/ GIMT_Encode4(441607), GIMT_Encode4(0),
     /* 441254 */ /*GILLT_nxv2s1*//*Label 8993*/ GIMT_Encode4(441641),
     /* 441258 */ /*GILLT_nxv2s16*//*Label 8994*/ GIMT_Encode4(441667),
     /* 441262 */ /*GILLT_nxv2s32*//*Label 8995*/ GIMT_Encode4(441693),
     /* 441266 */ /*GILLT_nxv2s64*//*Label 8996*/ GIMT_Encode4(441719),
     /* 441270 */ /*GILLT_nxv4s1*//*Label 8997*/ GIMT_Encode4(441766),
     /* 441274 */ /*GILLT_nxv4s16*//*Label 8998*/ GIMT_Encode4(441792),
     /* 441278 */ /*GILLT_nxv4s32*//*Label 8999*/ GIMT_Encode4(441818),
     /* 441282 */ /*GILLT_nxv8s1*//*Label 9000*/ GIMT_Encode4(441865),
     /* 441286 */ /*GILLT_nxv8s16*//*Label 9001*/ GIMT_Encode4(441891),
     /* 441290 */ /*GILLT_nxv16s1*//*Label 9002*/ GIMT_Encode4(441938),
     /* 441294 */ /*GILLT_nxv16s8*//*Label 9003*/ GIMT_Encode4(441964),
     /* 441298 */ // Label 8986: @441298
     /* 441298 */ GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(441352),
     /* 441303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 441306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 441309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441321 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(441336), // Rule ID 1913 //
     /* 441326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441329 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 441329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 441334 */     GIR_RootConstrainSelectedInstOperands,
     /* 441335 */     // GIR_Coverage, 1913,
     /* 441335 */     GIR_Done,
     /* 441336 */   // Label 9006: @441336
     /* 441336 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(441351), // Rule ID 5537 //
     /* 441341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441344 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 441344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 441349 */     GIR_RootConstrainSelectedInstOperands,
     /* 441350 */     // GIR_Coverage, 5537,
     /* 441350 */     GIR_Done,
     /* 441351 */   // Label 9007: @441351
     /* 441351 */   GIM_Reject,
     /* 441352 */ // Label 9005: @441352
     /* 441352 */ GIM_Reject,
     /* 441353 */ // Label 8987: @441353
     /* 441353 */ GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(441407),
     /* 441358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 441361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 441364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441376 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(441391), // Rule ID 1915 //
     /* 441381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441384 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 441384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 441389 */     GIR_RootConstrainSelectedInstOperands,
     /* 441390 */     // GIR_Coverage, 1915,
     /* 441390 */     GIR_Done,
     /* 441391 */   // Label 9009: @441391
     /* 441391 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(441406), // Rule ID 5539 //
     /* 441396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441399 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 441399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 441404 */     GIR_RootConstrainSelectedInstOperands,
     /* 441405 */     // GIR_Coverage, 5539,
     /* 441405 */     GIR_Done,
     /* 441406 */   // Label 9010: @441406
     /* 441406 */   GIM_Reject,
     /* 441407 */ // Label 9008: @441407
     /* 441407 */ GIM_Reject,
     /* 441408 */ // Label 8988: @441408
     /* 441408 */ GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(441462),
     /* 441413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 441416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 441419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441431 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(441446), // Rule ID 1911 //
     /* 441436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441439 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 441439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 441444 */     GIR_RootConstrainSelectedInstOperands,
     /* 441445 */     // GIR_Coverage, 1911,
     /* 441445 */     GIR_Done,
     /* 441446 */   // Label 9012: @441446
     /* 441446 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(441461), // Rule ID 5535 //
     /* 441451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441454 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 441454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 441459 */     GIR_RootConstrainSelectedInstOperands,
     /* 441460 */     // GIR_Coverage, 5535,
     /* 441460 */     GIR_Done,
     /* 441461 */   // Label 9013: @441461
     /* 441461 */   GIM_Reject,
     /* 441462 */ // Label 9011: @441462
     /* 441462 */ GIM_Reject,
     /* 441463 */ // Label 8989: @441463
     /* 441463 */ GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(441517),
     /* 441468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 441471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 441474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441486 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(441501), // Rule ID 1914 //
     /* 441491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441494 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 441494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 441499 */     GIR_RootConstrainSelectedInstOperands,
     /* 441500 */     // GIR_Coverage, 1914,
     /* 441500 */     GIR_Done,
     /* 441501 */   // Label 9015: @441501
     /* 441501 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(441516), // Rule ID 5538 //
     /* 441506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441509 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 441509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 441514 */     GIR_RootConstrainSelectedInstOperands,
     /* 441515 */     // GIR_Coverage, 5538,
     /* 441515 */     GIR_Done,
     /* 441516 */   // Label 9016: @441516
     /* 441516 */   GIM_Reject,
     /* 441517 */ // Label 9014: @441517
     /* 441517 */ GIM_Reject,
     /* 441518 */ // Label 8990: @441518
     /* 441518 */ GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(441551), // Rule ID 1909 //
     /* 441523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 441529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 441532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441544 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 441544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 441549 */   GIR_RootConstrainSelectedInstOperands,
     /* 441550 */   // GIR_Coverage, 1909,
     /* 441550 */   GIR_Done,
     /* 441551 */ // Label 9017: @441551
     /* 441551 */ GIM_Reject,
     /* 441552 */ // Label 8991: @441552
     /* 441552 */ GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(441606),
     /* 441557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 441560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 441563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441575 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(441590), // Rule ID 1912 //
     /* 441580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441583 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 441583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 441588 */     GIR_RootConstrainSelectedInstOperands,
     /* 441589 */     // GIR_Coverage, 1912,
     /* 441589 */     GIR_Done,
     /* 441590 */   // Label 9019: @441590
     /* 441590 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(441605), // Rule ID 5536 //
     /* 441595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441598 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 441598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 441603 */     GIR_RootConstrainSelectedInstOperands,
     /* 441604 */     // GIR_Coverage, 5536,
     /* 441604 */     GIR_Done,
     /* 441605 */   // Label 9020: @441605
     /* 441605 */   GIM_Reject,
     /* 441606 */ // Label 9018: @441606
     /* 441606 */ GIM_Reject,
     /* 441607 */ // Label 8992: @441607
     /* 441607 */ GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(441640), // Rule ID 1910 //
     /* 441612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 441618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 441621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441633 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 441633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 441638 */   GIR_RootConstrainSelectedInstOperands,
     /* 441639 */   // GIR_Coverage, 1910,
     /* 441639 */   GIR_Done,
     /* 441640 */ // Label 9021: @441640
     /* 441640 */ GIM_Reject,
     /* 441641 */ // Label 8993: @441641
     /* 441641 */ GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(441666), // Rule ID 9081 //
     /* 441646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 441652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 441655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441659 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 441659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 441664 */   GIR_RootConstrainSelectedInstOperands,
     /* 441665 */   // GIR_Coverage, 9081,
     /* 441665 */   GIR_Done,
     /* 441666 */ // Label 9022: @441666
     /* 441666 */ GIM_Reject,
     /* 441667 */ // Label 8994: @441667
     /* 441667 */ GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(441692), // Rule ID 9036 //
     /* 441672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 441678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 441681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441685 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 441685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441690 */   GIR_RootConstrainSelectedInstOperands,
     /* 441691 */   // GIR_Coverage, 9036,
     /* 441691 */   GIR_Done,
     /* 441692 */ // Label 9023: @441692
     /* 441692 */ GIM_Reject,
     /* 441693 */ // Label 8995: @441693
     /* 441693 */ GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(441718), // Rule ID 9037 //
     /* 441698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 441704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 441707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441711 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 441711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441716 */   GIR_RootConstrainSelectedInstOperands,
     /* 441717 */   // GIR_Coverage, 9037,
     /* 441717 */   GIR_Done,
     /* 441718 */ // Label 9024: @441718
     /* 441718 */ GIM_Reject,
     /* 441719 */ // Label 8996: @441719
     /* 441719 */ GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(441765),
     /* 441724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 441727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 441730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441734 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(441749), // Rule ID 9032 //
     /* 441739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441742 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 441742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441747 */     GIR_RootConstrainSelectedInstOperands,
     /* 441748 */     // GIR_Coverage, 9032,
     /* 441748 */     GIR_Done,
     /* 441749 */   // Label 9026: @441749
     /* 441749 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(441764), // Rule ID 9038 //
     /* 441754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441757 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 441757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441762 */     GIR_RootConstrainSelectedInstOperands,
     /* 441763 */     // GIR_Coverage, 9038,
     /* 441763 */     GIR_Done,
     /* 441764 */   // Label 9027: @441764
     /* 441764 */   GIM_Reject,
     /* 441765 */ // Label 9025: @441765
     /* 441765 */ GIM_Reject,
     /* 441766 */ // Label 8997: @441766
     /* 441766 */ GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(441791), // Rule ID 9080 //
     /* 441771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 441777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 441780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441784 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 441784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 441789 */   GIR_RootConstrainSelectedInstOperands,
     /* 441790 */   // GIR_Coverage, 9080,
     /* 441790 */   GIR_Done,
     /* 441791 */ // Label 9028: @441791
     /* 441791 */ GIM_Reject,
     /* 441792 */ // Label 8998: @441792
     /* 441792 */ GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(441817), // Rule ID 9034 //
     /* 441797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 441803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 441806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441810 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 441810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441815 */   GIR_RootConstrainSelectedInstOperands,
     /* 441816 */   // GIR_Coverage, 9034,
     /* 441816 */   GIR_Done,
     /* 441817 */ // Label 9029: @441817
     /* 441817 */ GIM_Reject,
     /* 441818 */ // Label 8999: @441818
     /* 441818 */ GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(441864),
     /* 441823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 441826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 441829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441833 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(441848), // Rule ID 9031 //
     /* 441838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441841 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 441841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441846 */     GIR_RootConstrainSelectedInstOperands,
     /* 441847 */     // GIR_Coverage, 9031,
     /* 441847 */     GIR_Done,
     /* 441848 */   // Label 9031: @441848
     /* 441848 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(441863), // Rule ID 9035 //
     /* 441853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441856 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 441856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441861 */     GIR_RootConstrainSelectedInstOperands,
     /* 441862 */     // GIR_Coverage, 9035,
     /* 441862 */     GIR_Done,
     /* 441863 */   // Label 9032: @441863
     /* 441863 */   GIM_Reject,
     /* 441864 */ // Label 9030: @441864
     /* 441864 */ GIM_Reject,
     /* 441865 */ // Label 9000: @441865
     /* 441865 */ GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(441890), // Rule ID 9079 //
     /* 441870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 441876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 441879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441883 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 441883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 441888 */   GIR_RootConstrainSelectedInstOperands,
     /* 441889 */   // GIR_Coverage, 9079,
     /* 441889 */   GIR_Done,
     /* 441890 */ // Label 9033: @441890
     /* 441890 */ GIM_Reject,
     /* 441891 */ // Label 9001: @441891
     /* 441891 */ GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(441937),
     /* 441896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 441899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 441902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441906 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(441921), // Rule ID 9030 //
     /* 441911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441914 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 441914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 441919 */     GIR_RootConstrainSelectedInstOperands,
     /* 441920 */     // GIR_Coverage, 9030,
     /* 441920 */     GIR_Done,
     /* 441921 */   // Label 9035: @441921
     /* 441921 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(441936), // Rule ID 9033 //
     /* 441926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441929 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 441929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 441934 */     GIR_RootConstrainSelectedInstOperands,
     /* 441935 */     // GIR_Coverage, 9033,
     /* 441935 */     GIR_Done,
     /* 441936 */   // Label 9036: @441936
     /* 441936 */   GIM_Reject,
     /* 441937 */ // Label 9034: @441937
     /* 441937 */ GIM_Reject,
     /* 441938 */ // Label 9002: @441938
     /* 441938 */ GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(441963), // Rule ID 2406 //
     /* 441943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 441949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 441952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441956 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 441956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 441961 */   GIR_RootConstrainSelectedInstOperands,
     /* 441962 */   // GIR_Coverage, 2406,
     /* 441962 */   GIR_Done,
     /* 441963 */ // Label 9037: @441963
     /* 441963 */ GIM_Reject,
     /* 441964 */ // Label 9003: @441964
     /* 441964 */ GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(441989), // Rule ID 9029 //
     /* 441969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 441975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 441978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441982 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 441982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 441987 */   GIR_RootConstrainSelectedInstOperands,
     /* 441988 */   // GIR_Coverage, 9029,
     /* 441988 */   GIR_Done,
     /* 441989 */ // Label 9038: @441989
     /* 441989 */ GIM_Reject,
     /* 441990 */ // Label 9004: @441990
     /* 441990 */ GIM_Reject,
     /* 441991 */ // Label 155: @441991
     /* 441991 */ GIM_Reject,
     /* 441992 */ }; // Size: 441992 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
